local b_app_api = require("wnd.core.command.b_app_api")
local util 		= require("wnd.core.util")



local b_app_cfg = {}

b_app_cfg.cfgkey = {
	device = 'device',
	device_name = 'device_name',
	time = 'time',
	timezone = 'timezone' 
}

--¼ԭʼ
b_app_cfg.origin_cfg = {}
--¼Ĭ
b_app_cfg.default_cfg = {}
--¼û
b_app_cfg.user_cfg = {}


--
b_app_cfg.cfgdataclear =function()
	b_app_cfg.origin_cfg = nil
	b_app_cfg.default_cfg = nil
	b_app_cfg.user_cfg = nil
	collectgarbage("collect")
end

b_app_cfg.init = function(cfg_table)
	b_app_cfg.cfgdataclear();
	--ȡԭʼ
	b_app_cfg.origin_cfg = b_app_api.get_cfg(cfg_table)
	--ȡĬ
	b_app_cfg.default_cfg = b_app_api.get_default_cfg(cfg_table)	
	
	assert(type(b_app_cfg.origin_cfg) == 'table')
	assert(type(b_app_cfg.default_cfg) == 'table')
	
	--ԭʼݸƵû
	b_app_cfg.user_cfg = util.copy_tab(b_app_cfg.origin_cfg);
end

b_app_cfg.origin_init = function(cfg_table)
	--ȡԭʼ
	b_app_cfg.origin_cfg = util.copy_tab(b_app_api.get_cfg(cfg_table))
	--ȡĬ
	b_app_cfg.default_cfg = util.copy_tab(b_app_api.get_default_cfg(cfg_table))
end

b_app_cfg.destroy = function()
	b_app_cfg.origin_cfg = nil
	b_app_cfg.default_cfg = nil
	b_app_cfg.user_cfg = nil
end

--ĬݸƵû
b_app_cfg.defaluttousercfg = function()
	if(b_app_cfg.user_cfg == nil) then
		b_app_cfg.user_cfg = util.copy_tab(b_app_cfg.default_cfg);
	else
		util.copy_tab_b(b_app_cfg.user_cfg, b_app_cfg.default_cfg);		
	end
end

--ԭʼݸƵû
b_app_cfg.origintousercfg = function()
	if(b_app_cfg.user_cfg == nil) then
		b_app_cfg.user_cfg = util.copy_tab(b_app_cfg.origin_cfg);
	else
		util.copy_tab_b(b_app_cfg.user_cfg, b_app_cfg.origin_cfg);		
	end
end


--Ƚԭʼݺûݡûԭʼ޸ĵ"ṹ"
b_app_cfg.tabcompare = function()
	local param = {}
	if(b_app_cfg.user_cfg ~= nil)then --˳ҳãʼĳҳǰΪnil 
		for k, v in pairs(b_app_cfg.user_cfg) do
			if(b_app_cfg.origin_cfg[k] ~= nil and k ~= 'limits') then --limits ãҪȽϲ죬ˢٶȣãҲҪˣ
				--table,λûеtable¼param
				if( util.compare_tab(b_app_cfg.origin_cfg[k], b_app_cfg.user_cfg[k]) == 1 ) then
					if(param[k] == nil) then
						param[k] =  util.copy_tab(b_app_cfg.user_cfg[k])
					else
						util.copy_tab_b(param[k], b_app_cfg.user_cfg[k])
					end		
				end
			end
		end
	end
	return param
end

b_app_cfg.tabcompare_b = function(table1, table2)
	local param = {}
	if(table2 ~= nil)then --˳ҳãʼĳҳǰΪnil 
		for k, v in pairs(table2) do
			if(table1[k] ~= nil ) then
				--table,λûеtable¼param
				if( util.compare_tab(table1[k], table2[k]) == 1 ) then
					if(param[k] == nil) then
						param[k] =  util.copy_tab(table2[k])
					else
						util.copy_tab_b(param[k], table2[k])
					end		
				end
			end
		end
	end
	return param
end


b_app_cfg.checksavecfg = function(param)
	assert(type(param) == 'table');
	return true;
end

--û
b_app_cfg.savechangecfg = function(changeparam)
	local ret = b_app_api.save_cfg(changeparam);
	
	--֮Խorigin_cfgΪֻܷĿؼȡuser_cfgori_cfgԶͬ,
	--Ϊȫһ  ¸ֵ ɹʾǷ񱣴

	return ret;
end

b_app_cfg.saveSuccessful = function()
	if (b_app_cfg.origin_cfg ~= nil) then
		util.clear_tab(b_app_cfg.origin_cfg);
		b_app_cfg.origin_cfg = nil;	
	end		
	
	--ûݸƵԭʼ
	if(b_app_cfg.origin_cfg == nil) then
		b_app_cfg.origin_cfg = util.copy_tab(b_app_cfg.user_cfg);
	else
		util.copy_tab_b(b_app_cfg.origin_cfg, b_app_cfg.user_cfg);		
	end
end	


--޸ĳû
--޸ĳɹtrue,޸ʧܷfalse
b_app_cfg.setusercfg = function(cfgkey, cfgitem, cfgvalue)
	if(b_app_cfg.user_cfg[cfgkey] ~= nil and b_app_cfg.user_cfg[cfgkey][cfgitem]~= nil) then
		b_app_cfg.user_cfg[cfgkey][cfgitem] = cfgvalue
		return true
	else
		return false
	end
end

--ȡĳû
b_app_cfg.getusercfg = function(cfgkey, cfgitem)
	if(b_app_cfg.user_cfg[cfgkey] ~= nil and b_app_cfg.user_cfg[cfgkey][cfgitem]~= nil) then
		return b_app_cfg.user_cfg[cfgkey][cfgitem]
	else
		return nil
	end
end

--ûˢµUI()
b_app_cfg.usercfgdisplay = function(func)
	
end


return b_app_cfg