--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2017/11/27
-- author lsl
-- brief  չģ,ֻ֧: "cjson"
--]]
local cjson = require("cjson")

local util_ex = {}


local copy_t_p = nil
copy_t_p = function(t)
	local dst = {}
	
	for k, v in pairs(t) do
		if type(v) == 'table' then
			dst[k] = copy_t_p(v)
		elseif type(v) == 'string' or type(v) == 'number' or type(v) == 'boolean' then
			dst[k] = v
		else
			dst[k] = tostring(v)
		end
	end
	
	return dst
end

-- jsonʽӡ
-- ˺ԴӡLua, Чʵ; ֻʱʹ
util_ex.printf = function(...)
	local arg = {...} -- arg Ϊ
	local tmp = copy_t_p(arg)

	print(cjson.encode(tmp))
end

return util_ex
