local b_main 			= require("wnd.core.b_main")

local w1_ui_facade		= require("wnd.w1_facade.w1_ui_facade")
local w2_ui_facade		= require("wnd.w2_facade.w2_ui_facade")

local w1_msgbox			= require("wnd.w1_util.w1_msgbox")
local w1_edit_ipfilter	= require("wnd.w1_cfg.w1_edit_ipfilter")
local w1_modify_cam_ip	= require("wnd.w1_cfg.w1_modify_cam_ip")
local w1_copy			= require("wnd.w1_util.w1_copy")
local w1_modify_adam_ip	= require("wnd.w1_cfg.w1_modify_adam_ip")
local w1_edit_raid_msgbox = require("wnd.w1_cfg.w1_edit_raid_msgbox")
local w1_resolution		= require("wnd.w1_live.w1_resolution")
local w1_home_menu 		= require("wnd.w1_live.w1_home_menu")
local w1_audio			= require("wnd.w1_live.w1_audio")
local w1_cfg_setup 		= require("wnd.w1_cfg.w1_cfg_setup")
local w1_cfg_settings	= require("wnd.w1_cfg.w1_cfg_settings")
local w1_modify_camera	= require("wnd.w1_cfg.w1_modify_camera")
local w1_live_add_dev 	= require("wnd.w1_live.w1_add_device")
local w1_manual_control = require("wnd.w1_live.w1_manual_control")
local w1_net_packet = require("wnd.w1_live.w1_net_packet")
local w1_edit_record = require("wnd.w1_live.w1_edit_record")
local w1_sysinfo		= require("wnd.w1_live.w1_sysinfo")
local w1_image_adjust	= require("wnd.w1_live.w1_image_adjust")
local w1_ptz			= require("wnd.w1_live.w1_ptz")
local w1_ptz_control	= require("wnd.w1_live.w1_ptz_control")
local w1_live_edit_dev  = require("wnd.w1_live.w1_edit_device")
local w2_home_menu 		= require("wnd.w2_live.w2_home_menu")
local w2_cfg_setup 		= require("wnd.w2_cfg.w2_cfg_setup")
local w2_cfg_settings	= require("wnd.w2_cfg.w2_cfg_settings")
local w2_cfg_basic 		= require("wnd.w2_cfg.w2_cfg_basic")
local w1_alarm_list		= require("wnd.w1_live.w1_alarm_list")
local w1_login			= require("wnd.w1_live.w1_login")
local w1_login_pattern	= require("wnd.w1_live.w1_login_pattern")
local w1_activation		= require("wnd.w1_live.w1_activation")
local w1_forget			= require("wnd.w1_live.w1_forget")
local w1_modify_default_pwd	= require("wnd.w1_live.w1_modify_default_pwd")
local w1_deminder_change_pwd	= require("wnd.w1_live.w1_reminderchange_pw")
local w1_shut_down	= require("wnd.w1_live.w1_shutdown")
local w1_add_user 		= require("wnd.w1_cfg.w1_add_user")
local w1_edit_phone_filter	= require("wnd.w1_cfg.w1_edit_phone_filter")
local w1_create_raid 	= require("wnd.w1_cfg.w1_create_raid")
local w1_edit_raid      = require("wnd.w1_cfg.w1_edit_raid")
local w1_wizard			= require("wnd.w1_live.w1_wizard")
local w1_wizard_setup	= require("wnd.w1_live.w1_wizard_setup")
local w1_reset= require("wnd.w1_cfg.w1_reset")
local w1_pattern_pop	= require("wnd.w1_cfg.w1_pattern_pop")
local w1_page_add_dwell	= require("wnd.w1_cfg.w1_page_add_dwell")
local w1_select_intelligent_type = require("wnd.w1_cfg.w1_select_intelligent_type") 
local w1_page_plate_bwadv = require("wnd.w1_cfg.w1_page_plate_bwadv")
local w1_page_plate_edit	= require("wnd.w1_cfg.w1_page_plate_edit")
local w1_add_eth_route = require("wnd.w1_cfg.w1_add_eth_route");

local ui_init = {}

local b_app_cfg	= require("wnd.core.b_app_cfg")
local app_api = require("app_api")

--עԻ
local register_dialog =  function(w_str)
	if(w_str == 'w2')then
		b_main.insert(w2_home_menu.t, 	w2_home_menu.on_create, 	w2_home_menu.on_destroy, 	w2_home_menu.on_paint, 		nil, 						w2_home_menu.on_cmd_ctrl)
		b_main.insert(w2_cfg_setup.t, 	w2_cfg_setup.on_create, 	w2_cfg_setup.on_destroy, 	w2_cfg_setup.on_paint,		nil, 						w2_cfg_setup.on_cmd_ctrl)
		b_main.insert(w2_cfg_settings.t,w2_cfg_settings.on_create,  w2_cfg_settings.on_destroy, w2_cfg_settings.on_paint, 	nil, 						w2_cfg_settings.on_cmd_ctrl)
		b_main.insert(w2_cfg_basic.t, 	w2_cfg_basic.on_create, 	w2_cfg_basic.on_destroy, 	w2_cfg_basic.on_paint, 		nil, 						w2_cfg_basic.on_cmd_ctrl)
	else		
		
		b_main.insert(w1_msgbox.t, 		w1_msgbox.on_create, 		w1_msgbox.on_destroy, 		w1_msgbox.on_paint, 		w1_msgbox.on_pre_show, 		w1_msgbox.on_cmd_ctrl)
		b_main.insert(w1_resolution.t, 	w1_resolution.on_create, 	w1_resolution.on_destroy, 	w1_resolution.on_paint, 	w1_resolution.on_pre_show, 	w1_resolution.on_cmd_ctrl)
		b_main.insert(w1_edit_ipfilter.t, w1_edit_ipfilter.on_create, w1_edit_ipfilter.on_destroy, 	w1_edit_ipfilter.on_paint, w1_edit_ipfilter.on_pre_show, w1_edit_ipfilter.on_cmd_ctrl)
		b_main.insert(w1_modify_adam_ip.t, w1_modify_adam_ip.on_create, w1_modify_adam_ip.on_destroy, 	w1_modify_adam_ip.on_paint, w1_modify_adam_ip.on_pre_show, w1_modify_adam_ip.on_cmd_ctrl)
		b_main.insert(w1_modify_cam_ip.t, w1_modify_cam_ip.on_create, w1_modify_cam_ip.on_destroy, 	w1_modify_cam_ip.on_paint, w1_modify_cam_ip.on_pre_show, w1_modify_cam_ip.on_cmd_ctrl)
		b_main.insert(w1_copy.t, 		w1_copy.on_create, 			w1_copy.on_destroy, 		w1_copy.on_paint, 			w1_copy.on_pre_show, 		w1_copy.on_cmd_ctrl)
		b_main.insert(w1_home_menu.t, 	w1_home_menu.on_create, 	w1_home_menu.on_destroy, 	w1_home_menu.on_paint, 		nil, 						w1_home_menu.on_cmd_ctrl)
		b_main.insert(w1_audio.t, 		w1_audio.on_create, 		w1_audio.on_destroy, 		w1_audio.on_paint, 			nil,						w1_audio.on_cmd_ctrl)
		b_main.insert(w1_image_adjust.t,w1_image_adjust.on_create,	w1_image_adjust.on_destroy,	w1_image_adjust.on_paint,	w1_image_adjust.on_pre_show,w1_image_adjust.on_cmd_ctrl)
		b_main.insert(w1_manual_control.t,	w1_manual_control.on_create,w1_manual_control.on_destroy,	w1_manual_control.on_paint,	w1_manual_control.on_pre_show,				w1_manual_control.on_cmd_ctrl)
		b_main.insert(w1_net_packet.t,	w1_net_packet.on_create,w1_net_packet.on_destroy,	w1_net_packet.on_paint,	w1_net_packet.on_pre_show,				w1_net_packet.on_cmd_ctrl)
		b_main.insert(w1_edit_record.t,	w1_edit_record.on_create,w1_edit_record.on_destroy,	w1_edit_record.on_paint,	w1_edit_record.on_pre_show,				w1_edit_record.on_cmd_ctrl)
		b_main.insert(w1_sysinfo.t,		w1_sysinfo.on_create,		w1_sysinfo.on_destroy,		w1_sysinfo.on_paint,		w1_sysinfo.on_pre_show,		w1_sysinfo.on_cmd_ctrl)
		b_main.insert(w1_cfg_setup.t, 	w1_cfg_setup.on_create, 	w1_cfg_setup.on_destroy, 	w1_cfg_setup.on_paint,		w1_cfg_setup.on_pre_show,	w1_cfg_setup.on_cmd_ctrl)
		b_main.insert(w1_cfg_settings.t,w1_cfg_settings.on_create,  w1_cfg_settings.on_destroy, w1_cfg_settings.on_paint, 	w1_cfg_settings.on_pre_show, w1_cfg_settings.on_cmd_ctrl)
		b_main.insert(w1_modify_camera.t,w1_modify_camera.on_create,w1_modify_camera.on_destroy,w1_modify_camera.on_paint, 	w1_modify_camera.on_pre_show,w1_modify_camera.on_cmd_ctrl)
		b_main.insert(w1_live_add_dev.t,w1_live_add_dev.on_create,  w1_live_add_dev.on_destroy, w1_live_add_dev.on_paint, 	w1_live_add_dev.on_pre_show,w1_live_add_dev.on_cmd_ctrl)
		b_main.insert(w1_live_edit_dev.t,w1_live_edit_dev.on_create,  w1_live_edit_dev.on_destroy, w1_live_edit_dev.on_paint, w1_live_edit_dev.on_pre_show,w1_live_edit_dev.on_cmd_ctrl)
		b_main.insert(w1_ptz.t,			w1_ptz.on_create,  			w1_ptz.on_destroy,	 		w1_ptz.on_paint, 			nil, 						w1_ptz.on_cmd_ctrl)
		b_main.insert(w1_ptz_control.t,	w1_ptz_control.on_create,  	w1_ptz_control.on_destroy,	w1_ptz_control.on_paint, 	nil, 						w1_ptz_control.on_cmd_ctrl)
		b_main.insert(w1_alarm_list.t,	w1_alarm_list.on_create,  	w1_alarm_list.on_destroy,	w1_alarm_list.on_paint, 	w1_alarm_list.on_pre_show,	w1_alarm_list.on_cmd_ctrl)
		b_main.insert(w1_login.t,		w1_login.on_create,  		w1_login.on_destroy,		w1_login.on_paint,	 		w1_login.on_pre_show, 		w1_login.on_cmd_ctrl)
		b_main.insert(w1_login_pattern.t,	w1_login_pattern.on_create, w1_login_pattern.on_destroy,	w1_login_pattern.on_paint,	w1_login_pattern.on_pre_show,	w1_login_pattern.on_cmd_ctrl)
		b_main.insert(w1_activation.t,	w1_activation.on_create,  	w1_activation.on_destroy,	w1_activation.on_paint,	 	w1_activation.on_pre_show, 	w1_activation.on_cmd_ctrl)
		b_main.insert(w1_forget.t,		w1_forget.on_create,  		w1_forget.on_destroy,		w1_forget.on_paint,	 		w1_forget.on_pre_show, 		w1_forget.on_cmd_ctrl)
		b_main.insert(w1_modify_default_pwd.t, w1_modify_default_pwd.on_create, w1_modify_default_pwd.on_destroy, w1_modify_default_pwd.on_paint, w1_modify_default_pwd.on_pre_show, w1_modify_default_pwd.on_cmd_ctrl)
		b_main.insert(w1_deminder_change_pwd.t,	w1_deminder_change_pwd.on_create, w1_deminder_change_pwd.on_destroy, w1_deminder_change_pwd.on_paint, w1_deminder_change_pwd.on_pre_show, w1_deminder_change_pwd.on_cmd_ctrl)
		b_main.insert(w1_shut_down.t,	w1_shut_down.on_create, w1_shut_down.on_destroy, w1_shut_down.on_paint, w1_shut_down.on_pre_show, w1_shut_down.on_cmd_ctrl)	
		b_main.insert(w1_add_user.t,	w1_add_user.on_create,  	w1_add_user.on_destroy,		w1_add_user.on_paint,	 	w1_add_user.on_pre_show, 	w1_add_user.on_cmd_ctrl)
		b_main.insert(w1_edit_phone_filter.t,	w1_edit_phone_filter.on_create,  	w1_edit_phone_filter.on_destroy,		w1_edit_phone_filter.on_paint,	 	w1_edit_phone_filter.on_pre_show, 	w1_edit_phone_filter.on_cmd_ctrl)
		b_main.insert(w1_wizard.t,		w1_wizard.on_create,  		w1_wizard.on_destroy,		w1_wizard.on_paint,	 		nil, 		w1_wizard.on_cmd_ctrl)
		b_main.insert(w1_wizard_setup.t, w1_wizard_setup.on_create, w1_wizard_setup.on_destroy, w1_wizard_setup.on_paint,	w1_wizard_setup.on_pre_show,	w1_wizard_setup.on_cmd_ctrl)
		b_main.insert(w1_create_raid.t,	w1_create_raid.on_create,  	w1_create_raid.on_destroy,		w1_create_raid.on_paint,	 	w1_create_raid.on_pre_show, 	w1_create_raid.on_cmd_ctrl)
		b_main.insert(w1_edit_raid.t,	w1_edit_raid.on_create,  	w1_edit_raid.on_destroy,		w1_edit_raid.on_paint,	 	w1_edit_raid.on_pre_show, 	w1_edit_raid.on_cmd_ctrl)
		b_main.insert(w1_edit_raid_msgbox.t,	w1_edit_raid_msgbox.on_create,  	w1_edit_raid_msgbox.on_destroy,		w1_edit_raid_msgbox.on_paint,	 	w1_edit_raid_msgbox.on_pre_show, 	w1_edit_raid_msgbox.on_cmd_ctrl)
		b_main.insert(w1_reset.t,	w1_reset.on_create,  	w1_reset.on_destroy,	w1_reset.on_paint,	 w1_reset.on_pre_show, 	w1_reset.on_cmd_ctrl)
		b_main.insert(w1_pattern_pop.t,	w1_pattern_pop.on_create, w1_pattern_pop.on_destroy,	w1_pattern_pop.on_paint,	w1_pattern_pop.on_pre_show,	w1_pattern_pop.on_cmd_ctrl)
		b_main.insert(w1_page_add_dwell.t,	w1_page_add_dwell.on_create, w1_page_add_dwell.on_destroy,	w1_page_add_dwell.on_paint,	w1_page_add_dwell.on_pre_show,	w1_page_add_dwell.on_cmd_ctrl)
		b_main.insert(w1_select_intelligent_type.t,	w1_select_intelligent_type.on_create, w1_select_intelligent_type.on_destroy,	w1_select_intelligent_type.on_paint,	w1_select_intelligent_type.on_pre_show,	w1_select_intelligent_type.on_cmd_ctrl)
		b_main.insert(w1_page_plate_bwadv.t,	w1_page_plate_bwadv.on_create, w1_page_plate_bwadv.on_destroy,	w1_page_plate_bwadv.on_paint,	w1_page_plate_bwadv.on_pre_show,	w1_page_plate_bwadv.on_cmd_ctrl)
		b_main.insert(w1_page_plate_edit.t,	w1_page_plate_edit.on_create, w1_page_plate_edit.on_destroy,	w1_page_plate_edit.on_paint,	w1_page_plate_edit.on_pre_show,	w1_page_plate_edit.on_cmd_ctrl)
		b_main.insert(w1_add_eth_route.t,	w1_add_eth_route.on_create, w1_add_eth_route.on_destroy,	w1_add_eth_route.on_paint,	w1_add_eth_route.on_pre_show,	w1_add_eth_route.on_cmd_ctrl)
	
	end
end

local load_color =function(stylestr, colorstr)
	assert(type(stylestr) == 'string')
	assert(type(colorstr) == 'string')
	if(stylestr == 'w2') then
		if(colorstr == 'red') then
			w2_ui_facade.set_color('c_red')
		else
			w2_ui_facade.set_color('c_defalut')
		end	
	else
		w1_ui_facade.set_color(colorstr)
	end
end

local load_fontsize =function(vo, style, fontsizestr)
	assert(type(style) == 'string')
	assert(type(fontsizestr) == 'string')
	local set_fontsize;
	if(style == 'w2') then
		set_fontsize = w2_ui_facade.set_fontsize;
	else
		set_fontsize = w1_ui_facade.set_fontsize;
	end
	
	if(fontsizestr == 'small') then
		if(vo <= 4) then--RJ_VO_SIZE_XGA, RJ_VO_SIZE_720P, RJ_VO_SIZE_SXGA, RJ_VO_SIZE_WXGA, RJ_VO_SIZE_1080P 
			set_fontsize('f_small_1080p');
		elseif(vo == 7) then--RJ_VO_SIZE_4K
			set_fontsize('f_small_4k');
		elseif(vo == 8) then--RJ_VO_SIZE_2K	
			set_fontsize('f_small_2k');
		end
	elseif(fontsizestr == 'big') then
		if(vo <= 4) then--RJ_VO_SIZE_XGA, RJ_VO_SIZE_720P, RJ_VO_SIZE_SXGA, RJ_VO_SIZE_WXGA, RJ_VO_SIZE_1080P 
			set_fontsize('f_big_1080p');
		elseif(vo == 7) then--RJ_VO_SIZE_4K
			set_fontsize('f_big_4k');
		elseif(vo == 8) then--RJ_VO_SIZE_2K	
			set_fontsize('f_big_2k');
		end
	else
		if(vo <= 4) then--RJ_VO_SIZE_XGA, RJ_VO_SIZE_720P, RJ_VO_SIZE_SXGA, RJ_VO_SIZE_WXGA, RJ_VO_SIZE_1080P 
			set_fontsize('f_normal_1080p');
		elseif(vo == 7) then--RJ_VO_SIZE_4K
			set_fontsize('f_normal_4k');
		elseif(vo == 8) then--RJ_VO_SIZE_2K	
			set_fontsize('f_normal_2k');
		end
	end
end



--UIʼ
ui_init.init = function()
	--
	b_app_cfg.init({'guistyle','device_info','device'})
	local stylestr = b_app_cfg.user_cfg.guistyle
	
	--ȫֱֵ
	assert('table' == type(b_app_cfg.user_cfg.device_info))
	G.init(b_app_cfg.user_cfg.device_info,b_app_cfg.user_cfg.device)
	
	register_dialog(stylestr.style)
	load_color(stylestr.style, stylestr.color)
	w1_ui_facade.set_t_image()		--ʸͼƬ
	w1_ui_facade.load_layout(b_app_cfg.user_cfg.device.vo, stylestr.style, stylestr.font);--ز
	return b_app_cfg.user_cfg.device_info,b_app_cfg.user_cfg.device
end




return ui_init
