-- ӡ༭ͨҳ
local b_ui 		= require("wnd.core.b_ui")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_modifycamera_id;
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local cjson 	= require("cjson")
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")
local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size

local w1_modify_camera = {
	t = w1_key.DLG_MSG_MODIFTCAMERA,
	save_check_illegal,
	top = nil,
	dlg = nil,
	edit_type,		--0:, 1:༭, 2ɾ 3:  4ָ
	sel,
	device_type,	--豸
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_modify_camera.s_768 =
{
	s_modifycamera_xywh = {357,174,309,440},
	s_modify_camera_titleimg_xywh = {6,10,12,17},
	s_modify_camera_titlestr_xywh = {26,10,253,28},
	s_modify_camera_titleclose_xywh = {288,10,12,17},
	s_modify_camera_c_name_xywh = {26,64,106,28},
	s_modify_camera_t_name_xywh = {138,64,133,28},
	s_modify_camera_c_ip_xywh = {26,106,106,28},
	s_modify_camera_t_ip_xywh = {138,106,133,28},
	s_modify_camera_c_prot_xywh = {26,149,106,28},
	s_modify_camera_t_prot_xywh = {138,149,133,28},
	s_modify_camera_c_port_xywh = {26,192,106,28},
	s_modify_camera_t_port_xywh = {138,192,133,28},
	s_modify_camera_c_user_xywh = {26,234,106,28},
	s_modify_camera_t_user_xywh = {138,234,133,28},
	s_modify_camera_c_pwd_xywh = {26,277,106,28},
	s_modify_camera_t_pwd_xywh = {138,277,133,28},
	s_modify_camera_c_remote_ch_xywh = {26,320,106,28},
	s_modify_camera_t_remote_ch_xywh = {138,320,133,28},
	s_modify_camera_tipinfo_xywh = {26,362,266,12},
	s_modify_camera_hline_xywh = {8,384,293,1},
	s_modify_camera_ok_xywh = {162,398,64,27},
	s_modify_camera_cancel_xywh = {237,398,64,27},
	s_reset_camera_msg_xywh = {26,21,292,35},
	s_reset_camera_cap_ip_xywh = {26,71,106,31},
	s_reset_camera_t_ip_xywh = {138,71,26,31},
	s_reboot_camera_tipinfo_xywh = {26,120,160,35},
};

w1_modify_camera.s_1280 = 
{
	s_modifycamera_xywh = {350,202,580,620},
	s_modify_camera_titleimg_xywh = {13,15,24,24}, 
	s_modify_camera_titlestr_xywh = {50,15,476,40},
	s_modify_camera_titleclose_xywh = {541,15,24,24},
	s_modify_camera_c_name_xywh = {50,90,200,40}, 
	s_modify_camera_t_name_xywh = {260,90,250,40},
	s_modify_camera_c_ip_xywh = {50,150,200,40}, 
	s_modify_camera_t_ip_xywh = {260,150,250,40},
	s_modify_camera_c_prot_xywh = {50,210,200,40}, 
	s_modify_camera_t_prot_xywh = {260,210,250,40},
	s_modify_camera_c_port_xywh = {50,270,200,40}, 
	s_modify_camera_t_port_xywh = {260,270,250,40},
	s_modify_camera_c_user_xywh = {50,330,200,40}, 
	s_modify_camera_t_user_xywh = {260,330,250,40},
	s_modify_camera_c_pwd_xywh = {50,390,200,40}, 
	s_modify_camera_t_pwd_xywh = {260,390,250,40},
	s_modify_camera_c_remote_ch_xywh ={50,450,200,40}, 
	s_modify_camera_t_remote_ch_xywh ={260,450,250,40},	
	s_modify_camera_tipinfo_xywh = {50,510,500,18},
	s_modify_camera_hline_xywh = {15,540,550,2},
	s_modify_camera_ok_xywh = {305,560,120,38},
	s_modify_camera_cancel_xywh = {445,560,120,38},
	s_reset_camera_msg_xywh= {50,30,548,50},
	s_reset_camera_cap_ip_xywh= {50,100,200,44},
	s_reset_camera_t_ip_xywh= {260,100,50,44},
	s_reboot_camera_tipinfo_xywh = {50,170,300,50},
};

w1_modify_camera.s_1440 = 
{
	s_modifycamera_xywh = {430,140,580,620},
	s_modify_camera_titleimg_xywh = {13,15,24,24}, 
	s_modify_camera_titlestr_xywh = {50,15,476,40},
	s_modify_camera_titleclose_xywh = {541,15,24,24},
	s_modify_camera_c_name_xywh = {50,90,200,40}, 
	s_modify_camera_t_name_xywh = {260,90,250,40},
	s_modify_camera_c_ip_xywh = {50,150,200,40}, 
	s_modify_camera_t_ip_xywh = {260,150,250,40},
	s_modify_camera_c_prot_xywh = {50,210,200,40}, 
	s_modify_camera_t_prot_xywh = {260,210,250,40},
	s_modify_camera_c_port_xywh = {50,270,200,40}, 
	s_modify_camera_t_port_xywh = {260,270,250,40},
	s_modify_camera_c_user_xywh = {50,330,200,40}, 
	s_modify_camera_t_user_xywh = {260,330,250,40},
	s_modify_camera_c_pwd_xywh = {50,390,200,40}, 
	s_modify_camera_t_pwd_xywh = {260,390,250,40},
	s_modify_camera_c_remote_ch_xywh ={50,450,200,40}, 
	s_modify_camera_t_remote_ch_xywh ={260,450,250,40},	
	s_modify_camera_tipinfo_xywh = {50,510,500,18},
	s_modify_camera_hline_xywh = {15,540,550,2},
	s_modify_camera_ok_xywh = {305,560,120,38},
	s_modify_camera_cancel_xywh = {445,560,120,38},
	s_reset_camera_msg_xywh= {50,30,548,50},
	s_reset_camera_cap_ip_xywh= {50,100,200,44},
	s_reset_camera_t_ip_xywh= {260,100,50,44},
	s_reboot_camera_tipinfo_xywh = {50,170,300,50},
};

w1_modify_camera.s_1080p = 
{
	s_modifycamera_xywh = {670,245,580,620},
	s_modify_camera_titleimg_xywh = {13,15,24,24}, 
	s_modify_camera_titlestr_xywh = {50,15,476,40},
	s_modify_camera_titleclose_xywh = {541,15,24,24},
	s_modify_camera_c_name_xywh = {50,90,200,40}, 
	s_modify_camera_t_name_xywh = {260,90,250,40},
	s_modify_camera_c_ip_xywh = {50,150,200,40}, 
	s_modify_camera_t_ip_xywh = {260,150,250,40},
	s_modify_camera_c_prot_xywh = {50,210,200,40}, 
	s_modify_camera_t_prot_xywh = {260,210,250,40},
	s_modify_camera_c_port_xywh = {50,270,200,40}, 
	s_modify_camera_t_port_xywh = {260,270,250,40},
	s_modify_camera_c_user_xywh = {50,330,200,40}, 
	s_modify_camera_t_user_xywh = {260,330,250,40},
	s_modify_camera_c_pwd_xywh = {50,390,200,40}, 
	s_modify_camera_t_pwd_xywh = {260,390,250,40},
	s_modify_camera_c_remote_ch_xywh ={50,450,200,40}, 
	s_modify_camera_t_remote_ch_xywh ={260,450,250,40},	
	s_modify_camera_tipinfo_xywh = {50,510,500,18},
	s_modify_camera_hline_xywh = {15,540,550,2},
	s_modify_camera_ok_xywh = {305,560,120,38},
	s_modify_camera_cancel_xywh = {445,560,120,38},
	s_reset_camera_msg_xywh= {50,30,548,50},
	s_reset_camera_cap_ip_xywh= {50,100,200,44},
	s_reset_camera_t_ip_xywh= {260,100,50,44},
	s_reboot_camera_tipinfo_xywh = {50,170,300,50},
};
w1_modify_camera.s_2k = 
{
	s_modifycamera_xywh = {893,327,773,826},
	s_modify_camera_titleimg_xywh = {17,20,32,32},
	s_modify_camera_titlestr_xywh = {67,20,635,53},
	s_modify_camera_titleclose_xywh = {721,20,32,32},
	s_modify_camera_c_name_xywh = {67,120,270,53},
	s_modify_camera_t_name_xywh = {350,120,330,53},
	s_modify_camera_c_ip_xywh = {67,200,270,53},
	s_modify_camera_t_ip_xywh = {350,200,330,53},
	s_modify_camera_c_prot_xywh = {67,280,270,53},
	s_modify_camera_t_prot_xywh = {350,280,330,53},
	s_modify_camera_c_port_xywh = {67,360,270,53},
	s_modify_camera_t_port_xywh = {350,360,330,53},
	s_modify_camera_c_user_xywh = {67,440,270,53},
	s_modify_camera_t_user_xywh = {350,440,330,53},
	s_modify_camera_c_pwd_xywh = {67,520,270,53},
	s_modify_camera_t_pwd_xywh = {350,520,330,53},
	s_modify_camera_c_remote_ch_xywh ={67,600,270,53}, 
	s_modify_camera_t_remote_ch_xywh ={350,600,330,53},
	s_modify_camera_tipinfo_xywh = {67,680,667,24},
	s_modify_camera_hline_xywh = {20,720,733,3},
	s_modify_camera_ok_xywh = {427,746,160,51},
	s_modify_camera_cancel_xywh = {593,746,160,51},
	s_reset_camera_msg_xywh= {67,40,731,67},
	s_reset_camera_cap_ip_xywh= {67,133,267,59},
	s_reset_camera_t_ip_xywh= {347,133,67,59},
	s_reboot_camera_tipinfo_xywh = {67,227,400,80},		
};
w1_modify_camera.s_4k = 
{
	s_modifycamera_xywh = {1340,490,1160,1240},
	s_modify_camera_titleimg_xywh = {26,30,48,48},
	s_modify_camera_titlestr_xywh = {100,30,952,80},
	s_modify_camera_titleclose_xywh = {1082,30,48,48},
	s_modify_camera_c_name_xywh = {100,180,400,80},
	s_modify_camera_t_name_xywh = {520,180,500,80},
	s_modify_camera_c_ip_xywh = {100,300,400,80},
	s_modify_camera_t_ip_xywh = {520,300,500,80},
	s_modify_camera_c_prot_xywh = {100,420,400,80},
	s_modify_camera_t_prot_xywh = {520,420,500,80},
	s_modify_camera_c_port_xywh = {100,540,400,80},
	s_modify_camera_t_port_xywh = {520,540,500,80},
	s_modify_camera_c_user_xywh = {100,660,400,80},
	s_modify_camera_t_user_xywh = {520,660,500,80},
	s_modify_camera_c_pwd_xywh = {100,780,400,80},
	s_modify_camera_t_pwd_xywh = {520,780,500,80},
	s_modify_camera_c_remote_ch_xywh ={100,900,400,80}, 
	s_modify_camera_t_remote_ch_xywh ={520,900,500,80},		
	s_modify_camera_tipinfo_xywh = {100,1020,1000,36},
	s_modify_camera_hline_xywh = {30,1080,1100,4},
	s_modify_camera_ok_xywh = {640,1120,240,76},
	s_modify_camera_cancel_xywh = {890,1120,240,76},
	s_reset_camera_msg_xywh= {100,60,1096,100},
	s_reset_camera_cap_ip_xywh= {100,200,400,88},
	s_reset_camera_t_ip_xywh= {520,200,100,88},
	s_reboot_camera_tipinfo_xywh = {100,340,600,120},
};


local oldprotport = {}
local SAVE_IP;
local dev_type;
local rtsp_protocol
w1_modify_camera.init = function()
	w1_modify_camera.ok_func = nil;				--okťص	
	w1_modify_camera.okfunc_param = nil;		--okťص
end

w1_modify_camera.set_func  = function(ok_func, okfunc_param, cannel_func, cancelfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')
	
	w1_modify_camera.ok_func = ok_func;
	w1_modify_camera.okfunc_param = okfunc_param;
end

w1_modify_camera.set_data = function(data)
	if(w1_modify_camera.data == nil) then
		w1_modify_camera.data = data;
	else
		util.copy_tab_b(w1_modify_camera.data, data);
	end
end

w1_modify_camera.clear_data = function(data)
	w1_modify_camera.data = nil;
	w1_modify_camera.okfunc_param = nil;
	rtsp_protocol = nil;
end

local getdata_forchid= function(channel_id)
	assert(type(channel_id) == 'number');
	local data = w1_modify_camera.data;
	for i = 1, data.camera_num do
		if(data['idx'..i].channel_id == channel_id) then
			return data['idx'..i];
		end
	end
	return nil;
end

local is_change = function(top)
	local cwnd = w1_modify_camera.dlg;
	if(w1_modify_camera.edit_type == 1) then--༭ͼ
		local data = getdata_forchid(w1_modify_camera.sel);
		if(data == nil) then
			return 0;
		end
		
		--Э
		if (w1_modify_camera.support_ssl == true and data.protocol ~=3) then
			if(data.protocol == 4)then
				if b_wnd_ex.get_sel(top,  cwnd.t_prot.id) ~= data.protocol - 2 then
					return true
				end
			elseif data.protocol > 100 then
				if b_wnd_ex.get_sel(top,  cwnd.t_prot.id) ~= data.protocol - 98 then
					return true
				end
			else
				if b_wnd_ex.get_sel(top,  cwnd.t_prot.id) ~= data.protocol - 1 then
					return true
				end
			end
		else
			if data.protocol > 100 then
				if b_wnd_ex.get_sel(top,  cwnd.t_prot.id) ~= data.protocol - 99 then
					return true
				end
			else
				if b_wnd_ex.get_sel(top,  cwnd.t_prot.id) ~= data.protocol - 1 then
					return true
				end
			end	
		end	
		
		w1_modify_camera.device_type = data.protocol;
		if(b_wnd_ex.get_text(top, cwnd.t_name.id) ~= data.name) then
			return true
		end
		if(b_wnd_ex.get_text(top, cwnd.t_ip.id) ~= data.addr) then
			return true
		end

		if(b_wnd_ex.get_value(top, cwnd.t_port.id) ~= data.port) then
			return true;
		end
		
		if(b_wnd_ex.get_text(top, cwnd.t_user.id) ~= data.account) then
			return true;
		end
		
		if(b_wnd_ex.get_password(top, cwnd.t_pwd.id) ~= data.password) then
			return true;
		end

		if(data.remote_cam <= 0)then
			if b_wnd_ex.get_sel(top,  cwnd.t_remote_ch.id) ~= 0 then
				return true;
			end				
		else
			if b_wnd_ex.get_sel(top, cwnd.t_remote_ch.id) ~= data.remote_cam - 1 then
				return true;
			end
		end
	else
		if(b_wnd_ex.get_text(top, cwnd.t_ip.id) ~= '') then
			return true
		end
		
		if b_wnd_ex.get_sel(top,  cwnd.t_prot.id) ~= 0 then
			return true
		end
		
		if(b_wnd_ex.get_value(top, cwnd.t_port.id) ~= 80) then
			return true;
		end
		
		if(b_wnd_ex.get_text(top, cwnd.t_user.id) ~= '') then
			return true;
		end
		
		if(b_wnd_ex.get_password(top, cwnd.t_pwd.id) ~= '') then
			return true;
		end
		if b_wnd_ex.get_sel(top,  cwnd.t_remote_ch.id) ~= 0 then
			return true;
		end				
	end	
	return false
end

local save_change = function(param)
	local cwnd = w1_modify_camera.dlg;
	
	if(w1_legal.is_empty(param[1], cwnd.t_name.id)) then
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_DEVICE_NAME_EMPTY'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_modify_camera.save_check_illegal = true
		return 0;
	end
	local dev_name = b_wnd_ex.get_text(param[1], cwnd.t_name.id);
	local ch = string.gsub(dev_name, "^%s*(.-)%s*$", "%1")
	if ch == nil or ch == ''then
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_USERNAME_EMPTY'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_modify_camera.save_check_illegal = true
		return 0;
	end		
	local ret = string.find(dev_name,'[\"\'\\]',1);
	if ret ~= nil then
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_CHANNEL_ERR'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_modify_camera.save_check_illegal = true
		return 0;		
	end
	local legal, num = w1_legal.check_ip(param[1], cwnd.t_ip.id)
	if(legal == false) then
		if(num == w1_legal.ip.EMPTY or num == w1_legal.ip.PRARMERR or num == w1_legal.ip.LENERR) then
			b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_NETIP_ERR'), false);
			b_dlg.dlg_set_redraw(param[1]);
			w1_modify_camera.save_check_illegal = true
			return 0;
		end
	end
	
	local cur_ip;
	local modlist = {idx1 = {}};
	modlist.camera_num = 1;
	if(w1_modify_camera.edit_type == 0) then--
		modlist.idx1.channel_id = w1_modify_camera.sel;
		cur_ip = nil;
	elseif(w1_modify_camera.edit_type == 1) then--༭
		if(modlist.idx1 == nil) then
			modlist.idx1 =  util.copy_tab(getdata_forchid(w1_modify_camera.sel));
		else
			util.copy_tab_b(modlist.idx1, getdata_forchid(w1_modify_camera.sel));
		end
		local data = w1_modify_camera.data;
		for i=1, data.camera_num do
			if(modlist.idx1.channel_id == data['idx'..i].channel_id) then
				cur_ip = data['idx'..i].addr
				break;
			end			
		end
	end

	
	modlist['idx1'].name = dev_name;
		
	local ip_addr = b_wnd_ex.get_text(param[1], cwnd.t_ip.id);
	local ip1, ip2, ip3, ip4 = string.match(ip_addr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");	
	local ipstr = tonumber(ip1)..'.'..tonumber(ip2)..'.'..tonumber(ip3)..'.'..tonumber(ip4);
	modlist['idx1'].addr = ipstr;
	
	local protocol = b_wnd_ex.get_sel(param[1], cwnd.t_prot.id) + 1;
	modlist['idx1'].protocol = protocol;
	--ssl
	if (protocol == 3 and dev_type ~= true and w1_modify_camera.support_ssl == true) then
		modlist['idx1'].protocol = 4;
	elseif(protocol == 3 and dev_type == true) then
		
	elseif(protocol >= 3) then
		if dev_type == true or w1_modify_camera.support_ssl == true then
			modlist['idx1'].protocol = protocol + 97;
		else
			modlist['idx1'].protocol = protocol + 98;
		end
	end	
	
	local port = b_wnd_ex.get_text(param[1], cwnd.t_port.id);
	modlist['idx1'].port = tonumber(port);
	
	local user = b_wnd_ex.get_text(param[1], cwnd.t_user.id);
	modlist['idx1'].account = user;
	
	local pwd = b_wnd_ex.get_password(param[1], cwnd.t_pwd.id);
	modlist['idx1'].password = pwd;
	
	local remote_channel = b_wnd_ex.get_sel(param[1],  cwnd.t_remote_ch.id);
	modlist['idx1'].remote_cam = remote_channel+1;

	modlist['idx1'].binded = true;

	local ret;
	if(w1_modify_camera.edit_type == 0) then--
		ret = b_app_api.manual_add_camera(modlist);
		if ret.ret== -2 or ret.ret==-4 then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_CAMERA_MANAGED'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
		elseif ret.ret < 0 then
			b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_ADD_CHN_FAIL'), false);
			b_dlg.dlg_set_redraw(param[1]);
			w1_modify_camera.save_check_illegal = true
			return 0;
		end
	elseif(w1_modify_camera.edit_type == 1) then--༭
		ret = b_app_api.onekeyadd_camera(modlist);
		if ret.ret== -2 or ret.ret==-4 then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_CAMERA_MANAGED'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
		elseif ret.ret < 0 then
			b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_MOD_CHN_FAIL'), false);
			b_dlg.dlg_set_redraw(param[1]);
			w1_modify_camera.save_check_illegal = true
			return 0;
		end
	end
	w1_modify_camera.okfunc_param[2] = w1_modify_camera.edit_type;
	w1_modify_camera.okfunc_param[3] = w1_modify_camera.sel;
	w1_modify_camera.ok_func(w1_modify_camera.okfunc_param);
	b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, '', false);
	return 0;
end

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_modify_camera.dlg;
		
		if(w1_legal.is_empty(top, cwnd.t_name.id)) then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_DEVICE_NAME_EMPTY'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
		local dev_name = b_wnd_ex.get_text(top, cwnd.t_name.id);
		local ch = string.gsub(dev_name, "^%s*(.-)%s*$", "%1")
		if ch == nil or ch == ''then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_USERNAME_EMPTY'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end		

		local legal, num = w1_legal.check_ip(top, cwnd.t_ip.id)
		if(legal == false) then
			if(num == w1_legal.ip.EMPTY or num == w1_legal.ip.PRARMERR or num == w1_legal.ip.LENERR) then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_NETIP_ERR'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
		end
		
		local cur_ip;
		local modlist = {idx1 = {}};
		modlist.camera_num = 1;
		if(w1_modify_camera.edit_type == 0) then--
			modlist.idx1.channel_id = w1_modify_camera.sel;
			cur_ip = nil;
		elseif(w1_modify_camera.edit_type == 1) then--༭
			if(modlist.idx1 == nil) then
				modlist.idx1 =  util.copy_tab(getdata_forchid(w1_modify_camera.sel));
			else
				util.copy_tab_b(modlist.idx1, getdata_forchid(w1_modify_camera.sel));
			end
			local data = w1_modify_camera.data;
			for i=1, data.camera_num do
				if(modlist.idx1.channel_id == data['idx'..i].channel_id) then
					cur_ip = data['idx'..i].addr
					break;
				end			
			end
		end

		
		modlist['idx1'].name = dev_name;
			
		local ip_addr = b_wnd_ex.get_text(top, cwnd.t_ip.id);
		local ip1, ip2, ip3, ip4 = string.match(ip_addr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");	
		local ipstr = tonumber(ip1)..'.'..tonumber(ip2)..'.'..tonumber(ip3)..'.'..tonumber(ip4);
		modlist['idx1'].addr = ipstr;
		
		local protocol = b_wnd_ex.get_sel(top, cwnd.t_prot.id) + 1;
		modlist['idx1'].protocol = protocol;
		--ssl
		if (protocol == 3 and dev_type ~= true and w1_modify_camera.support_ssl == true) then
			modlist['idx1'].protocol = 4;
		elseif(protocol == 3 and dev_type == true) then
			
		elseif(protocol >= 3)then
			if dev_type == true or w1_modify_camera.support_ssl == true then
				modlist['idx1'].protocol = protocol + 97;
			else
				modlist['idx1'].protocol = protocol + 98;
			end
		end		
		
		local port = b_wnd_ex.get_text(top, cwnd.t_port.id);
		modlist['idx1'].port = tonumber(port);
		
		local user = b_wnd_ex.get_text(top, cwnd.t_user.id);
		modlist['idx1'].account = user;
		
		local pwd = b_wnd_ex.get_password(top, cwnd.t_pwd.id);
		modlist['idx1'].password = pwd;
		
		local remote_channel = b_wnd_ex.get_sel(top,  cwnd.t_remote_ch.id);
		modlist['idx1'].remote_cam = remote_channel+1;
	
		modlist['idx1'].binded = true;
		
		--ӻ߱༭IPǷѾ
		local ret;
		if(w1_modify_camera.edit_type == 0) then--
			ret = b_app_api.manual_add_camera(modlist);
			if ret.ret== -2 or ret.ret==-4 then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_CAMERA_MANAGED'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			elseif ret.ret < 0 then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_ADD_CHN_FAIL'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			elseif ret.ret == 3105 then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_IP_CONFLICT'), false);
				b_dlg.dlg_set_redraw(top);
				return 0
			end
		elseif(w1_modify_camera.edit_type == 1) then--༭
			ret = b_app_api.onekeyadd_camera(modlist);
			if ret.ret== -2 or ret.ret==-4 then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_CAMERA_MANAGED'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			elseif ret.ret < 0 then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_MOD_CHN_FAIL'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			elseif ret.ret == 3105 then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_IP_CONFLICT'), false);
				b_dlg.dlg_set_redraw(top);
				return 0
			end
		end
		b_dlg.end_modal(top);
		w1_modify_camera.okfunc_param[2] = w1_modify_camera.edit_type;
		w1_modify_camera.okfunc_param[3] = w1_modify_camera.sel;
		w1_modify_camera.ok_func(w1_modify_camera.okfunc_param);
		b_wnd_ex.set_text(top, cwnd.tipinfo.id, '', false);
	end
	return 0
end

local on_ok_del = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local modlist = {idx1 = {}};
		modlist.camera_num = 1;
		modlist.idx1 = getdata_forchid(w1_modify_camera.sel);
		if(modlist.idx1 == nil or next(modlist.idx1) == nil)then
			b_dlg.end_modal(top);
			return 0;
		end
		modlist.idx1.channel_id = w1_modify_camera.sel;
		modlist.idx1.binded = false;
		b_app_api.onekeyadd_camera(modlist);
		b_dlg.end_modal(top);
		w1_modify_camera.okfunc_param[2] = w1_modify_camera.edit_type;
		w1_modify_camera.okfunc_param[3] = w1_modify_camera.sel;
		w1_modify_camera.ok_func(w1_modify_camera.okfunc_param);
	end
	return 0;
end

local on_ok_reboot = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local modlist = {};
		modlist.channel_id = w1_modify_camera.sel;		
		local ret = b_app_api.manual_reboot_camera(modlist);
		if ret.ret < 0 then
			b_wnd_ex.set_text(top, w1_modify_camera.dlg.tipinfo.id, STR('LA_REBOOT_FAIL'), false);
			b_dlg.dlg_set_redraw(top);			
			return 0;
		end
		b_dlg.end_modal(top);
	end
	return 0;
end

local on_ok_reset = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local modlist = {};
		modlist.channel_id =  w1_modify_camera.sel;
		modlist.save_flag = SAVE_IP;
		local ret = b_app_api.manual_reset_camera(modlist);
		if ret.ret < 0 then
			b_wnd_ex.set_text(top, w1_modify_camera.dlg.tipinfo.id, STR('LA_RESET_FAIL'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
		b_dlg.end_modal(top);	
	end
	return 0;
end

local on_retain_ip = function(top,id,vmsg,x,y)
	if b_ui.LBUTTONCLK == vmsg then
		SAVE_IP = b_wnd_ex.get_check(top, id);
	end
	return 0;
end	

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0;
end

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local on_protocolchange = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_modify_camera.dlg;
		local prot = b_wnd_ex.get_sel(top, w1_modify_camera.dlg.t_prot.id) + 1 ;
		b_wnd_ex.set_disable(top, w1_modify_camera.dlg.t_port.id ,false,false);
		if(prot == oldprotport.prot) then
			b_wnd_ex.set_value(top, w1_modify_camera.dlg.t_port.id , oldprotport.port,false);
		elseif(prot == 1) then
			b_wnd_ex.set_value(top, w1_modify_camera.dlg.t_port.id , 80,false);
		elseif(prot == 2) then
			b_wnd_ex.set_value(top, w1_modify_camera.dlg.t_port.id , 30001,false);
		else
			if(w1_modify_camera.support_ssl == true) then
				if prot == 3 then --ssl  ˿ں20001	
					b_wnd_ex.set_value(top, w1_modify_camera.dlg.t_port.id , 20001,false);
				else
					b_wnd_ex.set_value(top, w1_modify_camera.dlg.t_port.id , rtsp_protocol['idx'..prot-3]['stream'..1].port,false);
					b_wnd_ex.set_disable(top, w1_modify_camera.dlg.t_port.id ,true,false);
				end
			else
				b_wnd_ex.set_value(top, w1_modify_camera.dlg.t_port.id , rtsp_protocol['idx'..prot-2]['stream'..1].port,false);
				b_wnd_ex.set_disable(top, w1_modify_camera.dlg.t_port.id ,true,false);
			end
		end
		local prot_id = b_wnd_ex.get_sel(top,  cwnd.t_prot.id);
		local flag = 0
		if dev_type == true or w1_modify_camera.support_ssl == true then
			if (prot_id>2)then
				flag = 1;
			end
		else
			if (prot_id>1)then
				flag = 1;
			end
		end
		if (0 == prot_id or flag ==1)then
			b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, true, false);
		else
			b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, false, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local dlg = {
	attr 	= {xywh='s_modifycamera_xywh',},
	
	
	sub 	= {'titleimg', 'titlestr', 'titleclose', 
			'c_name', 't_name', 'c_ip', 't_ip', 'c_port', 't_port',
			'c_prot', 't_prot', 'c_user', 't_user', 'c_pwd', 't_pwd',
			'c_remote_ch','t_remote_ch','tipinfo','hline','ok','cancel'},
			
			
	titleimg 	= {t='tt_picture',	id=id+1,xywh='s_modify_camera_titleimg_xywh', 
					t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_editpic','it_editcameera'}},
	
	titlestr	= {t='static', 	id=id+2,xywh='s_modify_camera_titlestr_xywh', 
					text='',	font = 'f_grade5',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_titlestr'},
					},
					
	titleclose 	= {t='tt_button',id=id+3,xywh = 's_modify_camera_titleclose_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					cmd=on_close,
					},
	c_name 		= {t='static', 	id=id+4,xywh='s_modify_camera_c_name_xywh', 
					text='LA_DEVICE_NAME',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_name 		= {t='edit', 	id=id+5,xywh='s_modify_camera_t_name_xywh', 
					text='',	trans = false, 	font = 'f_grade6',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
					
	c_ip 		= {t='static', 	id=id+6,xywh='s_modify_camera_c_ip_xywh', 
					text='LA_IP_ADDRESS',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_ip 		= {t='edit_ip', 	id=id+7,xywh='s_modify_camera_t_ip_xywh', 
					text='',	trans = false, 	font = 'f_grade6',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
					
	c_prot 		= {t='static', 	id=id+8,xywh='s_modify_camera_c_prot_xywh', 
					text='LA_PROTOCOL',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_prot 		= {t='combox', 	id=id+9,xywh='s_modify_camera_t_prot_xywh', 
					font = 'f_grade6',items={},trans = false,
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					cmd = on_protocolchange
					},	
			
	c_port 		= {t='static', 	id=id+10,xywh='s_modify_camera_c_port_xywh', 
					text='LA_PORT',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_port 		= {t='edit_num', 	id=id+11,xywh='s_modify_camera_t_port_xywh', 
					value = 80, trans = false, 	font = 'f_grade6',range={1,65535},
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},		
					
	c_user 		= {t='static', 	id=id+12,xywh='s_modify_camera_c_user_xywh', 
					text='LA_USER_NAME',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_user 		= {t='edit', 	id=id+13,xywh='s_modify_camera_t_user_xywh',
					text='',	trans = false, 	font = 'f_grade6',guide_text='LA_USER_NAME',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
				
	c_pwd 		= {t='static', 	id=id+14,xywh='s_modify_camera_c_pwd_xywh', 
					text='LA_PASSWORD',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_pwd 		= {t='password', 	id=id+15,xywh='s_modify_camera_t_pwd_xywh', 
					password='',	font = 'f_grade6',guide_text='LA_PASSWORD',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},			
	c_remote_ch = {t='static', 	id=id+16,xywh='s_modify_camera_c_remote_ch_xywh', 
					text='LA_REMOTE_CHANNEL',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_remote_ch = {t='combox', 	id=id+17,xywh='s_modify_camera_t_remote_ch_xywh', font = 'f_grade6',
					items={'CH-1','CH-2','CH-3','CH-4','CH-5','CH-6','CH-7','CH-8','CH-9','CH-10','CH-11',
					'CH-12','CH-13','CH-14','CH-15','CH-16'},trans = false,
					},
					
	tipinfo		= {t='static',id=id+18,	xywh='s_modify_camera_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
					},
	hline		= {t='hline',	id=id+19,	xywh='s_modify_camera_hline_xywh'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
				
	ok			= {t='tt_button',id=id+20,	xywh='s_modify_camera_ok_xywh',	text='LA_OK', font='f_grade6', cmd=on_ok,
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	cancel		= {t='tt_button',id=id+21,	xywh='s_modify_camera_cancel_xywh',text='LA_CANCEL',font='f_grade6',cmd=on_cancel,
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
					},
}

local dlg_del = {
	attr 	= {xywh='s_msgbox_xywh',},
	sub 	= {'msg','ok', 'cancel'},
	
	msg	 	= {t='static',	id=id+2,	xywh='s_msgbox_msg_xywh',	
			text='LA_CONFIRM_DELETE',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
		
	ok		= {t='button',	id=id+4,	xywh='s_msgbox_ok_xywh',	text='LA_OK', font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok_del},
	cancel	= {t='button',	id=id+5,	xywh='s_msgbox_cancel_xywh',text='LA_CANCEL', font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
				cmd=on_close},		
}

local dlg_reboot = {
	attr 	= {xywh='s_msgbox_xywh',},
	sub 	= {'msg', 'ok','tipinfo', 'cancel'},
	
	msg	 	= {t='static',	id=id+1,	xywh='s_msgbox_msg_xywh',	
			text='LA_SURE_REBOOT',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
			
	tipinfo		= {t='static',id=id+2,	xywh='s_reboot_camera_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
					},
	
	ok		= {t='button',	id=id+3,	xywh='s_msgbox_ok_xywh',	text='LA_OK', font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok_reboot},
	cancel	= {t='button',	id=id+4,	xywh='s_msgbox_cancel_xywh',text='LA_CANCEL', font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
				cmd=on_close},		
}

local dlg_reset = {
	attr 	= {xywh='s_msgbox_xywh',},
	sub 	= {'msg','t_ip','cap_ip','tipinfo','ok', 'cancel'},
	
	msg	 	= {t='static',	id=id+1,	xywh='s_reset_camera_msg_xywh',	
			text='LA_SURE_RESET',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	cap_ip	= {t='static', id=id+2, xywh='s_reset_camera_cap_ip_xywh',
			text='LA_RESERVE_IP_ADDRESS',align = b_ui.ALIGN.LEFT, font = 'f_grade6',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_ip	= {t='tt_check',id=id+3, xywh='s_reset_camera_t_ip_xywh',font = 'f_grade6',check = true,
					t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					cmd = on_retain_ip,},
					
	tipinfo		= {t='static',id=id+4,	xywh='s_reboot_camera_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
					},

	ok		= {t='button',	id=id+5,	xywh='s_msgbox_ok_xywh',	text='LA_OK', font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok_reset},
				
	cancel	= {t='button',	id=id+6,	xywh='s_msgbox_cancel_xywh',text='LA_CANCEL', font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
				cmd=on_close},		
}

w1_modify_camera.on_create = function(top)
	w1_modify_camera.top = top;
	SAVE_IP = true;
	w1_modify_camera.support_ssl = global_val.get_support_ssl_attr();
	return 0;
end

w1_modify_camera.on_destroy = function(top)
	w1_modify_camera.top = nil;
	w1_modify_camera.dlg = nil;
	return 0;
end

w1_modify_camera.on_pre_show = function(top)
	w1_modify_camera.device_type =0;
	local param = b_wnd.get_wnd_data(top);	
	if(param ~= nil)then
		local paramdata = cjson.decode(param);
		w1_modify_camera.edit_type = paramdata.opera;
		w1_modify_camera.sel = paramdata.sel;
	end
	dev_type = false;
	local edittype = w1_modify_camera.edit_type;
	local trade_name = b_app_api.get_trade_name().name;
	if(trade_name == nil or trade_name == '') then
		trade_name = 'Private'
	end
	if rtsp_protocol == nil then
		rtsp_protocol = b_app_api.get_rtsp_pro();
	else
		rtsp_protocol = util.copy_tab(b_app_api.get_rtsp_pro());
	end
	
	assert(edittype == 0  or edittype == 1 or edittype == 2 or edittype == 3 or edittype == 4);
	if(edittype == 0 or edittype == 1) then--ӡ༭
		if(edittype == 0) then--ӱͼ
			dlg.titlestr.text = 'LA_ADD_CAMERA';
			dlg.c_name.text = 'LA_CHANNEL';dlg.t_name.t = 'static';
			dlg.t_name.text = tostring(math.floor(w1_modify_camera.sel/1));
		--	dlg.t_name.trans = false;
			dlg.titleimg.t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_addcameera'};	
		elseif(edittype == 1) then--༭ͼ
			dlg.titlestr.text = 'LA_MODIFY_CAMERA';
			dlg.c_name.text = 'LA_CHANNEL_NAME'
			dlg.t_name.t = 'edit';
			dlg.titleimg.t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_editcameera'};		
		end
		w1_modify_camera.dlg = dlg;
		b_parser(top, w1_modify_camera.dlg);	
		local cwnd = w1_modify_camera.dlg;
		local data = getdata_forchid(w1_modify_camera.sel);
		if(edittype == 1) then--༭ͼ
			--local data = getdata_forchid(w1_modify_camera.sel);
			if(data == nil) then
				return 0;
			end
			
			--Э
			if (w1_modify_camera.support_ssl == true and data.protocol ~=3) then
				local type_list ={'ONVIF',trade_name,trade_name..'_SSL'};
				local count = rtsp_protocol.protocol_num
				for i=1, count do
					table.insert(type_list,rtsp_protocol['idx'..i].name);
				end
				
				b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
				if(data.protocol == 4)then
					b_wnd_ex.set_sel(top,  cwnd.t_prot.id, data.protocol - 2, false);
				elseif(data.protocol > 100)then
					b_wnd_ex.set_sel(top,  cwnd.t_prot.id, data.protocol - 98, false);
					b_wnd_ex.set_disable(top, cwnd.t_port.id, true, false);
				else
					b_wnd_ex.set_sel(top,  cwnd.t_prot.id, data.protocol - 1, false);
				end
			else
				local type_list ={'ONVIF',trade_name};
				local count = rtsp_protocol.protocol_num
				for i=1, count do
					table.insert(type_list,rtsp_protocol['idx'..i].name);
				end
				b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
				if data.protocol > 100 then
					b_wnd_ex.set_sel(top,  cwnd.t_prot.id, data.protocol - 99, false);
					b_wnd_ex.set_disable(top, cwnd.t_port.id, true, false);
				else
					b_wnd_ex.set_sel(top,  cwnd.t_prot.id, data.protocol - 1, false);
				end
			end	
			
			w1_modify_camera.device_type = data.protocol;
			b_wnd_ex.set_text(top, cwnd.t_name.id, data.name, false);
			b_wnd_ex.set_text(top, cwnd.t_ip.id, data.addr, false);
			oldprotport.prot = data.protocol;
			oldprotport.port = data.port;
			b_wnd_ex.set_value(top, cwnd.t_port.id, data.port, false);
			b_wnd_ex.set_text(top, cwnd.t_user.id, data.account, false);
			b_wnd_ex.set_password(top, cwnd.t_pwd.id, data.password, false);
			if(data.remote_cam <= 0)then
				b_wnd_ex.set_sel(top,  cwnd.t_remote_ch.id, 0, false);
			else	
				b_wnd_ex.set_sel(top,  cwnd.t_remote_ch.id, data.remote_cam - 1, false);
			end
			if data.state == 4 then	--豸״̬
				b_wnd_ex.set_color_d(top, cwnd.t_ip.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
				b_wnd_ex.set_disable(top,cwnd.t_ip.id,true,false);
				b_wnd_ex.set_disable(top,cwnd.t_prot.id,true,false);
				b_wnd_ex.set_disable(top,cwnd.t_port.id,true,false);
				
			end
			
			if(data.protocol ==3)then
				dev_type = true;
				local root_name = global_val.get_root_user_name();
				local type_list ={'ONVIF',trade_name,'Local'};
				b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
				b_wnd_ex.set_sel(top,  cwnd.t_prot.id, data.protocol - 1, false);
				b_wnd_ex.set_text(top, cwnd.t_user.id, root_name, false);
				b_wnd_ex.set_password(top, cwnd.t_pwd.id, root_name, false);
				b_wnd_ex.set_disable(top,cwnd.t_ip.id,true,false);
				b_wnd_ex.set_disable(top,cwnd.t_prot.id,true,false);
				b_wnd_ex.set_disable(top,cwnd.t_port.id,true,false);
				b_wnd_ex.set_disable(top,cwnd.t_user.id,true,false);
				b_wnd_ex.set_disable(top,cwnd.t_pwd.id,true,false);
				b_wnd_ex.set_disable(top,cwnd.t_remote_ch.id,true,false);
			end
		else
			--Э
			if (w1_modify_camera.support_ssl == true) then
				local type_list ={'ONVIF',trade_name,trade_name..'_SSL'};
				local count = rtsp_protocol.protocol_num
				for i=1, count do
					table.insert(type_list,rtsp_protocol['idx'..i].name);
				end
				b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
				b_wnd_ex.set_sel(top,  cwnd.t_prot.id, 0, false);
			else
				local type_list ={'ONVIF',trade_name};
				local count = rtsp_protocol.protocol_num
				for i=1, count do
					table.insert(type_list,rtsp_protocol['idx'..i].name);
				end
				b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
				b_wnd_ex.set_sel(top,  cwnd.t_prot.id, 0, false);
			end	
		end
		local prot_id = b_wnd_ex.get_sel(top,  cwnd.t_prot.id);
		if(0 == prot_id or data.protocol>100)then
			b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, true, false);
		else
			local prot_text = b_wnd_ex.get_text(top, cwnd.t_prot.id);
			if("Local" == prot_text)then
				b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, true, false);
			else
				b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, false, false);
			end
		end
		
	elseif(edittype == 2) then--ɾ
		w1_modify_camera.dlg = dlg_del;
		b_parser(top, w1_modify_camera.dlg);
	elseif(edittype == 3) then--
		w1_modify_camera.dlg = dlg_reboot;
		b_parser(top, w1_modify_camera.dlg);
	elseif(edittype == 4) then--ָ
		w1_modify_camera.dlg = dlg_reset;
		b_parser(top, w1_modify_camera.dlg);		
	end		
	return 0
end

w1_modify_camera.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_modify_camera.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
	elseif(b_ui.RBUTTONCLK == vmsg) then
		local ret = false
		w1_modify_camera.save_check_illegal = false;		
		if(w1_modify_camera.edit_type == 0 or w1_modify_camera.edit_type == 1) then
			ret = is_change(top);
		end
		if ret == true then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_WANT_SAVE'), true, true, false,STR('LA_YES'), STR('LA_BAD'));
			w1_msgbox.set_func(save_change,{top}, nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			w1_msgbox.set_func(nil,nil, nil,nil);
		end
		if w1_modify_camera.save_check_illegal == true then
			return 0;
		end
		b_dlg.end_modal(top);
	end
	return 0
end
return w1_modify_camera




