--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_abnormal.abnormal_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_row_abnormalrow 		= require("wnd.w1_cfg.w1_row_abnormalrow")
local w1_page_abnormalevent 	= require("wnd.w1_cfg.w1_page_abnormalevent")
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local b_app_cfg  = require("wnd.core.b_app_cfg")
local b_wnd 		= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_page_abnormal = 
{
	data,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_abnormal.s_768 =
{
	s_abnormal_t_enable_xywh = {277,24,25,21},
	s_abnormal_alarm_type_xywh = {53,60,106,32},
	s_abnormal_c_diskalarm_xywh = {277,64,34,46},
	s_abnormal_diskalarm_xywh = {308,94,26,26},
	s_abnormal_c_ipconflit_xywh = {357,64,34,46},
	s_abnormal_ipconflit_xywh = {388,94,26,26},
	s_abnormal_c_illegal_xywh = {437,64,34,46},
	s_abnormal_illegal_xywh = {468,94,26,26},
	s_abnormal_c_no_canle_xywh = {517,64,34,46},
	s_abnormal_no_canle_xywh = {548,96,26,26},
	s_abnormal_tipinfo_xywh = {58,540,373,35},
};

w1_page_abnormal.s_1280 = 
{
	s_abnormal_t_enable_xywh = {455,35,48,30},
	s_abnormal_alarm_type_xywh = {100,85,200,45},
	s_abnormal_circle1_xywh ={425,70,135,135},
	s_abnormal_c_diskalarm_xywh = {420,90,53,53},
	s_abnormal_diskalarm_xywh = {473,125,28,28},
	s_abnormal_c_ipconflit_xywh = {540,90,53,53},
	s_abnormal_ipconflit_xywh = {593,125,28,28},
	s_abnormal_c_illegal_xywh = {660,90,53,53},
	s_abnormal_illegal_xywh = {713,125,28,28},
	s_abnormal_c_no_canle_xywh = {780,90,53,53},
	s_abnormal_no_canle_xywh = {833,125,28,28},
	s_abnormal_tipinfo_xywh = {110,700,700,50},
}
w1_page_abnormal.s_1440 = 
{
	s_abnormal_t_enable_xywh = {520,35,48,30},
	s_abnormal_alarm_type_xywh = {100,85,200,45},
	s_abnormal_c_diskalarm_xywh = {460,90,53,53},
	s_abnormal_diskalarm_xywh = {513,125,28,28},
	s_abnormal_c_ipconflit_xywh = {580,90,53,53},
	s_abnormal_ipconflit_xywh = {633,125,28,28},
	s_abnormal_c_illegal_xywh = {710,90,53,53},
	s_abnormal_illegal_xywh = {763,125,28,28},
	s_abnormal_c_no_canle_xywh = {840,90,53,53},
	s_abnormal_no_canle_xywh = {893,125,28,28},
	s_abnormal_tipinfo_xywh = {110,700,700,50},
}

w1_page_abnormal.s_1080p = 
{
	s_abnormal_t_enable_xywh = {520,35,48,30},
	s_abnormal_alarm_type_xywh = {100,85,200,45},
	s_abnormal_c_diskalarm_xywh = {520,90,65,65},
	s_abnormal_diskalarm_xywh = {585,135,33,33},
	s_abnormal_c_ipconflit_xywh = {670,90,65,65},	
	s_abnormal_ipconflit_xywh = {735,135,40,35},
	s_abnormal_c_illegal_xywh = {820,90,65,65},
	s_abnormal_illegal_xywh = {885,135,32,32},
	s_abnormal_c_no_canle_xywh = {970,90,65,65},
	s_abnormal_no_canle_xywh = {1035,135,32,32},
	s_abnormal_tipinfo_xywh = {110,760,700,50},
}

w1_page_abnormal.s_2k = 
{
	s_abnormal_t_enable_xywh = {693,47,64,40},
	s_abnormal_alarm_type_xywh = {133,113,267,60},
	s_abnormal_c_diskalarm_xywh = {693,120,87,87},
	s_abnormal_diskalarm_xywh = {780,180,44,44},
	s_abnormal_c_ipconflit_xywh = {893,120,87,87},
	s_abnormal_ipconflit_xywh = {980,180,53,47},
	s_abnormal_c_illegal_xywh = {1093,120,87,87},
	s_abnormal_illegal_xywh = {1180,180,43,43},
	s_abnormal_c_no_canle_xywh = {1293,120,87,87},
	s_abnormal_no_canle_xywh = {1380,180,43,43},
	s_abnormal_tipinfo_xywh = {147,1013,933,67},

}

w1_page_abnormal.s_4k = 
{
	s_abnormal_t_enable_xywh = {1040,70,96,60},
	s_abnormal_alarm_type_xywh = {200,170,400,90},
	s_abnormal_c_diskalarm_xywh = {1040,180,130,130},
	s_abnormal_diskalarm_xywh = {1170,270,66,66},
	s_abnormal_c_ipconflit_xywh = {1340,180,130,130},
	s_abnormal_ipconflit_xywh = {1470,270,80,70},
	s_abnormal_c_illegal_xywh = {1640,180,130,130},
	s_abnormal_illegal_xywh = {1770,270,64,64},
	s_abnormal_c_no_canle_xywh = {1940,180,130,130},
	s_abnormal_no_canle_xywh = {2070,270,64,64},
	s_abnormal_tipinfo_xywh = {220,1520,1400,100},
}

local channel_num;--豸ͨĿ

w1_page_abnormal.clear_data = function()
	w1_page_abnormal.data = nil;
end	

local refresh_chdata = function(top, redraw)
	local c_wnd = w1_page_abnormal.wnd
	local channeldata = w1_page_abnormal.data.abnormal
	local ro_num = w1_page_abnormal.data.device_info['ro_num']
	local buzz_support = w1_page_abnormal.data.device_info['buzzer_support']
	local fan_num = w1_page_abnormal.data.device_info['fan_num']
	local enable = channeldata.enable;
	local fanalarm = channeldata.exce_type[1];
	local diskalarm = channeldata.exce_type[2];
	local ipconflit = channeldata.exce_type[3];
	local illegal = channeldata.exce_type[4];
	local no_canle = channeldata.exce_type[5];
		
	b_wnd_ex.set_check(top, c_wnd.t_enable.id, enable, redraw);
	b_wnd_ex.set_check(top, c_wnd.diskalarm.id, diskalarm, redraw);
	b_wnd_ex.set_check(top, c_wnd.ipconflit.id, ipconflit, redraw);
	b_wnd_ex.set_check(top, c_wnd.illegal.id, illegal, redraw);
	b_wnd_ex.set_check(top, c_wnd.no_canle.id, no_canle, redraw);
	b_wnd_ex.set_check(top, c_wnd.fan.id, fanalarm, redraw);
	if(false == diskalarm)then
		b_wnd_ex.set_hide(top, c_wnd.diskalarm.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, c_wnd.diskalarm.id, false, redraw);
	end
	
	if(false == ipconflit)then
		b_wnd_ex.set_hide(top, c_wnd.ipconflit.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, c_wnd.ipconflit.id, false, redraw);
	end
	
	
	if(false == no_canle)then
		b_wnd_ex.set_hide(top, c_wnd.no_canle.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, c_wnd.no_canle.id, false, redraw);
	end
	
	b_wnd_ex.set_hide(top, c_wnd.c_illegal.id, true, redraw);
	b_wnd_ex.set_hide(top, c_wnd.illegal.id, true, redraw);
	
	if fan_num ~= 0 then
		b_wnd_ex.set_hide(top, c_wnd.c_fan.id, false, redraw);
		if(false == fanalarm)then
			b_wnd_ex.set_hide(top, c_wnd.fan.id, true, redraw);
		else
			b_wnd_ex.set_hide(top, c_wnd.fan.id, false, redraw);
		end
	else
		b_wnd_ex.set_hide(top, c_wnd.c_fan.id, true, redraw);
		b_wnd_ex.set_hide(top, c_wnd.fan.id, true, redraw);
	end	
	
	local checkidx = w1_row_abnormalrow.get_checkidx(top);
	if(checkidx == 0) then
		w1_page_abnormalevent.setstatus(top, channeldata, 0, ro_num, buzz_support, redraw) --ͨ
	else
		w1_page_abnormalevent.setstatus(top, channeldata, 0, ro_num, buzz_support, false)
	end
	
	local pb_flag = global_val.get_playback_support();		
	if (pb_flag ~= true) then
		b_wnd_ex.set_hide(top, c_wnd.c_diskalarm.id, true, redraw);
		b_wnd_ex.set_hide(top, c_wnd.diskalarm.id, true, redraw);
			
		local c_pos = SIZE('s_abnormal_c_diskalarm_xywh')
		local t_pos = SIZE('s_abnormal_diskalarm_xywh')	
		b_wnd_ex.move_ex(top, c_wnd.c_ipconflit.id, c_pos, redraw);	
		b_wnd_ex.move_ex(top, c_wnd.ipconflit.id, t_pos, redraw);		
		c_pos = SIZE('s_abnormal_c_ipconflit_xywh')
		t_pos = SIZE('s_abnormal_ipconflit_xywh')	
		b_wnd_ex.move_ex(top, c_wnd.c_no_canle.id, c_pos, redraw);	
		b_wnd_ex.move_ex(top, c_wnd.no_canle.id, t_pos, redraw);			
		c_pos = SIZE('s_abnormal_c_illegal_xywh')
		t_pos = SIZE('s_abnormal_illegal_xywh')	
		b_wnd_ex.move_ex(top, c_wnd.c_fan.id, c_pos, redraw);	
		b_wnd_ex.move_ex(top, c_wnd.fan.id, t_pos, redraw);			
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)	
	assert(type(cfgdata) == 'table')
	w1_page_abnormal.data = cfgdata;
	local c_wnd = w1_page_abnormal.wnd
	
	refresh_chdata(top, false);
	
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_abnormal.timer_start = function()
	w1_page_abnormal.timestart = true
end

w1_page_abnormal.timer_stop = function(top)
	w1_page_abnormal.timestart = false
	w1_wnd_util.tipclear(top, w1_page_abnormal.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_abnormal.timerenevt = function(top)
	if(w1_page_abnormal.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_abnormal.wnd.tipinfo.id)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_abnormal.wnd;
	
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	local diskalarm = b_wnd_ex.get_check(top,cwnd.diskalarm.id);
	local illegal = b_wnd_ex.get_check(top,cwnd.illegal.id);
	local ipconflit = b_wnd_ex.get_check(top,cwnd.ipconflit.id);
	local no_canle = b_wnd_ex.get_check(top,cwnd.no_canle.id);
	local fanalarm = b_wnd_ex.get_check(top, cwnd.fan.id);
	local data = cfgdata.abnormal
	data.exce_type[1]= fanalarm;
	data.exce_type[2]= diskalarm;
	data.exce_type[3]= ipconflit;
	data.exce_type[4]= false;--illegal;
	data.exce_type[5]= no_canle;

	data.enable = enable;	

	data.change_flag = true;
	
	return 0
end

w1_page_abnormal.pageinit = function(top)

	return 0
end

w1_page_abnormal.init= function(top)
	local c_wnd = w1_page_abnormal.wnd
	
	w1_wnd_util.cfgtab = {'abnormal','device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

local on_check = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
		b_wnd_ex.set_hide(top, win_id, true, true);
	end
	return 0
end

local on_enable= function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_diskalarm = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_abnormal.wnd;
		local diskalarm = b_wnd_ex.get_check(top,cwnd.diskalarm.id);
		if(diskalarm == true)then
			b_wnd_ex.set_check(top,cwnd.diskalarm.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.diskalarm.id, true, false);
		else
			b_wnd_ex.set_check(top,cwnd.diskalarm.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.diskalarm.id, false, false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_ipconflit = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_abnormal.wnd;
		local ipconflit = b_wnd_ex.get_check(top,cwnd.ipconflit.id);
		if(ipconflit == true)then
			b_wnd_ex.set_check(top,cwnd.ipconflit.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.ipconflit.id, true, false);
		else
			b_wnd_ex.set_check(top,cwnd.ipconflit.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.ipconflit.id, false, false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_illegal = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_abnormal.wnd;
		local illegal = b_wnd_ex.get_check(top,cwnd.illegal.id);
		if(illegal == true)then
			b_wnd_ex.set_check(top,cwnd.illegal.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.illegal.id, true, false);
		else
			b_wnd_ex.set_check(top,cwnd.illegal.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.illegal.id, false, false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_page_abnormal.on_data_change = function(top)
	w1_page_abnormalevent.on_channel_check(top);
end

local on_nocanle = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_abnormal.wnd;
		local no_canle = b_wnd_ex.get_check(top,cwnd.no_canle.id);
		if(no_canle == true)then
			b_wnd_ex.set_check(top,cwnd.no_canle.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.no_canle.id, true, false);
		else
			b_wnd_ex.set_check(top,cwnd.no_canle.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.no_canle.id, false, false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_fan = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_abnormal.wnd;
		local fan = b_wnd_ex.get_check(top,cwnd.fan.id);
		if(fan == true)then
			b_wnd_ex.set_check(top,cwnd.fan.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.fan.id, true, false);
		else
			b_wnd_ex.set_check(top,cwnd.fan.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.fan.id, false, false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		uitousercfg(top,b_app_cfg.user_cfg);
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_abnormal.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_abnormal.on_pre_show = function(top)
	local cwnd = w1_page_abnormal.wnd;
	channel_num = global_val.get_channelnum();
	
	w1_page_abnormalevent.on_pre_show(top, channel_num)
	local con_id = cwnd.con_abnormal.id
	
--	b_wnd_ex.set_show_page(top,con_id, cwnd.lossevent_wnd.id, false)
	w1_row_abnormalrow.changecheck(top, w1_row_abnormalrow.wnd, w1_id.cfg_abnormal.abnormalrow_id + 1, false)
end

w1_page_abnormal.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable',	'alram_type','circle1','c_diskalarm','diskalarm','circle2','c_ipconflit','ipconflit','circle3','c_illegal','illegal','circle4',
			'c_no_canle','no_canle','c_fan','fan','con_abnormal',
			'abnormal_row_wnd','abnormalevent_wnd','tipinfo',  'apply'},

	cap_enable 	= {t='static',	id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE_ABM_ALA'},
	t_enable 	= {t='tt_check',id=id+2,xywh='s_abnormal_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable},
	
	alram_type	= {t='static',	id=id+3,xywh='s_abnormal_alarm_type_xywh',text='LA_ABNORMAL_TYPE'},

	c_diskalarm 	= {t='tt_button',id=id+5,xywh='s_abnormal_c_diskalarm_xywh',tip = 'LA_DISK_ALARM',
				t_imgs ={b_ui.ALIGN.CENTER,'f_alarmimg','it_disk_alarm','it_disk_alarm', 'it_disk_alarm'},
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},cmd = on_diskalarm
			},
	diskalarm 	= {t='tt_check',id=id+6,xywh='s_abnormal_diskalarm_xywh',
				t_imgs ={b_ui.ALIGN.CENTER,'f_cicrl_select','it_circle_select','it_circle_select', 'it_circle_select'},
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_c= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},
				color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},cmd = on_check},

	c_ipconflit 	= {t='tt_button',id=id+8,xywh='s_abnormal_c_ipconflit_xywh',tip = 'LA_ADDR_CONFLICT',
				t_imgs ={b_ui.ALIGN.CENTER,'f_alarmimg','it_ipconfig','it_ipconfig', 'it_ipconfig'},
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},cmd = on_ipconflit},
	
	ipconflit 	= {t='tt_check',id=id+9,xywh='s_abnormal_ipconflit_xywh',
				t_imgs ={b_ui.ALIGN.CENTER,'f_cicrl_select','it_circle_select','it_circle_select', 'it_circle_select'},
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_c= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},
				color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},cmd = on_check},
	
				
	c_illegal 	= {t='tt_button',id=id+11,xywh='s_abnormal_c_illegal_xywh',tip = 'LA_ILLEGAL_ALARM',
				t_imgs ={b_ui.ALIGN.CENTER,'f_alarmimg','it_illega','it_illega', 'it_illega'},
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},cmd = on_illegal},

	illegal 	= {t='tt_check',id=id+12,xywh='s_abnormal_illegal_xywh',
				t_imgs ={b_ui.ALIGN.CENTER,'f_cicrl_select','it_circle_select','it_circle_select', 'it_circle_select'},
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_c= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},
				color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},cmd = on_check},
				
	c_no_canle 	= {t='tt_button',id=id+14,xywh='s_abnormal_c_illegal_xywh',tip = 'LA_NET_DISCONNECT',
				t_imgs ={b_ui.ALIGN.CENTER,'f_alarmimg','it_no_canle','it_no_canle', 'it_no_canle'},
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},cmd = on_nocanle},
				
	no_canle 	= {t='tt_check',id=id+15,xywh='s_abnormal_illegal_xywh',
				t_imgs ={b_ui.ALIGN.CENTER,'f_cicrl_select','it_circle_select','it_circle_select', 'it_circle_select'},
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_c= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},
				color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},cmd = on_check},
	c_fan   	= {t='tt_button',id=id+16,xywh='s_abnormal_c_no_canle_xywh',tip = 'LA_FAN_ALARM',
				t_imgs ={b_ui.ALIGN.CENTER,'f_alarmimg','it_fan_alarm','it_fan_alarm', 'it_fan_alarm'},
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},cmd = on_fan},
				
	fan		 	= {t='tt_check',id=id+17,xywh='s_abnormal_no_canle_xywh',
				t_imgs ={b_ui.ALIGN.CENTER,'f_cicrl_select','it_circle_select','it_circle_select', 'it_circle_select'},
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_c= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},
				color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},cmd = on_check},

	con_abnormal		= {t='container',id=w1_id.cfg_abnormal.con_abnormal_id,	xywh={0,0,10,10}},
	abnormal_row_wnd 	= w1_row_abnormalrow.wnd,
	abnormalevent_wnd 	= w1_page_abnormalevent.wnd,	
	
	tipinfo		= {t='static',id=id+18,	xywh='s_abnormal_tipinfo_xywh',text='',trans = false},
	
	apply 	= {t='button',id=id+19,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_abnormal

