--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_auxiliary.dsp_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local util 		= require("wnd.core.util")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_app_api = require("wnd.core.command.b_app_api");
local w1_page_add_dwell =  require("wnd.w1_cfg.w1_page_add_dwell")

local channel_num;--豸ͨĿ
local REF_SPLIT1 	= 1
local REF_SPLIT4 	= 4
local REF_SPLIT8 	= 8
local REF_SPLIT9 	= 9
local REF_SPLIT16 	= 16
local REF_SPLIT32 	= 32
local REF_SPLIT36 	= 36
local REF_SPLIT64 	= 64
local REF_SPLIT128 	= 128
local REF_PAGEUP 	= 33
local REF_PAGEDOWN 	= 34
local REF_PAGESKIP 	= 35
local diplay_off = 0;		--ǰƫ
local dis_col;		--ǰʾͨ
local title_max_len = 0; --ıλ
local vaild_channel_num = 0;
local dec_mode = 0;
local w1_page_auxiliary_dsp = 
{
	data,--Чб
	old_layout_id, --δ˵б 
	select_layout = 1,		--ǰѡĲ 1ʼ
	all_channel_name = nil,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_auxiliary_dsp.s_768 =
{
	s_auxi_dwell_channel_xywh = {32,21,122,32},
	s_auxi_dwell_add_xywh = {154,22,21,28},
	s_auxi_dwell_vline1_xywh = {176,21,1,568},
	s_auxi_dwell_hline1_xywh = {32,53,144,1},
	s_auxi_dwell_cap_name_xywh = {202,21,106,32},
	s_auxi_dwell_t_name_xywh = {312,21,106,32},
	s_auxi_dwell_cap_time_xywh = {434,21,106,32},
	s_auxi_dwell_t_time_xywh = {544,21,106,32},
	s_auxi_dwell_edit_xywh = {677,22,64,28},
	s_auxi_dwell_del_xywh = {741,22,64,28},
	s_auxi_dwell_move_pos_info = {2,21,26,0},
	s_auxi_dwell_ch1_xywh = {32,54,144,32},
	s_auxi_dwell_ch2_xywh = {32,85,144,32},
	s_auxi_dwell_ch3_xywh = {32,116,144,32},
	s_auxi_dwell_ch4_xywh = {32,147,144,32},
	s_auxi_dwell_ch5_xywh = {32,179,144,32},
	s_auxi_dwell_ch6_xywh = {32,210,144,32},
	s_auxi_dwell_ch7_xywh = {32,241,144,32},
	s_auxi_dwell_ch8_xywh = {32,273,144,32},
	s_auxi_dwell_ch9_xywh = {32,304,144,32},
	s_auxi_dwell_ch10_xywh = {32,335,144,32},
	s_auxi_dwell_ch11_xywh = {32,366,144,32},
	s_auxi_dwell_ch12_xywh = {32,398,144,32},
	s_auxi_dwell_ch13_xywh = {32,429,144,32},
	s_auxi_dwell_ch14_xywh = {32,460,144,32},
	s_auxi_dwell_ch15_xywh = {32,492,144,32},
	s_auxi_dwell_ch16_xywh = {32,523,144,32},
	s_auxi_dwell_vdrop_xywh = {176,54,10,512},
	s_auxi_dwell_wnd_xywh = {149,67,75,56},
	 
	s_auxi_dwell_tipinfo_xywh = {32,597,266,35},
	s_auxi_dwell_split1_xywh = {202,67,602,504},
	s_auxi_dwell_split4_xywh = {202,67,298,248},
	s_auxi_dwell_split8_1_xywh = {202,67,448,370},
	s_auxi_dwell_split8_7_xywh = {202,67,146,120},
	s_auxi_dwell_split9_xywh = {202,67,197,163},
	s_auxi_dwell_split16_xywh = {202,67,146,120},
	s_auxi_dwell_split32_4_xywh = {202,67,222,192},
	s_auxi_dwell_split32_28_xywh = {202,67,72,64},
	s_auxi_dwell_split36_xywh = {202,67,98,85},
	s_auxi_dwell_split64_xywh = {202,67,72,64},
	
	s_auxi_dwell_split6_1_xywh = {202,67,400,334},
	s_auxi_dwell_split6_5_xywh = {202,67,197,163},
	s_auxi_dwell_split10_2_xywh = {202,67,297,245},
	s_auxi_dwell_split10_8_xywh = {202,67,146,120},
	s_auxi_dwell_split13_1_xywh = {202,67,297,245},
	s_auxi_dwell_split13_12_xywh = {202,67,146,120},
	s_auxi_dwell_split24_4_xywh = {202,67,198,167},
	s_auxi_dwell_split24_20_xywh = {202,67,98,85},
	s_auxi_dwell_split25_xywh = {202,67,118,100},
	s_auxi_dwell_wnd_pace = {5,3,0,0},	
};

w1_page_auxiliary_dsp.s_1280 = 
{

	s_auxi_dwell_channel_xywh = {40,30,131,45},
	s_auxi_dwell_add_xywh = {171,37,32,32},
	s_auxi_dwell_vline1_xywh = {203,30,1,800},
	s_auxi_dwell_hline1_xywh = {40,75,163,1},
	s_auxi_dwell_cap_name_xywh = {250,25,120,45},
	s_auxi_dwell_t_name_xywh = {370,25,140,45},	
	s_auxi_dwell_cap_time_xywh = {520,25,140,45},
	s_auxi_dwell_t_time_xywh = {660,25,120,45},
	s_auxi_dwell_edit_xywh = {800,27,100,40},
	s_auxi_dwell_del_xywh = {900,27,100,40},
	s_auxi_dwell_move_pos_info = {5, 30, 50, 0}, --ƶ¼ Ԫ1ʾֵļ Ԫ2ΪԪصļ Ԫ3ΪťͼƬС,

	s_auxi_dwell_ch1_xywh = {40,76,163,45},
	s_auxi_dwell_ch2_xywh = {40,120,163,45},
	s_auxi_dwell_ch3_xywh = {40,164,163,45},
	s_auxi_dwell_ch4_xywh = {40,208,163,45},
	s_auxi_dwell_ch5_xywh = {40,252,163,45},
	s_auxi_dwell_ch6_xywh = {40,296,163,45},
	s_auxi_dwell_ch7_xywh = {40,340,163,45},
	s_auxi_dwell_ch8_xywh = {40,384,163,45},
	s_auxi_dwell_ch9_xywh = {40,428,163,45},
	s_auxi_dwell_ch10_xywh = {40,472,163,45},
	s_auxi_dwell_ch11_xywh = {40,516,163,45},
	s_auxi_dwell_ch12_xywh = {40,560,163,45},
	s_auxi_dwell_ch13_xywh = {40,604,163,45},
	s_auxi_dwell_ch14_xywh = {40,648,163,45},
	s_auxi_dwell_ch15_xywh = {40,692,163,45},
	s_auxi_dwell_ch16_xywh = {40,736,163,45},
	s_auxi_dwell_vdrop_xywh = {203,76,20,720},
	s_auxi_dwell_wnd_xywh = {250,78,171,170},
	
	s_auxi_dwell_tipinfo_xywh = {40,800,350,50},
	s_auxi_dwell_split1_xywh = {250,78,750,710},
	s_auxi_dwell_split4_xywh = {250,78,370,350},
	s_auxi_dwell_split8_1_xywh = {250,78,560,530},
	s_auxi_dwell_split8_7_xywh = {250,78,180,170},
	s_auxi_dwell_split9_xywh = {250,78,243,230},
	s_auxi_dwell_split16_xywh = {250,78,180,170},
	s_auxi_dwell_split32_4_xywh = {250,78,277,262},
	s_auxi_dwell_split32_28_xywh = {250,78, 89, 84},
	s_auxi_dwell_split36_xywh = {250, 78, 120, 114}, 
	s_auxi_dwell_split64_xywh = {250, 78, 89, 84},
	s_auxi_dwell_split6_1_xywh = {250,78,496,470},
	s_auxi_dwell_split6_5_xywh = {250,78,243,230},
	s_auxi_dwell_split10_2_xywh = {250,78,370,350},
	s_auxi_dwell_split10_8_xywh = {250,78,180,170},
	s_auxi_dwell_split13_1_xywh = {250,78,370,350},
	s_auxi_dwell_split13_12_xywh = {250,78,180,170},
	s_auxi_dwell_split24_4_xywh = {250, 78, 245, 233},
	s_auxi_dwell_split24_20_xywh = {250, 78, 120, 114},
	s_auxi_dwell_split25_xywh = {250, 78, 146, 138},
	s_auxi_dwell_wnd_pace 	= {10, 5, 0, 0},	
}

w1_page_auxiliary_dsp.s_1440 = 
{
	s_auxi_dwell_channel_xywh = {40,25,131,45},
	s_auxi_dwell_add_xywh = {171,31,32,32},
	s_auxi_dwell_vline1_xywh = {203,25,1,650},
	s_auxi_dwell_hline1_xywh = {40,65,163,1},
	s_auxi_dwell_cap_name_xywh = {250,25,120,45},
	s_auxi_dwell_t_name_xywh = {370,25,140,45},	
	s_auxi_dwell_cap_time_xywh = {520,25,140,45},
	s_auxi_dwell_t_time_xywh = {760,25,115,45},
	s_auxi_dwell_edit_xywh = {880,27,100,40},
	s_auxi_dwell_del_xywh = {980,27,100,40},
	s_auxi_dwell_move_pos_info = {5, 30, 50, 0}, --ƶ¼ Ԫ1ʾֵļ Ԫ2ΪԪصļ Ԫ3ΪťͼƬС,

	s_auxi_dwell_ch1_xywh = {40,66,163,37},
	s_auxi_dwell_ch2_xywh = {40,103,163,37},
	s_auxi_dwell_ch3_xywh = {40,140,163,37},
	s_auxi_dwell_ch4_xywh = {40,177,163,37},
	s_auxi_dwell_ch5_xywh = {40,214,163,37},
	s_auxi_dwell_ch6_xywh = {40,251,163,37},
	s_auxi_dwell_ch7_xywh = {40,288,163,37},
	s_auxi_dwell_ch8_xywh = {40,325,163,37},
	s_auxi_dwell_ch9_xywh = {40,362,163,37},
	s_auxi_dwell_ch10_xywh = {40,399,163,37},
	s_auxi_dwell_ch11_xywh = {40,436,163,37},
	s_auxi_dwell_ch12_xywh = {40,473,163,37},
	s_auxi_dwell_ch13_xywh = {40,510,163,37},
	s_auxi_dwell_ch14_xywh = {40,547,163,37},
	s_auxi_dwell_ch15_xywh = {40,584,163,37},
	s_auxi_dwell_ch16_xywh = {40,621,163,37},
	s_auxi_dwell_vdrop_xywh = {203,66,20,592},
	s_auxi_dwell_wnd_xywh = {250,78,190, 142},

	s_auxi_dwell_tipinfo_xywh = {40,680,400,50},
	s_auxi_dwell_split1_xywh = {250,78,830,592},
	s_auxi_dwell_split4_xywh = {250,78,410,291},
	s_auxi_dwell_split8_1_xywh = {250,78,620,446},
	s_auxi_dwell_split8_7_xywh = {250,78,200,142},
	s_auxi_dwell_split9_xywh = {250,78,270,187},
	s_auxi_dwell_split16_xywh = {250,78,200,142},
	s_auxi_dwell_split32_4_xywh = {250,78,307,222},
	s_auxi_dwell_split32_28_xywh = {250,78, 99, 69},
	s_auxi_dwell_split36_xywh = {250,78, 134, 94}, 
	s_auxi_dwell_split64_xywh = {250,78, 99, 69},	
	
	s_auxi_dwell_split6_1_xywh = {250, 78, 550, 400},
	s_auxi_dwell_split6_5_xywh = {250, 78, 270, 187},
	s_auxi_dwell_split10_2_xywh = {250,78,410,294},
	s_auxi_dwell_split10_8_xywh = {250,78,200,142},
	s_auxi_dwell_split13_1_xywh = {250,78,410,294},
	s_auxi_dwell_split13_12_xywh = {250,78,200,142},
	s_auxi_dwell_split24_4_xywh = {250, 78, 273, 196},
	s_auxi_dwell_split24_20_xywh = {250, 78, 134, 94},
	s_auxi_dwell_split25_xywh = {250, 78, 162, 114},
	s_auxi_dwell_wnd_pace 	= {10, 5, 0, 0},	
}

w1_page_auxiliary_dsp.s_1080p = 
{
	s_auxi_dwell_channel_xywh = {60,30,230,45},
	s_auxi_dwell_add_xywh = {290,32,40,40},
	s_auxi_dwell_vline1_xywh = {330,30,1,800},
	s_auxi_dwell_hline1_xywh = {60,75,270,1},
	s_auxi_dwell_cap_name_xywh = {380,30,200,45},
	s_auxi_dwell_t_name_xywh = {585,30,200,45},	
	s_auxi_dwell_cap_time_xywh = {815,30,200,45},
	s_auxi_dwell_t_time_xywh = {1020,30,200,45},
	s_auxi_dwell_edit_xywh = {1270,32,120,40},
	s_auxi_dwell_del_xywh = {1390,32,120,40},
	s_auxi_dwell_move_pos_info = {5, 30, 50, 0}, --ƶ¼ Ԫ1ʾֵļ Ԫ2ΪԪصļ Ԫ3ΪťͼƬС,
	s_auxi_dwell_ch1_xywh = {60,76,270,45},
	s_auxi_dwell_ch2_xywh = {60,120,270,45},
	s_auxi_dwell_ch3_xywh = {60,164,270,45},
	s_auxi_dwell_ch4_xywh = {60,208,270,45},
	s_auxi_dwell_ch5_xywh = {60,252,270,45},
	s_auxi_dwell_ch6_xywh = {60,296,270,45},
	s_auxi_dwell_ch7_xywh = {60,340,270,45},
	s_auxi_dwell_ch8_xywh = {60,384,270,45},
	s_auxi_dwell_ch9_xywh = {60,428,270,45},
	s_auxi_dwell_ch10_xywh = {60,472,270,45},
	s_auxi_dwell_ch11_xywh = {60,516,270,45},
	s_auxi_dwell_ch12_xywh = {60,560,270,45},
	s_auxi_dwell_ch13_xywh = {60,604,270,45},
	s_auxi_dwell_ch14_xywh = {60,648,270,45},
	s_auxi_dwell_ch15_xywh = {60,692,270,45},
	s_auxi_dwell_ch16_xywh = {60,736,270,45},
	s_auxi_dwell_vdrop_xywh = {330,76,20,720},
	s_auxi_dwell_wnd_xywh = {280, 95, 142, 80},
 
	s_auxi_dwell_tipinfo_xywh = {60,840,500,50},
	s_auxi_dwell_split1_xywh = {380, 95, 1130, 710}, 
	s_auxi_dwell_split4_xywh = {380, 95, 560, 350}, 
	s_auxi_dwell_split8_1_xywh = {380, 95, 845, 530},
	s_auxi_dwell_split8_7_xywh = {380, 95, 275, 170},
	s_auxi_dwell_split9_xywh = {380, 95, 370, 230}, 
	s_auxi_dwell_split16_xywh = {380, 95, 275, 170},
	s_auxi_dwell_split32_4_xywh = {380, 95, 418, 270},
	s_auxi_dwell_split32_28_xywh = {380, 95, 136, 90},
	s_auxi_dwell_split36_xywh = {380, 95, 184, 120}, 
	s_auxi_dwell_split64_xywh = {380, 95, 136, 90},	
	
	s_auxi_dwell_split6_1_xywh = {380, 95, 750, 470},
	s_auxi_dwell_split6_5_xywh = {380, 95, 370, 230},
	s_auxi_dwell_split10_2_xywh = {380, 95, 560, 350},
	s_auxi_dwell_split10_8_xywh = {380, 95, 275, 170},
	s_auxi_dwell_split13_1_xywh = {380, 95, 560, 350},
	s_auxi_dwell_split13_12_xywh = {380, 95, 275, 170},
	s_auxi_dwell_split24_4_xywh = {380, 95, 373, 235},
	s_auxi_dwell_split24_20_xywh = {380, 95, 184, 120},
	s_auxi_dwell_split25_xywh = {380, 95, 222, 141},
	s_auxi_dwell_wnd_pace 	= {10, 5, 0, 0},	
	
}

w1_page_auxiliary_dsp.s_2k = 
{
	s_auxi_dwell_channel_xywh = {79,40,306,60},
	s_auxi_dwell_add_xywh = {386,42,53,53},
	s_auxi_dwell_vline1_xywh = {439,40,1,1066},
	s_auxi_dwell_hline1_xywh = {79,99,359,1},
	s_auxi_dwell_cap_name_xywh = {506,40,266,59},
	s_auxi_dwell_t_name_xywh = {779,40,266,59},
	s_auxi_dwell_cap_time_xywh = {1086,40,266,59},
	s_auxi_dwell_t_time_xywh = {1359,40,266,59},
	s_auxi_dwell_edit_xywh = {1692,42,159,53},
	s_auxi_dwell_del_xywh = {1852,42,159,53},
	s_auxi_dwell_move_pos_info = {6,40,66,0},
	s_auxi_dwell_ch1_xywh = {79,101,359,59},
	s_auxi_dwell_ch2_xywh = {79,159,359,59},
	s_auxi_dwell_ch3_xywh = {79,218,359,59},
	s_auxi_dwell_ch4_xywh = {79,277,359,59},
	s_auxi_dwell_ch5_xywh = {79,335,359,59},
	s_auxi_dwell_ch6_xywh = {79,394,359,59},
	s_auxi_dwell_ch7_xywh = {79,453,359,59},
	s_auxi_dwell_ch8_xywh = {79,511,359,59},
	s_auxi_dwell_ch9_xywh = {79,570,359,59},
	s_auxi_dwell_ch10_xywh = {79,629,359,59},
	s_auxi_dwell_ch11_xywh = {79,687,359,59},
	s_auxi_dwell_ch12_xywh = {79,746,359,59},
	s_auxi_dwell_ch13_xywh = {79,805,359,59},
	s_auxi_dwell_ch14_xywh = {79,863,359,59},
	s_auxi_dwell_ch15_xywh = {79,922,359,59},
	s_auxi_dwell_ch16_xywh = {79,981,359,59},
	s_auxi_dwell_vdrop_xywh = {439,101,26,959},
	s_auxi_dwell_wnd_xywh = {506,126,189,106},
 
	s_auxi_dwell_tipinfo_xywh = {80,1120,800,67},
	s_auxi_dwell_split1_xywh = {506,126,1506,946},
	s_auxi_dwell_split4_xywh = {506,126,746,466},
	s_auxi_dwell_split8_1_xywh = {506,126,1124,704},
	s_auxi_dwell_split8_7_xywh = {506,126,366,226},
	s_auxi_dwell_split9_xywh = {506,126,493,306},
	s_auxi_dwell_split16_xywh = {506,126,366,226},
	s_auxi_dwell_split32_4_xywh = {506,126,557,359},
	s_auxi_dwell_split32_28_xywh = {506,126,181,119},
	s_auxi_dwell_split36_xywh = {506,126,245,159},
	s_auxi_dwell_split64_xywh = {506,126,181,119},
	
	s_auxi_dwell_split6_1_xywh = {506,126,999,626},
	s_auxi_dwell_split6_5_xywh = {506,126,493,306},
	s_auxi_dwell_split10_2_xywh = {506,126,745,465},
	s_auxi_dwell_split10_8_xywh = {506,126,366,226},
	s_auxi_dwell_split13_1_xywh = {506,126,745,465},
	s_auxi_dwell_split13_12_xywh = {506,126,366,226},
	s_auxi_dwell_split24_4_xywh = {506,126,497,313},
	s_auxi_dwell_split24_20_xywh = {506,126,245,159},
	s_auxi_dwell_split25_xywh = {506,126,295,187},
	s_auxi_dwell_wnd_pace = {13,6,0,0},
}

w1_page_auxiliary_dsp.s_4k = 
{
	s_auxi_dwell_channel_xywh = {120,60,460,90},
	s_auxi_dwell_add_xywh = {580,64,80,80},
	s_auxi_dwell_vline1_xywh = {660,60,2,1600},
	s_auxi_dwell_hline1_xywh = {120,150,540,2},
	s_auxi_dwell_cap_name_xywh = {760,60,400,90},
	s_auxi_dwell_t_name_xywh = {1170,60,400,90},
	s_auxi_dwell_cap_time_xywh = {1630,60,400,90},
	s_auxi_dwell_t_time_xywh = {2040,60,400,90},
	s_auxi_dwell_edit_xywh = {2540,64,240,80},
	s_auxi_dwell_del_xywh = {2780,64,240,80},
	s_auxi_dwell_move_pos_info = {10,60,100,0},
	s_auxi_dwell_ch1_xywh = {120,152,540,90},
	s_auxi_dwell_ch2_xywh = {120,240,540,90},
	s_auxi_dwell_ch3_xywh = {120,328,540,90},
	s_auxi_dwell_ch4_xywh = {120,416,540,90},
	s_auxi_dwell_ch5_xywh = {120,504,540,90},
	s_auxi_dwell_ch6_xywh = {120,592,540,90},
	s_auxi_dwell_ch7_xywh = {120,680,540,90},
	s_auxi_dwell_ch8_xywh = {120,768,540,90},
	s_auxi_dwell_ch9_xywh = {120,856,540,90},
	s_auxi_dwell_ch10_xywh = {120,944,540,90},
	s_auxi_dwell_ch11_xywh = {120,1032,540,90},
	s_auxi_dwell_ch12_xywh = {120,1120,540,90},
	s_auxi_dwell_ch13_xywh = {120,1208,540,90},
	s_auxi_dwell_ch14_xywh = {120,1296,540,90},
	s_auxi_dwell_ch15_xywh = {120,1384,540,90},
	s_auxi_dwell_ch16_xywh = {120,1472,540,90},
	s_auxi_dwell_vdrop_xywh = {660,152,40,1440},
	s_auxi_dwell_wnd_xywh = {560,190,284,160},
	 
	s_auxi_dwell_tipinfo_xywh = {120,1680,1000,100},
	s_auxi_dwell_split1_xywh = {760,190,2260,1420},
	s_auxi_dwell_split4_xywh = {760,190,1120,700},
	s_auxi_dwell_split8_1_xywh = {760,190,1690,1060},
	s_auxi_dwell_split8_7_xywh = {760,190,550,340},
	s_auxi_dwell_split9_xywh = {760,190,740,460},
	s_auxi_dwell_split16_xywh = {760,190,550,340},
	s_auxi_dwell_split32_4_xywh = {760,190,836,540},
	s_auxi_dwell_split32_28_xywh = {760,190,272,180},
	s_auxi_dwell_split36_xywh = {760,190,368,240},
	s_auxi_dwell_split64_xywh = {760,190,272,180},
		
	s_auxi_dwell_split6_1_xywh = {760,190,1500,940},
	s_auxi_dwell_split6_5_xywh = {760,190,740,460},
	s_auxi_dwell_split10_2_xywh = {760,190,1120,700},
	s_auxi_dwell_split10_8_xywh = {760,190,550,340},
	s_auxi_dwell_split13_1_xywh = {760,190,1120,700},
	s_auxi_dwell_split13_12_xywh = {760,190,550,340},		
	s_auxi_dwell_split24_4_xywh = {760,190,746,470},
	s_auxi_dwell_split24_20_xywh = {760,190,368,240},
	s_auxi_dwell_split25_xywh = {760,190,444,282},
	s_auxi_dwell_wnd_pace = {20,10,0,0},	
}

w1_page_auxiliary_dsp.clear_data = function()
	w1_page_auxiliary_dsp.data = nil;
	w1_page_auxiliary_dsp.old_layout_id = nil;
	w1_page_auxiliary_dsp.select_layout = 1;
	w1_page_auxiliary_dsp.all_channel_name = nil;
	diplay_off = 0;
end	

local set_layout_name_list = function(top)
	local cwnd = w1_page_auxiliary_dsp.wnd;
	b_wnd_ex.set_hide(top,cwnd.drop.id,true,false);
	local data = w1_page_auxiliary_dsp.data;
	local layout_num = #data;
	if layout_num > 16 then
		local vdrop = {};
		vdrop.set_cur = diplay_off;
		vdrop.set_cap = 16;
		vdrop.set_max = layout_num;
		for i = 1, 16 do
			b_wnd_ex.set_text(top, id + 20 + i, data[i+diplay_off].name, false)
		end
		b_wnd_ex.set_drop(top,cwnd.drop.id,vdrop,false);
		b_wnd_ex.set_hide(top,cwnd.drop.id,false,false);
	else
		for i = 1, 16 do
			if i <= layout_num then
				b_wnd_ex.set_text(top, id + 20 + i, data[i+diplay_off].name, false)
				b_wnd_ex.set_hide(top,id + 20 + i, false,false);
			else
				b_wnd_ex.set_hide(top,id + 20 + i,true,false);
			end			
		end
	end
end	

local set_wnd_chn_info = function(top, id, data, redraw)
	local chn_list = {};
	local chn_name = {};
	assert(nil ~= data);
	local max_count = channel_num + 1;
	
	for i = 1, #data do
		table.insert(chn_list, data[i]);
		if (data[i] == 0) then
			table.insert(chn_name, w1_page_auxiliary_dsp.all_channel_name[max_count]);
		else
			table.insert(chn_name, w1_page_auxiliary_dsp.all_channel_name[data[i]]);
		end		
	end	
	
	local wnd_data = {chn_num_list = chn_list, chn_name_list = chn_name};
	b_wnd_ex.set_dwell_wnd_data(top, id, wnd_data, redraw);
end

local move_layout_name_show = function(top, redraw)
	local cwnd = w1_page_auxiliary_dsp.wnd;
	local size1 = b_wnd_ex.get_textsize(top, cwnd.cap_name.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.t_name.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.cap_time.id).w;
	local size4 = b_wnd_ex.get_textsize(top, cwnd.t_time.id).w;

	local space_info = SIZE('s_auxi_dwell_move_pos_info');
	local cap_name_pos = SIZE('s_auxi_dwell_cap_name_xywh');
	local space = space_info[1];
	local item_pace = space_info[2];
	local total_w = title_max_len;
	local valid_total_w = size1 + space + size2 + item_pace + size3 + space + size4 + space;
	
	local pos1 = nil	
	local pos2 = nil
	local pos3 = nil
	local pos4 = nil
	if (valid_total_w > total_w) then --
		size2 = total_w - (valid_total_w - size2) - space
		if (size2 < 0) then --СƿȻ ֱӻָĬ
			pos1 =  SIZE('s_auxi_dwell_cap_name_xywh');
			pos2 =  SIZE('s_auxi_dwell_t_name_xywh');	
			pos3 =  SIZE('s_auxi_dwell_cap_time_xywh');
			pos4 =  SIZE('s_auxi_dwell_t_time_xywh');
		else
			pos1 = {cap_name_pos[1], cap_name_pos[2], size1 + space, cap_name_pos[4]}
			pos2 = {pos1[1] + pos1[3], cap_name_pos[2], size2 + item_pace, cap_name_pos[4]};
			pos3 = {pos2[1] + pos2[3], cap_name_pos[2], size3 + space, cap_name_pos[4]};	
			pos4 = {pos3[1] + pos3[3], cap_name_pos[2], size4 + space, cap_name_pos[4]};
		end
	else
		pos1 = {cap_name_pos[1], cap_name_pos[2], size1 + space, cap_name_pos[4]}
		pos2 = {pos1[1] + pos1[3], cap_name_pos[2], size2 + item_pace, cap_name_pos[4]};
		pos3 = {pos2[1] + pos2[3], cap_name_pos[2], size3 + space, cap_name_pos[4]};	
		pos4 = {pos3[1] + pos3[3], cap_name_pos[2], size4 + space, cap_name_pos[4]};
	end
	
	b_wnd_ex.move_ex(top, cwnd.cap_name.id, pos1, false)	
	b_wnd_ex.move_ex(top, cwnd.t_name.id, pos2, false)	
	b_wnd_ex.move_ex(top, cwnd.cap_time.id, pos3, false)	
	b_wnd_ex.move_ex(top, cwnd.t_time.id, pos4, false)	
	
	if (w1_page_auxiliary_dsp.select_layout == 1) then --Ĭ ر༭ɾ
		b_wnd_ex.set_disable(top, cwnd.btn_edit.id, false, false)	
		b_wnd_ex.set_disable(top, cwnd.btn_del.id, true, false)	
	else
		b_wnd_ex.set_disable(top, cwnd.btn_edit.id, false, false)	
		b_wnd_ex.set_disable(top, cwnd.btn_del.id, false, false)	
	end		
	
	if (redraw) then
		b_dlg.dlg_set_redraw(top)
	end	
end

--лģʽ
local cutsplit = function(top, splittype, redraw)
	local count  = splittype;
	if (8 == splittype and channel_num == 6) then
		count = 6;
	elseif (9 == splittype and channel_num == 8) then
		count = 8;
	elseif (16 == splittype and channel_num == 10) then
		count = 10;	
	elseif (16 == splittype and channel_num == 12) then
		count = 12;
	elseif (32 == splittype and channel_num == 20) then
		count = 20;
	elseif (36 == splittype and channel_num == 20) then
		count = 20;				
	elseif (32 == splittype and channel_num == 24) then
		count = 24;
	elseif (36 == splittype and channel_num == 24) then
		count = 24;
	elseif (36 == splittype and channel_num == 32) then		
		count = 32
	end		
	
	if (count > channel_num) then
		count = channel_num;
	end		
	
	local cfgData = w1_page_auxiliary_dsp.data[w1_page_auxiliary_dsp.select_layout]; --ǰʹõ
	for i = 1, count do
		b_wnd_ex.set_hide(top, id + 40 + i, false, false)--ػredrawfalseŻٶ
	end
	for i = count + 1, 64 do
		b_wnd_ex.set_hide(top, id + 40 + i, true, false)
	end
	
	local wnd_space =  SIZE('s_add_dwell_wnd_pace');
	local wndsize;
	if(splittype == REF_SPLIT1) then
		wndsize = SIZE('s_auxi_dwell_split1_xywh');
		b_wnd_ex.move_ex(top, id + 40 + 1, {wndsize[1], wndsize[2], wndsize[3], wndsize[4]}, false)
		local item = "win" .. tostring(1);
		set_wnd_chn_info(top, id + 40 + 1, cfgData.win_list_info[item], false);			
	elseif(splittype == REF_SPLIT4) then
		wndsize = SIZE('s_auxi_dwell_split4_xywh');
		local i;
		local cx = wndsize[3];
		local cy = wndsize[4];
		local rowcolumn = wnd_space[1];
		for i = 1, count do
			local row, column;
			row = math.modf((i - 1) / 2);
			column = (i - 1) - math.floor( (i - 1) / 2) * 2
			local x = wndsize[1] + column  * cx + column * rowcolumn;
			local y = wndsize[2] + row  * cy + row * rowcolumn;
			b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
			local item = "win" .. tostring(i);
			set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);			
		end
	elseif(splittype == REF_SPLIT8) then
		if (channel_num == 6) then --6·⴦6
			wndsize = SIZE('s_auxi_dwell_split6_1_xywh');
			b_wnd_ex.move_ex(top, id + 41, wndsize, false)
			local item = "win" .. tostring(1);
			set_wnd_chn_info(top, id + 41, cfgData.win_list_info[item], false);						
			local wndsize6_5 = SIZE('s_auxi_dwell_split6_5_xywh');
			local cx = wndsize6_5[3];
			local cy = wndsize6_5[4];
			local rowcolumn = wnd_space[1];
			for i = 2,3 do
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+wndsize[3]+rowcolumn,wndsize[2]+(i-2)*(cy+rowcolumn), cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);				
			end
			for i = 4, count do
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+(i-4)*(cx+rowcolumn),wndsize[2]+wndsize[4]+rowcolumn, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);			
			end
		else
			wndsize = SIZE('s_auxi_dwell_split8_1_xywh');
			b_wnd_ex.move_ex(top, id + 41, wndsize, false)
			local item = "win" .. tostring(1);
			set_wnd_chn_info(top, id + 41, cfgData.win_list_info[item], false);		
			local wndsize8_7 = SIZE('s_auxi_dwell_split8_7_xywh');
			local cx = wndsize8_7[3];
			local cy = wndsize8_7[4];
			local rowcolumn = wnd_space[1];
			for i = 2,4 do
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+wndsize[3]+rowcolumn,wndsize[2]+(i-2)*(cy+rowcolumn), cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);						
			end
			for i = 5, count do
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+(i-5)*(cx+rowcolumn),wndsize[2]+wndsize[4]+rowcolumn, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);									
			end
		end
	elseif(splittype == REF_SPLIT9) then
		wndsize = SIZE('s_auxi_dwell_split9_xywh');
		local i;
		local cx = wndsize[3];
		local cy = wndsize[4];
		local rowcolumn = wnd_space[1];
		for i = 1, count do
			local row, column;
			row = math.modf((i - 1) / 3);
			column = (i - 1) - math.floor( (i - 1) / 3) * 3
			local x = wndsize[1] + column  * cx + column * rowcolumn;
			local y = wndsize[2] + row  * cy + row * rowcolumn;
			b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
			local item = "win" .. tostring(i);
			set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
		end
	elseif(splittype == REF_SPLIT16) then	
		if (channel_num == 10) then --10·⴦10
			wndsize = SIZE('s_auxi_dwell_split10_2_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn = wnd_space[1];
			for i = 1, 2 do
				local row, column;
				row = math.modf((i - 1) / 2);
				column = (i - 1) - math.floor( (i - 1) / 2) * 2
				local x = wndsize[1] + column  * cx + column * rowcolumn;
				local y = wndsize[2] + row  * cy + row * rowcolumn;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end
			
			local wndsize_8 = SIZE('s_auxi_dwell_split10_8_xywh');		
			for i = 3, count do
				local row, column;
				row = math.modf((i - 3) / 4);
				column = (i - 3) - math.floor( (i - 3) / 4) * 4
				local x2 = wndsize[1] + wndsize_8[3] * column + column * rowcolumn;
				local y2 = wndsize[2] + cy + rowcolumn + row * wndsize_8[4] + row * rowcolumn;
				b_wnd_ex.move_ex(top, id + 40 + i, {x2, y2, wndsize_8[3], wndsize_8[4]}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);		
			end
		elseif (channel_num == 12) then --6·⴦6
			wndsize = SIZE('s_auxi_dwell_split13_1_xywh');
			b_wnd_ex.move_ex(top, id + 41, wndsize, false)
			local item = "win" .. tostring(1);
			set_wnd_chn_info(top, id + 41, cfgData.win_list_info[item], false);			
			local wndsize13_12 = SIZE('s_auxi_dwell_split13_12_xywh');
			local cx = wndsize13_12[3];
			local cy = wndsize13_12[4];
			local rowcolumn = wnd_space[1];		
			local row, column;
			for i = 2,5 do
				row = math.modf((i - 2) / 2);
				column = math.modf((i - 2) % 2);
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+wndsize[3]+rowcolumn + column * (cx + rowcolumn) ,wndsize[2] + row *(cy + rowcolumn), cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end
			
			for i = 6, count do
				row = math.modf((i - 6) / 4);
				column = math.modf((i - 6) % 4);			
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+ column *(cx + rowcolumn),wndsize[2]+wndsize[4]+rowcolumn + row *(cy + rowcolumn), cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end			
		else			
			wndsize = SIZE('s_auxi_dwell_split16_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn = wnd_space[1];
			for i = 1, count do
				local row, column;
				row = math.modf((i - 1) / 4);
				column = (i - 1) - math.floor( (i - 1) / 4) * 4
				local x = wndsize[1] + column  * cx + column * rowcolumn;
				local y = wndsize[2] + row  * cy + row * rowcolumn;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);						
			end
		end
	elseif(splittype == REF_SPLIT32) then	
		if (channel_num == 20 or channel_num == 24) then --6·⴦6
			wndsize = SIZE('s_auxi_dwell_split24_4_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn_4 = wnd_space[2];
			for i = 1, 4 do
				local row, column;
				row = math.modf((i - 1) / 2);
				column = (i - 1) - math.floor( (i - 1) / 2) * 2
				local x = wndsize[1] + column  * cx + column * rowcolumn_4;
				local y = wndsize[2] + row  * cy + row * rowcolumn_4;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);						
			end
			local rowcolumn_28 = wnd_space[2];
			local wndsize_28 = SIZE('s_auxi_dwell_split24_20_xywh');		
			for i = 5, 12 do
				row = math.modf((i - 5) / 2);
				column = (i - 5) - math.floor( (i - 5) / 2) * 2		
				local x1 = wndsize[1]+2*cx+wndsize_28[3]*column+ 2*rowcolumn_4 + column*rowcolumn_28;
				local y1 = wndsize[2]+row*wndsize_28[4]+row*rowcolumn_28;
				b_wnd_ex.move_ex(top,id + 40 +i,{x1,y1,wndsize_28[3],wndsize_28[4]}, false);
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);							
			end
			
			for i = 13, count do
				row = math.modf((i - 13) / 6);
				column = (i - 13) - math.floor((i - 13) / 6) * 6		
				local x2 = wndsize[1]+wndsize_28[3]*column+column*rowcolumn_28;
				local y2 = wndsize[2]+2*cy+row*wndsize_28[4]+2*rowcolumn_4 + row*rowcolumn_28;
				b_wnd_ex.move_ex(top,id + 40 +i,{x2,y2,wndsize_28[3],wndsize_28[4]}, false);	
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);				
			end
		else
			wndsize = SIZE('s_auxi_dwell_split32_4_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn_4 = wnd_space[2];
			for i = 1, 4 do
				local row, column;
				row = math.modf((i - 1) / 2);
				column = (i - 1) - math.floor( (i - 1) / 2) * 2
				local x = wndsize[1] + column  * cx + column * rowcolumn_4;
				local y = wndsize[2] + row  * cy + row * rowcolumn_4;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);								
			end
			local rowcolumn_28 = wnd_space[2];
			local wndsize_28 = SIZE('s_auxi_dwell_split32_28_xywh');		
			for i = 5, 16 do
				row = math.modf((i - 5) / 2);
				column = (i - 5) - math.floor( (i - 5) / 2) * 2		
				local x1 = wndsize[1]+2*cx+wndsize_28[3]*column+ 2*rowcolumn_4 + column*rowcolumn_28;
				local y1 = wndsize[2]+row*wndsize_28[4]+row*rowcolumn_28;
				b_wnd_ex.move_ex(top,id + 40 +i,{x1,y1,wndsize_28[3],wndsize_28[4]}, false);
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);						
			end
			
			for i = 17, count do
				row = math.modf((i - 17) / 8);
				column = (i - 17) - math.floor((i - 17) / 8) * 8		
				local x2 = wndsize[1]+wndsize_28[3]*column+column*rowcolumn_28;
				local y2 = wndsize[2]+2*cy+row*wndsize_28[4]+2*rowcolumn_4 + row*rowcolumn_28;
				b_wnd_ex.move_ex(top,id + 40 +i,{x2,y2,wndsize_28[3],wndsize_28[4]}, false);	
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);		
			end
		end
	elseif(splittype == REF_SPLIT36) then	
		if (channel_num == 20 or channel_num == 24) then --6·⴦6
			wndsize = SIZE('s_auxi_dwell_split25_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn = wnd_space[2];
			for i = 1, count do
				local row, column;
				row = math.modf((i - 1) / 5);
				column = (i - 1) - math.floor( (i - 1) / 5) * 5
				local x = wndsize[1] + column  * cx + column*rowcolumn;
				local y = wndsize[2] + row  * cy + row*rowcolumn;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);						
			end
			
		else
			wndsize = SIZE('s_auxi_dwell_split36_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn = wnd_space[2];
			for i = 1, count do
				local row, column;
				row = math.modf((i - 1) / 6);
				column = (i - 1) - math.floor( (i - 1) / 6) * 6
				local x = wndsize[1] + column  * cx + column*rowcolumn;
				local y = wndsize[2] + row  * cy + row*rowcolumn;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);						
			end
		end		
	elseif(splittype == REF_SPLIT64) then	
		wndsize = SIZE('s_auxi_dwell_split64_xywh');
		local i;
		local cx = wndsize[3];
		local cy = wndsize[4];
		local rowcolumn = wnd_space[2];
		for i = 1, count do
			local row, column;
			row = math.modf((i - 1) / 8);
			column = (i - 1) - math.floor( (i - 1) / 8) * 8
			local x = wndsize[1] + column  * cx + column*rowcolumn;
			local y = wndsize[2] + row  * cy + row*rowcolumn;
			b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
			local item = "win" .. tostring(i);
			set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
		end
	elseif(splittype == REF_SPLIT128) then	

	end
	
	for i = 1, 16 do
		local check_status = false;
		if (i+diplay_off == w1_page_auxiliary_dsp.select_layout) then
			check_status = true;
		end
		b_wnd_ex.set_check(top, id + 20 + i, check_status, false);		
	end
end

--ˢUI
local check_valid = function(top, layout_info)	
	local cwnd = w1_page_auxiliary_dsp.wnd;
	local valid_channel =  vaild_channel_num;
	local win_num  = layout_info.win_num
	if (win_num > valid_channel) then --ǰֳ	
		return false;
	else
		return true;
	end
	
end

local cfgdatatoui = function(top, cfgdata)
	local valid_layout = {};	
	local data = cfgdata.auxi_layout_cfg;
	dec_mode = cfgdata.cfg_auxiliary.layout_mode	
	if (0 == dec_mode) then
		vaild_channel_num = global_val.get_channelnum() / 2;
	elseif(1 == dec_mode) then
		vaild_channel_num = global_val.get_channelnum() - 1;
	elseif(2 == dec_mode) then	
		vaild_channel_num = 1;
	end	
	channel_num = vaild_channel_num;

	
	local layout_idx = {};
	for i = 1, #data do
		if (check_valid(top, data[i])) then
			local layout = {};
			util.copy_tab_b(layout, data[i]);
			table.insert(valid_layout, layout);		
			table.insert(layout_idx, i - 1);
		end
	end
	
	if (w1_page_auxiliary_dsp.old_layout_id == nil) then
		w1_page_auxiliary_dsp.old_layout_id = util.copy_tab(layout_idx);
	else
		util.copy_tab_b(w1_page_auxiliary_dsp.old_layout_id, layout_idx);
	end	
	
	if(w1_page_auxiliary_dsp.data == nil) then
		w1_page_auxiliary_dsp.data = util.copy_tab(valid_layout);
	else
		util.copy_tab_b(w1_page_auxiliary_dsp.data, valid_layout);
	end

	if (w1_page_auxiliary_dsp.select_layout > #w1_page_auxiliary_dsp.data)	then
		w1_page_auxiliary_dsp.select_layout = 1;
	end
	
	local cwnd = w1_page_auxiliary_dsp.wnd;
	set_layout_name_list(top);
	local cutLayoutCfg = w1_page_auxiliary_dsp.data[w1_page_auxiliary_dsp.select_layout]; --ǰʹõ
	local split_type = cutLayoutCfg.dev_type;
	b_wnd_ex.set_text(top, cwnd.t_name.id, cutLayoutCfg.name, false)	
	local poll_interval = 	cutLayoutCfg.poll_interval
	local text;
	if (poll_interval == 0) then
		text = STR('LA_NO_SWITCH');
	elseif (poll_interval == 5) then
		text = STR('LA_SECOND_5');
	elseif (poll_interval == 10) then
		text = STR('LA_SECOND_10');	
	elseif (poll_interval == 20) then
		text = STR('LA_SECOND_20');
	elseif (poll_interval == 30) then
		text = STR('LA_SECOND_30');	
	elseif (poll_interval == 60) then
		text = STR('LA_SECOND_60');
	elseif (poll_interval == 120) then
		text = STR('LA_SECOND_120');
	elseif (poll_interval == 300) then
		text = STR('LA_SECOND_300');
	end
	b_wnd_ex.set_text(top, cwnd.t_time.id, text, false)	
	move_layout_name_show(top, false)
	
	if( split_type == 1) then
		cutsplit(top, 1, false);
	elseif(split_type == 4) then
		cutsplit(top, 4, false);
	elseif(split_type == 8) then
		cutsplit(top, 8, false);	
	elseif(split_type == 9) then
		cutsplit(top, 9, false);
	elseif(split_type == 16) then
		cutsplit(top, 16, false);
	elseif(split_type == 32) then
		cutsplit(top, 32, false);
	elseif(split_type == 36) then
		cutsplit(top, 36, false);
	elseif(split_type == 64) then
		cutsplit(top, 64, false);		
	end
	
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_auxiliary_dsp.init = function(top)
	if(w1_page_auxiliary_dsp.all_channel_name == nil) then
		w1_page_auxiliary_dsp.all_channel_name = util.copy_tab(b_app_api.get_all_channel_name());		
	else
		util.copy_tab_b(w1_page_auxiliary_dsp.all_channel_name, b_app_api.get_all_channel_name());
	end
	table.insert(w1_page_auxiliary_dsp.all_channel_name, STR('LA_EMPTY'));
	
	w1_page_auxiliary_dsp.open_auxi = false;
	w1_wnd_util.cfgtab = {'cfg_auxiliary','auxi_layout_cfg'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0;
end

local on_channel = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_auxiliary_dsp.wnd;
		for i = 1, 16 do
			b_wnd_ex.set_check(top, id + 20 + i, false, false);
		end
		b_wnd_ex.set_check(top, win_id, true, false);
		w1_page_auxiliary_dsp.select_layout = win_id - id - 20 + diplay_off

		local cutLayoutCfg = w1_page_auxiliary_dsp.data[w1_page_auxiliary_dsp.select_layout]; --ǰʹõ
		b_wnd_ex.set_text(top, cwnd.t_name.id, cutLayoutCfg.name, false)	
		local poll_interval = 	cutLayoutCfg.poll_interval
		local text = "";
		if (poll_interval == 0) then
			text = STR('LA_NO_SWITCH');
		elseif (poll_interval == 5) then
			text = STR('LA_SECOND_5');
		elseif (poll_interval == 10) then
			text = STR('LA_SECOND_10');	
		elseif (poll_interval == 20) then
			text = STR('LA_SECOND_20');
		elseif (poll_interval == 30) then
			text = STR('LA_SECOND_30');	
		elseif (poll_interval == 60) then
			text = STR('LA_SECOND_60');
		elseif (poll_interval == 120) then
			text = STR('LA_SECOND_120');
		elseif (poll_interval == 300) then
			text = STR('LA_SECOND_300');
		end
		b_wnd_ex.set_text(top, cwnd.t_time.id, text, false)	
		move_layout_name_show(top, false)		

		local split_type = cutLayoutCfg.dev_type;
		if( split_type == 1) then
			cutsplit(top, 1, false);
		elseif(split_type == 4) then
			cutsplit(top, 4, false);
		elseif(split_type == 8) then
			cutsplit(top, 8, false);	
		elseif(split_type == 9) then
			cutsplit(top, 9, false);
		elseif(split_type == 16) then
			cutsplit(top, 16, false);
		elseif(split_type == 32) then
			cutsplit(top, 32, false);
		elseif(split_type == 36) then
			cutsplit(top, 36, false);
		elseif(split_type == 64) then
			cutsplit(top, 64, false);		
		end		
			
		b_dlg.dlg_set_redraw(top);
	elseif(b_ui.MOUSEWHEELDOWN == vmsg) then
		w1_page_auxiliary_dsp.dwell_mouse_down(top);
	elseif(b_ui.MOUSEWHEELUP == vmsg) then
		w1_page_auxiliary_dsp.dwell_mouse_up(top);	
	end
	return 0
end

local on_add = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cutLayoutCfg  = {
			name = "",
			poll_interval = 5,
			dev_type = 4,
			win_num = 4,
			win_list_info = {
				win1 = {},
				win2 = {},
				win3 = {},
				win4 = {},
			}
		}	
		w1_page_add_dwell.setCfgData(top, cutLayoutCfg, 0, 1, 0, false, dec_mode); --ã ͣ  ǰ
		b_dlg.do_modal(top, w1_key.DLG_ADD_DWELL, 0, 0, nil);
		--༭ɹȡ
		w1_wnd_util.cfgtab = {'cfg_auxiliary','auxi_layout_cfg'};
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_init(top)
		b_dlg.dlg_set_redraw(top)		
	end
	return 0
end

local on_edit = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cutLayoutCfg = w1_page_auxiliary_dsp.data[w1_page_auxiliary_dsp.select_layout]; --ǰʹõ
		local layout_id = w1_page_auxiliary_dsp.old_layout_id[w1_page_auxiliary_dsp.select_layout];
		local default_spilt = false;
		if (w1_page_auxiliary_dsp.select_layout == 1) then
			default_spilt = true;	
		end
		w1_page_add_dwell.setCfgData(top, cutLayoutCfg, 1, 1, layout_id, default_spilt, dec_mode);
		b_dlg.do_modal(top, w1_key.DLG_ADD_DWELL, 0, 0, nil);
		--༭ɹȡ
		w1_wnd_util.cfgtab = {'cfg_auxiliary','auxi_layout_cfg'};
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_init(top)
		b_dlg.dlg_set_redraw(top)				
		
	end
	return 0
end

local okfunc_delete = function(inParam)
	--ɾӿ
	local idx= w1_page_auxiliary_dsp.old_layout_id[w1_page_auxiliary_dsp.select_layout];
	local param = {
		layout_id = idx,
		screen_id = 1
	}
	local ret = b_app_api.delete_custom_dwell(param);
	diplay_off = 0;
	w1_page_auxiliary_dsp.select_layout = 1;
	--༭ɹȡ
	w1_wnd_util.cfgtab = {'cfg_auxiliary','auxi_layout_cfg'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(inParam[1])
	b_dlg.dlg_set_redraw(inParam[1])			
	
	return 0;
end

local on_del = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_DELETE'), true, true,false);
		w1_msgbox.set_func(okfunc_delete, {top}, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);	
	end
	return 0
end

w1_page_auxiliary_dsp.dwell_updata_f =function(top)
	local data = w1_page_auxiliary_dsp.data;
	local layout_num = #data;
	if layout_num > 16 then	
		diplay_off = b_wnd_ex.get_drop(top,w1_page_auxiliary_dsp.wnd.drop.id);
		for i = 1, 16 do
			b_wnd_ex.set_text(top, id + 20 + i, data[i+diplay_off].name, false)
			local check_status = false;
			if (i+diplay_off == w1_page_auxiliary_dsp.select_layout) then
				check_status = true;
			end
			b_wnd_ex.set_check(top, id + 20 + i, check_status, false);			
		end
		b_dlg.dlg_set_redraw(top);
	end
end

w1_page_auxiliary_dsp.dwell_mouse_up =function(top)
	local data = w1_page_auxiliary_dsp.data;
	local layout_num = #data;
	if layout_num > 16 then	
		if diplay_off > 0 then
			diplay_off = diplay_off-1
		end
		local vdrop = {};
		vdrop.set_cur = diplay_off;
		vdrop.set_cap = 16;
		vdrop.set_max = layout_num;
		b_wnd_ex.set_drop(top,w1_page_auxiliary_dsp.wnd.drop.id,vdrop,false);
		for i = 1, 16 do
			b_wnd_ex.set_text(top, id + 20 + i, data[i+diplay_off].name, false)
			local check_status = false;
			if (i+diplay_off == w1_page_auxiliary_dsp.select_layout) then
				check_status = true;
			end
			b_wnd_ex.set_check(top, id + 20 + i, check_status, false);
		end
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_auxiliary_dsp.dwell_mouse_down =function(top)
	local data = w1_page_auxiliary_dsp.data;
	local layout_num = #data;
	if layout_num > 16 then	
		if (diplay_off + 16 < layout_num)	then
			diplay_off = diplay_off+1
		else
			return 0;	
		end
		local vdrop = {};
		vdrop.set_cur = diplay_off;
		vdrop.set_cap = 16;
		vdrop.set_max = layout_num;
		b_wnd_ex.set_drop(top,w1_page_auxiliary_dsp.wnd.drop.id,vdrop,false);
		for i = 1, 16 do
			b_wnd_ex.set_text(top, id + 20 + i, data[i+diplay_off].name, false)
			local check_status = false;
			if (i+diplay_off == w1_page_auxiliary_dsp.select_layout) then
				check_status = true;
			end
			b_wnd_ex.set_check(top, id + 20 + i, check_status, false);
		end
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_auxiliary_dsp.dwell_drop_drag =function(top)
	local data = w1_page_auxiliary_dsp.data;
	local layout_num = #data;
	if layout_num > 16 then	
		diplay_off = b_wnd_ex.get_drop(top,w1_page_auxiliary_dsp.wnd.drop.id);
		for i = 1, 16 do
			b_wnd_ex.set_text(top, id + 20 + i, data[i+diplay_off].name, false)
			local check_status = false;
			if (i+diplay_off == w1_page_auxiliary_dsp.select_layout) then
				check_status = true;
			end
			b_wnd_ex.set_check(top, id + 20 + i, check_status, false);
		end
		b_dlg.dlg_set_redraw(top);	
	end
end

w1_page_auxiliary_dsp.timer_start = function()
	w1_page_auxiliary_dsp.timestart = true;
end

w1_page_auxiliary_dsp.timer_stop = function(top)
	w1_page_auxiliary_dsp.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_auxiliary_dsp.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_auxiliary_dsp.timerenevt = function(top)
	if(w1_page_auxiliary_dsp.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_auxiliary_dsp.wnd.tipinfo.id);
	end
	return 0;
end

local get_valid_cam_num = function(channel_num)
	local chn_num = channel_num;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (0 < dec_num and 0 < vi_num) then 
		local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
		if (0 == chn_type.chn_type[vi_num + 1]) then
			chn_num = vi_num;
		end
	end
	
	return chn_num;
end

w1_page_auxiliary_dsp.on_pre_show = function(top)
	local cwnd = w1_page_auxiliary_dsp.wnd;
	channel_num = global_val.get_channelnum();	
	channel_num = get_valid_cam_num(channel_num);

	w1_page_auxiliary_dsp.clear_data(top);
	
	if(w1_page_auxiliary_dsp.all_channel_name == nil) then
		w1_page_auxiliary_dsp.all_channel_name = util.copy_tab(b_app_api.get_all_channel_name());		
	else
		util.copy_tab_b(w1_page_auxiliary_dsp.all_channel_name, b_app_api.get_all_channel_name());
	end
	table.insert(w1_page_auxiliary_dsp.all_channel_name, STR('LA_EMPTY'));

	local layout_name = STR('LA_LAYOUT_NAME') .. ":";
	local swtich_time = STR('LA_POLL_INTERVAL') .. ":";
	b_wnd_ex.set_text(top, cwnd.cap_name.id, layout_name, false)		
	b_wnd_ex.set_text(top, cwnd.cap_time.id, swtich_time, false)	

	local space_info = SIZE('s_auxi_dwell_move_pos_info');
	local edit_pos = SIZE('s_auxi_dwell_edit_xywh');
	local del_pos = SIZE('s_auxi_dwell_del_xywh');	
	local cap_name_pos = SIZE('s_auxi_dwell_cap_name_xywh');
	local right_x = del_pos[1] + del_pos[3];
	local size= b_wnd_ex.get_textsize(top, cwnd.btn_edit.id)
	local edit_size = b_wnd_ex.get_textsize(top, cwnd.btn_edit.id).w + space_info[3];	
	local del_size = b_wnd_ex.get_textsize(top, cwnd.btn_del.id).w + space_info[3];		
	local valid_del_pos = {right_x -del_size, del_pos[2], del_size, del_pos[4]};
	local valid_edit_pos = {valid_del_pos[1] - edit_size, edit_pos[2], edit_size, edit_pos[4]};
	b_wnd_ex.move_ex(top, cwnd.btn_edit.id, valid_edit_pos, false)	
	b_wnd_ex.move_ex(top, cwnd.btn_del.id, valid_del_pos, false)	
	title_max_len = valid_edit_pos[1] - cap_name_pos[1];

	return 0;
end

w1_page_auxiliary_dsp.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'layout_list','vline1', 'hline1','cap_name', 't_name', 'cap_time', 't_time', 
			'btn_add', 'btn_edit','btn_del', 'ch1','ch2','ch3','ch4','ch5','ch6','ch7','ch8',
			'ch9','ch10','ch11','ch12','ch13','ch14','ch15','ch16','drop',
			'f1','f2','f3','f4','f5','f6','f7','f8','f9','f10','f11','f12','f13','f14','f15','f16',
			'f17','f18','f19','f20','f21','f22','f23','f24','f25','f26','f27','f28','f29','f30','f31','f32',
			'f33','f34','f35','f36','f37','f38','f39','f40','f41','f42','f43','f44','f45','f46','f47','f48',
			'f49','f50','f51','f52','f53','f54','f55','f56','f57','f58','f59','f60','f61','f62','f63','f64','tipinfo' },
	layout_list = {t='static',	id=id+1,	xywh='s_auxi_dwell_channel_xywh',text='LA_LAYOUT_LIST', align = b_ui.ALIGN.LEFT},
	vline1 		= {t='hline',	id=id+2,	xywh='s_auxi_dwell_vline1_xywh'},
	hline1		= {t='hline',	id=id+3,	xywh='s_auxi_dwell_hline1_xywh'},
		
	cap_name	= {t='static',	id=id+4,	xywh='s_auxi_dwell_cap_name_xywh',text='LA_LAYOUT_NAME',align = b_ui.ALIGN.LEFT},
	t_name	= {t='static',	id=id+5,	xywh='s_auxi_dwell_t_name_xywh',text='',align = b_ui.ALIGN.LEFT, trans = false},
	cap_time	= {t='static',	id=id+6,	xywh='s_auxi_dwell_cap_time_xywh',text='LA_POLL_INTERVAL',align = b_ui.ALIGN.LEFT},
	t_time	= {t='static',	id=id+7,	xywh='s_auxi_dwell_t_time_xywh',text='',align = b_ui.ALIGN.LEFT, trans = false},	

	btn_add 	= {t='tt_button',id=id+8,xywh='s_auxi_dwell_add_xywh',cmd= on_add, 
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'},
				color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.CENTER,'f_menu','it_add','it_add', 'it_add'},
				},
	btn_edit = {t='tt_button',id=id+9,xywh='s_auxi_dwell_edit_xywh',text='LA_EDIT', align = b_ui.ALIGN.LEFT,cmd= on_edit, 
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'},
				color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_editcameera','it_editcameera', 'it_editcameera'},
				},
	btn_del = {t='tt_button',id=id+10,xywh='s_auxi_dwell_del_xywh',text='LA_ROLE_DELETE', align = b_ui.ALIGN.LEFT,cmd= on_del, 
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'},
				color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_delcamera','it_delcamera', 'it_delcamera'},
				},

	ch1 		= { t='checkbutton',	id=id+21,	xywh='s_auxi_dwell_ch1_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},
	ch2 		= { t='checkbutton',	id=id+22,	xywh='s_auxi_dwell_ch2_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch3 		= { t='checkbutton',	id=id+23,	xywh='s_auxi_dwell_ch3_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},
	ch4 		= { t='checkbutton',	id=id+24,	xywh='s_auxi_dwell_ch4_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch5 		= { t='checkbutton',	id=id+25,	xywh='s_auxi_dwell_ch5_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},
	ch6 		= { t='checkbutton',	id=id+26,	xywh='s_auxi_dwell_ch6_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch7 		= { t='checkbutton',	id=id+27,	xywh='s_auxi_dwell_ch7_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},
	ch8 		= { t='checkbutton',	id=id+28,	xywh='s_auxi_dwell_ch8_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},
	ch9 		= { t='checkbutton',	id=id+29,	xywh='s_auxi_dwell_ch9_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},
	ch10 		= { t='checkbutton',	id=id+30,	xywh='s_auxi_dwell_ch10_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch11 		= { t='checkbutton',	id=id+31,	xywh='s_auxi_dwell_ch11_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},
	ch12 		= { t='checkbutton',	id=id+32,	xywh='s_auxi_dwell_ch12_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch13 		= { t='checkbutton',	id=id+33,	xywh='s_auxi_dwell_ch13_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},
	ch14 		= { t='checkbutton',	id=id+34,	xywh='s_auxi_dwell_ch14_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch15 		= { t='checkbutton',	id=id+35,	xywh='s_auxi_dwell_ch15_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},
	ch16 		= { t='checkbutton',	id=id+36,	xywh='s_auxi_dwell_ch16_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.LEFT,
				color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},cmd = on_channel
				},
	drop 		= {t='vdrop', id=id+37,xywh='s_auxi_dwell_vdrop_xywh', cmd = on_drop},
	
	f1 		= {t='dwell_wnd', id=id+41, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f2 		= {t='dwell_wnd', id=id+42, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f3 		= {t='dwell_wnd', id=id+43, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f4 		= {t='dwell_wnd', id=id+44, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f5 		= {t='dwell_wnd', id=id+45, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f6 		= {t='dwell_wnd', id=id+46, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f7 		= {t='dwell_wnd', id=id+47, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f8 		= {t='dwell_wnd', id=id+48, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f9 		= {t='dwell_wnd', id=id+49, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f10 	= {t='dwell_wnd', id=id+50, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f11 	= {t='dwell_wnd', id=id+51, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f12 	= {t='dwell_wnd', id=id+52, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f13 	= {t='dwell_wnd', id=id+53, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f14 	= {t='dwell_wnd', id=id+54, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f15 	= {t='dwell_wnd', id=id+55, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f16 	= {t='dwell_wnd', id=id+56, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},					
	f17 	= {t='dwell_wnd', id=id+57, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f18 	= {t='dwell_wnd', id=id+58, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f19 	= {t='dwell_wnd', id=id+59, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f20 	= {t='dwell_wnd', id=id+60, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f21 	= {t='dwell_wnd', id=id+61, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f22 	= {t='dwell_wnd', id=id+62, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f23 	= {t='dwell_wnd', id=id+63, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f24 	= {t='dwell_wnd', id=id+64, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f25 	= {t='dwell_wnd', id=id+65, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f26 	= {t='dwell_wnd', id=id+66, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f27 	= {t='dwell_wnd', id=id+67, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f28 	= {t='dwell_wnd', id=id+68, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f29 	= {t='dwell_wnd', id=id+69, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f30 	= {t='dwell_wnd', id=id+70, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f31 	= {t='dwell_wnd', id=id+71, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f32 	= {t='dwell_wnd', id=id+72, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},
	f33 	= {t='dwell_wnd', id=id+73, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f34 	= {t='dwell_wnd', id=id+74, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f35 	= {t='dwell_wnd', id=id+75, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f36 	= {t='dwell_wnd', id=id+76, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f37 	= {t='dwell_wnd', id=id+77, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f38 	= {t='dwell_wnd', id=id+78, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f39 	= {t='dwell_wnd', id=id+79, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f40 	= {t='dwell_wnd', id=id+80, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f41 	= {t='dwell_wnd', id=id+81, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f42 	= {t='dwell_wnd', id=id+82, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f43 	= {t='dwell_wnd', id=id+83, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f44 	= {t='dwell_wnd', id=id+84, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f45 	= {t='dwell_wnd', id=id+85, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f46 	= {t='dwell_wnd', id=id+86, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f47 	= {t='dwell_wnd', id=id+87, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f48 	= {t='dwell_wnd', id=id+88, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},
	f49 	= {t='dwell_wnd', id=id+89, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f50 	= {t='dwell_wnd', id=id+90, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f51 	= {t='dwell_wnd', id=id+91, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f52 	= {t='dwell_wnd', id=id+92, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f53 	= {t='dwell_wnd', id=id+93, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f54 	= {t='dwell_wnd', id=id+94, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f55 	= {t='dwell_wnd', id=id+95, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f56 	= {t='dwell_wnd', id=id+96, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f57 	= {t='dwell_wnd', id=id+97, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f58 	= {t='dwell_wnd', id=id+98, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f59 	= {t='dwell_wnd', id=id+99, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f60 	= {t='dwell_wnd', id=id+100, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f61 	= {t='dwell_wnd', id=id+101, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f62 	= {t='dwell_wnd', id=id+102, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},		
	f63 	= {t='dwell_wnd', id=id+103, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	
	f64 	= {t='dwell_wnd', id=id+104, xywh='s_auxi_dwell_wnd_xywh', check = false, enableselect = false},	

	tipinfo		= {t='static', id=id+173,	xywh='s_auxi_dwell_tipinfo_xywh',	text='',trans = false},	
}

return w1_page_auxiliary_dsp

