local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_bad_detection.bad_detection_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg 		= require("wnd.w1_util.w1_ui_msg") 
local r_str			= require("wnd.core.r_res.r_str")
local b_app_api		= require("wnd.core.command.b_app_api")
local STR 			= r_str.get_str
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")

local old_num = 0;
local old_index =0;
local status = 0;
local cflag = 1;
local path = "";
local scan_info = {};
local old_cur = "disk1";
local old_bads = 0;
local btn_flag = 0;

local w1_page_bad_detection={
	data,
	timestart = false,
	block_status,   --ȡײ״̬1Ϊڼ⣬0Ϊϣ˳
	flag = 0,  --תҳʱȷȡť
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_bad_detection.s_768 =
{
	disk_static_xywh = {53,21,42,32},
	disk_combox_xywh = {106,21,133,32},
	disk_radio_all = {288,21,48,32},
	disk_radio_key = {336,21,106,32},
	disk_button_xywh = {448,21,96,32},
	s_disk_error_xywh = {53,106,490,462},
	disk_line_xywh = {53,85,720,1},
	disk_cap_detect_xywh = {560,128,106,32},
	disk_t_detect_xywh = {693,128,53,32},
	disk_cap_hdd_xywh = {560,184,106,32},
	disk_t_hdd_xywh = {693,184,53,32},
	disk_cap_bolock_xywh = {560,241,106,32},
	disk_t_block_xywh = {693,241,53,32},
	disk_line2_xywh = {560,334,213,1},
	disk_good_img = {562,355,13,14},
	disk_bad_img = {666,355,13,14},
	disk_cap_good_xywh = {586,348,53,32},
	disk_cap_bad_xywh = {693,348,53,32},
	disk_bad_count_xywh = {560,298,106,32},
	disk_t_bad_xywh = {693,298,53,32},
	disk_cap_nodisk = {213,21,106,32},
	block_btn_size = {9,10,1,0},
	disk_tipinfo = {53,590,533,32},
};

w1_page_bad_detection.s_1280={
	disk_static_xywh={100,30,80,45},
	disk_combox_xywh={200,30,250,45},
	disk_radio_all={540,30,90,45},
	disk_radio_key={630,30,150,45},
	disk_button_xywh={800,30,150,45},
	s_disk_error_xywh = {100,130,580,600},
	disk_line_xywh = {100,120,850,1},
	disk_cap_detect_xywh ={680,180,200,45},
	disk_t_detect_xywh={900,180,100,45},
	disk_cap_hdd_xywh={680,260,200,45},
	disk_t_hdd_xywh={900,260,100,45},
	disk_cap_bolock_xywh={680,340,200,45},
	disk_t_block_xywh={900,340,100,45},
	disk_line2_xywh={680,460,300,1},
	disk_cap_good_xywh={730,490,120,45},
	disk_cap_bad_xywh={900,490,100,45},
	disk_bad_count_xywh = {680,410,200,45},
	disk_t_bad_xywh={900,410,100,45},
	disk_cap_nodisk = {400,30,200,45},
	disk_good_img={685,500,20,20},
	disk_bad_img={850,500,20,20},
	block_btn_size={10,11,3,0},
	disk_tipinfo={100,730,900,45},
}

w1_page_bad_detection.s_1440={
	disk_static_xywh={100,30,80,45},
	disk_combox_xywh={200,30,250,45},
	disk_radio_all={540,30,90,45},
	disk_radio_key={630,30,200,45},
	disk_button_xywh={840,30,180,45},
	s_disk_error_xywh = {100,130,600,500},
	disk_line_xywh = {100,120,930,1},
	disk_cap_detect_xywh ={700,180,200,45},
	disk_t_detect_xywh={900,180,100,45},
	disk_cap_hdd_xywh={700,260,200,45},
	disk_t_hdd_xywh={900,260,100,45},
	disk_cap_bolock_xywh={700,340,200,45},
	disk_t_block_xywh={900,340,100,45},
	disk_line2_xywh={700,470,400,1},
	disk_cap_good_xywh={740,480,120,45},
	disk_cap_bad_xywh={900,480,150,45},
	disk_bad_count_xywh = {700,420,200,45},
	disk_t_bad_xywh={900,420,100,45},
	disk_cap_nodisk = {400,30,200,45},
	disk_good_img={700,495,18,15},
	disk_bad_img={860,495,18,15},
	block_btn_size={10,10,3,0},
	disk_tipinfo={100,660,900,45},
}

w1_page_bad_detection.s_1080p={
	disk_static_xywh={100,30,80,45},
	disk_combox_xywh={200,30,250,45},
	disk_radio_all={540,30,90,45},
	disk_radio_key={630,30,200,45},
	disk_button_xywh={840,30,180,45},
	s_disk_error_xywh = {100,150,920,651},
	disk_line_xywh = {100,120,1350,1},
	disk_cap_detect_xywh ={1050,180,200,45},
	disk_t_detect_xywh={1300,180,100,45},
	disk_cap_hdd_xywh={1050,260,200,45},
	disk_t_hdd_xywh={1300,260,100,45},
	disk_cap_bolock_xywh={1050,340,200,45},
	disk_t_block_xywh={1300,340,100,45},
	disk_line2_xywh={1050,470,400,1},
	disk_good_img={1055,500,25,20},
	disk_bad_img={1250,500,25,20},
	disk_cap_good_xywh={1100,490,100,45},
	disk_cap_bad_xywh={1300,490,100,45},
	disk_bad_count_xywh = {1050,420,200,45},
	disk_t_bad_xywh={1300,420,100,45},
	disk_cap_nodisk = {400,30,200,45},
	block_btn_size={18,15,3,0},
	disk_tipinfo={100,830,1000,45},
}

w1_page_bad_detection.s_2k={
	disk_static_xywh={133,45,130,60},
	disk_combox_xywh={230,45,300,60},
	disk_radio_all={580,45,140,60},
	disk_radio_key={720,45,200,60},
	disk_button_xywh={950,45,260,60},
	s_disk_error_xywh = {133,230,1202,890},
	disk_line_xywh = {130,180,1800,2},
	disk_cap_detect_xywh ={1400,240,270,60},
	disk_t_detect_xywh={1800,240,130,60},
	disk_cap_hdd_xywh={1400,320,270,60},
	disk_t_hdd_xywh={1800,320,130,60},
	disk_cap_bolock_xywh={1400,400,270,60},
	disk_t_block_xywh={1800,400,130,60},
	disk_line2_xywh={1400,610,530,1},
	disk_cap_good_xywh={1500,640,200,60},
	disk_cap_bad_xywh={1800,640,200,60},
	disk_bad_count_xywh = {1400,480,266,60},
	disk_t_bad_xywh={1800,480,130,60},
	disk_cap_nodisk ={533,40,267,60},
	disk_good_img ={1400,655,30,25},
	disk_bad_img={1750,655,30,25},
	block_btn_size={23,20,4,0},
	disk_tipinfo={133,1103,1333,60},
}

w1_page_bad_detection.s_4k={
	disk_static_xywh={200,60,160,90},
	disk_combox_xywh={400,60,500,90},
	disk_radio_all={1080,60,180,90},
	disk_radio_key={1260,60,400,90},
	disk_button_xywh={1680,60,360,90},
	s_disk_error_xywh = {200,300,1840,1340},
	disk_line_xywh = {200,250,2700,2},
	disk_cap_detect_xywh ={2100,360,400,90},
	disk_t_detect_xywh={2600,360,200,90},
	disk_cap_hdd_xywh={2100,520,400,90},
	disk_t_hdd_xywh={2600,520,200,90},
	disk_cap_bolock_xywh={2100,680,400,90},
	disk_t_block_xywh={2600,680,200,90},
	disk_line2_xywh={2100,940,800,2},
	disk_good_img={2110,1000,50,40},
	disk_bad_img={2500,1000,50,40},
	disk_cap_good_xywh={2200,980,200,90},
	disk_cap_bad_xywh={2600,980,200,90},
	disk_bad_count_xywh = {2100,840,400,90},
	disk_t_bad_xywh={2600,840,200,90},
	block_btn_size={36,30,6,0},
	disk_tipinfo={200,1660,2000,90},
}

w1_page_bad_detection.clear_data = function()
	w1_page_bad_detection.data = nil;
	scan_info = nil;
end	

local cfgdatatoui=function (top,cfgdata)
	assert(type(cfgdata)=='table')
	w1_page_bad_detection.data=cfgdata.disk;
	local cwnd = w1_page_bad_detection.wnd;
	local disk_info = cfgdata.disk;
	b_wnd_ex.set_hide(top,cwnd.cap_nodisk.id,true,false);
	b_wnd_ex.set_disable(top,cwnd.t_combox.id,false,false);
	b_wnd_ex.set_disable(top,cwnd.t_all.id,false,false);
	b_wnd_ex.set_disable(top,cwnd.t_key.id,false,false);
	if disk_info.disk_num==0 then
		local sid = cwnd.cap_disk.id;
		local eid = cwnd.cap_nodisk.id; 
		for i=sid,eid do
			b_wnd_ex.set_hide(top,i,true,false);
		end
		b_wnd_ex.set_hide(top,cwnd.cap_nodisk.id,false,false);
	else
		local sid = cwnd.cap_disk.id;
		local eid = cwnd.cap_nodisk.id; 
		for i=sid,eid do
			b_wnd_ex.set_hide(top,i,false,false);
		end
		b_wnd_ex.set_hide(top,cwnd.t_tipinfo.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.cap_nodisk.id,true,false);
		local disk_list = {};
		local idx = "disk1"
		for i=1,disk_info.disk_num do
			local idx = "disk"..tostring(i);
			local is_raid = string.find(disk_info[idx].name,"md")
			if (nil == is_raid) then
				scan_info[idx]={process='0',bad='0'};	
				if disk_info[idx]~=nil then
					table.insert(disk_list,disk_info[idx].name);
				end
			end
		end
		if #disk_list==0 then
			local sid = cwnd.cap_disk.id;
			local eid = cwnd.cap_nodisk.id; 
			for i=sid,eid do
				b_wnd_ex.set_hide(top,i,true,false);
			end
			b_wnd_ex.set_hide(top,cwnd.cap_nodisk.id,false,false);
			return 0
		end
		b_wnd_ex.set_items(top,cwnd.t_combox.id,disk_list,false);
		idx =""
		local cur_name = b_wnd_ex.get_text(top,cwnd.t_combox.id)
		for i=1,disk_info.disk_num do
			if cur_name==disk_info['disk'..i].name then
				idx ="disk"..tostring(i)
			end
		end	
		
		local path_name = disk_info[idx].path;
		path = string.match(path_name,".+/(.+)");
		local hdd_size =  disk_info[idx].size/1000;
		if(hdd_size < 1000)then
			hdd_size =math.floor(hdd_size / 1)..'GB';
			
		else
			hdd_size = hdd_size/1000
			hdd_size =math.floor(hdd_size / 1)..'TB';
		end
		
		b_wnd_ex.set_text(top,cwnd.t_detect.id,scan_info[idx].process,false)
		b_wnd_ex.set_text(top,cwnd.t_bad.id,scan_info[idx].bad,false)
		b_wnd_ex.set_block_clear(top,cwnd.t_grid.id,{'1'},false);
		
		b_wnd_ex.set_text(top,cwnd.t_hdd.id,hdd_size,false);
		b_wnd_ex.set_text(top,w1_page_bad_detection.wnd.t_button.id,STR('LA_SCAN'),false)
		btn_flag = 0;
	end
	return 0;
end

local reflsh_data= function (top,redraw)

	
	return 0;
end

local uitousercfg=function (top,cfgdata)
	
	return 0;
end

w1_page_bad_detection.on_pre_show=function (top)
	local cwnd = w1_page_bad_detection.wnd;
	local dlg_w = global_val.get_size();
	local block_size = SIZE('block_btn_size')
	scan_info = {};
	b_wnd_ex.set_block_size(top,cwnd.t_grid.id,block_size,false);
	
	return 0;
end

w1_page_bad_detection.init =function (top)
	w1_wnd_util.cfgtab = {'disk'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0;
end

local on_disk = function (top,wnd_id,vmsg,x,y)
	if vmsg==b_ui_msg.msg_user_update_parent then
		local data = w1_page_bad_detection.data;
		local cwnd = w1_page_bad_detection.wnd;
		local idx = "";
		local cur_name = b_wnd_ex.get_text(top,cwnd.t_combox.id)
		for i=1,data.disk_num do
			if cur_name==data['disk'..i].name then
				idx ="disk"..tostring(i)
			end
		end
		local hdd_size =  data[idx].size/1000;
		local path_name = data[idx].path;
		b_wnd_ex.set_hide(top,cwnd.t_tipinfo.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_videoinfo.id,false,false);
		path = string.match(path_name,".+/(.+)")
		if(hdd_size < 1000)then
			hdd_size =math.floor(hdd_size / 1)..'GB';
		else
			hdd_size = hdd_size/1000
			hdd_size =math.floor(hdd_size / 1)..'TB';
		end

		b_wnd_ex.set_text(top,cwnd.t_hdd.id,hdd_size,false);
		
		local old_process = b_wnd_ex.get_text(top,cwnd.t_detect.id);
		local old_bad = b_wnd_ex.get_text(top,cwnd.t_bad.id);
		if (old_process ~= scan_info[old_cur].process or old_bad ~= scan_info[old_cur].bad) then
			scan_info[old_cur].process = old_process;
			scan_info[old_cur].bad = old_bad;
			
			if (old_process ~= 0) then
				scan_info[old_cur].blocks = b_wnd_ex.get_bad_block_data(top,cwnd.t_grid.id);
			end
		end
		
		b_wnd_ex.set_text(top,cwnd.t_detect.id,scan_info[idx].process,false)
		b_wnd_ex.set_text(top,cwnd.t_bad.id,scan_info[idx].bad,false)
		if (scan_info[idx].blocks == nil or scan_info[idx].process == 0) then
			b_wnd_ex.set_block_clear(top,cwnd.t_grid.id,{'1'},false);
		else
			for i = 1, scan_info[idx].blocks.size do
				b_wnd_ex.set_bad_color(top,cwnd.t_grid.id,{scan_info[idx].blocks['list'..i].status, scan_info[idx].blocks['list'..i].s_index, scan_info[idx].blocks['list'..i].e_index},false);
			end
		end
		
		old_cur = idx;
		b_wnd_ex.set_text(top,cwnd.t_button.id,STR('LA_SCAN'),false)
		btn_flag = 0;
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_all = function (top,wnd_id,vmsg,x,y)
	if vmsg==b_ui.WM_USER_UPDATE_PARAM then
		local cwnd = w1_page_bad_detection.wnd;
		b_wnd_ex.set_check(top,cwnd.t_key.id,false,false);
		b_wnd_ex.set_check(top,cwnd.t_all.id,true,false);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_key = function (top,wnd_id,vmsg,x,y)
	if vmsg==b_ui.WM_USER_UPDATE_PARAM then
		local cwnd = w1_page_bad_detection.wnd;
		b_wnd_ex.set_check(top,cwnd.t_all.id,false,false);
		b_wnd_ex.set_check(top,cwnd.t_key.id,true,false);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

w1_page_bad_detection.okfunc_diskdetect = function(top)
	local cwnd = w1_page_bad_detection.wnd;
	local data = w1_page_bad_detection.data;
	b_app_api.stop_detect();
	local status=b_app_api.get_block_status();
	b_app_api.channge_cursor(b_ui.CURSOR.JY_CURSOR_WAIT);
	while status.status~=0 do
		status=b_app_api.get_block_status();
		w1_page_bad_detection.block_status =status.status;
	end
	b_app_api.channge_cursor(b_ui.CURSOR.JY_CURSOR_POINT);
	
	w1_page_bad_detection.timer_stop_click();
	w1_page_bad_detection.flag = 1;
	b_wnd_ex.set_text(top[1],cwnd.t_button.id,STR('LA_SCAN'),true)	
	btn_flag = 0;
end

local on_button = function (top,wnd_id,vmsg,x,y)
	if vmsg == b_ui.LBUTTONCLK then
		local cwnd = w1_page_bad_detection.wnd;
		local data = w1_page_bad_detection.data;
		local button_name = b_wnd_ex.get_text(top,cwnd.t_button.id);
		local block = {} 
		local key = b_wnd_ex.get_check(top,cwnd.t_all.id);		
		
		block.device_name = path
		if key then
			block.key_area_flag = 0;
		else
			block.key_area_flag = 1;
		end
		
		b_wnd_ex.set_hide(top,cwnd.t_tipinfo.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_videoinfo.id,false,false);
		if btn_flag == 0 then
			old_index = 0;
			old_num = 0;
			status = 0;
			old_bads = 0;
			btn_flag = 1;
			b_wnd_ex.set_text(top,cwnd.t_bad.id,old_index,false)
			b_wnd_ex.set_block_clear(top,cwnd.t_grid.id,{'1'},false);
			b_app_api.start_detect(block);
			b_wnd_ex.set_text(top,cwnd.t_detect.id,0,false)
			b_wnd_ex.set_text(top,w1_page_bad_detection.wnd.t_button.id,STR('LA_CANCEL'),false)
			w1_page_bad_detection.timer_start_click();
			b_wnd_ex.set_disable(top,cwnd.t_combox.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.t_all.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.t_key.id,true,false);
			
		else
			w1_page_bad_detection.stop_block_detect(top)
			if w1_page_bad_detection.flag==1 then
				b_wnd_ex.set_disable(top,cwnd.t_combox.id,false,false);
				b_wnd_ex.set_disable(top,cwnd.t_all.id,false,false);
				b_wnd_ex.set_disable(top,cwnd.t_key.id,false,false);
				b_wnd_ex.set_text(top,cwnd.t_detect.id,0,false)
				b_wnd_ex.set_text(top,cwnd.t_bad.id,0,false)
				b_wnd_ex.set_block_clear(top,cwnd.t_grid.id,{'1'},false);
			end
		end
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

w1_page_bad_detection.stop_block_detect =function (top)
	w1_page_bad_detection.flag = 0;
	w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_STOP_DETECT'), true, true,false);
	w1_msgbox.set_attach_dlgattr(STR('LA_WAIT_STOP_DETECT'));
	w1_msgbox.set_func(w1_page_bad_detection.okfunc_diskdetect, {top}, nil, nil);
	b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
end

w1_page_bad_detection.timer_start_click = function()
	w1_page_bad_detection.timestart = true
end

w1_page_bad_detection.timer_stop_click = function(top)
	b_app_api.cancel_detect();
	w1_page_bad_detection.timestart = false
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_bad_detection.timerenevt = function(top)
	if(w1_page_bad_detection.timestart) then
		--w1_wnd_util.timerenevt(top, w1_page_bad_detection.wnd.t_grid.id)
		local cwnd = w1_page_bad_detection.wnd
		local block_info = b_app_api.get_bad_detection()
		
		local index = math.modf(block_info.scan_percent*14.4)
		
		local block_bg ={}
		
		if block_info.bb_count==old_num then
			if status==2 then
	
			else
				status = 1
			end
		else
			status = 2
			b_wnd_ex.set_text(top,cwnd.t_bad.id,block_info.bb_count,false)
			old_num = block_info.bb_count;
			if old_num >=100 then
				w1_page_bad_detection.timer_stop_click();
				b_wnd_ex.set_text(top,w1_page_bad_detection.wnd.t_button.id,STR('LA_SCAN'),false)
				btn_flag = 0;
				b_wnd_ex.set_disable(top,cwnd.t_combox.id,false,false);
				b_wnd_ex.set_disable(top,cwnd.t_all.id,false,false);
				b_wnd_ex.set_disable(top,cwnd.t_key.id,false,false);
				b_wnd_ex.set_hide(top,cwnd.t_videoinfo.id,true,false);
				b_wnd_ex.set_hide(top,cwnd.t_tipinfo.id,false,false)
			end
		end
		if old_index == index then
			
		else
			if status ==2 then
				if old_bads+90<block_info.bb_count then
					block_bg={status,old_index+1,index};
					b_wnd_ex.set_bad_color(top,cwnd.t_grid.id,block_bg,false);
				else
					block_bg={status,old_index+1,old_index+1};
					b_wnd_ex.set_bad_color(top,cwnd.t_grid.id,block_bg,false);
					if index > old_index+1 then
						block_bg={1,old_index+2,index};
						b_wnd_ex.set_bad_color(top,cwnd.t_grid.id,block_bg,false);
					end
				end
			else
				block_bg={status,old_index+1,index};
				b_wnd_ex.set_bad_color(top,cwnd.t_grid.id,block_bg,false);
			end
			old_index = index
			status = 1
			old_bads = block_info.bb_count
		end
		
		local percent_str = (string.format("%.2f",block_info.scan_percent)).."%"
		if (old_num >= 100) then
			percent_str = '100.00%'
		end
		b_wnd_ex.set_text(top,cwnd.t_detect.id,percent_str,false)
		if 0<=index and index<1440 then
			block_bg={cflag,index+1,index+1};
			b_wnd_ex.set_bad_color(top,cwnd.t_grid.id,block_bg,false);
			if cflag==0 then
				cflag = 1 
			else
				cflag =0
			end
		end
		if string.format("%.2f",block_info.scan_percent)=='100.00' then
			b_wnd_ex.set_text(top,w1_page_bad_detection.wnd.t_button.id,STR('LA_SCAN'),false)
			btn_flag = 0;
			b_wnd_ex.set_disable(top,cwnd.t_combox.id,false,false);
			b_wnd_ex.set_disable(top,cwnd.t_all.id,false,false);
			b_wnd_ex.set_disable(top,cwnd.t_key.id,false,false);
			w1_page_bad_detection.timer_stop_click();
		end
		
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

w1_page_bad_detection.wnd={
	t='wnd_bg',id=id,xywh='s_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'},
	sub={
			'cap_disk','t_button','t_grid','t_all','t_key','t_combox','cap_line',
			'cap_detect','t_detect','cap_hdd','t_hdd','cap_line2',
			'cap_good','cap_bad','t_bad','good_img','bad_img','cap_nodisk','t_tipinfo','t_videoinfo','cap_badcount'
		},
		
	cap_disk={t='static',id=id+1,xywh='disk_static_xywh',text='LA_DISK',},
	t_combox={t='combox',id=id+2,xywh='disk_combox_xywh',cmd=on_disk},
	
	
	
	t_grid={t='grid',id=id+3,xywh='s_disk_error_xywh',},
	
	t_all = {t='radio_text',id=id+4,xywh='disk_radio_all',text='LA_ALL',cmd=on_all,check=true,
		color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n',}},
	t_key = {t='radio_text',id=id+5,xywh='disk_radio_key',text='LA_KEY_AREA',cmd=on_key,
		color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n',}},
	
	
	t_button={t='button',id=id+6,xywh='disk_button_xywh',text='LA_SCAN',cmd=on_button},
	
	cap_line={t='hline',id=id+7,xywh='disk_line_xywh',},
	
	cap_detect={t='static',id=id+8,xywh='disk_cap_detect_xywh',text='LA_SACN_PROCESS'},
	t_detect = {t='static',id=id+9,xywh='disk_t_detect_xywh',text='0',trans=false,},
	
	cap_hdd={t='static',id=id+10,xywh='disk_cap_hdd_xywh',text='LA_HDD_CAPACITY'},
	t_hdd = {t='static',id=id+11,xywh='disk_t_hdd_xywh',text='0',trans=false,},
	
	cap_block={t='static',id=id+12,xywh='disk_bad_count_xywh',text='LA_BLOCK_SIZE'},
	t_block = {t='static',id=id+13,xywh='disk_t_bad_xywh',text='0',trans=false,},
	
	cap_line2 = {t='hline',id=id+14,xywh='disk_line2_xywh',},
	
	cap_good = {t='static',id=id+15,xywh='disk_cap_good_xywh',text='LA_GOOD_T'},
	
	cap_badcount = {t='static',id=id+16,xywh='disk_cap_bolock_xywh',text='LA_BAD_SECTOR_COUNT'},
	
	cap_bad = {t='static',id=id+17,xywh='disk_cap_bad_xywh',text='LA_BAD_T'},
	t_bad = {t='static',id=id+18,xywh='disk_t_block_xywh',text='0',trans=false,},
	
	good_img = {t='static',id=id+19,xywh='disk_good_img',color = {'c_apply_ok', 'c_apply_ok', 'c_txt_n'},
					},
	bad_img = {t='static',id=id+20,xywh='disk_bad_img',color= { 'c_hint_err_text', 'c_hint_err_text', 'c_txt_n'},
					},
	t_tipinfo = {t= 'static',id=id+21,xywh='disk_tipinfo',text='LA_BAD_TIP',color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'},},
	t_videoinfo = {t= 'static',id=id+22,xywh='disk_tipinfo',text='LA_BAD_VIDEO_TIP',},
	
	cap_nodisk = {t='static',id=id+23,xywh='disk_cap_nodisk',text='LA_NO_DISK',font = 'f_grade3'},
}

return w1_page_bad_detection