--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_encode.encode_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_copy 	= require("wnd.w1_util.w1_copy")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_app_cfg		= require("wnd.core.b_app_cfg")
local b_wnd 	= require("wnd.core.b_wnd") 
local r_size		= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local enc_vsize = nil
local enc_width = nil;
local enc_height = nil;
local enc_framerate= nil;
local enc_type = nil;
local enc_audiotype = nil;
local enc_level = nil;
local enc_ratetype= nil; 
local enc_quality = nil;
local enc_bitrate = nil;
local enc_iframe_interval= nil;
local enc_id = nil;
local enc_enable = nil;

local enc_type2 = nil;--Ƿֻеǰһֱͱ־Ŀǰ֧H264,H265
local enc_audiotype2 = nil;--жϵǰƵ־
local change_encode_type =nil;--ǰˢUIǷл
local change_resolution =nil;--ǰˢUIǷлֱʣʵˢµǰֱʶӦ
local enc_smart_cap = nil;--Ƿܱ

local audio_index = nil;

--local rtsp_flag = false;

local BITRATE_RANGE = {"0","512","1024","1536","2048","3072","4096","5120","6144","7168","8192","9216","10240"};
local BITRATE_RANGE_2 = {"0","64","128","256","512","768","1024","1536","2048","3072","4096","5120","6144","7168","8192","9216","10240"};
local vsize_list = {};
local width_list ={};
local height_list ={};
local res_list ={};
local rate_list ={};
local iframe_list={};
local BITRATE = {};

local vsize_list2 = {};
local width_list2 ={};
local height_list2 ={};
local res_list2 ={};
local rate_list2 ={};
local iframe_list2={};
local BITRATE2 = {};
local type_list ={"CBR","VBR"};
local w1_page_encode = 
{
	old_chid,
	data,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
};

w1_page_encode.s_768 =
{
	s_encode_hline_xywh = {53,85,746,1},
	s_encode_tipinfo = {53,540,373,35},
	s_encode_rtsp_tip = {53,576,373,35},
		
	s_encode_page_1_1 = {281,21,202,32},
	s_encode_page_2_1 = {281,64,202,32},
	s_encode_page_3_1 = {281,107,202,32},
	s_encode_page_4_1 = {281,150,202,32},
	s_encode_page_5_1 = {281,193,202,32},
	s_encode_page_6_1 = {281,236,202,32},
	s_encode_page_7_1 = {281,279,202,32},
	s_encode_page_8_1 = {281,322,202,32},
	s_encode_page_9_1 = {281,365,202,32},
	s_encode_page_10_1 = {281,408,202,32},
	s_encode_page_11_1 = {281,451,202,32},
	s_enable_xywh_10 = {277,451,25,21},
	s_enable_xywh_11 = {277,494,25,21},

	s_encode_page_1_2 = {494,21,202,32},
	s_encode_page_2_2 = {494,64,202,32},
	s_encode_page_3_2 = {494,107,202,32},
	s_encode_page_4_2 = {494,150,202,32},
	s_encode_page_5_2 = {494,193,202,32},
	s_encode_page_6_2 = {494,236,202,32},
	s_encode_page_7_2 = {494,279,202,32},
	s_encode_page_8_2 = {494,322,202,32},
	s_encode_page_9_2 = {494,365,202,32},
	s_encode_page_10_2 = {494,408,202,32},
	s_encode_page_11_2 = {494,451,202,32},
};

w1_page_encode.s_1280 = 
{
	s_encode_hline_xywh = {100,120,865,1},
	s_enable_xywh_11 = {445,690,48,30},
	s_enable_xywh_10 = {445,630,48,30},
	s_encode_tipinfo = {100,730,700,50},
	s_encode_rtsp_tip = {100,780,600,50},
	
	s_encode_page_1_1= {450, 30,250,45},
	s_encode_page_2_1 = {450, 90,250,45},
	s_encode_page_3_1 = {450, 150,250,45},
	s_encode_page_4_1 = {450, 210,250,45},
	s_encode_page_5_1 = {450, 270,250,45},
	s_encode_page_6_1 = {450, 330,250,45},
	s_encode_page_7_1 = {450, 390,250,45},
	s_encode_page_8_1 = {450, 450,250,45},
	s_encode_page_9_1 = {450, 510,250,45},
	s_encode_page_10_1 = {450, 570,250,45},
	s_encode_page_11_1 = {450, 630,250,45},
	
	s_encode_page_1_2 = {715, 30,250,45},
	s_encode_page_2_2 = {715, 90,250,45},
	s_encode_page_3_2 = {715, 150,250,45},
	s_encode_page_4_2 = {715, 210,250,45},
	s_encode_page_5_2 = {715, 270,250,45},
	s_encode_page_6_2 = {715, 330,250,45},
	s_encode_page_7_2 = {715, 390,250,45},
	s_encode_page_8_2 = {715, 450,250,45},
	s_encode_page_9_2 = {715, 510,250,45},
	s_encode_page_10_2 = {715, 570,250,45},
	s_encode_page_11_2 = {715, 630,250,45},

}
w1_page_encode.s_1440 = 
{
	s_encode_hline_xywh = {100,100,900,1},

	s_enable_xywh_11 = {470,575,48,30},
	s_enable_xywh_10 = {470,525,48,30},
	s_encode_tipinfo = {100,700,500,50},
	s_encode_rtsp_tip = {100,750,500,50},
	
	
	
	s_encode_page_1_1= {480, 25,250,45},
	s_encode_page_2_1 = {480, 75,250,45},
	s_encode_page_3_1 = {480, 125,250,45},
	s_encode_page_4_1 = {480, 175,250,45},
	s_encode_page_5_1 = {480, 225,250,45},
	s_encode_page_6_1 = {480, 275,250,45},
	s_encode_page_7_1 = {480, 325,250,45},
	s_encode_page_8_1 = {480, 375,250,45},
	s_encode_page_9_1 = {480, 425,250,45},
	s_encode_page_10_1 = {480, 475,250,45},
	s_encode_page_11_1 = {480, 525,250,45},
	
	s_encode_page_1_2 = {750, 25,250,45},
	s_encode_page_2_2 = {750, 75,250,45},
	s_encode_page_3_2 = {750, 125,250,45},
	s_encode_page_4_2 = {750, 175,250,45},
	s_encode_page_5_2 = {750, 225,250,45},
	s_encode_page_6_2 = {750, 275,250,45},
	s_encode_page_7_2 = {750, 325,250,45},
	s_encode_page_8_2 = {750, 375,250,45},
	s_encode_page_9_2 = {750, 425,250,45},
	s_encode_page_10_2 = {750, 475,250,45},
	s_encode_page_11_2 = {750, 525,250,45},

}

w1_page_encode.s_1080p = 
{
	s_encode_hline_xywh = {100,120,1400,1},
	s_enable_xywh_11 = {520,695,48,30},
	s_enable_xywh_10 = {520,630,48,30},
	s_encode_tipinfo = {100,760,700,50},
	s_encode_rtsp_tip = {100,810,700,50},
	
	s_encode_page_1_1 = {527, 30,380,45},
	s_encode_page_2_1 = {527, 90,380,45},
	s_encode_page_3_1 = {527, 150,380,45},
	s_encode_page_4_1 = {527, 210,380,45},
	s_encode_page_5_1 = {527, 270,380,45},
	s_encode_page_6_1 = {527, 330,380,45},
	s_encode_page_7_1 = {527, 390,380,45},
	s_encode_page_8_1 = {527, 450,380,45},
	s_encode_page_9_1 = {527, 510,380,45},
	s_encode_page_10_1 = {527, 570,380,45},
	s_encode_page_11_1 = {527, 630,380,45},

	s_encode_page_1_2 = {927, 30,380,45},
	s_encode_page_2_2 = {927, 90,380,45},
	s_encode_page_3_2 = {927, 150,380,45},
	s_encode_page_4_2 = {927, 210,380,45},
	s_encode_page_5_2 = {927, 270,380,45},
	s_encode_page_6_2 = {927, 330,380,45},
	s_encode_page_7_2 = {927, 390,380,45},
	s_encode_page_8_2 = {927, 450,380,45},
	s_encode_page_9_2 = {927, 510,380,45},
	s_encode_page_10_2 = {927, 570,380,45},
	s_encode_page_11_2 = {927, 630,380,45},
}

w1_page_encode.s_2k = 
{
	s_enable_xywh_10 = {691,837,63,39},
	s_enable_xywh_11 = {691,924,63,39},
	s_encode_hline_xywh = {133,159,1862,1},
	s_encode_page_4_2 = {1232,279,505,59},
	s_encode_page_9_2 = {1232,678,505,59},
	s_encode_page_2_2 = {1232,119,505,59},
	s_encode_page_6_1 = {700,438,505,59},
	s_encode_tipinfo = {133,1010,931,66},
	s_encode_page_10_1 = {700,758,505,59},
	s_encode_page_8_1 = {700,598,505,59},
	s_encode_page_3_2 = {1232,199,505,59},
	s_encode_page_11_2 = {1232,837,505,59},
	s_encode_page_9_1 = {700,678,505,59},
	s_encode_page_10_2 = {1232,758,505,59},
	s_encode_page_8_2 = {1232,598,505,59},
	s_encode_page_11_1 = {700,837,505,59},
	s_encode_page_7_2 = {1232,518,505,59},
	s_encode_page_6_2 = {1232,438,505,59},
	s_encode_page_5_2 = {1232,359,505,59},
	s_encode_page_1_2 = {1232,39,505,59},
	s_encode_page_7_1 = {700,518,505,59},
	s_encode_page_5_1 = {700,359,505,59},
	s_encode_page_4_1 = {700,279,505,59},
	s_encode_page_3_1 = {700,199,505,59},
	s_encode_rtsp_tip = {133,1077,931,66},
	s_encode_page_2_1 = {700,119,505,59},
	s_encode_page_1_1 = {700,39,505,59},
	
}

w1_page_encode.s_4k = 
{
	s_enable_xywh_10 = {1040,1260,96,60},
	s_enable_xywh_11 = {1040,1390,96,60},
	s_encode_hline_xywh = {200,240,2800,2},
	s_encode_page_4_2 = {1854,420,760,90},
	s_encode_page_9_2 = {1854,1020,760,90},
	s_encode_page_2_2 = {1854,180,760,90},
	s_encode_page_6_1 = {1054,660,760,90},
	s_encode_tipinfo = {200,1520,1400,100},
	s_encode_page_10_1 = {1054,1140,760,90},
	s_encode_page_8_1 = {1054,900,760,90},
	s_encode_page_3_2 = {1854,300,760,90},
	s_encode_page_11_2 = {1854,1260,760,90},
	s_encode_page_9_1 = {1054,1020,760,90},
	s_encode_page_10_2 = {1854,1140,760,90},
	s_encode_page_8_2 = {1854,900,760,90},
	s_encode_page_11_1 = {1054,1260,760,90},
	s_encode_page_7_2 = {1854,780,760,90},
	s_encode_page_6_2 = {1854,660,760,90},
	s_encode_page_5_2 = {1854,540,760,90},
	s_encode_page_1_2 = {1854,60,760,90},
	s_encode_page_7_1 = {1054,780,760,90},
	s_encode_page_5_1 = {1054,540,760,90},
	s_encode_page_4_1 = {1054,420,760,90},
	s_encode_page_3_1 = {1054,300,760,90},
	s_encode_rtsp_tip = {200,1620,1400,100},
	s_encode_page_2_1 = {1054,180,760,90},
	s_encode_page_1_1 = {1054,60,760,90},
}

local channel_num;--豸ͨĿ
local redraw =false;
--1,ǰлͨ//ʱҪ¸£仯
--2,֮ǰʾĵǰֵܲٷΧˢ
local getResolution = function(vsize)
	if (0 == vsize ) then	
		return nil;
	elseif (1 == vsize) then
		return "CIF";
	elseif (2 == vsize) then
		return "270p";
	elseif (4 == vsize) then
		return "HD1";
	elseif (8 == vsize) then
		return "360P";
	elseif (16 == vsize) then
		return "4CIF";
	elseif (32 == vsize) then
		return "D1";
	elseif (64 == vsize) then
		return "960H";
	elseif (128 == vsize) then
		return "720P";
	elseif (256 == vsize) then
		return "960P";
	elseif (512 == vsize ) then
		return "1080N";
	elseif (1024  == vsize ) then
		return "1080P";
	elseif ( 2048 == vsize) then
		return "2MP";
	elseif (4096 == vsize) then
		return "3MP";	
	elseif (8192 == vsize) then
		return "4MP2";
	elseif (16384 == vsize) then
		return "5MP"
	elseif (32768 == vsize) then
		return "6MP";
	elseif (65536 == vsize) then
		return "8MP";
	elseif (262144 == vsize) then
		return "3MP1";	
	elseif (524288 == vsize) then
		return "4MP";
	elseif (1048576 == vsize) then
		return "4MP1";
	elseif (2097152 == vsize) then
		return "6MP1";
	elseif (4194304 == vsize) then
		return "3MP2";
	elseif (8388608 == vsize) then
		return "5MP1";
	else
		return "8MP"
	end
end

w1_page_encode.clear_data = function ()
	vsize_list = nil
	width_list =nil;
	height_list =nil
	res_list =nil
	rate_list =nil
	iframe_list=nil
	
	vsize_list2 = nil
	width_list2 = nil;
	height_list2 = nil
	res_list2 = nil
	rate_list2 = nil
	iframe_list2 = nil

	w1_page_encode.data = nil
end

local resolution = function(top,cfgdata,current_encodetype,chn,stream_type,current_resolu,redraw)
	enc_type2 = nil;
	enc_audiotype2 = nil;

	if(stream_type == 0)then
		res_list ={};
		vsize_list ={};
		width_list ={};
		height_list ={};
	
		if(nil == cfgdata['limits'][chn])then
			print("------no limits-------"..chn);
		end
		local audiotype = cfgdata['limits'][chn]['limit_v1']['enc_id'];
		enc_audiotype2 = audiotype;
		for i =1,cfgdata['limits'][chn]['limit_v1']['limit_num'] do
			local list = "limit_list"..tostring(i)
			local enctype = cfgdata['limits'][chn]['limit_v1'][list]['enc_type'];
			local vsize = cfgdata['limits'][chn]['limit_v1'][list]['vsize'];
			local width = cfgdata['limits'][chn]['limit_v1'][list]['width'];
			local height = cfgdata['limits'][chn]['limit_v1'][list]['height'];
			if(enctype == current_encodetype)then --ͬʱH264H265ֻȡǰ
				local res = getResolution(vsize);
				--local res_str = res.."("..width.."x"..height..")"
				local res_str = width.."x"..height
				table.insert(res_list, res_str);
				table.insert(vsize_list,vsize);
				table.insert(width_list, width);
				table.insert(height_list,height);
			else
				enc_type2 =	enctype;		
			end
		end
		
		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_res.id+stream_type,res_list,redraw)
		for i=1,#res_list do
			if(current_resolu == res_list[i])then		
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_res.id+stream_type,i-1,redraw)
			end
		end
	
		if(0 == #res_list)then
			b_wnd_ex.set_text(top, w1_page_encode.wnd.t_res.id+stream_type,"960x570",redraw);
		end
	else
		res_list2 ={};
		vsize_list2 ={};
		width_list2 ={};
		height_list2 ={};
	
		local audiotype = cfgdata['limits'][chn]['limit_v2']['enc_id'];
		enc_audiotype2 = audiotype;
		for i =1,cfgdata['limits'][chn]['limit_v2']['limit_num'] do
			local list = "limit_list"..tostring(i)
			local enctype = cfgdata['limits'][chn]['limit_v2'][list]['enc_type'];
			local vsize = cfgdata['limits'][chn]['limit_v2'][list]['vsize'];
			local width = cfgdata['limits'][chn]['limit_v2'][list]['width'];
			local height = cfgdata['limits'][chn]['limit_v2'][list]['height'];
			if(enctype == current_encodetype)then
				local res = getResolution(vsize);
				local res_str = width.."x"..height
				table.insert(res_list2, res_str);
				table.insert(vsize_list2,vsize);
				table.insert(width_list2, width);
				table.insert(height_list2,height);
			else
				if((1 == enctype)or (2 == enctype))then -- 쳣
					enc_type2 =	enctype;
				else
					print("----enctype------else-------------"..enctype)
				end
			end
		end

		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_res.id+stream_type,res_list2,redraw)
		for i=1,#res_list2 do
			if(current_resolu == res_list2[i])then		
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_res.id+stream_type,i-1,redraw)
			end
		end
	
		if(0 == #res_list2)then
			b_wnd_ex.set_text(top, w1_page_encode.wnd.t_res.id+stream_type,"960x570",redraw);
		end	
	end 
end

local quality = function(top,cfgdata,chn,stream_type,current_quality,redraw)
	local QUALITY_RANGE ={};
	table.insert(QUALITY_RANGE,STR('LA_LOWEST'))
	table.insert(QUALITY_RANGE,STR('LA_LOWER'))
	table.insert(QUALITY_RANGE,STR('LA_LOW_T'))
	table.insert(QUALITY_RANGE,STR('LA_MEDIUM_T'))
	table.insert(QUALITY_RANGE,STR('LA_HIGH_T'))
	table.insert(QUALITY_RANGE,STR('LA_HIGHER'))
	table.insert(QUALITY_RANGE,STR('LA_HIGHEST'))
	b_wnd_ex.set_items(top,w1_page_encode.wnd.t_quality.id+stream_type,QUALITY_RANGE,redraw)
	if(current_quality >0)then
		b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_quality.id+stream_type,current_quality -1,redraw)
	else
		print("----lua---quality----"..current_quality)
		b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_quality.id+stream_type,0,redraw)--쳣ֵ
	end
end

local frame_rate= function(top,cfgdata,current_encodetype,chn,stream_type,current_resolu,current_rate,current_irate,redraw)
	if(stream_type == 0)then
		rate_list ={};
		iframe_list = {};
		
		for i =1,cfgdata['limits'][chn]['limit_v1']['limit_num'] do 
			local list = "limit_list"..tostring(i)
			local enctype = cfgdata['limits'][chn]['limit_v1'][list]['enc_type']
			if(enctype == current_encodetype)then
				local resolu =cfgdata['limits'][chn]['limit_v1'][list]['width'].."x"..cfgdata['limits'][chn]['limit_v1'][list]['height']
				if(current_resolu == resolu)then
					local min_rate = cfgdata['limits'][chn]['limit_v1'][list]['min_frame_rate'];
					local max_rate = cfgdata['limits'][chn]['limit_v1'][list]['max_frame_rate'];
					for i= min_rate,max_rate do
						table.insert(rate_list, tostring(i))--.." fps")
					end	
					local min_iframe =  cfgdata['limits'][chn]['limit_v1'][list]['min_iframe_interval'];
					local max_iframe =  cfgdata['limits'][chn]['limit_v1'][list]['max_iframe_interval'];
					for i= min_iframe,max_iframe do
						table.insert(iframe_list, tostring(i))
					end	
				end
			end
		end
		
		local num =#rate_list
		if(num >0)then
			b_wnd_ex.set_items(top,w1_page_encode.wnd.t_frame.id+stream_type,rate_list,redraw) --б
		else
			for i= 1,30 do
				table.insert(rate_list, tostring(i))--.." fps")--쳣
			end	
			b_wnd_ex.set_items(top,w1_page_encode.wnd.t_frame.id+stream_type,rate_list,redraw)
		end
		local numi =#iframe_list
		if numi>1 then
			b_wnd_ex.set_items(top,w1_page_encode.wnd.t_iframe.id+stream_type,iframe_list,redraw)
		else
			for i= 1,30 do
				table.insert(iframe_list, tostring(i))
			end	
			b_wnd_ex.set_items(top,w1_page_encode.wnd.t_iframe.id+stream_type,iframe_list,redraw)
		end
	
		local rate = tostring(current_rate)
		local flag =false;
	
		local rate_num =#rate_list
		for i=1,rate_num do
			if(rate == rate_list[i])then
				flag =true;
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_frame.id+stream_type,i-1,redraw)
			end
		end
		if(false ==flag)then
			if(0 < rate_num)then
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_frame.id+stream_type,rate_num-1,redraw)
			else
				print("--lua---frame_rate---")						--"1 fps"					
				b_wnd_ex.set_text(top, w1_page_encode.wnd.t_frame.id+stream_type,"1",redraw)--쳣ֵ
			end
		end
	
		local irate = tostring(current_irate)
		local iflag =false;
		local irate_num =#iframe_list
		for i=1,irate_num do
			if(irate == iframe_list[i])then
				iflag =true;
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_iframe.id+stream_type,i-1,redraw)
			end
		end
		if(false ==iflag)then
			if(0 < irate_num)then
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_iframe.id+stream_type,irate_num-1,redraw)
			else
				print("--lua---iframe_rate---")											
				b_wnd_ex.set_text(top, w1_page_encode.wnd.t_iframe.id+stream_type,"1",redraw)--쳣ֵ
			end
		end
	else
		rate_list2 ={};
		iframe_list2 = {};
	
		for i =1,cfgdata['limits'][chn]['limit_v2']['limit_num'] do 
			local list = "limit_list"..tostring(i)
			local enctype = cfgdata['limits'][chn]['limit_v2'][list]['enc_type']
			if(enctype == current_encodetype)then
				local resolu =cfgdata['limits'][chn]['limit_v2'][list]['width'].."x"..cfgdata['limits'][chn]['limit_v2'][list]['height']
				if(current_resolu == resolu)then
					local min_rate = cfgdata['limits'][chn]['limit_v2'][list]['min_frame_rate'];
					local max_rate = cfgdata['limits'][chn]['limit_v2'][list]['max_frame_rate'];
					for i= min_rate,max_rate do
						table.insert(rate_list2, tostring(i))
					end	
					local min_iframe =  cfgdata['limits'][chn]['limit_v2'][list]['min_iframe_interval'];
					local max_iframe =  cfgdata['limits'][chn]['limit_v2'][list]['max_iframe_interval'];
					for i= min_iframe,max_iframe do
						table.insert(iframe_list2, tostring(i))
					end	
				end
			end
		end

		local num =#rate_list2
		if(num >0)then
			b_wnd_ex.set_items(top,w1_page_encode.wnd.t_frame.id+stream_type,rate_list2,redraw) --б
		else
			for i= 1,30 do
				table.insert(rate_list2, tostring(i))--.." fps")--쳣
			end	
			b_wnd_ex.set_items(top,w1_page_encode.wnd.t_frame.id+stream_type,rate_list2,redraw)
		end
		local numi =#iframe_list2
		if numi>1 then
			b_wnd_ex.set_items(top,w1_page_encode.wnd.t_iframe.id+stream_type,iframe_list2,redraw)
		else
			for i= 1,30 do
				table.insert(iframe_list2, tostring(i))
			end	
			b_wnd_ex.set_items(top,w1_page_encode.wnd.t_iframe.id+stream_type,iframe_list2,redraw)
		end
	
		local rate = tostring(current_rate)
		local flag =false;
	
		local rate_num =#rate_list2
		for i=1,rate_num do
			if(rate == rate_list2[i])then
				flag =true;
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_frame.id+stream_type,i-1,redraw)
			end
		end
		if(false ==flag)then
			if(0 < rate_num)then
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_frame.id+stream_type,rate_num-1,redraw)
			else
				print("--lua---frame_rate---")						--"1 fps"					
				b_wnd_ex.set_text(top, w1_page_encode.wnd.t_frame.id+stream_type,"1",redraw)--쳣ֵ
			end
		end
	
		local irate = tostring(current_irate)
		local iflag =false;
		local irate_num =#iframe_list2
		for i=1,irate_num do
			if(irate == iframe_list2[i])then
				iflag =true;
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_iframe.id+stream_type,i-1,redraw)
			end
		end
		if(false ==iflag)then
			if(0 < irate_num)then
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_iframe.id+stream_type,irate_num-1,redraw)
			else
				print("--lua---iframe_rate---")											
				b_wnd_ex.set_text(top, w1_page_encode.wnd.t_iframe.id+stream_type,"1",redraw)--쳣ֵ
			end
		end
	end
end

local bit_rate= function(top,cfgdata,current_encodetype,chn,stream_type,current_resolu,current_bitrate,redraw)
	local min_bit1 =0;
	local max_bit1 =0;
	if(stream_type == 0)then
		for i =1,cfgdata['limits'][chn]['limit_v1']['limit_num'] do 
			local list = "limit_list"..tostring(i)
			local enctype = cfgdata['limits'][chn]['limit_v1'][list]['enc_type']		
			if(enctype == current_encodetype)then
				local resolu =cfgdata['limits'][chn]['limit_v1'][list]['width'].."x"..cfgdata['limits'][chn]['limit_v1'][list]['height']
				if(current_resolu == resolu)then
					min_bit1 = cfgdata['limits'][chn]['limit_v1'][list]['min_bit'];
					max_bit1 = cfgdata['limits'][chn]['limit_v1'][list]['max_bit'];		
				end
			end
		end
		
		for i =1,#BITRATE do
			BITRATE[i] = nil;
		end
	else
		for i =1,cfgdata['limits'][chn]['limit_v2']['limit_num'] do 
			local list = "limit_list"..tostring(i)
			local enctype = cfgdata['limits'][chn]['limit_v2'][list]['enc_type']
			if(enctype == current_encodetype)then
				local resolu =cfgdata['limits'][chn]['limit_v2'][list]['width'].."x"..cfgdata['limits'][chn]['limit_v2'][list]['height']
				if(current_resolu == resolu)then
					min_bit1 = cfgdata['limits'][chn]['limit_v2'][list]['min_bit'];
					max_bit1 = cfgdata['limits'][chn]['limit_v2'][list]['max_bit'];		
				end
			end
		end
		
		for i =1,#BITRATE2 do
			BITRATE2[i] = nil;
		end
	end
--	b_wnd_ex.set_text(top,w1_page_encode.wnd.cap_bitrate.id,STR('LA_BITRATE').."("..min_bit1.."-"..max_bit1..")",redraw);
	local k = 2;
	local mindix =0;
	local maxdix =0;

	if(0 == max_bit1)then--쳣
		max_bit1 =4096
		print("----lua_bit_rate----max_bit1 =0 ----")
	end
	if(0 == stream_type)then
		for i=1,#BITRATE_RANGE do
			if(min_bit1 >= tonumber(BITRATE_RANGE[i]))then --ҵһСֵλ
				mindix = i;
			end
			
			if(max_bit1 > tonumber(BITRATE_RANGE[i]))then --ҵһֵλ
				maxdix = i;
			else
				break;
			end			
		end
		
		BITRATE[1]     =  tostring(min_bit1)--.."kbps";	
	else
		for i=1,#BITRATE_RANGE_2 do
			if(min_bit1 >= tonumber(BITRATE_RANGE_2[i]))then --ҵһСֵλ
				mindix = i;
			end
			
			if(max_bit1 > tonumber(BITRATE_RANGE_2[i]))then --ҵһֵλ
				maxdix = i;
			else
				break;
			end			
		end
		
		BITRATE2[1]     =  tostring(min_bit1)--.."kbps";	
	end
	if(0 == maxdix)then --ȡʧܴӡ
		print("encode_type: "..current_encodetype.."--chn: "..chn.."--current_resolu: "..current_resolu);
	end
	
	local bit = 0;
	if(0 == stream_type)then
		for j= mindix+1,maxdix do
			BITRATE[k] = tostring(BITRATE_RANGE[j])--.."kbps";
			k= k+1;
		end
		bit = cfgdata['encode'][chn]['stream1']['v1_bitrate']
		maxdix = #BITRATE;
		BITRATE[maxdix+1] = tostring(max_bit1)--.."kbps";
		
		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_bitrate.id+stream_type,BITRATE,redraw)
	else
		for j= mindix+1,maxdix do
			BITRATE2[k] = tostring(BITRATE_RANGE_2[j])
			k= k+1;
		end
		bit = cfgdata['encode'][chn]['stream2']['v2_bitrate']
		maxdix = #BITRATE2;
		BITRATE2[maxdix+1] = tostring(max_bit1)
		
		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_bitrate.id+stream_type,BITRATE2,redraw)
	end
	
	--ǰûõֵµȡֵΧڣ ҪָΪĬ
	if(0 == stream_type)then
		local end_idx = #BITRATE;
		if (current_bitrate >= tonumber(BITRATE[1]) and current_bitrate <= tonumber(BITRATE[end_idx])) then
			bit = current_bitrate;
		end
	else
		local end_idx = #BITRATE2;
		if (current_bitrate >= tonumber(BITRATE2[1]) and current_bitrate <= tonumber(BITRATE2[end_idx])) then
			bit = current_bitrate;
		end
	end
	
	--b_wnd_ex.set_text(top, w1_page_encode.wnd.t_bitrate.id,bit,redraw)
	b_wnd_ex.set_value(top, w1_page_encode.wnd.t_bitrate.id+stream_type,tonumber(bit),redraw)
end

local bitrate_type= function(top,cfgdata,chn,stream_type,current_ratetype,redraw)	
	 b_wnd_ex.set_items(top,w1_page_encode.wnd.t_bittype.id+stream_type,type_list,redraw)
	if(current_ratetype > 0)then
		b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_bittype.id+stream_type,current_ratetype-1,redraw)
	else
		print("--lua---bitrate_type-----")
		b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_bittype.id+stream_type,0,redraw)--쳣ֵ
	end
end

local encode_type = function(top,cfgdata,current_encodetype,chn,stream_type,redraw)
	local enc_type_limit = 0;
	if (stream_type == 0) then
		enc_type_limit = cfgdata['limits'][chn]['limit_v1'].enc_type_limit;
	else
		enc_type_limit = cfgdata['limits'][chn]['limit_v2'].enc_type_limit;
	end
		
	local encodetype_item ={};		
	if (enc_type_limit == 1) then
		table.insert(encodetype_item, "H264");
	elseif(enc_type_limit == 2) then
		table.insert(encodetype_item, "H265");
	elseif(enc_type_limit == 3) then
		table.insert(encodetype_item, "H264");
		table.insert(encodetype_item, "H265");
	elseif(enc_type_limit == 4) then
		table.insert(encodetype_item, "MJPEG");
	elseif(enc_type_limit == 5) then
		table.insert(encodetype_item, "H264");
		table.insert(encodetype_item, "MJPEG");
	elseif(enc_type_limit == 6) then
		table.insert(encodetype_item, "H265");
		table.insert(encodetype_item, "MJPEG");
	elseif(enc_type_limit == 7) then
		table.insert(encodetype_item, "H264");	
		table.insert(encodetype_item, "H265");	
		table.insert(encodetype_item, "MJPEG");	
	end	
	
	b_wnd_ex.set_items(top,w1_page_encode.wnd.t_enc_type.id+stream_type,encodetype_item,redraw)	
	if (enc_type_limit ~= 0) then
		local  len = #encodetype_item;
		if (len == 1) then
			b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_enc_type.id+stream_type,0,redraw)
		elseif(len == 2) then	
			if (current_encodetype == 3) then
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_enc_type.id+stream_type,1,redraw)
			else
				b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_enc_type.id+stream_type,current_encodetype-1,redraw)
			end
		elseif(len == 3) then
			b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_enc_type.id+stream_type,current_encodetype-1,redraw)
		end
	end
end

local audiocode_type = function (top,cfgdata,current_audiotype,chn,stream_type,redraw)
	local enctype_audio = nil;
	if ( enc_audiotype2 == 1) then
		enctype_audio = {"G711A"}
		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_audio_type.id+stream_type,enctype_audio,redraw)
		b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,0,redraw)
	elseif( enc_audiotype2 == 2 ) then
		enctype_audio = {"G711U"}
		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_audio_type.id+stream_type,enctype_audio,redraw)
		b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,0,redraw)
	elseif( enc_audiotype2 == 3 ) then
		enctype_audio = {"G711A","G711U"}
		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_audio_type.id+stream_type,enctype_audio,redraw)
		if current_audiotype==102 then
			b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,0,redraw)
		else
			b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,1,redraw)
		end
	elseif( enc_audiotype2 == 7 ) then	
		enctype_audio = {"G711A","G711U","NONE"}
		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_audio_type.id+stream_type,enctype_audio,redraw)
		if current_audiotype==102 then
			b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,0,redraw)
		elseif(current_audiotype==103) then
			b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,1,redraw)
		else
			b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,2,redraw)
		end
	elseif( enc_audiotype2 == 5 ) then
		enctype_audio = {"G711A","NONE"}
		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_audio_type.id+stream_type,enctype_audio,redraw)
		if current_audiotype==103 then
			b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,0,redraw)
		else
			b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,1,redraw)
		end
	elseif( enc_audiotype2 == 6 ) then
		enctype_audio = {"G711U","NONE"}
		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_audio_type.id+stream_type,enctype_audio,redraw)
		if current_audiotype==103 then
			b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,0,redraw)
		else
			b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,1,redraw)
		end
	else
		enctype_audio = {"NONE"}
		b_wnd_ex.set_items(top,w1_page_encode.wnd.t_audio_type.id+stream_type,enctype_audio,redraw)
		b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_audio_type.id+stream_type,0,redraw)
	end
end

local refresh_encode = function (top,cfgdata,flag,chn,idx,stream_type)
	--жǷܱ
	local c_wnd = w1_page_encode.wnd
	if flag.is_wifi == 1 then
		b_wnd_ex.set_disable (top, c_wnd.t_res.id+stream_type, true, false)	
		b_wnd_ex.set_disable (top, c_wnd.t_quality.id+stream_type, true, false)	
		b_wnd_ex.set_disable (top, c_wnd.t_frame.id+stream_type, true, false)
		b_wnd_ex.set_disable (top, c_wnd.t_iframe.id+stream_type, true, false)
		b_wnd_ex.set_disable (top, c_wnd.t_bitrate.id+stream_type, true, false)
		b_wnd_ex.set_disable (top, c_wnd.t_bittype.id+stream_type, true, false)
		b_wnd_ex.set_disable (top, c_wnd.t_enc_type.id+stream_type, true, false)
		b_wnd_ex.set_disable (top, c_wnd.t_audio_type.id+stream_type, true, false)
	else
		b_wnd_ex.set_disable (top, c_wnd.t_res.id+stream_type, false, false)	
		b_wnd_ex.set_disable (top, c_wnd.t_quality.id+stream_type, false, false)	
		b_wnd_ex.set_disable (top, c_wnd.t_frame.id+stream_type, false, false)
		b_wnd_ex.set_disable (top, c_wnd.t_iframe.id+stream_type, false, false)
		b_wnd_ex.set_disable (top, c_wnd.t_bitrate.id+stream_type, false, false)
		b_wnd_ex.set_disable (top, c_wnd.t_bittype.id+stream_type, false, false)
		b_wnd_ex.set_disable (top, c_wnd.t_enc_type.id+stream_type, false, false)
		b_wnd_ex.set_disable (top, c_wnd.t_audio_type.id+stream_type, false, false)
	end
	local enc_smart_cap = cfgdata.limits[chn].limit_v1.SmartEnc_CAP
	local show_smart = true;
	if enc_smart_cap == 1 and flag.is_wifi~=1 then
		show_smart = false
		b_wnd_ex.set_disable (top, c_wnd.t_enable.id, false, false)
	end
	b_wnd_ex.set_hide(top,w1_page_encode.wnd.cap_enable.id,show_smart,false)
	b_wnd_ex.set_hide(top,w1_page_encode.wnd.t_enable.id,show_smart,false)
	--  ȡǰֵ
	b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_channel.id,idx-1,false)
	--	stream_type  =b_wnd_ex.get_sel(top, c_wnd.t_id.id);
	local resolu = nil;
	
	if(stream_type == 0)then	
	--	enc_vsize = 	cfgdata['encode'][chn]['stream1']['v1_vsize']
		--ǰˢлֱ/ͣʵˢµǰΪǰӦлǷ񳬷ΧǷ	
		if((nil == change_resolution)and(nil == change_encode_type))then
			local cur_chdata = cfgdata.encode[chn].stream1;
			enc_width 	= 	cur_chdata.v1_width;
			enc_height 	= 	cur_chdata.v1_height;
			enc_type 	= 	cur_chdata.v1_enctype;
			enc_audiotype = cur_chdata.v1_audio_enctype;
			enc_framerate = cur_chdata.v1_framerate;
			enc_level 	= 	cur_chdata.v1_level;
			enc_ratetype =  cur_chdata.v1_ratetype;
			enc_quality = 	cur_chdata.v1_quality;
			enc_bitrate = 	cur_chdata.v1_bitrate;
			enc_iframe_interval = cur_chdata.v1_iframe_interval;
			enc_enable  =   cur_chdata.v1_smart_encode;
			enc_id		= 	cur_chdata.v1_id;
			resolu = enc_width.."x"..enc_height;
		else
			resolu = b_wnd_ex.get_text(top, c_wnd.t_res.id);
			local enc_type_txt = b_wnd_ex.get_text(top, c_wnd.t_enc_type.id);
			if (enc_type_txt == "H264") then
				enc_type = 1;
			elseif(enc_type_txt == "H265") then
				enc_type = 2;
			else
				enc_type = 3;
			end
			local audio_text = b_wnd_ex.get_text(top, c_wnd.t_audio_type.id);
			if (audio_text == 'G711A') then
				enc_audiotype = 102
			elseif(audio_text == 'G711U') then
				enc_audiotype = 103
			else
				enc_audiotype = 109
			end
			
			enc_ratetype =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_bittype.id)+1;
			enc_quality =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_quality.id)+1;
			
			enc_enable = b_wnd_ex.get_check(top, w1_page_encode.wnd.t_enable.id);
			local rate_idx =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_frame.id);	
			enc_framerate =tonumber(rate_list[rate_idx+1]);--tonumber(string.sub(tostring(rate_list[rate_idx+1]),1,-4));
									
			local iframe_idx =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_iframe.id);	
			enc_iframe_interval =tonumber(iframe_list[iframe_idx+1]);
			
			local bitrate_str = b_wnd_ex.get_text(top, w1_page_encode.wnd.t_bitrate.id);
			enc_bitrate = tonumber(bitrate_str);--tonumber(string.sub(tostring(bitrate_str),1,-5));
		end
		
		
	else			
		--[[b_wnd_ex.set_hide(top,w1_page_encode.wnd.cap_enable.id,true,false)
		b_wnd_ex.set_hide(top,w1_page_encode.wnd.t_enable.id,true,false)--]]
		if((nil == change_resolution)and(nil == change_encode_type))then
			local cur_chdata = cfgdata.encode[chn].stream2;
			enc_width = cur_chdata.v2_width;
			enc_height = cur_chdata.v2_height;
			enc_type = cur_chdata.v2_enctype;
			enc_audiotype = cur_chdata.v2_audio_enctype;
			enc_framerate = cur_chdata.v2_framerate;
			enc_level = cur_chdata.v2_level;
			enc_ratetype = cur_chdata.v2_ratetype;
			enc_quality = cur_chdata.v2_quality;
			enc_bitrate = cur_chdata.v2_bitrate;
			enc_iframe_interval = cur_chdata.v2_iframe_interval;
			enc_id = cur_chdata.v2_id;
			resolu = enc_width.."x"..enc_height;
		else
			resolu = b_wnd_ex.get_text(top, c_wnd.t_res.id+stream_type);
			local enc_type_txt = b_wnd_ex.get_text(top, c_wnd.t_enc_type.id+stream_type);
			enc_type = 1;
			if(enc_type_txt == "H265") then
				enc_type = 2;
			elseif(enc_type_txt == "MJPEG")then
				enc_type = 3;
			end				
			
			enc_ratetype =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_bittype.id+stream_type)+1;
			enc_quality =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_quality.id+stream_type)+1;
			local audio_text = b_wnd_ex.get_text(top, c_wnd.t_audio_type.id+stream_type);
			if (audio_text == 'G711A') then
				enc_audiotype = 102
			elseif(audio_text == 'G711U') then
				enc_audiotype = 103
			else
				enc_audiotype = 109
			end
			
			local rate_idx =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_frame.id+stream_type);	
			enc_framerate =tonumber((rate_list2[rate_idx+1]))--tonumber(string.sub(tostring(rate_list2[rate_idx+1]),1,-4));
			
			local iframe_idx =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_iframe.id+stream_type);	
			enc_iframe_interval =tonumber(iframe_list2[iframe_idx+1]);
			
			local bitrate_str = b_wnd_ex.get_text(top, w1_page_encode.wnd.t_bitrate.id+stream_type);
			enc_bitrate = tonumber(bitrate_str)--tonumber(string.sub(tostring(bitrate_str),1,-5));
		end			
		
		
	end		

--ȡõǰֵ
----------------------------------------------------------------------------------
	
	if(nil == resolu)then
		resolu = "960x576";
	end
	resolution(top,cfgdata,enc_type,chn,stream_type,resolu,false)
	encode_type(top,cfgdata,enc_type,chn,stream_type,false)
	audiocode_type(top,cfgdata,enc_audiotype,chn,stream_type,false)
	frame_rate(top,cfgdata,enc_type,chn,stream_type,resolu,enc_framerate,enc_iframe_interval,false)
	bit_rate(top,cfgdata,enc_type,chn,stream_type,resolu,enc_bitrate,false)

	
	
	bitrate_type(top,cfgdata,chn,stream_type,enc_ratetype,false)		
	quality(top,cfgdata,chn,stream_type,enc_quality,false)
	
	b_wnd_ex.set_disable (top, c_wnd.t_channel.id, false, false)
--		b_wnd_ex.set_disable (top, c_wnd.t_id.id, false, false)
	
	if (stream_type==0)then
		if (enc_enable)then
			b_wnd_ex.set_check(top,w1_page_encode.wnd.t_enable.id,true,false)
			b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_bittype.id,1,false)
			enc_ratetype = 2;
		else
			b_wnd_ex.set_check(top,w1_page_encode.wnd.t_enable.id,false,false)
		end
	end
	
	channel = b_wnd_ex.get_text(top, c_wnd.t_channel.id);
	local rtsp = w1_page_encode.data.camera_bind
	local camera_num = rtsp.camera_num;
	local idx_id = 1;
	for j=1,camera_num do
		if rtsp['idx'..j].channel_id == tonumber(channel) then
			idx_id = j;
			break;
		end
	end
	local res_x = b_wnd.get_wnd_a_rect(top, c_wnd.cap_res.id);
	local sid = c_wnd.t_enc_type.id+stream_type;
	local eid = c_wnd.t_enable.id;
--	if(tonumber(rtsp['idx'..idx_id].protocol) >100) then
--		for i=sid,eid,3 do
--		b_wnd_ex.set_disable (top,i,true,false)
--		end
--		rtsp_flag = true;
--	else
		if  flag.is_wifi~=1 then
			for i=sid,eid,3 do
				b_wnd_ex.set_disable (top,i,false,false)
			end
			if stream_type==0 then
				if enc_enable then
					b_wnd_ex.set_disable (top, c_wnd.t_iframe.id, true, false)
					b_wnd_ex.set_disable (top, c_wnd.t_bittype.id, true, false)
					b_wnd_ex.set_disable (top, c_wnd.t_quality.id, true, false)
				else
					b_wnd_ex.set_disable (top, c_wnd.t_iframe.id, false, false)
					b_wnd_ex.set_disable (top, c_wnd.t_bittype.id, false, false)
					b_wnd_ex.set_disable (top, c_wnd.t_quality.id, false, false)
				end
			end	
			if(1 == enc_ratetype)then
				b_wnd_ex.set_disable (top, w1_page_encode.wnd.t_quality.id+stream_type, true, false);
				b_wnd_ex.set_text(top,w1_page_encode.wnd.t_quality.id+stream_type,'',false)
			elseif enc_enable==false then 
				b_wnd_ex.set_disable (top, w1_page_encode.wnd.t_quality.id+stream_type, false, false);
			end
			--ЭƵi֡
			local move_h = SIZE('s_encode_page_4_1')[2]-SIZE('s_encode_page_3_1')[2]
			--onviflocalЭ ֧ƵI֡
			if((tonumber(rtsp['idx'..idx_id].protocol) == 1 or tonumber(rtsp['idx'..idx_id].protocol) == 3) ) then	
				b_wnd_ex.set_hide(top,c_wnd.cap_audio_type.id,true,false)
				b_wnd_ex.set_hide(top,c_wnd.t_audio_type.id+stream_type,true,false)
				b_wnd_ex.set_hide(top,c_wnd.cap_iframe.id,true,false)
				b_wnd_ex.set_hide(top,c_wnd.t_iframe.id+stream_type,true,false)
				if SIZE('s_cfg_page_6_1')[2]==res_x[2] then
					local s_id = c_wnd.cap_res.id
					local e_id = c_wnd.t_enable.id
					for i=s_id,e_id do
						local pos = b_wnd.get_wnd_a_rect(top, i);
						if i>=c_wnd.cap_bittype.id then
							b_wnd_ex.move_pos(top,i,{pos[1],pos[2]-move_h*2},false)
						else
							b_wnd_ex.move_pos(top,i,{pos[1],pos[2]-move_h},false)
						end	
					end
				end	
			elseif((tonumber(rtsp['idx'..idx_id].protocol) > 1 and tonumber(rtsp['idx'..idx_id].protocol) ~= 3)and SIZE('s_cfg_page_5_1')[2]==res_x[2]) then
				b_wnd_ex.set_hide(top,c_wnd.cap_audio_type.id,false,false)
				b_wnd_ex.set_hide(top,c_wnd.t_audio_type.id+stream_type,false,false)
				b_wnd_ex.set_hide(top,c_wnd.cap_iframe.id,false,false)
				b_wnd_ex.set_hide(top,c_wnd.t_iframe.id+stream_type,false,false)
				local s_id = c_wnd.cap_res.id
				local e_id = c_wnd.t_enable.id
				for i=s_id,e_id do
					local pos = b_wnd.get_wnd_a_rect(top, i);
					if i>=c_wnd.cap_bittype.id then
						b_wnd_ex.move_pos(top,i,{pos[1],pos[2]+move_h*2},false)
					else
						b_wnd_ex.move_pos(top,i,{pos[1],pos[2]+move_h},false)
					end	
				end
			end
--			rtsp_flag = false;
		end	
--	end
end
--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_encode.data = cfgdata;
	local c_wnd = w1_page_encode.wnd
	local channel = b_wnd_ex.get_text(top, c_wnd.t_channel.id);
	local chn = "channel"..channel
	local flag = cfgdata['encode'][chn];--ͨ
	local chn_idx=tonumber(channel);
	if(flag == nil)then
		for i= 1,channel_num do 
			if(flag == nil)then
				 chn = "channel"..tostring(i);
				 flag = cfgdata['encode'][chn];--ͨ
				 chn_idx =i
			else
				break;
			end
		end
	end

	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_list ={};
	local ch_prilist = privilege.channel_manager_list;
	for i= 1,channel_num do
		local ch = "channel"..i
		local ch_flag= nil;
		local ch_flag= cfgdata['encode'][ch];
		if(ch_flag ~= nil and ch_prilist[i] == 1)then
			table.insert(ch_list,i);
		end
	end
	local idx =chn_idx;
	if(0 ~= #ch_list)then
		b_wnd_ex.set_items(top, c_wnd.t_channel.id, ch_list, false);
		for i=1,#ch_list do  --ͨ,ȡǰͨӦ
			if(ch_list[i] == chn_idx)then
				idx=i;
			end
		end
	else
		b_wnd_ex.set_items(top, c_wnd.t_channel.id, ch_list, false);
	end
	
	b_wnd_ex.set_hide(top,w1_page_encode.wnd.rtsp_tip.id,true,false);
	local sid = c_wnd.hline.id;
	local eid = c_wnd.t_enable.id;
	if((flag ~= nil) and (0 ~= #ch_list))then	
		for i=sid,eid do
		b_wnd_ex.set_hide(top,i,false,false)
		end
		refresh_encode(top,cfgdata,flag,chn,idx,0)
		refresh_encode(top,cfgdata,flag,chn,idx,1)	
		change_encode_type =nil;
		change_resolution =nil;
	else
		for i=sid,eid do
		b_wnd_ex.set_hide(top,i,true,false)
		end
	end
	if (false ~= redraw) then
		b_dlg.dlg_set_redraw(top)
	end
	
	redraw =false
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local channel = b_wnd_ex.get_text(top, w1_page_encode.wnd.t_channel.id);
	local chn = "channel"..channel
	local save_encode = function (top,cfgdata,chn,stream)
		local res_idx =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_res.id+stream);
		local quality_idx =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_quality.id+stream);
		local rate_idx =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_frame.id+stream);
		local irate_idx=b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_iframe.id+stream);
		local bitrate_idx =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_bitrate.id+stream);
		local bitrate_str = b_wnd_ex.get_text(top, w1_page_encode.wnd.t_bitrate.id+stream);
		local ratetype_idx =b_wnd_ex.get_sel(top, w1_page_encode.wnd.t_bittype.id+stream);
		local enable_smart =b_wnd_ex.get_check(top, w1_page_encode.wnd.t_enable.id);
		local enc_type_txt = b_wnd_ex.get_text(top, w1_page_encode.wnd.t_enc_type.id+stream);
		local encodetype = 1;
		if(enc_type_txt == "H265") then
			encodetype = 2;
		elseif(enc_type_txt == "MJPEG")then
			encodetype = 3;
		end
		encodetype = encodetype - 1;			
		local encodeaudio = b_wnd_ex.get_text(top,w1_page_encode.wnd.t_audio_type.id+stream);
		local bitrate_s = tonumber(bitrate_str)--tonumber(string.sub(tostring(bitrate_str),1,-5));
		local chn = "channel"..channel
		local flag = cfgdata['encode'][chn];--ͨ
		for i= 1,channel_num do 
			if(flag == nil)then
				 chn = "channel"..tostring(i);
				 flag = cfgdata['encode'][chn];--ͨ
			else
				break;
			end
		end
		if(flag ~= nil)then
			if(0 == stream)then
				local rate =tonumber(rate_list[rate_idx+1])--tonumber(string.sub(tostring(rate_list[rate_idx+1]),1,-4));
				local bitrate =tonumber(BITRATE[bitrate_idx+1])--tonumber(string.sub(tostring(BITRATE[bitrate_idx+1]),1,-5));
				local irate = tonumber(iframe_list[irate_idx+1])
				cfgdata['encode'][chn]['stream1']['v1_vsize'] = vsize_list[res_idx+1]
				cfgdata['encode'][chn]['stream1']['v1_width'] = width_list[res_idx+1]
				cfgdata['encode'][chn]['stream1']['v1_height'] =height_list[res_idx+1]
				cfgdata['encode'][chn]['stream1']['v1_framerate'] =rate
				cfgdata['encode'][chn]['stream1']['v1_iframe_interval'] = irate
			--	cfgdata['encode'][chn]['stream1']['enctype']
			--	cfgdata['encode'][chn]['stream1']['level']
				cfgdata['encode'][chn]['stream1']['v1_ratetype'] =ratetype_idx+1
				cfgdata['encode'][chn]['stream1']['v1_quality'] =quality_idx+1;--quality_list[quality_idx+1]
				cfgdata['encode'][chn]['stream1']['v1_bitrate'] =bitrate_s
				cfgdata['encode'][chn]['stream1']['v1_enctype'] = encodetype+1
						
				if (encodeaudio == 'G711A') then
					cfgdata['encode'][chn]['stream1']['v1_audio_enctype'] = 102
				elseif(encodeaudio == 'G711U') then
					cfgdata['encode'][chn]['stream1']['v1_audio_enctype'] = 103
				else
					cfgdata['encode'][chn]['stream1']['v1_audio_enctype'] = 109
				end
				
				cfgdata['encode'][chn]['stream1']['v1_smart_encode'] = enable_smart;
			else
				local rate =tonumber(rate_list2[rate_idx+1])--tonumber(string.sub(tostring(rate_list2[rate_idx+1]),1,-4));
				local bitrate =tonumber(BITRATE2[bitrate_idx+1])--tonumber(string.sub(tostring(BITRATE2[bitrate_idx+1]),1,-5));
				local irate = tonumber(iframe_list2[irate_idx+1])
				cfgdata['encode'][chn]['stream2']['v2_vsize'] = vsize_list2[res_idx+1]
				cfgdata['encode'][chn]['stream2']['v2_width'] = width_list2[res_idx+1]
				cfgdata['encode'][chn]['stream2']['v2_height'] =height_list2[res_idx+1]
				cfgdata['encode'][chn]['stream2']['v2_framerate'] =rate
				cfgdata['encode'][chn]['stream2']['v2_iframe_interval'] = irate
			--	cfgdata['encode'][chn]['stream2']['enctype']
			--	cfgdata['encode'][chn]['stream2']['level']
				cfgdata['encode'][chn]['stream2']['v2_ratetype'] =ratetype_idx+1
				cfgdata['encode'][chn]['stream2']['v2_quality'] =quality_idx+1;--[quality_idx]
				cfgdata['encode'][chn]['stream2']['v2_bitrate'] =bitrate_s
				cfgdata['encode'][chn]['stream2']['v2_enctype'] = encodetype+1
				if (encodeaudio == 'G711A') then
					cfgdata['encode'][chn]['stream2']['v2_audio_enctype'] = 102
				elseif(encodeaudio == 'G711U') then
					cfgdata['encode'][chn]['stream2']['v2_audio_enctype'] = 103
				else
					cfgdata['encode'][chn]['stream2']['v2_audio_enctype'] = 109
				end
			end
			cfgdata['encode'][chn]['change_flag'] =1;
		end
	
	end
	save_encode(top,cfgdata,chn,0)	
	save_encode(top,cfgdata,chn,1)	
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_encode.init = function(top)
	w1_wnd_util.cfgtab = {'encode','encode_limits','camera_bind'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_encode.timer_start = function()
	w1_page_encode.timestart = true
end

w1_page_encode.timer_stop = function(top)
	w1_page_encode.timestart = false
	w1_wnd_util.tipclear(top, w1_page_encode.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_encode.timerenevt = function(top)
	if(w1_page_encode.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_encode.wnd.tipinfo.id)
	end
	return 0
end

local on_reso_change = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		change_resolution = 1;
		redraw =true;
		w1_wnd_util.cfgtab = {'encode','encode_limits','camera_bind'}
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_init(top)
		
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	
	return 0;
end

local on_encodetype_change = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		change_encode_type = 1;
		redraw =true;
		w1_wnd_util.cfgtab = {'encode','encode_limits','camera_bind'}
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_init(top)
		
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_audiotype_change = function (top ,win_id ,vmsg,x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then

		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_streamchange = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		redraw =true;
		w1_wnd_util.cfgtab = {'encode','encode_limits','camera_bind'}
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_init(top)
	end
	return 0;
end

local on_channel = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		redraw =true;
		w1_wnd_util.cfgtab = {'encode','encode_limits','camera_bind'}
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_init(top)
	end
	return 0;
end

local set_quality_item = function (top,stream)
	local c_wnd = w1_page_encode.wnd
	local chn = b_wnd_ex.get_text(top,c_wnd.t_channel.id)
	local cur_chdata = w1_page_encode.data.encode["channel"..chn]["stream"..tostring(1+stream)];
	local idx = 0
	if stream==0 then
		idx = cur_chdata.v1_quality
	else
		idx = cur_chdata.v2_quality
	end
	local QUALITY_RANGE ={};
	table.insert(QUALITY_RANGE,STR('LA_LOWEST'))
	table.insert(QUALITY_RANGE,STR('LA_LOWER'))
	table.insert(QUALITY_RANGE,STR('LA_LOW_T'))
	table.insert(QUALITY_RANGE,STR('LA_MEDIUM_T'))
	table.insert(QUALITY_RANGE,STR('LA_HIGH_T'))
	table.insert(QUALITY_RANGE,STR('LA_HIGHER'))
	table.insert(QUALITY_RANGE,STR('LA_HIGHEST'))
	b_wnd_ex.set_items(top,w1_page_encode.wnd.t_quality.id+stream,QUALITY_RANGE,true)
	b_wnd_ex.set_sel(top,w1_page_encode.wnd.t_quality.id+stream,idx-1,true)
end

local on_bittype = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local bittype = b_wnd_ex.get_sel(top, win_id)
		local stream  = win_id-w1_page_encode.wnd.t_bittype.id 
		local c_wnd = w1_page_encode.wnd
		if(0 == bittype)then
			b_wnd_ex.set_disable (top, w1_page_encode.wnd.t_quality.id+stream, true, true);
			b_wnd_ex.set_text (top, w1_page_encode.wnd.t_quality.id+stream, '', true);
		else
			set_quality_item(top,stream)
			b_wnd_ex.set_disable (top, w1_page_encode.wnd.t_quality.id+stream, false, true);
			
		end
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_bitrate = function (top, win_id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		local cfgdata =w1_page_encode.data;
		local min_bit1 =0;
		local max_bit1 =0;
		local stream_type  = win_id - w1_page_encode.wnd.t_bitrate.id
		local enc_type_txt = b_wnd_ex.get_text(top, w1_page_encode.wnd.t_enc_type.id+stream_type);	
		local current_encodetype = 1;
		if(enc_type_txt == "H265") then
			current_encodetype = 2;
		elseif(enc_type_txt == "MJPEG")then
			current_encodetype = 3;
		end		
		local current_resolu = b_wnd_ex.get_text(top, w1_page_encode.wnd.t_res.id+stream_type);
		local channel = b_wnd_ex.get_text(top, w1_page_encode.wnd.t_channel.id);
		local chn = "channel"..channel
		local bitrate_str = b_wnd_ex.get_text(top, win_id);
		if(stream_type == 0)then
			for i =1,cfgdata['limits'][chn]['limit_v1']['limit_num'] do 
				local list = "limit_list"..tostring(i)
				local enctype = cfgdata['limits'][chn]['limit_v1'][list]['enc_type']		
				if(enctype == current_encodetype)then
					local resolu =cfgdata['limits'][chn]['limit_v1'][list]['width'].."x"..cfgdata['limits'][chn]['limit_v1'][list]['height']
					if(current_resolu == resolu)then
						min_bit1 = cfgdata['limits'][chn]['limit_v1'][list]['min_bit'];
						max_bit1 = cfgdata['limits'][chn]['limit_v1'][list]['max_bit'];		
					end
				end
			end
		else
			for i =1,cfgdata['limits'][chn]['limit_v2']['limit_num'] do 
				local list = "limit_list"..tostring(i)
				local enctype = cfgdata['limits'][chn]['limit_v2'][list]['enc_type']
				if(enctype == current_encodetype)then
					local resolu =cfgdata['limits'][chn]['limit_v2'][list]['width'].."x"..cfgdata['limits'][chn]['limit_v2'][list]['height']
					if(current_resolu == resolu)then
						min_bit1 = cfgdata['limits'][chn]['limit_v2'][list]['min_bit'];
						max_bit1 = cfgdata['limits'][chn]['limit_v2'][list]['max_bit'];		
					end
				end
			end
		end
		if tonumber(bitrate_str)>max_bit1 then
			b_wnd_ex.set_value(top, win_id,tonumber(max_bit1),true)
		elseif tonumber(bitrate_str)< min_bit1 then
			b_wnd_ex.set_value(top, win_id,tonumber(min_bit1),true)
		end
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	
	return 0;
end
local copy_okfunc = function(param)
	local cwnd = w1_page_encode.wnd;
	local chid = tonumber(b_wnd_ex.get_text(param[1], cwnd.t_channel.id));
	if(chid == nil) then
		return 0;
	end
	local chsrc = w1_page_encode.data.encode['channel'..chid];
	local chdir = w1_page_encode.data.encode;
	local chlimit = w1_page_encode.data.limits
	
	local rtsp = w1_page_encode.data.camera_bind
	local camera_num = rtsp.camera_num;
	local idx_id = 1;
	for j=1,camera_num do
		if rtsp['idx'..j].channel_id == tonumber(chid) then
			idx_id = j;
			break;
		end
	end
	for i=1, #param[2] do
	
		if (chlimit['channel'..chid]['limit_v1']['SmartEnc_CAP'] == chlimit['channel'..param[2][i]]['limit_v1']['SmartEnc_CAP']) then
			chdir['channel'..param[2][i]]['stream1']['v1_smart_encode'] = chsrc['stream1']['v1_smart_encode']
		elseif chlimit['channel'..chid]['limit_v1']['SmartEnc_CAP'] ~= 1 then --ܱbitetype ΪCBRܱĿعرգܿ״̬bitetype״̬޷ơ
			if chsrc['stream1']['v1_ratetype']==1 then
				chdir['channel'..param[2][i]]['stream1']['v1_smart_encode'] = false--ܿصЧӦbitetype ޷
			end
		end
		chdir['channel'..param[2][i]]['stream1']['v1_vsize'] = chsrc['stream1']['v1_vsize']
		chdir['channel'..param[2][i]]['stream1']['v1_width'] = chsrc['stream1']['v1_width']
		chdir['channel'..param[2][i]]['stream1']['v1_height'] =chsrc['stream1']['v1_height']
		chdir['channel'..param[2][i]]['stream1']['v1_framerate'] =chsrc['stream1']['v1_framerate']
		chdir['channel'..param[2][i]]['stream1']['v1_ratetype'] =chsrc['stream1']['v1_ratetype']
		chdir['channel'..param[2][i]]['stream1']['v1_quality'] =chsrc['stream1']['v1_quality']
		chdir['channel'..param[2][i]]['stream1']['v1_bitrate'] =chsrc['stream1']['v1_bitrate']
		chdir['channel'..param[2][i]]['stream1']['v1_enctype'] = chsrc['stream1']['v1_enctype']
		if(tonumber(rtsp['idx'..idx_id].protocol) ~= 1 and tonumber(rtsp['idx'..idx_id].protocol) ~= 3)then		
			chdir['channel'..param[2][i]]['stream1']['v1_audio_enctype'] = chsrc['stream1']['v1_audio_enctype']
			chdir['channel'..param[2][i]]['stream1']['v1_iframe_interval'] = chsrc['stream1']['v1_iframe_interval']
		end
		
		
		chdir['channel'..param[2][i]]['stream2']['v2_vsize'] = chsrc['stream2']['v2_vsize']
		chdir['channel'..param[2][i]]['stream2']['v2_width'] = chsrc['stream2']['v2_width']
		chdir['channel'..param[2][i]]['stream2']['v2_height'] =chsrc['stream2']['v2_height']
		chdir['channel'..param[2][i]]['stream2']['v2_framerate'] =chsrc['stream2']['v2_framerate']
		chdir['channel'..param[2][i]]['stream2']['v2_ratetype'] =chsrc['stream2']['v2_ratetype']
		chdir['channel'..param[2][i]]['stream2']['v2_quality'] =chsrc['stream2']['v2_quality']
		chdir['channel'..param[2][i]]['stream2']['v2_bitrate'] =chsrc['stream2']['v2_bitrate']
		chdir['channel'..param[2][i]]['stream2']['v2_enctype'] = chsrc['stream2']['v2_enctype']
		if(tonumber(rtsp['idx'..idx_id].protocol) ~= 1 and tonumber(rtsp['idx'..idx_id].protocol) ~= 3)then		
			chdir['channel'..param[2][i]]['stream2']['v2_audio_enctype'] = chsrc['stream2']['v2_audio_enctype']
			chdir['channel'..param[2][i]]['stream2']['v2_iframe_interval'] = chsrc['stream2']['v2_iframe_interval']
		end
		chdir['channel'..param[2][i]].channel = param[2][i];
		chdir['channel'..param[2][i]]['change_flag'] =1;

	end
	return 0;
end

local on_copy = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_encode.wnd;
		--if rtsp_flag then --ΪrtspЭ飬򲻵
		--	b_wnd_ex.set_hide(top,cwnd.rtsp_tip.id,false,true);
		--	return 0;
		--end
		local param = {};
		local idx = 1;
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	--	uitousercfg(top, w1_page_encode.data)
		
		local privilege = global_val.get_allprivilege();--ȡȨ
		local ch_prilist = privilege.channel_manager_list;	
		for i=1, channel_num do
			if( i ~= chid and w1_page_encode.data.encode['channel'..i] ~= nil
				and ch_prilist[i] == 1 and w1_page_encode.data.encode['channel'..i].is_wifi == 0) then
				--local rtsp = w1_page_encode.data.camera_bind
				--local camera_num = rtsp.camera_num;
				--local idx_id = 1;
				--for j=1,camera_num do
				--	if rtsp['idx'..j].channel_id == i then
				--		idx_id = j;
				--		break;
				--	end
				--end
				--if(tonumber(rtsp['idx'..idx_id].protocol) >100) then
				
				--else
					param[idx] = i;
					idx =idx + 1;
				--end
			end
		end
		w1_copy.init();
		w1_copy.set_dlgattr(param);
		w1_copy.set_func (copy_okfunc,{top, w1_page_encode.copy_ch} );
		b_dlg.post_modal(top, w1_key.DLG_COPY, 0, 0, nil)
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_enable = function (top,win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK==vmsg then
		local c_wnd = w1_page_encode.wnd
		local redraw = true
		local check = b_wnd_ex.get_check(top, win_id)
		if check then
			b_wnd_ex.set_sel(top, w1_page_encode.wnd.t_bittype.id,1,redraw)
			set_quality_item(top,0)
			b_wnd_ex.set_disable (top, c_wnd.t_iframe.id, true, redraw)
			b_wnd_ex.set_disable (top, c_wnd.t_bittype.id, true, redraw)
			b_wnd_ex.set_disable (top, c_wnd.t_quality.id, true, redraw)
		else
			b_wnd_ex.set_disable (top, c_wnd.t_iframe.id, false, redraw)
			b_wnd_ex.set_disable (top, c_wnd.t_bittype.id, false, redraw)
			b_wnd_ex.set_disable (top, c_wnd.t_quality.id, false, redraw)
		end
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_encode.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	
	return ret;
end

w1_page_encode.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	local privilege = global_val.get_allprivilege();--ȡȨ
end

w1_page_encode.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'cap_channel', 't_channel', 'cap_id', 't_id','cap_enc_type','t_enc_type','cap_audio_type','t_audio_type', 
			'cap_res', 't_res', 'cap_frame', 't_frame', 'cap_bittype', 't_bittype','rtsp_tip','hline',
			'cap_bitrate', 't_bitrate', 'cap_quality', 't_quality','tipinfo',
			'copy', 'default', 'apply','cap_iframe','t_iframe','cap_enable','t_enable',
			't_id2','t_enc_type2','t_audio_type2','t_res2','t_frame2','t_iframe2','t_bittype2','t_bitrate2','t_quality2',},
			
	cap_channel	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+2,xywh='s_encode_page_1_1',items={},trans = false,channel_cbox = true,cmd = on_channel},	
	
	hline		= {t='hline',id=id+3,xywh='s_encode_hline_xywh'},
	
	cap_id		= {t='static',id=id+4,xywh='s_cfg_page_3_1',text='LA_STREAM_INFOR'},
	t_id 		= {t='static',id=id+5,xywh='s_encode_page_3_1',text='LA_MAIN_STREAM'},	
	t_id2 		= {t='static',id=id+6,xywh='s_encode_page_3_2',text='LA_SUBCODE_FLOW'},	

	cap_enc_type= {t='static',id=id+7,xywh='s_cfg_page_4_1',text='LA_VIDEO_ENCODE_TYPE'},
	t_enc_type 	= {t='combox',id=id+8,xywh='s_encode_page_4_1',items={},trans = false,cmd = on_encodetype_change},
	t_enc_type2 	= {t='combox',id=id+9,xywh='s_encode_page_4_2',items={},trans = false,cmd = on_encodetype_change},

	cap_audio_type= {t='static',id=id+10,xywh='s_cfg_page_5_1',text='LA_AUDIO_ENCODE_TYPE'},
	t_audio_type  = {t='combox',id=id+11,xywh='s_encode_page_5_1',items={},trans = false,cmd = on_audiotype_change},
	t_audio_type2  = {t='combox',id=id+12,xywh='s_encode_page_5_2',items={},trans = false,cmd = on_audiotype_change},	

	cap_res		= {t='static',id=id+13,xywh='s_cfg_page_6_1',text='LA_RESOLUTION'},
	t_res 		= {t='combox',id=id+14,xywh='s_encode_page_6_1',items={},trans = false, cmd = on_reso_change},	
	t_res2 		= {t='combox',id=id+15,xywh='s_encode_page_6_2',items={},trans = false, cmd = on_reso_change},	
	
	cap_frame	= {t='static',id=id+16,xywh='s_cfg_page_7_1',text='LA_FRAME_RATE'},
	t_frame 	= {t='combox',id=id+17,xywh='s_encode_page_7_1',items={},trans = false, cmd = on_update_param},	
	t_frame2	= {t='combox',id=id+18,xywh='s_encode_page_7_2',items={},trans = false, cmd = on_update_param},	
	
	cap_iframe	= {t='static',id=id+19,xywh='s_cfg_page_8_1',text='LA_I_FRAME_INTERVAL'},
	t_iframe 	= {t='combox',id=id+20,xywh='s_encode_page_8_1',items={},trans = false, cmd = on_update_param},
	t_iframe2 	= {t='combox',id=id+21,xywh='s_encode_page_8_2',items={},trans = false, cmd = on_update_param},
	
	
	cap_bittype	= {t='static',id=id+22,xywh='s_cfg_page_9_1',text='LA_BITRATE_TYPE'},
	t_bittype 	= {t='combox',id=id+23,xywh='s_encode_page_9_1',items={},trans = false,cmd = on_bittype},	
	t_bittype2 	= {t='combox',id=id+24,xywh='s_encode_page_9_2',items={},trans = false,cmd = on_bittype},
	
	cap_bitrate	= {t='static',id=id+25,xywh='s_cfg_page_10_1',text='LA_BITRATE'},
	t_bitrate 	= {t='combox_in',id=id+26,xywh='s_encode_page_10_1',items={},trans = false,dlg_key={1}, cmd = on_bitrate},	
	t_bitrate2 	= {t='combox_in',id=id+27,xywh='s_encode_page_10_2',items={},trans = false,dlg_key={1}, cmd = on_bitrate},	

	cap_quality	= {t='static',id=id+28,xywh='s_cfg_page_11_1',text='LA_QUALITY'},
	t_quality 	= {t='combox',id=id+29,xywh='s_encode_page_11_1',items={}, cmd = on_update_param},	
	t_quality2 	= {t='combox',id=id+30,xywh='s_encode_page_11_2',items={}, cmd = on_update_param},	
	
	cap_enable 	= {t='static',id=id+31,xywh='s_cfg_page_12_1',text='LA_INTELLIGENT_CODING'},
	t_enable 	= {t='tt_check', id=id+32,xywh='s_enable_xywh_11',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_enable},
	
	tipinfo		= {t='static',id=id+33,	xywh='s_encode_tipinfo',	text='',trans = false},	
	copy 	= {t='button',id=id+34,	xywh = 's_cfg_copy_xywh',	text='LA_COPY_TO',cmd=on_copy},
	apply 	= {t='button',id=id+35,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
	
	rtsp_tip   = {t='static',id=id+36,	xywh='s_encode_rtsp_tip',	text='LA_NOT_CONFIG',color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},	
}

return w1_page_encode

