--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.daynight_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_page_imagedaynight = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_imagedaynight.s_768 =
{
	s_cfg_page_imagedaynight_xywh = {53,366,746,220},
	s_imagedaynight_cap_mode_xywh = {10,0,154,35},
	s_imagedaynight_t_mode_xywh = {173,0,106,35},
	s_imagedaynight_cap_dn_transl_xywh = {10,42,154,35},
	s_imagedaynight_dn_transl_subb_xywh = {170,49,16,21},
	s_imagedaynight_t_dn_transl_xywh = {186,42,123,35},
	s_imagedaynight_dn_transl_add_xywh = {310,49,16,21},
	s_imagedaynight_dn_transl_value_xywh = {329,49,32,21},
	s_imagedaynight_cap_nd_transl_xywh = {10,85,154,35},
	s_imagedaynight_nd_transl_subb_xywh = {170,92,16,21},
	s_imagedaynight_t_nd_transl_xywh = {186,85,123,35},
	s_imagedaynight_nd_transl_add_xywh = {310,92,16,21},
	s_imagedaynight_nd_transl_value_xywh = {329,92,32,21},
	s_imagedaynight_cap_delay_xywh = {10,128,154,35},
	s_imagedaynight_delay_subb_xywh = {170,135,16,21},
	s_imagedaynight_t_delay_xywh = {186,128,123,35},
	s_imagedaynight_delay_add_xywh = {310,135,16,21},
	s_imagedaynight_delay_value_xywh = {329,135,32,21},
	s_imagedaynight_hline_xywh = {368,0,1,170},
	s_imagedaynight_check1_xywh = {378,0,26,35},
	s_imagedaynight_cap_infrared_xywh = {405,0,106,35},
	s_imagedaynight_t_infrared_xywh = {512,0,106,35},
	--	s_imagedaynight_cap_near_xywh = {405,42,106,35},
	--	s_imagedaynight_t_near_xywh = {384,42,106,35},
	s_imagedaynight_cap_strengh2_xywh = {384,42,106,35},
	s_imagedaynight_strengh2_subb_xywh = {512,49,16,21},
	s_imagedaynight_t_strengh2_xywh = {528,42,123,35},
	s_imagedaynight_strengh2_add_xywh = {651,49,16,21},
	s_imagedaynight_strengh2_value_xywh = {670,49,32,21},
	s_imagedaynight_cap_dtn_xywh = {10,42,154,35},
	s_imagedaynight_t_dtn_xywh = {173,49,106,35},
	s_imagedaynight_cap_ntd_xywh = {10,85,154,35},
	s_imagedaynight_t_ntd_xywh = {173,92,106,35},
};

w1_page_imagedaynight.s_1280 = 
{
	s_cfg_page_imagedaynight_xywh 		= {60,475,920,310},--980
	s_imagedaynight_cap_mode_xywh 		= {20,0,190,45},
	s_imagedaynight_t_mode_xywh			= {220,0,150,45},
	s_imagedaynight_cap_dn_transl_xywh 	= {20,60,190,45},
	s_imagedaynight_dn_transl_subb_xywh = {220,70,30,30},
	s_imagedaynight_t_dn_transl_xywh 	= {250,60,160,45},
	s_imagedaynight_dn_transl_add_xywh 	= {410,70,30,30},
	s_imagedaynight_dn_transl_value_xywh= {445,70,40,30},
	s_imagedaynight_cap_nd_transl_xywh 	= {20,120,190,45},
	s_imagedaynight_nd_transl_subb_xywh = {220,130,30,30},
	s_imagedaynight_t_nd_transl_xywh 	= {250,120,160,45},
	s_imagedaynight_nd_transl_add_xywh 	= {410,130,30,30},
	s_imagedaynight_nd_transl_value_xywh= {445,130,40,30},	
	s_imagedaynight_cap_delay_xywh 		= {20,180,190,45},
	s_imagedaynight_delay_subb_xywh		= {220,190,30,30},
	s_imagedaynight_t_delay_xywh 		= {250,180,160,45},
	s_imagedaynight_delay_add_xywh 		= {410,190,30,30},
	s_imagedaynight_delay_value_xywh 	= {445,190,40,30},
	s_imagedaynight_hline_xywh			= {495,0,1,240},
	s_imagedaynight_check1_xywh 		= {505,0,40,45},		
	s_imagedaynight_cap_infrared_xywh 	= {545,0,160,45},
	s_imagedaynight_t_infrared_xywh 	= {710,0,150,45},
--	s_imagedaynight_cap_near_xywh 		= {505,60,160,45},
--	s_imagedaynight_t_near_xywh 		= {710,60,150,45},
	s_imagedaynight_cap_strengh2_xywh	= {505,60,160,45},
	s_imagedaynight_strengh2_subb_xywh 	= {670,70,30,30},
	s_imagedaynight_t_strengh2_xywh 	= {700,60,160,45},
	s_imagedaynight_strengh2_add_xywh 	= {860,70,30,30},
	s_imagedaynight_strengh2_value_xywh	= {895,70,40,30},
	s_imagedaynight_cap_dtn_xywh		= {20,60,190,45},
	s_imagedaynight_t_dtn_xywh    		= {220,70,150,45},
	s_imagedaynight_cap_ntd_xywh		= {20,120,190,45},
	s_imagedaynight_t_ntd_xywh      	= {220,130,150,45},
};

w1_page_imagedaynight.s_1440 = 
{
	s_cfg_page_imagedaynight_xywh 		= {60,440,1000,245},
	s_imagedaynight_cap_mode_xywh 		= {20,0,195,45},
	s_imagedaynight_t_mode_xywh			= {225,0,150,45},
	s_imagedaynight_cap_dn_transl_xywh 	= {20,60,195,45},
	s_imagedaynight_dn_transl_subb_xywh = {220,70,30,30},
	s_imagedaynight_t_dn_transl_xywh 	= {250,60,160,45},
	s_imagedaynight_dn_transl_add_xywh 	= {410,70,30,30},
	s_imagedaynight_dn_transl_value_xywh= {445,70,40,30},
	s_imagedaynight_cap_nd_transl_xywh 	= {20,120,195,45},
	s_imagedaynight_nd_transl_subb_xywh = {220,130,30,30},
	s_imagedaynight_t_nd_transl_xywh 	= {250,120,160,45},
	s_imagedaynight_nd_transl_add_xywh 	= {410,130,30,30},
	s_imagedaynight_nd_transl_value_xywh= {445,130,40,30},
	s_imagedaynight_cap_delay_xywh 		= {20,180,195,45},
	s_imagedaynight_delay_subb_xywh		= {220,190,30,30},
	s_imagedaynight_t_delay_xywh 		= {250,180,160,45},
	s_imagedaynight_delay_add_xywh 		= {410,190,30,30},
	s_imagedaynight_delay_value_xywh 	= {445,190,40,30},
	s_imagedaynight_hline_xywh			= {495,0,1,240},
	s_imagedaynight_check1_xywh 		= {505,0,40,45},	
	s_imagedaynight_cap_infrared_xywh 	= {545,0,160,45},
	s_imagedaynight_t_infrared_xywh 	= {710,0,150,45},
--	s_imagedaynight_cap_near_xywh 		= {515,60,160,45},
--	s_imagedaynight_t_near_xywh 		= {710,60,150,45},
	s_imagedaynight_cap_strengh2_xywh	= {515,60,160,45},
	s_imagedaynight_strengh2_subb_xywh 	= {670,70,30,30},
	s_imagedaynight_t_strengh2_xywh 	= {700,60,160,45},
	s_imagedaynight_strengh2_add_xywh 	= {860,70,30,30},
	s_imagedaynight_strengh2_value_xywh	= {895,70,40,30},

	s_imagedaynight_cap_dtn_xywh		= {20,60,195,45},
	s_imagedaynight_t_dtn_xywh    		= {225,70,150,45},
	s_imagedaynight_cap_ntd_xywh		= {20,120,195,45},
	s_imagedaynight_t_ntd_xywh      	= {225,130,150,45},
};

w1_page_imagedaynight.s_1080p = 
{
	s_cfg_page_imagedaynight_xywh 		= {100,515,1400,310},
	s_imagedaynight_cap_mode_xywh 		= {20,0,290,50},
	s_imagedaynight_t_mode_xywh			= {325,0,200,50},
	s_imagedaynight_cap_dn_transl_xywh 	= {20,60,290,50},
	s_imagedaynight_dn_transl_subb_xywh = {320,70,30,30},
	s_imagedaynight_t_dn_transl_xywh 	= {350,60,232,50},
	s_imagedaynight_dn_transl_add_xywh 	= {582,70,30,30},
	s_imagedaynight_dn_transl_value_xywh= {618,70,60,30},
	s_imagedaynight_cap_nd_transl_xywh 	= {20,120,290,50},
	s_imagedaynight_nd_transl_subb_xywh = {320,130,30,30},
	s_imagedaynight_t_nd_transl_xywh 	= {350,120,232,50},
	s_imagedaynight_nd_transl_add_xywh 	= {582,130,30,30},
	s_imagedaynight_nd_transl_value_xywh= {618,130,60,30},
	s_imagedaynight_cap_delay_xywh 		= {20,180,290,50},
	s_imagedaynight_delay_subb_xywh		= {320,190,30,30},
	s_imagedaynight_t_delay_xywh 		= {350,180,232,50},
	s_imagedaynight_delay_add_xywh 		= {582,190,30,30},
	s_imagedaynight_delay_value_xywh 	= {618,190,60,30},
	s_imagedaynight_hline_xywh			= {690,0,2,240},
	s_imagedaynight_check1_xywh 		= {710,0,50,50},	
	s_imagedaynight_cap_infrared_xywh 	= {760,0,200,50},
	s_imagedaynight_t_infrared_xywh 	= {960,0,200,50},
--	s_imagedaynight_cap_near_xywh 		= {760,60,200,50},
--	s_imagedaynight_t_near_xywh 		= {720,60,200,50},
	s_imagedaynight_cap_strengh2_xywh	= {720,60,200,50},
	s_imagedaynight_strengh2_subb_xywh 	= {960,70,30,30},
	s_imagedaynight_t_strengh2_xywh 	= {990,60,232,50},
	s_imagedaynight_strengh2_add_xywh 	= {1222,70,30,30},
	s_imagedaynight_strengh2_value_xywh	= {1258,70,60,30},
	s_imagedaynight_cap_dtn_xywh		= {20,60,290,50},
	s_imagedaynight_t_dtn_xywh    		= {325,70,200,50},
	s_imagedaynight_cap_ntd_xywh		= {20,120,290,50},
	s_imagedaynight_t_ntd_xywh      	= {325,130,200,50},
};

w1_page_imagedaynight.s_2k = 
{
	s_cfg_page_imagedaynight_xywh 		= {133,686,1866,413},
	s_imagedaynight_cap_mode_xywh 		= {40,0,380,67},
	s_imagedaynight_t_mode_xywh			= {432,0,267,67},
	s_imagedaynight_cap_dn_transl_xywh 	= {40,80,380,67},
	s_imagedaynight_dn_transl_subb_xywh = {427,93,40,40},
	s_imagedaynight_t_dn_transl_xywh 	= {467,80,309,67},
	s_imagedaynight_dn_transl_add_xywh 	= {776,93,40,40},
	s_imagedaynight_dn_transl_value_xywh= {824,93,80,40},
	s_imagedaynight_cap_nd_transl_xywh 	= {40,160,380,67},
	s_imagedaynight_nd_transl_subb_xywh = {427,173,40,40},
	s_imagedaynight_t_nd_transl_xywh 	= {467,160,309,67},
	s_imagedaynight_nd_transl_add_xywh 	= {776,173,40,40},
	s_imagedaynight_nd_transl_value_xywh= {824,173,80,40},
	s_imagedaynight_cap_delay_xywh 		= {40,240,380,67},
	s_imagedaynight_delay_subb_xywh		= {427,253,40,40},
	s_imagedaynight_t_delay_xywh 		= {467,240,309,67},
	s_imagedaynight_delay_add_xywh 		= {776,253,40,40},
	s_imagedaynight_delay_value_xywh 	= {824,253,80,40},
	s_imagedaynight_hline_xywh			= {920,0,3,320},
	s_imagedaynight_check1_xywh 		= {946,0,67,67},
	s_imagedaynight_cap_infrared_xywh 	= {1013,0,267,67},
	s_imagedaynight_t_infrared_xywh 	= {1280,0,267,67},
--	s_imagedaynight_cap_near_xywh 		= {955,80,267,67},
--	s_imagedaynight_t_near_xywh 		= {1280,80,267,67},
	s_imagedaynight_cap_strengh2_xywh	= {955,80,267,67},
	s_imagedaynight_strengh2_subb_xywh 	= {1273,93,40,40},
	s_imagedaynight_t_strengh2_xywh 	= {1363,80,309,67},
	s_imagedaynight_strengh2_add_xywh 	= {1622,93,40,40},
	s_imagedaynight_strengh2_value_xywh	= {1670,93,80,40},
	s_imagedaynight_cap_dtn_xywh		= {40,80,380,67},
	s_imagedaynight_t_dtn_xywh    		= {432,93,267,67},
	s_imagedaynight_cap_ntd_xywh		= {40,160,380,67},
	s_imagedaynight_t_ntd_xywh      	= {432,173,267,67},
};

w1_page_imagedaynight.s_4k = 
{
	s_cfg_page_imagedaynight_xywh 		= {200,1030,2800,620},
	s_imagedaynight_cap_mode_xywh 		= {40,0,580,100},
	s_imagedaynight_t_mode_xywh			= {645,0,400,100},
	s_imagedaynight_cap_dn_transl_xywh 	= {40,120,580,100},
	s_imagedaynight_dn_transl_subb_xywh = {640,140,60,60},
	s_imagedaynight_t_dn_transl_xywh 	= {700,120,464,100},
	s_imagedaynight_dn_transl_add_xywh 	= {1164,140,60,60},
	s_imagedaynight_dn_transl_value_xywh= {1236,140,120,60},
	s_imagedaynight_cap_nd_transl_xywh 	= {40,240,580,100},
	s_imagedaynight_nd_transl_subb_xywh = {640,260,60,60},
	s_imagedaynight_t_nd_transl_xywh 	= {700,240,464,100},
	s_imagedaynight_nd_transl_add_xywh 	= {1164,260,60,60},
	s_imagedaynight_nd_transl_value_xywh= {1236,260,120,60},
	s_imagedaynight_cap_delay_xywh 		= {40,360,580,100},
	s_imagedaynight_delay_subb_xywh		= {640,380,60,60},
	s_imagedaynight_t_delay_xywh 		= {700,360,464,100},
	s_imagedaynight_delay_add_xywh 		= {1164,380,60,60},
	s_imagedaynight_delay_value_xywh 	= {1236,380,120,60},
	s_imagedaynight_hline_xywh			= {1380,0,4,480},
	s_imagedaynight_check1_xywh 		= {1420,0,100,100},
	s_imagedaynight_cap_infrared_xywh 	= {1520,0,400,100},
	s_imagedaynight_t_infrared_xywh 	= {1920,0,400,100},
--	s_imagedaynight_cap_near_xywh 		= {1430,120,400,100},
--	s_imagedaynight_t_near_xywh 		= {1920,120,400,100},
	s_imagedaynight_cap_strengh2_xywh	= {1430,120,400,100},
	s_imagedaynight_strengh2_subb_xywh 	= {1920,140,60,60},
	s_imagedaynight_t_strengh2_xywh 	= {1980,120,464,100},
	s_imagedaynight_strengh2_add_xywh 	= {2444,140,60,60},
	s_imagedaynight_strengh2_value_xywh	= {2516,140,120,60},
	s_imagedaynight_cap_dtn_xywh		= {40,120,580,100},
	s_imagedaynight_t_dtn_xywh    		= {645,140,400,100},
	s_imagedaynight_cap_ntd_xywh		= {40,240,580,100},
	s_imagedaynight_t_ntd_xywh      	= {645,260,400,100},

};

w1_page_imagedaynight.clear_data=function ()
	w1_page_imagedaynight.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imagedaynight.wnd;
	local data = cfgdata.daynight;
	data.dn_setting = b_wnd_ex.get_sel(top,cwnd.t_mode.id);
	if(-1 ~= data.transl_dn)then
		data.transl_dn = b_wnd_ex.get_value(top,cwnd.t_dn_transl.id);
	end
	
	if(-1 ~= data.transl_nd)then
		data.transl_nd = b_wnd_ex.get_value(top,cwnd.t_nd_transl.id);
	end
	
	if(-1 ~= data.delay)then
		data.delay = b_wnd_ex.get_value(top,cwnd.t_delay.id);
	end
	
	if(-1 ~= data.ir_led_enable)then
		local check = b_wnd_ex.get_check(top, cwnd.check1.id);
		if(true == check)then
			data.ir_led_enable = 1;
		else
			data.ir_led_enable = 0;
		end
	end
	
	if(-1 ~= data.ir_led) then
		data.ir_led = b_wnd_ex.get_sel(top,cwnd.t_infrared.id) + 1;
	end

	if(-1 ~= data.strength)then
		data.strength = b_wnd_ex.get_value(top,cwnd.t_strengh2.id);
	end
	if(-1 ~= data.dtn_time_hour and -1 ~= data.dtn_time_min and -1 ~= data.ntd_time_hour and -1 ~= data.ntd_time_min)then
		local s_time = b_wnd_ex.get_time(top, cwnd.t_dtn.id)
		data.dtn_time_hour = s_time.hour
		data.dtn_time_min = s_time.minute
		local time_fmt = s_time.format
		if  time_fmt ~= 0 then
			if  data.dtn_time_hour == 12  then
				data.dtn_time_hour = data.dtn_time_hour - 12
			end
			if  time_fmt == 2 then
				data.dtn_time_hour = data.dtn_time_hour + 12
			end
		end
		
		local e_time = b_wnd_ex.get_time(top, cwnd.t_ntd.id)
		data.ntd_time_hour = e_time.hour
		data.ntd_time_min = e_time.minute 
		time_fmt = e_time.format
		if  time_fmt ~= 0 then
			if  data.ntd_time_hour == 12  then
				data.ntd_time_hour = data.ntd_time_hour - 12
			end
			if time_fmt == 2 then
				data.ntd_time_hour = data.ntd_time_hour + 12
			end
		end
		
	end
	cfgdata.change_flag = 1;
	b_app_api.set_immediate_color(cfgdata);
	return 0
end

local refresh_hide = function (top,param,redraw)
	local cwnd = w1_page_imagedaynight.wnd;
	local hide_flag = 0; --Զģʽؿؼǣ
--ģʽл

	if(-1 == param.dn_setting)then
		b_wnd_ex.set_hide(top, cwnd.cap_mode.id, true, redraw);
		b_wnd_ex.set_hide(top, cwnd.t_mode.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_mode.id, false, redraw);
		b_wnd_ex.set_hide(top, cwnd.t_mode.id, false, redraw);
	end

	if(0 == param.dn_setting)then
		if(-1 == param.transl_dn)then -- زֵ֧Ĺ
			b_wnd_ex.set_hide(top,cwnd.cap_dn_transl.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.dn_transl_subb.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_dn_transl.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.dn_transl_add.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.dn_transl_value.id,true,redraw);
			hide_flag = 1;
		else
			b_wnd_ex.set_hide(top,cwnd.cap_dn_transl.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.dn_transl_subb.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_dn_transl.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.dn_transl_add.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.dn_transl_value.id,false,redraw);	
		end
		
		if(-1 == param.transl_nd)then
			b_wnd_ex.set_hide(top,cwnd.cap_nd_transl.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.nd_transl_subb.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_nd_transl.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.nd_transl_add.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.nd_transl_value.id,true,redraw);
			hide_flag = hide_flag + 2;
		else
			b_wnd_ex.set_hide(top,cwnd.cap_nd_transl.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.nd_transl_subb.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_nd_transl.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.nd_transl_add.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.nd_transl_value.id,false,redraw);
		end
		if(-1 == param.delay)then
			b_wnd_ex.set_hide(top,cwnd.cap_delay.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.delay_subb.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_delay.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.delay_add.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.delay_value.id,true,redraw);
			hide_flag = hide_flag + 4;
		else
			b_wnd_ex.set_hide(top,cwnd.cap_delay.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.delay_subb.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_delay.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.delay_add.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.delay_value.id,false,redraw);
		end	
	else
		b_wnd_ex.set_hide(top,cwnd.cap_dn_transl.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.dn_transl_subb.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.t_dn_transl.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.dn_transl_add.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.dn_transl_value.id,true,redraw);	
	
		b_wnd_ex.set_hide(top,cwnd.cap_nd_transl.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.nd_transl_subb.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.t_nd_transl.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.nd_transl_add.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.nd_transl_value.id,true,redraw);
		
		b_wnd_ex.set_hide(top,cwnd.cap_delay.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.delay_subb.id,true,redraw);	
		b_wnd_ex.set_hide(top,cwnd.t_delay.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.delay_add.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.delay_value.id,true,redraw);	
	end
	
	if(3 == param.dn_setting)then	
		if(-1 == param.dtn_time_hour or -1 == param.dtn_time_min or -1 == param.ntd_time_hour or -1 == param.ntd_time_min)then
			b_wnd_ex.set_hide(top,cwnd.cap_dtn.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_dtn.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.cap_ntd.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_ntd.id,true,redraw);	
		else
			b_wnd_ex.set_hide(top,cwnd.cap_dtn.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_dtn.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.cap_ntd.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_ntd.id,false,redraw);
		end
	else
		b_wnd_ex.set_hide(top,cwnd.cap_dtn.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.t_dtn.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.cap_ntd.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.t_ntd.id,true,redraw);
	end
	
	if(-1 == param.ir_led_enable)then
		b_wnd_ex.set_hide(top, cwnd.check1.id,true,redraw);
	elseif(0 == param.ir_led_enable)then
		b_wnd_ex.set_hide(top, cwnd.check1.id,false,redraw);
		
		b_wnd_ex.set_disable(top, cwnd.cap_infrared.id,true,redraw);
		b_wnd_ex.set_disable(top, cwnd.t_infrared.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.cap_strengh2.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_subb.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_strengh2.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_add.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_value.id,true,redraw);
	elseif(1 == param.ir_led_enable)then
		b_wnd_ex.set_hide(top, cwnd.check1.id,false,redraw);	
		
		b_wnd_ex.set_disable(top, cwnd.cap_infrared.id,false,redraw);
		b_wnd_ex.set_disable(top, cwnd.t_infrared.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.cap_strengh2.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_subb.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_strengh2.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_add.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_value.id,false,redraw);
	end
	
	if(2 == param.ir_led)then	
		if(-1 == param.strength)then
			b_wnd_ex.set_hide(top,cwnd.cap_strengh2.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.strengh2_subb.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_strengh2.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.strengh2_add.id,true,redraw);
			b_wnd_ex.set_hide(top,cwnd.strengh2_value.id,true,redraw);
		else
			b_wnd_ex.set_hide(top,cwnd.cap_strengh2.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.strengh2_subb.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.t_strengh2.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.strengh2_add.id,false,redraw);
			b_wnd_ex.set_hide(top,cwnd.strengh2_value.id,false,redraw);
		end		
	else
		b_wnd_ex.set_hide(top,cwnd.cap_strengh2.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.strengh2_subb.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.t_strengh2.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.strengh2_add.id,true,redraw);
		b_wnd_ex.set_hide(top,cwnd.strengh2_value.id,true,redraw);
	end
	
	if(-1 == param.ir_led)then
		b_wnd_ex.set_hide(top, cwnd.cap_infrared.id,true,redraw);
		b_wnd_ex.set_hide(top, cwnd.t_infrared.id,true,redraw);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_infrared.id,false,redraw);
		b_wnd_ex.set_hide(top, cwnd.t_infrared.id,false,redraw);
	end

--  µλ
	if (0== hide_flag) then
		local param_size = SIZE('s_imagedaynight_cap_nd_transl_xywh')
		b_wnd_ex.move_ex(top, cwnd.cap_nd_transl.id,param_size, false)
		param_size = SIZE('s_imagedaynight_nd_transl_subb_xywh')
		b_wnd_ex.move_ex(top, cwnd.nd_transl_subb.id,param_size, false)
		param_size = SIZE('s_imagedaynight_t_nd_transl_xywh')
		b_wnd_ex.move_ex(top, cwnd.t_nd_transl.id,param_size, false)
		param_size = SIZE('s_imagedaynight_nd_transl_add_xywh')
		b_wnd_ex.move_ex(top, cwnd.nd_transl_add.id,param_size, false)
		param_size = SIZE('s_imagedaynight_nd_transl_value_xywh')
		b_wnd_ex.move_ex(top, cwnd.nd_transl_value.id,param_size, false)	
	
		param_size = SIZE('s_imagedaynight_cap_delay_xywh')
		b_wnd_ex.move_ex(top, cwnd.cap_delay.id,param_size, false)
		param_size = SIZE('s_imagedaynight_delay_subb_xywh')
		b_wnd_ex.move_ex(top, cwnd.delay_subb.id,param_size, false)
		param_size = SIZE('s_imagedaynight_t_delay_xywh')
		b_wnd_ex.move_ex(top, cwnd.t_delay.id,param_size, false)
		param_size = SIZE('s_imagedaynight_delay_add_xywh')
		b_wnd_ex.move_ex(top, cwnd.delay_add.id,param_size, false)
		param_size = SIZE('s_imagedaynight_delay_value_xywh')
		b_wnd_ex.move_ex(top, cwnd.delay_value.id,param_size, false)
		
	elseif(1 == hide_flag)then
		local param_size = SIZE('s_imagedaynight_cap_dn_transl_xywh')
		b_wnd_ex.move_ex(top, cwnd.cap_nd_transl.id,param_size, false)
		param_size = SIZE('s_imagedaynight_dn_transl_subb_xywh')
		b_wnd_ex.move_ex(top, cwnd.nd_transl_subb.id,param_size, false)
		param_size = SIZE('s_imagedaynight_t_dn_transl_xywh')
		b_wnd_ex.move_ex(top, cwnd.t_nd_transl.id,param_size, false)
		param_size = SIZE('s_imagedaynight_dn_transl_add_xywh')
		b_wnd_ex.move_ex(top, cwnd.nd_transl_add.id,param_size, false)
		param_size = SIZE('s_imagedaynight_dn_transl_value_xywh')
		b_wnd_ex.move_ex(top, cwnd.nd_transl_value.id,param_size, false)	
	
		param_size = SIZE('s_imagedaynight_cap_nd_transl_xywh')
		b_wnd_ex.move_ex(top, cwnd.cap_delay.id,param_size, false)
		param_size = SIZE('s_imagedaynight_nd_transl_subb_xywh')
		b_wnd_ex.move_ex(top, cwnd.delay_subb.id,param_size, false)
		param_size = SIZE('s_imagedaynight_t_nd_transl_xywh')
		b_wnd_ex.move_ex(top, cwnd.t_delay.id,param_size, false)
		param_size = SIZE('s_imagedaynight_nd_transl_add_xywh')
		b_wnd_ex.move_ex(top, cwnd.delay_add.id,param_size, false)
		param_size = SIZE('s_imagedaynight_nd_transl_value_xywh')
		b_wnd_ex.move_ex(top, cwnd.delay_value.id,param_size, false)
	elseif(3 == hide_flag)then
		local param_size = SIZE('s_imagedaynight_cap_dn_transl_xywh')
		b_wnd_ex.move_ex(top, cwnd.cap_delay.id,param_size, false)
		param_size = SIZE('s_imagedaynight_dn_transl_subb_xywh')
		b_wnd_ex.move_ex(top, cwnd.delay_subb.id,param_size, false)
		param_size = SIZE('s_imagedaynight_t_dn_transl_xywh')
		b_wnd_ex.move_ex(top, cwnd.t_delay.id,param_size, false)
		param_size = SIZE('s_imagedaynight_dn_transl_add_xywh')
		b_wnd_ex.move_ex(top, cwnd.delay_add.id,param_size, false)
		param_size = SIZE('s_imagedaynight_dn_transl_value_xywh')
		b_wnd_ex.move_ex(top, cwnd.delay_value.id,param_size, false)
	end
	
end

local on_mode = function (top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_imagedaynight.wnd;
		local mode = b_wnd_ex.get_sel(top, cwnd.t_mode.id);
		local red = b_wnd_ex.get_sel(top, cwnd.t_infrared.id);	
		uitousercfg(top,w1_page_imagedaynight.cfg_data);
		local data = w1_page_imagedaynight.cfg_data.daynight;
		refresh_hide(top,data,false)	
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
	
end

local set_image_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), false);
	end
	local cwnd = w1_page_imagedaynight.wnd;
	if(id == cwnd.t_dn_transl.id) then
		set_text(cwnd.dn_transl_value.id, value);
	elseif(id == cwnd.t_nd_transl.id) then
		set_text(cwnd.nd_transl_value.id, value);
	elseif(id == cwnd.t_delay.id) then
		set_text(cwnd.delay_value.id, value);
	elseif(id == cwnd.t_strengh2.id)then
		set_text(cwnd.strengh2_value.id, value);
	end
	uitousercfg(top,w1_page_imagedaynight.cfg_data)
	b_dlg.dlg_set_redraw(top)
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local data =w1_page_imagedaynight.cfg_data.daynight
		local cwnd = w1_page_imagedaynight.wnd;
		local opearid = nil;
		if(win_id == cwnd.dn_transl_subb.id) then
			opearid = cwnd.t_dn_transl.id;
			local dn = b_wnd_ex.get_value(top, cwnd.t_dn_transl.id) - 1;
			local nd = b_wnd_ex.get_value(top, cwnd.t_nd_transl.id);
			if(nd > dn or nd == dn)then
				b_wnd_ex.set_value(top, cwnd.t_dn_transl.id, data.transl_dn, false);
				set_image_value(top, opearid, data.transl_dn);
			else
				local value = b_wnd_ex.get_value(top, opearid);
				if(value > 0) then	
					value = value - 1;
					b_wnd_ex.set_value(top, opearid, value, false);
					set_image_value(top, opearid, value);
				end	
			end
			return 0;
		elseif(win_id == cwnd.nd_transl_subb.id) then
			opearid = cwnd.t_nd_transl.id;
		elseif(win_id == cwnd.delay_subb.id) then
			opearid = cwnd.t_delay.id;
		elseif(win_id == cwnd.strengh2_subb.id) then
			opearid = cwnd.t_strengh2.id;
		end
		
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > 0) then	
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, false);
			set_image_value(top, opearid, value);
		end	
	end
	return 0
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_imagedaynight.wnd;
		local data =w1_page_imagedaynight.cfg_data.daynight
		local dn = b_wnd_ex.get_value(top, cwnd.t_dn_transl.id);
		local nd = b_wnd_ex.get_value(top, cwnd.t_nd_transl.id);
		if(nd > dn or nd == dn)then
			if(win_id == cwnd.t_dn_transl.id) then
				b_wnd_ex.set_value(top, cwnd.t_dn_transl.id, data.transl_dn, false);
			else
				b_wnd_ex.set_value(top, cwnd.t_nd_transl.id, data.transl_nd, false);
			end
		end
		local value = b_wnd_ex.get_value(top, win_id);
		set_image_value(top, win_id, value);
		
	--	w1_wnd_util.uidatacheckfunc = uidatacheck;
	--	w1_wnd_util.uitocfgfunc = uitousercfg;
	--	w1_wnd_util.page_onapply(top);
	--	w1_wnd_util.tipdispon();		--ʾ
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local data =w1_page_imagedaynight.cfg_data.daynight
		local cwnd = w1_page_imagedaynight.wnd;
		local opearid = nil;
		if(win_id == cwnd.dn_transl_add.id) then
			opearid = cwnd.t_dn_transl.id;
			local dn = b_wnd_ex.get_value(top, opearid);
		elseif(win_id == cwnd.nd_transl_add.id) then
			opearid = cwnd.t_nd_transl.id;
			local dn = b_wnd_ex.get_value(top, cwnd.t_dn_transl.id) - 1;
			local nd = b_wnd_ex.get_value(top, cwnd.t_nd_transl.id);
			if(nd > dn or nd == dn)then
				b_wnd_ex.set_value(top, opearid, data.transl_nd, false);
				set_image_value(top, opearid, data.transl_nd);
			else
				local value = b_wnd_ex.get_value(top, opearid);
				if(value < 100) then
					value = value + 1;
					b_wnd_ex.set_value(top, opearid, value, false)
					set_image_value(top, opearid, value);
				end
			end
			return 0;
		elseif(win_id == cwnd.delay_add.id) then
			opearid = cwnd.t_delay.id;
		elseif(win_id == cwnd.strengh2_add.id) then
			opearid = cwnd.t_strengh2.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, false)
			set_image_value(top, opearid, value);
		end
	end
	return 0
end

local on_add_delay = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imagedaynight.wnd;
		local value = b_wnd_ex.get_value(top, cwnd.t_delay.id);
		if(value < 180) then
			value = value + 1;
			b_wnd_ex.set_value(top, cwnd.t_delay.id, value, false)
			set_image_value(top, cwnd.t_delay.id, value);
		end
	end
	return 0
end

local on_check1 = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		uitousercfg(top,w1_page_imagedaynight.cfg_data)
		local data = w1_page_imagedaynight.cfg_data.daynight
		refresh_hide(top, data, false)
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_imagedaynight.cfg_data)
	end
	return 0;
end

local on_dtn_time = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_time_update) then
		local cwnd = w1_page_imagedaynight.wnd;
		local data = w1_page_imagedaynight.cfg_data.daynight
		local dtn_time = b_wnd_ex.get_time(top, cwnd.t_dtn.id)
		local ntd_time = b_wnd_ex.get_time(top, cwnd.t_ntd.id)
		if(dtn_time.hour == ntd_time.hour and dtn_time.minute == ntd_time.minute and dtn_time.format == ntd_time.format)then
			local format = 0;
			dtn_time.hour = data.dtn_time_hour;
			dtn_time.minute = data.dtn_time_min
			if (0 == data.time_fmt) then -- 12Сʱģʽ
				if (data.dtn_time_hour > 12) then
					dtn_time.hour = dtn_time.hour - 12;
					format = 2;
				elseif (data.dtn_time_hour == 12) then
					dtn_time.hour = 12;
					format = 2;
				elseif (data.dtn_time_hour == 0) then
					dtn_time.hour = 12;
					format = 1;
				else
					format = 1;	
				end
			end
				
			local dtntime = {}
			dtntime[1] = format
			dtntime[2] = dtn_time.hour 
			dtntime[3] = dtn_time.minute
			dtntime[4] = 0
			dtntime[5] = 1		
			b_wnd_ex.set_time(top, cwnd.t_dtn.id, dtntime, false)			
		end	
		uitousercfg(top,w1_page_imagedaynight.cfg_data)
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end  

local on_ntd_time = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_time_update) then
		local cwnd = w1_page_imagedaynight.wnd;
		local data = w1_page_imagedaynight.cfg_data.daynight
		local dtn_time = b_wnd_ex.get_time(top, cwnd.t_dtn.id)
		local ntd_time = b_wnd_ex.get_time(top, cwnd.t_ntd.id)
		if(dtn_time.hour == ntd_time.hour and dtn_time.minute == ntd_time.minute and dtn_time.format == ntd_time.format)then
			local format = 0;
			ntd_time.hour = data.ntd_time_hour;
			ntd_time.minute = data.ntd_time_min	
			if (0 == data.time_fmt) then -- 12Сʱģʽ
				if (data.ntd_time_hour > 12) then
					ntd_time.hour = ntd_time.hour - 12;
					format = 2;
				elseif (data.ntd_time_hour == 12) then
					ntd_time.hour = 12;
					format = 2;
				elseif (data.ntd_time_hour == 0) then
					ntd_time.hour = 12;
					format = 1;
				else
					format = 1;	
				end
			end	
			
			local dtntime = {}
			dtntime[1] = format;
			dtntime[2] = ntd_time.hour
			dtntime[3] = ntd_time.minute
			dtntime[4] = 0
			dtntime[5] = 1		
			b_wnd_ex.set_time(top, cwnd.t_ntd.id, dtntime, false)			
		end	
		uitousercfg(top,w1_page_imagedaynight.cfg_data)
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end  

w1_page_imagedaynight.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_imagedaynight.wnd;
--	if(bool_hide)then
		local data = {}; 
		refresh_hide(top,data,redraw)
--	end
	
	b_wnd_ex.set_hide(top, cwnd.cap_mode.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_mode.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.hline.id, bool_hide, redraw)
	
	b_wnd_ex.set_hide(top, cwnd.check1.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_infrared.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_infrared.id, bool_hide, redraw)
end

w1_page_imagedaynight.set_param = function(top, param, redraw)
	local cwnd = w1_page_imagedaynight.wnd;
	local data = param.daynight;
	--	ģʽл ԼӦ	
	refresh_hide(top,data,redraw)
	
	b_wnd_ex.set_sel(top, cwnd.t_mode.id, data.dn_setting, redraw);
	
	if(-1 ~= data.transl_dn)then
		b_wnd_ex.set_value(top, cwnd.t_dn_transl.id, data.transl_dn, redraw);
		b_wnd_ex.set_text(top, cwnd.dn_transl_value.id, tostring(data.transl_dn), redraw);
	end
	
	if(-1 ~= data.transl_nd)then
		b_wnd_ex.set_value(top, cwnd.t_nd_transl.id, data.transl_nd, redraw);
		b_wnd_ex.set_text(top, cwnd.nd_transl_value.id, tostring(data.transl_nd), redraw);
	end
	
	if(-1 ~= data.delay)then
		b_wnd_ex.set_value(top, cwnd.t_delay.id, data.delay, redraw);
		b_wnd_ex.set_text(top, cwnd.delay_value.id, tostring(data.delay), redraw);
	end
	
	b_wnd_ex.set_one_min_interval(top,cwnd.t_dtn.id,1,redraw);
	
	local timt_fmt = 0;
	local hour = data.dtn_time_hour;
	if (0 == data.time_fmt) then -- 12Сʱģʽ
		if (hour > 12) then
			timt_fmt = 2;
			hour = hour - 12;
		elseif (hour == 12) then
			timt_fmt = 2;
			hour = 12;
		elseif (hour == 0) then
			timt_fmt = 1;
			hour = 12;
		else
			timt_fmt = 1;
		end
	else 
		timt_fmt = 0;
	end
		
	
	if(-1 ~= data.dtn_time_hour and -1 ~= data.dtn_time_min)then
		local dtntime = {}
		dtntime[1] = timt_fmt
		dtntime[2] = hour
		dtntime[3] = data.dtn_time_min
		dtntime[4] = 0
		dtntime[5] = 1
		b_wnd_ex.set_time(top, cwnd.t_dtn.id, dtntime, redraw)
	end


	b_wnd_ex.set_one_min_interval(top,cwnd.t_ntd.id,1,redraw);
	local nhour = data.ntd_time_hour;
	if (0 == data.time_fmt) then -- 12Сʱģʽ
		if (nhour > 12) then
			timt_fmt = 2;
			nhour = nhour - 12;
		elseif (nhour == 12) then
			timt_fmt = 2;
			nhour = 12;
		elseif (nhour == 0) then
			timt_fmt = 1;
			nhour = 12;
		else
			timt_fmt = 1;
		end
	else 
		timt_fmt = 0;
	end
			
	
	if(-1 ~= data.ntd_time_hour and -1 ~= data.ntd_time_min)then
		local ntdtime = {}
		ntdtime[1] = timt_fmt
		ntdtime[2] = nhour
		ntdtime[3] = data.ntd_time_min
		ntdtime[4] = 0
		ntdtime[5] = 1
		b_wnd_ex.set_time(top, cwnd.t_ntd.id, ntdtime, redraw)
	end
	
	if(0 == data.ir_led_enable)then
		b_wnd_ex.set_check(top, cwnd.check1.id,false,redraw);
	elseif(1 == data.ir_led_enable)then
		b_wnd_ex.set_check(top, cwnd.check1.id,true,redraw);
	end
	if(-1 ~= data.ir_led)then
		b_wnd_ex.set_sel(top, cwnd.t_infrared.id,data.ir_led - 1,redraw);--1Զ 2ֶ
	end
	if(-1 ~= data.strength)then
		b_wnd_ex.set_value(top, cwnd.t_strengh2.id, data.strength, redraw);
		b_wnd_ex.set_text(top, cwnd.strengh2_value.id, tostring(data.strength), redraw);
	end
	
	local dlg_w = global_val.get_size();
	if(dlg_w == 1440)then
		b_wnd_ex.dlg_direct_up(top, cwnd.t_ntd.id, true, false);
	else
		b_wnd_ex.dlg_direct_up(top, cwnd.t_ntd.id, false, false);
	end
	w1_page_imagedaynight.cfg_data = param;
end

w1_page_imagedaynight.get_param = function(top)
	local cwnd = w1_page_imagedaynight.wnd;
	local param = {};
	param.dn_setting = b_wnd_ex.get_sel(top,cwnd.t_mode.id);
	param.transl_dn = b_wnd_ex.get_value(top,cwnd.t_dn_transl.id);
	param.transl_nd = b_wnd_ex.get_value(top,cwnd.t_nd_transl.id);
	param.delay = b_wnd_ex.get_value(top,cwnd.t_delay.id);
	
	local check = b_wnd_ex.get_check(top, cwnd.check1.id);
	if(true == check)then
		param.ir_led_enable = 1;
	else
		param.ir_led_enable = 0;
	end
	param.ir_led = b_wnd_ex.get_sel(top,cwnd.t_infrared.id) + 1;
	param.strength = b_wnd_ex.get_value(top,cwnd.t_strengh2.id);
	
	local s_time = b_wnd_ex.get_time(top, cwnd.t_dtn.id)
	param.dtn_time_hour = s_time.hour
	param.dtn_time_min = s_time.minute
	local time_fmt = s_time.format
	if  time_fmt ~= 0 then
		if  data.dtn_time_hour == 12  then
			data.dtn_time_hour = data.dtn_time_hour - 12
		end
		if  time_fmt == 2 then
			data.dtn_time_hour = data.dtn_time_hour + 12
		end
	end
		
	local e_time = b_wnd_ex.get_time(top, cwnd.t_ntd.id)
	param.ntd_time_hour = e_time.hour
	param.ntd_time_min = e_time.minute 
	time_fmt = e_time.format
	if  time_fmt ~= 0 then
		if  data.ntd_time_hour == 12  then
			data.ntd_time_hour = data.ntd_time_hour - 12
		end
		if time_fmt == 2 then
			data.ntd_time_hour = data.ntd_time_hour + 12
		end
	end
	
	return param
end

w1_page_imagedaynight.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imagedaynight_xywh',
--	color_d	= {'c_cfgclose_bk', 'c_cfgclose_bk','c_cfgclose_bk'},	
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'cap_mode','t_mode','hline',
			'cap_dn_transl', 'dn_transl_subb', 't_dn_transl', 'dn_transl_add', 'dn_transl_value', 
			'cap_nd_transl','nd_transl_subb','t_nd_transl','nd_transl_add','nd_transl_value',
			'cap_delay', 'delay_subb', 't_delay', 'delay_add', 'delay_value',
			'cap_strengh2','strengh2_subb','t_strengh2','strengh2_add','strengh2_value',
			'check1','cap_infrared','t_infrared','cap_near','t_near','cap_dtn','t_dtn','cap_ntd','t_ntd',
			},
		
	cap_mode = {t='static',id=id+1,xywh='s_imagedaynight_cap_mode_xywh',text='LA_DAY_NIGHT_MODE', font = 'f_image',
					},	
	t_mode  	= {t='combox',id=id+2,xywh='s_imagedaynight_t_mode_xywh',items={'LA_AUTO','LA_DAY_MODE','LA_NIGHT_MODE','LA_TIMING'},  
					font = 'f_image',cmd = on_mode,
					},	
	
	--dn_transl		
	cap_dn_transl	= {t='static',id=id+4,	xywh='s_imagedaynight_cap_dn_transl_xywh',	text='LA_DAY_THRESHOLD',font = 'f_image'},
	dn_transl_subb	= {t='button',id=id+5,	xywh='s_imagedaynight_dn_transl_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_dn_transl		= {t='hslider',id=id+6,	xywh='s_imagedaynight_t_dn_transl_xywh',		
					font = 'f_slider', cmd=on_adj},
	dn_transl_add	= {t='button',id=id+7,	xywh='s_imagedaynight_dn_transl_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	dn_transl_value	= {t='static',id=id+8,	xywh='s_imagedaynight_dn_transl_value_xywh',text='',trans = false,font = 'f_image'},
	--nd_transl
	cap_nd_transl	= {t='static',id=id+9,	xywh='s_imagedaynight_cap_nd_transl_xywh',text='LA_NIGHT_THRESHOLD',font = 'f_image'},
	nd_transl_subb	= {t='button',id=id+10,	xywh='s_imagedaynight_nd_transl_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_nd_transl		= {t='hslider',id=id+11,	xywh='s_imagedaynight_t_nd_transl_xywh',		
					font = 'f_slider', cmd=on_adj},
	nd_transl_add	= {t='button',id=id+12,	xywh='s_imagedaynight_nd_transl_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	nd_transl_value	= {t='static',id=id+13,	xywh='s_imagedaynight_nd_transl_value_xywh',text='',trans = false,font = 'f_image'},
	--delay
	cap_delay	= {t='static',id=id+14,	xywh='s_imagedaynight_cap_delay_xywh',text='LA_DELAY',font = 'f_image'},
	delay_subb	= {t='button',id=id+15,	xywh='s_imagedaynight_delay_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_delay	= {t='hslider',id=id+16,xywh='s_imagedaynight_t_delay_xywh',		
					font = 'f_slider', max_value = 180,cmd=on_adj},
	delay_add	= {t='button',id=id+17,	xywh='s_imagedaynight_delay_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add_delay},
	delay_value= {t='static',id=id+18,	xywh='s_imagedaynight_delay_value_xywh',text='',trans = false,font = 'f_image'},
	
	hline 	= {t='hline',	id=id+19,xywh='s_imagedaynight_hline_xywh'},
	
	check1 	= {t='check', 	id=id+20,xywh='s_imagedaynight_check1_xywh',
				--	t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check_select','it_check_select','it_check_select_f', 'it_check_select_f'},
					cmd = on_check1},	
					
	cap_infrared = {t='static',id=id+21,xywh='s_imagedaynight_cap_infrared_xywh',text='LA_INFRARED_LIGHT',font = 'f_image',
					},	
					
	t_infrared  = {t='combox',id=id+22,xywh='s_imagedaynight_t_infrared_xywh',items={'LA_AUTO','LA_FIXED'},  
					font = 'f_image',cmd = on_mode
					},
	
--[[	cap_near = {t='static',id=id+23,xywh='s_imagedaynight_cap_near_xywh',text='LA_NEAR',font = 'f_image',
					},	
					
	t_near  = {t='combox',id=id+24,xywh='s_imagedaynight_t_near_xywh',items={'LA_OPEN','LA_CLOSE'},  
					font = 'f_image',cmd = on_update_param
					},--]]
	cap_strengh2= {t='static',id=id+25,	xywh='s_imagedaynight_cap_strengh2_xywh',text='LA_STRENGTH',font = 'f_image'},
	strengh2_subb	= {t='button',id=id+26,	xywh='s_imagedaynight_strengh2_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_strengh2	= {t='hslider',id=id+27,	xywh='s_imagedaynight_t_strengh2_xywh',	
					font = 'f_slider', cmd=on_adj},
	strengh2_add	= {t='button',id=id+28,	xywh='s_imagedaynight_strengh2_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	strengh2_value	= {t='static',id=id+29,	xywh='s_imagedaynight_strengh2_value_xywh',text='',trans = false,font = 'f_image'},
	
	-------лģʽ/
	cap_dtn = {t='static',id=id+35,xywh='s_imagedaynight_cap_dtn_xywh',text='LA_DAY_TO_NIGHT',font = 'f_image',
					},	
	t_dtn  	= {t='time_edit',id=id+36,xywh='s_imagedaynight_t_dtn_xywh',time = {b_ui.TIME.TIME_24,1,0,0,1}, time_sec =true,
					trans = false,font = 'f_image',cmd = on_dtn_time
					},	
	cap_ntd = {t='static',id=id+37,xywh='s_imagedaynight_cap_ntd_xywh',text='LA_NIGHT_TO_DAY',font = 'f_image',
					},	
	t_ntd  	= {t='time_edit',id=id+38,xywh='s_imagedaynight_t_ntd_xywh',time = {b_ui.TIME.TIME_24,1,0,0,1}, 
					trans = false,font = 'f_image',cmd = on_ntd_time
					},	
}

return w1_page_imagedaynight

