local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.imageffc_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local b_dlg = require("wnd.core.b_dlg")
local w1_page_imageffc = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}
local shutter_flag = 0;	--һ 1 ȥϻָΪ0
local background_flag = 0;	--һ 1 ȥϻָΪ0

w1_page_imageffc.s_768 =
{
	s_cfg_page_imageffc_xywh = {53,366,746,220},
	s_imageffc_cap_control_xywh = {32,0,85,35},
	s_imageffc_t_control_xywh = {141,0,106,35},
	s_imageffc_cap_min_xywh = {32,42,85,35},
	s_imageffc_min_subb_xywh = {138,49,16,21},
	s_imageffc_t_min_xywh = {154,42,123,35},
	s_imageffc_min_add_xywh = {278,49,16,21},
	s_imageffc_min_value_xywh = {297,49,32,21},
	s_imageffc_cap_tempr_xywh = {32,85,85,35},
	s_imageffc_tempr_subb_xywh = {138,92,16,21},
	s_imageffc_t_tempr_xywh = {154,85,123,35},
	s_imageffc_tempr_add_xywh = {278,92,16,21},
	s_imageffc_tempr_value_xywh = {297,92,32,21},
	s_imageffc_shutter_init_xywh = {426,0,160,28},
	s_imageffc_shutter_adjust_xywh = {426,46,160,28},
	s_imageffc_background_adjust_xywh = {426,92,160,28},
};

w1_page_imageffc.s_1280 = 
{
	s_cfg_page_imageffc_xywh = {60,475,900,310},
	s_imageffc_cap_control_xywh = {60,0,160,50},
	s_imageffc_t_control_xywh= {260,0,160,50},
	s_imageffc_cap_min_xywh = {60,60,160,50},
	s_imageffc_min_subb_xywh = {250,70,30,30},
	s_imageffc_t_min_xywh = {280,60,160,50},
	s_imageffc_min_add_xywh = {440,70,30,30},
	s_imageffc_min_value_xywh = {475,70,60,30},
	s_imageffc_cap_tempr_xywh = {60,120,160,50},
	s_imageffc_tempr_subb_xywh = {250,130,30,30},
	s_imageffc_t_tempr_xywh = {280,120,160,50},
	s_imageffc_tempr_add_xywh = {440,130,30,30},
	s_imageffc_tempr_value_xywh = {475,130,60,30},
	s_imageffc_shutter_init_xywh = {650,0,200,40},
	s_imageffc_shutter_adjust_xywh = {650,65,200,40},
	s_imageffc_background_adjust_xywh = {650,130,200,40}
};

w1_page_imageffc.s_1440 = 
{
	s_cfg_page_imageffc_xywh = {60,440,900,245},
	s_imageffc_cap_control_xywh = {60,0,160,45},
	s_imageffc_t_control_xywh= {255,0,160,45},
	s_imageffc_cap_min_xywh = {60,50,160,40},
	s_imageffc_min_subb_xywh = {250,60,30,30},
	s_imageffc_t_min_xywh = {280,50,160,40},
	s_imageffc_min_add_xywh = {440,60,30,30},
	s_imageffc_min_value_xywh = {475,60,60,30},
	s_imageffc_cap_tempr_xywh = {60,95,160,40},
	s_imageffc_tempr_subb_xywh = {250,105,30,30},
	s_imageffc_t_tempr_xywh = {280,95,160,40},
	s_imageffc_tempr_add_xywh = {440,105,30,30},
	s_imageffc_tempr_value_xywh = {475,105,60,30},
	s_imageffc_shutter_init_xywh = {650,0,200,40},
	s_imageffc_shutter_adjust_xywh = {650,50,200,40},
	s_imageffc_background_adjust_xywh = {650,100,200,40}
};

w1_page_imageffc.s_1080p = 
{
	s_cfg_page_imageffc_xywh = {100,515,1400,310},
	s_imageffc_cap_control_xywh = {60,0,160,50},
	s_imageffc_t_control_xywh= {265,0,200,50},
	s_imageffc_cap_min_xywh = {60,60,160,50},
	s_imageffc_min_subb_xywh = {260,70,30,30},
	s_imageffc_t_min_xywh = {290,60,232,50},
	s_imageffc_min_add_xywh = {522,70,30,30},
	s_imageffc_min_value_xywh = {558,70,60,30},
	s_imageffc_cap_tempr_xywh = {60,120,160,50},
	s_imageffc_tempr_subb_xywh = {260,130,30,30},
	s_imageffc_t_tempr_xywh = {290,120,232,50},
	s_imageffc_tempr_add_xywh = {522,130,30,30},
	s_imageffc_tempr_value_xywh = {558,130,60,30},
	s_imageffc_shutter_init_xywh = {800,0,300,40},
	s_imageffc_shutter_adjust_xywh = {800,65,300,40},
	s_imageffc_background_adjust_xywh = {800,130,300,40}

};

w1_page_imageffc.s_2k = 
{
	s_cfg_page_imageffc_xywh = {133,686,1866,413},
	s_imageffc_cap_control_xywh = {80,0,213,67},
	s_imageffc_t_control_xywh= {352,0,213,67},
	s_imageffc_cap_min_xywh = {80,80,213,67},
	s_imageffc_min_subb_xywh = {347,93,40,40},
	s_imageffc_t_min_xywh = {387,80,309,67},
	s_imageffc_min_add_xywh = {696,93,40,40},
	s_imageffc_min_value_xywh = {744,93,80,40},
	s_imageffc_cap_tempr_xywh = {80,160,213,67},
	s_imageffc_tempr_subb_xywh = {347,173,40,40},
	s_imageffc_t_tempr_xywh = {387,160,309,67},
	s_imageffc_tempr_add_xywh = {696,173,40,40},
	s_imageffc_tempr_value_xywh = {744,173,80,40},
	s_imageffc_shutter_init_xywh = {950,5,400,50},
	s_imageffc_shutter_adjust_xywh = {950,90,400,50},
	s_imageffc_background_adjust_xywh = {950,170,400,50}

};

w1_page_imageffc.s_4k = 
{
	s_cfg_page_imageffc_xywh 	= {200,1030,2800,620},
	s_imageffc_cap_control_xywh 	= {120,0,320,100},
	s_imageffc_t_control_xywh		= {520,0,400,100},
	s_imageffc_cap_min_xywh 	= {120,120,320,100},
	s_imageffc_min_subb_xywh	= {520,140,60,60},
	s_imageffc_t_min_xywh 		= {580,120,464,100},
	s_imageffc_min_add_xywh 	= {1044,140,60,60},
	s_imageffc_min_value_xywh 	= {1116,140,120,60},
	s_imageffc_cap_tempr_xywh 	= {120,240,320,100},
	s_imageffc_tempr_subb_xywh	= {520,260,60,60},
	s_imageffc_t_tempr_xywh 		= {580,240,464,100},
	s_imageffc_tempr_add_xywh 	= {1044,260,60,60},
	s_imageffc_tempr_value_xywh 	= {1116,260,120,60},
	s_imageffc_shutter_init_xywh = {1600,0,600,80},
	s_imageffc_shutter_adjust_xywh = {1600,130,600,80},
	s_imageffc_background_adjust_xywh = {1600,260,600,80}
};

w1_page_imageffc.clear_data=function ()
	w1_page_imageffc.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imageffc.wnd;
	local data = cfgdata.ffc;
	if(-1 ~= data.ffc_interval_min)then
		data.ffc_interval_min = b_wnd_ex.get_value(top,cwnd.t_min.id);
	end
	if(-1 ~= data.ffc_interval_tempr)then
		data.ffc_interval_tempr = b_wnd_ex.get_value(top,cwnd.t_tempr.id);
	end
	if(-1 ~= data.ffc_control)then
		data.ffc_control = b_wnd_ex.get_sel(top,cwnd.t_control.id);
	end
	cfgdata.change_flag = 1;
	
	b_app_api.set_immediate_color(cfgdata);
	return 0
end

local set_image_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), false);
	end
	local cwnd = w1_page_imageffc.wnd;
	if(id == cwnd.t_min.id) then
		set_text(cwnd.min_value.id, value);
	elseif(id == cwnd.t_tempr.id) then
		set_text(cwnd.tempr_value.id, value);
	end
	uitousercfg(top,w1_page_imageffc.cfg_data);
	b_dlg.dlg_set_redraw(top)
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imageffc.wnd;
		local opearid = nil;
		local m_value = 0
		if(win_id == cwnd.min_subb.id) then
			opearid = cwnd.t_min.id;
			if(-1 == w1_page_imageffc.cfg_data.ffc.shutter_init)then
				m_value = 5
			else
				m_value = 2
			end
		elseif(win_id == cwnd.tempr_subb.id) then
			opearid = cwnd.t_tempr.id;
			m_value = 2
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > m_value) then
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, true);
			set_image_value(top, opearid, value);
		end	
	end
	return 0
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_imageffc.wnd;
		local value = b_wnd_ex.get_value(top, win_id);
		set_image_value(top, win_id, value);
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imageffc.wnd;
		local opearid = nil;
		if(win_id == cwnd.min_add.id) then
			opearid = cwnd.t_min.id;
		elseif(win_id == cwnd.tempr_add.id) then
			opearid = cwnd.t_tempr.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 255) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, false)
			set_image_value(top, opearid, value);
		end
	end
	return 0
end

local on_shutter = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imageffc.wnd;
		local shutter = w1_page_imageffc.cfg_data.ffc.shutter_adjust;
		w1_page_imageffc.cfg_data.ffc.shutter_adjust = shutter+1;
		uitousercfg(top,w1_page_imageffc.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_shutter_init = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local init = w1_page_imageffc.cfg_data.ffc.shutter_init;
		w1_page_imageffc.cfg_data.ffc.shutter_init = init+1;
		uitousercfg(top,w1_page_imageffc.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_background = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imageffc.wnd;
		local background = w1_page_imageffc.cfg_data.ffc.background_adjust;
		w1_page_imageffc.cfg_data.ffc.background_adjust = background+1;
		uitousercfg(top,w1_page_imageffc.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_imageffc.wnd;
		local idx = b_wnd_ex.get_sel(top,cwnd.t_control.id);
		uitousercfg(top,w1_page_imageffc.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local refresh_hide = function(top, param, redraw)
	local cwnd = w1_page_imageffc.wnd;
	if(-1 == param.ffc_control)then
		b_wnd_ex.set_hide(top, cwnd.cap_control.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_control.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_control.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_control.id, false, redraw)
	end
	if(-1 == param.ffc_interval_min)then
		b_wnd_ex.set_hide(top, cwnd.cap_min.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.min_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_min.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.min_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.min_value.id, true, redraw)
	else	
		b_wnd_ex.set_hide(top, cwnd.cap_min.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.min_subb.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_min.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.min_add.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.min_value.id, false, redraw)
	end
	
	if(-1 == param.ffc_interval_tempr)then
		b_wnd_ex.set_hide(top, cwnd.cap_tempr.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.tempr_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_tempr.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.tempr_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.tempr_value.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_tempr.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.tempr_subb.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_tempr.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.tempr_add.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.tempr_value.id, false, redraw)
	end
	
	if(-1 == param.shutter_adjust)then
		b_wnd_ex.set_hide(top, cwnd.shutter_adjust.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.shutter_adjust.id, false, redraw)	
	end
	
	if(-1 == param.background_adjust)then
		b_wnd_ex.set_hide(top, cwnd.background_adjust.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.background_adjust.id, false, redraw)
	end
	
	if(-1 == param.shutter_init)then
		b_wnd_ex.set_hide(top, cwnd.shutter_init.id, true, redraw)
		b_wnd_ex.set_range(top,cwnd.t_min.id,{5,255},redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.shutter_init.id, false, redraw)
		b_wnd_ex.set_range(top,cwnd.t_min.id,{2,255},redraw)
	end
end

w1_page_imageffc.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_imageffc.wnd;
	local sid =cwnd.cap_control.id
	local eid = cwnd.background_adjust.id
	for i=sid,eid  do
		b_wnd_ex.set_hide(top,i, bool_hide, redraw)
	end
end

w1_page_imageffc.set_param = function(top, param, redraw)
	local cwnd = w1_page_imageffc.wnd;
	local data = param.ffc;--w1_page_image.data.color['channel'..chid];
	refresh_hide(top, data, false)
	local set_value = function(id, value)
		b_wnd_ex.set_value(top, id, value, redraw);
	end
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), redraw);
	end

	set_value(cwnd.t_min.id,  data.ffc_interval_min);
	set_value(cwnd.t_tempr.id, data.ffc_interval_tempr);

	set_text(cwnd.min_value.id, data.ffc_interval_min);
	set_text(cwnd.tempr_value.id, data.ffc_interval_tempr);
	
	b_wnd_ex.set_sel(top, cwnd.t_control.id, data.ffc_control, redraw);
	w1_page_imageffc.cfg_data = param;
end

w1_page_imageffc.get_param = function(top)
	local cwnd = w1_page_imageffc.wnd;
	local param = {};
	param.ffc_interval_min = b_wnd_ex.get_value(top,cwnd.t_min.id);
	param.ffc_interval_tempr = b_wnd_ex.get_value(top,cwnd.t_tempr.id);

	return param;
end

w1_page_imageffc.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imageffc_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'cap_control','t_control','cap_min','min_subb', 't_min', 'min_add', 'min_value', 
			'cap_tempr', 'tempr_subb', 't_tempr', 'tempr_add', 'tempr_value','shutter_adjust','background_adjust','shutter_init' },
		
	cap_control = {t='static',id=id+1,xywh='s_imageffc_cap_control_xywh',text='LA_FFC_MODE',font = 'f_image',
					},	
					
	t_control  = {t='combox',id=id+2,xywh='s_imageffc_t_control_xywh',items={'LA_AUTO','LA_MANUAL'},  
					font = 'f_image',cmd = on_update_param
					},
	cap_min	= {t='static',id=id+3,	xywh='s_imageffc_cap_min_xywh',	text='LA_FFC_INTERVAL_M',font = 'f_image'},
	min_subb	= {t='button',id=id+4,	xywh='s_imageffc_min_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_min		= {t='hslider',id=id+5,	xywh='s_imageffc_t_min_xywh',range={5,255},	
					font = 'f_slider', cmd=on_adj},
	min_add	= {t='button',id=id+6,	xywh='s_imageffc_min_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	min_value	= {t='static',id=id+7,	xywh='s_imageffc_min_value_xywh',trans = false},
	--tempr		
	cap_tempr	= {t='static',id=id+8,	xywh='s_imageffc_cap_tempr_xywh',text='LA_FFC_INTERVAL_C',font = 'f_image'},
	tempr_subb	= {t='button',id=id+9,	xywh='s_imageffc_tempr_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_tempr		= {t='hslider',id=id+10,	xywh='s_imageffc_t_tempr_xywh',range={2,255},	
					font = 'f_slider', cmd=on_adj},
	tempr_add	= {t='button',id=id+11,	xywh='s_imageffc_tempr_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	tempr_value	= {t='static',id=id+12,	xywh='s_imageffc_tempr_value_xywh',trans = false},
	
	shutter_init	= {t='button',id=id+13,	xywh='s_imageffc_shutter_init_xywh',
					text	='LA_SHUTTER_INIT',  cmd = on_shutter_init},		
					
	shutter_adjust	= {t='button',id=id+14,	xywh='s_imageffc_shutter_adjust_xywh',
					text	='LA_SHUT_COR',   cmd = on_shutter},
	background_adjust	= {t='button',id=id+15,	xywh='s_imageffc_background_adjust_xywh',
					text	='LA_BACKGROUD_COR',  cmd = on_background},
			
					
	--contrast
	
}

return w1_page_imageffc

