--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.scenes_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local global_val= require("wnd.global_val")
local w1_page_imagescenes = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_imagescenes.s_768 =
{
	s_cfg_page_imagescenes_xywh = {53,366,746,220},
	s_imagescenes_check1_xywh = {32,0,26,35},
	s_imagescenes_corridor_mode_xywh = {58,0,128,35},
	s_imagescenes_cap_where_xywh = {34,42,128,35},
	s_imagescenes_t_where_xywh = {197,42,128,35},
	s_imagescenes_cap_mirror_xywh = {34,85,128,35},
	s_imagescenes_t_mirror_xywh = {197,85,128,35},
	s_imagescenes_check2_xywh = {32,128,26,35},
	s_imagescenes_freeze_mode_xywh = {58,128,128,35},
		
	s_imagescenes_cap_test_xywh = {34,0,128,35},
	s_imagescenes_t_test_xywh = {197,0,128,35},
};

w1_page_imagescenes.s_1280 = 
{
	s_cfg_page_imagescenes_xywh 	= {60,475,900,310},
	s_imagescenes_check1_xywh		= {60,0,40,45},
	s_imagescenes_corridor_mode_xywh = {100,0,170,45},
	s_imagescenes_cap_where_xywh= {60,60,170,45},
	s_imagescenes_t_where_xywh  = {250,60,170,45},
	s_imagescenes_cap_mirror_xywh	= {60,120,170,45},
	s_imagescenes_t_mirror_xywh    = {250,120,170,45},
	s_imagescenes_check2_xywh		= {60,180,50,50},
	s_imagescenes_freeze_mode_xywh= {100,180,200,50},
	
	s_imagescenes_cap_test_xywh= {60,0,170,45},
	s_imagescenes_t_test_xywh  = {250,0,170,45},

};

w1_page_imagescenes.s_1440 = 
{
	s_cfg_page_imagescenes_xywh 	= {60,440,1000,245},
	s_imagescenes_check1_xywh		= {60,0,40,45},
	s_imagescenes_corridor_mode_xywh = {100,0,170,45},
	s_imagescenes_cap_where_xywh= {65,60,170,45},
	s_imagescenes_t_where_xywh  = {260,60,170,45},
	s_imagescenes_cap_mirror_xywh	= {65,120,170,45},
	s_imagescenes_t_mirror_xywh    = {260,120,170,45},
	s_imagescenes_check2_xywh		= {60,180,50,50},
	s_imagescenes_freeze_mode_xywh= {100,180,200,50},
	
	s_imagescenes_cap_test_xywh= {65,0,170,45},
	s_imagescenes_t_test_xywh  = {260,0,170,45},

};

w1_page_imagescenes.s_1080p = 
{
	s_cfg_page_imagescenes_xywh 	= {100,515,1400,310},
	s_imagescenes_check1_xywh		= {60,0,50,50},
	s_imagescenes_corridor_mode_xywh= {110,0,240,50},
	s_imagescenes_cap_where_xywh= {65,60,240,50},
	s_imagescenes_t_where_xywh  = {370,60,240,50},
	s_imagescenes_cap_mirror_xywh	= {65,120,240,50},
	s_imagescenes_t_mirror_xywh    = {370,120,240,50},
	s_imagescenes_check2_xywh		= {60,180,50,50},
	s_imagescenes_freeze_mode_xywh= {110,180,240,50},
	
	s_imagescenes_cap_test_xywh= {65,0,240,50},
	s_imagescenes_t_test_xywh  = {370,0,240,50},

};

w1_page_imagescenes.s_2k = 
{
	s_cfg_page_imagescenes_xywh 	= {133,686,1866,413},
	s_imagescenes_check1_xywh 		= {75,0,67,67},
	s_imagescenes_corridor_mode_xywh= {147,0,320,67},
	s_imagescenes_cap_where_xywh= {85,80,320,67},
	s_imagescenes_t_where_xywh  = {493,80,320,67},
	s_imagescenes_cap_mirror_xywh	= {85,160,320,67},
	s_imagescenes_t_mirror_xywh    = {493,160,320,67},
	s_imagescenes_check2_xywh		= {75,240,67,67},
	s_imagescenes_freeze_mode_xywh	= {147,240,320,67},

	s_imagescenes_cap_test_xywh= {85,0,320,67},
	s_imagescenes_t_test_xywh  = {493,0,320,67},
};

w1_page_imagescenes.s_4k = 
{
	s_cfg_page_imagescenes_xywh 	= {200,1030,2800,620},
	s_imagescenes_check1_xywh 		= {110,0,100,100},
	s_imagescenes_corridor_mode_xywh= {220,0,480,100},
	s_imagescenes_cap_where_xywh= {120,120,480,100},
	s_imagescenes_t_where_xywh  = {740,120,480,100},
	s_imagescenes_cap_mirror_xywh	= {120,240,480,100},
	s_imagescenes_t_mirror_xywh    = {740,240,480,100},
	s_imagescenes_check2_xywh		= {110,380,100,100},
	s_imagescenes_freeze_mode_xywh	= {220,380,480,100},
	
	s_imagescenes_cap_test_xywh= {120,0,480,100},
	s_imagescenes_t_test_xywh  = {740,0,480,100},
};

w1_page_imagescenes.clear_data=function ()
	w1_page_imagescenes.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imagescenes.wnd;
	local data = cfgdata.sence;

	local check1 = b_wnd_ex.get_check(top, cwnd.check1.id);
	local check2 = b_wnd_ex.get_check(top, cwnd.check2.id);
	local where = b_wnd_ex.get_sel(top, cwnd.t_where.id);
	local mirror = b_wnd_ex.get_sel(top, cwnd.t_mirror.id);
	if(-1 ~= data.aisle_enable)then
		if(true == check1)then
			data.aisle_enable = 1;
		else
			data.aisle_enable = 0;
		end
	end
	if(-1 ~= data.freeze)then
		if(true == check2)then
			data.freeze = 1;
		else
			data.freeze = 0;
		end
		
	end
	data.where = where;
	data.mirror = mirror;
	cfgdata.change_flag = 1;
	b_app_api.set_immediate_color(cfgdata);
	return 0
end

local on_enable = function(top, win_id, vmsg, x, y)
	local cwnd = w1_page_imagescenes.wnd;
	if(b_ui.LBUTTONCLK == vmsg)then
		uitousercfg(top,w1_page_imagescenes.cfg_data)
	end
	return 0;
end
local on_where = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_imagescenes.cfg_data)
	end
	return 0;
end

local on_mirror = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_imagescenes.cfg_data)
	end
	return 0;
end

local refresh_hide = function(top, param, redraw)
	local cwnd = w1_page_imagescenes.wnd;
	if(-1 == param.aisle_enable)then
		b_wnd_ex.set_hide(top, cwnd.check1.id, true, redraw);
		b_wnd_ex.set_hide(top, cwnd.corridor.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, cwnd.check1.id, false, redraw);
		b_wnd_ex.set_hide(top, cwnd.corridor.id, false, redraw);
	end
	
	if(-1 == param.freeze)then
		b_wnd_ex.set_hide(top, cwnd.check2.id, true, redraw);
		b_wnd_ex.set_hide(top, cwnd.freeze.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, cwnd.check2.id, false, redraw);
		b_wnd_ex.set_hide(top, cwnd.freeze.id, false, redraw);
	end
	
	if(-1 == param.where)then
		b_wnd_ex.set_hide(top, cwnd.cap_where.id, true, redraw);
		b_wnd_ex.set_hide(top, cwnd.t_where.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_where.id, false, redraw);
		b_wnd_ex.set_hide(top, cwnd.t_where.id, false, redraw);
	end
	
	if(-1 == param.mirror)then
		b_wnd_ex.set_hide(top, cwnd.cap_mirror.id, true, redraw);
		b_wnd_ex.set_hide(top, cwnd.t_mirror.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_mirror.id, false, redraw);
		b_wnd_ex.set_hide(top, cwnd.t_mirror.id, false, redraw);
	end
end

w1_page_imagescenes.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_imagescenes.wnd;
	b_wnd_ex.set_hide(top, cwnd.check1.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.corridor.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_where.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_where.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_mirror.id, bool_hide, redraw)	
	b_wnd_ex.set_hide(top, cwnd.t_mirror.id, bool_hide, redraw)
end

w1_page_imagescenes.set_param = function(top, param, redraw)
	local cwnd = w1_page_imagescenes.wnd;
	local data = param.sence; 
	refresh_hide(top, data,false)
	local dlg_w = global_val.get_size();
	if(dlg_w == 1440) then
		b_wnd_ex.dlg_direct_up(top, cwnd.t_mirror.id, true, false);
	end
	if(-1 == data.aisle_enable and -1 == data.freeze)then
		b_wnd_ex.dlg_direct_up(top, cwnd.t_mirror.id, false, false);
	end
	if(-1 == data.aisle_enable)then
		b_wnd_ex.set_hide(top, cwnd.check1.id, true, redraw);
		b_wnd_ex.set_hide(top, cwnd.corridor.id, true, redraw);
		if(-1 == data.freeze)then
			b_wnd_ex.set_hide(top, cwnd.check2.id, true, redraw);
			b_wnd_ex.set_hide(top, cwnd.freeze.id, true, redraw);
			
			local pos = SIZE('s_imagescenes_cap_test_xywh');
			b_wnd_ex.move_ex(top, cwnd.cap_where.id, pos, redraw);
			pos = SIZE('s_imagescenes_t_test_xywh');
			b_wnd_ex.move_ex(top, cwnd.t_where.id, pos, redraw);
			if data.where==-1 then
				pos = SIZE('s_imagescenes_cap_test_xywh');
				b_wnd_ex.move_ex(top, cwnd.cap_mirror.id, pos, redraw);
				pos = SIZE('s_imagescenes_t_test_xywh');
				b_wnd_ex.move_ex(top, cwnd.t_mirror.id, pos, redraw);
			else
				pos = SIZE('s_imagescenes_cap_where_xywh');
				b_wnd_ex.move_ex(top, cwnd.cap_mirror.id, pos, redraw);
				pos = SIZE('s_imagescenes_t_where_xywh');
				b_wnd_ex.move_ex(top, cwnd.t_mirror.id, pos, redraw);
			end
		
		else
			b_wnd_ex.set_hide(top, cwnd.check2.id, false, redraw);
			b_wnd_ex.set_hide(top, cwnd.freeze.id, false, redraw);
			local pos = SIZE('s_imagescenes_check1_xywh');
			b_wnd_ex.move_ex(top, cwnd.check2.id, pos, redraw);
			pos = SIZE('s_imagescenes_corridor_mode_xywh');
			b_wnd_ex.move_ex(top, cwnd.freeze.id, pos, redraw);
			if(0 == data.freeze)then
				b_wnd_ex.set_check(top, cwnd.check2.id,false,redraw);
			else
				b_wnd_ex.set_check(top, cwnd.check2.id,true,redraw);
			end
			
			local pos = SIZE('s_imagescenes_cap_where_xywh');
			b_wnd_ex.move_ex(top, cwnd.cap_where.id, pos, redraw);
			pos = SIZE('s_imagescenes_t_where_xywh');
			b_wnd_ex.move_ex(top, cwnd.t_where.id, pos, redraw);
			if data.where==-1 then
				pos = SIZE('s_imagescenes_cap_where_xywh');
				b_wnd_ex.move_ex(top, cwnd.cap_mirror.id, pos, redraw);
				pos = SIZE('s_imagescenes_t_where_xywh');
				b_wnd_ex.move_ex(top, cwnd.t_mirror.id, pos, redraw);
			else
				pos = SIZE('s_imagescenes_cap_mirror_xywh');
				b_wnd_ex.move_ex(top, cwnd.cap_mirror.id, pos, redraw);
				pos = SIZE('s_imagescenes_t_mirror_xywh');
				b_wnd_ex.move_ex(top, cwnd.t_mirror.id, pos, redraw);
			end

		end
	else
		b_wnd_ex.set_hide(top, cwnd.check1.id, false, redraw);
		b_wnd_ex.set_hide(top, cwnd.corridor.id, false, redraw);
		if(0 == data.aisle_enable)then
			b_wnd_ex.set_check(top, cwnd.check1.id,false,redraw);
		else
			b_wnd_ex.set_check(top, cwnd.check1.id,true,redraw);
		end
		if(-1 == data.freeze)then
			b_wnd_ex.set_hide(top, cwnd.check2.id, true, redraw);
			b_wnd_ex.set_hide(top, cwnd.freeze.id, true, redraw);
		else
			b_wnd_ex.set_hide(top, cwnd.check2.id, false, redraw);
			b_wnd_ex.set_hide(top, cwnd.freeze.id, false, redraw);
			local pos = SIZE('s_imagescenes_check2_xywh');
			b_wnd_ex.move_ex(top, cwnd.check2.id, pos, redraw);
			pos = SIZE('s_imagescenes_freeze_mode_xywh');
			b_wnd_ex.move_ex(top, cwnd.freeze.id, pos, redraw);
			if(0 == data.freeze)then
				b_wnd_ex.set_check(top, cwnd.check2.id,false,redraw);
			else
				b_wnd_ex.set_check(top, cwnd.check2.id,false,redraw);
			end
		end
		
		local pos = SIZE('s_imagescenes_cap_where_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_where.id, pos, redraw);
		pos = SIZE('s_imagescenes_t_where_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_where.id, pos, redraw);
		if data.where==-1 then
			pos = SIZE('s_imagescenes_cap_where_xywh');
			b_wnd_ex.move_ex(top, cwnd.cap_mirror.id, pos, redraw);
			pos = SIZE('s_imagescenes_t_where_xywh');
			b_wnd_ex.move_ex(top, cwnd.t_mirror.id, pos, redraw);
		else
			pos = SIZE('s_imagescenes_cap_mirror_xywh');
			b_wnd_ex.move_ex(top, cwnd.cap_mirror.id, pos, redraw);
			pos = SIZE('s_imagescenes_t_mirror_xywh');
			b_wnd_ex.move_ex(top, cwnd.t_mirror.id, pos, redraw);
		end
	end
	
	b_wnd_ex.set_sel(top, cwnd.t_where.id, data.where, redraw);
	if(nil ~= data.mirror and data.mirror < 4 )then
		b_wnd_ex.set_sel(top, cwnd.t_mirror.id, data.mirror, redraw);
	else
		b_wnd_ex.set_disable(top, cwnd.t_mirror.id, true, redraw);
	end
	w1_page_imagescenes.cfg_data = param;
end

w1_page_imagescenes.get_param = function(top)
	local cwnd = w1_page_imagescenes.wnd;
	local param = {};
	local check1 = b_wnd_ex.get_check(top, cwnd.check1.id);
	local where = b_wnd_ex.get_sel(top, cwnd.t_where.id);
	local mirror = b_wnd_ex.get_sel(top, cwnd.t_mirror.id);
	if(true == check1)then
		param.aisle_enable = 1;
	else
		param.aisle_enable = 0;
	end
	param.where = where;
	param.mirror = mirror;
	return param
end

w1_page_imagescenes.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imagescenes_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'check1','corridor','check2','freeze','cap_where','t_where','cap_mirror','t_mirror','t_sen'},
		
	check1 	= {t='check', 	id=id+1,xywh='s_imagescenes_check1_xywh',
				--	t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check_select','it_check_select','it_check_select_f', 'it_check_select_f'},
					cmd = on_enable},
					
	corridor = {t='static',id=id+2,xywh='s_imagescenes_corridor_mode_xywh',text='LA_CORRIDOR_MODE',font = 'f_image',
					},	
					
	cap_where = {t='static',id=id+3,xywh='s_imagescenes_cap_where_xywh',text='LA_SCENCE',font = 'f_image',
					},	
	t_where  	= {t='combox',id=id+4,xywh='s_imagescenes_t_where_xywh',items={'LA_INDOOR','LA_OUTDOOR'},font = 'f_image',
					cmd = on_where
					},	
	cap_mirror = {t='static',id=id+5,xywh='s_imagescenes_cap_mirror_xywh',text='LA_MIRROR',font = 'f_image',
					},	
	t_mirror  	= {t='combox',id=id+6,xywh='s_imagescenes_t_mirror_xywh',items={'LA_NORMAL','LA_HORIZONTAL','LA_VERTICAL','LA_HORIZONTAL_VERTICAL'},
					font = 'f_image',cmd =on_mirror,
					},	
	check2 	= {t='check', 	id=id+7,xywh='s_imagescenes_check2_xywh',
				--	t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check_select','it_check_select','it_check_select_f', 'it_check_select_f'},
					cmd = on_enable},
					
	freeze = {t='static',id=id+8,xywh='s_imagescenes_freeze_mode_xywh',text='LA_FREEZE',font = 'f_image',
					},	
}

return w1_page_imagescenes

