--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.imagetime_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_imagetime = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_imagetime.s_768 =
{
	s_cfg_page_imagetime_xywh = {53,366,746,220},
	s_imagetime_check1_xywh = {32,0,26,35},
	s_imagetime_t_enable_xywh = {58,0,106,35},
	s_imagetime_cap_starttime_xywh = {32,42,106,35},
	s_imagetime_t_starttime_xywh = {197,49,106,35},
	s_imagetime_cap_endtime_xywh = {32,85,106,35},
	s_imagetime_t_endtime_xywh = {197,92,106,35},
};

w1_page_imagetime.s_1280 = 
{
	s_cfg_page_imagetime_xywh 		= {60,475,900,270},
	s_imagetime_check1_xywh 		= {60,0,40,45},
	s_imagetime_t_enable_xywh		= {100,0,160,45},
	s_imagetime_cap_starttime_xywh	= {60,60,160,45},
	s_imagetime_t_starttime_xywh    = {250,70,160,45},
	s_imagetime_cap_endtime_xywh	= {60,120,160,45},
	s_imagetime_t_endtime_xywh      = {250,130,160,45},
};

w1_page_imagetime.s_1440 = 
{
	s_cfg_page_imagetime_xywh 		= {60,440,1000,245},
	s_imagetime_check1_xywh 		= {60,0,40,45},
	s_imagetime_t_enable_xywh		= {100,0,160,45},
	s_imagetime_cap_starttime_xywh	= {60,60,160,45},
	s_imagetime_t_starttime_xywh    = {250,60,160,45},
	s_imagetime_cap_endtime_xywh	= {60,120,160,45},
	s_imagetime_t_endtime_xywh      = {250,120,160,45},
};

w1_page_imagetime.s_1080p = 
{
	s_cfg_page_imagetime_xywh 		= {100,515,1400,310},
	s_imagetime_check1_xywh 		= {60,0,50,50},
	s_imagetime_t_enable_xywh		= {110,0,200,50},
	s_imagetime_cap_starttime_xywh	= {60,60,200,50},
	s_imagetime_t_starttime_xywh    = {370,70,200,50},
	s_imagetime_cap_endtime_xywh	= {60,120,200,50},
	s_imagetime_t_endtime_xywh      = {370,130,200,50},

};
w1_page_imagetime.s_2k = 
{
	s_cfg_page_imagetime_xywh 		= {133,686,1866,413},
	s_imagetime_check1_xywh 		= {80,0,67,67},
	s_imagetime_t_enable_xywh		= {147,0,267,67},
	s_imagetime_cap_starttime_xywh	= {80,80,267,67},
	s_imagetime_t_starttime_xywh    = {493,93,267,67},
	s_imagetime_cap_endtime_xywh	= {80,160,267,67},
	s_imagetime_t_endtime_xywh      = {493,173,267,67},

};
w1_page_imagetime.s_4k = 
{
	s_cfg_page_imagetime_xywh 		= {200,1030,2800,620},
	s_imagetime_check1_xywh 		= {120,0,100,100},
	s_imagetime_t_enable_xywh		= {220,0,400,100},
	s_imagetime_cap_starttime_xywh	= {120,120,400,100},
	s_imagetime_t_starttime_xywh    = {740,140,400,100},
	s_imagetime_cap_endtime_xywh	= {120,240,400,100},
	s_imagetime_t_endtime_xywh      = {740,260,400,100},
};

w1_page_imagetime.clear_data=function ()
	w1_page_imagetime.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imagetime.wnd;
	local data = cfgdata.time
	
	local check = b_wnd_ex.get_check(top, cwnd.check1.id);
	if(true == check)then
		data.time_enable = 1;
	else
		data.time_enable = 0;
	end
	
	local s_time = b_wnd_ex.get_time(top, cwnd.t_starttime.id)
	data.s_time_hour = s_time.hour
	data.s_time_min = s_time.minute
	
	local e_time = b_wnd_ex.get_time(top, cwnd.t_endtime.id)
	data.e_time_hour = e_time.hour
	data.e_time_min = e_time.minute 
	cfgdata.change_flag = 1;
	--δȡ
	b_app_api.set_immediate_color(cfgdata);
	return 0
end

local on_enable = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
	--	uitousercfg(top,b_app_cfg.user_cfg);
		uitousercfg(top,w1_page_imagetime.cfg_data)
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_time_update) then
	--	uitousercfg(top,b_app_cfg.user_cfg);
		uitousercfg(top,w1_page_imagetime.cfg_data)
	end
	return 0
end

w1_page_imagetime.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_imagetime.wnd;
	b_wnd_ex.set_hide(top, cwnd.check1.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_enable.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_starttime.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_starttime.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_endtime.id, bool_hide, redraw)	
	b_wnd_ex.set_hide(top, cwnd.t_endtime.id, bool_hide, redraw)

end

w1_page_imagetime.set_param = function(top, param, redraw)
	local cwnd = w1_page_imagetime.wnd;
	local data = param.time;
	if(0 == data.time_enable)then
		b_wnd_ex.set_check(top, cwnd.check1.id,false,redraw);
	else
		b_wnd_ex.set_check(top, cwnd.check1.id,true,redraw);
	end
	local stime = {}
	stime[1] = b_ui.TIME.TIME_24
	stime[2] = (data.s_time_hour < 24) and data.s_time_hour or 23 --ipcΧ0-24 쳣
	stime[3] = data.s_time_min
	stime[4] = 0
	stime[5] = 1
	if(stime[2] >23)then
		local test =0;
	end
	b_wnd_ex.set_time(top, cwnd.t_starttime.id, stime, redraw)
	
	local etime = {}
	etime[1] = b_ui.TIME.TIME_24
	etime[2] = (data.e_time_hour < 24) and data.e_time_hour or 23
	etime[3] = data.e_time_min
	etime[4] = 0
	etime[5] = 1
	if(etime[2] >23)then
		local test =0;
	end
	b_wnd_ex.set_time(top, cwnd.t_endtime.id, etime, redraw)	
	w1_page_imagetime.cfg_data = param;
end

w1_page_imagetime.get_param = function(top)
	local cwnd = w1_page_imagetime.wnd;
	local param = {};
	local check = b_wnd_ex.get_check(top, cwnd.check1.id);
	if(true == check)then
		param.time_enable = 1;
	else
		param.time_enable = 0;
	end
	
	local s_time = b_wnd_ex.get_time(top, cwnd.t_starttime.id)
	param.s_time_hour = s_time.hour
	param.s_time_min = s_time.minute
	
	local e_time = b_wnd_ex.get_time(top, cwnd.t_endtime.id)
	param.e_time_hour = e_time.hour
	param.e_time_min = e_time.minute 
	--δȡ
	return param
end

w1_page_imagetime.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imagetime_xywh',	
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'check1','t_enable','cap_starttime','t_starttime','cap_endtime','t_endtime'},
					
	check1 	= {t='check', 	id=id+1,xywh='s_imagetime_check1_xywh',
				--	t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check_select','it_check_select','it_check_select_f', 'it_check_select_f'},
					cmd = on_enable},
					
	t_enable = {t='static',id=id+2,xywh='s_imagetime_t_enable_xywh',text='LA_ENABLE',font = 'f_image',
					},	
					
	cap_starttime = {t='static',id=id+3,xywh='s_imagetime_cap_starttime_xywh',text='LA_START_TIME',font = 'f_image',
					},															--time еλ
	t_starttime  	= {t='time_edit',id=id+4,xywh='s_imagetime_t_starttime_xywh',time = {b_ui.TIME.TIME_24,1,0,0,1}, 
					trans = false,font = 'f_image',cmd = on_update_param
					},	
	cap_endtime = {t='static',id=id+5,xywh='s_imagetime_cap_endtime_xywh',text='LA_END_TIME',font = 'f_image',
					},	
	t_endtime  	= {t='time_edit',id=id+6,xywh='s_imagetime_t_endtime_xywh',time = {b_ui.TIME.TIME_24,1,0,0,1}, 
					trans = false,font = 'f_image',cmd = on_update_param
					},	
}

return w1_page_imagetime

