--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local global_val 	=  require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_lan_info.lan_info_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_app_api = require("wnd.core.command.b_app_api");
local b_dlg 	= require("wnd.core.b_dlg")
local t_qr_lan_info = "P2P";				-- [QR code]P2Pά
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_size	= require("wnd.core.r_res.r_size")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local SIZE		= r_size.get_size;
local flag = 0;
local show_trans = 1;--3 all 1 transmit  2 receive
local show_rec = 2;
local tr_flag = 1;
local rr_flag = 1;
local show_lan = 1;
local nic_num = 1; -- 
local w1_page_lan_info = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_lan_info.s_768 =
{
	s_line_chart_xywh = {80,348,690,7},
	s_line_max_xywh = {5,49,74,35},
	s_line_mid_xywh = {5,188,74,35},
	s_t_line_trans_xywh = {192,378,16,2},
	s_line_trans_xywh = {210,362,213,35},
	s_t_line_rec_xywh = {426,378,16,2},
	s_line_rec_xywh = {445,362,213,35},
	s_line_start_xywh = {53,327,21,35},
	s_line_nic_xywh = {80,362,53,35},
	s_line_info_list_xywh = {26,483,746,142},
	s_info_list_w1 = {141,0,0,0},
	s_info_list_w2 = {170,0,0,0},
	s_info_list_w3 = {197,0,0,0},
	s_info_list_w4 = {141,0,0,0},
	s_info_list_w5 = {85,0,0,0},

	s_chart_size = {8,10,36,69},
};

w1_page_lan_info.s_1280 = 
{
	s_line_chart_xywh = {120,410,500,10},
	s_line_max_xywh = {5,20,115,50},
	s_line_mid_xywh = {5,200,115,50},
	s_t_line_trans_xywh = {310,472,30,4},
	s_line_trans_xywh = {345,450,300,50},
	s_t_line_rec_xywh = {660,472,30,4},
	s_line_rec_xywh = {695,450,300,50},
	s_line_start_xywh = {60,390,40,50},
	s_line_nic_xywh = {100,450,100,50},
	s_line_info_list_xywh = {50,600,910,200},
	s_info_list_w1 = {185,0,0,0},
	s_info_list_w2 = {210,0,0,0},
	s_info_list_w3 = {210,0,0,0},
	s_info_list_w4 = {185,0,0,0},
	s_info_list_w5 = {90,0,0,0},

	
	s_chart_size = {8,10,45,80},--row ,col ,height,width
}

w1_page_lan_info.s_1440 = 
{
	s_line_chart_xywh = {150,400,500,10},
	s_line_max_xywh = {10,20,140,50},
	s_line_mid_xywh = {10,200,140,50},
	s_t_line_trans_xywh = {310,442,30,4},
	s_line_trans_xywh = {345,420,300,50},
	s_t_line_rec_xywh = {660,442,30,4},
	s_line_rec_xywh = {695,420,300,50},
	s_line_start_xywh = {100,380,40,50},
	s_line_nic_xywh = {150,420,100,50},
	s_line_info_list_xywh = {50,550,1010,150},
	s_info_list_w1 = {190,0,0,0},
	s_info_list_w2 = {245,0,0,0},
	s_info_list_w3 = {245,0,0,0},
	s_info_list_w4 = {210,0,0,0},
	s_info_list_w5 = {100,0,0,0},

	
	s_chart_size = {8,9,45,100},
}

w1_page_lan_info.s_1080p = 
{
	s_line_chart_xywh = {150,490,960,10},
	s_line_max_xywh = {10,70,140,50},
	s_line_mid_xywh = {10,265,140,50},
	s_t_line_trans_xywh = {360,532,30,4},
	s_line_trans_xywh = {395,510,400,50},
	s_t_line_rec_xywh = {800,532,30,4},
	s_line_rec_xywh = {835,510,400,50},
	s_line_start_xywh = {100,460,40,50},
	s_line_nic_xywh = {150,510,100,50},
	s_line_info_list_xywh = {50,680,1400,200},
	s_info_list_w1 = {265,0,0,0},
	s_info_list_w2 = {320,0,0,0},
	s_info_list_w3 = {370,0,0,0},
	s_info_list_w4 = {265,0,0,0},
	s_info_list_w5 = {160,0,0,0},


	s_chart_size = {8,12,50,108},
}

w1_page_lan_info.s_2k = 
{
	s_line_trans_xywh = {525,678,532,66},
	s_t_line_rec_xywh = {1064,707,39,5},
	s_line_rec_xywh = {1110,678,532,66},
	s_t_line_trans_xywh = {478,707,39,5},
	s_line_max_xywh = {13,93,186,66},
	s_line_mid_xywh = {13,352,186,66},
	s_line_chart_xywh = {199,651,1276,13},
	s_line_nic_xywh = {189,678,133,66},
	s_line_start_xywh = {133,625,53,66},
	s_line_info_list_xywh = {66,918,1860,266},
	s_info_list_w1 = {345,0,0,0},
	s_info_list_w2 = {420,0,0,0},
	s_info_list_w3 = {500,0,0,0},
	s_info_list_w4 = {345,0,0,0},
	s_info_list_w5 = {180,0,0,0},

	s_chart_size = {8,12,65,140},
}

w1_page_lan_info.s_4k = 
{
	s_chart_size = {8,12,100,216},
	s_line_trans_xywh = {790,1020,800,100},
	s_t_line_rec_xywh = {1600,1064,60,8},
	s_line_info_list_xywh = {100,1360,2800,400},
	s_line_rec_xywh = {1670,1020,800,100},
	s_info_list_w4 = {530,0,0,0},
	s_info_list_w1 = {530,0,0,0},
	s_t_line_trans_xywh = {720,1064,60,8},
	s_line_max_xywh = {20,140,280,100},
	s_line_mid_xywh = {20,530,280,100},
	s_info_list_w3 = {740,0,0,0},
	s_line_chart_xywh = {300,980,1920,20},
	s_info_list_w2 = {640,0,0,0},
	s_info_list_w5 = {320,0,0,0},
	s_line_nic_xywh = {300,1020,200,100},
	s_line_start_xywh = {200,940,80,100},
}

local reflsh_list = function (top)
	local cfg_network = b_app_api.get_network_info();
	local displist = {};
	local idx = 0;
	local status = {};
	local mac = {}
	mac[1] = cfg_network['dev_mac']
	status[1]= cfg_network.lan
	
	if nic_num==2 then
		mac[2] = cfg_network['dev_mac1']
		status[2]= cfg_network.lan1
	end
	for i=1,nic_num do
		local lan_status = ""
		if(status[i])then
			lan_status=STR('LA_ONLINE')
		else
			lan_status=STR('LA_OFFLINE');
		end
		idx = idx +1;
		displist['idx'..idx] = {idx-1, false,"LAN"..i,lan_status,mac[i],cfg_network['mtu'],''};
	end
	displist.item_total = idx;
	b_wnd_ex.set_listdata(top, w1_page_lan_info.wnd.info_list.id, displist, false);
	if nic_num==1 then
		b_wnd_ex.set_list_end_nofind(top,w1_page_lan_info.wnd.info_list.id,{true,true},false)
	else
		b_wnd_ex.set_list_end_nofind(top,w1_page_lan_info.wnd.info_list.id,{false,true},false)
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)

	local c_wnd = w1_page_lan_info.wnd
	b_wnd_ex.set_enableselect(top,w1_page_lan_info.wnd.line_chart.id,false,false);
	b_wnd_ex.set_block_clear(top,c_wnd.line_chart.id,{'1'},false);--
	flag = 0
	local cfg_network = b_app_api.get_network_info();
	local device_info = b_app_api.get_device_info();
	nic_num = device_info.nic_num
	reflsh_list(top)
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)

	return 0
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_alan_infoly = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onalan_infoly(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_lan_info.timer_start = function()
	w1_page_lan_info.timestart = true
end

w1_page_lan_info.timer_stop = function(top)
	w1_page_lan_info.timestart = false
	w1_wnd_util.tipclear(top, w1_page_lan_info.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_lan_info.timerenevt = function(top)
	if(w1_page_lan_info.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_lan_info.wnd.tipinfo.id)
		local show_idx = show_trans+show_rec
		b_wnd_ex.set_enableselect(top,w1_page_lan_info.wnd.line_chart.id,true,false);
		local lan_name ="eth"
		if show_lan==1 then
			lan_name=lan_name..tostring(0)
			b_wnd_ex.set_text(top,w1_page_lan_info.wnd.cap_nic.id,"LAN1",false)
		else
			lan_name=lan_name..tostring(1)
			b_wnd_ex.set_text(top,w1_page_lan_info.wnd.cap_nic.id,"LAN2",false)
		end
		
		local info = b_app_api.get_net_flow(lan_name)
		if (type(info) ~= "table")	then
			return ;	
		end
		
		local tr = 1;
		local rr = 1;
		local str  = ""	
		local y_str = ""
		if info['transmit']>1024 or info['rec']>1024 then
			tr = math.floor(info['transmit']/1024)
			rr = math.floor(info['rec']/1024)
			if tr>1024 or rr>1024 then
				tr = string.format("%.2f", tr/1024)
				rr = string.format("%.2f", rr/1024)
				str = "Mbps"
			else
				str = "Kbps"
			end
		else
			tr = info['transmit']
			rr = info['rec']
			str = "bps"
		end
		b_wnd_ex.set_net_flow(top,w1_page_lan_info.wnd.line_chart.id,{tonumber(info['transmit']),tonumber(info['rec']),show_idx},false)
		local max = b_wnd_ex.get_net_flow_max(top,w1_page_lan_info.wnd.line_chart.id)
	
		if max>1024 then
			y_str = "Kbps"
			max = math.floor(max /1024)
			if max > 1024 then
				max =  math.floor(max /1024)
				y_str = "Mbps"
			end
		else
			y_str = "bps"
		end
		
		local max_str = tostring(max)..y_str
		b_wnd_ex.set_text(top,w1_page_lan_info.wnd.cap_max.id,max_str,false)
		max_str = math.floor(max/2)..y_str
		b_wnd_ex.set_text(top,w1_page_lan_info.wnd.cap_mid.id,max_str,false)
		local tr_str =STR('LA_TRANSMIT_RATE').." : "..tr..str
		local rr_str =STR('LA_RECEIVE_RATE').." : ".. rr..str
		b_wnd_ex.set_text(top,w1_page_lan_info.wnd.cap_trans.id,tr_str,false)
		b_wnd_ex.set_text(top,w1_page_lan_info.wnd.cap_rec.id,rr_str,false)

		reflsh_list(top)
		b_wnd_ex.set_hide(top,w1_page_lan_info.wnd.line_chart.id,false,false)
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_lan_info.init = function(top)
	w1_wnd_util.cfgtab = {''}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_lan_info.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

local on_trans = function (top,wnd_id,vmsg,x,y)
	if vmsg==b_ui.LBUTTONCLK then
		local cwnd = w1_page_lan_info.wnd;
		if tr_flag == 1 then
			tr_flag = 0
			b_wnd_ex.set_color(top,cwnd.line_trans.id,
		{COLOR('c_txt_d'),COLOR('c_txt_d'),COLOR('c_txt_d')},false)
			b_wnd_ex.set_color(top,cwnd.cap_trans.id,
		{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_txt_d')},false)
			show_trans = 0
		else
			tr_flag = 1
			b_wnd_ex.set_color(top,cwnd.line_trans.id,
		{COLOR('c_thermal_min_temper'),COLOR('c_thermal_min_temper'),COLOR('c_thermal_min_temper')},false)
			b_wnd_ex.set_color(top,cwnd.cap_trans.id,
		{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_thermal_min_temper')},false)
			show_trans = 1
		end
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_rec = function (top,wnd_id,vmsg,x,y)
	if vmsg==b_ui.LBUTTONCLK then
		local cwnd = w1_page_lan_info.wnd;
		if rr_flag == 1 then
			rr_flag = 0
			b_wnd_ex.set_color(top,cwnd.line_rec.id,
		{COLOR('c_txt_d'),COLOR('c_txt_d'),COLOR('c_txt_d')},false)
			b_wnd_ex.set_color(top,cwnd.cap_rec.id,
		{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_txt_d')},false)
			show_rec = 0
		else
			rr_flag = 1
			b_wnd_ex.set_color(top,cwnd.line_rec.id,
		{COLOR('c_thermal_max_temper'),COLOR('c_thermal_max_temper'),COLOR('c_thermal_max_temper')},false)
			b_wnd_ex.set_color(top,cwnd.cap_rec.id,
		{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_thermal_max_temper')},false)
			show_rec = 2
		end
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_list = function (top,wnd_id,vmsg,x,y)
	if vmsg==b_ui.LBUTTONCLK then
		local cwnd = w1_page_lan_info.wnd;
		local pos = SIZE('s_line_info_list_xywh')
		if y>pos[2]+math.floor(pos[4]/3) then
			if nic_num>1 then
				show_lan = b_wnd_ex.get_list_idx(top,cwnd.info_list.id,x,y)+1;
				b_wnd_ex.set_end_selecelist_only(top,cwnd.info_list.id,show_lan-1,true)
			end	
		end
	end
	return 0;
end

w1_page_lan_info.on_pre_show = function (top)
	local param = {
			STR('LA_NIC'), STR('LA_STATUS'),STR('LA_MAC_ADDRESS'),STR('LA_MTU'),STR('LA_DISPLAY')
		}	
	b_wnd_ex.set_title_texts(top, w1_page_lan_info.wnd.info_list.id, param, false)
	
	local list_w = {};
	for i=1,5 do
		local str = 's_info_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, w1_page_lan_info.wnd.info_list.id, list_w, false);
	local size = SIZE('s_chart_size')
	b_wnd_ex.set_chart_size(top,w1_page_lan_info.wnd.line_chart.id,size,false)
	local show_lan1={}
	show_lan1[1] =1
	b_wnd_ex.set_end_selecelist(top,w1_page_lan_info.wnd.info_list.id,show_lan1,false)
	show_lan = 1
end

w1_page_lan_info.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'line_chart','cap_max','cap_mid', 'cap_start','cap_trans','cap_rec','cap_nic',
			'line_trans','line_rec','info_list','apply' },
	
	line_chart  = {t='line_chart',id=id+1,xywh = 's_line_chart_xywh',},
	cap_max 	= {t='static',	id=id+2,	xywh='s_line_max_xywh',text='512kbps',trans=false, align = b_ui.ALIGN.RIGHT},	
	
	cap_mid 	= {t='static',	id=id+3,	xywh='s_line_mid_xywh',text='512kbps',trans=false, align = b_ui.ALIGN.RIGHT},	
	
	cap_start	= {t='static',	id=id+4,	xywh='s_line_start_xywh',text='0',trans= false, align = b_ui.ALIGN.RIGHT},	
	
	line_trans  = {t='hline',	id=id+5,	xywh='s_t_line_trans_xywh',
			color = {'c_thermal_min_temper', 'c_thermal_min_temper', 'c_thermal_min_temper'},},
	cap_trans	= {t='button',id=id+6,xywh='s_line_trans_xywh',text='LA_TRANSMIT_RATE',cmd=on_trans,align = b_ui.ALIGN.LEFT,
		color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_thermal_min_temper',},
		color_f = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_f',}},	
	
	line_rec  = {t='hline',	id=id+7,	xywh='s_t_line_rec_xywh',
			color = {'c_thermal_max_temper', 'c_thermal_max_temper', 'c_thermal_max_temper'},},
	cap_rec	= {t='button',id=id+8,xywh='s_line_rec_xywh',text='LA_RECEIVE_RATE',cmd=on_rec,align = b_ui.ALIGN.LEFT,
		color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_thermal_max_temper',},
		color_f = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_f',}},
		
	cap_nic 	= {t='static',	id=id+9,	xywh='s_line_nic_xywh',text='LAN',trans=false, align = b_ui.ALIGN.LEFT},	
	info_list	= {t='list',	id=id+10,	xywh=	's_line_info_list_xywh', font = 'f_camera_list',
					listattr = {2,5,b_ui.LISTATTR.FIRST_WIDGET_STATIC, b_ui.LISTATTR.END_WIDGET_CHECK},
					cmd= on_list},	

	tipinfo		= {t='static',	id=id+11,	xywh='s_pp_tipinfo_xywh',text='',trans = false},
	apply 		= {t='button',	id=id+12,	xywh='s_cfg_alan_infoly_xywh', 	text='LA_APPLY',	cmd=on_apply},
}


return w1_page_lan_info



