--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_ai.multi_obj_param_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")
local b_dlg 	= require("wnd.core.b_dlg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_page_multi_objparam = 
{
	cfg_data,
	cap_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_multi_objparam.s_768 =
{
	s_cfg_page_multi_objparam_xywh = {53,320,746,220},
	s_multi_obj_cap_face_detect_xywh = {32,0,149,32},
	s_multi_obj_t_face_detect_xywh = {237,4,25,21},
	s_multi_obj_cap_person_detect_xywh = {32,35,149,32},
	s_multi_obj_t_person_detect_xywh = {237,40,25,21},
	s_multi_obj_cap_plate_detect_xywh = {32,71,149,32},
	s_multi_obj_t_plate_detect_xywh = {237,76,25,21},
	s_multi_obj_cap_vehicle_detect_xywh = {32,106,149,32},
	s_multi_obj_t_vehicle_detect_xywh = {237,111,25,21},
	s_multi_obj_cap_trace_info_xywh = {32,142,149,32},
	s_multi_obj_t_trace_info_xywh = {240,142,117,32},
	s_multi_obj_cap_detect_area_xywh = {32,177,149,32},
	s_multi_obj_t_detect_area_xywh = {237,182,25,21},
	s_multi_obj_cap_con_coe_xywh = {32,213,149,32},
	s_multi_obj_t_con_coe_xywh = {240,213,117,32},
	s_multi_obj_cap_face_pix_min_xywh = {32,248,149,32},
	s_multi_obj_t_face_pix_min_xywh = {240,248,117,32},
	s_multi_obj_cap_person_pix_min_xywh = {32,284,149,32},
	s_multi_obj_t_person_pix_min_xywh = {240,284,117,32},
	s_multi_obj_cap_plate_pix_min_xywh = {32,320,149,32},
	s_multi_obj_t_plate_pix_min_xywh = {240,320,117,32},
	s_multi_obj_cap_vehicle_pix_min_xywh = {32,355,149,32},
	s_multi_obj_t_vehicle_pix_min_xywh = {240,355,117,32},
		
	s_multi_obj_cap_mat_qua_xywh = {376,0,149,32},
	s_multi_obj_t_mat_qua_xywh = {584,0,117,32},
	s_multi_obj_cap_attr_xywh = {376,35,154,32},
	s_multi_obj_t_attr_xywh = {581,40,25,21},
	s_multi_obj_cap_snap_mode_xywh = {376,71,149,32},
	s_multi_obj_t_snap_mode_xywh = {584,71,117,32},
	s_multi_obj_cap_img_int_xywh = {376,106,149,32},
	s_multi_obj_t_img_int_xywh = {584,106,117,32},
	s_multi_obj_cap_yaw_deg_xywh = {376,142,149,32},
	s_multi_obj_t_yaw_deg_xywh = {584,142,117,32},
	s_multi_obj_cap_tilt_deg_xywh = {376,177,149,32},
	s_multi_obj_t_tilt_deg_xywh = {584,177,117,32},
	s_multi_obj_cap_pitch_deg_xywh = {376,213,149,32},
	s_multi_obj_t_pitch_deg_xywh = {584,213,117,32},
	s_multi_obj_cap_ftp_img_mat_xywh = {376,248,149,32},
	s_multi_obj_t_ftp_img_mat_xywh = {581,253,25,21},
	s_multi_obj_cap_ftp_whole_img_xywh = {376,284,149,32},
	s_multi_obj_t_ftp_whole_img_xywh = {581,289,25,21},
	s_multi_obj_cap_alg_lib_ver_xywh = {376,320,149,32},
	s_multi_obj_t_alg_lib_ver_xywh = {584,320,117,32},
	s_multi_obj_hline_xywh = {368,0,1,284},
	s_multi_obj_vdrop_xywh = {706,0,10,277},
	s_multi_obj_l_cap_line = {32,0,170,32},
	s_multi_obj_l_t_line = {240,0,117,32},
	s_multi_obj_r_cap_line = {376,0,170,32},
	s_multi_obj_r_t_line = {584,0,117,32},
	s_multi_obj_tt_check_xywh = {2,4,25,21},
	s_multi_obj_int_xywh = {0,0,35,0},
};

w1_page_multi_objparam.s_1280 = 
{
	s_cfg_page_multi_objparam_xywh = {60,440,900,310},
	s_multi_obj_cap_face_detect_xywh = {40,0,270,45},
	s_multi_obj_t_face_detect_xywh = {315,7,48,30},
	s_multi_obj_cap_person_detect_xywh = {40,50,270,45},
	s_multi_obj_t_person_detect_xywh = {315,57,48,30},
	s_multi_obj_cap_plate_detect_xywh = {40,100,270,45},
	s_multi_obj_t_plate_detect_xywh = {315,107,48,30},
	s_multi_obj_cap_vehicle_detect_xywh = {40,150,270,45},
	s_multi_obj_t_vehicle_detect_xywh = {315,157,48,30},
	s_multi_obj_cap_trace_info_xywh = {40,200,270,45},
	s_multi_obj_t_trace_info_xywh = {320,200,160,45},
	s_multi_obj_cap_detect_area_xywh = {40,250,270,45},
	s_multi_obj_t_detect_area_xywh = {315,257,48,30},
	s_multi_obj_cap_con_coe_xywh = {40,300,270,45},
	s_multi_obj_t_con_coe_xywh = {320,300,160,45},
	s_multi_obj_cap_face_pix_min_xywh = {40,350,270,45},
	s_multi_obj_t_face_pix_min_xywh = {320,350,160,45},
	s_multi_obj_cap_person_pix_min_xywh = {40,400,270,45},
	s_multi_obj_t_person_pix_min_xywh = {320,400,160,45},
	s_multi_obj_cap_plate_pix_min_xywh = {40,450,270,45},
	s_multi_obj_t_plate_pix_min_xywh = {320,450,160,45},
	s_multi_obj_cap_vehicle_pix_min_xywh = {40,500,270,45},
	s_multi_obj_t_vehicle_pix_min_xywh = {320,500,160,45},
	
	s_multi_obj_cap_mat_qua_xywh = {505,0,270,45},
	s_multi_obj_t_mat_qua_xywh = {780,0,160,45},
	s_multi_obj_cap_attr_xywh = {505,50,270,45},
	s_multi_obj_t_attr_xywh = {775,57,48,30},
	s_multi_obj_cap_snap_mode_xywh = {505,100,270,45},
	s_multi_obj_t_snap_mode_xywh = {780,100,160,45},
	s_multi_obj_cap_img_int_xywh = {505,150,270,45},
	s_multi_obj_t_img_int_xywh = {780,150,160,45},
	s_multi_obj_cap_yaw_deg_xywh = {505,200,270,45},
	s_multi_obj_t_yaw_deg_xywh = {780,200,160,45},
	s_multi_obj_cap_tilt_deg_xywh = {505,250,270,45},
	s_multi_obj_t_tilt_deg_xywh = {780,250,160,45},
	s_multi_obj_cap_pitch_deg_xywh = {505,300,270,45},
	s_multi_obj_t_pitch_deg_xywh = {780,300,160,45},
	s_multi_obj_cap_ftp_img_mat_xywh = {505,350,270,45},
	s_multi_obj_t_ftp_img_mat_xywh = {775,357,48,30},
	s_multi_obj_cap_ftp_whole_img_xywh = {505,400,270,45},
	s_multi_obj_t_ftp_whole_img_xywh = {775,407,48,30},
	s_multi_obj_cap_alg_lib_ver_xywh = {505,450,270,45},
	s_multi_obj_t_alg_lib_ver_xywh = {780,450,160,45},
	s_multi_obj_hline_xywh = {495,0,1,350},
	s_multi_obj_vdrop_xywh = {940,0,20,350},
	s_multi_obj_l_cap_line = {40,0,270,45},
	s_multi_obj_l_t_line = {320,0,160,45},
	s_multi_obj_r_cap_line = {505,0,270,45},
	s_multi_obj_r_t_line = {780,0,160,45},
	s_multi_obj_tt_check_xywh = {5,7,48,30},
	s_multi_obj_int_xywh = {0,0,50,0}
};

w1_page_multi_objparam.s_1440 = 
{
	s_cfg_page_multi_objparam_xywh = {60,332,900,245},
	s_multi_obj_cap_face_detect_xywh = {40,0,270,45},
	s_multi_obj_t_face_detect_xywh = {315,7,48,30},
	s_multi_obj_cap_person_detect_xywh = {40,50,270,45},
	s_multi_obj_t_person_detect_xywh	= {315,57,48,30},
	s_multi_obj_cap_plate_detect_xywh = {40,100,270,45},
	s_multi_obj_t_plate_detect_xywh = {315,107,48,30},
	s_multi_obj_cap_vehicle_detect_xywh = {40,150,270,45},
	s_multi_obj_t_vehicle_detect_xywh = {315,157,48,30},
	s_multi_obj_cap_trace_info_xywh = {40,200,270,45},
	s_multi_obj_t_trace_info_xywh = {320,200,160,45},
	s_multi_obj_cap_detect_area_xywh = {40,250,270,45},
	s_multi_obj_t_detect_area_xywh = {315,257,48,30},
	s_multi_obj_cap_con_coe_xywh = {40,300,270,45},
	s_multi_obj_t_con_coe_xywh = {320,300,160,45},
	s_multi_obj_cap_face_pix_min_xywh = {40,350,270,45},
	s_multi_obj_t_face_pix_min_xywh = {320,350,160,45},
	s_multi_obj_cap_person_pix_min_xywh = {40,400,270,45},
	s_multi_obj_t_person_pix_min_xywh = {320,400,160,45},
	s_multi_obj_cap_plate_pix_min_xywh = {40,450,270,45},
	s_multi_obj_t_plate_pix_min_xywh = {320,450,160,45},
	s_multi_obj_cap_vehicle_pix_min_xywh = {40,500,270,45},
	s_multi_obj_t_vehicle_pix_min_xywh = {320,500,160,45},
	
	s_multi_obj_cap_mat_qua_xywh = {505,0,270,45},
	s_multi_obj_t_mat_qua_xywh = {780,0,160,45},
	s_multi_obj_cap_attr_xywh = {505,50,270,45},
	s_multi_obj_t_attr_xywh = {775,57,48,30},
	s_multi_obj_cap_snap_mode_xywh = {505,100,270,45},
	s_multi_obj_t_snap_mode_xywh = {780,100,160,45},
	s_multi_obj_cap_img_int_xywh = {505,150,270,45},
	s_multi_obj_t_img_int_xywh = {780,150,160,45},
	s_multi_obj_cap_yaw_deg_xywh = {505,200,270,45},
	s_multi_obj_t_yaw_deg_xywh = {780,200,160,45},
	s_multi_obj_cap_tilt_deg_xywh = {505,250,270,45},
	s_multi_obj_t_tilt_deg_xywh = {780,250,160,45},
	s_multi_obj_cap_pitch_deg_xywh = {505,300,270,45},
	s_multi_obj_t_pitch_deg_xywh = {780,300,160,45},
	s_multi_obj_cap_ftp_img_mat_xywh = {505,350,270,45},
	s_multi_obj_t_ftp_img_mat_xywh = {775,357,48,30},
	s_multi_obj_cap_ftp_whole_img_xywh = {505,400,270,45},
	s_multi_obj_t_ftp_whole_img_xywh = {775,407,48,30},
	s_multi_obj_cap_alg_lib_ver_xywh = {505,450,270,45},
	s_multi_obj_t_alg_lib_ver_xywh = {780,450,160,45},
	s_multi_obj_hline_xywh = {495,0,1,350},
	s_multi_obj_vdrop_xywh = {950,0,20,345},
	s_multi_obj_l_cap_line = {40,0,270,45},
	s_multi_obj_l_t_line = {320,0,160,45},
	s_multi_obj_r_cap_line = {505,0,270,45},
	s_multi_obj_r_t_line = {780,0,160,45},
	s_multi_obj_tt_check_xywh = {5,7,48,30},
	s_multi_obj_int_xywh = {0,0,50,0}
};

w1_page_multi_objparam.s_1080p = 
{
	s_cfg_page_multi_objparam_xywh = {100,450,1400,310},
	s_multi_obj_cap_face_detect_xywh = {60,0,280,45},
	s_multi_obj_t_face_detect_xywh = {445,7,48,30},
	s_multi_obj_cap_person_detect_xywh = {60,50,280,45},
	s_multi_obj_t_person_detect_xywh = {445,57,48,30},
	s_multi_obj_cap_plate_detect_xywh = {60,100,280,45},
	s_multi_obj_t_plate_detect_xywh = {445,107,48,30},
	s_multi_obj_cap_vehicle_detect_xywh = {60,150,280,45},
	s_multi_obj_t_vehicle_detect_xywh = {445,157,48,30},
	s_multi_obj_cap_trace_info_xywh = {60,200,280,45},
	s_multi_obj_t_trace_info_xywh = {450,200,220,45},
	s_multi_obj_cap_detect_area_xywh = {60,250,280,45},
	s_multi_obj_t_detect_area_xywh = {445,257,48,30},
	s_multi_obj_cap_con_coe_xywh = {60,300,280,45},
	s_multi_obj_t_con_coe_xywh = {450,300,220,45},
	s_multi_obj_cap_face_pix_min_xywh = {60,350,280,45},
	s_multi_obj_t_face_pix_min_xywh = {450,350,220,45},
	s_multi_obj_cap_person_pix_min_xywh = {60,400,280,45},
	s_multi_obj_t_person_pix_min_xywh = {450,400,220,45},
	s_multi_obj_cap_plate_pix_min_xywh = {60,450,280,45},
	s_multi_obj_t_plate_pix_min_xywh = {450,450,220,45},
	s_multi_obj_cap_vehicle_pix_min_xywh = {60,500,280,45},
	s_multi_obj_t_vehicle_pix_min_xywh = {450,500,220,45},
	
	s_multi_obj_cap_mat_qua_xywh = {705,0,280,45},
	s_multi_obj_t_mat_qua_xywh = {1095,0,220,45},
	s_multi_obj_cap_attr_xywh = {705,50,290,45},
	s_multi_obj_t_attr_xywh = {1090,57,48,30},
	s_multi_obj_cap_snap_mode_xywh = {705,100,280,45},
	s_multi_obj_t_snap_mode_xywh = {1095,100,220,45},
	s_multi_obj_cap_img_int_xywh = {705,150,280,45},
	s_multi_obj_t_img_int_xywh = {1095,150,220,45},
	s_multi_obj_cap_yaw_deg_xywh = {705,200,280,45},
	s_multi_obj_t_yaw_deg_xywh = {1095,200,220,45},
	s_multi_obj_cap_tilt_deg_xywh = {705,250,280,45},
	s_multi_obj_t_tilt_deg_xywh = {1095,250,220,45},
	s_multi_obj_cap_pitch_deg_xywh = {705,300,280,45},
	s_multi_obj_t_pitch_deg_xywh = {1095,300,220,45},
	s_multi_obj_cap_ftp_img_mat_xywh = {705,350,280,45},
	s_multi_obj_t_ftp_img_mat_xywh = {1090,357,48,30},
	s_multi_obj_cap_ftp_whole_img_xywh = {705,400,280,45},
	s_multi_obj_t_ftp_whole_img_xywh = {1090,407,48,30},
	s_multi_obj_cap_alg_lib_ver_xywh = {705,450,280,45},
	s_multi_obj_t_alg_lib_ver_xywh = {1095,450,220,45},
	s_multi_obj_hline_xywh = {690,0,2,400},
	s_multi_obj_vdrop_xywh = {1325,0,20,390},
	s_multi_obj_l_cap_line = {60,0,320,45},
	s_multi_obj_l_t_line = {450,0,220,45},
	s_multi_obj_r_cap_line = {705,0,320,45},
	s_multi_obj_r_t_line = {1095,0,220,45},
	s_multi_obj_tt_check_xywh = {5,7,48,30},
	s_multi_obj_int_xywh = {0,0,50,0}
};

w1_page_multi_objparam.s_2k = 
{
	s_cfg_page_multi_objparam_xywh = {133,600,1866,413},
	s_multi_obj_cap_face_detect_xywh = {80,0,373,60},
	s_multi_obj_t_face_detect_xywh = {593,9,64,40},
	s_multi_obj_cap_person_detect_xywh = {80,67,373,60},
	s_multi_obj_t_person_detect_xywh = {593,76,64,40},
	s_multi_obj_cap_plate_detect_xywh = {80,133,373,60},
	s_multi_obj_t_plate_detect_xywh = {593,142,64,40},
	s_multi_obj_cap_vehicle_detect_xywh = {80,200,373,60},
	s_multi_obj_t_vehicle_detect_xywh = {593,209,64,40},
	s_multi_obj_cap_trace_info_xywh = {80,267,373,60},
	s_multi_obj_t_trace_info_xywh = {600,267,293,60},
	s_multi_obj_cap_detect_area_xywh = {80,333,373,60},
	s_multi_obj_t_detect_area_xywh = {593,343,64,40},
	s_multi_obj_cap_con_coe_xywh = {80,400,373,60},
	s_multi_obj_t_con_coe_xywh = {600,400,293,60},
	s_multi_obj_cap_face_pix_min_xywh = {80,467,373,60},
	s_multi_obj_t_face_pix_min_xywh = {600,467,293,60},
	s_multi_obj_cap_person_pix_min_xywh = {80,533,373,60},
	s_multi_obj_t_person_pix_min_xywh = {600,533,293,60},
	s_multi_obj_cap_plate_pix_min_xywh = {80,600,373,60},
	s_multi_obj_t_plate_pix_min_xywh = {600,600,293,60},
	s_multi_obj_cap_vehicle_pix_min_xywh = {80,667,373,60},
	s_multi_obj_t_vehicle_pix_min_xywh = {600,667,293,60},
	
	s_multi_obj_cap_mat_qua_xywh = {940,0,373,60},
	s_multi_obj_t_mat_qua_xywh = {1460,0,293,60},
	s_multi_obj_cap_attr_xywh = {940,67,387,60},
	s_multi_obj_t_attr_xywh = {1453,76,64,40},
	s_multi_obj_cap_snap_mode_xywh = {940,133,373,60},
	s_multi_obj_t_snap_mode_xywh = {1460,133,293,60},
	s_multi_obj_cap_img_int_xywh = {940,200,373,60},
	s_multi_obj_t_img_int_xywh = {1460,200,293,60},
	s_multi_obj_cap_yaw_deg_xywh = {940,267,373,60},
	s_multi_obj_t_yaw_deg_xywh = {1460,267,293,60},
	s_multi_obj_cap_tilt_deg_xywh = {940,333,373,60},
	s_multi_obj_t_tilt_deg_xywh = {1460,333,293,60},
	s_multi_obj_cap_pitch_deg_xywh = {940,400,373,60},
	s_multi_obj_t_pitch_deg_xywh = {1460,400,293,60},
	s_multi_obj_cap_ftp_img_mat_xywh = {940,467,373,60},
	s_multi_obj_t_ftp_img_mat_xywh = {1453,476,64,40},
	s_multi_obj_cap_ftp_whole_img_xywh = {940,533,373,60},
	s_multi_obj_t_ftp_whole_img_xywh = {1453,543,64,40},
	s_multi_obj_cap_alg_lib_ver_xywh = {940,600,373,60},
	s_multi_obj_t_alg_lib_ver_xywh = {1460,600,293,60},
	s_multi_obj_hline_xywh = {920,0,3,533},
	s_multi_obj_vdrop_xywh = {1767,0,27,520},
	s_multi_obj_l_cap_line = {80,0,427,60},
	s_multi_obj_l_t_line = {600,0,293,60},
	s_multi_obj_r_cap_line = {940,0,427,60},
	s_multi_obj_r_t_line = {1460,0,293,60},
	s_multi_obj_tt_check_xywh = {7,9,64,40},
	s_multi_obj_int_xywh = {0,0,67,0}
};

w1_page_multi_objparam.s_4k = 
{
	s_cfg_page_multi_objparam_xywh = {200,900,2800,620},
	s_multi_obj_cap_face_detect_xywh = {120,0,560,90},
	s_multi_obj_t_face_detect_xywh = {890,14,96,60},
	s_multi_obj_cap_person_detect_xywh = {120,100,560,90},
	s_multi_obj_t_person_detect_xywh = {890,114,96,60},
	s_multi_obj_cap_plate_detect_xywh = {120,200,560,90},
	s_multi_obj_t_plate_detect_xywh = {890,214,96,60},
	s_multi_obj_cap_vehicle_detect_xywh = {120,300,560,90},
	s_multi_obj_t_vehicle_detect_xywh = {890,314,96,60},
	s_multi_obj_cap_trace_info_xywh = {120,400,560,90},
	s_multi_obj_t_trace_info_xywh = {900,400,440,90},
	s_multi_obj_cap_detect_area_xywh = {120,500,560,90},
	s_multi_obj_t_detect_area_xywh = {890,514,96,60},
	s_multi_obj_cap_con_coe_xywh = {120,600,560,90},
	s_multi_obj_t_con_coe_xywh = {900,600,440,90},
	s_multi_obj_cap_face_pix_min_xywh = {120,700,560,90},
	s_multi_obj_t_face_pix_min_xywh = {900,700,440,90},
	s_multi_obj_cap_person_pix_min_xywh = {120,800,560,90},
	s_multi_obj_t_person_pix_min_xywh = {900,800,440,90},
	s_multi_obj_cap_plate_pix_min_xywh = {120,900,560,90},
	s_multi_obj_t_plate_pix_min_xywh = {900,900,440,90},
	s_multi_obj_cap_vehicle_pix_min_xywh = {120,1000,560,90},
	s_multi_obj_t_vehicle_pix_min_xywh = {900,1000,440,90},
	
	s_multi_obj_cap_mat_qua_xywh = {1410,0,560,90},
	s_multi_obj_t_mat_qua_xywh = {2190,0,440,90},
	s_multi_obj_cap_attr_xywh = {1410,100,580,90},
	s_multi_obj_t_attr_xywh = {2180,114,96,60},
	s_multi_obj_cap_snap_mode_xywh = {1410,200,560,90},
	s_multi_obj_t_snap_mode_xywh = {2190,200,440,90},
	s_multi_obj_cap_img_int_xywh = {1410,300,560,90},
	s_multi_obj_t_img_int_xywh = {2190,300,440,90},
	s_multi_obj_cap_yaw_deg_xywh = {1410,400,560,90},
	s_multi_obj_t_yaw_deg_xywh = {2190,400,440,90},
	s_multi_obj_cap_tilt_deg_xywh = {1410,500,560,90},
	s_multi_obj_t_tilt_deg_xywh = {2190,500,440,90},
	s_multi_obj_cap_pitch_deg_xywh = {1410,600,560,90},
	s_multi_obj_t_pitch_deg_xywh = {2190,600,440,90},	
	s_multi_obj_cap_ftp_img_mat_xywh = {1410,700,560,90},
	s_multi_obj_t_ftp_img_mat_xywh = {2180,714,96,60},
	s_multi_obj_cap_ftp_whole_img_xywh = {1410,800,560,90},
	s_multi_obj_t_ftp_whole_img_xywh = {2180,814,96,60},
	s_multi_obj_cap_alg_lib_ver_xywh = {1410,900,560,60},
	s_multi_obj_t_alg_lib_ver_xywh = {2190,900,440,60},
	s_multi_obj_hline_xywh = {1380,0,4,800},
	s_multi_obj_vdrop_xywh = {2650,0,40,780},
	s_multi_obj_l_cap_line = {120,0,640,90},
	s_multi_obj_l_t_line = {900,0,440,90},
	s_multi_obj_r_cap_line = {1410,0,640,90},
	s_multi_obj_r_t_line = {2190,0,440,90},
	s_multi_obj_tt_check_xywh = {10,14,96,60},
	s_multi_obj_int_xywh = {0,0,100,0}
};

local show_line = 8;
local display_off = 0;
local total_show = 0;
local show_list_l = {};
local index_l = 1;
local show_list_r = {};
local index_r = 1;
local tt_check_list_id = {};
local tt_check_count = nil;
w1_page_multi_objparam.clear_data=function ()
	w1_page_multi_objparam.cfg_data=nil;
	w1_page_multi_objparam.cap_data = nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_multi_objparam.wnd;
	local cap_param = w1_page_multi_objparam.cap_data;
	cfgdata.face_enable = b_wnd_ex.get_check(top,cwnd.t_face_detect.id);
	cfgdata.fullbody_enable = b_wnd_ex.get_check(top,cwnd.t_fullbody_detect.id);
	cfgdata.plate_enable = b_wnd_ex.get_check(top,cwnd.t_plate_detect.id);
	cfgdata.vehicle_enable = b_wnd_ex.get_check(top,cwnd.t_vehicle_detect.id);
	local sel = b_wnd_ex.get_sel(top,cwnd.t_trace_info.id);
	cfgdata.object_mode = cap_param.SnapObjectModeList[sel+1] 
	cfgdata.area_enable = b_wnd_ex.get_check(top,cwnd.t_detect_area.id);
	local sel = b_wnd_ex.get_sel(top,cwnd.t_con_coe.id);
	if sel == 0 then
		cfgdata.reliability = 30
	elseif sel == 1 then
		cfgdata.reliability = 60
	else
		cfgdata.reliability = 90
	end
	cfgdata.face_pix_min = b_wnd_ex.get_value(top,cwnd.t_face_pix_min.id);
	cfgdata.body_pix_min = b_wnd_ex.get_value(top,cwnd.t_body_pix_min.id);
	cfgdata.plate_pix_min = b_wnd_ex.get_value(top,cwnd.t_plate_pix_min.id);
	cfgdata.vehicle_pix_min = b_wnd_ex.get_value(top,cwnd.t_vehicle_pix_min.id);
	sel = b_wnd_ex.get_sel(top,cwnd.t_mat_qua.id);
	if sel == 0 then
		cfgdata.pic_quality = 30
	elseif sel == 1 then
		cfgdata.pic_quality = 60
	elseif sel == 2 then
		cfgdata.pic_quality = 80
	else
		cfgdata.pic_quality = 97
	end
	cfgdata.attribute = b_wnd_ex.get_check(top,cwnd.t_attribute.id);
	cfgdata.snap_pic_mode = b_wnd_ex.get_sel(top,cwnd.t_snap_mode.id);
	cfgdata.upload_inteval = b_wnd_ex.get_value(top,cwnd.t_img_int.id);
	cfgdata.yawdegree = b_wnd_ex.get_value(top,cwnd.t_yaw_deg.id);
	cfgdata.tiltdegree = b_wnd_ex.get_value(top,cwnd.t_tilt_deg.id);
	cfgdata.petchdegree = b_wnd_ex.get_value(top,cwnd.t_pitch_deg.id);
	cfgdata.ftpupload_enable = b_wnd_ex.get_check(top,cwnd.t_ftp_img_mat.id);
	cfgdata.fuleview_enable = b_wnd_ex.get_check(top,cwnd.t_ftp_whole_img.id);
	cfgdata.change_flag = true;
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_multi_objparam.cfg_data)
	end
	return 0;
end

local move_ex = function (top)
	local cwnd = w1_page_multi_objparam.wnd;
	local is_tt_check = function (id)
		for i = 1, tt_check_count do
			if(tt_check_list_id[i] == id) then
				return true
			end
			if i == tt_check_count then
				return false
			end
		end
	end
	--------------------------------------------
	local s_id = cwnd.cap_face_detect.id;
	local e_id = cwnd.t_alg_lib_ver.id;
	for i = s_id, e_id do
		b_wnd_ex.set_hide(top,i,true,false);
	end
	--------------------------------------------
	local size_cap_l = SIZE('s_multi_obj_l_cap_line');
	local size_t_l = SIZE('s_multi_obj_l_t_line');
	local size_cap_r = SIZE('s_multi_obj_r_cap_line');
	local size_t_r = SIZE('s_multi_obj_r_t_line');
	local size_int = SIZE('s_multi_obj_int_xywh');
	local size_tt_check = SIZE('s_multi_obj_tt_check_xywh');
	for i = 1, show_line do
		if show_list_l[2*i+display_off*2-1] ~= nil then
			local pos = {size_cap_l[1],size_cap_l[2]+size_int[3]*(i-1),size_cap_l[3],size_cap_l[4]};
			b_wnd_ex.move_ex(top,show_list_l[2*i+display_off*2-1],pos,false);
			b_wnd_ex.set_hide(top, show_list_l[2*i+display_off*2-1],false,false);
			local flag = is_tt_check(show_list_l[2*i+display_off*2])
			if flag == true then
				local pos = {size_t_l[1]-size_tt_check[1],size_t_l[2]+size_int[3]*(i-1)+size_tt_check[2],size_tt_check[3],size_tt_check[4]};
				b_wnd_ex.move_ex(top,show_list_l[2*i+display_off*2],pos,false);
			else
				local pos = {size_t_l[1],size_t_l[2]+size_int[3]*(i-1),size_t_l[3],size_t_l[4]};
				b_wnd_ex.move_ex(top,show_list_l[2*i+display_off*2],pos,false);
			end
			b_wnd_ex.set_hide(top, show_list_l[2*i+display_off*2],false,false);
		end
		if show_list_r[2*i+display_off*2-1] ~= nil then
			local pos = {size_cap_r[1],size_cap_r[2]+size_int[3]*(i-1),size_cap_r[3],size_cap_r[4]};
			b_wnd_ex.move_ex(top,show_list_r[2*i+display_off*2-1],pos,false);
			b_wnd_ex.set_hide(top, show_list_r[2*i+display_off*2-1],false,false);
			local flag = is_tt_check(show_list_r[2*i+display_off*2])
			if flag == true then
				local pos = {size_t_r[1]-size_tt_check[1],size_t_r[2]+size_int[3]*(i-1)+size_tt_check[2],size_tt_check[3],size_tt_check[4]};
				b_wnd_ex.move_ex(top,show_list_r[2*i+display_off*2],pos,false);
			else
				local pos = {size_t_r[1],size_t_r[2]+size_int[3]*(i-1),size_t_r[3],size_t_r[4]};
				b_wnd_ex.move_ex(top,show_list_r[2*i+display_off*2],pos,false);
			end
			b_wnd_ex.set_hide(top, show_list_r[2*i+display_off*2],false,false);
		end
	end
end

local tt_check_changel = function(top,check,cap_id,t_id)
	local cwnd = w1_page_multi_objparam.wnd
	if check == true then
		for i = 1, index_l/2 do
			if show_list_l[2*i-1] > cap_id then
				for j = 1, index_l/2 + 1 - i do
					show_list_l[index_l-2*(j-1)+1] = show_list_l[index_l-2*(j-1)-1]
					show_list_l[index_l-2*(j-1)+2] = show_list_l[index_l-2*(j-1)]
				end
				show_list_l[2*i-1] = cap_id
				show_list_l[2*i] = t_id
				index_l = index_l + 2;
				break;
			end
			if i == index_l/2 then
				show_list_l[index_l+1] = cap_id
				show_list_l[index_l+2] = t_id
				index_l = index_l + 2;
			end
		end
	else
		for i = 1, index_l/2 do
			if show_list_l[2*i-1] == cap_id then
				for j = 1, index_l/2 - i do
					show_list_l[2*i-1+(j-1)*2] = show_list_l[2*i+1+(j-1)*2]
					show_list_l[2*i+(j-1)*2] = show_list_l[2*i+2+(j-1)*2]
				end
				show_list_l[index_l] = nil
				show_list_l[index_l-1] = nil
				index_l = index_l -2;
				break;
			end
		end
	end
	if index_l > index_r then
		total_show = index_l/2
	else
		total_show = index_r/2
	end
	if display_off + show_line > total_show then
		if show_line < total_show then
			display_off = total_show - show_line;
		else
			display_off = 0;
		end
	end
	if total_show > show_line then
		local v_drop = {};
		v_drop.set_cap = show_line;
		v_drop.set_max = total_show
		v_drop.set_cur = display_off;
		b_wnd_ex.set_drop(top,cwnd.t_vdrop.id,v_drop,false);
		b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,false,false);
	else
		b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,true,false);
	end
	move_ex(top);
end

local on_face_detect = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_multi_objparam.wnd
		local check = b_wnd_ex.get_check(top,cwnd.t_face_detect.id);
		if true == w1_page_multi_objparam.cap_data.FaceMinPixelWidthEnable then
			tt_check_changel(top,check,cwnd.cap_face_pix_min.id,cwnd.t_face_pix_min.id);
		end
		if true == w1_page_multi_objparam.cap_data.FaceMaxPixelWidthEnable then
			tt_check_changel(top,check,cwnd.cap_face_pix_max.id,cwnd.t_face_pix_max.id);
		end
		uitousercfg(top,w1_page_multi_objparam.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_upbody_detect = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_multi_objparam.wnd
		local check = b_wnd_ex.get_check(top,cwnd.t_upbody_detect.id);
		if true == w1_page_multi_objparam.cap_data.UpBodyMinPixelWidthEnable then
			tt_check_changel(top,check,cwnd.cap_upbody_pix_min.id,cwnd.t_upbody_pix_min.id);
		end
		if true == w1_page_multi_objparam.cap_data.UpBodyMaxPixelWidthEnable then
			tt_check_changel(top,check,cwnd.cap_upbody_pix_max.id,cwnd.t_upbody_pix_max.id);
		end
		uitousercfg(top,w1_page_multi_objparam.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_body_detect = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_multi_objparam.wnd
		local check = b_wnd_ex.get_check(top,cwnd.t_fullbody_detect.id);
		if true == w1_page_multi_objparam.cap_data.FullBodyMinPixelWidthEnable then
			tt_check_changel(top,check,cwnd.cap_body_pix_min.id,cwnd.t_body_pix_min.id)
		end
		if true == w1_page_multi_objparam.cap_data.FullBodyMaxPixelWidthEnable then
			tt_check_changel(top,check,cwnd.cap_body_pix_max.id,cwnd.t_body_pix_max.id)
		end
		uitousercfg(top,w1_page_multi_objparam.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_plate_detect = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_multi_objparam.wnd
		local check = b_wnd_ex.get_check(top,cwnd.t_plate_detect.id);
		if true == w1_page_multi_objparam.cap_data.PlateMinPixelWidthEnable then
			tt_check_changel(top,check,cwnd.cap_plate_pix_min.id,cwnd.t_plate_pix_min.id);
		end
		if true == w1_page_multi_objparam.cap_data.PlateMaxPixelWidthEnable then
			tt_check_changel(top,check,cwnd.cap_plate_pix_max.id,cwnd.t_plate_pix_max.id);
		end
		uitousercfg(top,w1_page_multi_objparam.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_vehicle_detect = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_multi_objparam.wnd
		local check = b_wnd_ex.get_check(top,cwnd.t_vehicle_detect.id);
		if check == true then
			if true == w1_page_multi_objparam.cap_data.VehicleMinPixelWidthEnable then
				show_list_l[index_l+1] = cwnd.cap_vehicle_pix_min.id
				show_list_l[index_l+2] = cwnd.t_vehicle_pix_min.id
				index_l = index_l + 2;
			end
			if true == w1_page_multi_objparam.cap_data.VehicleMaxPixelWidthEnable then
				show_list_l[index_l+1] = cwnd.cap_vehicle_pix_max.id
				show_list_l[index_l+2] = cwnd.t_vehicle_pix_max.id
				index_l = index_l + 2;
			end
		else
			if true == w1_page_multi_objparam.cap_data.VehicleMaxPixelWidthEnable then
				show_list_l[index_l] = nil
				show_list_l[index_l-1] = nil
				index_l = index_l - 2;
			end
			if true == w1_page_multi_objparam.cap_data.VehicleMinPixelWidthEnable then
				show_list_l[index_l] = nil
				show_list_l[index_l-1] = nil
				index_l = index_l - 2;
			end
		end
		if index_l > index_r then
			total_show = index_l/2
		else
			total_show = index_r/2
		end
		if display_off + show_line > total_show then
			if show_line < total_show then
				display_off = total_show - show_line;
			else
				display_off = 0;
			end
		end
		if total_show > show_line then
			local v_drop = {};
			v_drop.set_cur = display_off;
			v_drop.set_cap = show_line;
			v_drop.set_max = total_show
			b_wnd_ex.set_drop(top,cwnd.t_vdrop.id,v_drop,false);
			b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,false,false);
		else
			b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,true,false);
		end
		move_ex(top);
		uitousercfg(top,w1_page_multi_objparam.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_snap_mode = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_multi_objparam.wnd
		local sel = b_wnd_ex.get_sel(top,cwnd.t_snap_mode.id)
		if sel == 0 then
			for i = 1, index_r/2 do
				if show_list_r[2*i-1] > cwnd.cap_img_int.id then
					for j = 1, index_r/2 + 1 - i do
						show_list_r[index_r-2*(j-1)+1] = show_list_r[index_r-2*(j-1)-1]
						show_list_r[index_r-2*(j-1)+2] = show_list_r[index_r-2*(j-1)]
					end
					show_list_r[2*i-1] = cwnd.cap_img_int.id
					show_list_r[2*i] = cwnd.t_img_int.id
					index_r = index_r + 2;
					break;
				end
				if i == index_r/2 then
					show_list_r[index_r+1] = cwnd.cap_img_int.id
					show_list_r[index_r+2] = cwnd.t_img_int.id
					index_r = index_r + 2;
				end
			end
		else
			for i = 1, index_r/2 do
				if show_list_r[2*i-1] == cwnd.cap_img_int.id then
					for j = 1, index_r/2 - i do
						show_list_r[2*i-1+(j-1)*2] = show_list_r[2*i+1+(j-1)*2]
						show_list_r[2*i+(j-1)*2] = show_list_r[2*i+2+(j-1)*2]
					end
					show_list_r[index_r] = nil
					show_list_r[index_r-1] = nil
					index_r = index_r -2;
					break;
				end
			end
		end
		if index_l > index_r then
			total_show = index_l/2
		else
			total_show = index_r/2
		end
		if display_off + show_line > total_show then
			if show_line < total_show then
				display_off = total_show - show_line;
			else
				display_off = 0;
			end
		end
		if total_show > show_line then
			local v_drop = {};
			v_drop.set_cur = display_off;
			v_drop.set_cap = show_line;
			v_drop.set_max = total_show
			b_wnd_ex.set_drop(top,cwnd.t_vdrop.id,v_drop,false);
			b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,false,false);
		else
			b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,true,false);
		end
		move_ex(top);
		uitousercfg(top,w1_page_multi_objparam.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

w1_page_multi_objparam.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_multi_objparam.wnd;
	if bool_hide == false then
		
	else
		local s_id_l = cwnd.cap_face_detect.id
		local e_id_l = cwnd.t_alg_lib_ver.id
		for i = s_id_l, e_id_l do
			b_wnd_ex.set_hide(top,i,bool_hide,false);
		end
		b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,bool_hide,false);
	end
	b_wnd_ex.set_hide(top,cwnd.hline.id,bool_hide,false);
end

w1_page_multi_objparam.set_cap_param = function(top, param, redraw)
	w1_page_multi_objparam.cap_data = param
end

w1_page_multi_objparam.set_param = function(top, param, redraw)
	w1_page_multi_objparam.cfg_data = param
	local cap_param = w1_page_multi_objparam.cap_data;
	local cwnd = w1_page_multi_objparam.wnd;
	index_l = 1;
	show_list_l = {}
	show_list_r = {}
	b_wnd_ex.set_check(top,cwnd.t_face_detect.id,param.face_enable,false);
	if true == cap_param.FaceEnable then
		show_list_l[index_l] = cwnd.cap_face_detect.id;
		index_l = index_l + 1;
		show_list_l[index_l] = cwnd.t_face_detect.id
		index_l = index_l + 1;
	end
	b_wnd_ex.set_check(top,cwnd.t_upbody_detect.id,param.upbody_enable,false);
	if true == cap_param.UpBodyEnable then
		show_list_l[index_l] = cwnd.cap_upbody_detect.id;
		index_l = index_l + 1;
		show_list_l[index_l] = cwnd.t_upbody_detect.id
		index_l = index_l + 1;
	end
	b_wnd_ex.set_check(top,cwnd.t_fullbody_detect.id,param.fullbody_enable,false);
	if true == cap_param.FullBodyEnable then
		show_list_l[index_l] = cwnd.cap_fullbody_detect.id;
		index_l = index_l + 1;
		show_list_l[index_l] = cwnd.t_fullbody_detect.id
		index_l = index_l + 1;
	end
	b_wnd_ex.set_check(top,cwnd.t_plate_detect.id,param.plate_enable,false);
	if true == cap_param.PlateEnable then
		show_list_l[index_l] = cwnd.cap_plate_detect.id;
		index_l = index_l + 1;
		show_list_l[index_l] = cwnd.t_plate_detect.id
		index_l = index_l + 1;
	end
	b_wnd_ex.set_check(top,cwnd.t_vehicle_detect.id,param.vehicle_enable,false);
	if true == cap_param.VehicleEnable then
		show_list_l[index_l] = cwnd.cap_vehicle_detect.id;
		index_l = index_l + 1;
		show_list_l[index_l] = cwnd.t_vehicle_detect.id
		index_l = index_l + 1;
	end
	if true == cap_param.ShowObjectEnable then
		local items={};
		local idx = 0;
		for i=1,cap_param.ShowObjectModeNum do
			if cap_param.SnapObjectModeList[i] == 0 then
				items[i] = STR('LA_OFF');
			elseif(cap_param.SnapObjectModeList[i] == 1) then
				items[i] = STR('LA_MODE_1');
			else
				items[i] = STR('LA_MODE_2');
			end
			if param.object_mode == cap_param.SnapObjectModeList[i] then
				idx = i-1;
			end
		end
		b_wnd_ex.set_items(top, cwnd.t_trace_info.id, items, false);
		b_wnd_ex.set_sel(top,cwnd.t_trace_info.id, idx,false);
		show_list_l[index_l] = cwnd.cap_trace_info.id;
		index_l = index_l + 1;
		show_list_l[index_l] = cwnd.t_trace_info.id
		index_l = index_l + 1;
	end
	b_wnd_ex.set_check(top,cwnd.t_detect_area.id,param.area_enable,false);
	if true == cap_param.ShowAreaEnable then
		show_list_l[index_l] = cwnd.cap_detect_area.id;
		index_l = index_l + 1;
		show_list_l[index_l] = cwnd.t_detect_area.id
		index_l = index_l + 1;
	end
	
	if false == cap_param.ConfidenceDisable then
		if param.reliability == 30 then
			b_wnd_ex.set_sel(top,cwnd.t_con_coe.id,0,false);
		elseif param.reliability == 60 then
			b_wnd_ex.set_sel(top,cwnd.t_con_coe.id,1,false);
		else
			b_wnd_ex.set_sel(top,cwnd.t_con_coe.id,2,false);
		end
		show_list_l[index_l] = cwnd.cap_con_coe.id;
		index_l = index_l + 1;
		show_list_l[index_l] = cwnd.t_con_coe.id
		index_l = index_l + 1;
	end
	
	b_wnd_ex.set_value(top,cwnd.t_face_pix_min.id,param.face_pix_min,false);
	b_wnd_ex.set_value(top,cwnd.t_face_pix_max.id,param.face_pix_max,false);
	if true == cap_param.FaceEnable then
		if param.face_enable == true and cap_param.FaceMinPixelWidthEnable == true then
			show_list_l[index_l] = cwnd.cap_face_pix_min.id;
			index_l = index_l + 1;
			show_list_l[index_l] = cwnd.t_face_pix_min.id
			index_l = index_l + 1;
		end
		if param.face_enable == true and cap_param.FaceMaxPixelWidthEnable == true then
			show_list_l[index_l] = cwnd.cap_face_pix_max.id;
			index_l = index_l + 1;
			show_list_l[index_l] = cwnd.t_face_pix_max.id
			index_l = index_l + 1;
		end
	end
	b_wnd_ex.set_value(top,cwnd.t_upbody_pix_min.id,param.upbody_pix_min,false);
	b_wnd_ex.set_value(top,cwnd.t_upbody_pix_max.id,param.upbody_pix_max,false);
	if true == cap_param.UpBodyEnable then
		if param.upbody_enable == true and cap_param.UpBodyMinPixelWidthEnable == true then
			show_list_l[index_l] = cwnd.cap_upbody_pix_min.id;
			index_l = index_l + 1;
			show_list_l[index_l] = cwnd.t_upbody_pix_min.id
			index_l = index_l + 1;
		end
		if param.upbody_enable == true and cap_param.UpBodyMaxPixelWidthEnable == true then
			show_list_l[index_l] = cwnd.cap_upbody_pix_max.id;
			index_l = index_l + 1;
			show_list_l[index_l] = cwnd.t_upbody_pix_max.id
			index_l = index_l + 1;
		end
	end
	b_wnd_ex.set_value(top,cwnd.t_body_pix_min.id,param.body_pix_min,false);
	b_wnd_ex.set_value(top,cwnd.t_body_pix_max.id,param.body_pix_max,false);
	if true == cap_param.FullBodyEnable then
		if param.fullbody_enable == true and cap_param.FullBodyMinPixelWidthEnable == true then
			show_list_l[index_l] = cwnd.cap_body_pix_min.id;
			index_l = index_l + 1;
			show_list_l[index_l] = cwnd.t_body_pix_min.id
			index_l = index_l + 1;
		end
		if param.fullbody_enable == true and cap_param.FullBodyMaxPixelWidthEnable == true then
			show_list_l[index_l] = cwnd.cap_body_pix_max.id;
			index_l = index_l + 1;
			show_list_l[index_l] = cwnd.t_body_pix_max.id
			index_l = index_l + 1;
		end
	end
	b_wnd_ex.set_value(top,cwnd.t_plate_pix_min.id,param.plate_pix_min,false);
	b_wnd_ex.set_value(top,cwnd.t_plate_pix_max.id,param.plate_pix_max,false);
	if true == cap_param.PlateEnable then
		if param.plate_enable == true and cap_param.PlateMinPixelWidthEnable == true then
			show_list_l[index_l] = cwnd.cap_plate_pix_min.id;
			index_l = index_l + 1;
			show_list_l[index_l] = cwnd.t_plate_pix_min.id
			index_l = index_l + 1;
		end
		if param.plate_enable == true and cap_param.PlateMaxPixelWidthEnable == true then
			show_list_l[index_l] = cwnd.cap_plate_pix_max.id;
			index_l = index_l + 1;
			show_list_l[index_l] = cwnd.t_plate_pix_max.id
			index_l = index_l + 1;
		end
	end
	b_wnd_ex.set_value(top,cwnd.t_vehicle_pix_min.id,param.vehicle_pix_min,false);
	b_wnd_ex.set_value(top,cwnd.t_vehicle_pix_max.id,param.vehicle_pix_max,false);
	if true == cap_param.VehicleEnable then
		if param.vehicle_enable == true and cap_param.VehicleMinPixelWidthEnable == true then
			show_list_l[index_l] = cwnd.cap_vehicle_pix_min.id;
			index_l = index_l + 1;
			show_list_l[index_l] = cwnd.t_vehicle_pix_min.id
			index_l = index_l + 1;
		end
		if param.vehicle_enable == true and cap_param.VehicleMaxPixelWidthEnable == true then
			show_list_l[index_l] = cwnd.cap_vehicle_pix_max.id;
			index_l = index_l + 1;
			show_list_l[index_l] = cwnd.t_vehicle_pix_max.id
			index_l = index_l + 1;
		end
	end
	index_l = index_l - 1;
	index_r = 1;
	if param.pic_quality == 30 then
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,0,false);
	elseif param.pic_quality == 60 then
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,1,false);
	elseif param.pic_quality == 80 then
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,2,false);
	else
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,3,false);
	end
	show_list_r[index_r] = cwnd.cap_mat_qua.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_mat_qua.id
	index_r = index_r + 1;
	b_wnd_ex.set_check(top,cwnd.t_attribute.id,param.attribute,false);
	if true == cap_param.AttributeOutSupport then
		show_list_r[index_r] = cwnd.cap_attribute.id;
		index_r = index_r + 1;
		show_list_r[index_r] = cwnd.t_attribute.id
		index_r = index_r + 1;
	end
	b_wnd_ex.set_sel(top,cwnd.t_snap_mode.id,param.snap_pic_mode,false);
	show_list_r[index_r] = cwnd.cap_snap_mode.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_snap_mode.id
	index_r = index_r + 1;
	b_wnd_ex.set_value(top,cwnd.t_img_int.id,param.upload_inteval,false);
	if param.snap_pic_mode == 0 then
		b_wnd_ex.set_hide(top,cwnd.t_img_int.id,true,false);
		show_list_r[index_r] = cwnd.cap_img_int.id;
		index_r = index_r + 1;
		show_list_r[index_r] = cwnd.t_img_int.id
		index_r = index_r + 1;
	end
	b_wnd_ex.set_value(top,cwnd.t_yaw_deg.id,param.yawdegree,false);
	if true == cap_param.YawDegreeEnable then
		show_list_r[index_r] = cwnd.cap_yaw_deg.id;
		index_r = index_r + 1;
		show_list_r[index_r] = cwnd.t_yaw_deg.id
		index_r = index_r + 1;
	end
	b_wnd_ex.set_value(top,cwnd.t_tilt_deg.id,param.tiltdegree,false);
	if true == cap_param.TiltDegreeEnable then
		show_list_r[index_r] = cwnd.cap_tilt_deg.id;
		index_r = index_r + 1;
		show_list_r[index_r] = cwnd.t_tilt_deg.id
		index_r = index_r + 1;
	end
	b_wnd_ex.set_value(top,cwnd.t_pitch_deg.id,param.petchdegree,false);
	if true == cap_param.PitchDegreeEnable then
		show_list_r[index_r] = cwnd.cap_pitch_deg.id;
		index_r = index_r + 1;
		show_list_r[index_r] = cwnd.t_pitch_deg.id
		index_r = index_r + 1;
	end
	b_wnd_ex.set_check(top,cwnd.t_ftp_img_mat.id,param.ftpupload_enable,false);
	if false == cap_param.FtpUpImageMatDisable then
		show_list_r[index_r] = cwnd.cap_ftp_img_mat.id;
		index_r = index_r + 1;
		show_list_r[index_r] = cwnd.t_ftp_img_mat.id
		index_r = index_r + 1;
	end
	
	b_wnd_ex.set_check(top,cwnd.t_ftp_whole_img.id,param.fuleview_enable,false);
	if false == cap_param.FtpUpWholeImageDisable then
		show_list_r[index_r] = cwnd.cap_ftp_whole_img.id;
		index_r = index_r + 1;
		show_list_r[index_r] = cwnd.t_ftp_whole_img.id
		index_r = index_r + 1;
	end
	b_wnd_ex.set_check(top,cwnd.t_osd.id,param.picosd_enable,false);
	if true == cap_param.PictureOSDEnable then
		show_list_r[index_r] = cwnd.cap_osd.id;
		index_r = index_r + 1;
		show_list_r[index_r] = cwnd.t_osd.id
		index_r = index_r + 1;
	end
	b_wnd_ex.set_text(top,cwnd.t_alg_lib_ver.id,param.algoversion,false)
	if false == cap_param.ALVDisable then
		show_list_r[index_r] = cwnd.cap_alg_lib_ver.id;
		index_r = index_r + 1;
		show_list_r[index_r] = cwnd.t_alg_lib_ver.id
		index_r = index_r + 1;
	end
	index_r = index_r - 1;
	
	if index_l > index_r then
		total_show = index_l/2
	else
		total_show = index_r/2
	end
	if display_off + show_line > total_show then
		if show_line < total_show then
			display_off = total_show - show_line;
		else
			display_off = 0;
		end
	end
	if total_show > show_line then
		local v_drop = {};
		v_drop.set_cur = display_off;
		v_drop.set_cap = show_line;
		v_drop.set_max = total_show
		b_wnd_ex.set_drop(top,cwnd.t_vdrop.id,v_drop,false);
		b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,false,false);
	else
		b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,true,false);
	end
	move_ex(top)
end

w1_page_multi_objparam.datacheck = function(top)
	local cwnd = w1_page_multi_objparam.wnd;
	local cap = w1_page_multi_objparam.cap_data;
	local data = w1_page_multi_objparam.cfg_data;
	if true == cap.FaceEnable and true == cap.FaceMinPixelWidthEnable then
		if b_wnd_ex.get_value(top,cwnd.t_face_pix_min.id) < 30 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_FACE_PIX_MIN')..')'
		end
	end
	
	if true == cap.FaceEnable and true == cap.FaceMaxPixelWidthEnable then
		if b_wnd_ex.get_value(top,cwnd.t_face_pix_max.id) < 300 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_FACE_PIX_MAX')..')'
		end
	end
	
	if true == cap.UpBodyEnable and true == cap.UpBodyMinPixelWidthEnable then
		if b_wnd_ex.get_value(top,cwnd.t_upbody_pix_min.id) < 30 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_UPBODY_PIX_MIN')..')'
		end
	end
	
	if true == cap.UpBodyEnable and true == cap.UpBodyMaxPixelWidthEnable then
		if b_wnd_ex.get_value(top,cwnd.t_upbody_pix_max.id) < 300 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_UPBODY_PIX_MAX')..')'
		end
	end
	
	if true == cap.FullBodyEnable and true == cap.FullBodyMinPixelWidthEnable then
		if b_wnd_ex.get_value(top,cwnd.t_body_pix_min.id) < 30 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_PERSON_PIX_MIN')..')'
		end
	end

	if true == cap.FullBodyEnable and true == cap.FullBodyMaxPixelWidthEnable then
		if b_wnd_ex.get_value(top,cwnd.t_body_pix_max.id) < 300 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_PERSON_PIX_MAX')..')'
		end
	end
	
	if true == cap.PlateEnable and true == cap.PlateMinPixelWidthEnable then
		if b_wnd_ex.get_value(top,cwnd.t_plate_pix_min.id) < 30 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_PLATE_PIX_MIN')..')'
		end
	end
	
	if true == cap.PlateEnable and true == cap.PlateMaxPixelWidthEnable then
		if b_wnd_ex.get_value(top,cwnd.t_plate_pix_max.id) < 300 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_PLATE_PIX_MAX')..')'
		end
	end
	
	if true == cap.VehicleEnable and true == cap.VehicleMinPixelWidthEnable then
		if b_wnd_ex.get_value(top,cwnd.t_vehicle_pix_min.id) < 30 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_CAR_PIX_MIN')..')'
		end
	end
	
	if true == cap.VehicleEnable and true == cap.VehicleMaxPixelWidthEnable then
		if b_wnd_ex.get_value(top,cwnd.t_vehicle_pix_max.id) < 800 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_CAR_PIX_MAX')..')'
		end
	end
	
	local sel = b_wnd_ex.get_sel(top,cwnd.t_snap_mode.id);
	if data.upload_inteval < 1 then
		return false,STR('LA_OUT_RANGE')..'('..STR('LA_UPLOAD_IMAGE_INTERVAL')..')'
	end
	return true,nil
end

w1_page_multi_objparam.dwell_updata_f =function(top)
	if total_show > show_line then
		display_off = b_wnd_ex.get_drop(top,w1_page_multi_objparam.wnd.t_vdrop.id);
		move_ex(top);
		b_dlg.dlg_set_redraw(top);
	end
end

w1_page_multi_objparam.dwell_mouse_up =function(top)
	if total_show > show_line then
		if display_off > 0 then
			display_off = display_off-1
		end
		local vdrop = {};
		vdrop.set_cur = display_off;
		vdrop.set_cap = show_line;
		vdrop.set_max = total_show;
		b_wnd_ex.set_drop(top,w1_page_multi_objparam.wnd.t_vdrop.id,vdrop,false);
		move_ex(top)
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_multi_objparam.dwell_mouse_down =function(top)
	if total_show > show_line then
		if display_off < total_show - show_line then
			display_off = display_off+1
		end
		local vdrop = {};
		vdrop.set_cur = display_off;
		vdrop.set_cap = show_line;
		vdrop.set_max = total_show;
		b_wnd_ex.set_drop(top,w1_page_multi_objparam.wnd.t_vdrop.id,vdrop,false);
		move_ex(top);
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_multi_objparam.dwell_drop_drag =function(top)
	if total_show > show_line then
		display_off = b_wnd_ex.get_drop(top,w1_page_multi_objparam.wnd.t_vdrop.id);
		move_ex(top);
		b_dlg.dlg_set_redraw(top);	
	end
end

w1_page_multi_objparam.on_pre_show = function(top)
	local dlg_w, dlg_h = global_val.get_size();
	local cwnd = w1_page_multi_objparam.wnd;
	tt_check_list_id[1] = cwnd.t_face_detect.id;
	tt_check_list_id[2] = cwnd.t_upbody_detect.id
	tt_check_list_id[3] = cwnd.t_fullbody_detect.id;
	tt_check_list_id[4] = cwnd.t_plate_detect.id;
	tt_check_list_id[5] = cwnd.t_vehicle_detect.id;
	tt_check_list_id[6] = cwnd.t_detect_area.id;
	tt_check_list_id[7] = cwnd.t_attribute.id;
	tt_check_list_id[8] = cwnd.t_ftp_img_mat.id;
	tt_check_list_id[9] = cwnd.t_ftp_whole_img.id;
	tt_check_list_id[10] = cwnd.t_osd.id
	tt_check_count = 10
	if(dlg_w == 1280 or dlg_h == 1024) then
		show_line = 7;
	elseif(dlg_w == 1440 or dlg_h == 900) then
		show_line = 7;
	else
		show_line = 8;
	end
	local s_id_l = cwnd.cap_face_detect.id
	local e_id_l = cwnd.t_vehicle_pix_min.id
	for i = s_id_l, e_id_l do
		if i >= s_id_l + show_line * 2 then
			b_wnd_ex.set_hide(top,i,true,false);
		end
	end
	local s_id_r = cwnd.cap_mat_qua.id
	local e_id_r = cwnd.t_alg_lib_ver.id
	for i = s_id_r, e_id_r do
		if i >= s_id_r + show_line * 2 then
			b_wnd_ex.set_hide(top,i,true,false);
		end
	end
	b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,true,false);
end

w1_page_multi_objparam.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_multi_objparam_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'cap_face_detect','t_face_detect','cap_upbody_detect','t_upbody_detect','cap_fullbody_detect','t_fullbody_detect','cap_plate_detect','t_plate_detect',
	'cap_vehicle_detect','t_vehicle_detect','cap_trace_info','t_trace_info','cap_detect_area','t_detect_area',
	'cap_con_coe','t_con_coe','cap_face_pix_min','t_face_pix_min','cap_face_pix_max','t_face_pix_max',
	'cap_upbody_pix_min','t_upbody_pix_min','cap_upbody_pix_max','t_upbody_pix_max','cap_body_pix_min','t_body_pix_min',
	'cap_body_pix_max','t_body_pix_max','cap_plate_pix_min','t_plate_pix_min','cap_plate_pix_max','t_plate_pix_max',
	'cap_vehicle_pix_min','t_vehicle_pix_min','cap_vehicle_pix_max','t_vehicle_pix_max','cap_mat_qua','t_mat_qua',
	'cap_attribute','t_attribute','cap_snap_mode','t_snap_mode','cap_img_int','t_img_int','cap_yaw_deg','t_yaw_deg',
	'cap_tilt_deg','t_tilt_deg','cap_pitch_deg','t_pitch_deg','cap_ftp_img_mat','t_ftp_img_mat',
	'cap_ftp_whole_img','t_ftp_whole_img','cap_osd','t_osd','cap_alg_lib_ver','t_alg_lib_ver','hline','t_vdrop'},
	cap_face_detect= {t='static',	id=id+1,	xywh='s_multi_obj_cap_face_detect_xywh',text='LA_FACE_DETECT', align = b_ui.ALIGN.LEFT},
	t_face_detect = {t='tt_check',id=id+2,	xywh='s_multi_obj_t_face_detect_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_face_detect},
	cap_upbody_detect= {t='static',	id=id+3,	xywh='s_multi_obj_cap_face_detect_xywh',text='LA_UPBODY', align = b_ui.ALIGN.LEFT},
	t_upbody_detect = {t='tt_check',id=id+4,	xywh='s_multi_obj_t_face_detect_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_upbody_detect},
	cap_fullbody_detect= {t='static',	id=id+5,	xywh='s_multi_obj_cap_person_detect_xywh',text='LA_PERSON_DET', align = b_ui.ALIGN.LEFT},
	t_fullbody_detect = {t='tt_check',id=id+6,	xywh='s_multi_obj_t_person_detect_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_body_detect},
	cap_plate_detect= {t='static',	id=id+7,	xywh='s_multi_obj_cap_plate_detect_xywh',text='LA_PLATE_DET', align = b_ui.ALIGN.LEFT},
	t_plate_detect = {t='tt_check',id=id+8,	xywh='s_multi_obj_t_plate_detect_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_plate_detect},
	cap_vehicle_detect= {t='static',	id=id+9,	xywh='s_multi_obj_cap_vehicle_detect_xywh',text='LA_CAR_DET', align = b_ui.ALIGN.LEFT},
	t_vehicle_detect = {t='tt_check',id=id+10,	xywh='s_multi_obj_t_vehicle_detect_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_vehicle_detect},
	cap_trace_info= {t='static',	id=id+11,	xywh='s_multi_obj_cap_trace_info_xywh',text='LA_TRACE_INFO', align = b_ui.ALIGN.LEFT},
	t_trace_info = {t='combox',	id=id+12,	xywh='s_multi_obj_t_trace_info_xywh' ,items = {}, trans=false,cmd = on_update_param},
	cap_detect_area= {t='static',	id=id+13,	xywh='s_multi_obj_cap_detect_area_xywh',text='LA_DETECT_AREA', align = b_ui.ALIGN.LEFT},
	t_detect_area = {t='tt_check',id=id+14,	xywh='s_multi_obj_t_detect_area_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_con_coe = {t='static',	id=id+15,	xywh='s_multi_obj_cap_con_coe_xywh',text='LA_CONFIDENCE_DEGREE', align = b_ui.ALIGN.LEFT},
	t_con_coe = {t='combox',	id=id+16,	xywh='s_multi_obj_t_con_coe_xywh' ,
					items = {'LA_LOW','LA_MEDIUM','LA_HIGH'},cmd = on_update_param},
	cap_face_pix_min = {t='static',	id=id+17,	xywh='s_multi_obj_cap_face_pix_min_xywh',text='LA_FACE_PIX_MIN', align = b_ui.ALIGN.LEFT},
	t_face_pix_min = {t='edit_num',id=id+18,xywh='s_multi_obj_t_face_pix_min_xywh',range={30,300},cmd = on_update_param},
	cap_face_pix_max = {t='static',	id=id+19,	xywh='s_multi_obj_cap_face_pix_min_xywh',text='LA_FACE_PIX_MAX', align = b_ui.ALIGN.LEFT},
	t_face_pix_max = {t='edit_num',id=id+20,xywh='s_multi_obj_t_face_pix_min_xywh',range={0,2000},cmd = on_update_param},
	cap_upbody_pix_min = {t='static',	id=id+21,	xywh='s_multi_obj_cap_face_pix_min_xywh',text='LA_UPBODY_PIX_MIN', align = b_ui.ALIGN.LEFT},
	t_upbody_pix_min = {t='edit_num',id=id+22,xywh='s_multi_obj_t_face_pix_min_xywh',range={30,300},cmd = on_update_param},
	cap_upbody_pix_max = {t='static',	id=id+23,	xywh='s_multi_obj_cap_face_pix_min_xywh',text='LA_UPBODY_PIX_MAX', align = b_ui.ALIGN.LEFT},
	t_upbody_pix_max= {t='edit_num',id=id+24,xywh='s_multi_obj_t_face_pix_min_xywh',range={0,2000},cmd = on_update_param},
	cap_body_pix_min = {t='static',	id=id+25,	xywh='s_multi_obj_cap_person_pix_min_xywh',text='LA_PERSON_PIX_MIN', align = b_ui.ALIGN.LEFT},
	t_body_pix_min = {t='edit_num',id=id+26,xywh='s_multi_obj_t_person_pix_min_xywh',range={30,300},cmd = on_update_param},
	cap_body_pix_max = {t='static',	id=id+27,	xywh='s_multi_obj_cap_person_pix_min_xywh',text='LA_PERSON_PIX_MAX', align = b_ui.ALIGN.LEFT},
	t_body_pix_max = {t='edit_num',id=id+28,xywh='s_multi_obj_t_person_pix_min_xywh',range={0,2000},cmd = on_update_param},
	cap_plate_pix_min = {t='static',	id=id+29,	xywh='s_multi_obj_cap_plate_pix_min_xywh',text='LA_PLATE_PIX_MIN', align = b_ui.ALIGN.LEFT},
	t_plate_pix_min = {t='edit_num',id=id+30,xywh='s_multi_obj_t_plate_pix_min_xywh',range={30,300},cmd = on_update_param},
	cap_plate_pix_max = {t='static',	id=id+31,	xywh='s_multi_obj_cap_plate_pix_min_xywh',text='LA_PLATE_PIX_MAX', align = b_ui.ALIGN.LEFT},
	t_plate_pix_max = {t='edit_num',id=id+32,xywh='s_multi_obj_t_plate_pix_min_xywh',range={0,2000},cmd = on_update_param},
	cap_vehicle_pix_min = {t='static',	id=id+33,	xywh='s_multi_obj_cap_vehicle_pix_min_xywh',text='LA_CAR_PIX_MIN', align = b_ui.ALIGN.LEFT},
	t_vehicle_pix_min = {t='edit_num',id=id+34,xywh='s_multi_obj_t_vehicle_pix_min_xywh',range={30,800},cmd = on_update_param},
	cap_vehicle_pix_max = {t='static',	id=id+35,	xywh='s_multi_obj_cap_vehicle_pix_min_xywh',text='LA_CAR_PIX_MAX', align = b_ui.ALIGN.LEFT},
	t_vehicle_pix_max = {t='edit_num',id=id+36,xywh='s_multi_obj_t_vehicle_pix_min_xywh',range={0,2000},cmd = on_update_param},
	
	cap_mat_qua = {t='static',	id=id+37,	xywh='s_multi_obj_cap_mat_qua_xywh',text='LA_MAT_QUA', align = b_ui.ALIGN.LEFT},
	t_mat_qua = {t='combox',	id=id+38,	xywh='s_multi_obj_t_mat_qua_xywh' ,
				items = {'LA_LOW','LA_MEDIUM','LA_HIGH','LA_HIGHEST'},cmd = on_update_param},
	cap_attribute = {t='static',	id=id+39,	xywh='s_multi_obj_cap_attr_xywh',text='LA_OBJ_ATTR', align = b_ui.ALIGN.LEFT},
	t_attribute = {t='tt_check',id=id+40,	xywh='s_multi_obj_t_attr_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_snap_mode= {t='static',	id=id+41,	xywh='s_multi_obj_cap_snap_mode_xywh',text='LA_SNAPSHOT_MODE', align = b_ui.ALIGN.LEFT},
	t_snap_mode = {t='combox',	id=id+42,	xywh='s_multi_obj_t_snap_mode_xywh',
				items = {'LA_TIMING','LA_OPTIMAL'},cmd = on_snap_mode},
	cap_img_int= {t='static',	id=id+43,	xywh='s_multi_obj_cap_img_int_xywh',text='LA_UPLOAD_IMAGE_INTERVAL', align = b_ui.ALIGN.LEFT},
	t_img_int = {t='edit_num',id=id+44,xywh='s_multi_obj_t_img_int_xywh',range={1,10},cmd = on_update_param},
	cap_yaw_deg= {t='static',	id=id+45,	xywh='s_multi_obj_cap_yaw_deg_xywh',text='LA_YAW_DEGREE', align = b_ui.ALIGN.LEFT},
	t_yaw_deg = {t='edit_num',id=id+46,xywh='s_multi_obj_t_yaw_deg_xywh',range={0,90},cmd = on_update_param},
	cap_tilt_deg= {t='static',	id=id+47,	xywh='s_multi_obj_cap_tilt_deg_xywh',text='LA_TILT_DEGREE', align = b_ui.ALIGN.LEFT},
	t_tilt_deg = {t='edit_num',id=id+48,xywh='s_multi_obj_t_tilt_deg_xywh',range={0,90},cmd = on_update_param},
	cap_pitch_deg= {t='static',	id=id+49,	xywh='s_multi_obj_cap_pitch_deg_xywh',text='LA_PITCH_DEGREE', align = b_ui.ALIGN.LEFT},
	t_pitch_deg = {t='edit_num',id=id+50,xywh='s_multi_obj_t_pitch_deg_xywh',range={0,90},cmd = on_update_param},
	cap_ftp_img_mat= {t='static',	id=id+51,	xywh='s_multi_obj_cap_ftp_img_mat_xywh',text='LA_FTP_UPLOAD_IMAGE_MATTING', align = b_ui.ALIGN.LEFT},
	t_ftp_img_mat = {t='tt_check',id=id+52,	xywh='s_multi_obj_t_ftp_img_mat_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_ftp_whole_img = {t='static',	id=id+53,	xywh='s_multi_obj_cap_ftp_whole_img_xywh',text='LA_FTP_UPLOAD_WHOLE_IMAGE', align = b_ui.ALIGN.LEFT},
	t_ftp_whole_img = {t='tt_check',id=id+54,	xywh='s_multi_obj_t_ftp_whole_img_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_osd = {t='static',	id=id+55,	xywh='s_multi_obj_cap_ftp_whole_img_xywh',text='LA_OSD_OVERLAY_SNAPSHOT', align = b_ui.ALIGN.LEFT},
	t_osd = {t='tt_check',id=id+56,	xywh='s_multi_obj_t_ftp_whole_img_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_alg_lib_ver = {t='static',	id=id+57,	xywh='s_multi_obj_cap_alg_lib_ver_xywh',text='LA_ALG_LIB_VER', align = b_ui.ALIGN.LEFT},
	t_alg_lib_ver = {t='static',	id=id+58,	xywh='s_multi_obj_t_alg_lib_ver_xywh',text='', trans=false, align = b_ui.ALIGN.LEFT},
	hline 	= {t='hline',	id=id+59,xywh='s_multi_obj_hline_xywh'},
	t_vdrop = {t='vdrop', id=id+60,xywh='s_multi_obj_vdrop_xywh'};
}

return w1_page_multi_objparam