--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_noopsyche.noopsyche_advance_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 

local w1_row_noopsycherow_advance 		= require("wnd.w1_cfg.w1_row_noopsycherow_advance")
local w1_page_noopsychearea_advance 	= require("wnd.w1_cfg.w1_page_noopsychearea_advance")

local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_color		= require("wnd.core.r_res.r_color")
local COLOR 		= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;

local w1_page_noopsyche_advance = 
{
	channel = 0,
	old_sel = 0,
	data,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_noopsyche_advance.s_768 =
{
	s_advance_sens_sub 			= {281,71,16,21},
	s_advance_t_sens 			= {297,64,158,32},
	s_advance_t_add 			= {455,71,16,21},
	s_advance_sense_value 		= {471,64,32,32},
	s_advance_t_white_light 	= {281,106,25,21},
	s_advance_t_light_duate 	= {281,149,132,32},
	s_advance_t_unit 			= {413,149,130,32},	
};

w1_page_noopsyche_advance.s_1280 = 
{
	s_advance_sens_sub 			= {460, 100, 30, 30},
	s_advance_t_sens 			= {490, 90, 200, 45},
	s_advance_t_add 			= {690, 100, 30, 30},
	s_advance_sense_value 		= {720, 90, 40, 45},
	s_advance_t_white_light 	= {460, 150, 48, 30},
	s_advance_t_light_duate		= {460, 210, 170, 45},
	s_advance_t_unit			= {630, 210, 200, 45}
}

w1_page_noopsyche_advance.s_1440 = 
{
	s_advance_sens_sub 			= {530, 85, 30, 30},
	s_advance_t_sens 			= {560, 75, 260, 45},
	s_advance_t_add 			= {820, 85, 30, 30},
	s_advance_sense_value 		= {850, 75, 60, 45},
	s_advance_t_white_light 	= {530, 125, 48, 30},
	s_advance_t_light_duate		= {530, 175, 250, 45},
	s_advance_t_unit			= {780, 175, 200, 45}
}

w1_page_noopsyche_advance.s_1080p = 
{
	s_advance_sens_sub 			= {527, 100, 30, 30},
	s_advance_t_sens 			= {557, 90, 290, 45},
	s_advance_t_add 			= {847, 100, 30, 30},
	s_advance_sense_value 		= {877, 90, 50, 45},
	s_advance_t_white_light 	= {527, 150, 48, 30},
	s_advance_t_light_duate		= {527, 210, 255, 45},
	s_advance_t_unit			= {782, 210, 200, 45}
}

w1_page_noopsyche_advance.s_2k = 
{
	s_advance_sens_sub 			= {702,133,39,39},
	s_advance_t_sens 			= {742,119,386,59},
	s_advance_t_add 			= {1129,133,39,39},
	s_advance_sense_value 		= {1169,119,66,59},
	s_advance_t_white_light 	= {702,199,63,39},
	s_advance_t_light_duate 	= {702,279,339,59},
	s_advance_t_unit 			= {1042,279,280,59},
}

w1_page_noopsyche_advance.s_4k = 
{
	s_advance_sens_sub 			= {1054,200,60,60},
	s_advance_t_sens 			= {1114,180,580,90},
	s_advance_t_add 			= {1694,200,60,60},
	s_advance_sense_value 		= {1754,180,100,90},
	s_advance_t_white_light 	= {1054,300,96,60},
	s_advance_t_light_duate 	= {1054,420,510,90},
	s_advance_t_unit 			= {1564,420,400,90},
}

local channel_num;--豸ͨĿ
local show_senc = false;	--ʾ		

w1_page_noopsyche_advance.clear_data = function()
	w1_page_noopsyche_advance.data = nil;
	w1_page_noopsyche_advance.copy_ch = nil;
end	

local refresh_chdata = function(top, chid, redraw)
	local c_wnd = w1_page_noopsyche_advance.wnd
	local channeldata = w1_page_noopsyche_advance.data.advance['channel'..chid]
	local channelcapdata = w1_page_noopsyche_advance.data.advance_cap['channel'..chid]
	w1_page_noopsychearea_advance.setcapdata(top,channelcapdata,false);
	w1_page_noopsychearea_advance.setmareaparam(top, channeldata, false)
end
local hide_sens = function(top, status, redraw)
	local c_wnd = w1_page_noopsyche_advance.wnd
	local s_id = c_wnd.cap_sensitivity.id
	local e_id = c_wnd.t_unit.id
	for i = s_id, e_id do
		b_wnd_ex.set_hide(top, i, status, false)	
	end
	if (redraw ~= false) then
		b_dlg.dlg_set_redraw(top);
	end	
end
local on_white_light_change = function(top, check, redraw)
	local c_wnd = w1_page_noopsyche_advance.wnd
	if (check) then
		b_wnd_ex.set_hide(top, c_wnd.cap_light_durate.id, false, false);
		b_wnd_ex.set_hide(top, c_wnd.t_light_durate.id, false, false);
		b_wnd_ex.set_hide(top, c_wnd.t_unit.id, false, false);
	else
		b_wnd_ex.set_hide(top, c_wnd.cap_light_durate.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.t_light_durate.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.t_unit.id, true, false);
	end
	if  (true == redraw) then
		b_dlg.dlg_set_redraw(top);
	end
end	
local update_layout = function(top, chn_data, cap_data, redraw)
	local c_wnd = w1_page_noopsyche_advance.wnd
	local item_h = SIZE('s_cfg_page_2_1')[2] - SIZE('s_cfg_page_1_1')[2];	
	local move_h = 0;
	if (cap_data.Scene_enable == true) then
		b_wnd_ex.set_hide(top, c_wnd.cap_sensitivity.id, false, false);
		b_wnd_ex.set_hide(top, c_wnd.sens_subb.id, false, false);
		b_wnd_ex.set_hide(top, c_wnd.t_sens.id, false, false);
		b_wnd_ex.set_hide(top, c_wnd.sens_add.id, false, false);
		b_wnd_ex.set_hide(top, c_wnd.sens_value.id, false, false);
	else
		b_wnd_ex.set_hide(top, c_wnd.cap_sensitivity.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.sens_subb.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.t_sens.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.sens_add.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.sens_value.id, true, false);		
		move_h = item_h;
	end	
	if (cap_data.LightLinkage_enable == true) then
		b_wnd_ex.set_hide(top, c_wnd.cap_white_light.id, false, false);
		b_wnd_ex.set_hide(top, c_wnd.t_white_light.id, false, false);		
		local check = b_wnd_ex.get_check(top, c_wnd.t_white_light.id);
		on_white_light_change(top, check, false);
		local s_id = c_wnd.cap_white_light.id;
		local e_id =  c_wnd.t_unit.id
		local pos_str = {'s_cfg_page_3_1', 's_advance_t_white_light', 's_cfg_page_4_1', 's_advance_t_light_duate', 's_advance_t_unit'};
		for i = s_id, e_id do
			local pos = SIZE(pos_str[i - s_id + 1])
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end
	else
		b_wnd_ex.set_hide(top, c_wnd.cap_white_light.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.t_white_light.id, true, false);		
		b_wnd_ex.set_hide(top, c_wnd.cap_light_durate.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.t_light_durate.id, true, false);		
		b_wnd_ex.set_hide(top, c_wnd.t_unit.id, true, false);		
	end
	if (true == redraw) then
		b_dlg.dlg_set_redraw(top);
	end	
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)	
	assert(type(cfgdata) == 'table')
	w1_page_noopsyche_advance.data = cfgdata;
	
	local c_wnd = w1_page_noopsyche_advance.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	w1_page_noopsyche_advance.old_sel = 0
	for i=1, channel_num do
		if(cfgdata['advance']['channel'..i] ~= nil and ch_prilist[i] == 1 and cfgdata['advance_cap']['channel'..i] ~= nil 
				and cfgdata['advance_cap']['channel'..i].AdvancedAbility_enable == true) then
			camreaitems[idx] = i;
			if w1_page_noopsyche_advance.channel == i then
				w1_page_noopsyche_advance.old_sel = idx-1
			end
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id, false, false)
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, w1_page_noopsyche_advance.old_sel, false);--Ĭһ
		
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		w1_page_noopsyche_advance.channel = chid
		if cfgdata['advance_cap']['channel'..chid] ~= nil and cfgdata['advance_cap']['channel'..chid].AdvancedAbility_enable == true then
			if (cfgdata.advance_cap['channel'..chid].camera_type == 1) then
				show_senc = true;
				hide_sens(top, not show_senc, false);		
				local channeldata = w1_page_noopsyche_advance.data.advance['channel'..chid]
				local cap_data = cfgdata['advance_cap']['channel'..chid];	
				b_wnd_ex.set_value(top, c_wnd.t_sens.id, channeldata.sensitivity, false)
				b_wnd_ex.set_text(top, c_wnd.sens_value.id, tostring(channeldata.sensitivity), false)			
				if ( channeldata.white_light_enable == 1) then
					b_wnd_ex.set_check(top, c_wnd.t_white_light.id, true, false);
				else
					b_wnd_ex.set_check(top, c_wnd.t_white_light.id, false, false);
				end	
					b_wnd_ex.set_value(top, c_wnd.t_light_durate.id, channeldata.ligth_duration, false);
				b_wnd_ex.set_range(top, c_wnd.t_light_durate.id, {cfgdata['advance_cap']['channel'..chid].LightLinkage_min, cfgdata['advance_cap']['channel'..chid].LightLinkage_max}, false);
				update_layout(top, channeldata, cap_data, false);

				b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_advance_id, 	true, false)
				w1_page_noopsychearea_advance.sethide(top, true, false)
				b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_advance_area_id, true, false);
				b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.con_noopsyche_advance_id, true, false);				
			else
			b_wnd_ex.set_hide(top, w1_id.cfg_noopsyche.noopsycheprow_advance_id, false, false)
				b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_advance_area_id, false, false);
				b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.con_noopsyche_advance_id, false, false);			
			w1_page_noopsychearea_advance.sethide(top, false, false)
			w1_page_noopsychearea_advance.setdispch(top, chid);
			refresh_chdata(top, chid, false);
				show_senc = false;
				hide_sens(top, not show_senc, false);		
			end			
		else
			b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_advance_id, 	true, false)
			w1_page_noopsychearea_advance.sethide(top, true, false)
			b_wnd_ex.set_text(top,c_wnd.tipinfo.id,STR('LA_RAID_NOT_SUPPORT'),false);
			b_wnd_ex.set_color(top,c_wnd.tipinfo.id,
			{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_hint_err_text')},false);
			show_senc = false;
			hide_sens(top, not show_senc, false);				
		end
	else--ͨ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,true, false)
		b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_advance_id, 	true, false)
		w1_page_noopsychearea_advance.sethide(top, true, false)
		b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_advance_area_id, true, false);
		b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.con_noopsyche_advance_id, true, false);
		show_senc = false;
		hide_sens(top, not show_senc, false);
	end
	
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local c_wnd = w1_page_noopsyche_advance.wnd
	if (show_senc ~= true) then	
	local flag,errstr = w1_page_noopsychearea_advance.datacheck(top);
	if flag == false then
		w1_msgbox.set_dlgattr(STR('LA_TIP'), errstr, true, false,false);
		w1_msgbox.set_func(nil, nil, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		return false,nil
		end
	end
	return true, nil
end

w1_page_noopsyche_advance.timer_start = function()
	w1_page_noopsyche_advance.timestart = true
end

w1_page_noopsyche_advance.timer_stop = function(top)
	w1_page_noopsyche_advance.timestart = false
	w1_wnd_util.tipclear(top, w1_page_noopsyche_advance.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_noopsyche_advance.timerenevt = function(top)
	if(w1_page_noopsyche_advance.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_noopsyche_advance.wnd.tipinfo.id)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_noopsyche_advance.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id))
	if(chid == nil) then
		return 0
	end
	
	local c_wnd = w1_page_noopsyche_advance.wnd
	local data = cfgdata.advance['channel'..chid]
	local cap_data = w1_page_noopsyche_advance.data['advance_cap']['channel'..chid];
	if (show_senc == true) then
		if (cap_data.Scene_enable == true) then
		data.sensitivity = b_wnd_ex.get_value(top, c_wnd.t_sens.id);
		end
		if (cap_data.LightLinkage_enable == true) then
		local check = b_wnd_ex.get_check(top, c_wnd.t_white_light.id);
		data.white_light_enable = 0;	
		if (check) then
			data.white_light_enable = 1;	
		end
		data.ligth_duration = b_wnd_ex.get_value(top, c_wnd.t_light_durate.id);
		end
	end	
	data.change_flag = true;
	
	return 0
end

w1_page_noopsyche_advance.pageinit = function(top)
	return 0
end

w1_page_noopsyche_advance.init= function(top)
	local c_wnd = w1_page_noopsyche_advance.wnd
	
	w1_wnd_util.cfgtab = {'advance','advance_cap','device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local chidstr = b_wnd_ex.get_text(top, c_wnd.t_channel.id);
	if(chidstr == '') then
		w1_page_noopsychearea_advance.setdispch(top, 1);
		return 0
	end
	return 0
end

w1_page_noopsyche_advance.set_channel = function(chn)
	w1_page_noopsyche_advance.channel = chn;
end

w1_page_noopsyche_advance.get_channel = function()
	return w1_page_noopsyche_advance.channel;
end

local on_channel = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_noopsyche_advance.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		local old_chid = w1_page_noopsyche_advance.channel
		if(old_chid ~= chid) then
			if w1_page_noopsyche_advance.data['advance_cap']['channel'..old_chid] ~= nil 
				and w1_page_noopsyche_advance.data['advance_cap']['channel'..old_chid].AdvancedAbility_enable == true then
				if (show_senc ~= true) then
				local flag,errstr = w1_page_noopsychearea_advance.datacheck(top);
				if flag == false then
					b_wnd_ex.set_sel(top, c_wnd.t_channel.id, w1_page_noopsyche_advance.old_sel,false);
					w1_msgbox.set_dlgattr(STR('LA_TIP'), errstr, true, false,false);
					w1_msgbox.set_func(nil, nil, nil, nil);
					b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
					b_dlg.dlg_set_redraw(top);
					return 0;
				end
			end
			end
			 w1_page_noopsyche_advance.old_sel = b_wnd_ex.get_sel(top, c_wnd.t_channel.id);
			b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);
			if w1_page_noopsyche_advance.data['advance_cap']['channel'..chid] ~= nil 
				and w1_page_noopsyche_advance.data['advance_cap']['channel'..chid].AdvancedAbility_enable == true then
				if (w1_page_noopsyche_advance.data.advance_cap['channel'..chid].camera_type == 1) then	
					show_senc = true;
					hide_sens(top, not show_senc, false);		
					local channeldata = w1_page_noopsyche_advance.data.advance['channel'..chid]
					local cap_data = w1_page_noopsyche_advance.data['advance_cap']['channel'..chid];
					b_wnd_ex.set_value(top, c_wnd.t_sens.id, channeldata.sensitivity, false)
					b_wnd_ex.set_text(top, c_wnd.sens_value.id, tostring(channeldata.sensitivity), false)			
					if ( channeldata.white_light_enable == 1) then
						b_wnd_ex.set_check(top, c_wnd.t_white_light.id, true, false);
					else
						b_wnd_ex.set_check(top, c_wnd.t_white_light.id, false, false);
					end	
						b_wnd_ex.set_value(top, c_wnd.t_light_durate.id, channeldata.ligth_duration, false);
					b_wnd_ex.set_range(top, c_wnd.t_light_durate.id, {cap_data.LightLinkage_min, cap_data.LightLinkage_max}, false);
					update_layout(top, channeldata, cap_data, false);
					
					b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_advance_id, 	true, false)
					w1_page_noopsychearea_advance.sethide(top, true, false)
					b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_advance_area_id, true, false);
					b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.con_noopsyche_advance_id, true, false);				
				else
				b_wnd_ex.set_hide(top, w1_id.cfg_noopsyche.noopsycheprow_advance_id, false, false)
					b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_advance_area_id, false, false);
					b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.con_noopsyche_advance_id, false, false);			
				w1_page_noopsychearea_advance.sethide(top, false, false)
				w1_page_noopsychearea_advance.setdispch(top, chid);
				refresh_chdata(top, chid, false);
					show_senc = false;
					hide_sens(top, not show_senc, false);		
				end			
			else
				b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_advance_id, 	true, false)
				w1_page_noopsychearea_advance.sethide(top, true, false)
				b_wnd_ex.set_text(top,c_wnd.tipinfo.id,STR('LA_RAID_NOT_SUPPORT'),false);
				b_wnd_ex.set_color(top,c_wnd.tipinfo.id,
				{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_hint_err_text')},false);
				show_senc = false;
				hide_sens(top, not show_senc, false);						
			end
			w1_page_noopsyche_advance.channel = chid;
		end
		b_dlg.dlg_set_redraw(top);
	end
	
	return 0;

end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.insight ~= 0) then--????
		w1_wnd_util.setparamerr_str(STR('LA_APPLY_FAIL'));
		--????????
		b_app_cfg.origin_init(w1_wnd_util.cfgtab);
		return false, nil;
	end
	return true, nil;
end

local copy_okfunc = function(param)
	local cwnd = w1_page_noopsyche_advance.wnd;
	local chid = tonumber(b_wnd_ex.get_text(param[1], cwnd.t_channel.id));
	if(chid == nil) then
		return 0;
	end
	local chsrc = w1_page_noopsyche_advance.data.advance['channel'..chid];
	local chdir = w1_page_noopsyche_advance.data.advance;
	
	for i=1, #param[2] do
		if(chdir['channel'..param[2][i]] == nil) then
			chdir['channel'..param[2][i]] = util.copy_tab(chsrc)
		else
			util.copy_tab_b(chdir['channel'..param[2][i]], chsrc)
		end	
		chdir['channel'..param[2][i]].change_flag = true;	
		chdir['channel'..param[2][i]].channel_id = param[2][i];
	end
	
	
	return 0;
end

local on_copy = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_noopsyche_advance.wnd;
		local param = {};
		local idx = 1;
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
		local ret, errstr = uidatacheck(top)
		if ret == false then
			return 0;
		end
		
		local privilege = global_val.get_allprivilege();--ȡȨ
		local ch_prilist = privilege.channel_manager_list;	
		for i=1, channel_num do
			if( i ~= chid and w1_page_noopsyche_advance.data.advance['channel'..i] ~= nil
				 and ch_prilist[i] == 1) then
				param[idx] = i;
				idx =idx + 1;
			end
		end
		w1_copy.init();
		w1_copy.set_dlgattr(param);
		w1_copy.set_func (copy_okfunc,{top, w1_page_noopsyche_advance.copy_ch} );
		b_dlg.post_modal(top, w1_key.DLG_COPY, 0, 0, nil)
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;
	end
	return 0
end

w1_page_noopsyche_advance.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;
	return ret;
end

w1_page_noopsyche_advance.on_pre_show = function(top)
	local cwnd = w1_page_noopsyche_advance.wnd;
	channel_num = global_val.get_channelnum();
	local con_id = cwnd.con_noopsyche.id
	w1_row_noopsycherow_advance.changecheck(top, w1_row_noopsycherow_advance.wnd, w1_id.cfg_noopsyche.noopsycheprow_advance_id + 1, false)
end

w1_page_noopsyche_advance.dwell_updata_f =function(top)
	if (show_senc) then
		return ;
	end
	local cwnd = w1_page_noopsyche_advance.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if chid ~= nil and w1_page_noopsyche_advance.data['advance_cap']['channel'..chid] ~= nil 
				and w1_page_noopsyche_advance.data['advance_cap']['channel'..chid].AdvancedAbility_enable == true then
		w1_page_noopsychearea_advance.dwell_updata_f(top)
	end
end

w1_page_noopsyche_advance.dwell_mouse_up =function(top)
	if (show_senc) then
		return ;
	end	
	local cwnd = w1_page_noopsyche_advance.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if chid ~= nil and w1_page_noopsyche_advance.data['advance_cap']['channel'..chid] ~= nil 
				and w1_page_noopsyche_advance.data['advance_cap']['channel'..chid].AdvancedAbility_enable == true then
		w1_page_noopsychearea_advance.dwell_mouse_up(top)
	end
end

w1_page_noopsyche_advance.dwell_mouse_down =function(top)
	if (show_senc) then
		return ;
	end
	local cwnd = w1_page_noopsyche_advance.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if chid ~= nil and w1_page_noopsyche_advance.data['advance_cap']['channel'..chid] ~= nil 
				and w1_page_noopsyche_advance.data['advance_cap']['channel'..chid].AdvancedAbility_enable == true then
		w1_page_noopsychearea_advance.dwell_mouse_down(top)
	end
end

w1_page_noopsyche_advance.dwell_drop_drag =function(top)
	if (show_senc) then
		return ;
	end
	local cwnd = w1_page_noopsyche_advance.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if chid ~= nil and w1_page_noopsyche_advance.data['advance_cap']['channel'..chid] ~= nil 
				and w1_page_noopsyche_advance.data['advance_cap']['channel'..chid].AdvancedAbility_enable == true then
		w1_page_noopsychearea_advance.dwell_drop_drag(top)
	end
end

local on_white_light = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local c_wnd = w1_page_noopsyche_advance.wnd
		local check = b_wnd_ex.get_check(top, c_wnd.t_white_light.id);
		on_white_light_change(top, check, false)
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end
local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_noopsyche_advance.wnd;
		local value = b_wnd_ex.get_value(top, cwnd.t_sens.id);
		if(value > 1) then
			value = value - 1;
			b_wnd_ex.set_value(top, cwnd.t_sens.id, value, true)
			b_wnd_ex.set_text(top, cwnd.sens_value.id, tostring(value), true)
			uitousercfg(top,b_app_cfg.user_cfg);
		end	
	end
	return 0
end
local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_noopsyche_advance.wnd;
		local value = b_wnd_ex.get_value(top, cwnd.t_sens.id);
		b_wnd_ex.set_text(top, cwnd.sens_value.id, tostring(value), true)
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end
local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_noopsyche_advance.wnd;
		local value = b_wnd_ex.get_value(top, cwnd.t_sens.id);
		if(value < 5) then
			value = value + 1;
			b_wnd_ex.set_value(top, cwnd.t_sens.id, value, true)
			b_wnd_ex.set_text(top, cwnd.sens_value.id, tostring(value), true)
		end
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end
local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
		update_flag = false;
	end
	return 0
end
w1_page_noopsyche_advance.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_channel', 't_channel','con_noopsyche','noopsyche_row_wnd','noopsychearea_wnd',
			'cap_sensitivity','sens_subb', 't_sens', 'sens_add', 'sens_value', 'cap_white_light', 
			't_white_light', 'cap_light_durate','t_light_durate','t_unit', 'tipinfo', 'apply'},
		
	cap_channel	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+2,xywh='s_cfg_page_1_2',items={},trans = false,channel_cbox = true,cmd =on_channel},	
		
	con_noopsyche			= {t='container',id=w1_id.cfg_noopsyche.con_noopsyche_advance_id,	xywh={0,0,10,10}},
	noopsyche_row_wnd 		= w1_row_noopsycherow_advance.wnd,
	noopsychearea_wnd 		= w1_page_noopsychearea_advance.wnd,	
	tipinfo	= {t='static',id=id+5,	xywh='s_noopsyche_page_tipinfo_xywh',text='',trans = false},
	
	cap_sensitivity	 = {t='static',id=id+6,xywh='s_cfg_page_2_1',text='LA_SENSITIVITY'},			
	sens_subb	= {t='button',id=id+7,	xywh='s_advance_sens_sub',
					color 	= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},
					color_f = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_sens	= {t='hslider',id=id+8,xywh='s_advance_t_sens',	range = {1, 5},	
					font = 'f_slider', cmd=on_adj},
	sens_add	= {t='button',id=id+9,	xywh='s_advance_t_add',
					color 	= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},
					color_f = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	sens_value = {t='static',id=id+10,	xywh='s_advance_sense_value',trans = false},
	cap_white_light	= {t='static',id=id+11,	xywh='s_cfg_page_3_1',text='LA_WHITE_LIGHT'},
	t_white_light = {t='tt_check',id=id+12,	xywh='s_advance_t_white_light',	font = 'f_grade4',
					t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_white_light},		
	cap_light_durate 	= {t='static',id=id+13,	xywh='s_cfg_page_4_1',text='LA_LIGHT_DURATE'},	
	t_light_durate 		= {t='edit_num',id=id+14,xywh='s_advance_t_light_duate',range={10,40},cmd = on_update_param},
	t_unit				= {t='static',id=id+15,	xywh='s_advance_t_unit',text='LA_DURATE_UNIT'},	
	apply 	= {t='button',id=id+16,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_noopsyche_advance

