--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_noopsyche.noopsyche_person_count_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 

local w1_row_noopsycherow_person_count 		= require("wnd.w1_cfg.w1_row_noopsycherow_person_count")
local w1_page_noopsychearea_person_count 	= require("wnd.w1_cfg.w1_page_noopsychearea_person_count")
local w1_page_noopsycheevent_person_count 	= require("wnd.w1_cfg.w1_page_noopsycheevent_person_count")
local w1_page_noopsychetimeplan_person_count 	= require("wnd.w1_cfg.w1_page_noopsychetimeplan_person_count")

local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_color		= require("wnd.core.r_res.r_color")
local COLOR 		= r_color.get_color

local w1_page_noopsyche_person_count = 
{
	channel = 0,
	old_sel = 0,
	data,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_noopsyche_person_count.s_768 =
{
};

w1_page_noopsyche_person_count.s_1280 = 
{

}

w1_page_noopsyche_person_count.s_1440 = 
{

}

w1_page_noopsyche_person_count.s_1080p = 
{

}

w1_page_noopsyche_person_count.s_2k = 
{

}

w1_page_noopsyche_person_count.s_4k = 
{

}

local channel_num;--豸ͨĿ

w1_page_noopsyche_person_count.clear_data = function()
	w1_page_noopsycheevent_person_count.clear_data();
	w1_page_noopsychearea_person_count.clear_data();
	w1_page_noopsychetimeplan_person_count.clear_data();
	w1_page_noopsyche_person_count.data = nil;
end	

local refresh_chdata = function(top, chid, redraw)
	local c_wnd = w1_page_noopsyche_person_count.wnd
	local channeldata = w1_page_noopsyche_person_count.data.person_count['channel'..chid]
	local ro_num = w1_page_noopsyche_person_count.data.device_info['ro_num']
	local buzz_support = w1_page_noopsyche_person_count.data.device_info['buzzer_support']
	b_wnd_ex.set_check(top, c_wnd.t_enable.id, channeldata.enable, redraw);
	local checkidx = w1_row_noopsycherow_person_count.get_checkidx(top);
	if(checkidx == 0) then
		w1_page_noopsycheevent_person_count.setstatus(top, channeldata, chid, ro_num, buzz_support, redraw);
		w1_page_noopsychearea_person_count.set_data(top, chid, channeldata, redraw);
		w1_page_noopsychetimeplan_person_count.settimeplan(top, channeldata, redraw);	
	elseif(checkidx == 1) then
		w1_page_noopsycheevent_person_count.setstatus(top, channeldata, chid, ro_num, buzz_support,redraw);
		w1_page_noopsychearea_person_count.set_data(top, chid, channeldata, redraw);
		w1_page_noopsychetimeplan_person_count.settimeplan(top, channeldata, redraw);
	elseif(checkidx == 2) then
		w1_page_noopsycheevent_person_count.setstatus(top, channeldata, chid, ro_num, buzz_support,redraw);
		w1_page_noopsychearea_person_count.set_data(top, chid, channeldata, redraw);
		w1_page_noopsychetimeplan_person_count.settimeplan(top, channeldata, redraw);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)	
	assert(type(cfgdata) == 'table')
	w1_page_noopsyche_person_count.data = cfgdata;
	
	local c_wnd = w1_page_noopsyche_person_count.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	w1_page_noopsyche_person_count.old_sel = 0
	for i=1, channel_num do
		if(cfgdata['person_count']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			if w1_page_noopsyche_person_count.channel == i then
				w1_page_noopsyche_person_count.old_sel = idx-1
			end
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	if(idx ~= 1 ) then--˵ͨ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id, false, false)
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, w1_page_noopsyche_person_count.old_sel, false);--Ĭһ
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		w1_page_noopsyche_person_count.channel = chid
		b_wnd_ex.set_hide(top, w1_id.cfg_noopsyche.noopsycheprow_person_count_id, false, false)
		b_wnd_ex.set_hide(top,  c_wnd.cap_enable.id, 	false, false)
		b_wnd_ex.set_hide(top,  c_wnd.t_enable.id, 	false, false)
		w1_page_noopsycheevent_person_count.sethide(top, false, false)
		w1_page_noopsychearea_person_count.sethide(top, false, false)
		w1_page_noopsychetimeplan_person_count.sethide(top, false, false)
		refresh_chdata(top, chid, false);
	else--ͨ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,true, false)
		b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_person_count_id, 	true, false)
		b_wnd_ex.set_hide(top,  c_wnd.cap_enable.id, 	true, false)
		b_wnd_ex.set_hide(top,  c_wnd.t_enable.id, 	true, false)
		w1_page_noopsycheevent_person_count.sethide(top, true, false)
		w1_page_noopsychearea_person_count.sethide(top, true, false)
		w1_page_noopsychetimeplan_person_count.sethide(top, true, false)
	end
	
	return 0	
end

w1_page_noopsyche_person_count.timer_start = function()
	w1_page_noopsyche_person_count.timestart = true
end

w1_page_noopsyche_person_count.timer_stop = function(top)
	w1_page_noopsyche_person_count.timestart = false
	w1_wnd_util.tipclear(top, w1_page_noopsyche_person_count.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_noopsyche_person_count.timerenevt = function(top)
	if(w1_page_noopsyche_person_count.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_noopsyche_person_count.wnd.tipinfo.id)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_noopsyche_person_count.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id))
	if(chid == nil) then
		return 0
	end
	
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	local data = cfgdata.person_count['channel'..chid]
	data.enable = enable;
	data.change_flag = true;
	
	return 0
end

w1_page_noopsyche_person_count.pageinit = function(top)
	return 0
end

w1_page_noopsyche_person_count.init= function(top)
	local c_wnd = w1_page_noopsyche_person_count.wnd
	w1_wnd_util.cfgtab = {'person_count', 'device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local chidstr = b_wnd_ex.get_text(top, c_wnd.t_channel.id);
	if(chidstr == '') then
		b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_person_count_id, 	true, false)
		return 0
	end
	return 0
end

w1_page_noopsyche_person_count.set_channel = function(chn)
	w1_page_noopsyche_person_count.channel = chn;
end

w1_page_noopsyche_person_count.get_channel = function()
	return w1_page_noopsyche_person_count.channel;
end



w1_page_noopsyche_person_count.on_data_change = function(top)
	if w1_row_noopsycherow_person_count.get_checkidx(top)==0 then
		w1_page_noopsycheevent_person_count.on_channel_check(top);
	else
		w1_page_noopsychearea_person_count.on_data_change(top);
	end
end

local on_channel = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_noopsyche_person_count.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		local old_chid = w1_page_noopsyche_person_count.channel
		if(old_chid ~= chid) then
			w1_page_noopsyche_person_count.old_sel = b_wnd_ex.get_sel(top, c_wnd.t_channel.id);
			b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);
			b_wnd_ex.set_hide(top, w1_id.cfg_noopsyche.noopsycheprow_person_count_id, false, false)
			w1_page_noopsychearea_person_count.sethide(top, false, false)
			w1_page_noopsycheevent_person_count.sethide(top, false, false)
			w1_page_noopsychetimeplan_person_count.sethide(top, false, false)
			refresh_chdata(top, chid, false);
			w1_page_noopsyche_person_count.channel = chid;
		end
		b_dlg.dlg_set_redraw(top);
	end
	
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local uidatacheck =function(top)
	return true, nil
end

local returndatacheck =function(top,ret)
	return true, nil;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;
	end
	return 0
end

w1_page_noopsyche_person_count.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	w1_wnd_util.returndatacheckfunc = nil;
	return ret;
end

w1_page_noopsyche_person_count.on_pre_show = function(top)
	local cwnd = w1_page_noopsyche_person_count.wnd;
	channel_num = global_val.get_channelnum();
	w1_page_noopsycheevent_person_count.on_pre_show(top, channel_num)
	w1_page_noopsychearea_person_count.on_pre_show(top)
	local con_id = cwnd.con_noopsyche.id
	w1_row_noopsycherow_person_count.changecheck(top, w1_row_noopsycherow_person_count.wnd, w1_id.cfg_noopsyche.noopsycheprow_person_count_id + 1, false)
end

w1_page_noopsyche_person_count.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_channel', 't_channel','cap_enable','t_enable','con_noopsyche','noopsyche_row_wnd','noopsycheevent_wnd','noopsychearea_wnd', 'noopsychetimeplan_wnd',
			'tipinfo', 'apply'},
		
	cap_channel	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+2,xywh='s_cfg_page_1_2',items={},trans = false,channel_cbox = true,cmd =on_channel},
	
	cap_enable 	= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_ENABLE'},
	t_enable 	= {t='tt_check', id=id+4,xywh='s_noopsyche_page_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd =on_enable},
		
	con_noopsyche			= {t='container',id=w1_id.cfg_noopsyche.con_noopsyche_person_count_id,	xywh={0,0,10,10}},
	noopsyche_row_wnd 		= w1_row_noopsycherow_person_count.wnd,
	noopsycheevent_wnd 		= w1_page_noopsycheevent_person_count.wnd,	
	noopsychearea_wnd 		= w1_page_noopsychearea_person_count.wnd,	
	noopsychetimeplan_wnd 		= w1_page_noopsychetimeplan_person_count.wnd,	
	
	tipinfo	= {t='static',id=id+5,	xywh='s_noopsyche_page_tipinfo_xywh',text='',trans = false},
	apply 	= {t='button',id=id+6,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_noopsyche_person_count

