--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_noopsyche.noopsycheprow_person_count_area_id
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_wnd 				= require("wnd.core.b_wnd")

local w1_page_noopsychearea_person_count = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_noopsychearea_person_count.s_768 = 
{
	s_person_count_area_xywh = {53,170,746,369},
	s_cfg_person_count_image_xywh = {17,8,384,296},
	s_cfg_person_count_cap_osd_enable_xywh = {416,7,160,35},
	s_cfg_person_count_t_osd_enable_xywh = {572,14,25,21},
	s_cfg_person_count_cap_clear_interval_xywh = {416,42,160,35},
	s_cfg_person_count_t_clear_interval_xywh = {576,42,160,35},
	s_cfg_person_count_cap_area_type_xywh = {416,78,160,35},
	s_cfg_person_count_t_area_type_xywh = {576,78,160,35},
	s_cfg_person_count_cap_setting_enable_xywh = {416,113,160,35},
	s_cfg_person_count_t_setting_enable_xywh = {572,120,25,21},
	s_cfg_person_count_cap_setting_value_xywh = {416,149,160,35},
	s_cfg_person_count_t_setting_value_xywh = {576,149,160,35},
	s_cfg_person_count_cap_alarm_enable_xywh = {416,184,160,35},
	s_cfg_person_count_t_alarm_enable_xywh = {572,192,25,21},
	s_cfg_person_count_cap_threshold_xywh = {416,220,160,35},
	s_cfg_person_count_t_threshold_xywh = {576,220,160,35},
	s_cfg_person_count_cap_audio_dec_xywh = {416,256,160,35},
	s_cfg_person_count_t_audio_dec_xywh = {572,263,25,21},
	s_cfg_person_count_cap_sound_file_xywh = {416,291,160,35},
	s_cfg_person_count_t_sound_file_xywh = {576,291,160,35},
	s_cfg_person_count_cap_flashlight_xywh = {416,327,160,35},
	s_cfg_person_count_t_flashlight_xywh = {572,334,25,21},
	s_cfg_person_count_noteinfo_xywh = {6,312,346,28},
	s_cfg_person_count_noteinfo2_xywh = {6,341,346,28},
};


w1_page_noopsychearea_person_count.s_1280 = 
{
	s_person_count_area_xywh 					= {80,240,880,520},
	s_cfg_person_count_image_xywh 				= {12,10,416,400},
	s_cfg_person_count_cap_osd_enable_xywh 		= {430,10,230,40},
	s_cfg_person_count_t_osd_enable_xywh 		= {713,15,48,30},
	s_cfg_person_count_cap_clear_interval_xywh 	= {430,50,240,40},
	s_cfg_person_count_t_clear_interval_xywh 	= {720,50,200,40},
	s_cfg_person_count_cap_area_type_xywh 		= {430,90,230,40},
	s_cfg_person_count_t_area_type_xywh 		= {720,90,200,40},
	s_cfg_person_count_cap_setting_enable_xywh 	= {430,130,230,40},
	s_cfg_person_count_t_setting_enable_xywh 	= {713,135,48,30},
	s_cfg_person_count_cap_setting_value_xywh 	= {430,170,230,40},
	s_cfg_person_count_t_setting_value_xywh 	= {720,170,200,40},
	s_cfg_person_count_cap_alarm_enable_xywh 	= {430,210,230,40},
	s_cfg_person_count_t_alarm_enable_xywh 		= {713,215,48,30},
	s_cfg_person_count_cap_threshold_xywh 		= {430,250,230,40},
	s_cfg_person_count_t_threshold_xywh 		= {720,250,200,40},
	s_cfg_person_count_cap_audio_dec_xywh 		= {430, 290, 230, 40},	
	s_cfg_person_count_t_audio_dec_xywh 		= {713, 295, 48, 30},	
	s_cfg_person_count_cap_sound_file_xywh 		= {430, 330, 230, 40},	
	s_cfg_person_count_t_sound_file_xywh 		= {720, 330, 200, 40},	
	s_cfg_person_count_cap_flashlight_xywh 		= {430, 370, 230, 40},	
	s_cfg_person_count_t_flashlight_xywh 		= {713, 375, 48, 30},		
	s_cfg_person_count_noteinfo_xywh 			= {12,430,450,40},
	s_cfg_person_count_noteinfo2_xywh 			= {12,470,450,40},	
};

w1_page_noopsychearea_person_count.s_1440 = 
{
	s_person_count_area_xywh 					= {100,220,1000,480},
	s_cfg_person_count_image_xywh 				= {12,10,550,356},
	s_cfg_person_count_cap_osd_enable_xywh 		= {600,10,250,40},
	s_cfg_person_count_t_osd_enable_xywh 		= {853,15,48,30},
	s_cfg_person_count_cap_clear_interval_xywh 	= {600,50,250,40},
	s_cfg_person_count_t_clear_interval_xywh 	= {860,50,150,40},
	s_cfg_person_count_cap_area_type_xywh 		= {600,90,250,40},
	s_cfg_person_count_t_area_type_xywh 		= {860,90,150,40},
	s_cfg_person_count_cap_setting_enable_xywh 	= {600,130,250,40},
	s_cfg_person_count_t_setting_enable_xywh 	= {853,135,48,30},
	s_cfg_person_count_cap_setting_value_xywh 	= {600,170,250,40},
	s_cfg_person_count_t_setting_value_xywh 	= {860,170,150,40},
	s_cfg_person_count_cap_alarm_enable_xywh 	= {600,210,250,40},
	s_cfg_person_count_t_alarm_enable_xywh 		= {853,215,48,30},
	s_cfg_person_count_cap_threshold_xywh 		= {600,250,250,40},
	s_cfg_person_count_t_threshold_xywh 		= {860,250,150,40},
	s_cfg_person_count_cap_audio_dec_xywh 		= {600, 290, 300, 40},	
	s_cfg_person_count_t_audio_dec_xywh 		= {853, 295, 48, 30},	
	s_cfg_person_count_cap_sound_file_xywh 		= {600, 330, 300, 40},	
	s_cfg_person_count_t_sound_file_xywh 		= {860, 330, 300, 40},	
	s_cfg_person_count_cap_flashlight_xywh 		= {600, 370, 300, 40},	
	s_cfg_person_count_t_flashlight_xywh 		= {853, 375, 48, 30},			
	s_cfg_person_count_noteinfo_xywh 			= {12,366,550,30},
	s_cfg_person_count_noteinfo2_xywh 			= {12,400,550,30},	
};

w1_page_noopsychearea_person_count.s_1080p = 
{
	s_person_count_area_xywh 					= {100,240,1400,520},
	s_cfg_person_count_image_xywh 				= {30,10,704,416},
	s_cfg_person_count_cap_osd_enable_xywh 		= {780,10,300,50},
	s_cfg_person_count_t_osd_enable_xywh 		= {1073,20,48,30},
	s_cfg_person_count_cap_clear_interval_xywh 	= {780,60,300,50},
	s_cfg_person_count_t_clear_interval_xywh 	= {1080,60,300,50},
	s_cfg_person_count_cap_area_type_xywh 		= {780,110,300,50},
	s_cfg_person_count_t_area_type_xywh 		= {1080,110,300,50},
	s_cfg_person_count_cap_setting_enable_xywh 	= {780,160,300,50},
	s_cfg_person_count_t_setting_enable_xywh 	= {1073,170,48,30},
	s_cfg_person_count_cap_setting_value_xywh 	= {780,210,300,50},
	s_cfg_person_count_t_setting_value_xywh 	= {1080,210,300,50},
	s_cfg_person_count_cap_alarm_enable_xywh 	= {780,260,300,50},
	s_cfg_person_count_t_alarm_enable_xywh 		= {1073,270,48,30},
	s_cfg_person_count_cap_threshold_xywh 		= {780,310,300,50},
	s_cfg_person_count_t_threshold_xywh 		= {1080,310,300,50},
	s_cfg_person_count_cap_audio_dec_xywh 		= {780, 360, 300, 50},	
	s_cfg_person_count_t_audio_dec_xywh 		= {1073, 370, 48, 30},	
	s_cfg_person_count_cap_sound_file_xywh 		= {780, 410, 300, 50},	
	s_cfg_person_count_t_sound_file_xywh 		= {1080,410, 300, 50},	
	s_cfg_person_count_cap_flashlight_xywh 		= {780, 460, 300, 50},	
	s_cfg_person_count_t_flashlight_xywh 		= {1073, 470, 48, 30},			
	s_cfg_person_count_noteinfo_xywh 			= {12,440,650,40},
	s_cfg_person_count_noteinfo2_xywh 			= {12,480,650,40},	
};

w1_page_noopsychearea_person_count.s_2k = 
{
	s_person_count_area_xywh = {133,320,1866,694},
	s_cfg_person_count_image_xywh = {16,13,970,555},
	s_cfg_person_count_cap_osd_enable_xywh = {1040,13,400,66},
	s_cfg_person_count_t_osd_enable_xywh = {1430,26,63,39},
	s_cfg_person_count_cap_clear_interval_xywh = {1039,79,399,66},
	s_cfg_person_count_t_clear_interval_xywh = {1439,79,399,66},
	s_cfg_person_count_cap_area_type_xywh = {1039,146,399,66},
	s_cfg_person_count_t_area_type_xywh = {1439,146,399,66},
	s_cfg_person_count_cap_setting_enable_xywh = {1039,213,399,66},
	s_cfg_person_count_t_setting_enable_xywh = {1430,226,63,39},
	s_cfg_person_count_cap_setting_value_xywh = {1039,279,399,66},
	s_cfg_person_count_t_setting_value_xywh = {1439,279,399,66},
	s_cfg_person_count_cap_alarm_enable_xywh = {1039,346,399,66},
	s_cfg_person_count_t_alarm_enable_xywh = {1430,359,63,39},
	s_cfg_person_count_cap_threshold_xywh = {1039,413,399,66},
	s_cfg_person_count_t_threshold_xywh = {1439,413,399,66},
	s_cfg_person_count_cap_audio_dec_xywh = {1039,479,399,66},
	s_cfg_person_count_t_audio_dec_xywh = {1430,493,63,39},
	s_cfg_person_count_cap_sound_file_xywh = {1039,546,399,66},
	s_cfg_person_count_t_sound_file_xywh = {1439,546,399,66},
	s_cfg_person_count_cap_flashlight_xywh = {1039,613,399,66},
	s_cfg_person_count_t_flashlight_xywh = {1430,626,63,39},
	s_cfg_person_count_noteinfo_xywh = {15,586,866,53},
	s_cfg_person_count_noteinfo2_xywh = {15,639,866,53},
};

w1_page_noopsychearea_person_count.s_4k = 
{
	s_person_count_area_xywh = {200,480,2800,1040},
	s_cfg_person_count_image_xywh = {24,20,1456,832},
	s_cfg_person_count_cap_osd_enable_xywh = {1560,20,600,100},
	s_cfg_person_count_t_osd_enable_xywh = {2146,40,96,60},
	s_cfg_person_count_cap_clear_interval_xywh = {1560,120,600,100},
	s_cfg_person_count_t_clear_interval_xywh = {2160,120,600,100},
	s_cfg_person_count_cap_area_type_xywh = {1560,220,600,100},
	s_cfg_person_count_t_area_type_xywh = {2160,220,600,100},
	s_cfg_person_count_cap_setting_enable_xywh = {1560,320,600,100},
	s_cfg_person_count_t_setting_enable_xywh = {2146,340,96,60},
	s_cfg_person_count_cap_setting_value_xywh = {1560,420,600,100},
	s_cfg_person_count_t_setting_value_xywh = {2160,420,600,100},
	s_cfg_person_count_cap_alarm_enable_xywh = {1560,520,600,100},
	s_cfg_person_count_t_alarm_enable_xywh = {2146,540,96,60},
	s_cfg_person_count_cap_threshold_xywh = {1560,620,600,100},
	s_cfg_person_count_t_threshold_xywh = {2160,620,600,100},
	s_cfg_person_count_cap_audio_dec_xywh = {1560,720,600,100},
	s_cfg_person_count_t_audio_dec_xywh = {2146,740,96,60},
	s_cfg_person_count_cap_sound_file_xywh = {1560,820,600,100},
	s_cfg_person_count_t_sound_file_xywh = {2160,820,600,100},
	s_cfg_person_count_cap_flashlight_xywh = {1560,920,600,100},
	s_cfg_person_count_t_flashlight_xywh = {2146,940,96,60},
	s_cfg_person_count_noteinfo_xywh = {24,880,1300,80},
	s_cfg_person_count_noteinfo2_xywh = {24,960,1300,80},
};
local channel_num;--豸ͨĿ
local set_custom_layout = function(chid)
	local param = {
		chn_id = chid,
		wnd_id = 1,
	}
	local layoutpos = w1_page_noopsychearea_person_count.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param)
end

w1_page_noopsychearea_person_count.clear_data = function()
	w1_page_noopsychearea_person_count.data = nil;
end	

local update_layout_info = function(top, redraw)
	local cwnd =w1_page_noopsychearea_person_count.wnd
	local data = w1_page_noopsychearea_person_count.data;
	local set_enable = b_wnd_ex.get_check(top,cwnd.t_setting_enable.id);
	local pos_1 = SIZE('s_cfg_person_count_cap_setting_value_xywh');
	local pos_2 = SIZE('s_cfg_person_count_cap_alarm_enable_xywh');
	local move_h = pos_2[2] - pos_1[2];	
	
	local s_id = cwnd.cap_setting_value.id; 
	local e_id = cwnd.t_enable_flshlight.id;	
	for i = s_id, e_id do
		pos = SIZE(cwnd[cwnd.sub[i - id]].xywh);
		b_wnd_ex.move_pos(top, i, {pos[1], pos[2]}, false);
	end
	
	if (set_enable == false) then
		b_wnd_ex.set_hide(top,cwnd.t_setting_value.id, true, false);
		b_wnd_ex.set_hide(top,cwnd.cap_setting_value.id, true, false);
		local s_id = cwnd.cap_alarm_enable.id; 
		local e_id = cwnd.t_enable_flshlight.id;	
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end			
	else
		b_wnd_ex.set_hide(top,cwnd.t_setting_value.id, false, false);
		b_wnd_ex.set_hide(top,cwnd.cap_setting_value.id, false, false);
	end	
	
	if (data.AudioAction_enable == true) then
		b_wnd_ex.set_hide(top,cwnd.cap_enable_audio.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_audio.id,false,false);
		local audio_enable = b_wnd_ex.get_check(top,cwnd.t_enable_audio.id);	
		if (audio_enable == true) then
			b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,false,false);
			b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,false,false);	
		else
			b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,true,false);
			b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,true,false);		
			--һ
			local s_id = cwnd.cap_enable_flshlight.id; 
			local e_id = cwnd.t_enable_flshlight.id;
			for i = s_id, e_id do
				pos = b_wnd.get_wnd_a_rect(top, i);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
			end			
		end	
	else
		b_wnd_ex.set_hide(top,cwnd.cap_enable_audio.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_audio.id,true,false);	
		b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,true,false);	
		--2
		local s_id = cwnd.cap_enable_flshlight.id; 
		local e_id = cwnd.t_enable_flshlight.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - 2*move_h}, false);
		end			
	end	
	
	if (data.LEDAction_enable == true) then
		b_wnd_ex.set_hide(top,cwnd.cap_enable_flshlight.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_flshlight.id,false,false);	
	else
		b_wnd_ex.set_hide(top,cwnd.cap_enable_flshlight.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_flshlight.id,true,false);	
	end
	
	if (true == redraw)then
		b_dlg.dlg_set_redraw(top);	
	end
	
end	

w1_page_noopsychearea_person_count.set_data = function(top, chid, chn_data, redraw)
	w1_page_noopsychearea_person_count.data = chn_data;
	local data = w1_page_noopsychearea_person_count.data;
	local chn = "channel"..chid;
	set_custom_layout(chid);
	local cwnd =w1_page_noopsychearea_person_count.wnd
	b_wnd_ex.set_enableselect(top,cwnd.image.id,true,false);	
	b_wnd_ex.set_check(top, cwnd.t_osd_enable.id, data.osd_enable, false)
	local sel = data.ClearCountMode - 1;
	b_wnd_ex.set_sel(top, cwnd.t_clear_interval.id, sel, false);
	
	b_wnd_ex.set_check(top,cwnd.t_setting_enable.id, data.InitSettingEnable, false)	;
	b_wnd_ex.set_value(top,cwnd.t_setting_value.id, data.InitSettingValue, false);
	b_wnd_ex.set_text(top,cwnd.t_setting_value.id, tostring(data.InitSettingValue), false);
	b_wnd_ex.set_check(top,cwnd.t_alarm_enable.id, data.EnableFlag, false);	
	b_wnd_ex.set_value(top,cwnd.t_threshold.id, data.AlarmThreshold, false);
	b_wnd_ex.set_text(top,cwnd.t_threshold.id, tostring(data.AlarmThreshold), false);
	if (data.AudioAction_enable == true) then
		local param = {};
		for i=data.AudioAction_min+1,data.AudioAction_max+1 do
			param[i] = STR('LA_AUDIO') .. tostring(i-1);
		end
		b_wnd_ex.set_items(top, cwnd.t_sound_cbox.id, param, false);
	end
	b_wnd_ex.set_check(top,cwnd.t_enable_audio.id,data.audio_enable,false);
	b_wnd_ex.set_sel(top, cwnd.t_sound_cbox.id, data.audio_type - data.AudioAction_min, false);	
	b_wnd_ex.set_check(top,cwnd.t_enable_flshlight.id,data.led_enable,false);
	
	local param = {};
	param.RegionType = data.RegionType;
	if  data.RegionType == 1 then
		param.TriggerDirection = data.TriggerDirection;
		param.s_x = data.s_x;
		param.s_y = data.s_y;
		param.e_x = data.e_x;
		param.e_y = data.e_y;
	end
	b_wnd_ex.set_person_count_data(top, w1_page_noopsychearea_person_count.wnd.image.id, param, false);
	
	update_layout_info(top, false);
	
	if (true == redraw)then
		b_dlg.dlg_set_redraw(top);	
	end
end

w1_page_noopsychearea_person_count.sethide =function(top, bool_hide, redraw)
	local cwnd = w1_page_noopsychearea_person_count.wnd;
	local sid = cwnd.image.id;
	local eid = cwnd.noteinfo2.id;
	
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_noopsychearea_person_count.wnd
	local osd_enable = b_wnd_ex.get_check(top,cwnd.t_osd_enable.id)
	local clear_interval = b_wnd_ex.get_sel(top,cwnd.t_clear_interval.id)+1
	local area_type= b_wnd_ex.get_sel(top,cwnd.t_area_type.id)+1
	local image_data = b_wnd_ex.get_person_count_data(top, w1_page_noopsychearea_person_count.wnd.image.id);
	local setting_enable = b_wnd_ex.get_check(top,cwnd.t_setting_enable.id)	
	local setting_value = b_wnd_ex.get_value(top,cwnd.t_setting_value.id);
	local alarm_enable = b_wnd_ex.get_check(top,cwnd.t_alarm_enable.id)	
	local thershold_value = b_wnd_ex.get_value(top,cwnd.t_threshold.id);
	local data = w1_page_noopsychearea_person_count.data;
	data.osd_enable = osd_enable;
	data.ClearCountMode = clear_interval;	
	data.change_flag = true;
	data.InitSettingEnable = setting_enable;	
	data.InitSettingValue = setting_value;
	data.EnableFlag = alarm_enable;
	data.AlarmThreshold = thershold_value;
	if (data.AudioAction_enable == true) then
		data.audio_type = data.AudioAction_min + b_wnd_ex.get_sel(top,cwnd.t_sound_cbox.id);	
		data.audio_enable = b_wnd_ex.get_check(top,cwnd.t_enable_audio.id);
	end	
	
	if (data.LEDAction_enable == true) then
		data.led_enable = b_wnd_ex.get_check(top,cwnd.t_enable_flshlight.id);
	end
	data.RegionType = image_data.RegionType;
	if  data.RegionType == 1 then
		data.TriggerDirection = image_data.TriggerDirection;
		data.s_x = image_data.s_x;
		data.s_y = image_data.s_y;
		data.e_x = image_data.e_x;
		data.e_y = image_data.e_y;
	end
end

w1_page_noopsychearea_person_count.on_data_change = function(top)
	uitousercfg(top,b_app_cfg.user_cfg);
end

local on_update_param = function(top, id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM or b_ui.LBUTTONCLK == vmsg ) then
		uitousercfg(top,b_app_cfg.user_cfg);
	elseif (vmsg == b_ui.RBUTTONCLK) then
		return vmsg;
	end
	return 0;
end

local on_enable_audio = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		update_layout_info(top, true);
		uitousercfg(top,w1_page_noopsychearea_person_count.data)
	end
	return 0
end

local on_setting_enable = function(top, id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM or b_ui.LBUTTONCLK == vmsg ) then
		uitousercfg(top,b_app_cfg.user_cfg);
		update_layout_info(top, true);
	end
	
	return 0;
end

w1_page_noopsychearea_person_count.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	
	local cwnd = w1_page_noopsychearea_person_count.wnd;
	local param = {
		x = SIZE('s_cfg_person_count_image_xywh')[1] + SIZE('s_person_count_area_xywh')[1]+ SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_cfg_person_count_image_xywh')[2] + SIZE('s_person_count_area_xywh')[2]+ SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_cfg_person_count_image_xywh')[3],
		cy = SIZE('s_cfg_person_count_image_xywh')[4],
	}	
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_noopsychearea_person_count.layoutpos.x = param.x;
	w1_page_noopsychearea_person_count.layoutpos.cx = param.cx;
	w1_page_noopsychearea_person_count.layoutpos.y = param.y;
	w1_page_noopsychearea_person_count.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_cfg_person_count_image_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_cfg_person_count_image_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
	
	local negative_num_atrr = {true, 6, 0};
	b_wnd_ex.set_negative_num_atrr(top, cwnd.t_setting_value.id, negative_num_atrr, false);
		b_wnd_ex.set_negative_num_atrr(top, cwnd.t_threshold.id, negative_num_atrr, false);
end

w1_page_noopsychearea_person_count.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_person_count_area_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'image', 'cap_osd_enable','t_osd_enable',
			'cap_clear_interval', 't_clear_interval','cap_area_type', 't_area_type','cap_setting_enable','t_setting_enable',
			'cap_setting_value','t_setting_value','cap_alarm_enable','t_alarm_enable','cap_threshold','t_threshold',
			'cap_enable_audio', 't_enable_audio', 'cap_sound_cbox', 't_sound_cbox', 'cap_enable_flshlight', 't_enable_flshlight', 'noteinfo','noteinfo2',},

	image 	= {t='person_count',id=id+1,xywh='s_cfg_person_count_image_xywh',text='image weight',trans = false,
				color= {'c_image_bk', 'c_cfg_row_bk', 'c_txt_n'},cmd = on_update_param},	
				
	cap_osd_enable	= {t='static',	id=id+2,	xywh='s_cfg_person_count_cap_osd_enable_xywh',		text='LA_OSD_ENABLE'},
	t_osd_enable	= {t='tt_check',id=id+3,	xywh='s_cfg_person_count_t_osd_enable_xywh', cmd = on_update_param,		
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					},
	cap_clear_interval	= {t='static',	id=id+4,	xywh='s_cfg_person_count_cap_clear_interval_xywh',		text='LA_CLEAR_INTERVAL'},	
	t_clear_interval 	= {t='combox',	id=id+5,	xywh='s_cfg_person_count_t_clear_interval_xywh',cmd = on_update_param,
							items={'LA_MIN_10','LA_MIN_30', 'LA_ONE_HOUR', 'LA_HOUR_12', 'LA_DAY_1'}},

	cap_area_type	= {t='static',	id=id+6,	xywh='s_cfg_person_count_cap_area_type_xywh',		text='LA_AREA_TYPE'},
	t_area_type		= {t='combox',	id=id+7,	xywh='s_cfg_person_count_t_area_type_xywh',cmd = on_update_param,
						items={'LA_LINE'}},
	
	cap_setting_enable	= {t='static',	id=id+8,	xywh='s_cfg_person_count_cap_setting_enable_xywh',		text='LA_SET_CORRECTION'},
	t_setting_enable	= {t='tt_check',id=id+9,	xywh='s_cfg_person_count_t_setting_enable_xywh', cmd = on_setting_enable,		
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					},	

	cap_setting_value = {t='static', 	id=id+10,xywh='s_cfg_person_count_cap_setting_value_xywh',text='LA_COUNT_CORRECTION'},	
	t_setting_value 		= {t='edit_num', 	id=id+11,xywh='s_cfg_person_count_t_setting_value_xywh', 
					trans = false, 	font = 'f_grade6',range={-99999,999999},
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},		

	cap_alarm_enable	= {t='static',	id=id+12,	xywh='s_cfg_person_count_cap_alarm_enable_xywh', text='LA_ALARM_THRESHOLD_ENABLE'},
	t_alarm_enable	= {t='tt_check',id=id+13,	xywh='s_cfg_person_count_t_alarm_enable_xywh', cmd = on_update_param,		
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					},	
	
	cap_threshold = {t='static', 	id=id+14,xywh='s_cfg_person_count_cap_threshold_xywh', text='LA_ALARM_THRESHOLD_VALUE'},	
	t_threshold = {t='edit_num', 	id=id+15,xywh='s_cfg_person_count_t_threshold_xywh', 
					trans = false, 	font = 'f_grade6',range={-99999,999999},
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},			
		
	cap_enable_audio 	= {t='static',id=id+16,	xywh='s_cfg_person_count_cap_audio_dec_xywh',	text='LA_AUDIO_DEC_ALARM'},
	t_enable_audio 		= {t='tt_check', id=id+17,xywh='s_cfg_person_count_t_audio_dec_xywh',			
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable_audio},
	
	cap_sound_cbox	= {t='static',id=id+18,	xywh='s_cfg_person_count_cap_sound_file_xywh',	text='LA_SOUND_ALARM_FILE'},
	t_sound_cbox 	= {t='combox',id=id+19,	xywh='s_cfg_person_count_t_sound_file_xywh',	items={},trans = false,cmd=on_update_param},	
	
	cap_enable_flshlight 	= {t='static',id=id+20,	xywh='s_cfg_person_count_cap_flashlight_xywh',	text='LA_FLASHLIGHT_ALARM'},
	t_enable_flshlight 	= {t='tt_check', id=id+21,xywh='s_cfg_person_count_t_flashlight_xywh',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},		
	
	noteinfo	= {t='static',	id=id+22,	xywh='s_cfg_person_count_noteinfo_xywh', text='LA_PERSON_COUNT_TIP1'},	
	noteinfo2	= {t='static',	id=id+23,	xywh='s_cfg_person_count_noteinfo2_xywh',	text='LA_PERSON_COUNT_TIP2'},
}

return w1_page_noopsychearea_person_count

