--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/6/7
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_nvr_noopsyche.nvr_noopsyche_general_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg") 
local w1_copy 		= require("wnd.w1_util.w1_copy")
local w1_key 		= require("wnd.w1_util.w1_key")
local util 			= require("wnd.core.util")
local b_app_cfg  	= require("wnd.core.b_app_cfg")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local r_str			= require("wnd.core.r_res.r_str")
local b_app_api		= require("wnd.core.command.b_app_api")
local STR 			= r_str.get_str

local r_color		= require("wnd.core.r_res.r_color")
local COLOR 		= r_color.get_color
local ro_num;
local channel_num;
local w1_page_nvr_noopsyche_general = 
{
	data,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_nvr_noopsyche_general.s_768 =
{
	s_nvr_noopsychel_general_t_enable_xywh = {277,26,25,21},
	s_nvr_noopsychel_general_t_draw_rect_xywh = {277, 69,25, 21},	
	s_nvr_noopsychel_general_t_chn_xywh = {281,149,202,99},
	s_nvr_noopsychel_general_table_btn_xywh = {0,0,21,28},
	s_nvr_noopsychel_general_reboot_xywh = {58, 285, 650, 35},
	s_nvr_noopsychel_general_tip_xywh = {58,586,650,28},
};

w1_page_nvr_noopsyche_general.s_1280 = 
{
	s_nvr_noopsychel_general_t_enable_xywh = {455,37,48,30},
	s_nvr_noopsychel_general_t_draw_rect_xywh = {455, 97, 48, 30},
	s_nvr_noopsychel_general_t_chn_xywh ={460,210,380,140},
	s_nvr_noopsychel_general_table_btn_xywh = {0,0, 40,40},
	s_nvr_noopsychel_general_reboot_xywh = {110, 380, 700, 50},
	s_nvr_noopsychel_general_tip_xywh = {110,810,680,40},
}

w1_page_nvr_noopsyche_general.s_1440 = 
{
	s_nvr_noopsychel_general_t_enable_xywh = {520,33,48,30},
	s_nvr_noopsychel_general_t_draw_rect_xywh = {520, 83, 48, 30},	
	s_nvr_noopsychel_general_t_chn_xywh ={530,175,380,140},
	s_nvr_noopsychel_general_table_btn_xywh = {0,0, 40,40},	
	s_nvr_noopsychel_general_reboot_xywh = {110, 350, 1000, 50},
	s_nvr_noopsychel_general_tip_xywh = {110,693,800,30},
}


w1_page_nvr_noopsyche_general.s_1080p = 
{
	s_nvr_noopsychel_general_t_enable_xywh = {520,37,48,30};
	s_nvr_noopsychel_general_t_draw_rect_xywh = {520, 97, 48, 30},	
	s_nvr_noopsychel_general_t_chn_xywh	= {527, 210, 380, 150},
	s_nvr_noopsychel_general_table_btn_xywh = {0, 0, 40, 40},
	s_nvr_noopsychel_general_reboot_xywh = {110, 380, 1300, 50},
	s_nvr_noopsychel_general_tip_xywh = {110,825,1220,40};
}

w1_page_nvr_noopsyche_general.s_2k = 
{
	s_nvr_noopsychel_general_t_enable_xywh = {693,50,64,40},
	s_nvr_noopsychel_general_t_draw_rect_xywh = {693, 130, 64, 40},	
	s_nvr_noopsychel_general_t_chn_xywh ={703,280,482,186},
	s_nvr_noopsychel_general_table_btn_xywh = {0,0, 52,52},	
	s_nvr_noopsychel_general_reboot_xywh = {147, 493, 1600, 67},
	s_nvr_noopsychel_general_tip_xywh = {147,1100,1600,53},
}
w1_page_nvr_noopsyche_general.s_4k = 
{
	s_nvr_noopsychel_general_t_enable_xywh = {1040,74,96,60},
	s_nvr_noopsychel_general_t_draw_rect_xywh = {1040, 194, 96, 60},	
	s_nvr_noopsychel_general_t_chn_xywh ={1055,420,760,280},
	s_nvr_noopsychel_general_table_btn_xywh = {0,0, 80,80},	
	s_nvr_noopsychel_general_reboot_xywh = {220, 760, 2600, 100},
	s_nvr_noopsychel_general_tip_xywh = {220,1650,2450,80},
}


w1_page_nvr_noopsyche_general.clear_data = function()
	w1_page_nvr_noopsyche_general.data = nil;
end	

local set_hide = function(top, state, redraw)
	local cwnd = w1_page_nvr_noopsyche_general.wnd
	local s_id = cwnd.cap_draw_rect.id;
	local e_id = cwnd.t_chn.id;
	local bool_flag = true;
	if (state == true) then
		bool_flag =false;
	end
	
	for i = s_id, e_id do
		b_wnd_ex.set_hide(top, i, bool_flag, false);
	end
	
	if (redraw) then
		b_dlg.dlg_set_redraw(top);
	end	
end	

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata)=='table')
	w1_page_nvr_noopsyche_general.data=cfgdata;
	local data = cfgdata.ai_resource;
	local cwnd=w1_page_nvr_noopsyche_general.wnd;
	b_wnd_ex.set_check(top, cwnd.t_enable.id, data.enable, false);
	b_wnd_ex.set_check(top, cwnd.t_draw_rect.id, data.enable_draw, false);
	b_wnd_ex.set_sel(top, cwnd.t_mode.id, data.mode - 1, false);
	local chn_table= {};
	for i=1,data.channel_num do
		table.insert(chn_table,data.chn_cfg[i])
	end
	b_wnd_ex.set_chcopy_data(top,cwnd.t_chn.id,chn_table,false)
	set_hide(top, data.enable, false);
	
	return 0;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local data = cfgdata.ai_resource;
	local cwnd = w1_page_nvr_noopsyche_general.wnd;
	local chn_data = b_wnd_ex.get_chcopy_data(top,cwnd.t_chn.id)
	data.enable = b_wnd_ex.get_check(top, cwnd.t_enable.id);
	data.mode = b_wnd_ex.get_sel(top,cwnd.t_mode.id) + 1
	data.channel_num = #chn_data;
	data.chn_cfg = chn_data;
	data.enable_draw = b_wnd_ex.get_check(top, cwnd.t_draw_rect.id);
	return 0
end

local uidatacheck =function(top)
	return true, nil
end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.ai_resource ~= 0) then--޸ʧ
		local nlegalid = {};
		--table.insert(nlegalid, w1_page_nvr_noopsyche_general.wnd.tipinfo.id);	
		
		local max_vi_num = global_val.get_svp_max_vi_num()
		local max_vdec_num = global_val.get_svp_max_vdec_num()
		local max_chn_num = global_val.get_svp_max_chn_num()	
		if (ret.ai_resource == 1) then
			local max_vi_num_str = tostring(max_vi_num); 
			local str_info = string.gsub(STR('LA_SVP_MAX_VI_NUM'), '*' ,max_vi_num_str);  
			w1_wnd_util.setparamerr_str(str_info);
		elseif (ret.ai_resource == 2) then
			if (max_vdec_num == 0) then
				w1_wnd_util.setparamerr_str(STR('LA_CHANNEL_SELECTION_TIP'));
			else
				local max_vdec_num_str = tostring(max_vdec_num);
				local str_info = string.gsub(STR('LA_SVP_MAX_VDEC_NUM'), '*' ,max_vdec_num_str); 
				w1_wnd_util.setparamerr_str(str_info);
			end
		elseif (ret.ai_resource == 3) then
			local max_chn_num_str = tostring(max_chn_num);
			local str_info = string.gsub(STR('LA_SVP_MAX_CHN_NUM'), '*' ,max_chn_num_str); 
			w1_wnd_util.setparamerr_str(str_info);	
		elseif (ret.ai_resource == 4) then
			w1_wnd_util.setparamerr_str(STR('LA_SVP_RULE'));
		else
			w1_wnd_util.setparamerr_str(STR('LA_APPLY_FAIL'));
		end
		--¶ȡԭʼ
		b_app_cfg.origin_init(w1_wnd_util.cfgtab);
		return false, nlegalid;
	end
	
	return true, nil;
end

w1_page_nvr_noopsyche_general.timer_start = function()
	w1_page_nvr_noopsyche_general.timestart = true
end

w1_page_nvr_noopsyche_general.timer_stop = function(top)
	w1_page_nvr_noopsyche_general.timestart = false
	w1_wnd_util.tipclear(top, w1_page_nvr_noopsyche_general.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_nvr_noopsyche_general.timerenevt = function(top)
	if(w1_page_nvr_noopsyche_general.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_nvr_noopsyche_general.wnd.tipinfo.id)
		--[[
		local tip_text = b_wnd_ex.get_text(top, w1_page_nvr_noopsyche_general.wnd.tipinfo.id);
		if (tip_text == '' and w1_wnd_util.tipdisp == 0 and w1_wnd_util.tiptimenum >= w1_wnd_util.tipdisptime) then
			b_wnd_ex.set_color(top,w1_page_nvr_noopsyche_general.wnd.tipinfo.id,
			{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk')},true);
		end
		--]]
	end
	return 0
end


--ҳʼʱٶȡҳҪ
w1_page_nvr_noopsyche_general.init = function(top)
	w1_wnd_util.cfgtab = {'ai_resource'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;
	end
	return 0
end

local on_mode = function (top, win_id, vmsg, x, y)
	if b_ui_msg.msg_user_update_parent == vmsg then
		local cwnd = w1_page_nvr_noopsyche_general.wnd
		local chn_table= {};
		b_wnd_ex.set_chcopy_data(top,cwnd.t_chn.id,chn_table,false)
		uitousercfg(top,w1_page_nvr_noopsyche_general.data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if b_ui_msg.msg_user_update_parent == vmsg or b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_nvr_noopsyche_general.wnd
		if (cwnd.t_enable.id == win_id) then
			local check = b_wnd_ex.get_check(top, win_id)
			set_hide(top, check, true);
		end
		uitousercfg(top,w1_page_nvr_noopsyche_general.data)
	end
	return 0
end

w1_page_nvr_noopsyche_general.on_data_change=function (top)
	uitousercfg(top,w1_page_nvr_noopsyche_general.data)
end

w1_page_nvr_noopsyche_general.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;
	return ret;
end

w1_page_nvr_noopsyche_general.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	local cwnd = w1_page_nvr_noopsyche_general.wnd;
	b_wnd_ex.set_chcopy_chn_num(top, cwnd.t_chn.id, channel_num, false)	
	local rect_size = SIZE('s_event_table_btn_xywh');
	b_wnd_ex.set_chn_type_size(top, cwnd.t_chn.id, rect_size, false);
	local param={};
	local svp = global_val.get_support_svp();
	if svp == 1 then
		param[1] = STR('LA_MODE_DETECTION');
		b_wnd_ex.set_items(top, w1_page_nvr_noopsyche_general.wnd.t_mode.id, param, false);
	end
end

w1_page_nvr_noopsyche_general.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
			
	sub = {'cap_enable', 't_enable','cap_draw_rect', 't_draw_rect', 'cap_mode','t_mode', 'cap_chn','t_chn', 'reboot_tip','tipinfo', 'apply'},
			
	cap_enable 	= {t='static',	id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE'},
	t_enable 	= {t='tt_check',id=id+2,xywh='s_nvr_noopsychel_general_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	
	cap_draw_rect 	= {t='static',	id=id+3,xywh='s_cfg_page_2_1',text='LA_ENABLE_DRAW_RECT'},
	t_draw_rect 	= {t='tt_check',id=id+4,xywh='s_nvr_noopsychel_general_t_draw_rect_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
			
	cap_mode	= {t='static',	id=id+5,xywh='s_cfg_page_3_1',text='LA_MODE'},
	t_mode = {t='combox',id=id+6, xywh='s_cfg_page_3_2',items={'LA_MODE_DETECTION','LA_RECOGNIZE_MODE'},cmd=on_mode},
	
	cap_chn 	= {t='static',	id=id+7,xywh='s_cfg_page_4_1',text='LA_CHANNEL'},
	t_chn = {t='chn_copy', id=id+8,	xywh='s_nvr_noopsychel_general_t_chn_xywh',
					color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n',}, cmd = on_update_param},
	
	
	reboot_tip = {t='static',id=id+9,xywh='s_nvr_noopsychel_general_reboot_xywh',text='LA_REBOOT_TIP_SVP',
					color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},		
	
	tipinfo		= {t='static',id=id+10,	xywh='s_nvr_noopsychel_general_tip_xywh',	text='',trans = false},

	apply 	= {t='button',id=id+11,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_nvr_noopsyche_general
