--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_ai.plate_blackwhite_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")
local b_dlg 	= require("wnd.core.b_dlg")
local r_str			= require("wnd.core.r_res.r_str")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_page_plate_edit = require("wnd.w1_cfg.w1_page_plate_edit")
local w1_page_plate_bwadv = require("wnd.w1_cfg.w1_page_plate_bwadv")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local STR 			= r_str.get_str
local w1_page_plateblackwhite = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	channel,			--ǰͨ
	member_list = {},	--ԱбϢ
	search_handle = {},	--¼Ϣ
	total_num,			--
	cap_value,			--ÿҳʾ
	cur_page,			--ǰҳ
	total_page,			--ҳ
	time_fmt,			--ʱʽ
}

w1_page_plateblackwhite.s_768 = 
{
	s_page_bw_xywh = {53,320,746,263},
	s_page_bw_filter_xywh = {16,3,160,28},
	s_page_bw_search_xywh = {177,3,21,28},
	s_page_bw_import_xywh = {634,3,21,28},
	s_page_bw_export_xywh = {661,3,21,28},
	s_page_bw_add_xywh = {688,3,21,28},
	s_page_bw_delete_xywh = {714,3,21,28},
	s_page_bw_bwlist_xywh = {16,42,714,177},
	s_page_bw_pageup_xywh = {16,227,21,28},
	s_page_bw_curpage_xywh = {37,227,106,28},
	s_page_bw_nextpage_xywh = {144,227,21,28},
	s_page_bw_refresh_xywh = {533,227,96,28},
	s_page_bw_advance_xywh = {634,227,96,28},
	s_page_bw_list_w1 = {26,0,0,0},
	s_page_bw_list_w2 = {122,0,0,0},
	s_page_bw_list_w3 = {122,0,0,0},
	s_page_bw_list_w4 = {133,0,0,0},
	s_page_bw_list_w5 = {96,0,0,0},
	s_page_bw_list_w6 = {106,0,0,0},
	s_page_bw_list_w7 = {90,0,0,0},
};


w1_page_plateblackwhite.s_1280 = 
{
	s_page_bw_xywh = {60,440,900,350},
	s_page_bw_filter_xywh = {30, 5, 260, 35},
	s_page_bw_search_xywh = {292, 5, 40, 35},
	s_page_bw_import_xywh = {700, 5, 40, 35},
	s_page_bw_export_xywh = {740, 5, 40, 35},
	s_page_bw_add_xywh 	  = {780, 5, 40, 35},
	s_page_bw_delete_xywh = {820, 5, 40, 35},
	s_page_bw_bwlist_xywh = {30, 45, 830, 250},
	s_page_bw_pageup_xywh = {30, 305, 40, 35},
	s_page_bw_curpage_xywh = {70, 305, 200, 35},
	s_page_bw_nextpage_xywh = {270, 305, 40, 35},
	s_page_bw_refresh_xywh = {530, 305, 160, 35},
	s_page_bw_advance_xywh = {700, 305, 160, 35},
	s_page_bw_list_w1 = {38,0,0,0},
	s_page_bw_list_w2 = {130,0,0,0},
	s_page_bw_list_w3 = {130,0,0,0},
	s_page_bw_list_w4 = {130,0,0,0},
	s_page_bw_list_w5 = {120,0,0,0},
	s_page_bw_list_w6 = {120,0,0,0},
	s_page_bw_list_w7 = {130,0,0,0},
};

w1_page_plateblackwhite.s_1440 = 
{
	s_page_bw_xywh = {60,332,1040,350},
	s_page_bw_filter_xywh = {30, 5, 260, 35},
	s_page_bw_search_xywh = {292, 5, 40, 35},
	s_page_bw_import_xywh = {820, 5, 40, 35},
	s_page_bw_export_xywh = {860, 5, 40, 35},
	s_page_bw_add_xywh 	  = {900, 5, 40, 35},
	s_page_bw_delete_xywh = {940, 5, 40, 35},
	s_page_bw_bwlist_xywh = {30, 45, 950, 250},
	s_page_bw_pageup_xywh = {30, 305, 40, 35},
	s_page_bw_curpage_xywh = {70, 305, 200, 35},
	s_page_bw_nextpage_xywh = {270, 305, 40, 35},
	s_page_bw_refresh_xywh = {650, 305, 160, 35},
	s_page_bw_advance_xywh = {820, 305, 160, 35},
	s_page_bw_list_w1 = {50,0,0,0},
	s_page_bw_list_w2 = {195,0,0,0},
	s_page_bw_list_w3 = {180,0,0,0},
	s_page_bw_list_w4 = {120,0,0,0},
	s_page_bw_list_w5 = {120,0,0,0},
	s_page_bw_list_w6 = {120,0,0,0},
	s_page_bw_list_w7 = {130,0,0,0},
};

w1_page_plateblackwhite.s_1080p = 
{
	s_page_bw_xywh = {100,450,1400,370},
	s_page_bw_filter_xywh = {30, 5, 300, 40},
	s_page_bw_search_xywh = {332, 5, 40, 40},
	s_page_bw_import_xywh = {1190, 5, 40, 40},
	s_page_bw_export_xywh = {1240, 5, 40, 40},
	s_page_bw_add_xywh 	  = {1290, 5, 40, 40},
	s_page_bw_delete_xywh = {1340, 5, 40, 40},
	s_page_bw_bwlist_xywh = {30, 60, 1340, 250},
	s_page_bw_pageup_xywh = {30, 320, 40, 40},
	s_page_bw_curpage_xywh = {70, 320, 200, 40},
	s_page_bw_nextpage_xywh = {270, 320, 40, 40},
	s_page_bw_refresh_xywh = {1000, 320, 180, 40},
	s_page_bw_advance_xywh = {1190, 320, 180, 40},
	s_page_bw_list_w1 = {50,0,0,0},
	s_page_bw_list_w2 = {230,0,0,0},
	s_page_bw_list_w3 = {230,0,0,0},
	s_page_bw_list_w4 = {250,0,0,0},
	s_page_bw_list_w5 = {200,0,0,0},
	s_page_bw_list_w6 = {200,0,0,0},
	s_page_bw_list_w7 = {150,0,0,0},
};

w1_page_plateblackwhite.s_2k = 
{
	s_page_bw_xywh = {133,599,1866,493},
	s_page_bw_filter_xywh = {39,6,399,53},
	s_page_bw_search_xywh = {442,6,53,53},
	s_page_bw_import_xywh = {1586,6,53,53},
	s_page_bw_export_xywh = {1652,6,53,53},
	s_page_bw_add_xywh = {1719,6,53,53},
	s_page_bw_delete_xywh = {1786,6,53,53},
	s_page_bw_bwlist_xywh = {39,79,1786,333},
	s_page_bw_pageup_xywh = {39,426,53,53},
	s_page_bw_curpage_xywh = {93,426,266,53},
	s_page_bw_nextpage_xywh = {359,426,53,53},
	s_page_bw_refresh_xywh = {1333,426,239,53},
	s_page_bw_advance_xywh = {1586,426,239,53},
	s_page_bw_list_w1 = {79,0,0,0},
	s_page_bw_list_w2 = {323,0,0,0},
	s_page_bw_list_w3 = {323,0,0,0},
	s_page_bw_list_w4 = {300,0,0,0},
	s_page_bw_list_w5 = {266,0,0,0},
	s_page_bw_list_w6 = {266,0,0,0},
	s_page_bw_list_w7 = {200,0,0,0},
};

w1_page_plateblackwhite.s_4k = 
{
	s_page_bw_xywh = {200,900,2800,740},
	s_page_bw_filter_xywh = {60,10,600,80},
	s_page_bw_search_xywh = {664,10,80,80},
	s_page_bw_import_xywh = {2380,10,80,80},
	s_page_bw_export_xywh = {2480,10,80,80},
	s_page_bw_add_xywh = {2580,10,80,80},
	s_page_bw_delete_xywh = {2680,10,80,80},
	s_page_bw_bwlist_xywh = {60,120,2680,500},
	s_page_bw_pageup_xywh = {60,640,80,80},
	s_page_bw_curpage_xywh = {140,640,400,80},
	s_page_bw_nextpage_xywh = {540,640,80,80},
	s_page_bw_refresh_xywh = {2000,640,360,80},
	s_page_bw_advance_xywh = {2380,640,360,80},
	s_page_bw_list_w1 = {100,0,0,0},
	s_page_bw_list_w2 = {460,0,0,0},
	s_page_bw_list_w3 = {460,0,0,0},
	s_page_bw_list_w4 = {500,0,0,0},
	s_page_bw_list_w5 = {400,0,0,0},
	s_page_bw_list_w6 = {400,0,0,0},
	s_page_bw_list_w7 = {300,0,0,0},
};


w1_page_plateblackwhite.clear_data =function ()
	w1_page_plateblackwhite.member_list = nil;
	w1_page_plateblackwhite.search_handle = nil;
	w1_page_plateblackwhite.total_num=0;
	w1_page_plateblackwhite.cur_page=0;
	w1_page_plateblackwhite.total_page=0;
	w1_page_plate_edit.clear_data();
end

w1_page_plateblackwhite.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_plateblackwhite.wnd;
	local s_id_l = cwnd.t_filter_edit.id
	local e_id_l = cwnd.advance.id
	for i = s_id_l, e_id_l do
		b_wnd_ex.set_hide(top,i,bool_hide,false);
	end
	
	b_wnd_ex.set_hide(top,cwnd.import.id,true,false);
	b_wnd_ex.set_hide(top,cwnd.export.id,true,false);
	
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end		
end

local clearlist = function(top,redraw)
	local cwnd = w1_page_plateblackwhite.wnd;
	local displist = {};
	local hide_opera = {};
	displist.item_total = 0;
	b_wnd_ex.set_listdata(top, cwnd.bw_list.id, displist, false);	
	
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end		
end

local updatelist = function(top, cur_page, redraw)
	if(cur_page == 0) then
		return 
	end
	
	--δ
	local valid_num = 0;
	if (w1_page_plateblackwhite.search_handle == nil) then --ȡݲ
		local inputParam = {};
		inputParam.channel = w1_page_plateblackwhite.channel;
		inputParam.type = -1;
		inputParam.s_id = (cur_page - 1) * w1_page_plateblackwhite.cap_value;
		inputParam.e_id = (cur_page - 1) * w1_page_plateblackwhite.cap_value + w1_page_plateblackwhite.cap_value - 1;
		if(w1_page_plateblackwhite.total_num - 1 < inputParam.e_id) then
			inputParam.e_id = w1_page_plateblackwhite.total_num - 1;
		end		
		local resData = b_app_api.get_plage_bw_list_info(inputParam);
		valid_num = resData.num;
		if (w1_page_plateblackwhite.member_list == nil) then
			w1_page_plateblackwhite.member_list = resData.info;
		else
			util.copy_tab_b(w1_page_plateblackwhite.member_list, resData.info);
		end
	else --
		local inputParam = {};
		inputParam.channel = w1_page_plateblackwhite.search_handle.channel;
		inputParam.total = w1_page_plateblackwhite.search_handle.total;
		inputParam.handle = w1_page_plateblackwhite.search_handle.handle;
		inputParam.number = w1_page_plateblackwhite.search_handle.number;
		inputParam.begin_index = (cur_page - 1) * w1_page_plateblackwhite.cap_value;
		inputParam.end_index = (cur_page - 1) * w1_page_plateblackwhite.cap_value + w1_page_plateblackwhite.cap_value - 1;
		if(w1_page_plateblackwhite.total_num - 1 < inputParam.end_index) then
			inputParam.end_index =  w1_page_plateblackwhite.total_num - 1;
		end	
		local resData = b_app_api.search_gain_plage_bw_list(inputParam);
		valid_num = resData.num;
		if (w1_page_plateblackwhite.member_list == nil) then
			w1_page_plateblackwhite.member_list = resData.info;
		else
			util.copy_tab_b(w1_page_plateblackwhite.member_list, resData.info);
		end		
	end
	
	w1_page_plate_edit.set_data(w1_page_plateblackwhite.member_list);	
	
	local displist = {};
	local idx = 0;
	for i=1, valid_num do
		idx = idx + 1;
		local cur_menber = w1_page_plateblackwhite.member_list['member'..i];
		local libType = nil;
		if (cur_menber.type == 1) then
			libType = STR('LA_RULE_WHITE');
		else
			libType = STR('LA_RULE_BLACK');
		end
		
		displist['idx'..idx] = {idx-1, false, '', cur_menber.plate, cur_menber.lib, libType, cur_menber.str_stime, cur_menber.str_etime, ''};	
	end
	displist.item_total = idx;
	b_wnd_ex.set_listdata(top, w1_page_plateblackwhite.wnd.bw_list.id, displist, false);
	
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end	
end

local updatepageitems = function(top, total_page, redraw)
	local jump_page_items = {}
	for i=1, total_page do
		jump_page_items[i] = tostring(i)..'/'..total_page;
	end
	b_wnd_ex.set_items(top, w1_page_plateblackwhite.wnd.cur_page.id, jump_page_items, redraw)	
end

local updatepage = function(top, cur_page, total_page, redraw)
	local cwnd = w1_page_plateblackwhite.wnd;
	if (cur_page == 0) then
		local page_str = tostring(cur_page)..'/'..tostring(total_page);
		b_wnd_ex.set_text(top, cwnd.cur_page.id, page_str,redraw);
	else
		b_wnd_ex.set_sel(top, cwnd.cur_page.id, cur_page - 1,redraw);	
	end
end

local clearall = function(top, redraw)
	local cwnd = w1_page_plateblackwhite.wnd;
	w1_page_plateblackwhite.cur_page = 0;
	w1_page_plateblackwhite.total_page = 0;
	b_wnd_ex.set_disable(top, cwnd.page_up.id, true, false);
	b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
	updatepageitems(top, w1_page_plateblackwhite.total_page, false);
	updatepage(top, w1_page_plateblackwhite.cur_page, w1_page_plateblackwhite.total_page, false);		
	clearlist(top, false);
	if (redraw == true) then
		b_dlg.dlg_set_redraw(top)
	end
end

local on_search = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_plateblackwhite.wnd;
		local plate_num = b_wnd_ex.get_text(top, cwnd.t_filter_edit.id);
		if ('' == plate_num) then
			w1_page_plateblackwhite.reacquire_data(top, w1_page_plateblackwhite.channel, w1_page_plateblackwhite.time_fmt, true);
			return 0;
		end
			
		plate_num = string.upper(plate_num);
		if (w1_page_plateblackwhite.search_handle ~= nil) then
			b_app_api.search_close_plage_bw_list(w1_page_plateblackwhite.search_handle);
			util.clear_tab(w1_page_plateblackwhite.search_handle);
			w1_page_plateblackwhite.search_handle = nil;
		end
		
		local data = b_app_api.search_open_plage_bw_list(w1_page_plateblackwhite.channel, plate_num);
		if (w1_page_plateblackwhite.search_handle == nil) then
			w1_page_plateblackwhite.search_handle = data;
		else
			util.copy_tab_b(w1_page_plateblackwhite.search_handle, data);
		end
		
			--
		w1_page_plateblackwhite.total_num  = w1_page_plateblackwhite.search_handle.total
		if (0 >= w1_page_plateblackwhite.total_num) then
			clearall(top, false);		
		else
			w1_page_plateblackwhite.cur_page = 1;
			b_wnd_ex.set_disable(top, cwnd.page_up.id, true, false);
			w1_page_plateblackwhite.total_page = math.modf((w1_page_plateblackwhite.total_num + w1_page_plateblackwhite.cap_value - 1) / w1_page_plateblackwhite.cap_value);
			if w1_page_plateblackwhite.total_page == 1 then
				b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
			else
				b_wnd_ex.set_disable(top, cwnd.page_down.id, false, false);
			end
			updatepageitems(top, w1_page_plateblackwhite.total_page, false);
			updatepage(top, w1_page_plateblackwhite.cur_page, w1_page_plateblackwhite.total_page, false);		
			updatelist(top, w1_page_plateblackwhite.cur_page, false);	
		end		
		b_dlg.dlg_set_redraw(top)
	end
	
	return 0;
end	

local on_import = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local fileName = nil;
		b_app_api.mount_dev();
		local inputPath = b_dlg.do_modal(top, w1_key.DLG_UPGRADEDECTORY, 0, 0, 1)
		if (nil ~= inputPath and '' ~= inputPath) then
			local paramdata = cjson.decode(inputPath);
			fileName = paramdata.path
		end	
		b_app_api.unmount_dev();
	end
	
	return 0;
end	

local on_export = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local exportPath = nil;
		b_app_api.mount_dev();
		local path = b_dlg.dlg_get_path(top, w1_key.DLG_UPGRADEDECTORY, 0, 0, 2)
		if (nil ~= path and '' ~= path) then
			exportPath = path;
		end
		b_app_api.unmount_dev();
	end
	
	return 0;
end	

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.do_modal(top, w1_key.DLG_PLATE_EDIT, 0, 0, nil)
	end
	
	return 0;
end	

local on_batch_del = function(param)
	local top = param[1]
	local cwnd = w1_page_plateblackwhite.wnd;
	local checktab = b_wnd_ex.get_selecelist(top, cwnd.bw_list.id);
	if (w1_page_plateblackwhite.total_num <= 0) then
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DELETE_ITEM'), true, false,false);
		w1_msgbox.set_func(nil, nil, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);			
		return 0;
	end
	
	local param = {};
	param.channel = w1_page_plateblackwhite.channel;
	param.num = 0;
	param.info = {}
	for i=1, w1_page_plateblackwhite.cap_value do
		if checktab['r'..i] ~= 0 then
			local cur_plate_data = w1_page_plate_edit.data['member'..i];
			param.num = param.num + 1;
			table.insert(param.info, cur_plate_data);
		end
	end
	
	if (0 < param.num) then
		local ret = b_app_api.del_plate_detect_bw_list(param);
		--ѡ
		local checktab = {};
		local flag = true;
		for i=1, w1_page_plateblackwhite.cap_value do
			checktab[i] = false;
		end
		b_wnd_ex.set_first_checkall(top, cwnd.bw_list.id, false, false);
		b_wnd_ex.set_selecelist(top, cwnd.bw_list.id, checktab, false);
	else
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DELETE_ITEM'), true, false,false);
		w1_msgbox.set_func(nil, nil, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);			
		return 0;	
	end
	
	on_search(top, 0, b_ui.LBUTTONCLK, x, y);
end

local on_del = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_CONFIRM_DELETE'), true, true, false,STR('LA_YES'), STR('LA_BAD'));
		w1_msgbox.set_func(on_batch_del,{top}, nil,nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		w1_msgbox.set_func(nil,nil, nil,nil);	
	end
	
	return 0;
end	

local on_pageup = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_plateblackwhite.wnd;
		if(w1_page_plateblackwhite.cur_page > 1) then
			w1_page_plateblackwhite.cur_page = w1_page_plateblackwhite.cur_page - 1;
			b_wnd_ex.set_sel(top, cwnd.cur_page.id, w1_page_plateblackwhite.cur_page -1, false);
		end
		updatepage(top, w1_page_plateblackwhite.cur_page, w1_page_plateblackwhite.total_page, false)
		updatelist(top, w1_page_plateblackwhite.cur_page, false);
		b_wnd_ex.set_disable(top, cwnd.page_down.id, false, false);
		if (w1_page_plateblackwhite.cur_page == 1) then
			b_wnd_ex.set_disable(top, cwnd.page_up.id, true, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	
	return 0
end	

local on_page = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_page_plateblackwhite.wnd;
		local sel = b_wnd_ex.get_sel(top, win_id);	
		w1_page_plateblackwhite.cur_page = sel + 1;
		updatepage(top, w1_page_plateblackwhite.cur_page, w1_page_plateblackwhite.total_page, false)
		updatelist(top, w1_page_plateblackwhite.cur_page, false);
		if (1 == w1_page_plateblackwhite.total_page) then
			b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
			b_wnd_ex.set_disable(top, cwnd.page_up.id, true, false);
		else
			if(w1_page_plateblackwhite.cur_page == 1) then
				b_wnd_ex.set_disable(top, cwnd.page_down.id, false, false);
				b_wnd_ex.set_disable(top, cwnd.page_up.id, true, true);
			elseif(w1_page_plateblackwhite.cur_page == w1_page_plateblackwhite.total_page) then
				b_wnd_ex.set_disable(top, cwnd.page_up.id, false, false);
				b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
			else
				b_wnd_ex.set_disable(top, cwnd.page_up.id, false, false);
				b_wnd_ex.set_disable(top, cwnd.page_down.id, false, false);
			end		
		end
		b_dlg.dlg_set_redraw(top);
	end
	
	return 0
end	

local on_pagedown = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_plateblackwhite.wnd;
		if(w1_page_plateblackwhite.cur_page < w1_page_plateblackwhite.total_page) then
			b_wnd_ex.set_sel(top, cwnd.cur_page.id, w1_page_plateblackwhite.cur_page, false);
			w1_page_plateblackwhite.cur_page = w1_page_plateblackwhite.cur_page + 1;
		end
			
		updatepage(top, w1_page_plateblackwhite.cur_page, w1_page_plateblackwhite.total_page, false)
		updatelist(top, w1_page_plateblackwhite.cur_page, false);
		b_wnd_ex.set_disable(top, cwnd.page_up.id, false, true);
		if (w1_page_plateblackwhite.cur_page == w1_page_plateblackwhite.total_page) then
			b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end	

local on_refresh = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		on_search(top, 0, b_ui.LBUTTONCLK, x, y);
	end
	
	return 0;
end	

local on_advance = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.do_modal(top, w1_key.DLG_PLATE_BWADV, 0, 0, nil)
	end
	
	return 0;
end	

local ok_func = function(param)
	--¶ȡ,ˢб
	on_search(param[1], 0, b_ui.LBUTTONCLK, x, y);
	return 0;
end

w1_page_plateblackwhite.reacquire_data = function(top, channel, time_fmt, redraw)
	local cwnd = w1_page_plateblackwhite.wnd;
	w1_page_plateblackwhite.time_fmt = time_fmt;
	w1_page_plate_edit.set_time_fmt(time_fmt);
	w1_page_plate_edit.set_channel(channel);
	w1_page_plate_bwadv.set_channel(channel)
	b_wnd_ex.set_text(top, cwnd.t_filter_edit.id, "", false); --
	w1_page_plateblackwhite.channel = channel;
	
	if (w1_page_plateblackwhite.search_handle ~= nil) then
		b_app_api.search_close_plage_bw_list(w1_page_plateblackwhite.search_handle);
		util.clear_tab(w1_page_plateblackwhite.search_handle);
		w1_page_plateblackwhite.search_handle = nil;
	end	
	
	--
	w1_page_plateblackwhite.total_num  = b_app_api.get_plage_bw_list_num(channel, -1);
	if (0 >= w1_page_plateblackwhite.total_num) then
		clearall(top, false);		
	else
		w1_page_plateblackwhite.cur_page = 1;
		b_wnd_ex.set_disable(top, cwnd.page_up.id, true, false);
		w1_page_plateblackwhite.total_page = math.modf((w1_page_plateblackwhite.total_num + w1_page_plateblackwhite.cap_value - 1) / w1_page_plateblackwhite.cap_value);
		if w1_page_plateblackwhite.total_page == 1 then
			b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
		else
			b_wnd_ex.set_disable(top, cwnd.page_down.id, false, false);
		end
		updatepageitems(top, w1_page_plateblackwhite.total_page, false);
		updatepage(top, w1_page_plateblackwhite.cur_page, w1_page_plateblackwhite.total_page, false);		
		updatelist(top, w1_page_plateblackwhite.cur_page, false);	
	end	
	
	if (redraw == true) then
		b_dlg.dlg_set_redraw(top)
	end
end
	
w1_page_plateblackwhite.on_pre_show = function(top)
	local cwnd = w1_page_plateblackwhite.wnd;
	local param = {	"", STR('LA_PLATE'),STR('LA_LIB_NAME'),STR('LA_LIST_TYPE'),STR('LA_BEGIN_TIME'), STR('LA_END_TIME'),  STR('LA_OPERATE')}
	b_wnd_ex.set_title_texts(top, cwnd.bw_list.id, param, false)
	
	local list_w = {};
	for i=1,7 do
		local str = 's_page_bw_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, cwnd.bw_list.id, list_w, false);
	
	w1_page_plateblackwhite.clear_data();	
	w1_page_plateblackwhite.cap_value = 5;
	
	w1_page_plate_edit.init();
	w1_page_plate_edit.set_func(ok_func, {top});
	return 0;
end

w1_page_plateblackwhite.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_page_bw_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'t_filter_edit', 'search', 'import', 'export', 'add', 'delete', 'plate_list', 'bw_list',  'page_up', 'cur_page', 'page_down', 'refresh', 'advance'},
	
	t_filter_edit 	= {t='edit', id=id+1,	xywh = 's_page_bw_filter_xywh', text = '',trans = false},	
		
	search	= {t='tt_button',id=id+2,	xywh='s_page_bw_search_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade4','it_search','it_search_f', 'it_search'},
					text = 'LA_SEARCH', draw_text = 0, 		
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},cmd = on_search},

	import	= {t='tt_button',id=id+3,	xywh='s_page_bw_import_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade3','it_import','it_import_f', 'it_import'},
					text = 'LA_IMPORT', draw_text = 0, 		
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},cmd = on_import},
					
	export	= {t='tt_button',id=id+4,	xywh='s_page_bw_export_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade3','it_export','it_export_f', 'it_export'},
					text = 'LA_EXPORT', draw_text = 0, 		
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},cmd = on_export},

	add	= {t='tt_button',id=id+5,	xywh='s_page_bw_add_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade1','it_add','it_add', 'it_add'},
					text = 'LA_ROLE_ADD', draw_text = 0, 		
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},cmd = on_add},

	delete	= {t='tt_button',id=id+6,	xywh='s_page_bw_delete_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade1','it_del','it_del', 'it_del'},
					text = 'LA_ROLE_DELETE', draw_text = 0, 		
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},cmd = on_del},			

	bw_list	= {t='list',	id=id+7,	xywh='s_page_bw_bwlist_xywh', font = 'f_grade4',
					listattr = {5,7,b_ui.LISTATTR.FIRST_WIDGET_CHECK,b_ui.LISTATTR.END_WIDGET_EDITDEL},
					dlg_key = {w1_key.DLG_PLATE_EDIT, w1_key.DLG_PLATE_EDIT},
					title_texts = {"", STR('LA_PLATE'), STR('LA_LIB_NAME'),STR('LA_LIST_TYPE'),STR('LA_BEGIN_TIME'), STR('LA_END_TIME'), STR('LA_OPERATE')},
					columns_w = {80,200, 200,200,200, 200, 120},
					},
	page_up 	= {t='tt_button',	id=id+8,	xywh='s_page_bw_pageup_xywh',		
					t_imgs = {b_ui.ALIGN.CENTER,'f_pageupdown','it_pageup','it_pageup', 'it_pageup'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_pageup},
	cur_page 		= {t='combox',	id=id+9,	xywh='s_page_bw_curpage_xywh',		text='0/0',trans = false, 
					align = b_ui.ALIGN.CENTER, font = 'f_grade3',dlg_direct_up = true,
					t_imgs = {b_ui.ALIGN.CENTER,'f_column','it_null','it_null', 'it_null'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_page},
	page_down 	= {t='tt_button',id=id+10,	xywh='s_page_bw_nextpage_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_pageupdown','it_pagedown','it_pagedown', 'it_pagedown'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_pagedown},		
					
	refresh 		= {t='button',	id=id+11,	xywh='s_page_bw_refresh_xywh', text='LA_REFRESH',cmd=on_refresh},
	advance 		= {t='button',	id=id+12,	xywh='s_page_bw_advance_xywh', text='LA_ADVANCED',cmd=on_advance},
}


return w1_page_plateblackwhite

