--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_camera.pro_man_id
local b_dlg 		= require("wnd.core.b_dlg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local util 			= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local w1_page_pro_man = 
{
	data,
	old_sel = 0,
	err_time = 0,
	errwidgetid,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_pro_man.s_768 =
{
	s_pro_man_check_main_xywh = {281,106,21,32},
	s_pro_man_cap_check_main_xywh = {302,106,80,32},
	s_pro_man_check_sub_xywh = {382,106,21,32},
	s_pro_man_cap_check_sub_xywh = {403,106,80,32},
	s_pro_man_t_type_main_xywh = {281,149,98,32},
	s_pro_man_t_type_sub_xywh = {385,149,98,32},
	s_pro_man_t_port_main_xywh = {281,192,98,32},
	s_pro_man_t_port_sub_xywh = {385,192,98,32},
	s_pro_man_t_path_main_xywh = {281,234,98,32},
	s_pro_man_t_path_sub_xywh = {385,234,98,32},
	s_pro_man_info1_xywh = {53,277,373,32},
	s_pro_man_info2_xywh = {53,320,373,32},
	s_pro_man_tipinfo_xywh = {53,362,373,35},
};

w1_page_pro_man.s_1280 = 
{
	s_pro_man_check_main_xywh		= {460,150,40,45},
	s_pro_man_cap_check_main_xywh	= {500,150,110,45},
	s_pro_man_check_sub_xywh		= {610,150,40,45},
	s_pro_man_cap_check_sub_xywh	= {650,150,110,45},
	s_pro_man_t_type_main_xywh		= {460,210,145,45},
	s_pro_man_t_type_sub_xywh		= {615,210,145,45},
	s_pro_man_t_port_main_xywh		= {460,270,145,45},
	s_pro_man_t_port_sub_xywh		= {615,270,145,45},
	s_pro_man_t_path_main_xywh		= {460,330,145,45},
	s_pro_man_t_path_sub_xywh		= {615,330,145,45},
	s_pro_man_info1_xywh			= {100,390,700,45},
	s_pro_man_info2_xywh			= {100,450,700,45},
	s_pro_man_tipinfo_xywh			= {100,510,700,50},
}

w1_page_pro_man.s_1440 = 
{
	s_pro_man_check_main_xywh		= {530,125,40,45},
	s_pro_man_cap_check_main_xywh	= {570,125,150,45},
	s_pro_man_check_sub_xywh		= {720,125,40,45},
	s_pro_man_cap_check_sub_xywh	= {760,125,150,45},
	s_pro_man_t_type_main_xywh		= {530,175,185,45},
	s_pro_man_t_type_sub_xywh		= {725,175,185,45},
	s_pro_man_t_port_main_xywh		= {530,225,185,45},
	s_pro_man_t_port_sub_xywh		= {725,225,185,45},
	s_pro_man_t_path_main_xywh		= {530,275,185,45},
	s_pro_man_t_path_sub_xywh		= {725,275,185,45},
	s_pro_man_info1_xywh			= {100,325,700,45},
	s_pro_man_info2_xywh			= {100,375,700,45},
	s_pro_man_tipinfo_xywh			= {100,425,700,50},
}

w1_page_pro_man.s_1080p = 
{
	s_pro_man_check_main_xywh		= {527,150,40,45},
	s_pro_man_cap_check_main_xywh	= {567,150,150,45},
	s_pro_man_check_sub_xywh		= {717,150,40,45},
	s_pro_man_cap_check_sub_xywh	= {757,150,150,45},
	s_pro_man_t_type_main_xywh		= {527,210,185,45},
	s_pro_man_t_type_sub_xywh		= {722,210,185,45},
	s_pro_man_t_port_main_xywh		= {527,270,185,45},
	s_pro_man_t_port_sub_xywh		= {722,270,185,45},
	s_pro_man_t_path_main_xywh		= {527,330,185,45},
	s_pro_man_t_path_sub_xywh		= {722,330,185,45},
	s_pro_man_info1_xywh			= {100,390,700,45},
	s_pro_man_info2_xywh			= {100,450,700,45},
	s_pro_man_tipinfo_xywh			= {100,510,700,50},
}
w1_page_pro_man.s_2k = 
{
	s_pro_man_check_main_xywh		= {703,200,53,60},
	s_pro_man_cap_check_main_xywh	= {756,200,200,60},
	s_pro_man_check_sub_xywh		= {956,200,53,60},
	s_pro_man_cap_check_sub_xywh	= {1009,200,200,60},
	s_pro_man_t_type_main_xywh		= {703,280,247,60},
	s_pro_man_t_type_sub_xywh		= {963,280,247,60},
	s_pro_man_t_port_main_xywh		= {703,360,247,60},
	s_pro_man_t_port_sub_xywh		= {963,360,247,60},
	s_pro_man_t_path_main_xywh		= {703,440,247,60},
	s_pro_man_t_path_sub_xywh		= {963,440,247,60},
	s_pro_man_info1_xywh			= {133,520,933,60},
	s_pro_man_info2_xywh			= {133,600,933,60},
	s_pro_man_tipinfo_xywh			= {133,680,933,67},
}
w1_page_pro_man.s_4k = 
{
	s_pro_man_check_main_xywh		= {1054,300,80,90},
	s_pro_man_cap_check_main_xywh	= {1134,300,300,90},
	s_pro_man_check_sub_xywh		= {1434,300,80,90},
	s_pro_man_cap_check_sub_xywh	= {1514,300,300,90},
	s_pro_man_t_type_main_xywh		= {1054,420,390,90},
	s_pro_man_t_type_sub_xywh		= {1444,420,390,90},
	s_pro_man_t_port_main_xywh		= {1054,540,390,90},
	s_pro_man_t_port_sub_xywh		= {1444,540,390,90},
	s_pro_man_t_path_main_xywh		= {1054,660,390,90},
	s_pro_man_t_path_sub_xywh		= {1444,660,390,90},
	s_pro_man_info1_xywh			= {200,780,1400,90},
	s_pro_man_info2_xywh			= {200,900,1400,90},
	s_pro_man_tipinfo_xywh			= {200,1020,1400,100},
}
local show_param = function (top,data,idx)
	local cwnd = w1_page_pro_man.wnd;
	b_wnd_ex.set_sel(top,cwnd.t_cus_pro.id,idx-1,false);
	w1_page_pro_man.old_sel = idx - 1;
	b_wnd_ex.set_text(top,cwnd.t_name.id,data['idx'..idx].name,false);
	if(data['idx'..idx].stream2.enable ~= 0) then
		b_wnd_ex.set_check(top,cwnd.t_check_sub.id,true,false);
		b_wnd_ex.set_disable(top,cwnd.t_type_sub.id,false,false);
		b_wnd_ex.set_disable(top,cwnd.t_port_sub.id,false,false);
		b_wnd_ex.set_disable(top,cwnd.t_path_sub.id,false,false);
	else
		b_wnd_ex.set_check(top,cwnd.t_check_sub.id,false,false);
		b_wnd_ex.set_disable(top,cwnd.t_type_sub.id,true,false);
		b_wnd_ex.set_disable(top,cwnd.t_port_sub.id,true,false);
		b_wnd_ex.set_disable(top,cwnd.t_path_sub.id,true,false);
	end
	b_wnd_ex.set_value(top,cwnd.t_port_main.id,data['idx'..idx].stream1.port,false);
	b_wnd_ex.set_value(top,cwnd.t_port_sub.id,data['idx'..idx].stream2.port,false);
	b_wnd_ex.set_text(top,cwnd.t_path_main.id,data['idx'..idx].stream1.path,false);
	b_wnd_ex.set_text(top,cwnd.t_path_sub.id,data['idx'..idx].stream2.path,false);
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_pro_man.data = cfgdata;
	local cwnd = w1_page_pro_man.wnd;
	local items = {}
	for i=1, cfgdata.pro_man.protocol_num do
		items[i] = STR('LA_CUSTOM_PORT')..' '..i
	end
	b_wnd_ex.set_items(top,cwnd.t_cus_pro.id,items,false);
	show_param(top,cfgdata.pro_man,1);
	b_wnd_ex.set_disable(top,cwnd.t_check_main.id,true,false);
	b_wnd_ex.set_check(top,cwnd.t_check_main.id,true,false);
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_pro_man.wnd;
	local sel = b_wnd_ex.get_sel(top,cwnd.t_cus_pro.id);
	local data = cfgdata.pro_man;
	local check = b_wnd_ex.get_check(top,cwnd.t_check_sub.id);
	if check == true then
		data['idx'..sel+1].stream2.enable = 1
	else
		data['idx'..sel+1].stream2.enable = 0
	end
	
	data['idx'..sel+1].name = b_wnd_ex.get_text(top,cwnd.t_name.id);
	data['idx'..sel+1].stream1.port = b_wnd_ex.get_value(top,cwnd.t_port_main.id)
	data['idx'..sel+1].stream2.port = b_wnd_ex.get_value(top,cwnd.t_port_sub.id)
	data['idx'..sel+1].stream1.path = b_wnd_ex.get_text(top,cwnd.t_path_main.id)
	data['idx'..sel+1].stream2.path = b_wnd_ex.get_text(top,cwnd.t_path_sub.id)
	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local gettext = function(id)
		local text = b_wnd_ex.get_text(top, id);
		return text;
	end
	local nlegalid = {}
	local cwnd = w1_page_pro_man.wnd;
	local pro_name = gettext(cwnd.t_name.id);
	local flag = false
	if(pro_name == '') then
		table.insert(nlegalid, cwnd.t_name.id);
		b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_NOT_EMPTY'), false);
		w1_wnd_util.setparamerr_str(STR('LA_NOT_EMPTY'));
		return false, nlegalid;
	end
	return true, nil;
end

local on_change_protocol = function (top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
	local cwnd = w1_page_pro_man.wnd;
	local legalflag, idtab = uidatacheck(top)
	--ûǷȫϷ
	if(legalflag == false) then
		b_wnd_ex.set_sel(top,cwnd.t_cus_pro.id,w1_page_pro_man.old_sel,false);
		for i =1, #idtab do
			b_wnd_ex.set_color(top, idtab[i],
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top, idtab[i],
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_f'),COLOR('c_txt_f')},false)
		end
		b_wnd_ex.set_color(top, cwnd.tipinfo.id,
			{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_hint_err_text')},false)
		if (w1_page_pro_man.errwidgetid == nil) then
			w1_page_pro_man.errwidgetid  = idtab;
		else
			util.copy_tab_b(w1_page_pro_man.errwidgetid, idtab);	
		end
		b_dlg.dlg_set_redraw(top);
		return 0;
	end
	local sel = b_wnd_ex.get_sel(top,cwnd.t_cus_pro.id);
	show_param(top,b_app_cfg.user_cfg.pro_man,sel+1)
	b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_sub_check = function (top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg)then
	local cwnd = w1_page_pro_man.wnd;
	local check = b_wnd_ex.get_check(top,cwnd.t_check_sub.id);
	if check == true then
		b_wnd_ex.set_disable(top,cwnd.t_type_sub.id,false,false);
		b_wnd_ex.set_disable(top,cwnd.t_port_sub.id,false,false);
		b_wnd_ex.set_disable(top,cwnd.t_path_sub.id,false,false);
	else
		b_wnd_ex.set_disable(top,cwnd.t_type_sub.id,true,false);
		b_wnd_ex.set_disable(top,cwnd.t_port_sub.id,true,false);
		b_wnd_ex.set_disable(top,cwnd.t_path_sub.id,true,false);
	end
	uitousercfg(top,b_app_cfg.user_cfg);
	b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_update_param	= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_time_event = function (top)
	if w1_page_pro_man.err_time ~= 0 then
		local time = os.time();
		if time - w1_page_pro_man.err_time >= 6 then
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,'',false);
			for i =1, #w1_page_pro_man.errwidgetid do
				b_wnd_ex.set_color(top,w1_page_pro_man.errwidgetid[i],
				{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_edit_text_n')},redraw)
				b_wnd_ex.set_color_f(top,w1_page_pro_man.errwidgetid[i],
				{COLOR('c_edit_bg_f'),COLOR('c_edit_border_f'),COLOR('c_txt_f')},redraw)
			end
			w1_page_pro_man.errwidgetid = {}
		end
	end
end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.pro_man ~= 0) then--޸ʧ
		local cwnd = w1_page_pro_man.wnd;
		local nlegalid = {};
		if(ret.pro_man == -1 ) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'));
		end
		return false, nlegalid;
	end
	return true, nil;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;	
	end
	return 0
end

w1_page_pro_man.timer_start = function()
	w1_page_pro_man.timestart = true;
end

w1_page_pro_man.timer_stop = function(top)
	w1_page_pro_man.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_pro_man.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_pro_man.timerenevt = function(top)
	if(w1_page_pro_man.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_pro_man.wnd.tipinfo.id);
		on_time_event(top)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_pro_man.init = function(top)
	w1_wnd_util.cfgtab = {'pro_man'};
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0
end

w1_page_pro_man.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck;
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top);
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_pro_man.clear_data =function ()
	w1_page_pro_man.errwidgetid=nil;
	w1_page_pro_man.data=nil;
end

w1_page_pro_man.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_cus_pro','t_cus_pro','cap_name','t_name','cap_stream_t','t_check_main','cap_check_main','t_check_sub',
			'cap_check_sub','cap_type','t_type_main','t_type_sub','cap_port','t_port_main','t_port_sub','cat_path','t_path_main','t_path_sub',
			'info1',--[['info2',--]]'tipinfo', 'apply' },
	cap_cus_pro		= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',text='LA_CUSTOM_PORT'},
	t_cus_pro		= {t='combox',	id=id+2,	xywh='s_cfg_page_1_2',items={}, cmd = on_change_protocol},
	cap_name		= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',text='LA_PROTOCOL_NAME'},
	t_name			= {t='edit', 	id=id+4,	xywh='s_cfg_page_2_2',cmd = on_update_param},
	cap_stream_t	= {t='static',	id=id+5,	xywh='s_cfg_page_3_1',text='LA_STREAM_TYPE'},
	t_check_main	= {t='check', 	id=id+6,	xywh='s_pro_man_check_main_xywh'},
	cap_check_main	= {t='static',	id=id+7,	xywh='s_pro_man_cap_check_main_xywh',text='LA_MAIN_STREAM'},
	t_check_sub		= {t='check', 	id=id+8,	xywh='s_pro_man_check_sub_xywh',cmd = on_sub_check},
	cap_check_sub	= {t='static',	id=id+9,	xywh='s_pro_man_cap_check_sub_xywh',text='LA_SUBCODE_FLOW'},
	cap_type		= {t='static',	id=id+10,	xywh='s_cfg_page_4_1',text='LA_PROTOCOL_TYPE'},
	t_type_main		= {t='combox', 	id=id+11,	xywh='s_pro_man_t_type_main_xywh',items={'RTSP'},trans = false,cmd = on_update_param},
	t_type_sub		= {t='combox', 	id=id+12,	xywh='s_pro_man_t_type_sub_xywh',items={'RTSP'},trans = false,cmd = on_update_param},
	cap_port		= {t='static',	id=id+13,	xywh='s_cfg_page_5_1',text='LA_PORT'},
	t_port_main		= {t='edit_num',id=id+14,	xywh='s_pro_man_t_port_main_xywh',range={1,65534},cmd = on_update_param},
	t_port_sub		= {t='edit_num',id=id+15,	xywh='s_pro_man_t_port_sub_xywh',range={1,65534},cmd = on_update_param},
	cat_path		= {t='static',	id=id+16,	xywh='s_cfg_page_6_1',text='LA_ABS_PATH'},
	t_path_main		= {t='edit',	id=id+17,	xywh='s_pro_man_t_path_main_xywh',max_value = 128,cmd = on_update_param},
	t_path_sub		= {t='edit',	id=id+18,	xywh='s_pro_man_t_path_sub_xywh',max_value = 128,cmd = on_update_param},
	info1			= {t='static',	id=id+19,	xywh='s_pro_man_info1_xywh',text='LA_EXAMPLE_TIP'},
	--info2			= {t='static',	id=id+20,	xywh='s_pro_man_info2_xywh',text='rtsp://192.168.0.1:554/ch1/main/av_stream',trans = false},
	tipinfo			= {t='static',	id=id+21,	xywh='s_pro_man_tipinfo_xywh',text='',trans = false},
	apply 			= {t='button',	id=id+23,	xywh='s_cfg_apply_xywh', text='LA_APPLY',cmd=on_apply},
}

return w1_page_pro_man