--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_wnd 	= require("wnd.core.b_wnd")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_record.record_id
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local b_app_api = require("wnd.core.command.b_app_api");
local w1_edit_record = require("wnd.w1_live.w1_edit_record")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;

local reflash_flag = 0
local channel_num;--豸ͨĿ
local w1_page_record = 
{
	old_chid,
	data,
	timestart =false,
	anr_sopport = nil;
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_record.s_768 =
{
	s_record_t_enable_xywh = {277,68,25,21},
	s_record_t_audio_xywh = {277,110,25,21},
	s_record_t_enable_anr_xywh = {277,152,25,21},--+42
	
	s_record_check_main_xywh = {277,194,21,32},
	s_record_cap_check_main_xywh = {298,194,80,32},
	s_record_check_sub_xywh	= {378,194,21,32},
	s_record_cap_check_sub_xywh	= {399,194,80,32},
	
	s_record_cap_sun_xywh = {53,268,32,21},
	s_record_t_sun_xywh = {85,268,16,21},
	s_record_cap_mon_xywh = {53,297,32,21},
	s_record_t_mon_xywh = {85,297,16,21},
	s_record_cap_tue_xywh = {53,325,32,21},
	s_record_t_tue_xywh = {85,325,16,21},
	s_record_cap_wed_xywh = {53,354,32,21},
	s_record_t_wed_xywh = {85,354,16,21},
	s_record_cap_thu_xywh = {53,382,32,21},
	s_record_t_thu_xywh = {85,382,16,21},
	s_record_cap_fri_xywh = {53,411,32,21},
	s_record_t_fri_xywh = {85,411,16,21},
	s_record_cap_sat_xywh = {53,439,32,21},
	s_record_t_sat_xywh = {85,439,16,21},
	s_record_cap_all_xywh = {53,240,32,21},
	s_record_t_all_xywh = {85,240,16,21},
	s_record_t_h2_xywh = {141,240,21,21},
	s_record_t_h4_xywh = {183,240,21,21},
	s_record_t_h6_xywh = {222,240,21,21},
	s_record_t_h8_xywh = {263,240,21,21},
	s_record_t_h10_xywh = {301,240,21,21},
	s_record_t_h12_xywh = {342,240,21,21},
	s_record_t_h14_xywh = {382,240,21,21},
	s_record_t_h16_xywh = {423,240,21,21},
	s_record_t_h18_xywh = {464,240,21,21},
	s_record_t_h20_xywh = {503,240,21,21},
	s_record_t_h22_xywh = {544,240,21,21},
	s_record_t_h24_xywh = {585,240,21,21},
	s_record_policy_xywh = {106,261,487,205},
	s_record_tipinfo_xywh = {58,510,373,35},
	s_record_edit_btn_xywh = {613,268,64,28},
	s_record_policytype1_xywh = {613,268,106,21},
	s_record_policytype2_xywh = {613,297,106,21},
	s_record_policytype3_xywh = {613,325,106,21},
	s_record_policytype4_xywh = {613,354,106,21},
	s_record_policytype5_xywh = {613,382,106,21},
	s_record_policytype6_xywh = {613,411,106,21},
};

w1_page_record.s_1280 = 
{
	s_record_t_enable_xywh = {455,96,48,30},
	s_record_t_audio_xywh = {455,156,48,30},
	s_record_t_enable_anr_xywh = {455,216,48,30},--+60
	
	s_record_check_main_xywh = {455,276,40,45},
	s_record_cap_check_main_xywh = {495,276,110,45},
	s_record_check_sub_xywh	= {605,276,40,45},
	s_record_cap_check_sub_xywh	= {645,276,110,45},
	
	s_record_cap_sun_xywh = {100,380,60,30},
	s_record_t_sun_xywh = {160,380,30,30},
	s_record_cap_mon_xywh = {100,420,60,30},
	s_record_t_mon_xywh = {160,420,30,30},
	s_record_cap_tue_xywh = {100,460,60,30},
	s_record_t_tue_xywh = {160,460,30,30},
	s_record_cap_wed_xywh = {100,500,60,30},
	s_record_t_wed_xywh = {160,500,30,30},
	s_record_cap_thu_xywh = {100,540,60,30},
	s_record_t_thu_xywh = {160,540,30,30},
	s_record_cap_fri_xywh = {100,580,60,30},
	s_record_t_fri_xywh = {160,580,30,30},
	s_record_cap_sat_xywh = {100,620,60,30},
	s_record_t_sat_xywh = {160,620,30,30},
	s_record_cap_all_xywh = {100,340,60,30},
	s_record_t_all_xywh = {160,340,30,30},
	s_record_t_h2_xywh = {250,340,40,30},
	s_record_t_h4_xywh = {310,340,40,30},
	s_record_t_h6_xywh = {370,340,40,30},
	s_record_t_h8_xywh = {430,340,40,30},
	s_record_t_h10_xywh = {486,340,40,30},
	s_record_t_h12_xywh = {546,340,40,30},
	s_record_t_h14_xywh = {606,340,40,30},
	s_record_t_h16_xywh = {666,340,40,30},
	s_record_t_h18_xywh = {726,340,40,30},
	s_record_t_h20_xywh = {784,340,40,30},
	s_record_t_h22_xywh = {844,340,40,30},
	s_record_t_h24_xywh = {904,340,40,30},
	s_record_policy_xywh = {200,370,722,289},--עcx48ı2߿,cy7ı2߿
	s_record_tipinfo_xywh = {110,740,700,50},
	s_record_edit_btn_xywh = {100,680,120,40},
	s_record_policytype1_xywh = {230,680,118,30},
	s_record_policytype2_xywh = {350,680,118,30},
	s_record_policytype3_xywh = {470,680,118,30},
	s_record_policytype4_xywh = {590,680,118,30},
	s_record_policytype5_xywh = {710,680,118,30},
	s_record_policytype6_xywh = {830,680,118,30},
}

w1_page_record.s_1440 = 
{
	s_record_t_enable_xywh = {520,80,48,30},
	s_record_t_audio_xywh = {520,130,48,30},
	s_record_t_enable_anr_xywh = {520,180,48,30},--+50
	
	s_record_check_main_xywh = {520,230,40,45},
	s_record_cap_check_main_xywh = {560,230,150,45},
	s_record_check_sub_xywh	= {710,230,40,45},
	s_record_cap_check_sub_xywh	= {750,230,150,45},
	
	s_record_cap_sun_xywh = {100,370,60,30},
	s_record_t_sun_xywh = {160,370,30,30},
	s_record_cap_mon_xywh = {100,410,60,30},
	s_record_t_mon_xywh = {160,410,30,30},
	s_record_cap_tue_xywh = {100,450,60,30},
	s_record_t_tue_xywh = {160,450,30,30},
	s_record_cap_wed_xywh = {100,490,60,30},
	s_record_t_wed_xywh = {160,490,30,30},
	s_record_cap_thu_xywh = {100,530,60,30},
	s_record_t_thu_xywh = {160,530,30,30},
	s_record_cap_fri_xywh = {100,570,60,30},
	s_record_t_fri_xywh = {160,570,30,30},
	s_record_cap_sat_xywh = {100,610,60,30},
	s_record_t_sat_xywh = {160,610,30,30},
	s_record_cap_all_xywh = {100,330,60,30},
	s_record_t_all_xywh = {160,330,30,30},
	s_record_t_h2_xywh = {255,330,40,30},
	s_record_t_h4_xywh = {318,330,40,30},
	s_record_t_h6_xywh = {383,330,40,30},
	s_record_t_h8_xywh = {446,330,40,30},
	s_record_t_h10_xywh = {507,330,40,30},
	s_record_t_h12_xywh = {571,330,40,30},
	s_record_t_h14_xywh = {635,330,40,30},
	s_record_t_h16_xywh = {699,330,40,30},
	s_record_t_h18_xywh = {763,330,40,30},
	s_record_t_h20_xywh = {825,330,40,30},
	s_record_t_h22_xywh = {889,330,40,30},
	s_record_t_h24_xywh = {953,330,40,30},
	s_record_policy_xywh = {200,360,770,289},--עcx48ı2߿,cy7ı2߿
	s_record_tipinfo_xywh = {110,700,500,50},
	s_record_edit_btn_xywh = {980,370,120,40},
	s_record_policytype1_xywh = {980,370,150,30},
	s_record_policytype2_xywh = {980,410,150,30},
	s_record_policytype3_xywh = {980,450,150,30},
	s_record_policytype4_xywh = {980,490,150,30},
	s_record_policytype5_xywh = {980,530,150,30},
	s_record_policytype6_xywh = {980,570,150,30},
}

w1_page_record.s_1080p = 
{
	s_record_t_enable_xywh = {520,96,48,30},
	s_record_t_audio_xywh = {520,156,48,30},
	s_record_t_enable_anr_xywh = {520,216,48,30},
	s_record_check_main_xywh = {520,276,40,45},
	s_record_cap_check_main_xywh = {560,276,150,45},
	s_record_check_sub_xywh	= {710,276,40,45},
	s_record_cap_check_sub_xywh	= {750,276,150,45},
	s_record_cap_sun_xywh = {100,380,60,30},
	s_record_t_sun_xywh = {160,380,30,30},
	s_record_cap_mon_xywh = {100,420,60,30},
	s_record_t_mon_xywh = {160,420,30,30},
	s_record_cap_tue_xywh = {100,460,60,30},
	s_record_t_tue_xywh = {160,460,30,30},
	s_record_cap_wed_xywh = {100,500,60,30},
	s_record_t_wed_xywh = {160,500,30,30},
	s_record_cap_thu_xywh = {100,540,60,30},
	s_record_t_thu_xywh = {160,540,30,30},
	s_record_cap_fri_xywh = {100,580,60,30},
	s_record_t_fri_xywh = {160,580,30,30},
	s_record_cap_sat_xywh = {100,620,60,30},
	s_record_t_sat_xywh = {160,620,30,30},
	s_record_cap_all_xywh = {100,340,60,30},
	s_record_t_all_xywh = {160,340,30,30},
	s_record_t_h2_xywh = {266,340,40,30},
	s_record_t_h4_xywh = {344,340,40,30},
	s_record_t_h6_xywh = {418,340,40,30},
	s_record_t_h8_xywh = {494,340,40,30},
	s_record_t_h10_xywh = {566,340,40,30},
	s_record_t_h12_xywh = {642,340,40,30},
	s_record_t_h14_xywh = {718,340,40,30},
	s_record_t_h16_xywh = {794,340,40,30},
	s_record_t_h18_xywh = {870,340,40,30},
	s_record_t_h20_xywh = {944,340,40,30},
	s_record_t_h22_xywh = {1020,340,40,30},
	s_record_t_h24_xywh = {1098,340,40,30},
	s_record_policy_xywh = {200,370,914,289},--עcx48ı2߿,cy7ı2߿
	s_record_tipinfo_xywh = {110,720,700,50},
	s_record_edit_btn_xywh = {1150,380,120,40},
	s_record_policytype1_xywh = {1150,380,200,30},
	s_record_policytype2_xywh = {1150,420,200,30},
	s_record_policytype3_xywh = {1150,460,200,30},
	s_record_policytype4_xywh = {1150,500,200,30},
	s_record_policytype5_xywh = {1150,540,200,30},
	s_record_policytype6_xywh = {1150,580,200,30},
}

w1_page_record.s_2k = 
{
	s_record_t_enable_xywh = {693,127,64,40},
	s_record_t_audio_xywh = {693,207,64,40},
	s_record_t_enable_anr_xywh = {693,287,64,40},--+80
	
	s_record_check_main_xywh = {693,367,53,60},
	s_record_cap_check_main_xywh = {746,367,200,60},
	s_record_check_sub_xywh	= {946,367,53,60},
	s_record_cap_check_sub_xywh	= {999,367,200,60},
	
	s_record_cap_sun_xywh = {133,506,80,40},
	s_record_t_sun_xywh = {213,506,40,40},
	s_record_cap_mon_xywh = {133,559,80,40},
	s_record_t_mon_xywh = {213,559,40,40},
	s_record_cap_tue_xywh = {133,613,80,40},
	s_record_t_tue_xywh = {213,613,40,40},
	s_record_cap_wed_xywh = {133,666,80,40},
	s_record_t_wed_xywh = {213,666,40,40},
	s_record_cap_thu_xywh = {133,719,80,40},
	s_record_t_thu_xywh = {213,719,40,40},
	s_record_cap_fri_xywh = {133,773,80,40},
	s_record_t_fri_xywh = {213,773,40,40},
	s_record_cap_sat_xywh = {133,826,80,40},
	s_record_t_sat_xywh = {213,826,40,40},
	s_record_cap_all_xywh = {133,453,80,40},
	s_record_t_all_xywh = {213,453,40,40},
	s_record_t_h2_xywh = {355,453,53,40},
	s_record_t_h4_xywh = {455,453,53,40},
	s_record_t_h6_xywh = {555,453,53,40},
	s_record_t_h8_xywh = {655,453,53,40},
	s_record_t_h10_xywh = {752,453,53,40},
	s_record_t_h12_xywh = {852,453,53,40},
	s_record_t_h14_xywh = {952,453,53,40},
	s_record_t_h16_xywh = {1052,453,53,40},
	s_record_t_h18_xywh = {1152,453,53,40},
	s_record_t_h20_xywh = {1250,453,53,40},
	s_record_t_h22_xywh = {1350,453,53,40},
	s_record_t_h24_xywh = {1450,453,53,40},
	s_record_policy_xywh = {267,493,1202,387},
	s_record_tipinfo_xywh = {147,959,933,67},
	s_record_edit_btn_xywh = {1500,506,160,53},
	s_record_policytype1_xywh = {1500,506,270,40},
	s_record_policytype2_xywh = {1500,559,270,40},
	s_record_policytype3_xywh = {1500,613,270,40},
	s_record_policytype4_xywh = {1500,666,270,40},
	s_record_policytype5_xywh = {1500,719,270,40},
	s_record_policytype6_xywh = {1500,773,270,40},
}

w1_page_record.s_4k = 
{
	s_record_t_enable_xywh = {1040,192,96,60},
	s_record_t_audio_xywh = {1040,312,96,60},
	s_record_t_enable_anr_xywh = {1040,432,96,60},--+120
	
	s_record_check_main_xywh = {1040,552,80,90},
	s_record_cap_check_main_xywh = {1120,552,300,90},
	s_record_check_sub_xywh	= {1420,552,80,90},
	s_record_cap_check_sub_xywh	= {1500,552,300,90},
	
	s_record_cap_sun_xywh = {200,760,120,60},
	s_record_t_sun_xywh = {320,760,60,60},
	s_record_cap_mon_xywh = {200,840,120,60},
	s_record_t_mon_xywh = {320,840,60,60},
	s_record_cap_tue_xywh = {200,920,120,60},
	s_record_t_tue_xywh = {320,920,60,60},
	s_record_cap_wed_xywh = {200,1000,120,60},
	s_record_t_wed_xywh = {320,1000,60,60},
	s_record_cap_thu_xywh = {200,1080,120,60},
	s_record_t_thu_xywh = {320,1080,60,60},
	s_record_cap_fri_xywh = {200,1160,120,60},
	s_record_t_fri_xywh = {320,1160,60,60},
	s_record_cap_sat_xywh = {200,1240,120,60},
	s_record_t_sat_xywh = {320,1240,60,60},
	s_record_cap_all_xywh = {200,680,120,60},
	s_record_t_all_xywh = {320,680,60,60},
	s_record_t_h2_xywh = {532,680,80,60},
	s_record_t_h4_xywh = {688,680,80,60},
	s_record_t_h6_xywh = {836,680,80,60},
	s_record_t_h8_xywh = {988,680,80,60},
	s_record_t_h10_xywh = {1132,680,80,60},
	s_record_t_h12_xywh = {1284,680,80,60},
	s_record_t_h14_xywh = {1436,680,80,60},
	s_record_t_h16_xywh = {1588,680,80,60},
	s_record_t_h18_xywh = {1740,680,80,60},
	s_record_t_h20_xywh = {1888,680,80,60},
	s_record_t_h22_xywh = {2040,680,80,60},
	s_record_t_h24_xywh = {2196,680,80,60},
	s_record_policy_xywh = {400,740,1828,578},
	s_record_tipinfo_xywh = {220,1440,1400,100},
	s_record_edit_btn_xywh = {2300,760,240,80},
	s_record_policytype1_xywh = {2300,760,400,60},
	s_record_policytype2_xywh = {2300,840,400,60},
	s_record_policytype3_xywh = {2300,920,400,60},
	s_record_policytype4_xywh = {2300,1000,400,60},
	s_record_policytype5_xywh = {2300,1080,400,60},
	s_record_policytype6_xywh = {2300,1160,400,60},
}

w1_page_record.clear_data = function()
	w1_page_record.data = nil;
	w1_page_record.copy_ch = nil;
	w1_page_record.anr_sopport = nil;
end	

local refresh_enable = function(top, hide, redraw)
	local cwnd = w1_page_record.wnd
	
	local sid = cwnd.cap_audio.id;
	local eid = cwnd.policy_type6.id;
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, hide, redraw)
	end
	b_wnd_ex.set_hide(top,w1_page_record.wnd.edit_btn.id,true,redraw)
	
	if (w1_page_record.anr_sopport == false) then
		b_wnd_ex.set_hide(top, cwnd.cap_enable_anr.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_enable_anr.id, true, redraw)
	end
end

local uirefresh_chdata = function(top, redraw)
	local cwnd = w1_page_record.wnd;
	
	local idx =  b_wnd_ex.get_sel(top, cwnd.t_channel.id);
	local chidstr = 'channel' .. (idx + 1);	
	local data = w1_page_record.data.record[chidstr];
	
	local enable = data.enable;
	b_wnd_ex.set_check(top, cwnd.t_enable.id, enable, redraw);
	local audio_flag = data.audio_flag;
	b_wnd_ex.set_check(top, cwnd.t_audio.id, audio_flag, redraw);
	local enable_anr = data.enable_anr;
	b_wnd_ex.set_check(top, cwnd.t_enable_anr.id, enable_anr, redraw);
	
	local stream_type = data.streams;--0:ȫѡ,1:main,2:sub
	if (0 == stream_type) then
		b_wnd_ex.set_check(top, cwnd.t_check_main.id, true, redraw);
		b_wnd_ex.set_check(top, cwnd.t_check_sub.id, true, redraw);
		
		b_wnd_ex.set_disable(top,cwnd.t_check_main.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_check_sub.id,false,redraw);
	elseif (1 == stream_type) then
		b_wnd_ex.set_check(top, cwnd.t_check_main.id, true, redraw);
		b_wnd_ex.set_check(top, cwnd.t_check_sub.id, false, redraw);
		
		b_wnd_ex.set_disable(top,cwnd.t_check_main.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_check_sub.id,false,redraw);
	elseif (2 == stream_type) then
		b_wnd_ex.set_check(top, cwnd.t_check_main.id, false, redraw);
		b_wnd_ex.set_check(top, cwnd.t_check_sub.id, true, redraw);
		
		b_wnd_ex.set_disable(top,cwnd.t_check_main.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_check_sub.id,true,redraw);
	end
	
	local time_plan = {
		weekday1 = data.weekday1,
		weekday2 = data.weekday2,
		weekday3 = data.weekday3,
		weekday4 = data.weekday4,
		weekday5 = data.weekday5,
		weekday6 = data.weekday6,
		weekday7 = data.weekday7
	}
	b_wnd_ex.set_timeplan_record (top, cwnd.policy.id, time_plan, redraw);
	if(data.enable) then
		refresh_enable(top, false, redraw)
	else
		refresh_enable(top, true, redraw)
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)	
	assert(type(cfgdata) == 'table');
	w1_page_record.data = cfgdata;
	uirefresh_chdata(top ,false);
	b_wnd_ex.set_hide(top,w1_page_record.wnd.edit_btn.id,true,false)
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_record.timer_start = function()
	w1_page_record.timestart = true
end

w1_page_record.timer_stop = function(top)
	w1_page_record.timestart = false
	w1_wnd_util.tipclear(top, w1_page_record.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_record.timerenevt = function(top)
	if(w1_page_record.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_record.wnd.tipinfo.id)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_record.wnd;
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	
	local data  =cfgdata.record['channel'..chid];
	local timeplan_area = b_wnd_ex.get_timeplan_record (top, w1_page_record.wnd.policy.id);
    for i=1,7 do
		data['weekday'..i] = timeplan_area['weekday'..i]
	end
	local enable =  b_wnd_ex.get_check(top, w1_page_record.wnd.t_enable.id);
	data.enable = enable;
	local audio  =  b_wnd_ex.get_check(top, w1_page_record.wnd.t_audio.id);
	data.audio_flag = 	audio;
	local anr  =  b_wnd_ex.get_check(top, w1_page_record.wnd.t_enable_anr.id);
	data.enable_anr = 	anr;
	
	local main_check = b_wnd_ex.get_check(top, w1_page_record.wnd.t_check_main.id);
	local sub_check = b_wnd_ex.get_check(top, w1_page_record.wnd.t_check_sub.id);
	if (main_check == true and sub_check == true) then
		data.streams = 0;
	elseif (main_check == true) then
		data.streams = 1;
	elseif (sub_check == true) then
		data.streams = 2;
	end
	
	cfgdata.record.type = 1;
	return 0
end

w1_page_record.init = function(top)
	local c_wnd = w1_page_record.wnd
	channel_num = global_val.get_channelnum();
	
	w1_wnd_util.cfgtab = {'record'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local chidstr = b_wnd_ex.get_text(top, c_wnd.t_channel.id);
	if(chidstr == '') then
		return 0
	end
	local chid =tonumber(chidstr);
	w1_page_record.old_chid = chid;
	return 0
end

local on_channel= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_record.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		if(w1_page_record.old_chid ~= chid) then
			uirefresh_chdata(top, false);
			b_dlg.dlg_set_redraw(top);
			w1_page_record.old_chid = chid;
		end
	end
	return 0;
end

local on_stream_check = function (top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg)then
		local cwnd = w1_page_record.wnd;
		
		--֤һѡ
		local check_main = b_wnd_ex.get_check(top, cwnd.t_check_main.id);
		if (check_main == true) then
			b_wnd_ex.set_disable(top,cwnd.t_check_sub.id,false,false);
		else
			b_wnd_ex.set_disable(top,cwnd.t_check_sub.id,true,false);
		end

		local check_sub = b_wnd_ex.get_check(top,cwnd.t_check_sub.id);		
		if (check_sub == true) then
			b_wnd_ex.set_disable(top,cwnd.t_check_main.id,false,false);
		else
			b_wnd_ex.set_disable(top,cwnd.t_check_main.id,true,false);
		end
		
		b_dlg.dlg_set_redraw(top);
		
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	
	return 0;
end

local copy_okfunc = function(param)
	local cwnd = w1_page_record.wnd;
	local chid = tonumber(b_wnd_ex.get_text(param[1], cwnd.t_channel.id));
	local chsrc = w1_page_record.data.record['channel'..chid];
	local chdir = w1_page_record.data.record;
	
	for i=1, #param[2] do
		if(chdir['channel'..param[2][i]] == nil) then
			chdir['channel'..param[2][i]] = util.copy_tab(chsrc)
		else
			util.copy_tab_b(chdir['channel'..param[2][i]], chsrc)
		end	
		chdir['channel'..param[2][i]].chn = param[2][i];
	end
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id)
		if(check) then
			refresh_enable(top, false, false)
		else
			refresh_enable(top, true, false)
		end
		b_dlg.dlg_set_redraw(top);
		
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_copy = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_record.wnd;
		local param = {};
		local idx = 1;
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
		uitousercfg(top, w1_page_record.data)
		
		for i=1, channel_num do
			if( i ~= chid) then
				param[idx] = i;
				idx =idx + 1;
			end
		end
		w1_copy.init();
		w1_copy.set_dlgattr(param);
		w1_copy.set_func (copy_okfunc,{top, w1_page_record.copy_ch} );
		b_dlg.post_modal(top, w1_key.DLG_COPY, 0, 0, nil)
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		--w1_wnd_util.cfgtouifunc = cfgdatatoui
		--w1_wnd_util.page_ondefault(top)
		--w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		uitousercfg(top,b_app_cfg.user_cfg);
	elseif (b_ui.LBUTTONCLK == vmsg) then
		uitousercfg(top,b_app_cfg.user_cfg);	 
	end
	
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ	
	end
	return 0
end

w1_page_record.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	
	return ret;
end

local on_type_check = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local type = 0;
		local cwnd = w1_page_record.wnd;
		for i=cwnd.policy_type1.id, cwnd.policy_type6.id do
			if(win_id == i) then
				b_wnd_ex.set_check(top, i, true, true);
				type = i - cwnd.policy_type1.id + 1;
			else
				b_wnd_ex.set_check(top, i, false, true);
			end
		end
		
		b_wnd_ex.set_timeplan_type(top, cwnd.policy.id, type, false);
	end
	
	return 0;
end

w1_page_record.ok_get_tempdata = function ()
	reflash_flag = 1
end

local on_manual_edit = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then	
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_record.wnd.t_channel.id));
		w1_edit_record.set_func(w1_page_record.ok_get_tempdata,{chid},nil,nil,b_app_cfg.user_cfg)
		b_dlg.do_modal(top, w1_key.DLG_EDIT_RECORD, 0, 0, nil)
		if reflash_flag==1 then
			uirefresh_chdata(top ,false);
			b_dlg.dlg_set_redraw(top)
		end
		reflash_flag = 0
		end
	return 0;
end

local on_select = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_record.wnd;
		local data = b_wnd_ex.get_timeplan_record (top, cwnd.policy.id);
		
		local plantype = 0;
		for i=cwnd.policy_type1.id, cwnd.policy_type6.id do
			if (true == b_wnd_ex.get_check(top, i)) then
				plantype = i - cwnd.policy_type1.id + 1;
			end
		end
		
		local plannum_4h = 0;
		if (1 == plantype) then
			plannum_4h = 0x11111111;
		elseif (2 == plantype) then
			plannum_4h = 0x22222222;
		elseif (3 == plantype) then
			plannum_4h = 0x33333333;
		elseif (4 == plantype) then
			plannum_4h = 0x44444444;
		elseif (5 == plantype) then
			plannum_4h = 0x55555555;
		elseif (6 == plantype) then
			plannum_4h = 0x66666666;
		end

		local allselect = true;
		local plannum;
		if(win_id == cwnd.t_all.id) then
			for i=1,7 do
				for j=1,6 do
					if(data['weekday'..i][j] ~= plannum_4h) then
						allselect = false;
						break;
					end
				end
				if(allselect == false) then
					break;
				end
			end			
			
			if(allselect) then
				plannum = 0;
			else
				plannum = plannum_4h;
			end
			for i=1,7 do
				for j=1,6 do
					data['weekday'..i][j] = plannum;
				end
			end
		else
			local weekday;
			if(win_id == cwnd.t_sun.id) then
				weekday = 1;
			elseif(win_id == cwnd.t_mon.id) then
				weekday = 2;
			elseif(win_id == cwnd.t_tue.id) then
				weekday = 3;
			elseif(win_id == cwnd.t_wed.id) then
				weekday = 4;
			elseif(win_id == cwnd.t_thu.id) then
				weekday = 5;
			elseif(win_id == cwnd.t_fri.id) then
				weekday = 6;
			elseif(win_id == cwnd.t_sat.id) then
				weekday = 7;
			end
				
			allselect = true;
			for j=1,6 do
				if(data['weekday'..weekday][j] ~= plannum_4h) then
					allselect = false;
					break;
				end
			end
			if(allselect) then
				plannum = 0;
			else
				plannum = plannum_4h;
			end
			
			for j=1,6 do
				data['weekday'..weekday][j] = plannum;
			end
		end
		b_wnd_ex.set_timeplan_record (top, cwnd.policy.id, data, true);
		
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_record.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	local cwnd = w1_page_record.wnd;
	local param={}
	for i=1,channel_num do
		param[i] = tostring(i)
	end
	b_wnd_ex.set_items(top, cwnd.t_channel.id, param, false);
	
	w1_page_record.anr_sopport = global_val.get_anr_support();
	if (w1_page_record.anr_sopport == false) then --֧һ
		b_wnd_ex.set_hide(top, cwnd.cap_enable_anr.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.t_enable_anr.id, true, false)
		local pos = SIZE('s_cfg_page_3_1');
		local pos1 = SIZE('s_cfg_page_4_1');
		local move_h = pos1[2] - pos[2];
		local s_id = cwnd.cap_sun.id;
		local e_id = cwnd.policy_type6.id
		for i = 8, #cwnd.sub - 3  do
			local position = SIZE(cwnd[cwnd.sub[i]].xywh)
			b_wnd_ex.move_pos(top, cwnd[cwnd.sub[i]].id, {position[1], position[2] - move_h}, false);
		end
	end	
end

w1_page_record.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_channel', 't_channel','cap_enable', 't_enable',
			'cap_audio','t_audio','cap_enable_anr', 't_enable_anr', 
			'cap_stream_t', 't_check_main', 'cap_check_main', 't_check_sub', 'cap_check_sub',
			'cap_sun','t_sun','cap_mon','t_mon','cap_tue', 't_tue', 
			'cap_wed', 't_wed', 'cap_thu', 't_thu','cap_fri','t_fri',	
			'cap_sat','t_sat','cap_all',	
			't_all','t_h2','t_h4','t_h6','t_h8','t_h10','t_h12',
			't_h14','t_h16','t_h18','t_h20','t_h22','t_h24', 'policy', 'edit_btn',
			'policy_type1','policy_type2','policy_type3','policy_type4','policy_type5','policy_type6',
			'tipinfo', 'copy', 'apply'},
			
	cap_channel	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',	text='LA_CHANNEL'},
	t_channel 	= {t='combox',	id=id+2,	xywh='s_cfg_page_1_2',	items={},
					trans = false, channel_cbox = true,cmd =on_channel},	
	
	cap_enable 	= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',	text='LA_ENABLE_RECORD'},
	t_enable 	= {t='tt_check',id=id+4,	xywh='s_record_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_enable},
	
	cap_audio 	= {t='static',	id=id+5,	xywh='s_cfg_page_3_1',	text='LA_RECORD_AUDIO'},
	t_audio 	= {t='tt_check',id=id+6,	xywh='s_record_t_audio_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'}, cmd=on_update_param},
					
	cap_enable_anr 	= {t='static',	id=id+7,	xywh='s_cfg_page_4_1',	text='LA_ANR'},
	t_enable_anr 	= {t='tt_check',id=id+8,	xywh='s_record_t_enable_anr_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'}, cmd=on_update_param},					

	cap_stream_t	= {t='static',	id=id+9,	xywh='s_cfg_page_5_1',text='LA_STREAM_TYPE'},
	t_check_main	= {t='check', 	id=id+10,	xywh='s_record_check_main_xywh',cmd = on_stream_check},
	cap_check_main	= {t='static',	id=id+11,	xywh='s_record_cap_check_main_xywh',text='LA_MAIN_STREAM'},
	t_check_sub		= {t='check', 	id=id+12,	xywh='s_record_check_sub_xywh',cmd = on_stream_check},
	cap_check_sub	= {t='static',	id=id+13,	xywh='s_record_cap_check_sub_xywh',text='LA_SUBCODE_FLOW',},
	
	cap_sun		= {t='static',	id=id+14,	xywh='s_record_cap_sun_xywh',	text='LA_WEEK_SUNDAY'},
	t_sun 		= {t='tt_button',id=id+15,	xywh='s_record_t_sun_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_mon		= {t='static',	id=id+16,	xywh='s_record_cap_mon_xywh',	text='LA_WEEK_MONDAY'},
	t_mon 		= {t='tt_button',id=id+17,	xywh='s_record_t_mon_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_tue		= {t='static',	id=id+18,	xywh='s_record_cap_tue_xywh',	text='LA_WEEK_TUESDAY'},
	t_tue 		= {t='tt_button',id=id+19,	xywh='s_record_t_tue_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_wed		= {t='static',	id=id+20,	xywh='s_record_cap_wed_xywh',	text='LA_WEEK_WEDNESDAY'},
	t_wed 		= {t='tt_button',id=id+21,	xywh='s_record_t_wed_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_thu		= {t='static',	id=id+22,	xywh='s_record_cap_thu_xywh',	text='LA_WEEK_THURSDAY'},
	t_thu 		= {t='tt_button',id=id+23,	xywh='s_record_t_thu_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_fri		= {t='static',	id=id+24,	xywh='s_record_cap_fri_xywh',	text='LA_WEEK_FRIDAY'},
	t_fri 		= {t='tt_button',id=id+25,	xywh='s_record_t_fri_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_sat		= {t='static',	id=id+26,	xywh='s_record_cap_sat_xywh',	text='LA_WEEK_SATURDAY'},
	t_sat 		= {t='tt_button',id=id+27,	xywh='s_record_t_sat_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_all		= {t='static',	id=id+28,	xywh='s_record_cap_all_xywh',	text='LA_ALL'},
	t_all		= {t='tt_button',id=id+29,	xywh='s_record_t_all_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
				
	t_h2		= {t='static',	id=id+30,	xywh='s_record_t_h2_xywh',	text='2',	trans = false},	
	t_h4		= {t='static',	id=id+31,	xywh='s_record_t_h4_xywh',	text='4',	trans = false},	
	t_h6		= {t='static',	id=id+32,	xywh='s_record_t_h6_xywh',	text='6',	trans = false},	
	t_h8		= {t='static',	id=id+33,	xywh='s_record_t_h8_xywh',	text='8',	trans = false},	
	t_h10		= {t='static',	id=id+34,	xywh='s_record_t_h10_xywh',	text='10',	trans = false},	
	t_h12		= {t='static',	id=id+35,	xywh='s_record_t_h12_xywh',	text='12',	trans = false},	
	t_h14		= {t='static',	id=id+36,	xywh='s_record_t_h14_xywh',	text='14',	trans = false},	
	t_h16		= {t='static',	id=id+37,	xywh='s_record_t_h16_xywh',	text='16',	trans = false},	
	t_h18		= {t='static',	id=id+38,	xywh='s_record_t_h18_xywh',	text='18',	trans = false},	
	t_h20		= {t='static',	id=id+39,	xywh='s_record_t_h20_xywh',	text='20',	trans = false},	
	t_h22		= {t='static',	id=id+40,	xywh='s_record_t_h22_xywh',	text='22',	trans = false},	
	t_h24		= {t='static',	id=id+41,	xywh='s_record_t_h24_xywh',	text='24',	trans = false},		

	policy 		= {t='timeplan_record',id=id+42,	xywh='s_record_policy_xywh',	text='policy widget',trans = false,
					color= {'c_image_bk', 'c_cfg_row_bk', 'c_txt_n'}, cmd=on_update_param},
	
	edit_btn = {t='button',	id=id+43,	xywh = 's_record_edit_btn_xywh',	text='LA_EDIT',	cmd=on_manual_edit},
	
	policy_type1 = {t='checkcoloredbtn', id=id+44, xywh = 's_record_policytype1_xywh',	text='LA_CONTINUOUS',  check = true, cmd=on_type_check,
					color_f= {'c_timeplan_block_c_1', 'c_timeplan_block_c_1', 'c_timeplan_block_c_1'}},
	policy_type2 = {t='checkcoloredbtn', id=id+45, xywh = 's_record_policytype2_xywh',	text='LA_ALARM',  cmd=on_type_check,
					color_f= {'c_timeplan_block_c_2', 'c_timeplan_block_c_2', 'c_timeplan_block_c_2'}},
	policy_type3 = {t='checkcoloredbtn', id=id+46, xywh = 's_record_policytype3_xywh',	text='LA_MOTION_D', cmd=on_type_check,
					color_f= {'c_timeplan_block_c_3', 'c_timeplan_block_c_3', 'c_timeplan_block_c_3'}},
	policy_type4 = {t='checkcoloredbtn', id=id+47, xywh = 's_record_policytype4_xywh',	text='LA_IO', cmd=on_type_check,
					color_f= {'c_timeplan_block_c_4', 'c_timeplan_block_c_4', 'c_timeplan_block_c_4'}},
	policy_type5 = {t='checkcoloredbtn', id=id+48, xywh = 's_record_policytype5_xywh',	text='LA_MOTION_OR_IO', cmd=on_type_check,
					color_f= {'c_timeplan_block_c_5', 'c_timeplan_block_c_5', 'c_timeplan_block_c_5'}},
	policy_type6 = {t='checkcoloredbtn', id=id+49, xywh = 's_record_policytype6_xywh',	text='LA_MOTION_AND_IO', cmd=on_type_check,
					color_f= {'c_timeplan_block_c_6', 'c_timeplan_block_c_6', 'c_timeplan_block_c_6'}},
					
	tipinfo		= {t='static',id=id+50,	xywh='s_record_tipinfo_xywh',	
					text='',trans = false},
	copy 		= {t='button',	id=id+51,	xywh = 's_cfg_copy_xywh',	text='LA_COPY_TO',	cmd=on_copy},
	apply 		= {t='button',	id=id+52,	xywh = 's_cfg_apply_xywh',	text='LA_APPLY',	cmd=on_apply},
}

return w1_page_record

