--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_smtp.smtp_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_msgbox	 	= require("wnd.w1_util.w1_msgbox")
local w1_key 		= require("wnd.w1_util.w1_key")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local util 			= require("wnd.core.util")
local b_app_api 	= require("wnd.core.command.b_app_api")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_smtp 	= 
{
	data,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_smtp.s_768 =
{
	s_smtp_check_alarm1_xywh = {485,234,21,28},
	s_smtp_alarm_1_xywh = {506,234,53,32},
	s_smtp_check_pass1_xywh = {568,234,21,28},
	s_smtp_password1_xywh = {589,234,80,32},
	s_smtp_check_alarm2_xywh = {485,277,21,28},
	s_smtp_alarm_2_xywh = {506,277,53,32},
	s_smtp_check_pass2_xywh = {568,277,21,28},
	s_smtp_password2_xywh = {589,277,80,32},
	s_smtp_check_alarm3_xywh = {485,320,21,32},
	s_smtp_alarm_3_xywh = {506,320,53,28},
	s_smtp_check_pass3_xywh = {568,320,21,28},
	s_smtp_password3_xywh = {589,320,80,32},
	s_smtp_test_xywh = {277,448,80,32},
	s_smtp_tipinfo_xywh = {53,490,373,35},
		
	s_smtp_cfg_page_1_1 = {53,21,202,32},
	s_smtp_cfg_page_1_2 = {277,21,202,32},
	s_smtp_cfg_page_2_1 = {53,64,202,32},
	s_smtp_cfg_page_2_2 = {277,64,202,32},
	s_smtp_cfg_page_3_1 = {53,106,202,32},
	s_smtp_cfg_page_3_2 = {277,106,202,32},
	s_smtp_cfg_page_4_1 = {53,149,213,32},
	s_smtp_cfg_page_4_2 = {277,149,202,32},
	s_smtp_cfg_page_5_1 = {53,192,202,32},
	s_smtp_cfg_page_5_2 = {277,192,202,32},
	s_smtp_cfg_page_6_1 = {53,234,213,32},
	s_smtp_cfg_page_6_2 = {277,234,202,32},
	s_smtp_cfg_page_7_1 = {53,277,202,32},
	s_smtp_cfg_page_7_2 = {277,277,202,32},
	s_smtp_cfg_page_8_1 = {53,320,202,32},
	s_smtp_cfg_page_8_2 = {277,320,202,32},
	s_smtp_cfg_page_9_1 = {53,362,202,32},
	s_smtp_cfg_page_9_2 = {277,362,202,32},
	s_smtp_cfg_page_10_1 = {53,405,202,32},
	s_smtp_cfg_page_10_2 = {277,405,202,32},
};

w1_page_smtp.s_1280 = 
{
	s_smtp_check_alarm1_xywh = {670,330,35,40},
	s_smtp_alarm_1_xywh = {705,330,100,45},
	s_smtp_check_pass1_xywh = {805,330,35,40},
	s_smtp_password1_xywh = {840,330,130,45},
	s_smtp_check_alarm2_xywh = {670,390,35,40},
	s_smtp_alarm_2_xywh = {705,390,100,45},
	s_smtp_check_pass2_xywh = {805,390,35,40},
	s_smtp_password2_xywh = {840,390,130,45},
	s_smtp_check_alarm3_xywh = {670,450,35,45},
	s_smtp_alarm_3_xywh = {705,450,100,40},
	s_smtp_check_pass3_xywh = {805,450,35,40},
	s_smtp_password3_xywh = {840,450,130,45},
	s_smtp_test_xywh = {380,630,150,45},
	s_smtp_tipinfo_xywh = {100,690,700,50},
	
	s_smtp_cfg_page_1_1= {100, 30,280,45},
	s_smtp_cfg_page_1_2 = {380, 30,280,45},
	s_smtp_cfg_page_2_1 = {100, 90,280,45},
	s_smtp_cfg_page_2_2 = {380, 90,280,45},
	s_smtp_cfg_page_3_1 = {100, 150,280,45},
	s_smtp_cfg_page_3_2 = {380, 150,280,45},
	s_smtp_cfg_page_4_1 = {100, 210,278,45},
	s_smtp_cfg_page_4_2 = {380, 210,280,45},
	s_smtp_cfg_page_5_1 = {100, 270,280,45},
	s_smtp_cfg_page_5_2 = {380, 270,280,45},
	s_smtp_cfg_page_6_1 = {100, 330,278,45},
	s_smtp_cfg_page_6_2 = {380, 330,280,45},
	s_smtp_cfg_page_7_1 = {100, 390,280,45},
	s_smtp_cfg_page_7_2 = {380, 390,280,45},
	s_smtp_cfg_page_8_1 = {100, 450,280,45},
	s_smtp_cfg_page_8_2 = {380, 450,280,45},
	s_smtp_cfg_page_9_1 = {100, 510,280,45},
	s_smtp_cfg_page_9_2 = {380, 510,280,45},
	s_smtp_cfg_page_10_1 = {100, 570,280,45},
	s_smtp_cfg_page_10_2 = {380, 570,280,45},
}

w1_page_smtp.s_1440 = 
{
	s_smtp_check_alarm1_xywh = {720,280,35,40},
	s_smtp_alarm_1_xywh = {755,280,100,45},
	s_smtp_check_pass1_xywh = {855,280,35,40},
	s_smtp_password1_xywh = {890,280,130,45},
	s_smtp_check_alarm2_xywh = {720,330,35,40},
	s_smtp_alarm_2_xywh = {755,330,100,45},
	s_smtp_check_pass2_xywh = {855,330,35,40},
	s_smtp_password2_xywh = {890,330,130,45},
	s_smtp_check_alarm3_xywh = {720,380,35,45},
	s_smtp_alarm_3_xywh = {755,380,100,40},
	s_smtp_check_pass3_xywh = {855,380,35,40},
	s_smtp_password3_xywh = {890,380,130,45},
	s_smtp_test_xywh = {430,530,150,45},
	s_smtp_tipinfo_xywh = {100,580,700,50},
	
	s_smtp_cfg_page_1_1= {100, 30,280,45},
	s_smtp_cfg_page_1_2 = {430, 30,280,45},
	s_smtp_cfg_page_2_1 = {100, 80,280,45},
	s_smtp_cfg_page_2_2 = {430, 80,280,45},
	s_smtp_cfg_page_3_1 = {100, 130,280,45},
	s_smtp_cfg_page_3_2 = {430, 130,280,45},
	s_smtp_cfg_page_4_1 = {100, 180,320,45},
	s_smtp_cfg_page_4_2 = {430, 180,280,45},
	s_smtp_cfg_page_5_1 = {100, 230,280,45},
	s_smtp_cfg_page_5_2 = {430, 230,280,45},
	s_smtp_cfg_page_6_1 = {100, 280,300,45},
	s_smtp_cfg_page_6_2 = {430, 280,280,45},
	s_smtp_cfg_page_7_1 = {100, 330,280,45},
	s_smtp_cfg_page_7_2 = {430, 330,280,45},
	s_smtp_cfg_page_8_1 = {100, 380,280,45},
	s_smtp_cfg_page_8_2 = {430, 380,280,45},
	s_smtp_cfg_page_9_1 = {100, 430,280,45},
	s_smtp_cfg_page_9_2 = {430, 430,280,45},
	s_smtp_cfg_page_10_1 = {100, 480,280,45},
	s_smtp_cfg_page_10_2 = {430, 480,280,45},
}

w1_page_smtp.s_1080p = 
{
	s_smtp_check_alarm1_xywh = {910,330,40,40},
	s_smtp_alarm_1_xywh = {950,330,100,45},
	s_smtp_check_pass1_xywh = {1065,330,40,40},
	s_smtp_password1_xywh = {1105,330,150,45},
	s_smtp_check_alarm2_xywh = {910,390,40,40},
	s_smtp_alarm_2_xywh = {950,390,100,45},
	s_smtp_check_pass2_xywh = {1065,390,40,40},
	s_smtp_password2_xywh = {1105,390,150,45},
	s_smtp_check_alarm3_xywh = {910,450,40,45},
	s_smtp_alarm_3_xywh = {950,450,100,40},
	s_smtp_check_pass3_xywh = {1065,450,40,40},
	s_smtp_password3_xywh = {1105,450,150,45},
	s_smtp_test_xywh = {520,630,150,45},
	s_smtp_tipinfo_xywh = {100,690,700,50},
	
	s_smtp_cfg_page_1_1= {100, 30,380,45},
	s_smtp_cfg_page_1_2 = {520, 30,380,45},
	s_smtp_cfg_page_2_1 = {100, 90,380,45},
	s_smtp_cfg_page_2_2 = {520, 90,380,45},
	s_smtp_cfg_page_3_1 = {100, 150,380,45},
	s_smtp_cfg_page_3_2 = {520, 150,380,45},
	s_smtp_cfg_page_4_1 = {100, 210,400,45},
	s_smtp_cfg_page_4_2 = {520, 210,380,45},
	s_smtp_cfg_page_5_1 = {100, 270,380,45},
	s_smtp_cfg_page_5_2 = {520, 270,380,45},
	s_smtp_cfg_page_6_1 = {100, 330,400,45},
	s_smtp_cfg_page_6_2 = {520, 330,380,45},
	s_smtp_cfg_page_7_1 = {100, 390,380,45},
	s_smtp_cfg_page_7_2 = {520, 390,380,45},
	s_smtp_cfg_page_8_1 = {100, 450,380,45},
	s_smtp_cfg_page_8_2 = {520, 450,380,45},
	s_smtp_cfg_page_9_1 = {100, 510,380,45},
	s_smtp_cfg_page_9_2 = {520, 510,380,45},
	s_smtp_cfg_page_10_1 = {100, 570,380,45},
	s_smtp_cfg_page_10_2 = {520, 570,380,45},
	
}

w1_page_smtp.s_2k = 
{
	s_smtp_check_alarm1_xywh = {1213,440,53,53},
	s_smtp_alarm_1_xywh = {1266,440,133,60},
	s_smtp_check_pass1_xywh = {1420,440,53,53},
	s_smtp_password1_xywh = {1473,440,200,60},
	s_smtp_check_alarm2_xywh = {1213,520,53,53},
	s_smtp_alarm_2_xywh = {1266,520,133,60},
	s_smtp_check_pass2_xywh = {1420,520,53,53},
	s_smtp_password2_xywh = {1473,520,200,60},
	s_smtp_check_alarm3_xywh = {1213,600,53,60},
	s_smtp_alarm_3_xywh = {1266,600,133,53},
	s_smtp_check_pass3_xywh = {1420,600,53,53},
	s_smtp_password3_xywh = {1473,600,200,60},
	s_smtp_test_xywh = {693,840,200,60},
	s_smtp_tipinfo_xywh = {133,920,933,67},
	
	s_smtp_cfg_page_1_1= {133,40,507,60},
	s_smtp_cfg_page_1_2 = {693,40,507,60},
	s_smtp_cfg_page_2_1 = {133,120,507,60},
	s_smtp_cfg_page_2_2 = {693,120,507,60},
	s_smtp_cfg_page_3_1 = {133,200,507,60},
	s_smtp_cfg_page_3_2 = {693,200,507,60},
	s_smtp_cfg_page_4_1 = {133,280,530,60},
	s_smtp_cfg_page_4_2 = {693,280,507,60},
	s_smtp_cfg_page_5_1 = {133,360,507,60},
	s_smtp_cfg_page_5_2 = {693,360,507,60},
	s_smtp_cfg_page_6_1 = {133,440,533,60},
	s_smtp_cfg_page_6_2 = {693,440,507,60},
	s_smtp_cfg_page_7_1 = {133,520,507,60},
	s_smtp_cfg_page_7_2 = {693,520,507,60},
	s_smtp_cfg_page_8_1 = {133,600,507,60},
	s_smtp_cfg_page_8_2 = {693,600,507,60},
	s_smtp_cfg_page_9_1 = {133,680,507,60},
	s_smtp_cfg_page_9_2 = {693,680,507,60},
	s_smtp_cfg_page_10_1 = {133,760,507,60},
	s_smtp_cfg_page_10_2 = {693,760,507,60},
}

w1_page_smtp.s_4k = 
{
	s_smtp_check_alarm1_xywh = {1820,660,80,80},
	s_smtp_alarm_1_xywh = {1900,660,200,90},
	s_smtp_check_pass1_xywh = {2130,660,80,80},
	s_smtp_password1_xywh = {2210,660,300,90},
	s_smtp_check_alarm2_xywh = {1820,780,80,80},
	s_smtp_alarm_2_xywh = {1900,780,200,90},
	s_smtp_check_pass2_xywh = {2130,780,80,80},
	s_smtp_password2_xywh = {2210,780,300,90},
	s_smtp_check_alarm3_xywh = {1820,900,80,90},
	s_smtp_alarm_3_xywh = {1900,900,200,80},
	s_smtp_check_pass3_xywh = {2130,900,80,80},
	s_smtp_password3_xywh = {2210,900,300,90},
	s_smtp_test_xywh = {1040,1260,300,90},
	s_smtp_tipinfo_xywh = {200,1380,1400,100},
	
	s_smtp_cfg_page_1_1= {200,60,760,90},
	s_smtp_cfg_page_1_2 = {1040,60,760,90},
	s_smtp_cfg_page_2_1 = {200,180,760,90},
	s_smtp_cfg_page_2_2 = {1040,180,760,90},
	s_smtp_cfg_page_3_1 = {200,300,760,90},
	s_smtp_cfg_page_3_2 = {1040,300,760,90},
	s_smtp_cfg_page_4_1 = {200,420,760,90},
	s_smtp_cfg_page_4_2 = {1040,420,760,90},
	s_smtp_cfg_page_5_1 = {200,540,760,90},
	s_smtp_cfg_page_5_2 = {1040,540,760,90},
	s_smtp_cfg_page_6_1 = {200,660,800,90},
	s_smtp_cfg_page_6_2 = {1040,660,760,90},
	s_smtp_cfg_page_7_1 = {200,780,760,90},
	s_smtp_cfg_page_7_2 = {1040,780,760,90},
	s_smtp_cfg_page_8_1 = {200,900,760,90},
	s_smtp_cfg_page_8_2 = {1040,900,760,90},
	s_smtp_cfg_page_9_1 = {200,1020,760,90},
	s_smtp_cfg_page_9_2 = {1040,1020,760,90},
	s_smtp_cfg_page_10_1 = {200,1140,760,90},
	s_smtp_cfg_page_10_2 = {1040,1140,760,90},
}

w1_page_smtp.clear_data = function()
	w1_page_smtp.data = nil;
end	


--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w1_page_smtp.wnd
	
	w1_page_smtp.data = cfgdata.smtp;
	
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,false)
	end
	local function setcheck(id, flag)
		if(flag ==1)then
			b_wnd_ex.set_check(top, id, true,false)
		else
			b_wnd_ex.set_check(top, id, false,false)
		end
	end
	local function setvalue(id, value)
		b_wnd_ex.set_value(top, id, value, false)
	end
	if(cfgdata['smtp']['smtp_type'] == 0) then
		b_wnd_ex.set_sel(top, c_wnd.t_ssl.id, 0,false)
	elseif(cfgdata['smtp']['smtp_type'] == 1) then
		b_wnd_ex.set_sel(top, c_wnd.t_ssl.id, 1,false)
	elseif(cfgdata['smtp']['smtp_type'] == 2) then
		b_wnd_ex.set_sel(top, c_wnd.t_ssl.id, 2,false)
	end
	settext(c_wnd.t_server.id,cfgdata['smtp']['mail_server_addr'] );
	setvalue(c_wnd.t_port.id,cfgdata['smtp']['mail_server_port'] );
	settext(c_wnd.t_email.id,cfgdata['smtp']['sender_mail_addr'] );
	settext(c_wnd.t_name.id,cfgdata['smtp']['sender_account'] );
	b_wnd_ex.set_password(top, c_wnd.t_pass.id, cfgdata['smtp']['sender_password'], false);
	
	settext(c_wnd.t_recv1.id,cfgdata['smtp']['receiver1']['receiver_mail_addr'] );
	settext(c_wnd.t_recv2.id,cfgdata['smtp']['receiver2']['receiver_mail_addr'] );
	settext(c_wnd.t_recv3.id,cfgdata['smtp']['receiver3']['receiver_mail_addr'] );
	setvalue(c_wnd.t_sendtime.id,cfgdata['smtp']['send_interval'] );
	b_wnd_ex.set_disp(top, w1_page_smtp.wnd.t_pass.id, false, false);
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local ssl = b_wnd_ex.get_sel(top,w1_page_smtp.wnd.t_ssl.id);
	cfgdata['smtp']['smtp_type'] =ssl	

	local server_addr = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_server.id);
	cfgdata['smtp']['mail_server_addr'] =server_addr;
	local server_port = b_wnd_ex.get_value(top, w1_page_smtp.wnd.t_port.id);
	cfgdata['smtp']['mail_server_port'] =server_port;
	local email_addr = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_email.id)
	cfgdata['smtp']['sender_mail_addr'] =email_addr;
	local name = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_name.id)
	cfgdata['smtp']['sender_account'] =name;
	local pass = b_wnd_ex.get_password(top, w1_page_smtp.wnd.t_pass.id)
	cfgdata['smtp']['sender_password'] =pass;
	local sendtime = b_wnd_ex.get_value(top, w1_page_smtp.wnd.t_sendtime.id)
	cfgdata['smtp']['send_interval'] =sendtime;
	
	local recv_addr1 = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_recv1.id)
	local recv_addr2 = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_recv2.id)
	local recv_addr3 = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_recv3.id)
	cfgdata['smtp']['receiver1']['receiver_mail_addr'] = recv_addr1
	cfgdata['smtp']['receiver2']['receiver_mail_addr'] = recv_addr2
	cfgdata['smtp']['receiver3']['receiver_mail_addr'] = recv_addr3

	if(recv_addr1~=nil and recv_addr1~="")then
		cfgdata['smtp']['receiver1']['alarm_enable'] =1;
	else
		cfgdata['smtp']['receiver1']['alarm_enable'] =0;	
	end 
	if(recv_addr2~=nil and recv_addr2~="")then
		cfgdata['smtp']['receiver2']['alarm_enable'] =1;
	else
		cfgdata['smtp']['receiver2']['alarm_enable'] =0;
	end 

	if(recv_addr3 ~=nil and recv_addr3~="")then
		cfgdata['smtp']['receiver3']['alarm_enable'] =1;
	else
		cfgdata['smtp']['receiver3']['alarm_enable'] =0;
	end 
	
	return 0
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_page_smtp.wnd;
	local recv_addr1 = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_recv1.id)
	local recv_addr2 = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_recv2.id)
	local recv_addr3 = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_recv3.id)

	if(recv_addr1 ~=nil and recv_addr1 ~="")then
		--[[legalflag =false
		table.insert(nlegalid, cwnd.t_recv1.id)	
		w1_wnd_util.setparamerr_str(STR('LA_NOT_EMPTY'))--]]
	end 
	if(recv_addr2~=nil or recv_addr2~="")then

	end 

	if(recv_addr3 ~=nil or recv_addr3~="")then

	end 


	local server_port = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_port.id)
	local port = tonumber(server_port)
	if(port < 1 or port>65534) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_port.id)	
		w1_wnd_util.setparamerr_str(STR('LA_PORT_RANGE1'))
		
	end
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
--	return true, nil
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end
local okfunc_isempty = function(param)
	
end
local on_test = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local test_smtp = w1_page_smtp.data
		--w1_page_smtp.data
		local ssl = b_wnd_ex.get_sel(top,w1_page_smtp.wnd.t_ssl.id);
		test_smtp.smtp_type =ssl	

		local server_addr = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_server.id);
		test_smtp.mail_server_addr =server_addr;
		local server_port = b_wnd_ex.get_value(top, w1_page_smtp.wnd.t_port.id);
		test_smtp.mail_server_port =server_port;
		local email_addr = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_email.id)
		test_smtp.sender_mail_addr =email_addr;
		local name = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_name.id)
		test_smtp.sender_account =name;
		local pass = b_wnd_ex.get_password(top, w1_page_smtp.wnd.t_pass.id)
		test_smtp.sender_password =pass;
		
		local recv_addr1 = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_recv1.id)
		local recv_addr2 = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_recv2.id)
		local recv_addr3 = b_wnd_ex.get_text(top, w1_page_smtp.wnd.t_recv3.id)
		
		test_smtp.receiver1.receiver_mail_addr =recv_addr1
		test_smtp.receiver2.receiver_mail_addr =recv_addr2
		test_smtp.receiver3.receiver_mail_addr =recv_addr3
		
		
		local check_alarm1 =false;
		local check_alarm2 =false;
		local check_alarm3 =false;
		
		
		if(recv_addr1 ~= nil and recv_addr1 ~="")then
			check_alarm1 =true;
			test_smtp.receiver1.alarm_enable=1;
		else
			test_smtp.receiver1.alarm_enable=0;
		end
		if(recv_addr2 ~= nil and recv_addr2 ~="")then
			check_alarm1 =true;
			test_smtp.receiver2.alarm_enable=1;
		else
			test_smtp.receiver2.alarm_enable=0;
		end
		if(recv_addr3 ~= nil and recv_addr3 ~="")then
			check_alarm1 =true;
			test_smtp.receiver3.alarm_enable=1;
		else
			test_smtp.receiver3.alarm_enable=0;
		end
		
		local check_flag =false;
		if(check_alarm1==true or check_alarm2 ==true or check_alarm3 ==true)then
			check_flag =true;
		end

		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.check_param(top);
		w1_wnd_util.tipdispon()		--ʾ
		
		if(check_flag==false)then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_EMAIL'), true, false,false);
			w1_msgbox.set_func(okfunc_isempty,{top}, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			return 0
		end
		
		if( check_flag==true)then
			--ʾ
			
			local flag =b_app_api.test_email(test_smtp)
			if(flag ==0)then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TEST_OK'), true, false,false);
				w1_msgbox.set_func(okfunc_isempty,{top}, nil, nil);
				b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			else
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TEST_FAIL'), true, false,false);
				w1_msgbox.set_func(okfunc_isempty,{top}, nil, nil);
				b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			end
		end
	end
	
	return 0
end

w1_page_smtp.timer_start = function()
	w1_page_smtp.timestart = true
end

w1_page_smtp.timer_stop = function(top)
	w1_page_smtp.timestart = false
	w1_wnd_util.tipclear(top, w1_page_smtp.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_smtp.timerenevt = function(top)
	if(w1_page_smtp.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_smtp.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_smtp.init = function(top)
	w1_wnd_util.cfgtab = {'smtp'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_smtp.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_smtp.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_server','t_server','cap_port','t_port',
			'cap_email','t_email','cap_name','t_name','cap_pass','t_pass',
			'check_alarm4','alarm_4','check_pass4','password4',
			'cap_recv1','t_recv1','check_alarm1','alarm_1','check_pass1','password1',
			'cap_recv2','t_recv2','check_alarm2','alarm_2','check_pass2','password2',
			'cap_recv3','t_recv3','check_alarm3','alarm_3','check_pass3','password3',
			'cap_ssl','t_ssl','test','tipinfo', 'default','cap_sendtime','t_sendtime', 'apply' },
	
	cap_server 	= {t='static',id=id+1,xywh='s_smtp_cfg_page_1_1',text='LA_SMTP_IP_DNS'},
	t_server 	= {t='edit',  id=id+2,xywh='s_smtp_cfg_page_1_2',guide_text='smtp.gmail.com',guide_trans=false,max_value = 64,cmd = on_update_param},
	
	cap_port 	= {t='static',id=id+3,xywh='s_smtp_cfg_page_2_1',text='LA_SMTP_SERVER_PORT'},
	t_port 		= {t='edit_num',id=id+4,xywh='s_smtp_cfg_page_2_2',range={0,65534},cmd = on_update_param},
	
	cap_name 	= {t='static',id=id+5,xywh='s_smtp_cfg_page_3_1',text='LA_SENDER_ACCOUNT'},
	t_name 		= {t='edit',  id=id+6,xywh='s_smtp_cfg_page_3_2',guide_text='******@gmail.com',guide_trans=false,cmd = on_update_param},
	
	cap_pass 	= {t='static',id=id+7,xywh='s_smtp_cfg_page_4_1',text='LA_SENDER_PASSWORD'},
	t_pass 		= {t='password',  id=id+8,xywh='s_smtp_cfg_page_4_2',guide_text='LA_PASSWORD',cmd = on_update_param},

	cap_email 	= {t='static',id=id+10,xywh='s_smtp_cfg_page_5_1',text='LA_SENDER_EMAIL_ADDRESS'},
	t_email 	= {t='edit',  id=id+11,xywh='s_smtp_cfg_page_5_2',guide_text='******@gmail.com',guide_trans=false,max_value = 64, cmd = on_update_param},
	
	cap_recv1= {t='static',id=id+12,xywh='s_smtp_cfg_page_6_1',text='LA_ALARM_RECEIVER1'},
	t_recv1 	= {t='edit',  id=id+13,xywh='s_smtp_cfg_page_6_2',guide_text='******@gmail.com',guide_trans=false,max_value = 64,cmd = on_update_param},
	
	cap_recv2= {t='static',id=id+18,xywh='s_smtp_cfg_page_7_1',text='LA_ALARM_RECEIVER2'},
	t_recv2 	= {t='edit',  id=id+19,xywh='s_smtp_cfg_page_7_2',guide_text='******@gmail.com',guide_trans=false,max_value = 64,cmd = on_update_param},

	cap_recv3= {t='static',id=id+24,xywh='s_smtp_cfg_page_8_1',text='LA_ALARM_RECEIVER3'},
	t_recv3 	= {t='edit',  id=id+25,xywh='s_smtp_cfg_page_8_2',guide_text='******@gmail.com',guide_trans=false,max_value = 64,cmd = on_update_param},
	
	cap_ssl 	= {t='static',id=id+36,xywh='s_smtp_cfg_page_9_1',text='LA_SSL_ENABLE'},
	t_ssl 		= {t='combox',id=id+37,xywh='s_smtp_cfg_page_9_2',items={'LA_NO_ENCRYPT','LA_SSL_ENCRYPT','LA_STARTTLS_ENCRYPT'},cmd = on_update_param},
	test 		= {t='button',id=id+38,	xywh='s_smtp_test_xywh', 	text='LA_CHECK_EMAIL',cmd=on_test},				
	tipinfo		= {t='static',id=id+39,	xywh='s_smtp_tipinfo_xywh',	text='',trans = false},
	
	cap_sendtime= {t='static',id=id+40,xywh='s_smtp_cfg_page_10_1',text='LA_SEND_INTERVAL'},
	t_sendtime 	= {t='edit_num',  id=id+41,xywh='s_smtp_cfg_page_10_2',range={0,600},cmd = on_update_param},
	
	apply 		= {t='button',id=id+42,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_smtp



