--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_track.track_id
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local magnify_size = 30
local presetID_list = {};
local w1_page_track = 
{
	old_chid,
	data,
	timestart = false,
	flag, --Ƿtrackͨ
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}


w1_page_track.s_768 =
{
	s_track_t_enable_xywh = {277,67,25,21},
	s_track_t_calibration_subb_xywh = {281,113,16,21},
	s_track_t_calibration_xywh = {297,106,150,32},
	s_track_t_calibration_add_xywh = {448,113,16,21},
	s_track_t_calibration_value_xywh = {466,113,32,21},
		
	s_track_t_magnify_subb_xywh = {281,156,16,21},
	s_track_t_magnify_xywh = {297,149,150,32},
	s_track_t_magnify_add_xywh = {448,156,16,21},
	s_track_t_magnify_value_xywh = {466,156,32,21},
		
	s_track_t_duration_subb_xywh = {281,199,16,21},
	s_track_t_duration_xywh = {297,192,150,32},
	s_track_t_duration_add_xywh = {448,199,16,21},
	s_track_t_duration_value_xywh = {466,199,32,21},
	s_track_tipinfo_xywh = {53,426,373,35},
};

w1_page_track.s_1280 = 
{
	s_track_t_enable_xywh = {455,95,48,30},
	s_track_t_calibration_subb_xywh = {460,160,30,30},
	s_track_t_calibration_xywh	  = {490,150,200,45},
	s_track_t_calibration_add_xywh = {690,160,30,30},
	s_track_t_calibration_value_xywh = {725,160,60,30},	
	
	s_track_t_magnify_subb_xywh = {460,220,30,30},
	s_track_t_magnify_xywh	  = {490,210,200,45},
	s_track_t_magnify_add_xywh = {690,220,30,30},
	s_track_t_magnify_value_xywh = {725,220,60,30},	
	
	s_track_t_duration_subb_xywh = {460,280,30,30},
	s_track_t_duration_xywh	  = {490,270,200,45},
	s_track_t_duration_add_xywh = {690,280,30,30},
	s_track_t_duration_value_xywh = {725,280,60,30},	
	s_track_tipinfo_xywh = {100,750,700,50},
};

w1_page_track.s_1440 = 
{
	s_track_t_enable_xywh = {520,80,48,30},
	s_track_t_calibration_subb_xywh = {530,130,30,30},
	s_track_t_calibration_xywh = {560,125,280,40},
	s_track_t_calibration_add_xywh = {840,130,30,30},
	s_track_t_calibration_value_xywh = {875,130,60,30},	
	
	s_track_t_magnify_subb_xywh = {530,180,30,30},
	s_track_t_magnify_xywh = {560,175,280,40},
	s_track_t_magnify_add_xywh = {840,180,30,30},
	s_track_t_magnify_value_xywh = {875,180,60,30},	
	
	s_track_t_duration_subb_xywh = {530,230,30,30},
	s_track_t_duration_xywh = {560,225,280,40},
	s_track_t_duration_add_xywh = {840,230,30,30},
	s_track_t_duration_value_xywh = {875,230,60,30},	
	
	s_track_tipinfo_xywh = {100,600,700,50},
};

w1_page_track.s_1080p = 
{
	s_track_t_enable_xywh = {520,95,48,30},
	s_track_t_calibration_subb_xywh = {527,160,30,30},
	s_track_t_calibration_xywh = {557,150,282,45},
	s_track_t_calibration_add_xywh = {840,160,30,30},
	s_track_t_calibration_value_xywh = {875,160,60,30},	
	
	s_track_t_magnify_subb_xywh = {527,220,30,30},
	s_track_t_magnify_xywh = {557,210,282,45},
	s_track_t_magnify_add_xywh = {840,220,30,30},
	s_track_t_magnify_value_xywh = {875,220,60,30},	
	
	s_track_t_duration_subb_xywh = {527,280,30,30},
	s_track_t_duration_xywh = {557,270,282,45},
	s_track_t_duration_add_xywh = {840,280,30,30},
	s_track_t_duration_value_xywh = {875,280,60,30},	
	s_track_tipinfo_xywh = {100,600,700,50},

};
w1_page_track.s_2k = 
{
	s_track_t_enable_xywh = {693,127,64,40},
	s_track_t_calibration_subb_xywh = {703,213,40,40},
	s_track_t_calibration_xywh = {743,200,360,67},
	s_track_t_calibration_add_xywh = {1103,213,40,40},
	s_track_t_calibration_value_xywh ={1150,213,80,40},	
	
	s_track_t_magnify_subb_xywh = {703,293,40,40},
	s_track_t_magnify_xywh = {743,280,360,67},
	s_track_t_magnify_add_xywh = {1103,293,40,40},
	s_track_t_magnify_value_xywh ={1150,293,80,40},	
	
	s_track_t_duration_subb_xywh = {703,373,40,40},
	s_track_t_duration_xywh = {743,360,360,67},
	s_track_t_duration_add_xywh = {1103,373,40,40},
	s_track_t_duration_value_xywh ={1150,373,80,40},
	s_track_tipinfo_xywh = {133,800,933,67},

};
w1_page_track.s_4k = 
{
	s_track_t_enable_xywh = {1040,190,96,60},
	s_track_t_calibration_subb_xywh 	= {1055,320,60,60},
	s_track_t_calibration_xywh 	= {1114,300,564,90},
	s_track_t_calibration_add_xywh 	= {1680,320,60,60},
	s_track_t_calibration_value_xywh = {1750,320,120,60},	
	
	s_track_t_magnify_subb_xywh 	= {1055,440,60,60},
	s_track_t_magnify_xywh 	= {1114,420,564,90},
	s_track_t_magnify_add_xywh 	= {1680,440,60,60},
	s_track_t_magnify_value_xywh = {1750,440,120,60},	
	
	s_track_t_duration_subb_xywh 	= {1055,560,60,60},
	s_track_t_duration_xywh 	= {1114,540,564,90},
	s_track_t_duration_add_xywh 	= {1680,560,60,60},
	s_track_t_duration_value_xywh = {1750,560,120,60},
	s_track_tipinfo_xywh = {200,1200,1400,100},
};

local channel_num;--豸ͨĿ

w1_page_track.clear_data = function()
	w1_page_track.data = nil;
end	

local refresh_chdata = function(top, chid, redraw)
	local chn = "channel"..chid;
	local cwnd =w1_page_track.wnd
	local track = w1_page_track.data.track
	magnify_size = math.floor(track[chn]['magnify_size']/1000)
	b_wnd_ex.set_range(top,cwnd.t_magnify.id,{1,magnify_size},false)
	b_wnd_ex.set_text(top,cwnd.calibration_value.id,track[chn]['calibration'],false)
	b_wnd_ex.set_text(top,cwnd.duration_value.id,track[chn]['duration'],false)
	b_wnd_ex.set_text(top,cwnd.magnify_value.id,track[chn]['magnify'],false)
	b_wnd_ex.set_value(top,cwnd.t_calibration.id,track[chn]['calibration'],false)
	b_wnd_ex.set_value(top,cwnd.t_duration.id,track[chn]['duration'],false)
	b_wnd_ex.set_value(top,cwnd.t_magnify.id,track[chn]['magnify'],false)
	b_wnd_ex.set_check(top,cwnd.t_enable.id,track[chn]['enable'],false)
	
	local cfg_tab = {'ptz_limits'}
	preset = b_app_api.get_cfg(cfg_tab)
	local chidstr = b_wnd_ex.get_text(top, cwnd.t_channel.id);
	
	local chn = "channel"..tostring(math.floor(chidstr));
	local preset_data = preset['ptz_limits'][chn];
	local max_preset_num = 255;
	local preset_list = {};
	local preset_num = 0;
	presetID_list = {};
	table.insert(preset_list,STR('LA_NONE'));
	for i=1,max_preset_num  do
		local str;
		for k = 1, preset_data.preset_num do
			if (i == preset_data.presets["idx"..k].preset_id) then
				str = string.format("%s", preset_data.presets["idx"..k].preset_name)
				table.insert(preset_list,str)
				table.insert(presetID_list,preset_data.presets["idx"..k].preset_id)
				preset_num = preset_num + 1;
			end
		end
	end
	b_wnd_ex.set_items(top,cwnd.start_point.id,preset_list,false)
	
	local presetID = track[chn]['start_point'];
	if(preset_num == 0 or presetID == 0) then
		b_wnd_ex.set_sel(top,cwnd.start_point.id,0,false)
	else
		for i=1,preset_num  do
			if(presetID == presetID_list[i]) then
				b_wnd_ex.set_sel(top,cwnd.start_point.id,i,false)
				ishad = true;
			end
		end
	end
	
	local tracktype = track[chn]['track_type'] - 1
	b_wnd_ex.set_sel(top,cwnd.track_type.id,tracktype,false)
	
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

local sethide =function(top, bool_hide, redraw)
	local cwnd = w1_page_track.wnd;
	local sid = cwnd.cap_enable.id;
	local eid = cwnd.track_type.id;
	
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	w1_page_track.data = cfgdata;
	local data = cfgdata.track;
	local c_wnd = w1_page_track.wnd;
	local camreaitems = {};

	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	for i=1, channel_num do
		if(data['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	if(idx ~= 1) then--˵ڷͨ
		sethide(top,false,false);
		b_wnd_ex.set_disable(top, c_wnd.t_channel.id, false, false);
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, 0, false);--Ĭϵһ
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		refresh_chdata(top, chid, false);
	else
		sethide(top,true,false);
		b_wnd_ex.set_disable(top, c_wnd.t_channel.id, true, false);
	end
	
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd=w1_page_track.wnd
	local check = b_wnd_ex.get_check(top,cwnd.t_enable.id)
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	local chn = "channel"..chid;
	cfgdata['track'][chn]['enable']=check
	cfgdata['track'][chn]['magnify']=b_wnd_ex.get_value(top,cwnd.t_magnify.id)
	cfgdata['track'][chn]['duration']=b_wnd_ex.get_value(top,cwnd.t_duration.id)
	cfgdata['track'][chn]['calibration']=b_wnd_ex.get_value(top,cwnd.t_calibration.id)
	cfgdata['track'][chn]['track_type']=b_wnd_ex.get_sel(top,cwnd.track_type.id) + 1
	cfgdata['track'][chn]['channel']=chid
	local sel = b_wnd_ex.get_sel(top,cwnd.start_point.id)
	if(sel == 0) then
		cfgdata['track'][chn]['start_point'] = 0;
	else
		cfgdata['track'][chn]['start_point'] = presetID_list[sel];
	end
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	
	
	return true,nil
end

w1_page_track.timer_start = function()
	w1_page_track.timestart = true
end

w1_page_track.timer_stop = function(top)
	w1_page_track.timestart = false
	w1_wnd_util.tipclear(top, w1_page_track.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_track.timerenevt = function(top)
	if(w1_page_track.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_track.wnd.tipinfo.id)
	end
	return 0
end

w1_page_track.init = function(top)
	w1_wnd_util.cfgtab = {'track'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	local chidstr = b_wnd_ex.get_text(top, w1_page_track.wnd.t_channel.id);
	if(chidstr == '') then
		return 0
	end
	local chid =tonumber(chidstr);
	w1_page_track.old_chid = chid;
	return 0
end

local on_channel= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_track.wnd.t_channel.id));
		refresh_chdata(top, chid, true)
		w1_page_track.old_chid = chid;
	end
	return 0;
end

local on_enable = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_update_param = function(top, id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		uitousercfg(top,b_app_cfg.user_cfg);
	elseif (vmsg == b_ui.RBUTTONCLK) then
		return vmsg;
	end
	return 0;
end


local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local c_wnd = w1_page_track.wnd;
		local value = b_wnd_ex.get_value(top, win_id-1);
		local max_value = 30
		if win_id==c_wnd.duration_add.id then
			max_value=300
		elseif win_id == c_wnd.magnify_add.id then
			max_value = magnify_size
		end
		if(value < max_value) then
			value = value + 1;
			b_wnd_ex.set_value(top, win_id-1, value, false)
			b_wnd_ex.set_text(top, win_id+1, tostring(value), false);
			uitousercfg(top,b_app_cfg.user_cfg);
			b_dlg.dlg_set_redraw(top);
		end
	end

	return 0;
end	

local on_sub = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local value = b_wnd_ex.get_value(top, win_id+1);
		if(value > 1) then
			value = value - 1;
			b_wnd_ex.set_value(top, win_id+1, value, false)
			b_wnd_ex.set_text(top, win_id+3, tostring(value), false);
			uitousercfg(top,b_app_cfg.user_cfg);
			b_dlg.dlg_set_redraw(top);
		end
	end

	return 0;
end	

local on_cfg_change = function(top, win_id, vmsg, x, y)
	if ((b_ui.LBUTTONCLK == vmsg) or (b_ui.WM_USER_UPDATE_PARAM == vmsg)) then
		uitousercfg(top,b_app_cfg.user_cfg);
		local value = b_wnd_ex.get_value(top, win_id);	
		b_wnd_ex.set_text(top, win_id+2, tostring(value), true);
	end
	return 0
end

local on_combox_change = function(top, win_id, vmsg, x, y)
	if ((b_ui.LBUTTONCLK == vmsg) or (b_ui.WM_USER_UPDATE_PARAM == vmsg)) then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_track.apply =function(top)
	local ret = nil; 
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	return ret
end

w1_page_track.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();

end

w1_page_track.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'cap_channel', 't_channel','cap_enable', 't_enable',
			'cap_calibration', 'calibration_subb','t_calibration', 'calibration_add','calibration_value','cap_magnify',
			'magnify_subb','t_magnify','tipinfo', 'magnify_add', 'apply','magnify_value','cap_duration','duration_subb',
			't_duration','duration_add','duration_value', 'cap_start_point', 'start_point', 'cap_track_type', 'track_type'},

	
	cap_channel	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',		text='LA_CHANNEL'},
	t_channel 	= {t='combox',	id=id+2,	xywh='s_cfg_page_1_2',		items={'1','2','3','4','5','6','7','8'},trans = false,channel_cbox = true,cmd = on_channel},	
	
	cap_enable	= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',		text='LA_INTELLIGENT_TRACK'},
	t_enable	= {t='tt_check',id=id+4,	xywh='s_track_t_enable_xywh', cmd = on_enable,		
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					},
	cap_calibration	= {t='static',id=id+5,	xywh='s_cfg_page_3_1',text='LA_CALIBRATION_COEFFICIENT',},
	calibration_subb	= {t='button',id=id+6,	xywh='s_track_t_calibration_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_sub},
	t_calibration	= {t='hslider',id=id+7,xywh='s_track_t_calibration_xywh',range={1,30},	
					font = 'f_slider', cmd=on_cfg_change},
	calibration_add	= {t='button',id=id+8,	xywh='s_track_t_calibration_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	calibration_value= {t='static',id=id+9,	xywh='s_track_t_calibration_value_xywh',trans = false},
	
	cap_magnify	= {t='static',id=id+10,	xywh='s_cfg_page_4_1',text='LA_TRACE_MAGNIFY',},
	magnify_subb	= {t='button',id=id+11,	xywh='s_track_t_magnify_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_sub},
	t_magnify	= {t='hslider',id=id+12,xywh='s_track_t_magnify_xywh',	range={1,30},
					font = 'f_slider', cmd=on_cfg_change},
	magnify_add	= {t='button',id=id+13,	xywh='s_track_t_magnify_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	magnify_value= {t='static',id=id+14,	xywh='s_track_t_magnify_value_xywh',trans = false},
	
	cap_duration	= {t='static',id=id+15,	xywh='s_cfg_page_5_1',text='LA_TRACK_DURATION',},
	duration_subb	= {t='button',id=id+16,	xywh='s_track_t_duration_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_sub},
	t_duration	= {t='hslider',id=id+17,xywh='s_track_t_duration_xywh',	range={1,300},	
					font = 'f_slider', cmd=on_cfg_change},
	duration_add	= {t='button',id=id+18,	xywh='s_track_t_duration_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	duration_value = {t='static',id=id+19,	xywh='s_track_t_duration_value_xywh',trans = false},
	
	cap_start_point = {t='static',id=id+20,xywh='s_cfg_page_6_1',text='LA_START_POINT'},
	start_point 	= {t='combox',id=id+21,xywh='s_cfg_page_6_2',items = {},
					font = 'f_grade4',cmd = on_combox_change},
					
	cap_track_type = {t='static',id=id+22,xywh='s_cfg_page_7_1',text='LA_TRACKING_TYPE'},
	track_type 	   = {t='combox',id=id+23,xywh='s_cfg_page_7_2',items = {'LA_PERSON', 'LA_CAR', 'LA_PERSON_OR_CAR'},
					font = 'f_grade4',cmd = on_combox_change},

	tipinfo		= {t='static',	id=id+24,	xywh='s_track_tipinfo_xywh',		text='',		trans = false},	
	apply 		= {t='button',	id=id+25,	xywh= 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_track

