-- UIʹõȷȡԻ
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_devm.resetid;
local cjson 		= require("cjson")
local util 		= require("wnd.core.util")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

-- 

local w1_reset = {
	t = w1_key.DLG_MSG_RESET,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_reset.s_768 =
{
	s_reset_xywh = {338,284,346,206},
	s_reset_title_xywh = {1,1,345,35},
	s_reset_title_close_xywh = {318,3,21,28},
	s_reset_check_reset1_xywh = {26,28,26,35},
	s_reset_cap_reset1_xywh = {53,28,266,35},
	s_reset_check_reset2_xywh = {26,64,26,35},
	s_reset_cap_reset2_xywh = {53,64,266,35},
	s_reset_check_reset3_xywh = {26,99,26,35},
	s_reset_cap_reset3_xywh = {53,99,266,35},
	s_reset_ok_xywh = {197,156,64,27},
	s_reset_cancel_xywh = {272,156,64,27},
	s_reset_okcancel_xywh = {272,156,64,27},
};

w1_reset.s_1280 = 
{
	s_reset_xywh={315,395,650,290},
	s_reset_title_xywh={1,1,648,50},
	s_reset_title_close_xywh = {598, 5, 40, 40},
	s_reset_check_reset1_xywh ={50,40,50,50},
	s_reset_cap_reset1_xywh ={100,40,500,50},
	s_reset_check_reset2_xywh ={50,90,50,50},
	s_reset_cap_reset2_xywh ={100,90,500,50},
	s_reset_check_reset3_xywh ={50,140,50,50},
	s_reset_cap_reset3_xywh ={100,140,500,50},
	s_reset_ok_xywh={370,220,120,38},
	s_reset_cancel_xywh={510,220,120,38},	
	s_reset_okcancel_xywh={510,220,120,38},
};
w1_reset.s_1440 = 
{
	s_reset_xywh={395,305,650,290},
	s_reset_title_xywh={1,1,648,50},
	s_reset_title_close_xywh = {598, 5, 40, 40},
	s_reset_check_reset1_xywh ={50,40,50,50},
	s_reset_cap_reset1_xywh ={100,40,500,50},
	s_reset_check_reset2_xywh ={50,90,50,50},
	s_reset_cap_reset2_xywh ={100,90,500,50},
	s_reset_check_reset3_xywh ={50,140,50,50},
	s_reset_cap_reset3_xywh ={100,140,500,50},
	s_reset_ok_xywh={370,220,120,38},
	s_reset_cancel_xywh={510,220,120,38},	
	s_reset_okcancel_xywh={510,220,120,38},
};
w1_reset.s_1080p = 
{
	s_reset_xywh={635,400,650,290},
	s_reset_title_xywh={1,1,648,50},
	s_reset_title_close_xywh = {598, 5, 40, 40},
	s_reset_check_reset1_xywh ={50,40,50,50},
	s_reset_cap_reset1_xywh ={100,40,500,50},
	s_reset_check_reset2_xywh ={50,90,50,50},
	s_reset_cap_reset2_xywh ={100,90,500,50},
	s_reset_check_reset3_xywh ={50,140,50,50},
	s_reset_cap_reset3_xywh ={100,140,500,50},
	s_reset_ok_xywh={370,220,120,38},
	s_reset_cancel_xywh={510,220,120,38},	
	s_reset_okcancel_xywh={510,220,120,38},
};
w1_reset.s_2k = 
{
	s_reset_xywh={846,533,866,387},
	s_reset_title_xywh={1,1,864,67},
	s_reset_title_close_xywh = {797,7,53,53},
	s_reset_check_reset1_xywh ={67,53,67,67},
	s_reset_cap_reset1_xywh ={133,53,667,67},
	s_reset_check_reset2_xywh ={67,120,67,67},
	s_reset_cap_reset2_xywh ={133,120,667,67},
	s_reset_check_reset3_xywh ={67,187,67,67},
	s_reset_cap_reset3_xywh ={133,187,667,67},
	s_reset_ok_xywh={493,293,160,51},
	s_reset_cancel_xywh={680,293,160,51},
	s_reset_okcancel_xywh={680,293,160,51},
};
w1_reset.s_4k = 
{
	s_reset_xywh={1270,800,1300,580},
	s_reset_title_xywh={2,2,1296,100},
	s_reset_title_close_xywh = {1196,10,80,80},
	s_reset_check_reset1_xywh ={100,80,100,100},
	s_reset_cap_reset1_xywh ={200,80,1000,100},
	s_reset_check_reset2_xywh ={100,180,100,100},
	s_reset_cap_reset2_xywh ={200,180,1000,100},
	s_reset_check_reset3_xywh ={100,280,100,100},
	s_reset_cap_reset3_xywh ={200,280,1000,100},
	s_reset_ok_xywh={740,440,240,76},
	s_reset_cancel_xywh={1020,440,240,76},
	s_reset_okcancel_xywh={1020,440,240,76},

	
};


w1_reset.ok_btn_str = '';			--ȷťַ
w1_reset.cancel_btn_str = '';		--ȡťַ
w1_reset.titlestr = '';			--ַ
w1_reset.msgstr = '';				--ʾַ
w1_reset.ok_disp = true;			--okťʾ־λ
w1_reset.cancel_disp = true;		--cancelťʾ־λ
w1_reset.close_disp = true;		--closeťʾ־λ
w1_reset.ok_func = nil;			--okťص
w1_reset.okfunc_param = nil;		--okťص
w1_reset.cannel_func = nil;		--cancelťص
w1_reset.cannelfunc_param = nil;	--cannelťص
w1_reset.attach_attr_state = false;--״̬ false  true ׼
local attach_str = '';				--ʹ ťر ٴʾ ϶ʱʹ


--ÿؼ Ӧok¼ر µʾȵ
w1_reset.set_attach_dlgattr = function(msgstr)
	w1_reset.attach_attr_state = true;
	attach_str = msgstr;
end	

w1_reset.set_dlgattr = function(titlestr, msgstr, ok_disp, cancel_disp,close_disp, ok_str, cancel_str)
	assert(titlestr ~= nil and type(titlestr) == 'string')
	assert(msgstr ~= nil and type(msgstr) == 'string')
	assert(ok_disp ~= nil and type(ok_disp) == 'boolean')
	assert(cancel_disp ~= nil and type(cancel_disp) == 'boolean')

	w1_reset.msgstr = msgstr;
	w1_reset.ok_disp = ok_disp;
	w1_reset.cancel_disp = cancel_disp;
	w1_reset.close_disp = close_disp;
	if (nil ~= ok_str) then
		w1_reset.ok_btn_str = ok_str
	else
		w1_reset.ok_btn_str = STR('LA_OK')	
	end
	
	if (nil ~= cancel_str) then
		w1_reset.cancel_btn_str = cancel_str
	else
		w1_reset.cancel_btn_str = STR('LA_CANCEL')	
	end
end 

w1_reset.set_func  = function(ok_func, okfunc_param, cannel_func, cancelfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')
	assert(cannel_func == nil or type(cannel_func) == 'function')
	assert(cancelfunc_param == nil or type(cancelfunc_param) == 'table')
	
	w1_reset.ok_func = ok_func;
	w1_reset.cannel_func = cannel_func;

	if (w1_reset.okfunc_param  ==  nil) then
		w1_reset.okfunc_param = okfunc_param;
	else
		if(okfunc_param == nil) then
			w1_reset.okfunc_param = nil;
		elseif(type(okfunc_param) == 'table') then
			util.copy_tab_b(w1_reset.okfunc_param, okfunc_param);		
		end
	end
	
	if (w1_reset.cannelfunc_param  ==  nil) then
		w1_reset.cannelfunc_param = cancelfunc_param;
	else
		if(cancelfunc_param == nil) then
			w1_reset.cannelfunc_param = nil;
		elseif(type(okfunc_param) == 'table') then
			util.copy_tab_b(w1_reset.cannelfunc_param, cancelfunc_param);		
		end	
	end
end

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local ret = nil;
		if (true == w1_reset.attach_attr_state) then
			b_wnd_ex.set_hide(top, w1_reset.dlg.ok.id, true, false)
			b_wnd_ex.set_hide(top, w1_reset.dlg.cancel.id, true, false)
			b_dlg.dlg_set_redraw(top);
			return b_ui.WM_USER_reset_RUN;
		else	
			if(w1_reset.ok_func ~= nil) then
				ret = w1_reset.ok_func(w1_reset.okfunc_param);
			end	

			b_dlg.end_modal(top);
			
			if(b_ui.WM_USER_CHANGE_RESOLUTION == ret)then
				return b_ui.WM_USER_CHANGE_RESOLUTION;
			end
		end
	end
	return 0
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(w1_reset.cannel_func ~= nil) then
			w1_reset.cannel_func(w1_reset.cannelfunc_param);
		end
		b_dlg.end_modal(top);
	end
	return 0
end

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	
	return 0;
end

local on_check_reset1 = function(top, id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_wnd_ex.set_check(top, id, true, false)
		b_wnd_ex.set_check(top, w1_reset.dlg.check_reset2.id, false, false)
		b_wnd_ex.set_check(top, w1_reset.dlg.check_reset3.id, false, false)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_check_reset2 = function(top, id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_wnd_ex.set_check(top, id, true, false)
		b_wnd_ex.set_check(top, w1_reset.dlg.check_reset1.id, false, false)
		b_wnd_ex.set_check(top, w1_reset.dlg.check_reset3.id, false, false)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_check_reset3 = function(top, id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_wnd_ex.set_check(top, id, true, false)
		b_wnd_ex.set_check(top, w1_reset.dlg.check_reset1.id, false, false)
		b_wnd_ex.set_check(top, w1_reset.dlg.check_reset2.id, false, false)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

w1_reset.get_data_info = function ()
	local check_reset1  =b_wnd_ex.get_check(w1_reset.top, w1_reset.dlg.check_reset1.id);	
	local check_reset2  =b_wnd_ex.get_check(w1_reset.top, w1_reset.dlg.check_reset2.id);
	local check_reset3  =b_wnd_ex.get_check(w1_reset.top, w1_reset.dlg.check_reset3.id);		
	
	local reset_flag = 0;
	local abnormal = 0;
	if(check_reset1)then
		abnormal = abnormal +1;
		reset_flag = 2;
	end
	if(check_reset2)then
		abnormal = abnormal +1;
		reset_flag = 1;
	end
	if(check_reset3)then
		abnormal = abnormal +1;
		reset_flag = 3;
	end
	if(1 ~= abnormal)then
		print("check_reset1:"..check_reset1.."check_reset2:"..check_reset1.."check_reset3:"..check_reset3)
	end
	return reset_flag;
end 

local dlg = {
	attr 	= {xywh='s_reset_xywh'},
	sub 	= {'titleclose', --[['msg',--]] 'check_reset1', 'cap_reset1', 'check_reset2', 'cap_reset2','check_reset3', 'cap_reset3', 'ok', 'cancel'},
	
	titleclose 	= {t='tt_button',id=id+2,xywh = 's_reset_title_close_xywh',
		t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
		color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_txt_f'},
		color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_cfgclose_bk'},
		cmd=on_close},

	--[[msg	 	= {t='static',	id=id+3,	xywh='s_reset_msg_xywh',	
			text='',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},--]]
			
	check_reset1 	= {t='tt_check', 	id=id+4,xywh='s_reset_check_reset1_xywh',
			t_imgs = {b_ui.ALIGN.LEFT,'f_signalimg', 'it_singnal_false','it_singnal_true', 'it_singnal_false'},
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
				color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_popdlg_text'},
					cmd = on_check_reset1},
					
	cap_reset1 = {t='static',id=id+5,xywh='s_reset_cap_reset1_xywh',text='LA_KEEP_IP',font = 'f_image',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
				color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_popdlg_text'},
					},	
					
	check_reset2 	= {t='tt_check', 	id=id+6,xywh='s_reset_check_reset2_xywh',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
			color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_popdlg_text'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_signalimg', 'it_singnal_false','it_singnal_true', 'it_singnal_false'},
					cmd = on_check_reset2},
					
	cap_reset2 = {t='static',id=id+7,xywh='s_reset_cap_reset2_xywh',text='LA_RESTORE_CFG',font = 'f_image',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
				color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_popdlg_text'},
					},	
	check_reset3 = {t='tt_check', 	id=id+8,xywh='s_reset_check_reset3_xywh',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
			color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_popdlg_text'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_signalimg', 'it_singnal_false','it_singnal_true', 'it_singnal_false'},
					cmd = on_check_reset3},
					
	cap_reset3 = {t='static',id=id+9,xywh='s_reset_cap_reset3_xywh',text='LA_RESTORE_ALL',font = 'f_image',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
				color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_popdlg_text'},
					},	
			
	ok		= {t='button',	id=id+10,	xywh='s_reset_ok_xywh',	text='LA_OK',		cmd=on_ok,
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},},
				
	cancel	= {t='button',	id=id+11,	xywh='s_reset_cancel_xywh',text='LA_CANCEL',	cmd=on_cancel,
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
				},			
}

w1_reset.on_create = function(top)
	w1_reset.top = top
	w1_reset.dlg = dlg
	b_parser(top, w1_reset.dlg)
	return 0
end

w1_reset.on_destroy = function(top)
	w1_reset.top = nil
	w1_reset.dlg = nil
	w1_reset.okfunc_param = nil
	w1_reset.cannelfunc_param = nil
	w1_reset.attach_attr_state = false;

	return 0
end

w1_reset.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top)	
	if(param ~= nil)then
		local paramdata = cjson.decode(param)
		if(paramdata.opera2_del ~= nil) then
			w1_reset.ok_disp = true;			--okťʾ־λ
			w1_reset.cancel_disp = true;		--cancelťʾ־λ
			w1_reset.close_disp = true;
			local temp = {top,paramdata.opera2_del};		--okťص	
			if (w1_reset.okfunc_param == nil) then
				w1_reset.okfunc_param = temp
			else
				util.copy_tab_b(w1_reset.okfunc_param, temp);	
			end
			w1_reset.cannel_func = nil;		--cancelťص
			w1_reset.cannelfunc_param = nil;	--cannelťص
			w1_reset.w1_reset.ok_btn_str = STR('LA_OK');
			w1_reset.cancel_btn_str = STR('LA_CANCEL');	
			
		end
	end
	
	b_wnd_ex.set_text(top,  w1_reset.dlg.ok.id, 	w1_reset.ok_btn_str, false);
	b_wnd_ex.set_text(top, w1_reset.dlg.cancel.id,	w1_reset.cancel_btn_str, false);
	
	if (w1_reset.close_disp == false) then
		b_wnd_ex.set_hide(top, w1_reset.dlg.titleclose.id, true, false)
	end
	
	if(w1_reset.ok_disp == false and w1_reset.cancel_disp == false) then
		b_wnd_ex.set_hide(top, w1_reset.dlg.ok.id, true, false)
		b_wnd_ex.set_hide(top, w1_reset.dlg.cancel.id, true, false)
	elseif(w1_reset.ok_disp == true and w1_reset.cancel_disp == false) then
		b_wnd_ex.set_hide(top, w1_reset.dlg.cancel.id, true, false)
		b_wnd_ex.move_ex(top, w1_reset.dlg.ok.id, SIZE('s_reset_okcancel_xywh'), false);
	elseif(w1_reset.ok_disp == false and w1_reset.cancel_disp == true) then
		b_wnd_ex.set_hide(top, w1_reset.dlg.ok.id, true, false)
		b_wnd_ex.move_ex(top, w1_reset.dlg.cancel.id, SIZE('s_reset_okcancel_xywh'), false);
	end
	
	b_wnd_ex.set_check(top, w1_reset.dlg.check_reset1.id, false, false)
	b_wnd_ex.set_check(top, w1_reset.dlg.check_reset2.id, true, false)
	b_wnd_ex.set_check(top, w1_reset.dlg.check_reset3.id, false, false)
	return 0
end

w1_reset.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	
	b_wnd.end_job(top)
	return 0
end

w1_reset.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
	local pos = SIZE('s_reset_xywh');
	if x < pos[1] or x > pos[1] + pos[3] or y < pos[2] or y > pos [2] + pos[4] then
	--	b_dlg.end_modal(top);
	end

	elseif(b_ui.WM_USER_CHANGE_RESOLUTION == vmsg)then
		return b_ui.WM_USER_CHANGE_RESOLUTION;
	elseif(b_ui.WM_USER_MSGBOX_RUN == vmsg) then
			return vmsg
	elseif(b_ui.WM_USER_MSGBOX_RUN_START == vmsg) then		
		w1_reset.attach_attr_state = false;
		if(w1_reset.ok_func ~= nil) then
			w1_reset.ok_func(w1_reset.okfunc_param);
		end	
		b_dlg.end_modal(top);
	elseif(b_ui.RBUTTONCLK == vmsg)then
		if(w1_reset.cannel_func ~= nil) then
			w1_reset.cannel_func(w1_reset.cannelfunc_param);
		end
		b_dlg.end_modal(top);
	end
	return 0
end

return w1_reset




