--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_app.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")

local w1_row_app = {}

local on_app = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_app.wnd, win_id, true)
	end
	return 0
end

w1_row_app.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'app','hline'},

	app 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_x1',
				text='LA_APP',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_app,check = true},
	hline 	= {t='hline',	id=id+2,xywh='s_cfg_row_hline'}		
}

return w1_row_app
