--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_alarmout.flashrow_alarm_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")

local w1_row_flashrow = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_flashrow.s_768 =
{
	s_row_flashrow_xywh = {0,117,533,57},
	s_row_flashrow_timeplan_xywh = {53,0,160,39},
};

w1_row_flashrow.s_1280 = 
{
	s_row_flashrow_xywh = {0,165,1000,81},
	s_row_flashrow_timeplan_xywh = {100,0,300,55},
};

w1_row_flashrow.s_1440 = 
{
	s_row_flashrow_xywh = {0,145,1000,81},
	s_row_flashrow_timeplan_xywh = {100,0,300,55},
};

w1_row_flashrow.s_1080p = 
{
	s_row_flashrow_xywh = {0,165,1000,81},
	s_row_flashrow_timeplan_xywh = {100,0,300,55},
};

w1_row_flashrow.s_2k = 
{
	s_row_flashrow_xywh = {0,220,1333,108},
	s_row_flashrow_timeplan_xywh = {133,0,400,73},

};

w1_row_flashrow.s_4k = 
{
	s_row_flashrow_xywh = {0,330,2000,162},
	s_row_flashrow_timeplan_xywh = {200,0,600,110},
};

w1_row_flashrow.changecheck = function(top, wnd, id, redraw)
	return 0;
end

w1_row_flashrow.get_checkidx = function(top)
	return 0;
end

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_row_flashrow.changecheck(top, w1_row_flashrow.wnd, win_id, true);
	end
	
	return 0
end

w1_row_flashrow.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_row_flashrow_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'timeplan','hline1'},

	timeplan 	= {t='checkbutton',	id=id+1,xywh = 's_row_flashrow_timeplan_xywh',	text='LA_DETECTION_SCHEDULE',			
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',check = true,	
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan','it_timeplan', 'it_timeplan'},
				cmd=on_click},	
	hline1 		= {t='hline',id=id+2,	xywh='s_cfg_lline1'},
}

return w1_row_flashrow
