local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_ftp.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")

local w1_row_ftp = {}

local on_bad_detection = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_ftp.wnd, win_id, true)
	end
	return 0
end

w1_row_ftp.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'bad_detection', 'hline'},

	bad_detection = {t='checktxt',	id=id+1,xywh='s_cfg_row_x1',
					text='LA_FTP',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
					cmd=on_bad_detection,check = true},
	hline 	= {t='hline',	id=id+2,xywh='s_cfg_row_hline'}
}

return w1_row_ftp