--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_noopsyche.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local util 			= require("wnd.core.util")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_page_advance		= require("wnd.w1_cfg.w1_page_noopsyche_advance");
local w1_page_badsignal		= require("wnd.w1_cfg.w1_page_noopsyche_badsignal");
local w1_page_cordon		= require("wnd.w1_cfg.w1_page_noopsyche_cordon");
local w1_page_dcordon		= require("wnd.w1_cfg.w1_page_noopsyche_dcordon");
local w1_page_perimeter		= require("wnd.w1_cfg.w1_page_noopsyche_perimeter");
local w1_page_objectleft	= require("wnd.w1_cfg.w1_page_noopsyche_objectleft");
local w1_page_abnormal_speed	= require("wnd.w1_cfg.w1_page_noopsyche_abnormal_speed");
local w1_page_objectremove		= require("wnd.w1_cfg.w1_page_noopsyche_objectremove");
local w1_page_illegalpacking	= require("wnd.w1_cfg.w1_page_noopsyche_illegal_packing");
local w1_page_person_count	= require("wnd.w1_cfg.w1_page_noopsyche_person_count");
local w1_page_converse			= require("wnd.w1_cfg.w1_page_noopsyche_converse");
local w1_page_loiter		= require("wnd.w1_cfg.w1_page_noopsyche_loiter");
local w1_page_multiloiter	= require("wnd.w1_cfg.w1_page_noopsyche_multiloiter");
local w1_page_fence			= require("wnd.w1_cfg.w1_page_noopsyche_fence");
local w1_select_intelligent_type = require("wnd.w1_cfg.w1_select_intelligent_type") 
local w1_page_enter_area		= require("wnd.w1_cfg.w1_page_noopsyche_enter_area");
local w1_page_leave_area		= require("wnd.w1_cfg.w1_page_noopsyche_leave_area");

local last_page = 1;

local w1_row_noopsyche = {
	item_width = nil,			--
	select_item_idx = 0, 		--չťѡеԪ
	dsp_item_s_id,				--ǰʾԪʼ
	dsp_item_e_id,				--ǰʾԪؽ
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,	
}

w1_row_noopsyche.s_768 =
{
	w1_row_noopsyche_total_width_xywh = {0,0,752,0},
	w1_row_noopsyche_item_space_xywh = {0,0,26,0},
	w1_row_noopsyche_exp_btn_xywh = {784,28,21,21},
};

w1_row_noopsyche.s_1280 = 
{
	w1_row_noopsyche_total_width_xywh = {0, 0, 860, 0},
	w1_row_noopsyche_item_space_xywh = {0, 0, 50, 0},
	w1_row_noopsyche_exp_btn_xywh = {920, 45, 40, 30},
};

w1_row_noopsyche.s_1440 = 
{
	w1_row_noopsyche_total_width_xywh = {0, 0, 985, 0},
	w1_row_noopsyche_item_space_xywh = {0, 0, 40, 0},
	w1_row_noopsyche_exp_btn_xywh = {1045, 40, 40, 30},
};

w1_row_noopsyche.s_1080p = 
{
	w1_row_noopsyche_total_width_xywh = {0, 0, 1410, 0},
	w1_row_noopsyche_item_space_xywh = {0, 0, 50, 0},
	w1_row_noopsyche_exp_btn_xywh = {1470, 40, 40, 30},
};

w1_row_noopsyche.s_2k = 
{
	w1_row_noopsyche_total_width_xywh = {0,0,1880,0},
	w1_row_noopsyche_item_space_xywh = {0,0,66,0},
	w1_row_noopsyche_exp_btn_xywh = {1960,53,53,40},
};

w1_row_noopsyche.s_4k = 
{
	w1_row_noopsyche_total_width_xywh = {0, 0, 2820, 0},
	w1_row_noopsyche_item_space_xywh = {0, 0, 100, 0},
	w1_row_noopsyche_exp_btn_xywh = {2940, 80, 80, 60},
};

w1_row_noopsyche.clear_data = function()
	w1_row_noopsyche.item_width = nil;			
	w1_row_noopsyche.select_item_idx = 0; 		
	w1_row_noopsyche.dsp_item_s_id = 0;				
	w1_row_noopsyche.dsp_item_e_id = 0;				
end

local move_item_position = function(top, s_id, e_id, redraw)
	--ȫ	
	for i = id + 1, id + 16 do
		b_wnd_ex.set_hide(top, i, true, false);
	end
	
	local space = SIZE('w1_row_noopsyche_item_space_xywh')[3]
	local pos = SIZE('s_cfg_row_1');
	local x = pos[1];
	local y = pos[2];
	local w = pos[3];
	local h = pos[4];
	local idx = 1;
	for i = s_id, e_id do
		idx = i - id;
		if (i > s_id) then
			x = x + w1_row_noopsyche.item_width[idx - 1] + space; 
		end	
		w = w1_row_noopsyche.item_width[idx];
		b_wnd_ex.set_hide(top, i, false, false);
		b_wnd_ex.move_ex(top, i, {x, y, w, h}, false);
	end
	
	if redraw == true then
		b_dlg.dlg_set_redraw(top);
	end
end

local get_channel = function()
	if last_page == 1 then
		return w1_page_perimeter.get_channel();
	elseif last_page == 2 then
		return w1_page_cordon.get_channel();
	elseif last_page == 3 then
		return w1_page_dcordon.get_channel();
	elseif last_page == 4 then
		return w1_page_objectleft.get_channel();
	elseif last_page == 5 then
		return w1_page_objectremove.get_channel();
	elseif last_page == 6 then
		return w1_page_badsignal.get_channel();	
	elseif last_page == 7 then
		return w1_page_loiter.get_channel();
	elseif last_page == 8 then
		return w1_page_multiloiter.get_channel();
	elseif last_page == 9 then
		return w1_page_abnormal_speed.get_channel();
	elseif last_page == 10 then
		return w1_page_converse.get_channel();
	elseif last_page == 11 then
		return w1_page_illegalpacking.get_channel();
	elseif last_page == 12 then
		return w1_page_person_count.get_channel();		
	elseif last_page == 13 then
		return w1_page_fence.get_channel();
	elseif last_page == 14 then
		return w1_page_enter_area.get_channel();		
	elseif last_page == 15 then
		return w1_page_leave_area.get_channel();
	elseif last_page == 16 then
		return w1_page_advance.get_channel();
	end
	return 0;
end

local on_item_clicked = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local chn = get_channel();
		local cwnd = w1_row_noopsyche.wnd;
		local cur_wnd = nil;
		if (win_id == cwnd.perimeter.id) then
			last_page = 1
			cur_wnd = w1_page_perimeter;
		elseif (win_id == cwnd.cordon.id) then
			last_page = 2
			cur_wnd = w1_page_cordon;
		elseif (win_id == cwnd.dcordon.id) then
			last_page = 3
			cur_wnd = w1_page_dcordon;
		elseif (win_id == cwnd.objectleft.id) then
			last_page = 4
			cur_wnd = w1_page_objectleft;
		elseif (win_id == cwnd.objectremove.id) then
			last_page = 5
			cur_wnd = w1_page_objectremove;
		elseif (win_id == cwnd.badsignal.id) then
			last_page = 6
			cur_wnd = w1_page_badsignal;
		elseif (win_id == cwnd.loiter.id) then
			last_page = 7
			cur_wnd = w1_page_loiter;
		elseif (win_id == cwnd.multiloiter.id) then
			last_page = 8
			cur_wnd = w1_page_multiloiter;
		elseif (win_id == cwnd.abnormalspeed.id) then
			last_page = 9
			cur_wnd = w1_page_abnormal_speed;
		elseif (win_id == cwnd.converse.id) then
			last_page = 10
			cur_wnd = w1_page_converse;
		elseif (win_id == cwnd.illegalparking.id) then					
			last_page = 11
			cur_wnd = w1_page_illegalpacking;
		elseif (win_id == cwnd.person_count.id) then					
			last_page = 12
			cur_wnd = w1_page_person_count;		
		elseif (win_id == cwnd.fence.id) then		
			last_page = 13	
			cur_wnd = w1_page_fence;		
		elseif (win_id == cwnd.enter_area.id) then					
			last_page = 14
			cur_wnd = w1_page_enter_area;		
		elseif (win_id == cwnd.leave_area.id) then		
			last_page = 15	
			cur_wnd = w1_page_leave_area;		
		elseif (win_id == cwnd.advanced.id) then		
			last_page = 16	
			cur_wnd = w1_page_advance;
		end	
		if (cur_wnd ~= nil) then
			cur_wnd.set_channel(chn);
		end
		
		w1_wnd_jump.click_row(top, w1_row_noopsyche.wnd, win_id, true)
	end
	
	return 0;
end	

local on_expand = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local item_num = #w1_row_noopsyche.item_width;	
		local item_txt = {};
		for i = 1, item_num do
			table.insert(item_txt, w1_row_noopsyche.wnd[w1_row_noopsyche.wnd.sub[i]].text);	
		end
		w1_select_intelligent_type.set_item_info(item_txt, w1_row_noopsyche.item_width,item_num, w1_row_noopsyche);
		w1_row_noopsyche.select_item_idx = 0;
		b_dlg.do_modal(top, w1_select_intelligent_type.t, 0, 0, nil)
		
		
		if (w1_row_noopsyche.select_item_idx > 0) then
			--ڵǰʾ ҪƶԪλ
			if (w1_row_noopsyche.dsp_item_s_id <=  w1_row_noopsyche.select_item_idx + id and w1_row_noopsyche.select_item_idx + id <= w1_row_noopsyche.dsp_item_e_id) then
				on_item_clicked(top, id + w1_row_noopsyche.select_item_idx, b_ui.LBUTTONCLK, 0, 0);
			else --ڵǰʾ Ҫƫλ

				local count = #w1_row_noopsyche.wnd.sub - 2; --ȥһťԪغˮƽԪ
				local cur_idx = w1_row_noopsyche.select_item_idx;
				local s_idx = cur_idx;
				local e_idx = cur_idx;
				local find_s_id = true;
				local find_e_id = true;
				local total_w = SIZE('w1_row_noopsyche_total_width_xywh')[3];
				local space = SIZE('w1_row_noopsyche_item_space_xywh')[3]
				local tem_width = w1_row_noopsyche.item_width[cur_idx] + space;
				for i = 1, count do
					if (find_s_id) then
						s_idx = cur_idx - i;
						if (s_idx >= 1) then
							tem_width = tem_width + w1_row_noopsyche.item_width[s_idx] + space;
							if (tem_width > total_w) then --ǰԪطŲ
								tem_width = tem_width - w1_row_noopsyche.item_width[s_idx] - space;
								s_idx = s_idx + 1;
								find_s_id = false;
							end
						else
							s_idx = s_idx + 1;
							find_s_id = false;
						end
					end
					
					if (find_e_id) then
						e_idx = cur_idx + i
						if (e_idx <= count) then
							tem_width = tem_width + w1_row_noopsyche.item_width[e_idx] + space;
							if (tem_width > total_w) then --ǰԪطŲ
								tem_width = tem_width - w1_row_noopsyche.item_width[e_idx] - space;
								e_idx = e_idx - 1;
								find_e_id = false;
							end
						else
							e_idx = e_idx - 1;
							find_e_id = false;
						end		
					end
					
					if (find_s_id == false and find_e_id == false) then
						break;
					end
				end
				w1_row_noopsyche.dsp_item_s_id = id + s_idx;			
				w1_row_noopsyche.dsp_item_e_id = id + e_idx;	
				move_item_position(top, w1_row_noopsyche.dsp_item_s_id, w1_row_noopsyche.dsp_item_e_id, false);
				on_item_clicked(top, id + w1_row_noopsyche.select_item_idx, b_ui.LBUTTONCLK, 0, 0);
				b_dlg.dlg_set_redraw(top);
			end	
		end
	end
	
	return 0;
end	

w1_row_noopsyche.set_select_intelligent_type = function(idx)
	w1_row_noopsyche.select_item_idx = idx;
end	

w1_row_noopsyche.on_pre_show = function(top)
	local item_width_ary = {};
	local cwnd = w1_row_noopsyche.wnd;
	local width = 0;
	width = b_wnd_ex.get_textsize(top, cwnd.perimeter.id).w; 
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.cordon.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.dcordon.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.objectleft.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.objectremove.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.badsignal.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.loiter.id).w; 
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.multiloiter.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.abnormalspeed.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.converse.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.illegalparking.id).w;	
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.person_count.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.fence.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.enter_area.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.leave_area.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.advanced.id).w;
	table.insert(item_width_ary, width);	

	if(w1_row_noopsyche.item_width == nil) then
		w1_row_noopsyche.item_width = util.copy_tab(item_width_ary);
	else
		util.copy_tab_b(w1_row_noopsyche.item_width, item_width_ary);
	end

	local total_w = SIZE('w1_row_noopsyche_total_width_xywh')[3];
	local space = SIZE('w1_row_noopsyche_item_space_xywh')[3]
	local dsp_item_cnt = 0;
	local tem_width = 0;
	for i = 1, #w1_row_noopsyche.item_width do
		tem_width = tem_width + w1_row_noopsyche.item_width[i] + space
		if (tem_width > total_w) then
			break;
		end
		dsp_item_cnt = dsp_item_cnt + 1;
	end

	w1_row_noopsyche.dsp_item_s_id = id + 1;			
	w1_row_noopsyche.dsp_item_e_id = id +dsp_item_cnt;				
	move_item_position(top, w1_row_noopsyche.dsp_item_s_id, w1_row_noopsyche.dsp_item_e_id, false);
end

w1_row_noopsyche.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'perimeter','cordon','dcordon','objectleft', 'objectremove','badsignal',
			    'loiter', 'multiloiter', 'abnormalspeed', 'converse', 'illegalparking',	'person_count','fence',  'enter_area', 'leave_area', 'advanced', 'exp_btn', 'hline'},
	perimeter 	= {t='checktxt', id=id+1,xywh='s_cfg_row_1',
				text='LA_PERIMETER',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked,check = true},
	cordon 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_1',
				text='LA_SINGLE_VIRTUAL_FRNCE',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},
	dcordon = {t='checktxt',	id=id+3,xywh='s_cfg_row_1',
				text='LA_DOUBLE_VIRTUAL_FENCES',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},
	objectleft 	= {t='checktxt',	id=id+4,xywh='s_cfg_row_1',
				text='LA_OBJECT_LEFT',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},
	objectremove = {t='checktxt',	id=id+5,xywh='s_cfg_row_1',
				text='LA_OBJECT_REMOVED',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},	
	badsignal 	= {t='checktxt',	id=id+6,xywh='s_cfg_row_1',
				text='LA_SIGNAL_BAD',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},
	loiter 	= {t='checktxt',	id=id+7,xywh='s_cfg_row_1',
				text='LA_LOITER',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},
	multiloiter 	= {t='checktxt',	id=id+8,xywh='s_cfg_row_1',
				text='LA_MULTI_LOITER',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},
	abnormalspeed 	= {t='checktxt',	id=id+9,xywh='s_cfg_row_1',
				text='LA_ABNORNAL_SPEED',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},
	converse 	= {t='checktxt',	id=id+10,xywh='s_cfg_row_1',
				text='LA_CONVERSE',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},
	illegalparking = {t='checktxt',	id=id+11,xywh='s_cfg_row_1',
				text='LA_ILLEGAL_PARKING',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},	
	person_count = {t='checktxt',	id=id+12,xywh='s_cfg_row_1',
				text='LA_PERSON_COUNT',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},		
	fence = {t='checktxt',	id=id+13,xywh='s_cfg_row_1',
				text='LA_FENCE',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},	
	enter_area = {t='checktxt',	id=id+14,xywh='s_cfg_row_1',
				text='LA_ENTER_AREA',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},		
	leave_area = {t='checktxt',	id=id+15,xywh='s_cfg_row_1',
				text='LA_LEAVE_AREA',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},		
	advanced 	= {t='checktxt',	id=id+16,xywh='s_cfg_row_1',
				text='LA_ADVANCED',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},			
	exp_btn = {t='tt_button',id=id+17,xywh='w1_row_noopsyche_exp_btn_xywh', cmd=on_expand,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			color_d= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_d'},
			t_imgs = {b_ui.ALIGN.CENTER,'f_grade4','it_down','it_down', 'it_down'}},				
				
	hline 	= {t='hline',	id=id+18,xywh='s_cfg_row_hline'},
}

return w1_row_noopsyche
