--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_noopsyche.noopsycheprow_advance_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")

local w1_row_noopsycherow_advance = {	
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_noopsycherow_advance.s_768 =
{
	s_row_noopsycherow_advance_xywh = {0,74,533,57},
	s_row_noopsycherow_advance_area_xywh = {53,0,106,39},
};

w1_row_noopsycherow_advance.s_1280 = 
{
	s_row_noopsycherow_advance_xywh = {0,105,1000,81},
	s_row_noopsycherow_advance_area_xywh = {100,0,200,55},
};

w1_row_noopsycherow_advance.s_1440 = 
{
	s_row_noopsycherow_advance_xywh = {0,95,1000,81},
	s_row_noopsycherow_advance_area_xywh = {100,0,200,55},
};

w1_row_noopsycherow_advance.s_1080p = 
{
	s_row_noopsycherow_advance_xywh = {0,105,1000,81},
	s_row_noopsycherow_advance_area_xywh = {100,0,200,55},
};
w1_row_noopsycherow_advance.s_2k = 
{
	s_row_noopsycherow_advance_xywh = {0,140,1333,108},
	s_row_noopsycherow_advance_area_xywh = {133,0,267,73},
};
w1_row_noopsycherow_advance.s_4k = 
{
	s_row_noopsycherow_advance_xywh = {0,210,2000,162},
	s_row_noopsycherow_advance_area_xywh = {200,0,400,110},
};

w1_row_noopsycherow_advance.changecheck = function(top, wnd, id, redraw)
	for k,v in pairs( wnd.sub ) do
		if(wnd[v].t == 'checkbutton') then
			b_wnd_ex.set_check(top, wnd[v].id, false, redraw)
		end
	end
	b_wnd_ex.set_check(top, id, true, redraw);
	local wnd_id = w1_row_noopsycherow_advance.wnd
	
	b_wnd_ex.set_show_page(top, w1_id.cfg_noopsyche.con_noopsyche_advance_id, w1_id.cfg_noopsyche.noopsycheprow_advance_area_id, redraw)
end

w1_row_noopsycherow_advance.get_checkidx = function(top)
	return 0
end

local on_area = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_row_noopsycherow_advance.changecheck(top, w1_row_noopsycherow_advance.wnd, win_id,true);
	end
	return 0
end

w1_row_noopsycherow_advance.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_row_noopsycherow_advance_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'area','hline1'},

	area		= {t='checkbutton',	id=id+1,xywh = 's_row_noopsycherow_advance_area_xywh',	text='LA_DETECTION_AREA',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_area','it_area', 'it_area'},
				cmd=on_area},
				
	hline1 		= {t='hline',id=id+4,	xywh='s_cfg_lline1'},
}

return w1_row_noopsycherow_advance
