--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/10/31
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_platform_access.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")

local w1_row_platform_access = {}

local on_check = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_platform_access.wnd, win_id, true)
	end
	return 0
end

w1_row_platform_access.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'platform_access', 'hline'},

	platform_access = {t='checktxt',	id=id+1,xywh='s_cfg_row_x1',
			text='LA_PLATFORM_ACCESS',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
			cmd=on_check,check = true},
	hline 	= {t='hline',	id=id+2,xywh='s_cfg_row_hline'}
}

return w1_row_platform_access
