-- UIʹõȷȡԻ
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.select_inteltype_id;
local cjson 	= require("cjson")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local util 			= require("wnd.core.util")
local w1_row_noopsyche  = nil;

local w1_select_intelligent_type = {
	t = w1_key.DLG_SELECT_INTELLIGENT_TYPE,
	item_txt = nil;
	item_txt_size = nil,
	item_num = 0;
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_select_intelligent_type.s_768 =
{
	s_select_intelligent_tytpe_xywh = {202,113,800,71},
	s_select_intelligent_tytpe_item_xywh = {16,10,80,28},
	s_select_intelligent_tytpe_space_xywh = {16,10,26,0},
};

w1_select_intelligent_type.s_1280 = 
{
	s_select_intelligent_tytpe_xywh={320,160,900,100},
	s_select_intelligent_tytpe_item_xywh = {30, 15, 150, 40},
	s_select_intelligent_tytpe_space_xywh = {30, 10, 40, 0},--һԪ߾ ϱ߾ 	 
}

w1_select_intelligent_type.s_1440 = 
{
	s_select_intelligent_tytpe_xywh={360,140,1025,100},
	s_select_intelligent_tytpe_item_xywh = {30, 15, 150, 40},
	s_select_intelligent_tytpe_space_xywh = {30, 10, 40, 0},--һԪ߾ ϱ߾ 	 
}

w1_select_intelligent_type.s_1080p = 
{
	s_select_intelligent_tytpe_xywh={380,160,1500,100},
	s_select_intelligent_tytpe_item_xywh = {30, 15, 150, 40},
	s_select_intelligent_tytpe_space_xywh = {30, 15, 50, 0},--һԪ߾ ϱ߾ 	 
}

w1_select_intelligent_type.s_2k = 
{
	s_select_intelligent_tytpe_xywh = {506,213,1999,133},
	s_select_intelligent_tytpe_item_xywh = {39,19,199,53},
	s_select_intelligent_tytpe_space_xywh = {39,19,66,0},
}

w1_select_intelligent_type.s_4k = 
{
	s_select_intelligent_tytpe_xywh = {760,320,3000,200},
	s_select_intelligent_tytpe_item_xywh = {60,30,300,80},
	s_select_intelligent_tytpe_space_xywh = {60,30,100,0},
}


local on_item_clicked = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_select_intelligent_type.dlg;
		local idx = win_id - id;
		if (w1_row_noopsyche ~= nil and w1_row_noopsyche.set_select_intelligent_type ~= nil)then
			w1_row_noopsyche.set_select_intelligent_type(idx)
		end	
		b_dlg.end_modal(top);
	end
	return 0
end

w1_select_intelligent_type.on_create = function(top)
	w1_select_intelligent_type.top = top
	return 0
end

w1_select_intelligent_type.set_item_info = function(item_txt, item_txt_size, item_num, p_dlg)
	assert(type(item_txt) == 'table');	
	assert(type(item_txt_size) == 'table');

	w1_row_noopsyche = p_dlg
	if(w1_select_intelligent_type.item_txt_size == nil) then
		w1_select_intelligent_type.item_txt_size = util.copy_tab(item_txt_size);
	else
		util.copy_tab_b(w1_select_intelligent_type.item_txt_size, item_txt_size);
	end
	
	if(w1_select_intelligent_type.item_txt == nil) then
		w1_select_intelligent_type.item_txt = util.copy_tab(item_txt);
	else
		util.copy_tab_b(w1_select_intelligent_type.item_txt, item_txt);
	end

	w1_select_intelligent_type.item_num = item_num;
end

w1_select_intelligent_type.on_destroy = function(top)
	w1_select_intelligent_type.top = nil
	w1_select_intelligent_type.dlg = nil
	w1_select_intelligent_type.item_txt = nil;
	w1_select_intelligent_type.item_txt_size = nil;
	w1_select_intelligent_type.item_num = 0;
	w1_row_noopsyche = nil
	return 0
end

w1_select_intelligent_type.on_pre_show = function(top)
	local dlg = {};	
	dlg.attr = {xywh='s_select_intelligent_tytpe_xywh'};
	dlg.sub = {};
	for i = 1, w1_select_intelligent_type.item_num do
		local str = 'item_' .. i;
		table.insert(dlg.sub, str);
	end
	
	local item_txt = w1_select_intelligent_type.item_txt;
	for i = 1, #dlg.sub do
		dlg[dlg.sub[i]] = {t='checktxt', id=id+i,xywh='s_cfg_row_1',
				text= item_txt[i],	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				cmd=on_item_clicked};
	end	
	
	local dlg_xywh = SIZE('s_select_intelligent_tytpe_xywh')
	local item_pos = SIZE('s_select_intelligent_tytpe_item_xywh')
	local space = SIZE('s_select_intelligent_tytpe_space_xywh')
	
	local total_w = dlg_xywh[3] - item_pos[1]; --ܳ	
	local space_cx = space[3];	
	
	local x = item_pos[1];
	local y = item_pos[2];
	local w = item_pos[3];
	local h = item_pos[4];
	local item_row = 1;	
	
	local tem_width = 0;
	for i = 1, #dlg.sub do
		tem_width = tem_width + w1_select_intelligent_type.item_txt_size[i] + space_cx
		if (tem_width > total_w) then
			tem_width = w1_select_intelligent_type.item_txt_size[i] + space_cx;
			x = item_pos[1];
			y = y + h;
			item_row = item_row + 1;
		end
		
		dlg[dlg.sub[i]].xywh = {x, y, w1_select_intelligent_type.item_txt_size[i], h};
		x = x + w1_select_intelligent_type.item_txt_size[i] + space_cx;
	end
	
	local dlg_h = item_pos[2] * 2 + item_row * item_pos[4];
	dlg.attr.xywh = {dlg_xywh[1], dlg_xywh[2], dlg_xywh[3],dlg_h};	
	w1_select_intelligent_type.dlg = dlg;
	b_parser(top, w1_select_intelligent_type.dlg)
	
	return 0
end

w1_select_intelligent_type.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_btn_n'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_select_intelligent_type.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local size = nil;
		if (type(w1_select_intelligent_type.dlg.attr.xywh) == 'string')then
			size = SIZE(w1_select_intelligent_type.dlg.attr.xywh);
		elseif(type(w1_select_intelligent_type.dlg.attr.xywh) == 'table') then	
			size = w1_select_intelligent_type.dlg.attr.xywh;
		else
			assert(false);
		end
	
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4])) then
			--
		else
			b_dlg.end_modal(top);
		end
	elseif(b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	end
	
	return 0
end

return w1_select_intelligent_type




