-- ӡ༭ͨҳ
local b_ui 		= require("wnd.core.b_ui")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.add_dev_id
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local cjson 	= require("cjson")
local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")

local w1_live_add_dev = {
	t = w1_key.DLG_ADD_DEV,
	top = nil,
	dlg = nil,
	sel,
	data,
	cameralist,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_live_add_dev.s_768 =
{
	s_live_add_dev_xywh = {357,110,309,440},
	s_live_add_dev_titleimg_xywh = {6,15,12,17},
	s_live_add_dev_titlestr_xywh = {26,10,253,28},
	s_live_add_dev_titleclose_xywh = {288,15,12,17},
	s_live_add_dev_c_channel_xywh = {26,64,106,28},
	s_live_add_dev_t_channel_xywh = {138,64,133,28},
	s_live_add_dev_c_ip_xywh = {26,106,106,28},
	s_live_add_dev_t_ip_xywh = {138,106,133,28},
	s_live_add_dev_c_prot_xywh = {26,149,106,28},
	s_live_add_dev_t_prot_xywh = {138,149,133,28},
	s_live_add_dev_c_port_xywh = {26,192,106,28},
	s_live_add_dev_t_port_xywh = {138,192,133,28},
	s_live_add_dev_c_user_xywh = {26,234,106,28},
	s_live_add_dev_t_user_xywh = {138,234,133,28},
	s_live_add_dev_c_pwd_xywh = {26,277,106,28},
	s_live_add_dev_t_pwd_xywh = {138,277,133,28},
	s_live_add_dev_c_remote_ch_xywh = {26,320,106,28},
	s_live_add_dev_t_remote_ch_xywh = {138,320,133,28},
	s_live_add_dev_tipinfo_xywh = {26,362,266,12},
	s_live_add_dev_hline_xywh = {8,384,293,1},
	s_live_add_dev_default_xywh = {64,398,64,27},
	s_live_add_dev_ok_xywh = {149,398,64,27},
	s_live_add_dev_cancel_xywh = {224,398,64,27},

	s_dev_add_dev_xywh = {330,92,362,583},
	s_dev_add_dev_titleimg_xywh = {6,15,12,17},
	s_dev_add_dev_titlestr_xywh = {26,10,307,28},
	s_dev_add_dev_titleclose_xywh = {341,15,12,17},
	s_dev_add_dev_bind_list_xywh = {26,64,298,128},
	s_dev_add_dev_list_item_xywh = {69,123,77,0},
	s_dev_add_dev_c_channel_xywh = {26,206,133,28},
	s_dev_add_dev_t_channel_xywh = {165,206,160,28},
	s_dev_add_dev_c_ip_xywh = {26,248,133,28},
	s_dev_add_dev_t_ip_xywh = {165,248,160,28},
	s_dev_add_dev_c_prot_xywh = {26,291,106,28},
	s_dev_add_dev_t_prot_xywh = {165,291,160,28},
	s_dev_add_dev_c_port_xywh = {26,334,106,28},
	s_dev_add_dev_t_port_xywh = {165,334,160,28},
	s_dev_add_dev_c_user_xywh = {26,376,106,28},
	s_dev_add_dev_t_user_xywh = {165,376,160,28},
	s_dev_add_dev_c_pwd_xywh = {26,419,106,28},
	s_dev_add_dev_t_pwd_xywh = {165,419,160,28},
	s_dev_add_dev_c_remote_ch_xywh = {26,462,106,28},
	s_dev_add_dev_t_remote_ch_xywh = {165,462,160,28},
	s_dev_add_dev_tipinfo_xywh = {26,504,266,12},
	s_dev_add_dev_hline_xywh = {8,526,346,1},
	s_dev_add_dev_default_xywh = {128,540,64,27},
	s_dev_add_dev_ok_xywh = {202,540,64,27},
	s_dev_add_dev_cancel_xywh = {277,540,64,27},
};

w1_live_add_dev.s_1280 = 
{
	s_live_add_dev_xywh = {350,202,580,620},
	s_live_add_dev_titleimg_xywh = {13,22,24,24}, 
	s_live_add_dev_titlestr_xywh = {50,15,476,40}, 
	s_live_add_dev_titleclose_xywh = {541,22,24,24},
	s_live_add_dev_c_channel_xywh = {50,90,200,40}, 
	s_live_add_dev_t_channel_xywh = {260,90,250,40},
	s_live_add_dev_c_ip_xywh = {50,150,200,40},
	s_live_add_dev_t_ip_xywh = {260,150,250,40},
	s_live_add_dev_c_prot_xywh = {50,210,200,40},
	s_live_add_dev_t_prot_xywh = {260,210,250,40},
	s_live_add_dev_c_port_xywh = {50,270,200,40},
	s_live_add_dev_t_port_xywh = {260,270,250,40},
	s_live_add_dev_c_user_xywh = {50,330,200,40},
	s_live_add_dev_t_user_xywh = {260,330,250,40},
	s_live_add_dev_c_pwd_xywh = {50,390,200,40},
	s_live_add_dev_t_pwd_xywh = {260,390,250,40},
	s_live_add_dev_c_remote_ch_xywh ={50,450,200,40}, 
	s_live_add_dev_t_remote_ch_xywh ={260,450,250,40},	
	s_live_add_dev_tipinfo_xywh = {50,510,500,18},
	s_live_add_dev_hline_xywh = {15,540,550,2},	
	s_live_add_dev_default_xywh = {120,560,120,38},
	s_live_add_dev_ok_xywh = {280,560,120,38},
	s_live_add_dev_cancel_xywh = {420,560,120,38},
	
	s_dev_add_dev_xywh = {300,102,680,820},
	s_dev_add_dev_titleimg_xywh = {13,22,24,24}, 
	s_dev_add_dev_titlestr_xywh = {50,15,576,40}, 
	s_dev_add_dev_titleclose_xywh = {641,22,24,24},
	s_dev_add_dev_bind_list_xywh = {50, 90, 560, 180},
	s_dev_add_dev_list_item_xywh = {130, 250, 145, 0},
	s_dev_add_dev_c_channel_xywh = {50,290,250,40}, 
	s_dev_add_dev_t_channel_xywh = {310,290,300,40},
	s_dev_add_dev_c_ip_xywh = {50,350,250,40},
	s_dev_add_dev_t_ip_xywh = {310,350,300,40},
	s_dev_add_dev_c_prot_xywh = {50,410,200,40},
	s_dev_add_dev_t_prot_xywh = {310,410,300,40},
	s_dev_add_dev_c_port_xywh = {50,470,200,40},
	s_dev_add_dev_t_port_xywh = {310,470,300,40},
	s_dev_add_dev_c_user_xywh = {50,530,200,40},
	s_dev_add_dev_t_user_xywh = {310,530,300,40},
	s_dev_add_dev_c_pwd_xywh = {50,590,200,40},
	s_dev_add_dev_t_pwd_xywh = {310,590,300,40},
	s_dev_add_dev_c_remote_ch_xywh ={50,650,200,40}, 
	s_dev_add_dev_t_remote_ch_xywh ={310,650,300,40},	
	s_dev_add_dev_tipinfo_xywh = {50,710,500,18},
	s_dev_add_dev_hline_xywh = {15,740,650,2},	
	s_dev_add_dev_default_xywh = {240,760,120,38},
	s_dev_add_dev_ok_xywh = {380,760,120,38},
	s_dev_add_dev_cancel_xywh = {520,760,120,38},	
};

w1_live_add_dev.s_1440 = 
{
	s_live_add_dev_xywh = {430,140,580,620},
	s_live_add_dev_titleimg_xywh = {13,22,24,24}, 
	s_live_add_dev_titlestr_xywh = {50,15,476,40}, 
	s_live_add_dev_titleclose_xywh = {541,22,24,24},
	s_live_add_dev_c_channel_xywh = {50,90,200,40}, 
	s_live_add_dev_t_channel_xywh = {260,90,250,40},
	s_live_add_dev_c_ip_xywh = {50,150,200,40},
	s_live_add_dev_t_ip_xywh = {260,150,250,40},
	s_live_add_dev_c_prot_xywh = {50,210,200,40},
	s_live_add_dev_t_prot_xywh = {260,210,250,40},
	s_live_add_dev_c_port_xywh = {50,270,200,40},
	s_live_add_dev_t_port_xywh = {260,270,250,40},
	s_live_add_dev_c_user_xywh = {50,330,200,40},
	s_live_add_dev_t_user_xywh = {260,330,250,40},
	s_live_add_dev_c_pwd_xywh = {50,390,200,40},
	s_live_add_dev_t_pwd_xywh = {260,390,250,40},
	s_live_add_dev_c_remote_ch_xywh ={50,450,200,40}, 
	s_live_add_dev_t_remote_ch_xywh ={260,450,250,40},	
	s_live_add_dev_tipinfo_xywh = {50,510,500,18},
	s_live_add_dev_hline_xywh = {15,540,550,2},	
	s_live_add_dev_default_xywh = {120,560,120,38},
	s_live_add_dev_ok_xywh = {280,560,120,38},
	s_live_add_dev_cancel_xywh = {420,560,120,38},
	
	s_dev_add_dev_xywh = {380,40,680,820},
	s_dev_add_dev_titleimg_xywh = {13,22,24,24}, 
	s_dev_add_dev_titlestr_xywh = {50,15,576,40}, 
	s_dev_add_dev_titleclose_xywh = {641,22,24,24},
	s_dev_add_dev_bind_list_xywh = {50, 90, 560, 180},
	s_dev_add_dev_list_item_xywh = {130, 250, 145, 0},
	s_dev_add_dev_c_channel_xywh = {50,290,250,40}, 
	s_dev_add_dev_t_channel_xywh = {310,290,300,40},
	s_dev_add_dev_c_ip_xywh = {50,350,250,40},
	s_dev_add_dev_t_ip_xywh = {310,350,300,40},
	s_dev_add_dev_c_prot_xywh = {50,410,200,40},
	s_dev_add_dev_t_prot_xywh = {310,410,300,40},
	s_dev_add_dev_c_port_xywh = {50,470,200,40},
	s_dev_add_dev_t_port_xywh = {310,470,300,40},
	s_dev_add_dev_c_user_xywh = {50,530,200,40},
	s_dev_add_dev_t_user_xywh = {310,530,300,40},
	s_dev_add_dev_c_pwd_xywh = {50,590,200,40},
	s_dev_add_dev_t_pwd_xywh = {310,590,300,40},
	s_dev_add_dev_c_remote_ch_xywh ={50,650,200,40}, 
	s_dev_add_dev_t_remote_ch_xywh ={310,650,300,40},	
	s_dev_add_dev_tipinfo_xywh = {50,710,500,18},
	s_dev_add_dev_hline_xywh = {15,740,650,2},	
	s_dev_add_dev_default_xywh = {240,760,120,38},
	s_dev_add_dev_ok_xywh = {380,760,120,38},
	s_dev_add_dev_cancel_xywh = {520,760,120,38},	
};

w1_live_add_dev.s_1080p = 
{
	s_live_add_dev_xywh = {670,155,580,620},
	s_live_add_dev_titleimg_xywh = {13,22,24,24}, 
	s_live_add_dev_titlestr_xywh = {50,15,476,40}, 
	s_live_add_dev_titleclose_xywh = {541,22,24,24},
	s_live_add_dev_c_channel_xywh = {50,90,200,40}, 
	s_live_add_dev_t_channel_xywh = {260,90,250,40},
	s_live_add_dev_c_ip_xywh = {50,150,200,40},
	s_live_add_dev_t_ip_xywh = {260,150,250,40},
	s_live_add_dev_c_prot_xywh = {50,210,200,40},
	s_live_add_dev_t_prot_xywh = {260,210,250,40},
	s_live_add_dev_c_port_xywh = {50,270,200,40},
	s_live_add_dev_t_port_xywh = {260,270,250,40},
	s_live_add_dev_c_user_xywh = {50,330,200,40},
	s_live_add_dev_t_user_xywh = {260,330,250,40},
	s_live_add_dev_c_pwd_xywh = {50,390,200,40},
	s_live_add_dev_t_pwd_xywh = {260,390,250,40},
	s_live_add_dev_c_remote_ch_xywh ={50,450,200,40}, 
	s_live_add_dev_t_remote_ch_xywh ={260,450,250,40},	
	s_live_add_dev_tipinfo_xywh = {50,510,500,18},
	s_live_add_dev_hline_xywh = {15,540,550,2},	
	s_live_add_dev_default_xywh = {120,560,120,38},
	s_live_add_dev_ok_xywh = {280,560,120,38},
	s_live_add_dev_cancel_xywh = {420,560,120,38},

	s_dev_add_dev_xywh = {620,130,680,820},
	s_dev_add_dev_titleimg_xywh = {13,22,24,24}, 
	s_dev_add_dev_titlestr_xywh = {50,15,576,40}, 
	s_dev_add_dev_titleclose_xywh = {641,22,24,24},
	s_dev_add_dev_bind_list_xywh = {50, 90, 560, 180},
	s_dev_add_dev_list_item_xywh = {130, 250, 145, 0},
	s_dev_add_dev_c_channel_xywh = {50,290,250,40}, 
	s_dev_add_dev_t_channel_xywh = {310,290,300,40},
	s_dev_add_dev_c_ip_xywh = {50,350,250,40},
	s_dev_add_dev_t_ip_xywh = {310,350,300,40},
	s_dev_add_dev_c_prot_xywh = {50,410,200,40},
	s_dev_add_dev_t_prot_xywh = {310,410,300,40},
	s_dev_add_dev_c_port_xywh = {50,470,200,40},
	s_dev_add_dev_t_port_xywh = {310,470,300,40},
	s_dev_add_dev_c_user_xywh = {50,530,200,40},
	s_dev_add_dev_t_user_xywh = {310,530,300,40},
	s_dev_add_dev_c_pwd_xywh = {50,590,200,40},
	s_dev_add_dev_t_pwd_xywh = {310,590,300,40},
	s_dev_add_dev_c_remote_ch_xywh ={50,650,200,40}, 
	s_dev_add_dev_t_remote_ch_xywh ={310,650,300,40},	
	s_dev_add_dev_tipinfo_xywh = {50,710,500,18},
	s_dev_add_dev_hline_xywh = {15,740,650,2},	
	s_dev_add_dev_default_xywh = {240,760,120,38},
	s_dev_add_dev_ok_xywh = {380,760,120,38},
	s_dev_add_dev_cancel_xywh = {520,760,120,38},
};
w1_live_add_dev.s_2k = 
{
	s_live_add_dev_xywh 		= {893,326,773,826},
	s_live_add_dev_titleimg_xywh = {17,29,32,32},
	s_live_add_dev_titlestr_xywh = {67,20,635,53},
	s_live_add_dev_titleclose_xywh = {721,29,32,32},
	s_live_add_dev_c_channel_xywh = {67,120,270,53},
	s_live_add_dev_t_channel_xywh = {350,120,330,53},
	s_live_add_dev_c_ip_xywh = {67,200,270,53},
	s_live_add_dev_t_ip_xywh = {350,200,330,53},
	s_live_add_dev_c_prot_xywh = {67,280,270,53},
	s_live_add_dev_t_prot_xywh = {350,280,330,53},
	s_live_add_dev_c_port_xywh = {67,360,270,53},
	s_live_add_dev_t_port_xywh = {350,360,330,53},
	s_live_add_dev_c_user_xywh = {67,440,270,53},
	s_live_add_dev_t_user_xywh = {350,440,330,53},
	s_live_add_dev_c_pwd_xywh = {67,520,270,53},
	s_live_add_dev_t_pwd_xywh = {350,520,330,53},
	s_live_add_dev_c_remote_ch_xywh ={67,600,270,53}, 
	s_live_add_dev_t_remote_ch_xywh ={350,600,330,53},
	s_live_add_dev_tipinfo_xywh = {67,680,667,24},
	s_live_add_dev_hline_xywh = {20,720,733,3},
	s_live_add_dev_default_xywh = {180,746,160,51},
	s_live_add_dev_ok_xywh = {373,746,160,51},
	s_live_add_dev_cancel_xywh = {560,746,160,51},
	
	s_dev_add_dev_xywh = {826,173,906,1093},
	s_dev_add_dev_titleimg_xywh = {17,29,32,32},
	s_dev_add_dev_titlestr_xywh = {67,20,768,53},
	s_dev_add_dev_titleclose_xywh = {854,29,32,32},
	s_dev_add_dev_bind_list_xywh = {67,120,746,240},
	s_dev_add_dev_list_item_xywh = {173,333,193,0},
	s_dev_add_dev_c_channel_xywh = {67,387,333,53},
	s_dev_add_dev_t_channel_xywh = {413,387,400,53},
	s_dev_add_dev_c_ip_xywh = {67,467,333,53},
	s_dev_add_dev_t_ip_xywh = {413,467,400,53},
	s_dev_add_dev_c_prot_xywh = {67,547,267,53},
	s_dev_add_dev_t_prot_xywh = {413,547,400,53},
	s_dev_add_dev_c_port_xywh = {67,627,267,53},
	s_dev_add_dev_t_port_xywh = {413,627,400,53},
	s_dev_add_dev_c_user_xywh = {67,706,267,53},
	s_dev_add_dev_t_user_xywh = {413,706,400,53},
	s_dev_add_dev_c_pwd_xywh = {67,786,267,53},
	s_dev_add_dev_t_pwd_xywh = {413,786,400,53},
	s_dev_add_dev_c_remote_ch_xywh ={67,866,267,53},
	s_dev_add_dev_t_remote_ch_xywh ={413,866,400,53},
	s_dev_add_dev_tipinfo_xywh = {67,946,667,24},
	s_dev_add_dev_hline_xywh = {20,986,866,3},
	s_dev_add_dev_default_xywh = {320,1013,160,51},
	s_dev_add_dev_ok_xywh = {507,1013,160,51},
	s_dev_add_dev_cancel_xywh = {693,1013,160,51},
};
w1_live_add_dev.s_4k = 
{
	s_live_add_dev_xywh 		= {1340,490,1160,1240},
	s_live_add_dev_titleimg_xywh = {26,44,64,64},
	s_live_add_dev_titlestr_xywh = {100,30,952,80},
	s_live_add_dev_titleclose_xywh = {1082,44,48,48},
	s_live_add_dev_c_channel_xywh = {100,180,400,80},
	s_live_add_dev_t_channel_xywh = {520,180,500,80},
	s_live_add_dev_c_ip_xywh = {100,300,400,80},
	s_live_add_dev_t_ip_xywh = {520,300,500,80},
	s_live_add_dev_c_prot_xywh = {100,420,400,80},
	s_live_add_dev_t_prot_xywh = {520,420,500,80},
	s_live_add_dev_c_port_xywh = {100,540,400,80},
	s_live_add_dev_t_port_xywh = {520,540,500,80},
	s_live_add_dev_c_user_xywh = {100,660,400,80},
	s_live_add_dev_t_user_xywh = {520,660,500,80},
	s_live_add_dev_c_pwd_xywh = {100,780,400,80},
	s_live_add_dev_t_pwd_xywh = {520,780,500,80},
	s_live_add_dev_c_remote_ch_xywh ={100,900,400,80}, 
	s_live_add_dev_t_remote_ch_xywh ={520,900,500,80},
	s_live_add_dev_tipinfo_xywh = {100,1020,1000,36},
	s_live_add_dev_hline_xywh = {30,1080,1100,4},
	s_live_add_dev_default_xywh = {240,1120,240,76},
	s_live_add_dev_ok_xywh = {560,1120,240,76},
	s_live_add_dev_cancel_xywh = {840,1120,240,76},
	
	s_dev_add_dev_xywh = {1240,260,1360,1640},
	s_dev_add_dev_titleimg_xywh = {26,44,48,48},
	s_dev_add_dev_titlestr_xywh = {100,30,1152,80},
	s_dev_add_dev_titleclose_xywh = {1282,44,48,48},
	s_dev_add_dev_bind_list_xywh = {100,180,1120,360},
	s_dev_add_dev_list_item_xywh = {260,500,290,0},
	s_dev_add_dev_c_channel_xywh = {100,580,500,80},
	s_dev_add_dev_t_channel_xywh = {620,580,600,80},
	s_dev_add_dev_c_ip_xywh = {100,700,500,80},
	s_dev_add_dev_t_ip_xywh = {620,700,600,80},
	s_dev_add_dev_c_prot_xywh = {100,820,400,80},
	s_dev_add_dev_t_prot_xywh = {620,820,600,80},
	s_dev_add_dev_c_port_xywh = {100,940,400,80},
	s_dev_add_dev_t_port_xywh = {620,940,600,80},
	s_dev_add_dev_c_user_xywh = {100,1060,400,80},
	s_dev_add_dev_t_user_xywh = {620,1060,600,80},
	s_dev_add_dev_c_pwd_xywh = {100,1180,400,80},
	s_dev_add_dev_t_pwd_xywh = {620,1180,600,80},
	s_dev_add_dev_c_remote_ch_xywh ={100,1300,400,80},
	s_dev_add_dev_t_remote_ch_xywh ={620,1300,600,80},
	s_dev_add_dev_tipinfo_xywh = {100,1420,1000,36},
	s_dev_add_dev_hline_xywh = {30,1480,1300,4},
	s_dev_add_dev_default_xywh = {480,1520,240,76},
	s_dev_add_dev_ok_xywh = {760,1520,240,76},
	s_dev_add_dev_cancel_xywh = {1040,1520,240,76},
};

local oldprotport = {}
local rtsp_protocol
local is_cfg = false;

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_live_add_dev.dlg;
		w1_msgbox.set_func(nil, nil, nil, nil);
		
		local legal, num = w1_legal.check_ip(top, cwnd.t_ip.id)
		if(legal == false) then
			if(num == w1_legal.ip.EMPTY or num == w1_legal.ip.PRARMERR or num == w1_legal.ip.LENERR) then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_NETIP_ERR'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
		end
		
		local modlist = {idx1 = {}};
		modlist.camera_num = 1;
		modlist['idx1'].channel_id = w1_live_add_dev.sel;
			
		local ip_addr = b_wnd_ex.get_text(top, cwnd.t_ip.id);
		local ip1, ip2, ip3, ip4 = string.match(ip_addr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");	
		local ipstr = tonumber(ip1)..'.'..tonumber(ip2)..'.'..tonumber(ip3)..'.'..tonumber(ip4);
		modlist.idx1.addr = ipstr;
		
		local protocol = b_wnd_ex.get_sel(top, cwnd.t_prot.id) + 1;
		modlist.idx1.protocol = protocol;
		--ssl
		if (protocol == 3 and w1_live_add_dev.support_ssl == true) then
			modlist['idx1'].protocol = 4;
		elseif(protocol >= 3)then
			if w1_live_add_dev.support_ssl == true then
				modlist['idx1'].protocol = protocol + 97;
			else
				modlist['idx1'].protocol = protocol + 98;
			end
		end	
		
		local port = b_wnd_ex.get_text(top, cwnd.t_port.id);
		modlist.idx1.port = tonumber(port);
		
		local user = b_wnd_ex.get_text(top, cwnd.t_user.id);
		modlist.idx1.account = user;
		
		local pwd = b_wnd_ex.get_password(top, cwnd.t_pwd.id);
		modlist.idx1.password = pwd;
		
		local remote_channel = b_wnd_ex.get_sel(top,  cwnd.t_remote_ch.id);
		modlist.idx1.remote_cam = remote_channel+1;
		
		modlist.idx1.binded = true;
		
		
		--ӻ߱༭IPǷѾ
		local ret = b_app_api.manual_add_camera(modlist);
		if ret.ret== -2 or ret.ret==-4 then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_CAMERA_MANAGED'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		elseif ret ~= nil and ret.ret < 0 then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_ADD_CHN_FAIL'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		elseif(ret ~= nil and ret.ret == 3105)then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_IP_CONFLICT'), false);
			b_dlg.dlg_set_redraw(top);
			return 0
		end		
		b_dlg.end_modal(top);
	end
	return 0
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local on_reset_info = function(top, redraw)
	local cwnd = w1_live_add_dev.dlg;	
	local select_chstr = nil;
	select_chstr =  math.floor(w1_live_add_dev.sel / 1);
	b_wnd_ex.set_text(top, w1_live_add_dev.dlg.t_channel.id, select_chstr, false);
	local trade_name = b_app_api.get_trade_name().name;
	if(trade_name == nil or trade_name == '') then
		trade_name = 'Private'
	end
	if rtsp_protocol == nil then
		rtsp_protocol = b_app_api.get_rtsp_pro();
	else
		rtsp_protocol = util.copy_tab(b_app_api.get_rtsp_pro());
	end
	if (w1_live_add_dev.support_ssl == true) then
		local type_list ={'ONVIF',trade_name,trade_name..'_SSL'};
		local count = rtsp_protocol.protocol_num
		for i=1, count do
			table.insert(type_list,rtsp_protocol['idx'..i].name);
		end
		b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
		b_wnd_ex.set_sel(top,  cwnd.t_prot.id, 0, false);
	else
		local type_list ={'ONVIF',trade_name};
		local count = rtsp_protocol.protocol_num
		for i=1, count do
			table.insert(type_list,rtsp_protocol['idx'..i].name);
		end
		b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
		b_wnd_ex.set_sel(top,  cwnd.t_prot.id, 0, false);
	end	
	local prot_id = b_wnd_ex.get_sel(top,  cwnd.t_prot.id);
	
	if(0 == prot_id)then
		b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, true, false);
	else
		b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, false, false);
	end

	b_wnd_ex.set_text(top, cwnd.t_ip.id, "", false);
	b_wnd_ex.set_value(top, cwnd.t_port.id, 80, false);
	b_wnd_ex.set_text(top, cwnd.t_user.id, "", false);
	b_wnd_ex.set_password(top, cwnd.t_pwd.id, "", false);
	b_wnd_ex.set_disp(top, cwnd.t_pwd.id, false, false);
	b_wnd_ex.set_disable(top,  cwnd.t_port.id, false, false);
	b_wnd_ex.set_text(top, cwnd.tipinfo.id, "", false);

	if (redraw == true) then
		b_dlg.dlg_set_redraw(top);
	end
end

local on_default = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		on_reset_info(top, true);
	end
	
	return 0
end

local on_protocolchange = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_live_add_dev.dlg;
		local prot = b_wnd_ex.get_sel(top, cwnd.t_prot.id);
		
		--remote_ch
		if (1 == prot or (2 == prot and w1_live_add_dev.support_ssl == true))then
			b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, false, false);
		else
			b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, true, false);
		end
		
		--port
		if ((prot < 2) or (2 == prot and w1_live_add_dev.support_ssl == true))then
			local port_num = nil;
			
			--default port
			if(0 == prot) then
				port_num = 80;
			elseif(1 == prot) then
				port_num = 30001;
			else--ssl  ˿ں20001
				port_num = 20001;
			end
			
			--copy from other chn
			if (prot == oldprotport.prot)then
				port_num = oldprotport.port;
			end			
			
			b_wnd_ex.set_value(top, cwnd.t_port.id , port_num,false);
			b_wnd_ex.set_disable(top, cwnd.t_port.id ,false,false);
		else
			b_wnd_ex.set_value(top, cwnd.t_port.id , rtsp_protocol['idx'..prot-1]['stream'..1].port,false);
			b_wnd_ex.set_disable(top, cwnd.t_port.id ,true,false);
		end
		
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local update_channel_info = function(top, index)
	local channel_num = global_val.get_channelnum();
	local curdata = nil;
	local k = 0;
	for i = 1, channel_num do
		local idx = 'idx' .. i;
		if (w1_live_add_dev.cameralist[idx] ~= nil and w1_live_add_dev.cameralist[idx].addr ~= '127.0.0.1') then
			if (index == k) then
				curdata = w1_live_add_dev.cameralist[idx];
				break;
			end	
			k = k + 1;		
		end
	end	
	if (curdata == nil) then
		return 0;	
	end	
	
	local trade_name = b_app_api.get_trade_name().name;
	if(trade_name == nil or trade_name == '') then
		trade_name = 'Private'
	end
	--Э
	local cwnd = w1_live_add_dev.dlg;
	if (w1_live_add_dev.support_ssl == true) then
		local type_list ={'ONVIF',trade_name,trade_name..'_SSL'};
		local count = rtsp_protocol.protocol_num
		for i=1, count do
			table.insert(type_list,rtsp_protocol['idx'..i].name);
		end
		b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
		if(curdata.protocol == 4)then
			b_wnd_ex.set_sel(top,  cwnd.t_prot.id, curdata.protocol - 2, false);
		elseif(curdata.protocol > 100)then
			b_wnd_ex.set_sel(top,  cwnd.t_prot.id, curdata.protocol - 98, false);
		else
			b_wnd_ex.set_sel(top,  cwnd.t_prot.id, curdata.protocol - 1, false);
		end
	else
		local type_list ={'ONVIF',trade_name};
		local count = rtsp_protocol.protocol_num
		for i=1, count do
			table.insert(type_list,rtsp_protocol['idx'..i].name);
		end
		b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
		if curdata.protocol > 100 then
			b_wnd_ex.set_sel(top,  cwnd.t_prot.id, curdata.protocol - 99, false);
		else
			b_wnd_ex.set_sel(top,  cwnd.t_prot.id, curdata.protocol - 1, false);
		end
	end	
		
	b_wnd_ex.set_text(top, cwnd.t_ip.id, curdata.addr, false);
	
	if(curdata.protocol == 4)then
		oldprotport.prot = curdata.protocol - 2;
	elseif(curdata.protocol > 100)then
		oldprotport.prot = curdata.protocol - 98;
	else
		oldprotport.prot = curdata.protocol - 1;
	end
	
	oldprotport.port = curdata.port;
	b_wnd_ex.set_value(top, cwnd.t_port.id, curdata.port, false);
	b_wnd_ex.set_text(top, cwnd.t_user.id, curdata.account, false);
	b_wnd_ex.set_password(top, cwnd.t_pwd.id, curdata.password, false);
	if(curdata.remote_cam <= 0)then
		b_wnd_ex.set_sel(top,  cwnd.t_remote_ch.id, 0, false);
	else	
		b_wnd_ex.set_sel(top,  cwnd.t_remote_ch.id, curdata.remote_cam - 1, false);
	end

	local prot_id = b_wnd_ex.get_sel(top,  cwnd.t_prot.id);

	--remote_ch
	if (1 == prot_id or (2 == prot_id and w1_live_add_dev.support_ssl == true))then
		b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, false, false);
	else
		b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, true, false);
	end

	--port
	if ((prot_id < 2) or (prot_id == 2 and w1_live_add_dev.support_ssl == true))then
		b_wnd_ex.set_disable(top, cwnd.t_port.id ,false,false);
	else
		b_wnd_ex.set_disable(top, cwnd.t_port.id ,true,false);
	end
	
	b_dlg.dlg_set_redraw(top);	
end	

local dlg_no_dev = {
	attr 	= {xywh='s_live_add_dev_xywh'},
	
	
	sub 	= {'titleimg', 'titlestr', 'titleclose', 
			'c_channel', 't_channel', 'c_ip', 't_ip', 'c_port', 't_port',
			'c_prot', 't_prot', 'c_user', 't_user', 'c_pwd', 't_pwd',
			'c_remote_ch','t_remote_ch','tipinfo','hline','default', 'ok','cancel'},
			
			
	titleimg 	= {t='tt_picture',	id=id+1,xywh='s_live_add_dev_titleimg_xywh', 
					t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_addcameera'}},
	
	titlestr	= {t='static', 	id=id+2,xywh='s_live_add_dev_titlestr_xywh', 
					text='LA_ADD_IPC',	font = 'f_grade5',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
					
	titleclose 	= {t='tt_button',id=id+3,xywh = 's_live_add_dev_titleclose_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn2','it_close','it_close', 'it_close'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_cfgclose_bk'},
					cmd=on_close,
					},
					
	c_channel 		= {t='static', 	id=id+4,xywh='s_live_add_dev_c_channel_xywh', 
					text='LA_CHANNEL',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_channel 		= {t='static', 	id=id+5,xywh='s_live_add_dev_t_channel_xywh', 
					text='',	trans = false, 	font = 'f_grade6',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
					
	c_ip 		= {t='static', 	id=id+6,xywh='s_live_add_dev_c_ip_xywh', 
					text='LA_IP_ADDRESS',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_ip 		= {t='edit_ip', 	id=id+7,xywh='s_live_add_dev_t_ip_xywh', 
					text='',	trans = false, 	font = 'f_grade6',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
					
	c_prot 		= {t='static', 	id=id+8,xywh='s_live_add_dev_c_prot_xywh', 
					text='LA_PROTOCOL',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_prot 		= {t='combox', 	id=id+9,xywh='s_live_add_dev_t_prot_xywh', 
					font = 'f_grade6', sel = 0,items={},trans = false,
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					cmd = on_protocolchange
					},	
				
	c_port 		= {t='static', 	id=id+10,xywh='s_live_add_dev_c_port_xywh', 
					text='LA_PORT',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_port 		= {t='edit_num', 	id=id+11,xywh='s_live_add_dev_t_port_xywh', 
					value = 80,	trans = false, 	font = 'f_grade6',range={0,65535},
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},		
					
	c_user 		= {t='static', 	id=id+12,xywh='s_live_add_dev_c_user_xywh', 
					text='LA_USER_NAME',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_user 		= {t='edit', 	id=id+13,xywh='s_live_add_dev_t_user_xywh', 
					text='',	trans = false, 	font = 'f_grade6',guide_text='LA_USER_NAME',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
				
	c_pwd 		= {t='static', 	id=id+14,xywh='s_live_add_dev_c_pwd_xywh', 
					text='LA_PASSWORD',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_pwd 		= {t='password', 	id=id+15,xywh='s_live_add_dev_t_pwd_xywh', 
					password='',guide_text='LA_PASSWORD',font = 'f_grade6',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},
						
	c_remote_ch = {t='static', 	id=id+18,xywh='s_live_add_dev_c_remote_ch_xywh', 
					text='LA_REMOTE_CHANNEL',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_remote_ch = {t='combox', 	id=id+19,xywh='s_live_add_dev_t_remote_ch_xywh', font = 'f_grade6',
					items={'CH-1','CH-2','CH-3','CH-4','CH-5','CH-6','CH-7','CH-8','CH-9','CH-10','CH-11',
					'CH-12','CH-13','CH-14','CH-15','CH-16'},trans = false,
					},	
					
	tipinfo		= {t='static',id=id+20,	xywh='s_live_add_dev_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
					},
	hline		= {t='hline',	id=id+21,	xywh='s_live_add_dev_hline_xywh'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
	
	default		= {t='tt_button',id=id+22,	xywh='s_live_add_dev_default_xywh',text='LA_DEFAULT_RESET',font='f_grade6',cmd=on_default,
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
					},
	
	ok			= {t='tt_button',id=id+23,	xywh='s_live_add_dev_ok_xywh',	text='LA_OK',font='f_grade6',cmd=on_ok,
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				},
	cancel		= {t='tt_button',id=id+24,	xywh='s_live_add_dev_cancel_xywh',text='LA_CANCEL',font='f_grade6',cmd=on_cancel,
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
					},
}

local dlg_dev = {
	attr 	= {xywh='s_dev_add_dev_xywh'},
	
	
	sub 	= {'titleimg', 'titlestr', 'titleclose', 'bind_list',
			'c_channel', 't_channel', 'c_ip', 't_ip', 'c_port', 't_port',
			'c_prot', 't_prot', 'c_user', 't_user', 'c_pwd', 't_pwd',
			'c_remote_ch','t_remote_ch','tipinfo','hline','default', 'ok','cancel'},
			
			
	titleimg 	= {t='tt_picture',	id=id+1,xywh='s_dev_add_dev_titleimg_xywh', 
					t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_addcameera'}},
	
	titlestr	= {t='static', 	id=id+2,xywh='s_dev_add_dev_titlestr_xywh', 
					text='LA_ADD_IPC',	font = 'f_grade5',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
					
	titleclose 	= {t='tt_button',id=id+3,xywh = 's_dev_add_dev_titleclose_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn2','it_close','it_close', 'it_close'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_cfgclose_bk'},
					cmd=on_close,
					},
					
	bind_list= {t='list',	id=id+4,	xywh='s_dev_add_dev_bind_list_xywh', font = 'f_grade6',items_font = 18,
		listattr = {3,3,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},list_tip =true,
		title_texts = {'LA_CHANNEL','LA_IP', 'LA_PROTOCOL'},
		columns_w = {40,120,40}
	},
						
	c_channel 		= {t='static', 	id=id+5,xywh='s_dev_add_dev_c_channel_xywh', 
					text='LA_CHANNEL',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_channel 		= {t='static', 	id=id+6,xywh='s_dev_add_dev_t_channel_xywh', 
					text='',	trans = false, 	font = 'f_grade6',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
					
	c_ip 		= {t='static', 	id=id+7,xywh='s_dev_add_dev_c_ip_xywh', 
					text='LA_IP_ADDRESS',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_ip 		= {t='edit_ip', 	id=id+8,xywh='s_dev_add_dev_t_ip_xywh', 
					text='',	trans = false, 	font = 'f_grade6',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
					
	c_prot 		= {t='static', 	id=id+9,xywh='s_dev_add_dev_c_prot_xywh', 
					text='LA_PROTOCOL',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_prot 		= {t='combox', 	id=id+10,xywh='s_dev_add_dev_t_prot_xywh', 
					font = 'f_grade6', sel = 0,items={},trans = false,
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					cmd = on_protocolchange
					},	
				
	c_port 		= {t='static', 	id=id+11,xywh='s_dev_add_dev_c_port_xywh', 
					text='LA_PORT',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_port 		= {t='edit_num', 	id=id+12,xywh='s_dev_add_dev_t_port_xywh', 
					value = 80,	trans = false, 	font = 'f_grade6',range={1,65535},
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},		
					
	c_user 		= {t='static', 	id=id+13,xywh='s_dev_add_dev_c_user_xywh', 
					text='LA_USER_NAME',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_user 		= {t='edit', 	id=id+14,xywh='s_dev_add_dev_t_user_xywh', 
					text='',	trans = false, 	font = 'f_grade6',guide_text='LA_USER_NAME',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
				
	c_pwd 		= {t='static', 	id=id+15,xywh='s_dev_add_dev_c_pwd_xywh', 
					text='LA_PASSWORD',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_pwd 		= {t='password', 	id=id+16,xywh='s_dev_add_dev_t_pwd_xywh', 
					password='',guide_text='LA_PASSWORD',font = 'f_grade6',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},
					
	c_remote_ch = {t='static', 	id=id+17,xywh='s_dev_add_dev_c_remote_ch_xywh', 
					text='LA_REMOTE_CHANNEL',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_remote_ch = {t='combox', 	id=id+18,xywh='s_dev_add_dev_t_remote_ch_xywh', font = 'f_grade6',
					items={'CH-1','CH-2','CH-3','CH-4','CH-5','CH-6','CH-7','CH-8','CH-9','CH-10','CH-11',
					'CH-12','CH-13','CH-14','CH-15','CH-16'},trans = false,
					},	
					
	tipinfo		= {t='static',id=id+19,	xywh='s_dev_add_dev_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
					},
	hline		= {t='hline',	id=id+20,	xywh='s_dev_add_dev_hline_xywh'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
	
	default		= {t='tt_button',id=id+21,	xywh='s_dev_add_dev_default_xywh',text='LA_DEFAULT_RESET',font='f_grade6',cmd=on_default,
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
					},	
	
	ok			= {t='tt_button',id=id+22,	xywh='s_dev_add_dev_ok_xywh',	text='LA_OK',font='f_grade6',cmd=on_ok,
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				},
	cancel		= {t='tt_button',id=id+23,	xywh='s_dev_add_dev_cancel_xywh',text='LA_CANCEL',font='f_grade6',cmd=on_cancel,
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
					},
}

w1_live_add_dev.on_create = function(top)
	w1_live_add_dev.top = top
	w1_live_add_dev.cameralist = b_app_api.get_cfg({'camera_bind'}).camera_bind;
	local channel_num = global_val.get_channelnum();
	if (w1_live_add_dev.cameralist.camera_num == 0) then --бΪ0
		w1_live_add_dev.dlg = dlg_no_dev
	else
		local has_ipc = false;
		for i = 1, channel_num do
			local idx = 'idx' .. i;
			if (w1_live_add_dev.cameralist[idx] ~= nil and w1_live_add_dev.cameralist[idx].addr ~= '127.0.0.1') then
				has_ipc = true;
				break;
			end
		end
		
		if (true == has_ipc) then			
			w1_live_add_dev.dlg = dlg_dev	
		else
			w1_live_add_dev.dlg = dlg_no_dev
		end
	end	
	
	b_parser(top, w1_live_add_dev.dlg)
	w1_live_add_dev.support_ssl = global_val.get_support_ssl_attr();
	
	return 0
end

w1_live_add_dev.on_destroy = function(top)
	w1_live_add_dev.top = nil
	w1_live_add_dev.dlg = nil
	w1_live_add_dev.data = nil
	rtsp_protocol = nil;
	if is_cfg == false then
		b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	end
	return 0
end

w1_live_add_dev.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top)
	local cwnd = w1_live_add_dev.dlg;	
	if(param ~= nil)then
		local paramdata = cjson.decode(param)
		assert(paramdata.channel ~= nil)
		w1_live_add_dev.sel = paramdata.channel;
		if paramdata.is_cfg ~= nil and paramdata.is_cfg == 1 then
			is_cfg = true;
		else
			is_cfg = false;
		end
		w1_live_add_dev.data = b_app_api.get_cfg({'camera'}).camera;
		
		on_reset_info(top, false);
	end
		
	if (cwnd.bind_list ~= nil) then 
		local param =  {STR('LA_CHANNEL'),STR('LA_IP'), STR('LA_PROTOCOL')};
		b_wnd_ex.set_title_texts(top, cwnd.bind_list.id, param, false);
		local size = SIZE('s_dev_add_dev_list_item_xywh')
		local list_w = {};
		for i=1,3 do
			list_w[i] = size[i];
		end	
		b_wnd_ex.columns_w(top, cwnd.bind_list.id, list_w, false);
		
		local list_data = {};
		local k = 0;
		local channel_num = global_val.get_channelnum();
		local trade_name = b_app_api.get_trade_name().name;
		if(trade_name == nil or trade_name == '') then
			trade_name = 'Private'
		end
		for i = 1, channel_num do
			local idx = 'idx' .. i;
			if (w1_live_add_dev.cameralist[idx] ~= nil and w1_live_add_dev.cameralist[idx].addr ~= '127.0.0.1') then
				local prot_name = 'ONVIF';
				if(tonumber(w1_live_add_dev.cameralist[idx].protocol) == 2) then
					prot_name = trade_name
				elseif(tonumber(w1_live_add_dev.cameralist[idx].protocol) == 4) then
					prot_name = trade_name..'_SSL'
				elseif(tonumber(w1_live_add_dev.cameralist[idx].protocol) > 100) then
					local index = tonumber(w1_live_add_dev.cameralist[idx].protocol) - 100
					prot_name = rtsp_protocol['idx'..index].name
				end			
				k = k + 1;		
				list_data['idx' .. k] = {k-1, false, 'CH' .. w1_live_add_dev.cameralist[idx].channel_id, 
				w1_live_add_dev.cameralist[idx].addr .. ':' .. w1_live_add_dev.cameralist[idx].port, prot_name};
			end
		end
		list_data.item_total = k;
		b_wnd_ex.set_listdata(top, cwnd.bind_list.id, list_data, false);	
	end
	if is_cfg == false then
		b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	end
	
	return 0
end

w1_live_add_dev.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'))

--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_modch_border'),1)
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_live_add_dev.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local size = SIZE(w1_live_add_dev.dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then --
			 if (w1_live_add_dev.dlg.bind_list ~= nil) then
				 local rect_list = SIZE(w1_live_add_dev.dlg.bind_list.xywh);
				 if(x >= size[1] + rect_list[1] and x <= (size[1] + rect_list[1] + rect_list[3]) and y >= size[2] + rect_list[2] and y <= (size[2] + rect_list[2] + rect_list[4]) ) then --
					local idx = b_wnd_ex.get_list_idx(top, w1_live_add_dev.dlg.bind_list.id, x, y);
					if (0 <= idx) then
						update_channel_info(top, idx);
					end
				 end	
			else
				b_dlg.dlg_set_redraw(top);	
			end
		else
			b_dlg.end_modal(top);
		end
	elseif  (b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	end
	
	return 0
end

return w1_live_add_dev




