--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/20
-- author lsl
-- brief  öԻ
--]]
local global_val 	= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.edit_record_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local app_api 	= require("app_api")
local b_app_api = require("wnd.core.command.b_app_api");
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local w1_copy 	= require("wnd.w1_util.w1_copy")
local util 		= require("wnd.core.util")
local reflsh_btn = true
local channel_list = {}
local chn_id= 1;
local ok_flag = false
local temp_data = {}


local w1_edit_record = {
	t = w1_key.DLG_EDIT_RECORD,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	copy_ch={},
}

w1_edit_record.ok_func = nil;
w1_edit_record.cannel_func = nil;
w1_edit_record.okfunc_param  =  nil
w1_edit_record.cannel_param = nil;
w1_edit_record.record_data=nil

w1_edit_record.s_768 =
{
	s_edit_record_xywh = {304,128,400,526},
	s_edit_record_titleimg_xywh = {6,10,12,17},
	s_edit_record_alarm_xywh = {26,8,368,28},
	s_edit_record_close_xywh = {378,10,12,17},
	s_edit_record_draw = {0,41,0,1},

	s_edit_record_cap_date_xywh = {26,49,128,35},
	s_edit_record_t_date_xywh = {154,49,218,35},

	s_edit_record_cap_recode_xywh = {26,92,128,35},
	s_edit_record_t_recode_xywh = {154,92,218,35},
	s_edit_record_cap_rule_xywh = {26,135,128,35},
	s_edit_record_t_rule_xywh = {154,135,218,35},

	s_edit_sun_draw = {106,444,37,28},
	s_edit_mon_draw = {144,444,37,28},
	s_edit_tue_draw = {181,444,37,28},
	s_edit_wed_draw = {218,444,42,28},
	s_edit_thu_draw = {261,444,37,28},
	s_edit_fri_draw = {298,444,37,28},
	s_edit_sat_draw = {336,444,37,28},

	s_edit_record_ok_xywh = {234,483,64,28},
	s_edit_record_export_xywh = {309,483,64,28},

	s_edit_record_list_xywh = {26,177,346,256},
	s_edit_record_list_w1 = {80,0,0,0},
	s_edit_record_list_w2 = {80,0,0,0},
	s_edit_record_list_w3 = {176,0,0,0},

	s_edit_record_cap_copy_draw = {26,440,128,35},
	s_edit_record_copy_draw = {154,177,202,35},
	s_event_table_btn_xywh = {0,0,20,26},
};

w1_edit_record.s_1280 = 
{
	s_edit_record_xywh= {300,150,740,740},
	s_edit_record_titleimg_xywh = {13,15,24,24}, 
	s_edit_record_alarm_xywh= {50,12,685, 40},
	s_edit_record_close_xywh=  {700,15,24,24},
	s_edit_record_draw= {0,58,0,1},
	
	s_edit_record_cap_date_xywh = {50,70,240,50},
	s_edit_record_t_date_xywh = {290,70,410,50},
	s_edit_record_cap_recode_xywh = {50,130,240,50},
	s_edit_record_t_recode_xywh = {290,130,410,50},
	
	s_edit_record_cap_rule_xywh = {50,190,240,50},
	s_edit_record_t_rule_xywh = {290,190,410,50},
	
	s_edit_record_ok_xywh = {440,690,120,40},

	s_edit_record_export_xywh = {580,690,120,40},
	
	s_edit_record_cap_copy_draw = {50,620,240,50},
	s_edit_record_copy_draw = {290,250,380,50},
	s_event_table_btn_xywh = {0,0, 40,40},
	
	s_edit_record_list_xywh = {50,250,650,360},
	s_edit_record_list_w1={200,0,0,0},
	s_edit_record_list_w2={250,0,0,0},
	s_edit_record_list_w3={180,0,0,0},
	
	s_edit_sun_draw = {200,625,70,40},
	s_edit_mon_draw = {270,625,70,40},
	s_edit_tue_draw = {340,625,70,40},
	s_edit_wed_draw = {410,625,80,40},
	s_edit_thu_draw = {490,625,70,40},
	s_edit_fri_draw = {560,625,70,40},
	s_edit_sat_draw = {630,625,70,40},
};
w1_edit_record.s_1440 = 
{
	s_edit_record_xywh= {370,100,750,740},
	s_edit_record_titleimg_xywh = {13,15,24,24}, 
	s_edit_record_alarm_xywh= {50,12,690, 40},
	s_edit_record_close_xywh=  {710,15,24,24},
	s_edit_record_draw= {0,58,0,1},
	
	s_edit_record_cap_date_xywh = {50,70,240,50},
	s_edit_record_t_date_xywh = {290,70,410,50},
	s_edit_record_dir_xywh = {700,70,50,50},
	
	s_edit_record_cap_recode_xywh = {50,130,240,50},
	s_edit_record_t_recode_xywh = {290,130,410,50},
	s_edit_record_t_port_xywh = {450,130,250,50},
	
	s_edit_record_cap_rule_xywh = {50,190,240,50},
	s_edit_record_t_rule_xywh = {290,190,410,50},
	
	s_edit_record_ok_xywh = {440,680,120,40},

	s_edit_record_export_xywh = {580,680,120,40},
	
	s_edit_record_cap_copy_draw = {50,620,240,50},
	s_edit_record_copy_draw = {290,250,380,50},
	s_event_table_btn_xywh = {0,0, 40,40},
	
	s_edit_record_list_xywh = {50,250,650,360},
	s_edit_record_list_w1={200,0,0,0},
	s_edit_record_list_w2={250,0,0,0},
	s_edit_record_list_w3={180,0,0,0},
	
	s_edit_sun_draw = {200,625,70,40},
	s_edit_mon_draw = {270,625,70,40},
	s_edit_tue_draw = {340,625,70,40},
	s_edit_wed_draw = {410,625,80,40},
	s_edit_thu_draw = {490,625,70,40},
	s_edit_fri_draw = {560,625,70,40},
	s_edit_sat_draw = {630,625,70,40},

};
w1_edit_record.s_1080p = 
{
	s_edit_record_xywh= {570,180,750,740},
	s_edit_record_titleimg_xywh = {13,15,24,24}, 
	s_edit_record_alarm_xywh= {50,12,690, 40},
	s_edit_record_close_xywh=  {710,15,24,24},
	s_edit_record_draw= {0,58,0,1},
	
	s_edit_record_cap_date_xywh = {50,70,240,50},
	s_edit_record_t_date_xywh = {290,70,410,50},

	s_edit_record_cap_recode_xywh = {50,130,240,50},
	s_edit_record_t_recode_xywh = {290,130,410,50},
	s_edit_record_cap_rule_xywh = {50,190,240,50},
	s_edit_record_t_rule_xywh = {290,190,410,50},
	
	s_edit_sun_draw = {200,625,70,40},
	s_edit_mon_draw = {270,625,70,40},
	s_edit_tue_draw = {340,625,70,40},
	s_edit_wed_draw = {410,625,80,40},
	s_edit_thu_draw = {490,625,70,40},
	s_edit_fri_draw = {560,625,70,40},
	s_edit_sat_draw = {630,625,70,40},
	
	s_edit_record_ok_xywh = {440,680,120,40},
	s_edit_record_export_xywh = {580,680,120,40},
	
	s_edit_record_list_xywh = {50,250,650,360},
	s_edit_record_list_w1={150,0,0,0},
	s_edit_record_list_w2={150,0,0,0},
	s_edit_record_list_w3={330,0,0,0},
	
	s_edit_record_cap_copy_draw = {50,620,240,50},
	s_edit_record_copy_draw = {290,250,380,50},
	s_event_table_btn_xywh = {0,0, 40,40},

};
w1_edit_record.s_2k = 
{
	s_edit_record_t_rule_xywh = {385,252,545,66},
	s_edit_record_t_recode_xywh = {385,172,545,66},
	s_edit_record_close_xywh = {944,19,31,31},
	s_edit_record_list_w1 = {199,0,0,0},
	s_edit_record_list_xywh = {66,332,864,478},
	s_edit_record_xywh = {758,239,997,984},
	s_event_table_btn_xywh = {0,0,53,53},
	s_edit_record_export_xywh = {771,904,159,53},
	s_edit_record_ok_xywh = {585,904,159,53},
	s_edit_mon_draw = {359,831,93,53},
	s_edit_record_list_w3 = {438,0,0,0},
	s_edit_wed_draw = {545,831,106,53},
	s_edit_fri_draw = {744,831,93,53},
	s_edit_record_titleimg_xywh = {17,19,31,31},
	s_edit_record_draw = {0,77,0,1},
	s_edit_record_copy_draw = {385,332,505,66},
	s_edit_record_cap_copy_draw = {66,824,319,66},
	s_edit_record_cap_recode_xywh = {66,172,319,66},
	s_edit_tue_draw = {452,831,93,53},
	s_edit_record_t_date_xywh = {385,93,545,66},
	s_edit_sat_draw = {837,831,93,53},
	s_edit_record_cap_rule_xywh = {66,252,319,66},
	s_edit_record_cap_date_xywh = {66,93,319,66},
	s_edit_thu_draw = {651,831,93,53},
	s_edit_record_list_w2 = {199,0,0,0},
	s_edit_sun_draw = {266,831,93,53},
	s_edit_record_alarm_xywh = {66,15,920,53},
};
w1_edit_record.s_4k = 
{
	s_edit_record_t_rule_xywh = {580,380,820,100},
	s_edit_record_t_recode_xywh = {580,260,820,100},
	s_edit_record_close_xywh = {1420,30,48,48},
	s_edit_record_list_w1 = {300,0,0,0},
	s_edit_record_list_xywh = {100,500,1300,720},
	s_edit_record_xywh = {1140,360,1500,1480},
	s_event_table_btn_xywh = {0,0,80,80},
	s_edit_record_export_xywh = {1160,1360,240,80},
	s_edit_record_ok_xywh = {880,1360,240,80},
	s_edit_mon_draw = {540,1250,140,80},
	s_edit_record_list_w3 = {660,0,0,0},
	s_edit_wed_draw = {820,1250,160,80},
	s_edit_fri_draw = {1120,1250,140,80},
	s_edit_record_titleimg_xywh = {26,30,48,48},
	s_edit_record_draw = {0,116,0,2},
	s_edit_record_copy_draw = {580,500,760,100},
	s_edit_record_cap_copy_draw = {100,1240,480,100},
	s_edit_record_cap_recode_xywh = {100,260,480,100},
	s_edit_tue_draw = {680,1250,140,80},
	s_edit_record_t_date_xywh = {580,140,820,100},
	s_edit_sat_draw = {1260,1250,140,80},
	s_edit_record_cap_rule_xywh = {100,380,480,100},
	s_edit_record_cap_date_xywh = {100,140,480,100},
	s_edit_thu_draw = {980,1250,140,80},
	s_edit_record_list_w2 = {300,0,0,0},
	s_edit_sun_draw = {400,1250,140,80},
	s_edit_record_alarm_xywh = {100,24,1380,80},
};

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local updatelist = function(top, redraw)
	local data = {}
	if w1_edit_record.record_data~=nil then
		data = w1_edit_record.record_data
	else
		data = b_app_api.get_cfg({'record'})
	end
	
	local day = b_wnd_ex.get_sel(top,w1_edit_record.dlg.t_date.id)+1
	local channel = "channel1"
	local day_str = "weekday"..day
	local record_type = 0;
	local half_hour = 0;
	local s_time = 0
	local time_seh = {}
	local idx = 1
	local displist = {}
	for i=1,6 do
		for j=1,8 do	
			record = b_app_api.get_record_type({data['record'][channel][day_str][i],j-1})
			
			if record ~= record_type and half_hour~=0  and idx<9 then			
				--.insert(time_seh,record)
				displist['idx'..idx] = {idx-1,s_time*1800,half_hour*1800,record_type};
				idx = idx + 1
				s_time = half_hour
			end
			half_hour = half_hour + 1;
			record_type = record 
		end
	end
	
	if s_time~= half_hour and idx<9 then
		displist['idx'..idx] = {idx-1,s_time*1800,half_hour*1800-60,record};
	end
 	for i=idx+1,8 do
		displist['idx'..i] = {i-1,0,0,0};
	end
	displist.item_total = 8;
	b_wnd_ex.set_custom_list_data(top, w1_edit_record.dlg.list.id, displist, redraw);	
end

local on_dlg = function(top, id, vmsg, x, y)
	
	return 0
end


local on_day = function(top, id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local check = b_wnd_ex.get_sel(top,id)
		local sid = w1_edit_record.dlg.sun.id
		for i=0,6 do
			b_wnd_ex.set_disable(top,sid+i,false,false)
		end
		b_wnd_ex.set_disable(top,sid+check,true,false)
		b_wnd_ex.set_check(top,sid+check,false,false)
		updatelist(top,false)
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_time_type = function(top, id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local check = b_wnd_ex.get_sel(top,id)
		if check==0 then
			b_wnd_ex.set_hide(top,w1_edit_record.dlg.list.id,false,false)
			b_wnd_ex.set_disable(top,w1_edit_record.dlg.t_rule.id,true,false)
		else
			b_wnd_ex.set_hide(top,w1_edit_record.dlg.list.id,true,false)	
			b_wnd_ex.set_disable(top,w1_edit_record.dlg.t_rule.id,false,false)	
		end
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end
local on_type = function(top, id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then

	end
	return 0
end

w1_edit_record.set_channel = function (channel)
	chn_id = channel
end

w1_edit_record.get_record_data = function ()
	return temp_data
end

w1_edit_record.set_func  = function(ok_func, okfunc_param, cannel_func, cancelfunc_param,data)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')
	assert(cannel_func == nil or type(cannel_func) == 'function')
	assert(cancelfunc_param == nil or type(cancelfunc_param) == 'table')
--[[	if(w1_edit_record.record_data == nil) then
		w1_edit_record.record_data = util.copy_tab(data);
	else
		util.copy_tab_b(w1_edit_record.record_data, data);		
	end--]]
	w1_edit_record.record_data = data
	chn_id = okfunc_param[1]
	w1_edit_record.ok_func = ok_func;
	w1_edit_record.cannel_func = cannel_func;
	
	if (w1_edit_record.okfunc_param  ==  nil) then
		w1_edit_record.okfunc_param = okfunc_param;
	else
		if(okfunc_param == nil) then
			w1_edit_record.okfunc_param = nil;
		elseif(type(okfunc_param) == 'table') then
			util.copy_tab_b(w1_edit_record.okfunc_param, okfunc_param);		
		end
	end
	
	if (w1_edit_record.cannelfunc_param  ==  nil) then
		w1_edit_record.cannelfunc_param = cancelfunc_param;
	else
		if(cancelfunc_param == nil) then
			w1_edit_record.cannelfunc_param = nil;
		elseif(type(okfunc_param) == 'table') then
			util.copy_tab_b(w1_edit_record.cannelfunc_param, cancelfunc_param);		
		end	
	end
end

local updaterecord_data = function (top)
		local listdata = b_wnd_ex.get_custom_list_data(top,w1_edit_record.dlg.list.id).custom_list_data
		temp_data = w1_edit_record.record_data 
		local day = b_wnd_ex.get_sel(top,w1_edit_record.dlg.t_date.id)+1
		local time_type = b_wnd_ex.get_sel(top,w1_edit_record.dlg.t_recode.id)
		local record_type = b_wnd_ex.get_sel(top,w1_edit_record.dlg.t_rule.id)
		local channel = "channel"..chn_id
		local w_time ={};
		local day_time = {0,0,0,0,0,0}
		local sum ={0,0,0,0,0,0,0,0}
		for i=1,48 do
			w_time[i]=-1
		end
		ok_flag = false;
		if time_type==0 then
			for i=1,8 do
					if tonumber(listdata['list'..i][1])<tonumber(listdata['list'..i][2]) then
						local s_half_hour = tonumber(listdata['list'..i][1])/1800
						local e_half_hour = tonumber(listdata['list'..i][2])/1800
						if tonumber(listdata['list'..i][2])>84600 then
							e_half_hour = 48
						end
						local r_type = tonumber(listdata['list'..i][3])
						for j=s_half_hour,e_half_hour-1 do
							if w_time[j+1]~=-1 then
								ok_flag = true
							end
							w_time[j+1] = r_type		
						end		
					end
			end
			for i=1,48 do
				if w_time[i]==-1 then
					w_time[i]=0
				end
			end
		else
			for i=1,48 do
				w_time[i]=record_type
			end
		end
		
		if ok_flag then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_RECORD_RULE_TIP'), true, false,false);
		--	w1_msgbox.set_attach_dlgattr(STR('LA_WAIT_STOP_DETECT'));
			w1_msgbox.set_func(nil,nil, nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		else
			local idx = 1
			--16תΪ10
			for i=1,6 do
				for j=8,1,-1 do
					idx = tonumber(i*8+j-8)
					for k=j-1,1,-1 do--lua 5.1 math xyݺ
						if sum[j]==0 then
							sum[j]= w_time[idx]*16
						else
							sum[j]= sum[j]*16
						end
					end
					day_time[i] = day_time[i]+sum[j]
					sum[j]=0;
				end
				day_time[i] = day_time[i]+w_time[idx] --һλϣ0η
			end
			
			for i=1,6 do
				temp_data['record'][channel]["weekday"..day][i] = day_time[i]
			end
			
			local sid = w1_edit_record.dlg.sun.id
			for i=0,6 do
				local check = b_wnd_ex.get_check(top,sid+i)
				if check then
					util.copy_tab_b(temp_data['record'][channel]["weekday"..(i+1)],temp_data['record'][channel]["weekday"..day])
				end
			end
		end
end

local on_copy = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local day = b_wnd_ex.get_sel(top,w1_edit_record.dlg.t_date.id)+1
		local idx = 1 
		local param = {}
		for i=1, 8 do
			if( i ~= day) then
				param[idx] = i;
				idx =idx + 1;
			end
		end
	end
	return 0
end

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		updaterecord_data(top)
		if w1_edit_record.ok_func~=nil then
			w1_edit_record.ok_func(w1_edit_record.okfunc_param)
		end
		if ok_flag==false then
			b_dlg.end_modal(top);	
		end
	end
	return 0
end

w1_edit_record.on_create = function(top)
	local dlg = {
		attr = {},
		sub = nil
	}	
	id = w1_id.edit_record_id
	dlg.attr.xywh='s_edit_record_xywh';

	dlg.sub = {	'img','network','close','alarm_out','line1','line2','line3','edit_record_start','edit_record_stop','state','list',
				'cap_date','t_date','cap_recode','packet','t_recode','cap_rule','t_rule','ok','cap_copy_table'
				,'sun','mon','tue','wed','thu','fri','sat',--[['all'--]]};
				
	dlg.img	= {t='tt_button',id=id+1,xywh = 's_edit_record_titleimg_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_editcameera','it_editcameera', 'it_editcameera'},
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
					color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
	};

	dlg.network	= {t='static', 	id=id+2,xywh='s_edit_record_alarm_xywh', 
					text='LA_EDIT',font = 'f_grade4', align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
				};
					
	dlg.close 	= {t='tt_button',id=id+3,xywh = 's_edit_record_close_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
					color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_f'},
					cmd=on_close,
	};
	dlg.cap_date	= {t='static', 	id=id+4,xywh='s_edit_record_cap_date_xywh', 
					text='LA_DATE',font = 'f_grade4', align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
				};
	dlg.t_date	= {t='combox', 	id=id+5,xywh='s_edit_record_t_date_xywh', 
					items={'LA_SUNDAY','LA_MONDAY','LA_TUESDAY','LA_WEDNESDAY','LA_THURSDAY','LA_FRIDAY','LA_SATURDAY'},
				font = 'f_grade4', align = b_ui.ALIGN.LEFT,cmd = on_day,
				};

	dlg.cap_recode	= {t='static', 	id=id+6,xywh='s_edit_record_cap_recode_xywh', 
					text='LA_NORMAL_RECORD',font = 'f_grade4', align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},	};
	dlg.t_recode = {t='combox',id=id+7,	xywh='s_edit_record_t_recode_xywh',items={'LA_CUSTOM','LA_FULL_RECORD'},cmd = on_time_type};


	dlg.cap_rule	= {t='static', 	id=id+8,xywh='s_edit_record_cap_rule_xywh', 
					text='LA_RECORD_RULE',font = 'f_grade4', align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'}};
	dlg.t_rule = {t='combox',id=id+9,	xywh='s_edit_record_t_rule_xywh',
					items={'LA_NONE','LA_CONTINUOUS','LA_ALARM','LA_MOTION_D','LA_IO','LA_MOTION_OR_IO','LA_MOTION_AND_IO'},cmd = on_type};
				
	dlg.ok 	= {t='button',id=id+10,	xywh = 's_edit_record_ok_xywh', 	text='LA_OK',cmd=on_ok,};
	dlg.cap_copy_table	= {t='static', 	id=id+11,xywh='s_edit_record_cap_copy_draw', 
					text='LA_COPY',font = 'f_grade4', align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},	};
	dlg.all = {t='checkbox',id=id+12,xywh='s_edit_all_draw',check=false,font='f_grade6',text='LA_ALL',color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'},};
	dlg.sun = {t='checkbox',id=id+13,xywh='s_edit_sun_draw',check=false,font='f_grade6',text='LA_WEEK_SUNDAY',
			color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'},
			color_d = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'}};
	dlg.mon = {t='checkbox',id=id+14,xywh='s_edit_mon_draw',check=false,font='f_grade6',text='LA_WEEK_MONDAY',
			color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'},
			color_d = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'}};
	dlg.tue = {t='checkbox',id=id+15,xywh='s_edit_tue_draw',check=false,font='f_grade6',text='LA_WEEK_TUESDAY',
			color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'},
			color_d = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'}};
	dlg.wed = {t='checkbox',id=id+16,xywh='s_edit_wed_draw',check=false,font='f_grade6',text='LA_WEEK_WEDNESDAY',
			color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'},
			color_d = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'}};
	dlg.thu = {t='checkbox',id=id+17,xywh='s_edit_thu_draw',check=false,font='f_grade6',text='LA_WEEK_THURSDAY',
			color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'},
			color_d = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'}};
	dlg.fri = {t='checkbox',id=id+18,xywh='s_edit_fri_draw',check=false,font='f_grade6',text='LA_WEEK_FRIDAY',
			color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'},
			color_d = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'}};
	dlg.sat = {t='checkbox',id=id+19,xywh='s_edit_sat_draw',check=false,font='f_grade6',text='LA_WEEK_SATURDAY',
			color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'},
			color_d = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'}};
	dlg.packet 	= {t='button',id=id+20,	xywh = 's_edit_record_export_xywh', 	text='LA_CANCEL',cmd=on_close,};
	
	dlg.list =  {t='custom_list',	id=id+21,xywh='s_edit_record_list_xywh', font = 'f_grade4',
					listattr = {6,3,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},
					item_type = {b_ui.TIMEEDIT,b_ui.TIMEEDIT,b_ui.COMBOX},
					columns_w = {150,150,180},};

	w1_edit_record.top = top
	w1_edit_record.dlg = dlg
	
	--UIڳʼ
	b_parser(top, w1_edit_record.dlg)
	updatelist(top,false)
	b_wnd_ex.set_custom_combox_item(top,w1_edit_record.dlg.list.id,{1,STR('LA_NONE'),STR('LA_CONTINUOUS'),STR('LA_ALARM'),STR('LA_MOTION_D'),STR('LA_IO'),STR('LA_MOTION_OR_IO'),STR('LA_MOTION_AND_IO')},false)
	b_wnd.set_no_find(top, w1_edit_record.dlg.network.id, true); ---ñ⾲̬ıɱ
	--b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	return 0
end

w1_edit_record.on_destroy = function(top)
	w1_edit_record.top = nil
	w1_edit_record.dlg = nil
	--b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0
end

w1_edit_record.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_edit_record_draw');
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	b_wnd.draw_fill(top, x, y+wndsize[2], cx, wndsize[4], COLOR('c_hline_color'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_edit_record.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);	
	end
	return 0
end

w1_edit_record.on_pre_show = function (top)
	local param = {
			STR('LA_START_TIME'), STR('LA_END_TIME'),STR('LA_RECORD_RULE')}
	b_wnd_ex.set_title_texts(top, w1_edit_record.dlg.list.id, param, false);
	local list_w = {};
		for i=1,3 do
			local str = 's_edit_record_list_w'..math.floor(i/1);
			list_w[i] = SIZE(str)[1];
		end
	b_wnd_ex.columns_w(top, w1_edit_record.dlg.list.id, list_w, false);
	reflsh_btn = true
	b_wnd_ex.set_disable(top,w1_edit_record.dlg.t_rule.id,true,false)
	b_wnd_ex.set_disable(top,w1_edit_record.dlg.sun.id,true,false)
	return 0;
end

return w1_edit_record




