local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local cfg_settings = require("wnd.w1_cfg.w1_cfg_settings")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.toolbar.menu_id
local w1_key 	= require("wnd.w1_util.w1_key")
local b_app_cfg = require("wnd.core.b_app_cfg")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_api = require("wnd.core.command.b_app_api")
local global_val= require("wnd.global_val")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_size	= require("wnd.core.r_res.r_size")
local util 		= require("wnd.core.util")
local SIZE 	= r_size.get_size
local w1_home_menu = {
	t = w1_key.DLG_HOME_MENU,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_home_menu.s_768 =
{
	s_home_menu_xywh = {2,386,130,354},
	s_home_menu_item_xywh = {0,0,126,50},
	s_home_menu_user_xywh = {2,2,126,50},
	s_home_menu_search_xywh = {2,52,126,50},
	s_home_menu_face_recognition_xywh = {2,102,126,50},
	s_home_menu_atte_xywh = {2,152,126,50},
	s_home_menu_thermal_xywh = {2,202,126,50},
	s_home_menu_setting_xywh = {2,252,126,50},
	s_home_menu_shutdown_xywh = {2,302,126,50},
};

w1_home_menu.s_1280 = 
{
	s_home_menu_xywh = {3,488,244,496},
	s_home_menu_item_xywh = {0, 0, 238, 70},
	s_home_menu_user_xywh= {3,3,238,70},
	s_home_menu_search_xywh= {3,73,238,70},
	s_home_menu_face_recognition_xywh= {3,143,238,70},
	s_home_menu_atte_xywh= {3,213,238,70},
	s_home_menu_thermal_xywh= {3,283,238,70},
	s_home_menu_setting_xywh= {3,353,238,70},
	s_home_menu_shutdown_xywh = {3,423,238,70},
};

w1_home_menu.s_1440 = 
{
	s_home_menu_xywh = {3,364,244,496},
	s_home_menu_item_xywh = {0, 0, 238, 70},
	s_home_menu_user_xywh= {3,3,238,70},
	s_home_menu_search_xywh= {3,73,238,70},
	s_home_menu_face_recognition_xywh= {3,143,238,70},
	s_home_menu_atte_xywh= {3,213,238,70},
	s_home_menu_thermal_xywh= {3,283,238,70},
	s_home_menu_setting_xywh= {3,353,238,70},
	s_home_menu_shutdown_xywh = {3,423,238,70},
};

w1_home_menu.s_1080p = 
{
	s_home_menu_xywh = {3,544,244,496},
	s_home_menu_item_xywh = {0, 0, 238, 70},
	s_home_menu_user_xywh= {3,3,238,70},
	s_home_menu_search_xywh= {3,73,238,70},
	s_home_menu_face_recognition_xywh= {3,143,238,70},
	s_home_menu_atte_xywh= {3,213,238,70},
	s_home_menu_thermal_xywh= {3,283,238,70},
	s_home_menu_setting_xywh= {3,353,238,70},
	s_home_menu_shutdown_xywh = {3,423,238,70},
};  
w1_home_menu.s_2k = 
{   
	s_home_menu_xywh = {4,725,325,661},
	s_home_menu_item_xywh = {0, 0, 317, 93},
	s_home_menu_user_xywh= {4,4,317,93},
	s_home_menu_search_xywh= {4,97,317,93},
	s_home_menu_face_recognition_xywh= {4,190,317,93},
	s_home_menu_atte_xywh= {4,283,317,93},
	s_home_menu_thermal_xywh= {4,376,317,93},
	s_home_menu_setting_xywh= {4,469,317,93},
	s_home_menu_shutdown_xywh = {4,562,317,93},
};  
w1_home_menu.s_4k = 
{   	
	s_home_menu_xywh = {6,1088,488,992},
	s_home_menu_item_xywh = {0, 0, 476, 140},
	s_home_menu_user_xywh= {6,6,476,140},
	s_home_menu_search_xywh= {6,146,476,140},
	s_home_menu_face_recognition_xywh= {6,286,476,140},
	s_home_menu_atte_xywh= {6,426,476,140},
	s_home_menu_thermal_xywh= {6,566,476,140},
	s_home_menu_setting_xywh= {6,706,476,140},
	s_home_menu_shutdown_xywh = {6,846,476,140},
};



local on_user = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		
	end
	return 0;
end

local on_search = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local privilege = global_val.get_allprivilege();--ȡȨ
		if ((privilege.playback == true) and (false == global_val.get_isallprizero(privilege.playback_list))) then	
			return b_ui_msg.msg_on_search;
		end
	end
	return 0;
end

local on_thermal = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local privilege = global_val.get_allprivilege();--ȡȨ
		if ((privilege.thermal == true) and (false == global_val.get_isallprizero(privilege.thermal_list))) then
			return b_ui_msg.ms_on_thermal;
		end		
	end
	return 0;
end

local on_face_recognition = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local privilege = global_val.get_allprivilege();--ȡȨ
		if (true == privilege.face_recognition) then
			return b_ui_msg.msg_on_face_recognition;
		end
	end
	return 0;
end

local on_attendance = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local privilege = global_val.get_allprivilege();--ȡȨ
		if (true == privilege.face_recognition)  then	
			return b_ui_msg.msg_on_attendance;
		else		

		end
	end
	return 0;
end

local on_setting = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		return b_ui_msg.msg_setting;
	end
	return 0;
end

local on_shutdown = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		return b_ui_msg.msg_on_shutdown;
	end
	return 0;
end

local dlg = {
	attr = {xywh='s_home_menu_xywh'},
	sub = {'user', 'search', 'face_recognition','attendance', 'thermal','setting', 'shutdown'},
	user 	= {t='tt_button',id=id+1,xywh='s_home_menu_user_xywh',text='admin      ', align = b_ui.ALIGN.LEFT,trans = false,cmd=on_user,
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_user','it_user_f', 'it_user'},
				},
	search 	= {t='tt_button',id=id+2,xywh='s_home_menu_search_xywh',text='LA_PLAYBACK_T', align = b_ui.ALIGN.LEFT,cmd=on_search, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_home_playback','it_home_playback_f', 'it_home_playback'},
				},
	face_recognition = {t='tt_button',id=id+3,xywh='s_home_menu_face_recognition_xywh',text='LA_AI_RECOGNITION', align = b_ui.ALIGN.LEFT,cmd=on_face_recognition, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_face_recogniton','it_face_recogniton_f', 'it_face_recogniton'},
				},
	attendance = {t='tt_button',id=id+4,xywh='s_home_menu_atte_xywh',text='LA_ATTENDANCE', align = b_ui.ALIGN.LEFT,cmd=on_attendance, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_atte','it_atte_f', 'it_atte'},
				},
	thermal 	= {t='tt_button',id=id+5,xywh='s_home_menu_thermal_xywh',text='LA_THERMAL', align = b_ui.ALIGN.LEFT,cmd=on_thermal, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_thermal','it_thermal_f', 'it_thermal'},
				},	
	setting = {t='tt_button',id=id+6,xywh='s_home_menu_setting_xywh',text='LA_SYSTEM', align = b_ui.ALIGN.LEFT,cmd=on_setting, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_settings','it_settings_f', 'it_settings'},
				},
	shutdown= {t='tt_button',id=id+7,xywh='s_home_menu_shutdown_xywh',text='LA_POWER_SUPPLY', align = b_ui.ALIGN.LEFT,cmd=on_shutdown, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_shutdown','it_shutdown_f', 'it_shutdown'},
				t_opt_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_more_menu','it_more_menu_f', 'it_more_menu'},
				},
}

local reset_id = function(wnd_id)
	for i = 1, #w1_home_menu.dlg.sub do
		local item = w1_home_menu.dlg.sub[i];
		w1_home_menu.dlg[item].id = wnd_id + i
	end
end
	
local update_layout_info = function(top)
	local cwnd = w1_home_menu.dlg;
	local pb_flag = global_val.get_playback_support();
	local face_flag = global_val.get_support_face_attr();
	local attendance_flag = global_val.get_support_attendance_attr();
	local thermal_flag = global_val.get_support_thermal_attr();
	local item_size = SIZE('s_home_menu_item_xywh')
	local move_h = 0;
	local pos = nil;
	local wnd_id = w1_home_menu.dlg['user'].id	- 1;
	
	if (pb_flag ~= true) then --֧¼ط(Ʒ)
		move_h = item_size[4];
		b_wnd_ex.set_hide(top, cwnd.search.id, true, false); --¼
		local s_id = cwnd.face_recognition.id; 
		local e_id = cwnd.shutdown.id;
		for i = s_id, e_id do
			pos = SIZE(cwnd[cwnd.sub[i - wnd_id]].xywh);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end
	end

	if (face_flag ~= true) then --֧
		move_h = move_h + item_size[4];
		b_wnd_ex.set_hide(top, cwnd.face_recognition.id, true, false); --
		local s_id = cwnd.attendance.id; 
		local e_id = cwnd.shutdown.id;
		for i = s_id, e_id do
			pos = SIZE(cwnd[cwnd.sub[i - wnd_id]].xywh);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end
	end
	
	if (attendance_flag ~= true) then --ֿ֧
		move_h = move_h + item_size[4];
		b_wnd_ex.set_hide(top, cwnd.attendance.id, true, false); --ؿ
		local s_id = cwnd.thermal.id; 
		local e_id = cwnd.shutdown.id;
		for i = s_id, e_id do
			pos = SIZE(cwnd[cwnd.sub[i - wnd_id]].xywh);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end
	end
	
	if (thermal_flag ~= true) then --֧ ȳ
		move_h = move_h + item_size[4];
		b_wnd_ex.set_hide(top, cwnd.thermal.id, true, false); --ȳ
		local s_id = cwnd.setting.id; 
		local e_id = cwnd.shutdown.id;
		for i = s_id, e_id do
			pos = SIZE(cwnd[cwnd.sub[i - wnd_id]].xywh);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end		
	end
	
	if (0 < move_h) then
		local dlg_size = util.copy_tab(SIZE('s_home_menu_xywh'));	
		dlg_size[2] = dlg_size[2] + move_h;
		dlg_size[4] = dlg_size[4] - move_h;
		b_wnd_ex.move_ex(top, wnd_id, dlg_size, false); -- Ľ治Ƕ㴰 ʹmove_ex
	end
end		
	
w1_home_menu.on_create = function(top, wnd_id)
	assert(wnd_id ~= nil);
	w1_home_menu.top = top
	w1_home_menu.dlg = dlg
	
	if (wnd_id ~= 0) then
		reset_id(wnd_id)
		b_parser(top, w1_home_menu.dlg, wnd_id)
	else	
		b_parser(top, w1_home_menu.dlg)
	end	
	
	update_layout_info(top);
	
	return 0
end

w1_home_menu.on_destroy = function(top)
	w1_home_menu.top = nil
	w1_home_menu.dlg = nil
	return 0
end

w1_home_menu.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_bk'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	local cwnd = w1_home_menu.dlg;
	local sid = cwnd.user.id;
	local eid = cwnd.shutdown.id;
	
	local param;
	--¼ɫ
	for i=sid, eid do
		param = {COLOR('c_btn_n'), COLOR('c_btn_n'), COLOR('c_btn_text_n') }
		b_wnd_ex.set_color(top, i, param, false);
		if (sid == i) then
			param = {COLOR('c_btn_n'), COLOR('c_btn_n'), COLOR('c_btn_text_n') }
			b_wnd_ex.set_color_f(top, i, param, false);		
		else
			param = {COLOR('c_btn_f'), COLOR('c_btn_f'), COLOR('c_btn_text_f') }
			b_wnd_ex.set_color_f(top, i, param, false);		
		end
	end
	--¼ط
	b_wnd_ex.set_text(top, cwnd.search.id, STR('LA_PLAYBACK_T'), false);
	b_wnd_ex.set_text(top, cwnd.face_recognition.id, STR('LA_AI_RECOGNITION'), false);		
	b_wnd_ex.set_text(top, cwnd.attendance.id, STR('LA_ATTENDANCE'), false);
	b_wnd_ex.set_text(top, cwnd.thermal.id, STR('LA_THERMAL'), false);	
	b_wnd_ex.set_text(top, cwnd.setting.id, STR('LA_SYSTEM'), false);
	b_wnd_ex.set_text(top, cwnd.shutdown.id, STR('LA_POWER_SUPPLY'), false);
	
	local color = {COLOR('c_btn_n'), COLOR('c_btn_n'), COLOR('c_btn_text_n')}	
	local color_d = {COLOR('c_btn_n'), COLOR('c_btn_n'), COLOR('c_txt_d')}
	local color_f = {COLOR('c_btn_f'), COLOR('c_btn_f'), COLOR('c_btn_text_f')}
	local privilege = global_val.get_allprivilege();
	
	if ((privilege.thermal == false) or (true == global_val.get_isallprizero(privilege.thermal_list))) then
        b_wnd_ex.set_color(top, cwnd.thermal.id, color_d, false);
		b_wnd_ex.set_color_f(top, cwnd.thermal.id, color_d, false);	
	else
		 b_wnd_ex.set_color(top, cwnd.thermal.id, color, false);
		b_wnd_ex.set_color_f(top, cwnd.thermal.id, color_f, false);	
	end
	
	if ((privilege.playback == false) or (true == global_val.get_isallprizero(privilege.playback_list))) then
        b_wnd_ex.set_color(top, cwnd.search.id, color_d, false);
		b_wnd_ex.set_color_f(top, cwnd.search.id, color_d, false);	
	else
		 b_wnd_ex.set_color(top, cwnd.search.id, color, false);
		b_wnd_ex.set_color_f(top, cwnd.search.id, color_f, false);	
	end
	
	if (privilege.face_recognition == false) then
		b_wnd_ex.set_color(top, cwnd.face_recognition.id, color_d, false);
		b_wnd_ex.set_color_f(top,cwnd.face_recognition.id, color_d, false);
		b_wnd_ex.set_color(top, cwnd.attendance.id, color_d, false);
		b_wnd_ex.set_color_f(top,cwnd.attendance.id, color_d, false);	     
	else
		b_wnd_ex.set_color(top, cwnd.face_recognition.id, color, false);
		b_wnd_ex.set_color_f(top, cwnd.face_recognition.id, color_f, false);	
		b_wnd_ex.set_color(top, cwnd.attendance.id,color, false);
		b_wnd_ex.set_color_f(top, cwnd.attendance.id,color_f, false);		
	end		
	
	--û
	local user_info	= global_val.get_current_user_info();--ȡԭʼ
	assert(user_info ~= nil and "table" == type(user_info))
	b_wnd_ex.set_text(top, w1_home_menu.dlg.user.id, user_info.m_strUsername, false)
	
	return 0
end

w1_home_menu.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui.RBUTTONCLK == vmsg) then
		local size = SIZE(w1_home_menu.dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			
		else
			b_dlg.end_modal(top);
		end
	end
	return 0
end

return w1_home_menu


