﻿local global_val= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.login.login_g_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_app_cfg	= require("wnd.core.b_app_cfg")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local r_str		= require("wnd.core.r_res.r_str")
local w1_login	= require("wnd.w1_live.w1_login")
local STR 		= r_str.get_str
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local err_stat = 0;
local err_str;
local flag = 0;
local err_login_user_lock = -515;

local w1_login_pattern = {
	t = w1_key.DLG_LOGIN_G,
	top = nil,
	dlg = nil,
	is_show	 = false,
	mouse_last_opt_time;		--鼠标上次操作时间
	err_count,
	check_verification,
	change_logintype = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_login_pattern.s_768 =
{
	s_login_pattern_page_xywh = {400,161,224,444},
	s_login_pattern_img_xywh = {82,21,58,78},
	s_login_pattern_user_xywh = {58,103,106,35},
	s_login_pattern_t_pattern_xywh = {29,142,165,220},
	s_login_pattern_t_pwd_xywh = {5,405,106,32},
	s_login_pattern_forget_xywh = {112,405,106,32},
	s_login_pattern_draw_xywh = {1,36,1,1},
	s_login_pattern_tipinfo_xywh = {5,369,213,32},
};

w1_login_pattern.s_1280 = 
{
	s_login_pattern_page_xywh= {430,227,420,625},
	s_login_pattern_img_xywh= {155,30,110,110},
	s_login_pattern_user_xywh= {110,145,200,50},
	s_login_pattern_t_pattern_xywh= {55,200,310,310},
	s_login_pattern_t_pwd_xywh= {10,570,200,45},
	s_login_pattern_forget_xywh= {210,570,200,45},
	s_login_pattern_draw_xywh= {1,51,2,1},
	s_login_pattern_tipinfo_xywh= {10,520,400,45},
};

w1_login_pattern.s_1440 = 
{
	s_login_pattern_page_xywh= {510,137,420,625},
	s_login_pattern_img_xywh= {155,30,110,110},
	s_login_pattern_user_xywh= {110,145,200,50},
	s_login_pattern_t_pattern_xywh= {55,200,310,310},
	s_login_pattern_t_pwd_xywh= {10,570,200,45},
	s_login_pattern_forget_xywh= {210,570,200,45},
	s_login_pattern_draw_xywh= {1,51,2,1},
	s_login_pattern_tipinfo_xywh= {10,520,400,45},
};

w1_login_pattern.s_1080p = 
{
	s_login_pattern_page_xywh= {750,227,420,625},
	s_login_pattern_img_xywh= {155,30,110,110},
	s_login_pattern_user_xywh= {110,145,200,50},
	s_login_pattern_t_pattern_xywh= {55,200,310,310},
	s_login_pattern_t_pwd_xywh= {10,570,200,45},
	s_login_pattern_forget_xywh= {210,570,200,45},
	s_login_pattern_draw_xywh= {1,51,2,1},
	s_login_pattern_tipinfo_xywh= {10,520,400,45},
};
w1_login_pattern.s_2k = 
{
	s_login_pattern_page_xywh= {1000,303,560,833},
	s_login_pattern_img_xywh= {207,40,147,147},
	s_login_pattern_user_xywh= {147,193,267,67},
	s_login_pattern_t_pattern_xywh= {73,267,413,413},
	s_login_pattern_t_pwd_xywh= {13,760,267,60},
	s_login_pattern_forget_xywh= {280,760,267,60},
	s_login_pattern_draw_xywh= {1,68,3,1},
	s_login_pattern_tipinfo_xywh= {13,693,533,60},
};
w1_login_pattern.s_4k = 
{
	s_login_pattern_page_xywh= {1500,454,840,1250},
	s_login_pattern_img_xywh= {310,60,220,220},
	s_login_pattern_user_xywh= {220,290,400,100},
	s_login_pattern_t_pattern_xywh= {110,400,620,620},
	s_login_pattern_t_pwd_xywh= {20,1140,400,90},
	s_login_pattern_forget_xywh= {420,1140,400,90},
	s_login_pattern_draw_xywh= {2,102,4,2},
	s_login_pattern_tipinfo_xywh= {20,1040,800,90},
};

w1_login_pattern.set_check_verification = function (top,check)
	w1_login_pattern.check_verification = check;
end

local on_forget =function(top,win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then	
		b_dlg.do_modal(top, w1_key.DLG_FORGOT, 0, 0, nil)
		if w1_login_pattern.check_verification == true then
			w1_login_pattern.check_verification = false
			return b_ui_msg.msg_on_skip_modify_default_pwd
		end		
	end
	return 0;
end

local on_login_pattern =function(top,win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		return b_ui_msg.msg_on_change_login_type
	end
	return 0;
end

local on_pattern =function(top,win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		local number = b_wnd_ex.get_pattern_num(top,w1_login_pattern.dlg.t_pattern.id);
		local password = nil;
		password = ''
		for i=1, number.count do
			password = password..number.num[i]
		end
		local user_name = G.get_user_name();
		local result = b_app_api.user_login_g(user_name, password)
		assert(result ~= nil and "table" == type(result))	
		-- 0 正常密码登录成功返回值  1 超级临时密码登录成功返回值 
		local pwd_rule = b_app_api.get_cfg({'pwd_rule_info'}).pwd_rule_info
		local mins = math.floor(pwd_rule.lock_time/60)
		local str = string.gsub(STR('LA_LOGIN_LOCK'), '*' ,mins); 
		if (0 ~= result.ret and 1 ~= result.ret) then
			if (err_login_user_lock == result.ret) then
				b_wnd_ex.pattern_clear(top,w1_login_pattern.dlg.t_pattern.id,false);
				b_wnd_ex.set_text(top,w1_login_pattern.dlg.tipinfo.id,str,false);
			else
				b_wnd_ex.set_pattern_error(top,w1_login_pattern.dlg.t_pattern.id,false);
				b_wnd_ex.set_text(top,w1_login_pattern.dlg.tipinfo.id,STR('LA_ERR_PASSWD'),false);
			end
			w1_login_pattern.err_count = 4;
			b_dlg.dlg_set_redraw(top)
		else
			err_stat = 0;
			err_str = '';
			local boot_gui = result.boot_guide;
			b_wnd_ex.pattern_clear(top,w1_login_pattern.dlg.t_pattern.id,false);
			--登录成功 更新登录用户名称
			b_app_api.update_login_user_name(user_name);
			--获取用户自身权限
			local user_info = b_app_api.get_current_user_info(user_name)
			assert(user_info ~= nil and "table" == type(user_info))
			global_val.set_current_user_info(user_info);
			if (true == boot_gui) then		--开机向导
				return b_ui_msg.msg_on_skip_wizard
			elseif (true ~= user_info.m_bisValid) then	--密码过期
				return b_ui_msg.msg_on_skip_reminder_pwd
			else
				return b_ui_msg.msg_on_login_successful
			end	
		end	
	end
	return 0;
end

local check_pattern =function(top)
	local number = b_wnd_ex.get_pattern_num(top,w1_login_pattern.dlg.t_pattern.id);
	local password = nil;
	password = ''
	for i=1, number.count do
		password = password..number.num[i]
	end
	local user_name = G.get_user_name();
	local result = b_app_api.user_login_g(user_name, password)
	assert(result ~= nil and "table" == type(result))	
	local pwd_rule = b_app_api.get_cfg({'pwd_rule_info'}).pwd_rule_info
	local mins = math.floor(pwd_rule.lock_time/60)
	local str = string.gsub(STR('LA_LOGIN_LOCK'), '*' ,mins); 
	-- 0 正常密码登录成功返回值  1 超级临时密码登录成功返回值 
	if (0 ~= result.ret and 1 ~= result.ret) then
		if (err_login_user_lock == result.ret) then
			b_wnd_ex.set_text(top,w1_login_pattern.dlg.tipinfo.id,str,false);
		else
			b_wnd_ex.set_pattern_error(top,w1_login_pattern.dlg.t_pattern.id,false);
			b_wnd_ex.set_text(top,w1_login_pattern.dlg.tipinfo.id,STR('LA_ERR_PASSWD'),false);
		end
		w1_login_pattern.err_count = 4;
		b_dlg.dlg_set_redraw(top)
	else
		err_stat = 0;
		err_str = '';
		local boot_gui = result.boot_guide;
		--登录成功 更新登录用户名称
		b_app_api.update_login_user_name(user_name);
		--获取用户自身权限
		local user_info = b_app_api.get_current_user_info(user_name)
		assert(user_info ~= nil and "table" == type(user_info))
		global_val.set_current_user_info(user_info);
		if (true == boot_gui) then		--开机向导
			return b_ui_msg.msg_on_skip_wizard
		elseif (true ~= user_info.m_bisValid) then	--密码过期
			return b_ui_msg.msg_on_skip_reminder_pwd
		else
			return b_ui_msg.msg_on_login_successful
		end	
	end	
	return 0;
end

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		local opt_flag = b_app_api.get_mouse_operation_flag();
		if (0 ~= opt_flag) then
			b_app_api.set_mouse_operation_flag(0);
			w1_login_pattern.mouse_last_opt_time = os.time();
		end
		if w1_login_pattern.err_count > 0 then
			w1_login_pattern.err_count = w1_login_pattern.err_count - 1
			if w1_login_pattern.err_count == 0 then
				b_wnd_ex.pattern_clear(top,w1_login_pattern.dlg.t_pattern.id,false);
				b_wnd_ex.set_text(top,w1_login_pattern.dlg.tipinfo.id,'',false);
				b_dlg.dlg_set_redraw(top)
			end
		end
		local cur_tinme = os.time() 
		--60s不操作隐藏界面
		if (60 < cur_tinme - w1_login_pattern.mouse_last_opt_time) then
			w1_login_pattern.is_show = false;
			w1_login_pattern.mouse_last_opt_time = cur_tinme
			b_dlg.clear_foucs_wnd(top);
			b_dlg.dlg_set_hide(top, 1, 0);
			b_dlg.dlg_set_redraw(top)	
			return b_ui_msg.msg_on_refresh_full_screen;
		end
	elseif (b_ui_msg.msg_on_login_successful == vmsg) then	
		return vmsg
	elseif (b_ui_msg.msg_on_skip_wizard == vmsg) then			--开机向导
		return vmsg
	elseif (b_ui_msg.msg_on_skip_modify_default_pwd == vmsg) then --修改默认密码
		return vmsg
	elseif (b_ui_msg.msg_on_skip_reminder_pwd == vmsg) then		 --密码过期提醒
		return vmsg
	end	
	
	return 0
end	

local dlg = {
	attr={xywh = 's_login_pattern_page_xywh', cmd=on_dlg,timer={-1, 500}},
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},
	sub = {"img","t_user","t_pwd","forget","t_pattern","tipinfo"};
	img = {t='pattern_logo',id=id+1,	xywh='s_login_pattern_img_xywh'},
	t_user = {t='static',id=id+2,	xywh='s_login_pattern_user_xywh',text='admin',trans=false,align = b_ui.ALIGN.CENTER, font = 'f_grade4'},
	t_pattern = {t='pattern',id=id+3,xywh='s_login_pattern_t_pattern_xywh',cmd = on_pattern},
	forget = {t='buttontext',id=id+4,	xywh = 's_login_pattern_forget_xywh',text='LA_FORGOT_PW',align = b_ui.ALIGN.CENTER,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},cmd= on_forget},
	t_pwd = {t='buttontext',id=id+5,	xywh = 's_login_pattern_t_pwd_xywh',text='LA_PASSWORD',align = b_ui.ALIGN.CENTER,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},cmd= on_login_pattern},
	tipinfo	= {t='static',id=id+6,	xywh='s_login_pattern_tipinfo_xywh',text='', align = b_ui.ALIGN.CENTER,
			font='f_grade7', trans = false,
			color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_hint_text'},
			},
}

local get_super_name = function()
	local admin_info = b_app_api.get_super_admin();	
	assert(nil ~= admin_info and type(admin_info) == "table");
	--默认的用户名和密码一致 因此都是用户名
	local root_name = G.get_root_user_name();
	local user_name = G.get_user_name();
	G.set_root_user_name(admin_info.user_name);
	if root_name == user_name then
		G.set_user_name(admin_info.user_name);
	end
end	

w1_login_pattern.on_pre_show  = function(top)
	--获取超级用户用户名默认密码
	get_super_name();
	local user_name = G.get_user_name();
	local root_name = G.get_root_user_name();
	w1_login_pattern.change_logintype = false
	if user_name ~= root_name then
		b_wnd_ex.set_hide(top,w1_login_pattern.dlg.forget.id,true,false);
	end
	b_wnd_ex.set_text(top,w1_login_pattern.dlg.t_user.id,user_name,false);
	w1_login_pattern.is_show = true
	w1_login_pattern.err_count = 0;
	w1_login_pattern.check_verification = false
	w1_login_pattern.mouse_last_opt_time = os.time()
	return 0
end

w1_login_pattern.on_create = function(top)
	w1_login_pattern.top = top
	w1_login_pattern.dlg = dlg
	b_parser(top, dlg)	
	
	--关闭现场定时器
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_chcek_login)	
	
	return 0
end

w1_login_pattern.on_destroy = function(top)
	w1_login_pattern.top = nil
	w1_login_pattern.dlg = nil
	
	w1_login_pattern.is_show = false
	
	--开启现场定时器
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	
	if w1_login_pattern.change_logintype == true then
		w1_login_pattern.change_logintype = false
		b_dlg.post_modal(top,w1_key.DLG_LOGIN,0,0,nil);
	end
	
	return 0
end

w1_login_pattern.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_login_pattern_draw_xywh');
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_login_pattern.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.RBUTTONCLK == vmsg) then
		if (true == w1_login_pattern.is_show) then
			w1_login_pattern.is_show = false;
			b_dlg.clear_foucs_wnd(top);
			b_dlg.dlg_set_hide(top, 1, 0);
			b_dlg.dlg_set_redraw(top)	
			return b_ui_msg.msg_on_refresh_full_screen;
		else
			w1_login_pattern.is_show = true;
			b_dlg.dlg_set_hide(top, 0, 0);
			b_dlg.dlg_set_redraw(top)	
		end
	elseif (b_ui_msg.msg_on_refresh_full_screen == vmsg) then
		return vmsg	
	elseif (b_ui.LBUTTOUP == vmsg) then
		local ret = b_wnd_ex.pattern_end(top,w1_login_pattern.dlg.t_pattern.id);
		if ret ~= nil and ret.is_end == 1 then
			local msg = check_pattern(top);
			if msg ~= 0 then
				b_dlg.end_modal(top)
				return msg;
			end
		end
	elseif (b_ui.LBUTTONCLK == vmsg) then
		local ret = b_wnd_ex.pattern_end(top,w1_login_pattern.dlg.t_pattern.id);
		if ret ~= nil and ret.is_end == 1 then
			local msg = check_pattern(top);
			if msg ~= 0 then
				b_dlg.end_modal(top)
				return msg;
			end
		end
		if (true == w1_login_pattern.is_show) then --显示
		
		else
			w1_login_pattern.is_show = true;
			b_dlg.dlg_set_hide(top, 0, 0);
			b_dlg.dlg_set_redraw(top)	
		end
	elseif (b_ui_msg.msg_on_login_successful == vmsg) then	
		b_dlg.end_modal(top)
		return vmsg
	elseif (b_ui_msg.msg_on_skip_wizard == vmsg) then			--开机向导
		b_dlg.end_modal(top)
		return vmsg
	elseif (b_ui_msg.msg_on_skip_modify_default_pwd == vmsg) then --修改默认密码
		b_dlg.end_modal(top)
		return vmsg
	elseif (b_ui_msg.msg_on_skip_reminder_pwd == vmsg) then		 --密码过期提醒
		b_dlg.end_modal(top)
		return vmsg
	elseif (b_ui_msg.msg_on_change_login_type == vmsg) then	--切换登陆方式
		b_dlg.end_modal(top)
		w1_login_pattern.change_logintype = true
		return vmsg;
	end
		
	return 0
end

return w1_login_pattern
