--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/20
-- author lsl
-- brief  öԻ
--]]
local global_val 	= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.net_packet.id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local app_api 	= require("app_api")
local b_app_api = require("wnd.core.command.b_app_api");
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local flag = 0 --0 uδ 1
local channel_list = {}
local task_id = 0;
local data = {}
local packet_flag = 0 --0δץ 1ץ
local state_num = 1
local packet_lan = 1;
local nic_num = 0  --
local packet_id = 1
local dir_path = ""
local monitor_id = 0
local old_id = 0

local w1_net_packet = {
	t = w1_key.DLG_NET_PACKET,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_net_packet.s_768 =
{
	s_net_packet_xywh = {304,142,416,483},
	s_net_packet_titleimg_xywh = {6,10,12,17},
	s_net_packet_alarm_xywh = {26,8,373,28},
	s_net_packet_close_xywh = {394,10,12,17},
	s_net_packet_draw = {0,41,0,1},

	s_net_packet_cap_path_xywh = {26,71,117,35},
	s_net_packet_t_path_xywh = {154,71,218,35},
	s_net_packet_dir_xywh = {373,71,26,35},

	s_net_packet_cap_port_xywh = {26,113,117,35},
	s_net_packet_enb_port_xywh = {154,113,80,35},
	s_net_packet_t_port_xywh = {240,113,133,35},

	s_net_packet_cap_ip_xywh = {26,156,117,35},
	s_net_packet_enb_ip_xywh = {154,156,80,35},
	s_net_packet_t_ip_xywh = {240,156,133,35},

	s_net_packet_cap_num_xywh = {26,199,117,35},
	s_net_packet_enb_num_xywh = {154,199,80,35},
	s_net_packet_t_num_xywh = {240,199,133,35},

	s_net_packet_cancel_xywh = {309,440,64,28},
	s_net_packet_ok_xywh = {234,440,64,28},


	s_net_packet_list_xywh = {26,263,346,128},
	s_net_packet_list_w1 = {59,0,0,0},
	s_net_packet_list_w2 = {96,0,0,0},
	s_net_packet_list_w3 = {100,0,0,0},
	s_net_packet_list_w4 = {80,0,0,0},
};

w1_net_packet.s_1280 = 
{
	s_net_packet_xywh= {300,200,780,620},
	s_net_packet_titleimg_xywh = {13,15,24,24}, 
	s_net_packet_alarm_xywh= {50,12,700, 40},
	s_net_packet_close_xywh=  {740,15,24,24},
	s_net_packet_draw= {0,58,0,1},
	
	s_net_packet_cap_path_xywh = {50,100,220,50},
	s_net_packet_t_path_xywh = {290,100,410,50},
	s_net_packet_dir_xywh = {700,100,50,50},
	
	s_net_packet_cap_port_xywh = {50,160,220,50},
	s_net_packet_enb_port_xywh = {290,160,150,50},
	s_net_packet_t_port_xywh = {450,160,250,50},
	
	s_net_packet_cap_ip_xywh = {50,220,220,50},
	s_net_packet_enb_ip_xywh = {290,220,150,50},
	s_net_packet_t_ip_xywh = {450,220,250,50},
	
	s_net_packet_cap_num_xywh = {50,280,220,50},
	s_net_packet_enb_num_xywh = {290,280,150,50},
	s_net_packet_t_num_xywh = {450,280,250,50},
	
	s_net_packet_cancel_xywh = {580,560,120,40},
	s_net_packet_ok_xywh = {440,560,120,40},

	s_net_packet_list_xywh = {50,360,650,180},
	s_net_packet_list_w1={130,0,0,0},
	s_net_packet_list_w2={180,0,0,0},
	s_net_packet_list_w3={210,0,0,0},
	s_net_packet_list_w4={110,0,0,0},
};
w1_net_packet.s_1440 = 
{
	s_net_packet_xywh= {370,145,780,620},
	s_net_packet_titleimg_xywh = {13,15,24,24}, 
	s_net_packet_alarm_xywh= {50,12,700, 40},
	s_net_packet_close_xywh=  {740,15,24,24},
	s_net_packet_draw= {0,58,0,1},
	
	s_net_packet_cap_path_xywh = {50,100,220,50},
	s_net_packet_t_path_xywh = {290,100,410,50},
	s_net_packet_dir_xywh = {700,100,50,50},
	
	s_net_packet_cap_port_xywh = {50,160,220,50},
	s_net_packet_enb_port_xywh = {290,160,150,50},
	s_net_packet_t_port_xywh = {450,160,250,50},
	
	s_net_packet_cap_ip_xywh = {50,220,220,50},
	s_net_packet_enb_ip_xywh = {290,220,150,50},
	s_net_packet_t_ip_xywh = {450,220,250,50},
	
	s_net_packet_cap_num_xywh = {50,280,220,50},
	s_net_packet_enb_num_xywh = {290,280,150,50},
	s_net_packet_t_num_xywh = {450,280,250,50},
	
	s_net_packet_cancel_xywh = {580,560,120,40},
	s_net_packet_ok_xywh = {440,560,120,40},
	
	s_net_packet_list_xywh = {50,360,650,180},
	s_net_packet_list_w1={130,0,0,0},
	s_net_packet_list_w2={180,0,0,0},
	s_net_packet_list_w3={210,0,0,0},
	s_net_packet_list_w4={110,0,0,0},

};
w1_net_packet.s_1080p = 
{
	s_net_packet_xywh= {570,200,780,680},
	s_net_packet_titleimg_xywh = {13,15,24,24}, 
	s_net_packet_alarm_xywh= {50,12,700, 40},
	s_net_packet_close_xywh=  {740,15,24,24},
	s_net_packet_draw= {0,58,0,1},
	
	s_net_packet_cap_path_xywh = {50,100,220,50},
	s_net_packet_t_path_xywh = {290,100,410,50},
	s_net_packet_dir_xywh = {700,100,50,50},
	
	s_net_packet_cap_port_xywh = {50,160,220,50},
	s_net_packet_enb_port_xywh = {290,160,150,50},
	s_net_packet_t_port_xywh = {450,160,250,50},
	
	s_net_packet_cap_ip_xywh = {50,220,220,50},
	s_net_packet_enb_ip_xywh = {290,220,150,50},
	s_net_packet_t_ip_xywh = {450,220,250,50},
	
	s_net_packet_cap_num_xywh = {50,280,220,50},
	s_net_packet_enb_num_xywh = {290,280,150,50},
	s_net_packet_t_num_xywh = {450,280,250,50},
	
	s_net_packet_cancel_xywh = {580,620,120,40},
	s_net_packet_ok_xywh = {440,620,120,40},

	
	s_net_packet_list_xywh = {50,370,650,180},
	s_net_packet_list_w1={130,0,0,0},
	s_net_packet_list_w2={180,0,0,0},
	s_net_packet_list_w3={210,0,0,0},
	s_net_packet_list_w4={110,0,0,0},

};
w1_net_packet.s_2k = 
{
	s_net_packet_xywh = {758,266,1037,904},
	s_net_packet_enb_ip_xywh = {385,292,199,66},
	s_net_packet_dir_xywh = {931,133,66,66},
	s_net_packet_cap_ip_xywh = {66,292,292,66},
	s_net_packet_cap_path_xywh = {66,133,292,66},
	s_net_packet_t_ip_xywh = {598,292,332,66},
	s_net_packet_draw = {0,77,0,1},
	s_net_packet_alarm_xywh = {66,15,931,53},
	s_net_packet_t_port_xywh = {598,212,332,66},
	s_net_packet_enb_port_xywh = {385,212,199,66},
	s_net_packet_enb_num_xywh = {385,372,199,66},
	s_net_packet_cancel_xywh = {771,824,159,53},
	s_net_packet_t_num_xywh = {598,372,332,66},
	s_net_packet_titleimg_xywh = {17,19,31,31},
	s_net_packet_cap_port_xywh = {66,212,292,66},
	s_net_packet_t_path_xywh = {385,133,545,66},
	s_net_packet_ok_xywh = {585,824,159,53},
	s_net_packet_cap_num_xywh = {66,372,292,66},
	s_net_packet_close_xywh = {984,19,31,31},
	
	s_net_packet_list_xywh = {66,480,864,210},
	s_net_packet_list_w1={150,0,0,0},
	s_net_packet_list_w2={230,0,0,0},
	s_net_packet_list_w3={330,0,0,0},
	s_net_packet_list_w4={120,0,0,0},
};
w1_net_packet.s_4k = 
{
	s_net_packet_xywh = {1140,400,1560,1360},
	s_net_packet_enb_ip_xywh = {580,440,300,100},
	s_net_packet_dir_xywh = {1400,200,100,100},
	s_net_packet_cap_ip_xywh = {100,440,440,100},
	s_net_packet_cap_path_xywh = {100,200,440,100},
	s_net_packet_t_ip_xywh = {900,440,500,100},
	s_net_packet_draw = {0,116,0,2},
	s_net_packet_alarm_xywh = {100,24,1400,80},
	s_net_packet_t_port_xywh = {900,320,500,100},
	s_net_packet_enb_port_xywh = {580,320,300,100},
	s_net_packet_enb_num_xywh = {580,560,300,100},
	s_net_packet_cancel_xywh = {1160,1240,240,80},
	s_net_packet_t_num_xywh = {900,560,500,100},
	s_net_packet_titleimg_xywh = {26,30,48,48},
	s_net_packet_cap_port_xywh = {100,320,440,100},
	s_net_packet_t_path_xywh = {580,200,820,100},
	s_net_packet_ok_xywh = {880,1240,240,80},
	s_net_packet_cap_num_xywh = {100,560,440,100},
	s_net_packet_close_xywh = {1480,30,48,48},
	
	s_net_packet_list_xywh = {100,720,1300,360},
	s_net_packet_list_w1={260,0,0,0},
	s_net_packet_list_w2={360,0,0,0},
	s_net_packet_list_w3={420,0,0,0},
	s_net_packet_list_w4={220,0,0,0},

};

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local on_dir = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		
		b_app_api.mount_dev();
		flag = 1
		local path = b_dlg.dlg_get_path(top, w1_key.DLG_UPGRADEDECTORY, 0, 0, 2)
		if (nil ~= path and '' ~= path) then
			b_wnd_ex.set_text(top,w1_net_packet.dlg.t_path.id,path,true)
			monitor_id = b_app_api.add_dev_monitor(path)
			if (nil ~= dir_path and '' ~= dir_path and flag == 1) then
				b_app_api.del_dev_monitor(old_id,dir_path)
			end
			dir_path = path
			old_id = monitor_id
		end
	end
	return 0
end

local on_net_packet = function (top,idx)
	local packet_info = {}
	local path = b_wnd_ex.get_text(top,w1_net_packet.dlg.t_path.id)
	if path=="" then
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_PATH_EMPTY'), true, false,false);
		w1_msgbox.set_func(nil, nil, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		return 0
	end
	local port = b_wnd_ex.get_value(top,w1_net_packet.dlg.t_port.id)
	local ip = b_wnd_ex.get_text(top,w1_net_packet.dlg.t_ip.id)
	local pack_num = b_wnd_ex.get_value(top,w1_net_packet.dlg.t_num.id)
	
	local check  = b_wnd_ex.get_sel(top,w1_net_packet.dlg.enb_port.id)
	if check==0  then
		port = 0
	end
	check  = b_wnd_ex.get_sel(top,w1_net_packet.dlg.enb_ip.id)
	if check==0  then
		ip = ""
	else
		local legal, num= w1_legal.check_ip(top, w1_net_packet.dlg.t_ip.id);
		if legal==false then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NETIP_ERR'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			return 0
		end
	end
	check  = b_wnd_ex.get_sel(top,w1_net_packet.dlg.enb_num.id)
	if check==0  then
		pack_num = 0
	end
	local nic = idx-1
	packet_info.port=port
	packet_info.path=path
	packet_info.ip=ip
	packet_info.if_name="eth"..nic
	packet_info.pack_num = pack_num
	task_id = b_app_api.creat_net_packet(packet_info)
	if task_id==-1 then
		return 0
	end
	data.task_id = task_id
	data.path = path
	b_wnd_ex.set_disable(top,w1_net_packet.dlg.packet.id,true,false)
	b_wnd_ex.set_disable(top,w1_net_packet.dlg.cancel.id,false,false)
	b_wnd.clear_wnd_focus(top);
	b_dlg.dlg_set_redraw(top);
	packet_flag=1;
	return 0
end




local updatelist = function(top, redraw)
	local cfg_network = b_app_api.get_network_info();	
	local displist = {};
	local idx = 0;
	local ip_addr = {}
	ip_addr[1]=cfg_network.ip
	if nic_num==2 then
		local net_cctv = b_app_api.get_cfg({'network_cctv'}).network_cctv;
		ip_addr[2]=net_cctv.ip
	end
	local state_str = {}
	for j=1,nic_num do
		if j==packet_id then
			if packet_flag==0 then
				state_str[j] = '-'
			elseif packet_flag==1 then
				state_str[j] = STR('LA_CAPTURE')
				if state_num<=3 then
					for i=1,state_num do
						state_str[j] = state_str[j]..'.'
					end
					state_num = state_num+1
				else
					state_num = 1
				end
			else
				state_str[j] = STR('LA_COMPLETED')
			end
		else
			state_str[j]='-'
		end
	end
	
	for i=1, nic_num do
		displist['idx'..i] = {i-1,false,"LAN"..i,ip_addr[i],state_str[i],''};
	end
	displist.item_total = nic_num;
	b_wnd_ex.set_listdata(top, w1_net_packet.dlg.list.id, displist, redraw);	
end

local on_type = function(top, id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local check = b_wnd_ex.get_sel(top,id)
		if check==0 then
			if id==w1_net_packet.dlg.enb_ip.id then
				b_wnd_ex.set_color_d(top,w1_net_packet.dlg.t_ip.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
				b_wnd_ex.set_text(top,w1_net_packet.dlg.t_ip.id,"",false)
			else
				b_wnd_ex.set_value(top,id+1,0,false)
			end
			b_wnd_ex.set_disable(top,id+1,true,false)	
		else
			if id==w1_net_packet.dlg.enb_ip.id then
			b_wnd_ex.set_color_d(top,w1_net_packet.dlg.t_ip.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);
			else
				b_wnd_ex.set_value(top,id+1,1,false)
			end
			b_wnd_ex.set_disable(top,id+1,false,false)			
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_packet = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if packet_flag==1 then
			return 0
		end
		on_net_packet(top,packet_lan)
		packet_id = packet_lan
	end
	return 0
end

local on_list = function (top,wnd_id,vmsg,x,y)
	if vmsg==b_ui.LBUTTONCLK then
		local pos = SIZE('s_net_packet_list_xywh')
		if y>pos[2]+math.floor(pos[4]/3) then
			if nic_num>1 then
				packet_lan = b_wnd_ex.get_list_idx(top,w1_net_packet.dlg.list.id,x,y)+1;
				b_wnd_ex.set_end_selecelist_only(top,w1_net_packet.dlg.list.id,packet_lan-1,true)
			end
		end
	end
	return 0;
end

local on_cancel = function (top,wnd_id,vmsg,x,y)
	if vmsg==b_ui.LBUTTONCLK then
		b_app_api.destroy_capture(data)
		packet_flag = 0
		b_wnd_ex.set_disable(top,w1_net_packet.dlg.packet.id,false,false)
		b_wnd_ex.set_disable(top,w1_net_packet.dlg.cancel.id,true,false)
		b_wnd.clear_wnd_focus(top);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		return 0;
	end
	if b_ui.TIMER == vmsg then
		local status = b_app_api.get_packet_status()
		if status~=nil then
			if status==1 and packet_flag == 1 then
				b_app_api.destroy_capture(data)
				packet_flag = 2
				b_wnd_ex.set_disable(top,w1_net_packet.dlg.packet.id,false,false)
				b_wnd_ex.set_disable(top,w1_net_packet.dlg.cancel.id,true,false)
				b_wnd.clear_wnd_focus(top);
			end
			updatelist(top,false)
			b_dlg.dlg_set_redraw(top);
		end
		
	end
	
	return 0;
end

w1_net_packet.on_create = function(top)
	local dlg = {
		attr = {},
		sub = nil
	}	
	id = w1_id.net_packet.id
	
	dlg.attr={xywh='s_net_packet_xywh',cmd=on_dlg,timer={-1, 1000}};
	
	dlg.sub = {	'img','network','close','alarm_out','line1','line2','line3','net_packet_start','net_packet_stop','state','list',
				'cap_path','t_path','dir','cap_port','enb_port','t_port','cap_ip','enb_ip','t_ip','packet','cancel','cap_num','enb_num','t_num'};
				
	dlg.img	= {t='tt_button',id=id+1,xywh = 's_net_packet_titleimg_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_net_packet','it_net_packet', 'it_net_packet'},
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
					color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
	};

	dlg.network	= {t='static', 	id=id+2,xywh='s_net_packet_alarm_xywh', 
					text='LA_NET_PACKET',font = 'f_grade3', align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
				};
					
	dlg.close 	= {t='tt_button',id=id+3,xywh = 's_net_packet_close_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
					color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_f'},
					cmd=on_close,
	};
	
	dlg.cap_path	= {t='static', 	id=id+4,xywh='s_net_packet_cap_path_xywh', 
					text='LA_SAVE_TO',font = 'f_grade3', align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
				};
	dlg.t_path	= {t='edit', 	id=id+5,xywh='s_net_packet_t_path_xywh', 
					text='',trans=false,font = 'f_grade3', align = b_ui.ALIGN.LEFT,
				};
	dlg.dir 	= {t='tt_button',id=id+6,xywh = 's_net_packet_dir_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_dir','it_dir', 'it_dir'},
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
					color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_f'},
					cmd=on_dir,};			
	
	dlg.cap_port	= {t='static', 	id=id+7,xywh='s_net_packet_cap_port_xywh', 
					text='LA_PORT',font = 'f_grade3', align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},	};
	dlg.enb_port = {t='combox',id=id+8,	xywh='s_net_packet_enb_port_xywh',items={'LA_ALL','LA_CUSTOM'},cmd = on_type};
	dlg.t_port	= {t='edit_num', 	id=id+9,xywh='s_net_packet_t_port_xywh', 
					range={1,65535},font = 'f_grade3', align = b_ui.ALIGN.LEFT,
					
				};

	dlg.cap_ip	= {t='static', 	id=id+10,xywh='s_net_packet_cap_ip_xywh', 
					text='LA_IP',font = 'f_grade3', align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'}};
	dlg.enb_ip = {t='combox',id=id+11,items={'LA_ALL','LA_CUSTOM'},	xywh='s_net_packet_enb_ip_xywh',
					cmd = on_type};
				
	dlg.t_ip	= {t='edit_ip', 	id=id+12,xywh='s_net_packet_t_ip_xywh', 
					font = 'f_grade3', align = b_ui.ALIGN.LEFT,
					
				};
	
	dlg.cap_num	= {t='static', 	id=id+13,xywh='s_net_packet_cap_num_xywh', 
					text='LA_PACKET_NUM',font = 'f_grade3', align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},	};
	dlg.enb_num = {t='combox',id=id+14,items={'LA_ALL','LA_CUSTOM'},xywh='s_net_packet_enb_num_xywh',cmd = on_type};
	dlg.t_num	= {t='edit_num', 	id=id+15,xywh='s_net_packet_t_num_xywh', 
					range={1,65535},font = 'f_grade3', align = b_ui.ALIGN.LEFT,
					
				};
				
	dlg.packet 	= {t='button',id=id+16,	xywh = 's_net_packet_ok_xywh', 	text='LA_START',cmd=on_packet,};
	dlg.cancel 	= {t='button',id=id+17,	xywh = 's_net_packet_cancel_xywh', 	text='LA_STOP',cmd=on_cancel,};
	dlg.list =  {t='list',	id=id+18,xywh='s_net_packet_list_xywh', font = 'f_grade4',
					listattr = {2,4,b_ui.LISTATTR.FIRST_WIDGET_STATIC,b_ui.LISTATTR.END_WIDGET_CHECK},
					columns_w = {150,150,180},cmd=on_list};

	w1_net_packet.top = top
	w1_net_packet.dlg = dlg
	
	--UIڳʼ

	local device_info = b_app_api.get_device_info();
	nic_num = device_info.nic_num
	b_parser(top, w1_net_packet.dlg)
	updatelist(top,false)
	b_wnd_ex.set_disable(top,w1_net_packet.dlg.t_ip.id,true,false)
	b_wnd_ex.set_disable(top,w1_net_packet.dlg.t_port.id,true,false)
	b_wnd_ex.set_disable(top,w1_net_packet.dlg.t_num.id,true,false)
	b_wnd_ex.set_disable(top,w1_net_packet.dlg.cancel.id,true,false)
	b_wnd_ex.set_value(top,w1_net_packet.dlg.t_port.id,0,false)
	b_wnd_ex.set_value(top,w1_net_packet.dlg.t_num.id,0,false)

	b_wnd.set_no_find(top,w1_net_packet.dlg.t_path.id,true,false)
	
	b_wnd.set_no_find(top, w1_net_packet.dlg.network.id, true); ---ñ⾲̬ıɱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	packet_lan = 1;
	return 0
end

w1_net_packet.on_destroy = function(top)
	b_app_api.destroy_capture(data)
	packet_flag = 0
	w1_net_packet.top = nil
	w1_net_packet.dlg = nil
	if flag ==1 then
		if (nil ~= dir_path and '' ~= dir_path) then
			b_app_api.del_dev_monitor(old_id,dir_path)
		end
		--b_app_api.unmount_dev();
		flag = 0
	end
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0
end

w1_net_packet.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_net_packet_draw');
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	b_wnd.draw_fill(top, x, y+wndsize[2], cx, wndsize[4], COLOR('c_hline_color'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	if nic_num==1 then
		b_wnd_ex.set_list_end_nofind(top,w1_net_packet.dlg.list.id,{true,true},false)
	else
		b_wnd_ex.set_list_end_nofind(top,w1_net_packet.dlg.list.id,{false,true},false)
	end
	return 0
end

w1_net_packet.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local size = SIZE(w1_net_packet.dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			
		else
			b_dlg.end_modal(top);
		end
	elseif  (b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);	
	end

	return 0
end

w1_net_packet.on_pre_show = function (top)
	packet_flag = 0
	local param = {
			STR('LA_NIC'), STR('LA_IP'),STR('LA_STATUS'),STR('LA_CAPTURE')}
	b_wnd_ex.set_title_texts(top, w1_net_packet.dlg.list.id, param, false);                
	local list_w = {};
		for i=1,4 do
			local str = 's_net_packet_list_w'..math.floor(i/1);
			list_w[i] = SIZE(str)[1];
		end
	b_wnd_ex.columns_w(top, w1_net_packet.dlg.list.id, list_w, false);
	local show_lan1= {}
	show_lan1[1]=1
	b_wnd_ex.set_end_selecelist(top,w1_net_packet.dlg.list.id,show_lan1,false)
	return 0;
end

return w1_net_packet




