-- ѽ
local b_ui 		= require("wnd.core.b_ui")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.start_up.reminder_pwd_id
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local cjson 	= require("cjson")
local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local global_val	= require("wnd.global_val")

local user_info = nil
local w1_deminder_change_pwd = {
	t = w1_key.DLG_REMINDER_CHANGE,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_deminder_change_pwd.s_768 =
{
	s_reminder_page_xywh = {352,277,320,213},
	s_modify_dis_no_tips_txt_xywh = {26,163,184,28},
	s_deminder_change_pwd_titlestr_xywh = {1,1,317,41},
	s_deminder_change_pwd_titleclose_xywh = {292,8,21,28},
	s_deminder_change_pwd_tip_1_xywh = {21,67,288,32},
	s_deminder_change_pwd_tip_2_xywh = {21,106,288,32},
	s_deminder_change_pwd_dis_no_tips_xywh = {10,163,16,28},
	s_deminder_change_pwd_modify_xywh = {218,163,92,35},
	s_deminder_change_pwd_draw_xywh = {0,42,0,1},
};

w1_deminder_change_pwd.s_1280 = 
{
	s_reminder_page_xywh= {340,362,600,300},
	s_modify_dis_no_tips_txt_xywh= {40,230,310,40},
	s_deminder_change_pwd_titlestr_xywh= {2,2, 596,58}, 
	s_deminder_change_pwd_titleclose_xywh= {548,12,40,40},
	s_deminder_change_pwd_tip_1_xywh= {40, 95, 540, 45},
	s_deminder_change_pwd_tip_2_xywh= {40, 150, 540, 45},
	s_deminder_change_pwd_dis_no_tips_xywh= {20,230,20,40},
	s_deminder_change_pwd_modify_xywh= {400,230,180,50},
	s_deminder_change_pwd_draw_xywh= {0,60,0,1},
};
w1_deminder_change_pwd.s_1440 = 
{
	s_reminder_page_xywh= {420,300,600,300},
	s_modify_dis_no_tips_txt_xywh= {40,230,310,40},
	s_deminder_change_pwd_titlestr_xywh= {2,2, 596,58}, 
	s_deminder_change_pwd_titleclose_xywh= {548,12,40,40},
	s_deminder_change_pwd_tip_1_xywh= {40, 95, 540, 45},
	s_deminder_change_pwd_tip_2_xywh= {40, 150, 540, 45},
	s_deminder_change_pwd_dis_no_tips_xywh= {20,230,20,40},
	s_deminder_change_pwd_modify_xywh= {400,230,180,50},
	s_deminder_change_pwd_draw_xywh= {0,60,0,1},
};
w1_deminder_change_pwd.s_1080p = 
{
	s_reminder_page_xywh= {660,390,600,300},
	s_modify_dis_no_tips_txt_xywh= {40,230,310,40},
	s_deminder_change_pwd_titlestr_xywh= {2,2, 596,58}, 
	s_deminder_change_pwd_titleclose_xywh= {548,12,40,40},
	s_deminder_change_pwd_tip_1_xywh= {40, 95, 540, 45},
	s_deminder_change_pwd_tip_2_xywh= {40, 150, 540, 45},
	s_deminder_change_pwd_dis_no_tips_xywh= {20,230,20,40},
	s_deminder_change_pwd_modify_xywh= {400,230,180,50},
	s_deminder_change_pwd_draw_xywh= {0,60,0,1},
};
w1_deminder_change_pwd.s_2k = 
{
	s_reminder_page_xywh= {880,520,800,400},
	s_modify_dis_no_tips_txt_xywh= {53,307,413,53},
	s_deminder_change_pwd_titlestr_xywh= {3,3,794,77},
	s_deminder_change_pwd_titleclose_xywh= {730,16,53,53},
	s_deminder_change_pwd_tip_1_xywh= {53,127,720,60},
	s_deminder_change_pwd_tip_2_xywh= {53,200,720,60},
	s_deminder_change_pwd_dis_no_tips_xywh= {27,307,27,53},
	s_deminder_change_pwd_modify_xywh= {533,307,240,67},
	s_deminder_change_pwd_draw_xywh= {0,80,0,1},
};
w1_deminder_change_pwd.s_4k = 
{
	s_reminder_page_xywh= {1320,780,1200,600},
	s_modify_dis_no_tips_txt_xywh= {80,460,620,80},
	s_deminder_change_pwd_titlestr_xywh= {4,4,1192,116},
	s_deminder_change_pwd_titleclose_xywh= {1096,24,80,80},
	s_deminder_change_pwd_tip_1_xywh= {80,190,1080,90},
	s_deminder_change_pwd_tip_2_xywh= {80,300,1080,90},
	s_deminder_change_pwd_dis_no_tips_xywh= {40,460,40,80},
	s_deminder_change_pwd_modify_xywh= {800,460,360,100},
	s_deminder_change_pwd_draw_xywh= {0,120,0,2},	
};

local update_reminder_time = function(top)
	local status = 	b_wnd_ex.get_check(top, w1_deminder_change_pwd.dlg.dis_no_tips.id)
	if (true == status) then
		local user_name = user_info.m_strUsername;
		b_app_api.update_pwdtime(user_name);
	end
end

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ǷѴ
		update_reminder_time(top);
		
		return b_ui_msg.msg_on_login_successful;
	end
	return 0
end

local on_modify = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		
		--ǷѴ
		update_reminder_time(top);
		return b_ui_msg.msg_on_ship_modify_pwd;
	end
	
	return 0
end


local dlg = {
	attr 	= {xywh= 's_reminder_page_xywh'},
	
	sub 	= {'titlestr', 'titleclose', 'tip_1', 'tip_2','dis_no_tips', 'dis_no_tips_txt', 'modify'},
			
	titlestr	= {t='static', 	id=id+1,xywh='s_deminder_change_pwd_titlestr_xywh', 
					text='LA_CHANGE_PASSWORD_REMINDER',	font = 'f_grade3',align = b_ui.ALIGN.CENTER,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
					
	titleclose 	= {t='tt_button',id=id+2,xywh = 's_deminder_change_pwd_titleclose_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn2','it_close','it_close', 'it_close'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_cfgclose_bk'},
					cmd=on_close,
					},
	tip_1 = {t='static',	id=id+3,	xywh= 's_deminder_change_pwd_tip_1_xywh',text='LA_REMINDER_PWD_TIP1', 
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},	
	
	tip_2 = {t='static',	id=id+4,	xywh= 's_deminder_change_pwd_tip_2_xywh',text='LA_REMINDER_PWD_TIP2', 
	
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},	

	dis_no_tips = {t='check',	id=id+5,xywh='s_deminder_change_pwd_dis_no_tips_xywh'},	
	
	dis_no_tips_txt	= {t='static', 	id=id+6,xywh='s_modify_dis_no_tips_txt_xywh', 
					text='LA_REMINDER_ONE_YEAR',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	modify = {t='tt_button',id=id+7,	xywh='s_deminder_change_pwd_modify_xywh',	text='LA_MODIFY', cmd=on_modify},
}

w1_deminder_change_pwd.on_create = function(top)
	w1_deminder_change_pwd.top = top
	w1_deminder_change_pwd.dlg = dlg
	b_parser(top, w1_deminder_change_pwd.dlg)
	return 0
end

w1_deminder_change_pwd.on_destroy = function(top)
	w1_deminder_change_pwd.top = nil
	w1_deminder_change_pwd.dlg = nil
	user_info = nil;
	--ֳʱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)	
	
	return 0
end

w1_deminder_change_pwd.on_pre_show = function(top)
	b_wnd.set_no_find(top, w1_deminder_change_pwd.dlg.titlestr.id, true); ---ñ⾲̬ıɱ
	b_wnd.set_no_find(top, w1_deminder_change_pwd.dlg.dis_no_tips_txt.id, true); ---ñ⾲̬ıɱ

	local user_name = b_app_api.get_cur_username().user_name
	user_info = b_app_api.get_current_user_info(user_name)
	assert(user_info ~= nil and "table" == type(user_info))
	global_val.set_current_user_info(user_info);
	
--	user_info = global_val.get_current_user_info();
	assert(user_info ~= nil and "table" == type(user_info))
	local expTime = nil;
	if (user_info.m_strPwdTimeout == "1d") then
		expTime = STR('LA_REMINDER_ONE_DAY')
	elseif (user_info.m_strPwdTimeout == "2d") then
		expTime = STR('LA_REMINDER_TWO_DAY')
	elseif (user_info.m_strPwdTimeout == "3d") then
		expTime = STR('LA_REMINDER_THREE_DAY') 
	elseif (user_info.m_strPwdTimeout == "1w") then
		expTime = STR('LA_REMINDER_ONE_WEEK')
	elseif (user_info.m_strPwdTimeout == "2w") then
		expTime = STR('LA_REMINDER_TWO_WEEK')
	elseif (user_info.m_strPwdTimeout == "3w") then
		expTime = STR('LA_REMINDER_THREE_WEEK')
	elseif (user_info.m_strPwdTimeout == "1m") then
		expTime = STR('LA_REMINDER_ONE_MONTH')
	elseif (user_info.m_strPwdTimeout == "2m") then
		expTime = STR('LA_REMINDER_THREE_MONTH')
	elseif (user_info.m_strPwdTimeout == "3m") then
		expTime = STR('LA_REMINDER_THREE_MONTH')
	elseif (user_info.m_strPwdTimeout == "6m") then
		expTime = STR('LA_REMINDER_THREE_MONTH')
	elseif (user_info.m_strPwdTimeout == "1y") then
		expTime = STR('LA_REMINDER_ONE_YEAR')
	end	
	
	b_wnd_ex.set_text(top, dlg.dis_no_tips_txt.id, expTime, false);
	
		--رֳʱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	
	return 0
end

w1_deminder_change_pwd.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_deminder_change_pwd_draw_xywh');
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'))
	b_wnd.draw_fill(top, x, y+wndsize[2], cx, wndsize[4], COLOR('c_hline_color'))
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_modch_border'),1)
	b_wnd.end_job(top)
	return 0
end

w1_deminder_change_pwd.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local size = SIZE(dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			local tip_size = SIZE(dlg.dis_no_tips_txt.xywh)
			if(x >= size[1] + tip_size[1] and x <= (size[1] + tip_size[1]  + tip_size[3]) and y >= size[2] + tip_size[2] and y <= (size[2] + tip_size[2] + tip_size[4])) then
				local status = 	b_wnd_ex.get_check(top, dlg.dis_no_tips.id)
				if (false == status) then
					status = true;
				else
					status = false;
				end
				
				b_wnd_ex.set_check(top, dlg.dis_no_tips.id, status, true)
			end
		else
			--ǷѴ
			update_reminder_time(top);
			b_dlg.end_modal(top);
			return b_ui_msg.msg_on_login_successful;
		end
	elseif  (b_ui.RBUTTONCLK == vmsg) then
		--ǷѴ
		update_reminder_time(top);	
		b_dlg.end_modal(top);
		return b_ui_msg.msg_on_login_successful;
	elseif (b_ui_msg.msg_on_ship_modify_pwd == vmsg) then
		b_dlg.end_modal(top);
		return vmsg;	
	elseif (b_ui_msg.msg_on_login_successful == vmsg) then
		b_dlg.end_modal(top);
		return vmsg;			
	end
	
	return 0
end

return w1_deminder_change_pwd




