--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/7/4
-- author 
-- brief  
--]]
local b_ui 	= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 	= w1_id.wizard_time.wizard_dst_id
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local b_app_api = require("wnd.core.command.b_app_api");
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_dlg 	= require("wnd.core.b_dlg")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")

local w1_wizard_dst = 
{
	origin_cfg ={},
	data,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_dst.s_768 =
{
	s_wizard_dst_xywh = {2,53,448,490},
	s_wizard_dst_c_dstime_xywh = {32,14,213,35},
	s_wizard_dst_t_dstime_xywh = {266,14,26,35},
	s_wizard_dst_c_stime_xywh = {32,56,117,32},
	s_wizard_dst_t_smonth_xywh = {149,56,64,32},
	s_wizard_dst_t_sorder_xywh = {213,56,74,32},
	s_wizard_dst_t_sweek_xywh = {288,56,64,32},
	s_wizard_dst_t_smoment_xywh = {352,56,74,32},
	s_wizard_dst_c_etime_xywh = {32,99,117,32},
	s_wizard_dst_t_emonth_xywh = {149,99,64,32},
	s_wizard_dst_t_eorder_xywh = {213,99,74,32},
	s_wizard_dst_t_eweek_xywh = {288,99,64,32},
	s_wizard_dst_t_emoment_xywh = {352,99,74,32},
	s_wizard_dst_c_offsettime_xywh = {32,142,181,32},
	s_wizard_dst_t_offsettime_xywh = {213,142,213,32},
	s_wizard_dst_tipinfo_xywh = {32,355,373,35},
};

w1_wizard_dst.s_1280 = 
{
	s_wizard_dst_xywh= {3,75,840,600},
	s_wizard_dst_c_dstime_xywh={60,20,400,50}, 
	s_wizard_dst_t_dstime_xywh={500,20,50,50}, 
	s_wizard_dst_c_stime_xywh={60,80,220,45},
	s_wizard_dst_t_smonth_xywh={280,80,120,45}, 
	s_wizard_dst_t_sorder_xywh={400,80,140,45}, 
	s_wizard_dst_t_sweek_xywh={540,80,120,45},
	s_wizard_dst_t_smoment_xywh={660,80,140,45}, 
	s_wizard_dst_c_etime_xywh={60,140,220,45},
	s_wizard_dst_t_emonth_xywh={280,140,120,45}, 
	s_wizard_dst_t_eorder_xywh={400,140,140,45}, 
	s_wizard_dst_t_eweek_xywh={540,140,120,45},
	s_wizard_dst_t_emoment_xywh={660,140,140,45}, 
	s_wizard_dst_c_offsettime_xywh={60,200,340,45},
	s_wizard_dst_t_offsettime_xywh={400,200,400,45},
	s_wizard_dst_tipinfo_xywh={60,500,700,50},
}

w1_wizard_dst.s_1440 = 
{
	s_wizard_dst_xywh= {3,75,840,600},
	s_wizard_dst_c_dstime_xywh={60,20,400,40}, 
	s_wizard_dst_t_dstime_xywh={500,20,50,40}, 
	s_wizard_dst_c_stime_xywh={60,80,220,40},
	s_wizard_dst_t_smonth_xywh={280,80,120,40}, 
	s_wizard_dst_t_sorder_xywh={400,80,140,40}, 
	s_wizard_dst_t_sweek_xywh={540,80,120,40},
	s_wizard_dst_t_smoment_xywh={660,80,140,40}, 
	s_wizard_dst_c_etime_xywh={60,140,220,40},
	s_wizard_dst_t_emonth_xywh={280,140,120,40}, 
	s_wizard_dst_t_eorder_xywh={400,140,140,40}, 
	s_wizard_dst_t_eweek_xywh={540,140,120,40},
	s_wizard_dst_t_emoment_xywh={660,140,140,40}, 
	s_wizard_dst_c_offsettime_xywh={60,200,340,40},
	s_wizard_dst_t_offsettime_xywh={400,200,400,40},
	s_wizard_dst_tipinfo_xywh={60,500,700,50},
}


w1_wizard_dst.s_1080p = 
{
	s_wizard_dst_xywh= {3,75,840,690},
	s_wizard_dst_c_dstime_xywh={60,20,400,50}, 
	s_wizard_dst_t_dstime_xywh={500,20,50,50}, 
	s_wizard_dst_c_stime_xywh={60,80,220,45},
	s_wizard_dst_t_smonth_xywh={280,80,120,45}, 
	s_wizard_dst_t_sorder_xywh={400,80,140,45}, 
	s_wizard_dst_t_sweek_xywh={540,80,120,45},
	s_wizard_dst_t_smoment_xywh={660,80,140,45}, 
	s_wizard_dst_c_etime_xywh={60,140,220,45},
	s_wizard_dst_t_emonth_xywh={280,140,120,45}, 
	s_wizard_dst_t_eorder_xywh={400,140,140,45}, 
	s_wizard_dst_t_eweek_xywh={540,140,120,45},
	s_wizard_dst_t_emoment_xywh={660,140,140,45}, 
	s_wizard_dst_c_offsettime_xywh={60,200,340,45},
	s_wizard_dst_t_offsettime_xywh={400,200,400,45},
	s_wizard_dst_tipinfo_xywh={60,500,700,50},
}

w1_wizard_dst.s_2k = 
{
	s_wizard_dst_xywh= {4,100,1120,800},
	s_wizard_dst_c_dstime_xywh={80,27,533,67},
	s_wizard_dst_t_dstime_xywh={667,27,67,67},
	s_wizard_dst_c_stime_xywh={80,107,293,60},
	s_wizard_dst_t_smonth_xywh={373,107,160,60},
	s_wizard_dst_t_sorder_xywh={533,107,187,60},
	s_wizard_dst_t_sweek_xywh={720,107,160,60},
	s_wizard_dst_t_smoment_xywh={880,107,187,60},
	s_wizard_dst_c_etime_xywh={80,187,293,60},
	s_wizard_dst_t_emonth_xywh={373,187,160,60},
	s_wizard_dst_t_eorder_xywh={533,187,187,60},
	s_wizard_dst_t_eweek_xywh={720,187,160,60},
	s_wizard_dst_t_emoment_xywh={880,187,187,60},
	s_wizard_dst_c_offsettime_xywh={80,267,453,60},
	s_wizard_dst_t_offsettime_xywh={533,267,533,60},
	s_wizard_dst_tipinfo_xywh={80,667,933,67},

}

w1_wizard_dst.s_4k = 
{
	s_wizard_dst_xywh= {6,150,1680,1200},
	s_wizard_dst_c_dstime_xywh={120,40,800,100},
	s_wizard_dst_t_dstime_xywh={1000,40,100,100},
	s_wizard_dst_c_stime_xywh={120,160,440,90},
	s_wizard_dst_t_smonth_xywh={560,160,240,90},
	s_wizard_dst_t_sorder_xywh={800,160,280,90},
	s_wizard_dst_t_sweek_xywh={1080,160,240,90},
	s_wizard_dst_t_smoment_xywh={1320,160,280,90},
	s_wizard_dst_c_etime_xywh={120,280,440,90},
	s_wizard_dst_t_emonth_xywh={560,280,240,90},
	s_wizard_dst_t_eorder_xywh={800,280,280,90},
	s_wizard_dst_t_eweek_xywh={1080,280,240,90},
	s_wizard_dst_t_emoment_xywh={1320,280,280,90},
	s_wizard_dst_c_offsettime_xywh={120,400,680,90},
	s_wizard_dst_t_offsettime_xywh={800,400,800,90},
	s_wizard_dst_tipinfo_xywh={120,1000,1400,100},

}

local month_str =
{
	'LA_JANUARY', 		'LA_FEBRUARY',	'LA_MARCH',		'LA_APRIL',
	'LA_MAY',			'LA_JUNE',		'LA_JULY',			'LA_AUGUST',
	'LA_SEPTEMBER',	'LA_OCTOBER',	'LA_NOVEBER',		'LA_DECEMBER',
}

local order_str =
{
	'LA_FIRST',		'LA_SECOND',		'LA_THIRD',
	'LA_FOURTH', 		'LA_LAST_ONE'
}

local week_str =
{
	'LA_MONDAY_T',		'LA_TUESDAY_T',		'LA_WEDNESDAY_T',
	'LA_THUSDAY_T',		'LA_FRIDAY_T',		'LA_SATURDAY_T',
	'LA_SUNDAY_T',
}

local time24_str =
{
	'0:00',		'0:30',		'1:00',		'1:30',		'2:00',		'2:30',		'3:00',		'3:30',	
	'4:00',		'4:30',		'5:00',		'5:30',		'6:00',		'6:30',		'7:00',		'7:30',	
	'8:00',		'8:30',		'9:00',		'9:30',		'10:00',	'10:30',	'11:00',	'11:30',	
	'12:00',	'12:30',	'13:00',	'13:30',	'14:00',	'14:30',	'15:00',	'15:30',	
	'16:00',	'16:30',	'17:00',	'17:30',	'18:00',	'18:30',	'19:00',	'19:30',	
	'20:00',	'20:30',	'21:00',	'21:30',	'22:00',	'22:30',	'23:00',	'23:30'
}

local time12_str =
{
	'12:00 AM',	'12:30 AM',	'1:00 AM',	'1:30 AM',	'2:00 AM',	'2:30 AM',	
	'3:00 AM',	'3:30 AM',	'4:00 AM',	'4:30 AM',	'5:00 AM',	'5:30 AM',
	'6:00 AM',	'6:30 AM',	'7:00 AM',	'7:30 AM',	'8:00 AM',	'8:30 AM',
	'9:00 AM',	'9:30 AM',	'10:00 AM',	'10:30 AM',	'11:00 AM',	'11:30 AM',
	'12:00 PM',	'12:30 PM',	'1:00 PM',	'1:30 PM',	'2:00 PM',	'2:30 PM',
	'3:00 PM',	'3:30 PM',	'4:00 PM',	'4:30 PM',	'5:00 PM',	'5:30 PM',
	'6:00 PM',	'6:30 PM',	'7:00 PM',	'7:30 PM',	'8:00 PM',	'8:30 PM',
	'9:00 PM',	'9:30 PM',	'10:00 PM',	'10:30 PM',	'11:00 PM',	'11:30 PM',	
}

local on_time = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		
	end
	return 0
end

local on_timezone = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		
	end
	return 0
end
local refresh_dst = function(top, synctime, redraw)
	local cwnd = w1_wizard_dst.wnd;
	if(synctime) then
		b_wnd_ex.set_hide (top, cwnd.c_stime.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_smonth.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_sorder.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_sweek.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_smoment.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.c_etime.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_emonth.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_eorder.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_eweek.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_emoment.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.c_offsettime.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_offsettime.id, false, false);
	else
		b_wnd_ex.set_hide (top, cwnd.c_stime.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_smonth.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_sorder.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_sweek.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_smoment.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.c_etime.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_emonth.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_eorder.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_eweek.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_emoment.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.c_offsettime.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_offsettime.id, true, false);
	end
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

local on_dst = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local synctime = b_wnd_ex.get_check(top, id);
		refresh_dst(top, synctime, true);
	end
	return 0
end

local on_time_index = function(time, time_type)
	for i=1,#time24_str do
		if time == time24_str[i] then
			return i - 1
		end
	end
	for i=1,#time12_str do
		if time == time12_str[i] then
			return i - 1
		end
	end
end

--
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w1_wizard_dst.wnd
	local data = cfgdata.dst
	if(w1_wizard_dst.data == nil) then
		w1_wizard_dst.data = cfgdata.dst
	else
		util.copy_tab_b(w1_wizard_dst.data, cfgdata.dst)
	end
	
	if(w1_wizard_dst.origin_cfg == nil) then
		w1_wizard_dst.origin_cfg = {};	
	end
			
	if(w1_wizard_dst.origin_cfg.dst == nil) then
		w1_wizard_dst.origin_cfg.dst = util.copy_tab(cfgdata.dst)
	else
		util.copy_tab_b(w1_wizard_dst.origin_cfg.dst, cfgdata.dst)
	end
	local dst_enable = data.enable
	if(dst_enable == true) then
		b_wnd_ex.set_check(top, c_wnd.t_dstime.id,true,false)
	else
		b_wnd_ex.set_check(top, c_wnd.t_dstime.id,false,false)--Dat2?dst
	end
	
	b_wnd_ex.set_sel(top, c_wnd.t_smonth.id, data.begin_mon - 1,false)
	b_wnd_ex.set_sel(top, c_wnd.t_sorder.id, data.begin_week - 1,false)
	b_wnd_ex.set_sel(top, c_wnd.t_sweek.id, data.begin_w_day - 1,false)
	
	local s_timetosel = cfgdata['dst']['s_time']	
	local h24 = cfgdata['time']['time_fmt']
	if(h24 == 1) then
		b_wnd_ex.set_items(top, c_wnd.t_smoment.id, time24_str, false);
		b_wnd_ex.set_items(top, c_wnd.t_emoment.id, time24_str, false);
	else
		b_wnd_ex.set_items(top, c_wnd.t_smoment.id, time12_str, false);
		b_wnd_ex.set_items(top, c_wnd.t_emoment.id, time12_str, false);
	end
	s_timetosel = on_time_index(s_timetosel, h24)
	assert(nil ~= s_timetosel)
	b_wnd_ex.set_sel(top, c_wnd.t_smoment.id,s_timetosel,false)
	
	b_wnd_ex.set_sel(top, c_wnd.t_emonth.id, data.end_mon - 1,false)
	b_wnd_ex.set_sel(top, c_wnd.t_eorder.id, data.end_week - 1,false)
	b_wnd_ex.set_sel(top, c_wnd.t_eweek.id, data.end_w_day - 1,false)
	
	local e_timetosel = data.e_time	
	e_timetosel = on_time_index(e_timetosel, h24)
	assert(nil ~= e_timetosel)
	b_wnd_ex.set_sel(top, c_wnd.t_emoment.id,e_timetosel,false)
	
	local offset_time = data.offset
	if(offset_time == 60) then
		b_wnd_ex.set_sel(top, c_wnd.t_offsettime.id,1,false)
	else
		b_wnd_ex.set_sel(top, c_wnd.t_offsettime.id,0,false)
	end
	
	if(dst_enable == true) then
		b_wnd_ex.set_check(top, c_wnd.t_dstime.id,true,false)
		refresh_dst(top, true, false);
	else
		b_wnd_ex.set_check(top, c_wnd.t_dstime.id,false,false)--Dat2?dst
		refresh_dst(top, false, false);
	end
	return 0
end

local on_seltotime = function(time_id, time_type)
	time_id = time_id + 1
	if(0 == time_type) then
		return time12_str[time_id]
	else
		return time24_str[time_id]
	end
end

local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	
	local c_wnd = w1_wizard_dst.wnd
	local enable = b_wnd_ex.get_check(top, c_wnd.t_dstime.id)
	
	local t_smonth = b_wnd_ex.get_sel(top, c_wnd.t_smonth.id)
	local t_sorder = b_wnd_ex.get_sel(top, c_wnd.t_sorder.id)
	local t_emonth = b_wnd_ex.get_sel(top, c_wnd.t_emonth.id)
	local t_eorder = b_wnd_ex.get_sel(top, c_wnd.t_eorder.id)
	if(enable == true)then
		if(t_smonth == t_emonth)then
			if((t_eorder - t_sorder) < 2)then
				legalflag = false		
				table.insert(nlegalid, c_wnd.t_smonth.id)	
				table.insert(nlegalid, c_wnd.t_sorder.id)	
				table.insert(nlegalid, c_wnd.t_emonth.id)	
				table.insert(nlegalid, c_wnd.t_eorder.id)
				w1_wnd_util.setparamerr_str(STR('LA_PARAMETER_ERR'))
			end
		end
	end
	
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

local tabcompare = function(origin_cfg,cur_cfg)
	local param = {}
	for k, v in pairs(cur_cfg) do
		if(origin_cfg[k] ~= nil ) then
			--table,λûеtable¼param
			if( util.compare_tab(origin_cfg[k], cur_cfg[k]) == 1 ) then
				if(param[k] == nil) then
					param[k] =  util.copy_tab(cur_cfg[k])
				else
					util.copy_tab_b(param[k], cur_cfg[k])
				end				
			end
		end
	end
	return param
end

--ûǷи,и,򷵻ظĺ
local usercfgchange =function(origin_cfg,cur_cfg)
	local param = tabcompare(origin_cfg,cur_cfg)
	if(	util.is_empty(param) )then
		return false,nil
	else
		return true, param
	end
end

w1_wizard_dst.dst_to_other =function (top)
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local flag = w1_wnd_util.check_legal_tip(top)
	if(flag ~= 0)then
		w1_wnd_util.tipdispon()		--ʾ
		return -1
	end	
	return 0;
end

w1_wizard_dst.timer_start = function()
	w1_wizard_dst.timestart = true
end

w1_wizard_dst.timer_stop = function(top)
	w1_wizard_dst.timestart = false
	w1_wnd_util.tipclear(top, w1_wizard_dst.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_wizard_dst.timerenevt = function(top)
	if(w1_wizard_dst.timestart) then
		w1_wnd_util.timerenevt(top, w1_wizard_dst.wnd.tipinfo.id)
	end
	return 0
end

w1_wizard_dst.init = function(top)
	local data ={}
	table.insert(data,"dst")
	table.insert(data,"time")
	local dst_time = b_app_api.get_cfg(data)
	cfgdatatoui(top,dst_time);
	return 0
end

w1_wizard_dst.get_data = function (top)
	local c_wnd = w1_wizard_dst.wnd
	local data = w1_wizard_dst.data
	
	data.enable = b_wnd_ex.get_check(top, c_wnd.t_dstime.id)
	
	local t_smonth = b_wnd_ex.get_sel(top, c_wnd.t_smonth.id)
	data.begin_mon = t_smonth + 1
	local t_sorder = b_wnd_ex.get_sel(top, c_wnd.t_sorder.id)
	data.begin_week = t_sorder + 1
	local t_sweek = b_wnd_ex.get_sel(top, c_wnd.t_sweek.id)
	data.begin_w_day = t_sweek + 1
	local t_smoment = b_wnd_ex.get_sel(top, c_wnd.t_smoment.id)
	local h24 = data.time_fmt
	data.s_time = on_seltotime(t_smoment, h24)
	
	local t_emonth = b_wnd_ex.get_sel(top, c_wnd.t_emonth.id)
	data.end_mon = t_emonth + 1
	local t_eorder = b_wnd_ex.get_sel(top, c_wnd.t_eorder.id)
	data.end_week = t_eorder + 1
	local t_eweek = b_wnd_ex.get_sel(top, c_wnd.t_eweek.id)
	data.end_w_day = t_eweek + 1
	local t_emoment = b_wnd_ex.get_sel(top, c_wnd.t_emoment.id)
	data.e_time = on_seltotime(t_emoment, h24)
	local t_offsettime = b_wnd_ex.get_sel(top, c_wnd.t_offsettime.id)
	if(t_offsettime == 1) then
		data.offset = 60
	else
		data.offset = 30
	end
	local cur_data ={};
	cur_data.dst = w1_wizard_dst.data
	local changeflag ,param = usercfgchange(w1_wizard_dst.origin_cfg,cur_data)
	if(changeflag)then
		return param.dst
	else
		return nil;
	end
	
end

w1_wizard_dst.clear = function()
	w1_wizard_dst.origin_cfg = nil;
	w1_wizard_dst.data = nil;
end	

w1_wizard_dst.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_wizard_dst_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'c_dstime', 't_dstime', 'c_stime', 't_smonth', 't_sorder','t_sweek',
			't_smoment','c_etime', 't_emonth', 't_eorder', 't_eweek','t_emoment',
			'c_offsettime', 't_offsettime', 'tipinfo', 'default', 'apply'},
			
	c_dstime 	= {t='static',	id=id+1,	xywh='s_wizard_dst_c_dstime_xywh',text='LA_DST_ENABLE'},
	t_dstime 	= {t='tt_check',	id=id+2,	xywh='s_wizard_dst_t_dstime_xywh',font = 'f_grade1',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					check=true,cmd = on_dst},
	
	c_stime 	= {t='static',	id=id+3,	xywh='s_wizard_dst_c_stime_xywh',	text='LA_START_TIME'},
	t_smonth 	= {t='combox',	id=id+4,	xywh='s_wizard_dst_t_smonth_xywh',	items=month_str},	
	t_sorder 	= {t='combox',	id=id+5,	xywh='s_wizard_dst_t_sorder_xywh',	items=order_str},	
	t_sweek 	= {t='combox',	id=id+6,	xywh='s_wizard_dst_t_sweek_xywh',	items=week_str},	
	t_smoment 	= {t='combox',	id=id+7,	xywh='s_wizard_dst_t_smoment_xywh',	items=time24_str,trans = false},	

	c_etime 	= {t='static',	id=id+8,	xywh='s_wizard_dst_c_etime_xywh',text='LA_END_TIME'},
	t_emonth 	= {t='combox',	id=id+9,	xywh='s_wizard_dst_t_emonth_xywh',items=month_str},	
	t_eorder 	= {t='combox',	id=id+10,	xywh='s_wizard_dst_t_eorder_xywh',items=order_str},	
	t_eweek 	= {t='combox',	id=id+11,	xywh='s_wizard_dst_t_eweek_xywh',items=week_str},	
	t_emoment 	= {t='combox',	id=id+12,	xywh='s_wizard_dst_t_emoment_xywh',	items=time24_str,trans = false},	

	c_offsettime= {t='static',	id=id+13,	xywh='s_wizard_dst_c_offsettime_xywh',text='LA_OFFSET_TIME'},
	t_offsettime= {t='combox',	id=id+14,	xywh='s_wizard_dst_t_offsettime_xywh',	items={'LA_HALFHOUR', 'LA_ONE_HOUR'}},	

	tipinfo		= {t='static', 	id=id+15,	xywh='s_wizard_dst_tipinfo_xywh',			text='',trans = false},
	
--	apply 		= {t='button',	id=id+17,	xywh= 's_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},

}

return w1_wizard_dst

