--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local global_val 	=  require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.wizard_p2p.id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_app_api = require("wnd.core.command.b_app_api");
local t_qr_pp = "P2P";				-- [QR code]P2Pά
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_app_cfg  = require("wnd.core.b_app_cfg")

local w1_wizard_p2p = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_p2p.s_768 =
{
	s_wizard_p2p_xywh = {2,35,448,547},
	s_wizard_p2p_p2p_xywh = {10,14,160,35},
	s_wizard_p2p_hline1_xywh = {8,49,437,1},
	s_wizard_p2p_c_enable_xywh = {32,56,160,35},
	s_wizard_p2p_t_enable_xywh = {236,61,25,21},
	s_wizard_p2p_c_status_xywh = {32,92,160,35},
	s_wizard_p2p_t_status_xywh = {240,92,160,35},
	s_wizard_p2p_c_id_xywh = {32,128,160,35},
	s_wizard_p2p_t_id_xywh = {240,128,160,35},
	s_wizard_p2p_qr_pp_xywh = {240,170,142,142},
	s_wizard_p2p_hline_xywh = {10,334,373,1},
	s_wizard_p2p_c_ppname_xywh = {32,341,160,35},
	s_wizard_p2p_t_ppname_xywh = {240,341,160,35},
	s_wizard_p2p_app_tip_xywh = {32,376,373,35},
};

w1_wizard_p2p.s_1280 = 
{
	s_wizard_p2p_xywh={3,50,840,770},
	s_wizard_p2p_p2p_xywh={20,20,300,50},
	s_wizard_p2p_hline1_xywh={15,70,820,2},	
	s_wizard_p2p_c_enable_xywh = {60,80,300,50},
	s_wizard_p2p_t_enable_xywh = {443,86,48,30},
	s_wizard_p2p_c_status_xywh = {60, 130, 300, 50},
	s_wizard_p2p_t_status_xywh = {450,130, 300, 50},
	s_wizard_p2p_c_id_xywh	   = {60, 180, 300, 50},
	s_wizard_p2p_t_id_xywh	   = {450, 180, 300,50},	
	s_wizard_p2p_qr_pp_xywh	   = {450,240, 200, 200},	
	s_wizard_p2p_hline_xywh    = {20,470,700,2},
	s_wizard_p2p_c_ppname_xywh = {60,480,300,50},
	s_wizard_p2p_t_ppname_xywh  = {450,480,300,50},
	s_wizard_p2p_app_tip_xywh  = {60,530,700,50},	
}

w1_wizard_p2p.s_1440 = 
{
	s_wizard_p2p_xywh={3,50,840,570},
	s_wizard_p2p_p2p_xywh={20,20,300,50},
	s_wizard_p2p_hline1_xywh={15,70,820,2},	
	s_wizard_p2p_c_enable_xywh = {60,80,300,50},
	s_wizard_p2p_t_enable_xywh = {443,86,48,30},
	s_wizard_p2p_c_status_xywh = {60, 130, 300, 50},
	s_wizard_p2p_t_status_xywh = {450,130, 300, 50},
	s_wizard_p2p_c_id_xywh	   = {60, 180, 300, 50},
	s_wizard_p2p_t_id_xywh	   = {450, 180, 300,50},	
	s_wizard_p2p_qr_pp_xywh	   = {450,240, 200, 200},	
	s_wizard_p2p_hline_xywh    = {20,470,700,2},
	s_wizard_p2p_c_ppname_xywh = {60,480,300,50},
	s_wizard_p2p_t_ppname_xywh  = {450,480,300,50},
	s_wizard_p2p_app_tip_xywh  = {60,530,700,50},	
}

w1_wizard_p2p.s_1080p = 
{
	s_wizard_p2p_xywh={3,50,840,770},
	s_wizard_p2p_p2p_xywh={20,20,300,50},
	s_wizard_p2p_hline1_xywh={15,70,820,2},	
	s_wizard_p2p_c_enable_xywh = {60,80,300,50},
	s_wizard_p2p_t_enable_xywh = {443,86,48,30},
	s_wizard_p2p_c_status_xywh = {60, 130, 300, 50},
	s_wizard_p2p_t_status_xywh = {450,130, 300, 50},
	s_wizard_p2p_c_id_xywh	   = {60, 180, 300, 50},
	s_wizard_p2p_t_id_xywh	   = {450, 180, 300,50},	
	s_wizard_p2p_qr_pp_xywh	   = {450,240, 200, 200},	
	s_wizard_p2p_hline_xywh    = {20,470,700,2},
	s_wizard_p2p_c_ppname_xywh = {60,480,300,50},
	s_wizard_p2p_t_ppname_xywh  = {450,480,300,50},
	s_wizard_p2p_app_tip_xywh  = {60,530,700,50},	
}

w1_wizard_p2p.s_2k = 
{
	s_wizard_p2p_xywh={4,67,1120,1026},
	s_wizard_p2p_p2p_xywh={27,27,400,67},
	s_wizard_p2p_hline1_xywh={20,93,1093,3},
	s_wizard_p2p_c_enable_xywh = {80,107,400,67},
	s_wizard_p2p_t_enable_xywh = {591,115,64,40},
	s_wizard_p2p_c_status_xywh = {80,173,400,67},
	s_wizard_p2p_t_status_xywh = {600,173,400,67},
	s_wizard_p2p_c_id_xywh= {80,240,400,67},
	s_wizard_p2p_t_id_xywh= {600,240,400,67},
	s_wizard_p2p_qr_pp_xywh = {600,320,267,267},
	s_wizard_p2p_hline_xywh= {27,627,933,3},
	s_wizard_p2p_c_ppname_xywh= {80,640,400,67},
	s_wizard_p2p_t_ppname_xywh= {600,640,400,67},
	s_wizard_p2p_app_tip_xywh= {80,706,933,67},
}

w1_wizard_p2p.s_4k = 
{
	s_wizard_p2p_xywh={6,100,1680,1540},
	s_wizard_p2p_p2p_xywh={40,40,600,100},
	s_wizard_p2p_hline1_xywh={30,140,1640,4},	
	s_wizard_p2p_c_enable_xywh = {120,160,600,100},
	s_wizard_p2p_t_enable_xywh = {886,172,96,60},
	s_wizard_p2p_c_status_xywh = {120,260,600,100},
	s_wizard_p2p_t_status_xywh = {900,260,600,100},
	s_wizard_p2p_c_id_xywh	   = {120,360,600,100},
	s_wizard_p2p_t_id_xywh	   = {900,360,600,100},	
	s_wizard_p2p_qr_pp_xywh	   = {900,480,400,400},	
	s_wizard_p2p_hline_xywh    = {40,940,1400,4},
	s_wizard_p2p_c_ppname_xywh = {120,960,600,100},
	s_wizard_p2p_t_ppname_xywh  = {900,960,600,100},
	s_wizard_p2p_app_tip_xywh  = {120,1060,1400,100}	
}


--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w1_wizard_p2p.wnd
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,false)
	end
	setcheck(c_wnd.t_enable.id,cfgdata['p2p']['enable'] );
	b_wnd_ex.set_text(top, c_wnd.qr_pp.id, G.dev_sn,false);
	local str =nil;
	local device_info = b_app_api.get_device_info();
	
	if(1 == cfgdata['p2p']['resv'])then
		b_wnd_ex.set_text(top, c_wnd.t_status.id, STR('LA_ONLINE'),false);
		str =device_info.dev_sn.."   "..STR('LA_ONLINE');
	else
		b_wnd_ex.set_text(top, c_wnd.t_status.id, STR('LA_OFFLINE'),false);
		str =device_info.dev_sn.."   "..STR('LA_OFFLINE');
	end
	local app_name = cfgdata['oem_info']['app_name']
	b_wnd_ex.set_text(top, c_wnd.t_ppname.id, app_name,false);
	b_wnd_ex.set_text(top, c_wnd.t_pp.id, device_info.dev_sn,false);
	
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local flag = b_wnd_ex.get_check(top, w1_wizard_p2p.wnd.t_enable.id)
	cfgdata['p2p']['enable'] =flag;
	return 0
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

w1_wizard_p2p.get_data = function(top)
	local data = b_app_cfg.user_cfg;
	local flag = b_wnd_ex.get_check(top, w1_wizard_p2p.wnd.t_enable.id)
	data['p2p']['enable'] = flag;
	return data.p2p;
end
--ҳʼʱٶȡҳҪ
w1_wizard_p2p.init = function(top)
	w1_wnd_util.cfgtab = {'p2p','oem_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_wizard_p2p.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_wizard_p2p_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'p2p','hline1','cap_enable','t_enable','cap_status','t_status','cap_pp','qr_pp','t_pp','hline','cap_ppname','t_ppname',
			't_download_tip','tipinfo'},
	
	p2p 	= {t='checktxt',	id=id+1,xywh='s_wizard_p2p_p2p_xywh',
				text='LA_PTWOP',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,check = true},
	hline1 	= {t='hline',	id=id+2,xywh='s_wizard_p2p_hline1_xywh'},
	
	cap_enable 	= {t='static',	id=id+3,	xywh='s_wizard_p2p_c_enable_xywh',		text='LA_ENABLE_P2P'},
	t_enable 	= {t='tt_check',id=id+4,	xywh='s_wizard_p2p_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable},
	
	cap_status	= {t='static',	id=id+5,	xywh='s_wizard_p2p_c_status_xywh',		text='LA_STATUS'},
	t_status	= {t='static',	id=id+6,	xywh='s_wizard_p2p_t_status_xywh',		text='',trans = false},
	
	cap_pp	= {t='static',	id=id+7,	xywh='s_wizard_p2p_c_id_xywh',		text='LA_P2P_ID'},
	t_pp 		= {t='static',	id=id+8,	xywh='s_wizard_p2p_t_id_xywh',		text='DVR8016134C04027',trans = false},
	qr_pp 		= {t='qr_code',	id=id+9,	xywh='s_wizard_p2p_qr_pp_xywh',	text=t_qr_pp,	trans = false},
	
	hline		= {t='hline', 	id=id+10,	xywh =	's_wizard_p2p_hline_xywh',	color = {'c_camear_line', 'c_camear_line', 'c_camear_line'}},
	cap_ppname 	= {t='static',	id=id+11,	xywh='s_wizard_p2p_c_ppname_xywh',		text='LA_APP_NAME'},
	t_ppname 	= {t='static',	id=id+12,	xywh='s_wizard_p2p_t_ppname_xywh',		text='InView Pro 4',trans = false},
	
	t_download_tip 	= {t='static',	id=id+13,	xywh='s_wizard_p2p_app_tip_xywh',	text='LA_DOWNLOAD_TIP'},
}


return w1_wizard_p2p

