--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/7/4
-- author 
-- brief  öԻ
--]]
local global_val	= require("wnd.global_val")
local b_wnd 		= require("wnd.core.b_wnd")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local b_dlg 		= require("wnd.core.b_dlg")
local b_parser 		= require("wnd.core.b_parser")
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.wizard_time_setup.id
local w1_key 		= require("wnd.w1_util.w1_key")
local r_color		= require("wnd.core.r_res.r_color")
local COLOR 		= r_color.get_color
local b_app_api 	= require("wnd.core.command.b_app_api");
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
--
--local w1_wizard_time_row 	= require("wnd.w1_live.w1_wizard_time_row")
local w1_wizard_time	= require("wnd.w1_live.w1_wizard_time")
local w1_wizard_tzone	= require("wnd.w1_live.w1_wizard_tzone")
local w1_wizard_dst	= require("wnd.w1_live.w1_wizard_dst")
local time_data={}

local w1_wizard_time_setup = {
	cur_page_idx,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_time_setup.s_768 =
{
	s_wizard_time_setup_xywh = {2,35,448,490},
	s_wizard_time_setup_time_xywh = {10,14,85,35},
	s_wizard_time_setup_tzone_xywh = {133,14,80,35},
	s_wizard_time_setup_dst_xywh = {240,14,80,35},
	s_wizard_time_setup_hline_xywh = {8,49,430,1},
};

w1_wizard_time_setup.s_1280 = 
{
	s_wizard_time_setup_xywh ={3,50,840,750},
	s_wizard_time_setup_time_xywh={20,20,160,50},
	s_wizard_time_setup_tzone_xywh= {250,20,150,50},
	s_wizard_time_setup_dst_xywh= {450,20,150,50},
	s_wizard_time_setup_hline_xywh={15,70,808,2},
}
w1_wizard_time_setup.s_1440 = 
{
	s_wizard_time_setup_xywh ={3,50,840,740},
	s_wizard_time_setup_time_xywh={20,20,160,50},
	s_wizard_time_setup_tzone_xywh= {250,20,150,50},
	s_wizard_time_setup_dst_xywh= {450,20,150,50},
	s_wizard_time_setup_hline_xywh={15,70,808,2},
}

w1_wizard_time_setup.s_1080p = 
{
	s_wizard_time_setup_xywh ={3,50,840,690},
	s_wizard_time_setup_time_xywh={20,20,160,50},
	s_wizard_time_setup_tzone_xywh= {250,20,150,50},
	s_wizard_time_setup_dst_xywh= {450,20,150,50},
	s_wizard_time_setup_hline_xywh={15,70,808,2},
}
w1_wizard_time_setup.s_2k = 
{
	s_wizard_time_setup_xywh ={4,67,1120,1000},
	s_wizard_time_setup_time_xywh={27,27,213,67},
	s_wizard_time_setup_tzone_xywh= {333,27,200,67},
	s_wizard_time_setup_dst_xywh= {600,27,200,67},
	s_wizard_time_setup_hline_xywh={20,93,1077,3},


}
w1_wizard_time_setup.s_4k = 
{
	s_wizard_time_setup_xywh ={6,100,1680,1500},
	s_wizard_time_setup_time_xywh={40,40,320,100},
	s_wizard_time_setup_tzone_xywh= {500,40,300,100},
	s_wizard_time_setup_dst_xywh= {900,40,300,100},
	s_wizard_time_setup_hline_xywh={30,140,1616,4},

}
w1_wizard_time_setup.get_checkidx = function(top)
	local timecheck = b_wnd_ex.get_check(top, w1_wizard_time_setup.wnd.time.id);
	local tzonecheck = b_wnd_ex.get_check(top, w1_wizard_time_setup.wnd.tzone.id);
	local dstcheck = b_wnd_ex.get_check(top, w1_wizard_time_setup.wnd.dst.id);
	if(timecheck) then
		return 0
	elseif(tzonecheck) then
		return 1
	elseif(dstcheck) then
		return 2
	end
end

local on_time = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(1 == w1_wizard_time_setup.cur_page_idx)then
			w1_wizard_tzone.timer_stop(top);
		elseif(2 == w1_wizard_time_setup.cur_page_idx)then
			if(0 ~= w1_wizard_dst.dst_to_other(top))then
				b_wnd_ex.set_check(top, w1_wizard_time_setup.wnd.time.id, false, true);
				return 0;
			end
			w1_wizard_dst.timer_stop(top);
		end
		
		b_wnd_ex.set_check(top, w1_wizard_time_setup.wnd.dst.id, false, false);
		b_wnd_ex.set_check(top, w1_wizard_time_setup.wnd.tzone.id, false, false);
		b_wnd_ex.set_show_page(top,w1_id.wizard_time_setup.conRow_id, w1_id.wizard_time.wizard_time_id, false)
		b_dlg.dlg_set_redraw(top)
		local dst = w1_wizard_dst.get_data(top)
		if(dst ~= nil)then 
			time_data.dst =dst;	
		end
		local tzone =w1_wizard_tzone.get_data(top)
		if(tzone ~= nil)then 
			time_data.timezone =tzone;
		end	
		w1_wizard_time.timer_start();	
		w1_wizard_time_setup.cur_page_idx = w1_wizard_time_setup.get_checkidx(top)
	end
	return 0
end

local on_tzone = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(0 == w1_wizard_time_setup.cur_page_idx)then
			local legal = w1_wizard_time.check_time(top)
			if(legal ~= 0)then
				b_wnd_ex.set_check(top, w1_wizard_time_setup.wnd.tzone.id, false, true);
				return 0;
			end
			w1_wizard_time.timer_stop(top);
		elseif(2 == w1_wizard_time_setup.cur_page_idx)then
			if(0 ~= w1_wizard_dst.dst_to_other(top))then
				b_wnd_ex.set_check(top, w1_wizard_time_setup.wnd.tzone.id, false, true);
				return 0;
			end
			w1_wizard_dst.timer_stop(top);
		end
		b_wnd_ex.set_check(top, w1_wizard_time_setup.wnd.time.id, false, false);
		b_wnd_ex.set_check(top, w1_wizard_time_setup.wnd.dst.id, false, false);
		w1_wizard_time_setup.cur_page_idx = w1_wizard_time_setup.get_checkidx(top)
		b_wnd_ex.set_show_page(top,w1_id.wizard_time_setup.conRow_id, w1_id.wizard_time.wizard_tzone_id, false)
		b_dlg.dlg_set_redraw(top);
		local time =w1_wizard_time.get_data(top)
		if(time ~= nil)then 
			time_data.time =time;
		end
		local dst = w1_wizard_dst.get_data(top)
		if(dst ~= nil)then 
			time_data.dst =dst;	
		end	
		w1_wizard_tzone.timer_start();
	end
	return 0
end

local on_dst = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(0 == w1_wizard_time_setup.cur_page_idx)then
			local legal = w1_wizard_time.check_time(top)
			if(legal ~= 0)then
				b_wnd_ex.set_check(top, w1_wizard_time_setup.wnd.dst.id, false, true);
				return 0;
			end
			w1_wizard_time.timer_stop(top);
		elseif(1 == w1_wizard_time_setup.cur_page_idx)then
			w1_wizard_tzone.timer_stop(top);
		end
		local check_idx = w1_wizard_time_setup.get_checkidx(top)
		local time =w1_wizard_time.get_data(top)
		if(time ~= nil)then 
			time_data.time =time;
		end
		local tzone =w1_wizard_tzone.get_data(top)
		if(tzone ~= nil)then 
			time_data.timezone =tzone;
		end		
		b_wnd_ex.set_check(top, w1_wizard_time_setup.wnd.time.id, false, false);
		b_wnd_ex.set_check(top, w1_wizard_time_setup.wnd.tzone.id, false, false);
		b_wnd_ex.set_show_page(top,w1_id.wizard_time_setup.conRow_id, w1_id.wizard_time.wizard_dst_id, false)	
		b_dlg.dlg_set_redraw(top)
		if(0 ==check_idx)then
			w1_wizard_time.timer_stop(top);
		end
		w1_wizard_dst.timer_start();
		w1_wizard_time_setup.cur_page_idx = w1_wizard_time_setup.get_checkidx(top)
	end
	return 0
end

w1_wizard_time_setup.get_data = function (top)
	local time = w1_wizard_time.get_data(top)
	if(time ~= nil)then 
		time_data.time =time;
	end
	return time_data;
end

w1_wizard_time_setup.move_title_show = function(top)
	local cwnd = w1_wizard_time_setup.wnd;
	local pos = SIZE('s_wizard_time_setup_xywh');
	local title_1 = SIZE('s_wizard_time_setup_time_xywh');
	local title_w =pos[3]-title_1[4]*2
	local size1 = b_wnd_ex.get_textsize(top, cwnd.time.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.tzone.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.dst.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.time.id).border * 60 ;--
	local total_w = size1 +size2+size3+space*4
	
	local space2 = b_wnd_ex.get_textsize(top, cwnd.time.id).border * 50 ;--
	local total_w2 = size1 +size2+size3+space2*4
	
	local space3 = b_wnd_ex.get_textsize(top, cwnd.time.id).border * 40 ;--
	local total_w3 = size1 +size2+size3+space3*4
--	local title_1 = SIZE('s_cfg_row_1')
	
	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.time.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.tzone.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+2*space,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.dst.id, movepos3, false);
	elseif(title_w > total_w2)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.time.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space2,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.tzone.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+2*space2,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.dst.id, movepos3, false);
	elseif(title_w > total_w3)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.time.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space3,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.tzone.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+2*space3,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.dst.id, movepos3, false);
	end
end

w1_wizard_time_setup.on_pre_show = function(top)
	local cwnd = w1_wizard_time_setup.wnd;
	local con_id = cwnd.containerRow.id
	b_wnd_ex.set_add_page(top, con_id, cwnd.w1_wizard_time_wnd.id)
	b_wnd_ex.set_add_page(top, con_id, cwnd.w1_wizard_tzone_wnd.id)
	b_wnd_ex.set_add_page(top, con_id, cwnd.w1_wizard_dst_wnd.id)
	
	b_wnd_ex.set_show_page(top,con_id, cwnd.w1_wizard_time_wnd.id, false)
	w1_wizard_time_setup.move_title_show(top)
--	b_wnd_ex.set_show_page(top,con_id, cwnd.w1_wizard_dst_wnd.id, false)
end

w1_wizard_time_setup.init = function(top)
	w1_wizard_time.init(top)
	w1_wizard_tzone.init(top)
	w1_wizard_dst.init(top)
	w1_wizard_time_setup.cur_page_idx = w1_wizard_time_setup.get_checkidx(top)
end

w1_wizard_time_setup.wnd= {
	--attr={xywh={1015,378,900,660}};
	t='wnd_bg',id=id,xywh = 's_wizard_time_setup_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'containerColumn', 'containerRow', 'containerItem',
			'w1_wizard_time_setup_wnd','w1_wizard_time_wnd','w1_wizard_time_row',
			'w1_wizard_tzone_wnd','w1_wizard_dst_wnd','w1_disk_wnd',
			'close','time','tzone','dst', 'hline'
		},
		
	containerRow	= {t='container',id=w1_id.wizard_time_setup.conRow_id,	xywh='s_cfg_con_xywh'},
--	w1_wizard_time_row	= w1_wizard_time_row.wnd,	
	w1_wizard_time_wnd 	= w1_wizard_time.wnd,
	w1_wizard_tzone_wnd	=	w1_wizard_tzone.wnd,
	w1_wizard_dst_wnd	= w1_wizard_dst.wnd,
	time 	= {t='checktxt',	id=id+4,xywh='s_wizard_time_setup_time_xywh',
				text='LA_DATE_TIME',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_time,check = true},
	tzone 	= {t='checktxt',	id=id+5,xywh= 's_wizard_time_setup_tzone_xywh',
				text='LA_ZONE',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_tzone},
	dst 	= {t='checktxt',	id=id+6,xywh= 's_wizard_time_setup_dst_xywh',
				text='LA_DST',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_dst},
	hline 	= {t='hline',	id=id+7,xywh='s_wizard_time_setup_hline_xywh'}
	
}

return w1_wizard_time_setup;




