--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/04/16
-- author 
-- brief  
--]]



local w1_all_require = 
{
--
	w1_msgbox 									= require("wnd.w1_util.w1_msgbox"),
	w1_util_size 								= require("wnd.w1_util.w1_util_size"),
	w1_copy 									= require("wnd.w1_util.w1_copy"),
--ֳ
	w1_login 									= require("wnd.w1_live.w1_login"),
	w1_login_pattern 							= require("wnd.w1_live.w1_login_pattern"),
	w1_activation								= require("wnd.w1_live.w1_activation"),
	w1_forget 									= require("wnd.w1_live.w1_forget"),
	w1_modify_default_pwd 						= require("wnd.w1_live.w1_modify_default_pwd"),
	w1_reminderchange_pw 						= require("wnd.w1_live.w1_reminderchange_pw"),
	w1_home_menu 								= require("wnd.w1_live.w1_home_menu"),
	w1_manual_control 							= require("wnd.w1_live.w1_manual_control"),
	w1_net_packet								= require("wnd.w1_live.w1_net_packet"),
	w1_alarm_list 								= require("wnd.w1_live.w1_alarm_list"),	
	w1_wizard 									= require("wnd.w1_live.w1_wizard"),
	w1_wizard_setup								= require("wnd.w1_live.w1_wizard_setup"),
	w1_wizard_camera							= require("wnd.w1_live.w1_wizard_camera"),
	w1_wizard_disk								= require("wnd.w1_live.w1_wizard_disk"),
	w1_wizard_dst								= require("wnd.w1_live.w1_wizard_dst"),
	w1_wizard_network							= require("wnd.w1_live.w1_wizard_network"),
	w1_wizard_net_cctv  						= require("wnd.w1_live.w1_wizard_net_cctv"),
	w1_wizard_network_setup 					= require("wnd.w1_live.w1_wizard_network_setup"),
	w1_wizard_sys								= require("wnd.w1_live.w1_wizard_sys"),
	w1_wizard_p2p								= require("wnd.w1_live.w1_wizard_p2p"),
	w1_wizard_time								= require("wnd.w1_live.w1_wizard_time"),
	w1_wizard_time_setup 						= require("wnd.w1_live.w1_wizard_time_setup"),
	w1_wizard_tzone 							= require("wnd.w1_live.w1_wizard_tzone"),
	w1_add_device								= require("wnd.w1_live.w1_add_device"),
	w1_audio									= require("wnd.w1_live.w1_audio"),
	w1_live_edit_dev							= require("wnd.w1_live.w1_edit_device"),
	w1_image_adjust								= require("wnd.w1_live.w1_image_adjust"),
	w1_ptz										= require("wnd.w1_live.w1_ptz"),
	w1_ptz_advanced								= require("wnd.w1_live.w1_ptz_advanced"),
	w1_ptz_control								= require("wnd.w1_live.w1_ptz_control"),
	w1_ptz_preset								= require("wnd.w1_live.w1_ptz_preset"),
	w1_ptz_set									= require("wnd.w1_live.w1_ptz_set"),
	w1_ptz_scan									= require("wnd.w1_live.w1_ptz_scan"),
	w1_ptz_cruise								= require("wnd.w1_live.w1_ptz_cruise"),
	w1_deminder_change_pwd						= require("wnd.w1_live.w1_reminderchange_pw"),
	w1_row_ptz_preset							= require("wnd.w1_live.w1_row_ptz_preset"),
	w1_shut_down								= require("wnd.w1_live.w1_shutdown"),
	w1_sysinfo									= require("wnd.w1_live.w1_sysinfo"),
	w1_sysinfo_channel							= require("wnd.w1_live.w1_sysinfo_channel"),
	w1_sysinfo_disk								= require("wnd.w1_live.w1_sysinfo_disk"),
	w1_sysinfo_network							= require("wnd.w1_live.w1_sysinfo_network"),
	w1_sysinfo_row								= require("wnd.w1_live.w1_sysinfo_row"),
	w1_sysinfo_system							= require("wnd.w1_live.w1_sysinfo_system"),
	w1_sysinfo_alarm							= require("wnd.w1_live.w1_sysinfo_alarm"),
	--
	w1_cfg_settings								= require("wnd.w1_cfg.w1_cfg_settings"),	--ҳ
	w1_cfg_setup								= require("wnd.w1_cfg.w1_cfg_setup"),		
	w1_page_image								= require("wnd.w1_cfg.w1_page_image"),		--ͨҳ
	w1_row_imagerow 							= require("wnd.w1_cfg.w1_row_imagerow"),
	w1_row_param_confrow						= require("wnd.w1_cfg.w1_row_param_confrow"),
	w1_row_multi_objrow							= require("wnd.w1_cfg.w1_row_multi_objrow"),
	w1_row_platerow								= require("wnd.w1_cfg.w1_row_platerow"),
	w1_row_facerow								= require("wnd.w1_cfg.w1_row_facerow"),
	w1_page_imagetime 							= require("wnd.w1_cfg.w1_page_imagetime"),
	w1_page_imageadjust							= require("wnd.w1_cfg.w1_page_imageadjust"),
	w1_page_imagepcolor							= require("wnd.w1_cfg.w1_page_imagepcolor"),
	w1_page_imageffc							= require("wnd.w1_cfg.w1_page_imageffc"),
	w1_page_imagescenes							= require("wnd.w1_cfg.w1_page_imagescenes"),
	w1_page_imageexposure						= require("wnd.w1_cfg.w1_page_imageexposure"),
	w1_page_imagebalance  						= require("wnd.w1_cfg.w1_page_imagebalance"),
	w1_page_imagedaynight 						= require("wnd.w1_cfg.w1_page_imagedaynight"),
	w1_page_imagenoise    						= require("wnd.w1_cfg.w1_page_imagenoise"),
	w1_page_imageenhance  						= require("wnd.w1_cfg.w1_page_imageenhance"),
	w1_page_imagefocus							= require("wnd.w1_cfg.w1_page_imagefocus"),
	w1_page_osd									= require("wnd.w1_cfg.w1_page_osd"),
	w1_page_microphone							= require("wnd.w1_cfg.w1_page_microphone"),
	w1_page_channel_type 						= require("wnd.w1_cfg.w1_page_channel_type"),
	w1_page_roi									= require("wnd.w1_cfg.w1_page_roi"),
	w1_page_track								= require("wnd.w1_cfg.w1_page_track"),
	w1_page_param_conf							= require("wnd.w1_cfg.w1_page_param_conf"),
	w1_page_param_confface_detect				= require("wnd.w1_cfg.w1_page_param_confface_detect"),
	w1_page_param_conftemp_param				= require("wnd.w1_cfg.w1_page_param_conftemp_param"),
	w1_page_param_conf_levent					= require("wnd.w1_cfg.w1_page_param_conf_levent"),
	w1_page_param_conf_nevent					= require("wnd.w1_cfg.w1_page_param_conf_nevent"),
	w1_page_param_conf_hevent					= require("wnd.w1_cfg.w1_page_param_conf_hevent"),
	w1_page_param_conftimeplan					= require("wnd.w1_cfg.w1_page_param_conftimeplan"),	
	w1_page_thermal_map							= require("wnd.w1_cfg.w1_page_thermal_map"),
	w1_page_thermal_cal							= require("wnd.w1_cfg.w1_page_thermal_cal"),
	w1_page_multi_obj							= require("wnd.w1_cfg.w1_page_multi_obj"),
	w1_page_multi_objparam						= require("wnd.w1_cfg.w1_page_multi_objparam"),
	w1_page_multi_objtimeplan					= require("wnd.w1_cfg.w1_page_multi_objtimeplan"),
	w1_page_plate								= require("wnd.w1_cfg.w1_page_plate"),
	w1_page_plateparam							= require("wnd.w1_cfg.w1_page_plateparam"),
	w1_page_plateblackwhite						= require("wnd.w1_cfg.w1_page_plateblackwhite"),
	w1_page_plateledcfg							= require("wnd.w1_cfg.w1_page_plateledcfg"),	
	w1_page_platetimeplan						= require("wnd.w1_cfg.w1_page_platetimeplan"),
	w1_page_face								= require("wnd.w1_cfg.w1_page_face"),
	w1_page_faceparam							= require("wnd.w1_cfg.w1_page_faceparam"),
	w1_page_facetimeplan						= require("wnd.w1_cfg.w1_page_facetimeplan"),
	w1_page_privacyarea							= require("wnd.w1_cfg.w1_page_privacyarea"),
	w1_page_camera								= require("wnd.w1_cfg.w1_page_camera"),
	w1_page_pro_man								= require("wnd.w1_cfg.w1_page_pro_man"),
	w1_page_encode								= require("wnd.w1_cfg.w1_page_encode"),
	w1_page_diskcfg								= require("wnd.w1_cfg.w1_page_diskcfg"),	--¼ҳ
	w1_page_ftp									= require("wnd.w1_cfg.w1_page_ftp"),	--ftpҳ
	w1_page_raid								= require("wnd.w1_cfg.w1_page_raid"),
	w1_page_smart								= require("wnd.w1_cfg.w1_page_smart"),
	w1_page_wdda								= require("wnd.w1_cfg.w1_page_wdda"),
	w1_page_bad_detection						= require("wnd.w1_cfg.w1_page_bad_detection"),
	w1_page_disk_group							= require("wnd.w1_cfg.w1_page_group"),
	w1_page_cloud								= require("wnd.w1_cfg.w1_page_cloud"),
	w1_page_record								= require("wnd.w1_cfg.w1_page_record"),
	w1_page_dis_cal								= require("wnd.w1_cfg.w1_page_dis_cal"),
	w1_create_raid								= require("wnd.w1_cfg.w1_create_raid"),
	w1_edit_raid								= require("wnd.w1_cfg.w1_edit_raid"),
	w1_edit_raid_msgbox							= require("wnd.w1_cfg.w1_edit_raid_msgbox"),
	w1_edit_ipfilter							= require("wnd.w1_cfg.w1_edit_ipfilter"),	--ҳ
	w1_modify_cam_ip							= require("wnd.w1_cfg.w1_modify_cam_ip"),	--޸IP
	w1_modify_adam_ip							= require("wnd.w1_cfg.w1_modify_adam_ip"),	
	w1_page_8021x								= require("wnd.w1_cfg.w1_page_8021x"),
	w1_page_ddns								= require("wnd.w1_cfg.w1_page_ddns"),
	w1_page_ipfilter							= require("wnd.w1_cfg.w1_page_ipfilter"),
	w1_page_poe									= require("wnd.w1_cfg.w1_page_poe"),
	w1_page_port								= require("wnd.w1_cfg.w1_page_port"),
	w1_page_pp									= require("wnd.w1_cfg.w1_page_pp"),
	w1_page_smtp								= require("wnd.w1_cfg.w1_page_smtp"),
	w1_page_smtp2								= require("wnd.w1_cfg.w1_page_smtp2"),
	w1_page_immix								= require("wnd.w1_cfg.w1_page_immix"),	
	w1_page_upnp								= require("wnd.w1_cfg.w1_page_upnp"),
	w1_page_nat_port							= require("wnd.w1_cfg.w1_page_nat_port"),
	w1_page_ip									= require("wnd.w1_cfg.w1_page_ip"),
	w1_page_eth_route							= require("wnd.w1_cfg.w1_page_eth_route"),
	w1_page_ipv4_cctv							= require("wnd.w1_cfg.w1_page_ipv4_cctv"),
	w1_page_snmp								= require("wnd.w1_cfg.w1_page_snmp"),
	w1_page_snmp12								= require("wnd.w1_cfg.w1_page_snmp12"),
	w1_page_snmp_port							= require("wnd.w1_cfg.w1_page_snmp_port"),
	w1_page_wifi_cfg							= require("wnd.w1_cfg.w1_page_wifi_cfg"),
	w1_page_wifi_network						= require("wnd.w1_cfg.w1_page_wifi_network"),
	w1_page_3g_4g								= require("wnd.w1_cfg.w1_page_3g_4g"),
	w1_page_pppoe								= require("wnd.w1_cfg.w1_page_pppoe"),
	w1_page_net_stat							= require("wnd.w1_cfg.w1_page_net_stat"),
	w1_page_lan_info							= require("wnd.w1_cfg.w1_page_lan_info"),
	w1_page_alarm_service_center 				= require("wnd.w1_cfg.w1_page_alarm_service_center"),
	w1_page_platform_access 					= require("wnd.w1_cfg.w1_page_platform_access"),
	w1_row_snmp									= require("wnd.w1_cfg.w1_row_snmp"),
	w1_row_motionrow							= require("wnd.w1_cfg.w1_row_motionrow"),	--ñҳ
	w1_row_tamperrow							= require("wnd.w1_cfg.w1_row_tamperrow"),
	w1_page_motionarea							= require("wnd.w1_cfg.w1_page_motionarea"),
	w1_page_alarmin								= require("wnd.w1_cfg.w1_page_alarmin"),
	w1_page_alarminevent						= require("wnd.w1_cfg.w1_page_alarminevent"),
	w1_page_alarmintimeplan						= require("wnd.w1_cfg.w1_page_alarmintimeplan"),
	w1_page_ioalarm								= require("wnd.w1_cfg.w1_page_ioalarm"),
	w1_page_ioalarmevent						= require("wnd.w1_cfg.w1_page_ioalarmevent"),
	w1_page_ioalarmtimeplan						= require("wnd.w1_cfg.w1_page_ioalarmtimeplan"),
	w1_page_alarm_advance 						= require("wnd.w1_cfg.w1_page_alarmin_advance"),
	w1_page_alarmout							= require("wnd.w1_cfg.w1_page_alarmout"),
	w1_page_alarmout_c							= require("wnd.w1_cfg.w1_page_alarmout_c"),
	w1_page_audio_out							= require("wnd.w1_cfg.w1_page_audio_out"),
	w1_page_loss								= require("wnd.w1_cfg.w1_page_loss"),
	w1_page_losstimeplan						= require("wnd.w1_cfg.w1_page_losstimeplan"),
	w1_page_adam								= require("wnd.w1_cfg.w1_page_adam"),	
	w1_page_nvr_noopsyche_general				= require("wnd.w1_cfg.w1_page_nvr_noopsyche_general"),
	
	w1_page_noopsyche_enter_area				= require("wnd.w1_cfg.w1_page_noopsyche_enter_area"),
	w1_page_noopsyche_leave_area				= require("wnd.w1_cfg.w1_page_noopsyche_leave_area"),
	w1_page_noopsyche_advance					= require("wnd.w1_cfg.w1_page_noopsyche_advance"),
	w1_page_noopsyche_badsignal					= require("wnd.w1_cfg.w1_page_noopsyche_badsignal"),
	w1_page_noopsyche_cordon					= require("wnd.w1_cfg.w1_page_noopsyche_cordon"),
	w1_page_noopsyche_dcordon					= require("wnd.w1_cfg.w1_page_noopsyche_dcordon"),
	w1_page_noopsyche_perimeter					= require("wnd.w1_cfg.w1_page_noopsyche_perimeter"),
	w1_page_noopsyche_objectleft				= require("wnd.w1_cfg.w1_page_noopsyche_objectleft"),
	w1_page_noopsyche_objectremove				= require("wnd.w1_cfg.w1_page_noopsyche_objectremove"),
	w1_page_noopsyche_abnormal_speed			= require("wnd.w1_cfg.w1_page_noopsyche_abnormal_speed"),
	w1_page_noopsyche_fence						= require("wnd.w1_cfg.w1_page_noopsyche_fence"),
	w1_page_noopsyche_converse					= require("wnd.w1_cfg.w1_page_noopsyche_converse"),
	w1_page_noopsyche_illegal_packing			= require("wnd.w1_cfg.w1_page_noopsyche_illegal_packing"),
	w1_page_noopsyche_loiter					= require("wnd.w1_cfg.w1_page_noopsyche_loiter"),
	w1_page_noopsyche_multiloiter				= require("wnd.w1_cfg.w1_page_noopsyche_multiloiter"),
	w1_page_noopsyche_person_count				= require("wnd.w1_cfg.w1_page_noopsyche_person_count"),
	w1_page_surve								= require("wnd.w1_cfg.w1_page_surve"),
	w1_page_abnormal							= require("wnd.w1_cfg.w1_page_abnormal"),
	w1_page_abnormalevent						= require("wnd.w1_cfg.w1_page_abnormalevent"),
	w1_row_abnormalrow							= require("wnd.w1_cfg.w1_row_abnormalrow"),
	w1_page_tamper								= require("wnd.w1_cfg.w1_page_tamper"),
	w1_page_tamperevent							= require("wnd.w1_cfg.w1_page_tamperevent"),
	w1_page_tampertimeplan						= require("wnd.w1_cfg.w1_page_tampertimeplan"),
	w1_row_alarminrow							= require("wnd.w1_cfg.w1_row_alarminrow"),
	w1_row_ioalarmrow							= require("wnd.w1_cfg.w1_row_alarminrow"),
	w1_row_out									= require("wnd.w1_cfg.w1_row_out"),
	w1_page_motionevent							= require("wnd.w1_cfg.w1_page_motionevent"),
	w1_page_motiontimeplan						= require("wnd.w1_cfg.w1_page_motiontimeplan"),
	w1_row_lossrow								= require("wnd.w1_cfg.w1_row_lossrow"),
	
	w1_row_nvr_noopsyche						= require("wnd.w1_cfg.w1_row_nvr_noopsyche"),
	w1_row_nvr_noopsycherow_perimeter			= require("wnd.w1_cfg.w1_row_nvr_noopsycherow_perimeter"),

	w1_page_nvr_noopsychearea_perimeter			= require("wnd.w1_cfg.w1_page_nvr_noopsychearea_perimeter"),

	w1_row_noopsycherow_enter_area				= require("wnd.w1_cfg.w1_row_noopsycherow_enter_area"),
	w1_row_noopsycherow_leave_area				= require("wnd.w1_cfg.w1_row_noopsycherow_leave_area"),
	w1_row_noopsyche							= require("wnd.w1_cfg.w1_row_noopsyche"),
	w1_row_noopsycherow_person_count			= require("wnd.w1_cfg.w1_row_noopsycherow_person_count"),
	w1_row_noopsycherow_advance					= require("wnd.w1_cfg.w1_row_noopsycherow_advance"),
	w1_row_noopsycherow_badsignal				= require("wnd.w1_cfg.w1_row_noopsycherow_badsignal"),
	w1_row_noopsycherow_cordon					= require("wnd.w1_cfg.w1_row_noopsycherow_cordon"),
	w1_row_noopsycherow_dcordon					= require("wnd.w1_cfg.w1_row_noopsycherow_dcordon"),
	w1_row_noopsycherow_perimeter				= require("wnd.w1_cfg.w1_row_noopsycherow_perimeter"),
	w1_row_noopsycherow_objectleft				= require("wnd.w1_cfg.w1_row_noopsycherow_objectleft"),
	w1_row_noopsycherow_objectremove			= require("wnd.w1_cfg.w1_row_noopsycherow_objectremove"),
	w1_row_noopsycherow_converse				= require("wnd.w1_cfg.w1_row_noopsycherow_converse"),
	w1_row_noopsycherow_abnormal_speed			= require("wnd.w1_cfg.w1_row_noopsycherow_abnormal_speed"),
	w1_row_noopsycherow_illegal_packing			= require("wnd.w1_cfg.w1_row_noopsycherow_illegal_packing"),
	w1_row_noopsycherow_loiter					= require("wnd.w1_cfg.w1_row_noopsycherow_loiter"),
	w1_row_noopsycherow_multiloiter				= require("wnd.w1_cfg.w1_row_noopsycherow_multiloiter"),
	w1_page_motion								= require("wnd.w1_cfg.w1_page_motion"),
	w1_page_lossevent							= require("wnd.w1_cfg.w1_page_lossevent"),
	w1_page_noopsychearea_advance				= require("wnd.w1_cfg.w1_page_noopsychearea_advance"),
	w1_page_noopsychearea_badsignal				= require("wnd.w1_cfg.w1_page_noopsychearea_badsignal"),
	w1_page_noopsychearea_cordon				= require("wnd.w1_cfg.w1_page_noopsychearea_cordon"),
	w1_page_noopsychearea_dcordon				= require("wnd.w1_cfg.w1_page_noopsychearea_dcordon"),
	w1_page_noopsychearea_perimeter				= require("wnd.w1_cfg.w1_page_noopsychearea_perimeter"),
	w1_page_noopsychearea_objectleft			= require("wnd.w1_cfg.w1_page_noopsychearea_objectleft"),
	w1_page_noopsychearea_objectremove			= require("wnd.w1_cfg.w1_page_noopsychearea_objectremove"),
	w1_page_noopsychearea_abnormal_speed		= require("wnd.w1_cfg.w1_page_noopsychearea_abnormal_speed"),
	w1_page_noopsychearea_loiter				= require("wnd.w1_cfg.w1_page_noopsychearea_loiter"),
	w1_page_noopsychearea_multiloiter			= require("wnd.w1_cfg.w1_page_noopsychearea_multiloiter"),
	w1_page_noopsychearea_converse				= require("wnd.w1_cfg.w1_page_noopsychearea_converse"),
	w1_page_noopsychetimeplan_person_count		= require("wnd.w1_cfg.w1_page_noopsychetimeplan_person_count"),
	w1_page_noopsychearea_person_count			= require("wnd.w1_cfg.w1_page_noopsychearea_person_count"),	
	w1_page_noopsychearea_fence					= require("wnd.w1_cfg.w1_page_noopsychearea_fence"),
	w1_page_noopsychearea_illegal_packing		= require("wnd.w1_cfg.w1_page_noopsychearea_illegal_packing"),
	w1_page_noopsychearea_enter_area			= require("wnd.w1_cfg.w1_page_noopsychearea_enter_area"),
	w1_page_noopsychearea_leave_area			= require("wnd.w1_cfg.w1_page_noopsychearea_leave_area"),
	w1_page_info								= require("wnd.w1_cfg.w1_page_info"),		--ϵͳҳ
	w1_page_info_chn								= require("wnd.w1_cfg.w1_page_info_chn"),
	w1_page_info_net								= require("wnd.w1_cfg.w1_page_info_net"),
	w1_page_info_disk								= require("wnd.w1_cfg.w1_page_info_disk"),
	w1_page_info_alarm								= require("wnd.w1_cfg.w1_page_info_alarm"),
	w1_page_dst									= require("wnd.w1_cfg.w1_page_dst"),
	w1_modify_camera							= require("wnd.w1_cfg.w1_modify_camera"),
	w1_add_user									= require("wnd.w1_cfg.w1_add_user"),
	w1_page_dwell								= require("wnd.w1_cfg.w1_page_dwell"),
	w1_page_devm								= require("wnd.w1_cfg.w1_page_devm"),
	w1_reset									= require("wnd.w1_cfg.w1_reset"),
	w1_page_logm								= require("wnd.w1_cfg.w1_page_logm"),
	w1_page_events								= require("wnd.w1_cfg.w1_page_events"),
	w1_page_restart								= require("wnd.w1_cfg.w1_page_restart"),
	w1_page_ai_resource							= require("wnd.w1_cfg.w1_page_ai_resource"),
	w1_page_modify								= require("wnd.w1_cfg.w1_page_modify"),
	w1_page_modify_g							= require("wnd.w1_cfg.w1_page_modify_g"),
	w1_page_securitymail						= require("wnd.w1_cfg.w1_page_securitymail"),
	w1_page_securityquestion					= require("wnd.w1_cfg.w1_page_securityquestion"),
	w1_row_basic								= require("wnd.w1_cfg.w1_row_basic"),
	w1_row_user									= require("wnd.w1_cfg.w1_row_user"),
	w1_page_pri									= require("wnd.w1_cfg.w1_page_pri"),
	w1_page_phone_filter						= require("wnd.w1_cfg.w1_page_phone_filter"),
	w1_edit_phone_filter						= require("wnd.w1_cfg.w1_edit_phone_filter"),
	w1_page_privacy								= require("wnd.w1_cfg.w1_page_privacy"),
	w1_page_sys									= require("wnd.w1_cfg.w1_page_sys"),
	w1_page_time								= require("wnd.w1_cfg.w1_page_time"),
	w1_page_tzone								= require("wnd.w1_cfg.w1_page_tzone"),
	w1_page_ipctime								= require("wnd.w1_cfg.w1_page_ipctime"),
	w1_row_auxiliary							= require("wnd.w1_cfg.w1_row_auxiliary"),
	w1_page_auxiliary_cfg						= require("wnd.w1_cfg.w1_page_auxiliary_cfg"),
	w1_page_auxiliary_dsp						= require("wnd.w1_cfg.w1_page_auxiliary_dsp"),
	w1_pattern_pop								= require("wnd.w1_cfg.w1_pattern_pop"),
	w1_edit_record								= require("wnd.w1_live.w1_edit_record"),	
	w1_page_add_dwell							= require("wnd.w1_cfg.w1_page_add_dwell"),
	w1_select_intelligent_type					= require("wnd.w1_cfg.w1_select_intelligent_type"),

	w1_page_flash_light_alarm					= require("wnd.w1_cfg.w1_page_flash_light_alarm"),
	w1_page_flashtimeplan						= require("wnd.w1_cfg.w1_page_flashtimeplan"),
	w1_row_flashrow								= require("wnd.w1_cfg.w1_row_flashrow"),	

	w1_page_plate_bwadv							= require("wnd.w1_cfg.w1_page_plate_bwadv"),
	w1_page_plate_edit							= require("wnd.w1_cfg.w1_page_plate_edit"),
	w1_add_eth_route							= require("wnd.w1_cfg.w1_add_eth_route"),
	
	w1_row_adv_insight							= require("wnd.w1_cfg.w1_row_adv_insight"),
	w1_row_adv_insightrow_smoker_dec			= require("wnd.w1_cfg.w1_row_adv_insightrow_smoker_dec"),
	w1_page_adv_insightarea_smoker_dec			= require("wnd.w1_cfg.w1_page_adv_insightarea_smoker_dec"),		
	w1_row_adv_insightrow_smoker_flame          = require("wnd.w1_cfg.w1_row_adv_insightrow_smoker_flame"),
	w1_page_adv_insightarea_smoker_flame		= require("wnd.w1_cfg.w1_page_adv_insightarea_smoker_flame"),		
	w1_row_adv_insightrow_fire_spot             = require("wnd.w1_cfg.w1_row_adv_insightrow_fire_spot"),
	w1_page_adv_insightarea_fire_spot			= require("wnd.w1_cfg.w1_page_adv_insightarea_fire_spot"),		
	w1_page_analog_audio_in 					= require("wnd.w1_cfg.w1_page_analog_audio_in"),
}

return w1_all_require

