-- ϷԼ
--[[local b_ui 		= require("wnd.core.b_ui")
local b_wnd 	= require("wnd.core.b_wnd")
)
--]]

local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local b_app_api 	= require("wnd.core.command.b_app_api")
local w1_legal = 
{
	ip = {},
	port = {},
}
--IPش
w1_legal.ip = {
	EMPTY 			= 1,			--IPΪ
	LENERR			= 2,			--IPȷǷ
	PRARMERR 		= 3,			--IPǷ
}
--ش
w1_legal.netmask = {
	EMPTY 			= 1,			--IPΪ
	LENERR			= 2,			--IPȷǷ
	PRARMERR 		= 3,			--IPǷ
}
--ش
w1_legal.gateway = {
	EMPTY 			= 1,			--IPΪ
	LENERR			= 2,			--IPȷǷ
	PRARMERR 		= 3,			--IPǷ
}

--˿ش
w1_legal.port = {
	EMPTY 			= 1,			--˿Ϊ
	OUT_RANGE 		= 2,			--˿ڳΧ
	SPECIAL 		= 3,			--˿
}

--ش
w1_legal.password = {
	SN_ERROR_PASSWORD_SHORT				= -519,		-- λ6λ̫
	SN_ERROR_PASSWORD_TOOSIMPLE 		= -521,		-- ȼ
	SN_ERROR_PASSWORD_LEVEL_MID 		= -522,		-- ȼ
	SN_ERROR_PASSWORD_LEVEL_HIG 		= -523,		-- ȼ
	SN_ERROR_ADMIN_PASSWORD_CHANGED     = -524, 	-- ûĬ
	SN_ERROR_PASSWORD_EQUALLY 			= -527,		-- ޸ʱ;һ
	SN_ERROR_NOT_SUPPOERT_CHAR			= -542, 	-- ַ֧
}



local DecToStrBin = function(value)
	if(tonumber(value) > 255) then
		return ;
	end
	local bintemp = {};
	local multiple = 1;
	local num = math.abs(value);
	while num > 0 do
		local decimal = num % 2;
		num = math.floor(num / 2);
		bintemp[multiple] = decimal;
		multiple = multiple + 1;
	end
	for i = 1, 8 do
		if(bintemp[i] == nil) then
			bintemp[i] = 0;
		end
	end	
	for i = 1, 4 do
		local temp = bintemp[i];
		bintemp[i] = bintemp[9-i];
		bintemp[9-i] = temp;
	end
	return bintemp;
end

local ipaddressToBin = function(addr1, addr2, addr3, addr4)
	local ipv4str = {};
	local ipv4temp = {};	
	ipv4temp = DecToStrBin(addr1);
	for i=1,#ipv4temp do
		ipv4str[i] = ipv4temp[i];
	end
	ipv4temp = DecToStrBin(addr2);
	for i=1,#ipv4temp do
		ipv4str[i+8] = ipv4temp[i];
	end
	ipv4temp = DecToStrBin(addr3);
	for i=1,#ipv4temp do
		ipv4str[i+16] = ipv4temp[i];
	end
	ipv4temp = DecToStrBin(addr4);
	for i=1,#ipv4temp do
		ipv4str[i+24] = ipv4temp[i];
	end
	return ipv4str;
end

--ıеַǷΪ,Ϊգtrue򷵻false
w1_legal.is_empty = function(top, id)
	local text = b_wnd_ex.get_text(top, id)
	if(text == '') then
		return true
	else
		return false
	end
end

--еַǷΪ,Ϊգtrue򷵻false
w1_legal.is_passempty = function(top, id)
	local text = b_wnd_ex.get_password(top, id)
	if(text == '') then
		return true
	else
		return false
	end
end

--ֿеĶ˿ںǷϷ
--Ϸtrue,nil
--Ϸfalse,
w1_legal.check_port = function(top, id)
	local port = b_wnd_ex.get_value(top, id)
	assert(type(port) == 'number')
	if(port == '') then
		return false, w1_legal.port.EMPTY;
	else
		if(port < 1 or port > 65534) then
			return false, w1_legal.port.OUT_RANGE
		else
			--˿ڱ
			local specialPort= {13,21, 22, 23, 25, 37,
					  69,79, 81, 88, 110,111,
					 113,119,135,139,161,177,
					 199,220,427,512,513,
					 514,631,657,1024,8090,1, 20001,
					}
			for i = 1 , #specialPort do 
				if(port == specialPort[i]) then
					return false, w1_legal.port.SPECIAL;
				end
			end
			return true, nil;
		end
	end
end

--ֿеĶ˿ںǷϷ
--Ϸtrue,nil
--Ϸfalse,
w1_legal.check_port2 = function(top, id)
	local port = b_wnd_ex.get_value(top, id)
	assert(type(port) == 'number')
	if(port == '') then
		return false, w1_legal.port.EMPTY;
	else
		if(port < 1025 or port > 65534) then
			return false, w1_legal.port.OUT_RANGE
		else
			--˿ڱ
			local specialPort= {13,21, 22, 23, 25, 37,
					  69,79, 81, 88, 110,111,
					 113,119,135,139,161,177,
					 199,220,427,512,513,
					 514,631,657,1024,8090,1, 20001,
					}
			for i = 1 , #specialPort do 
				if(port == specialPort[i]) then
					return false, w1_legal.port.SPECIAL;
				end
			end
			return true, nil;
		end
	end
end

--IPеIPǷϷ
--Ϸtrue,nil
--Ϸfalse,
--1.ĸʮ
--2.1ʮķΧΪ1223
--3.2,3ʮķΧΪ0255
--4.4ʮķΧΪ0254
--ͬʱ1234
w1_legal.check_ip = function(top, id)
	local ipstr = b_wnd_ex.get_text(top, id)
	assert(type(ipstr) == 'string')
	local ipstrnum = #ipstr;
	if(ipstrnum == 0) then
		return false, w1_legal.ip.EMPTY;
	else
		local ret = b_app_api.check_ip(ipstr);
		if (ret == 0) then
			return true, nil;
		else
			return false, w1_legal.ip.PRARMERR;
		end
	end		

	return true, nil;		
end

--еIPǷϷ
--Ϸtrue,nil
--Ϸfalse,
--1.ĸʮ
--2.ĸʮķΧΪ0255
--3.Ϊ404255
--4.ĸʮ˳תΪ32λֻΪ¼1.ȫ1  2.ȫ0  3.ǰΪ1Ϊ0 
--ͬʱ1234
w1_legal.check_netmask = function(top, id)
	local ipstr = b_wnd_ex.get_text(top, id)
	assert(type(ipstr) == 'string')
	local ipstrnum = #ipstr;
	if(ipstrnum == 0) then
		return false, w1_legal.netmask.EMPTY;
	else
		local ret = b_app_api.check_netmask(ipstr);
		if (ret == 0) then
			return true, nil;
		else
			return false, w1_legal.netmask.PRARMERR;
		end
	end	
	
	return true, nil;	
end

--ؿеIPǷϷ
--Ϸtrue,nil
--Ϸfalse,
--1.ĸʮ
--2.1ʮķΧΪ1223
--3.2,3ʮķΧΪ0255
--4.4ʮķΧΪ0254
--ͬʱ1234
w1_legal.check_gataway = function(top, id)
	local ipstr = b_wnd_ex.get_text(top, id)
	assert(type(ipstr) == 'string')
	local ipstrnum = #ipstr;
	if(ipstrnum == 0) then

	else
		local ret = b_app_api.check_gateway(ipstr);
		if (ret == 0) then
			return true, nil;
		else
			return false, w1_legal.gateway.PRARMERR;
		end
	end	
	
	return true, nil;	
end

--dnsеIPǷϷ
--Ϸtrue,nil
--Ϸfalse,
--1.ĸʮ
--2.ĸʮķΧΪ0255
--3.Ϊ404255
--ͬʱ123
w1_legal.check_dns = function(top, id)
	local ipstr = b_wnd_ex.get_text(top, id)
	assert(type(ipstr) == 'string')
	local ipstrnum = #ipstr;
	if(ipstrnum == 0) then
		
	else	
		local ret = b_app_api.check_ddns(ipstr)	
		if (ret == 0) then
			return true, nil;
		else
			return false, w1_legal.gateway.PRARMERR;
		end
	end	
	
	return true, nil;	
end


--IPеIPǷϷ
--Ϸtrue,nil
--Ϸfalse,
w1_legal.check_ipseg = function(top, id)
	local ipstr = b_wnd_ex.get_text(top, id)
	assert(type(ipstr) == 'string')
	local ipstrnum = #ipstr;
	if(ipstrnum == 0) then
		return false, w1_legal.ip.EMPTY;
	else
		local ip1, ip2, ip3, ip4 = string.match(ipstr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");
		if (nil ~= ip1) and (nil ~= ip2) and (nil ~= ip3) and (nil ~= ip4) then
			if  ((0 <= tonumber(ip1)) and (tonumber(ip1) <= 255)) and
				((0 <= tonumber(ip2)) and (tonumber(ip2) <= 255)) and
				((0 <= tonumber(ip3)) and (tonumber(ip3) <= 255)) and
				((0 <= tonumber(ip4)) and (tonumber(ip4) <= 255)) then
				return true, nil;
			else
				return false, w1_legal.ip.PRARMERR;
			end
		else
			return false, w1_legal.ip.PRARMERR;
		end
	end
	return true, nil;
end

--жϿʼַǷڽַ
--,false
--С,true
w1_legal.compared_ip = function (sipstr, eipstr)
	local ip1, ip2, ip3, ip4 = string.match(sipstr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");
	local ip5, ip6, ip7, ip8 = string.match(eipstr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");
	local ipstart = {};
	local ipend	 = {};
	ipstart = ipaddressToBin(ip1, ip2, ip3, ip4);
	ipend = ipaddressToBin(ip5, ip6, ip7 ,ip8);
	
	for i=1,32 do          
		if(ipstart[i]>ipend[i])then
			return false;
		end
		if(ipstart[i]<ipend[i])then
			break;
		end
	end
	return true;
end


--жǷֵַ֧
local is_passchar = function(char)
	if(char >= '0' and char <= '9') then
		return true;
	elseif(char >= 'A' and char <= 'Z') then
		return true;
	elseif(char >= 'a' and char <= 'z') then
		return true;
	elseif(char == '!' or char == '@' or char == '#'or
			char == '$' or char == '*' or char == '+'or
			char == '=' or char == '-' or char == '_'
			) then
		return true;
	else
		return false;
	end
end

--ȼ
--1.6λ볤Ȳ32λ32λᶪ泬Ȳַ;
--2.ǿɼַ[֣дӢģСдӢģ(%$!@#,.[]_=+*&() ...]];
--3.һɼַȼֿͣɼַϵȼУϿɼַϵȼ
--4.ȼͣȼУȼǿɹ

--Ϸ,trueǿȵȼ
--Ϸ,falseʹ
w1_legal.check_password = function (passstr)
	assert(type(passstr) == 'string');
	local CHAR_NUMBER 	= 1;		--
	local CHAR_CAPITAL 	= 2;    	--дĸ
	local CHAR_LOWRE 	= 4;    	--Сдĸ
	local CHAR_OTHER 	= 8;    	--ַ
	local strtype = 0;
	
	local check_password = b_app_api.check_password(passstr);
	
	for i =1, #passstr do
		local char = string.sub(passstr, i, i);
		if(is_passchar(char) == false) then
			return w1_legal.password.SN_ERROR_NOT_SUPPOERT_CHAR, check_password.level; 
		end	
	end
	return check_password.legal, check_password.level;
end

local getNetmaskBitNumber = function(netmask)
	local bitNumber = 0;
	local strtemp = {};
	strtemp = DecToStrBin(netmask);
	for i = 1, #strtemp do
		if strtemp[i] == 1 then
			bitNumber = bitNumber + 1;
		else
			break;
		end
	end
	return bitNumber;
end

--IPv4POEǷͬһ,ͬһ,ߴڳͻ
w1_legal.is_Ipv4PoeNetConflict = function(ipv4net, poenet, ipv4netmask, poenetmask)
	local IsIpv4PoeSameNetwork = function(ipv4net, poenet, bitTotal)--жipv4poeǷͬ
		for i = 1 ,bitTotal do 
			if( ipv4net[i] ~= poenet[i] ) then
				return false;
			end
		end 
		return true;
	end
	local getNetmaskBitTotal = function(netmask1,netmask2,netmask3,netmask4)
		local bitTotal = 0;
		bitTotal = getNetmaskBitNumber(netmask1);
		if(bitTotal ~= 8) then
			return bitTotal;
		end
		bitTotal = bitTotal + getNetmaskBitNumber(netmask2);
		if(bitTotal ~= 16) then
			return bitTotal;
		end
		bitTotal = bitTotal + getNetmaskBitNumber(netmask3);
		if(bitTotal ~= 24) then
			return bitTotal;
		end
		bitTotal = bitTotal + getNetmaskBitNumber(netmask4);
		if(bitTotal ~= 32) then
			return bitTotal;
		end
	end
	local ip1, ip2, ip3, ip4 = string.match(ipv4net, "(%d+)%.(%d+)%.(%d+)%.(%d+)");
	local poe1, poe2, poe3, poe4 = string.match(poenet, "(%d+)%.(%d+)%.(%d+)%.(%d+)");
	local ipv4netmask1, ipv4netmask2, ipv4netmask3, ipv4netmask4 = string.match(ipv4netmask, "(%d+)%.(%d+)%.(%d+)%.(%d+)");
	local ipv4bitTotal = getNetmaskBitTotal(ipv4netmask1,ipv4netmask2,ipv4netmask3,ipv4netmask4);
	
	local poenetmask1, poenetmask2, poenetmask3, poenetmask4 = string.match(poenetmask, "(%d+)%.(%d+)%.(%d+)%.(%d+)");
	local poebitTotal = getNetmaskBitTotal(poenetmask1,poenetmask2,poenetmask3,poenetmask4);
	
	local bitTotal = ipv4bitTotal;
	if(bitTotal > poebitTotal) then
		bitTotal = poebitTotal;
	end
	
	local ipv4strbin  = {};
	ipv4strbin = ipaddressToBin(ip1, ip2, ip3, ip4);
	local poestrbin  = {};
	poestrbin = ipaddressToBin(poe1, poe2, poe3, poe4);

	local sameflag = IsIpv4PoeSameNetwork(ipv4strbin, poestrbin, bitTotal);
	return sameflag;
end

return w1_legal
