-- UIʹõȷȡԻ
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.msgbox_id;
local cjson 		= require("cjson")
local util 		= require("wnd.core.util")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")

local w1_msgbox = {
	t = w1_key.DLG_MSG_BOX,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_msgbox.s_768 =
{
	s_msgbox_xywh = {338,284,346,170},
	s_msgbox_title_xywh = {1,1,345,35},
	s_msgbox_title_close_xywh = {318,3,21,28},
	s_msgbox_msg_xywh = {26,49,302,35},
	s_msgbox_msg_tip_xywh = {26,71,302,35},
	s_msgbox_tipinfo_xywh = {8,85,266,12},
	s_msgbox_hline_xywh = {8,106,330,1},
	s_msgbox_ok_xywh = {197,120,64,27},
	s_msgbox_cancel_xywh = {272,120,64,27},
	s_msgbox_okcancel_xywh = {272,120,64,27},
};

w1_msgbox.s_1280 = 
{
	s_msgbox_xywh={315,400,650,240},
	s_msgbox_title_xywh={1,1,648,50},
	s_msgbox_title_close_xywh = {598, 5, 40, 40},
	s_msgbox_msg_xywh ={50,70,568,50},
	s_msgbox_msg_tip_xywh ={50,100,568,50},
	s_msgbox_tipinfo_xywh= {15,120,500,18},
	s_msgbox_hline_xywh={15,150,620,2},
	s_msgbox_ok_xywh={370,170,120,38},
	s_msgbox_cancel_xywh={510,170,120,38},	
	s_msgbox_okcancel_xywh={510,170,120,38},
};
w1_msgbox.s_1440 = 
{
	s_msgbox_xywh={395,310,650,240},
	s_msgbox_title_xywh={1,1,648,50},
	s_msgbox_title_close_xywh = {598, 5, 40, 40},
	s_msgbox_msg_xywh ={50,70,568,50},
	s_msgbox_msg_tip_xywh ={50,100,568,50},
	s_msgbox_tipinfo_xywh= {15,120,500,18},
	s_msgbox_hline_xywh={15,150,620,2},	
	s_msgbox_ok_xywh={370,170,120,38},
	s_msgbox_cancel_xywh={510,170,120,38},	
	s_msgbox_okcancel_xywh={510,170,120,38},
};
w1_msgbox.s_1080p = 
{
	s_msgbox_xywh={635,400,650,240},
	s_msgbox_title_xywh={1,1,648,50},
	s_msgbox_title_close_xywh = {598, 5, 40, 40},
	s_msgbox_msg_xywh ={50,70,568,50},
	s_msgbox_msg_tip_xywh ={50,100,568,50},
	s_msgbox_tipinfo_xywh= {15,120,500,18},
	s_msgbox_hline_xywh={15,150,620,2},
	s_msgbox_ok_xywh={370,170,120,38},
	s_msgbox_cancel_xywh={510,170,120,38},	
	s_msgbox_okcancel_xywh={510,170,120,38},
};
w1_msgbox.s_2k = 
{
	s_msgbox_xywh={846,533,866,320},
	s_msgbox_title_xywh={1,1,864,67},
	s_msgbox_title_close_xywh = {794, 7, 53, 53},
	s_msgbox_msg_xywh ={67,91,753,67},
	s_msgbox_msg_tip_xywh ={67,133,753,67},
	s_msgbox_tipinfo_xywh= {20,160,667,24},
	s_msgbox_hline_xywh={20,200,827,3},
	s_msgbox_ok_xywh={492,227,160,51},
	s_msgbox_cancel_xywh={680,227,160,51},
	s_msgbox_okcancel_xywh = {680,227,160,51},

};
w1_msgbox.s_4k = 
{
	s_msgbox_xywh={1270,800,1300,480},
	s_msgbox_title_xywh={2,2,1296,100},
	s_msgbox_title_close_xywh = {1196, 10, 80, 80},
	s_msgbox_msg_xywh ={100,140,1136,100},
	s_msgbox_msg_tip_xywh ={100,200,1136,100},
	s_msgbox_tipinfo_xywh= {30,240,1000,36},
	s_msgbox_hline_xywh={30,300,1240,4},
	s_msgbox_ok_xywh={740,340,240,76},
	s_msgbox_cancel_xywh={1020,340,240,76},
	s_msgbox_okcancel_xywh = {1020,340,240,76},
	
};


w1_msgbox.ok_btn_str = '';			--ȷťַ
w1_msgbox.cancel_btn_str = '';		--ȡťַ
w1_msgbox.titlestr = '';			--ַ
w1_msgbox.msgstr = '';				--ʾַ
w1_msgbox.ok_disp = true;			--okťʾ־λ
w1_msgbox.cancel_disp = true;		--cancelťʾ־λ
w1_msgbox.close_disp = true;		--closeťʾ־λ
w1_msgbox.ok_func = nil;			--okťص
w1_msgbox.okfunc_param = nil;		--okťص
w1_msgbox.cannel_func = nil;		--cancelťص
w1_msgbox.cannelfunc_param = nil;	--cannelťص
w1_msgbox.attach_attr_state = false;--״̬ false  true ׼
local attach_str = '';				--ʹ ťر ٴʾ ϶ʱʹ

--local SAVE_TIME;

--ÿؼ Ӧok¼ر µʾȵ
w1_msgbox.set_attach_dlgattr = function(msgstr)
	w1_msgbox.attach_attr_state = true;
	attach_str = msgstr;
end	

w1_msgbox.set_dlgattr = function(titlestr, msgstr, ok_disp, cancel_disp,close_disp, ok_str, cancel_str)
	assert(titlestr ~= nil and type(titlestr) == 'string')
	assert(msgstr ~= nil and type(msgstr) == 'string')
	assert(ok_disp ~= nil and type(ok_disp) == 'boolean')
	assert(cancel_disp ~= nil and type(cancel_disp) == 'boolean')

	w1_msgbox.msgstr = msgstr;
	w1_msgbox.ok_disp = ok_disp;
	w1_msgbox.cancel_disp = cancel_disp;
	w1_msgbox.close_disp = close_disp;
	if (nil ~= ok_str) then
		w1_msgbox.ok_btn_str = ok_str
	else
		w1_msgbox.ok_btn_str = STR('LA_OK')	
	end
	
	if (nil ~= cancel_str) then
		w1_msgbox.cancel_btn_str = cancel_str
	else
		w1_msgbox.cancel_btn_str = STR('LA_CANCEL')	
	end
end 

w1_msgbox.set_func  = function(ok_func, okfunc_param, cannel_func, cancelfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')
	assert(cannel_func == nil or type(cannel_func) == 'function')
	assert(cancelfunc_param == nil or type(cancelfunc_param) == 'table')
	
	w1_msgbox.ok_func = ok_func;
	w1_msgbox.cannel_func = cannel_func;

	if (w1_msgbox.okfunc_param  ==  nil) then
		w1_msgbox.okfunc_param = okfunc_param;
	else
		if(okfunc_param == nil) then
			w1_msgbox.okfunc_param = nil;
		elseif(type(okfunc_param) == 'table') then
			util.copy_tab_b(w1_msgbox.okfunc_param, okfunc_param);		
		end
	end
	
	if (w1_msgbox.cannelfunc_param  ==  nil) then
		w1_msgbox.cannelfunc_param = cancelfunc_param;
	else
		if(cancelfunc_param == nil) then
			w1_msgbox.cannelfunc_param = nil;
		elseif(type(okfunc_param) == 'table') then
			util.copy_tab_b(w1_msgbox.cannelfunc_param, cancelfunc_param);		
		end	
	end
end

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local ret = nil;
		if (true == w1_msgbox.attach_attr_state) then
			b_wnd_ex.set_hide(top, w1_msgbox.dlg.ok.id, true, false)
			b_wnd_ex.set_hide(top, w1_msgbox.dlg.cancel.id, true, false)
			b_wnd_ex.set_text(top, w1_msgbox.dlg.msg.id, attach_str, false);
			b_dlg.dlg_set_redraw(top)
			return b_ui.WM_USER_MSGBOX_RUN;
		else	
			if(w1_msgbox.ok_func ~= nil) then
				ret = w1_msgbox.ok_func(w1_msgbox.okfunc_param);
			end	

			b_dlg.end_modal(top);
			
			if(b_ui.WM_USER_CHANGE_RESOLUTION == ret)then
				return b_ui.WM_USER_CHANGE_RESOLUTION;
			end
		end
	end
	return 0
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(w1_msgbox.cannel_func ~= nil) then
			w1_msgbox.cannel_func(w1_msgbox.cannelfunc_param);
		end
		b_dlg.end_modal(top);
	end
	return 0
end

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	
	return 0;
end

local dlg = {
	attr 	= {xywh='s_msgbox_xywh'},
	sub 	= {--[['title',--]] 'titleclose', 'msg',--[['hline', --]]'ok', 'cancel'},
	
--[[	title 	= {t='static',	id=id+1,	xywh='s_msgbox_title_xywh',	
			text='',align = b_ui.ALIGN.CENTER, font = 'f_grade5',
			color = {'c_popdlg_title_bk', 'c_popdlg_title_bk', 'c_popdlg_text'}},--]]
	
	titleclose 	= {t='tt_button',id=id+2,xywh = 's_msgbox_title_close_xywh',
		t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
		color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_txt_f'},
		color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_cfgclose_bk'},
		cmd=on_close},

	msg	 	= {t='static',	id=id+3,	xywh='s_msgbox_msg_xywh',	
			text='',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
			
--[[	hline		= {t='hline',	id=id+4,	xywh='s_msgbox_hline_xywh'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},--]]
			
	ok		= {t='button',	id=id+5,	xywh='s_msgbox_ok_xywh',	text='LA_OK',		cmd=on_ok,
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},},
	cancel	= {t='button',	id=id+6,	xywh='s_msgbox_cancel_xywh',text='LA_CANCEL',	cmd=on_cancel,
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
				},			
}

w1_msgbox.on_create = function(top)
	w1_msgbox.top = top
	w1_msgbox.dlg = dlg
	b_parser(top, w1_msgbox.dlg)
	return 0
end

w1_msgbox.on_destroy = function(top)
	w1_msgbox.top = nil
	w1_msgbox.dlg = nil
	w1_msgbox.okfunc_param = nil
	w1_msgbox.cannelfunc_param = nil
	w1_msgbox.attach_attr_state = false;

	return 0
end

w1_msgbox.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top)	
	if(param ~= nil)then
		local paramdata = cjson.decode(param)
		if(paramdata.opera2_del ~= nil) then
--			w1_msgbox.titlestr = w1_msgbox_cfunc.camera_opera2_titlestr;			--ַ
			w1_msgbox.msgstr = w1_msgbox_cfunc.camera_opera2_msgstr;				--ʾַ
			w1_msgbox.ok_disp = true;			--okťʾ־λ
			w1_msgbox.cancel_disp = true;		--cancelťʾ־λ
			w1_msgbox.close_disp = true;
			w1_msgbox.ok_func = w1_msgbox_cfunc.camera_opera2_ok;	--okťص
			local temp = {top,paramdata.opera2_del};		--okťص	
			if (w1_msgbox.okfunc_param == nil) then
				w1_msgbox.okfunc_param = temp
			else
				util.copy_tab_b(w1_msgbox.okfunc_param, temp);	
			end
			w1_msgbox.cannel_func = nil;		--cancelťص
			w1_msgbox.cannelfunc_param = nil;	--cannelťص
			w1_msgbox.w1_msgbox.ok_btn_str = STR('LA_OK');
			w1_msgbox.cancel_btn_str = STR('LA_CANCEL');	
			
		end
	end
	
--	b_wnd_ex.set_text(top, w1_msgbox.dlg.title.id, 	w1_msgbox.titlestr, false);
	b_wnd_ex.set_text(top, w1_msgbox.dlg.msg.id,	w1_msgbox.msgstr, 	false);
	b_wnd_ex.set_text(top,  w1_msgbox.dlg.ok.id, 	w1_msgbox.ok_btn_str, false);
	b_wnd_ex.set_text(top, w1_msgbox.dlg.cancel.id,	w1_msgbox.cancel_btn_str, false);
	
	if (w1_msgbox.close_disp == false) then
		b_wnd_ex.set_hide(top, w1_msgbox.dlg.titleclose.id, true, false)
	end
	
	if(w1_msgbox.ok_disp == false and w1_msgbox.cancel_disp == false) then
		b_wnd_ex.set_hide(top, w1_msgbox.dlg.ok.id, true, false)
		b_wnd_ex.set_hide(top, w1_msgbox.dlg.cancel.id, true, false)
		b_wnd_ex.move_ex(top, w1_msgbox.dlg.msg.id, SIZE('s_msgbox_msg_tip_xywh'),false);
	elseif(w1_msgbox.ok_disp == true and w1_msgbox.cancel_disp == false) then
		b_wnd_ex.set_hide(top, w1_msgbox.dlg.cancel.id, true, false)
		b_wnd_ex.move_ex(top, w1_msgbox.dlg.ok.id, SIZE('s_msgbox_okcancel_xywh'), false);
	elseif(w1_msgbox.ok_disp == false and w1_msgbox.cancel_disp == true) then
		b_wnd_ex.set_hide(top, w1_msgbox.dlg.ok.id, true, false)
		b_wnd_ex.move_ex(top, w1_msgbox.dlg.cancel.id, SIZE('s_msgbox_okcancel_xywh'), false);
	end

	return 0
end

w1_msgbox.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	
	b_wnd.end_job(top)
	return 0
end

w1_msgbox.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
	local pos = SIZE('s_msgbox_xywh');
	if x < pos[1] or x > pos[1] + pos[3] or y < pos[2] or y > pos [2] + pos[4] then
	--	b_dlg.end_modal(top);
	end
--[[		SAVE_TIME = 60;		
		b_dlg.dlg_set_redraw(top);--]]
	elseif(b_ui.WM_USER_CHANGE_RESOLUTION == vmsg)then
		return b_ui.WM_USER_CHANGE_RESOLUTION;
	elseif(b_ui.WM_USER_MSGBOX_RUN == vmsg) then
			return vmsg
	elseif(b_ui.WM_USER_MSGBOX_RUN_START == vmsg) then		
		w1_msgbox.attach_attr_state = false;
		if(w1_msgbox.ok_func ~= nil) then
			w1_msgbox.ok_func(w1_msgbox.okfunc_param);
		end	
		b_dlg.end_modal(top);
	elseif(b_ui.RBUTTONCLK == vmsg)then
		if(w1_msgbox.cannel_func ~= nil) then
			w1_msgbox.cannel_func(w1_msgbox.cannelfunc_param);
		end
		b_dlg.end_modal(top);
	end
	return 0
end

return w1_msgbox




