--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2017/11/17
-- author 
-- brief  UIṩȫֺװ
--]]
local util = require("wnd.core.util")
local ui_main = require("ui_main")

local b_main = {}

b_main.sleep = function(tickcount)
	ui_main.sleep(tickcount)
end

b_main.gc = function()
	ui_main.gc()
end

b_main.gc_count = function()
	local size = ui_main.gc_count()
	
	-- λKB
	return size -- number
end

-- ms
b_main.gc_interval = function(top, ms)
	ui_main.gc_interval(top, ms)
end


b_main.set_run_status = function(top, status)
	ui_main.set_run_status(top, status)
end

b_main.insert = function(key, cb_on_create, cb_on_destroy, cb_on_paint, cb_on_pre_show, cb_on_cmd_ctrl)
	assert(type(key) == "number")
	assert(type(cb_on_create) == "function")
	assert(type(cb_on_destroy) == "function")
	assert(type(cb_on_paint) == "function")

	local param = {}

	param[1] = key				-- number
	param[2] = cb_on_create		-- function
	param[3] = cb_on_destroy	-- function
	param[4] = cb_on_paint		-- function
	
	if type(cb_on_pre_show) == 'function' then
		param[5] = cb_on_pre_show
	else		
		param[5] = 0
	end
	
	if type(cb_on_cmd_ctrl) == 'function' then
		param[6] = cb_on_cmd_ctrl
	else
		param[6] = 0
	end
	
	local ret = ui_main.insert(param)
	--print("ui_main.insert", key, ret);
	assert(ret)
	
	return ret;
end

b_main.set_ui_ex2 = function(param)
	assert(type(param) == 'table')
	
	ui_main.set_ui_ex2(param)
end

return b_main
