--[[
-- Copyright(c) 2018-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/01/29
-- author 
-- brief  wndڽӿ
--]]
local b_wnd = require("wnd.core.b_wnd")

local b_wnd_ex = {}

b_wnd_ex.set_add_page = function(top, child_id, w_id)
	local param = {add_page=w_id}
	b_wnd.set_sub(top, child_id, false, param)
end


b_wnd_ex.set_show_page = function(top, child_id, w_id, redraw)
	local param = {show_page = w_id}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_check = function(top, child_id, status, redraw)
	local param = {check = status}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_check = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'check'}).check
end

b_wnd_ex.set_hide = function(top, child_id, status, redraw)
	local param = {hide = status}
	b_wnd.set_sub(top, child_id, redraw, param)
end

--[[b_wnd_ex.get_hide = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'check'}).check
end--]]


b_wnd_ex.dlg_move_ex = function(top, param, redraw)
	b_wnd.dlg_move_ex (top, param, redraw)
end

b_wnd_ex.get_dlg_a_rect = function(top)
	return b_wnd.get_dlg_a_rect(top)
end
	
b_wnd_ex.move_ex = function(top, child_id, move_ex, redraw)
	local param = {move_ex = move_ex}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_range = function(top, child_id, range, redraw)
	local param = {range = range}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.move_pos = function(top, child_id, move_pos, redraw)
	local param = {move_pos = move_pos}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_sel = function(top, child_id, sel, redraw)
	local param = {sel = sel}
	b_wnd.set_sub(top, child_id, redraw, param)
end
b_wnd_ex.get_sel = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'sel'}).sel
end

b_wnd_ex.set_text = function(top, child_id, text, redraw)
	local param = {text = text}
	b_wnd.set_sub(top, child_id, redraw, param)
end
b_wnd_ex.get_text = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'text'}).text
end

b_wnd_ex.set_guide_text = function(top, child_id, text, redraw)
	local param = {guide_text = text}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_value= function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'value'}).value
end
b_wnd_ex.set_value= function(top, child_id,value,redraw)
	local param = {value = value}
	return b_wnd.set_sub(top, child_id, redraw,param)
end

b_wnd_ex.set_color = function(top, child_id, color, redraw)
	local param = {color = color}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_color_f = function(top, child_id, color_f, redraw)
	local param = {color_f = color_f}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_color_d = function(top, child_id, color_d, redraw)
	local param = {color_d = color_d}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_items = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'items'}).value
end

b_wnd_ex.set_items = function (top, child_id, items, redraw)
	local param = {items = items}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_areas = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'areas'}).areas
end

b_wnd_ex.get_rect = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'rect'}).rect
end

b_wnd_ex.set_areas = function (top, child_id, areas, redraw)
	local param = {areas = areas}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_marea = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'marea'}).marea
end

b_wnd_ex.set_marea = function (top, child_id, mareas, redraw)
	local param = {marea = mareas}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_intarea = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'intarea'}).intarea
end

b_wnd_ex.set_intarea = function (top, child_id, intareas, redraw)
	local param = {intarea = intareas}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.clear_intarea = function (top, child_id, intareas, redraw)
	local param = {intarea_clear = intareas}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_virtual_fence = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'virtual_fence'}).virtual_fence
end

b_wnd_ex.set_virtual_fence = function (top, child_id, virtual_fence, redraw)
	local param = {virtual_fence = virtual_fence}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_virtual_fence_del = function (top, child_id, redraw)
	local param = {virtual_fence_del = true}
	b_wnd.set_sub(top,  child_id,redraw,param)
end

b_wnd_ex.set_virtual_fence_clear = function (top, child_id, redraw)
	local param = {virtual_fence_clear = true}
	b_wnd.set_sub(top,  child_id,redraw,param)
end

b_wnd_ex.get_d_virtual_fence = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'d_vir_fen'}).d_vir_fen
end

b_wnd_ex.set_d_virtual_fence = function (top, child_id, d_vir_fen, redraw)
	local param = {d_vir_fen = d_vir_fen}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_d_vir_fen_del = function (top, child_id, redraw)
	local param = {d_vir_fen_del = true}
	b_wnd.set_sub(top,  child_id,redraw,param)
end

b_wnd_ex.get_direct = function (top, child_id)
	return b_wnd.get_sub(top,  child_id,{'vir_direct'}).vir_direct
end

b_wnd_ex.set_direct = function (top, child_id,vir_direct,redraw)
	local param = {vir_direct = vir_direct}
	b_wnd.set_sub(top,  child_id,redraw,param)
end

b_wnd_ex.get_int_adv = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'int_adv'}).int_adv
end

b_wnd_ex.get_intellient_cur_sel = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'cur_line'}).cur_line
end

b_wnd_ex.get_int_adv_real_size = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'real_size'}).real_size
end

b_wnd_ex.get_int_adv_seg_type = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'seg_type'}).seg_type
end

b_wnd_ex.set_int_adv = function (top, child_id, int_adv, redraw)
	local param = {int_adv = int_adv}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_int_adv_cur_sel = function (top, child_id, cur_line, redraw)
	local param = {cur_line = cur_line}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_int_adv_real_size = function (top, child_id, real_size, redraw)
	local param = {real_size = real_size}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_int_adv_seg_type = function (top, child_id, seg_type, redraw)
	local param = {seg_type = seg_type}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_int_adv_del = function (top, child_id, redraw)
	local param = {int_adv_del = true}
	b_wnd.set_sub(top,  child_id,redraw,param)
end

b_wnd_ex.set_int_adv_clear = function (top, child_id, redraw)
	local param = {int_adv_clear = true}
	b_wnd.set_sub(top,  child_id,redraw,param)
end

b_wnd_ex.set_depth_field_validate = function (top, child_id, enable, redraw)
	local param = {depth_field_validate = enable}
	b_wnd.set_sub(top,  child_id,redraw,param)
end

b_wnd_ex.get_timeplan = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'time_plan'}).time_plan
end

b_wnd_ex.set_timeplan = function (top, child_id, timeplan, redraw)
	local param = {time_plan = timeplan}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_timeplan_record = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'time_plan_record'}).time_plan_record
end

b_wnd_ex.set_timeplan_record = function (top, child_id, timeplan, redraw)
	local param = {time_plan_record = timeplan}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_timeplan_type = function (top, child_id, type, redraw)
	local param = {time_plan_type = type}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_osdarea = function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'osd_area'}).osd_area
end
b_wnd_ex.set_osdarea = function (top, child_id, osd_area, redraw)
	local param = {osd_area = osd_area}
	b_wnd.set_sub(top, child_id, redraw, param)
end
b_wnd_ex.set_osdhidetime = function (top, child_id, hidetime, redraw)
	local param = {osd_hidetime = hidetime}
	b_wnd.set_sub(top, child_id, redraw, param)
end
b_wnd_ex.set_osdhidename = function (top, child_id, hidename, redraw)
	local param = {osd_hidename = hidename}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_time =function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'time'}).time
end
b_wnd_ex.set_time =function (top, child_id, time, redraw)
		local param = {time = time}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_date =function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'date'}).date
end
b_wnd_ex.set_date =function (top, child_id, date, redraw)
		local param = {date = date}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_listdata =function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'listdata'})
end
b_wnd_ex.set_listdata =function (top, child_id, listdata, redraw)
	local param = {listdata = listdata}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_opt_status =function (top, child_id, status, redraw)
	local param = {set_opt_status = status}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_manual_listdata =function (top, child_id, manual_listdata, redraw)
	local param = {manual_listdata = manual_listdata}
	b_wnd.set_sub(top, child_id, redraw, param)
end
b_wnd_ex.set_packet_listdata =function (top, child_id, packet_list, redraw)
	local param = {packet_list = packet_list}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_custom_list_data =function (top, child_id, custom_list_data, redraw)
	local param = {custom_list_data = custom_list_data}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_custom_list_data =function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'custom_list_data'})
end

b_wnd_ex.set_disablelist =function (top, child_id,disable_list,redraw)
	local param = {disable_list = disable_list}
		b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_listtype =function (top, child_id, listtype, redraw)
	local param = {listtype = listtype}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_list_idx=function (top, child_id, x, y)
	return b_wnd.get_sub(top, child_id, {'list_idx'}, x, y).value
end
b_wnd_ex.get_chlistattr =function (top, child_id)
	--return b_wnd.get_sub(top, child_id, {'chdata'})
	return 0
end

b_wnd_ex.set_chlistattr =function (top, child_id, chlistattr, redraw)
	local param = {chlistattr = chlistattr}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_chlist_chtype = function(top, child_id, chlist_chtype, redraw)
	local param = {chlist_chtype = chlist_chtype}
	b_wnd.set_sub(top, child_id, redraw, param)
end	

b_wnd_ex.set_listattr =function (top, child_id, listattr, redraw)
	local param = {listattr = listattr}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_chdata =function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'chdata'})
end

b_wnd_ex.set_chdata =function (top, child_id, chdata, redraw)
	local param = {chdata = chdata}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_selecechannel =function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'select_channel'}).select_channel
end
b_wnd_ex.set_selecechannel =function (top, child_id, checktab, redraw)
	local param = {select_channel = checktab}
	b_wnd.set_sub(top, child_id, redraw, param);
end

b_wnd_ex.set_select_disable =function (top, child_id, checktab, redraw)
	local param = {select_disable = checktab}
	b_wnd.set_sub(top, child_id, redraw, param);
end

b_wnd_ex.set_upgradechannel =function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'upgrade_channel'}).select_channel
end
	
b_wnd_ex.get_selecelist =function (top, child_id)
	return b_wnd.get_sub(top, child_id, {'select_list'}).select_list
end

b_wnd_ex.set_selecelist =function (top, child_id, select_list, redraw)
	local param = {select_list = select_list}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_end_selecelist=function (top, child_id)
	return b_wnd.get_sub(top, child_id,{'end_select_list'}).select_list
end

b_wnd_ex.set_end_selecelist=function (top, child_id, end_select_list, redraw)
	local param = {end_select_list = end_select_list}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_end_selecelist_only=function (top, child_id, end_select_only, redraw)
	local param = {end_select_only = end_select_only}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_hide_opera1=function (top, child_id, hide_list, redraw)
	local param = {hide_opera1 = hide_list}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_hide_opera2=function (top, child_id, hide_list, redraw)
	local param = {hide_opera2 = hide_list}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_enableselect = function(top, child_id, enableselect, redraw)
	local param = {enableselect = enableselect}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_disable = function(top, child_id, disable, redraw)
	local param = {disable = disable}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_nav_attr = function(top, child_id, nav_attr, redraw)
	local param = {nav_attr = nav_attr}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_title_texts = function(top, child_id, title_texts, redraw)
	local param = {title_texts = title_texts}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_custom_combox_item = function(top, child_id, combox_item, redraw)
	local param = {combox_item = combox_item}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_first_checkall = function(top, child_id, checkall, redraw)
	local param = {first_checkall = checkall}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.clear_checkall = function(top, child_id, checkall, redraw)
	local param = {clear_checkall = checkall}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_texts = function(top, child_id, texts, redraw)
	local param = {texts = texts}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_align = function(top, child_id, align, redraw)
	local param = {align = align}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_password = function(top, child_id, password, redraw)
	local param = {password = password}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_password = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'password'}).password
end

b_wnd_ex.set_disp = function(top, child_id, disp, redraw)
	local param = {disp = disp}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_status = function(top, child_id, status, redraw)
	local param = {status = status}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.columns_w = function(top, child_id, columns_w, redraw)
	local param = {columns_w = columns_w}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_left_w = function(top, child_id, left_w, redraw)
	local param = {left_w = left_w}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_drop = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'vdrop'}).vdrop
end

b_wnd_ex.set_drop = function(top, child_id, vdrop, redraw)
	local param = {vdrop = vdrop}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.dlg_direct_up = function(top, child_id, dlg_direct_up, redraw)
	local param = {dlg_direct_up = dlg_direct_up}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.dlg_direct_left = function(top, child_id, dlg_direct_left, redraw)
	local param = {dlg_direct_left = dlg_direct_left}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_t_imgs =  function(top, child_id, t_imgs, redraw)
	local param = {t_imgs = t_imgs}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_textsize = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'textsize'}).textsize;
end

b_wnd_ex.set_cap = function(top,child_id,img_cap,redraw)
	local param = {img_cap = img_cap}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.list_title_txt = function(top, child_id, title_txt, redraw)
	local param = {list_title_txt = title_txt}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_chn_type_size = function(top, child_id, rect_size, redraw)
	local param = {chn_type_rect_size = rect_size}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_chn_type_data = function(top, child_id, chn_type_data, redraw)
	local param = {chn_type_data = chn_type_data}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_chn_type_data = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'chn_type_data'}).chn_type_data;
end

b_wnd_ex.set_bmp_img = function(top,child_id,img,redraw)
	local param = {bmp_img =img}
	b_wnd.set_sub(top, child_id, redraw, param)
end
b_wnd_ex.set_chcopy_chn_num = function(top, child_id, chn_num, redraw)
	local param = {chn_num = chn_num}
	b_wnd.set_sub(top, child_id, redraw, param)
end
b_wnd_ex.set_chcopy_chn_bcolor = function(top, child_id, b_color, redraw)
	local param = {b_color = b_color}
	b_wnd.set_sub(top, child_id, redraw, param)
end
b_wnd_ex.pattern_clear = function(top, child_id, redraw)
	local param = {pattern_clear = true}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_pattern_num = function(top,child_id)
	return b_wnd.get_sub(top, child_id, {'pattern_num'}).pattern_num
end

b_wnd_ex.set_pattern_error = function(top,child_id,redraw)
	local param = {pattern_error = true}
	b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.pattern_end = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'pattern_end'}).pattern_end;
end

b_wnd_ex.get_chcopy_data = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'chn_copy_data'}).chn_copy_data;
end

b_wnd_ex.set_chcopy_data = function (top, child_id, param_data,redraw)
	local param = {chn_copy_data = param_data}
	return b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_chcopy_data_ex = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'chn_copy_data_ex'});
end

b_wnd_ex.set_chcopy_data_ex = function (top, child_id, param_data,redraw)
	local param = {chn_copy_data_ex = param_data}
	return b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_one_min_interval = function (top, child_id, one_min_interval,redraw)
	local param = {one_min_interval = one_min_interval}
	return b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_motion = function (top, child_id,motion,redraw)
	local param = {motion = motion}
	return b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_block_clear = function (top,child_id, block_clear,redraw)
	local param = {block_clear = block_clear}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.set_bad_color = function (top, child_id, block_bg,redraw)
	local param = {block_bg = block_bg}
	return b_wnd.set_sub(top, child_id, redraw, param)
end
b_wnd_ex.get_bad_block_data = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'bad_block'}).bad_block;
end

b_wnd_ex.set_block_size = function (top,child_id, block_size,redraw)
	local param = {block_size = block_size}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.set_relat_all = function (top,child_id, relat_all,redraw)
	local param = {relat_all = relat_all}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.set_roi_area = function (top,child_id, roi_area,redraw)
	local param = {roi_area = roi_area}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.get_roi_area = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'roi_area'}).roi_area;
end

b_wnd_ex.set_negative_num_atrr = function (top,child_id, negative_num_atrr,redraw)
	local param = {negative_num_atrr = negative_num_atrr}
	return b_wnd.set_sub(top, child_id, redraw,param)
end

b_wnd_ex.set_decimal_interval = function (top,child_id, decimal_interval,redraw)
	local param = {decimal_interval = decimal_interval}
	return b_wnd.set_sub(top, child_id, redraw,param)
end

b_wnd_ex.set_map_area = function (top,child_id, map_point,redraw)
	local param = {map_point = map_point}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.get_map_area = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'map_point'}).map_point;
end

b_wnd_ex.set_poe_net_margin = function (top,child_id, line_margin,redraw)
	local param = {line_margin = line_margin}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.set_poe_net_point = function (top,child_id, line_point,redraw)
	local param = {line_point = line_point}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.set_poe_net_num = function (top,child_id, line_num,redraw)
	local param = {line_num = line_num}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.set_poe_net_state = function (top,child_id, net_state,redraw)
	local param = {net_state = net_state}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.set_poe_net_step = function (top,child_id, line_step,redraw)
	local param = {line_step = line_step}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.set_person_count_data = function (top, child_id, data,redraw)
	local param = {per_count_data = data}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.get_person_count_data = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'per_count_data'}).per_count_data;
end

b_wnd_ex.get_customize_data = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'customize_data'}).customize_data;
end

b_wnd_ex.set_customize_xy = function (top,child_id, customize_data,redraw)
	local param = {customize_data = customize_data}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.set_net_flow = function (top,child_id, net_flow,redraw)
	local param = {net_flow = net_flow}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.get_net_flow_max = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'max_value'}).value;
end

b_wnd_ex.set_chart_size = function (top,child_id, chart_size,redraw)
	local param = {chart_size = chart_size}
	return b_wnd.set_sub(top,child_id, redraw,param)
end

b_wnd_ex.set_list_end_nofind = function (top,child_id, list_end_nofind,redraw)
	local param = {list_end_nofind = list_end_nofind}
	return b_wnd.set_sub(top,child_id, redraw,param)
end


b_wnd_ex.set_dwell_wnd_data = function(top, child_id, data, redraw)
	local param = {dwell_wnd_data = data}
	return b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_dwell_wnd_data = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'dwell_wnd_data'});
end

b_wnd_ex.set_link_event_attr = function(top, child_id, param, redraw)
	local param = {link_event_attr = param}
	return b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.set_link_event_data = function(top, child_id, data, redraw)
	local param = {link_event_data = data}
	return b_wnd.set_sub(top, child_id, redraw, param)
end

b_wnd_ex.get_link_event_data = function(top, child_id)
	return b_wnd.get_sub(top, child_id, {'link_event_data'});
end


return b_wnd_ex


