local app_api = require("app_api")

local b_app_api ={}

b_app_api.check_password = function(str)
	assert(type(str) == 'string')
	return app_api.check_password(str).check_password
end

b_app_api.check_ip = function(str)
	return app_api.check_ip(str)
end	

b_app_api.check_netmask = function(str)
	return app_api.check_netmask(str)
end	

b_app_api.check_gateway = function(str)
	return app_api.check_gateway(str)
end	

b_app_api.check_ddns = function(str)
	return app_api.check_ddns(str)
end	

b_app_api.get_default_cfg = function(cfg_table)
	assert(type(cfg_table) == 'table')
	return app_api.get_default_cfg(cfg_table)
end

b_app_api.get_cfg = function(cfg_table)
	assert(type(cfg_table) == 'table')
	return app_api.get_cfg(cfg_table)
end

b_app_api.get_log = function(param)
	assert(type(param) == 'table')
	return app_api.get_log(param).log
end

b_app_api.export_log = function(param)
	assert(type(param) == 'table')
	return app_api.export_log(param).log
end

b_app_api.save_cfg = function(cfg_table)
	return app_api.save_cfg(cfg_table);
end

b_app_api.onekeyadd_camera = function(cfg_table)
	return app_api.onekeyadd_camera(cfg_table)
end

b_app_api.upgrade_cameras = function(cfg_table)
	return app_api.upgrade_cameras(cfg_table)
end

b_app_api.upgrade_nvr = function(cfg_table)
	return app_api.upgrade_nvr(cfg_table)
end

b_app_api.manual_add_camera = function(cfg_table)
	return app_api.manual_add_camera(cfg_table)
end

b_app_api.manual_reboot_camera = function(cfg_table)
	return app_api.manual_reboot_camera(cfg_table)
end

b_app_api.manual_reset_camera = function(cfg_table)
	return app_api.manual_reset_camera(cfg_table)
end

b_app_api.language_change= function(cfg_table)
	return app_api.language_change(cfg_table)
end

b_app_api.set_immediate_cvbs = function (cvbs)
	return app_api.set_immediate_cvbs(cvbs);
end

b_app_api.shutdown = function()
	return app_api.shutdown()
end

b_app_api.reboot = function()
	return app_api.reboot()
end

b_app_api.cloud_upgrade = function()
	return app_api.cloud_upgrade()
end

b_app_api.cloud_version_check = function()
	return app_api.cloud_version_check()
end

b_app_api.exit_system = function()
	return app_api.exit_system()
end

b_app_api.reset = function(reset_flag)
	return app_api.reset(reset_flag);
end

b_app_api.cfgimport = function()
	return app_api.cfgimport().cfg_import;
end

b_app_api.cfgexport = function()
	return app_api.cfgexport().cfg_export;
end

b_app_api.sendPwd = function(data)
	return app_api.sendPwd(data)
end

b_app_api.test_email = function (data)
	return app_api.test_email(data)
end

b_app_api.test_ddns =function (data)
	return app_api.test_ddns(data)
end


b_app_api.add_user = function(param)
	assert(type(param) == 'table')
	return app_api.add_user(param).add_user.ret;
end

b_app_api.modify_user = function(param)
	assert(type(param) == 'table')
	return app_api.modify_user(param).modify_user.ret;
end

b_app_api.del_user = function(param)
	assert(type(param) == 'table')
	return app_api.del_user(param).del_user.errornum;
end

b_app_api.add_phone_num = function(param)
	assert(type(param) == 'table')
	return app_api.add_phone_num(param).add_phone_num.errornum;
end

b_app_api.del_phone_num = function(param)
	assert(type(param) == 'table')
	return app_api.del_phone_num(param).del_phone_num.errornum;
end

--ֳӿ
b_app_api.enable_poll = function(enable, screen_id)
	return app_api.enable_poll(enable, screen_id);
end

b_app_api.get_poll_state = function(param)
	return app_api.get_poll_state(param)
end
	
b_app_api.add_channel = function(chn_num, chn_list)
	assert(type(chn_num) == 'number')
	assert(type(chn_list) == 'table')
	return app_api.add_channel(chn_num, chn_list);
end

b_app_api.set_custom_layout_wnd = function(layout_info)
	assert(type(layout_info) == 'table')
	return app_api.set_custom_layout_wnd(layout_info);
end

b_app_api.set_custom_multi_layout_wnd = function(layout_info)
	assert(type(layout_info) == 'table')
	return app_api.set_custom_multi_layout_wnd(layout_info);
end

b_app_api.restore_layout = function()
	return app_api.restore_layout();
end

b_app_api.manual_alarm = function(manual_type, channel)
	return app_api.manual_alarm(manual_type, channel);
end

b_app_api.manual_ipc_alarm = function(channel, out_id , enable)
	return app_api.manual_ipc_alarm(channel, out_id, enable);
end

b_app_api.getvideosignal =function ()
	return app_api.get_videosignal_type();
end

b_app_api.setvideosignal =function (max_num,channel,type)
	return app_api.set_videosignal_type(max_num,channel,type);
end

b_app_api.change_stream_mode =function (mode)
	assert(type(mode) == 'number')
	return app_api.change_stream_mode(mode);
end

b_app_api.get_device_info = function()
	return app_api.get_device_info();
end
b_app_api.get_channel_info = function ()
	return app_api.get_channel_info();
end

b_app_api.get_network_info = function ()
	return app_api.get_network_info()
end
b_app_api.get_disk_info =function ()
	return app_api.get_disk_info();
end
b_app_api.get_volume = function ()
	return app_api.get_volume();
end
b_app_api.set_volume = function (volume,mute)
	return app_api.set_volume(volume,mute);
end
	
b_app_api.get_color =function (channel)
	return app_api.get_color(channel);
end	
b_app_api.set_color =function (color)
	return app_api.set_color(color);
end	

b_app_api.reset_color = function (channel)
	return app_api.reset_color(channel);
end

b_app_api.set_immediate_color = function (color)
	return app_api.set_immediate_color(color);
end

b_app_api.set_live_immediate_color = function (color)
	return app_api.set_live_immediate_color(color);
end

b_app_api.set_ptz = function (ptz)
	return app_api.set_ptz(ptz);
end

b_app_api.set_displaylayout= function (channel,wnd_id,layout_type)
	return app_api.set_displaylayout(channel,wnd_id,layout_type);
end

b_app_api.get_event_list = function()
	return app_api.get_event_list();
end

b_app_api.disk_format = function (disk_id)
	return app_api.disk_format(disk_id).disk_format;
end

b_app_api.add_raid = function(param)
	assert(type(param) == 'table')
	return app_api.add_raid(param);
end

b_app_api.delete_raid = function(param)
	assert(type(param) == 'table')
	return app_api.delete_raid(param);
end

b_app_api.add_raid_disk = function(param)
	assert(type(param) == 'table')
	return app_api.add_raid_disk(param);
end

b_app_api.delete_raid_disk = function(param)
	assert(type(param) == 'table')
	return app_api.delete_raid_disk(param);
end

b_app_api.get_smart_info = function(param)
	assert(type(param) == 'table')
	return app_api.get_smart(param);
end

b_app_api.get_wdda_info = function(param)
	assert(type(param) == 'table')
	return app_api.get_wdda(param);
end

b_app_api.channge_cursor = function (img_id)
	return app_api.channge_cursor(img_id);
end

b_app_api.get_qrc_info = function()
	return app_api.get_qrc_info()
end

b_app_api.send_emil_find_pwd = function()
	return app_api.send_emil_find_pwd()
end

b_app_api.get_all_username = function()
	return app_api.get_all_username()
end

b_app_api.user_login = function(user_name, password)
	return app_api.user_login(user_name, password)
end

b_app_api.user_login_g = function(user_name, password)
	return app_api.user_login_g(user_name, password)
end

b_app_api.user_activation = function(user_pwd, chn_pwd)
	return app_api.user_activation(user_pwd, chn_pwd)
end

b_app_api.user_activation_g = function(user_name, password)
	return app_api.user_activation_g(user_name, password)
end

b_app_api.check_admin_pwd = function(user_name, password)
	return app_api.check_admin_pwd(user_name, password)
end

b_app_api.get_cur_username = function()
	return app_api.get_cur_username()
end

b_app_api.get_current_user_info = function(user_name)
	return app_api.get_current_user_info(user_name)
end

b_app_api.update_pwdtime = function(user_name)
	return app_api.update_pwdtime(user_name)
end

b_app_api.update_login_user_name = function(user_name)
	return app_api.update_login_user_name(user_name)
end

b_app_api.get_auto_login = function(user_name)
	return app_api.get_auto_login(user_name)
end

b_app_api.channge_resolution = function(resolution)
	return app_api.channge_resolution(resolution)
end

b_app_api.set_update_type = function(upate_type)
	return app_api.set_update_type(upate_type)
end

b_app_api.get_phone_open_ch = function()
	return app_api.get_phone_open_ch()
end

b_app_api.set_phone_open_status = function(channel,status)
	return app_api.set_phone_open_status(channel,status)
end

b_app_api.set_mouse_operation_flag = function(flag)
	return app_api.set_mouse_operation_flag(flag)
end

b_app_api.get_mouse_operation_flag = function()
	return app_api.get_mouse_operation_flag()
end

b_app_api.get_audio_channel = function()
	return app_api.get_audio_channel()
end

b_app_api.set_enable_audio = function(ch, enable)
	return app_api.set_enable_audio(ch, enable)
end


b_app_api.get_super_admin = function()
	return app_api.get_super_admin()
end

b_app_api.save_ipc_default_pwd = function(username, userpwd)
	return app_api.save_ipc_default_pwd(username, userpwd)
end

b_app_api.open_auxiliary = function(param)
	return app_api.open_auxiliary(param)
end

b_app_api.close_auxiliary = function(param)
	return app_api.close_auxiliary(param)
end

b_app_api.change_auxiliary_vo = function(param)
	return app_api.change_auxiliary_vo(param)
end

b_app_api.change_auxiliary_layout = function(id, page)
	return app_api.change_auxiliary_layout(id, page)
end

b_app_api.change_auxiliary_dec_ability = function(param)
	return app_api.change_auxiliary_dec_ability(param)
end

b_app_api.get_act_stat = function()
	return app_api.get_act_stat()
end

b_app_api.mount_dev = function()
	return app_api.mount_dev()
end

b_app_api.unmount_dev = function()
	return app_api.unmount_dev()
end

b_app_api.check_verification_code = function(username,param)
	return app_api.check_verification_code(username,param)
end
b_app_api.check_question = function(username,param)
	return app_api.check_question(username,param)
end

b_app_api.get_trade_name = function()
	return app_api.get_trade_name()
end

b_app_api.get_rtsp_pro = function()
	return app_api.get_rtsp_pro()
end

b_app_api.set_security_question = function(username,password,param)
	return app_api.set_security_question(username,password,param);
end

b_app_api.get_security_question = function(username)
	return app_api.get_security_question(username);
end

b_app_api.set_security_mail = function(username,password,param)
	return app_api.set_security_mail(username,password,param);
end

b_app_api.get_security_mail = function(username)
	return app_api.get_security_mail(username);
end

b_app_api.check_security_mail = function(username,email)
	return app_api.check_security_mail(username,email);
end

b_app_api.send_security_code = function(username,email)
	return app_api.send_security_code(username,email);
end

b_app_api.get_pattern_pwd = function (username)
	return app_api.get_pattern_pwd(username);
end

b_app_api.check_pattern_pwd = function (username,pwd)
	return app_api.check_pattern_pwd(username,pwd);
end

b_app_api.start_motion_visible = function(channel)
	return app_api.start_motion_visible(channel);
end

b_app_api.stop_motion_visible = function(channel)
	return app_api.stop_motion_visible(channel);
end

b_app_api.get_motion = function(channel)
	return app_api.get_motion(channel);
end

b_app_api.start_detect = function (block)
	return app_api.start_detect(block);
end

b_app_api.cancel_detect = function ()
	return app_api.cancel_detect();
end

b_app_api.stop_detect = function ()
	return app_api.stop_detect();
end

b_app_api.get_bad_detection = function ()
	return app_api.get_bad_detection().bad_block;
end

b_app_api.get_block_status = function ()
	return app_api.get_block_status().block_status;
end

b_app_api.get_pppoe_ip = function ()
	return app_api.get_pppoe_ip()
end

b_app_api.get_ch_ro_num = function(channel)
	return app_api.get_ch_ro_num(channel);
end

b_app_api.start_search_device = function()
	return app_api.start_search_device();
end

b_app_api.get_gdrive_url = function ()
	return app_api.get_gdrive_url().gdrive_url;
end

b_app_api.gdrive_close = function ()
	return app_api.gdrive_close();
end

b_app_api.set_google_code = function (code)
	return app_api.set_google_code(code);
end

b_app_api.check_gdrive_status = function ()
	return app_api.check_gdrive_status();
end

b_app_api.get_ioalarm_cfg = function (channel_id,source_id)
	return app_api.get_ioalarm_cfg(channel_id,source_id);
end

b_app_api.get_poe_net_state = function ()
	return app_api.get_poe_net_state().poe_net
end

b_app_api.get_net_flow = function (lan_name)
	local data = app_api.get_net_flow(lan_name);
	if (type(data) ~= "table")	then
		return nil;	
	end
	return data.net_flow
end

b_app_api.creat_net_packet = function (param)
	return app_api.creat_net_packet(param)
end

b_app_api.get_packet_status = function ()
	return app_api.get_packet_status()
end

b_app_api.destroy_capture = function (param)
	return app_api.destroy_capture(param)
end

b_app_api.get_record_type = function (param)
	return app_api.get_record_type(param)
end

b_app_api.add_dev_monitor = function(dir)
	return app_api.add_dev_monitor(dir)
end

b_app_api.del_dev_monitor = function(monitor_id, dir)
	return app_api.del_dev_monitor(monitor_id, dir)
end

b_app_api.creat_run_log = function ()
	return app_api.creat_run_log()
end

b_app_api.get_run_log_status = function ()
	return app_api.get_run_log_status()
end

b_app_api.destroy_run_log = function ()
	return app_api.destroy_run_log()
end

b_app_api.test_ftp = function (param)
	return app_api.test_ftp(param)
end

b_app_api.get_vo_src = function(vo)
	return app_api.get_vo_src(vo);
end

b_app_api.check_current_pwd = function(name, pwd)
	return app_api.check_current_pwd(name, pwd);
end

b_app_api.get_all_bitrate = function()
	return app_api.get_all_bitrate();
end

b_app_api.get_only_4k_or_auxiliary = function()
	return app_api.get_only_4k_or_auxiliary();
end

b_app_api.get_is_auxiliary_restart = function()
	return app_api.get_is_auxiliary_restart();
end

b_app_api.get_all_channel_name = function()
	return app_api.get_all_channel_name();
end

b_app_api.modify_camera_ip = function(ip, mask, data)
	return app_api.modify_camera_ip(ip, mask, data);
end

b_app_api.save_custom_dwell = function(param)
	return app_api.save_custom_dwell(param);
end

b_app_api.delete_custom_dwell = function(param)
	return app_api.delete_custom_dwell(param);
end

b_app_api.get_plage_bw_list_num = function(channel, nType)
	return app_api.get_plage_bw_list_num(channel, nType)
end

b_app_api.get_plage_bw_list_info = function(inputParam)
	return app_api.get_plage_bw_list_info(inputParam)
end

b_app_api.search_open_plage_bw_list = function(channel, plateNum)
	return app_api.search_open_plage_bw_list(channel, plateNum);	
end

b_app_api.search_gain_plage_bw_list = function(param)
	return app_api.search_gain_plage_bw_list(param);	
end

b_app_api.search_close_plage_bw_list = function(param)
	return app_api.search_close_plage_bw_list(param);	
end

b_app_api.add_plate_detect_bw_list = function(param)
	return app_api.add_plate_detect_bw_list(param);	
end

b_app_api.modify_plate_detect_bw_list = function(param)
	return app_api.modify_plate_detect_bw_list(param);	
end

b_app_api.del_plate_detect_bw_list = function(param)
	return app_api.del_plate_detect_bw_list(param);	
end

b_app_api.get_link_plate_detect_bw_list = function(channel)
	return app_api.get_link_plate_detect_bw_list(channel);	
end

b_app_api.set_link_plate_detect_bw_list = function(param)
	return app_api.set_link_plate_detect_bw_list(param);	
end

b_app_api.adam_start_search = function(param)
	return app_api.adam_start_search(param);	
end

b_app_api.adam_add_dev = function(param)
	return app_api.adam_add_dev(param);	
end

b_app_api.adam_del_dev = function(param)
	return app_api.adam_del_dev(param);	
end

b_app_api.adam_modify_ip = function(param)
	return app_api.adam_modify_ip(param);	
end

b_app_api.del_eth_route = function(param)
	return app_api.del_eth_route(param);	
end

b_app_api.add_eth_route = function(param)
	return app_api.add_eth_route(param);	
end

return b_app_api