--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2017/12/26
-- author 
-- brief  Ϣ
--]]
local b_dlg = require("wnd.core.b_dlg")
local b_ui = require("wnd.core.b_ui")

-- ok ť Ƿʾ, 
local set_ok = function(top, show, ok)
	local param = {'ok', show, ok}
	b_dlg.set_attr(top, param)
end

-- cancel ť Ƿʾ, 
local set_cancel = function(top, show, cancel)
	local param = {'cancel', show, cancel}
	b_dlg.set_attr(top, param)
end

-- ʾϢ, 
local set_text = function(top, msg, title, redraw)
	local param = {'text', msg, title, redraw}	
	b_dlg.set_attr(top, param)
end

local msg_box = function(top, msg, title)
	local top_msg = b_dlg.create(top, b_ui.MSG_BOX) --
	local value = 1
	
	if nil ~= top_msg then	
		set_text(top_msg, msg, title, false)
		
		--set_ok(top_msg, true, "Yes")
		--set_cancel(top_msg, true, "No")
		
		if b_dlg.do_show(top_msg, 0, 0) then
			local ret, idx = b_dlg.get_ret(top_msg)	
			--print('msg box:', ret, idx)
			
			if ret then value = idx end
		end
		
		b_dlg.destroy(top_msg) --
	end	
	
	if 0 == value then return true end
	
	return false 
end

return msg_box
