-- ӡ༭ͨҳ
local global_val	= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_net.add_eth_route_id;
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local cjson 	= require("cjson")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local util 			= require("wnd.core.util")
local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")

local w1_add_eth_route = {
	t = w1_key.DLG_ADD_ETH_ROUTE,
	top = nil,
	dlg = nil,
	edit_type,		--0:,  2ɾ
	save_check_illegal,
	support_face,
	support_thermal,
	sel,
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_add_eth_route.s_768 = 
{
	s_add_routh_xywh = {309,256,405,256},
	s_add_routh_titleimg_xywh = {6,8,21,28},
	s_add_routh_titlestr_xywh = {33,8,307,28},
	s_add_routh_titleclose_xywh = {373,8,21,28},
	s_add_routh_cap_name_xywh = {26,42,186,28},
	s_add_routh_t_name_xywh = {245,42,133,28},
	s_add_routh_cap_ip_xywh = {26,78,186,28},
	s_add_routh_t_ip_xywh = {245,78,133,28},
	s_add_routh_cap_mask_xywh = {26,113,186,28},
	s_add_routh_t_mask_xywh = {245,113,133,28},
	s_add_routh_cap_gw_xywh = {26,149,186,28},
	s_add_routh_t_gw_xywh = {245,149,133,28},
	s_add_routh_tipinfo_xywh = {26,184,240,28},
	s_add_routh_hline3_xywh = {26,213,352,1},
	s_add_routh_ok_xywh = {240,220,64,28},
	s_add_routh_cancel_xywh = {314,220,64,28},
};

w1_add_eth_route.s_1280 = 
{
	s_add_routh_xywh 				= {260,332,760,360}, 
	s_add_routh_titleimg_xywh 		= {12,12,40,40},
	s_add_routh_titlestr_xywh 		= {62,12,576,40},
	s_add_routh_titleclose_xywh 	= {700,12,40,40},
	s_add_routh_cap_name_xywh 		= {50,60,350,40},
	s_add_routh_t_name_xywh 		= {460,60,250,40},		
	s_add_routh_cap_ip_xywh 		= {50,110,350,40},
	s_add_routh_t_ip_xywh 			= {460,110,250,40},		
	s_add_routh_cap_mask_xywh 		= {50,160,350,40},
	s_add_routh_t_mask_xywh 		= {460,160,250,40},		
	s_add_routh_cap_gw_xywh 		= {50,210,350,40},
	s_add_routh_t_gw_xywh 			= {460,210,250,40},		
	s_add_routh_tipinfo_xywh		= {50,260,450,40},
	s_add_routh_hline3_xywh			= {50,300,660,1},
	s_add_routh_ok_xywh				= {450,310,120,40},
	s_add_routh_cancel_xywh			= {590,310,120,40},	
};

w1_add_eth_route.s_1440 = 
{
	s_add_routh_xywh 				= {340,270,760,360}, 
	s_add_routh_titleimg_xywh 		= {12,12,40,40},
	s_add_routh_titlestr_xywh 		= {62,12,576,40},
	s_add_routh_titleclose_xywh 	= {700,12,40,40},
	s_add_routh_cap_name_xywh 		= {50,60,350,40},
	s_add_routh_t_name_xywh 		= {460,60,250,40},		
	s_add_routh_cap_ip_xywh 		= {50,110,350,40},
	s_add_routh_t_ip_xywh 			= {460,110,250,40},		
	s_add_routh_cap_mask_xywh 		= {50,160,350,40},
	s_add_routh_t_mask_xywh 		= {460,160,250,40},		
	s_add_routh_cap_gw_xywh 		= {50,210,350,40},
	s_add_routh_t_gw_xywh 			= {460,210,250,40},		
	s_add_routh_tipinfo_xywh		= {50,260,450,40},
	s_add_routh_hline3_xywh			= {50,300,660,1},
	s_add_routh_ok_xywh				= {450,310,120,40},
	s_add_routh_cancel_xywh			= {590,310,120,40},	
	
};

w1_add_eth_route.s_1080p = 
{
	s_add_routh_xywh 				= {580,360,760,360}, 
	s_add_routh_titleimg_xywh 		= {12,12,40,40},
	s_add_routh_titlestr_xywh 		= {62,12,576,40},
	s_add_routh_titleclose_xywh 	= {700,12,40,40},
	s_add_routh_cap_name_xywh 		= {50,60,350,40},
	s_add_routh_t_name_xywh 		= {460,60,250,40},		
	s_add_routh_cap_ip_xywh 		= {50,110,350,40},
	s_add_routh_t_ip_xywh 			= {460,110,250,40},		
	s_add_routh_cap_mask_xywh 		= {50,160,350,40},
	s_add_routh_t_mask_xywh 		= {460,160,250,40},		
	s_add_routh_cap_gw_xywh 		= {50,210,350,40},
	s_add_routh_t_gw_xywh 			= {460,210,250,40},		
	s_add_routh_tipinfo_xywh		= {50,260,450,40},
	s_add_routh_hline3_xywh			= {50,300,660,1},
	s_add_routh_ok_xywh				= {450,310,120,40},
	s_add_routh_cancel_xywh			= {590,310,120,40},	
};

w1_add_eth_route.s_2k = 
{
	s_add_routh_xywh = {773,479,1013,479},
	s_add_routh_titleimg_xywh = {15,15,53,53},
	s_add_routh_titlestr_xywh = {82,15,767,53},
	s_add_routh_titleclose_xywh = {933,15,53,53},
	s_add_routh_cap_name_xywh = {66,79,466,53},
	s_add_routh_t_name_xywh = {613,79,333,53},
	s_add_routh_cap_ip_xywh = {66,146,466,53},
	s_add_routh_t_ip_xywh = {613,146,333,53},
	s_add_routh_cap_mask_xywh = {66,213,466,53},
	s_add_routh_t_mask_xywh = {613,213,333,53},
	s_add_routh_cap_gw_xywh = {66,279,466,53},
	s_add_routh_t_gw_xywh = {613,279,333,53},
	s_add_routh_tipinfo_xywh = {66,346,599,53},
	s_add_routh_hline3_xywh = {66,399,879,1},
	s_add_routh_ok_xywh = {599,413,159,53},
	s_add_routh_cancel_xywh = {786,413,159,53},
};

w1_add_eth_route.s_4k = 
{
	s_add_routh_xywh = {1160,720,1520,720},
	s_add_routh_titleimg_xywh = {24,24,80,80},
	s_add_routh_titlestr_xywh = {124,24,1152,80},
	s_add_routh_titleclose_xywh = {1400,24,80,80},
	s_add_routh_cap_name_xywh = {100,120,700,80},
	s_add_routh_t_name_xywh = {920,120,500,80},
	s_add_routh_cap_ip_xywh = {100,220,700,80},
	s_add_routh_t_ip_xywh = {920,220,500,80},
	s_add_routh_cap_mask_xywh = {100,320,700,80},
	s_add_routh_t_mask_xywh = {920,320,500,80},
	s_add_routh_cap_gw_xywh = {100,420,700,80},
	s_add_routh_t_gw_xywh = {920,420,500,80},
	s_add_routh_tipinfo_xywh = {100,520,900,80},
	s_add_routh_hline3_xywh = {100,600,1320,2},
	s_add_routh_ok_xywh = {900,620,240,80},
	s_add_routh_cancel_xywh = {1180,620,240,80},
};

local dsp_tip_time = 0;

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		if (dsp_tip_time > 0) then
			dsp_tip_time = dsp_tip_time -1;
		elseif (dsp_tip_time == 0) then
			b_wnd_ex.set_text(top, w1_add_eth_route.dlg.tipinfo.id, "", true);
			dsp_tip_time = dsp_tip_time - 1; 
		end
	end
	
	return 0
end	

w1_add_eth_route.set_func  = function(ok_func, okfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')

	w1_add_eth_route.ok_func = ok_func;				--ⲿtable
	w1_add_eth_route.okfunc_param = okfunc_param;
end

w1_add_eth_route.set_data  = function(data)
	w1_add_eth_route.data = data;
	return 0;
end	

local is_change = function(top)
	return false
end

local save_change = function(param)
	local top = param[1];
	local cwnd = w1_add_eth_route.dlg;

	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id);
		return iptext;
	end
	
	local data = {};
	local nic_name = gettext(cwnd.t_name.id);
	local ip = gettext(cwnd.t_ip.id);
	local netmask = gettext(cwnd.t_mask.id);
	local gateway = gettext(cwnd.t_gw.id);
	
	local legal, num= w1_legal.check_ip(top, cwnd.t_ip.id);	
	if(legal == false) then
		dsp_tip_time = 3;
		b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_CORRECT_IP'), true);
		return 0;
	end			
	
	legal, num = w1_legal.check_netmask(top, cwnd.t_mask.id);
	if(legal == false) then
		dsp_tip_time = 3;
		b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LAN_SUBNET_MASK'), true);
		return 0;
	end		
	
	legal, num = w1_legal.check_gataway(top, cwnd.t_gw.id);
	if(legal == false) then
		dsp_tip_time = 3;
		b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LAN_DEFAULT_GATEWAY'), true);
		return 0;
	end	
	
	local param = {};
	param.nic_name = nic_name;
	param.ip = ip;
	param.netmask = netmask;
	param.gateway = gateway;
	local errornum = nil;
	if (w1_add_eth_route.edit_type == 0) then	 --
		errornum = b_app_api.add_eth_route(param);
		if(errornum == 0) then	--ֱ˳,ִлص
			w1_add_eth_route.save_check_illegal = false;
		else--ɾʧ
			print("add_eth_route fail, err code :", errornum)
			dsp_tip_time = 3;
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_ADD_FAIL'), false);
			b_dlg.dlg_set_redraw(top);
			w1_add_eth_route.save_check_illegal = true;
		end
	else --༭

	end
	
	return 0;
end

local on_close = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0;
end

local on_ok = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_add_eth_route.dlg;
		local gettext = function(id)
			local iptext = b_wnd_ex.get_text(top, id);
			return iptext;
		end
		
		local data = {};
		local nic_name = gettext(cwnd.t_name.id);
		local ip = gettext(cwnd.t_ip.id);
		local netmask = gettext(cwnd.t_mask.id);
		local gateway = gettext(cwnd.t_gw.id);
				
		local legal, num= w1_legal.check_ip(top, cwnd.t_ip.id);	
		if(legal == false) then
			dsp_tip_time = 3;
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_CORRECT_IP'), true);
			return 0;
		end			
		
		legal, num = w1_legal.check_netmask(top, cwnd.t_mask.id);
		if(legal == false) then
			dsp_tip_time = 3;
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LAN_SUBNET_MASK'), true);
			return 0;
		end		
		
		legal, num = w1_legal.check_gataway(top, cwnd.t_gw.id);
		if(legal == false) then
			dsp_tip_time = 3;
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LAN_DEFAULT_GATEWAY'), true);
			return 0;
		end	

		local param = {};
		param.nic_name = nic_name;
		param.ip = ip;
		param.netmask = netmask;
		param.gateway = gateway;
		
		local errornum = nil;
		if (w1_add_eth_route.edit_type == 0) then	 --
			errornum = b_app_api.add_eth_route(param);
			if(errornum == 0) then	--ֱ˳,ִлص
				b_dlg.end_modal(top);
				w1_add_eth_route.okfunc_param[2] = w1_add_eth_route.edit_type;
				w1_add_eth_route.ok_func(w1_add_eth_route.okfunc_param);
			else--ɾʧ
				print("add_eth_route fail, err code :", errornum)
				dsp_tip_time = 3;
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_ADD_FAIL'), false);
				b_dlg.dlg_set_redraw(top);
			end
		else --༭
	
		end
	end
	
	return 0;
end		

local on_ok_del = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cur_data = w1_add_eth_route.data.info_list['idx'..w1_add_eth_route.sel]
		local errornum = b_app_api.del_eth_route(cur_data)
		local cwnd = w1_add_eth_route.dlg;
		if(errornum == 0) then	--ɾɹֱ˳,ִлص
			b_dlg.end_modal(top);
			w1_add_eth_route.okfunc_param[2] = w1_add_eth_route.edit_type;
			w1_add_eth_route.ok_func(w1_add_eth_route.okfunc_param);
		else--ɾʧ
			print("del_route fail, err code :", errornum)
			dsp_tip_time = 3;
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_DELETE_FAIL'), false);
			b_dlg.dlg_set_redraw(top);
		end
	end
	return 0;
end

local dlg = {
	attr 	= {xywh='s_add_routh_xywh',cmd=on_dlg,timer={-1, 1000}},
	
	sub 	= {'titleimg', 'titlestr', 'titleclose', 
				'cap_name', 't_name', 'cap_ip', 't_ip','cap_mask','t_mask', 'cap_gw', 't_gw',  
				'hline3', 'tipinfo', 'ok','cancel'},
	
	titleimg 	= {t='tt_picture',	id=id+1,xywh='s_add_routh_titleimg_xywh', 
					t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_addcameera'}},
	
	titlestr	= {t='static', 	id=id+2,xywh='s_add_routh_titlestr_xywh', 
					text='LA_ADD_ROUTE',	font = 'f_grade5', 
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	
	titleclose 	= {t='tt_button',id=id+3,xywh = 's_add_routh_titleclose_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
					color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_txt_f'},
					color_f= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},cmd=on_close},
	
	cap_name	= {t='static', 	id=id+4,xywh='s_add_routh_cap_name_xywh', 
					text='LA_NETWORKCARD_NAME', font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	t_name 	= {t='combox', id=id+5,xywh='s_add_routh_t_name_xywh', 
					items={'eth0'},trans = false, 
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
	cap_ip 		= {t='static',id=id+6,xywh='s_add_routh_cap_ip_xywh',text='LA_IP_ADDRESS',
				   color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_ip 		= {t='edit_ip',  id=id+7,xywh='s_add_routh_t_ip_xywh'},
	
	cap_mask = {t='static',id=id+8,xywh='s_add_routh_cap_mask_xywh',text='LA_SUBNET_MASK',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_mask 	= {t='edit_ip',  id=id+9,xywh='s_add_routh_t_mask_xywh'},
	
	cap_gw = {t='static',id=id+10,xywh='s_add_routh_cap_gw_xywh',text='LA_GATEWAY',
			  color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_gw 	= {t='edit_ip',  id=id+11,xywh='s_add_routh_t_gw_xywh'},

	tipinfo		= {t='static',id=id+12,	xywh='s_add_routh_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
					},

	hline3		= {t='hline',	id=id+13,xywh='s_add_routh_hline3_xywh'},

	ok 			= {t='button',	id=id+14,	xywh='s_add_routh_ok_xywh',text='LA_OK',
					cmd=on_ok,font='f_grade6',
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	cancel  	= {t='button',	id=id+15,	xywh='s_add_routh_cancel_xywh', text='LA_CANCEL',
					cmd=on_close,font='f_grade6',
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
					},		
}

local dlg_del = {
	attr 	= {xywh='s_msgbox_xywh',},
	sub 	= {'msg', 'tipinfo','ok', 'cancel'},
	
	msg	 	= {t='static',	id=id+2,	xywh='s_msgbox_msg_xywh',	
			text='LA_CONFIRM_DELETE',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},

	tipinfo	= {t='static',id=id+3,	xywh='s_msgbox_tipinfo_xywh',	text='', 
			font='f_grade7', trans = false,
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
			},
			
	hline	= {t='hline',	id=id+4,	xywh='s_msgbox_hline_xywh'},
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
			
	ok		= {t='button',	id=id+5,	xywh='s_msgbox_ok_xywh',	text='LA_OK',	font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok_del},
	cancel	= {t='button',	id=id+6,	xywh='s_msgbox_cancel_xywh',text='LA_CANCEL',font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
				cmd=on_close},		
}

w1_add_eth_route.clear_data = function()
	w1_add_eth_route.ok_func = nil;--okťص	
	w1_add_eth_route.okfunc_param = nil; --okťص
	w1_add_eth_route.data = nil;

	return 0;
end

w1_add_eth_route.on_create = function(top)
	w1_add_eth_route.top = top;
	return 0;
end

w1_add_eth_route.on_destroy = function(top)
	w1_add_eth_route.top = nil;
	w1_add_eth_route.dlg = nil;
	
	return 0;
end

w1_add_eth_route.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top);
	local paramdata;
	if(param ~= nil)then
		paramdata = cjson.decode(param);
		assert(paramdata.opera == 2);
		w1_add_eth_route.edit_type = 2;--ǵǰɾ
		local sel = math.modf((paramdata.sel + 1) / 1)
		w1_add_eth_route.sel = sel;--¼ǰк
	else
		w1_add_eth_route.edit_type = 0;--ǵǰ
	end
		
	if(w1_add_eth_route.edit_type == 0) then
		--޸ıͼ
		dlg.titleimg.t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_addcameera'};
		w1_add_eth_route.dlg = dlg;
		b_parser(top, w1_add_eth_route.dlg);	
		local nic_num = global_val.get_nic_num();	
		local nic_name ={};
		table.insert(nic_name,'eth0')
		if (nic_num == 2) then
			table.insert(nic_name,'eth1')
		end
		b_wnd_ex.set_items(top,w1_add_eth_route.dlg.t_name.id,nic_name,false)		
	elseif(w1_add_eth_route.edit_type == 2) then
		w1_add_eth_route.dlg = dlg_del;
		b_parser(top, w1_add_eth_route.dlg);
		return 0;
	end
	
	return 0;
end

w1_add_eth_route.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'));
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1);
	b_wnd.end_job(top);
	return 0;
end

w1_add_eth_route.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if(b_ui.RBUTTONCLK == vmsg) then
		local ret = false
		w1_add_eth_route.save_check_illegal = false;		
		if(w1_add_eth_route.edit_type == 0 or w1_add_eth_route.edit_type == 1) then
			ret = is_change(top);
		end
		if ret == true then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_WANT_SAVE'), true, true, false,STR('LA_YES'), STR('LA_BAD'));
			w1_msgbox.set_func(save_change,{top}, nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			w1_msgbox.set_func(nil,nil, nil,nil);
		end
		if w1_add_eth_route.save_check_illegal == true then
			return 0;
		end
		b_dlg.end_modal(top);
	end
	return 0;
end

return w1_add_eth_route;




