-- ӡ༭ͨҳ
local global_val	= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_adduser_id;
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local cjson 	= require("cjson")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local util 			= require("wnd.core.util")

local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")

local w1_add_user = {
	t = w1_key.DLG_MSG_ADDUSER,
	top = nil,
	dlg = nil,
	edit_type,		--0:, 1:༭, 2ɾ
	save_check_illegal,
	support_face,
	support_thermal,
	sel,
	data,
	date_fmt,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_add_user.s_768 =
{
	s_adduser_xywh = {282,64,458,638},
	s_adduser_titleimg_xywh = {6,8,21,28},
	s_adduser_titlestr_xywh = {33,8,253,28},
	s_adduser_titleclose_xywh = {426,8,21,28},
	s_adduser_cap_name_xywh = {26,42,186,28},
	s_adduser_t_name_xywh = {245,42,181,28},
	s_adduser_cap_pass_xywh = {26,78,186,28},
	s_adduser_t_pass_xywh = {245,78,181,28},
	s_adduser_cap_confirm_xywh = {26,113,186,28},
	s_adduser_t_confirm_xywh = {245,113,181,28},
	s_adduser_cap_group_xywh = {26,149,186,28},
	s_adduser_t_group_xywh = {245,149,181,28},
	s_adduser_cap_ch_xywh = {26,184,186,28},
	s_adduser_t_ch_xywh = {245,184,181,28},
	c_date_xywh = {26,220,186,28},
	t_date_xywh = {277,220,149,28},
	t_date_enable_xywh = {234,220,42,28},
	s_adduser_hline1_xywh = {26,256,405,1},
	s_adduser_t_live_xywh = {26,270,21,28},
	s_adduser_cap_live_xywh = {48,270,160,28},
	s_add1user_t_ptz_xywh = {26,302,21,28},
	s_add1user_cap_ptz_xywh = {48,302,160,28},
	s_add1user_t_play_xywh = {26,334,21,28},
	s_add1user_cap_play_xywh = {48,334,160,28},
	s_add1user_t_chm_xywh = {26,366,21,28},
	s_add1user_cap_chm_xywh = {48,366,160,28},
	s_add1user_t_dev_xywh = {26,398,21,28},
	s_add1user_cap_dev_xywh = {48,398,160,28},
	s_add1user_t_sys_xywh = {26,430,21,28},
	s_add1user_cap_sys_xywh = {48,430,160,28},
	s_add1user_t_face_xywh = {26,462,21,28},
	s_add1user_cap_face_xywh = {48,462,160,28},
	s_add1user_t_thermal_xywh = {26,494,21,28},
	s_add1user_cap_thermal_xywh = {48,494,160,28},
	s_add1user_t_backup_xywh 	= {26,526,21,28},
	s_add1user_cap_backup_xywh 	= {48,526,160,28},
	s_add1user_t_sysmain_xywh 	= {26,556,21,28},
	s_add1user_cap_sysmain_xywh = {48,556,160,28},
	s_add1user_hline2_xywh = {224,270,1,248},
	s_add1user_livelist_xywh = {245,270,181,199},
	s_add1user_ptzlist_xywh = {245,270,181,199},
	s_add1user_playlist_xywh = {245,270,181,199},
	s_add1user_chlist_xywh = {245,270,181,199},
	s_add1user_facelist_xywh = {245,270,181,199},
	s_add1user_thermallist_xywh = {245,270,181,199},
	s_add1user_backuplist_xywh = {245,270,181,199},		
	s_add1user_list_title_xywh = {245,483,181,28},
	s_add1user_tipinfo_xywh= {26,621,240,12},
	s_adduser_hline3_xywh= {26,606,405,1},
	s_add1user_ok_xywh= {293,610,64,27},
	s_add1user_cancel_xywh= {368,609,64,27},
	s_add1user_list_w1 = {26,0,0,0},
	s_add1user_list_w2 = {130,0,0,0},
};

w1_add_user.s_1280 = 
{
	s_adduser_xywh = {210,67,860,890},
	s_adduser_titleimg_xywh = {12,12,40,40},
	s_adduser_titlestr_xywh = {62,12,476,40},
	s_adduser_titleclose_xywh = {800,12,40,40},
	s_adduser_cap_name_xywh = {50,60,350,40},
	s_adduser_t_name_xywh = {460,60,340,40},
	s_adduser_cap_pass_xywh = {50,110,350,40},
	s_adduser_t_pass_xywh = {460,110,340,40},
	s_adduser_cap_confirm_xywh = {50,160,350,40},
	s_adduser_t_confirm_xywh = {460,160,340,40},
	s_adduser_cap_group_xywh = {50,210,350,40},
	s_adduser_t_group_xywh = {460,210,340,40},
	s_adduser_cap_ch_xywh = {50,260,350,40},
	s_adduser_t_ch_xywh = {460,260,340,40},
	c_date_xywh			= {50,310,350,40},
	t_date_xywh			= {520,310,280,40},
	t_date_enable_xywh 	= {440,310,80,40},
	s_adduser_hline1_xywh = {50,360,760,1},
	s_adduser_t_live_xywh = {50,380,40,40},
	s_adduser_cap_live_xywh = {90,380,300,40},
	s_add1user_t_ptz_xywh= {50,425,40,40}, 
	s_add1user_cap_ptz_xywh= {90,425,300,40}, 
	s_add1user_t_play_xywh= {50,470,40,40}, 
	s_add1user_cap_play_xywh= {90,470,300,40}, 
	s_add1user_t_chm_xywh= {50,515,40,40},
	s_add1user_cap_chm_xywh= {90,515,300,40}, 
	s_add1user_t_dev_xywh= {50,560,40,40},
	s_add1user_cap_dev_xywh = {90,560,300,40}, 
	s_add1user_t_sys_xywh= {50,605,40,40},
	s_add1user_cap_sys_xywh= {90,605,300,40}, 
	s_add1user_t_face_xywh= {50,650,40,40},
	s_add1user_cap_face_xywh= {90,650,300,40}, 
	s_add1user_t_thermal_xywh= {50,695,40,40},
	s_add1user_cap_thermal_xywh= {90,695,300,40}, 	
	s_add1user_t_backup_xywh 	= {50, 740, 40, 40},
	s_add1user_cap_backup_xywh 	= {90, 740, 300, 40},
	s_add1user_t_sysmain_xywh 	= {50, 795, 40, 40},
	s_add1user_cap_sysmain_xywh = {90, 795, 300, 40},
	s_add1user_hline2_xywh= {420,380,1,350},
	s_add1user_livelist_xywh= {460,380,340,280},
	s_add1user_ptzlist_xywh= {460,380,340,280},
	s_add1user_playlist_xywh= {460,380,340,280},
	s_add1user_chlist_xywh= {460,380,340,280},
	s_add1user_facelist_xywh = {460,380,340,280},	
	s_add1user_thermallist_xywh = {460,380,340,280},	
	s_add1user_backuplist_xywh = {460,380,340,280},	
	s_add1user_list_title_xywh= {460,680,340,40},
	s_add1user_tipinfo_xywh= {50,850,450,18},
	s_adduser_hline3_xywh= {50,840,760,1},
	s_add1user_ok_xywh= {550,850,120,38},
	s_add1user_cancel_xywh= {690,850,120,38},
	s_add1user_list_w1 = {50,0,0,0},
	s_add1user_list_w2 = {264,0,0,0},
};

w1_add_user.s_1440 = 
{
	s_adduser_xywh = {290,5,860,890},
	s_adduser_titleimg_xywh = {12,12,40,40},
	s_adduser_titlestr_xywh = {62,12,476,40},
	s_adduser_titleclose_xywh = {800,12,40,40},
	s_adduser_cap_name_xywh = {50,60,350,40},
	s_adduser_t_name_xywh = {460,60,340,40},
	s_adduser_cap_pass_xywh = {50,110,350,40},
	s_adduser_t_pass_xywh = {460,110,340,40},
	s_adduser_cap_confirm_xywh = {50,160,350,40},
	s_adduser_t_confirm_xywh = {460,160,340,40},
	s_adduser_cap_group_xywh = {50,210,350,40},
	s_adduser_t_group_xywh = {460,210,340,40},
	s_adduser_cap_ch_xywh = {50,260,350,40},
	s_adduser_t_ch_xywh = {460,260,340,40},
	c_date_xywh			= {50,310,350,40},
	t_date_xywh			= {520,310,270,40},
	t_date_enable_xywh 	= {440,310,80,40},
	s_adduser_hline1_xywh = {50,360,760,1},
	s_adduser_t_live_xywh = {50,380,40,40},
	s_adduser_cap_live_xywh = {90,380,300,40},
	s_add1user_t_ptz_xywh= {50,425,40,40}, 
	s_add1user_cap_ptz_xywh= {90,425,300,40}, 
	s_add1user_t_play_xywh= {50,470,40,40}, 
	s_add1user_cap_play_xywh= {90,470,300,40}, 
	s_add1user_t_chm_xywh= {50,515,40,40},
	s_add1user_cap_chm_xywh= {90,515,300,40}, 
	s_add1user_t_dev_xywh= {50,560,40,40},
	s_add1user_cap_dev_xywh = {90,560,300,40}, 
	s_add1user_t_sys_xywh= {50,605,40,40},
	s_add1user_cap_sys_xywh= {90,605,300,40}, 
	s_add1user_t_face_xywh= {50,650,40,40},
	s_add1user_cap_face_xywh= {90,650,300,40}, 
	s_add1user_t_thermal_xywh= {50,695,40,40},
	s_add1user_cap_thermal_xywh= {90,695,300,40}, 	
	s_add1user_t_backup_xywh 	= {50, 740, 40, 40},
	s_add1user_cap_backup_xywh 	= {90, 740, 300, 40},
	s_add1user_t_sysmain_xywh 	= {50, 795, 40, 40},
	s_add1user_cap_sysmain_xywh = {90, 795, 300, 40},
	s_add1user_hline2_xywh= {420,380,1,350},
	s_add1user_livelist_xywh= {460,380,340,280},
	s_add1user_ptzlist_xywh= {460,380,340,280},
	s_add1user_playlist_xywh= {460,380,340,280},
	s_add1user_chlist_xywh= {460,380,340,280},
	s_add1user_facelist_xywh = {460,380,340,280},	
	s_add1user_thermallist_xywh = {460,380,340,280},	
	s_add1user_backuplist_xywh = {460,380,340,280},	
	s_add1user_list_title_xywh= {460,680,340,40},
	s_add1user_tipinfo_xywh= {50,850,450,18},
	s_adduser_hline3_xywh= {50,840,760,1},
	s_add1user_ok_xywh= {550,850,120,38},
	s_add1user_cancel_xywh= {690,850,120,38},
	s_add1user_list_w1 = {50,0,0,0},
	s_add1user_list_w2 = {264,0,0,0},
	
};

w1_add_user.s_1080p = 
{
	s_adduser_xywh = {530,95,860,890},
	s_adduser_titleimg_xywh = {12,12,40,40},
	s_adduser_titlestr_xywh = {62,12,476,40},
	s_adduser_titleclose_xywh = {800,12,40,40},
	s_adduser_cap_name_xywh = {50,60,350,40},
	s_adduser_t_name_xywh = {460,60,340,40},
	s_adduser_cap_pass_xywh = {50,110,350,40},
	s_adduser_t_pass_xywh = {460,110,340,40},
	s_adduser_cap_confirm_xywh = {50,160,350,40},
	s_adduser_t_confirm_xywh = {460,160,340,40},
	s_adduser_cap_group_xywh = {50,210,350,40},
	s_adduser_t_group_xywh = {460,210,340,40},
	s_adduser_cap_ch_xywh = {50,260,350,40},
	s_adduser_t_ch_xywh = {460,260,340,40},
	c_date_xywh			= {50,310,350,40},
	t_date_xywh			= {520,310,280,40},
	t_date_enable_xywh 	= {440,310,80,40},
	s_adduser_hline1_xywh = {50,360,760,1},
	s_adduser_t_live_xywh = {50,380,40,40},
	s_adduser_cap_live_xywh = {90,380,300,40},
	s_add1user_t_ptz_xywh= {50,425,40,40}, 
	s_add1user_cap_ptz_xywh= {90,425,300,40}, 
	s_add1user_t_play_xywh= {50,470,40,40}, 
	s_add1user_cap_play_xywh= {90,470,300,40}, 
	s_add1user_t_chm_xywh= {50,515,40,40},
	s_add1user_cap_chm_xywh= {90,515,300,40}, 
	s_add1user_t_dev_xywh= {50,560,40,40},
	s_add1user_cap_dev_xywh = {90,560,300,40}, 
	s_add1user_t_sys_xywh= {50,605,40,40},
	s_add1user_cap_sys_xywh= {90,605,300,40}, 
	s_add1user_t_face_xywh= {50,650,40,40},
	s_add1user_cap_face_xywh= {90,650,300,40}, 
	s_add1user_t_thermal_xywh= {50,695,40,40},
	s_add1user_cap_thermal_xywh	= {90,695,300,40}, 	
	s_add1user_t_backup_xywh 	= {50, 740, 40, 40},
	s_add1user_cap_backup_xywh 	= {90, 740, 300, 40},
	s_add1user_t_sysmain_xywh 	= {50, 795, 40, 40},
	s_add1user_cap_sysmain_xywh = {90, 795, 300, 40},
	s_add1user_hline2_xywh= {420,380,1,350},
	s_add1user_livelist_xywh= {460,380,340,280},
	s_add1user_ptzlist_xywh= {460,380,340,280},
	s_add1user_playlist_xywh= {460,380,340,280},
	s_add1user_chlist_xywh= {460,380,340,280},
	s_add1user_facelist_xywh = {460,380,340,280},	
	s_add1user_thermallist_xywh = {460,380,340,280},	
	s_add1user_backuplist_xywh = {460,380,340,280},	
	s_add1user_list_title_xywh= {460,680,340,40},
	s_add1user_tipinfo_xywh= {50,850,450,18},
	s_adduser_hline3_xywh= {50,840,760,1},
	s_add1user_ok_xywh= {550,850,120,38},
	s_add1user_cancel_xywh= {690,850,120,38},
	s_add1user_list_w1 = {50,0,0,0},
	s_add1user_list_w2 = {264,0,0,0},
	
};
w1_add_user.s_2k = 
{
	s_adduser_xywh = {706,127,1146,1187},
	s_adduser_titleimg_xywh = {16,16,53,53},
	s_adduser_titlestr_xywh = {83,16,635,53},
	s_adduser_titleclose_xywh = {1066,16,53,53},
	s_adduser_cap_name_xywh = {67,80,467,53},
	s_adduser_t_name_xywh = {613,80,453,53},
	s_adduser_cap_pass_xywh = {67,146,467,53},
	s_adduser_t_pass_xywh = {613,146,453,53},
	s_adduser_cap_confirm_xywh = {67,213,467,53},
	s_adduser_t_confirm_xywh = {613,213,453,53},
	s_adduser_cap_group_xywh = {67,280,467,53},
	s_adduser_t_group_xywh = {613,280,453,53},
	s_adduser_cap_ch_xywh = {67,346,467,53},
	s_adduser_t_ch_xywh = {613,346,453,53},
	c_date_xywh			= {67,412,467,53},
	t_date_xywh			= {689,412,377,53},
	t_date_enable_xywh 	= {585,412,104,53},
	s_adduser_hline1_xywh = {67,470,1013,1},
	s_adduser_t_live_xywh = {67,507,53,53},
	s_adduser_cap_live_xywh = {120,507,400,53},
	s_add1user_t_ptz_xywh= {67,567,53,53},
	s_add1user_cap_ptz_xywh= {120,567,400,53},
	s_add1user_t_play_xywh= {67,627,53,53},
	s_add1user_cap_play_xywh= {120,627,400,53},
	s_add1user_t_chm_xywh= {67,686,53,53},
	s_add1user_cap_chm_xywh= {120,686,400,53},
	s_add1user_t_dev_xywh= {67,746,53,53},
	s_add1user_cap_dev_xywh = {120,746,400,53},
	s_add1user_t_sys_xywh= {67,806,53,53},
	s_add1user_cap_sys_xywh= {120,806,400,53},
	s_add1user_t_face_xywh= {67,866,53,53},
	s_add1user_cap_face_xywh= {120,866,400,53},
	s_add1user_t_thermal_xywh= {67,926,53,53},
	s_add1user_cap_thermal_xywh= {120,926,400,53},
	s_add1user_t_backup_xywh 	= {67,986,53,53},
	s_add1user_cap_backup_xywh 	= {120,986,400,53},	
	s_add1user_t_sysmain_xywh 	= {67,1046,53,53},
	s_add1user_cap_sysmain_xywh = {120,1046,400,53},	
	s_add1user_hline2_xywh= {560,507,1,466},
	s_add1user_livelist_xywh= {613,507,453,373},
	s_add1user_ptzlist_xywh= {613,507,453,373},
	s_add1user_playlist_xywh= {613,507,453,373},
	s_add1user_chlist_xywh= {613,507,453,373},
	s_add1user_facelist_xywh = {613,507,453,373},
	s_add1user_thermallist_xywh = {613,507,453,373},
	s_add1user_backuplist_xywh = {613,507,453,373},
	s_add1user_list_title_xywh= {613,907,453,53},
	s_add1user_tipinfo_xywh= {67,1133,600,24},
	s_adduser_hline3_xywh= {67,1120,1013,1},
	s_add1user_ok_xywh= {733,1133,160,51},
	s_add1user_cancel_xywh= {920,1133,160,51},
	s_add1user_list_w1 = {67,0,0,0},
	s_add1user_list_w2 = {352,0,0,0},

};
w1_add_user.s_4k = 
{
	s_adduser_xywh = {1060,190,1720,1780},
	s_adduser_titleimg_xywh = {24,24,80,80},
	s_adduser_titlestr_xywh = {124,24,952,80},
	s_adduser_titleclose_xywh = {1600,24,80,80},
	s_adduser_cap_name_xywh = {100,120,700,80},
	s_adduser_t_name_xywh = {920,120,680,80},
	s_adduser_cap_pass_xywh = {100,220,700,80},
	s_adduser_t_pass_xywh = {920,220,680,80},
	s_adduser_cap_confirm_xywh = {100,320,700,80},
	s_adduser_t_confirm_xywh = {920,320,680,80},
	s_adduser_cap_group_xywh = {100,420,700,80},
	s_adduser_t_group_xywh = {920,420,680,80},
	s_adduser_cap_ch_xywh = {100,520,700,80},
	s_adduser_t_ch_xywh = {920,520,680,80},
	c_date_xywh			= {100,620,700,80},
	t_date_xywh			= {1040,620,560,80},
	t_date_enable_xywh 	= {880,620,160,80},
	s_adduser_hline1_xywh = {100,700,1520,2},
	s_adduser_t_live_xywh = {100,760,80,80},
	s_adduser_cap_live_xywh = {180,760,600,80},
	s_add1user_t_ptz_xywh= {100,850,80,80},
	s_add1user_cap_ptz_xywh= {180,850,600,80},
	s_add1user_t_play_xywh= {100,940,80,80},
	s_add1user_cap_play_xywh= {180,940,600,80},
	s_add1user_t_chm_xywh= {100,1030,80,80},
	s_add1user_cap_chm_xywh= {180,1030,600,80},
	s_add1user_t_dev_xywh= {100,1120,80,80},
	s_add1user_cap_dev_xywh = {180,1120,600,80},
	s_add1user_t_sys_xywh= {100,1210,80,80},
	s_add1user_cap_sys_xywh= {180,1210,600,80},
	s_add1user_t_face_xywh= {100,1300,80,80},
	s_add1user_cap_face_xywh= {180,1300,600,80},
	s_add1user_t_thermal_xywh= {100,1390,80,80},
	s_add1user_cap_thermal_xywh= {180,1390,600,80},
	s_add1user_t_backup_xywh 	= {100,1480,80,80},
	s_add1user_cap_backup_xywh 	= {180,1480,600,80},
	s_add1user_t_sysmain_xywh 	= {100,1590,80,80},
	s_add1user_cap_sysmain_xywh = {180,1590,600,80},
	s_add1user_hline2_xywh= {840,760,2,700},
	s_add1user_livelist_xywh= {920,760,680,560},
	s_add1user_ptzlist_xywh= {920,760,680,560},
	s_add1user_playlist_xywh= {920,760,680,560},
	s_add1user_chlist_xywh= {920,760,680,560},
	s_add1user_facelist_xywh = {920,760,680,560},
	s_add1user_thermallist_xywh = {920,760,680,560},
	s_add1user_backuplist_xywh = {920,760,680,560},
	s_add1user_list_title_xywh= {920,1360,680,80},
	s_add1user_tipinfo_xywh= {100,1700,900,36},
	s_adduser_hline3_xywh= {100,1680,1520,2},
	s_add1user_ok_xywh= {1100,1700,240,76},
	s_add1user_cancel_xywh= {1380,1700,240,76},
	s_add1user_list_w1 = {100,0,0,0},
	s_add1user_list_w2 = {528,0,0,0},
};

local channel_num;--豸ͨĿ
--local SAVE_TIME;

w1_add_user.init = function()
	w1_add_user.ok_func = nil;				--okťص	
	w1_add_user.okfunc_param = nil;			--okťص
end

w1_add_user.set_func  = function(ok_func, okfunc_param, cannel_func, cancelfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')

	w1_add_user.ok_func = ok_func;				--ⲿtable
	w1_add_user.okfunc_param = okfunc_param;
end

local prilist_allhide = function(top, redraw)
	local cwnd = w1_add_user.dlg;
	local idtab = {cwnd.livelist.id, cwnd.ptzlist.id,
				   cwnd.playlist.id, cwnd.chlist.id, cwnd.facelist.id, 
				   cwnd.thermallist.id, cwnd.backuplist.id};
	for i=1, #idtab do
		b_wnd_ex.set_hide(top, idtab[i], true, redraw);
	end
end

local switch_group = function(top, group, redraw)
	local sethide = function(id, hide)
		b_wnd_ex.set_hide(top, id, hide, false);
	end
	local setcheck = function(id, check)
		b_wnd_ex.set_check(top, id, check, false);
	end

	local cwnd = w1_add_user.dlg;
	local sid = cwnd.t_ptz.id;
	local eid = cwnd.cap_sysmain.id;
	for i=sid, eid do
		sethide(i, true);
	end
	
	local move_h = 0;
	local pos1 = SIZE('s_add1user_cap_ptz_xywh');		
	local pos2 = SIZE('s_add1user_t_play_xywh');
	local item_h = pos2[2] - pos1[2];	
	if(group == 0) then		--'Administrators'
		local cwnd = w1_add_user.dlg;
		local sid = cwnd.t_ptz.id;
		local eid = cwnd.cap_backup.id;
		for i=sid, eid do
			sethide(i, false);
		end
			
		if (w1_add_user.support_pb == true) then
			sid = cwnd.t_play.id;
			eid = cwnd.cap_sysmain.id;
			local pos_xywh = {
				"s_add1user_t_play_xywh",		
				"s_add1user_cap_play_xywh",		
				"s_add1user_t_chm_xywh",
				"s_add1user_cap_chm_xywh",
				"s_add1user_t_face_xywh",
				"s_add1user_cap_face_xywh",
				"s_add1user_t_thermal_xywh",
				"s_add1user_cap_thermal_xywh",
				"s_add1user_t_dev_xywh",
				"s_add1user_cap_dev_xywh",
				"s_add1user_t_sys_xywh",
				"s_add1user_cap_sys_xywh",
				"s_add1user_t_backup_xywh",		
				"s_add1user_cap_backup_xywh",		
				"s_add1user_t_sysmain_xywh",
				"s_add1user_cap_sysmain_xywh"};
			for i = sid, eid do
				local pos = SIZE(pos_xywh[i - sid + 1]);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2]}, false);
			end	
		else
			local cwnd = w1_add_user.dlg;
			local sid = cwnd.t_ptz.id;
			local eid = cwnd.cap_sys.id;
			for i=sid, eid do
				sethide(i, false);
			end
			--¼طȨ뱸Ȩ
			sethide(cwnd.cap_play.id, true);	
			sethide(cwnd.t_play.id, true);
			sethide(cwnd.playlist.id, true);	
			sethide(cwnd.cap_backup.id, true);	
			sethide(cwnd.t_backup.id, true);
			sethide(cwnd.backuplist.id, true);	
			
			sid = cwnd.t_chm.id;
			eid = cwnd.cap_sys.id;
			local pos_xywh = {
				"s_add1user_t_chm_xywh",
				"s_add1user_cap_chm_xywh",
				"s_add1user_t_face_xywh",
				"s_add1user_cap_face_xywh",
				"s_add1user_t_thermal_xywh",
				"s_add1user_cap_thermal_xywh",
				"s_add1user_t_dev_xywh",
				"s_add1user_cap_dev_xywh",
				"s_add1user_t_sys_xywh",
				"s_add1user_cap_sys_xywh",}
			--ƶһ	
			for i = sid, eid do
				local pos = SIZE(pos_xywh[i - sid + 1]);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - item_h}, false);
			end	
			move_h = item_h * 2;
		end
	elseif(group == 1) then	--'Operator'
		sethide(cwnd.t_ptz.id, false);
		sethide(cwnd.cap_ptz.id, false);
		sethide(cwnd.t_play.id, false);
		sethide(cwnd.cap_play.id, false);	
		sethide(cwnd.t_sys.id, false);
		sethide(cwnd.cap_sys.id, false);
		sethide(cwnd.t_backup.id, false);
		sethide(cwnd.cap_backup.id, false);
		if (w1_add_user.support_pb == true) then
				local pos = SIZE('s_add1user_t_chm_xywh');
				b_wnd_ex.move_ex(top, cwnd.t_sys.id, pos, false);
				pos = SIZE('s_add1user_cap_chm_xywh');
				b_wnd_ex.move_ex(top, cwnd.cap_sys.id, pos, false);
				pos = SIZE('s_add1user_t_play_xywh');
				b_wnd_ex.move_ex(top, cwnd.t_play.id, pos, false);
				pos = SIZE('s_add1user_cap_play_xywh');
				b_wnd_ex.move_ex(top, cwnd.cap_play.id, pos, false);
				pos = SIZE('s_add1user_t_dev_xywh');
				b_wnd_ex.move_ex(top, cwnd.t_backup.id, pos, false);
				pos = SIZE('s_add1user_cap_dev_xywh');
				b_wnd_ex.move_ex(top, cwnd.cap_backup.id, pos, false);
		else
			--¼طȨ뱸Ȩ
			sethide(cwnd.cap_play.id, true);	
			sethide(cwnd.t_play.id, true);
			sethide(cwnd.playlist.id, true);	
			sethide(cwnd.cap_backup.id, true);	
			sethide(cwnd.t_backup.id, true);
			sethide(cwnd.backuplist.id, true);				
			local pos = SIZE('s_add1user_t_chm_xywh');
			b_wnd_ex.move_ex(top, cwnd.t_sys.id, {pos[1], pos[2] - item_h,pos[3],pos[4]}, false);
			pos = SIZE('s_add1user_cap_chm_xywh');
			b_wnd_ex.move_ex(top, cwnd.cap_sys.id, {pos[1], pos[2] - item_h,pos[3],pos[4]}, false);
		end		
	elseif(group == 2) then	--'Media user'
		if (w1_add_user.support_pb == true) then
			sethide(cwnd.t_play.id, false);
			sethide(cwnd.cap_play.id, false);	
			sethide(cwnd.t_backup.id, false);
			sethide(cwnd.cap_backup.id, false);
			pos = SIZE('s_add1user_t_ptz_xywh');
			b_wnd_ex.move_ex(top, cwnd.t_play.id, pos, false);
			pos = SIZE('s_add1user_cap_ptz_xywh');
			b_wnd_ex.move_ex(top, cwnd.cap_play.id, pos, false);
			pos = SIZE('s_add1user_t_play_xywh');
			b_wnd_ex.move_ex(top, cwnd.t_backup.id, pos, false);
			pos = SIZE('s_add1user_cap_play_xywh');
			b_wnd_ex.move_ex(top, cwnd.cap_backup.id, pos, false);
		else
			sethide(cwnd.cap_play.id, true);	
			sethide(cwnd.t_play.id, true);
			sethide(cwnd.playlist.id, true);	
			sethide(cwnd.cap_backup.id, true);	
			sethide(cwnd.t_backup.id, true);
			sethide(cwnd.backuplist.id, true);			
		end
	end
	
	if (w1_add_user.support_face ~= true) then --֧
		move_h = move_h + item_h;
		local cwnd = w1_add_user.dlg;
		b_wnd_ex.set_hide(top, cwnd.t_face_recognition.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_face_recognition.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.facelist.id, true, false);
	end
	
	if (w1_add_user.support_thermal ~= true) then --֧ȳ
		move_h = move_h + item_h;
		local cwnd = w1_add_user.dlg;
		b_wnd_ex.set_hide(top, cwnd.t_thermal.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_thermal.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.thermallist.id, true, false);
	end
	
	if(group == 0) then
		if (w1_add_user.support_pb == true) then
			local pos_xywh = {"s_add1user_t_backup_xywh", "s_add1user_cap_backup_xywh", "s_add1user_t_sysmain_xywh","s_add1user_cap_sysmain_xywh"};
			local sid = cwnd.t_backup.id;		
			local eid = cwnd.cap_sysmain.id;
			for i = sid, eid do
				local pos = SIZE(pos_xywh[i - sid + 1]);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
			end	
		else
			local pos_xywh = {"s_add1user_t_sysmain_xywh","s_add1user_cap_sysmain_xywh"};
			local sid = cwnd.t_sysmain.id;		
			local eid = cwnd.cap_sysmain.id;
			for i = sid, eid do
				local pos = SIZE(pos_xywh[i - sid + 1]);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
			end	
		end
	end	
	
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

local get_listselect = function(top, win_id)
	local checklist = {};
	local param = b_wnd_ex.get_selecelist(top, win_id);
	for i=1, channel_num do
		checklist[i] = param['r'..i];
	end
	return checklist;
end

local get_private = function(top, groupstr)
	local getcheck = function(id)
		return b_wnd_ex.get_check(top, id);
	end
	local cwnd = w1_add_user.dlg;
	local live, livelist, ptz, ptzlist, playback, playbacklist,
		channel, channellist,  face_recongition, facelist, thermal, thermallist, device, system, backup, backuplist;
			
	live = getcheck(cwnd.t_live.id);
	if(live) then
		livelist = get_listselect(top, cwnd.livelist.id);
	end	
	playback = getcheck(cwnd.t_play.id);
	if(playback) then
		playbacklist = get_listselect(top, cwnd.playlist.id);
	end
	backup = getcheck(cwnd.t_backup.id);
	if(backup) then
		backuplist = get_listselect(top, cwnd.backuplist.id);
	end
	
	if(groupstr == 'Administrators') then
		ptz = getcheck(cwnd.t_ptz.id);
		if(ptz) then
			ptzlist = get_listselect(top, cwnd.ptzlist.id);
		end
		channel = getcheck(cwnd.t_chm.id);
		if(channel) then
			channellist = get_listselect(top, cwnd.chlist.id);
		end	
		face_recongition = getcheck(cwnd.t_face_recognition.id);
		if(face_recongition) then
			facelist = get_listselect(top, cwnd.facelist.id);
		end	
		thermal = getcheck(cwnd.t_thermal.id);
		if(thermal) then
			thermallist = get_listselect(top, cwnd.thermallist.id);
		end		
		device = getcheck(cwnd.t_dev.id);	
		system = getcheck(cwnd.t_sys.id);
	elseif(groupstr == 'Operator') then
		ptz = getcheck(cwnd.t_ptz.id);
		if(ptz) then
			ptzlist = get_listselect(top, cwnd.ptzlist.id);
		end
		system = getcheck(cwnd.t_sys.id);
	elseif(groupstr == 'Media user') then
		
	end
	
	local private = {};
	if(live) then
		private.live_video = {};
		private.live_video.hasdeviceflag = true;
		private.live_video.channellist = livelist;
	end
	if(ptz) then
		private.ptz_control = {};
		private.ptz_control.hasdeviceflag = true;
		private.ptz_control.channellist = ptzlist;
	end
	if(playback) then
		private.playback = {};
		private.playback.hasdeviceflag = true;
		private.playback.channellist = playbacklist;
	end
	if(channel) then
		private.channel_manager = {};
		private.channel_manager.hasdeviceflag = true;
		private.channel_manager.channellist = channellist;
	end
	if(face_recongition) then
		private.face_recognition = {};
		private.face_recognition.hasdeviceflag = true;
		private.face_recognition.channellist = facelist;
	end
	if(thermal) then
		private.thermal = {};
		private.thermal.hasdeviceflag = true;
		private.thermal.channellist = thermallist;
	end
	if(device) then
		private.device_manager = {};
		private.device_manager.hasdeviceflag = false;	
	end
	if(system) then
		private.systerm_config = {};
		private.systerm_config.hasdeviceflag = false;	
	end
	if(backup) then
		private.backup = {};
		private.backup.hasdeviceflag = true;
		private.backup.channellist = backuplist;
	end

	return private;
end

local  upate_list = function(top, groupstr)
	
	local getcheck = function(id)
		return b_wnd_ex.get_check(top, id);
	end
	local cwnd = w1_add_user.dlg;
	local  livelist, ptzlist, playbacklist, channellist, facelist, thermallist, backuplist;
	
	local group = b_wnd_ex.get_text(top, cwnd.t_group.id);	
		
	
	livelist = get_listselect(top, cwnd.livelist.id);
	local selected = 0;
	for i=1,#livelist do
		if(1 == livelist[i])then
			selected = selected + 1;
		end
	end
	if(0 == selected)then
		b_wnd_ex.set_check(top,cwnd.t_live.id, false, false);
	else
		b_wnd_ex.set_check(top,cwnd.t_live.id, true, false);
	end 
	
	playbacklist = get_listselect(top, cwnd.playlist.id);
	selected = 0;
	for i=1,#playbacklist do
		if(1 == playbacklist[i])then
			selected = selected + 1;
		end
	end
	if(0 == selected)then
		b_wnd_ex.set_check(top,cwnd.t_play.id, false, false);
	else
		b_wnd_ex.set_check(top,cwnd.t_play.id, true, false);
	end 

	bakuplist = get_listselect(top, cwnd.backuplist.id);
	selected = 0;
	for i=1,#bakuplist do
		if(1 == bakuplist[i])then
			selected = selected + 1;
		end
	end
	if(0 == selected)then
		b_wnd_ex.set_check(top,cwnd.t_backup.id, false, false);
	else
		b_wnd_ex.set_check(top,cwnd.t_backup.id, true, false);
	end 
	
	if(groupstr == 'Administrators') then
		
		ptzlist = get_listselect(top, cwnd.ptzlist.id);
		selected = 0;
		for i=1,#ptzlist do
			if(1 == ptzlist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_ptz.id, false, false);
		else
			b_wnd_ex.set_check(top,cwnd.t_ptz.id, true, false);
		end 

		channellist = get_listselect(top, cwnd.chlist.id);
		selected = 0;
		for i=1,#channellist do
			if(1 == channellist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_chm.id, false, false);
		else
			b_wnd_ex.set_check(top,cwnd.t_chm.id, true, false);
		end 
		
		
		facelist = get_listselect(top, cwnd.facelist.id);
		selected = 0;
		for i=1,#facelist do
			if(1 == facelist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_face_recognition.id, false, false);
		else
			b_wnd_ex.set_check(top,cwnd.t_face_recognition.id, true, false);
		end  
		
		thermallist = get_listselect(top, cwnd.thermallist.id);
		selected = 0;
		for i=1,#thermallist do
			if(1 == thermallist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_thermal.id, false, false);
		else
			b_wnd_ex.set_check(top,cwnd.t_thermal.id, true, false);
		end  
	elseif(groupstr == 'Operator') then
		ptzlist = get_listselect(top, cwnd.ptzlist.id);
		selected = 0;
		for i=1,#ptzlist do
			if(1 == ptzlist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_ptz.id, false, false);
		else
			b_wnd_ex.set_check(top,cwnd.t_ptz.id, true, false);
		end 
	
	elseif(groupstr == 'Media user') then
		
	end
	b_dlg.dlg_set_redraw(top)
end

local set_private = function(top, private)
	local setcheck = function(id, status)
		b_wnd_ex.set_check(top, id, status, false);
	end
	
	local set_selecelist = function(id, list)
		local checktab = {};
		local flag = true;
		for i=1, channel_num do
			if(list[i] == 0) then
				checktab[i] = false;
				flag = false;
			else
				checktab[i] = true;
			end
		end
		if flag == false then
			b_wnd_ex.set_first_checkall(top, id, false, false);
		end
		b_wnd_ex.set_selecelist(top, id, checktab, false);
	end
	
	local clear_selecelist = function(id)
		local checktab = {};	
		for i=1, channel_num do
			checktab[i] = false;
		end
		b_wnd_ex.set_first_checkall(top, id, false, false);
		b_wnd_ex.set_selecelist(top, id, checktab, false);
	end
	
	local cwnd = w1_add_user.dlg;
	
	if(private.live_video == nil) then
		setcheck(cwnd.t_live.id, false);
		clear_selecelist(cwnd.livelist.id);
	else
		setcheck(cwnd.t_live.id, true);
		set_selecelist(cwnd.livelist.id, private.live_video.channellist);
	end
	if(private.ptz_control == nil) then
		setcheck(cwnd.t_ptz.id, false);
		clear_selecelist(cwnd.ptzlist.id);
	else
		setcheck(cwnd.t_ptz.id, true);
		set_selecelist(cwnd.ptzlist.id, private.ptz_control.channellist);
	end
	
	if(private.playback == nil) then
		setcheck(cwnd.t_play.id, false);
		clear_selecelist(cwnd.playlist.id);
	else
		setcheck(cwnd.t_play.id, true);
		set_selecelist(cwnd.playlist.id, private.playback.channellist);
	end
	
	if(private.channel_manager == nil) then
		setcheck(cwnd.t_chm.id, false);
		clear_selecelist(cwnd.chlist.id);
	else
		setcheck(cwnd.t_chm.id, true);
		set_selecelist(cwnd.chlist.id, private.channel_manager.channellist);
	end
	
	if(private.face_recognition == nil) then
		setcheck(cwnd.t_face_recognition.id, false);
		clear_selecelist(cwnd.facelist.id);
	else
		setcheck(cwnd.t_face_recognition.id, true);
		set_selecelist(cwnd.facelist.id, private.face_recognition.channellist);
	end
	
	if(private.thermal == nil) then
		setcheck(cwnd.t_thermal.id, false);
		clear_selecelist(cwnd.thermallist.id);
	else
		setcheck(cwnd.t_thermal.id, true);
		set_selecelist(cwnd.thermallist.id, private.thermal.channellist);
	end	
	
	if(private.device_manager == nil) then
		setcheck(cwnd.t_dev.id, false);
	else
		setcheck(cwnd.t_dev.id, true);
	end
	
	if(private.systerm_config == nil) then
		setcheck(cwnd.t_sys.id, false);
	else
		setcheck(cwnd.t_sys.id, true);
	end
	if(private.backup == nil) then
		setcheck(cwnd.t_backup.id, false);
		clear_selecelist(cwnd.backuplist.id);
	else
		setcheck(cwnd.t_backup.id, true);
		set_selecelist(cwnd.backuplist.id, private.backup.channellist);
	end	
	
	return 0;
	
end

local is_change = function(top)
	local param = b_wnd.get_wnd_data(top);
	
	channel_num = global_val.get_channelnum();
	local cwnd = w1_add_user.dlg;
	
	if(w1_add_user.edit_type == 1) then	--Ǳ༭û,Ҫֵ
		local data = w1_add_user.data['user'.. w1_add_user.sel];
		if b_wnd_ex.get_text(top, cwnd.t_name.id) ~= data.username then
			return true
		end	
		if b_wnd_ex.get_password(top, cwnd.t_pass.id) ~= data.password then
			return true
		end
		if b_wnd_ex.get_password(top, cwnd.t_confirm.id) ~= data.password then
			return true
		end
		
		if(data.groupname == 'Administrators') then
			if b_wnd_ex.get_sel(top, cwnd.t_group.id) ~= 0 then
				return true
			end
		elseif(data.groupname == 'Operator') then
			if b_wnd_ex.get_sel(top, cwnd.t_group.id) ~= 1 then
				return true
			end
		elseif(data.groupname == 'Media user') then
			if b_wnd_ex.get_sel(top, cwnd.t_group.id) ~= 2 then
				return true
			end
		end			
		
		if(data.pwdtimeout == '0d') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 0 then
				return true
			end
		elseif(data.pwdtimeout == '1d') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 1 then
				return true
			end
		elseif(data.pwdtimeout == '2d') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 2 then
				return true
			end			
		elseif(data.pwdtimeout == '3d') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 3 then
				return true
			end
		elseif(data.pwdtimeout == '1w') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 4 then
				return true
			end
		elseif(data.pwdtimeout == '2w') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 5 then
				return true
			end
		elseif(data.pwdtimeout == '3w') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 6 then
				return true
			end		
		elseif(data.pwdtimeout == '1m') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 7 then
				return true
			end
		elseif(data.pwdtimeout == '2m') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 8 then
				return true
			end	
		elseif(data.pwdtimeout == '3m') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 9 then
				return true
			end			
		elseif(data.pwdtimeout == '6m') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 10 then
				return true
			end
		elseif(data.pwdtimeout == '1y') then
			if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 11 then
				return true
			end
		else
			assert(false);
		end
		local get_selecelist = function(id, list)
			local checktab = b_wnd_ex.get_selecelist(top, id);
			for i=1, channel_num do
				if(list[i] == 0) then
					if checktab['r'..i] ~= 0 then
						return true
					end
				else
					if checktab['r'..i] ~= 1 then
						return true
					end
				end
			end
			return false
		end

		local cwnd = w1_add_user.dlg;
		if(data.validtime == 0) then
			if(b_wnd_ex.get_check(top, cwnd.t_date_enable.id) ~= false)then
				return true
			end
		else
			if(b_wnd_ex.get_check(top, cwnd.t_date_enable.id) ~= true)then
				return true
			end
			local cur_date = b_wnd_ex.get_date(top, cwnd.t_date.id) 
			local time = os.time{year=cur_date.year, month=cur_date.month, day=cur_date.day, hour=0, min=0, sec=0}
			if data.validtime ~= time then
				return true
			end
		end	
		
		if(data.private.live_video == nil) then
			if(b_wnd_ex.get_check(top, cwnd.t_live.id) ~= false)then
				return true
			end
		else
			if(b_wnd_ex.get_check(top, cwnd.t_live.id) ~= true)then
				return true
			end
			if get_selecelist(cwnd.livelist.id, data.private.live_video.channellist) then
				return true
			end
		end
		if(data.private.ptz_control == nil) then
			if(b_wnd_ex.get_check(top, cwnd.t_ptz.id) ~= false)then
				return true
			end
		else
			if(b_wnd_ex.get_check(top, cwnd.t_ptz.id) ~= true)then
				return true
			end
			if get_selecelist(cwnd.ptzlist.id, data.private.ptz_control.channellist)then
				return true
			end
		end

		if(data.private.playback == nil) then
			if(b_wnd_ex.get_check(top, cwnd.t_play.id) ~= false)then
				return true
			end
		else
			if(b_wnd_ex.get_check(top, cwnd.t_play.id) ~= true)then
				return true
			end
			if get_selecelist(cwnd.playlist.id, data.private.playback.channellist)then
				return true
			end
		end

		if(data.private.channel_manager == nil) then
			if(b_wnd_ex.get_check(top, cwnd.t_chm.id) ~= false)then
				return true
			end
		else
			if(b_wnd_ex.get_check(top, cwnd.t_chm.id) ~= true)then
				return true
			end
			if get_selecelist(cwnd.chlist.id, data.private.channel_manager.channellist)then
				return true
			end
		end
		
		if (w1_add_user.support_face == true) then --֧
			if(data.private.face_recognition == nil) then
				if(b_wnd_ex.get_check(top, cwnd.t_face_recognition.id) ~= false)then
					return true
				end
			else
				if(b_wnd_ex.get_check(top, cwnd.t_face_recognition.id) ~= true)then
					return true
				end
				if get_selecelist(cwnd.facelist.id, data.private.face_recognition.channellist)then
					return true
				end
			end
		end
		
		if (w1_add_user.support_thermal == true) then --֧ȳ
			if(data.private.thermal == nil) then
				if(b_wnd_ex.get_check(top, cwnd.t_thermal.id) ~= false)then
					return true
				end
			else
				if(b_wnd_ex.get_check(top, cwnd.t_thermal.id) ~= true)then
					return true
				end
				if get_selecelist(cwnd.thermallist.id, data.private.thermal.channellist)then
					return true
				end
			end
		end		
		
		if(data.private.device_manager == nil) then
			if(b_wnd_ex.get_check(top, cwnd.t_dev.id) ~= false)then
				return true
			end
		else
			if(b_wnd_ex.get_check(top, cwnd.t_dev.id) ~= true)then
				return true
			end
		end

		if(data.private.systerm_config == nil) then
			if(b_wnd_ex.get_check(top, cwnd.t_sys.id) ~= false)then
				return true
			end
		else
			if(b_wnd_ex.get_check(top, cwnd.t_sys.id) ~= true)then
				return true
			end
		end
		
		if(data.private.backup == nil) then
			if(b_wnd_ex.get_check(top, cwnd.t_backup.id) ~= false)then
				return true
			end
		else
			if(b_wnd_ex.get_check(top, cwnd.t_backup.id) ~= true)then
				return true
			end
			if get_selecelist(cwnd.backuplist.id, data.private.backup.channellist)then
				return true
			end
		end
	else--û
		if b_wnd_ex.get_text(top, cwnd.t_name.id) ~= '' then
			return true
		end	
		if b_wnd_ex.get_password(top, cwnd.t_pass.id) ~= '' then
			return true
		end
		if b_wnd_ex.get_password(top, cwnd.t_confirm.id) ~= '' then
			return true
		end
		if b_wnd_ex.get_sel(top, cwnd.t_group.id) ~= 0 then
			return true
		end
		if b_wnd_ex.get_sel(top,cwnd.t_ch.id) ~= 0 then
			return true
		end
		if (b_wnd_ex.get_check(top,cwnd.t_date_enable.id) == true) then
			return true
		end	
		local get_selecelist = function(id)
			local checktab = b_wnd_ex.get_selecelist(top, id);
			for i=1, channel_num do
				if checktab['r'..i] ~= 1 then
					return true
				end
			end
			return false
		end

		if(b_wnd_ex.get_check(top, cwnd.t_live.id) ~= true)then
			return true
		end
		if get_selecelist(cwnd.livelist.id) then
			return true
		end
	
		if(b_wnd_ex.get_check(top, cwnd.t_ptz.id) ~= true)then
			return true
		end
		if get_selecelist(cwnd.ptzlist.id)then
			return true
		end

		if(b_wnd_ex.get_check(top, cwnd.t_play.id) ~= true)then
			return true
		end
		if get_selecelist(cwnd.playlist.id)then
			return true
		end

		if(b_wnd_ex.get_check(top, cwnd.t_chm.id) ~= true)then
			return true
		end
		if get_selecelist(cwnd.chlist.id)then
			return true
		end
		
		if (w1_add_user.support_face == true) then --֧
			if(b_wnd_ex.get_check(top, cwnd.t_face_recognition.id) ~= true)then
				return true
			end
			if get_selecelist(cwnd.facelist.id)then
				return true
			end
		end
		
		if (w1_add_user.support_thermal == true) then --֧ȳ
			if(b_wnd_ex.get_check(top, cwnd.t_thermal.id) ~= true)then
				return true
			end
			if get_selecelist(cwnd.thermallist.id)then
				return true
			end
		end
		
		if(b_wnd_ex.get_check(top, cwnd.t_dev.id) ~= true)then
			return true
		end

		if(b_wnd_ex.get_check(top, cwnd.t_sys.id) ~= true)then
			return true
		end	
		
		if(b_wnd_ex.get_check(top, cwnd.t_backup.id) ~= true)then
			return true
		end
		if get_selecelist(cwnd.backuplist.id)then
			return true
		end
	end
	return false
end

local save_change = function(param)
	local edituser = {};
	local cwnd = w1_add_user.dlg;
	local username = b_wnd_ex.get_text(param[1], cwnd.t_name.id);
	--ûϷԼ
	if(username == '') then--ûΪ
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_USERNAME_ILLEGAL'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	end
	if(w1_add_user.edit_type == 0) then--ǰû			
		if(username == w1_add_user.data.curuser) then--ǰûѴ
			b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_USER_EXIST'), false);
			b_dlg.dlg_set_redraw(param[1]);
			w1_add_user.save_check_illegal = true
			return 0;
		end	
	end
	local ret = string.find(username,'[ ]',1);
	if ret ~= nil then
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_USERNAME_VALID'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;		
	end
	--ϷԼ
	local password = b_wnd_ex.get_password(param[1], cwnd.t_pass.id);
	local rootname = G.get_root_user_name();

	--ȷϷԼ
	local confimpass = b_wnd_ex.get_password(param[1], cwnd.t_confirm.id);
	if(password ~= confimpass) then
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_PWD_NO_SAME'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	end
	
	local group = b_wnd_ex.get_text(param[1], cwnd.t_group.id);
	local changepass = b_wnd_ex.get_sel(param[1], cwnd.t_ch.id);
	if(changepass == 0) then
		edituser.pwdtimeoutstr = '0d';
		edituser.pwdtimeout = 0;
	elseif(changepass == 1) then
		edituser.pwdtimeoutstr = '1d';
		edituser.pwdtimeout = 1;
	elseif(changepass == 2) then
		edituser.pwdtimeoutstr = '2d';
		edituser.pwdtimeout = 2;
	elseif(changepass == 3) then
		edituser.pwdtimeoutstr = '3d';
		edituser.pwdtimeout = 3;
	elseif(changepass == 4) then
		edituser.pwdtimeoutstr = '1w';
		edituser.pwdtimeout = 7;
	elseif(changepass == 5) then
		edituser.pwdtimeoutstr = '2w';
		edituser.pwdtimeout = 14;
	elseif(changepass == 6) then
		edituser.pwdtimeoutstr = '3w';
		edituser.pwdtimeout = 21;
	elseif(changepass == 7) then
		edituser.pwdtimeoutstr = '1m';
		edituser.pwdtimeout = 30;
	elseif(changepass == 8) then
		edituser.pwdtimeoutstr = '2m';
		edituser.pwdtimeout = 60;
	elseif(changepass == 9) then
		edituser.pwdtimeoutstr = '3m';
		edituser.pwdtimeout = 90;
	elseif(changepass == 10) then
		edituser.pwdtimeoutstr = '6m';
		edituser.pwdtimeout = 180;
	elseif(changepass == 11) then
		edituser.pwdtimeoutstr = '1y';
		edituser.pwdtimeout = 365;
	end
	
	local private = get_private(param[1], group);
	edituser.cur_username = w1_add_user.data.curuser;
	edituser.username = username;
	edituser.password = password;
	edituser.groupname = group;
	edituser.private = private;
	
	local check_date = b_wnd_ex.get_check(param[1],cwnd.t_date_enable.id)
	if check_date then
		local cur_date = b_wnd_ex.get_date(param[1], cwnd.t_date.id) 
		local time = os.time{year=cur_date.year, month=cur_date.month, day=cur_date.day, hour=0, min=0, sec=0}
		edituser.validtime = time
	else
		edituser.validtime = 0
	end
	
	assert(w1_add_user.edit_type == 0 or w1_add_user.edit_type == 1);
	local ret;
	if(w1_add_user.edit_type == 0) then--ǰû,ûĽӿ
		ret = b_app_api.add_user(edituser);		
	elseif(w1_add_user.edit_type == 1) then--ǰǱ༭û,ñ༭ûĽӿ
		ret = b_app_api.modify_user(edituser);
	end
	local pwd_rule = b_app_api.get_cfg({'pwd_rule_info'}).pwd_rule_info
	local pwd_min_len = string.gsub(STR('LA_PWD_MIN_RULE'), '*' ,pwd_rule.pwd_min_len); 
	local pwd_max_len = string.gsub(STR('LA_PWD_MAX_RULE'), '*' ,pwd_rule.pwd_max_len); 
	if(ret == 0) then--ӳɹ,
		w1_add_user.okfunc_param[2] = w1_add_user.edit_type;
		w1_add_user.ok_func(w1_add_user.okfunc_param);
		return 0;
	elseif(ret == -519) then--볤С6
	
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, pwd_min_len, false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	elseif(ret == -520) then--ûѴ
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_USER_EXIST'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	elseif(ret == -521) then--ȼ
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_PWD_LOW'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	elseif(ret == -522) then--ȼ
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_PASSWORD_TIP'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;	
	elseif(ret == -541) then--ﵽû
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_USER_MAX'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	elseif(ret == -542) then --ַ֧
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_ROLE_NAME1'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	elseif(ret == -545) then 
		b_wnd_ex.set_text(param[1],cwnd.tipinfo.id,pwd_max_len,false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	elseif(ret == -546) then -- 
		b_wnd_ex.set_text(param[1],cwnd.tipinfo.id,STR('LA_PWD_RULE_TIP1'),false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	elseif(ret == -547) then -- 
		b_wnd_ex.set_text(param[1],cwnd.tipinfo.id,STR('LA_PWD_REQ_TIP'),false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	else--
		b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_USER_MAX'), false);
		b_dlg.dlg_set_redraw(param[1]);
		w1_add_user.save_check_illegal = true
		return 0;
	end	
end

local on_group = function(top, win_id, vmsg, x, y)
	if vmsg == b_ui_msg.msg_user_update_parent then
		local setchecktab = function(id, check)
			local checktab = {};	
			for i=1,channel_num do
				checktab[i] = check;
			end
			b_wnd_ex.set_selecelist(top, id, checktab, false);
		end
		local cwnd = w1_add_user.dlg;
		setchecktab(cwnd.livelist.id, true);
		setchecktab(cwnd.ptzlist.id, true);
		setchecktab(cwnd.playlist.id, true);
		setchecktab(cwnd.chlist.id, true);	
		setchecktab(cwnd.facelist.id, true);	
		setchecktab(cwnd.thermallist.id, true);	
		setchecktab(cwnd.backuplist.id, true);
		local t_idtab = {cwnd.t_live.id, cwnd.t_ptz.id, cwnd.t_play.id, 
						cwnd.t_chm.id, cwnd.t_dev.id, cwnd.t_sys.id, 
						cwnd.t_sysmain.id, cwnd.t_face_recognition.id, 
						cwnd.t_thermal.id, cwnd.t_backup.id};
		for i=1, #t_idtab do
			b_wnd_ex.set_check(top, t_idtab[i], true, false);
		end
		
		local sel = b_wnd_ex.get_sel(top, win_id);
		switch_group(top, sel, false);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_t_pri = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local setchecktab = function(id, check, redraw)
			local checktab = {};	
			for i=1,channel_num do
				checktab[i] = check;
			end
			b_wnd_ex.set_selecelist(top, id, checktab, redraw);
		end
		local cwnd = w1_add_user.dlg;
		local check = b_wnd_ex.get_check(top, win_id);
		
		if(win_id == cwnd.t_live.id) then
			setchecktab(cwnd.livelist.id, check, true);
		elseif(win_id == cwnd.t_ptz.id) then
			setchecktab(cwnd.ptzlist.id, check, true);
		elseif(win_id == cwnd.t_play.id) then
			setchecktab(cwnd.playlist.id, check, true);
		elseif(win_id == cwnd.t_chm.id) then
			setchecktab(cwnd.chlist.id, check, true);
		elseif(win_id == cwnd.t_face_recognition.id) then
			setchecktab(cwnd.facelist.id, check, true);			
		elseif(win_id == cwnd.t_thermal.id) then
			setchecktab(cwnd.thermallist.id, check, true);
		elseif(win_id == cwnd.t_backup.id) then
			setchecktab(cwnd.backuplist.id, check, true);
		end
	end
	return 0;
end

local on_pri = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local function settext(id, str)
			b_wnd_ex.set_text(top, id, str, false);
		end
		local cwnd = w1_add_user.dlg;
		local idtab = {cwnd.cap_live.id, cwnd.cap_ptz.id, cwnd.cap_play.id,
						cwnd.cap_chm.id, cwnd.cap_dev.id, cwnd.cap_sys.id,
						cwnd.cap_sysmain.id, cwnd.cap_face_recognition.id, 
						cwnd.cap_thermal.id, cwnd.cap_backup.id};
		for i=1, #idtab do
			b_wnd_ex.set_check(top, idtab[i], false, false);
		end
		b_wnd_ex.set_check(top, win_id, true, false);
		
		prilist_allhide(top, false);
		if( win_id == cwnd.cap_live.id ) then
			settext(cwnd.list_title.id, STR('LA_LIVE_PREVIEW') );
			b_wnd_ex.set_hide(top, cwnd.livelist.id, false, false);
		elseif( win_id == cwnd.cap_ptz.id ) then
			settext(cwnd.list_title.id, STR('LA_PTZ') );	
			b_wnd_ex.set_hide(top, cwnd.ptzlist.id, false, false);	
		elseif( win_id == cwnd.cap_play.id ) then	
			settext(cwnd.list_title.id, STR('LA_PLAYBACK_T') );
			b_wnd_ex.set_hide(top, cwnd.playlist.id, false, false);
		elseif( win_id == cwnd.cap_face_recognition.id ) then	
			settext(cwnd.list_title.id, STR('LA_AI_RECOGNITION') );
			b_wnd_ex.set_hide(top, cwnd.facelist.id, false, false);
		elseif( win_id == cwnd.cap_thermal.id ) then	
			settext(cwnd.list_title.id, STR('LA_THERMAL') );
			b_wnd_ex.set_hide(top, cwnd.thermallist.id, false, false);		
		elseif( win_id == cwnd.cap_chm.id ) then	
			settext(cwnd.list_title.id, STR('LA_CHANNEL_MANAGEMENT') );
			b_wnd_ex.set_hide(top, cwnd.chlist.id, false, false);
		elseif( win_id == cwnd.cap_dev.id ) then	
			settext(cwnd.list_title.id, STR('LA_DEVICE_MANAGE') );
		elseif( win_id == cwnd.cap_sys.id ) then	
			settext(cwnd.list_title.id, STR('LA_SYSTEM_MANAGEMENT') );
		elseif( win_id == cwnd.cap_sysmain.id ) then	
			settext(cwnd.list_title.id, STR('LA_SYSTEM_MAINTENANCE') );
		elseif( win_id == cwnd.cap_backup.id ) then
			settext(cwnd.list_title.id, STR('LA_RECORD_BACKUP') );
			b_wnd_ex.set_hide(top, cwnd.backuplist.id, false, true);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_livelist = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_add_user.dlg;
		local livelist = get_listselect(top, cwnd.livelist.id);
		local selected = 0;
		for i=1,#livelist do
			if(1 == livelist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_live.id, false, true);
		else
			b_wnd_ex.set_check(top,cwnd.t_live.id, true, true);
		end 
	end
	return 0;
end

local on_ptzlist = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_add_user.dlg;
		local ptzlist = get_listselect(top, cwnd.ptzlist.id);
		selected = 0;
		for i=1,#ptzlist do
			if(1 == ptzlist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_ptz.id, false, true);
		else
			b_wnd_ex.set_check(top,cwnd.t_ptz.id, true, true);
		end  
	end
	return 0;
end

local on_playlist = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_add_user.dlg;
		local playbacklist = get_listselect(top, cwnd.playlist.id);
		selected = 0;
		for i=1,#playbacklist do
			if(1 == playbacklist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_play.id, false, true);
		else
			b_wnd_ex.set_check(top,cwnd.t_play.id, true, true);
		end  
	end
	return 0;
end

local on_chlist = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_add_user.dlg;
		local channellist = get_listselect(top, cwnd.chlist.id);
		selected = 0;
		for i=1,#channellist do
			if(1 == channellist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_chm.id, false, true);
		else
			b_wnd_ex.set_check(top,cwnd.t_chm.id, true, true);
		end  
	end
	return 0;
end

local on_facelist = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_add_user.dlg;
		local facelist = get_listselect(top, cwnd.facelist.id);
		selected = 0;
		for i=1,#facelist do
			if(1 == facelist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_face_recognition.id, false, true);
		else
			b_wnd_ex.set_check(top,cwnd.t_face_recognition.id, true, true);
		end  
	end
	return 0;
end

local on_thermallist = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_add_user.dlg;
		local thermallist = get_listselect(top, cwnd.thermallist.id);
		selected = 0;
		for i=1,#thermallist do
			if(1 == thermallist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_thermal.id, false, true);
		else
			b_wnd_ex.set_check(top,cwnd.t_thermal.id, true, true);
		end  
	end
	return 0;
end

local on_backuplist = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_add_user.dlg;
		local backuplist = get_listselect(top, cwnd.backuplist.id);
		selected = 0;
		for i=1,#backuplist do
			if(1 == backuplist[i])then
				selected = selected + 1;
			end
		end
		if(0 == selected)then
			b_wnd_ex.set_check(top,cwnd.t_backup.id, false, true);
		else
			b_wnd_ex.set_check(top,cwnd.t_backup.id, true, true);
		end  
	end
	return 0;
end	

local on_close = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0;
end

local on_date_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_add_user.dlg
		local check = b_wnd_ex.get_check(top,cwnd.t_date_enable.id)
		if check then
			b_wnd_ex.set_hide(top,cwnd.t_date.id,false,true)
		else
			b_wnd_ex.set_hide(top,cwnd.t_date.id,true,true)
		end
	end
	return 0;
end

local on_ok_addedit = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
--		SAVE_TIME = 60;
		local edituser = {};
		local cwnd = w1_add_user.dlg;
		local username = b_wnd_ex.get_text(top, cwnd.t_name.id);
		--ûϷԼ
		if(username == '') then--ûΪ
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_USERNAME_ILLEGAL'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
		if(w1_add_user.edit_type == 0) then--ǰû			
			if(username == w1_add_user.data.curuser) then--ǰûѴ
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_USER_EXIST'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			end	
		end
		local ret = string.find(username,'[ ]',1);
		if ret ~= nil then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_USERNAME_VALID'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;		
		end
		--ϷԼ
		local password = b_wnd_ex.get_password(top, cwnd.t_pass.id);
		local rootname = G.get_root_user_name();
--[[		if(rootname ~= username)then  -- û
			local legal, level =w1_legal.check_password(password); 
			if(legal == 0) then	--Ҫ
			
			else
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_PASSWORD_ILLEGAL'), false);
				b_dlg.dlg_set_redraw(top);			
				return 0;
			end
		end--]]
		--ȷϷԼ
		local confimpass = b_wnd_ex.get_password(top, cwnd.t_confirm.id);
		if(password ~= confimpass) then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_PWD_NO_SAME'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
		
		local group = b_wnd_ex.get_text(top, cwnd.t_group.id);
		local changepass = b_wnd_ex.get_sel(top, cwnd.t_ch.id);
		if(changepass == 0) then
			edituser.pwdtimeoutstr = '0d';
			edituser.pwdtimeout = 0;
		elseif(changepass == 1) then
			edituser.pwdtimeoutstr = '1d';
			edituser.pwdtimeout = 1;
		elseif(changepass == 2) then
			edituser.pwdtimeoutstr = '2d';
			edituser.pwdtimeout = 2;
		elseif(changepass == 3) then
			edituser.pwdtimeoutstr = '3d';
			edituser.pwdtimeout = 3;
		elseif(changepass == 4) then
			edituser.pwdtimeoutstr = '1w';
			edituser.pwdtimeout = 7;
		elseif(changepass == 5) then
			edituser.pwdtimeoutstr = '2w';
			edituser.pwdtimeout = 14;
		elseif(changepass == 6) then
			edituser.pwdtimeoutstr = '3w';
			edituser.pwdtimeout = 21;
		elseif(changepass == 7) then
			edituser.pwdtimeoutstr = '1m';
			edituser.pwdtimeout = 30;
		elseif(changepass == 8) then
			edituser.pwdtimeoutstr = '2m';
			edituser.pwdtimeout = 60;
		elseif(changepass == 9) then
			edituser.pwdtimeoutstr = '3m';
			edituser.pwdtimeout = 90;
		elseif(changepass == 10) then
			edituser.pwdtimeoutstr = '6m';
			edituser.pwdtimeout = 180;
		elseif(changepass == 11) then
			edituser.pwdtimeoutstr = '1y';
			edituser.pwdtimeout = 365;
		end
		
		local private = get_private(top, group);
		edituser.cur_username = w1_add_user.data.curuser;
		edituser.username = username;
		edituser.password = password;
		edituser.groupname = group;
		edituser.private = private;
		
		local check_date = b_wnd_ex.get_check(top,cwnd.t_date_enable.id)
		if check_date then
			local cur_date = b_wnd_ex.get_date(top, cwnd.t_date.id) 
			local time = os.time{year=cur_date.year, month=cur_date.month, day=cur_date.day, hour=0, min=0, sec=0}
			edituser.validtime = time
		else
			edituser.validtime = 0
		end
		
		
		assert(w1_add_user.edit_type == 0 or w1_add_user.edit_type == 1);
		local ret;
		if(w1_add_user.edit_type == 0) then--ǰû,ûĽӿ
			ret = b_app_api.add_user(edituser);
			
		elseif(w1_add_user.edit_type == 1) then--ǰǱ༭û,ñ༭ûĽӿ
			ret = b_app_api.modify_user(edituser);
		end
		local pwd_rule = b_app_api.get_cfg({'pwd_rule_info'}).pwd_rule_info
		local pwd_min_len = string.gsub(STR('LA_PWD_MIN_RULE'), '*' ,pwd_rule.pwd_min_len); 
		local pwd_max_len = string.gsub(STR('LA_PWD_MAX_RULE'), '*' ,pwd_rule.pwd_max_len); 
		if(ret == 0) then--ӳɹ,
			b_dlg.end_modal(top);
			w1_add_user.okfunc_param[2] = w1_add_user.edit_type;
			w1_add_user.ok_func(w1_add_user.okfunc_param);
			return 0;
		elseif(ret == -519) then--λ6λ̫
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, pwd_min_len, false);
			b_dlg.dlg_set_redraw(top);
			return 0;		
		elseif(ret == -520) then--ûѴ
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_USER_EXIST'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		elseif(ret == -521) then--ȼ
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_PWD_LOW'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		elseif(ret == -522) then--ȼ
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_PASSWORD_TIP'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		elseif(ret == -542) then --ַ֧
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_ROLE_NAME1'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		elseif(ret == -545) then 
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,pwd_max_len,false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		elseif(ret == -546) then -- 
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_PWD_RULE_TIP1'),false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		elseif(ret == -547) then -- 
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_PWD_REQ_TIP'),false)
			b_dlg.dlg_set_redraw(top);
			return 0;
		else--
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_USER_MAX'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end	
	end
	return 0;
end		

local on_ok_del = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
--		SAVE_TIME = 60;
		local data  = w1_add_user.data;
		local curuser = data.curuser;
		local deluser = data['user'..w1_add_user.sel].username;
		local cwnd = w1_add_user.dlg;
		if(curuser == deluser) then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_DELETE_ITSELF'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
		
		local errornum = b_app_api.del_user({cur_user = curuser, del_user= deluser})
		if(errornum == 0) then	--ɾɹֱ˳,ִлص
			b_dlg.end_modal(top);
			w1_add_user.okfunc_param[2] = w1_add_user.edit_type;
			w1_add_user.ok_func(w1_add_user.okfunc_param);
		else--ɾʧ
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_DELETE_FAIL'), false);
			b_dlg.dlg_set_redraw(top);
		end
	end
	return 0;
end

local dlg = {
	attr 	= {xywh='s_adduser_xywh',},
	
	sub 	= {'titleimg', 'titlestr', 'titleclose', 
				'cap_name', 't_name', 'cap_pass', 't_pass',
				'cap_confirm', 't_confirm', 'cap_group', 't_group',
				'cap_ch', 't_ch','c_date','t_date','t_date_enable', 'hline1',
				't_live', 'cap_live', 't_ptz', 'cap_ptz',
				't_play', 'cap_play', 't_chm', 'cap_chm','t_face_recognition', 'cap_face_recognition', 
				't_thermal', 'cap_thermal', 't_dev', 'cap_dev', 't_sys', 'cap_sys',
				't_backup','cap_backup','t_sysmain', 'cap_sysmain',
				'hline2',
				'livelist', 'ptzlist', 'playlist', 'chlist','facelist','thermallist','backuplist',
				'list_title','hline3','tipinfo',
				'ok','cancel'},
	
	titleimg 	= {t='tt_picture',	id=id+1,xywh='s_adduser_titleimg_xywh', 
					t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_addcameera'}},
	
	titlestr	= {t='static', 	id=id+2,xywh='s_adduser_titlestr_xywh', 
					text='LA_ADD_USER',	font = 'f_grade5',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
								
	titleclose 	= {t='tt_button',id=id+3,xywh = 's_adduser_titleclose_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
					color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_txt_f'},
					color_f= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},cmd=on_close},
	
	cap_name	= {t='static', 	id=id+4,xywh='s_adduser_cap_name_xywh', 
					text='LA_USER_NAME', font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	t_name 		= {t='edit', 	id=id+5,xywh='s_adduser_t_name_xywh', 
					text='',	trans = false, 
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},		

	cap_pass	= {t='static', 	id=id+6,xywh='s_adduser_cap_pass_xywh', 
					text='LA_PASSWORD',font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	t_pass 		= {t='password', id=id+7,xywh='s_adduser_t_pass_xywh', 
					 password = '',guide_text='LA_PASSWORD',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},
	cap_confirm	= {t='static', 	id=id+8,xywh='s_adduser_cap_confirm_xywh', 
					text='LA_CONFIRM_PWD',font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	t_confirm 		= {t='password', id=id+9,xywh='s_adduser_t_confirm_xywh',
					 password = '',guide_text='LA_PASSWORD',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},
					
	cap_group	= {t='static', 	id=id+10,xywh='s_adduser_cap_group_xywh', 
					text='LA_GROUPS',font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	t_group 	= {t='combox', id=id+11,xywh='s_adduser_t_group_xywh', 
					items={'Administrators','Operator', 'Media user'},trans = false,
					cmd = on_group,
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
	cap_ch		= {t='static', 	id=id+12,xywh='s_adduser_cap_ch_xywh', 
					text='LA_CHANGE_PASSWORD_REMINDER',font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	t_ch 		= {t='combox', id=id+13,xywh='s_adduser_t_ch_xywh', 
					items={},trans = false,
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
	hline1		= {t='hline',	id=id+14,xywh='s_adduser_hline1_xywh'},
	
	t_live		= {t='check', id=id+15,xywh='s_adduser_t_live_xywh', check = true,
					cmd = on_t_pri,
					},
	cap_live	= {t='checkbutton', id=id+16,xywh='s_adduser_cap_live_xywh', 
					text='LA_LIVE_PREVIEW',align = b_ui.ALIGN.LEFT,font = 'f_grade6',
					cmd = on_pri,
					},					
	t_ptz		= {t='check', id=id+17,xywh='s_add1user_t_ptz_xywh', check = true,
					cmd = on_t_pri,
					},
	cap_ptz		= {t='checkbutton', id=id+18,xywh='s_add1user_cap_ptz_xywh', 
					text='LA_PTZ',align = b_ui.ALIGN.LEFT,font = 'f_grade6',
					cmd = on_pri,
					},			
	t_play		= {t='check', id=id+19,xywh='s_add1user_t_play_xywh', check = true,
					cmd = on_t_pri,
					},
	cap_play	= {t='checkbutton', id=id+20,xywh='s_add1user_cap_play_xywh', 
					text='LA_PLAYBACK_T',align = b_ui.ALIGN.LEFT,font = 'f_grade6',
					cmd = on_pri,
					},					
	t_chm		= {t='check', id=id+21,xywh='s_add1user_t_chm_xywh', check = true,
					cmd = on_t_pri,
					},
	cap_chm		= {t='checkbutton', id=id+22,xywh='s_add1user_cap_chm_xywh', 
					text='LA_CHANNEL_MANAGEMENT',align = b_ui.ALIGN.LEFT,font = 'f_grade6',
					cmd = on_pri,
					},	
	t_face_recognition	= {t='check', id=id+23,xywh='s_add1user_t_face_xywh', check = true,
					cmd = on_t_pri,
					},
	cap_face_recognition = {t='checkbutton', id=id+24,xywh='s_add1user_cap_face_xywh', 
					text='LA_AI_RECOGNITION',align = b_ui.ALIGN.LEFT,font = 'f_grade6',
					cmd = on_pri,
					},
	t_thermal	= {t='check', id=id+25,xywh='s_add1user_t_thermal_xywh', check = true,
					cmd = on_t_pri,
					},
	cap_thermal= {t='checkbutton', id=id+26,xywh='s_add1user_cap_thermal_xywh', 
					text='LA_THERMAL',align = b_ui.ALIGN.LEFT,font = 'f_grade6',
					cmd = on_pri,
					},				
	t_dev		= {t='check', id=id+27,xywh='s_add1user_t_dev_xywh', check = true,
					},
	cap_dev		= {t='checkbutton', id=id+28,xywh='s_add1user_cap_dev_xywh', 
					text='LA_DEVICE_MANAGE',align = b_ui.ALIGN.LEFT,font = 'f_grade6',
					cmd = on_pri,
					},					
	t_sys		= {t='check', id=id+29,xywh='s_add1user_t_sys_xywh', check = true,

					},
	cap_sys		= {t='checkbutton', id=id+30,xywh='s_add1user_cap_sys_xywh', 
					text='LA_SYSTEM_MANAGEMENT',align = b_ui.ALIGN.LEFT,font = 'f_grade6',
					cmd = on_pri,
					},
	t_backup	= {t='check', id=id+31,xywh='s_add1user_t_backup_xywh', check = true,
					cmd = on_t_pri,
					},
	cap_backup  = {t='checkbutton', id=id+32,xywh='s_add1user_cap_backup_xywh', 
					text='LA_BACKUP',align = b_ui.ALIGN.LEFT,font = 'f_grade6',
					cmd = on_pri,
					},
	t_sysmain	= {t='check', id=id+33,xywh='s_add1user_t_sysmain_xywh', check = true,

					},
	cap_sysmain = {t='checkbutton', id=id+34, xywh='s_add1user_cap_sysmain_xywh', 
					text='LA_SYSTEM_MAINTENANCE',align = b_ui.ALIGN.LEFT,font = 'f_grade6',
					cmd = on_pri,
					},
	hline2		= {t='hline',	id=id+35,xywh='s_add1user_hline2_xywh'},
	
	livelist	= {t='list',	id=id+36,	xywh='s_add1user_livelist_xywh', font = 'f_grade4',
					listattr = {8,2,b_ui.LISTATTR.FIRST_WIDGET_CHECK},
					columns_w = {50,264},cmd = on_livelist,
					},
	ptzlist		= {t='list',	id=id+37,	xywh='s_add1user_ptzlist_xywh', font = 'f_grade4',
					listattr = {8,2,b_ui.LISTATTR.FIRST_WIDGET_CHECK},
					columns_w = {50,264},cmd = on_ptzlist,
					},
	
	playlist	= {t='list',	id=id+38,	xywh='s_add1user_playlist_xywh', font = 'f_grade4',
					listattr = {8,2,b_ui.LISTATTR.FIRST_WIDGET_CHECK},
					columns_w = {50,264},cmd = on_playlist,
					},
	
	chlist		= {t='list',	id=id+39,	xywh='s_add1user_chlist_xywh', font = 'f_grade4',
					listattr = {8,2,b_ui.LISTATTR.FIRST_WIDGET_CHECK},
					columns_w = {50,264},cmd = on_chlist,
					},
	facelist	= {t='list',	id=id+40,	xywh='s_add1user_facelist_xywh', font = 'f_grade4',
					listattr = {8,2,b_ui.LISTATTR.FIRST_WIDGET_CHECK},
					columns_w = {50,264},cmd = on_facelist,
					},
	thermallist	= {t='list',	id=id+41,	xywh='s_add1user_thermallist_xywh', font = 'f_grade4',
					listattr = {8,2,b_ui.LISTATTR.FIRST_WIDGET_CHECK},
					columns_w = {50,264},cmd = on_thermallist,
					},	
	backuplist	= {t='list',	id=id+42,	xywh='s_add1user_backuplist_xywh', font = 'f_grade4',
					listattr = {8,2,b_ui.LISTATTR.FIRST_WIDGET_CHECK},
					columns_w = {50,264},cmd = on_backuplist,
					},
					
	list_title	= {t='static', 	id=id+43,	xywh='s_add1user_list_title_xywh', font='f_grade5',
					color = {'c_cfg_bk', 'c_cfg_bk', 'c_popdlg_text'},
					},

	tipinfo		= {t='static',id=id+44,	xywh='s_add1user_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
					},

	hline3		= {t='hline',	id=id+45,xywh='s_adduser_hline3_xywh'},

	ok 			= {t='button',	id=id+46,	xywh='s_add1user_ok_xywh', 		text='LA_OK',
					cmd=on_ok_addedit,font='f_grade6',
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	cancel  	= {t='button',	id=id+47,	xywh='s_add1user_cancel_xywh',		text='LA_CANCEL',
					cmd=on_close,font='f_grade6',
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
					},		
	c_date 		= {t='static',	id=id+48,	xywh='c_date_xywh',	text='LA_PASS_EXPIRE',color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},},
	t_date 		= {t='date_edit',id=id+49,	xywh='t_date_xywh',	date={0,2020,1,1, true},trans = false, },
	t_date_enable = {t='tt_check',id=id+50, xywh='t_date_enable_xywh',color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
	t_imgs = {b_ui.ALIGN.LEFT,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd=on_date_enable},
}

local dlg_del = {
	attr 	= {xywh='s_msgbox_xywh',},
	sub 	= {'msg', 'tipinfo','ok', 'cancel'},
	
	msg	 	= {t='static',	id=id+2,	xywh='s_msgbox_msg_xywh',	
			text='LA_CONFIRM_DELETE',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},

	tipinfo	= {t='static',id=id+3,	xywh='s_msgbox_tipinfo_xywh',	text='', 
			font='f_grade7', trans = false,
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
			},
			
	hline	= {t='hline',	id=id+4,	xywh='s_msgbox_hline_xywh'},
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
			
	ok		= {t='button',	id=id+5,	xywh='s_msgbox_ok_xywh',	text='LA_OK',	font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok_del},
	cancel	= {t='button',	id=id+6,	xywh='s_msgbox_cancel_xywh',text='LA_CANCEL',font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
				cmd=on_close},		
}

w1_add_user.set_data = function(data,date_fmt)
	w1_add_user.data = data;
	w1_add_user.date_fmt = date_fmt
	return 0;
end

w1_add_user.clear_data = function()
	w1_add_user.data = nil;
	w1_add_user.ok_func = nil;--okťص	
	w1_add_user.okfunc_param = nil; --okťص

	return 0;
end

w1_add_user.on_create = function(top)
	w1_add_user.top = top;
	return 0;
end

w1_add_user.on_destroy = function(top)
	w1_add_user.top = nil;
	w1_add_user.dlg = nil;
	return 0;
end

w1_add_user.on_pre_show = function(top)
	local setsel = function(id, sel)
		b_wnd_ex.set_sel(top, id, sel, false);
	end
	local setdisable = function(id, disable)
		b_wnd_ex.set_disable(top, id, disable, false);
	end
	
	w1_add_user.support_face = global_val.get_support_face_attr();
	w1_add_user.support_thermal = global_val.get_support_thermal_attr();
	w1_add_user.support_pb = global_val.get_playback_support();
	
	local param = b_wnd.get_wnd_data(top);
	local paramdata;
	if(param ~= nil)then
		paramdata = cjson.decode(param);
		assert(paramdata.opera == 1 or paramdata.opera == 2);
		if(paramdata.opera == 1) then
			w1_add_user.edit_type = 1;--ǵǰǱ༭
		elseif(paramdata.opera == 2) then
			w1_add_user.edit_type = 2;--ǵǰɾ
		end
		local sel = math.modf((paramdata.sel + 1) / 1)
		w1_add_user.sel = sel;--¼ǰк
	else
		w1_add_user.edit_type = 0;--ǵǰ
	end
	
	if(w1_add_user.edit_type == 0 or w1_add_user.edit_type == 1) then
		w1_add_user.dlg = dlg;
		if(w1_add_user.edit_type == 0) then
			--޸ıͼ
			dlg.titlestr.text = 'LA_ADD_USER';
			dlg.titleimg.t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_addcameera'};
		elseif(w1_add_user.edit_type == 1) then
			dlg.titlestr.text = 'LA_EDIT_USER';
			dlg.titleimg.t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_editcameera'}	
		end
		b_parser(top, w1_add_user.dlg);	
		channel_num = global_val.get_channelnum();
		local cwnd = w1_add_user.dlg;
		local items = {STR('LA_NEVER'), '1 '..STR('LA_DAY'), '2 '..STR('LA_DAY'),'3 '..STR('LA_DAY'),
						'1 '..STR('LA_WEEK'), '2 '..STR('LA_WEEK'),'3 '..STR('LA_WEEK'),
						'1 '..STR('LA_MONTH'), '2 '..STR('LA_MONTH'),'3 '..STR('LA_MONTH'),
						'6 '..STR('LA_MONTH'), '1 '..STR('LA_YEAR'),
						};
		b_wnd_ex.set_items(top, cwnd.t_ch.id, items, false);
		
		b_wnd_ex.set_first_checkall(top, cwnd.livelist.id, true, false);
		b_wnd_ex.set_first_checkall(top, cwnd.ptzlist.id, true, false);
		b_wnd_ex.set_first_checkall(top, cwnd.playlist.id, true, false);
		b_wnd_ex.set_first_checkall(top, cwnd.chlist.id, true, false);		
		b_wnd_ex.set_first_checkall(top, cwnd.facelist.id, true, false);	
		b_wnd_ex.set_first_checkall(top, cwnd.thermallist.id, true, false);		
		b_wnd_ex.set_first_checkall(top, cwnd.backuplist.id, true, false);		
		b_wnd_ex.set_text(top, cwnd.list_title.id, STR('LA_LIVE_PREVIEW'), false);
		local chlist = {
				'', STR('LA_CHANNEL')
			}
		b_wnd_ex.set_title_texts(top, cwnd.livelist.id, chlist, false);
		b_wnd_ex.set_title_texts(top, cwnd.ptzlist.id, chlist, false);
		b_wnd_ex.set_title_texts(top, cwnd.playlist.id, chlist, false);
		b_wnd_ex.set_title_texts(top, cwnd.chlist.id, chlist, false);
		b_wnd_ex.set_title_texts(top, cwnd.facelist.id, chlist, false);
		b_wnd_ex.set_title_texts(top, cwnd.thermallist.id, chlist, false);		
		b_wnd_ex.set_title_texts(top, cwnd.backuplist.id, chlist, false);
		
		local list_w = {};
		for i=1,2 do
			local str = 's_add1user_list_w'..math.floor(i/1);
			list_w[i] = SIZE(str)[1];
		end
		b_wnd_ex.columns_w(top, cwnd.livelist.id, list_w, false);
		b_wnd_ex.columns_w(top, cwnd.ptzlist.id, list_w, false);
		b_wnd_ex.columns_w(top, cwnd.playlist.id, list_w, false);
		b_wnd_ex.columns_w(top, cwnd.chlist.id, list_w, false);
		b_wnd_ex.columns_w(top, cwnd.facelist.id, list_w, false);
		b_wnd_ex.columns_w(top, cwnd.thermallist.id, list_w, false);
		b_wnd_ex.columns_w(top, cwnd.backuplist.id, list_w, false);

		
		local searchlist = {};
		searchlist.item_total = channel_num;
		for i=1,searchlist.item_total do
			searchlist['idx'..i] = nil;
			searchlist['idx'..i] ={};
			searchlist['idx'..i] = {i-1, true, '', 
				'CH'..i};
		end

		b_wnd_ex.set_listdata(top, cwnd.livelist.id, searchlist, false);
		b_wnd_ex.set_listdata(top, cwnd.ptzlist.id, searchlist, false);
		b_wnd_ex.set_listdata(top, cwnd.playlist.id, searchlist, false);
		b_wnd_ex.set_listdata(top, cwnd.chlist.id, searchlist, false);
		b_wnd_ex.set_listdata(top, cwnd.facelist.id, searchlist, false);
		b_wnd_ex.set_listdata(top, cwnd.thermallist.id, searchlist, false);
		b_wnd_ex.set_listdata(top, cwnd.backuplist.id, searchlist, false);

		b_wnd_ex.set_hide(top,cwnd.t_date.id,true,false)
		local date_d = {}
		date_d[1] = w1_add_user.date_fmt
		date_d[2] = tonumber(os.date("%Y", tonumber(os.date())))
		date_d[3] = tonumber(os.date("%m", tonumber(os.date())))
		date_d[4] = tonumber(os.date("%d", tonumber(os.date())))
		b_wnd_ex.set_date (top, cwnd.t_date.id, date_d, false)
		if(w1_add_user.edit_type == 1) then	--Ǳ༭û,Ҫֵ
			local data = w1_add_user.data['user'.. w1_add_user.sel];
			
			b_wnd_ex.set_text(top, cwnd.t_name.id, data.username, false);		
			b_wnd_ex.set_password(top, cwnd.t_pass.id, data.password, false);
			b_wnd_ex.set_password(top, cwnd.t_confirm.id, data.password, false);
			b_wnd_ex.set_enableselect(top, cwnd.t_pass.id, false, false);
			b_wnd_ex.set_enableselect(top, cwnd.t_confirm.id, false, false);
			
			b_wnd_ex.set_hide(top,cwnd.c_date.id,false,false)
			b_wnd_ex.set_hide(top,cwnd.t_date.id,false,false)
			b_wnd_ex.set_hide(top,cwnd.t_date_enable.id,false,false)
			
			local date = {}
			date[1] = w1_add_user.date_fmt
			date[2] = tonumber(os.date("%Y", data.validtime))
			date[3] = tonumber(os.date("%m", data.validtime))
			date[4] = tonumber(os.date("%d", data.validtime))
			if data.validtime==0 then
				b_wnd_ex.set_hide(top,cwnd.t_date.id,true,false)
				b_wnd_ex.set_check(top,cwnd.t_date_enable.id,false,false)
			else
				b_wnd_ex.set_hide(top,cwnd.t_date.id,false,false)
				b_wnd_ex.set_check(top,cwnd.t_date_enable.id,true,false)
				b_wnd_ex.set_date (top, cwnd.t_date.id, date, false)--Ч
			end
						
			if(data.groupname == 'Administrators') then
				setsel(cwnd.t_group.id, 0);
				switch_group(top, 0, false);
			elseif(data.groupname == 'Operator') then
				setsel(cwnd.t_group.id, 1);
				switch_group(top, 1, false);
			elseif(data.groupname == 'Media user') then	
				setsel(cwnd.t_group.id, 2);
				switch_group(top, 2, false);
			else --û
				switch_group(top, 0, false);	
				--ʾ豸άȨ
				b_wnd_ex.set_hide(top, cwnd.t_sysmain.id, false, false);
				b_wnd_ex.set_hide(top, cwnd.cap_sysmain.id, false, false);
			end			
			
			if(data.pwdtimeout == '0d') then
				setsel(cwnd.t_ch.id, 0);
			elseif(data.pwdtimeout == '1d') then
				setsel(cwnd.t_ch.id, 1);
			elseif(data.pwdtimeout == '2d') then
				setsel(cwnd.t_ch.id, 2);			
			elseif(data.pwdtimeout == '3d') then
				setsel(cwnd.t_ch.id, 3);
			elseif(data.pwdtimeout == '1w') then
				setsel(cwnd.t_ch.id, 4);
			elseif(data.pwdtimeout == '2w') then
				setsel(cwnd.t_ch.id, 5);
			elseif(data.pwdtimeout == '3w') then
				setsel(cwnd.t_ch.id, 6);			
			elseif(data.pwdtimeout == '1m') then
				setsel(cwnd.t_ch.id, 7);
			elseif(data.pwdtimeout == '2m') then
				setsel(cwnd.t_ch.id, 8);	
			elseif(data.pwdtimeout == '3m') then
				setsel(cwnd.t_ch.id, 9);			
			elseif(data.pwdtimeout == '6m') then
				setsel(cwnd.t_ch.id, 10);
			elseif(data.pwdtimeout == '1y') then
				setsel(cwnd.t_ch.id, 11);
			else
				assert(false);
			end
			set_private(top, data.private);
			setdisable(cwnd.t_name.id, true);			
			--ǰ༭ûֻ޸벻޸Ȩ
			if(data.username == w1_add_user.data.curuser)then
				if(data.nGroupId == 1)then
					b_wnd_ex.set_text(top, cwnd.t_group.id, 'Super admin', false);	
					b_wnd_ex.set_hide(top,cwnd.c_date.id,true,false)
					b_wnd_ex.set_hide(top,cwnd.t_date.id,true,false)
					b_wnd_ex.set_hide(top,cwnd.t_date_enable.id,true,false)
				end
				
				setdisable(cwnd.t_pass.id, true);
				setdisable(cwnd.t_confirm.id, true);
				setdisable(cwnd.t_group.id, true);
				setdisable(cwnd.t_live.id, true);				
				setdisable(cwnd.t_ptz.id, true);
				setdisable(cwnd.t_play.id, true);
				setdisable(cwnd.t_chm.id, true);		
				setdisable(cwnd.t_dev.id, true);
				setdisable(cwnd.t_sys.id, true);
				setdisable(cwnd.t_sysmain.id, true);
				setdisable(cwnd.t_backup.id, true);
				setdisable(cwnd.t_face_recognition.id, true);
				setdisable(cwnd.t_thermal.id, true);
				setdisable(cwnd.livelist.id, true);
				setdisable(cwnd.ptzlist.id, true);		
				setdisable(cwnd.playlist.id, true);
				setdisable(cwnd.chlist.id, true);
				setdisable(cwnd.facelist.id, true);
				setdisable(cwnd.thermallist.id, true);
				setdisable(cwnd.backuplist.id, true);
			end
		else--û
			--豸άȨ
			b_wnd_ex.set_hide(top, cwnd.t_sysmain.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_sysmain.id, true, false);
			switch_group(top, 0, false);
		end
		prilist_allhide(top, false);
		
		b_wnd_ex.set_check(top, cwnd.cap_live.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.livelist.id, false, false);
	elseif(w1_add_user.edit_type == 2) then
		w1_add_user.dlg = dlg_del;
		b_parser(top, w1_add_user.dlg);
	end
	
	if (w1_add_user.support_face ~= true and w1_add_user.edit_type ~= 2) then --֧
		local cwnd = w1_add_user.dlg;
		if(w1_add_user.edit_type == 0) then	
			b_wnd_ex.set_check(top, cwnd.t_face_recognition.id, false, false);	
		end
		b_wnd_ex.set_hide(top, cwnd.t_face_recognition.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_face_recognition.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.facelist.id, true, false);
		
		if (w1_add_user.support_thermal ~= true and w1_add_user.edit_type ~= 2) then --֧ȳ
			local cwnd = w1_add_user.dlg;
			if(w1_add_user.edit_type == 0) then	
				b_wnd_ex.set_check(top, cwnd.t_thermal.id, false, false);	
			end
			b_wnd_ex.set_hide(top, cwnd.t_thermal.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_thermal.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.thermallist.id, true, false);
		else	
			local pos1 = SIZE('s_add1user_cap_ptz_xywh');		
			local pos2 = SIZE('s_add1user_t_play_xywh');
			local item_h = pos2[2] - pos1[2];	
			local pos = b_wnd.get_wnd_a_rect(top, cwnd.cap_thermal.id);
			b_wnd_ex.move_ex(top, cwnd.cap_thermal.id, {pos[1], pos[2] - item_h, pos[3],pos[4]}, false);
			pos = b_wnd.get_wnd_a_rect(top, cwnd.t_thermal.id);
			b_wnd_ex.move_ex(top, cwnd.t_thermal.id,  {pos[1], pos[2] - item_h, pos[3],pos[4]}, false);
		end
	else
		if (w1_add_user.support_thermal ~= true and w1_add_user.edit_type ~= 2) then --֧ȳ
			local cwnd = w1_add_user.dlg;
			if(w1_add_user.edit_type == 0) then	
				b_wnd_ex.set_check(top, cwnd.t_thermal.id, false, false);	
			end
			b_wnd_ex.set_hide(top, cwnd.t_thermal.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_thermal.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.thermallist.id, true, false);
		end	
	end
	
	return 0;
end

w1_add_user.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'));
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1);
	b_wnd.end_job(top);
	return 0;
end

w1_add_user.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if(b_ui.RBUTTONCLK == vmsg) then
		local ret = false
		w1_add_user.save_check_illegal = false;		
		if(w1_add_user.edit_type == 0 or w1_add_user.edit_type == 1) then
			ret = is_change(top);
		end
		if ret == true then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_WANT_SAVE'), true, true, false,STR('LA_YES'), STR('LA_BAD'));
			w1_msgbox.set_func(save_change,{top}, nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			w1_msgbox.set_func(nil,nil, nil,nil);
		end
		if w1_add_user.save_check_illegal == true then
			return 0;
		end
		b_dlg.end_modal(top);
	elseif (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		local cwnd = w1_add_user.dlg;
		local group = b_wnd_ex.get_text(top, cwnd.t_group.id);
		upate_list(top, group);
		local test =0 ; 
	end
	return 0;
end

return w1_add_user;




