-- UIʹõȷȡԻ
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_privacy.edit_phone_filter_id;
local cjson 	= require("cjson")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_legal 	= require("wnd.w1_util.w1_legal")

local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")

local w1_edit_phone_filter = {
	t = w1_key.DLG_MSG_EDIT_PHONE_FILTER,
	top = nil,
	dlg = nil,
	listdata = nil,
	addflag,
	save_check_illegal,
	sel,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_edit_phone_filter.s_768 =
{
	s_edit_phone_filter_xywh = {338,284,346,227},
	s_edit_phone_filter_t_remark_xywh = {132,99,163,28},
	s_edit_phone_filter_ok_xywh = {197,177,64,27},
	s_edit_phone_filter_tipinfo_xywh = {26,142,266,12},
	s_edit_phone_filter_cancel_xywh = {272,177,64,27},
	s_edit_phone_filter_cap_remark_xywh = {26,99,106,28},
	s_edit_phone_filter_cap_phone_number_xywh = {26,56,106,28},
	s_edit_phone_filter_t_phone_number_xywh = {132,56,163,28},
	s_edit_phone_filter_hline_xywh = {8,163,330,1},
};

w1_edit_phone_filter.s_1280 = 
{
	s_edit_phone_filter_xywh={315,400,650,320},
	s_edit_phone_filter_cap_phone_number_xywh= {50,80,200,40},
	s_edit_phone_filter_t_phone_number_xywh= {250,80,300,40},
	s_edit_phone_filter_cap_remark_xywh= {50,140,200,40},
	s_edit_phone_filter_t_remark_xywh= {250,140,300,40},
	s_edit_phone_filter_tipinfo_xywh= {50,200,500,18},
	s_edit_phone_filter_hline_xywh={15,230,620,1},
	s_edit_phone_filter_ok_xywh= {370,250,120,38},
	s_edit_phone_filter_cancel_xywh= {510,250,120,38},
}
w1_edit_phone_filter.s_1440 = 
{
	s_edit_phone_filter_xywh={395,310,650,320},
	s_edit_phone_filter_cap_phone_number_xywh= {50,80,200,40},
	s_edit_phone_filter_t_phone_number_xywh= {250,80,300,40},
	s_edit_phone_filter_cap_remark_xywh= {50,140,200,40},
	s_edit_phone_filter_t_remark_xywh= {250,140,300,40},
	s_edit_phone_filter_tipinfo_xywh= {50,200,500,18},
	s_edit_phone_filter_hline_xywh={15,230,620,1},
	s_edit_phone_filter_ok_xywh= {370,250,120,38},
	s_edit_phone_filter_cancel_xywh= {510,250,120,38},
}
w1_edit_phone_filter.s_1080p = 
{
	s_edit_phone_filter_xywh={635,400,650,320},
	s_edit_phone_filter_cap_phone_number_xywh= {50,80,200,40},
	s_edit_phone_filter_t_phone_number_xywh= {250,80,300,40},
	s_edit_phone_filter_cap_remark_xywh= {50,140,200,40},
	s_edit_phone_filter_t_remark_xywh= {250,140,300,40},
	s_edit_phone_filter_tipinfo_xywh= {50,200,500,18},
	s_edit_phone_filter_hline_xywh={15,230,620,2},
	s_edit_phone_filter_ok_xywh= {370,250,120,38},
	s_edit_phone_filter_cancel_xywh= {510,250,120,38},
}

w1_edit_phone_filter.s_2k = 
{
	s_edit_phone_filter_xywh={846,533,866,426},
	s_edit_phone_filter_cap_phone_number_xywh= {67,107,267,53},
	s_edit_phone_filter_t_phone_number_xywh= {334,107,400,53},
	s_edit_phone_filter_cap_remark_xywh= {67,187,267,53},
	s_edit_phone_filter_t_remark_xywh= {334,187,400,53},
	s_edit_phone_filter_tipinfo_xywh= {67,280,667,24},
	s_edit_phone_filter_hline_xywh={20,306,827,3},	
	s_edit_phone_filter_ok_xywh= {493,333,160,51},
	s_edit_phone_filter_cancel_xywh= {680,333,160,51},

}

w1_edit_phone_filter.s_4k = 
{
	s_edit_phone_filter_xywh= {1270,800,1300,640},
	s_edit_phone_filter_cap_phone_number_xywh= {100,160,400,80},
	s_edit_phone_filter_t_phone_number_xywh= {500,160,600,80},
	s_edit_phone_filter_cap_remark_xywh= {100,280,400,80},
	s_edit_phone_filter_t_remark_xywh= {500,280,600,80},
	s_edit_phone_filter_tipinfo_xywh= {100,420,1000,36},
	s_edit_phone_filter_hline_xywh={30,460,1240,4},
	s_edit_phone_filter_ok_xywh= {740,500,240,76},
	s_edit_phone_filter_cancel_xywh= {1020,500,240,76},	
}



w1_edit_phone_filter.PAGE_ADD = 1;
w1_edit_phone_filter.PAGE_EDIT = 2;
w1_edit_phone_filter.PAGE_DEL = 3;
--local SAVE_TIME;

local is_change = function(top)
	if(w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_EDIT) then
		if b_wnd_ex.get_text(top, w1_edit_phone_filter.dlg.t_phone_number.id) ~= w1_edit_phone_filter.phone_num then
			return true
		end
		if b_wnd_ex.get_text(top, w1_edit_phone_filter.dlg.t_remark.id) ~= w1_edit_phone_filter.remark then
			return true
		end
	elseif(w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_ADD) then
		if b_wnd_ex.get_text(top, w1_edit_phone_filter.dlg.t_phone_number.id) ~= '' then
			return true
		end
		if b_wnd_ex.get_text(top, w1_edit_phone_filter.dlg.t_remark.id) ~= '' then
			return true
		end
	end
	return false;
end

local save_change = function(param)
	local cwnd = w1_edit_phone_filter.dlg;
	
	if(w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_EDIT 
		or w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_ADD ) then
		
		w1_edit_phone_filter.phone_num = b_wnd_ex.get_text(param[1], cwnd.t_phone_number.id);
		w1_edit_phone_filter.remark = b_wnd_ex.get_text(param[1], cwnd.t_remark.id);
		w1_edit_phone_filter.state = 0;
		
		if (w1_edit_phone_filter.phone_num == '')then
			b_wnd_ex.set_text(param[1], cwnd.tipinfo.id, STR('LA_PARAM_NOT_EMPTY'), false);
			b_dlg.dlg_set_redraw(param[1]);
			w1_edit_phone_filter.save_check_illegal = true
			return 0;
		end
	end

	w1_edit_phone_filter.okfunc_param[2] = w1_edit_phone_filter.addflag;
	if(w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_EDIT
		or w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_DEL) then
		w1_edit_phone_filter.okfunc_param[3] = w1_edit_phone_filter.sel
	end
	
	if(w1_edit_phone_filter.ok_func ~= nil) then
		w1_edit_phone_filter.ok_func(w1_edit_phone_filter.okfunc_param);
	end
	return 0
end

w1_edit_phone_filter.init = function(top)
	w1_edit_phone_filter.phone_num = '';		--绰
	w1_edit_phone_filter.state = '';			--״̬
	w1_edit_phone_filter.remark = '';			--ע

	w1_edit_phone_filter.ok_func = nil;			--okťص	
	w1_edit_phone_filter.okfunc_param = nil;		--okťص
	w1_edit_phone_filter.cannel_func = nil;		--cancelťص
	w1_edit_phone_filter.cannelfunc_param = nil;	--cannelťص
	
end

w1_edit_phone_filter.set_dlgattr = function(listdata)
	if(listdata ~= nil) then
		assert(type(listdata) == 'table');
		w1_edit_phone_filter.listdata = listdata;
	end
end 

w1_edit_phone_filter.set_func  = function(ok_func, okfunc_param, cannel_func, cancelfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')
	assert(cannel_func == nil or type(cannel_func) == 'function')
	assert(cancelfunc_param == nil or type(cancelfunc_param) == 'table')
	
	w1_edit_phone_filter.ok_func = ok_func;
	w1_edit_phone_filter.okfunc_param = okfunc_param;
	w1_edit_phone_filter.cannel_func = cannel_func;
	w1_edit_phone_filter.cannelfunc_param = cancelfunc_param;
end

w1_edit_phone_filter.set_phonenum_state = function(phone_num, remark)
	assert(phone_num == nil or type(phone_num) == 'string')
	assert(remark == nil or type(remark) == 'string')
	w1_edit_phone_filter.phone_num = phone_num;
	w1_edit_phone_filter.remark = remark;
end 

w1_edit_phone_filter.get_number_state = function()
	return w1_edit_phone_filter.phone_num, w1_edit_phone_filter.state, w1_edit_phone_filter.remark;
end 

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_edit_phone_filter.dlg;
		
		--Ǳ༭ʼIPҪкϷԼ
		if(w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_EDIT 
			or w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_ADD ) then

			w1_edit_phone_filter.phone_num = b_wnd_ex.get_text(top, cwnd.t_phone_number.id);
			w1_edit_phone_filter.remark = b_wnd_ex.get_text(top, cwnd.t_remark.id);
			w1_edit_phone_filter.state = 0;

			if (w1_edit_phone_filter.phone_num == '')then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_PARAM_NOT_EMPTY'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
					
			if(w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_ADD) then
			    local data = w1_edit_phone_filter.listdata;
				for i=1,data.count do
					if data['idx'..i].number == w1_edit_phone_filter.phone_num then
						b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_PHONE_NUMBER_EXIST'), false);
						b_dlg.dlg_set_redraw(top);
						return 0;
				end
			end
			end
		end 
	
		w1_edit_phone_filter.okfunc_param[2] = w1_edit_phone_filter.addflag;
		if(w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_EDIT
			or w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_DEL) then
			w1_edit_phone_filter.okfunc_param[3] = w1_edit_phone_filter.sel
		end
		
		if(w1_edit_phone_filter.ok_func ~= nil) then
			w1_edit_phone_filter.ok_func(w1_edit_phone_filter.okfunc_param);
		end

		b_dlg.end_modal(top);
	end
	return 0
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(w1_edit_phone_filter.cannel_func ~= nil) then
			w1_edit_phone_filter.cannel_func(w1_edit_phone_filter.cannelfunc_param);
		end
		b_dlg.end_modal(top);
	end
	return 0
end

local dlg = {
	attr 	= {xywh='s_edit_phone_filter_xywh',},
	sub 	= {'cap_phone_number', 't_phone_number', 'cap_remark', 't_remark', 'tipinfo','ok', 'cancel'},
	
	cap_phone_number	 = {t='static',	id=id+3,	xywh = 's_edit_phone_filter_cap_phone_number_xywh',	
				text='LA_PHONE_NUMBER', font = 'f_grade6',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_phone_number 	= {t='edit',  	id=id+4,	xywh = 's_edit_phone_filter_t_phone_number_xywh', edit_num_str =1, text = '',trans = false},	

	cap_remark	 = {t='static',	id=id+5,	xywh = 's_edit_phone_filter_cap_remark_xywh',
				text='LA_REMARK_OPT', font = 'f_grade6',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_remark 	= {t='edit',  	id=id+6,	xywh = 's_edit_phone_filter_t_remark_xywh', text = '',trans = false},	
	
	tipinfo	= {t='static',id=id+7,	xywh='s_edit_phone_filter_tipinfo_xywh',	text='', 
			font='f_grade7', trans = false,
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
			},	
	
	hline		= {t='hline',	id=id+8,xywh='s_edit_phone_filter_hline_xywh'},
			
	ok		= {t='button',	id=id+9,	xywh = 's_edit_phone_filter_ok_xywh',	text='LA_OK',		cmd=on_ok, font='f_grade6',
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	cancel	= {t='button',	id=id+10,	xywh = 's_edit_phone_filter_cancel_xywh',text='LA_CANCEL',	cmd=on_cancel,font='f_grade6',
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
					},				
}

local dlg_del = {
	attr 	= {xywh='s_msgbox_xywh',},
	sub 	= {'msg','ok', 'cancel'},
	msg	 	= {t='static',	id=id+2,	xywh='s_msgbox_msg_xywh',	
			text='LA_CONFIRM_DELETE',trans = true,align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
			
	ok		= {t='button',	id=id+3,	xywh='s_msgbox_ok_xywh',	text='LA_OK',		cmd=on_ok,
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},},
	cancel	= {t='button',	id=id+4,	xywh='s_msgbox_cancel_xywh',text='LA_CANCEL',	cmd=on_cancel,
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
				},			
}


w1_edit_phone_filter.on_create = function(top)
	w1_edit_phone_filter.top = top
	return 0
end

w1_edit_phone_filter.clear_data = function()
	w1_edit_phone_filter.ok_func = nil;			
	w1_edit_phone_filter.okfunc_param = nil;	
	w1_edit_phone_filter.cannel_func = nil;		
	w1_edit_phone_filter.cannelfunc_param = nil;
	w1_edit_phone_filter.listdata = nil;
end

w1_edit_phone_filter.on_destroy = function(top)
	w1_edit_phone_filter.top = nil
	w1_edit_phone_filter.dlg = nil
	return 0
end

w1_edit_phone_filter.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top);
	local listdata = w1_edit_phone_filter.listdata;
	local paramdata;
	assert(listdata ~= nil)
	if(param ~= nil)then
		paramdata = cjson.decode(param)
		assert(paramdata.opera == 1 or paramdata.opera == 2);
		local sel = math.modf((paramdata.sel + 1) / 1)
		w1_edit_phone_filter.sel = sel;--¼ǰк
		
		if(paramdata.opera == 1) then
			w1_edit_phone_filter.dlg = dlg;
			w1_edit_phone_filter.addflag = w1_edit_phone_filter.PAGE_EDIT;--Ǵӱ༭ť		
			assert(type(sel) == 'number')
			sel = 'idx'..tostring(sel)
			w1_edit_phone_filter.phone_num = listdata[sel].number;
			w1_edit_phone_filter.state = listdata[sel].state;
			w1_edit_phone_filter.remark = listdata[sel].remark;
		elseif(paramdata.opera == 2) then
			w1_edit_phone_filter.dlg = dlg_del
			w1_edit_phone_filter.addflag = w1_edit_phone_filter.PAGE_DEL;--Ǵɾť
		end
		
	else
		w1_edit_phone_filter.dlg = dlg;
		w1_edit_phone_filter.addflag = w1_edit_phone_filter.PAGE_ADD;--ǴӰť
	end
	b_parser(top, w1_edit_phone_filter.dlg)
	if w1_edit_phone_filter.addflag ~= w1_edit_phone_filter.PAGE_DEL then
		if(w1_edit_phone_filter.phone_num ~= nil) then
			b_wnd_ex.set_text(top, w1_edit_phone_filter.dlg.t_phone_number.id, 	w1_edit_phone_filter.phone_num, false);
		else
			b_wnd_ex.set_text(top, w1_edit_phone_filter.dlg.t_phone_number.id, 	'', false);
		end

--[[		if (w1_edit_phone_filter.state == 1)then
			b_wnd_ex.set_text(top, w1_edit_phone_filter.dlg.t_remark.id, STR('LA_OFFLINE'), false);
		elseif (w1_edit_phone_filter.state == 2) then
			b_wnd_ex.set_text(top, w1_edit_phone_filter.dlg.t_remark.id, STR('LA_ONLINE'), false);
		else
			b_wnd_ex.set_text(top, w1_edit_phone_filter.dlg.t_remark.id, STR('LA_NOT_ACTIVED'), false);
		end]]--
		
		if(w1_edit_phone_filter.remark ~= nil) then
			b_wnd_ex.set_text(top, w1_edit_phone_filter.dlg.t_remark.id,  w1_edit_phone_filter.remark, false);
		else
			b_wnd_ex.set_text(top, w1_edit_phone_filter.dlg.t_remark.id,  '', false);
		end
		
		if w1_edit_phone_filter.addflag ~= w1_edit_phone_filter.PAGE_ADD then
			b_wnd_ex.set_disable(top, w1_edit_phone_filter.dlg.t_phone_number.id, true, false);--ֻӺʱ޸ĺ
		end
	end	
	return 0
end

w1_edit_phone_filter.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'))
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1)
	b_wnd.end_job(top)
	return 0
end

w1_edit_phone_filter.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.dlg_set_redraw(top);
	elseif(b_ui.RBUTTONCLK == vmsg) then
		local ret = false
		w1_edit_phone_filter.save_check_illegal = false;		
		if(w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_EDIT 
			or w1_edit_phone_filter.addflag == w1_edit_phone_filter.PAGE_ADD) then
			ret = is_change(top);
		end
		if ret == true then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_WANT_SAVE'), true, true, false,STR('LA_YES'), STR('LA_BAD'));
			w1_msgbox.set_func(save_change,{top}, nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			w1_msgbox.set_func(nil,nil, nil,nil);
		end
		if w1_edit_phone_filter.save_check_illegal == true then
			return 0;
		end
		b_dlg.end_modal(top);
	end	
	return 0
end

return w1_edit_phone_filter




