-- UIʹõȷȡԻ
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_adam.modifyip_id;
local cjson 	= require("cjson")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_legal 	= require("wnd.w1_util.w1_legal")
local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")
local b_app_api 	= require("wnd.core.command.b_app_api")
local w1_page_adam		= require("wnd.w1_cfg.w1_page_adam")
local util 		= require("wnd.core.util")
local w1_modify_adam_ip = {
	t = w1_key.DLG_MODIFY_ADAM_IP,
	top = nil,
	dlg = nil,
	data = nil,   --
	save_check_illegal,
	sel,		--ѡб
	opera,		-- 1б 2б
	start_timer = false,	--ʱ
	timer_count = 0, --ʱ
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_modify_adam_ip.s_768 = 
{
	w1_adam_modifyip_xywh = {338,213,346,373},
	w1_adam_modifyip_titleimg_xywh = {6,8,21,28},
	w1_adam_modifyip_titlestr_xywh = {33,8,282,28},
	w1_adam_modifyip_titleclose_xywh = {325,8,16,28},
	w1_adam_modifyip_cap_id = {26,49,106,28},
	w1_adam_modifyip_t_id = {176,49,133,28},
	w1_adam_modifyip_cap_mac = {26,85,106,28},
	w1_adam_modifyip_t_mac = {176,85,133,28},
	w1_adam_modifyip_cap_ip = {26,120,106,28},
	w1_adam_modifyip_t_ip = {176,120,133,28},
	w1_adam_modifyip_cap_mask = {26,156,106,28},
	w1_adam_modifyip_t_mask = {176,156,133,28},
	w1_adam_modifyip_cap_gateway = {26,192,106,28},
	w1_adam_modifyip_t_gateway = {176,192,133,28},
	w1_adam_modifyip_cap_timeout = {26,227,106,28},
	w1_adam_modifyip_t_timeout = {176,227,133,28},
	w1_adam_modifyip_cap_ipmode = {26,263,106,28},
	w1_adam_modifyip_t_ipmode = {176,263,133,28},
	w1_adam_modifyip_tipinfo_xywh = {26,291,293,28},
	w1_adam_modifyip_hline_xywh = {8,319,330,1},
	w1_adam_modifyip_ok_xywh = {197,330,64,34},
	w1_adam_modifyip_cancel_xywh = {272,330,64,34},
}

w1_modify_adam_ip.s_1280 = 
{
	w1_adam_modifyip_xywh			={315,300,650,525},
	w1_adam_modifyip_titleimg_xywh	= {12,12,40,40},
	w1_adam_modifyip_titlestr_xywh 	= {62,12,530,40},
	w1_adam_modifyip_titleclose_xywh = {610,12,30,40},
	w1_adam_modifyip_cap_id			= {50,  70, 200, 40},
	w1_adam_modifyip_t_id			= {330, 70, 250, 40},
	w1_adam_modifyip_cap_mac		= {50,  120, 200, 40},
	w1_adam_modifyip_t_mac			= {330, 120, 250, 40},
	w1_adam_modifyip_cap_ip			= {50,  170, 200, 40},
	w1_adam_modifyip_t_ip			= {330, 170, 250, 40},
	w1_adam_modifyip_cap_mask		= {50,  220, 200, 40},
	w1_adam_modifyip_t_mask			= {330, 220, 250, 40},
	w1_adam_modifyip_cap_gateway	= {50,  270, 200, 40},
	w1_adam_modifyip_t_gateway		= {330, 270, 250, 40},
	w1_adam_modifyip_cap_timeout	= {50,  320, 200, 40},
	w1_adam_modifyip_t_timeout		= {330, 320, 250, 40},
	w1_adam_modifyip_cap_ipmode		= {50,  370, 200, 40},
	w1_adam_modifyip_t_ipmode		= {330, 370, 250, 40},
	w1_adam_modifyip_tipinfo_xywh	= {50,410,550,40},
	w1_adam_modifyip_hline_xywh		= {15,450,620,2},
	w1_adam_modifyip_ok_xywh		= {370,465,120,48},
	w1_adam_modifyip_cancel_xywh	= {510,465,120,48},
}
w1_modify_adam_ip.s_1440 = 
{
	w1_adam_modifyip_xywh			={395,210,650,525},
	w1_adam_modifyip_titleimg_xywh 	= {12,12,40,40},
	w1_adam_modifyip_titlestr_xywh 	= {62,12,530,40},
	w1_adam_modifyip_titleclose_xywh = {610,12,30,40},
	w1_adam_modifyip_cap_id			= {50,  70, 200, 40},
	w1_adam_modifyip_t_id			= {330, 70, 250, 40},
	w1_adam_modifyip_cap_mac		= {50,  120, 200, 40},
	w1_adam_modifyip_t_mac			= {330, 120, 250, 40},
	w1_adam_modifyip_cap_ip			= {50,  170, 200, 40},
	w1_adam_modifyip_t_ip			= {330, 170, 250, 40},
	w1_adam_modifyip_cap_mask		= {50,  220, 200, 40},
	w1_adam_modifyip_t_mask			= {330, 220, 250, 40},
	w1_adam_modifyip_cap_gateway	= {50,  270, 200, 40},
	w1_adam_modifyip_t_gateway		= {330, 270, 250, 40},
	w1_adam_modifyip_cap_timeout	= {50,  320, 200, 40},
	w1_adam_modifyip_t_timeout		= {330, 320, 250, 40},
	w1_adam_modifyip_cap_ipmode		= {50,  370, 200, 40},
	w1_adam_modifyip_t_ipmode		= {330, 370, 250, 40},
	w1_adam_modifyip_tipinfo_xywh	= {50,410,550,40},
	w1_adam_modifyip_hline_xywh		= {15,450,620,2},
	w1_adam_modifyip_ok_xywh		= {370,465,120,48},
	w1_adam_modifyip_cancel_xywh	= {510,465,120,48},
}

w1_modify_adam_ip.s_1080p = 
{
	w1_adam_modifyip_xywh={635,300,650,525},
	w1_adam_modifyip_titleimg_xywh = {12,12,40,40},
	w1_adam_modifyip_titlestr_xywh = {62,12,530,40},
	w1_adam_modifyip_titleclose_xywh = {610,12,30,40},
	w1_adam_modifyip_cap_id			= {50,  70, 200, 40},
	w1_adam_modifyip_t_id			= {330, 70, 250, 40},
	w1_adam_modifyip_cap_mac		= {50,  120, 200, 40},
	w1_adam_modifyip_t_mac			= {330, 120, 250, 40},
	w1_adam_modifyip_cap_ip			= {50,  170, 200, 40},
	w1_adam_modifyip_t_ip			= {330, 170, 250, 40},
	w1_adam_modifyip_cap_mask		= {50,  220, 200, 40},
	w1_adam_modifyip_t_mask			= {330, 220, 250, 40},
	w1_adam_modifyip_cap_gateway	= {50,  270, 200, 40},
	w1_adam_modifyip_t_gateway		= {330, 270, 250, 40},
	w1_adam_modifyip_cap_timeout	= {50,  320, 200, 40},
	w1_adam_modifyip_t_timeout		= {330, 320, 250, 40},
	w1_adam_modifyip_cap_ipmode		= {50,  370, 200, 40},
	w1_adam_modifyip_t_ipmode		= {330, 370, 250, 40},
	w1_adam_modifyip_tipinfo_xywh	= {50,410,550,40},
	w1_adam_modifyip_hline_xywh		= {15,450,620,2},
	w1_adam_modifyip_ok_xywh		= {370,465,120,48},
	w1_adam_modifyip_cancel_xywh	= {510,465,120,48},
}

w1_modify_adam_ip.s_2k = 
{
	w1_adam_modifyip_xywh = {846,399,866,700},
	w1_adam_modifyip_titleimg_xywh = {15,15,53,53},
	w1_adam_modifyip_titlestr_xywh = {82,15,706,53},
	w1_adam_modifyip_titleclose_xywh = {813,15,40,53},
	w1_adam_modifyip_cap_id = {66,93,266,53},
	w1_adam_modifyip_t_id = {439,93,333,53},
	w1_adam_modifyip_cap_mac = {66,159,266,53},
	w1_adam_modifyip_t_mac = {439,159,333,53},
	w1_adam_modifyip_cap_ip = {66,226,266,53},
	w1_adam_modifyip_t_ip = {439,226,333,53},
	w1_adam_modifyip_cap_mask = {66,293,266,53},
	w1_adam_modifyip_t_mask = {439,293,333,53},
	w1_adam_modifyip_cap_gateway = {66,359,266,53},
	w1_adam_modifyip_t_gateway = {439,359,333,53},
	w1_adam_modifyip_cap_timeout = {66,426,266,53},
	w1_adam_modifyip_t_timeout = {439,426,333,53},
	w1_adam_modifyip_cap_ipmode = {66,493,266,53},
	w1_adam_modifyip_t_ipmode = {439,493,333,53},
	w1_adam_modifyip_tipinfo_xywh = {66,546,733,53},
	w1_adam_modifyip_hline_xywh = {19,599,826,2},
	w1_adam_modifyip_ok_xywh = {493,619,159,63},
	w1_adam_modifyip_cancel_xywh = {679,619,159,63},
}

w1_modify_adam_ip.s_4k = 
{
	w1_adam_modifyip_xywh = {1270,600,1300,1050},
	w1_adam_modifyip_titleimg_xywh = {24,24,80,80},
	w1_adam_modifyip_titlestr_xywh = {124,24,1060,80},
	w1_adam_modifyip_titleclose_xywh = {1220,24,60,80},
	w1_adam_modifyip_cap_id = {100,140,400,80},
	w1_adam_modifyip_t_id = {660,140,500,80},
	w1_adam_modifyip_cap_mac = {100,240,400,80},
	w1_adam_modifyip_t_mac = {660,240,500,80},
	w1_adam_modifyip_cap_ip = {100,340,400,80},
	w1_adam_modifyip_t_ip = {660,340,500,80},
	w1_adam_modifyip_cap_mask = {100,440,400,80},
	w1_adam_modifyip_t_mask = {660,440,500,80},
	w1_adam_modifyip_cap_gateway = {100,540,400,80},
	w1_adam_modifyip_t_gateway = {660,540,500,80},
	w1_adam_modifyip_cap_timeout = {100,640,400,80},
	w1_adam_modifyip_t_timeout = {660,640,500,80},
	w1_adam_modifyip_cap_ipmode = {100,740,400,80},
	w1_adam_modifyip_t_ipmode = {660,740,500,80},
	w1_adam_modifyip_tipinfo_xywh = {100,820,1100,80},
	w1_adam_modifyip_hline_xywh = {30,900,1240,4},
	w1_adam_modifyip_ok_xywh = {740,930,240,96},
	w1_adam_modifyip_cancel_xywh = {1020,930,240,96},
}


local is_change = function(top)
	local cwnd = w1_modify_adam_ip.dlg;
	local data = w1_modify_adam_ip.data;
	if b_wnd_ex.get_text(top, w1_modify_adam_ip.dlg.t_ip.id) ~= data.ip then
		return true
	end
	
	if b_wnd_ex.get_text(top, w1_modify_adam_ip.dlg.t_mask.id) ~= data.mask then
		return true
	end	
	
	if b_wnd_ex.get_text(top, w1_modify_adam_ip.dlg.t_gateway.id) ~= data.getway then
		return true
	end	
	
	if b_wnd_ex.get_value(top, w1_modify_adam_ip.dlg.t_timeout.id) ~= data.timeout then
		return true
	end
	
	if b_wnd_ex.get_sel(top, w1_modify_adam_ip.dlg.t_ipmode.id) ~= data.net_mode then
		return true
	end
	
	return false;
end

local set_err_tip = function(top, id, txt, redraw)
	b_wnd_ex.set_text(top, id, txt, redraw);
	w1_modify_adam_ip.start_timer = true;
	w1_modify_adam_ip.timer_count = 3;
end

local param_check = function(top)
	local cwnd = w1_modify_adam_ip.dlg;
	local ret = true;
	local legal, num = w1_legal.check_gataway(top, cwnd.t_gateway.id);
	if(legal == false) then
		set_err_tip(top, cwnd.tipinfo.id, STR('LAN_DEFAULT_GATEWAY'), true);
		ret = false
	end
	legal, num = w1_legal.check_netmask(top, cwnd.t_mask.id);
	if(legal == false) then
		set_err_tip(top, cwnd.tipinfo.id, STR('LAN_SUBNET_MASK'), true);
		ret = false;
	end	
	
	legal, num= w1_legal.check_ip(top, cwnd.t_ip.id);	
	if(legal == false) then
		set_err_tip(top, cwnd.tipinfo.id, STR('LA_CORRECT_IP'), true);
		ret = false;
	end	
	
	return ret
end	

local save_change = function(param)
	local cwnd = w1_modify_adam_ip.dlg;
	local top = param[1];
	if (false == param_check(top)) then
		return 0;	
	end	
	
	w1_modify_adam_ip.save_check_illegal = false;
	local ipstr = b_wnd_ex.get_text(top, w1_modify_adam_ip.dlg.t_ip.id);
	local maskstr = b_wnd_ex.get_text(top, w1_modify_adam_ip.dlg.t_mask.id);
	local gateway = b_wnd_ex.get_text(top, w1_modify_adam_ip.dlg.t_gateway.id);
	local timeout = b_wnd_ex.get_value(top, w1_modify_adam_ip.dlg.t_timeout.id);
	local ipmode = b_wnd_ex.get_sel(top, w1_modify_adam_ip.dlg.t_ipmode.id);

	local data = w1_modify_adam_ip.data;
	local param = {};
	util.copy_tab_b(param, data);
	param.modify_ip = ipstr
	param.mask 		= maskstr
	param.getway 	= gateway
	param.timeout 	= timeout
	param.net_mode 	= ipmode
	local ret = b_app_api.adam_modify_ip(param);
	if (ret == 0) then	 --ɹ
		w1_page_adam.update_ilst_data();
		b_dlg.end_modal(top);
	else --
		set_err_tip(top, cwnd.tipinfo.id, STR('LA_PARAMETER_ERR'), true);
		w1_modify_adam_ip.save_check_illegal = true 
	end	

	return 0
end

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_modify_adam_ip.dlg;
		if (false == param_check(top)) then
			return 0;	
		end		

		local ipstr = b_wnd_ex.get_text(top, w1_modify_adam_ip.dlg.t_ip.id);
		local maskstr = b_wnd_ex.get_text(top, w1_modify_adam_ip.dlg.t_mask.id);
		local gateway = b_wnd_ex.get_text(top, w1_modify_adam_ip.dlg.t_gateway.id);
		local timeout = b_wnd_ex.get_value(top, w1_modify_adam_ip.dlg.t_timeout.id);
		local ipmode = b_wnd_ex.get_sel(top, w1_modify_adam_ip.dlg.t_ipmode.id);
	
		local data = w1_modify_adam_ip.data;
		local param = {};
		util.copy_tab_b(param, data);
		param.modify_ip = ipstr
		param.mask 		= maskstr
		param.getway 	= gateway
		param.timeout 	= timeout
		param.net_mode 	= ipmode
		local ret = b_app_api.adam_modify_ip(param);
		if (ret == 0) then	 --ɹ
			w1_page_adam.update_ilst_data();
			b_dlg.end_modal(top);
		else --
			set_err_tip(top, cwnd.tipinfo.id, STR('LA_PARAMETER_ERR'), true);
			w1_modify_adam_ip.save_check_illegal = true 
		end	
	end
		
	return 0
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	
	return 0
end

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		if (w1_modify_adam_ip.start_timer) then
			if (w1_modify_adam_ip.timer_count > 0) then
				w1_modify_adam_ip.timer_count = w1_modify_adam_ip.timer_count -1;
			else
				w1_modify_adam_ip.start_timer = false;
				w1_modify_adam_ip.timer_count = 0;
				b_wnd_ex.set_text(top, w1_modify_adam_ip.dlg.tipinfo.id, '', true);
			end
		end
	end	
	
	return 0
end	

local on_ipmode = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		
	end
	
	return 0;
end	

local dlg = {
	attr 	= {xywh='w1_adam_modifyip_xywh',cmd=on_dlg,timer={-1, 1000}},
	sub 	= {'titleimg', 'titlestr', 'titleclose','cap_id', 't_id',  'cap_mac', 't_mac', 
				'cap_ip', 't_ip', 'cap_mask', 't_mask', 'cap_gateway', 't_gateway', 
				'cap_timeout', 't_timeout', 'cap_ipmode', 't_ipmode', 'tipinfo', 'hline', 'ok', 'cancel'},
	
	titleimg 	= {t='tt_picture',	id=id+1,xywh='w1_adam_modifyip_titleimg_xywh', 
					t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_editcameera'}},
	
	titlestr	= {t='static', 	id=id+2,xywh='w1_adam_modifyip_titlestr_xywh', 
					text='LA_MODIFY_CAMERA',	font = 'f_grade5',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
								
	titleclose 	= {t='tt_button',id=id+3,xywh = 'w1_adam_modifyip_titleclose_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
					color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_txt_f'},
					color_f= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},cmd=on_cancel},

	cap_id	 = {t='static',	id=id+4,	xywh = 'w1_adam_modifyip_cap_id',	
				text='LA_ID', font = 'f_grade6',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},

	t_id	 = {t='static',	id=id+5,	xywh = 'w1_adam_modifyip_t_id',	
				text='', font = 'f_grade6',trans = false,
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},

	cap_mac	 = {t='static',	id=id+6,	xywh = 'w1_adam_modifyip_cap_mac',	
				text='LA_MAC_ADDRESS', font = 'f_grade6',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_mac 	= {t='edit',  	id=id+7,	xywh = 'w1_adam_modifyip_t_mac', text = '',trans = false},	
	
	cap_ip 		= {t='static',id=id+8,xywh='w1_adam_modifyip_cap_ip',text='LA_IP_ADDRESS',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_ip 		= {t='edit_ip',  id=id+9,xywh='w1_adam_modifyip_t_ip'},
	
	cap_mask = {t='static',id=id+10,xywh='w1_adam_modifyip_cap_mask',text='LA_SUBNET_MASK',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_mask 	= {t='edit_ip',  id=id+11,xywh='w1_adam_modifyip_t_mask'},
	
	cap_gateway = {t='static',id=id+12,xywh='w1_adam_modifyip_cap_gateway',text='LA_GATEWAY',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_gateway 	= {t='edit_ip',  id=id+13,xywh='w1_adam_modifyip_t_gateway'},

	cap_timeout	 = {t='static',	id=id+14,	xywh = 'w1_adam_modifyip_cap_timeout',
				text='LA_HOST_IDLE', font = 'f_grade6',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_timeout	= {t='edit_num',id=id+15,xywh='w1_adam_modifyip_t_timeout',range={5,4095}},
	
	cap_ipmode	= {t='static', 	id=id+16,xywh='w1_adam_modifyip_cap_ipmode', 
					text='LA_IP_MODE',font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	t_ipmode 	= {t='combox', id=id+17,xywh='w1_adam_modifyip_t_ipmode', 
					items={'Static','DHCP'},trans = false,
					cmd = on_ipmode,
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},		
	
	tipinfo	= {t='static',id=id+18,	xywh='w1_adam_modifyip_tipinfo_xywh',	text='', 
			font='f_grade7', trans = false,
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
			},	
	
	hline		= {t='hline',	id=id+19,xywh='w1_adam_modifyip_hline_xywh'},
			
	ok		= {t='button',	id=id+20,	xywh = 'w1_adam_modifyip_ok_xywh',	text='LA_OK',		cmd=on_ok, font='f_grade6',
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	cancel	= {t='button',	id=id+21,	xywh = 'w1_adam_modifyip_cancel_xywh',text='LA_CANCEL',	cmd=on_cancel,font='f_grade6',
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
					},				
}

w1_modify_adam_ip.on_create = function(top)
	w1_modify_adam_ip.top = top
	w1_modify_adam_ip.dlg = dlg;
	
	b_parser(top, w1_modify_adam_ip.dlg)

	return 0
end

w1_modify_adam_ip.on_destroy = function(top)
	w1_modify_adam_ip.top = nil
	w1_modify_adam_ip.dlg = nil
	w1_modify_adam_ip.data = nil;
	w1_modify_adam_ip.start_timer = false	--ʱ
	w1_modify_adam_ip.timer_count = 0; --ʱ	
	return 0
end

w1_modify_adam_ip.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top);
	local paramdata;
	if(param ~= nil)then
		paramdata = cjson.decode(param)
		assert(paramdata.opera == 1 or paramdata.opera == 0);
		local sel = math.modf(paramdata.sel)
		local opt = math.modf(paramdata.opera)
		w1_modify_adam_ip.sel = sel;--¼ǰк
		w1_modify_adam_ip.opera = opt;--¼ǰ0б1б
		assert(opt == 1);
		sel = sel + 1
		local listdata = w1_page_adam.get_search_list(top);
		w1_modify_adam_ip.data = listdata['idx' .. sel];
		
		local cwnd = w1_modify_adam_ip.dlg;
		local str_id = tostring(sel);
		if (sel < 10) then
			str_id = '0' .. tostring(sel)
		end
		b_wnd_ex.set_text(top, cwnd.t_id.id, str_id, false);
		b_wnd_ex.set_text(top, cwnd.t_mac.id, w1_modify_adam_ip.data.mac, false);
		b_wnd_ex.set_disable(top, cwnd.t_mac.id, true, false);
		b_wnd_ex.set_text(top, cwnd.t_ip.id, w1_modify_adam_ip.data.ip, false);
		b_wnd_ex.set_text(top, cwnd.t_mask.id, w1_modify_adam_ip.data.mask, false);
		b_wnd_ex.set_text(top, cwnd.t_gateway.id, w1_modify_adam_ip.data.getway, false);
		b_wnd_ex.set_value(top, cwnd.t_timeout.id, w1_modify_adam_ip.data.timeout, false);
		b_wnd_ex.set_sel(top, cwnd.t_timeout.id,w1_modify_adam_ip.data.net_mode, false);
	end
	

	return 0
end

w1_modify_adam_ip.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'))
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1)
	b_wnd.end_job(top)
	return 0
end

w1_modify_adam_ip.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.dlg_set_redraw(top);
	elseif(b_ui.RBUTTONCLK == vmsg) then
		local ret = false
		w1_modify_adam_ip.save_check_illegal = false;		
		ret = is_change(top);
		if ret == true then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_WANT_SAVE'), true, true, false,STR('LA_YES'), STR('LA_BAD'));
			w1_msgbox.set_func(save_change,{top}, nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			w1_msgbox.set_func(nil,nil, nil,nil);
		end
		if w1_modify_adam_ip.save_check_illegal == true then
			return 0;
		end
		b_dlg.end_modal(top);
	end	
	return 0
end

return w1_modify_adam_ip




