-- UIʹõȷȡԻ
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.ipsegment_id;
local cjson 	= require("cjson")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_legal 	= require("wnd.w1_util.w1_legal")
local w1_page_camera = require("wnd.w1_cfg.w1_page_camera")
local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")
local b_app_api 	= require("wnd.core.command.b_app_api")

local w1_modify_cam_ip = {
	t = w1_key.DLG_MODIFY_CAM_IP,
	top = nil,
	dlg = nil,
	data = nil,   --
	save_check_illegal,
	sel,		--ѡб
	opera,		-- 1б 2б
	start_timer = false,	--ʱ
	timer_count = 0, --ʱ
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_modify_cam_ip.s_768 =
{
	w1_modifyip_xywh = {338,284,346,227},
	w1_modifyip_cap_ip_xywh = {26,56,106,28},
	w1_modifyip_t_ip_xywh = {176,56,133,28},
	w1_modifyip_cap_submask_xywh = {26,99,106,28},
	w1_modifyip_t_submask_xywh = {176,99,133,28},
	w1_modifyip_tipinfo_xywh = {26,142,266,12},
	w1_modifyip_hline_xywh = {8,163,330,1},
	w1_modifyip_ok_xywh = {197,177,64,27},
	w1_modifyip_cancel_xywh = {272,177,64,27},
};

w1_modify_cam_ip.s_1280 = 
{
	w1_modifyip_xywh={315,400,650,320},
	w1_modifyip_cap_ip_xywh= {50,80,200,40},
	w1_modifyip_t_ip_xywh= {330,80,250,40},
	w1_modifyip_cap_submask_xywh= {50,140,200,40},
	w1_modifyip_t_submask_xywh= {330,140,250,40},
	w1_modifyip_tipinfo_xywh= {50,200,500,18},
	w1_modifyip_hline_xywh={15,230,620,1},
	w1_modifyip_ok_xywh= {370,250,120,38},
	w1_modifyip_cancel_xywh= {510,250,120,38},
}
w1_modify_cam_ip.s_1440 = 
{
	w1_modifyip_xywh={395,310,650,320},
	w1_modifyip_cap_ip_xywh= {50,80,200,40},
	w1_modifyip_t_ip_xywh= {330,80,250,40},
	w1_modifyip_cap_submask_xywh= {50,140,200,40},
	w1_modifyip_t_submask_xywh= {330,140,250,40},
	w1_modifyip_tipinfo_xywh= {50,200,500,18},
	w1_modifyip_hline_xywh={15,230,620,1},
	w1_modifyip_ok_xywh= {370,250,120,38},
	w1_modifyip_cancel_xywh= {510,250,120,38},
}
w1_modify_cam_ip.s_1080p = 
{
	w1_modifyip_xywh={635,400,650,320},
	w1_modifyip_cap_ip_xywh= {50,80,200,40},
	w1_modifyip_t_ip_xywh= {330,80,250,40},
	w1_modifyip_cap_submask_xywh= {50,140,200,40},
	w1_modifyip_t_submask_xywh= {330,140,250,40},
	w1_modifyip_tipinfo_xywh= {50,200,500,18},
	w1_modifyip_hline_xywh={15,230,620,2},
	w1_modifyip_ok_xywh= {370,250,120,38},
	w1_modifyip_cancel_xywh= {510,250,120,38},
}

w1_modify_cam_ip.s_2k = 
{
	w1_modifyip_xywh={846,533,866,426},
	w1_modifyip_cap_ip_xywh= {67,107,267,53},
	w1_modifyip_t_ip_xywh= {440,107,333,53},
	w1_modifyip_cap_submask_xywh= {67,187,267,53},
	w1_modifyip_t_submask_xywh= {440,187,333,53},
	w1_modifyip_tipinfo_xywh= {67,280,667,24},
	w1_modifyip_hline_xywh={20,306,827,3},	
	w1_modifyip_ok_xywh= {493,333,160,51},
	w1_modifyip_cancel_xywh= {680,333,160,51},

}

w1_modify_cam_ip.s_4k = 
{
	w1_modifyip_xywh= {1270,800,1300,640},
	w1_modifyip_cap_ip_xywh= {100,160,400,80},
	w1_modifyip_t_ip_xywh= {660,160,500,80},
	w1_modifyip_cap_submask_xywh= {100,280,400,80},
	w1_modifyip_t_submask_xywh= {660,280,500,80},
	w1_modifyip_tipinfo_xywh= {100,420,1000,36},
	w1_modifyip_hline_xywh={30,460,1240,4},
	w1_modifyip_ok_xywh= {740,500,240,76},
	w1_modifyip_cancel_xywh= {1020,500,240,76},	
}

local is_change = function(top)
	if b_wnd_ex.get_text(top, w1_modify_cam_ip.dlg.t_ip.id) ~= '' then
		return true
	end
	
	if b_wnd_ex.get_text(top, w1_modify_cam_ip.dlg.t_mask.id) ~= '' then
		return true
	end
	
	return false;
end

local set_err_tip = function(top, id, txt, redraw)
	b_wnd_ex.set_text(top, id, txt, redraw);
	w1_modify_cam_ip.start_timer = true;
	w1_modify_cam_ip.timer_count = 3;
end

local save_change = function(param)
	local cwnd = w1_modify_cam_ip.dlg;
	local legal, num = w1_legal.check_ipseg(param[1], cwnd.t_ip.id)
	if (legal == false) then
		if((num == w1_legal.ip.EMPTY) or (num == w1_legal.ip.LENERR or num == w1_legal.ip.PRARMERR)) then
			set_err_tip(param[1], cwnd.tipinfo.id, STR('LA_CORRECT_IP'), true);
			w1_modify_cam_ip.save_check_illegal = true
		end
	end
		
	legal, num = w1_legal.check_netmask(param[1], cwnd.t_mask.id)
	if (legal == false) then
		if((num == w1_legal.netmask.EMPTY) or (num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR)) then
			set_err_tip(param[1], cwnd.tipinfo.id, STR('LAN_SUBNET_MASK'), true);
			w1_modify_cam_ip.save_check_illegal = true
		end	
	end
	
	if w1_modify_cam_ip.save_check_illegal ~= true	then
		local ip_addr = b_wnd_ex.get_text(param[1], cwnd.t_ip.id);
		local ip1, ip2, ip3, ip4 = string.match(ip_addr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");	
		local ipStr = tonumber(ip1)..'.'..tonumber(ip2)..'.'..tonumber(ip3)..'.'..tonumber(ip4);
		
		ip_addr = b_wnd_ex.get_text(param[1], cwnd.t_mask.id);
		ip1, ip2, ip3, ip4 = string.match(ip_addr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");	
		local maskStr = tonumber(ip1)..'.'..tonumber(ip2)..'.'..tonumber(ip3)..'.'..tonumber(ip4);
		
		--TODO
		local data = w1_modify_cam_ip.data;
		local ret = b_app_api.modify_camera_ip(ipStr, maskStr, data);
		if (ret == 0) then	 --ɹ
			data.addr = ipStr;
			data.netmask = maskStr;
			w1_page_camera.update_ilst_data();
			b_dlg.end_modal(param[1]);
		elseif(ret == 3) then	--IPͻ
			set_err_tip(param[1], cwnd.tipinfo.id, STR('LA_IP_CONFLICT'), true);
			w1_modify_cam_ip.save_check_illegal = true
		else --
			set_err_tip(param[1], cwnd.tipinfo.id, STR('LA_PARAMETER_ERR'), true);
			w1_modify_cam_ip.save_check_illegal = true 
		end	
	end

	return 0
end

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_modify_cam_ip.dlg;
		w1_modify_cam_ip.save_check_illegal = false
		local legal, num = w1_legal.check_ipseg(top, cwnd.t_ip.id)
		if (legal == false) then
			if(num == w1_legal.ip.EMPTY or (num == w1_legal.ip.LENERR or num == w1_legal.ip.PRARMERR)) then
				set_err_tip(top, cwnd.tipinfo.id, STR('LA_CORRECT_IP'), true);
				w1_modify_cam_ip.save_check_illegal = true
			end
		end
			
		legal, num = w1_legal.check_netmask(top, cwnd.t_mask.id)
		if (legal == false) then
			if(num == w1_legal.netmask.EMPTY or (num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR)) then
				set_err_tip(top, cwnd.tipinfo.id, STR('LAN_SUBNET_MASK'), true);
				w1_modify_cam_ip.save_check_illegal = true
			end	
		end
		
		if w1_modify_cam_ip.save_check_illegal ~= true	then
			local ip_addr = b_wnd_ex.get_text(top, cwnd.t_ip.id);
			local ip1, ip2, ip3, ip4 = string.match(ip_addr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");	
			local ipStr = tonumber(ip1)..'.'..tonumber(ip2)..'.'..tonumber(ip3)..'.'..tonumber(ip4);
			w1_modify_cam_ip.sipstr = ipStr
			
			ip_addr = b_wnd_ex.get_text(top, cwnd.t_mask.id);
			ip1, ip2, ip3, ip4 = string.match(ip_addr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");	
			local maskStr = tonumber(ip1)..'.'..tonumber(ip2)..'.'..tonumber(ip3)..'.'..tonumber(ip4);
			w1_modify_cam_ip.eipstr = maskStr
			
			--TODO
			local data = w1_modify_cam_ip.data;
			local ret = b_app_api.modify_camera_ip(ipStr, maskStr, data);
			if (ret == 0) then	 --ɹ
				data.addr = ipStr;
				data.netmask = maskStr;
				w1_page_camera.update_ilst_data();
				b_dlg.end_modal(top);
			elseif(ret == 3) then	--IPͻ
				set_err_tip(top, cwnd.tipinfo.id, STR('LA_IP_CONFLICT'), true);
				w1_modify_cam_ip.save_check_illegal = true
			else --
				set_err_tip(top, cwnd.tipinfo.id, STR('LA_PARAMETER_ERR'), true);
				w1_modify_cam_ip.save_check_illegal = true 
			end	
		end
	end
	return 0
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	
	return 0
end

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		if (w1_modify_cam_ip.start_timer) then
			if (w1_modify_cam_ip.timer_count > 0) then
				w1_modify_cam_ip.timer_count = w1_modify_cam_ip.timer_count -1;
			else
				w1_modify_cam_ip.start_timer = false;
				w1_modify_cam_ip.timer_count = 0;
				b_wnd_ex.set_text(top, w1_modify_cam_ip.dlg.tipinfo.id, '', true);
			end
		end
	end	
	
	return 0
end	

local dlg = {
	attr 	= {xywh='w1_modifyip_xywh',cmd=on_dlg,timer={-1, 1000}},
	sub 	= {'cap_ip', 't_ip', 'cap_mask', 't_mask', 'tipinfo','ok', 'cancel'},
	
	cap_ip	 = {t='static',	id=id+3,	xywh = 'w1_modifyip_cap_ip_xywh',	
				text='LA_IP_ADDRESS', font = 'f_grade6',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_ip 	= {t='edit_ip',  	id=id+4,	xywh = 'w1_modifyip_t_ip_xywh', text = '',trans = false},	
	
	cap_mask	 = {t='static',	id=id+5,	xywh = 'w1_modifyip_cap_submask_xywh',
				text='LA_SUBNET_MASK', font = 'f_grade6',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_mask 	= {t='edit_ip',  	id=id+6,	xywh = 'w1_modifyip_t_submask_xywh', text = '',trans = false},	
	
	tipinfo	= {t='static',id=id+7,	xywh='w1_modifyip_tipinfo_xywh',	text='', 
			font='f_grade7', trans = false,
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
			},	
	
	hline		= {t='hline',	id=id+8,xywh='w1_modifyip_hline_xywh'},
			
	ok		= {t='button',	id=id+9,	xywh = 'w1_modifyip_ok_xywh',	text='LA_OK',		cmd=on_ok, font='f_grade6',
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	cancel	= {t='button',	id=id+10,	xywh = 'w1_modifyip_cancel_xywh',text='LA_CANCEL',	cmd=on_cancel,font='f_grade6',
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
					},				
}

w1_modify_cam_ip.on_create = function(top)
	w1_modify_cam_ip.top = top
	w1_modify_cam_ip.dlg = dlg;

	return 0
end

w1_modify_cam_ip.on_destroy = function(top)
	w1_modify_cam_ip.top = nil
	w1_modify_cam_ip.dlg = nil
	w1_modify_cam_ip.data = nil;
	w1_modify_cam_ip.start_timer = false	--ʱ
	w1_modify_cam_ip.timer_count = 0; --ʱ	
	return 0
end

w1_modify_cam_ip.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top);
	local paramdata;
	if(param ~= nil)then
		paramdata = cjson.decode(param)
		assert(paramdata.opera == 1 or paramdata.opera == 0);
		local sel = math.modf(paramdata.sel)
		local opt = math.modf(paramdata.opera)
		w1_modify_cam_ip.sel = sel;--¼ǰк
		w1_modify_cam_ip.opera = opt;--¼ǰ0б1б
		if (opt == 0) then  --бIP
			local listdata = w1_page_camera.get_bind_list(top);
			for i = 1, listdata.camera_num do
				if(listdata['idx'..i].channel_id == sel) then
					w1_modify_cam_ip.data = listdata['idx'..i]
					break;
				end
			end			
		else --б޸IP 
			sel = sel + 1
			local listdata = w1_page_camera.get_search_list(top);
			w1_modify_cam_ip.data = listdata['idx' .. sel];
		end
	end
	
	b_parser(top, w1_modify_cam_ip.dlg)

	return 0
end

w1_modify_cam_ip.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'))
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1)
	b_wnd.end_job(top)
	return 0
end

w1_modify_cam_ip.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.dlg_set_redraw(top);
	elseif(b_ui.RBUTTONCLK == vmsg) then
		local ret = false
		w1_modify_cam_ip.save_check_illegal = false;		
		ret = is_change(top);
		if ret == true then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_WANT_SAVE'), true, true, false,STR('LA_YES'), STR('LA_BAD'));
			w1_msgbox.set_func(save_change,{top}, nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			w1_msgbox.set_func(nil,nil, nil,nil);
		end
		if w1_modify_cam_ip.save_check_illegal == true then
			return 0;
		end
		b_dlg.end_modal(top);
	end	
	return 0
end

return w1_modify_cam_ip




