--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local util 		= require("wnd.core.util")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local id 		= w1_id.cfg_adam.adam_id
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_legal 	= require("wnd.w1_util.w1_legal")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local b_app_cfg		= require("wnd.core.b_app_cfg")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local channel_num;--豸ͨĿ

local w1_page_adam = 
{
	delete_all_flag = false,
	delete_signel_flag = false,
	del_sel,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_adam.s_768 = 
{
	s_adam_online_list_xywh = {42,21,752,245},
	s_adam_onlie_list_w1 = {42,0,0,0},
	s_adam_onlie_list_w2 = {106,0,0,0},
	s_adam_onlie_list_w3 = {160,0,0,0},
	s_adam_onlie_list_w4 = {160,0,0,0},
	s_adam_onlie_list_w5 = {266,0,0,0},
	s_adam_del_xywh = {688,277,106,28},
	s_adam_hline_xywh = {309,320,485,32},
	s_adam_onlinedev_xywh = {42,320,160,32},
	s_adam_search_xywh = {202,320,106,32},
	s_adam_add_xywh = {688,597,106,28},
	s_adam_search_list_xywh = {42,359,752,227},
	s_adam_devlist_w1 = {42,0,0,0},
	s_adam_devlist_w2 = {106,0,0,0},
	s_adam_devlist_w3 = {213,0,0,0},
	s_adam_devlist_w4 = {213,0,0,0},
	s_adam_devlist_w5 = {160,0,0,0},
}

w1_page_adam.s_1280 = 
{
	s_adam_online_list_xywh = {80,30,860,345},
	s_adam_onlie_list_w1 	= {80, 0, 0, 0},
	s_adam_onlie_list_w2 	= {150, 0, 0, 0},
	s_adam_onlie_list_w3 	= {180, 0, 0, 0},
	s_adam_onlie_list_w4 	= {180, 0, 0, 0},
	s_adam_onlie_list_w5 	= {240, 0, 0, 0},		
	s_adam_del_xywh= {740,390,200,40},
	s_adam_hline_xywh = {580,450,360,45},
	s_adam_onlinedev_xywh = {80,450,300,45},
	s_adam_search_xywh = {380,450,200,45}, 
	s_adam_search_list_xywh = {80,505,860,290},
	s_adam_add_xywh = {740,810,200,40},
	s_adam_devlist_w1		= {80,0,0,0},
	s_adam_devlist_w2		= {150,0,0,0},
	s_adam_devlist_w3		= {230,0,0,0},
	s_adam_devlist_w4		= {230,0,0,0},
	s_adam_devlist_w5		= {120,0,0,0},
}

w1_page_adam.s_1440 = 
{
	s_adam_online_list_xywh = {80,30,920,287},
	s_adam_onlie_list_w1 	= {80, 0, 0, 0},
	s_adam_onlie_list_w2 	= {150, 0, 0, 0},
	s_adam_onlie_list_w3 	= {200, 0, 0, 0},
	s_adam_onlie_list_w4 	= {200, 0, 0, 0},
	s_adam_onlie_list_w5 	= {260, 0, 0, 0},	
	s_adam_del_xywh			= {800,330,200,40},
	s_adam_hline_xywh 		= {580,380,420,40},
	s_adam_onlinedev_xywh 	= {80,380,300,40},
	s_adam_search_xywh 		= {380,380,200,40}, 
	s_adam_search_list_xywh = {80,430,920,242},
	s_adam_add_xywh 		= {800,684,200,33},
	s_adam_devlist_w1		= {80,0,0,0},
	s_adam_devlist_w2		= {150,0,0,0},
	s_adam_devlist_w3		= {260,0,0,0},
	s_adam_devlist_w4		= {260,0,0,0},
	s_adam_devlist_w5		= {120,0,0,0},
}

w1_page_adam.s_1080p = 
{
	s_adam_online_list_xywh = {80,30,1410,345},
	s_adam_onlie_list_w1 	= {80, 0, 0, 0},
	s_adam_onlie_list_w2 	= {200, 0, 0, 0},
	s_adam_onlie_list_w3 	= {300, 0, 0, 0},
	s_adam_onlie_list_w4 	= {300, 0, 0, 0},
	s_adam_onlie_list_w5 	= {500, 0, 0, 0},
	s_adam_del_xywh			= {1290,390,200,40},
	s_adam_hline_xywh 		= {580,450,910,45},
	s_adam_onlinedev_xywh 	= {80,450,300,45},
	s_adam_search_xywh 		= {380,450,200,45}, 
	s_adam_add_xywh 		= {1290,840,200,40},
	s_adam_search_list_xywh = {80,505,1410,320},
	s_adam_devlist_w1 		= {80,0,0,0},
	s_adam_devlist_w2 		= {200,0,0,0},
	s_adam_devlist_w3 		= {400,0,0,0},
	s_adam_devlist_w4 		= {400,0,0,0},
	s_adam_devlist_w5 		= {300,0,0,0},
}

w1_page_adam.s_2k = 
{
	s_adam_online_list_xywh = {106,39,1879,459},
	s_adam_onlie_list_w1 = {106,0,0,0},
	s_adam_onlie_list_w2 = {266,0,0,0},
	s_adam_onlie_list_w3 = {399,0,0,0},
	s_adam_onlie_list_w4 = {399,0,0,0},
	s_adam_onlie_list_w5 = {666,0,0,0},
	s_adam_del_xywh = {1719,519,266,53},
	s_adam_hline_xywh = {773,599,1213,59},
	s_adam_onlinedev_xywh = {106,599,399,59},
	s_adam_search_xywh = {506,599,266,59},
	s_adam_add_xywh = {1719,1119,266,53},
	s_adam_search_list_xywh = {106,673,1879,426},
	s_adam_devlist_w1 = {106,0,0,0},
	s_adam_devlist_w2 = {266,0,0,0},
	s_adam_devlist_w3 = {533,0,0,0},
	s_adam_devlist_w4 = {533,0,0,0},
	s_adam_devlist_w5 = {399,0,0,0},
}

w1_page_adam.s_4k = 
{
	s_adam_online_list_xywh = {160,60,2820,690},
	s_adam_onlie_list_w1 = {160,0,0,0},
	s_adam_onlie_list_w2 = {400,0,0,0},
	s_adam_onlie_list_w3 = {600,0,0,0},
	s_adam_onlie_list_w4 = {600,0,0,0},
	s_adam_onlie_list_w5 = {1000,0,0,0},
	s_adam_del_xywh = {2580,780,400,80},
	s_adam_hline_xywh = {1160,900,1820,90},
	s_adam_onlinedev_xywh = {160,900,600,90},
	s_adam_search_xywh = {760,900,400,90},
	s_adam_add_xywh = {2580,1680,400,80},
	s_adam_search_list_xywh = {160,1010,2820,640},
	s_adam_devlist_w1 = {160,0,0,0},
	s_adam_devlist_w2 = {400,0,0,0},
	s_adam_devlist_w3 = {800,0,0,0},
	s_adam_devlist_w4 = {800,0,0,0},
	s_adam_devlist_w5 = {600,0,0,0},
}

w1_page_adam.timestart = false;
w1_page_adam.searchstart = false;
w1_page_adam.searchcount = 0;
w1_page_adam.searchlist = {};

local cameralist_refresh = function(top, redraw)
	local cwnd = w1_page_adam.wnd;
	local param = b_app_api.get_cfg({'adam'}).adam;
	local camera_num = param.camera_num;
	if(param.camera_num >= 0) then
		camera_num = param.camera_num;
	else
		return 0;
	end
	
	local param_searchlist = {};
	local idx = 1;
	local i;
	
	local data = {};
	
	local dataidx;
	for i=1,camera_num do
		if(param['idx'..i] == nil ) then
			return 0;
		end
		dataidx = 'idx'..idx;
		if(param['idx'..i].status == 0) then
			data[dataidx] = nil;
			data[dataidx] = param['idx'..i];
			idx = idx + 1;
		end
	end
	data.camera_num = idx - 1;
	if(w1_page_adam.searchlist == nil ) then	
		w1_page_adam.searchlist = util.copy_tab(data);
	else
		util.copy_tab_b(w1_page_adam.searchlist, data);
	end

	local searchlist = {};
	searchlist.item_total = idx - 1;
	
	local hide_opera1 = {};
	for i=1,searchlist.item_total do
		local id = tostring(i);
		if (i < 10) then
			id = '0' .. tostring(i)
		end
		hide_opera1[i] = false;
		searchlist['idx'..i] = {i-1, false, '', 
			id, data['idx'..i].ip,
			data['idx'..i].mac, ''};
	end
	
	--ʱ
	for i = searchlist.item_total + 1, 6 do
		hide_opera1[i] = true;
	end
	b_wnd_ex.set_listdata(top, cwnd.devlist.id, searchlist, redraw);
	b_wnd_ex.set_hide_opera1(top,cwnd.devlist.id, hide_opera1,redraw);	
	
end

local delete_all_channels = function(param)
	b_app_api.onekeyadd_camera(param[2]);
	cameralist_refresh(param[1], param[3]);
	w1_page_adam.delete_all_flag = true;
	return 0
end

local on_search = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if w1_page_adam.searchstart then
			w1_page_adam.searchstart = false
			w1_page_adam.searchcount = 0
			b_wnd_ex.set_text(top,w1_page_adam.wnd.search.id,STR('LA_START_SEARCH'),true);
			b_app_api.adam_start_search(0)
		else
			w1_page_adam.searchstart = true
			w1_page_adam.searchcount = 20
			b_app_api.adam_start_search(1)
		end		
	end
	return 0
end

w1_page_adam.init = function(top)
	--һ
	w1_page_adam.searchstart = true
	w1_page_adam.searchcount = 20
	b_app_api.adam_start_search(1)
	local time=w1_page_adam.searchcount;
	local str = STR('LA_STOP_SEARCH') ..'('..time..'s)'
	b_wnd_ex.set_text(top,w1_page_adam.wnd.search.id,str,false);
	return 0;
end

local get_listselect = function(top, win_id, num)
	local checklist = {};
	local param = b_wnd_ex.get_selecelist(top, win_id);
	
	for i=1, 8 do
		checklist[i] = param['r'..i];
	end
	return checklist;
end

local batch_del = function(param)
	local top = param[1];
	local selece_list = param[2];
	local cwnd = w1_page_adam.wnd;
	for i = 1, #selece_list do
		if (selece_list[i] == 1) then
			for k = 1, w1_page_adam.cameralist.camera_num do
				if (w1_page_adam.cameralist['idx'.. k].channel == i) then
					local sel_data = w1_page_adam.cameralist['idx'..k];
					local ret = b_app_api.adam_del_dev(sel_data);
				end
			end
		end
	end
	--δ ִһ
	if false == w1_page_adam.searchstart then
		on_search(top, w1_page_adam.wnd.search.id, b_ui.LBUTTONCLK, 0, 0);
	end		
	b_wnd_ex.clear_checkall(top, w1_page_adam.wnd.onlinelist.id, false, false);
	
	b_dlg.dlg_set_redraw(top);
end

local on_del = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then			
		local cwnd = w1_page_adam.wnd;
		local selece_list = get_listselect(top, cwnd.onlinelist.id, 8);
		local all_zero = true
		for i = 1, #selece_list do
			if (selece_list[i] ~= 0) then
				all_zero = false;
			end
		end	
		
		if (all_zero == true) then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DELETE_ITEM'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)		
			return 0;
		end		
		
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_DELETE'), true, true,false);
		w1_msgbox.set_func(batch_del,{top, selece_list, true}, nil, nil);
		b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
	end
	return 0
end

local on_add = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then	
		local cwnd = w1_page_adam.wnd;
		local selece_list = get_listselect(top, cwnd.devlist.id, w1_page_adam.searchlist.camera_num);
		local all_zero = true
		for i = 1, #selece_list do
			if (selece_list[i] ~= 0) then
				all_zero = false;
				break;
			end
		end	

		if (all_zero == true) then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_UNSELECTED'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)		
			return 0;
		end		
		
		for i = 1, #selece_list do
			if (selece_list[i] == 1) then
				local sel_data = w1_page_adam.searchlist['idx'..i];
				if (sel_data ~= nil) then
					local ret = b_app_api.adam_add_dev(sel_data);
					if (ret == -2) then
						w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_CHANNEL_TIED'), true, false,false);
						w1_msgbox.set_func(nil, nil, nil, nil);
						b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)					
						break;
					end
				end
			end
		end
		--δ ִһ
		if false == w1_page_adam.searchstart then
			on_search(top, w1_page_adam.wnd.search.id, b_ui.LBUTTONCLK, 0, 0);
		end		
		b_wnd_ex.clear_checkall(top, w1_page_adam.wnd.devlist.id, false, false);
		b_dlg.dlg_set_redraw(top);		
	end
	
	return 0
end

w1_page_adam.chrefresh = function(top, redraw)
	local cwnd = w1_page_adam.wnd;
	local ret = b_app_api.get_cfg({'adam_bind'})
	local cameralist = ret.adam_bind; 
	if(w1_page_adam.cameralist == nil ) then	
		w1_page_adam.cameralist = util.copy_tab(cameralist);
	else
		util.copy_tab_b(w1_page_adam.cameralist, cameralist);
	end
	
	local onlinelist = {};
	--ÿһʱбռλ
	onlinelist.item_total =  8;
	for i = 1, onlinelist.item_total do
		onlinelist['idx'..i] = {i-1, false, '', 
			"", 0, "", "", {}};
	end
	
	for i=1,cameralist.camera_num do
		local io_list = {};
		local chn = cameralist['idx'..i].channel;
		for k = 1, cameralist['idx'..i].io_list.num do
			table.insert(io_list,cameralist['idx'..i].io_list['idx'..k].status);
		end
		
		local name = cameralist['idx'..i].dev_name;
		if (name == '') then
			name = 'Do' .. cameralist['idx'..i].channel
		end
		
		onlinelist['idx'..chn] = {chn-1, false, '', 
			name, cameralist['idx'..i].online, cameralist['idx'..i].ip,
			cameralist['idx'..i].mac, io_list};
	end
	b_wnd_ex.set_listdata(top, w1_page_adam.wnd.onlinelist.id, onlinelist, redraw);
end

w1_page_adam.timer_start = function()
	w1_page_adam.timestart = true;
end

w1_page_adam.timer_stop = function()
	w1_page_adam.timestart = false;
end

w1_page_adam.timerenevt = function(top)
	if(w1_page_adam.timestart) then
		w1_page_adam.chrefresh(top, false);
		if(w1_page_adam.searchstart) then
			local time=w1_page_adam.searchcount;
			local str = STR('LA_STOP_SEARCH') ..'('..time..'s)'
			b_wnd_ex.set_text(top,w1_page_adam.wnd.search.id,str,false);
			if 0 == w1_page_adam.searchcount%4 then
				cameralist_refresh(top, false);
			end
			if(w1_page_adam.searchcount == 0) then
				w1_page_adam.searchstart = false
				b_wnd_ex.set_text(top,w1_page_adam.wnd.search.id,STR('LA_START_SEARCH'),false);
				b_app_api.adam_start_search(0)
			else
				w1_page_adam.searchcount = w1_page_adam.searchcount - 1;
			end
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_page_adam.on_pre_show = function(top)
	local onlinelist_w = {};
	
	local param = {
			'', STR('LA_ID'),STR('LA_IP_ADDRESS'),STR('LA_MAC_ADDRESS'),STR('LA_STATUS')
		}	
	b_wnd_ex.set_title_texts(top, w1_page_adam.wnd.onlinelist.id, param, false)
	
	param = {
		'', STR('LA_ID'),STR('LA_IP_ADDRESS'),STR('LA_MAC_ADDRESS'),STR('LA_OPERATE')
		}
	b_wnd_ex.set_title_texts(top, w1_page_adam.wnd.devlist.id, param, false)
	
	for i=1,5 do
		local str = 's_adam_onlie_list_w'..math.floor(i/1);
		onlinelist_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, w1_page_adam.wnd.onlinelist.id, onlinelist_w, false);
	
	local list_w = {};
	for i=1,5 do
		local str = 's_adam_devlist_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, w1_page_adam.wnd.devlist.id, list_w, false);
	
	w1_page_adam.chrefresh(top, false);
	cameralist_refresh(top, false);
end

w1_page_adam.clear_data = function(top)
	w1_page_adam.searchlist = nil;
	w1_page_adam.cameralist = nil;
	b_wnd_ex.clear_checkall(top, w1_page_adam.wnd.onlinelist.id, false, false);
	b_wnd_ex.clear_checkall(top, w1_page_adam.wnd.devlist.id, false, false);
end

w1_page_adam.get_search_list = function(top)
	return w1_page_adam.searchlist;
end

w1_page_adam.get_bind_list = function(top)
	return  w1_page_adam.cameralist;
end

w1_page_adam.update_ilst_data = function()
	w1_page_adam.searchstart = true
	w1_page_adam.searchcount = 20
	b_app_api.adam_start_search(1)
end

w1_page_adam.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'onlinelist', 'del', 'hline', 
			'onlinedev', 'search', 'devlist','add'},
	
	onlinelist 	= {	t='adammanage',id=id+1,	xywh =	's_adam_online_list_xywh',	font = 'f_grade4',
					listattr = {7,5, b_ui.LISTATTR.FIRST_WIDGET_CHECK,b_ui.LISTATTR.END_WIDGET_EDIT}},			
	
	del		= {t='button',	id=id+2,	xywh = 	's_adam_del_xywh', 	text='LA_DELETE',		cmd=on_del},
	
	hline		= {t='hline', 	id=id+3,	xywh =	's_adam_hline_xywh',	color = {'c_camear_line', 'c_camear_line', 'c_camear_line'}},

	onlinedev	= {t='static',	id=id+4,	xywh =	's_adam_onlinedev_xywh',		text='LA_ONLINE_DEVICE',
					color = {'c_camear_line', 'c_camear_line', 'c_txt_n'}},
	
	search	 	= {t='tt_button',id=id+5,	xywh = 	's_adam_search_xywh', 	text='LA_START_SEARCH',
					color = {'c_camear_line', 'c_bor_n', 'c_txt_n'},cmd=on_search},
	
	devlist	 	= {t='list',	id=id+6,	xywh=	's_adam_search_list_xywh', font = 'f_camera_list',
					listattr = {6,5,b_ui.LISTATTR.FIRST_WIDGET_CHECK,b_ui.LISTATTR.END_WIDGET_EDIT},
					dlg_key = {w1_key.DLG_MODIFY_ADAM_IP},
					},		
	add  		= {t='tt_button',id=id+7,	xywh = 	's_adam_add_xywh', 	text='LA_ADD', cmd=on_add},
}

return w1_page_adam

