local global_val= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_api = require("wnd.core.command.b_app_api");
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local util 		= require("wnd.core.util")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_wnd_util = require("wnd.w1_cfg.w1_wnd_util")

local channel_num = 4;
local max_cap_chn_num = 20;
local REF_SPLIT1 	= 1
local REF_SPLIT4 	= 4
local REF_SPLIT8 	= 8
local REF_SPLIT9 	= 9
local REF_SPLIT16 	= 16
local REF_SPLIT32 	= 32
local REF_SPLIT36 	= 36
local REF_SPLIT64 	= 64
local REF_SPLIT128 	= 128
local diplay_off = 0;	--ǰƫ
local timer_time_count = 0;

local id  = w1_id.cfg_out.add_dwell

local w1_page_add_dwell = 
{
	t = w1_key.DLG_ADD_DWELL,
	all_channel_name = nil,
	cfgData,
	original_data,
	default_split = false,	--ĬϷ
	drag_state = 0,
	opt_type = 0,		-- 0Ϊ 1Ϊ༭ ĬΪ
	screen_id = 0,		--ĻID 0Ϊ 1Ϊ
	layout_id = 0,		--ID༭ʱҪʹ ǰ༭ԭбе
	split_cur = 1,
	select_chn = 0,
	cur_check_wnd = nil;
	data_check_illegal = false, --ݼǷ falseϷ trueǷ
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_add_dwell.s_768 =
{
	s_add_dwell_xywh = {0,0,1024,768},
	s_add_dwell_title_xywh = {0,0,1024,56},
	s_add_dwell_titleimg_xywh = {8,8,21,39},
	s_add_dwell_titlestr_xywh = {34,8,800,39},
	s_add_dwell_titleclose_xywh = {992,17,12,17},
		
	s_add_dwell_channelbar_xywh = {0,64,138,704},
	s_add_dwell_channel_xywh = {1,78,128,32},
	s_add_dwell_vline1_xywh = {138,78,1,689},
	s_add_dwell_hline1_xywh = {0,110,1024,1},
	s_add_dwell_cap_name_xywh = {149,71,160,32},
	s_add_dwell_t_name_xywh = {330,71,160,28},
	s_add_dwell_cap_time_xywh = {533,71,160,32},
	s_add_dwell_t_time_xywh = {704,71,106,28},

	s_add_dwell_ch1_xywh = {1,120,126,32},
	s_add_dwell_ch2_xywh = {1,152,126,32},
	s_add_dwell_ch3_xywh = {1,184,126,32},
	s_add_dwell_ch4_xywh = {1,216,126,32},
	s_add_dwell_ch5_xywh = {1,248,126,32},
	s_add_dwell_ch6_xywh = {1,280,126,32},
	s_add_dwell_ch7_xywh = {1,312,126,32},
	s_add_dwell_ch8_xywh = {1,344,126,32},
	s_add_dwell_ch9_xywh = {1,376,126,32},
	s_add_dwell_ch10_xywh = {1,408,126,32},
	s_add_dwell_ch11_xywh = {1,440,126,32},
	s_add_dwell_ch12_xywh = {1,472,126,32},
	s_add_dwell_ch13_xywh = {1,504,126,32},
	s_add_dwell_ch14_xywh = {1,536,126,32},
	s_add_dwell_ch15_xywh = {1,568,126,32},
	s_add_dwell_ch16_xywh = {1,600,126,32},
	s_add_dwell_ch17_xywh = {1,632,126,32},
	s_add_dwell_ch18_xywh = {1,664,126,32},
	s_add_dwell_ch19_xywh = {1,696,126,32},
	s_add_dwell_ch20_xywh = {1,728,126,32},
	s_add_dwell_vdrop_xywh = {128,115,10,647},

	s_add_dwell_wnd_xywh = {149,120,75,56},
	s_add_dwell_split1_xywh = {149,120,842,540},
	s_add_dwell_split4_xywh = {149,120,418,266},
	s_add_dwell_split8_1_xywh = {149,120,628,397},
	s_add_dwell_split8_7_xywh = {149,120,206,129},
	s_add_dwell_split9_xywh = {149,120,277,174},
	s_add_dwell_split16_xywh = {149,120,206,129},
	s_add_dwell_split32_4_xywh = {149,120,312,198},
	s_add_dwell_split32_28_xywh = {149,120,102,64},
	s_add_dwell_split36_xywh = {149,120,138,86},
	s_add_dwell_split64_xywh = {149,120,102,64},
		
	s_add_dwell_split6_1_xywh = {149,120,560,356},
	s_add_dwell_split6_5_xywh = {149,120,277,174},

	s_add_dwell_split10_2_xywh = {149,120,417,263},
	s_add_dwell_split10_8_xywh = {149,120,206,129},
	s_add_dwell_split13_1_xywh = {149,120,417,263},
	s_add_dwell_split13_12_xywh = {149,120,206,129},
	
	s_add_dwell_split24_4_xywh = {149,120,279,175},
	s_add_dwell_split24_20_xywh = {149,120,138,86},
	s_add_dwell_split25_xywh = {149,120,166,105},

	s_add_dwell_split1_btn_xywh = {149,675,17,22},
	s_add_dwell_split4_btn_xywh = {176,675,17,22},
	s_add_dwell_split8_btn_xywh = {202,675,17,22},
	s_add_dwell_split9_btn_xywh = {229,675,17,22},
	s_add_dwell_split16_btn_xywh = {256,675,17,22},
	s_add_dwell_split32_btn_xywh = {282,675,17,22},
	s_add_dwell_split36_btn_xywh = {309,675,17,22},
	s_add_dwell_split64_btn_xywh = {336,675,17,22},
		
	s_add_dwell_wnd_pace = {5,3,0,0},
	s_add_dwell_tipinfo_xywh = {149,711,700,35},
	s_add_dwell_apply_xywh = {853,711,64,28},
	s_add_dwell_clear_xywh = {928,711,64,28},
	
};

w1_page_add_dwell.s_1280 = 
{
	s_add_dwell_xywh = {0,0,1280,1024},
	s_add_dwell_title_xywh = {0, 0, 1280, 80},
	s_add_dwell_titleimg_xywh = {15,12,40,56},
	s_add_dwell_titlestr_xywh = {65,12,1000,56},
	s_add_dwell_titleclose_xywh = {1220,25,24,24},

	s_add_dwell_channelbar_xywh = {0, 90, 260, 930},
	s_add_dwell_channel_xywh = {1,110,240,40},
	s_add_dwell_vline1_xywh = {260,110,1,914},
	s_add_dwell_hline1_xywh = {0,150,1280,2},
	s_add_dwell_cap_name_xywh = {280, 100, 200, 45},
	s_add_dwell_t_name_xywh	= {480, 100, 200, 40},
	s_add_dwell_cap_time_xywh = {680,100,200,45},
	s_add_dwell_t_time_xywh = {880,100,200,40},	
	
	s_add_dwell_ch1_xywh = {1,160,238,43},
	s_add_dwell_ch2_xywh = {1,203,238,43},
	s_add_dwell_ch3_xywh = {1,246,238,43},
	s_add_dwell_ch4_xywh = {1,289,238,43},
	s_add_dwell_ch5_xywh = {1,332,238,43},
	s_add_dwell_ch6_xywh = {1,375,238,43},
	s_add_dwell_ch7_xywh = {1,418,238,43},
	s_add_dwell_ch8_xywh = {1,461,238,43},
	s_add_dwell_ch9_xywh = {1,504,238,43},
	s_add_dwell_ch10_xywh = {1,547,238,43},
	s_add_dwell_ch11_xywh = {1,590,238,43},
	s_add_dwell_ch12_xywh = {1,633,238,43},
	s_add_dwell_ch13_xywh = {1,676,238,43},
	s_add_dwell_ch14_xywh = {1,719,238,43},
	s_add_dwell_ch15_xywh = {1,762,238,43},
	s_add_dwell_ch16_xywh = {1,805,238,43},
	s_add_dwell_ch17_xywh = {1,848,238,43},
	s_add_dwell_ch18_xywh = {1,891,238,43},
	s_add_dwell_ch19_xywh = {1,934,238,43},
	s_add_dwell_ch20_xywh = {1,977,238,43},
	s_add_dwell_vdrop_xywh = {240,162,20,856},
	
	s_add_dwell_wnd_xywh = {280,160,232,180},	
	s_add_dwell_split1_xywh = {280,160,960,750},
	s_add_dwell_split4_xywh = {280,160,475,370},
	s_add_dwell_split8_1_xywh = {280,160,716,560},
	s_add_dwell_split8_7_xywh = {280,160,232,180},
	s_add_dwell_split9_xywh = {280,160,313,243},
	s_add_dwell_split16_xywh = {280,160,232,180},
	s_add_dwell_split32_4_xywh = {280,160,355,277},
	s_add_dwell_split32_28_xywh = {280,160, 115, 89},
	s_add_dwell_split36_xywh = {280, 160, 155, 120}, 
	s_add_dwell_split64_xywh = {280, 160, 115, 89},
	s_add_dwell_split6_1_xywh = {280,160,636,496},
	s_add_dwell_split6_5_xywh = {280,160,313,243},
	
	s_add_dwell_split10_2_xywh = {280,160,474,370},
	s_add_dwell_split10_8_xywh = {280,160,232,180},
	s_add_dwell_split13_1_xywh = {280,160,474,370},
	s_add_dwell_split13_12_xywh = {280,160,232,180},
	
	s_add_dwell_split24_4_xywh = {280, 160, 315, 245},
	s_add_dwell_split24_20_xywh = {280, 160, 155, 120},
	s_add_dwell_split25_xywh = {280, 160, 188, 141},

	s_add_dwell_split1_btn_xywh = {280,920,32,32},
	s_add_dwell_split4_btn_xywh = {330,920,32,32},
	s_add_dwell_split8_btn_xywh = {380,920,32,32},
	s_add_dwell_split9_btn_xywh = {430,920,32,32},
	s_add_dwell_split16_btn_xywh = {480,920,32,32},
	s_add_dwell_split32_btn_xywh = {530,920,32,32},
	s_add_dwell_split36_btn_xywh = {580,920,32,32},	
	s_add_dwell_split64_btn_xywh = {630,920,32,32},	
	
	s_add_dwell_wnd_pace 	= {10, 5, 0, 0},	
	s_add_dwell_tipinfo_xywh = {280,960,695,50},
	s_add_dwell_apply_xywh = {980,960,120,40},
	s_add_dwell_clear_xywh = {1120,960,120,40},	
}

w1_page_add_dwell.s_1440 = 
{
	s_add_dwell_xywh = {0,0,1440,900},
	s_add_dwell_title_xywh = {0, 0, 1440, 80},
	s_add_dwell_titleimg_xywh = {15,12,40,56},
	s_add_dwell_titlestr_xywh = {65,12,1300,56},
	s_add_dwell_titleclose_xywh = {1380,25,24,24},
	
	s_add_dwell_channelbar_xywh = {0, 90, 260, 810},
	s_add_dwell_channel_xywh = {1,100,238,35},
	s_add_dwell_vline1_xywh = {260,100,1,800},
	s_add_dwell_hline1_xywh = {0,135,1440,2},
	s_add_dwell_cap_name_xywh = {280, 95, 200, 38},
	s_add_dwell_t_name_xywh	= {480, 95, 200, 35},
	s_add_dwell_cap_time_xywh = {680,95,200,38},
	s_add_dwell_t_time_xywh = {880,95,200,35},		
	
	s_add_dwell_ch1_xywh = {1,150,238,37},
	s_add_dwell_ch2_xywh = {1,187,238,37},
	s_add_dwell_ch3_xywh = {1,224,238,37},
	s_add_dwell_ch4_xywh = {1,261,238,37},
	s_add_dwell_ch5_xywh = {1,298,238,37},
	s_add_dwell_ch6_xywh = {1,335,238,37},
	s_add_dwell_ch7_xywh = {1,372,238,37},
	s_add_dwell_ch8_xywh = {1,409,238,37},
	s_add_dwell_ch9_xywh = {1,446,238,37},
	s_add_dwell_ch10_xywh = {1,483,238,37},
	s_add_dwell_ch11_xywh = {1,520,238,37},
	s_add_dwell_ch12_xywh = {1,557,238,37},
	s_add_dwell_ch13_xywh = {1,594,238,37},
	s_add_dwell_ch14_xywh = {1,631,238,37},
	s_add_dwell_ch15_xywh = {1,668,238,37},
	s_add_dwell_ch16_xywh = {1,705,238,37},
	s_add_dwell_ch17_xywh = {1,742,238,37},
	s_add_dwell_ch18_xywh = {1,779,238,37},
	s_add_dwell_ch19_xywh = {1,816,238,37},
	s_add_dwell_ch20_xywh = {1,853,238,37},	
	s_add_dwell_vdrop_xywh = {240,142,20,748},
	
	s_add_dwell_wnd_xywh = {280,150,272, 152},
	s_add_dwell_split1_xywh = {280,150,1120,640},
	s_add_dwell_split4_xywh = {280,150,555,315},
	s_add_dwell_split8_1_xywh = {280,150,836,476},
	s_add_dwell_split8_7_xywh = {280,150,272,152},
	s_add_dwell_split9_xywh = {280,150,366,206},
	s_add_dwell_split16_xywh = {280,150,272,152},
	s_add_dwell_split32_4_xywh = {280,150,415,235},
	s_add_dwell_split32_28_xywh = {280,150, 135, 75},
	s_add_dwell_split36_xywh = {280,150, 182, 102}, 
	s_add_dwell_split64_xywh = {280,150, 135, 75},	
	s_add_dwell_split6_1_xywh = {280, 150, 742, 422},
	s_add_dwell_split6_5_xywh = {280, 150, 366, 206},

	s_add_dwell_split10_2_xywh = {280,150,554,314},
	s_add_dwell_split10_8_xywh = {280,150,272,152},
	s_add_dwell_split13_1_xywh = {280,150,554,314},
	s_add_dwell_split13_12_xywh = {280,150,272,152},
	
	
	s_add_dwell_split24_4_xywh = {280, 150, 369, 209},
	s_add_dwell_split24_20_xywh = {280, 150, 182, 102},
	s_add_dwell_split25_xywh = {280, 150, 220, 124},
	
	s_add_dwell_split1_btn_xywh = {280,800,32,32},
	s_add_dwell_split4_btn_xywh = {330,800,32,32},
	s_add_dwell_split8_btn_xywh = {380,800,32,32},
	s_add_dwell_split9_btn_xywh = {430,800,32,32},
	s_add_dwell_split16_btn_xywh = {480,800,32,32},
	s_add_dwell_split32_btn_xywh = {530,800,32,32},
	s_add_dwell_split36_btn_xywh = {580,800,32,32},	
	s_add_dwell_split64_btn_xywh = {630,800,32,32},
	
	s_add_dwell_wnd_pace 	= {10, 5, 0, 0},	
	s_add_dwell_tipinfo_xywh = {280,840,850,50},
	s_add_dwell_apply_xywh = {1140,840,120,40},
	s_add_dwell_clear_xywh = {1280,840,120,40},	
}

w1_page_add_dwell.s_1080p = 
{
	s_add_dwell_xywh = {0,0,1920,1080},
	s_add_dwell_title_xywh = {0, 0, 1920, 80},
	s_add_dwell_titleimg_xywh = {15,12,40,56},
	s_add_dwell_titlestr_xywh = {65,12,1500,56},
	s_add_dwell_titleclose_xywh = {1860,25,24,24},
	
	s_add_dwell_channelbar_xywh = {0, 90, 260, 990},
	s_add_dwell_channel_xywh = {1,110,240,45},
	s_add_dwell_vline1_xywh = {260,110,1,970},
	s_add_dwell_hline1_xywh = {0,155,1920,2},
	s_add_dwell_cap_name_xywh = {280, 100, 300, 45},
	s_add_dwell_t_name_xywh	= {620, 100, 300, 40},
	s_add_dwell_cap_time_xywh = {1000,100,300,45},
	s_add_dwell_t_time_xywh = {1320,100,200,40},	

	s_add_dwell_ch1_xywh = {1,170,238,45},
	s_add_dwell_ch2_xywh = {1,215,238,45},
	s_add_dwell_ch3_xywh = {1,260,238,45},
	s_add_dwell_ch4_xywh = {1,305,238,45},
	s_add_dwell_ch5_xywh = {1,350,238,45},
	s_add_dwell_ch6_xywh = {1,395,238,45},
	s_add_dwell_ch7_xywh = {1,440,238,45},
	s_add_dwell_ch8_xywh = {1,485,238,45},
	s_add_dwell_ch9_xywh = {1,530,238,45},
	s_add_dwell_ch10_xywh = {1,575,238,45},
	s_add_dwell_ch11_xywh = {1,620,238,45},
	s_add_dwell_ch12_xywh = {1,665,238,45},
	s_add_dwell_ch13_xywh = {1,710,238,45},
	s_add_dwell_ch14_xywh = {1,755,238,45},
	s_add_dwell_ch15_xywh = {1,800,238,45},
	s_add_dwell_ch16_xywh = {1,845,238,45},
	s_add_dwell_ch17_xywh = {1,890,238,45},
	s_add_dwell_ch18_xywh = {1,935,238,45},
	s_add_dwell_ch19_xywh = {1,980,238,45},
	s_add_dwell_ch20_xywh = {1,1025,238,45},
	s_add_dwell_vdrop_xywh = {240,162,20,910},

	s_add_dwell_wnd_xywh = {280, 170, 142, 80}, 
	s_add_dwell_split1_xywh = {280, 170, 1580, 760}, 
	s_add_dwell_split4_xywh = {280, 170, 785, 375}, 
	s_add_dwell_split8_1_xywh = {280, 170, 1181, 566},
	s_add_dwell_split8_7_xywh = {280, 170, 387, 182},
	s_add_dwell_split9_xywh = {280, 170, 520, 246}, 
	s_add_dwell_split16_xywh = {280, 170, 387, 182},
	s_add_dwell_split32_4_xywh = {280, 170, 589, 280},
	s_add_dwell_split32_28_xywh = {280, 170, 193, 90},
	s_add_dwell_split36_xywh = {280, 170, 259, 122}, 
	s_add_dwell_split64_xywh = {280, 170, 193, 90},	
	
	s_add_dwell_split6_1_xywh = {280, 170, 1050, 502},
	s_add_dwell_split6_5_xywh = {280, 170, 520, 246},
	
	s_add_dwell_split10_2_xywh = {280, 170, 784, 378},
	s_add_dwell_split10_8_xywh = {280, 170, 387, 182},
	s_add_dwell_split13_1_xywh = {280, 170, 784, 378},
	s_add_dwell_split13_12_xywh = {280, 170, 387, 182},
	
	s_add_dwell_split24_4_xywh = {280, 170, 523, 249},
	s_add_dwell_split24_20_xywh = {280, 170, 259, 122},
	s_add_dwell_split25_xywh = {280, 170, 312, 148},

	s_add_dwell_split1_btn_xywh = {280,950,32,32},
	s_add_dwell_split4_btn_xywh = {330,950,32,32},
	s_add_dwell_split8_btn_xywh = {380,950,32,32},
	s_add_dwell_split9_btn_xywh = {430,950,32,32},
	s_add_dwell_split16_btn_xywh = {480,950,32,32},
	s_add_dwell_split32_btn_xywh = {530,950,32,32},
	s_add_dwell_split36_btn_xywh = {580,950,32,32},	
	s_add_dwell_split64_btn_xywh = {630,950,32,32},			
	
	s_add_dwell_wnd_pace 	= {10, 5, 0, 0},	
	s_add_dwell_tipinfo_xywh = {280,1000,1300,50},
	s_add_dwell_apply_xywh = {1600,1000,120,40},
	s_add_dwell_clear_xywh = {1740,1000,120,40},	
}

w1_page_add_dwell.s_2k = 
{
	s_add_dwell_xywh = {0,0,2559,1439},
	s_add_dwell_title_xywh = {0,0,2559,106},
	s_add_dwell_titleimg_xywh = {19,15,53,74},
	s_add_dwell_titlestr_xywh = {86,15,1999,74},
	s_add_dwell_titleclose_xywh = {2479,33,31,31},
		
	s_add_dwell_channelbar_xywh = {0,119,346,1319},
	s_add_dwell_channel_xywh = {1,146,319,59},
	s_add_dwell_vline1_xywh = {346,146,1,1293},
	s_add_dwell_hline1_xywh = {0,205,2559,2},
	s_add_dwell_cap_name_xywh = {373,133,399,59},
	s_add_dwell_t_name_xywh = {826,133,399,53},
	s_add_dwell_cap_time_xywh = {1333,133,399,59},
	s_add_dwell_t_time_xywh = {1759,133,266,53},

	s_add_dwell_ch1_xywh = {1,226,319,59},
	s_add_dwell_ch2_xywh = {1,286,319,59},
	s_add_dwell_ch3_xywh = {1,346,319,59},
	s_add_dwell_ch4_xywh = {1,406,319,59},
	s_add_dwell_ch5_xywh = {1,466,319,59},
	s_add_dwell_ch6_xywh = {1,526,319,59},
	s_add_dwell_ch7_xywh = {1,586,319,59},
	s_add_dwell_ch8_xywh = {1,646,319,59},
	s_add_dwell_ch9_xywh = {1,706,319,59},
	s_add_dwell_ch10_xywh = {1,766,319,59},
	s_add_dwell_ch11_xywh = {1,826,319,59},
	s_add_dwell_ch12_xywh = {1,886,319,59},
	s_add_dwell_ch13_xywh = {1,946,319,59},
	s_add_dwell_ch14_xywh = {1,1006,319,59},
	s_add_dwell_ch15_xywh = {1,1066,319,59},
	s_add_dwell_ch16_xywh = {1,1126,319,59},
	s_add_dwell_ch17_xywh = {1,1186,319,59},
	s_add_dwell_ch18_xywh = {1,1246,319,59},
	s_add_dwell_ch19_xywh = {1,1306,319,59},
	s_add_dwell_ch20_xywh = {1,1366,319,59},
	s_add_dwell_vdrop_xywh = {319,215,26,1213},

	s_add_dwell_wnd_xywh = {373,226,189,106},
	s_add_dwell_split1_xywh = {373,226,2106,1013},
	s_add_dwell_split4_xywh = {373,226,1046,499},
	s_add_dwell_split8_1_xywh = {373,226,1571,754},
	s_add_dwell_split8_7_xywh = {373,226,515,242},
	s_add_dwell_split9_xywh = {373,226,693,327},
	s_add_dwell_split16_xywh = {373,226,515,242},
	s_add_dwell_split32_4_xywh = {373,226,785,373},
	s_add_dwell_split32_28_xywh = {373,226,257,119},
	s_add_dwell_split36_xywh = {373,226,345,162},
	s_add_dwell_split64_xywh = {373,226,257,119},
		
	s_add_dwell_split6_1_xywh = {373,226,1399,669},
	s_add_dwell_split6_5_xywh = {373,226,693,327},

	s_add_dwell_split10_2_xywh = {373,226,1043,499},
	s_add_dwell_split10_8_xywh = {373,226,515,242},
	s_add_dwell_split13_1_xywh = {373,226,1043,499},
	s_add_dwell_split13_12_xywh = {373,226,515,242},
	
	s_add_dwell_split24_4_xywh = {373,226,696,331},
	s_add_dwell_split24_20_xywh = {373,226,345,162},
	s_add_dwell_split25_xywh = {373,226,415,197},

	s_add_dwell_split1_btn_xywh = {373,1266,42,42},
	s_add_dwell_split4_btn_xywh = {439,1266,42,42},
	s_add_dwell_split8_btn_xywh = {506,1266,42,42},
	s_add_dwell_split9_btn_xywh = {573,1266,42,42},
	s_add_dwell_split16_btn_xywh = {639,1266,42,42},
	s_add_dwell_split32_btn_xywh = {706,1266,42,42},
	s_add_dwell_split36_btn_xywh = {773,1266,42,42},
	s_add_dwell_split64_btn_xywh = {839,1266,42,42},
		
	s_add_dwell_wnd_pace = {13,6,0,0},
	s_add_dwell_tipinfo_xywh = {373,1333,1700,66},
	s_add_dwell_apply_xywh = {2132,1333,159,53},
	s_add_dwell_clear_xywh = {2319,1333,159,53},
}

w1_page_add_dwell.s_4k = 
{
	s_add_dwell_xywh = {0,0,3840,2160},
	s_add_dwell_title_xywh = {0,0,3840,160},
	s_add_dwell_titleimg_xywh = {30,24,80,112},
	s_add_dwell_titlestr_xywh = {130,24,3000,112},
	s_add_dwell_titleclose_xywh = {3720,50,48,48},
	
	s_add_dwell_channelbar_xywh = {0,180,520,1980},
	s_add_dwell_channel_xywh = {2,220,480,90},
	s_add_dwell_vline1_xywh = {520,220,2,1940},
	s_add_dwell_hline1_xywh = {0,310,3840,4},
	s_add_dwell_cap_name_xywh = {560,200,600,90},
	s_add_dwell_t_name_xywh = {1240,200,600,80},
	s_add_dwell_cap_time_xywh = {2000,200,600,90},
	s_add_dwell_t_time_xywh = {2640,200,400,80},

	s_add_dwell_ch1_xywh = {2,340,476,90},
	s_add_dwell_ch2_xywh = {2,430,476,90},
	s_add_dwell_ch3_xywh = {2,520,476,90},
	s_add_dwell_ch4_xywh = {2,610,476,90},
	s_add_dwell_ch5_xywh = {2,700,476,90},
	s_add_dwell_ch6_xywh = {2,790,476,90},
	s_add_dwell_ch7_xywh = {2,880,476,90},
	s_add_dwell_ch8_xywh = {2,970,476,90},
	s_add_dwell_ch9_xywh = {2,1060,476,90},
	s_add_dwell_ch10_xywh = {2,1150,476,90},
	s_add_dwell_ch11_xywh = {2,1240,476,90},
	s_add_dwell_ch12_xywh = {2,1330,476,90},
	s_add_dwell_ch13_xywh = {2,1420,476,90},
	s_add_dwell_ch14_xywh = {2,1510,476,90},
	s_add_dwell_ch15_xywh = {2,1600,476,90},
	s_add_dwell_ch16_xywh = {2,1690,476,90},
	s_add_dwell_ch17_xywh = {2,1780,476,90},
	s_add_dwell_ch18_xywh = {2,1870,476,90},
	s_add_dwell_ch19_xywh = {2,1960,476,90},
	s_add_dwell_ch20_xywh = {2,2050,476,90},
	s_add_dwell_vdrop_xywh = {480,324,40,1820},

	s_add_dwell_wnd_xywh = {560,340,284,160},
	s_add_dwell_split1_xywh = {560,340,3160,1520},
	s_add_dwell_split4_xywh = {560,340,1570,750},
	s_add_dwell_split8_1_xywh = {560,340,2362,1132},
	s_add_dwell_split8_7_xywh = {560,340,774,364},
	s_add_dwell_split9_xywh = {560,340,1040,492},
	s_add_dwell_split16_xywh = {560,340,774,364},
	s_add_dwell_split32_4_xywh = {560,340,1178,560},
	s_add_dwell_split32_28_xywh = {560,340,386,180},
	s_add_dwell_split36_xywh = {560,340,518,244},
	s_add_dwell_split64_xywh = {560,340,386,180},
		
	s_add_dwell_split6_1_xywh = {560,340,2100,1004},
	s_add_dwell_split6_5_xywh = {560,340,1040,492},
	
	s_add_dwell_split10_2_xywh = {560,340,1568,748},
	s_add_dwell_split10_8_xywh = {560,340,774,364},
	s_add_dwell_split13_1_xywh = {560,340,1568,748},
	s_add_dwell_split13_12_xywh = {560,340,774,364},
	
	s_add_dwell_split24_4_xywh = {560,340,1046,498},
	s_add_dwell_split24_20_xywh = {560,340,518,244},
	s_add_dwell_split25_xywh = {560,340,624,296},

	s_add_dwell_split1_btn_xywh = {560,1900,64,64},
	s_add_dwell_split4_btn_xywh = {660,1900,64,64},
	s_add_dwell_split8_btn_xywh = {760,1900,64,64},
	s_add_dwell_split9_btn_xywh = {860,1900,64,64},
	s_add_dwell_split16_btn_xywh = {960,1900,64,64},
	s_add_dwell_split32_btn_xywh = {1060,1900,64,64},
	s_add_dwell_split36_btn_xywh = {1160,1900,64,64},
	s_add_dwell_split64_btn_xywh = {1260,1900,64,64},
		
	s_add_dwell_wnd_pace = {20,10,0,0},
	s_add_dwell_tipinfo_xywh = {560,2000,2600,100},
	s_add_dwell_apply_xywh = {3200,2000,240,80},
	s_add_dwell_clear_xywh = {3480,2000,240,80},	
}

local decode_mode = 0;
w1_page_add_dwell.clear_data = function()
	w1_page_add_dwell.original_data = nil;
	w1_page_add_dwell.cfgData = nil;
	w1_page_add_dwell.drag_state = 0;
	w1_page_add_dwell.split_cur = 1;
	w1_page_add_dwell.select_chn = 0;
	w1_page_add_dwell.opt_type = 0;
	w1_page_add_dwell.all_channel_name	= nil;
	w1_page_add_dwell.data_check_illegal = false
	w1_page_add_dwell.default_split = false;
	w1_page_add_dwell.screen_id = 0;
	w1_page_add_dwell.layout_id = 0;
	w1_page_add_dwell.cur_check_wnd = id + 41;
	diplay_off = 0;
	timer_time_count = 0;
	dec_num = 0;
end	

local setTipInfo = function(top, text, redraw)
	timer_time_count = 3; --ִζʱ
	b_wnd_ex.set_text(top, w1_page_add_dwell.dlg.tipinfo.id, text, redraw);
end	

local set_default_cfg = function(top)
	w1_page_add_dwell.cfgData = {
		name = "",
		poll_interval = 5,
		dev_type = 4,
		win_num = 4,
		win_list_info = {
			win1 = {},
			win2 = {},
			win3 = {},
			win4 = {},
		}
	}	
		
	w1_page_add_dwell.original_data = util.copy_tab(w1_page_add_dwell.cfgData);
end

local set_wnd_chn_info = function(top, id, data, redraw)
	local chn_list = {};
	local chn_name = {};
	local max_count = global_val.get_channelnum() + 1;
	for i = 1, #data do
		table.insert(chn_list, data[i]);
		if (data[i] == 0) then
			table.insert(chn_name, w1_page_add_dwell.all_channel_name[max_count]);
		else
			table.insert(chn_name, w1_page_add_dwell.all_channel_name[data[i]]);
		end
	end	
	
	local wnd_data = {chn_num_list = chn_list, chn_name_list = chn_name};
	b_wnd_ex.set_dwell_wnd_data(top, id, wnd_data, redraw);
end

--жͨǷǷ 0Ϸ 1֮ͨ佻 2 ͨ
local check_channel_illege = function(top, ch_num, item)
	local count = w1_page_add_dwell.cfgData.win_num;
	for k, v in pairs(w1_page_add_dwell.cfgData.win_list_info) do
		if (type(v) == "table" and item ~= k) then
			for key, value in pairs(v) do
				if (value == ch_num) then
					return 1;	
				end
			end
		end		
	end
	
	local max_cnt = channel_num * 2;
	local count = 0;
	for k, v in pairs(w1_page_add_dwell.cfgData.win_list_info) do
		if (type(v) == "table") then
			for key, value in pairs(v) do
				if (value ~= nil) then
					count = count + 1;
				end
			end
		end		
	end
	
	if (count >= max_cnt) then
		return 2;
	end	
	
	return 0;
end	

local add_channel = function(top, child_id, ch_num, redraw)
	--ͨǷ	
	local item = "win" .. tostring(child_id - id - 40);
	local max_count = global_val.get_channelnum() + 1;
	local ret = check_channel_illege(top, ch_num, item);
	
	if (ch_num == max_count and ret ~= 2) then
		table.insert(w1_page_add_dwell.cfgData.win_list_info[item], 0);
		set_wnd_chn_info(top, child_id, w1_page_add_dwell.cfgData.win_list_info[item], redraw);
		return ;
	end
	
	if (ret == 0) then
		table.insert(w1_page_add_dwell.cfgData.win_list_info[item], ch_num);
		set_wnd_chn_info(top, child_id, w1_page_add_dwell.cfgData.win_list_info[item], redraw);
	elseif (ret == 1) then --ʾͨ
		setTipInfo(top, STR("LA_CHN_CROSS_TIP"), true)	
	elseif (ret == 2) then --ʾͨ
		setTipInfo(top, STR("LA_CHN_MAX_TIP"), true)
	end
end	

local clear_wnd_data = function(top,splittype)
	util.clear_tab(w1_page_add_dwell.cfgData.win_list_info);
	w1_page_add_dwell.cfgData.win_list_info = nil;

	local count  = splittype;
	if (8 == splittype and channel_num == 6) then
		count = 6;
	elseif (9 == splittype and channel_num == 8) then
		count = 8;
	elseif (16 == splittype and channel_num == 10) then
		count = 10;	
	elseif (16 == splittype and channel_num == 12) then
		count = 12;			
	elseif (32 == splittype and channel_num == 24) then
		count = 24;
	elseif (36 == splittype and channel_num == 24) then
		count = 24;
	elseif (36 == splittype and channel_num == 32) then		
		count = 32
	end		
	
	if (count > channel_num) then
		count = channel_num;
	end	
	
	w1_page_add_dwell.cfgData.win_list_info = {};
	for i = 1, count do
		local item = "win" .. tostring(i);
		w1_page_add_dwell.cfgData.win_list_info[item] = {};
	end
	w1_page_add_dwell.cfgData.win_num = count;
end

--лģʽ
local cutsplit = function(top, splittype, redraw)
	assert(splittype == 1 or splittype == 4 or splittype == 8 or splittype == 9 or splittype == 16 or 
	splittype == 32 or splittype == 36 or splittype == 64 or splittype == 128)
	local cfgData = w1_page_add_dwell.cfgData;
	cfgData.dev_type = splittype
	
	local count  = splittype;
	if (8 == splittype and channel_num == 6) then
		count = 6;
	elseif (9 == splittype and channel_num == 8) then
		count = 8;
	elseif (16 == splittype and channel_num == 10) then
		count = 10;	
	elseif (16 == splittype and channel_num == 12) then
		count = 12;			
	elseif (32 == splittype and channel_num == 20) then
		count = 20;
	elseif (36 == splittype and channel_num == 20) then
		count = 20;
	elseif (32 == splittype and channel_num == 24) then
		count = 24;
	elseif (36 == splittype and channel_num == 24) then
		count = 24;
	elseif (36 == splittype and channel_num == 32) then		
		count = 32
	end		
	
	if (count > channel_num) then
		count = channel_num;
	end

	for i = 1, count do
		b_wnd_ex.set_hide(top, id + 40 + i, false, false)
	end
	for i = count + 1, 64 do
		b_wnd_ex.set_hide(top, id + 40 + i, true, false)
	end
	
	local wnd_space =  SIZE('s_add_dwell_wnd_pace');
	
	local wndsize;
	if(splittype == REF_SPLIT1) then
		wndsize = SIZE('s_add_dwell_split1_xywh');
		b_wnd_ex.move_ex(top, id + 40 + 1, {wndsize[1], wndsize[2], wndsize[3], wndsize[4]}, false)
		local item = "win" .. tostring(1);
		set_wnd_chn_info(top, id + 40 + 1, cfgData.win_list_info[item], false);		
	elseif(splittype == REF_SPLIT4) then
		wndsize = SIZE('s_add_dwell_split4_xywh');
		local i;
		local cx = wndsize[3];
		local cy = wndsize[4];
		local rowcolumn = wnd_space[1];
		for i = 1, count do
			local row, column;
			row = math.modf((i - 1) / 2);
			column = (i - 1) - math.floor( (i - 1) / 2) * 2
			local x = wndsize[1] + column  * cx + column * rowcolumn;
			local y = wndsize[2] + row  * cy + row * rowcolumn;
			b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
			local item = "win" .. tostring(i);
			set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);
		end
	elseif(splittype == REF_SPLIT8) then
		if (channel_num == 6) then --6·⴦6
			wndsize = SIZE('s_add_dwell_split6_1_xywh');
			b_wnd_ex.move_ex(top, id + 41, wndsize, false)
			local item = "win" .. tostring(1);
			set_wnd_chn_info(top, id + 41, cfgData.win_list_info[item], false);			
			local wndsize6_5 = SIZE('s_add_dwell_split6_5_xywh');
			local cx = wndsize6_5[3];
			local cy = wndsize6_5[4];
			local rowcolumn = wnd_space[1];
			for i = 2,3 do
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+wndsize[3]+rowcolumn,wndsize[2]+(i-2)*(cy+rowcolumn), cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);
			end
			for i = 4, count do
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);			
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+(i-4)*(cx+rowcolumn),wndsize[2]+wndsize[4]+rowcolumn, cx, cy}, false)
			end
		else
			wndsize = SIZE('s_add_dwell_split8_1_xywh');
			b_wnd_ex.move_ex(top, id + 41, wndsize, false)
			local item = "win" .. tostring(1);
			set_wnd_chn_info(top, id + 41, cfgData.win_list_info[item], false);				
			local wndsize8_7 = SIZE('s_add_dwell_split8_7_xywh');
			local cx = wndsize8_7[3];
			local cy = wndsize8_7[4];
			local rowcolumn = wnd_space[1];
			for i = 2,4 do
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+wndsize[3]+rowcolumn,wndsize[2]+(i-2)*(cy+rowcolumn), cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end
			for i = 5, count do
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+(i-5)*(cx+rowcolumn),wndsize[2]+wndsize[4]+rowcolumn, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end
		end
	elseif(splittype == REF_SPLIT9) then
		wndsize = SIZE('s_add_dwell_split9_xywh');
		local i;
		local cx = wndsize[3];
		local cy = wndsize[4];
		local rowcolumn = wnd_space[1];
		for i = 1, count do
			local row, column;
			row = math.modf((i - 1) / 3);
			column = (i - 1) - math.floor( (i - 1) / 3) * 3
			local x = wndsize[1] + column  * cx + column * rowcolumn;
			local y = wndsize[2] + row  * cy + row * rowcolumn;
			b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
			local item = "win" .. tostring(i);
			set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);				
		end
	elseif(splittype == REF_SPLIT16) then	
		if (channel_num == 10) then --10·⴦10
			wndsize = SIZE('s_add_dwell_split10_2_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn = wnd_space[1];
			for i = 1, 2 do
				local row, column;
				row = math.modf((i - 1) / 2);
				column = (i - 1) - math.floor( (i - 1) / 2) * 2
				local x = wndsize[1] + column  * cx + column * rowcolumn;
				local y = wndsize[2] + row  * cy + row * rowcolumn;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end
			
			local wndsize_8 = SIZE('s_add_dwell_split10_8_xywh');		
			for i = 3, count do
				local row, column;
				row = math.modf((i - 3) / 4);
				column = (i - 3) - math.floor( (i - 3) / 4) * 4
				local x2 = wndsize[1] + wndsize_8[3] * column + column * rowcolumn;
				local y2 = wndsize[2] + cy + rowcolumn + row * wndsize_8[4] + row * rowcolumn;
				b_wnd_ex.move_ex(top, id + 40 + i, {x2, y2, wndsize_8[3], wndsize_8[4]}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);		
			end
		elseif (channel_num == 12) then --12·⴦13
			wndsize = SIZE('s_add_dwell_split13_1_xywh');
			b_wnd_ex.move_ex(top, id + 41, wndsize, false)
			local item = "win" .. tostring(1);
			set_wnd_chn_info(top, id + 41, cfgData.win_list_info[item], false);			
			local wndsize13_12 = SIZE('s_add_dwell_split13_12_xywh');
			local cx = wndsize13_12[3];
			local cy = wndsize13_12[4];
			local rowcolumn = wnd_space[1];		
			local row, column;
			for i = 2,5 do
				row = math.modf((i - 2) / 2);
				column = math.modf((i - 2) % 2);
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+wndsize[3]+rowcolumn + column * (cx + rowcolumn) ,wndsize[2] + row *(cy + rowcolumn), cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end
			
			for i = 6, count do
				row = math.modf((i - 6) / 4);
				column = math.modf((i - 6) % 4);			
				b_wnd_ex.move_ex(top, id + 40 + i, {wndsize[1]+ column *(cx + rowcolumn),wndsize[2]+wndsize[4]+rowcolumn + row *(cy + rowcolumn), cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end		
		else	
			wndsize = SIZE('s_add_dwell_split16_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn = wnd_space[1];
			for i = 1, count do
				local row, column;
				row = math.modf((i - 1) / 4);
				column = (i - 1) - math.floor( (i - 1) / 4) * 4
				local x = wndsize[1] + column  * cx + column * rowcolumn;
				local y = wndsize[2] + row  * cy + row * rowcolumn;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);				
			end
		end	
	elseif(splittype == REF_SPLIT32) then	
		if (channel_num == 20 or channel_num == 24) then --6·⴦6
			wndsize = SIZE('s_add_dwell_split24_4_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn_4 = wnd_space[2];
			for i = 1, 4 do
				local row, column;
				row = math.modf((i - 1) / 2);
				column = (i - 1) - math.floor( (i - 1) / 2) * 2
				local x = wndsize[1] + column  * cx + column * rowcolumn_4;
				local y = wndsize[2] + row  * cy + row * rowcolumn_4;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end
			local rowcolumn_28 = wnd_space[2];
			local wndsize_28 = SIZE('s_add_dwell_split24_20_xywh');		
			for i = 5, 12 do
				row = math.modf((i - 5) / 2);
				column = (i - 5) - math.floor( (i - 5) / 2) * 2		
				local x1 = wndsize[1]+2*cx+wndsize_28[3]*column+ 2*rowcolumn_4 + column*rowcolumn_28;
				local y1 = wndsize[2]+row*wndsize_28[4]+row*rowcolumn_28;
				b_wnd_ex.move_ex(top,id + 40 +i,{x1,y1,wndsize_28[3],wndsize_28[4]}, false);
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end
			
			for i = 13, count do
				row = math.modf((i - 13) / 6);
				column = (i - 13) - math.floor((i - 13) / 6) * 6		
				local x2 = wndsize[1]+wndsize_28[3]*column+column*rowcolumn_28;
				local y2 = wndsize[2]+2*cy+row*wndsize_28[4]+2*rowcolumn_4 + row*rowcolumn_28;
				b_wnd_ex.move_ex(top,id + 40 +i,{x2,y2,wndsize_28[3],wndsize_28[4]}, false);		
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);				
			end
		else
			wndsize = SIZE('s_add_dwell_split32_4_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn_4 = wnd_space[2];
			for i = 1, 4 do
				local row, column;
				row = math.modf((i - 1) / 2);
				column = (i - 1) - math.floor( (i - 1) / 2) * 2
				local x = wndsize[1] + column  * cx + column * rowcolumn_4;
				local y = wndsize[2] + row  * cy + row * rowcolumn_4;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);				
			end
			local rowcolumn_28 = wnd_space[2];
			local wndsize_28 = SIZE('s_add_dwell_split32_28_xywh');		
			for i = 5, 16 do
				row = math.modf((i - 5) / 2);
				column = (i - 5) - math.floor( (i - 5) / 2) * 2		
				local x1 = wndsize[1]+2*cx+wndsize_28[3]*column+ 2*rowcolumn_4 + column*rowcolumn_28;
				local y1 = wndsize[2]+row*wndsize_28[4]+row*rowcolumn_28;
				b_wnd_ex.move_ex(top,id + 40 +i,{x1,y1,wndsize_28[3],wndsize_28[4]}, false);
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);				
			end
			
			for i = 17, count do
				row = math.modf((i - 17) / 8);
				column = (i - 17) - math.floor((i - 17) / 8) * 8		
				local x2 = wndsize[1]+wndsize_28[3]*column+column*rowcolumn_28;
				local y2 = wndsize[2]+2*cy+row*wndsize_28[4]+2*rowcolumn_4 + row*rowcolumn_28;
				b_wnd_ex.move_ex(top,id + 40 +i,{x2,y2,wndsize_28[3],wndsize_28[4]}, false);	
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);	
			end
		end
	elseif(splittype == REF_SPLIT36) then	
		if (channel_num == 20 or channel_num == 24) then --6·⴦6
			wndsize = SIZE('s_add_dwell_split25_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn = wnd_space[2];
			for i = 1, count do
				local row, column;
				row = math.modf((i - 1) / 5);
				column = (i - 1) - math.floor( (i - 1) / 5) * 5
				local x = wndsize[1] + column  * cx + column*rowcolumn;
				local y = wndsize[2] + row  * cy + row*rowcolumn;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);		
				if (i == 25) then
					b_wnd_ex.set_hide(top, id + 40 + i, true, false) --ͨش
				end	
			end
			
		else
			wndsize = SIZE('s_add_dwell_split36_xywh');
			local i;
			local cx = wndsize[3];
			local cy = wndsize[4];
			local rowcolumn = wnd_space[2];
			for i = 1, count do
				local row, column;
				row = math.modf((i - 1) / 6);
				column = (i - 1) - math.floor( (i - 1) / 6) * 6
				local x = wndsize[1] + column  * cx + column*rowcolumn;
				local y = wndsize[2] + row  * cy + row*rowcolumn;
				b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
				local item = "win" .. tostring(i);
				set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);					
			end
		end		
	elseif(splittype == REF_SPLIT64) then	
		wndsize = SIZE('s_add_dwell_split64_xywh');
		local i;
		local cx = wndsize[3];
		local cy = wndsize[4];
		local rowcolumn = wnd_space[2];
		for i = 1, count do
			local row, column;
			row = math.modf((i - 1) / 8);
			column = (i - 1) - math.floor( (i - 1) / 8) * 8
			local x = wndsize[1] + column  * cx + column*rowcolumn;
			local y = wndsize[2] + row  * cy + row*rowcolumn;
			b_wnd_ex.move_ex(top, id + 40 + i, {x, y, cx, cy}, false)
			local item = "win" .. tostring(i);
			set_wnd_chn_info(top, id + 40 + i, cfgData.win_list_info[item], false);				
		end
	elseif(splittype == REF_SPLIT128) then	

	end
end

local set_tt_btn_color = function(top, dev_type, redraw)
	local dev_types = {1, 4, 8, 9, 16, 32, 36, 64}		
	local dev_type_idx = 1;
	for i = 1, #dev_types do
		if (dev_type == dev_types[i]) then
			dev_type_idx = i;
			break;
		end
	end		
	
	local k = 1;
	local s_id = w1_page_add_dwell.dlg.spilt1.id;
	local e_id = w1_page_add_dwell.dlg.spilt64.id;	
	local color = {COLOR('c_btn_n'), COLOR('c_btn_n'), COLOR('c_btn_text_n') }	
	local color_f = {COLOR('c_btn_f'), COLOR('c_btn_f'), COLOR('c_btn_text_f') }
	for i = s_id, e_id do
		if (k == dev_type_idx) then
			b_wnd_ex.set_color(top, i, color_f, redraw);
			b_wnd_ex.set_color_f(top, i, color_f, redraw);		
		else	
			b_wnd_ex.set_color(top, i, color, redraw);
			b_wnd_ex.set_color_f(top, i, color_f, redraw);		
		end
		k = k + 1;
	end
end	

--ˢUI
local cfgdatatoui = function(top, cfgdata)	
	local set_sel = function(win_id, sel)
		b_wnd_ex.set_sel(top, win_id, sel, false);
	end

	local cwnd = w1_page_add_dwell.dlg;
	local split_type = cfgdata.dev_type;
	set_tt_btn_color(top, split_type, false);
	
	if( split_type == 1) then
		cutsplit(top, 1, false);
	elseif(split_type == 4) then
		cutsplit(top, 4, false);
	elseif(split_type == 8) then
		cutsplit(top, 8, false);	
	elseif(split_type == 9) then
		cutsplit(top, 9, false);
	elseif(split_type == 16) then
		cutsplit(top, 16, false);
	elseif(split_type == 32) then
		cutsplit(top, 32, false);
	elseif(split_type == 36) then
		cutsplit(top, 36, false);
	elseif(split_type == 64) then
		cutsplit(top, 64, false);		
	end
	
	--ò
	b_wnd_ex.set_text(top, cwnd.t_name.id, cfgdata.name, false);
	--ѯ
	local split_interval = cfgdata.poll_interval;
	if(split_interval == 0) then
		set_sel(cwnd.t_time.id, 0)
	elseif(split_interval == 5) then
		set_sel(cwnd.t_time.id, 1)
	elseif(split_interval == 10) then
		set_sel(cwnd.t_time.id, 2)
	elseif(split_interval == 20) then
		set_sel(cwnd.t_time.id, 3)
	elseif(split_interval == 30) then
		set_sel(cwnd.t_time.id, 4)
	elseif(split_interval == 60) then
		set_sel(cwnd.t_time.id, 5)
	elseif(split_interval == 120) then
		set_sel(cwnd.t_time.id, 6)
	elseif(split_interval == 300) then
		set_sel(cwnd.t_time.id, 7)
	end
	
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_add_dwell.dlg;
	local interval = b_wnd_ex.get_sel(top, cwnd.t_time.id);
	if(interval == 0) then
		cfgdata.poll_interval = 0;
	elseif(interval == 1) then
		cfgdata.poll_interval = 5;
	elseif(interval == 2) then
		cfgdata.poll_interval = 10;
	elseif(interval == 3) then
		cfgdata.poll_interval = 20;
	elseif(interval == 4) then
		cfgdata.poll_interval = 30;
	elseif(interval == 5) then
		cfgdata.poll_interval = 60;
	elseif(interval == 6) then
		cfgdata.poll_interval = 120;
	elseif(interval == 7) then
		cfgdata.poll_interval = 300;
	end
	cfgdata.name = b_wnd_ex.get_text(top, cwnd.t_name.id, false);	
	local count = cfgdata.win_num;
	for i = 1, count do
		local curWinData = b_wnd_ex.get_dwell_wnd_data(top, id + 40 + i);
		if (type(curWinData) == "table") then
			local item = "win" .. tostring(i);
			util.copy_tab_b(cfgdata.win_list_info[item], curWinData)
		end
	end
	
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	--ûϷԼ
	local cfgData = w1_page_add_dwell.cfgData;
	local cwnd = w1_page_add_dwell.dlg;
	if(cfgData.name == '') then--ûΪ
		setTipInfo(top, STR('LA_LAYOUT_NAME_NOT_EMPTY'), false);
		b_dlg.dlg_set_redraw(top);
		w1_page_add_dwell.data_check_illegal = true
		return false;
	end
	
	local isAllEmpty = true;
	for i = 1, cfgData.win_num do
		local item = "win" .. tostring(i);
		for k, v in pairs(cfgData.win_list_info[item]) do
			if (v ~= nil) then
				isAllEmpty = false;
				break;
			end
		end
	end	
	
	if (isAllEmpty) then
		w1_page_add_dwell.data_check_illegal = true
		setTipInfo(top, STR('LA_ALLCHN_EMPTY'), true);
		return false;
	end	
	
	
	isAllEmpty = true
	for i = 1, cfgData.win_num do
		local item = "win" .. tostring(i);
		for k, v in pairs(cfgData.win_list_info[item]) do
			if (v ~= nil and v ~= 0) then
				isAllEmpty = false;
				break;
			end
		end
	end	
	

	if (isAllEmpty) then
		w1_page_add_dwell.data_check_illegal = true
		setTipInfo(top, STR('LA_ALLCHN_EMPTY'), true);
		return false;
	end	

	
	w1_page_add_dwell.data_check_illegal = false
	return true;
end

local is_change = function(top)
	local cwnd = w1_page_add_dwell.dlg;
	if (w1_page_add_dwell.cfgData.name ~= w1_page_add_dwell.original_data.name) then
		return true;
	end
	
	if (w1_page_add_dwell.cfgData.poll_interval ~= w1_page_add_dwell.original_data.poll_interval) then
		return true;
	end

	if (w1_page_add_dwell.cfgData.dev_type ~= w1_page_add_dwell.original_data.dev_type) then
		return true;
	end

	if (w1_page_add_dwell.cfgData.win_num ~= w1_page_add_dwell.original_data.win_num) then
		return true;
	end
	
	local ret = w1_wnd_util.usercfgchange_b(w1_page_add_dwell.cfgData.win_list_info, w1_page_add_dwell.original_data.win_list_info);
	
	return ret
end

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		if timer_time_count > 0 then
			timer_time_count = timer_time_count - 1;
			if timer_time_count == 0 and "" ~= b_wnd_ex.get_text(top, w1_page_add_dwell.dlg.tipinfo.id) then
				b_wnd_ex.set_text(top, w1_page_add_dwell.dlg.tipinfo.id, "", true);
			end
		else
			timer_time_count = 0;
		end
	end
	
	return 0;
end	

--ҳʼʱٶȡҳҪ
w1_page_add_dwell.setCfgData = function(top, cfgData, opt_type, screen_id, layout_id, default_split, dec_mode)
	w1_page_add_dwell.clear_data();
	w1_page_add_dwell.cfgData = util.copy_tab(cfgData);
	w1_page_add_dwell.original_data = util.copy_tab(w1_page_add_dwell.cfgData);
	w1_page_add_dwell.opt_type = opt_type;
	w1_page_add_dwell.screen_id = screen_id;
	w1_page_add_dwell.layout_id = layout_id;
	w1_page_add_dwell.default_split = default_split;
	if (dec_mode ~= nil) then
		decode_mode = dec_mode
	end
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,w1_page_add_dwell.cfgData);
		if (uidatacheck(top)) then
			local param = {
				opt_type = w1_page_add_dwell.opt_type, 
				cfg_data = w1_page_add_dwell.cfgData, 
				screen_id = w1_page_add_dwell.screen_id,
				layout_id = w1_page_add_dwell.layout_id}			

			local ret = b_app_api.save_custom_dwell(param)
			if (ret == 0) then	
				b_dlg.end_modal(top);
			elseif (ret == 4) then
				setTipInfo(top, STR('LA_EXCEED_MAX_NUM'), false);
				b_dlg.dlg_set_redraw(top);
			else
				print("save custom dwell fail err code:", ret);
				setTipInfo(top, STR('LA_OPERATE_FAIL'), false);
				b_dlg.dlg_set_redraw(top);
			end
		
		end
	end
	
	return 0
end

local save_change = function(param)
	local cwnd = w1_page_add_dwell.dlg;
	if (uidatacheck(param[1])) then
		local param_data = {
			opt_type = w1_page_add_dwell.opt_type, 
			cfg_data = w1_page_add_dwell.cfgData, 
			screen_id = w1_page_add_dwell.screen_id,
			layout_id = w1_page_add_dwell.layout_id}
		local ret = b_app_api.save_custom_dwell(param_data)
		if (ret == 0) then	
			
		elseif (ret == 4) then
			setTipInfo(param[1], STR('LA_EXCEED_MAX_NUM'), false);
			b_dlg.dlg_set_redraw(param[1]);
			w1_page_add_dwell.data_check_illegal = true;
		else
			print("save custom dwell fail err code:", ret);
			setTipInfo(param[1], STR('LA_OPERATE_FAIL'), false);
			b_dlg.dlg_set_redraw(param[1]);
			w1_page_add_dwell.data_check_illegal = true;
		end		
	end
end

local on_close = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local on_cancel = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local on_splitmode = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local s_id = w1_page_add_dwell.dlg.spilt1.id;
		local e_id = w1_page_add_dwell.dlg.spilt64.id;	
		local idx = 1
		for i = s_id, e_id do
			if (i == win_id) then
				break;
			end
			idx = idx + 1;
		end		
		
		local dev_types = {1, 4, 8, 9, 16, 32, 36, 64};
		w1_page_add_dwell.cfgData.dev_type = dev_types[idx];	
		clear_wnd_data(top, dev_types[idx]);		
		cutsplit(top, dev_types[idx], false)	
		set_tt_btn_color(top, dev_types[idx], false);
		w1_page_add_dwell.cur_check_wnd = id + 41;
		local s_id = id + 41;
		local e_id = id + 104;
		for i = s_id, e_id do
			if (w1_page_add_dwell.cur_check_wnd == i) then
				b_wnd_ex.set_check(top, i, true, false);
			else
				b_wnd_ex.set_check(top, i, false, false);
			end
		end	
		b_dlg.dlg_set_redraw(top);		
	end
	return 0
end

local on_channel = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_add_dwell.dlg;
		for i = 1, max_cap_chn_num do
			b_wnd_ex.set_check(top, id + 20 + i, false, false);
		end
		b_wnd_ex.set_check(top, win_id, true, false);
		local ch_num = win_id - (id + 21) + 1  + diplay_off
		if (w1_page_add_dwell.cur_check_wnd == nil) then
			w1_page_add_dwell.cur_check_wnd = id + 41;
		end
		add_channel(top, w1_page_add_dwell.cur_check_wnd, ch_num, false)
		b_dlg.dlg_set_redraw(top);
	elseif(b_ui.LBUTTONDOWN == vmsg) then
		local cwnd = w1_page_add_dwell.dlg;
		for i = 1, max_cap_chn_num do
			b_wnd_ex.set_check(top, id + 20 + i, false, false);
		end
		b_wnd_ex.set_check(top, win_id, true, false);
		b_dlg.dlg_set_redraw(top);
		return vmsg;
	elseif(b_ui.MOUSEWHEELDOWN == vmsg) then
		w1_page_add_dwell.dwell_mouse_down(top);
	elseif(b_ui.MOUSEWHEELUP == vmsg) then
		w1_page_add_dwell.dwell_mouse_up(top);	
	else
		return vmsg;	
	end
	return 0
end

w1_page_add_dwell.dwell_mouse_up =function(top)
	local max_count =  global_val.get_channelnum() + 1
	if max_count > max_cap_chn_num then
		if diplay_off > 0 then
			diplay_off = diplay_off-1
		end
		local vdrop = {};
		vdrop.set_cur = diplay_off;
		vdrop.set_cap = max_cap_chn_num;
		vdrop.set_max = max_count;
		b_wnd_ex.set_drop(top,w1_page_add_dwell.dlg.drop.id,vdrop,false);
		for i = 1, max_cap_chn_num do
			local chn_name = string.format("[%d]%s", i+diplay_off, w1_page_add_dwell.all_channel_name[i+diplay_off]);
			if (i == max_count) then
				chn_name = string.format("[-]%s", w1_page_add_dwell.all_channel_name[i+diplay_off]);	
			end			
			b_wnd_ex.set_text(top, id + 20 + i, chn_name, false)
			local check_status = false;
			if (i+diplay_off == w1_page_add_dwell.select_chn) then
				check_status = true;
			end
			b_wnd_ex.set_check(top, id + 20 + i, check_status, false);
		end
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_add_dwell.dwell_mouse_down =function(top)
	local max_count =  global_val.get_channelnum() + 1
	if max_count > max_cap_chn_num then
		if (diplay_off + max_cap_chn_num < max_count)	then
			diplay_off = diplay_off+1
		else
			return 0;	
		end
		local vdrop = {};
		vdrop.set_cur = diplay_off;
		vdrop.set_cap = max_cap_chn_num;
		vdrop.set_max = max_count;
		b_wnd_ex.set_drop(top,w1_page_add_dwell.dlg.drop.id,vdrop,false);
		for i = 1, max_cap_chn_num do
			local chn_name = string.format("[%d]%s", i+diplay_off, w1_page_add_dwell.all_channel_name[i+diplay_off]);		
			if (i == max_count) then
				chn_name = string.format("[-]%s", w1_page_add_dwell.all_channel_name[i+diplay_off]);	
			end				
			b_wnd_ex.set_text(top, id + 20 + i, chn_name, false)
			local check_status = false;
			if (i+diplay_off == w1_page_add_dwell.select_chn) then
				check_status = true;
			end
			b_wnd_ex.set_check(top, id + 20 + i, check_status, false);
		end
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_add_dwell.dwell_drop_drag =function(top)
	local max_count =  global_val.get_channelnum() + 1
	if max_count > max_cap_chn_num then
		diplay_off = b_wnd_ex.get_drop(top,w1_page_add_dwell.dlg.drop.id);
		for i = 1, max_cap_chn_num do
			local chn_name = string.format("[%d]%s", i+diplay_off, w1_page_add_dwell.all_channel_name[i+diplay_off]);		
			if (i == max_count) then
				chn_name = string.format("[-]%s", w1_page_add_dwell.all_channel_name[i+diplay_off]);	
			end				
			b_wnd_ex.set_text(top, id + 20 + i, chn_name, false)
			local check_status = false;
			if (i+diplay_off == w1_page_add_dwell.select_chn) then
				check_status = true;
			end
			b_wnd_ex.set_check(top, id + 20 + i, check_status, false);
		end
		b_dlg.dlg_set_redraw(top);	
	end
end

w1_page_add_dwell.dwell_updata_f =function(top)
	local max_count =  global_val.get_channelnum() + 1
	if max_count > max_cap_chn_num then
		diplay_off = b_wnd_ex.get_drop(top,w1_page_add_dwell.dlg.drop.id);
		for i = 1, max_cap_chn_num do
			local chn_name = string.format("[%d]%s", i+diplay_off, w1_page_add_dwell.all_channel_name[i+diplay_off]);
			if (i == max_count) then
				chn_name = string.format("[-]%s", w1_page_add_dwell.all_channel_name[i+diplay_off]);	
			end				
			b_wnd_ex.set_text(top, id + 20 + i, chn_name, false)
			local check_status = false;
			if (i+diplay_off == w1_page_add_dwell.select_chn) then
				check_status = true;
			end
			b_wnd_ex.set_check(top, id + 20 + i, check_status, false);			
		end
		b_dlg.dlg_set_redraw(top);
	end
end

local dlg = 
{
	attr = {xywh='s_cfg_xywh', cmd=on_dlg,timer={-1, 1000}},
	sub = {	'titleimg','titlestr','titleclose', 'channel','vline1', 'hline1', 'cap_name', 't_name', 'cap_time', 't_time', 
			'ch1','ch2','ch3','ch4','ch5','ch6','ch7','ch8',
			'ch9','ch10','ch11','ch12','ch13','ch14','ch15','ch16','ch17','ch18','ch19','ch20','drop',
			'f1','f2','f3','f4','f5','f6','f7','f8','f9','f10','f11','f12','f13','f14','f15','f16',
			'f17','f18','f19','f20','f21','f22','f23','f24','f25','f26','f27','f28','f29','f30','f31','f32',
			'f33','f34','f35','f36','f37','f38','f39','f40','f41','f42','f43','f44','f45','f46','f47','f48',
			'f49','f50','f51','f52','f53','f54','f55','f56','f57','f58','f59','f60','f61','f62','f63','f64',
			'spilt1', 'spilt4', 'spilt8', 'spilt9', 'spilt16', 'spilt32', 'spilt36', 'spilt64',
			'tipinfo', 'default', 'cancel', 'apply' },
	
	titleimg 	= {t='tt_picture',	id=id+1,xywh='s_add_dwell_titleimg_xywh', 
					t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_addcameera'}},
	
	titlestr	= {t='static', 	id=id+2,xywh='s_add_dwell_titlestr_xywh', 
					text='LA_ADD_USER',	font = 'f_grade5',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	titleclose 	= {t='tt_button',id=id+3,xywh = 's_add_dwell_titleclose_xywh',
					t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'},
					color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_txt_f'},
					color_f= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},cmd=on_close},	
	
	channel 	= {t='static',	id=id+4,	xywh='s_add_dwell_channel_xywh',text='LA_CHANNEL', align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'}},
	vline1 		= {t='hline',	id=id+5,	xywh='s_add_dwell_vline1_xywh'},
	hline1		= {t='hline',	id=id+6,	xywh='s_add_dwell_hline1_xywh'},
	

	cap_name	= {t='static',	id=id+7,	xywh='s_add_dwell_cap_name_xywh',text='LA_LAYOUT_NAME',align = b_ui.ALIGN.LEFT},
	t_name 		= {t='edit', 	id=id+8,xywh='s_add_dwell_t_name_xywh',	text='',	trans = false,},		

	cap_time	= {t='static',	id=id+9,	xywh='s_add_dwell_cap_time_xywh',text='LA_POLL_INTERVAL',align = b_ui.ALIGN.LEFT},
	t_time 		= {t='combox',	id=id+10,	xywh='s_add_dwell_t_time_xywh',
					items={'LA_NO_SWITCH','LA_SECOND_5','LA_SECOND_10','LA_SECOND_20','LA_SECOND_30','LA_SECOND_60','LA_SECOND_120','LA_SECOND_300'}},	

	ch1 		= { t='checkbutton',	id=id+21,	xywh='s_add_dwell_ch1_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch2 		= { t='checkbutton',	id=id+22,	xywh='s_add_dwell_ch2_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch3 		= { t='checkbutton',	id=id+23,	xywh='s_add_dwell_ch3_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch4 		= { t='checkbutton',	id=id+24,	xywh='s_add_dwell_ch4_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch5 		= { t='checkbutton',	id=id+25,	xywh='s_add_dwell_ch5_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch6 		= { t='checkbutton',	id=id+26,	xywh='s_add_dwell_ch6_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch7 		= { t='checkbutton',	id=id+27,	xywh='s_add_dwell_ch7_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch8 		= { t='checkbutton',	id=id+28,	xywh='s_add_dwell_ch8_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch9 		= { t='checkbutton',	id=id+29,	xywh='s_add_dwell_ch9_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch10 		= { t='checkbutton',	id=id+30,	xywh='s_add_dwell_ch10_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch11 		= { t='checkbutton',	id=id+31,	xywh='s_add_dwell_ch11_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch12 		= { t='checkbutton',	id=id+32,	xywh='s_add_dwell_ch12_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch13 		= { t='checkbutton',	id=id+33,	xywh='s_add_dwell_ch13_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch14 		= { t='checkbutton',	id=id+34,	xywh='s_add_dwell_ch14_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch15 		= { t='checkbutton',	id=id+35,	xywh='s_add_dwell_ch15_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch16 		= { t='checkbutton',	id=id+36,	xywh='s_add_dwell_ch16_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch17 		= { t='checkbutton',	id=id+37,	xywh='s_add_dwell_ch17_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch18 		= { t='checkbutton',	id=id+38,	xywh='s_add_dwell_ch18_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},	
	ch19 		= { t='checkbutton',	id=id+39,	xywh='s_add_dwell_ch19_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},
	ch20 		= { t='checkbutton',	id=id+40,	xywh='s_add_dwell_ch20_xywh',
				text='' ,trans = false, align = b_ui.ALIGN.CENTER,
				color = {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_txt_n'},cmd = on_channel
				},

	f1 		= {t='dwell_wnd', id=id+41, xywh='s_add_dwell_wnd_xywh',check = true, enableselect = true},	
	f2 		= {t='dwell_wnd', id=id+42, xywh='s_add_dwell_wnd_xywh',check = false, enableselect = true},		
	f3 		= {t='dwell_wnd', id=id+43, xywh='s_add_dwell_wnd_xywh',check = false, enableselect = true},		
	f4 		= {t='dwell_wnd', id=id+44, xywh='s_add_dwell_wnd_xywh',check = false, enableselect = true},		
	f5 		= {t='dwell_wnd', id=id+45, xywh='s_add_dwell_wnd_xywh',check = false, enableselect = true},		
	f6 		= {t='dwell_wnd', id=id+46, xywh='s_add_dwell_wnd_xywh',check = false, enableselect = true},		
	f7 		= {t='dwell_wnd', id=id+47, xywh='s_add_dwell_wnd_xywh',check = false, enableselect = true},		
	f8 		= {t='dwell_wnd', id=id+48, xywh='s_add_dwell_wnd_xywh',check = false, enableselect = true},	
	f9 		= {t='dwell_wnd', id=id+49, xywh='s_add_dwell_wnd_xywh',check = false, enableselect = true},	
	f10 	= {t='dwell_wnd', id=id+50, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f11 	= {t='dwell_wnd', id=id+51, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f12 	= {t='dwell_wnd', id=id+52, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f13 	= {t='dwell_wnd', id=id+53, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f14 	= {t='dwell_wnd', id=id+54, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f15 	= {t='dwell_wnd', id=id+55, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f16 	= {t='dwell_wnd', id=id+56, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},					
	f17 	= {t='dwell_wnd', id=id+57, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f18 	= {t='dwell_wnd', id=id+58, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f19 	= {t='dwell_wnd', id=id+59, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f20 	= {t='dwell_wnd', id=id+60, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f21 	= {t='dwell_wnd', id=id+61, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f22 	= {t='dwell_wnd', id=id+62, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f23 	= {t='dwell_wnd', id=id+63, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f24 	= {t='dwell_wnd', id=id+64, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f25 	= {t='dwell_wnd', id=id+65, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f26 	= {t='dwell_wnd', id=id+66, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f27 	= {t='dwell_wnd', id=id+67, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f28 	= {t='dwell_wnd', id=id+68, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f29 	= {t='dwell_wnd', id=id+69, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f30 	= {t='dwell_wnd', id=id+70, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f31 	= {t='dwell_wnd', id=id+71, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f32 	= {t='dwell_wnd', id=id+72, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},
	f33 	= {t='dwell_wnd', id=id+73, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f34 	= {t='dwell_wnd', id=id+74, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f35 	= {t='dwell_wnd', id=id+75, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f36 	= {t='dwell_wnd', id=id+76, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f37 	= {t='dwell_wnd', id=id+77, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f38 	= {t='dwell_wnd', id=id+78, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f39 	= {t='dwell_wnd', id=id+79, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f40 	= {t='dwell_wnd', id=id+80, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f41 	= {t='dwell_wnd', id=id+81, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f42 	= {t='dwell_wnd', id=id+82, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f43 	= {t='dwell_wnd', id=id+83, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f44 	= {t='dwell_wnd', id=id+84, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f45 	= {t='dwell_wnd', id=id+85, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f46 	= {t='dwell_wnd', id=id+86, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f47 	= {t='dwell_wnd', id=id+87, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f48 	= {t='dwell_wnd', id=id+88, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},
	f49 	= {t='dwell_wnd', id=id+89, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f50 	= {t='dwell_wnd', id=id+90, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f51 	= {t='dwell_wnd', id=id+91, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f52 	= {t='dwell_wnd', id=id+92, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f53 	= {t='dwell_wnd', id=id+93, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f54 	= {t='dwell_wnd', id=id+94, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f55 	= {t='dwell_wnd', id=id+95, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f56 	= {t='dwell_wnd', id=id+96, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f57 	= {t='dwell_wnd', id=id+97, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f58 	= {t='dwell_wnd', id=id+98, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f59 	= {t='dwell_wnd', id=id+99, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f60 	= {t='dwell_wnd', id=id+100, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f61 	= {t='dwell_wnd', id=id+101, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f62 	= {t='dwell_wnd', id=id+102, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},		
	f63 	= {t='dwell_wnd', id=id+103, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	
	f64 	= {t='dwell_wnd', id=id+104, xywh='s_add_dwell_wnd_xywh', check = false, enableselect = true},	

	drop 		= {t='vdrop', id=id+164,xywh='s_add_dwell_vdrop_xywh', cmd = on_drop},
	
	spilt1 	= {t='tt_button',id=id+165,xywh='s_add_dwell_split1_btn_xywh',cmd=on_splitmode, 
				text = 'LA_SCREEN_ONE', draw_text = 0, 		
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_split','it_split1','it_split1_f', 'it_split1'}},			
				
	spilt4 	= {t='tt_button',id=id+166,xywh='s_add_dwell_split4_btn_xywh',cmd=on_splitmode, 		
				text = 'LA_SCREEN_FOUR', draw_text = 0, 		
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_split','it_split4','it_split4_f', 'it_split4'}},			
				

	spilt8 	= {t='tt_button',id=id+167,xywh='s_add_dwell_split8_btn_xywh',cmd=on_splitmode, 
				text = 'LA_SCREEN_EIGHT', draw_text = 0, 		
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_split','it_split8','it_split8_f', 'it_split8'}},			
				

	spilt9 	= {t='tt_button',id=id+168,xywh='s_add_dwell_split9_btn_xywh',cmd=on_splitmode, 
				text = 'LA_SCREEN_NINE', draw_text = 0, 		
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_split','it_split9','it_split9_f', 'it_split9'}},			
				

	spilt16 	= {t='tt_button',id=id+169,xywh='s_add_dwell_split16_btn_xywh',cmd=on_splitmode, 
				text = 'LA_SCREEN_SIXTEEN', draw_text = 0, 		
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_split','it_split16','it_split16_f', 'it_split16'}},			
				

	spilt32 	= {t='tt_button',id=id+170,xywh='s_add_dwell_split32_btn_xywh',cmd=on_splitmode, 
				text = 'LA_DISPLAY32', draw_text = 0, 		
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_split','it_split32','it_split32_f', 'it_split32'}},			
				

	spilt36 	= {t='tt_button',id=id+171,xywh='s_add_dwell_split36_btn_xywh',cmd=on_splitmode, 
				text = 'LA_SCREEN_THIRTYSIX', draw_text = 0, 		
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_split','it_split36','it_split36_f', 'it_split36'}},			
				
	spilt64 	= {t='tt_button',id=id+172,xywh='s_add_dwell_split64_btn_xywh',cmd=on_splitmode, 
				text = 'LA_DISPLAY64', draw_text = 0, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_split','it_split64','it_split64_f', 'it_split64'}},			
				

	tipinfo		= {t='static', id=id+173,	xywh='s_add_dwell_tipinfo_xywh',	text='',trans = false,
					color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_popdlg_tip_text'}},
	
	cancel 		= {t='button',	id=id+174,	xywh='s_add_dwell_clear_xywh', text='LA_CANCEL',cmd=on_cancel},	
	
	apply 		= {t='button',	id=id+175,	xywh='s_add_dwell_apply_xywh', text='LA_OK',cmd=on_apply},
}

local get_valid_cam_num = function(channel_num)
	local chn_num = channel_num;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (0 < dec_num and 0 < vi_num) then 
		local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
		if (0 == chn_type.chn_type[vi_num + 1]) then
			chn_num = vi_num;
		end
	end
	
	return chn_num;
end

local move_layout_name_show = function(top, redraw)
	local cwnd = w1_page_add_dwell.dlg;
	local size1 = b_wnd_ex.get_textsize(top, cwnd.cap_name.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.cap_time.id).w;
	local space = 15;
	local item_pace = 50;
	local cap_name_pos = SIZE('s_add_dwell_cap_name_xywh');
	local t_name_pos = SIZE('s_add_dwell_t_name_xywh');
	local cap_time_pos = SIZE('s_add_dwell_cap_time_xywh');
	local t_time_pos = SIZE('s_add_dwell_t_time_xywh');

	local pos1 = {cap_name_pos[1], cap_name_pos[2], size1 + space, cap_name_pos[4]}
	local pos2 = {pos1[1] + pos1[3], t_name_pos[2], t_name_pos[3], t_name_pos[4]};
	local pos3 = {pos2[1] + pos2[3] + item_pace, cap_time_pos[2], size2 + space, cap_time_pos[4]};	
	local pos4 = {pos3[1] + pos3[3], t_time_pos[2], t_time_pos[3], t_time_pos[4]};
	
	b_wnd_ex.move_ex(top, cwnd.cap_name.id, pos1, false)	
	b_wnd_ex.move_ex(top, cwnd.t_name.id, pos2, false)	
	b_wnd_ex.move_ex(top, cwnd.cap_time.id, pos3, false)	
	b_wnd_ex.move_ex(top, cwnd.t_time.id, pos4, false)	

	if (redraw) then
		b_dlg.dlg_set_redraw(top)
	end	
end

w1_page_add_dwell.on_create = function(top)
	channel_num = global_val.get_channelnum();
	channel_num = get_valid_cam_num(channel_num);		

	w1_page_add_dwell.top = top
	w1_page_add_dwell.dlg = dlg
	b_parser(top, dlg)
	return 0
end

w1_page_add_dwell.on_pre_show = function(top)
	local cwnd = w1_page_add_dwell.dlg;
	w1_page_add_dwell.all_channel_name = util.copy_tab(b_app_api.get_all_channel_name());
	table.insert(w1_page_add_dwell.all_channel_name, STR('LA_EMPTY'));
	channel_num = global_val.get_channelnum();
	channel_num = get_valid_cam_num(channel_num);
	if (w1_page_add_dwell.screen_id == 1) then --
		if (decode_mode == 0) then
			channel_num = channel_num / 2;
		elseif (decode_mode == 1) then
			channel_num = channel_num  - 1;
		elseif (decode_mode == 2) then
			channel_num = 1
		end
	end
	
	local set_tt_btn_hide = function(s_id, e_id, redraw)
		for i = s_id, e_id do
			b_wnd_ex.set_hide(top, i, true, redraw);
		end
	end	
	
	local dlg_w, dlg_h = global_val.get_size();
	local font = 24;
	if(dlg_w == 1024 or dlg_h == 768) then
		font = 12;
	elseif(dlg_w == 1280 or dlg_h == 1024) then
		font = 24;
	elseif(dlg_w == 1440 or dlg_h == 900) then
		font = 24;
	elseif(dlg_w == 1920 or dlg_h == 1080) then
		font = 24;
	elseif(dlg_w == 2560 or dlg_h == 1440) then
		font = 32;
	elseif(dlg_w == 3840 or dlg_h == 2160) then
		font = 48;
	end	
	
	if (channel_num == 1) then
		local s_id = w1_page_add_dwell.dlg.spilt4.id;
		local e_id = w1_page_add_dwell.dlg.spilt64.id;
		set_tt_btn_hide(s_id, e_id, false);
	elseif(channel_num == 4)then
		local s_id = w1_page_add_dwell.dlg.spilt8.id;
		local e_id = w1_page_add_dwell.dlg.spilt64.id;
		set_tt_btn_hide(s_id, e_id, false);
	elseif(channel_num == 6) then
		local s_id = w1_page_add_dwell.dlg.spilt9.id;
		local e_id = w1_page_add_dwell.dlg.spilt64.id;
		set_tt_btn_hide(s_id, e_id, false);
		b_wnd_ex.set_text(top, w1_page_add_dwell.dlg.spilt8.id, STR('LA_SCREEN_SIX'), false);
		local t_imgs = {b_ui.ALIGN.LEFT,font,61477, 61477, 61477};	 --it_split6
		b_wnd_ex.set_t_imgs(top, w1_page_add_dwell.dlg.spilt8.id, t_imgs, false);
	elseif(channel_num == 8)then
		local s_id = w1_page_add_dwell.dlg.spilt16.id;
		local e_id = w1_page_add_dwell.dlg.spilt64.id;
		set_tt_btn_hide(s_id, e_id, false);
	elseif(channel_num == 10)then
		local s_id = w1_page_add_dwell.dlg.spilt32.id;
		local e_id = w1_page_add_dwell.dlg.spilt64.id;		
		set_tt_btn_hide(s_id, e_id, false);
		
		b_wnd_ex.set_text(top, w1_page_add_dwell.dlg.spilt16.id, STR('LA_SCREEN_TEN'), false);
		local t_imgs_10 = {b_ui.ALIGN.LEFT,font,61713, 61713, 61713};	--it_split10
		b_wnd_ex.set_t_imgs(top, w1_page_add_dwell.dlg.spilt16.id, t_imgs_10, false);		
	elseif(channel_num == 12) then
		local s_id = w1_page_add_dwell.dlg.spilt32.id;
		local e_id = w1_page_add_dwell.dlg.spilt64.id;	
		set_tt_btn_hide(s_id, e_id, false);
		
		b_wnd_ex.set_text(top, w1_page_add_dwell.dlg.spilt16.id, STR('LA_SCREEN_THIRTEEN'), false);
		local t_imgs_10 = {b_ui.ALIGN.LEFT,font,61715, 61715, 61715};	--it_split13
		b_wnd_ex.set_t_imgs(top, w1_page_add_dwell.dlg.spilt16.id, t_imgs_10, false);			
	elseif(channel_num == 16)then
		local s_id = w1_page_add_dwell.dlg.spilt32.id;
		local e_id = w1_page_add_dwell.dlg.spilt64.id;
		set_tt_btn_hide(s_id, e_id, false);
	elseif(channel_num == 20 or channel_num == 24) then
		local s_id = w1_page_add_dwell.dlg.spilt64.id;
		local e_id = w1_page_add_dwell.dlg.spilt64.id;
		set_tt_btn_hide(s_id, e_id, false);
			
		b_wnd_ex.set_text(top, w1_page_add_dwell.dlg.spilt32.id, STR('LA_SCREEN_TWENTYFOUR'), false);
		local t_imgs_24 = {b_ui.ALIGN.LEFT,font,61585, 61585, 61585};	--it_split24
		b_wnd_ex.set_t_imgs(top, w1_page_add_dwell.dlg.spilt32.id, t_imgs_24, false);

		b_wnd_ex.set_text(top, w1_page_add_dwell.dlg.spilt36.id, STR('LA_SCREEN_TWENTYFIVE'), false);
		local t_imgs_25 = {b_ui.ALIGN.LEFT,font,61672, 61672, 61672}; --it_split25	
		b_wnd_ex.set_t_imgs(top, w1_page_add_dwell.dlg.spilt36.id, t_imgs_25, false);
	elseif(channel_num == 32)then
		local s_id = w1_page_add_dwell.dlg.spilt64.id;
		local e_id = w1_page_add_dwell.dlg.spilt64.id;
		set_tt_btn_hide(s_id, e_id, false);
	end

	--Ĭ
	b_wnd_ex.set_hide(top,cwnd.drop.id,true,false);
	local max_count =  global_val.get_channelnum() + 1
	if max_count > max_cap_chn_num then
		local vdrop = {};
		vdrop.set_cur = diplay_off;
		vdrop.set_cap = max_cap_chn_num;
		vdrop.set_max = max_count;
		for i = 1, max_cap_chn_num do
			local chn_name = string.format("[%d]%s", i+diplay_off, w1_page_add_dwell.all_channel_name[i+diplay_off]);
			if (i == max_count) then
				chn_name = string.format("[-]%s", w1_page_add_dwell.all_channel_name[i+diplay_off]);	
			end			
			b_wnd_ex.set_text(top, id + 20 + i, chn_name, false)
		end
		b_wnd_ex.set_drop(top,cwnd.drop.id,vdrop,false);
		b_wnd_ex.set_hide(top,cwnd.drop.id,false,false);
	else
		for i = 1, max_cap_chn_num do
			if i <= max_count then
				local chn_name = string.format("[%d]%s", i+diplay_off, w1_page_add_dwell.all_channel_name[i+diplay_off]);
				if (i == max_count) then
					chn_name = string.format("[-]%s", w1_page_add_dwell.all_channel_name[i+diplay_off]);	
				end
				b_wnd_ex.set_text(top, id + 20 + i, chn_name, false)
			else
				b_wnd_ex.set_hide(top,id + 20 + i,true,false);
			end			
		end
	end
	
	if (w1_page_add_dwell.opt_type == 0 and w1_page_add_dwell.cfgData == nil)then --CӲ 
		set_default_cfg(top)
	end		
	
	--ñ
	if(w1_page_add_dwell.opt_type == 0) then 	
		b_wnd_ex.set_text(top, cwnd.titlestr.id, STR("LA_ADD_LAYOUT"), false)
	else
		b_wnd_ex.set_text(top, cwnd.titlestr.id, STR("LA_EDIT_LAYOUT"), false)
	end
	
	--ĬϷ༭֧޸ѯʱ
	if (w1_page_add_dwell.default_split == true) then 
		local s_id = id + 41;
		local e_id = id + 104;
		for i = s_id, e_id do
			b_wnd_ex.set_enableselect(top, i, false, false);
		end	
		
		local s_id = id + 21;
		local e_id = id + 40;
		for i = s_id, e_id do
			b_wnd_ex.set_disable(top, i, true, false);
		end	
		
		local s_id = id + 165;
		local e_id = id + 172;
		for i = s_id, e_id do
			b_wnd_ex.set_disable(top, i, true, false);
		end			
		
		b_wnd_ex.set_disable(top, cwnd.t_name.id, true, false);		
		b_wnd_ex.set_disable(top, cwnd.drop.id, true, false);
	end
	
	cfgdatatoui(top, w1_page_add_dwell.cfgData);
	
	--ƶλ
	move_layout_name_show(top, false);

	return 0;
end

w1_page_add_dwell.on_destroy = function(top)
	w1_page_add_dwell.top = nil
	w1_page_add_dwell.dlg = nil
	w1_page_add_dwell.clear_data();
	b_app_api.channge_cursor(b_ui.CURSOR.JY_CURSOR_POINT);
	return 0
end

w1_page_add_dwell.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_page_bk'));	--Ʊ
	local pos = SIZE('s_add_dwell_title_xywh');	
	b_wnd.draw_fill(top, pos[1], pos[2], pos[3], pos[4], COLOR('c_cfg_title_bk')); --Ʊ
	local pos = SIZE('s_add_dwell_channelbar_xywh');	
	b_wnd.draw_fill(top, pos[1], pos[2], pos[3], pos[4], COLOR('c_cfg_col_bk'));	--ͨ
	b_wnd.draw_rect(top, pos[1], pos[2], pos[3], pos[4], COLOR('c_popdlg_border'), 1); --ͨ߿
	b_wnd.end_job(top);
	return 0
end

w1_page_add_dwell.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if(b_ui.RBUTTONCLK == vmsg) then
		uitousercfg(top,w1_page_add_dwell.cfgData);
		w1_page_add_dwell.data_check_illegal = false;		
		local ret = is_change(top);
		if ret == true then --޸ ʾǷ񱣴
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_WANT_SAVE'), true, true, false,STR('LA_YES'), STR('LA_BAD'));
			w1_msgbox.set_func(save_change,{top}, nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			w1_msgbox.set_func(nil,nil, nil,nil);
		end
		if (w1_page_add_dwell.data_check_illegal == true) then --ݷǷ
			return 0;
		end
		b_dlg.end_modal(top);
	elseif b_ui.WM_USER_UPDATE_PARAM == vmsg then
		uitousercfg(top,w1_page_add_dwell.cfgData);
	elseif (w1_page_add_dwell.default_split == true) then 	
		return 0		
	elseif(b_ui.MOUSEWHEELUP == vmsg) then
		local drop_hide = b_wnd.get_wnd_hide_status(top,w1_page_add_dwell.dlg.drop.id)
		if (drop_hide == true) then --ǰ״̬
			return 0;
		end	
		w1_page_add_dwell.dwell_mouse_up(top);
	elseif(b_ui.MOUSEWHEELDOWN == vmsg) then
		local drop_hide = b_wnd.get_wnd_hide_status(top,w1_page_add_dwell.dlg.drop.id)
		if (drop_hide == true) then --ǰ״̬
			return 0;
		end	
		w1_page_add_dwell.dwell_mouse_down(top);
	elseif (b_ui.LBUTTONDOWN == vmsg) then	
		local find_chn = 0;
		local s_id = id + 21;
		local e_id = id + 40;
		for i = s_id, e_id do
			local hide_state = b_wnd.get_wnd_hide_status(top, i)
			if (hide_state == false) then --ǰʾ
				local pos = b_wnd.get_wnd_a_rect(top, i);			
				if(pos[1] <= x and x <= (pos[1]+pos[3]) and  pos[2] <= y  and  y <= (pos[2]+pos[4]))then	
					find_chn = i - s_id + 1  + diplay_off
					break;
				end	
			end			
		end
			
		if (find_chn ~= 0) then
			w1_page_add_dwell.select_chn = find_chn;
			w1_page_add_dwell.drag_state = 1;
		end
	elseif (b_ui.LBUTTONDRAG == vmsg) then			
		if (w1_page_add_dwell.drag_state == 1) then
			w1_page_add_dwell.drag_state = 2;
			b_app_api.channge_cursor(b_ui.CURSOR.JY_CURSOR_DRAG);
		else
			local drop_hide = b_wnd.get_wnd_hide_status(top,w1_page_add_dwell.dlg.drop.id)
			if (drop_hide == true) then --ǰ״̬
				return 0;
			end		
			local pos = b_wnd.get_wnd_a_rect(top, w1_page_add_dwell.dlg.drop.id);
			if(pos[1] <= x and x <= (pos[1]+pos[3]) and  pos[2] <= y  and  y <= (pos[2]+pos[4]))then	
				w1_page_add_dwell.dwell_drop_drag(top);
			end	
		end
	elseif (b_ui.LBUTTOUP == vmsg) then	
		if (w1_page_add_dwell.drag_state == 2) then
			local s_id = id + 41;
			local e_id = id + 104;
			local cur_sel_wnd = 0;
			for i = s_id, e_id do
				local hide_state = b_wnd.get_wnd_hide_status(top, i)
				if (hide_state == false) then --ǰʾ
					local pos = b_wnd.get_wnd_a_rect(top, i);			
					if(pos[1] <= x and x <= (pos[1]+pos[3]) and  pos[2] <= y  and  y <= (pos[2]+pos[4]))then	
						cur_sel_wnd = i
						break;
					end	
				end
			end
			
			if (cur_sel_wnd ~= 0) then
				add_channel(top, cur_sel_wnd, w1_page_add_dwell.select_chn, true);
			end

			w1_page_add_dwell.drag_state = 0;
			b_app_api.channge_cursor(b_ui.CURSOR.JY_CURSOR_POINT);
		end
	elseif(b_ui.LBUTTONCLK == vmsg) then		
		local s_id = id + 41;
		local e_id = id + 104;
		for i = s_id, e_id do
			local hide_state = b_wnd.get_wnd_hide_status(top, i)
			if (hide_state == false) then --ǰʾ
				local pos = b_wnd.get_wnd_a_rect(top, i);			
				if(pos[1] <= x and x <= (pos[1]+pos[3]) and  pos[2] <= y  and  y <= (pos[2]+pos[4]))then	
					w1_page_add_dwell.cur_check_wnd = i
					break;
				end	
			end
		end	

		local s_id = id + 41;
		local e_id = id + 104;
		for i = s_id, e_id do
			if (w1_page_add_dwell.cur_check_wnd == i) then
				b_wnd_ex.set_check(top, i, true, false);
			else
				b_wnd_ex.set_check(top, i, false, false);
			end
		end	
		b_dlg.dlg_set_redraw(top);
	end	
	
	
	return 0
end

return w1_page_add_dwell


