--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_adv_insight.insightrow_smoker_flame_area_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local r_str 	= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_adv_insightarea_smoker_flame = 
{
	cfg_data,
	cap_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}


--ע˴s_objectleft_img_xywh
--cx222߿,Ҳͬʱ4
--cy182߿,Ҳͬʱ4
--1280,1440,1920,2Kı߿ֵΪ1,,4Kı߿ֵΪ2
w1_page_adv_insightarea_smoker_flame.s_768 = 
{
	s_smokerflame_area_xywh 					= {53,170,640,398},
	s_smokerflame_img_xywh 					= {17,8,384,296},
	s_smokerflame_clear_xywh 					= {282,320,106,28},
	s_smokerflame_cap_sensitivity_xywh		= {404,7,181,35},	
	s_smokerdect_sensitivity_xywh			= {586,7,160,35},		
	s_smokerflame_cap_audio_dec_xywh 			= {404,42,181,35},
	s_smokerflame_t_audio_dec_xywh 			= {586,42,25,21},
	s_smokerflame_cap_sound_file_xywh 		= {404,78,181,35},
	s_smokerflame_t_sound_file_xywh 			= {586,78,160,35},
	s_smokerflame_cap_flashlight_xywh 		= {404,114,181,35},
	s_smokerflame_t_flashlight_xywh 			= {586,114,25,21},	
	s_smokerflame_cap_draw_xywh 				= {404,150,181,35},
	s_smokerflame_t_draw_xywh 				= {586,150,25,21},	
};

w1_page_adv_insightarea_smoker_flame.s_1280 = 
{
	s_smokerflame_area_xywh 					= {80,240,800,560},
	s_smokerflame_img_xywh 						= {12,10,416,416},
	s_smokerflame_clear_xywh 					= {270,440,150,40},
	s_smokerflame_cap_sensitivity_xywh			= {430,10,340,50},	
	s_smokerdect_sensitivity_xywh				= {780,10,120,50},		
	s_smokerflame_cap_audio_dec_xywh 			= {430,70, 340, 50},	
	s_smokerflame_t_audio_dec_xywh 				= {773,70, 48,  30},	
	s_smokerflame_cap_sound_file_xywh 			= {430,130, 340, 50},	
	s_smokerflame_t_sound_file_xywh 			= {780,130, 120, 50},	
	s_smokerflame_cap_flashlight_xywh 			= {430,190, 340, 50},	
	s_smokerflame_t_flashlight_xywh 			= {773,190, 48, 30},	
	s_smokerflame_cap_draw_xywh 				= {430,250,350,50},
	s_smokerflame_t_draw_xywh 					= {773,250,48,30},
};

w1_page_adv_insightarea_smoker_flame.s_1440 = 
{
	s_smokerflame_area_xywh 					= {100,220,900,480},
	s_smokerflame_img_xywh 						= {12,10,500,356},
	s_smokerflame_clear_xywh 					= {300,380,200,40},
	s_smokerflame_cap_sensitivity_xywh		= {530,10,300,40},	
	s_smokerdect_sensitivity_xywh			= {850,10,160,40},		
	s_smokerflame_cap_audio_dec_xywh 			= {530,60, 300, 40},	
	s_smokerflame_t_audio_dec_xywh 			= {843,60, 48,  30},	
	s_smokerflame_cap_sound_file_xywh 		= {530,110, 300, 40},	
	s_smokerflame_t_sound_file_xywh 			= {850,110, 160, 40},	
	s_smokerflame_cap_flashlight_xywh 		= {530,160, 300, 40},	
	s_smokerflame_t_flashlight_xywh 			= {843,160, 48, 30},	
	s_smokerflame_cap_draw_xywh 			 	= {530,210,300,40},
	s_smokerflame_t_draw_xywh 				= {843,210,48,30},
};

w1_page_adv_insightarea_smoker_flame.s_1080p = 
{
	s_smokerflame_area_xywh 					= {100,240,1200,560},
	s_smokerflame_img_xywh 					= {30,10,704,416},
	s_smokerflame_clear_xywh 					= {530,450,200,40},
	s_smokerflame_cap_sensitivity_xywh		= {740,10,340,50},	
	s_smokerdect_sensitivity_xywh			= {1080,10,340,50},	
	s_smokerflame_cap_audio_dec_xywh 			= {740, 70, 340, 50},	
	s_smokerflame_t_audio_dec_xywh 			= {1073,70, 48, 30},	
	s_smokerflame_cap_sound_file_xywh 		= {740, 130, 340, 50},	
	s_smokerflame_t_sound_file_xywh 			= {1080,130, 300, 50},	
	s_smokerflame_cap_flashlight_xywh 		= {740, 190, 340, 50},	
	s_smokerflame_t_flashlight_xywh 			= {1073,190, 48, 30},		
	s_smokerflame_cap_draw_xywh 			 	= {740, 250,340,50},
	s_smokerflame_t_draw_xywh 				= {1073,250,48,30},	
};

w1_page_adv_insightarea_smoker_flame.s_2k = 
{
	s_smokerflame_area_xywh 					= {133,319,1599,746},
	s_smokerflame_img_xywh 					= {16,13,970,555},
	s_smokerflame_clear_xywh 					= {706,600,266,53},
	s_smokerflame_cap_sensitivity_xywh		= {986,13,453,66},	
	s_smokerdect_sensitivity_xywh			= {1439,13,399,66},	
	s_smokerflame_cap_audio_dec_xywh 			= {986,79,453,66},
	s_smokerflame_t_audio_dec_xywh 			= {1439,79,63,39},
	s_smokerflame_cap_sound_file_xywh 		= {986,146,453,66},
	s_smokerflame_t_sound_file_xywh 			= {1439,146,399,66},
	s_smokerflame_cap_flashlight_xywh 		= {986,213,453,66},
	s_smokerflame_t_flashlight_xywh 			= {1439,213,63,39},
	s_smokerflame_cap_draw_xywh 				= {986,279,453,66},
	s_smokerflame_t_draw_xywh 				= {1439,279,63,39},	
};
w1_page_adv_insightarea_smoker_flame.s_4k = 
{
	s_smokerflame_area_xywh 					= {200,480,2400,1120},
	s_smokerflame_img_xywh 					= {24,20,1412,832},
	s_smokerflame_clear_xywh 					= {1060,900,400,80},
	s_smokerflame_cap_sensitivity_xywh		= {1480,20,680,100},	
	s_smokerdect_sensitivity_xywh			= {2146,20,600,100},	
	s_smokerflame_cap_audio_dec_xywh 			= {1480,120,680,100},
	s_smokerflame_t_audio_dec_xywh 			= {2146,120,96,60},
	s_smokerflame_cap_sound_file_xywh 		= {1480,220,680,100},
	s_smokerflame_t_sound_file_xywh 			= {2160,220,600,100},
	s_smokerflame_cap_flashlight_xywh 		= {1480,320,680,100},
	s_smokerflame_t_flashlight_xywh 			= {2146,320,96,60},
	s_smokerflame_cap_draw_xywh 				= {1480,420,680,100},
	s_smokerflame_t_draw_xywh 				= {2146,420,96,60},	
};

w1_page_adv_insightarea_smoker_flame.datacheck = function(top, redraw)
	return true,nil
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_adv_insightarea_smoker_flame.wnd;
	local area = cfgdata.area
	local capdata = w1_page_adv_insightarea_smoker_flame.cap_data;
	area.isDraw = b_wnd_ex.get_check(top,cwnd.t_draw.id);
	area.sensitivity = b_wnd_ex.get_sel(top,cwnd.t_sensitivity.id) + 1;
	local intarea = b_wnd_ex.get_intarea(top,cwnd.image.id)
	area.region_list = {}
	area.region_num = 0
	for i=1, w1_page_adv_insightarea_smoker_flame.cap_data.maxRegionNum do
		if(nil ~= intarea['area'..i]) then
			area.region_num = area.region_num + 1;
			area.region_list['region'..i] = {}
			area.region_list['region'..i].point_num = 0;
			area.region_list['region'..i].points = {}
			for j = 1, w1_page_adv_insightarea_smoker_flame.cap_data.edgeNum do
				if intarea['area'..i]['point'..j] ~= nil then
					area.region_list['region'..i].points['point'..j] = {}
					area.region_list['region'..i].points['point'..j].x = intarea['area'..i]['point'..j].x
					area.region_list['region'..i].points['point'..j].y = intarea['area'..i]['point'..j].y
					area.region_list['region'..i].point_num = area.region_list['region'..i].point_num +1;
				end
			end
		end
	end
	if (capdata.AudioAction_enable == true) then
		area.audio_type = capdata.AudioAction_min + b_wnd_ex.get_sel(top,cwnd.t_sound_cbox.id);	
		area.audio_enable = b_wnd_ex.get_check(top,cwnd.t_enable_audio.id);
	end	
	
	if (capdata.LEDAction_enable == true) then
		area.led_enable = b_wnd_ex.get_check(top,cwnd.t_enable_flshlight.id);
	end	
	cfgdata.change_flag = true;
end

local update_layout_info = function(top, redraw)
	local cwnd = w1_page_adv_insightarea_smoker_flame.wnd;	
	--ȸλؼλ
	local pos = nil;
	local s_id = cwnd.cap_sensitivity.id; 
	local e_id = cwnd.t_draw.id;
	for i = s_id, e_id do
		pos = SIZE(cwnd[cwnd.sub[i - id]].xywh);
		b_wnd_ex.move_pos(top, i, {pos[1], pos[2]}, false);
	end	

	pos = SIZE('s_smokerflame_cap_sensitivity_xywh');	
	local s_y = pos[2];
	pos = SIZE('s_smokerflame_cap_audio_dec_xywh');
	local move_h = pos[2] - s_y;	
	local capdata = w1_page_adv_insightarea_smoker_flame.cap_data
	local area = w1_page_adv_insightarea_smoker_flame.cfg_data.area
				
	if capdata.Region_enable == true then
		b_wnd_ex.set_disable(top,cwnd.clear.id,false,false);
	else
		b_wnd_ex.set_disable(top,cwnd.clear.id,true,false);
	end	
	
	if (capdata.AudioAction_enable == true) then
		b_wnd_ex.set_hide(top,cwnd.cap_enable_audio.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_audio.id,false,false);
		local audio_enable = b_wnd_ex.get_check(top,cwnd.t_enable_audio.id);	
		if (audio_enable == true) then
			b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,false,false);
			b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,false,false);	
		else
			b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,true,false);
			b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,true,false);		
			--һ
			local s_id = cwnd.cap_enable_flshlight.id; 
			local e_id = cwnd.t_draw.id;
			for i = s_id, e_id do
				pos = b_wnd.get_wnd_a_rect(top, i);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
			end			
		end	
	else
		b_wnd_ex.set_hide(top,cwnd.cap_enable_audio.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_audio.id,true,false);	
		b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,true,false);	
		--2
		local s_id = cwnd.cap_enable_flshlight.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - 2*move_h}, false);
		end			
	end
	
	if (capdata.LEDAction_enable == true) then
		b_wnd_ex.set_hide(top,cwnd.cap_enable_flshlight.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_flshlight.id,false,false);	
	else
		b_wnd_ex.set_hide(top,cwnd.cap_enable_flshlight.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_flshlight.id,true,false);	
		--һ
		local s_id = cwnd.cap_draw.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end			
	end	
	
	if capdata.OSDDrawLine_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_draw.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_draw.id,false,false);
	else
		b_wnd_ex.set_hide(top,cwnd.cap_draw.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_draw.id,true,false);
	end	
	
	if (redraw ~= false) then
		b_dlg.dlg_set_redraw(top);
	end
end	

w1_page_adv_insightarea_smoker_flame.setmareaparam = function(top, param, redraw)
	local area = param.area
	local cwnd = w1_page_adv_insightarea_smoker_flame.wnd;
	w1_page_adv_insightarea_smoker_flame.cfg_data = param;
	local capdata = w1_page_adv_insightarea_smoker_flame.cap_data
	local img_cap = {};
	img_cap.Region_enable = capdata.Region_enable;
	img_cap.edgeNum = capdata.edgeNum;
	img_cap.maxRegionNum = capdata.maxRegionNum;
	b_wnd_ex.set_cap(top,cwnd.image.id,img_cap,false);	
	b_wnd_ex.set_check(top,cwnd.t_draw.id,area.isDraw,false);
	b_wnd_ex.clear_intarea(top,cwnd.image.id,false,false);
	if (capdata.Sensitivity_enable == true) then
		local param = {};
		for i=capdata.Sensitivity_min,capdata.Sensitivity_max do
			param[i] = tostring(i);
		end
		b_wnd_ex.set_items(top, cwnd.t_sensitivity.id, param, false);
	end
	b_wnd_ex.set_sel(top, cwnd.t_sensitivity.id, area.sensitivity-1, false);	
	
	if (capdata.AudioAction_enable == true) then
		local param = {};
		for i=capdata.AudioAction_min+1,capdata.AudioAction_max+1 do
			param[i] = STR('LA_AUDIO') .. tostring(i-1);
		end
		b_wnd_ex.set_items(top, cwnd.t_sound_cbox.id, param, false);
	end
	b_wnd_ex.set_check(top,cwnd.t_enable_audio.id,area.audio_enable,false);
	b_wnd_ex.set_sel(top, cwnd.t_sound_cbox.id, area.audio_type - capdata.AudioAction_min, false);	
	b_wnd_ex.set_check(top,cwnd.t_enable_flshlight.id,area.led_enable,false);
	
	local region_num = area.region_num;
	local intarea = {};
	for i = 1, region_num do
		intarea['area'..i] = {};
		intarea['area'..i].points = {};
		intarea['area'..i].point_num = area.region_list['region'..i].point_num 
		for j = 1,  intarea['area'..i].point_num do
			intarea['area'..i].points['point'..j]= {};
			intarea['area'..i].points['point'..j].x = area.region_list['region'..i].points['point'..j].x
			intarea['area'..i].points['point'..j].y = area.region_list['region'..i].points['point'..j].y
		end
	end
	
	if region_num > 0 and intarea['area'..1].point_num ~= nil and intarea['area'..1].point_num ~= 0 then
		b_wnd_ex.set_intarea(top,cwnd.image.id,intarea,false);
	end
	
	update_layout_info(top, false);
	
	if (redraw ~= false) then
		b_dlg.dlg_set_redraw(top);
	end
end
	
w1_page_adv_insightarea_smoker_flame.setcapdata = function(top, p_data, redraw)
	local cwnd = w1_page_adv_insightarea_smoker_flame.wnd;
	w1_page_adv_insightarea_smoker_flame.cap_data = p_data;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg or b_ui.LBUTTONCLK == vmsg) then
		local cwnd = w1_page_adv_insightarea_smoker_flame.wnd;
		uitousercfg(top,w1_page_adv_insightarea_smoker_flame.cfg_data)
	end
	return 0
end

local on_clear = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_wnd_ex.clear_intarea(top,w1_page_adv_insightarea_smoker_flame.wnd.image.id,false,false);
		uitousercfg(top,w1_page_adv_insightarea_smoker_flame.cfg_data)
	end
	return 0;
end

local on_enable_audio = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		update_layout_info(top, true);
		uitousercfg(top,w1_page_adv_insightarea_smoker_flame.cfg_data)
	end
	return 0
end

w1_page_adv_insightarea_smoker_flame.clear_data = function()
	w1_page_adv_insightarea_smoker_flame.cfg_data = nil;	
	w1_page_adv_insightarea_smoker_flame.cap_data = nil;
end

w1_page_adv_insightarea_smoker_flame.setdispch = function(top, idx)
	local param = {
		chn_id = idx,
		wnd_id = 1,
	}
	local layoutpos = w1_page_adv_insightarea_smoker_flame.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param);
	return 0;
end

w1_page_adv_insightarea_smoker_flame.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_adv_insightarea_smoker_flame.wnd;
	local sid = cwnd.image.id;
	local eid = cwnd.t_draw.id
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end
end

w1_page_adv_insightarea_smoker_flame.on_pre_show = function(top)
	local cwnd = w1_page_adv_insightarea_smoker_flame.wnd;
	local param = {
		x = SIZE('s_smokerflame_img_xywh')[1] + SIZE('s_smokerflame_area_xywh')[1]+ SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_smokerflame_img_xywh')[2] + SIZE('s_smokerflame_area_xywh')[2]+ SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_smokerflame_img_xywh')[3],
		cy = SIZE('s_smokerflame_img_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_adv_insightarea_smoker_flame.layoutpos.x = param.x;
	w1_page_adv_insightarea_smoker_flame.layoutpos.cx = param.cx;
	w1_page_adv_insightarea_smoker_flame.layoutpos.y = param.y;
	w1_page_adv_insightarea_smoker_flame.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_smokerflame_img_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_smokerflame_img_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
end

w1_page_adv_insightarea_smoker_flame.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_smokerflame_area_xywh',	
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'image','clear', 'cap_sensitivity','t_sensitivity',	'cap_enable_audio', 't_enable_audio',
		'cap_sound_cbox', 't_sound_cbox','cap_enable_flshlight','t_enable_flshlight','cap_draw','t_draw'},
	image 	= {t='intelarea',id=id+1,xywh='s_smokerflame_img_xywh',text='image weight',trans = false,
				color= {'c_image_bk', 'c_cfg_row_bk', 'c_txt_n'},cmd = on_update_param},
	clear	= {t='tt_button',id=id+2,xywh='s_smokerflame_clear_xywh',text='LA_CLEAR',cmd = on_clear},			

	cap_sensitivity = {t='static',	id=id+3, xywh='s_smokerflame_cap_sensitivity_xywh',text='LA_SENSITIVITY'},
	t_sensitivity = {t='combox',	id=id+4, xywh='s_smokerdect_sensitivity_xywh' ,trans = false,
					items = {}, trans = false, cmd = on_update_param},
					
	cap_enable_audio 	= {t='static',id=id+5,	xywh='s_smokerflame_cap_audio_dec_xywh',	text='LA_AUDIO_DEC_ALARM'},
	t_enable_audio 		= {t='tt_check', id=id+6,xywh='s_smokerflame_t_audio_dec_xywh',			
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable_audio},
	
	cap_sound_cbox	= {t='static',id=id+7,	xywh='s_smokerflame_cap_sound_file_xywh',	text='LA_SOUND_ALARM_FILE'},
	t_sound_cbox 	= {t='combox',id=id+8,	xywh='s_smokerflame_t_sound_file_xywh',	items={},trans = false,cmd=on_update_param},	
	
	cap_enable_flshlight 	= {t='static',id=id+9,	xywh='s_smokerflame_cap_flashlight_xywh',	text='LA_FLASHLIGHT_ALARM'},
	t_enable_flshlight 	= {t='tt_check', id=id+10,xywh='s_smokerflame_t_flashlight_xywh',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
				
	cap_draw =  {t='static',	id=id+11, xywh='s_smokerflame_cap_draw_xywh',text='LA_VIDEO_DRAW'},
	t_draw = {t='tt_check',id=id+12, xywh='s_smokerflame_t_draw_xywh',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
				cmd = on_update_param},
}


return w1_page_adv_insightarea_smoker_flame

