--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local util 		= require("wnd.core.util")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local id 		= w1_id.cfg_camera.camera_id
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_legal 	= require("wnd.w1_util.w1_legal")
local w1_modify_camera	= require("wnd.w1_cfg.w1_modify_camera")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local b_app_cfg		= require("wnd.core.b_app_cfg")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 

local channel_num;--豸ͨĿ

local w1_page_camera = 
{
	delete_all_flag = false,
	delete_signel_flag = false,
	del_sel,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_camera.s_768 =
{
	s_camera_chmanage_xywh = {42,21,752,245},
	s_camera_onekeyadd_xywh = {453,277,106,28},
	s_camera_del_xywh = {570,277,106,28},
	s_camera_upgrade_xywh = {688,277,106,28},
	s_camera_hline_xywh = {309,320,485,32},
	s_camera_onlinedev_xywh = {42,320,160,32},
	s_camera_search_xywh = {202,320,106,32},
	s_camera_devlist_xywh = {42,359,752,227},
	s_camera_cap_user_xywh = {261,597,64,28},
	s_camera_t_user_xywh = {336,597,106,28},
	s_camera_cap_pass_xywh = {464,597,64,28},
	s_camera_t_pass_xywh = {538,597,106,28},
	s_camera_add_xywh = {688,597,106,28},
	s_camera_devlist_w1 = {26,0,0,0},
	s_camera_devlist_w2 = {140,0,0,0},
	s_camera_devlist_w3 = {140,0,0,0},
	s_camera_devlist_w4 = {140,0,0,0},
	s_camera_devlist_w5 = {200,0,0,0},
	s_camera_devlist_w6 = {84,0,0,0},
};

w1_page_camera.s_1280 = 
{
	s_camera_chmanage_xywh = {80,30,860,345},
	s_camera_onekeyadd_xywh = {300,390,200,40},
	s_camera_del_xywh = {520,390,200,40},
	s_camera_upgrade_xywh= {740,390,200,40},
	s_camera_hline_xywh = {580,450,360,45},
	s_camera_onlinedev_xywh = {80,450,300,45},
	s_camera_search_xywh = {380,450,200,45}, 
	s_camera_devlist_xywh = {80,505,860,290},
	s_camera_cap_user_xywh = {90,810,120,40}, 
	s_camera_t_user_xywh = {230,810,160,40}, 
	s_camera_cap_pass_xywh = {390,810,120,40}, 
	s_camera_t_pass_xywh = {530,810,160,40},
	s_camera_add_xywh = {740,810,200,40},
	s_camera_devlist_w1 = {50,0,0,0},
	s_camera_devlist_w2 = {220,0,0,0},
	s_camera_devlist_w3 = {100,0,0,0},
	s_camera_devlist_w4 = {100,0,0,0},
	s_camera_devlist_w5 = {260,0,0,0},
	s_camera_devlist_w6 = {100,0,0,0},
}

w1_page_camera.s_1440 = 
{
	s_camera_chmanage_xywh = {80,30,920,287},
	s_camera_onekeyadd_xywh = {360,330,200,40},
	s_camera_del_xywh = {580,330,200,40},
	s_camera_upgrade_xywh= {800,330,200,40},
	s_camera_hline_xywh = {580,380,420,40},
	s_camera_onlinedev_xywh = {80,380,300,40},
	s_camera_search_xywh = {380,380,200,40}, 
	s_camera_devlist_xywh = {80,430,920,242},
	s_camera_cap_user_xywh = {90,684,120,40}, 
	s_camera_t_user_xywh = {230,687,160,33}, 
	s_camera_cap_pass_xywh = {450,684,120,40}, 
	s_camera_t_pass_xywh = {590,687,160,33},
	s_camera_add_xywh = {800,684,200,33},
	s_camera_devlist_w1 = {50,0,0,0},
	s_camera_devlist_w2 = {220,0,0,0},
	s_camera_devlist_w3 = {120,0,0,0},
	s_camera_devlist_w4 = {120,0,0,0},
	s_camera_devlist_w5 = {280,0,0,0},
	s_camera_devlist_w6 = {100,0,0,0},
}

w1_page_camera.s_1080p = 
{
	s_camera_chmanage_xywh = {80,30,1410,345},
	s_camera_onekeyadd_xywh = {850,390,200,40},
	s_camera_del_xywh = {1070,390,200,40},
	s_camera_upgrade_xywh= {1290,390,200,40},
	s_camera_hline_xywh = {580,450,910,45},
	s_camera_onlinedev_xywh = {80,450,300,45},
	s_camera_search_xywh = {380,450,200,45}, 
	s_camera_devlist_xywh = {80,505,1410,320},
	s_camera_cap_user_xywh = {490,840,120,40}, 
	s_camera_t_user_xywh = {630,840,200,40}, 
	s_camera_cap_pass_xywh = {870,840,120,40}, 
	s_camera_t_pass_xywh = {1010,840,200,40},
	s_camera_add_xywh = {1290,840,200,40},
	s_camera_devlist_w1 = {50,0,0,0},
	s_camera_devlist_w2 = {300,0,0,0},
	s_camera_devlist_w3 = {300,0,0,0},
	s_camera_devlist_w4 = {300,0,0,0},
	s_camera_devlist_w5 = {300,0,0,0},
	s_camera_devlist_w6 = {140,0,0,0},
}

w1_page_camera.s_2k = 
{
	s_camera_chmanage_xywh = {107,40,1880,462},
	s_camera_onekeyadd_xywh = {1133,520,267,53},
	s_camera_del_xywh = {1426,520,267,53},
	s_camera_upgrade_xywh= {1720,520,267,53},
	s_camera_hline_xywh = {773,600,1213,60},
	s_camera_onlinedev_xywh = {107,600,400,60},
	s_camera_search_xywh = {507,600,267,60},
	s_camera_devlist_xywh = {107,673,1880,427},
	s_camera_cap_user_xywh = {653,1120,160,53},
	s_camera_t_user_xywh = {840,1120,267,53},
	s_camera_cap_pass_xywh = {1160,1120,160,53},
	s_camera_t_pass_xywh = {1346,1120,267,53},
	s_camera_add_xywh = {1720,1120,267,53},
	s_camera_devlist_w1 = {67,0,0,0},
	s_camera_devlist_w2 = {400,0,0,0},
	s_camera_devlist_w3 = {400,0,0,0},
	s_camera_devlist_w4 = {400,0,0,0},
	s_camera_devlist_w5 = {400,0,0,0},
	s_camera_devlist_w6 = {186,0,0,0},
}

w1_page_camera.s_4k = 
{
	s_camera_chmanage_xywh = {160,60,2820,690},
	s_camera_onekeyadd_xywh = {1700,780,400,80},
	s_camera_del_xywh = {2140,780,400,80},
	s_camera_upgrade_xywh= {2580,780,400,80},
	s_camera_hline_xywh = {1160,900,1820,90},
	s_camera_onlinedev_xywh = {160,900,600,90},
	s_camera_search_xywh = {760,900,400,90},
	s_camera_devlist_xywh = {160,1010,2820,640},
	s_camera_cap_user_xywh = {980,1680,240,80},
	s_camera_t_user_xywh = {1260,1680,400,80},
	s_camera_cap_pass_xywh = {1740,1680,240,80},
	s_camera_t_pass_xywh = {2020,1680,400,80},
	s_camera_add_xywh = {2580,1680,400,80},
	s_camera_devlist_w1 = {100,0,0,0},
	s_camera_devlist_w2 = {600,0,0,0},
	s_camera_devlist_w3 = {600,0,0,0},
	s_camera_devlist_w4 = {600,0,0,0},
	s_camera_devlist_w5 = {600,0,0,0},
	s_camera_devlist_w6 = {280,0,0,0},
}


w1_page_camera.timestart = false;
w1_page_camera.searchstart = false;
w1_page_camera.searchcount = 0;
w1_page_camera.searchlist = {};

local cameralist_refresh = function(top, redraw)
	local cwnd = w1_page_camera.wnd;
	local param = b_app_api.get_cfg({'camera'}).camera;
	local camera_num = param.camera_num;
	if(param.camera_num >= 0) then
		camera_num = param.camera_num;
	else
		return 0;
	end
	
	local param_searchlist = {};
	local idx = 1;
	local i;
	
	--local paramdata;
	local data = {};
	local dataidx;
	local trade_name = b_app_api.get_trade_name().name;
	if(trade_name == nil or trade_name == '') then
		trade_name = 'Private'
	end
	for i=1,camera_num do
		if(param['idx'..i] == nil ) then
			return 0;
		end
		--paramdata = param['idx'..i];
		--data = w1_page_camera.searchlist;
		dataidx = 'idx'..idx;
		if(param['idx'..i].binded == false) then
			data[dataidx] = nil;
			data[dataidx] = param['idx'..i];
			if(param['idx'..i].device_type == 0)then
				data[dataidx].chtype = 'LOCAL'		--IPC
			elseif(param['idx'..i].device_type == 1) then
				data[dataidx].chtype = 'IPDOME'		
			elseif(param['idx'..i].device_type == 2) then
				data[dataidx].chtype = 'IPC'			
			else
				data[dataidx].chtype = 'Other'		
			end
				
			data[dataidx].protocol_num = param['idx'..i].protocol;
			if(param['idx'..i].protocol == 0)then
				data[dataidx].protocol = 'Unkown';
			elseif(param['idx'..i].protocol == 1)then
				data[dataidx].protocol = 'ONVIF';
			elseif(param['idx'..i].protocol == 2)then
				data[dataidx].protocol = trade_name;
			elseif(param['idx'..i].protocol == 3)then
				data[dataidx].protocol = 'Local';
			elseif(param['idx'..i].protocol == 4)then
				data[dataidx].protocol = trade_name..'_SSL';
			end
			data[dataidx].address = param['idx'..i].addr;	
			data[dataidx].addr = param['idx'..i].addr..':'..param['idx'..i].port
			data[dataidx].fw_ver = param['idx'..i].fw_ver
			data[dataidx].model = param['idx'..i].model
			idx = idx + 1;
		end
	end
	
	if(w1_page_camera.searchlist == nil ) then	
		w1_page_camera.searchlist = util.copy_tab(data);
	else
		util.copy_tab_b(w1_page_camera.searchlist, data);
	end

	local searchlist = {};
	searchlist.item_total = idx - 1;
	
	local hide_opera1 = {};
	for i=1,searchlist.item_total do
		hide_opera1[i] = true;
		searchlist['idx'..i] = {i-1, false, '', 
			data['idx'..i].addr, data['idx'..i].model,
			data['idx'..i].protocol, data['idx'..i].fw_ver, ''};
			
		--˽Эssl֧޸	
		if((data['idx'..i].protocol == trade_name) or (param['idx'..i].protocol == trade_name..'_SSL'))then
			hide_opera1[i] = false;
		end
	end
	
	--ʱ
	for i = searchlist.item_total + 1, 6 do
		hide_opera1[i] = true;
	end
	b_wnd_ex.set_listdata(top, cwnd.devlist.id, searchlist, redraw);
	b_wnd_ex.set_hide_opera1(top,cwnd.devlist.id, hide_opera1,redraw);	
	
	if(w1_page_camera.delete_all_flag) then--ؼ·ɾťɾ
		local checktab = {};
		for i=1,channel_num do
			checktab[i] = false;
		end
		b_wnd_ex.set_selecechannel(top, cwnd.chmanage.id, checktab, false);
		w1_page_camera.delete_all_flag = false;
	end
	if(w1_page_camera.delete_signel_flag) then--ؼĵɾťɾ
		local checktab = {};
		local selecechannel = b_wnd_ex.get_selecechannel(top, cwnd.chmanage.id);
		for i=1, channel_num do
			if(selecechannel['ch'..i] == 1) then
				checktab[i] = true;
			else
				checktab[i] = false;
			end
		end		
		checktab[w1_page_camera.del_sel] = false;
		b_wnd_ex.set_selecechannel(top, cwnd.chmanage.id, checktab, false);	
		w1_page_camera.delete_signel_flag = false;
	end
end

local delete_all_channels = function(param)
	b_app_api.onekeyadd_camera(param[2]);
	cameralist_refresh(param[1], param[3]);
	w1_page_camera.delete_all_flag = true;
	return 0
end

local upgrade_all_channels = function(param)
	b_app_api.upgrade_cameras(param[2]);
	return 0
end

local on_search = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if w1_page_camera.searchstart then
			w1_page_camera.searchstart = false
			w1_page_camera.searchcount = 0
			b_wnd_ex.set_text(top,w1_page_camera.wnd.search.id,STR('LA_START_SEARCH'),true);
		else
			w1_page_camera.searchstart = true
			w1_page_camera.searchcount = 20
			b_app_api.start_search_device();
		end		
	end
	return 0
end

--شparam
--param[1]:top
--param[2]:,,༭,ɾ
--param[3]:
local ok_func = function(param)
	if(param[2] == 2) then	--ɾ
		w1_page_camera.del_sel = param[3];
		--δ ִһ
		if false == w1_page_camera.searchstart then
			on_search(param[1], w1_page_camera.wnd.search.id, b_ui.LBUTTONCLK, 0, 0);
		end		
		cameralist_refresh(param[1], false);
		w1_page_camera.delete_signel_flag = true;	
	end
	return 0;
end

w1_page_camera.init = function(top)
	b_app_cfg.cfgdataclear();					--Ϊýûõ  ֹȽʾ
	local camera_user_pwd = b_app_api.get_cfg({'camera_user_pwd'}).camera_user_pwd;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (dec_num ~= channel_num) then --DVR 4+2ȵ豸 Ҫͨ
		local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
		assert(type(chn_type) == 'table')
		local num = vi_num + dec_num;
		if (0 < vi_num and 0 < dec_num and 0 == chn_type.chn_type[vi_num + 1]) then --δͨ  4 + 2 δ ͨΪ4
			b_wnd_ex.set_chlistattr(top, w1_page_camera.wnd.chmanage.id, {7,vi_num,0}, false);
			num = vi_num;	
		end
		local chn_type_data = {};
		for i = 1, num do
			if (i <= vi_num) then
				chn_type_data[i] = chn_type.chn_type[i];
			else
				chn_type_data[i] = chn_type.chn_type[vi_num + 1];
			end
		end	
		
		b_wnd_ex.set_chlist_chtype(top, w1_page_camera.wnd.chmanage.id, chn_type_data, false);
	end
	b_wnd_ex.set_text(top, w1_page_camera.wnd.t_user.id,camera_user_pwd.account,false);
	b_wnd_ex.set_password(top, w1_page_camera.wnd.t_pass.id,camera_user_pwd.password,false);
	
	w1_modify_camera.init();
	w1_modify_camera.set_func(ok_func, {top});
	
	--һ
	w1_page_camera.searchstart = true
	w1_page_camera.searchcount = 20
	b_app_api.start_search_device();
	local time=w1_page_camera.searchcount;
	local str = STR('LA_STOP_SEARCH') ..'('..time..'s)'
	b_wnd_ex.set_text(top,w1_page_camera.wnd.search.id,str,false);

	return 0;
end

w1_page_camera.update_param = function(top)
	local cwnd = w1_page_camera.wnd;
	local username = b_wnd_ex.get_text(top, cwnd.t_user.id);				
	local userpwd = b_wnd_ex.get_password(top, cwnd.t_pass.id);		
	b_app_api.save_ipc_default_pwd(username, userpwd);
	return 0;
end

local on_onekeyadd = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_camera.wnd;
			
		local param = b_app_api.get_cfg({'camera'}).camera;
		local camera_list = {};
		local listtotal = 0;
		for i=1,param.camera_num do	
			if(param['idx'..i].binded == false) then
				listtotal = listtotal + 1;
			end		
		end
		
		for i=1,listtotal do
			for j=i,param.camera_num do
				if(param['idx'..j].binded == false) then
					camera_list['idx'..i] = param['idx'..j];
					camera_list['idx'..i].binded = true;
					camera_list['idx'..i].account = b_wnd_ex.get_text(top, w1_page_camera.wnd.t_user.id);
					camera_list['idx'..i].password = b_wnd_ex.get_password(top, w1_page_camera.wnd.t_pass.id);
					camera_list['idx'..i].remote_cam =1;
					break
				end
			end
		end
		camera_list.camera_num = listtotal;
		local ret = true;
		local vi_num, dec_num = global_val.get_vi_dec_num();
		local count = channel_num
		local total_chn = channel_num;
		local local_chn = 0;
		local search_flag = false
		if (dec_num ~= channel_num) then --DVR 4+2ȵ豸 Ҫͨ
			count = 0;
			local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
			assert(type(chn_type) == 'table')
			for i = 1, vi_num do
				if (chn_type.chn_type[i] == 2) then
					count = count + 1;
				else
					local_chn = local_chn + 1;
				end
			end
			if (0 < vi_num and 0 < dec_num and 0 == chn_type.chn_type[vi_num + 1]) then --δͨ  4 + 2 δ ͨΪ4
				total_chn = total_chn - dec_num
			else
				count = count + dec_num
			end			
		end
		local index = 1;
		for i=local_chn+1,total_chn do
			search_flag = false;
			for j =1,param.camera_num do
				if( param['idx'..j].channel_id == i ) then
					search_flag = true;
					break;
				end
			end
			if(search_flag== false) then
				index = index + 1;
			end
		end
		if(index == 1) then
			--ʾʾͨѾ
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_ALL_BOUND'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			ret = false;
		else
			if(camera_list.camera_num ~=0 ) then
				if(camera_list.camera_num > 64) then
					local i;
					for i=64+1, camera_list.camera_num do
						camera_list['idx'..i] = nil;
					end
					camera_list.camera_num = 64;
				end
				local nret = b_app_api.onekeyadd_camera(camera_list);
				if(nret.ret == 3105)then
					w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_IP_CONFLICT'), true, false,false);
					w1_msgbox.set_func(nil, nil, nil, nil);
					b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
					ret = false;
				else
					local username = b_wnd_ex.get_text(top, cwnd.t_user.id);				
					local userpwd = b_wnd_ex.get_password(top, cwnd.t_pass.id);
					b_app_api.save_ipc_default_pwd(username, userpwd);
				end
			else
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_CHANNEL_BINDING'), true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
				ret = false;
			end
		end
		
		if (ret == true) then
			local checktab = {};	
			for i=1, 128 do
				checktab[i] = false;
			end
			
			--δ ִһ
			if false == w1_page_camera.searchstart then
				on_search(top, w1_page_camera.wnd.search.id, b_ui.LBUTTONCLK, 0, 0);
			end
			
			b_wnd_ex.set_selecelist(top, cwnd.devlist.id, checktab, false);
			b_wnd_ex.clear_checkall(top, cwnd.devlist.id, false, false);
			cameralist_refresh(top, true);
		end
	end
	return 0
end

local on_savepwd  = function(top, id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_camera.wnd;
		local username = b_wnd_ex.get_text(top, cwnd.t_user.id);				
		local userpwd = b_wnd_ex.get_password(top, cwnd.t_pass.id);
		
		b_app_api.save_ipc_default_pwd(username, userpwd);
	end	
	return 0;
end	

local on_del = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then			
		local selecech = b_wnd_ex.get_selecechannel(top, w1_page_camera.wnd.chmanage.id);
		local cameralist = b_app_api.get_cfg({'camera'}).camera;
		local delcameralist = {};
		local idx = 1;
		local i;
		for i=1,channel_num do
			local chname = 'ch'..i
			if(selecech[chname] == 1) then
				local j;
				for j=1,channel_num do
					if(cameralist['idx'..j] ~=nil ) then
						if(cameralist['idx'..j].channel_id == i) then
							cameralist['idx'..j].binded = false;
							delcameralist['idx'..idx] = cameralist['idx'..j];
							idx = idx+1;
						end
					end
				end
			end
		end
		
		delcameralist.camera_num = idx-1;
		if(delcameralist.camera_num ~=0 ) then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_ISDEL_CHANNEL'), true, true,false);
			w1_msgbox.set_func(delete_all_channels,{top, delcameralist, true}, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
		else
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_CHANNEL_DEL'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		end
		local cwnd = w1_page_camera.wnd;
		b_wnd_ex.clear_checkall(top, cwnd.chmanage.id, false, false);
		
		--δ ִһ
		if false == w1_page_camera.searchstart then
			on_search(top, w1_page_camera.wnd.search.id, b_ui.LBUTTONCLK, 0, 0);
		end
	end
	return 0
end

local on_upgrade = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then			
		local selecech = b_wnd_ex.get_selecechannel(top, w1_page_camera.wnd.chmanage.id);
		local cameralist = b_app_api.get_cfg({'camera'}).camera;
		local upgradecameralist = {};
		local idx = 1;
		local i;
		local onvif_flag = false;
		for i=1,channel_num do
			local chname = 'ch'..i
			if(selecech[chname] == 1) then
				local j;
				for j=1,channel_num do
					if(cameralist['idx'..j] ~=nil ) then
						if(cameralist['idx'..j].channel_id == i) then
							local c,n1,n2,n3,n4,n5,n6,n7,s = string.match(tostring(cameralist['idx'..j].fw_ver), "(%w?)(%w?)%.(%d+)%.(%d+)%.(%d+)%.(%d+)%.(%d+)%.(%d+)%.(%w+)")
							if cameralist['idx'..j].sn ~= '' and cameralist['idx'..j].sn ~= nil and cameralist['idx'..j].protocol ~= 1 and cameralist['idx'..j].state == 4 
								and c == 'v' and (tonumber(n1) > 3 or (tonumber(n1)== 3 and tonumber(n2) == 5 and tonumber(n7)>=31) or 
								(tonumber(n1)== 3 and tonumber(n2) == 6 and tonumber(n7)>=2) or
								(tonumber(n1)== 3 and tonumber(n2) > 7 ))then
								upgradecameralist['idx'..idx] = cameralist['idx'..j];
								idx = idx+1;
							else
								onvif_flag = true
							end
						end
					end
				end
			end
		end
		
		upgradecameralist.camera_num = idx-1;
		local upgradedata = {}
		if(upgradecameralist.camera_num ~=0 ) then
			b_app_api.set_update_type(0);
			b_app_api.mount_dev();
			local upgradedata = b_dlg.do_modal(top, w1_key.DLG_UPGRADEDECTORY, 0, 0, 1)
			if (nil ~= upgradedata and '' ~= upgradedata) then
					local paramdata = cjson.decode(upgradedata);
					upgradecameralist.path = paramdata.path
					b_app_api.upgrade_cameras(upgradecameralist)			
			end
			b_app_api.unmount_dev();
		else
			if onvif_flag == true then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NOT_UPGRADES'), true, false,false);			
			else
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NOT_ONVIF_CHANNEL'), true, false,false);
			end
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		end
				
		local cwnd = w1_page_camera.wnd;
		b_wnd_ex.clear_checkall(top, cwnd.chmanage.id, false, false);
	end
	return 0
end

local on_add = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then	
		local cwnd = w1_page_camera.wnd;

		local selecech = b_wnd_ex.get_selecelist(top, cwnd.devlist.id);		
		local cameralist = b_app_api.get_cfg({'camera'}).camera;
		local trade_name = b_app_api.get_trade_name().name;
		if(trade_name == nil or trade_name == '') then
			trade_name = 'Private'
		end
		local i,j;
		local idx = 1;
		local search_flag ;
		local leisurechannel = {};
		local vi_num, dec_num = global_val.get_vi_dec_num();
		local count = channel_num
		local local_chn = 0;
		if (dec_num ~= channel_num) then --DVR 4+2ȵ豸 Ҫͨ
			local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
			assert(type(chn_type) == 'table')
			for i = 1, vi_num do
				if (chn_type.chn_type[i] ~= 2) then
					local_chn = local_chn + 1;
				end
			end
			if (0 < vi_num and 0 < dec_num and 0 == chn_type.chn_type[vi_num + 1]) then --δͨ  4 + 2 δ ͨΪ4
				count = count - dec_num
			end			
		end
		for i=local_chn+1,count do
			search_flag = false;
			for j =1,cameralist.camera_num do
				if( cameralist['idx'..j].channel_id == i ) then
					search_flag = true;
					break;
				end
			end
			if(search_flag== false) then
				leisurechannel[idx] = i;
				idx = idx + 1;
			end
		end
		if(idx == 1) then	--ûпͨ
			w1_msgbox.set_dlgattr(STR('LA_TIP'),STR('LA_ALL_BOUND'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		else
			local selecechlist = {};
			local listidx = 1;
			for i =1, selecech.list_num do
				if(selecech['r'..i] == 1) then
					selecechlist['idx'..listidx] = w1_page_camera.searchlist['idx'..i];
					listidx = listidx + 1;
				end
			end
			selecechlist.camera_num = listidx - 1;
			if(selecechlist.camera_num == 0) then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_SELECT_CH'), true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			else
				local leisurechannel_num =#leisurechannel;
				local min = selecechlist.camera_num;
				if(leisurechannel_num < min) then
					min = leisurechannel_num;
				end	
				
				local username = b_wnd_ex.get_text(top, cwnd.t_user.id);				
				local userpwd = b_wnd_ex.get_password(top, cwnd.t_pass.id);
				local cur_selecechlist = {};
				local j=1;
				for i=1, min do
					if(selecechlist['idx'..i] ~=nil and next(selecechlist['idx'..i]) ~= nil)then
						selecechlist['idx'..i].channel_id = leisurechannel[i];
						
						cur_selecechlist['idx'..j] = selecechlist['idx'..i];
						cur_selecechlist.camera_num = j;
						cur_selecechlist['idx'..j].addr = selecechlist['idx'..i].address; --½ƴӶ˿ڵipָ
						cur_selecechlist['idx'..j].binded = true;
						cur_selecechlist['idx'..j].account = username;
						cur_selecechlist['idx'..j].password = userpwd;
						if(cur_selecechlist['idx'..j].protocol == 'ONVIF') then
							cur_selecechlist['idx'..j].protocol = 1
						elseif(cur_selecechlist['idx'..j].protocol == trade_name) then
							cur_selecechlist['idx'..j].protocol = 2
						elseif(cur_selecechlist['idx'..j].protocol == (trade_name..'_SSL')) then --SSL 
							cur_selecechlist['idx'..j].protocol = 4
						else
							assert(0);
						end
						cur_selecechlist['idx'..j].remote_cam = 1;
						j=j+1;
					end				
				end	
				b_app_api.save_ipc_default_pwd(username, userpwd)
				local nret = b_app_api.onekeyadd_camera(cur_selecechlist);
				if(nret.ret == 3105)then
					w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_IP_CONFLICT'), true, false,false);
					w1_msgbox.set_func(nil, nil, nil, nil);
					b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
					return 0;
				end
				
				--δ ִһ
				if false == w1_page_camera.searchstart then
					on_search(top, w1_page_camera.wnd.search.id, b_ui.LBUTTONCLK, 0, 0);
				end				
				
				local checktab = {};	
				for i=1, 128 do
					checktab[i] = false;
				end
				b_wnd_ex.set_selecelist(top, cwnd.devlist.id, checktab, false);
				b_wnd_ex.clear_checkall(top, cwnd.devlist.id, false, false);
				cameralist_refresh(top, true);
			end
		end
		
	end
	return 0
end

w1_page_camera.chrefresh = function(top, redraw)
	local cwnd = w1_page_camera.wnd;
	local cameralist = b_app_api.get_cfg({'camera_bind'}).camera_bind;
	w1_modify_camera.set_data(cameralist);
	local trade_name = b_app_api.get_trade_name().name;
	if(trade_name == nil or trade_name == '') then
		trade_name = 'Private'
	end
	local rtsp_protocol = b_app_api.get_rtsp_pro();
	local count = rtsp_protocol.protocol_num
	for i=1,cameralist.camera_num do
		cameralist['idx'..i].rtsp_name = ''
		cameralist['idx'..i].address = cameralist['idx'..i].addr; --бһ
		cameralist['idx'..i].protocol_num = cameralist['idx'..i].protocol;
		if(tonumber(cameralist['idx'..i].protocol) == 2) then
			cameralist['idx'..i].prot_name = nil;
			cameralist['idx'..i].prot_name = trade_name
		elseif(tonumber(cameralist['idx'..i].protocol) == 4) then
			cameralist['idx'..i].prot_name = nil;
			cameralist['idx'..i].prot_name = trade_name..'_SSL'
		elseif(tonumber(cameralist['idx'..i].protocol) > 100) then
			local index = tonumber(cameralist['idx'..i].protocol) - 100
			cameralist['idx'..i].rtsp_name = rtsp_protocol['idx'..index].name
		end
	end
	
	if(w1_page_camera.cameralist == nil ) then	
		w1_page_camera.cameralist = util.copy_tab(cameralist);
	else
		util.copy_tab_b(w1_page_camera.cameralist, cameralist);
	end

	b_wnd_ex.set_chdata(top, w1_page_camera.wnd.chmanage.id, cameralist, redraw);
	local upgrade_state = b_app_api.get_cfg({'upgrade_state'}).upgrade_state;
	local camera_num = cameralist.camera_num;
	local disable_table = {};
	disable_table.item_total = camera_num
	for i=1,camera_num  do
		local channel_id = cameralist['idx'..i].channel_id
		if(upgrade_state['idx'..channel_id] == nil ) then
			return 0;
		end
		if(upgrade_state['idx'..channel_id].state == 0) then
			disable_table[i]= channel_id*10+1
		else
			if cameralist['idx'..i].state ~= 4 then
				disable_table[i]= channel_id*10+2
			else
				disable_table[i]= channel_id*10+3
			end			
		end
	end

	b_wnd_ex.set_select_disable(top,cwnd.chmanage.id,disable_table,redraw)	
end

w1_page_camera.timer_start = function()
	w1_page_camera.timestart = true;
end

w1_page_camera.timer_stop = function()
	w1_page_camera.timestart = false;
end

w1_page_camera.timerenevt = function(top)
	if(w1_page_camera.timestart) then
		w1_page_camera.chrefresh(top, false);
		if(w1_page_camera.searchstart) then
			local time=w1_page_camera.searchcount;
			local str = STR('LA_STOP_SEARCH') ..'('..time..'s)'
			b_wnd_ex.set_text(top,w1_page_camera.wnd.search.id,str,false);
			if 0 == w1_page_camera.searchcount%4 then
				cameralist_refresh(top, false);
			end
			if(w1_page_camera.searchcount == 0) then
				w1_page_camera.searchstart = false
				b_wnd_ex.set_text(top,w1_page_camera.wnd.search.id,STR('LA_START_SEARCH'),false);
			else
				w1_page_camera.searchcount = w1_page_camera.searchcount - 1;
			end
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_page_camera.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	b_wnd_ex.set_chlistattr(top, w1_page_camera.wnd.chmanage.id, {7,channel_num,0}, false);
	
	w1_page_camera.chrefresh(top, false);
	cameralist_refresh(top, false);
	
	local param = {
			'', STR('LA_IP'),STR('LA_PRODUCT_MODEL'),STR('LA_PROTOCOL'),STR('LA_SOFTWARE_VERSION'), STR('LA_MOD_ADDR')
		}	
	b_wnd_ex.set_title_texts(top, w1_page_camera.wnd.devlist.id, param, false)
	
	param = {
			STR('LA_CHANNEL'), STR('LA_IP'), STR('LA_PRODUCT_MODEL'), STR('LA_PROTOCOL'),
			STR('LA_FIRMWARE'), STR('LA_OPERATE'), 
		}
	b_wnd_ex.set_title_texts(top, w1_page_camera.wnd.chmanage.id, param, false)
	
	
	local list_w = {};
	local hide_opera1 = {};
	for i=1,6 do
		local str = 's_camera_devlist_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
		hide_opera1[i] = true;
	end
	b_wnd_ex.columns_w(top, w1_page_camera.wnd.devlist.id, list_w, false);
	b_wnd_ex.set_hide_opera1(top,w1_page_camera.wnd.devlist.id, hide_opera1,false);	
	local camera_user_pwd = b_app_api.get_cfg({'camera_user_pwd'}).camera_user_pwd;
	b_wnd_ex.set_text(top, w1_page_camera.wnd.t_user.id,camera_user_pwd.account,false);
	b_wnd_ex.set_password(top, w1_page_camera.wnd.t_pass.id,camera_user_pwd.password,false);
	--Ĭϲʾ 
	b_wnd_ex.set_disp(top, w1_page_camera.wnd.t_pass.id, false, false);
end

w1_page_camera.clear_data = function(top)
	w1_page_camera.searchlist = nil;
	w1_page_camera.cameralist = nil;
	w1_modify_camera.clear_data();
	b_wnd_ex.clear_checkall(top, w1_page_camera.wnd.chmanage.id, false, false);
	b_wnd_ex.clear_checkall(top, w1_page_camera.wnd.devlist.id, false, false);
end

w1_page_camera.get_search_list = function(top)
	return w1_page_camera.searchlist;
end

w1_page_camera.get_bind_list = function(top)
	return  w1_page_camera.cameralist;
end

w1_page_camera.update_ilst_data = function()
	w1_page_camera.searchstart = true
	w1_page_camera.searchcount = 20
	b_app_api.start_search_device();
end

w1_page_camera.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'chmanage', 'onekeyadd','del', 'upgrade','devlist',
			'hline','onlinedev', 'search', 
		   'cap_user', 't_user', 'cap_pass', 't_pass', 'add'},
	
	chmanage 	= {	t='chmanage',id=id+1,	xywh =	's_camera_chmanage_xywh',	font = 'f_grade4',
					chlistattr = {7,4,0}
					},			
	
	onekeyadd 	= {t='button',	id=id+2,	xywh = 	's_camera_onekeyadd_xywh', 	text='LA_ADD_DEVICES',	cmd=on_onekeyadd},
	del 		= {t='button',	id=id+3,	xywh = 	's_camera_del_xywh', 	text='LA_DELETE',		cmd=on_del},
	upgrade		= {t='button',	id=id+4,	xywh = 	's_camera_upgrade_xywh', 	text='LA_BATCH_UPGRADE',		cmd=on_upgrade},
	
	hline		= {t='hline', 	id=id+5,	xywh =	's_camera_hline_xywh',	color = {'c_camear_line', 'c_camear_line', 'c_camear_line'}},

	onlinedev	= {t='static',	id=id+6,	xywh =	's_camera_onlinedev_xywh',		text='LA_ONLINE_DEVICE',
					color = {'c_camear_line', 'c_camear_line', 'c_txt_n'}},
	search	 	= {t='tt_button',id=id+7,	xywh = 	's_camera_search_xywh', 	text='LA_START_SEARCH',
					color = {'c_camear_line', 'c_bor_n', 'c_txt_n'},cmd=on_search},
	devlist	 	= {t='list',	id=id+8,	xywh=	's_camera_devlist_xywh', font = 'f_camera_list',list_resort={2,3,5},
					listattr = {6,6,b_ui.LISTATTR.FIRST_WIDGET_CHECK,b_ui.LISTATTR.END_WIDGET_EDIT},
					dlg_key = {w1_key.DLG_MODIFY_CAM_IP},
					},		
	
	cap_user  	= {t='static',	id=id+9,	xywh =  's_camera_cap_user_xywh', 	text='LA_USER_NAME'},
	t_user  	= {t='edit',	id=id+10,	xywh = 	's_camera_t_user_xywh', 	text='admin',	trans = false, guide_text='LA_USER_NAME',cmd=on_savepwd},
	
	cap_pass  	= {t='static',	id=id+11,	xywh = 	's_camera_cap_pass_xywh', 	text='LA_PASSWORD',	align = b_ui.ALIGN.RIGHT},
	t_pass  	= {t='password',id=id+12,	xywh = 	's_camera_t_pass_xywh', 	password='admin',guide_text='LA_PASSWORD',cmd=on_savepwd},
	add  		= {t='tt_button',id=id+13,	xywh = 	's_camera_add_xywh', 	text='LA_ADD',			cmd=on_add},
}

return w1_page_camera

