--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_diskcfg.diskcfg_id
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg") 
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_app_api 	= require("wnd.core.command.b_app_api")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local util 			= require("wnd.core.util")

local exp_unlegal = 0   --¼Ϊ0
local cap_value = 4;	--ÿҳʾԪظ(ÿҳʾ4)

local w1_page_diskcfg = 
{
	cur_page,		--ǰҳ
	max_page,		--ҳ
	data,
	format_status,
	raid,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_diskcfg.s_768 =
{
	s_diskcfg_disk1img_xywh = {53,42,160,85},
	s_diskcfg_disk2img_xywh = {229,42,160,85},
	s_diskcfg_disk3img_xywh = {405,42,160,85},
	s_diskcfg_disk4img_xywh = {581,42,160,85},
		
	s_diskcfg_pre_disk_xywh = {42,42,24,85},
	s_diskcfg_disk5img_xywh = {77,42,160,85},
	s_diskcfg_disk6img_xywh = {248,42,160,85},
	s_diskcfg_disk7img_xywh = {418,42,160,85},
	s_diskcfg_disk8img_xywh = {589,42,160,85},
	s_diskcfg_next_disk_xywh = {749,42,24,85},
		
	s_diskcfg_format_xywh = {517,177,96,28},
	s_diskcfg_cap_status_xywh = {85,234,213,28},
	s_diskcfg_t_status_xywh = {298,234,160,28},
	s_diskcfg_cap_sn_xywh = {85,277,213,28},
	s_diskcfg_t_sn_xywh = {298,277,160,28},
	s_diskcfg_cap_space_xywh = {85,320,213,28},
	s_diskcfg_t_space_xywh = {298,320,160,28},
	s_diskcfg_cap_group_xywh = {85,362,213,28},
	s_diskcfg_t_group_xywh = {298,362,160,28},
	s_diskcfg_hline1_xywh = {53,216,560,1},
	s_diskcfg_diskname_xywh = {53,184,202,28},
	s_diskcfg_hline2_xywh = {53,412,560,1},
	s_diskcfg_cap_over_w_xywh = {85,433,213,28},
	s_diskcfg_t_over_w_xywh = {269,433,80,28},
	s_diskcfg_cap_record_xywh = {85,476,213,28},
	s_diskcfg_t_record_xywh = {298,476,80,28},
	s_diskcfg_cap_etip_xywh = {85,519,533,28},
	s_diskcfg_tipinfo_xywh = {53,590,373,35},
	s_diskcfg_no_diskname_xywh = {213,21,106,32},
	s_diskcfg_no_hline2_xywh = {53,56,560,1},
	s_diskcfg_no_cap_over_w_xywh = {85,71,213,28},
	s_diskcfg_no_t_over_w_xywh = {269,71,80,28},
	s_diskcfg_no_cap_record_xywh = {85,113,213,28},
	s_diskcfg_no_t_record_xywh = {298,113,80,28},
	s_diskcfg_no_cap_etip_xywh = {85,156,533,28},
};

w1_page_diskcfg.s_1280 = 
{
	
	s_diskcfg_disk1img_xywh = {120,60,200,120},
	s_diskcfg_disk2img_xywh = {330,60,200,120},
	s_diskcfg_disk3img_xywh = {540,60,200,120},
	s_diskcfg_disk4img_xywh = {750,60,200,120},
	
	s_diskcfg_pre_disk_xywh = {80,60,40,120},
	s_diskcfg_disk5img_xywh = {120,60,200,120},
	s_diskcfg_disk6img_xywh = {330,60,200,120},
	s_diskcfg_disk7img_xywh = {540,60,200,120},
	s_diskcfg_disk8img_xywh = {750,60,200,120},
	s_diskcfg_next_disk_xywh = {950,60,40,120},
	
	s_diskcfg_format_xywh = {720,250,180,40},
	s_diskcfg_cap_status_xywh = {130,330,400,40},
	s_diskcfg_t_status_xywh = {560,330,300,40},
	s_diskcfg_cap_sn_xywh = {130,390,400,40},
	s_diskcfg_t_sn_xywh = {560,390,300,40},
	s_diskcfg_cap_space_xywh = {130,450,400,40},
	s_diskcfg_t_space_xywh = {560,450,300,40},
	s_diskcfg_cap_group_xywh = {130,510,400,40},
	s_diskcfg_t_group_xywh = {560,510,300,40},
	s_diskcfg_hline1_xywh = {80,305,800,1},
	s_diskcfg_diskname_xywh = {80,260,380,40},
	s_diskcfg_hline2_xywh = {80,580,800,1},
	s_diskcfg_cap_over_w_xywh = {130,610,400,40},
	s_diskcfg_t_over_w_xywh = {505,610,150,40},
	s_diskcfg_cap_record_xywh = {130,670,400,40},
	s_diskcfg_t_record_xywh = {560,670,150,40}, 
	s_diskcfg_cap_etip_xywh = {130,730,750,40},
	s_diskcfg_tipinfo_xywh = {80,800,700,50},
	s_diskcfg_no_diskname_xywh = {400,30,200,45},
	s_diskcfg_no_hline2_xywh = {80,100,800,1},
	s_diskcfg_no_cap_over_w_xywh = {130,120,400,40},
	s_diskcfg_no_t_over_w_xywh = {505,120,150,40},	
	s_diskcfg_no_cap_record_xywh = {130,180,400,40},
	s_diskcfg_no_t_record_xywh = {560,180,150,40},	
	s_diskcfg_no_cap_etip_xywh = {130,240,750,40},
}
w1_page_diskcfg.s_1440 = 
{
	
	s_diskcfg_disk1img_xywh = {80,60,225,120},
	s_diskcfg_disk2img_xywh = {315,60,225,120},
	s_diskcfg_disk3img_xywh = {550,60,225,120},
	s_diskcfg_disk4img_xywh = {785,60,225,120},
	
	s_diskcfg_pre_disk_xywh = {80,60,40,120},
	s_diskcfg_disk5img_xywh = {120,60,210,120},
	s_diskcfg_disk6img_xywh = {340,60,210,120},
	s_diskcfg_disk7img_xywh = {560,60,210,120},
	s_diskcfg_disk8img_xywh = {780,60,210,120},
	s_diskcfg_next_disk_xywh = {990,60,40,120},

	s_diskcfg_format_xywh = {770,230,180,40},
	s_diskcfg_cap_status_xywh = {130,310,400,40},
	s_diskcfg_t_status_xywh = {560,310,300,40},
	s_diskcfg_cap_sn_xywh = {130,360,400,40},
	s_diskcfg_t_sn_xywh = {560,360,300,40},
	s_diskcfg_cap_space_xywh = {130,410,400,40},
	s_diskcfg_t_space_xywh = {560,410,300,40},
	s_diskcfg_cap_group_xywh = {130,460,400,40},
	s_diskcfg_t_group_xywh = {560,460,300,40},
	s_diskcfg_hline1_xywh = {80,285,850,1},
	s_diskcfg_diskname_xywh = {80,240,380,40},
	s_diskcfg_hline2_xywh = {80,520,850,1},
	s_diskcfg_cap_over_w_xywh = {130,550,400,40},
	s_diskcfg_t_over_w_xywh = {505,550,150,40},
	s_diskcfg_cap_record_xywh = {130,600,400,40},
	s_diskcfg_t_record_xywh = {560,600,150,40}, 
	s_diskcfg_cap_etip_xywh = {130,650,800,40},
	s_diskcfg_tipinfo_xywh = {80,690,700,50},
	s_diskcfg_no_diskname_xywh = {400,30,200,45},
	s_diskcfg_no_hline2_xywh = {80,100,850,1},
	s_diskcfg_no_cap_over_w_xywh = {130,120,400,40},
	s_diskcfg_no_t_over_w_xywh = {505,120,150,40},
	s_diskcfg_no_cap_record_xywh = {130,170,400,40},
	s_diskcfg_no_t_record_xywh = {560,170,150,40},
	s_diskcfg_no_cap_etip_xywh = {130,220,800,40},
}

w1_page_diskcfg.s_1080p = 
{
	s_diskcfg_disk1img_xywh = {100,60,300,120},
	s_diskcfg_disk2img_xywh = {430,60,300,120},
	s_diskcfg_disk3img_xywh = {760,60,300,120},
	s_diskcfg_disk4img_xywh = {1090,60,300,120},
	
	s_diskcfg_pre_disk_xywh = {80,60,45,120},
	s_diskcfg_disk5img_xywh = {145,60,300,120},
	s_diskcfg_disk6img_xywh = {465,60,300,120},
	s_diskcfg_disk7img_xywh = {785,60,300,120},
	s_diskcfg_disk8img_xywh = {1105,60,300,120},
	s_diskcfg_next_disk_xywh = {1405,60,45,120},
	
	s_diskcfg_format_xywh = {970,250,180,40},
	s_diskcfg_cap_status_xywh = {160,330,400,40},
	s_diskcfg_t_status_xywh = {560,330,300,40},
	s_diskcfg_cap_sn_xywh = {160,390,400,40},
	s_diskcfg_t_sn_xywh = {560,390,300,40},
	s_diskcfg_cap_space_xywh = {160,450,400,40},
	s_diskcfg_t_space_xywh = {560,450,300,40},
	s_diskcfg_cap_group_xywh = {160,510,400,40},
	s_diskcfg_t_group_xywh = {560,510,300,40},
	s_diskcfg_hline1_xywh = {100,305,1050,1},
	s_diskcfg_diskname_xywh = {100,260,380,40},
	s_diskcfg_hline2_xywh = {100,580,1050,1},
	s_diskcfg_cap_over_w_xywh = {160,610,400,40},
	s_diskcfg_t_over_w_xywh = {505,610,150,40}, 
	s_diskcfg_cap_record_xywh = {160,670,400,40},
	s_diskcfg_t_record_xywh = {560,670,150,40}, 
	s_diskcfg_cap_etip_xywh = {160,730,1000,40},
	s_diskcfg_tipinfo_xywh = {100,830,700,50},
	s_diskcfg_no_diskname_xywh = {400,30,200,45},
	s_diskcfg_no_hline2_xywh = {100,80,1050,1},
	s_diskcfg_no_cap_over_w_xywh = {160,100,400,40},
	s_diskcfg_no_t_over_w_xywh = {505,100,150,40},
	s_diskcfg_no_cap_record_xywh = {160,160,400,40},
	s_diskcfg_no_t_record_xywh = {560,160,150,40},
	s_diskcfg_no_cap_etip_xywh = {160,220,1000,40},
}

w1_page_diskcfg.s_2k = 
{
	s_diskcfg_disk1img_xywh = {133,80,400,160},
	s_diskcfg_disk2img_xywh = {573,80,400,160},
	s_diskcfg_disk3img_xywh = {1013,80,400,160},
	s_diskcfg_disk4img_xywh = {1453,80,400,160},
	
	s_diskcfg_pre_disk_xywh={107,80,60,160},
	s_diskcfg_disk5img_xywh={193,80,400,160},
	s_diskcfg_disk6img_xywh={620,80,400,160},
	s_diskcfg_disk7img_xywh={1044,80,400,160},
	s_diskcfg_disk8img_xywh={1473,80,400,160},
	s_diskcfg_next_disk_xywh={1873,80,60,160},
	
	s_diskcfg_format_xywh = {1293,333,240,53},
	s_diskcfg_cap_status_xywh = {213,440,533,53},
	s_diskcfg_t_status_xywh = {746,440,400,53},
	s_diskcfg_cap_sn_xywh = {213,520,533,53},
	s_diskcfg_t_sn_xywh = {746,520,400,53},
	s_diskcfg_cap_space_xywh = {213,600,533,53},
	s_diskcfg_t_space_xywh = {746,600,400,53},
	s_diskcfg_cap_group_xywh = {213,690,400,40},
	s_diskcfg_t_group_xywh = {746,690,300,40},
	s_diskcfg_hline1_xywh = {133,407,1400,1},
	s_diskcfg_diskname_xywh = {133,347,507,53},
	s_diskcfg_hline2_xywh = {133,783,1400,1},
	s_diskcfg_cap_over_w_xywh = {213,823,533,53},
	s_diskcfg_t_over_w_xywh = {673,823,200,53},
	s_diskcfg_cap_record_xywh = {213,890,533,53},
	s_diskcfg_t_record_xywh = {746,890,200,53},
	s_diskcfg_cap_etip_xywh = {213,957,1200,53},
	s_diskcfg_tipinfo_xywh = {133,1100,933,67},
	s_diskcfg_no_diskname_xywh = {533,40,267,60},
	s_diskcfg_no_hline2_xywh = {133,107,1400,1},
	s_diskcfg_no_cap_over_w_xywh = {213,133,533,53},
	s_diskcfg_no_t_over_w_xywh = {673,133,200,53},
	s_diskcfg_no_cap_record_xywh = {213,200,533,53},
	s_diskcfg_no_t_record_xywh = {746,200,200,53},
	s_diskcfg_no_cap_etip_xywh = {213,267,1200,53},
}

w1_page_diskcfg.s_4k = 
{
	s_diskcfg_disk1img_xywh = {200,120,600,240},
	s_diskcfg_disk2img_xywh = {860,120,600,240},
	s_diskcfg_disk3img_xywh = {1520,120,600,240},
	s_diskcfg_disk4img_xywh = {2180,120,600,240},
	
	s_diskcfg_pre_disk_xywh={160,120,90,240},
	s_diskcfg_disk5img_xywh={290,120,600,240},
	s_diskcfg_disk6img_xywh={930,120,600,240},
	s_diskcfg_disk7img_xywh={1570,120,600,240},
	s_diskcfg_disk8img_xywh={2210,120,600,240},
	s_diskcfg_next_disk_xywh={2810,120,90,240},
	
	s_diskcfg_format_xywh = {1940,500,360,80},
	s_diskcfg_cap_status_xywh = {320,660,800,80},
	s_diskcfg_t_status_xywh = {1120,660,600,80},
	s_diskcfg_cap_sn_xywh = {320,780,800,80},
	s_diskcfg_t_sn_xywh = {1120,780,600,80},
	s_diskcfg_cap_space_xywh = {320,900,800,80},
	s_diskcfg_t_space_xywh = {1120,900,600,80},
	s_diskcfg_cap_group_xywh = {320,1020,800,80},
	s_diskcfg_t_group_xywh = {1120,1020,600,80},
	s_diskcfg_hline1_xywh = {200,610,2100,2},
	s_diskcfg_diskname_xywh = {200,520,760,80},
	s_diskcfg_hline2_xywh = {200,1160,2100,2},
	s_diskcfg_cap_over_w_xywh = {320,1220,800,80},
	s_diskcfg_t_over_w_xywh = {1010,1220,300,80},
	s_diskcfg_cap_record_xywh = {320,1340,800,80},
	s_diskcfg_t_record_xywh = {1120,1340,300,80},
	s_diskcfg_cap_etip_xywh = {320,1460,1900,80},
	s_diskcfg_tipinfo_xywh = {200,1620,1400,100},
	s_diskcfg_no_diskname_xywh = {800,60,400,90},
	s_diskcfg_no_hline2_xywh = {200,160,2100,2},
	s_diskcfg_no_cap_over_w_xywh = {320,200,800,80},
	s_diskcfg_no_t_over_w_xywh = {1010,200,300,80},
	s_diskcfg_no_cap_record_xywh = {320,320,800,80},
	s_diskcfg_no_t_record_xywh = {1120,320,300,80},
	s_diskcfg_no_cap_etip_xywh = {320,440,1900,80},
}

w1_page_diskcfg.clear_data = function()
	w1_page_diskcfg.data = nil;
	w1_page_diskcfg.raid = nil;
	w1_page_diskcfg.format_status = nil;
end	

local refresh_data = function(top, redraw)
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,false);
	end
	local cwnd = w1_page_diskcfg.wnd;
	local cur_disknum;
	
	--޴ֹˢ´Ϣ
	if (w1_page_diskcfg.data.disk_num == 0) then
		return 	
	end	
	
	local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
						cwnd.disk3img.id, cwnd.disk4img.id};
	for i=1, cap_value do
		if( b_wnd_ex.get_check(top, disk_idtab[i]) )then
			cur_disknum = i + w1_page_diskcfg.cur_page * cap_value;
			break;
		end
	end
	
	local cur_data = w1_page_diskcfg.data['disk'..cur_disknum];
	b_wnd_ex.set_sel(top,cwnd.t_group.id,cur_data.group,false);
	if(cur_data.status == 1) then
		settext(cwnd.t_status.id, STR('LA_NORMAL'));
	elseif(cur_data.status == 2) then
		settext(cwnd.t_status.id, STR('LA_NEED_FORMAT'));
	elseif(cur_data.status == 4) then
		settext(cwnd.t_status.id, STR('LA_DISK_ERROR'));
		b_wnd_ex.set_disable(top, cwnd.format.id, true, false);	
	elseif(cur_data.status == 8) then
		settext(cwnd.t_status.id, STR('LA_FULL_DISK'));
	elseif(cur_data.status == 65) then
		settext(cwnd.t_status.id, STR('LA_NORMAL'));
	elseif(cur_data.status == 66) then
		settext(cwnd.t_status.id, STR('LA_WARNING'));
	elseif(cur_data.status == 67) then
		settext(cwnd.t_status.id, STR('LA_DESTROYED'));
		b_wnd_ex.set_disable(top, cwnd.format.id, true, false);	
	elseif(cur_data.status == 68) then
		settext(cwnd.t_status.id, STR('LA_RECOVER'));
	elseif(cur_data.status == 69) then
		settext(cwnd.t_status.id, STR('LA_LOAD_FAIL'));
		b_wnd_ex.set_disable(top, cwnd.format.id, true, false);
	else
		settext(cwnd.t_status.id, STR('LA_DISK_ERROR'));
		b_wnd_ex.set_disable(top, cwnd.format.id, true, false);	
	end
	if(cur_data.status == 4 or cur_data.status == 67 or cur_data.status == 69) then
		b_wnd_ex.set_disable(top, cwnd.format.id, true, false);
	else
		b_wnd_ex.set_disable(top, cwnd.format.id, false, false);
	end
	assert(cur_data.sn ~= nil)
	settext(cwnd.t_sn.id, cur_data.sn);
	
	local cap;
	if(cur_data.used < 1000) then
		cap = cur_data.used..'MB';
	else
		cap = cur_data.used / 1000;
		cap = math.floor(cap / 1)..'GB';
	end
	settext(cwnd.t_space.id, cap);
	if redraw == true then
		b_dlg.dlg_set_redraw(top);
	end
end

local refresh_disknum = function(top, disknum, redraw)
	local sethide = function(id, hide)
		b_wnd_ex.set_hide(top, id, hide, false);
	end
	local cwnd = w1_page_diskcfg.wnd;
	if(disknum == 0) then	--ûд
		local sid = cwnd.disk1img.id;
		local eid = cwnd.hline1.id;
		for i=sid, eid do
			sethide(i, true);
		end
		sethide(cwnd.diskname.id, false);
		b_wnd_ex.set_text(top, cwnd.diskname.id, STR('LA_NO_DISK'), false);
		local pos = SIZE('s_diskcfg_no_diskname_xywh');
		b_wnd_ex.move_ex(top, cwnd.diskname.id, pos, false);
		pos = SIZE('s_diskcfg_no_hline2_xywh');
		b_wnd_ex.move_ex(top, cwnd.hline2.id, pos, false);	
		pos = SIZE('s_diskcfg_no_cap_over_w_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_over_w.id, pos, false);	
		pos = SIZE('s_diskcfg_no_t_over_w_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_over_w.id, pos, false);
		pos = SIZE('s_diskcfg_no_cap_record_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_record.id, pos, false);	
		pos = SIZE('s_diskcfg_no_t_record_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_record.id, pos, false);
		pos = SIZE('s_diskcfg_no_cap_etip_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_expired_tip.id, pos, false);	
	else	--ڴ
		local sid = cwnd.disk1img.id;
		local eid = cwnd.hline1.id;
		for i=sid, eid do
			sethide(i, false);
		end
		sethide(cwnd.diskname.id, true);
		local privilege = G.get_allprivilege()
		if false == privilege.system_maintenance then
			b_wnd_ex.set_hide(top,cwnd.format.id,true,false);
		end
		local pos = SIZE('s_diskcfg_hline2_xywh');
		b_wnd_ex.move_ex(top, cwnd.hline2.id, pos, false);
		pos = SIZE('s_diskcfg_cap_over_w_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_over_w.id, pos, false);
		pos = SIZE('s_diskcfg_t_over_w_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_over_w.id, pos, false);
		pos = SIZE('s_diskcfg_cap_record_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_record.id, pos, false);
		pos = SIZE('s_diskcfg_t_record_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_record.id, pos, false);	
		pos = SIZE('s_diskcfg_cap_etip_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_expired_tip.id, pos, false);
		
		local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
							cwnd.disk3img.id, cwnd.disk4img.id};
		for i=1,cap_value do
			if (i <= disknum) then
				sethide(disk_idtab[i], false);
			else
				sethide(disk_idtab[i], true);
			end
		end
	end
	if redraw == true then
		b_dlg.dlg_set_redraw(top);
	end
end

local refresh_hide =function (top)
	local cwnd = w1_page_diskcfg.wnd;
	local data = w1_page_diskcfg.data;
	local sethide = function(id, hide)
		b_wnd_ex.set_hide(top, id, hide, false);
	end
	
	local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
						cwnd.disk3img.id, cwnd.disk4img.id};
					
	local disk_num = data.disk_num;
	for i = 1, cap_value do
		local idx = i + w1_page_diskcfg.cur_page * cap_value;
		if (idx <= disk_num) then	
			sethide(disk_idtab[i], false);
		else
			sethide(disk_idtab[i], true);
		end	
		
		if (i == 1) then
			b_wnd_ex.set_check(top, disk_idtab[i], true, false);
		else
			b_wnd_ex.set_check(top, disk_idtab[i], false, false)			
		end
	end	

	if(data.disk_num > cap_value)then
		local pos = SIZE('s_diskcfg_disk5img_xywh');
		b_wnd_ex.move_ex(top, cwnd.disk1img.id, pos, false);
		pos = SIZE('s_diskcfg_disk6img_xywh');
		b_wnd_ex.move_ex(top, cwnd.disk2img.id, pos, false);
		pos = SIZE('s_diskcfg_disk7img_xywh');
		b_wnd_ex.move_ex(top, cwnd.disk3img.id, pos, false);
		pos = SIZE('s_diskcfg_disk8img_xywh');
		b_wnd_ex.move_ex(top, cwnd.disk4img.id, pos, false);	
		b_wnd_ex.set_hide(top, cwnd.prev_disk.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.next_disk.id, false, false);
	else
		local pos = SIZE('s_diskcfg_disk1img_xywh');
		b_wnd_ex.move_ex(top, cwnd.disk1img.id, pos, false);
		pos = SIZE('s_diskcfg_disk2img_xywh');
		b_wnd_ex.move_ex(top, cwnd.disk2img.id, pos, false);
		pos = SIZE('s_diskcfg_disk3img_xywh');
		b_wnd_ex.move_ex(top, cwnd.disk3img.id, pos, false);
		pos = SIZE('s_diskcfg_disk4img_xywh');
		b_wnd_ex.move_ex(top, cwnd.disk4img.id, pos, false);
		
		b_wnd_ex.set_hide(top, cwnd.prev_disk.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.next_disk.id, true, false);
	end
end

local set_disk_data = function(top, disk_id, diskdata, redraw)
	local cwnd = w1_page_diskcfg.wnd;
	--ֵ
	local diskstr;
	local str = STR('LA_DISK');
	local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
						cwnd.disk3img.id, cwnd.disk4img.id};
	for i=1, cap_value do
		if( disk_id == disk_idtab[i] )then
			local is_raid = string.find(diskdata.name,"md")
			if(nil ~= diskdata.name and "" ~= diskdata.name and nil ~= is_raid)then
				diskstr = "RAID-"..diskdata.name;
			else
				diskstr = diskdata.name;
			end
			break;
		end
	end
	
	local size = STR('LA_CAPACITY')..' '.. '0GB'; 
	local value = 0;
	if(diskdata.status == 1 or diskdata.status == 8 or diskdata.status == 65 or diskdata.status == 66 or diskdata.status == 68) then	--
		--ȡӲ
		size = diskdata.size/1000;
		if(size < 1000)then
			size =STR('LA_CAPACITY')..' '.. math.floor(size / 1)..'GB';
		else
			size = size/1000
			size =STR('LA_CAPACITY')..' '.. math.floor(size / 1)..'TB';
		end
		--ʹٷֱ		
		value = diskdata.used * 100 / diskdata.size;
		value = math.floor(value / 1);
		if(value == 0 and diskdata.used >= 1000) then
			value = 1;
		end	
		b_wnd_ex.set_status(top, disk_id, 0, redraw);
	elseif(diskdata.status == 2) then	--Ҫʽ
		value = 0;
		size = STR('LA_NEED_FORMAT');
		b_wnd_ex.set_status(top, disk_id, 2, redraw);
	elseif(diskdata.status == 4 or diskdata.status == 67 or diskdata.status == 69) then	--̴
		value = 0;
		size = STR('LA_DISK_ERROR');
		b_wnd_ex.set_status(top, disk_id, 2, redraw);
	end
	--ô
	local texts = {diskstr, size};
	b_wnd_ex.set_texts(top, disk_id, texts, redraw);
	--ôʹðٷֱ
	b_wnd_ex.set_value(top, disk_id, value, redraw);
end

--ˢUI
local cfgdatatoui = function(top, cfgdata, redraw)
	assert(type(cfgdata) == 'table');
	w1_page_diskcfg.data = cfgdata.disk;
	
	w1_page_diskcfg.raid = cfgdata.raid;
	local cwnd = w1_page_diskcfg.wnd;
	local data = cfgdata.disk;
	if(redraw == nil or redraw == false) then
		redraw = false
		if (w1_page_diskcfg.cur_page == 0) then
			b_wnd_ex.set_disable(top, cwnd.prev_disk.id, true, false);
			b_wnd_ex.set_disable(top, cwnd.next_disk.id, false, false);
		else
			b_wnd_ex.set_disable(top, cwnd.prev_disk.id, false, false);
			b_wnd_ex.set_disable(top, cwnd.next_disk.id, true, false);
		end
	else
		redraw = true;
	end

	if (data.disk_num % cap_value == 0) then
		w1_page_diskcfg.max_page = math.floor(data.disk_num / cap_value);
	else
		w1_page_diskcfg.max_page = math.floor(data.disk_num / cap_value) + 1;
	end		
	if (w1_page_diskcfg.cur_page >= w1_page_diskcfg.max_page) then
		w1_page_diskcfg.cur_page = 0;
	end		
	
	refresh_disknum(top, data.disk_num, false);
	
	local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
						cwnd.disk3img.id, cwnd.disk4img.id};
	for i=1, cap_value do
		local idx = i + w1_page_diskcfg.cur_page * cap_value;
		if (idx <= data.disk_num) then
			set_disk_data(top, disk_idtab[i], data['disk'..idx], redraw);
		end
	end		
		
	refresh_hide(top);
	refresh_data(top, redraw);
	
	local exp_time = cfgdata.record_exp.record_exp;
	local overwrite = cfgdata.record_exp.overwrite;
	
	if (overwrite == 0) then
		b_wnd_ex.set_check(top, cwnd.t_over_w.id,false,false);
	else
		b_wnd_ex.set_check(top, cwnd.t_over_w.id,true,false);
	end
	
	b_wnd_ex.set_value(top, cwnd.t_record.id, exp_time/24, false);
	
	local privilege = G.get_allprivilege()
	if false == privilege.system_maintenance then
		b_wnd_ex.set_hide(top,cwnd.format.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.cap_over_w.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_over_w.id,true,false);		
		b_wnd_ex.set_hide(top,cwnd.cap_record.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.cap_expired_tip.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_record.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.apply.id,true,false);		
	end
	return 0;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_diskcfg.wnd;
	local data = cfgdata.record_exp;
	local check = b_wnd_ex.get_check(top, cwnd.t_over_w.id);
	if check == true then
		cfgdata.record_exp.overwrite = 1;
	else
		cfgdata.record_exp.overwrite = 0;
	end
	
	local value = b_wnd_ex.get_value(top,cwnd.t_record.id);
	cfgdata.record_exp.record_exp = value * 24;
	
	return 0;
end

--̹ʱ
--Ϸtrul,nil
--Ϸfalse,
local check_rcd = function(top,id)
	local rcdexpt = b_wnd_ex.get_text(top,id)
	assert(type(rcdexpt) == 'string')

	return true ,nil
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local cwnd = w1_page_diskcfg.wnd;

	local legalflag = true
	local nlegalid = {}
    local legal, num = check_rcd(top, cwnd.t_record.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_record.id)	
		if(num == exp_unlegal) then
			w1_wnd_util.setparamerr_str(STR('LA_EXPIRE_TIP'));
			return legalflag, nlegalid;
		end
	end
	return true, nil;	
end

w1_page_diskcfg.timer_start = function()
	w1_page_diskcfg.timestart = true
end

w1_page_diskcfg.timer_stop = function(top)
	w1_page_diskcfg.timestart = false
	w1_wnd_util.tipclear(top, w1_page_diskcfg.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_diskcfg.timerenevt = function(top)
	if(w1_page_diskcfg.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_diskcfg.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_diskcfg.init = function(top)
	w1_wnd_util.cfgtab = {'disk','record_exp'};
	w1_page_diskcfg.cur_page = 0;
	w1_page_diskcfg.max_page = 0;
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0;
end

local on_pre_disk = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(w1_page_diskcfg.cur_page >= 1)then
			w1_page_diskcfg.cur_page = w1_page_diskcfg.cur_page - 1;
			local cwnd = w1_page_diskcfg.wnd;	
			local data = w1_page_diskcfg.data;
			local disk_num = data.disk_num;
			local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
								cwnd.disk3img.id, cwnd.disk4img.id};				
			for i=1, cap_value do
				local idx = i + w1_page_diskcfg.cur_page * cap_value;		
				if (idx <= data.disk_num) then
					set_disk_data(top, disk_idtab[i], data['disk'..idx], false);
				end
			end		
			
			local sethide = function(id, hide)
				b_wnd_ex.set_hide(top, id, hide, false);
			end
			
			local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
					cwnd.disk3img.id, cwnd.disk4img.id};
			
			for i = 1, cap_value do
				local idx = i + w1_page_diskcfg.cur_page * cap_value;
				if (idx <= data.disk_num) then
					sethide(disk_idtab[i], false);
				else
					sethide(disk_idtab[i], true);	
				end	
			end				
	
			for i=1,cap_value do
				if (1 == i) then
					b_wnd_ex.set_check(top, disk_idtab[i], true, false)	
				else
					b_wnd_ex.set_check(top, disk_idtab[i], false, false)	
				end
			end
			refresh_data(top, false);
			
			b_wnd_ex.set_disable(top, cwnd.next_disk.id, false, false);	
			if (w1_page_diskcfg.cur_page == 0) then	
				b_wnd_ex.set_disable(top, cwnd.prev_disk.id, true, false);
			else
				b_wnd_ex.set_disable(top, cwnd.prev_disk.id, false, false);
			end
			b_wnd.clear_wnd_focus(top);
			b_dlg.dlg_set_redraw(top);
		end
	end
	return 0
end

local on_next_disk = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(w1_page_diskcfg.cur_page + 1 <= w1_page_diskcfg.max_page)then
			w1_page_diskcfg.cur_page = w1_page_diskcfg.cur_page +1;
			local cwnd = w1_page_diskcfg.wnd;
			local data = w1_page_diskcfg.data;
			local disk_num = data.disk_num;
			local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
								cwnd.disk3img.id, cwnd.disk4img.id};			
			for i=1, cap_value do
				local idx = i + w1_page_diskcfg.cur_page * cap_value;		
				if (idx <= data.disk_num) then
					set_disk_data(top, disk_idtab[i], data['disk'..idx], false);
				end
			end		
			
			local sethide = function(id, hide)
				b_wnd_ex.set_hide(top, id, hide, false);
			end

			local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
							cwnd.disk3img.id, cwnd.disk4img.id};
			for i = 1, cap_value do
				local idx = i + w1_page_diskcfg.cur_page * cap_value;
				if (idx <= data.disk_num) then
					sethide(disk_idtab[i], false);
				else
					sethide(disk_idtab[i], true);	
				end	
			end					
			
			for i=1,cap_value do
				if (1 == i) then
					b_wnd_ex.set_check(top, disk_idtab[i], true, false)	
				else
					b_wnd_ex.set_check(top, disk_idtab[i], false, false)	
				end
			end
			refresh_data(top, true);
			
			b_wnd_ex.set_disable(top, cwnd.prev_disk.id, false, false);
			if (w1_page_diskcfg.cur_page >= w1_page_diskcfg.max_page - 1) then
				b_wnd_ex.set_disable(top, cwnd.next_disk.id, true, false);
			else
				b_wnd_ex.set_disable(top, cwnd.next_disk.id, false, false);			
			end
			b_wnd.clear_wnd_focus(top);
			b_dlg.dlg_set_redraw(top);
		end
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()
	end
	return 0
end

w1_page_diskcfg.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	
	return ret;
end

local on_disk = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local setcheck = function(id, check)
			b_wnd_ex.set_check(top, id, check, false);
		end
		local cwnd = w1_page_diskcfg.wnd;
		local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
							cwnd.disk3img.id, cwnd.disk4img.id};
		for i=1, cap_value do
			if(win_id ~= disk_idtab[i]) then
				setcheck(disk_idtab[i], false);			
			end
		end
		refresh_data(top, true);
	end
	return 0;
end

local okfunc_diskformat = function(param)
	local cwnd = w1_page_diskcfg.wnd;
	local data = w1_page_diskcfg.data;
	
	b_app_api.channge_cursor(b_ui.CURSOR.JY_CURSOR_WAIT);
	local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
						cwnd.disk3img.id, cwnd.disk4img.id};
	for i=1, cap_value do
		if(b_wnd_ex.get_check(param[1], disk_idtab[i]) ) then
			local idx = i + w1_page_diskcfg.cur_page * cap_value;
			w1_page_diskcfg.format_status = b_app_api.disk_format(data['disk'..idx].disk_id).status;		
			break;
		end
	end
	b_app_api.channge_cursor(b_ui.CURSOR.JY_CURSOR_POINT);
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	
	return 0;
end

local on_over_write = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local cwnd = w1_page_diskcfg.wnd;
		local check = b_wnd_ex.get_check(top,cwnd.t_over_w.id);
		
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	
	return 0;
end

local on_change_group = function(top, win_id, vmsg, x, y)
	if (b_ui_msg.msg_user_update_parent == vmsg) then
		local cwnd = w1_page_diskcfg.wnd;
		local group=b_wnd_ex.get_sel(top,cwnd.t_group.id)
		local cur_disknum;
		local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
						cwnd.disk3img.id, cwnd.disk4img.id};
		for i=1, cap_value do
			if( b_wnd_ex.get_check(top, disk_idtab[i]) )then
				cur_disknum = i + w1_page_diskcfg.cur_page * cap_value;
				break;
			end
		end
		local cur_data = w1_page_diskcfg.data['disk'..cur_disknum];
		cur_data.group=group;
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_format = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_diskcfg.wnd;
		local data = w1_page_diskcfg.data;
		w1_page_diskcfg.format_status = nil;
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_FORMAT'), true, true,false);
		w1_msgbox.set_attach_dlgattr(STR('LA_FORMATTING_T'));
		w1_msgbox.set_func(okfunc_diskformat, {top}, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		if(w1_page_diskcfg.format_status ~= nil) then	
			if(w1_page_diskcfg.format_status == 0) then	--ʽɹ
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_FORMAT_OK'), true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			else							--ʽʧ
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_FORMAT_FAIL'), true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			end
			local group=b_wnd_ex.get_sel(top,cwnd.t_group.id)
			local cur_disknum;
			local disk_idtab = {cwnd.disk1img.id, cwnd.disk2img.id, 
							cwnd.disk3img.id, cwnd.disk4img.id};
			for i=1, #disk_idtab do
				if( b_wnd_ex.get_check(top, disk_idtab[i]) )then
					cur_disknum = i + w1_page_diskcfg.cur_page * cap_value;
					break;
				end
			end
			--¶ȡˢҳ
			b_app_cfg.init({'disk','record_exp'});		
			cfgdatatoui(top, b_app_cfg.user_cfg, false);
			b_wnd_ex.set_sel(top,cwnd.t_group.id,group,false)
			local cur_data = w1_page_diskcfg.data['disk'..cur_disknum];
			cur_data.group=group;
			for i=1, cap_value do
				if(i ==  cur_disknum - w1_page_diskcfg.cur_page * cap_value) then
					b_wnd_ex.set_check(top,disk_idtab[i],true,false)
				else
					b_wnd_ex.set_check(top,disk_idtab[i],false,false)
				end
			end
			b_dlg.dlg_set_redraw(top);
		end
	end
	return 0;
end

w1_page_diskcfg.on_pre_show = function(top)
	local privilege = G.get_allprivilege()
	local cwnd = w1_page_diskcfg.wnd
	if false == privilege.system_maintenance then
		b_wnd_ex.set_hide(top,cwnd.format.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.cap_over_w.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_over_w.id,true,false);		
		b_wnd_ex.set_hide(top,cwnd.cap_record.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_record.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.cap_expired_tip.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.apply.id,true,false);
		b_wnd_ex.set_disable(top,cwnd.t_group.id,true,false);
	else
		b_wnd_ex.set_hide(top,cwnd.format.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.cap_over_w.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_over_w.id,false,false);		
		b_wnd_ex.set_hide(top,cwnd.cap_record.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_record.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.cap_expired_tip.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.apply.id,false,false);
		b_wnd_ex.set_disable(top,cwnd.t_group.id,false,false);
	end
end

w1_page_diskcfg.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'prev_disk','next_disk','disk1img','disk2img','disk3img','disk4img','diskname', 'format', 'hline1',
			'cap_status', 't_status', 'cap_sn', 't_sn','cap_group','t_group',
			'cap_space', 't_space', 'hline2', 'cap_over_w', 't_over_w','cap_record', 't_record','cap_expired_tip',
			'tipinfo', 'default', 'apply'},

	prev_disk ={t='tt_button',id=id+1,xywh='s_diskcfg_pre_disk_xywh', cmd=on_pre_disk,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			color_d= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_d'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_pre','it_pre_f', 'it_pre'}},

	next_disk = {t='tt_button',id=id+2,xywh='s_diskcfg_next_disk_xywh', cmd=on_next_disk,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			color_d= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_d'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_next','it_next_f', 'it_next'}},
				
	disk1img 	= {t='disk',id=id+3,xywh='s_diskcfg_disk1img_xywh',font = 'f_disk', 
				check = true,
				cmd = on_disk,
				},			
	disk2img 	= {t='disk',id=id+4,xywh='s_diskcfg_disk2img_xywh',font = 'f_disk', 
				check = false,
				cmd = on_disk,
				},
	disk3img 	= {t='disk',id=id+5,xywh='s_diskcfg_disk3img_xywh',font = 'f_disk', 
				check = false,
				cmd = on_disk,
				},			
	disk4img 	= {t='disk',id=id+6,xywh='s_diskcfg_disk4img_xywh',font = 'f_disk', 
				check = false,
				cmd = on_disk,
				},	
	format 	 	= {t='button',id=id+7,	xywh='s_diskcfg_format_xywh', 	text='LA_FORMAT',
				cmd=on_format},
	
	cap_status	= {t='static',id=id+8,	xywh='s_diskcfg_cap_status_xywh',text='LA_DISK_STATUS'},
	t_status	= {t='static',id=id+9,	xywh='s_diskcfg_t_status_xywh',text='LA_NORMAL'},
	
	cap_sn		= {t='static',id=id+10,	xywh='s_diskcfg_cap_sn_xywh',text='LA_DISK_SN'},
	t_sn		= {t='static',id=id+11,	xywh='s_diskcfg_t_sn_xywh',},
	
	cap_space	= {t='static',id=id+12,	xywh='s_diskcfg_cap_space_xywh',text='LA_USED_SPACE'},
	t_space		= {t='static',id=id+13,	xywh='s_diskcfg_t_space_xywh',},
	
	cap_group   = {t='static',id=id+14, xywh='s_diskcfg_cap_group_xywh',text='LA_DISK_GROUP'},
	t_group		= {t='combox',id=id+15,	xywh='s_diskcfg_t_group_xywh',items={1,2,3,4},trans=false,cmd= on_change_group},
	
	hline1		= {t='hline', id=id+16,	xywh='s_diskcfg_hline1_xywh'},
	diskname 	= {t='static',id=id+17,	xywh='s_diskcfg_diskname_xywh',font = 'f_grade3'},
	hline2		= {t='hline', id=id+28,	xywh='s_diskcfg_hline2_xywh'},

	cap_over_w	= {t='static',id=id+29,	xywh='s_diskcfg_cap_over_w_xywh',text='LA_RECORD_OVERWRITE'},
	t_over_w	= {t='tt_check',id=id+20,  xywh='s_diskcfg_t_over_w_xywh', check = true,
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd=on_over_write},
					
	cap_record	= {t='static',id=id+21,	xywh='s_diskcfg_cap_record_xywh',text='LA_RECORD_EXPIRATION'},
	t_record	= {t='edit_num',id=id+22,xywh='s_diskcfg_t_record_xywh',range={0,90},cmd = on_update_param},
	
	cap_expired_tip = {t='static',id=id+23,xywh='s_diskcfg_cap_etip_xywh',text='LA_EXPIRED_LOST',
					color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},
					
	
	tipinfo		= {t='static',id=id+24,	xywh='s_diskcfg_tipinfo_xywh',	
					text='',trans = false},
		
	apply 	= {t='button',id=id+25,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},	
}

return w1_page_diskcfg

