--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_alarmout.flash_alarm_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_row_flashrow 		= require("wnd.w1_cfg.w1_row_flashrow")
local w1_page_flashtimeplan 	= require("wnd.w1_cfg.w1_page_flashtimeplan")
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")

local w1_page_flash_light_alarm = 
{
	old_chid,
	data,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_flash_light_alarm.s_768 =
{
	s_flash_light_tipinfo_xywh = {58,540,213,35},
};

w1_page_flash_light_alarm.s_1280 = 
{
	s_flash_light_tipinfo_xywh = {110,760,400,50},
}
w1_page_flash_light_alarm.s_1440 = 
{
	s_flash_light_tipinfo_xywh = {110,680,400,50},
}

w1_page_flash_light_alarm.s_1080p = 
{
	s_flash_light_tipinfo_xywh = {110,810,400,50},
}

w1_page_flash_light_alarm.s_2k = 
{
	s_flash_light_tipinfo_xywh = {147,1013,523,67},

}

w1_page_flash_light_alarm.s_4k = 
{
	s_flash_light_tipinfo_xywh = {220,1620,700,100},
}

local channel_num;--豸ͨĿ

w1_page_flash_light_alarm.clear_data = function()
	w1_page_flash_light_alarm.data = nil;
	w1_page_flash_light_alarm.copy_ch = nil;
end	


local refresh_chdata = function(top, chid, redraw)
	local c_wnd = w1_page_flash_light_alarm.wnd
	local channeldata = w1_page_flash_light_alarm.data.flash_light['channel'..chid]
	w1_page_flashtimeplan.settimeplan(top, channeldata, redraw);
	b_wnd_ex.set_value(top,c_wnd.t_alarm_time.id, channeldata.led_time, redraw);
end

w1_page_flash_light_alarm.on_data_change = function(top)
	return 0;
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)	
	assert(type(cfgdata) == 'table')
	w1_page_flash_light_alarm.data = cfgdata;
	
	local c_wnd = w1_page_flash_light_alarm.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	local old_chn = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
	local sel = 0;
	for i=1, channel_num do
		if(cfgdata['flash_light']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			if old_chn == i then
				sel = idx-1
			end
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id, false, false)
		b_wnd_ex.set_hide(top, c_wnd.cap_alarm_time.id, false, false)
		b_wnd_ex.set_hide(top, c_wnd.t_alarm_time.id, false, false)
		b_wnd_ex.set_hide(top, w1_id.cfg_alarmout.flashrow_alarm_id, false, false)
		w1_page_flashtimeplan.sethide(top, false, false)
		
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, sel, false);--Ĭһ
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		refresh_chdata(top, chid, false);
	else--ͨ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,true, false)
		b_wnd_ex.set_hide(top, c_wnd.cap_alarm_time.id, true, false)
		b_wnd_ex.set_hide(top, c_wnd.t_alarm_time.id, true, false)
		b_wnd_ex.set_hide(top,  w1_id.cfg_alarmout.flashrow_alarm_id, 	true, false)
		w1_page_flashtimeplan.sethide(top, true, false)
	end
	
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_flash_light_alarm.timer_start = function()
	w1_page_flash_light_alarm.timestart = true
end

w1_page_flash_light_alarm.timer_stop = function(top)
	w1_page_flash_light_alarm.timestart = false
	w1_wnd_util.tipclear(top, w1_page_flash_light_alarm.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_flash_light_alarm.timerenevt = function(top)
	if(w1_page_flash_light_alarm.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_flash_light_alarm.wnd.tipinfo.id)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_flash_light_alarm.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id))
	if(chid == nil) then
		return 0
	end
	
	local value = b_wnd_ex.get_value(top,cwnd.t_alarm_time.id);
	local data = cfgdata.flash_light['channel'..chid]
	data.led_time = value;
	data.change_flag = true;
	
	return 0
end

w1_page_flash_light_alarm.pageinit = function(top)
		return 0
end

w1_page_flash_light_alarm.init= function(top)
	local c_wnd = w1_page_flash_light_alarm.wnd
	
	w1_wnd_util.cfgtab = {'flash_light','device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local chidstr = b_wnd_ex.get_text(top, c_wnd.t_channel.id);
	if(chidstr == '') then
		return 0
	end
	local chid =tonumber(chidstr);
	w1_page_flash_light_alarm.old_chid = chid;
	return 0
end

local on_channel= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_flash_light_alarm.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		if(w1_page_flash_light_alarm.old_chid ~= chid) then
			refresh_chdata(top, chid, false);
			w1_page_flash_light_alarm.old_chid = chid;
		end
		b_dlg.dlg_set_redraw(top);
	end
	
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_flash_light_alarm.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_flash_light_alarm.on_pre_show = function(top)
	local cwnd = w1_page_flash_light_alarm.wnd;
	channel_num = global_val.get_channelnum();

	w1_row_flashrow.changecheck(top, w1_row_flashrow.wnd, w1_id.cfg_alarmout.flashrow_alarm_id + 1, false)
end

w1_page_flash_light_alarm.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_channel', 't_channel','cap_alarm_time','t_alarm_time',			
			'con_flash_light','flash_row_wnd','flashtimeplan_wnd',	
			'tipinfo', 'apply'},
		
	cap_channel= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+2,xywh='s_cfg_page_1_2',items={},trans = false,channel_cbox = true,cmd =on_channel},	
	
	cap_alarm_time	= {t='static',id=id+3,	xywh='s_cfg_page_2_1',text='LA_ALATM_TIME'},
	t_alarm_time	= {t='edit_num',id=id+4,xywh='s_cfg_page_2_2',range={10,60},cmd = on_update_param},
	
	con_flash_light	= {t='container',id=w1_id.cfg_alarmout.con_flash_alarm_id,	xywh={0,0,10,10}},
	flash_row_wnd 	= w1_row_flashrow.wnd,
	flashtimeplan_wnd = w1_page_flashtimeplan.wnd,
	
	tipinfo		= {t='static',id=id+5,	xywh='s_flash_light_tipinfo_xywh',text='',trans = false},
	
	apply 	= {t='button',id=id+8,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_flash_light_alarm

