--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.imageadjust_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local b_dlg = require("wnd.core.b_dlg")
local w1_page_imageadjust = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_imageadjust.s_768 =
{
	s_cfg_page_imageadjust_xywh = {53,366,746,220},
	s_imageadjust_cap_where_xywh = {32,0,85,35},
	s_imageadjust_t_where_xywh = {141,0,106,35},
	s_imageadjust_cap_brig_xywh = {32,42,85,35},
	s_imageadjust_brig_subb_xywh = {138,49,16,21},
	s_imageadjust_t_brig_xywh = {154,42,123,35},
	s_imageadjust_brig_add_xywh = {278,49,16,21},
	s_imageadjust_brig_value_xywh = {297,49,32,21},
	s_imageadjust_cap_sharp_xywh = {32,85,85,35},
	s_imageadjust_sharp_subb_xywh = {138,92,16,21},
	s_imageadjust_t_sharp_xywh = {154,85,123,35},
	s_imageadjust_sharp_add_xywh = {278,92,16,21},
	s_imageadjust_sharp_value_xywh = {297,92,32,21},
	s_imageadjust_cap_contrast_xywh = {32,128,85,35},
	s_imageadjust_contrast_subb_xywh = {138,135,16,21},
	s_imageadjust_t_contrast_xywh = {154,128,123,35},
	s_imageadjust_contrast_add_xywh = {278,135,16,21},
	s_imageadjust_contrast_value_xywh = {297,135,32,21},
	s_imageadjust_cap_satura_xywh = {32,170,85,35},
	s_imageadjust_satura_subb_xywh = {138,177,16,21},
	s_imageadjust_t_satura_xywh = {154,170,123,35},
	s_imageadjust_satura_add_xywh = {278,177,16,21},
	s_imageadjust_satura_value_xywh = {297,177,32,21},
};

w1_page_imageadjust.s_1280 = 
{
	s_cfg_page_imageadjust_xywh = {60,475,900,310},
	s_imageadjust_cap_where_xywh = {60,0,160,50},
	s_imageadjust_t_where_xywh= {260,0,160,50},
	s_imageadjust_cap_brig_xywh = {60,60,160,50},
	s_imageadjust_brig_subb_xywh = {250,70,30,30},
	s_imageadjust_t_brig_xywh = {280,60,160,50},
	s_imageadjust_brig_add_xywh = {440,70,30,30},
	s_imageadjust_brig_value_xywh = {475,70,60,30},
	s_imageadjust_cap_sharp_xywh = {60,120,160,50},
	s_imageadjust_sharp_subb_xywh = {250,130,30,30},
	s_imageadjust_t_sharp_xywh = {280,120,160,50},
	s_imageadjust_sharp_add_xywh = {440,130,30,30},
	s_imageadjust_sharp_value_xywh = {475,130,60,30},
	s_imageadjust_cap_contrast_xywh = {60,180,160,50},
	s_imageadjust_contrast_subb_xywh = {250,190,30,30},
	s_imageadjust_t_contrast_xywh = {280,180,160,50},
	s_imageadjust_contrast_add_xywh = {440,190,30,30},
	s_imageadjust_contrast_value_xywh = {475,190,60,30},
	s_imageadjust_cap_satura_xywh = {60,240,160,50},
	s_imageadjust_satura_subb_xywh = {250,250,30,30},
	s_imageadjust_t_satura_xywh = {280,240,160,50},
	s_imageadjust_satura_add_xywh = {440,250,30,30},
	s_imageadjust_satura_value_xywh = {475,250,60,30},
};

w1_page_imageadjust.s_1440 = 
{
	s_cfg_page_imageadjust_xywh = {60,440,900,245},
	s_imageadjust_cap_where_xywh = {60,0,160,45},
	s_imageadjust_t_where_xywh= {255,0,160,45},
	s_imageadjust_cap_brig_xywh = {60,50,160,40},
	s_imageadjust_brig_subb_xywh = {250,60,30,30},
	s_imageadjust_t_brig_xywh = {280,50,160,40},
	s_imageadjust_brig_add_xywh = {440,60,30,30},
	s_imageadjust_brig_value_xywh = {475,60,60,30},
	s_imageadjust_cap_sharp_xywh = {60,95,160,40},
	s_imageadjust_sharp_subb_xywh = {250,105,30,30},
	s_imageadjust_t_sharp_xywh = {280,95,160,40},
	s_imageadjust_sharp_add_xywh = {440,105,30,30},
	s_imageadjust_sharp_value_xywh = {475,105,60,30},
	s_imageadjust_cap_contrast_xywh = {60,140,160,40},
	s_imageadjust_contrast_subb_xywh = {250,150,30,30},
	s_imageadjust_t_contrast_xywh = {280,140,160,40},
	s_imageadjust_contrast_add_xywh = {440,150,30,30},
	s_imageadjust_contrast_value_xywh = {475,150,60,30},
	s_imageadjust_cap_satura_xywh = {60,185,160,40},
	s_imageadjust_satura_subb_xywh = {250,195,30,30},
	s_imageadjust_t_satura_xywh = {280,185,160,40},
	s_imageadjust_satura_add_xywh = {440,195,30,30},
	s_imageadjust_satura_value_xywh = {475,195,60,30},
};

w1_page_imageadjust.s_1080p = 
{
	s_cfg_page_imageadjust_xywh = {100,515,1400,310},
	s_imageadjust_cap_where_xywh = {60,0,160,50},
	s_imageadjust_t_where_xywh= {265,0,200,50},
	s_imageadjust_cap_brig_xywh = {60,60,160,50},
	s_imageadjust_brig_subb_xywh = {260,70,30,30},
	s_imageadjust_t_brig_xywh = {290,60,232,50},
	s_imageadjust_brig_add_xywh = {522,70,30,30},
	s_imageadjust_brig_value_xywh = {558,70,60,30},
	s_imageadjust_cap_sharp_xywh = {60,120,160,50},
	s_imageadjust_sharp_subb_xywh = {260,130,30,30},
	s_imageadjust_t_sharp_xywh = {290,120,232,50},
	s_imageadjust_sharp_add_xywh = {522,130,30,30},
	s_imageadjust_sharp_value_xywh = {558,130,60,30},
	s_imageadjust_cap_contrast_xywh = {60,180,160,50},
	s_imageadjust_contrast_subb_xywh = {260,190,30,30},
	s_imageadjust_t_contrast_xywh = {290,180,232,50},
	s_imageadjust_contrast_add_xywh = {522,190,30,30},
	s_imageadjust_contrast_value_xywh = {558,190,60,30},
	s_imageadjust_cap_satura_xywh = {60,240,160,50},
	s_imageadjust_satura_subb_xywh = {260,250,30,30},
	s_imageadjust_t_satura_xywh = {290,240,232,50},
	s_imageadjust_satura_add_xywh = {522,250,30,30},
	s_imageadjust_satura_value_xywh = {558,250,60,30},

};

w1_page_imageadjust.s_2k = 
{
	s_cfg_page_imageadjust_xywh = {133,686,1866,413},
	s_imageadjust_cap_where_xywh = {80,0,213,67},
	s_imageadjust_t_where_xywh= {352,0,213,67},
	s_imageadjust_cap_brig_xywh = {80,80,213,67},
	s_imageadjust_brig_subb_xywh = {347,93,40,40},
	s_imageadjust_t_brig_xywh = {387,80,309,67},
	s_imageadjust_brig_add_xywh = {696,93,40,40},
	s_imageadjust_brig_value_xywh = {744,93,80,40},
	s_imageadjust_cap_sharp_xywh = {80,160,213,67},
	s_imageadjust_sharp_subb_xywh = {347,173,40,40},
	s_imageadjust_t_sharp_xywh = {387,160,309,67},
	s_imageadjust_sharp_add_xywh = {696,173,40,40},
	s_imageadjust_sharp_value_xywh = {744,173,80,40},
	s_imageadjust_cap_contrast_xywh = {80,240,213,67},
	s_imageadjust_contrast_subb_xywh = {347,253,40,40},
	s_imageadjust_t_contrast_xywh = {387,240,309,67},
	s_imageadjust_contrast_add_xywh = {696,253,40,40},
	s_imageadjust_contrast_value_xywh = {744,253,80,40},
	s_imageadjust_cap_satura_xywh = {80,320,213,67},
	s_imageadjust_satura_subb_xywh = {347,333,40,40},
	s_imageadjust_t_satura_xywh = {387,320,309,67},
	s_imageadjust_satura_add_xywh = {696,333,40,40},
	s_imageadjust_satura_value_xywh ={744,333,80,40},

};

w1_page_imageadjust.s_4k = 
{
	s_cfg_page_imageadjust_xywh 	= {200,1030,2800,620},
	s_imageadjust_cap_where_xywh 	= {120,0,320,100},
	s_imageadjust_t_where_xywh		= {520,0,400,100},
	s_imageadjust_cap_brig_xywh 	= {120,120,320,100},
	s_imageadjust_brig_subb_xywh	= {520,140,60,60},
	s_imageadjust_t_brig_xywh 		= {580,120,464,100},
	s_imageadjust_brig_add_xywh 	= {1044,140,60,60},
	s_imageadjust_brig_value_xywh 	= {1116,140,120,60},
	s_imageadjust_cap_sharp_xywh 	= {120,240,320,100},
	s_imageadjust_sharp_subb_xywh	= {520,260,60,60},
	s_imageadjust_t_sharp_xywh 		= {580,240,464,100},
	s_imageadjust_sharp_add_xywh 	= {1044,260,60,60},
	s_imageadjust_sharp_value_xywh 	= {1116,260,120,60},
	s_imageadjust_cap_contrast_xywh = {120,360,320,100},
	s_imageadjust_contrast_subb_xywh= {520,380,60,60},
	s_imageadjust_t_contrast_xywh 	= {580,360,464,100},
	s_imageadjust_contrast_add_xywh = {1044,380,60,60},
	s_imageadjust_contrast_value_xywh = {1116,380,120,60},
	s_imageadjust_cap_satura_xywh 	= {120,480,320,100},
	s_imageadjust_satura_subb_xywh 	= {520,500,60,60},
	s_imageadjust_t_satura_xywh 	= {580,480,464,100},
	s_imageadjust_satura_add_xywh 	= {1044,500,60,60},
	s_imageadjust_satura_value_xywh = {1116,500,120,60},
};

w1_page_imageadjust.clear_data=function ()
	w1_page_imageadjust.cfg_data=nil;
end

local COLOR_PARAM = {
	default = {bright = 50, contrast = 50, saturation = 50, sharpness = 50},
	indoor 	= {bright = 60, contrast = 50, saturation = 50, sharpness = 55},
	outdoor = {bright = 45, contrast = 50, saturation = 50, sharpness = 45}
};

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imageadjust.wnd;
	local data = cfgdata.adjust;
	if(-1 ~= data.bright)then
		data.bright = b_wnd_ex.get_value(top,cwnd.t_brig.id);
	end
	if(-1 ~= data.sharpness)then
		data.sharpness = b_wnd_ex.get_value(top,cwnd.t_sharp.id);
	end
	if(-1 ~= data.contrast)then
		data.contrast = b_wnd_ex.get_value(top,cwnd.t_contrast.id);
	end
	if(-1 ~= data.saturation)then
		data.saturation = b_wnd_ex.get_value(top,cwnd.t_satura.id);
	end
	if(-1 ~= data.where_put)then
		data.where_put = b_wnd_ex.get_sel(top,cwnd.t_where.id);
	end
	cfgdata.change_flag = 1;
	
	b_app_api.set_immediate_color(cfgdata);
	return 0
end

local set_image_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), true);
	end
	local cwnd = w1_page_imageadjust.wnd;
	if(id == cwnd.t_brig.id) then
		set_text(cwnd.brig_value.id, value);
	elseif(id == cwnd.t_sharp.id) then
		set_text(cwnd.sharp_value.id, value);
	elseif(id == cwnd.t_contrast.id) then
		set_text(cwnd.contrast_value.id, value);
	elseif(id == cwnd.t_satura.id) then
		set_text(cwnd.satura_value.id, value);
	end
	uitousercfg(top,w1_page_imageadjust.cfg_data);
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imageadjust.wnd;
		local opearid = nil;
		if(win_id == cwnd.brig_subb.id) then
			opearid = cwnd.t_brig.id;
		elseif(win_id == cwnd.sharp_subb.id) then
			opearid = cwnd.t_sharp.id;
		elseif(win_id == cwnd.contrast_subb.id) then
			opearid = cwnd.t_contrast.id;
		elseif(win_id == cwnd.satura_subb.id) then
			opearid = cwnd.t_satura.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > 0) then
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, true);
			set_image_value(top, opearid, value);
		end	
	end
	return 0
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_imageadjust.wnd;
		local value = b_wnd_ex.get_value(top, win_id);
		set_image_value(top, win_id, value);
	--[[	w1_wnd_util.uidatacheckfunc = uidatacheck;
		w1_wnd_util.uitocfgfunc = uitousercfg;
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ--]]
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imageadjust.wnd;
		local opearid = nil;
		if(win_id == cwnd.brig_add.id) then
			opearid = cwnd.t_brig.id;
		elseif(win_id == cwnd.sharp_add.id) then
			opearid = cwnd.t_sharp.id;
		elseif(win_id == cwnd.contrast_add.id) then
			opearid = cwnd.t_contrast.id;
		elseif(win_id == cwnd.satura_add.id) then
			opearid = cwnd.t_satura.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, true)
			set_image_value(top, opearid, value);
		end
	end
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_imageadjust.wnd;
		local idx = b_wnd_ex.get_sel(top,cwnd.t_where.id);
		
		if(idx == 0) then
			colortable = COLOR_PARAM.default;
		elseif(idx == 1) then
			colortable = COLOR_PARAM.indoor;
		elseif(idx == 2) then
			colortable = COLOR_PARAM.outdoor;		
		end	
		
		local set_value = function(id, value)
			b_wnd_ex.set_value(top, id, value, false);
		end
		local set_text = function(id, value)
			b_wnd_ex.set_text(top, id, tostring(value), false);
		end

		set_value(cwnd.t_brig.id,  colortable.bright);
		set_value(cwnd.t_sharp.id, colortable.sharpness);
		set_value(cwnd.t_contrast.id, colortable.contrast);
		set_value(cwnd.t_satura.id, colortable.saturation);
		
		set_text(cwnd.brig_value.id, colortable.bright);
		set_text(cwnd.sharp_value.id, colortable.sharpness);
		set_text(cwnd.contrast_value.id, colortable.contrast);
		set_text(cwnd.satura_value.id, colortable.saturation);
	
		uitousercfg(top,w1_page_imageadjust.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local refresh_hide = function(top, param, redraw)
	local cwnd = w1_page_imageadjust.wnd;
	if(-1 == param.where_put)then
		b_wnd_ex.set_hide(top, cwnd.cap_where.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_where.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_where.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_where.id, false, redraw)
	end
	if(-1 == param.bright)then
		b_wnd_ex.set_hide(top, cwnd.cap_brig.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.brig_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_brig.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.brig_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.brig_value.id, true, redraw)
	else	
		b_wnd_ex.set_hide(top, cwnd.cap_brig.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.brig_subb.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_brig.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.brig_add.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.brig_value.id, false, redraw)
	end
	
	if(-1 == param.sharpness)then
		b_wnd_ex.set_hide(top, cwnd.cap_sharp.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.sharp_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_sharp.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.sharp_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.sharp_value.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_sharp.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.sharp_subb.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_sharp.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.sharp_add.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.sharp_value.id, false, redraw)
	end
	
	if(-1 == param.contrast)then
		b_wnd_ex.set_hide(top, cwnd.cap_contrast.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.contrast_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_contrast.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.contrast_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.contrast_value.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_contrast.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.contrast_subb.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_contrast.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.contrast_add.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.contrast_value.id, false, redraw)
	end
	
	if(-1 == param.saturation)then
		b_wnd_ex.set_hide(top, cwnd.cap_satura.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.satura_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_satura.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.satura_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.satura_value.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_satura.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.satura_subb.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_satura.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.satura_add.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.satura_value.id, false, redraw)
	end
	
end

w1_page_imageadjust.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_imageadjust.wnd;
	b_wnd_ex.set_hide(top, cwnd.cap_where.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_where.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_brig.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.brig_subb.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_brig.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.brig_add.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.brig_value.id, bool_hide, redraw)
	
	b_wnd_ex.set_hide(top, cwnd.cap_sharp.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.sharp_subb.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_sharp.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.sharp_add.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.sharp_value.id, bool_hide, redraw)
	
	b_wnd_ex.set_hide(top, cwnd.cap_contrast.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.contrast_subb.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_contrast.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.contrast_add.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.contrast_value.id, bool_hide, redraw)
	
	b_wnd_ex.set_hide(top, cwnd.cap_satura.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.satura_subb.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_satura.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.satura_add.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.satura_value.id, bool_hide, redraw)
end

w1_page_imageadjust.set_param = function(top, param, redraw)
	local cwnd = w1_page_imageadjust.wnd;
	local data = param.adjust;--w1_page_image.data.color['channel'..chid];
	refresh_hide(top, data, false)
	local set_value = function(id, value)
		b_wnd_ex.set_value(top, id, value, redraw);
	end
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), redraw);
	end

	set_value(cwnd.t_brig.id,  data.bright);
	set_value(cwnd.t_sharp.id, data.sharpness);
	set_value(cwnd.t_contrast.id, data.contrast);
	set_value(cwnd.t_satura.id, data.saturation);
	
	set_text(cwnd.brig_value.id, data.bright);
	set_text(cwnd.sharp_value.id, data.sharpness);
	set_text(cwnd.contrast_value.id, data.contrast);
	set_text(cwnd.satura_value.id, data.saturation);
	b_wnd_ex.set_sel(top, cwnd.t_where.id, data.where_put, redraw);
	w1_page_imageadjust.cfg_data = param;
end

w1_page_imageadjust.get_param = function(top)
	local cwnd = w1_page_imageadjust.wnd;
	local param = {};
	param.bright = b_wnd_ex.get_value(top,cwnd.t_brig.id);
	param.sharpness = b_wnd_ex.get_value(top,cwnd.t_sharp.id);
	param.contrast = b_wnd_ex.get_value(top,cwnd.t_contrast.id);
	param.saturation = b_wnd_ex.get_value(top,cwnd.t_satura.id);
	return param;
end

w1_page_imageadjust.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imageadjust_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'cap_where','t_where','cap_brig','brig_subb', 't_brig', 'brig_add', 'brig_value', 
			'cap_sharp', 'sharp_subb', 't_sharp', 'sharp_add', 'sharp_value', 
			'cap_contrast','contrast_subb', 't_contrast','contrast_add','contrast_value',
			'cap_satura', 'satura_subb', 't_satura', 'satura_add', 'satura_value'},
		
	cap_where = {t='static',id=id+21,xywh='s_imageadjust_cap_where_xywh',text='LA_SCENCE',font = 'f_image',
					},	
					
	t_where  = {t='combox',id=id+22,xywh='s_imageadjust_t_where_xywh',items={'LA_DEFAULT','LA_INDOOR','LA_OUTDOOR'},  
					font = 'f_image',cmd = on_update_param
					},
	cap_brig	= {t='static',id=id+1,	xywh='s_imageadjust_cap_brig_xywh',	text='LA_BRIGHT',font = 'f_image'},
	brig_subb	= {t='button',id=id+2,	xywh='s_imageadjust_brig_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_brig		= {t='hslider',id=id+3,	xywh='s_imageadjust_t_brig_xywh',		
					font = 'f_slider', cmd=on_adj},
	brig_add	= {t='button',id=id+4,	xywh='s_imageadjust_brig_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	brig_value	= {t='static',id=id+5,	xywh='s_imageadjust_brig_value_xywh',trans = false},
	--sharp		
	cap_sharp	= {t='static',id=id+6,	xywh='s_imageadjust_cap_sharp_xywh',text='LA_SHARPNESS',font = 'f_image'},
	sharp_subb	= {t='button',id=id+7,	xywh='s_imageadjust_sharp_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_sharp		= {t='hslider',id=id+8,	xywh='s_imageadjust_t_sharp_xywh',		
					font = 'f_slider', cmd=on_adj},
	sharp_add	= {t='button',id=id+9,	xywh='s_imageadjust_sharp_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	sharp_value	= {t='static',id=id+10,	xywh='s_imageadjust_sharp_value_xywh',trans = false},
	--contrast
	cap_contrast= {t='static',id=id+11,	xywh='s_imageadjust_cap_contrast_xywh',		text='LA_CONTRAST',font = 'f_image'},
	contrast_subb	= {t='button',id=id+12,	xywh='s_imageadjust_contrast_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_contrast	= {t='hslider',id=id+13,	xywh='s_imageadjust_t_contrast_xywh',	
					font = 'f_slider', cmd=on_adj},
	contrast_add	= {t='button',id=id+14,	xywh='s_imageadjust_contrast_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	contrast_value	= {t='static',id=id+15,	xywh='s_imageadjust_contrast_value_xywh',trans = false},
	--satura
	cap_satura	= {t='static',id=id+16,	xywh='s_imageadjust_cap_satura_xywh',text='LA_SATURATION',font = 'f_image'},
	satura_subb	= {t='button',id=id+17,	xywh='s_imageadjust_satura_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_satura	= {t='hslider',id=id+18,xywh='s_imageadjust_t_satura_xywh',		
					font = 'f_slider', cmd=on_adj},
	satura_add	= {t='button',id=id+19,	xywh='s_imageadjust_satura_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	satura_value= {t='static',id=id+20,	xywh='s_imageadjust_satura_value_xywh',trans = false},
}

return w1_page_imageadjust

