--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.enhance_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_page_imageenhance = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_imageenhance.s_768 =
{
	s_cfg_page_imageenhance_xywh = {53,366,746,220},
	s_imageenhance_check_xywh_1 = {32,0,21,35},
	s_imageenhance_cap_xywh_1 = {53,0,138,35},
	s_imageenhance_subb_xywh_1 = {197,7,16,21},
	s_imageenhance_t_xywh_1 = {213,0,123,35},
	s_imageenhance_add_xywh_1 = {337,7,16,21},
	s_imageenhance_value_xywh_1 = {356,7,32,21},
	s_imageenhance_check_xywh_2 = {32,42,21,35},
	s_imageenhance_cap_xywh_2 = {53,42,138,35},
	s_imageenhance_subb_xywh_2 = {197,49,16,21},
	s_imageenhance_t_xywh_2 = {213,42,123,35},
	s_imageenhance_add_xywh_2 = {337,49,16,21},
	s_imageenhance_value_xywh_2 = {356,49,32,21},
	s_imageenhance_check_xywh_3 = {32,85,21,35},
	s_imageenhance_cap_xywh_3 = {53,85,138,35},
	s_imageenhance_subb_xywh_3 = {197,92,16,21},
	s_imageenhance_t_xywh_3 = {213,85,123,35},
	s_imageenhance_add_xywh_3 = {337,92,16,21},
	s_imageenhance_value_xywh_3 = {356,92,32,21},
	s_imageenhance_check_xywh_4 = {32,128,21,35},
	s_imageenhance_cap_xywh_4 = {53,128,138,35},
	s_imageenhance_subb_xywh_4 = {197,135,16,21},
	s_imageenhance_t_xywh_4 = {213,128,123,35},
	s_imageenhance_add_xywh_4 = {337,135,16,21},
	s_imageenhance_value_xywh_4 = {356,135,32,21},
	s_imageenhance_check5_xywh = {421,0,21,32},
	s_imageenhance_anti_shake_xywh = {448,0,106,32},
};

w1_page_imageenhance.s_1280 = 
{
	s_cfg_page_imageenhance_xywh 	= {60,475,880,310},--980
	s_imageenhance_check_xywh_1		= {60,0,40,45},
	s_imageenhance_cap_xywh_1 		= {100,0,160,45},
	s_imageenhance_subb_xywh_1		= {270,10,30,30},
	s_imageenhance_t_xywh_1 		= {300,0,160,45},
	s_imageenhance_add_xywh_1 		= {460,10,30,30},
	s_imageenhance_value_xywh_1 	= {495,10,50,30},
	s_imageenhance_check_xywh_2		= {60,60,40,45},
	s_imageenhance_cap_xywh_2 	= {100,60,160,45},
	s_imageenhance_subb_xywh_2 	= {270,70,30,30},
	s_imageenhance_t_xywh_2 		= {300,60,160,45},
	s_imageenhance_add_xywh_2 	= {460,70,30,30},
	s_imageenhance_value_xywh_2 	= {495,70,50,30},
	s_imageenhance_check_xywh_3		= {60,120,40,45},
	s_imageenhance_cap_xywh_3 	= {100,120,160,45},
	s_imageenhance_subb_xywh_3 	= {270,130,30,30},
	s_imageenhance_t_xywh_3 		= {300,120,160,45},
	s_imageenhance_add_xywh_3 	= {460,130,30,30},
	s_imageenhance_value_xywh_3 	= {495,130,50,30},
	s_imageenhance_check_xywh_4		= {60,180,40,45},
	s_imageenhance_cap_xywh_4 	= {100,180,160,45},
	s_imageenhance_subb_xywh_4 	= {270,190,30,30},
	s_imageenhance_t_xywh_4 	= {300,180,160,45},
	s_imageenhance_add_xywh_4 	= {460,190,30,30},
	s_imageenhance_value_xywh_4 = {495,190,50,30},
	s_imageenhance_check5_xywh		= {600,0,40,45},
	s_imageenhance_anti_shake_xywh	= {640,0,200,45},
};

w1_page_imageenhance.s_1440 = 
{
	s_cfg_page_imageenhance_xywh 	= {60,440,1000,245},
	s_imageenhance_check_xywh_1		= {60,0,40,45},
	s_imageenhance_cap_xywh_1 	= {100,0,160,45},
	s_imageenhance_subb_xywh_1	= {270,10,30,30},
	s_imageenhance_t_xywh_1 		= {300,0,160,45},
	s_imageenhance_add_xywh_1 	= {460,10,30,30},
	s_imageenhance_value_xywh_1 	= {495,10,50,30},
	s_imageenhance_check_xywh_2		= {60,60,40,45},
	s_imageenhance_cap_xywh_2 	= {100,60,160,45},
	s_imageenhance_subb_xywh_2 	= {270,70,30,30},
	s_imageenhance_t_xywh_2 		= {300,60,160,45},
	s_imageenhance_add_xywh_2 	= {460,70,30,30},
	s_imageenhance_value_xywh_2 	= {495,70,50,30},
	s_imageenhance_check_xywh_3		= {60,120,40,45},
	s_imageenhance_cap_xywh_3 	= {100,120,160,45},
	s_imageenhance_subb_xywh_3 	= {270,130,30,30},
	s_imageenhance_t_xywh_3 		= {300,120,160,45},
	s_imageenhance_add_xywh_3 	= {460,130,30,30},
	s_imageenhance_value_xywh_3 	= {495,130,50,30},
	s_imageenhance_check_xywh_4		= {60,180,40,45},
	s_imageenhance_cap_xywh_4 	= {100,180,160,45},
	s_imageenhance_subb_xywh_4 	= {270,190,30,30},
	s_imageenhance_t_xywh_4 	= {300,180,160,45},
	s_imageenhance_add_xywh_4 	= {460,190,30,30},
	s_imageenhance_value_xywh_4 = {495,190,50,30},
	s_imageenhance_check5_xywh		= {610,0,40,45},
	s_imageenhance_anti_shake_xywh	= {650,0,200,45},
};

w1_page_imageenhance.s_1080p = 
{
	s_cfg_page_imageenhance_xywh 	= {100,515,1400,310},
	s_imageenhance_check_xywh_1		= {60,0,40,50},
	s_imageenhance_cap_xywh_1		= {100,0,260,50},
	s_imageenhance_subb_xywh_1	= {370,10,30,30},
	s_imageenhance_t_xywh_1 		= {400,0,232,50},
	s_imageenhance_add_xywh_1 	= {632,10,30,30},
	s_imageenhance_value_xywh_1 	= {668,10,60,30},
	s_imageenhance_check_xywh_2		= {60,60,40,50},
	s_imageenhance_cap_xywh_2 	= {100,60,260,50},
	s_imageenhance_subb_xywh_2 	= {370,70,30,30},
	s_imageenhance_t_xywh_2 		= {400,60,232,50},
	s_imageenhance_add_xywh_2 	= {632,70,30,30},
	s_imageenhance_value_xywh_2 	= {668,70,60,30},
	s_imageenhance_check_xywh_3		= {60,120,40,50},
	s_imageenhance_cap_xywh_3 	= {100,120,260,50},
	s_imageenhance_subb_xywh_3 	= {370,130,30,30},
	s_imageenhance_t_xywh_3 		= {400,120,232,50},
	s_imageenhance_add_xywh_3 	= {632,130,30,30},
	s_imageenhance_value_xywh_3 	= {668,130,60,30},
	s_imageenhance_check_xywh_4		= {60,180,40,50},
	s_imageenhance_cap_xywh_4 	= {100,180,260,50},
	s_imageenhance_subb_xywh_4 	= {370,190,30,30},
	s_imageenhance_t_xywh_4 	= {400,180,232,50},
	s_imageenhance_add_xywh_4 	= {632,190,30,30},
	s_imageenhance_value_xywh_4 = {668,190,60,30},
	s_imageenhance_check5_xywh		= {790,0,40,45},
	s_imageenhance_anti_shake_xywh	= {840,0,200,45},

};

w1_page_imageenhance.s_2k = 
{
	s_cfg_page_imageenhance_xywh 	= {133,686,1866,413},
	s_imageenhance_check_xywh_1		= {80,0,53,67},
	s_imageenhance_cap_xywh_1		= {133,0,347,67},
	s_imageenhance_subb_xywh_1	= {493,13,40,40},
	s_imageenhance_t_xywh_1 		= {533,0,309,67},
	s_imageenhance_add_xywh_1 	= {842,13,40,40},
	s_imageenhance_value_xywh_1 	= {890,13,80,40},
	s_imageenhance_check_xywh_2		= {80,80,53,67},
	s_imageenhance_cap_xywh_2 	= {133,80,347,67},
	s_imageenhance_subb_xywh_2 	= {493,93,40,40},
	s_imageenhance_t_xywh_2 		= {533,80,309,67},
	s_imageenhance_add_xywh_2 	= {842,93,40,40},
	s_imageenhance_value_xywh_2 	= {890,93,80,40},
	s_imageenhance_check_xywh_3		= {80,160,53,67},
	s_imageenhance_cap_xywh_3 	= {133,160,347,67},
	s_imageenhance_subb_xywh_3 	= {493,173,40,40},
	s_imageenhance_t_xywh_3 		= {533,160,309,67},
	s_imageenhance_add_xywh_3 	= {842,173,40,40},
	s_imageenhance_value_xywh_3 	= {890,173,80,40},
	s_imageenhance_check_xywh_4		= {80,240,53,67},
	s_imageenhance_cap_xywh_4 	= {133,240,347,67},
	s_imageenhance_subb_xywh_4 	= {493,253,40,40},
	s_imageenhance_t_xywh_4 	= {533,240,309,67},
	s_imageenhance_add_xywh_4 	= {842,253,40,40},
	s_imageenhance_value_xywh_4 = {890,253,80,40},
	s_imageenhance_check5_xywh		= {1053,0,53,60},
	s_imageenhance_anti_shake_xywh	= {1120,0,267,60},
};

w1_page_imageenhance.s_4k = 
{
	s_cfg_page_imageenhance_xywh 	= {200,1030,2800,620},
	s_imageenhance_check_xywh_1		= {120,0,80,100},
	s_imageenhance_cap_xywh_1		= {200,0,520,100},
	s_imageenhance_subb_xywh_1	= {740,20,60,60},
	s_imageenhance_t_xywh_1 		= {800,0,464,100},
	s_imageenhance_add_xywh_1 	= {1264,20,60,60},
	s_imageenhance_value_xywh_1 	= {1336,20,120,60},
	s_imageenhance_check_xywh_2		= {120,120,80,100},
	s_imageenhance_cap_xywh_2 	= {200,120,520,100},
	s_imageenhance_subb_xywh_2 	= {740,140,60,60},
	s_imageenhance_t_xywh_2 		= {800,120,464,100},
	s_imageenhance_add_xywh_2 	= {1264,140,60,60},
	s_imageenhance_value_xywh_2 	= {1336,140,120,60},
	s_imageenhance_check_xywh_3		= {120,240,80,100},
	s_imageenhance_cap_xywh_3 	= {200,240,520,100},
	s_imageenhance_subb_xywh_3 	= {740,260,60,60},
	s_imageenhance_t_xywh_3 		= {800,240,464,100},
	s_imageenhance_add_xywh_3 	= {1264,260,60,60},
	s_imageenhance_value_xywh_3 	= {1336,260,120,60},
	s_imageenhance_check_xywh_4		= {120,360,80,100},
	s_imageenhance_cap_xywh_4 	= {200,360,520,100},
	s_imageenhance_subb_xywh_4 	= {740,380,60,60},
	s_imageenhance_t_xywh_4 	= {800,360,464,100},
	s_imageenhance_add_xywh_4 	= {1264,380,60,60},
	s_imageenhance_value_xywh_4 = {1336,380,120,60},
	s_imageenhance_check5_xywh		= {1580,0,80,90},
	s_imageenhance_anti_shake_xywh	= {1680,0,400,90},
};

w1_page_imageenhance.clear_data=function ()
	w1_page_imageenhance.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imageenhance.wnd;
	local data = cfgdata.enhance;
	local check1 = b_wnd_ex.get_check(top, cwnd.check1.id);
	local check2 = b_wnd_ex.get_check(top, cwnd.check2.id);
	local check3 = b_wnd_ex.get_check(top, cwnd.check3.id);
	local check4 = b_wnd_ex.get_check(top, cwnd.check4.id);
	local check5 = b_wnd_ex.get_check(top, cwnd.check5.id);
	if(-1 ~= data.wdr)then
		data.wdr = b_wnd_ex.get_value(top,cwnd.t_wdr.id);
	end
	if(-1 ~= data.hlc)then
		data.hlc = b_wnd_ex.get_value(top,cwnd.t_hlc.id);
	end
	if(-1 ~= data.blc)then
		data.blc = b_wnd_ex.get_value(top,cwnd.t_blc.id);
	end
	if(-1 ~= data.defog)then
		data.defog = b_wnd_ex.get_value(top,cwnd.t_defog.id);
	end
	
	if(-1 ~= data.wdr_enable)then
		if(true == check1)then
			data.wdr_enable = 1;
		else
			data.wdr_enable = 0;
		end
	end
	
	if(-1 ~= data.hlc_enable)then
		if(true == check2)then
			data.hlc_enable = 1;
		else
			data.hlc_enable = 0;
		end
	end
	if(-1 ~= data.blc_enable)then
		if(true == check3)then
			data.blc_enable = 1;
		else
			data.blc_enable = 0;
		end
	end
	
	if(-1 ~= data.defog_enable)then
		if(true == check4)then
			data.defog_enable = 1;
		else
			data.defog_enable = 0;
		end
	end	
	
	if(-1 ~= data.anti_shake)then
		if(true == check5)then
			data.anti_shake = 1;
		else
			data.anti_shake = 0;
		end
	end
	
	cfgdata.change_flag = 1;
	--δȡ
	b_app_api.set_immediate_color(cfgdata);
	return 0
end

local set_image_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), false);
	end
	local cwnd = w1_page_imageenhance.wnd;
	if(id == cwnd.t_wdr.id) then
		set_text(cwnd.wdr_value.id, value);
	elseif(id == cwnd.t_hlc.id) then
		set_text(cwnd.hlc_value.id, value);
	elseif(id == cwnd.t_blc.id) then
		set_text(cwnd.blc_value.id, value);
	elseif(id == cwnd.t_defog.id) then
		set_text(cwnd.defog_value.id, value);
	end
	uitousercfg(top,w1_page_imageenhance.cfg_data)
	b_dlg.dlg_set_redraw(top)
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imageenhance.wnd;
		local opearid = nil;
		if(win_id == cwnd.wdr_subb.id) then
			opearid = cwnd.t_wdr.id;
		elseif(win_id == cwnd.hlc_subb.id) then
			opearid = cwnd.t_hlc.id;
		elseif(win_id == cwnd.blc_subb.id) then
			opearid = cwnd.t_blc.id;
		elseif(win_id == cwnd.defog_subb.id) then
			opearid = cwnd.t_defog.id;	
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > 0) then
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, false);
			set_image_value(top, opearid, value);
		end	
	end
	return 0
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_imageenhance.wnd;
		local value = b_wnd_ex.get_value(top, win_id);
		set_image_value(top, win_id, value);
		
	--	w1_wnd_util.uidatacheckfunc = uidatacheck;
	--	w1_wnd_util.uitocfgfunc = uitousercfg;
	--	w1_wnd_util.page_onapply(top);
	--	w1_wnd_util.tipdispon();		--ʾ
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imageenhance.wnd;
		local opearid = nil;
		if(win_id == cwnd.wdr_add.id) then
			opearid = cwnd.t_wdr.id;
		elseif(win_id == cwnd.hlc_add.id) then
			opearid = cwnd.t_hlc.id;
		elseif(win_id == cwnd.blc_add.id) then
			opearid = cwnd.t_blc.id;
		elseif(win_id == cwnd.defog_add.id) then
			opearid = cwnd.t_defog.id;	
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, false)
			set_image_value(top, opearid, value);
		end
	end
	return 0
end

local on_enable = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		uitousercfg(top,w1_page_imageenhance.cfg_data)
	end
	return 0;
end

local refresh_disable = function (top,param,redraw)
	local cwnd = w1_page_imageenhance.wnd;
--	ʹ
--	b_wnd_ex.set_disable(top, cwnd.check1.id, false, redraw);
--	b_wnd_ex.set_disable(top, cwnd.cap_wdr.id, false, redraw);
	b_wnd_ex.set_disable(top, cwnd.check2.id, false, redraw);
	b_wnd_ex.set_disable(top, cwnd.cap_hlc.id, false, redraw);
	b_wnd_ex.set_disable(top, cwnd.check3.id, false, redraw);
	b_wnd_ex.set_disable(top, cwnd.cap_blc.id, false, redraw);
--ģʽûҲʹ	
	if(1 == param.wdr_enable)then
		b_wnd_ex.set_disable(top,cwnd.wdr_subb.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_wdr.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.wdr_add.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.wdr_value.id,false,redraw);
	else
		b_wnd_ex.set_disable(top,cwnd.wdr_subb.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_wdr.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.wdr_add.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.wdr_value.id,true,redraw);
	end
	
	if(1 == param.hlc_enable)then
	--	b_wnd_ex.set_disable(top, cwnd.check1.id, true, redraw);
	--	b_wnd_ex.set_disable(top, cwnd.cap_wdr.id, true, redraw);
		b_wnd_ex.set_disable(top, cwnd.check3.id, true, redraw);
		b_wnd_ex.set_disable(top, cwnd.cap_blc.id, true, redraw);
		
		b_wnd_ex.set_disable(top,cwnd.hlc_subb.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_hlc.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.hlc_add.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.hlc_value.id,false,redraw);
	else
		b_wnd_ex.set_disable(top,cwnd.hlc_subb.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_hlc.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.hlc_add.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.hlc_value.id,true,redraw);
	end
		
	if(1 == param.blc_enable)then
	--	b_wnd_ex.set_disable(top, cwnd.check1.id, true, redraw);
	--	b_wnd_ex.set_disable(top, cwnd.cap_wdr.id, true, redraw);
		b_wnd_ex.set_disable(top, cwnd.check2.id, true, redraw);
		b_wnd_ex.set_disable(top, cwnd.cap_hlc.id, true, redraw);
		
		b_wnd_ex.set_disable(top,cwnd.blc_subb.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_blc.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.blc_add.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.blc_value.id,false,redraw);
	else
		b_wnd_ex.set_disable(top,cwnd.blc_subb.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_blc.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.blc_add.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.blc_value.id,true,redraw);
	end
	
	if(1 == param.defog_enable)then
		b_wnd_ex.set_disable(top,cwnd.defog_subb.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_defog.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.defog_add.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.defog_value.id,false,redraw);
	else
		b_wnd_ex.set_disable(top,cwnd.defog_subb.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_defog.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.defog_add.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.defog_value.id,true,redraw);
	end
			
end

local on_check1 = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		uitousercfg(top,w1_page_imageenhance.cfg_data)
		local data = w1_page_imageenhance.cfg_data
		refresh_disable(top,data.enhance,false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_check2 = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		uitousercfg(top,w1_page_imageenhance.cfg_data)
		local data = w1_page_imageenhance.cfg_data
		refresh_disable(top,data.enhance,false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_check3 = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		uitousercfg(top,w1_page_imageenhance.cfg_data)
		local data = w1_page_imageenhance.cfg_data
		refresh_disable(top,data.enhance,false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_check4 = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		uitousercfg(top,w1_page_imageenhance.cfg_data)
		local data = w1_page_imageenhance.cfg_data
		refresh_disable(top,data.enhance,false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local refresh_hide = function(top, bool_hide,param, redraw)
	local cwnd = w1_page_imageenhance.wnd;
	local disp_num = 0;
	local disp_table = {}
	if(-1 ~= param.wdr_enable)then
		disp_num = disp_num+1;
		table.insert(disp_table,cwnd.check1.id);
		b_wnd_ex.set_hide(top, cwnd.cap_wdr.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.check1.id, bool_hide, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_wdr.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.check1.id, true, redraw)
	end
	if( -1 ~= param.wdr)then
	--	b_wnd_ex.set_hide(top, cwnd.cap_wdr.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.wdr_subb.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_wdr.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.wdr_add.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.wdr_value.id, bool_hide, redraw)
	else
	--	b_wnd_ex.set_hide(top, cwnd.cap_wdr.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.wdr_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_wdr.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.wdr_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.wdr_value.id, true, redraw)
	end
	
	if(-1 ~= param.hlc_enable)then
		disp_num = disp_num+1;
		table.insert(disp_table,cwnd.check2.id);
		b_wnd_ex.set_hide(top, cwnd.cap_hlc.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.check2.id, bool_hide, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_hlc.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.check2.id, true, redraw)
	end
	
	if( -1 ~= param.hlc)then
	--	b_wnd_ex.set_hide(top, cwnd.cap_hlc.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.hlc_subb.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_hlc.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.hlc_add.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.hlc_value.id, bool_hide, redraw)
	else
	--	b_wnd_ex.set_hide(top, cwnd.cap_hlc.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.hlc_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_hlc.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.hlc_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.hlc_value.id, true, redraw)
	end
	
	
	if(-1 ~= param.blc_enable)then
		disp_num = disp_num+1;
		table.insert(disp_table,cwnd.check3.id);
		b_wnd_ex.set_hide(top, cwnd.cap_blc.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.check3.id, bool_hide, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_blc.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.check3.id, true, redraw)
	end
	if(-1 ~= param.blc)then
	--	b_wnd_ex.set_hide(top, cwnd.cap_blc.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.blc_subb.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_blc.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.blc_add.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.blc_value.id, bool_hide, redraw)
	else
	--	b_wnd_ex.set_hide(top, cwnd.cap_blc.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.blc_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_blc.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.blc_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.blc_value.id, true, redraw)
	end
	
	if(-1 ~= param.defog_enable)then
		disp_num = disp_num+1;
		table.insert(disp_table,cwnd.check4.id);
		b_wnd_ex.set_hide(top, cwnd.cap_defog.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.check4.id, bool_hide, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_defog.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.check4.id, true, redraw)					
	end
	
	if(-1 ~= param.defog)then
	--	b_wnd_ex.set_hide(top, cwnd.cap_defog.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.defog_subb.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_defog.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.defog_add.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.defog_value.id, bool_hide, redraw)
	else
	--	b_wnd_ex.set_hide(top, cwnd.cap_defog.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.defog_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_defog.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.defog_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.defog_value.id, true, redraw)
	end
	
	for i=1,disp_num do
		local pos = SIZE('s_imageenhance_check_xywh_'..i)
		b_wnd_ex.move_ex(top,disp_table[i],pos,redraw)
		 pos = SIZE('s_imageenhance_cap_xywh_'..i)
		b_wnd_ex.move_ex(top,disp_table[i]+1,pos,redraw)
		 pos = SIZE('s_imageenhance_subb_xywh_'..i)
		b_wnd_ex.move_ex(top,disp_table[i]+2,pos,redraw)
		 pos = SIZE('s_imageenhance_t_xywh_'..i)
		b_wnd_ex.move_ex(top,disp_table[i]+3,pos,redraw)
		 pos = SIZE('s_imageenhance_add_xywh_'..i)
		b_wnd_ex.move_ex(top,disp_table[i]+4,pos,redraw)
		 pos = SIZE('s_imageenhance_value_xywh_'..i)
		b_wnd_ex.move_ex(top,disp_table[i]+5,pos,redraw)
	end
	
	
	if(-1 ~= param.anti_shake)then
		b_wnd_ex.set_hide(top, cwnd.check5.id,bool_hide,redraw);
		b_wnd_ex.set_hide(top, cwnd.anti_shake.id,bool_hide,redraw);	
	else
		b_wnd_ex.set_hide(top, cwnd.check5.id,true,redraw);
		b_wnd_ex.set_hide(top, cwnd.anti_shake.id,true,redraw);
	end
end

w1_page_imageenhance.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_imageenhance.wnd;
	local data = {};
	refresh_hide(top, bool_hide,data, redraw)
end

w1_page_imageenhance.set_param = function(top, param, redraw)
	local cwnd = w1_page_imageenhance.wnd;
	local data = param.enhance;--anti_shake δ
	
	refresh_hide(top,false,data, redraw)--ģʽ
	refresh_disable(top,data,redraw) --ûҴ
	if(0 == data.wdr_enable)then
		b_wnd_ex.set_check(top, cwnd.check1.id,false,redraw);
	elseif(1 == data.wdr_enable)then
		b_wnd_ex.set_check(top, cwnd.check1.id,true,redraw);
	end
	if( -1 ~= data.wdr)then --Ż쳣ʾ
		b_wnd_ex.set_value(top, cwnd.t_wdr.id, data.wdr, redraw);
		b_wnd_ex.set_text(top, cwnd.wdr_value.id, tostring(data.wdr), redraw);		
	end
	
	if(0 == data.hlc_enable)then
		b_wnd_ex.set_check(top, cwnd.check2.id,false,redraw);
	elseif(1 == data.hlc_enable)then
		b_wnd_ex.set_check(top, cwnd.check2.id,true,redraw);
	end
	
	if( -1 ~= data.hlc)then
		b_wnd_ex.set_value(top, cwnd.t_hlc.id, data.hlc, redraw);
		b_wnd_ex.set_text(top, cwnd.hlc_value.id, tostring(data.hlc), redraw);
	end
	
	if(0 == data.blc_enable)then
		b_wnd_ex.set_check(top, cwnd.check3.id,false,redraw);
	elseif(1 == data.blc_enable)then
		b_wnd_ex.set_check(top, cwnd.check3.id,true,redraw);
	end
	
	if( -1 ~= data.blc)then
		b_wnd_ex.set_value(top, cwnd.t_blc.id, data.blc, redraw);
		b_wnd_ex.set_text(top, cwnd.blc_value.id, tostring(data.blc), redraw);
	end
			
	if(0 == data.defog_enable)then
		b_wnd_ex.set_check(top, cwnd.check4.id,false,redraw);
	elseif(1 == data.defog_enable)then
		b_wnd_ex.set_check(top, cwnd.check4.id,true,redraw);
	end
	
	if( -1 ~= data.defog)then
		b_wnd_ex.set_value(top, cwnd.t_defog.id, data.defog, redraw);
		b_wnd_ex.set_text(top, cwnd.defog_value.id, tostring(data.defog), redraw);
	end
	
	if(0 == data.anti_shake)then
		b_wnd_ex.set_check(top, cwnd.check5.id,false,redraw);
	elseif(1 == data.anti_shake)then
		b_wnd_ex.set_check(top, cwnd.check5.id,true,redraw);
	end
	
	
	w1_page_imageenhance.cfg_data = param;
end

w1_page_imageenhance.get_param = function(top)
	local cwnd = w1_page_imageenhance.wnd;
	local param = {};
	local check1 = b_wnd_ex.get_check(top, cwnd.check1.id);
	local check2 = b_wnd_ex.get_check(top, cwnd.check2.id);
	local check3 = b_wnd_ex.get_check(top, cwnd.check3.id);
	local check4 = b_wnd_ex.get_check(top, cwnd.check4.id);
	param.wdr = b_wnd_ex.get_value(top,cwnd.t_wdr.id);
	param.hlc = b_wnd_ex.get_value(top,cwnd.t_hlc.id);
	param.blc = b_wnd_ex.get_value(top,cwnd.t_blc.id);
	param.defog = b_wnd_ex.get_value(top,cwnd.t_defog.id);

	if(true == check1)then
		param.wdr_enable = 1;
	else
		param.wdr_enable = 0;
	end
	
	if(true == check2)then
		param.hlc_enable = 1;
	else
		param.hlc_enable = 0;
	end
	
	if(true == check3)then
		param.blc_enable = 1;
	else
		param.blc_enable = 0;
	end
	
	if(true == check4)then
		param.defog_enable = 1;
	else
		param.defog_enable = 0;
	end
	--δȡ
	return param
end

w1_page_imageenhance.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imageenhance_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},	
--	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'check1','cap_wdr','wdr_subb', 't_wdr', 'wdr_add', 'wdr_value',
			'check2','cap_hlc','hlc_subb', 't_hlc', 'hlc_add', 'hlc_value',
			'check3','cap_blc','blc_subb', 't_blc','blc_add','blc_value',
			'check4','cap_defog', 'defog_subb', 't_defog', 'defog_add', 'defog_value',
			'check5','anti_shake'
	},
		
	check1 	= {t='check', 	id=id+1,xywh='s_imageenhance_check_xywh_1',
				cmd = on_check1},
					
	cap_wdr= {t='static',id=id+2,xywh='s_imageenhance_cap_xywh_1',text='LA_WDR',font = 'f_image',
					color_d 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},},	
					
	wdr_subb	= {t='button',id=id+3,	xywh='s_imageenhance_subb_xywh_1',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_wdr	= {t='hslider',id=id+4,	xywh='s_imageenhance_t_xywh_1',
					color_d 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},		
					font = 'f_slider', cmd=on_adj},
	wdr_add	= {t='button',id=id+5,	xywh='s_imageenhance_add_xywh_1',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	wdr_value	= {t='static',id=id+6,	xywh='s_imageenhance_value_xywh_1',font = 'f_image',trans = false,
					color_d 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},},				
		
	--hlc				
	check2 	= {t='check', 	id=id+7,xywh='s_imageenhance_check_xywh_2',
					cmd = on_check2},
	cap_hlc= {t='static',id=id+8,xywh='s_imageenhance_cap_xywh_2',text='LA_LIGHT_SUPPRESSION',font = 'f_image',
				color_d 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},},								
	hlc_subb	= {t='button',id=id+9,	xywh='s_imageenhance_subb_xywh_2',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},	
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_hlc		= {t='hslider',id=id+10,	xywh='s_imageenhance_t_xywh_2',
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					font = 'f_slider', cmd=on_adj},
	hlc_add	= {t='button',id=id+11,	xywh='s_imageenhance_add_xywh_2',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	hlc_value	= {t='static',id=id+12,	xywh='s_imageenhance_value_xywh_2',font = 'f_image',trans = false,
					color_d 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},},	
	
	--blc			
	check3 	= {t='check', 	id=id+13,xywh='s_imageenhance_check_xywh_3',
					cmd = on_check3},
	cap_blc= {t='static',id=id+14,	xywh='s_imageenhance_cap_xywh_3',text='LA_BLC',font = 'f_image',
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},},
	blc_subb	= {t='button',id=id+15,	xywh='s_imageenhance_subb_xywh_3',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_blc	= {t='hslider',id=id+16,	xywh='s_imageenhance_t_xywh_3',
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},	
					font = 'f_slider', cmd=on_adj},
	blc_add	= {t='button',id=id+17,	xywh='s_imageenhance_add_xywh_3',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	blc_value	= {t='static',id=id+18,	xywh='s_imageenhance_value_xywh_3',font = 'f_image',trans = false,
					color_d 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},},
	--defog
	check4	= {t='check', 	id=id+19,xywh='s_imageenhance_check_xywh_4',
					cmd = on_check4},
	cap_defog	= {t='static',id=id+20,	xywh='s_imageenhance_cap_xywh_4',text='LA_DEFOG',font = 'f_image'},
	defog_subb	= {t='button',id=id+21,	xywh='s_imageenhance_subb_xywh_4',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_defog	= {t='hslider',id=id+22,xywh='s_imageenhance_t_xywh_4',		
					font = 'f_slider', cmd=on_adj},
	defog_add	= {t='button',id=id+23,	xywh='s_imageenhance_add_xywh_4',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	defog_value= {t='static',id=id+24,	xywh='s_imageenhance_value_xywh_4',font = 'f_image',trans = false},			
	
	check5	= {t='check', 	id=id+25,xywh='s_imageenhance_check5_xywh',
					cmd = on_enable},	
	anti_shake = {t='static',id=id+26,	xywh='s_imageenhance_anti_shake_xywh',text='LA_ANTI_SHAKE',font = 'f_image'},			
					
}

return w1_page_imageenhance

