--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.exposure_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_dlg = require("wnd.core.b_dlg")
local w1_page_imageexposure = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_imageexposure.s_768 =
{
	s_cfg_page_imageexposure_xywh = {53,366,746,220},
	s_imageexposure_cap_mode_xywh = {32,0,106,35},
	s_imageexposure_t_mode_xywh = {197,0,106,35},
	s_imageexposure_cap_metering_xywh = {32,42,106,35},
	s_imageexposure_t_metering_xywh = {197,42,106,35},
	s_imageexposure_hline_xywh = {325,0,1,170},
	s_imageexposure_cap_maxshutter_xywh = {346,0,106,35},
	s_imageexposure_t_maxshutter_xywh = {514,0,106,35},
	s_imageexposure_cap_maxgain_xywh = {346,42,106,35},
	s_imageexposure_maxgain_subb_xywh = {512,49,16,21},
	s_imageexposure_t_maxgain_xywh = {528,42,123,35},
	s_imageexposure_maxgain_add_xywh = {651,49,16,21},
	s_imageexposure_maxgain_value_xywh = {670,49,32,21},
	s_imageexposure_cap_iris_xywh = {346,85,106,35},
	s_imageexposure_t_iris_xywh = {512,92,106,35},
	s_imageexposure_cap_iris_speed_xywh = {346,128,106,35},
	s_imageexposure_iris_speed_subb_xywh = {512,135,16,21},
	s_imageexposure_t_iris_speed_xywh = {528,128,123,35},
	s_imageexposure_iris_speed_add_xywh = {651,135,16,21},
	s_imageexposure_iris_speed_value_xywh = {670,135,32,21},
};

w1_page_imageexposure.s_1280 = 
{
	s_cfg_page_imageexposure_xywh 			= {60,475,920,310},--980
	s_imageexposure_cap_mode_xywh			= {50,0,160,45},
	s_imageexposure_t_mode_xywh    			= {230,0,160,45},
	s_imageexposure_cap_metering_xywh 		= {50,60,160,45},
	s_imageexposure_t_metering_xywh			= {230,60,160,45},
	s_imageexposure_hline_xywh 				= {440,0,1,240},
	s_imageexposure_cap_maxshutter_xywh 	= {455,0,160,45},
	s_imageexposure_t_maxshutter_xywh   	= {630,0,160,45},
	s_imageexposure_cap_maxgain_xywh    	= {455,60,160,45},
	s_imageexposure_maxgain_subb_xywh 		= {630,70,30,30},
	s_imageexposure_t_maxgain_xywh 			= {660,60,160,45},
	s_imageexposure_maxgain_add_xywh 		= {820,70,30,30},
	s_imageexposure_maxgain_value_xywh 		= {855,70,40,30},
	s_imageexposure_cap_iris_xywh			= {455,120,160,45},
	s_imageexposure_t_iris_xywh 			= {630,130,150,45},
	s_imageexposure_cap_iris_speed_xywh	 	= {455,180,160,45},
	s_imageexposure_iris_speed_subb_xywh	= {630,190,30,30},
	s_imageexposure_t_iris_speed_xywh 	 	= {660,180,160,45},
	s_imageexposure_iris_speed_add_xywh   	= {820,190,30,30},
	s_imageexposure_iris_speed_value_xywh 	= {855,190,40,30},
};

w1_page_imageexposure.s_1440 = 
{
	s_cfg_page_imageexposure_xywh 			= {60,440,1000,245},
	s_imageexposure_cap_mode_xywh			= {50,0,160,45},
	s_imageexposure_t_mode_xywh    			= {230,0,160,45},
	s_imageexposure_cap_metering_xywh 		= {50,60,160,45},
	s_imageexposure_t_metering_xywh			= {230,60,160,45},
	s_imageexposure_hline_xywh 				= {440,0,1,240},
	s_imageexposure_cap_maxshutter_xywh 	= {455,0,160,45},
	s_imageexposure_t_maxshutter_xywh   	= {635,0,160,45},
	s_imageexposure_cap_maxgain_xywh    	= {455,60,160,45},
	s_imageexposure_maxgain_subb_xywh 		= {630,70,30,30},
	s_imageexposure_t_maxgain_xywh 			= {660,60,160,45},
	s_imageexposure_maxgain_add_xywh 		= {820,70,30,30},
	s_imageexposure_maxgain_value_xywh 		= {855,70,40,30},
	s_imageexposure_cap_iris_xywh			= {455,120,160,45},
	s_imageexposure_t_iris_xywh 			= {630,130,150,45},
	s_imageexposure_cap_iris_speed_xywh	 	= {455,180,160,45},
	s_imageexposure_iris_speed_subb_xywh	= {630,190,30,30},
	s_imageexposure_t_iris_speed_xywh 	 	= {660,180,160,45},
	s_imageexposure_iris_speed_add_xywh   	= {820,190,30,30},
	s_imageexposure_iris_speed_value_xywh 	= {855,190,40,30},
};

w1_page_imageexposure.s_1080p = 
{
	s_cfg_page_imageexposure_xywh 			= {100,515,1400,310},
	s_imageexposure_cap_mode_xywh			= {60,0,200,50},
	s_imageexposure_t_mode_xywh    			= {370,0,200,50},
	s_imageexposure_cap_metering_xywh 		= {60,60,200,50},
	s_imageexposure_t_metering_xywh			= {370,60,200,50},
	s_imageexposure_hline_xywh 				= {610,0,2,240},
	s_imageexposure_cap_maxshutter_xywh 	= {650,0,200,50},
	s_imageexposure_t_maxshutter_xywh   	= {965,0,200,50},
	s_imageexposure_cap_maxgain_xywh    	= {650,60,200,50},
	s_imageexposure_maxgain_subb_xywh 		= {960,70,30,30},
	s_imageexposure_t_maxgain_xywh 			= {990,60,232,50},
	s_imageexposure_maxgain_add_xywh 		= {1222,70,30,30},
	s_imageexposure_maxgain_value_xywh 		= {1258,70,60,30},
	s_imageexposure_cap_iris_xywh			= {650,120,200,50},
	s_imageexposure_t_iris_xywh 			= {960,130,200,50},
	s_imageexposure_cap_iris_speed_xywh	 	= {650,180,200,50},
	s_imageexposure_iris_speed_subb_xywh	= {960,190,30,30},
	s_imageexposure_t_iris_speed_xywh 	 	= {990,180,232,50},
	s_imageexposure_iris_speed_add_xywh   	= {1222,190,30,30},
	s_imageexposure_iris_speed_value_xywh 	= {1258,190,60,30},

};

w1_page_imageexposure.s_2k = 
{
	s_cfg_page_imageexposure_xywh 			= {133,686,1866,413},
	s_imageexposure_cap_mode_xywh			= {80,0,267,67},
	s_imageexposure_t_mode_xywh    			= {493,0,267,67},
	s_imageexposure_cap_metering_xywh 		= {80,80,267,67},
	s_imageexposure_t_metering_xywh			= {493,80,267,67},
	s_imageexposure_hline_xywh 				= {813,0,3,320},
	s_imageexposure_cap_maxshutter_xywh 	= {866,0,267,67},
	s_imageexposure_t_maxshutter_xywh   	= {1285,0,267,67},
	s_imageexposure_cap_maxgain_xywh    	= {866,80,267,67},
	s_imageexposure_maxgain_subb_xywh 		= {1280,93,40,40},
	s_imageexposure_t_maxgain_xywh 			= {1320,80,309,67},
	s_imageexposure_maxgain_add_xywh 		= {1629,93,40,40},
	s_imageexposure_maxgain_value_xywh 		= {1677,93,80,40},
	s_imageexposure_cap_iris_xywh			= {866,160,267,67},
	s_imageexposure_t_iris_xywh 			= {1280,173,267,67},
	s_imageexposure_cap_iris_speed_xywh	 	= {866,240,267,67},
	s_imageexposure_iris_speed_subb_xywh	= {1280,253,40,40},
	s_imageexposure_t_iris_speed_xywh 	 	= {1320,240,309,67},
	s_imageexposure_iris_speed_add_xywh   	= {1629,253,40,40},
	s_imageexposure_iris_speed_value_xywh 	= {1677,253,80,40},

};

w1_page_imageexposure.s_4k = 
{
	s_cfg_page_imageexposure_xywh 			= {200,1030,2800,620},
	s_imageexposure_cap_mode_xywh			= {120,0,400,100},
	s_imageexposure_t_mode_xywh    			= {740,0,400,100},
	s_imageexposure_cap_metering_xywh 		= {120,120,400,100},
	s_imageexposure_t_metering_xywh			= {740,120,400,100},
	s_imageexposure_hline_xywh 				= {1220,0,4,480},
	s_imageexposure_cap_maxshutter_xywh 	= {1300,0,400,100},
	s_imageexposure_t_maxshutter_xywh   	= {1925,0,400,100},
	s_imageexposure_cap_maxgain_xywh    	= {1300,120,400,100},
	s_imageexposure_maxgain_subb_xywh 		= {1920,140,60,60},
	s_imageexposure_t_maxgain_xywh 			= {1980,120,464,100},
	s_imageexposure_maxgain_add_xywh 		= {2444,140,60,60},
	s_imageexposure_maxgain_value_xywh 		= {2516,140,120,60},
	s_imageexposure_cap_iris_xywh			= {1300,240,400,100},
	s_imageexposure_t_iris_xywh 			= {1920,260,400,100},
	s_imageexposure_cap_iris_speed_xywh	 	= {1300,360,400,100},
	s_imageexposure_iris_speed_subb_xywh	= {1920,380,60,60},
	s_imageexposure_t_iris_speed_xywh 	 	= {1980,360,464,100},
	s_imageexposure_iris_speed_add_xywh   	= {2444,380,60,60},
	s_imageexposure_iris_speed_value_xywh 	= {2516,380,120,60},

};

w1_page_imageexposure.clear_data=function ()
	w1_page_imageexposure.cfg_data=nil;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imageexposure.wnd;
	local data = cfgdata.expose;

	data.expose_mode = b_wnd_ex.get_sel(top, cwnd.t_mode.id);
	if(-1 ~=data.meter_area)then
		local metering_idx = b_wnd_ex.get_sel(top, cwnd.t_metering.id);
		if(0 ==metering_idx)then
			data.meter_area = 4;
		elseif(1 ==metering_idx)then
			data.meter_area = 0;
		elseif(2 ==metering_idx)then
			data.meter_area = 1;
		end
	end
	
	if(0 == data.expose_mode)then
		data.max_shutter = b_wnd_ex.get_sel(top, cwnd.t_maxshutter.id);
		data.max_gain = b_wnd_ex.get_value(top, cwnd.t_maxgain.id);
	elseif(1 == data.expose_mode)then
		data.fix_shutter = b_wnd_ex.get_sel(top, cwnd.t_maxshutter.id);
		data.fix_gain = b_wnd_ex.get_value(top, cwnd.t_maxgain.id);
	elseif(2 == data.expose_mode)then
		data.fix_shutter = b_wnd_ex.get_sel(top, cwnd.t_maxshutter.id);
		data.max_gain = b_wnd_ex.get_value(top, cwnd.t_maxgain.id);
	elseif(3 == data.expose_mode)then
		data.max_shutter = b_wnd_ex.get_sel(top, cwnd.t_maxshutter.id);
		data.max_gain = b_wnd_ex.get_value(top, cwnd.t_maxgain.id);
	end
	
	if(-1 ~= data.iris)then
		data.iris = b_wnd_ex.get_sel(top, cwnd.t_iris.id);
	elseif(-1 ~= data.iris_opt)then
		data.iris_opt = b_wnd_ex.get_sel(top, cwnd.t_iris.id);
	end
		
	if(-1 ~= data.iris_speed)then
		data.iris_speed = b_wnd_ex.get_value(top, cwnd.t_iris_speed.id);
	end
	cfgdata.change_flag = 1;
	b_app_api.set_immediate_color(cfgdata);
	b_dlg.dlg_set_redraw(top)
	return 0
end

local set_image_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), false);
	end
	local cwnd = w1_page_imageexposure.wnd;
	if(id == cwnd.t_maxgain.id) then
		set_text(cwnd.maxgain_value.id, value);
	elseif(id == cwnd.t_iris_speed.id)then	
		set_text(cwnd.iris_speed_value.id, value);
	end
	uitousercfg(top,w1_page_imageexposure.cfg_data)
	b_dlg.dlg_set_redraw(top)
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imageexposure.wnd;
		local opearid = nil;
		if(win_id == cwnd.maxgain_subb.id) then
			opearid = cwnd.t_maxgain.id;
		elseif(win_id == cwnd.iris_speed_subb.id)then	
			opearid = cwnd.t_iris_speed.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > 0) then
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, false);
			set_image_value(top, opearid, value);
		end	
	end
	return 0
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_imageexposure.wnd;
		local value = b_wnd_ex.get_value(top, win_id);
		set_image_value(top, win_id, value);
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imageexposure.wnd;
		local opearid = nil;
		if(win_id == cwnd.maxgain_add.id) then
			opearid = cwnd.t_maxgain.id;
		elseif(win_id == cwnd.iris_speed_add.id)then	
			opearid = cwnd.t_iris_speed.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, false)
			set_image_value(top, opearid, value);
		end
	end
	return 0
end

local refresh_hide = function(top, bool_hide, param,redraw)
	local cwnd = w1_page_imageexposure.wnd;
	if(-1 == param.meter_area)then
		b_wnd_ex.set_hide(top, cwnd.cap_metering.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_metering.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_metering.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_metering.id, bool_hide, redraw)
	end
	
	if((-1 == param.iris) and (-1 == param.iris_opt))then
		b_wnd_ex.set_hide(top, cwnd.cap_iris.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_iris.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_iris.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_iris.id, bool_hide, redraw)
	end
	
	if((1 == param.iris) and (-1 == param.iris_opt))then
		b_wnd_ex.set_disable(top, cwnd.cap_iris_speed.id, false, redraw)
		b_wnd_ex.set_disable(top, cwnd.iris_speed_subb.id, false, redraw)
		b_wnd_ex.set_disable(top, cwnd.t_iris_speed.id, false, redraw)
		b_wnd_ex.set_disable(top, cwnd.iris_speed_add.id, false, redraw)
		b_wnd_ex.set_disable(top, cwnd.iris_speed_value.id, false, redraw)
	elseif((0 == param.iris) and (-1 == param.iris_opt))then
		b_wnd_ex.set_disable(top, cwnd.cap_iris_speed.id, true, redraw)
		b_wnd_ex.set_disable(top, cwnd.iris_speed_subb.id, true, redraw)
		b_wnd_ex.set_disable(top, cwnd.t_iris_speed.id, true, redraw)
		b_wnd_ex.set_disable(top, cwnd.iris_speed_add.id, true, redraw)
		b_wnd_ex.set_disable(top, cwnd.iris_speed_value.id, true, redraw)
	end
	
	if(-1 ~= param.iris_opt)then
		if(0 == param.expose_mode or 2 == param.expose_mode)then
			b_wnd_ex.set_disable(top, cwnd.cap_iris.id, true, redraw)	
			b_wnd_ex.set_disable(top, cwnd.t_iris.id, true, redraw)	
		else
			b_wnd_ex.set_disable(top, cwnd.cap_iris.id, false, redraw)	
			b_wnd_ex.set_disable(top, cwnd.t_iris.id, false, redraw)	
		end
	else
		b_wnd_ex.set_disable(top, cwnd.t_iris.id, false, redraw)	
	end
	
	if(-1 == param.expose_mode)then
		b_wnd_ex.set_hide(top, cwnd.cap_mode.id, true, redraw);
		b_wnd_ex.set_hide(top, cwnd.t_mode.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_mode.id, false, redraw);
		b_wnd_ex.set_hide(top, cwnd.t_mode.id, false, redraw);
	end
	
	if(-1 == param.fix_shutter and -1 == param.max_shutter)then
		b_wnd_ex.set_hide(top, cwnd.cap_maxshutter.id, true, redraw);
		b_wnd_ex.set_hide(top, cwnd.t_maxshutter.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_maxshutter.id, false, redraw);
		b_wnd_ex.set_hide(top, cwnd.t_maxshutter.id, false, redraw);
	end

	if(-1 == param.fix_gain and -1 == param.max_gain)then
		b_wnd_ex.set_hide(top, cwnd.cap_maxgain.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.maxgain_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_maxgain.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.maxgain_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.maxgain_value.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_maxgain.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.maxgain_subb.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_maxgain.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.maxgain_add.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.maxgain_value.id, false, redraw)
	end
	
	if(-1 == param.iris_speed)then
		b_wnd_ex.set_hide(top, cwnd.cap_iris_speed.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.iris_speed_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_iris_speed.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.iris_speed_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.iris_speed_value.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_iris_speed.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.iris_speed_subb.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_iris_speed.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.iris_speed_add.id, bool_hide, redraw)
		b_wnd_ex.set_hide(top, cwnd.iris_speed_value.id, bool_hide, redraw)
	end
end


local on_mode = function(top, win_id, vmsg, x, y)
	local cwnd = w1_page_imageexposure.wnd;
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local data = w1_page_imageexposure.cfg_data.expose;
		local mode = b_wnd_ex.get_sel(top,cwnd.t_mode.id)
		if(0 == mode)then
			b_wnd_ex.set_text(top,cwnd.cap_maxshutter.id,STR('LA_MAX_SHUTTER'),false)
			b_wnd_ex.set_text(top,cwnd.cap_maxgain.id,STR('LA_MAX_GAIN'),false)
			
			b_wnd_ex.set_sel(top, cwnd.t_maxshutter.id, data.max_shutter, false);
			b_wnd_ex.set_value(top, cwnd.t_maxgain.id, data.max_gain, false);
			b_wnd_ex.set_text(top, cwnd.maxgain_value.id, tostring(data.max_gain), false);	
		elseif(1 == mode)then
			b_wnd_ex.set_text(top,cwnd.cap_maxshutter.id,STR('LA_FIXED_SHUTTER'),false)
			b_wnd_ex.set_text(top,cwnd.cap_maxgain.id,STR('LA_FIXED_GAIN'),false)
			
			b_wnd_ex.set_sel(top, cwnd.t_maxshutter.id, data.fix_shutter, false);
			b_wnd_ex.set_value(top, cwnd.t_maxgain.id, data.fix_gain, false);
			b_wnd_ex.set_text(top, cwnd.maxgain_value.id, tostring(data.fix_gain), false);
		elseif(2 == mode)then
			b_wnd_ex.set_text(top,cwnd.cap_maxshutter.id,STR('LA_FIXED_SHUTTER'),false)
			b_wnd_ex.set_text(top,cwnd.cap_maxgain.id,STR('LA_MAX_GAIN'),false)
			
			b_wnd_ex.set_sel(top, cwnd.t_maxshutter.id, data.fix_shutter, false);
			b_wnd_ex.set_value(top, cwnd.t_maxgain.id, data.max_gain, false);
			b_wnd_ex.set_text(top, cwnd.maxgain_value.id, tostring(data.max_gain), false);	
		elseif(3 == mode)then
			b_wnd_ex.set_text(top, cwnd.cap_maxshutter.id, STR('LA_MAX_SHUTTER'), false);
			b_wnd_ex.set_text(top, cwnd.cap_maxgain.id, STR('LA_MAX_GAIN'), false);
			
			b_wnd_ex.set_sel(top, cwnd.t_maxshutter.id, data.max_shutter, false);
			b_wnd_ex.set_value(top, cwnd.t_maxgain.id, data.max_gain, false);
			b_wnd_ex.set_text(top, cwnd.maxgain_value.id, tostring(data.max_gain), false);			
		end
		uitousercfg(top,w1_page_imageexposure.cfg_data)
		local data = w1_page_imageexposure.cfg_data.expose
		refresh_hide(top, false, data,false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_imageexposure.cfg_data);
	end
	return 0;
end

local on_iris = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_imageexposure.cfg_data);
		refresh_hide(top, false, w1_page_imageexposure.cfg_data.expose,false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

w1_page_imageexposure.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_imageexposure.wnd;
	b_wnd_ex.set_hide(top, cwnd.cap_mode.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_mode.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.hline.id, bool_hide, redraw)
	
	b_wnd_ex.set_hide(top, cwnd.cap_maxshutter.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_maxshutter.id, bool_hide, redraw)
	
	b_wnd_ex.set_hide(top, cwnd.cap_maxgain.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.maxgain_subb.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_maxgain.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.maxgain_add.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.maxgain_value.id, bool_hide, redraw)
	
	local data = {};
	refresh_hide(top, bool_hide, data,redraw);
end

w1_page_imageexposure.set_param = function(top, param, redraw)
	local cwnd = w1_page_imageexposure.wnd;
	local data = param.expose;
	refresh_hide(top, false, data,redraw);--
	
	b_wnd_ex.set_sel(top, cwnd.t_mode.id, data.expose_mode, redraw);
	if(4 == data.meter_area)then
		b_wnd_ex.set_sel(top, cwnd.t_metering.id, 0, redraw);	
	elseif(0 == data.meter_area)then
		b_wnd_ex.set_sel(top, cwnd.t_metering.id,1, redraw);
	elseif(1 == data.meter_area)then
		b_wnd_ex.set_sel(top, cwnd.t_metering.id, 2, redraw);
	elseif(-1 == data.meter_area)then  --ָ֧ù

	end
	
	if(0 == data.expose_mode)then
		b_wnd_ex.set_text(top, cwnd.cap_maxshutter.id, STR('LA_MAX_SHUTTER'), redraw);
		b_wnd_ex.set_text(top, cwnd.cap_maxgain.id, STR('LA_MAX_GAIN'), redraw);
		
		b_wnd_ex.set_sel(top, cwnd.t_maxshutter.id, data.max_shutter, redraw);
		b_wnd_ex.set_value(top, cwnd.t_maxgain.id, data.max_gain, redraw);
		b_wnd_ex.set_text(top, cwnd.maxgain_value.id, tostring(data.max_gain), redraw);	
	elseif(1 == data.expose_mode)then
		b_wnd_ex.set_text(top, cwnd.cap_maxshutter.id, STR('LA_FIXED_SHUTTER'), redraw);
		b_wnd_ex.set_text(top, cwnd.cap_maxgain.id, STR('LA_FIXED_GAIN'), redraw);
		
		b_wnd_ex.set_sel(top, cwnd.t_maxshutter.id, data.fix_shutter, redraw);
		b_wnd_ex.set_value(top, cwnd.t_maxgain.id, data.fix_gain, redraw);
		b_wnd_ex.set_text(top, cwnd.maxgain_value.id, tostring(data.fix_gain), redraw);
	elseif(2 == data.expose_mode)then
		b_wnd_ex.set_text(top, cwnd.cap_maxshutter.id, STR('LA_FIXED_SHUTTER'), redraw);
		b_wnd_ex.set_text(top, cwnd.cap_maxgain.id, STR('LA_MAX_GAIN'), redraw);
		
		b_wnd_ex.set_sel(top, cwnd.t_maxshutter.id, data.fix_shutter, redraw);
		b_wnd_ex.set_value(top, cwnd.t_maxgain.id, data.max_gain, redraw);
		b_wnd_ex.set_text(top, cwnd.maxgain_value.id, tostring(data.max_gain), redraw);	
	elseif(3 == data.expose_mode)then
		b_wnd_ex.set_text(top, cwnd.cap_maxshutter.id, STR('LA_MAX_SHUTTER'), redraw);
		b_wnd_ex.set_text(top, cwnd.cap_maxgain.id, STR('LA_MAX_GAIN'), redraw);
		
		b_wnd_ex.set_sel(top, cwnd.t_maxshutter.id, data.max_shutter, redraw);
		b_wnd_ex.set_value(top, cwnd.t_maxgain.id, data.max_gain, redraw);
		b_wnd_ex.set_text(top, cwnd.maxgain_value.id, tostring(data.max_gain), redraw);	
	end
	b_wnd_ex.dlg_direct_up(top, cwnd.t_maxshutter.id, true, false);	--ʾ
	
	local iris_lis1 = {STR('LA_CLOSE'),'F1.0','F1.1','F1.2','F1.3','F1.4','F1.6','F1.7','F1.8','F2.0','F2.2','F2.4','F2.6','F2.8','F3.2','F3.4',
					'F3.6','F4.0','F4.5','F4.8','F5.0','F5.6','F6.3','F6.8','F7.1','F8.0','F9.0','F9.6','F10.0','F11.0','F13.0','F14.0','F16.0',
					'F18.0','F19.0','F20.0','F22.0','F25.0','F27.0','F29.0','F32.0','F36.0','F38.0','F40.0','F45.0','F52.0','F54.0','F58.0','F64.0'};
	local iris_list2 = {STR('LA_FULLY_OPEN'),STR('LA_AUTO')};

	if(-1 ~= data.iris_opt)then --iris_opt 82
		b_wnd_ex.set_items(top,  cwnd.t_iris.id, iris_lis1, false);
		b_wnd_ex.set_sel(top, cwnd.t_iris.id, data.iris_opt, redraw);
	elseif(-1 ~= data.iris)then
		b_wnd_ex.set_items(top,  cwnd.t_iris.id, iris_list2, false);
		if(data.iris > 1)then
			b_wnd_ex.set_sel(top, cwnd.t_iris.id, 1, redraw);
		else
			b_wnd_ex.set_sel(top, cwnd.t_iris.id, data.iris, redraw);
		end
	else
	
	end
	b_wnd_ex.dlg_direct_up(top, cwnd.t_iris.id, true, false);	--ʾ
	if(-1 ~= data.iris_speed)then
		b_wnd_ex.set_value(top, cwnd.t_iris_speed.id, data.iris_speed, redraw);
		b_wnd_ex.set_text(top, cwnd.iris_speed_value.id, tostring(data.iris_speed), redraw);		
	end
	
	w1_page_imageexposure.cfg_data = param

end

w1_page_imageexposure.get_param = function(top)
	local cwnd = w1_page_imageexposure.wnd;
	local param = {};
	param.expose_mode = b_wnd_ex.get_sel(top, cwnd.t_mode.id);
	local metering_idx = b_wnd_ex.get_sel(top, cwnd.t_metering.id);
	if(0 ==metering_idx)then
		param.meter_area = 4;
	elseif(1 ==metering_idx)then
		param.meter_area = 0;
	elseif(2 ==metering_idx)then
		param.meter_area = 1;
	end
	param.fix_shutter = b_wnd_ex.get_sel(top, cwnd.t_maxshutter.id);
	param.max_gain = b_wnd_ex.get_value(top, cwnd.t_maxgain.id);
	return param
end

w1_page_imageexposure.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imageexposure_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	
	sub = {'cap_mode','t_mode','cap_metering','t_metering','hline','cap_maxshutter','t_maxshutter',
			'cap_maxgain','maxgain_subb','t_maxgain','maxgain_add','maxgain_value','cap_iris','t_iris',
			'cap_iris_speed','iris_speed_subb','t_iris_speed','iris_speed_add','iris_speed_value',},
		

	cap_mode = {t='static',id=id+1,xywh='s_imageexposure_cap_mode_xywh',text='LA_EXPOSURE_MODE',font = 'f_image',
					},	
	t_mode  	= {t='combox',id=id+2,xywh='s_imageexposure_t_mode_xywh',items={'LA_AUTO','LA_MANUAL','LA_SHUTTER_PRIORITY','LA_IRIS_PRIORITY'},
					 cmd = on_mode,font = 'f_image',
					},	

	cap_metering = {t='static',id=id+3,xywh='s_imageexposure_cap_metering_xywh',text='LA_METER_AREA',font = 'f_image',
					},	
	t_metering  	= {t='combox',id=id+4,xywh='s_imageexposure_t_metering_xywh',items={'LA_WHOLE','LA_CENTER_SPOT','LA_CENTER_AREA'},
					font = 'f_image',cmd = on_mode},	
	hline 	= {t='hline',	id=id+5,xywh='s_imageexposure_hline_xywh'},		
	
	cap_maxshutter = {t='static',id=id+6,xywh='s_imageexposure_cap_maxshutter_xywh',text='LA_MAX_SHUTTER',font = 'f_image',
					},	
	t_maxshutter  	= {t='combox',id=id+7,xywh='s_imageexposure_t_maxshutter_xywh',items={'1/1','1/2','1/5','1/10','1/12.5','1/15','1/20','1/25','1/30','1/50','1/60',
					'1/100','1/120','1/125','1/150','1/200','1/250','1/500','1/1000','1/2000','1/5000','1/10000','1/20000','1/50000','1/100000','1/200000'},
					trans = false,font = 'f_image',cmd = on_update_param,
					},	
	--max_gain
	cap_maxgain = {t='static',id=id+8,xywh='s_imageexposure_cap_maxgain_xywh',text='LA_MAX_GAIN',font = 'f_image',
					},	

	maxgain_subb	= {t='button',id=id+9,	xywh='s_imageexposure_maxgain_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_maxgain	= {t='hslider',id=id+10,	xywh='s_imageexposure_t_maxgain_xywh',	
					font = 'f_slider', cmd=on_adj},
	maxgain_add	= {t='button',id=id+11,	xywh='s_imageexposure_maxgain_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	maxgain_value	= {t='static',id=id+12,	xywh='s_imageexposure_maxgain_value_xywh',text = '',trans = false},
	
	
	cap_iris = {t='static',id=id+13,xywh='s_imageexposure_cap_iris_xywh',text='LA_IRIS',font = 'f_image',
					},	
	t_iris  	= {t='combox',id=id+14,xywh='s_imageexposure_t_iris_xywh',items={'Auto','Open Fully','Close','F1.0','F1.1','F1.2','F1.3','F1.4','F1.6',
					'F1.7','F1.8','F2.0','F2.2','F2.4','F2.6','F2.8','F3.2','F3.4','F3.6','F4.0','F4.5','F4.8','F5.0','F5.6','F6.3','F6.8','F7.1','F8.0',
					'F9.0','F9.6','F10.0','F11.0','F13.0','F14.0','F16.0'},
					trans = false,font = 'f_image',cmd = on_iris,
					},	
	
	--iris speed
	cap_iris_speed = {t='static',id=id+15,xywh='s_imageexposure_cap_iris_speed_xywh',text='LA_IRIS_SPEED',font = 'f_image',
					},	

	iris_speed_subb	= {t='button',id=id+16,	xywh='s_imageexposure_iris_speed_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_iris_speed	= {t='hslider',id=id+17,	xywh='s_imageexposure_t_iris_speed_xywh',	
					font = 'f_slider', cmd=on_adj},
	iris_speed_add	= {t='button',id=id+18,	xywh='s_imageexposure_iris_speed_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	iris_speed_value	= {t='static',id=id+19,	xywh='s_imageexposure_iris_speed_value_xywh',text = '',trans = false},
	
}

return w1_page_imageexposure

