--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.focus_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local b_dlg 	= require("wnd.core.b_dlg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_page_imagefocus = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_imagefocus.s_768 =
{
	s_cfg_page_imagefocus_xywh = {53,366,746,220},
	s_imagefocus_check1_xywh = {32,0,26,35},
	s_imagefocus_cap_digitalzoom_xywh = {58,0,106,35},
	s_imagefocus_hline_xywh = {325,0,1,170},
	s_imagefocus_cap_focusmode_xywh = {346,0,106,35},
	s_imagefocus_t_focusmode_xywh = {512,0,106,35},
	s_imagefocus_cap_sensitivity_xywh = {346,42,106,35},
	s_imagefocus_sensitivity_subb_xywh = {512,49,16,21},
	s_imagefocus_t_sensitivity_xywh = {528,42,123,35},
	s_imagefocus_sensitivity_add_xywh = {651,49,16,21},
	s_imagefocus_sensitivity_value_xywh = {670,49,32,21},
	s_imagefocus_cap_focusdistance_xywh = {346,85,106,35},
	s_imagefocus_t_focusdistance_xywh = {512,85,106,35},
	s_imagefocus_zoom_down_xywh = {512,49,16,21},
	s_imagefocus_t_zoom_xywh = {528,42,123,35},
	s_imagefocus_zoom_up_xywh = {651,49,16,21},
	s_imagefocus_nearfocus_xywh = {512,92,16,21},
	s_imagefocus_t_focus_xywh = {528,85,123,35},
	s_imagefocus_farfocus_xywh = {651,92,16,21},
	s_imagefocus_focus_once_xywh = {512,128,106,35},
};

w1_page_imagefocus.s_1280 = 
{
	s_cfg_page_imagefocus_xywh 			= {60,475,920,310},
	s_imagefocus_check1_xywh			= {40,0,40,45},
	s_imagefocus_cap_digitalzoom_xywh	= {80,0,250,45},
	s_imagefocus_hline_xywh 			= {400,0,2,240},
	s_imagefocus_cap_focusmode_xywh 	= {415,0,160,45},
	s_imagefocus_t_focusmode_xywh   	= {590,0,160,45},
	s_imagefocus_cap_sensitivity_xywh   = {415,60,160,45},
	s_imagefocus_sensitivity_subb_xywh 	= {590,70,30,30},
	s_imagefocus_t_sensitivity_xywh 	= {620,60,160,45},
	s_imagefocus_sensitivity_add_xywh 	= {780,70,30,30},
	s_imagefocus_sensitivity_value_xywh = {815,70,40,30},
	s_imagefocus_cap_focusdistance_xywh = {415,120,160,45},
	s_imagefocus_t_focusdistance_xywh	= {590,120,160,45},	
	s_imagefocus_zoom_down_xywh 		= {590,70,30,30},
	s_imagefocus_t_zoom_xywh 			= {620,60,160,45},
	s_imagefocus_zoom_up_xywh 			= {780,70,30,30},
	s_imagefocus_nearfocus_xywh 		= {590,130,30,30},
	s_imagefocus_t_focus_xywh 			= {620,120,160,45},
	s_imagefocus_farfocus_xywh 			= {780,130,30,30},
	s_imagefocus_focus_once_xywh		= {590,180,160,45},
};

w1_page_imagefocus.s_1440 = 
{
	s_cfg_page_imagefocus_xywh 			= {60,440,1000,245},
	s_imagefocus_check1_xywh			= {40,0,40,45},
	s_imagefocus_cap_digitalzoom_xywh	= {80,0,250,45},
	s_imagefocus_hline_xywh 			= {400,0,2,240},
	s_imagefocus_cap_focusmode_xywh 	= {415,0,160,45},
	s_imagefocus_t_focusmode_xywh   	= {590,0,160,45},
	s_imagefocus_cap_sensitivity_xywh   = {415,60,160,45},
	s_imagefocus_sensitivity_subb_xywh 	= {590,70,30,30},
	s_imagefocus_t_sensitivity_xywh 	= {620,60,160,45},
	s_imagefocus_sensitivity_add_xywh 	= {780,70,30,30},
	s_imagefocus_sensitivity_value_xywh = {815,70,40,30},
	s_imagefocus_cap_focusdistance_xywh = {415,120,160,45},
	s_imagefocus_t_focusdistance_xywh	= {590,120,160,45},	
	s_imagefocus_zoom_down_xywh 		= {590,70,30,30},
	s_imagefocus_t_zoom_xywh 			= {620,60,160,45},
	s_imagefocus_zoom_up_xywh 			= {780,70,30,30},
	s_imagefocus_nearfocus_xywh 		= {590,130,30,30},
	s_imagefocus_t_focus_xywh 			= {620,120,160,45},
	s_imagefocus_farfocus_xywh 			= {780,130,30,30},
	s_imagefocus_focus_once_xywh		= {590,180,160,45},
};

w1_page_imagefocus.s_1080p = 
{
	s_cfg_page_imagefocus_xywh 			= {100,515,1400,310},
	s_imagefocus_check1_xywh			= {60,0,50,50},
	s_imagefocus_cap_digitalzoom_xywh	= {110,0,200,50},
	s_imagefocus_hline_xywh 			= {610,0,2,240},
	s_imagefocus_cap_focusmode_xywh 	= {650,0,200,50},
	s_imagefocus_t_focusmode_xywh   	= {960,0,200,50},
	s_imagefocus_cap_sensitivity_xywh   = {650,60,200,50},
	s_imagefocus_sensitivity_subb_xywh 	= {960,70,30,30},
	s_imagefocus_t_sensitivity_xywh 	= {990,60,232,50},
	s_imagefocus_sensitivity_add_xywh 	= {1222,70,30,30},
	s_imagefocus_sensitivity_value_xywh = {1258,70,60,30},
	s_imagefocus_cap_focusdistance_xywh = {650,120,200,50},
	s_imagefocus_t_focusdistance_xywh	= {960,120,200,50},	
	s_imagefocus_zoom_down_xywh 		= {960,70,30,30},
	s_imagefocus_t_zoom_xywh 			= {990,60,232,50},
	s_imagefocus_zoom_up_xywh 			= {1222,70,30,30},
	s_imagefocus_nearfocus_xywh 		= {960,130,30,30},
	s_imagefocus_t_focus_xywh 			= {990,120,232,50},
	s_imagefocus_farfocus_xywh 			= {1222,130,30,30},
	s_imagefocus_focus_once_xywh		= {960,180,200,50},
};

w1_page_imagefocus.s_2k = 
{
	s_cfg_page_imagefocus_xywh 			= {133,686,1866,413},
	s_imagefocus_check1_xywh			= {80,0,67,67},
	s_imagefocus_cap_digitalzoom_xywh	= {147,0,267,67},
	s_imagefocus_hline_xywh 			= {813,0,3,320},
	s_imagefocus_cap_focusmode_xywh 	= {866,0,267,67},
	s_imagefocus_t_focusmode_xywh   	= {1280,0,267,67},
	s_imagefocus_cap_sensitivity_xywh   = {866,80,267,67},
	s_imagefocus_sensitivity_subb_xywh 	= {1280,93,40,40},
	s_imagefocus_t_sensitivity_xywh 	= {1320,80,309,67},
	s_imagefocus_sensitivity_add_xywh 	= {1629,93,40,40},
	s_imagefocus_sensitivity_value_xywh = {1677,93,80,40},
	s_imagefocus_cap_focusdistance_xywh = {866,160,267,67},
	s_imagefocus_t_focusdistance_xywh	= {1280,160,267,67},	
	s_imagefocus_zoom_down_xywh 		= {1280,93,40,40},
	s_imagefocus_t_zoom_xywh 			= {1320,80,309,67},
	s_imagefocus_zoom_up_xywh 			= {1629,93,40,40},
	s_imagefocus_nearfocus_xywh 		= {1280,173,40,40},
	s_imagefocus_t_focus_xywh 			= {1320,160,309,67},
	s_imagefocus_farfocus_xywh 			= {1629,173,40,40},
	s_imagefocus_focus_once_xywh		= {1280,240,267,67},
};

w1_page_imagefocus.s_4k = 
{
	s_cfg_page_imagefocus_xywh 			= {200,1030,2800,620},
	s_imagefocus_check1_xywh			= {120,0,100,100},
	s_imagefocus_cap_digitalzoom_xywh	= {220,0,400,100},
	s_imagefocus_hline_xywh 			= {1220,0,4,490},
	s_imagefocus_cap_focusmode_xywh 	= {1300,0,400,100},
	s_imagefocus_t_focusmode_xywh   	= {1920,0,400,100},
	s_imagefocus_cap_sensitivity_xywh   = {1300,120,400,100},
	s_imagefocus_sensitivity_subb_xywh 	= {1920,140,60,60},
	s_imagefocus_t_sensitivity_xywh 	= {1980,120,464,100},
	s_imagefocus_sensitivity_add_xywh 	= {2444,140,60,60},
	s_imagefocus_sensitivity_value_xywh = {2516,140,120,60},
	s_imagefocus_cap_focusdistance_xywh = {1300,240,400,100},
	s_imagefocus_t_focusdistance_xywh	= {1920,240,400,100},	
	s_imagefocus_zoom_down_xywh 		= {1920,140,60,60},
	s_imagefocus_t_zoom_xywh 			= {1980,120,464,100},
	s_imagefocus_zoom_up_xywh 			= {2444,140,60,60},
	s_imagefocus_nearfocus_xywh 		= {1920,260,60,60},
	s_imagefocus_t_focus_xywh 			= {1980,240,464,100},
	s_imagefocus_farfocus_xywh 			= {2444,260,60,60},
	s_imagefocus_focus_once_xywh		= {1920,360,400,100},
};

w1_page_imagefocus.clear_data=function ()
	w1_page_imagefocus.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imagefocus.wnd;
	local data = cfgdata.focus;

	
	local check1 = b_wnd_ex.get_check(top,cwnd.check1.id);
	if(-1 ~= data.zoom_enable)then
		if(true ==  check1)then
			data.zoom_enable = 1;
		else
			data.zoom_enable = 0;
		end
	end
	
	if(-1 ~= data.dn_autofocus)then
		if(true ==  check1)then
			data.dn_autofocus = 1;
		else
			data.dn_autofocus = 0;
		end
	end
	
	if(-1 ~= data.focus_mode)then
		data.focus_mode = b_wnd_ex.get_sel(top, cwnd.t_focusmode.id);
	end
	
	if(-1 ~= data.sensitivity)then
		data.sensitivity = b_wnd_ex.get_value(top, cwnd.t_sensitivity.id);
	end
	
	if(-1 ~= data.distance)then
		local distance_sel = b_wnd_ex.get_sel(top, cwnd.t_focusdistance.id);
		if(0 == distance_sel)then 	--Զ	
			data.distance = 0;	
		elseif(1 == distance_sel)then --10m	
			data.distance = 2;
		elseif(2 == distance_sel)then  --6m	
			data.distance = 3;
		elseif(3 == distance_sel)then --3m
			data.distance = 4;
		elseif(4 == distance_sel)then --2m	
			data.distance = 5;
		elseif(5 == distance_sel)then--1.5m
			data.distance = 6;
		else	
			data.distance = 0;	
		end
	end
	cfgdata.change_flag = 1;
	b_app_api.set_immediate_color(cfgdata);
	
	if(-1 ~= data.zoomout)then
		data.zoomout = 0;
	end
	if(-1 ~= data.zoomin)then
		data.zoomin = 0;
	end
	if(-1 ~= data.nearfocus)then
		data.nearfocus = 0;
	end
	if(-1 ~= data.farfocus)then
		data.farfocus = 0;
	end
	--[[if(-1 ~= data.autofocus)then
		data.autofocus = 0;
	end--]]
	
	return 0
end

local set_image_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), true);
	end
	local cwnd = w1_page_imagefocus.wnd;
	if(id == cwnd.t_sensitivity.id) then
		set_text(cwnd.sensitivity_value.id, value);
	end
	uitousercfg(top,w1_page_imagefocus.cfg_data)
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imagefocus.wnd;
		local opearid = nil;
		if(win_id == cwnd.sensitivity_subb.id) then
			opearid = cwnd.t_sensitivity.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > 0) then
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, true);
			set_image_value(top, opearid, value);
		end	
	end
	return 0
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_imagefocus.wnd;
		local value = b_wnd_ex.get_value(top, win_id);
		set_image_value(top, win_id, value);
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imagefocus.wnd;
		local opearid = nil;
		if(win_id == cwnd.sensitivity_add.id) then
			opearid = cwnd.t_sensitivity.id;	
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, true)
			set_image_value(top, opearid, value);
		end
	end
	return 0
end

local refresh_hide = function (top, mode, dn_autofocus, redraw)
	local cwnd = w1_page_imagefocus.wnd;
	if(-1 ~= dn_autofocus)then
		b_wnd_ex.set_hide(top, cwnd.cap_focusmode.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_focusmode.id, true, redraw)
		b_wnd_ex.set_hide(top,cwnd.cap_sensitivity.id,true,redraw)
		b_wnd_ex.set_hide(top,cwnd.sensitivity_subb.id,true,redraw)
		b_wnd_ex.set_hide(top,cwnd.t_sensitivity.id,true,redraw)
		b_wnd_ex.set_hide(top,cwnd.sensitivity_add.id,true,redraw)
		b_wnd_ex.set_hide(top,cwnd.sensitivity_value.id,true,redraw)
		b_wnd_ex.set_hide(top,cwnd.cap_focusdistance.id,true,redraw)
		b_wnd_ex.set_hide(top,cwnd.t_focusdistance.id,true,redraw)
		
		b_wnd_ex.set_hide(top,cwnd.zoom_down.id,false,redraw)
		b_wnd_ex.set_hide(top,cwnd.zoom.id,false,redraw)
		b_wnd_ex.set_hide(top,cwnd.zoom_up.id,false,redraw)
		b_wnd_ex.set_hide(top,cwnd.nearfocus.id,false,redraw)
		b_wnd_ex.set_hide(top,cwnd.focus.id,false,redraw)
		b_wnd_ex.set_hide(top,cwnd.farfocus.id,false,redraw)
		b_wnd_ex.set_hide(top,cwnd.focus_once.id,false,redraw)
			
		b_wnd_ex.set_hide(top, cwnd.focus_once.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.init.id, false,	redraw)
		
		local pos = SIZE('s_imagefocus_t_focusmode_xywh');
		b_wnd_ex.move_ex(top, cwnd.focus_once.id, pos, redraw);
		pos = SIZE('s_imagefocus_focus_once_xywh');
		b_wnd_ex.move_ex(top, cwnd.init.id, pos, redraw);
		b_wnd_ex.set_text(top,cwnd.cap_digitalzoom.id, STR('LA_DN_AUTO_FOCUS'),redraw)
		
	else
		
		b_wnd_ex.set_text(top,cwnd.cap_digitalzoom.id, STR('LA_DIGITAL_ZOOM'),	redraw)
		local pos = SIZE('s_imagefocus_focus_once_xywh');
		b_wnd_ex.move_ex(top, cwnd.focus_once.id, pos, redraw);
		b_wnd_ex.set_hide(top,	cwnd.init.id, true,	redraw)
		if(1 ~= mode)then
			b_wnd_ex.set_hide(top,cwnd.cap_sensitivity.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.sensitivity_subb.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.t_sensitivity.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.sensitivity_add.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.sensitivity_value.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.cap_focusdistance.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.t_focusdistance.id,false,redraw)
		else
			b_wnd_ex.set_hide(top,cwnd.cap_sensitivity.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.sensitivity_subb.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.t_sensitivity.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.sensitivity_add.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.sensitivity_value.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.cap_focusdistance.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.t_focusdistance.id,true,redraw)
		end
		
		if(1 == mode)then	
			b_wnd_ex.set_hide(top,cwnd.zoom_down.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.zoom.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.zoom_up.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.nearfocus.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.focus.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.farfocus.id,false,redraw)
			b_wnd_ex.set_hide(top,cwnd.focus_once.id,false,redraw)
		else
			b_wnd_ex.set_hide(top,cwnd.zoom_down.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.zoom.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.zoom_up.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.nearfocus.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.focus.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.farfocus.id,true,redraw)
			b_wnd_ex.set_hide(top,cwnd.focus_once.id,true,redraw)
		end
		
		if(-1 == mode)then
			b_wnd_ex.set_hide(top, cwnd.hline.id, true, redraw)
			b_wnd_ex.set_hide(top, cwnd.cap_focusmode.id, true, redraw)
			b_wnd_ex.set_hide(top, cwnd.t_focusmode.id, true, redraw)
		end
	end
	
end

local on_enable = function(top, win_id, vmsg, x, y)
	local cwnd = w1_page_imagefocus.wnd;
	if(b_ui.LBUTTONCLK == vmsg)then
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	return 0;
end

local on_mode = function(top, win_id, vmsg, x, y)
	local cwnd = w1_page_imagefocus.wnd;
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local focus = w1_page_imagefocus.cfg_data.focus
		local mode = b_wnd_ex.get_sel(top, cwnd.t_focusmode.id);
		refresh_hide(top, mode, focus.dn_autofocus, false)
		uitousercfg(top,w1_page_imagefocus.cfg_data)
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_focus_distance = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	return 0;
end

local on_zoom_down = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		w1_page_imagefocus.cfg_data.focus.zoomout = 1;
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	
	if b_ui.LBUTTONCLK == vmsg then
		w1_page_imagefocus.cfg_data.focus.zoomout = 0;
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	return 0;
end

local on_zoom_up = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		w1_page_imagefocus.cfg_data.focus.zoomin = 1;
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	if b_ui.LBUTTONCLK == vmsg then
		w1_page_imagefocus.cfg_data.focus.zoomin = 0;
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	return 0;
end

local on_nearfocus = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		w1_page_imagefocus.cfg_data.focus.nearfocus = 1;
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	if b_ui.LBUTTONCLK == vmsg then
		w1_page_imagefocus.cfg_data.focus.nearfocus = 0;
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	return 0;
end

local on_farfocus = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		w1_page_imagefocus.cfg_data.focus.farfocus = 1;
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	if b_ui.LBUTTONCLK == vmsg then
		w1_page_imagefocus.cfg_data.focus.farfocus = 0;
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	return 0;
end

local on_once_focus = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local data = w1_page_imagefocus.cfg_data.focus.autofocus;
		if(data > 127)then
			w1_page_imagefocus.cfg_data.focus.autofocus = 0;
		else
			w1_page_imagefocus.cfg_data.focus.autofocus = data + 1;
		end
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	return 0;
end

local on_init = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local data = w1_page_imagefocus.cfg_data.focus.init;
		if(data > 127)then
			w1_page_imagefocus.cfg_data.focus.init = 0;
		else
			w1_page_imagefocus.cfg_data.focus.init = data + 1;
		end
		uitousercfg(top,w1_page_imagefocus.cfg_data)
	end
	return 0;
end

w1_page_imagefocus.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_imagefocus.wnd;
	b_wnd_ex.set_hide(top, cwnd.check1.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_digitalzoom.id, bool_hide, redraw)

	b_wnd_ex.set_hide(top, cwnd.hline.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_focusmode.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_focusmode.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_focusdistance.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_focusdistance.id, bool_hide, redraw)
	if(bool_hide)then
		refresh_hide (top, -1, -1, redraw)
	end
end

w1_page_imagefocus.set_param = function(top, param, redraw)
	local cwnd = w1_page_imagefocus.wnd;
	local data = param.focus;
	refresh_hide(top,data.focus_mode, data.dn_autofocus, redraw) --ģʽԼ
	if(0 == data.zoom_enable)then
		b_wnd_ex.set_check(top,cwnd.check1.id,false,redraw);
	elseif(1 == data.zoom_enable)then
		b_wnd_ex.set_check(top,cwnd.check1.id,true,redraw);
	end	
	
	if(0 == data.dn_autofocus)then
		b_wnd_ex.set_check(top,cwnd.check1.id,false,redraw);
	elseif(1 == data.dn_autofocus)then
		b_wnd_ex.set_check(top,cwnd.check1.id,true,redraw);
	end
	if(-1 ~= data.focus_mode)then
		b_wnd_ex.set_sel(top, cwnd.t_focusmode.id, data.focus_mode, redraw);
	end
	
	if(-1 ~= data.sensitivity)then
		b_wnd_ex.set_value(top, cwnd.t_sensitivity.id, data.sensitivity, redraw);
		b_wnd_ex.set_text(top, cwnd.sensitivity_value.id, tostring(data.sensitivity), redraw);
	end
	
	if(-1 ~= data.distance)then
		local param = {
			STR('LA_INFINITY'), '10m','6m','3m','2m','1.5m'
		};
		b_wnd_ex.set_items(top, cwnd.t_focusdistance.id, param, false);
		if(0 == data.distance)then 		--Զ
			b_wnd_ex.set_sel(top, cwnd.t_focusdistance.id, 0, redraw);	
		elseif(2 == data.distance)then 	--10m
			b_wnd_ex.set_sel(top, cwnd.t_focusdistance.id, 1, redraw);
		elseif(3 == data.distance)then 	--6m
			b_wnd_ex.set_sel(top, cwnd.t_focusdistance.id, 2, redraw);
		elseif(4 == data.distance)then 	--3m
			b_wnd_ex.set_sel(top, cwnd.t_focusdistance.id, 3, redraw);
		elseif(5 == data.distance)then	--2m
			b_wnd_ex.set_sel(top, cwnd.t_focusdistance.id, 4, redraw);
		elseif(6 == data.distance)then	--1.5m
			b_wnd_ex.set_sel(top, cwnd.t_focusdistance.id, 5, redraw);
		else
			b_wnd_ex.set_sel(top, cwnd.t_focusdistance.id, 0, redraw);	
		end
		b_wnd_ex.dlg_direct_up(top, cwnd.t_focusdistance.id, true, false);
		--items={'Infinity','10m','6m','3m','2m','1.5m'},
		
	end
	
	
	w1_page_imagefocus.cfg_data = param
end

w1_page_imagefocus.get_param = function(top)
	local cwnd = w1_page_imagefocus.wnd;
	local param = {};
	local check1 = b_wnd_ex.get_check(top,cwnd.check1.id);
	if(true ==  check1)then
		param.zoom_enable = 1;
	else
		param.zoom_enable = 0;
	end
	
	param.focus_mode = b_wnd_ex.get_sel(top, cwnd.t_focusmode.id);
	param.sensitivity = b_wnd_ex.get_value(top, cwnd.t_sensitivity.id);
	param.distance = b_wnd_ex.get_sel(top, cwnd.t_focusdistance.id);	
	
	return param
end

w1_page_imagefocus.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imagefocus_xywh',
	--color_d	= {'c_cfgclose_bk', 'c_cfgclose_bk','c_cfgclose_bk'},	
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'check1','cap_digitalzoom','hline','cap_focusmode','t_focusmode',
			'cap_sensitivity','sensitivity_subb','t_sensitivity','sensitivity_add','sensitivity_value',
			'cap_focusdistance','t_focusdistance',
			'zoom_down','zoom','zoom_up',
			'nearfocus','focus','farfocus','focus_once','init'},
		
	check1 	= {t='check', 	id=id+1,xywh='s_imagefocus_check1_xywh',
				--	t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check_select','it_check_select','it_check_select_f', 'it_check_select_f'},
					cmd = on_enable},
	cap_digitalzoom = {t='static',id=id+2,xywh='s_imagefocus_cap_digitalzoom_xywh',text='LA_DIGITAL_ZOOM',font = 'f_image',
					},	

	hline 	= {t='hline',	id=id+3,xywh='s_imagefocus_hline_xywh'},		
	
	cap_focusmode = {t='static',id=id+4,xywh='s_imagefocus_cap_focusmode_xywh',text='LA_FOCUS_MODE',font = 'f_image',
					},	
	t_focusmode  	= {t='combox',id=id+5,xywh='s_imagefocus_t_focusmode_xywh',items={'LA_AUTO','LA_MANUAL','LA_SEMI_AUTOMATIC'},
					font = 'f_image',cmd = on_mode,
					},	
	--auto_sensitivity
	cap_sensitivity = {t='static',id=id+6,xywh='s_imagefocus_cap_sensitivity_xywh',text='LA_AUTO_FOCUS_SEN',font = 'f_image',
					},	
	sensitivity_subb	= {t='button',id=id+7,	xywh='s_imagefocus_sensitivity_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_sensitivity	= {t='hslider',id=id+8,	xywh='s_imagefocus_t_sensitivity_xywh',	
					font = 'f_slider', cmd=on_adj},
	sensitivity_add	= {t='button',id=id+9,	xywh='s_imagefocus_sensitivity_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	sensitivity_value	= {t='static',id=id+10,	xywh='s_imagefocus_sensitivity_value_xywh',trans = false,font = 'f_image'},

	cap_focusdistance = {t='static',id=id+11,xywh='s_imagefocus_cap_focusdistance_xywh',text='LA_LEAST_DISTANCE',font = 'f_image',
					},															--items={'over inf','10m','6m','3m','2m','1.5m'}				
	t_focusdistance  	= {t='combox',id=id+12,xywh='s_imagefocus_t_focusdistance_xywh',items={'Infinity','10m','6m','3m','2m','1.5m'},
					trans = false,font = 'f_image', cmd = on_focus_distance,
					},	
									
	--ZoomOut / ZoomIn
	zoom_down = {t='tt_button',id=id+13,xywh='s_imagefocus_zoom_down_xywh', cmd=on_zoom_down,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_reduce','it_reduce', 'it_reduce'},};
	zoom = {t='static',id=id+14,xywh='s_imagefocus_t_zoom_xywh',text = 'LA_ZOOM',align = b_ui.ALIGN.CENTER,font = 'f_image'};
	zoom_up = {t='tt_button',id=id+15,xywh='s_imagefocus_zoom_up_xywh', cmd=on_zoom_up,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_increase','it_increase_f', 'it_increase'}};
	
	--NearFocus / FarFocus
	nearfocus = {t='tt_button',id=id+16,xywh='s_imagefocus_nearfocus_xywh', cmd=on_nearfocus,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_reduce','it_reduce', 'it_reduce'},};
	focus = {t='static',id=id+17,xywh='s_imagefocus_t_focus_xywh',text = 'LA_FOCUS_T',align = b_ui.ALIGN.CENTER,font = 'f_image'};
	farfocus = {t='tt_button',id=id+18,xywh='s_imagefocus_farfocus_xywh', cmd=on_farfocus,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_increase','it_increase_f', 'it_increase'}};
				
	focus_once =  {t='button',id=id+19,	xywh = 's_imagefocus_focus_once_xywh', 	text='LA_AUTO_FOCUS_ONCE',font = 'f_image',cmd = on_once_focus},
	init =  {t='button',id=id+20,	xywh = 's_imagefocus_focus_once_xywh', 	text='LA_INIT',font = 'f_image',cmd = on_init},
}

return w1_page_imagefocus

