--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.noise_reduct_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_dlg 	= require("wnd.core.b_dlg")
local w1_page_imagenoise = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_imagenoise.s_768 =
{
	s_cfg_page_imagenoise_xywh = {53,366,746,220},
	s_imagenoise_check1_xywh = {29,0,26,35},
	s_imagenoise_cap_reduct1_xywh = {56,0,112,35},
	s_imagenoise_t_reduct1_xywh = {173,0,106,35},
	s_imagenoise_cap_strengh1_xywh = {32,42,106,35},
	s_imagenoise_strengh1_subb_xywh = {170,49,16,21},
	s_imagenoise_t_strengh1_xywh = {186,42,123,35},
	s_imagenoise_strengh1_add_xywh = {310,49,16,21},
	s_imagenoise_strengh1_value_xywh = {329,49,32,21},
	s_imagenoise_hline_xywh = {368,0,1,170},
	s_imagenoise_check2_xywh = {376,0,26,35},
	s_imagenoise_cap_reduct2_xywh = {402,0,112,35},
	s_imagenoise_t_reduct2_xywh = {520,0,106,35},
	s_imagenoise_cap_strengh2_xywh = {378,42,106,35},
	s_imagenoise_strengh2_subb_xywh = {517,49,16,21},
	s_imagenoise_t_strengh2_xywh = {533,42,123,35},
	s_imagenoise_strengh2_add_xywh = {657,49,16,21},
	s_imagenoise_strengh2_value_xywh = {676,49,32,21},
};

w1_page_imagenoise.s_1280 = 
{
	s_cfg_page_imagenoise_xywh 		= {60,475,920,310},
	s_imagenoise_check1_xywh		= {40,0,40,45},
	s_imagenoise_cap_reduct1_xywh	= {80,0,180,45},
	s_imagenoise_t_reduct1_xywh   	= {260,0,160,45},
	s_imagenoise_cap_strengh1_xywh	= {40,60,160,45},
	s_imagenoise_strengh1_subb_xywh = {220,70,30,30},
	s_imagenoise_t_strengh1_xywh 	= {250,60,160,45},
	s_imagenoise_strengh1_add_xywh 	= {410,70,30,30},
	s_imagenoise_strengh1_value_xywh= {445,70,40,30},
	s_imagenoise_hline_xywh 		= {495,0,1,240},
	s_imagenoise_check2_xywh 		= {501,0,40,45},
	s_imagenoise_cap_reduct2_xywh	= {541,0,170,45},
	s_imagenoise_t_reduct2_xywh    	= {715,0,160,45},
	s_imagenoise_cap_strengh2_xywh	= {505,60,160,45},
	s_imagenoise_strengh2_subb_xywh = {675,70,30,30},
	s_imagenoise_t_strengh2_xywh 	= {705,60,160,45},
	s_imagenoise_strengh2_add_xywh 	= {865,70,30,30},
	s_imagenoise_strengh2_value_xywh= {895,70,40,30},
};

w1_page_imagenoise.s_1440 = 
{
	s_cfg_page_imagenoise_xywh 		= {60,440,1000,245},
	s_imagenoise_check1_xywh		= {40,0,40,45},
	s_imagenoise_cap_reduct1_xywh	= {80,0,180,45},
	s_imagenoise_t_reduct1_xywh   	= {265,0,160,45},
	s_imagenoise_cap_strengh1_xywh	= {40,60,160,45},
	s_imagenoise_strengh1_subb_xywh = {220,70,30,30},
	s_imagenoise_t_strengh1_xywh 	= {250,60,160,45},
	s_imagenoise_strengh1_add_xywh 	= {410,70,30,30},
	s_imagenoise_strengh1_value_xywh= {445,70,40,30},
	s_imagenoise_hline_xywh 		= {500,0,1,240},
	s_imagenoise_check2_xywh 		= {510,0,40,45},
	s_imagenoise_cap_reduct2_xywh	= {550,0,180,45},
	s_imagenoise_t_reduct2_xywh    	= {720,0,160,45},
	s_imagenoise_cap_strengh2_xywh	= {510,60,160,45},
	s_imagenoise_strengh2_subb_xywh = {680,70,30,30},
	s_imagenoise_t_strengh2_xywh 	= {710,60,160,45},
	s_imagenoise_strengh2_add_xywh 	= {870,70,30,30},
	s_imagenoise_strengh2_value_xywh= {900,70,40,30},
};

w1_page_imagenoise.s_1080p = 
{
	s_cfg_page_imagenoise_xywh 		= {100,515,1400,310},
	s_imagenoise_check1_xywh		= {55,0,50,50},
	s_imagenoise_cap_reduct1_xywh	= {105,0,210,50},
	s_imagenoise_t_reduct1_xywh   	= {325,0,200,50},
	s_imagenoise_cap_strengh1_xywh	= {60,60,200,50},
	s_imagenoise_strengh1_subb_xywh = {320,70,30,30},
	s_imagenoise_t_strengh1_xywh 	= {350,60,232,50},
	s_imagenoise_strengh1_add_xywh 	= {582,70,30,30},
	s_imagenoise_strengh1_value_xywh= {618,70,60,30},
	s_imagenoise_hline_xywh 		= {690,0,2,240},
	s_imagenoise_check2_xywh 		= {705,0,50,50},
	s_imagenoise_cap_reduct2_xywh	= {755,0,210,50},
	s_imagenoise_t_reduct2_xywh    	= {975,0,200,50},
	s_imagenoise_cap_strengh2_xywh	= {710,60,200,50},
	s_imagenoise_strengh2_subb_xywh = {970,70,30,30},
	s_imagenoise_t_strengh2_xywh 	= {1000,60,232,50},
	s_imagenoise_strengh2_add_xywh 	= {1232,70,30,30},
	s_imagenoise_strengh2_value_xywh= {1268,70,60,30},

};

w1_page_imagenoise.s_2k = 
{
	s_cfg_page_imagenoise_xywh 		= {133,686,1866,413},
	s_imagenoise_check1_xywh		= {80,0,67,67},
	s_imagenoise_cap_reduct1_xywh	= {147,0,267,67},
	s_imagenoise_t_reduct1_xywh   	= {432,0,267,67},
	s_imagenoise_cap_strengh1_xywh	= {80,80,267,67},
	s_imagenoise_strengh1_subb_xywh = {427,93,40,40},
	s_imagenoise_t_strengh1_xywh 	= {467,80,309,67},
	s_imagenoise_strengh1_add_xywh 	= {776,93,40,40},
	s_imagenoise_strengh1_value_xywh= {824,93,80,40},
	s_imagenoise_hline_xywh 		= {920,0,3,320},
	s_imagenoise_check2_xywh 		= {940,0,67,67},
	s_imagenoise_cap_reduct2_xywh	= {1013,0,267,67},
	s_imagenoise_t_reduct2_xywh    	= {1293,0,267,67},
	s_imagenoise_cap_strengh2_xywh	= {950,80,267,67},
	s_imagenoise_strengh2_subb_xywh = {1291,93,40,40},
	s_imagenoise_t_strengh2_xywh 	= {1331,80,309,67},
	s_imagenoise_strengh2_add_xywh 	= {1640,93,40,40},
	s_imagenoise_strengh2_value_xywh= {1688,93,80,40},

};

w1_page_imagenoise.s_4k = 
{
	s_cfg_page_imagenoise_xywh 		= {200,1030,2800,620},
	s_imagenoise_check1_xywh		= {120,0,100,100},
	s_imagenoise_cap_reduct1_xywh	= {220,0,400,100},
	s_imagenoise_t_reduct1_xywh   	= {645,0,400,100},
	s_imagenoise_cap_strengh1_xywh	= {120,120,400,100},
	s_imagenoise_strengh1_subb_xywh = {640,140,60,60},
	s_imagenoise_t_strengh1_xywh 	= {700,120,464,100},
	s_imagenoise_strengh1_add_xywh 	= {1164,140,60,60},
	s_imagenoise_strengh1_value_xywh= {1236,140,120,60},
	s_imagenoise_hline_xywh 		= {1380,0,4,480},
	s_imagenoise_check2_xywh 		= {1420,0,100,100},
	s_imagenoise_cap_reduct2_xywh	= {1520,0,400,100},
	s_imagenoise_t_reduct2_xywh    	= {1945,0,400,100},
	s_imagenoise_cap_strengh2_xywh	= {1420,120,400,100},
	s_imagenoise_strengh2_subb_xywh = {1940,140,60,60},
	s_imagenoise_t_strengh2_xywh 	= {2000,120,464,100},
	s_imagenoise_strengh2_add_xywh 	= {2464,140,60,60},
	s_imagenoise_strengh2_value_xywh= {2536,140,120,60},
};

w1_page_imagenoise.clear_data=function ()
	w1_page_imagenoise.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imagenoise.wnd;
	local data = cfgdata.noise;

	local check1 = b_wnd_ex.get_check(top, cwnd.check1.id);
	local check2 = b_wnd_ex.get_check(top, cwnd.check2.id);
	local reduct1 = b_wnd_ex.get_sel(top, cwnd.t_reduct1.id);
	local reduct2 = b_wnd_ex.get_sel(top, cwnd.t_reduct2.id);
	local strengh1 = b_wnd_ex.get_value(top, cwnd.t_strengh1.id);
	local strengh2 = b_wnd_ex.get_value(top, cwnd.t_strengh2.id);
	if(-1 ~= data.d2_nr_enable )then
		if(true == check1)then
			data.d2_nr_enable = 1;
		else
			data.d2_nr_enable = 0;
		end
		data.d2_nr = reduct1 + 1;
		
		if(0 == reduct1)then
			data.d2_max_strength = strengh1;
		else
			data.d2_fix_strength = strengh1;
		end
	
	end
	if(-1 ~= data.d3_nr_enable)then
		if(true == check2)then
			data.d3_nr_enable = 1;
		else
			data.d3_nr_enable = 0;
		end
	end
	
--	data.d2_nr = reduct1 + 1;
	data.d3_nr = reduct2 + 1;
	--[[if(0 == reduct1)then
		data.d2_max_strength = strengh1;
	else
		data.d2_fix_strength = strengh1;
	end--]]
	if(0 == reduct2)then
		data.d3_max_strength = strengh2;
	else
		data.d3_fix_strength = strengh2;
	end
	cfgdata.change_flag = 1;
	b_app_api.set_immediate_color(cfgdata);
	return 0
end

local set_image_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), true);
	end
	local cwnd = w1_page_imagenoise.wnd;
	if(id == cwnd.t_strengh1.id) then
		set_text(cwnd.strengh1_value.id, value);
	elseif(id == cwnd.t_strengh2.id) then
		set_text(cwnd.strengh2_value.id, value);
	end
	uitousercfg(top,w1_page_imagenoise.cfg_data)
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imagenoise.wnd;
		local opearid = nil;
		if(win_id == cwnd.strengh1_subb.id) then
			opearid = cwnd.t_strengh1.id;
		elseif(win_id == cwnd.strengh2_subb.id) then
			opearid = cwnd.t_strengh2.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > 0) then
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, true);
			set_image_value(top, opearid, value);
		end	
	end
	return 0;
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_imagenoise.wnd;
		local value = b_wnd_ex.get_value(top, win_id);
		set_image_value(top, win_id, value);
	end
	return 0;
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imagenoise.wnd;
		local opearid = nil;
		if(win_id == cwnd.strengh1_add.id) then
			opearid = cwnd.t_strengh1.id;
		elseif(win_id == cwnd.strengh2_add.id) then
			opearid = cwnd.t_strengh2.id;	
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, true)
			set_image_value(top, opearid, value);
			
		end
	end
	return 0;
end

local on_enable1 = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		local cwnd = w1_page_imagenoise.wnd;
		uitousercfg(top,w1_page_imagenoise.cfg_data)
		local check1 = b_wnd_ex.get_check(top, cwnd.check1.id);
		if(check1 == true)then
			b_wnd_ex.set_disable(top, cwnd.t_reduct1.id,false,false);
			b_wnd_ex.set_disable(top, cwnd.cap_strengh1.id,false,false);
			b_wnd_ex.set_disable(top,cwnd.strengh1_subb.id,false,false);
			b_wnd_ex.set_disable(top,cwnd.t_strengh1.id,false,false);
			b_wnd_ex.set_disable(top,cwnd.strengh1_add.id,false,false);
			b_wnd_ex.set_disable(top,cwnd.strengh1_value.id,false,false);
		else
			b_wnd_ex.set_disable(top, cwnd.t_reduct1.id,true,false);
			b_wnd_ex.set_disable(top, cwnd.cap_strengh1.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.strengh1_subb.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.t_strengh1.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.strengh1_add.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.strengh1_value.id,true,false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_enable2 = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		local cwnd = w1_page_imagenoise.wnd;
		uitousercfg(top,w1_page_imagenoise.cfg_data)
		local check2 = b_wnd_ex.get_check(top, cwnd.check2.id);
		if(check2 == true)then
			b_wnd_ex.set_disable(top, cwnd.t_reduct2.id,false,false);
			b_wnd_ex.set_disable(top, cwnd.cap_strengh2.id,false,false);
			b_wnd_ex.set_disable(top,cwnd.strengh2_subb.id,false,false);
			b_wnd_ex.set_disable(top,cwnd.t_strengh2.id,false,false);
			b_wnd_ex.set_disable(top,cwnd.strengh2_add.id,false,false);
			b_wnd_ex.set_disable(top,cwnd.strengh2_value.id,false,false);
		else
			b_wnd_ex.set_disable(top, cwnd.t_reduct2.id,true,false);
			b_wnd_ex.set_disable(top, cwnd.cap_strengh2.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.strengh2_subb.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.t_strengh2.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.strengh2_add.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.strengh2_value.id,true,false);	
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_reduct1 = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_imagenoise.wnd;
		local data = w1_page_imagenoise.cfg_data.noise
		local reduct1 = b_wnd_ex.get_sel(top, cwnd.t_reduct1.id);
		if(0 == reduct1)then
			b_wnd_ex.set_text(top, cwnd.cap_strengh1.id, STR('LA_MAXIMUM_STRENGTH'), false);
			b_wnd_ex.set_value(top, cwnd.t_strengh1.id, data.d2_max_strength, false);
			b_wnd_ex.set_text(top, cwnd.strengh1_value.id, tostring(data.d2_max_strength), false);
		else
			b_wnd_ex.set_text(top, cwnd.cap_strengh1.id, STR('LA_FIXED_STRENGTH'), false);
			b_wnd_ex.set_value(top, cwnd.t_strengh1.id, data.d2_fix_strength, false);
			b_wnd_ex.set_text(top, cwnd.strengh1_value.id, tostring(data.d2_fix_strength), false);
		end
		uitousercfg(top,w1_page_imagenoise.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_reduct2 = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_imagenoise.wnd;
		local data = w1_page_imagenoise.cfg_data.noise
		local reduct2 = b_wnd_ex.get_sel(top, cwnd.t_reduct2.id);
		if(0 == reduct2)then
			b_wnd_ex.set_text(top, cwnd.cap_strengh2.id, STR('LA_MAXIMUM_STRENGTH'), false);
			b_wnd_ex.set_value(top, cwnd.t_strengh2.id, data.d3_max_strength, false);
			b_wnd_ex.set_text(top, cwnd.strengh2_value.id, tostring(data.d3_max_strength), false);
		elseif(1 == reduct2)then
			b_wnd_ex.set_text(top, cwnd.cap_strengh2.id, STR('LA_FIXED_STRENGTH'), false);
			b_wnd_ex.set_value(top, cwnd.t_strengh2.id, data.d3_fix_strength, false);
			b_wnd_ex.set_text(top, cwnd.strengh2_value.id, tostring(data.d3_fix_strength), false);
		end
		uitousercfg(top,w1_page_imagenoise.cfg_data)
	end
	b_dlg.dlg_set_redraw(top);
	return 0;
end

local refresh_hide = function(top, param, redraw)
	local cwnd = w1_page_imagenoise.wnd;
	if(-1 == param.d2_nr_enable)then
		b_wnd_ex.set_hide(top, cwnd.check1.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.cap_reduct1.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_reduct1.id, true, redraw)
		
		b_wnd_ex.set_hide(top, cwnd.cap_strengh1.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh1_subb.id, true, redraw)	
		b_wnd_ex.set_hide(top, cwnd.t_strengh1.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh1_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh1_value.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.hline.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.check1.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.cap_reduct1.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_reduct1.id, false, redraw)
		
		b_wnd_ex.set_hide(top, cwnd.cap_strengh1.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh1_subb.id, false, redraw)	
		b_wnd_ex.set_hide(top, cwnd.t_strengh1.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh1_add.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh1_value.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.hline.id, false, redraw)
		
	end
	if(-1 == param.d3_nr_enable)then
		b_wnd_ex.set_hide(top, cwnd.check2.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.cap_reduct2.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_reduct2.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.cap_strengh2.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh2_subb.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_strengh2.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh2_add.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh2_value.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.check2.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.cap_reduct2.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_reduct2.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.cap_strengh2.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh2_subb.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_strengh2.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh2_add.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.strengh2_value.id, false, redraw)
	end
	if(-1 == param.d2_nr_enable and -1 == param.d3_nr_enable)then
	--	b_wnd_ex.set_hide(top, cwnd.hline.id, true, redraw)
	end
	if(-1 == param.d2_nr_enable)then
		local pos = SIZE('s_imagenoise_check1_xywh');
		b_wnd_ex.move_ex(top, cwnd.check2.id, pos, redraw);
		pos = SIZE('s_imagenoise_cap_reduct1_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_reduct2.id, pos, redraw);
		pos = SIZE('s_imagenoise_t_reduct1_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_reduct2.id, pos, redraw);
		pos = SIZE('s_imagenoise_cap_strengh1_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_strengh2.id, pos, redraw);
		pos = SIZE('s_imagenoise_strengh1_subb_xywh');
		b_wnd_ex.move_ex(top, cwnd.strengh2_subb.id, pos, redraw);
		pos = SIZE('s_imagenoise_t_strengh1_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_strengh2.id, pos, redraw);
		pos = SIZE('s_imagenoise_strengh1_add_xywh');
		b_wnd_ex.move_ex(top, cwnd.strengh2_add.id, pos, redraw);
		pos = SIZE('s_imagenoise_strengh1_value_xywh');
		b_wnd_ex.move_ex(top, cwnd.strengh2_value.id, pos, redraw);	
	else
		local pos = SIZE('s_imagenoise_check2_xywh');
		b_wnd_ex.move_ex(top, cwnd.check2.id, pos, redraw);
		pos = SIZE('s_imagenoise_cap_reduct2_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_reduct2.id, pos, redraw);
		pos = SIZE('s_imagenoise_t_reduct2_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_reduct2.id, pos, redraw);
		pos = SIZE('s_imagenoise_cap_strengh2_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_strengh2.id, pos, redraw);
		pos = SIZE('s_imagenoise_strengh2_subb_xywh');
		b_wnd_ex.move_ex(top, cwnd.strengh2_subb.id, pos, redraw);
		pos = SIZE('s_imagenoise_t_strengh2_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_strengh2.id, pos, redraw);
		pos = SIZE('s_imagenoise_strengh2_add_xywh');
		b_wnd_ex.move_ex(top, cwnd.strengh2_add.id, pos, redraw);
		pos = SIZE('s_imagenoise_strengh2_value_xywh');
		b_wnd_ex.move_ex(top, cwnd.strengh2_value.id, pos, redraw);
	end
	
end

w1_page_imagenoise.sethide = function(top, bool_hide, redraw)
	local data = {};
	refresh_hide(top, data, redraw);
end

w1_page_imagenoise.set_param = function(top, param, redraw)
	local cwnd = w1_page_imagenoise.wnd;
	local data = param.noise; 
	refresh_hide(top, data, redraw);
	if(0 == data.d2_nr_enable)then
		b_wnd_ex.set_check(top, cwnd.check1.id,false,redraw);
		
		b_wnd_ex.set_disable(top, cwnd.t_reduct1.id,true,redraw);
		b_wnd_ex.set_disable(top, cwnd.cap_strengh1.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh1_subb.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_strengh1.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh1_add.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh1_value.id,true,redraw);
	elseif(1 == data.d2_nr_enable)then
		b_wnd_ex.set_check(top, cwnd.check1.id,true,redraw);
		
		b_wnd_ex.set_disable(top, cwnd.t_reduct1.id,false,redraw);
		b_wnd_ex.set_disable(top, cwnd.cap_strengh1.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh1_subb.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_strengh1.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh1_add.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh1_value.id,false,redraw);
	end
	
	if(-1 ~= data.d2_nr)then
		b_wnd_ex.set_sel(top, cwnd.t_reduct1.id, data.d2_nr - 1, redraw);
		if(1 == data.d2_nr)then
			b_wnd_ex.set_text(top, cwnd.cap_strengh1.id, STR('LA_MAXIMUM_STRENGTH'), redraw);
			b_wnd_ex.set_value(top, cwnd.t_strengh1.id, data.d2_max_strength, redraw);
			b_wnd_ex.set_text(top, cwnd.strengh1_value.id, tostring(data.d2_max_strength), redraw);
		elseif(2 == data.d2_nr)then
			b_wnd_ex.set_text(top, cwnd.cap_strengh1.id, STR('LA_FIXED_STRENGTH'), redraw);
			b_wnd_ex.set_value(top, cwnd.t_strengh1.id, data.d2_fix_strength, redraw);
			b_wnd_ex.set_text(top, cwnd.strengh1_value.id, tostring(data.d2_fix_strength), redraw);
		end
	end
	
	if(0 == data.d3_nr_enable)then
		b_wnd_ex.set_check(top, cwnd.check2.id,false,redraw);
		
		b_wnd_ex.set_disable(top, cwnd.t_reduct2.id,true,redraw);
		b_wnd_ex.set_disable(top, cwnd.cap_strengh2.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_subb.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_strengh2.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_add.id,true,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_value.id,true,redraw);
	else
		b_wnd_ex.set_check(top, cwnd.check2.id,true,redraw);
		
		b_wnd_ex.set_disable(top, cwnd.t_reduct2.id,false,redraw);
		b_wnd_ex.set_disable(top, cwnd.cap_strengh2.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_subb.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.t_strengh2.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_add.id,false,redraw);
		b_wnd_ex.set_disable(top,cwnd.strengh2_value.id,false,redraw);
	end
	if(1 == data.d3_nr)then
		b_wnd_ex.set_sel(top, cwnd.t_reduct2.id, data.d3_nr - 1, redraw);
		b_wnd_ex.set_text(top, cwnd.cap_strengh2.id, STR('LA_MAXIMUM_STRENGTH'), redraw);
		b_wnd_ex.set_value(top, cwnd.t_strengh2.id, data.d3_max_strength, redraw);
		b_wnd_ex.set_text(top, cwnd.strengh2_value.id, tostring(data.d3_max_strength), redraw);
	elseif(2 == data.d3_nr)then
		b_wnd_ex.set_sel(top, cwnd.t_reduct2.id, data.d3_nr - 1, redraw);
		b_wnd_ex.set_text(top, cwnd.cap_strengh2.id, STR('LA_FIXED_STRENGTH'), redraw);
		b_wnd_ex.set_value(top, cwnd.t_strengh2.id, data.d3_fix_strength, redraw);
		b_wnd_ex.set_text(top, cwnd.strengh2_value.id, tostring(data.d3_fix_strength), redraw);
	end
	if(0 == data.d3_nr or 0 == data.d2_nr)then
		print("---error--w1_page_imagenoise--set_param--data.d3_nr = "..data.d2_nr.."data.d3_nr = "..data.d3_nr);
	end
	w1_page_imagenoise.cfg_data = param	
end

w1_page_imagenoise.get_param = function(top)
	local cwnd = w1_page_imagenoise.wnd;
	local param = {};
	local check1 = b_wnd_ex.get_check(top, cwnd.check1.id);
	local check2 = b_wnd_ex.get_check(top, cwnd.check2.id);
	local reduct1 = b_wnd_ex.get_sel(top, cwnd.t_reduct1.id);
	local reduct2 = b_wnd_ex.get_sel(top, cwnd.t_reduct2.id);
	local strengh1 = b_wnd_ex.get_value(top, cwnd.t_strengh1.id);
	local strengh2 = b_wnd_ex.get_value(top, cwnd.t_strengh2.id);
	if(true == check1)then
		param.d2_nr_enable = 1;
	else
		param.d2_nr_enable = 0;
	end
	
	if(true == check2)then
		param.d3_nr_enable = 1;
	else
		param.d3_nr_enable = 0;
	end
	
	param.d2_nr = reduct1 + 1;
	param.d3_nr = reduct2 + 1;
	param.d2_max_strength = strengh1;
	param.d3_max_strength = strengh2;
	return param
end

w1_page_imagenoise.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imagenoise_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'check1','cap_reduct1','t_reduct1','cap_strengh1','strengh1_subb','t_strengh1',
			'strengh1_add','strengh1_value','hline','check2','cap_reduct2','t_reduct2',
			'cap_strengh2','strengh2_subb','t_strengh2','strengh2_add','strengh2_value'},
		
	check1 	= {t='check', 	id=id+1,xywh='s_imagenoise_check1_xywh',
				--	t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check_select','it_check_select','it_check_select_f', 'it_check_select_f'},
					cmd = on_enable1},
					
	cap_reduct1 = {t='static',id=id+3,xywh='s_imagenoise_cap_reduct1_xywh',text='LA_2D_REDUCTION', font = 'f_image',
					},	
	t_reduct1  	= {t='combox',id=id+4,xywh='s_imagenoise_t_reduct1_xywh',items={'LA_AUTO','LA_MANUAL'}, 
					font = 'f_image',cmd = on_reduct1,
					},						
					
	cap_strengh1= {t='static',id=id+5,	xywh='s_imagenoise_cap_strengh1_xywh',text='LA_MAXIMUM_STRENGTH', font = 'f_image'},
	strengh1_subb	= {t='button',id=id+6,	xywh='s_imagenoise_strengh1_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_strengh1	= {t='hslider',id=id+7,	xywh='s_imagenoise_t_strengh1_xywh',	
					font = 'f_slider', cmd=on_adj},
	strengh1_add	= {t='button',id=id+8,	xywh='s_imagenoise_strengh1_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	strengh1_value	= {t='static',id=id+9,	xywh='s_imagenoise_strengh1_value_xywh',text='',font = 'f_image',trans = false},
	
	hline 	= {t='hline',	id=id+10,xywh='s_imagenoise_hline_xywh'},	
	
	check2 	= {t='check', 	id=id+11,xywh='s_imagenoise_check2_xywh',
				--	t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check_select','it_check_select','it_check_select_f', 'it_check_select_f'},
					cmd = on_enable2},
	cap_reduct2 = {t='static',id=id+14,xywh='s_imagenoise_cap_reduct2_xywh',text = 'LA_3D_REDUCTION', font = 'f_image',
					},	
	t_reduct2  	= {t='combox',id=id+15,xywh='s_imagenoise_t_reduct2_xywh',items={'LA_AUTO','LA_MANUAL'}, 
					font = 'f_image',cmd = on_reduct2,
					},						
	cap_strengh2= {t='static',id=id+16,	xywh='s_imagenoise_cap_strengh2_xywh',text='LA_MAXIMUM_STRENGTH', font = 'f_image'},
	strengh2_subb	= {t='button',id=id+17,	xywh='s_imagenoise_strengh2_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_strengh2	= {t='hslider',id=id+18,	xywh='s_imagenoise_t_strengh2_xywh',	
					font = 'f_slider', cmd=on_adj},
	strengh2_add	= {t='button',id=id+19,	xywh='s_imagenoise_strengh2_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	strengh2_value	= {t='static',id=id+20,	xywh='s_imagenoise_strengh2_value_xywh',text='',font = 'f_image',trans = false},
					
}

return w1_page_imagenoise

