--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_motion.area_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local b_dlg 		= require("wnd.core.b_dlg")
local r_str 	= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_motionarea = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}


--ע˴s_cfg_marea_img_xywh
--cx222߿,Ҳͬʱ4
--cy182߿,Ҳͬʱ4
--1280,1440,1920,2Kı߿ֵΪ1,,4Kı߿ֵΪ2

--ӽŴҪxcx 32
--1280,1440,1920,2Kı߿ֵΪ1cx=22*m+2=32*neg:640, 288
w1_page_motionarea.s_768 =
{
	s_cfg_page_motionarea_xywh = {53,213,480,412},
	s_cfg_marea_img_xywh = {17,9,288,272},
	s_motionarea_cap_sen_xywh = {323,10,106,35},
	s_motionarea_t_sen_xywh = {456,10,106,28},
	s_cfg_marea_cap_audio_dec_xywh = {323,45,117,35},
	s_cfg_marea_t_audio_dec_xywh = {452,48,25,21},
	s_cfg_marea_cap_sound_file_xywh = {323,80,117,35},
	s_cfg_marea_t_sound_file_xywh = {456,80,117,28},
	s_cfg_marea_cap_flashlight_xywh = {323,115,117,35},
	s_cfg_marea_t_flashlight_xywh = {452,119,25,21},	
};

w1_page_motionarea.s_1280 = 
{
	s_cfg_page_motionarea_xywh = {100,300,920,500},
	s_cfg_marea_img_xywh 			= {24,12,448,416},
	s_motionarea_cap_sen_xywh 		= {500,10,200,50},
	s_motionarea_t_sen_xywh 		= {720,10,160,40},	
	s_cfg_marea_cap_audio_dec_xywh 	= {500,60, 210, 50},	
	s_cfg_marea_t_audio_dec_xywh 	= {713,70, 48,  30},	
	s_cfg_marea_cap_sound_file_xywh = {500,110, 200, 50},	
	s_cfg_marea_t_sound_file_xywh 	= {720,110, 160, 40},	
	s_cfg_marea_cap_flashlight_xywh = {500,160, 200, 50},	
	s_cfg_marea_t_flashlight_xywh 	= {713,170, 48, 30},	
};

w1_page_motionarea.s_1440 = 
{
	s_cfg_page_motionarea_xywh = {100,275,1040,425},
	s_cfg_marea_img_xywh = {12,10,640,362},
	s_motionarea_cap_sen_xywh 		= {660,10,200,50},
	s_motionarea_t_sen_xywh 		= {880,10,160,40},	
	s_cfg_marea_cap_audio_dec_xywh 	= {660,60, 200, 50},	
	s_cfg_marea_t_audio_dec_xywh 	= {872,70, 48,  30},	
	s_cfg_marea_cap_sound_file_xywh = {660,110, 200, 50},	
	s_cfg_marea_t_sound_file_xywh 	= {880,110, 160, 40},	
	s_cfg_marea_cap_flashlight_xywh = {660,160, 200, 50},	
	s_cfg_marea_t_flashlight_xywh 	= {872,170, 48, 30},	
};

w1_page_motionarea.s_1080p = 
{
	s_cfg_page_motionarea_xywh 		= {100,300,900,580},
	s_cfg_marea_img_xywh 			= {30,10,640,416},
	s_motionarea_cap_sen_xywh 		= {700,	10,220,50},
	s_motionarea_t_sen_xywh 		= {950,	10,220,40},
	s_cfg_marea_cap_audio_dec_xywh 	= {700, 60, 220, 50},	
	s_cfg_marea_t_audio_dec_xywh 	= {943, 70, 48,  30},	
	s_cfg_marea_cap_sound_file_xywh = {700, 110, 220, 50},	
	s_cfg_marea_t_sound_file_xywh 	= {950, 110, 220, 40},	
	s_cfg_marea_cap_flashlight_xywh = {700, 160, 220, 50},	
	s_cfg_marea_t_flashlight_xywh 	= {943, 170, 48, 30},	
};

w1_page_motionarea.s_2k = 
{
	s_cfg_page_motionarea_xywh = {133,399,1199,773},
	s_cfg_marea_img_xywh = {16,13,948,560},
	s_motionarea_cap_sen_xywh = {933,13,266,66},
	s_motionarea_t_sen_xywh = {1266,13,266,53},
	s_cfg_marea_cap_audio_dec_xywh = {933,79,293,66},
	s_cfg_marea_t_audio_dec_xywh = {1257,93,63,39},
	s_cfg_marea_cap_sound_file_xywh = {933,146,293,66},
	s_cfg_marea_t_sound_file_xywh = {1266,146,293,53},
	s_cfg_marea_cap_flashlight_xywh = {933,213,293,66},
	s_cfg_marea_t_flashlight_xywh = {1257,226,63,39},	
};

w1_page_motionarea.s_4k = 
{
	s_cfg_page_motionarea_xywh		= {200,600,1800,1160},
	s_cfg_marea_img_xywh 			= {60,20,1280,832},
	s_motionarea_cap_sen_xywh 		= {1400, 20,440,100},
	s_motionarea_t_sen_xywh 		= {1900, 20,440,80},
	s_cfg_marea_cap_audio_dec_xywh 	= {1400, 120, 440, 100},	
	s_cfg_marea_t_audio_dec_xywh 	= {1886, 140, 96,  60},	
	s_cfg_marea_cap_sound_file_xywh = {1400, 220, 440, 100},	
	s_cfg_marea_t_sound_file_xywh 	= {1900, 220, 440, 80},	
	s_cfg_marea_cap_flashlight_xywh = {1400, 320, 440, 100},	
	s_cfg_marea_t_flashlight_xywh 	= {1886, 340, 96, 60},	
};

w1_page_motionarea.clear_data = function ()
	w1_page_motionarea.cfg_data =nil;
end

local update_layout = function(top, redraw)
	local cwnd = w1_page_motionarea.wnd;
	local enable = b_wnd_ex.get_check(top, cwnd.t_enable_audio.id);
	local move_h = SIZE('s_cfg_marea_cap_audio_dec_xywh')[2] -  SIZE('s_motionarea_cap_sen_xywh')[2]
	
	if (enable) then
		b_wnd_ex.set_hide(top, cwnd.cap_sound_cbox.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_sound_cbox.id, false, false);
		move_h = 0;
	else
		b_wnd_ex.set_hide(top, cwnd.cap_sound_cbox.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_sound_cbox.id, true, false);
	end	
	
	local pos1 = SIZE('s_cfg_marea_cap_flashlight_xywh')
	b_wnd_ex.move_pos(top, cwnd.cap_enable_flshlight.id, {pos1[1], pos1[2] - move_h}, false);	
	local pos2 = SIZE('s_cfg_marea_t_flashlight_xywh')
	b_wnd_ex.move_pos(top, cwnd.t_enable_flshlight.id, {pos2[1], pos2[2] - move_h}, false);		
	
	if (redraw) then
		b_dlg.dlg_set_redraw(top);
	end
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_motionarea.wnd;
	local area = cfgdata.area
	area.cell = {};
	area.cell = b_wnd_ex.get_marea(top, cwnd.image.id)
	local comboxidx = b_wnd_ex.get_sel(top, cwnd.t_sen.id);
	area.sensitivity = comboxidx + 1;
	
	if (area.AudioAction_enable == true) then
		area.audio_type = area.AudioAction_min + b_wnd_ex.get_sel(top,cwnd.t_sound_cbox.id);	
		area.audio_enable = b_wnd_ex.get_check(top,cwnd.t_enable_audio.id);
	end	
	
	if (area.LEDAction_enable == true) then
		area.led_enable = b_wnd_ex.get_check(top,cwnd.t_enable_flshlight.id);
	end
	
	cfgdata.change_flag = true;
end

w1_page_motionarea.setmareaparam = function(top, param, redraw)
	local area = param.area
	local cwnd = w1_page_motionarea.wnd;
	b_wnd_ex.set_marea(top, cwnd.image.id, area.cell, redraw);
	assert(area.sensitivity >=1 and area.sensitivity <=4)
	b_wnd_ex.set_sel(top, cwnd.t_sen.id, area.sensitivity - 1, redraw);
	w1_page_motionarea.cfg_data = param;
	if (area.AudioAction_enable == true) then
		local param = {};
		for i=area.AudioAction_min+1,area.AudioAction_max+1 do
			param[i] = STR('LA_AUDIO') .. tostring(i-1);
		end
		b_wnd_ex.set_items(top, cwnd.t_sound_cbox.id, param, false);
	end
	b_wnd_ex.set_check(top,cwnd.t_enable_audio.id,area.audio_enable,false);
	b_wnd_ex.set_sel(top, cwnd.t_sound_cbox.id, area.audio_type - area.AudioAction_min, false);	
	b_wnd_ex.set_check(top,cwnd.t_enable_flshlight.id,area.led_enable,false);
	
	if (area.AudioAction_enable == true) then
		b_wnd_ex.set_hide(top,cwnd.cap_enable_audio.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_audio.id,false,false);			
		b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,false,false);			

		update_layout(top, false);
	else
		b_wnd_ex.set_hide(top,cwnd.cap_enable_audio.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_audio.id,true,false);			
		b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,true,false);		

		local move_h = SIZE('s_cfg_marea_cap_audio_dec_xywh')[2] -  SIZE('s_motionarea_cap_sen_xywh')[2]
		local pos1 = SIZE('s_cfg_marea_cap_flashlight_xywh')
		b_wnd_ex.move_pos(top, cwnd.cap_enable_flshlight.id, {pos1[1], pos1[2] - 2 * move_h}, false);	
		local pos2 = SIZE('s_cfg_marea_t_flashlight_xywh')
		b_wnd_ex.move_pos(top, cwnd.t_enable_flshlight.id, {pos2[1], pos2[2] - 2 * move_h}, false);			
	end
	
	if (area.LEDAction_enable == true) then
		b_wnd_ex.set_hide(top,cwnd.cap_enable_flshlight.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_flshlight.id,false,false);			
	else
		b_wnd_ex.set_hide(top,cwnd.cap_enable_flshlight.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_flshlight.id,true,false);			
	end
	
end

w1_page_motionarea.getmareaparam = function(top)
	local cwnd = w1_page_motionarea.wnd;
	local param = {};
	param.cell = {};
	param.cell = b_wnd_ex.get_marea(top, cwnd.image.id)
	local comboxidx = b_wnd_ex.get_sel(top, cwnd.t_sen.id);
	param.sensitivity = comboxidx + 1;
	
	local area = w1_page_motionarea.cfg_data.area
	if (area.AudioAction_enable == true) then
		param.audio_type = area.AudioAction_min + b_wnd_ex.get_sel(top,cwnd.t_sound_cbox.id);	
		param.audio_enable = b_wnd_ex.get_check(top,cwnd.t_enable_audio.id);
	end	
	
	if (area.LEDAction_enable == true) then
		param.led_enable = b_wnd_ex.get_check(top,cwnd.t_enable_flshlight.id);
	end
	
	return param;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg or b_ui.LBUTTONCLK == vmsg) then
		uitousercfg(top,w1_page_motionarea.cfg_data)
	end
	
	return 0
end

local on_sen = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		uitousercfg(top,w1_page_motionarea.cfg_data)
	end
	return 0
end

local on_enable_audio = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		update_layout(top, true);
		uitousercfg(top,w1_page_motionarea.cfg_data)
	end
	return 0
end

w1_page_motionarea.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_motionarea.wnd;
	local s_id = cwnd.image.id;
	local e_id = cwnd.t_enable_flshlight.id	
	for i = s_id, e_id do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end	
	
	return 0;
end

w1_page_motionarea.setdispch = function(top, idx)
	local param = {
		chn_id = idx,
		wnd_id = 1,
	}
	local layoutpos = w1_page_motionarea.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param);
	
	return 0;
end

w1_page_motionarea.set_sen_direct_up = function(top, direct_up, redraw)
	local cwnd = w1_page_motionarea.wnd;
	b_wnd_ex.dlg_direct_up(top, cwnd.t_sen.id, direct_up, redraw);
	return 0;
end

w1_page_motionarea.set_motion = function(top, motion, redraw)
	local cwnd = w1_page_motionarea.wnd;
	b_wnd_ex.set_motion(top, cwnd.image.id, motion, redraw);
	return 0;
end

w1_page_motionarea.on_pre_show = function(top)
	local cwnd = w1_page_motionarea.wnd;
	local param = {
		x = SIZE('s_cfg_marea_img_xywh')[1] + SIZE('s_cfg_page_motionarea_xywh')[1]+ SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_cfg_marea_img_xywh')[2] + SIZE('s_cfg_page_motionarea_xywh')[2]+ SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_cfg_marea_img_xywh')[3],
		cy = SIZE('s_cfg_marea_img_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_motionarea.layoutpos.x = param.x;
	w1_page_motionarea.layoutpos.cx = param.cx;
	w1_page_motionarea.layoutpos.y = param.y;
	w1_page_motionarea.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_cfg_marea_img_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_cfg_marea_img_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
end

w1_page_motionarea.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_motionarea_xywh',	
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'image','cap_sen', 't_sen', 'cap_enable_audio', 't_enable_audio', 'cap_sound_cbox', 't_sound_cbox', 'cap_enable_flshlight', 't_enable_flshlight'},
		
	image 	= {t='motionarea',id=id+1,xywh='s_cfg_marea_img_xywh',text='image weight',trans = false,
				color= {'c_image_bk', 'c_cfg_row_bk', 'c_txt_n'},cmd = on_update_param},
	cap_sen = {t='static',id=id+2,xywh='s_motionarea_cap_sen_xywh',
					text='LA_SENSITIVITY',font = 'f_grade4',
					},	
	t_sen 	= {t='combox',id=id+3,xywh='s_motionarea_t_sen_xywh',items = {'LA_LOW_T','LA_MEDIUM_T','LA_HIGH_T','LA_HIGHEST'},
					font = 'f_grade4',cmd = on_sen,
					},	

	cap_enable_audio 	= {t='static',id=id+4,	xywh='s_cfg_marea_cap_audio_dec_xywh',	text='LA_AUDIO_DEC_ALARM'},
	t_enable_audio 		= {t='tt_check', id=id+5,xywh='s_cfg_marea_t_audio_dec_xywh',			
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable_audio},
	
	cap_sound_cbox	= {t='static',id=id+6,	xywh='s_cfg_marea_cap_sound_file_xywh',	text='LA_SOUND_ALARM_FILE'},
	t_sound_cbox 	= {t='combox',id=id+7,	xywh='s_cfg_marea_t_sound_file_xywh',	items={},trans = false,cmd=on_update_param},	
	
	cap_enable_flshlight 	= {t='static',id=id+8,	xywh='s_cfg_marea_cap_flashlight_xywh',	text='LA_FLASHLIGHT_ALARM'},
	t_enable_flshlight 	= {t='tt_check', id=id+9,xywh='s_cfg_marea_t_flashlight_xywh',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},

}

return w1_page_motionarea

