--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_noopsyche.noopsyche_badsignal_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 

local w1_row_noopsycherow_badsignal 		= require("wnd.w1_cfg.w1_row_noopsycherow_badsignal")
local w1_page_noopsycheevent_badsignal 	= require("wnd.w1_cfg.w1_page_noopsycheevent_badsignal")
local w1_page_noopsychearea_badsignal 	= require("wnd.w1_cfg.w1_page_noopsychearea_badsignal")
local w1_page_noopsychetimeplan_badsignal = require("wnd.w1_cfg.w1_page_noopsychetimeplan_badsignal")

local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_color		= require("wnd.core.r_res.r_color")
local COLOR 		= r_color.get_color
local w1_page_noopsyche_badsignal = 
{
	channel = 0,
	old_sel = 0,
	data,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_noopsyche_badsignal.s_768 =
{
};

w1_page_noopsyche_badsignal.s_1280 = 
{

}

w1_page_noopsyche_badsignal.s_1440 = 
{

}

w1_page_noopsyche_badsignal.s_1080p = 
{

}

w1_page_noopsyche_badsignal.s_2k = 
{

}

w1_page_noopsyche_badsignal.s_4k = 
{

}

local channel_num;--豸ͨĿ

w1_page_noopsyche_badsignal.clear_data = function()
	w1_page_noopsyche_badsignal.data = nil;
	w1_page_noopsyche_badsignal.copy_ch = nil;
end	

local refresh_chdata = function(top, chid, redraw)
	local c_wnd = w1_page_noopsyche_badsignal.wnd
	local channeldata = w1_page_noopsyche_badsignal.data.badsignal['channel'..chid]
	local channelcapdata = w1_page_noopsyche_badsignal.data.badsignal_cap['channel'..chid]
	local ro_num = w1_page_noopsyche_badsignal.data.device_info['ro_num']
	local buzz_support = w1_page_noopsyche_badsignal.data.device_info['buzzer_support']
	b_wnd_ex.set_check(top, c_wnd.t_enable.id, channeldata.enable, redraw);
	local checkidx = w1_row_noopsycherow_badsignal.get_checkidx(top);
	if(checkidx == 0) then
		w1_page_noopsycheevent_badsignal.setstatus(top, channeldata, chid, ro_num, buzz_support, redraw)
		w1_page_noopsychearea_badsignal.setcapdata(top,channelcapdata,false);
		w1_page_noopsychearea_badsignal.setmareaparam(top, channeldata, false)
		w1_page_noopsychetimeplan_badsignal.settimeplan(top, channeldata, false);
	elseif (checkidx == 1) then
		w1_page_noopsycheevent_badsignal.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_noopsychearea_badsignal.setcapdata(top,channelcapdata,true);
		w1_page_noopsychearea_badsignal.setmareaparam(top, channeldata, true)
		w1_page_noopsychetimeplan_badsignal.settimeplan(top, channeldata, false);
	else
		w1_page_noopsycheevent_badsignal.setstatus(top, channeldata, chid, ro_num, buzz_support, false)		
		w1_page_noopsychearea_badsignal.setcapdata(top,channelcapdata,false);
		w1_page_noopsychearea_badsignal.setmareaparam(top, channeldata, false)
		w1_page_noopsychetimeplan_badsignal.settimeplan(top, channeldata, redraw);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)	
	assert(type(cfgdata) == 'table')
	w1_page_noopsyche_badsignal.data = cfgdata;
	
	local c_wnd = w1_page_noopsyche_badsignal.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	w1_page_noopsyche_badsignal.old_sel = 0
	for i=1, channel_num do
		if(cfgdata['badsignal']['channel'..i] ~= nil and ch_prilist[i] == 1 and cfgdata['badsignal_cap']['channel'..i] ~= nil 
			and cfgdata['badsignal_cap']['channel'..i].SignalBadAbility_enable == true) then
			camreaitems[idx] = i;
			if w1_page_noopsyche_badsignal.channel == i then
				w1_page_noopsyche_badsignal.old_sel = idx-1
			end
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id, false, false)
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, w1_page_noopsyche_badsignal.old_sel, false);--Ĭһ
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));		
		w1_page_noopsyche_badsignal.channel = chid
		if cfgdata['badsignal_cap']['channel'..chid] ~= nil and cfgdata['badsignal_cap']['channel'..chid].SignalBadAbility_enable == true then -- 
			b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, false, false)
			b_wnd_ex.set_hide(top, c_wnd.t_enable.id, false, false)
			b_wnd_ex.set_hide(top, w1_id.cfg_noopsyche.noopsycheprow_badsignal_id, false, false)
			w1_page_noopsycheevent_badsignal.sethide(top, false, false)
			w1_page_noopsychetimeplan_badsignal.sethide(top, false, false)
			w1_page_noopsychearea_badsignal.sethide(top, false, false)
			w1_page_noopsychearea_badsignal.setdispch(top, chid);
			refresh_chdata(top, chid, false);
		else
			b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, true, false)
			b_wnd_ex.set_hide(top, c_wnd.t_enable.id, true, false)
			b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_badsignal_id, 	true, false)
			w1_page_noopsycheevent_badsignal.sethide(top, true, false)
			w1_page_noopsychetimeplan_badsignal.sethide(top, true, false)
			w1_page_noopsychetimeplan_badsignal.sethide(top, true, false)
			b_wnd_ex.set_text(top,c_wnd.tipinfo.id,STR('LA_RAID_NOT_SUPPORT'),false);
			b_wnd_ex.set_color(top,c_wnd.tipinfo.id,
			{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_hint_err_text')},false);
		end
	else--ͨ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,true, false)
		b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, true, false)
		b_wnd_ex.set_hide(top, c_wnd.t_enable.id, true, false)
		b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_badsignal_id, 	true, false)
		w1_page_noopsycheevent_badsignal.sethide(top, true, false)
		w1_page_noopsychetimeplan_badsignal.sethide(top, true, false)
		w1_page_noopsychetimeplan_badsignal.sethide(top, true, false)
	end
	
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_noopsyche_badsignal.timer_start = function()
	w1_page_noopsyche_badsignal.timestart = true
end

w1_page_noopsyche_badsignal.timer_stop = function(top)
	w1_page_noopsyche_badsignal.timestart = false
	w1_wnd_util.tipclear(top, w1_page_noopsyche_badsignal.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_noopsyche_badsignal.timerenevt = function(top)
	if(w1_page_noopsyche_badsignal.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_noopsyche_badsignal.wnd.tipinfo.id)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_noopsyche_badsignal.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id))
	if(chid == nil) then
		return 0
	end
	
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	local data = cfgdata.badsignal['channel'..chid]
	data.enable = enable;
	data.change_flag = true;
	
	return 0
end

w1_page_noopsyche_badsignal.pageinit = function(top)

	return 0
end

w1_page_noopsyche_badsignal.on_data_change = function(top)
	if w1_row_noopsycherow_badsignal.get_checkidx(top)==0 then
		w1_page_noopsycheevent_badsignal.on_channel_check(top);
	end
end

w1_page_noopsyche_badsignal.init= function(top)
	local c_wnd = w1_page_noopsyche_badsignal.wnd
	
	w1_wnd_util.cfgtab = {'badsignal','badsignal_cap','device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local chidstr = b_wnd_ex.get_text(top, c_wnd.t_channel.id);
	if(chidstr == '') then
		w1_page_noopsychearea_badsignal.setdispch(top, 1);
		return 0
	end
	return 0
end

w1_page_noopsyche_badsignal.set_channel = function(chn)
	w1_page_noopsyche_badsignal.channel = chn;
end

w1_page_noopsyche_badsignal.get_channel = function()
	return w1_page_noopsyche_badsignal.channel;
end

local on_channel = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_noopsyche_badsignal.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		local old_chid = w1_page_noopsyche_badsignal.channel
		b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);
		if(old_chid ~= chid) then
			if w1_page_noopsyche_badsignal.data['badsignal_cap']['channel'..chid] ~= nil 
				and w1_page_noopsyche_badsignal.data['badsignal_cap']['channel'..chid].SignalBadAbility_enable == true then -- 
				b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, false, false)
				b_wnd_ex.set_hide(top, c_wnd.t_enable.id, false, false)
				b_wnd_ex.set_hide(top, w1_id.cfg_noopsyche.noopsycheprow_badsignal_id, false, false)
				w1_page_noopsycheevent_badsignal.sethide(top, false, false)
				w1_page_noopsychetimeplan_badsignal.sethide(top, false, false)
				w1_page_noopsychearea_badsignal.sethide(top, false, false)
				w1_page_noopsychearea_badsignal.setdispch(top, chid);
				refresh_chdata(top, chid, false);
			else
				b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, true, false)
				b_wnd_ex.set_hide(top, c_wnd.t_enable.id, true, false)
				b_wnd_ex.set_hide(top,  w1_id.cfg_noopsyche.noopsycheprow_badsignal_id, true, false)
				w1_page_noopsycheevent_badsignal.sethide(top, true, false)
				w1_page_noopsychetimeplan_badsignal.sethide(top, true, false)
				w1_page_noopsychetimeplan_badsignal.sethide(top, true, false)
				w1_page_noopsychearea_badsignal.sethide(top, true, false)
				b_wnd_ex.set_text(top,c_wnd.tipinfo.id,STR('LA_RAID_NOT_SUPPORT'),false);	
				b_wnd_ex.set_color(top,c_wnd.tipinfo.id,
				{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_hint_err_text')},false);
			end
			w1_page_noopsyche_badsignal.channel = chid;
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.insight ~= 0) then--޸ʧ
		w1_wnd_util.setparamerr_str(STR('LA_APPLY_FAIL'));
		--¶ȡԭʼ
		b_app_cfg.origin_init(w1_wnd_util.cfgtab);
		return false, nil;
	end
	return true, nil;
end

local copy_okfunc = function(param)
	local cwnd = w1_page_noopsyche_badsignal.wnd;
	local chid = tonumber(b_wnd_ex.get_text(param[1], cwnd.t_channel.id));
	if(chid == nil) then
		return 0;
	end

	local chsrc = w1_page_noopsyche_badsignal.data.badsignal['channel'..chid];
	local chdir = w1_page_noopsyche_badsignal.data.badsignal;
	
	for i=1, #param[2] do
		if(chdir['channel'..param[2][i]] == nil) then
			chdir['channel'..param[2][i]] = util.copy_tab(chsrc)
		else
			util.copy_tab_b(chdir['channel'..param[2][i]], chsrc)
		end	
		chdir['channel'..param[2][i]].change_flag = true;	
		chdir['channel'..param[2][i]].channel_id = param[2][i];
	end
	
	--Դֻͨһ.Ҹͨŵͨid,
	--ĬϸƵͨ
	if(#param[2] > 0) then	
		if(#chsrc.linkage.trigger_ch == 1 and 
			chsrc.linkage.trigger_ch[1] == chsrc.channel_id) then
			
			for i=1, #param[2] do
				chdir['channel'..param[2][i]].linkage.trigger_ch = nil;
				chdir['channel'..param[2][i]].linkage.trigger_ch = {param[2][i]};
			end	
		end
	end
	
	return 0;
end

local on_copy = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_noopsyche_badsignal.wnd;
		local param = {};
		local idx = 1;
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
		local ret, errstr = uidatacheck(top)
		if ret == false then
			return 0;
		end
		
		local privilege = global_val.get_allprivilege();--ȡȨ
		local ch_prilist = privilege.channel_manager_list;	
		for i=1, channel_num do
			if( i ~= chid and w1_page_noopsyche_badsignal.data.badsignal['channel'..i] ~= nil
				 and ch_prilist[i] == 1) then
				param[idx] = i;
				idx =idx + 1;
			end
		end
		w1_copy.init();
		w1_copy.set_dlgattr(param);
		w1_copy.set_func (copy_okfunc,{top, w1_page_noopsyche_badsignal.copy_ch} );
		b_dlg.post_modal(top, w1_key.DLG_COPY, 0, 0, nil)
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;
	end
	return 0
end

w1_page_noopsyche_badsignal.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;
	return ret;
end

w1_page_noopsyche_badsignal.on_pre_show = function(top)
	local cwnd = w1_page_noopsyche_badsignal.wnd;
	channel_num = global_val.get_channelnum();
	w1_page_noopsycheevent_badsignal.on_pre_show(top, channel_num)
	w1_page_noopsychearea_badsignal.on_pre_show(top)
	local con_id = cwnd.con_noopsyche.id
	
--	b_wnd_ex.set_show_page(top,con_id, cwnd.noopsycheevent_wnd.id, false)
	w1_row_noopsycherow_badsignal.changecheck(top, w1_row_noopsycherow_badsignal.wnd, w1_id.cfg_noopsyche.noopsycheprow_badsignal_id + 1, false)
end

w1_page_noopsyche_badsignal.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_channel', 't_channel','cap_enable','t_enable',			
			'con_noopsyche','noopsyche_row_wnd',
			'noopsycheevent_wnd', 'noopsychearea_wnd','noopsychetimeplan_wnd',	
			'tipinfo', --[['copy',--]]'default', 'apply'},
		
	cap_channel	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+2,xywh='s_cfg_page_1_2',items={},trans = false,channel_cbox = true,cmd =on_channel},	
	
	cap_enable 	= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_ENABLE'},
	t_enable 	= {t='tt_check', id=id+4,xywh='s_noopsyche_page_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd =on_enable},
	
	
	con_noopsyche			= {t='container',id=w1_id.cfg_noopsyche.con_noopsyche_badsignal_id,	xywh={0,0,10,10}},
	noopsyche_row_wnd 		= w1_row_noopsycherow_badsignal.wnd,
	noopsycheevent_wnd 		= w1_page_noopsycheevent_badsignal.wnd,	
	noopsychearea_wnd 		= w1_page_noopsychearea_badsignal.wnd,	
	noopsychetimeplan_wnd 	= w1_page_noopsychetimeplan_badsignal.wnd,
	
	tipinfo				= {t='static',id=id+5,	xywh='s_noopsyche_page_tipinfo_xywh',text='',trans = false},
	
	copy 	= {t='button',id=id+6,	xywh = 's_cfg_copy_xywh',	text='LA_COPY_TO',cmd=on_copy},
	apply 	= {t='button',id=id+8,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_noopsyche_badsignal

