--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_noopsyche.noopsycheprow_badsignal_area_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")

local w1_page_noopsychearea_badsignal = 
{
	cfg_data,
	cap_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}


--ע˴s_badsignal_img_xywh
--cx222߿,Ҳͬʱ4
--cy182߿,Ҳͬʱ4
--1280,1440,1920,2Kı߿ֵΪ1,,4Kı߿ֵΪ2
w1_page_noopsychearea_badsignal.s_768 =
{
	s_badsignal_area_xywh = {53,170,497,274},
	s_badsignal_img_xywh = {17,8,384,296},
	s_badsignal_cap_upload_xywh = {416,7,160,35},
	s_badsignal_t_upload_xywh = {576,7,160,35},
};

w1_page_noopsychearea_badsignal.s_1280 = 
{
	s_badsignal_area_xywh = {80,240,480,333},
	s_badsignal_img_xywh = {12,10,416,400},
	s_badsignal_cap_upload_xywh = {500,10,220,50},
	s_badsignal_t_upload_xywh = {740,10,160,50},
};

w1_page_noopsychearea_badsignal.s_1440 = 
{
	s_badsignal_area_xywh = {100,220,666,320},
	s_badsignal_img_xywh = {12,10,550,356},
	s_badsignal_cap_upload_xywh = {600,10,240,50},
	s_badsignal_t_upload_xywh = {840,10,160,50},
};

w1_page_noopsychearea_badsignal.s_1080p = 
{
	s_badsignal_area_xywh = {100,240,933,386},
	s_badsignal_img_xywh = {30,10,704,416},
	s_badsignal_cap_upload_xywh = {780,10,300,50},
	s_badsignal_t_upload_xywh = {1080,10,300,50},	
};
w1_page_noopsychearea_badsignal.s_2k = 
{
	s_badsignal_area_xywh = {133,320,1244,515},
	s_badsignal_img_xywh = {16,13,948,560},
	s_badsignal_cap_upload_xywh = {1040,13,400,67},
	s_badsignal_t_upload_xywh = {1440,13,400,67},
};
w1_page_noopsychearea_badsignal.s_4k = 
{
	s_badsignal_area_xywh = {200,480,1866,773},
	s_badsignal_img_xywh = {24,20,1412,796},
	s_badsignal_cap_upload_xywh = {1560,20,600,100},
	s_badsignal_t_upload_xywh = {2160,20,600,100},	
};

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_noopsychearea_badsignal.wnd;
	local area = cfgdata.area
	cfgdata.isGetDetail = b_wnd_ex.get_check(top,cwnd.t_upload.id);
	cfgdata.change_flag = true;
end

w1_page_noopsychearea_badsignal.setcapdata = function(top, p_data, redraw)
	local cwnd = w1_page_noopsychearea_badsignal.wnd;
	w1_page_noopsychearea_badsignal.cap_data = p_data;
	local test =0;
end

w1_page_noopsychearea_badsignal.datacheck = function(top, redraw)
	return true,nil
end
w1_page_noopsychearea_badsignal.setmareaparam = function(top, param, redraw)
	local area = param.area
	local cwnd = w1_page_noopsychearea_badsignal.wnd;
	local capdata = w1_page_noopsychearea_badsignal.cap_data
	if capdata.DetailGet_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_upload.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_upload.id,false,false);	
	else
		b_wnd_ex.set_hide(top,cwnd.cap_upload.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_upload.id,true,false);	
	end	
	b_wnd_ex.set_check(top,cwnd.t_upload.id,area.isGetDetail,false);
	w1_page_noopsychearea_badsignal.cfg_data = param;
	local img_cap = {};
	img_cap.enable = false;
	b_wnd_ex.set_cap(top,cwnd.image.id,img_cap,false);	
end

w1_page_noopsychearea_badsignal.getmareaparam = function(top)
	return w1_page_noopsychearea_badsignal.cfg_data.area;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		uitousercfg(top,w1_page_noopsychearea_badsignal.cfg_data)
	end
	return 0
end

local on_upload = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_noopsychearea_badsignal.clear_data = function()
	w1_page_noopsychearea_badsignal.cfg_data = nil;	
	w1_page_noopsychearea_badsignal.cap_data = nil;
end

w1_page_noopsychearea_badsignal.setdispch = function(top, idx)
	local param = {
		chn_id = idx,
		wnd_id = 1,
	}
	local layoutpos = w1_page_noopsychearea_badsignal.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param);
	return 0;
end
w1_page_noopsychearea_badsignal.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_noopsychearea_badsignal.wnd;

	b_wnd_ex.set_hide(top, cwnd.image.id, bool_hide, redraw)
end

w1_page_noopsychearea_badsignal.on_pre_show = function(top)
	local cwnd = w1_page_noopsychearea_badsignal.wnd;
	local param = {
		x = SIZE('s_badsignal_img_xywh')[1] + SIZE('s_badsignal_area_xywh')[1]+ SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_badsignal_img_xywh')[2] + SIZE('s_badsignal_area_xywh')[2]+ SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_badsignal_img_xywh')[3],
		cy = SIZE('s_badsignal_img_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_noopsychearea_badsignal.layoutpos.x = param.x;
	w1_page_noopsychearea_badsignal.layoutpos.cx = param.cx;
	w1_page_noopsychearea_badsignal.layoutpos.y = param.y;
	w1_page_noopsychearea_badsignal.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_badsignal_img_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_badsignal_img_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
end

w1_page_noopsychearea_badsignal.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_badsignal_area_xywh',	
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'image','cap_upload','t_upload'},
		
	image 	= {t='advarea',id=id+1,xywh='s_badsignal_img_xywh',text='image weight',trans = false,
				color= {'c_image_bk', 'c_cfg_row_bk', 'c_txt_n'},cmd = on_update_param},
	cap_upload 		=  {t='static',	id=id+2, xywh='s_badsignal_cap_upload_xywh',text='LA_UPLOAD_TARGET_INFO'},
	t_upload = {t='tt_check',id=id+3, xywh='s_badsignal_t_upload_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_upload},
}

return w1_page_noopsychearea_badsignal

