--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_noopsyche.noopsycheprow_fence_area_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local r_str 	= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_noopsychearea_fence = 
{
	cfg_data,
	cap_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}


--ע˴s_objectleft_img_xywh
--cx222߿,Ҳͬʱ4
--cy182߿,Ҳͬʱ4
--1280,1440,1920,2Kı߿ֵΪ1,,4Kı߿ֵΪ2
w1_page_noopsychearea_fence.s_768 =
{
	s_fence_area_xywh = {53,170,640,376},
	s_fence_img_xywh = {17,8,384,296},
	s_fence_clear_xywh = {282,320,106,28},
		
	s_fence_sensitivity_xywh = {404,7,181,35},
	s_fence_t_sensitivity_xywh = {586,7,160,35},
		
	s_fence_cap_lt_type_xywh = {404,42,181,35},
	s_fence_t_lt_type_xywh = {586,42,25,21},
	
	s_fence_cap_type_xywh = {404,77,181,35},
	s_fence_t_type_xywh = {586,77,160,35},
	
	s_fence_draw_line_xywh = {404,112,181,35},
	s_fence_t_draw_line_xywh = {586,112,25,21},
	
	s_fence_c_sound_alarm_xywh = {404,147,181,35},
	s_fence_t_enable_audio_xywh = {586,147,25,21},

	s_fence_cap_sound_file_xywh = {404,182,181,35},
	s_fence_t_sound_file_xywh    = {586,182,25,21},

	s_fence_c_led_alarm_xywh = {404,217,181,35},
	s_fence_t_enable_flshlight_xywh = {586,217,25,21},
};

w1_page_noopsychearea_fence.s_1280 = 
{
	s_fence_area_xywh = {80,240,800,530},
	s_fence_img_xywh = {12,10,416,416},
	s_fence_clear_xywh = {270,440,150,40},
	
	s_fence_sensitivity_xywh = {430,10,340,50},
	s_fence_t_sensitivity_xywh = {780,10,120,50},
	
	s_fence_cap_lt_type_xywh = {430,60,350,50},
	s_fence_t_lt_type_xywh = {740,60,120,50},
	
	s_fence_cap_type_xywh = {430,110,120,50},
	s_fence_t_type_xywh = {780,110,120,50},
	
	s_fence_draw_line_xywh = {430,160,350,50},
	s_fence_t_draw_line_xywh = {740,160,120,50},
	
	s_fence_c_sound_alarm_xywh = {430,210,350,50},
	s_fence_t_enable_audio_xywh = {740,210,120,50},

	s_fence_cap_sound_file_xywh = {430,260,350,50},
	s_fence_t_sound_file_xywh    = {740,260,120,50},

	s_fence_c_led_alarm_xywh = {430,310,350,50},
	s_fence_t_enable_flshlight_xywh = {740,310,120,50},
};

w1_page_noopsychearea_fence.s_1440 = 
{
	s_fence_area_xywh = {100,220,900,450},
	s_fence_img_xywh = {12,10,500,356},
	s_fence_clear_xywh = {300,380,200,40},
	
	s_fence_sensitivity_xywh = {540,10,340,45},
	s_fence_t_sensitivity_xywh = {860,10,160,45},
		
	s_fence_cap_lt_type_xywh = {540,60,340,45},
	s_fence_t_lt_type_xywh = {860,60,48,30},
	
	s_fence_cap_type_xywh = {540,110,340,45},
	s_fence_t_type_xywh = {860,110,160,45},
	
	s_fence_draw_line_xywh = {540,160,340,45},
	s_fence_t_draw_line_xywh = {860,160,48,30},
	
	s_fence_c_sound_alarm_xywh = {540,210,340,45},
	s_fence_t_enable_audio_xywh = {860,210,48,30},

	s_fence_cap_sound_file_xywh = {540,260,340,45},
	s_fence_t_sound_file_xywh    = {860,260,48,30},

	s_fence_c_led_alarm_xywh = {540,310,340,45},
	s_fence_t_enable_flshlight_xywh = {860,310,48,30},
};

w1_page_noopsychearea_fence.s_1080p = 
{
	s_fence_area_xywh = {100,240,1200,530},
	s_fence_img_xywh = {30,10,704,416},
	s_fence_clear_xywh = {530,450,200,40},
	
	s_fence_sensitivity_xywh = {740,10,340,50},
	s_fence_t_sensitivity_xywh = {1080,10,300,50},
	
	s_fence_cap_lt_type_xywh = {740,70,340,50},
	s_fence_t_lt_type_xywh = {1080,70,48,30},
	
	s_fence_cap_type_xywh = {740,130,340,50},
	s_fence_t_type_xywh = {1080,130,300,50},
	
	s_fence_draw_line_xywh = {740,190,340,50},
	s_fence_t_draw_line_xywh = {1080,190,48,30},
	
	s_fence_c_sound_alarm_xywh = {740,250,340,50},
	s_fence_t_enable_audio_xywh = {1080,250,48,30},
	
	s_fence_cap_sound_file_xywh = {740, 310, 340, 50},	
	s_fence_t_sound_file_xywh   = {1080,310, 300, 50},		

	s_fence_c_led_alarm_xywh = {740,370,340,50},
	s_fence_t_enable_flshlight_xywh = {1080,370,48,30},
	
};
w1_page_noopsychearea_fence.s_2k = 
{
	s_fence_area_xywh = {133,320,1900,706},
	s_fence_img_xywh = {16,13,970,555},
	s_fence_clear_xywh = {706,600,267,53},

	s_fence_sensitivity_xywh = {986,13,453,67},
	s_fence_t_sensitivity_xywh = {1440,13,400,67},
	
	s_fence_cap_lt_type_xywh = {986,90,453,67},
	s_fence_t_lt_type_xywh = {1440,90,64,40},
	
	s_fence_cap_type_xywh = {986,167,453,67},
	s_fence_t_type_xywh = {1440,167,400,67},
	
	s_fence_draw_line_xywh = {986,244,453,67},
	s_fence_t_draw_line_xywh = {1440,244,64,40},
	
	s_fence_c_sound_alarm_xywh = {986,321,453,67},
	s_fence_t_enable_audio_xywh = {1440,321,64,40},
	
	s_fence_cap_sound_file_xywh = {986,398,453,67},
	s_fence_t_sound_file_xywh    = {1440,398,64,40},

	s_fence_c_led_alarm_xywh = {986,475,453,67},
	s_fence_t_enable_flshlight_xywh = {1440,475,64,40},
};
w1_page_noopsychearea_fence.s_4k = 
{
	s_fence_area_xywh = {200,480,2400,1060},
	s_fence_img_xywh = {24,20,1412,832},
	s_fence_clear_xywh = {1060,900,400,80},
	
	s_fence_sensitivity_xywh = {1480,20,680,100},
	s_fence_t_sensitivity_xywh = {2160,20,600,100},
	
	s_fence_cap_lt_type_xywh = {1480,140,680,100},
	s_fence_t_lt_type_xywh = {2160,140,96,60},
	
	s_fence_cap_type_xywh = {1480,240,680,100},
	s_fence_t_type_xywh = {2160,240,600,100},
	
	s_fence_draw_line_xywh = {1480,360,680,100},
	s_fence_t_draw_line_xywh = {2160,360,96,60},
	
	s_fence_c_sound_alarm_xywh = {1480,480,680,100},
	s_fence_t_enable_audio_xywh = {2160,480,96,60},

	s_fence_cap_sound_file_xywh = {740, 600, 340, 50},	
	s_fence_t_sound_file_xywh   = {1080,600, 300, 50},		

	s_fence_c_led_alarm_xywh = {1480,720,680,100},
	s_fence_t_enable_flshlight_xywh = {2160,720,96,60},
};

w1_page_noopsychearea_fence.datacheck = function(top, redraw)
	local cwnd = w1_page_noopsychearea_fence.wnd;
	return true,nil
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_noopsychearea_fence.wnd;
	local area = cfgdata.area
	local capdata = w1_page_noopsychearea_fence.cap_data;
	area.sensitivity = b_wnd_ex.get_sel(top,cwnd.t_sensitivity.id) + 1
	local check = b_wnd_ex.get_check(top,cwnd.t_lt_type.id);
	area.target_type_enable = check;
	area.target_type = b_wnd_ex.get_sel(top,cwnd.t_type.id)
	local draw_line = b_wnd_ex.get_check(top,cwnd.t_draw_line.id);
	area.isDraw = draw_line;
	local sound_alarm = b_wnd_ex.get_check(top,cwnd.t_enable_audio.id);
	area.audio_enable = sound_alarm;
	local led_alarm = b_wnd_ex.get_check(top,cwnd.t_enable_flshlight.id);
	area.led_enable = led_alarm;
	
	local intarea = b_wnd_ex.get_intarea(top,cwnd.image.id)
	area.region_list = {}
	area.region_num = 0
	for i=1, w1_page_noopsychearea_fence.cap_data.maxRegionNum do
		if(nil ~= intarea['area'..i]) then
			area.region_num = area.region_num + 1;
			area.region_list['region'..i] = {}
			area.region_list['region'..i].point_num = 0;
			area.region_list['region'..i].points = {}
			for j = 1, w1_page_noopsychearea_fence.cap_data.edgeNum do
				if intarea['area'..i]['point'..j] ~= nil then
					area.region_list['region'..i].points['point'..j] = {}
					area.region_list['region'..i].points['point'..j].x = intarea['area'..i]['point'..j].x
					area.region_list['region'..i].points['point'..j].y = intarea['area'..i]['point'..j].y
					area.region_list['region'..i].point_num = area.region_list['region'..i].point_num +1;
				end
			end
		end
	end
	
	if (capdata.AudioAction_enable == true) then
		area.audio_type = capdata.AudioAction_min + b_wnd_ex.get_sel(top,cwnd.t_sound_cbox.id);	
		area.audio_enable = b_wnd_ex.get_check(top,cwnd.t_enable_audio.id);
	end	
	
	if (capdata.LEDAction_enable == true) then
		area.led_enable = b_wnd_ex.get_check(top,cwnd.t_enable_flshlight.id);
	end	
	
	cfgdata.change_flag = true;
end

local update_layout_info = function(top, redraw)
	local cwnd = w1_page_noopsychearea_fence.wnd;	
	local capdata = w1_page_noopsychearea_fence.cap_data;
	--ȸλؼλ
	local pos = nil;
	local check = b_wnd_ex.get_check(top,cwnd.t_lt_type.id);
	pos = SIZE('s_fence_cap_lt_type_xywh');	
	local s_y = pos[2];
	pos = SIZE('s_fence_cap_type_xywh');
	local move_h = pos[2] - s_y;	
	if (check) then
		b_wnd_ex.set_hide(top, cwnd.cap_type.id, false, false)		
		b_wnd_ex.set_hide(top, cwnd.t_type.id, false, false)
		
		pos = SIZE('s_fence_draw_line_xywh');		
		b_wnd_ex.move_pos(top, cwnd.draw_line.id, {pos[1], pos[2]}, false);
		pos = SIZE('s_fence_t_draw_line_xywh');		
		b_wnd_ex.move_pos(top, cwnd.t_draw_line.id, {pos[1], pos[2]}, false);
		pos = SIZE('s_fence_c_sound_alarm_xywh');		
		b_wnd_ex.move_pos(top, cwnd.cap_enable_audio.id, {pos[1], pos[2]}, false);
		pos = SIZE('s_fence_t_enable_audio_xywh');		
		b_wnd_ex.move_pos(top, cwnd.t_enable_audio.id, {pos[1], pos[2]}, false);
		pos = SIZE('s_fence_cap_sound_file_xywh');		
		b_wnd_ex.move_pos(top, cwnd.cap_sound_cbox.id, {pos[1], pos[2]}, false);
		pos = SIZE('s_fence_t_sound_file_xywh');		
		b_wnd_ex.move_pos(top, cwnd.t_sound_cbox.id, {pos[1], pos[2]}, false);
		pos = SIZE('s_fence_c_led_alarm_xywh');		
		b_wnd_ex.move_pos(top, cwnd.cap_enable_flshlight.id, {pos[1], pos[2]}, false);
		pos = SIZE('s_fence_t_enable_flshlight_xywh');		
		b_wnd_ex.move_pos(top, cwnd.t_enable_flshlight.id, {pos[1], pos[2]}, false);		
	else
		b_wnd_ex.set_hide(top, cwnd.cap_type.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.t_type.id, true, false)
		pos = SIZE('s_fence_draw_line_xywh');		
		b_wnd_ex.move_pos(top, cwnd.draw_line.id, {pos[1], pos[2] - move_h}, false);
		pos = SIZE('s_fence_t_draw_line_xywh');		
		b_wnd_ex.move_pos(top, cwnd.t_draw_line.id, {pos[1], pos[2] - move_h}, false);
		pos = SIZE('s_fence_c_sound_alarm_xywh');		
		b_wnd_ex.move_pos(top, cwnd.cap_enable_audio.id, {pos[1], pos[2] - move_h}, false);
		pos = SIZE('s_fence_t_enable_audio_xywh');		
		b_wnd_ex.move_pos(top, cwnd.t_enable_audio.id, {pos[1], pos[2] - move_h}, false);
		pos = SIZE('s_fence_cap_sound_file_xywh');		
		b_wnd_ex.move_pos(top, cwnd.cap_sound_cbox.id, {pos[1], pos[2] - move_h}, false);
		pos = SIZE('s_fence_t_sound_file_xywh');		
		b_wnd_ex.move_pos(top, cwnd.t_sound_cbox.id, {pos[1], pos[2] - move_h}, false);
		pos = SIZE('s_fence_c_led_alarm_xywh');		
		b_wnd_ex.move_pos(top, cwnd.cap_enable_flshlight.id, {pos[1], pos[2] - move_h}, false);
		pos = SIZE('s_fence_t_enable_flshlight_xywh');		
		b_wnd_ex.move_pos(top, cwnd.t_enable_flshlight.id, {pos[1], pos[2] - move_h}, false);			
	end	
	
	if (capdata.AudioAction_enable == true) then
		b_wnd_ex.set_hide(top,cwnd.cap_enable_audio.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_audio.id,false,false);
		local audio_enable = b_wnd_ex.get_check(top,cwnd.t_enable_audio.id);	
		if (audio_enable == true) then
			b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,false,false);
			b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,false,false);	
		else
			b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,true,false);
			b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,true,false);		
			--һ
			local s_id = cwnd.cap_enable_flshlight.id; 
			local e_id = cwnd.t_enable_flshlight.id;
			for i = s_id, e_id do
				pos = b_wnd.get_wnd_a_rect(top, i);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
			end			
		end	
	else
		b_wnd_ex.set_hide(top,cwnd.cap_enable_audio.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_audio.id,true,false);	
		b_wnd_ex.set_hide(top,cwnd.cap_sound_cbox.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_sound_cbox.id,true,false);	
		--2
		local s_id = cwnd.cap_enable_flshlight.id; 
		local e_id = cwnd.t_enable_flshlight.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - 2*move_h}, false);
		end			
	end
	
	if (capdata.LEDAction_enable == true) then
		b_wnd_ex.set_hide(top,cwnd.cap_enable_flshlight.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_flshlight.id,false,false);	
	else
		b_wnd_ex.set_hide(top,cwnd.cap_enable_flshlight.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_enable_flshlight.id,true,false);	
	end		
	
	if (redraw ~= false) then
		b_dlg.dlg_set_redraw(top);
	end
end	

w1_page_noopsychearea_fence.setmareaparam = function(top, param, redraw)
	local area = param.area
	local cwnd = w1_page_noopsychearea_fence.wnd;
	w1_page_noopsychearea_fence.cfg_data = param;
	local capdata = w1_page_noopsychearea_fence.cap_data
	local img_cap = {};
	local size;
	img_cap.Region_enable = capdata.Region_enable;
	img_cap.edgeNum = capdata.edgeNum;
	img_cap.maxRegionNum = capdata.maxRegionNum;
	b_wnd_ex.set_cap(top,cwnd.image.id,img_cap,false);	
	b_wnd_ex.set_sel(top,cwnd.t_sensitivity.id,area.sensitivity - 1,false);
	b_wnd_ex.set_check(top,cwnd.t_lt_type.id,area.target_type_enable,false);
	b_wnd_ex.set_sel(top,cwnd.t_type.id,area.target_type,false);
	b_wnd_ex.clear_intarea(top,cwnd.image.id,false,false);
	b_wnd_ex.set_check(top,cwnd.t_draw_line.id,area.isDraw,false);

	if (capdata.AudioAction_enable == true) then
		local param = {};
		for i=capdata.AudioAction_min+1,capdata.AudioAction_max+1 do
			param[i] = STR('LA_AUDIO') .. tostring(i-1);
		end
		b_wnd_ex.set_items(top, cwnd.t_sound_cbox.id, param, false);
	end
	b_wnd_ex.set_check(top,cwnd.t_enable_audio.id,area.audio_enable,false);
	b_wnd_ex.set_sel(top, cwnd.t_sound_cbox.id, area.audio_type - capdata.AudioAction_min, false);	
	b_wnd_ex.set_check(top,cwnd.t_enable_flshlight.id,area.led_enable,false);	
	
	local region_num = area.region_num;
	local intarea = {};
	for i = 1, region_num do
		intarea['area'..i] = {};
		intarea['area'..i].points = {};
		intarea['area'..i].point_num = area.region_list['region'..i].point_num 
		for j = 1,  intarea['area'..i].point_num do
			intarea['area'..i].points['point'..j]= {};
			intarea['area'..i].points['point'..j].x = area.region_list['region'..i].points['point'..j].x
			intarea['area'..i].points['point'..j].y = area.region_list['region'..i].points['point'..j].y
		end
	end
	
	if region_num > 0 and intarea['area'..1].point_num ~= nil and intarea['area'..1].point_num ~= 0 then
		b_wnd_ex.set_intarea(top,cwnd.image.id,intarea,false);
	end
	
	update_layout_info(top, false);
	
	if (redraw ~= false) then
		b_dlg.dlg_set_redraw(top);
	end
end
	
w1_page_noopsychearea_fence.setcapdata = function(top, p_data, redraw)
	local cwnd = w1_page_noopsychearea_fence.wnd;
	w1_page_noopsychearea_fence.cap_data = p_data;
end

w1_page_noopsychearea_fence.clear_data = function()
	w1_page_noopsychearea_fence.cfg_data = nil;	
	w1_page_noopsychearea_fence.cap_data = nil;
end


local on_enable_audio = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		update_layout_info(top, true);
		uitousercfg(top,w1_page_noopsychearea_fence.cfg_data)
	end
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg or b_ui.LBUTTONCLK == vmsg) then
		local cwnd = w1_page_noopsychearea_fence.wnd;
		uitousercfg(top,w1_page_noopsychearea_fence.cfg_data)
		if (win_id == cwnd.t_lt_type.id) then
			update_layout_info(top, true);
		end
	end
	return 0
end

local on_clear = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_wnd_ex.clear_intarea(top,w1_page_noopsychearea_fence.wnd.image.id,false,false);
		uitousercfg(top,w1_page_noopsychearea_fence.cfg_data)
	end
	return 0;
end

w1_page_noopsychearea_fence.setdispch = function(top, idx)
	local param = {
		chn_id = idx,
		wnd_id = 1,
	}
	local layoutpos = w1_page_noopsychearea_fence.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param);
	return 0;
end

w1_page_noopsychearea_fence.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_noopsychearea_fence.wnd;
	local sid = cwnd.image.id;
	local eid = cwnd.t_enable_flshlight.id
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end
end

w1_page_noopsychearea_fence.on_pre_show = function(top)
	local cwnd = w1_page_noopsychearea_fence.wnd;
	local param = {
		x = SIZE('s_fence_img_xywh')[1] + SIZE('s_fence_area_xywh')[1]+ SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_fence_img_xywh')[2] + SIZE('s_fence_area_xywh')[2]+ SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_fence_img_xywh')[3],
		cy = SIZE('s_fence_img_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_noopsychearea_fence.layoutpos.x = param.x;
	w1_page_noopsychearea_fence.layoutpos.cx = param.cx;
	w1_page_noopsychearea_fence.layoutpos.y = param.y;
	w1_page_noopsychearea_fence.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_fence_img_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_fence_img_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
end

w1_page_noopsychearea_fence.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_fence_area_xywh',	
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'image','clear','sensitivity','t_sensitivity','cap_lt_type','t_lt_type','cap_type','t_type',
			'draw_line','t_draw_line','cap_enable_audio', 't_enable_audio', 'cap_sound_cbox', 't_sound_cbox','cap_enable_flshlight', 't_enable_flshlight',},
		
	image 	= {t='intelarea',id=id+1,xywh='s_fence_img_xywh',text='image weight',trans = false,
				color= {'c_image_bk', 'c_cfg_row_bk', 'c_txt_n'},cmd = on_update_param},
	clear	= {t='tt_button',id=id+2,xywh='s_fence_clear_xywh',text='LA_CLEAR',cmd = on_clear},	
	
	sensitivity = {t='static',	id=id+3, xywh='s_fence_sensitivity_xywh',text='LA_SENSITIVITY'},
	t_sensitivity = {t='combox',	id=id+4, xywh='s_fence_t_sensitivity_xywh' ,trans = false,
					items = {'1','2','3', '4', '5'},cmd = on_update_param},
		
	cap_lt_type 	= {t='static',	id=id+5, xywh='s_fence_cap_lt_type_xywh',text='LA_LIMIT_TARGET_TYPE'},
	t_lt_type 	= {t='tt_check',id=id+6, xywh='s_fence_t_lt_type_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_update_param},
	cap_type 	= {t='static',	id=id+7, xywh='s_fence_cap_type_xywh',text='LA_TYPE'},
	t_type = {t='combox',	id=id+8, xywh='s_fence_t_type_xywh' ,
					items = {'LA_PERSON_OR_CAR','LA_PERSON','LA_CAR'},cmd = on_update_param},
	draw_line  = {t='static',	id=id+9, xywh='s_fence_draw_line_xywh',text='LA_VIDEO_DRAW'},
	t_draw_line = {t='tt_check',id=id+10, xywh='s_fence_t_draw_line_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_update_param},
	
	cap_enable_audio  = {t='static',	id=id+11, xywh='s_fence_c_sound_alarm_xywh',text='LA_SOUND_DETECTION'},
	t_enable_audio = {t='tt_check',id=id+12, xywh='s_fence_t_enable_audio_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_enable_audio},
					
	cap_sound_cbox	= {t='static',id=id+13,	xywh='s_fence_cap_sound_file_xywh',	text='LA_SOUND_ALARM_FILE'},
	t_sound_cbox 	= {t='combox',id=id+14,	xywh='s_fence_t_sound_file_xywh',	items={},trans = false,cmd=on_update_param},	
					
	cap_enable_flshlight  = {t='static',	id=id+15, xywh='s_fence_c_led_alarm_xywh',text='LA_FLASHLIGHT_ALARM'},
	t_enable_flshlight = {t='tt_check',id=id+16, xywh='s_fence_t_enable_flshlight_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_update_param},					
}

return w1_page_noopsychearea_fence

