--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_noopsyche.noopsycheprow_illegalpacking_area_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local r_str 	= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_noopsychearea_illegal_packing = 
{
	cfg_data,
	cap_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}


--ע˴s_objectleft_img_xywh
--cx222߿,Ҳͬʱ4
--cy182߿,Ҳͬʱ4
--1280,1440,1920,2Kı߿ֵΪ1,,4Kı߿ֵΪ2
w1_page_noopsychearea_illegal_packing.s_768 =
{
	s_illpacking_area_xywh = {53,170,640,376},
	s_illpacking_img_xywh = {17,8,384,296},
	s_illpacking_clear_xywh = {282,320,106,28},
	s_illpacking_cap_min_size_xywh = {404,7,181,35},
	s_illpacking_t_min_size_xywh = {586,7,160,35},
	s_illpacking_cap_max_size_xywh = {404,49,181,35},
	s_illpacking_t_max_size_xywh = {586,49,160,35},
	s_illpacking_cap_left_time_xywh = {404,92,181,35},
	s_illpacking_t_left_time_xywh = {586,92,160,35},
	s_illpacking_cap_upload_xywh = {404,135,181,35},
	s_illpacking_t_upload_xywh = {586,142,25,21},
	s_illpacking_cap_draw_xywh = {404,177,181,35},
	s_illpacking_t_draw_xywh = {586,184,25,21},
};

w1_page_noopsychearea_illegal_packing.s_1280 = 
{
	s_illpacking_area_xywh = {80,240,800,530},
	s_illpacking_img_xywh = {12,10,416,416},
	s_illpacking_clear_xywh = {270,440,150,40},
	s_illpacking_cap_min_size_xywh = {430,10,350,50},
	s_illpacking_t_min_size_xywh = {780,10,120,50},
	s_illpacking_cap_max_size_xywh =  {430,70,350,50},
	s_illpacking_t_max_size_xywh = {780,70,120,50},
	s_illpacking_cap_left_time_xywh = {430,130,350,50},
	s_illpacking_t_left_time_xywh = {780,130,120,50},
	s_illpacking_cap_upload_xywh = {430,190,350,50},
	s_illpacking_t_upload_xywh = {780,200,48,30},
	s_illpacking_cap_draw_xywh = {430,250,350,50},
	s_illpacking_t_draw_xywh = {780,260,48,30},
};

w1_page_noopsychearea_illegal_packing.s_1440 = 
{
	s_illpacking_area_xywh = {100,220,900,450},
	s_illpacking_img_xywh = {12,10,500,356},
	s_illpacking_clear_xywh = {300,400,200,40},
	s_illpacking_cap_min_size_xywh = {540,10,320,50},
	s_illpacking_t_min_size_xywh = {860,10,160,50},
	s_illpacking_cap_max_size_xywh =  {540,70,320,50},
	s_illpacking_t_max_size_xywh = {860,70,160,50},
	s_illpacking_cap_left_time_xywh = {540,130,320,50},
	s_illpacking_t_left_time_xywh = {860,130,160,50},
	s_illpacking_cap_upload_xywh = {540,190,320,50},
	s_illpacking_t_upload_xywh = {860,200,48,30},
	s_illpacking_cap_draw_xywh = {540,250,320,50},
	s_illpacking_t_draw_xywh = {860,260,48,30},
};

w1_page_noopsychearea_illegal_packing.s_1080p = 
{
	s_illpacking_area_xywh = {100,240,1200,530},
	s_illpacking_img_xywh = {30,10,704,416},
	s_illpacking_clear_xywh = {530,450,200,40},
	s_illpacking_cap_min_size_xywh = {740,10,340,50},
	s_illpacking_t_min_size_xywh = {1080,10,300,50},
	s_illpacking_cap_max_size_xywh = {740,70,340,50},
	s_illpacking_t_max_size_xywh = {1080,70,300,50},
	s_illpacking_cap_left_time_xywh = {740,130,340,50},
	s_illpacking_t_left_time_xywh = {1080,130,300,50},
	s_illpacking_cap_upload_xywh = {740,190,340,50},
	s_illpacking_t_upload_xywh = {1080,200,48,30},
	s_illpacking_cap_draw_xywh = {740,250,340,50},
	s_illpacking_t_draw_xywh = {1080,260,48,30},
};
w1_page_noopsychearea_illegal_packing.s_2k = 
{
	s_illpacking_area_xywh = {133,320,1900,706},
	s_illpacking_img_xywh = {16,13,948,560},
	s_illpacking_clear_xywh = {706,600,267,53},
	s_illpacking_cap_min_size_xywh = {986,13,453,67},
	s_illpacking_t_min_size_xywh = {1440,13,400,67},
	s_illpacking_cap_max_size_xywh = {986,93,453,67},
	s_illpacking_t_max_size_xywh = {1440,93,400,67},
	s_illpacking_cap_left_time_xywh = {986,173,453,67},
	s_illpacking_t_left_time_xywh = {1440,173,400,67},
	s_illpacking_cap_upload_xywh = {986,254,453,67},
	s_illpacking_t_upload_xywh = {1440,267,64,40},
	s_illpacking_cap_draw_xywh = {986,334,453,67},
	s_illpacking_t_draw_xywh = {1440,347,64,40},
};
w1_page_noopsychearea_illegal_packing.s_4k = 
{
	s_illpacking_area_xywh = {200,480,2400,1060},
	s_illpacking_img_xywh = {24,20,1412,796},
	s_illpacking_clear_xywh = {1060,900,400,80},
	s_illpacking_cap_min_size_xywh = {1480,20,680,100},
	s_illpacking_t_min_size_xywh = {2160,20,600,100},
	s_illpacking_cap_max_size_xywh = {1480,140,680,100},
	s_illpacking_t_max_size_xywh = {2160,140,600,100},
	s_illpacking_cap_left_time_xywh = {1480,260,680,100},
	s_illpacking_t_left_time_xywh = {2160,260,600,100},
	s_illpacking_cap_upload_xywh = {1480,380,680,100},
	s_illpacking_t_upload_xywh = {2160,400,96,60},
	s_illpacking_cap_draw_xywh = {1480,500,680,100},
	s_illpacking_t_draw_xywh = {2160,520,96,60},
};

w1_page_noopsychearea_illegal_packing.datacheck = function(top, redraw)
	local cwnd = w1_page_noopsychearea_illegal_packing.wnd;
	local minsize = b_wnd_ex.get_value(top,cwnd.t_min_size.id);
	local maxsize = b_wnd_ex.get_value(top,cwnd.t_max_size.id);
	local lefttime = b_wnd_ex.get_value(top,cwnd.t_left_time.id);
	local cap_data = w1_page_noopsychearea_illegal_packing.cap_data
	local errorstr;

	if(cap_data.MinTargetSize_enable == true and cap_data.MaxTargetSize_enable == true) then
		if(maxsize < minsize) then
			errorstr = STR('LA_ERR_MIN_BIGGER_MAX')
			return false,errorstr;
		end	
		if maxsize == minsize then
			errorstr = STR('LA_MIN_EQUAL_MAX')
			return false,errorstr;
		end
	end
	
	if cap_data.MaxTargetSize_enable == true and 
		(maxsize > cap_data.MaxTargetSize_max or
		maxsize < cap_data.MaxTargetSize_min) then
		errorstr = STR('LA_ERR_MAX_SIZE')..tostring(cap_data.MaxTargetSize_min)..'-'..tostring(cap_data.MaxTargetSize_max);
		return false, errorstr;
	end
	if cap_data.MinTargetSize_enable == true and 
		(minsize > cap_data.MinTargetSize_max or 
		minsize < cap_data.MinTargetSize_min) then
		errorstr = STR('LA_ERR_MIN_SIZE')..tostring(cap_data.MinTargetSize_min)..'-'..tostring(cap_data.MinTargetSize_max);
		return false,errorstr;
	end
	
	if lefttime > cap_data.MinTime_max or
		lefttime < cap_data.MinTime_min then
		errorstr = STR('LA_ERR_MIN_LEFT')..tostring(cap_data.MinTime_min)..'-'..tostring(cap_data.MinTime_max);
		return false,errorstr;
	end	
	
	return true,nil
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_noopsychearea_illegal_packing.wnd;
	local area = cfgdata.area
	cfgdata.area.target_min_size = b_wnd_ex.get_value(top,cwnd.t_min_size.id)
	cfgdata.area.target_max_size = b_wnd_ex.get_value(top,cwnd.t_max_size.id)
	cfgdata.area.time	= b_wnd_ex.get_value(top,cwnd.t_left_time.id);
	area.isGetDetail = b_wnd_ex.get_check(top,cwnd.t_upload.id);
	area.isDraw = b_wnd_ex.get_check(top,cwnd.t_draw.id);
	local intarea = b_wnd_ex.get_intarea(top,cwnd.image.id)
	area.region_list = {}
	area.region_num = 0
	for i=1, w1_page_noopsychearea_illegal_packing.cap_data.maxRegionNum do
		if(nil ~= intarea['area'..i]) then
			area.region_num = area.region_num + 1;
			area.region_list['region'..i] = {}
			area.region_list['region'..i].point_num = 0;
			area.region_list['region'..i].points = {}
			for j = 1, w1_page_noopsychearea_illegal_packing.cap_data.edgeNum do
				if intarea['area'..i]['point'..j] ~= nil then
					area.region_list['region'..i].points['point'..j] = {}
					area.region_list['region'..i].points['point'..j].x = intarea['area'..i]['point'..j].x
					area.region_list['region'..i].points['point'..j].y = intarea['area'..i]['point'..j].y
					area.region_list['region'..i].point_num = area.region_list['region'..i].point_num +1;
				end
			end
		end
	end
	cfgdata.change_flag = true;
end

local update_layout_info = function(top, redraw)
	local cwnd = w1_page_noopsychearea_illegal_packing.wnd;	
	--ȸλؼλ
	local pos = nil;
	local s_id = cwnd.cap_min_size.id; 
	local e_id = cwnd.t_draw.id;
	for i = s_id, e_id do
		pos = SIZE(cwnd[cwnd.sub[i - id]].xywh);
		b_wnd_ex.move_pos(top, i, {pos[1], pos[2]}, false);
	end	

	local capdata = w1_page_noopsychearea_illegal_packing.cap_data
	local area = w1_page_noopsychearea_illegal_packing.cfg_data.area
	pos = SIZE('s_illpacking_cap_min_size_xywh');	
	local s_y = pos[2];
	pos = SIZE('s_illpacking_cap_max_size_xywh');
	local move_h = pos[2] - s_y;		
	
	if capdata.Region_enable == true then
		b_wnd_ex.set_disable(top,cwnd.clear.id,false,false);
	else
		b_wnd_ex.set_disable(top,cwnd.clear.id,true,false);
	end	
	
	if capdata.MinTargetSize_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_min_size.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_min_size.id,false,false);		
	else
		b_wnd_ex.set_hide(top,cwnd.cap_min_size.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_min_size.id,true,false);	
		--һ
		local s_id = cwnd.cap_max_size.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end	
	end
	
	if capdata.MaxTargetSize_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_max_size.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_max_size.id,false,false);		
	else
		b_wnd_ex.set_hide(top,cwnd.cap_max_size.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_max_size.id,true,false);		
		--һ
		local s_id = cwnd.cap_left_time.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end	
	end
	
	if capdata.MinTime_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_left_time.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_left_time.id,false,false);		
	else
		b_wnd_ex.set_hide(top,cwnd.cap_left_time.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_left_time.id,true,false);		
		--һ
		local s_id = cwnd.cap_upload.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end	
	end

	if capdata.DetailGet_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_upload.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_upload.id,false,false);	
	else
		b_wnd_ex.set_hide(top,cwnd.cap_upload.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_upload.id,true,false);	
		--һ
		local s_id = cwnd.cap_draw.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end	
	end

	if capdata.OSDDrawLine_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_draw.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_draw.id,false,false);
	else
		b_wnd_ex.set_hide(top,cwnd.cap_draw.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_draw.id,true,false);
	end
	
	if (redraw ~= false) then
		b_dlg.dlg_set_redraw(top);
	end
end	

w1_page_noopsychearea_illegal_packing.setmareaparam = function(top, param, redraw)
	local area = param.area
	local cwnd = w1_page_noopsychearea_illegal_packing.wnd;
	w1_page_noopsychearea_illegal_packing.cfg_data = param;
	local capdata = w1_page_noopsychearea_illegal_packing.cap_data
	local img_cap = {};
	local size;
	img_cap.Region_enable = capdata.Region_enable;
	img_cap.edgeNum = capdata.edgeNum;
	img_cap.maxRegionNum = capdata.maxRegionNum;
	b_wnd_ex.set_cap(top,cwnd.image.id,img_cap,false);
	b_wnd_ex.set_range(top,cwnd.t_min_size.id,{capdata.MinTargetSize_min, capdata.MinTargetSize_max},false);
	b_wnd_ex.set_range(top,cwnd.t_max_size.id,{capdata.MaxTargetSize_min, capdata.MaxTargetSize_max},false);
	b_wnd_ex.set_range(top,cwnd.t_left_time.id,{capdata.MinTime_min, capdata.MinTime_max},false);
	b_wnd_ex.set_value(top,cwnd.t_min_size.id,area.target_min_size,false);
	b_wnd_ex.set_value(top,cwnd.t_max_size.id,area.target_max_size,false);
	b_wnd_ex.set_value(top,cwnd.t_left_time.id,area.time,false);
	b_wnd_ex.set_check(top,cwnd.t_upload.id,area.isGetDetail,false);
	b_wnd_ex.set_check(top,cwnd.t_draw.id,area.isDraw,false);
	b_wnd_ex.clear_intarea(top,cwnd.image.id,false,false);
	local region_num = area.region_num;
	local intarea = {};
	for i = 1, region_num do
		intarea['area'..i] = {};
		intarea['area'..i].points = {};
		intarea['area'..i].point_num = area.region_list['region'..i].point_num 
		for j = 1,  intarea['area'..i].point_num do
			intarea['area'..i].points['point'..j]= {};
			intarea['area'..i].points['point'..j].x = area.region_list['region'..i].points['point'..j].x
			intarea['area'..i].points['point'..j].y = area.region_list['region'..i].points['point'..j].y
		end
	end
	
	if region_num > 0 and intarea['area'..1].point_num ~= nil and intarea['area'..1].point_num ~= 0 then
		b_wnd_ex.set_intarea(top,cwnd.image.id,intarea,false);
	end
	
	update_layout_info(top, false);
	
	if (redraw ~= false) then
		b_dlg.dlg_set_redraw(top);
	end
end
	
local on_update_param = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		uitousercfg(top,w1_page_noopsychearea_illegal_packing.cfg_data)
	end
	return 0
end

local on_clear = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_wnd_ex.clear_intarea(top,w1_page_noopsychearea_illegal_packing.wnd.image.id,false,false);
		uitousercfg(top,w1_page_noopsychearea_illegal_packing.cfg_data)
	end
	return 0;
end

w1_page_noopsychearea_illegal_packing.clear_data = function()
	w1_page_noopsychearea_illegal_packing.cfg_data = nil;	
	w1_page_noopsychearea_illegal_packing.cap_data = nil;
end

w1_page_noopsychearea_illegal_packing.setcapdata = function(top, p_data, redraw)
	local cwnd = w1_page_noopsychearea_illegal_packing.wnd;
	w1_page_noopsychearea_illegal_packing.cap_data = p_data;
end

w1_page_noopsychearea_illegal_packing.setdispch = function(top, idx)
	local param = {
		chn_id = idx,
		wnd_id = 1,
	}
	local layoutpos = w1_page_noopsychearea_illegal_packing.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param);
	return 0;
end

w1_page_noopsychearea_illegal_packing.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_noopsychearea_illegal_packing.wnd;
	local sid = cwnd.image.id;
	local eid = cwnd.t_draw.id
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end
end

w1_page_noopsychearea_illegal_packing.on_pre_show = function(top)
	local cwnd = w1_page_noopsychearea_illegal_packing.wnd;
	local param = {
		x = SIZE('s_illpacking_img_xywh')[1] + SIZE('s_illpacking_area_xywh')[1]+ SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_illpacking_img_xywh')[2] + SIZE('s_illpacking_area_xywh')[2]+ SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_illpacking_img_xywh')[3],
		cy = SIZE('s_illpacking_img_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_noopsychearea_illegal_packing.layoutpos.x = param.x;
	w1_page_noopsychearea_illegal_packing.layoutpos.cx = param.cx;
	w1_page_noopsychearea_illegal_packing.layoutpos.y = param.y;
	w1_page_noopsychearea_illegal_packing.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_illpacking_img_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_illpacking_img_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
end

w1_page_noopsychearea_illegal_packing.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_illpacking_area_xywh',	
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'image','clear','cap_min_size','t_min_size','cap_max_size',
		't_max_size','cap_left_time','t_left_time','cap_upload','t_upload','cap_draw','t_draw'},
		
	image 	= {t='intelarea',id=id+1,xywh='s_illpacking_img_xywh',text='image weight',trans = false,
				color= {'c_image_bk', 'c_cfg_row_bk', 'c_txt_n'},cmd = on_update_param},
	clear	= {t='tt_button',id=id+2,xywh='s_illpacking_clear_xywh',text='LA_CLEAR',cmd = on_clear},			
	cap_min_size 	= {t='static',	id=id+3, xywh='s_illpacking_cap_min_size_xywh',text='LA_MIN_SIZE'},
	t_min_size = {t='edit_num',	id=id+4, xywh='s_illpacking_t_min_size_xywh',cmd = on_update_param},	
	cap_max_size 	= {t='static',	id=id+5, xywh='s_illpacking_cap_max_size_xywh',text='LA_MAX_SIZE'},
	t_max_size = {t='edit_num',	id=id+6, xywh='s_illpacking_t_max_size_xywh',cmd = on_update_param},
	cap_left_time = {t='static', id=id+7, xywh='s_illpacking_cap_left_time_xywh',text='LA_PARKING_TIME'},
	t_left_time = {t='edit_num',id=id+8, xywh='s_illpacking_t_left_time_xywh',cmd = on_update_param},
	cap_upload 		=  {t='static',	id=id+9, xywh='s_illpacking_cap_upload_xywh',text='LA_UPLOAD_TARGET_INFO'},
	t_upload = {t='tt_check',id=id+10, xywh='s_illpacking_t_upload_xywh',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
				cmd = on_update_param},
	cap_draw =  {t='static',	id=id+11, xywh='s_illpacking_cap_draw_xywh',text='LA_VIDEO_DRAW'},
	t_draw = {t='tt_check',id=id+12, xywh='s_illpacking_t_draw_xywh',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
				cmd = on_update_param},
}

return w1_page_noopsychearea_illegal_packing

