--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_noopsyche.noopsycheprow_loiter_area_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local r_str 	= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_noopsychearea_loiter = 
{
	cfg_data,
	cap_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}


--ע˴s_objectleft_img_xywh
--cx222߿,Ҳͬʱ4
--cy182߿,Ҳͬʱ4
--1280,1440,1920,2Kı߿ֵΪ1,,4Kı߿ֵΪ2
w1_page_noopsychearea_loiter.s_768 =
{
	s_loiter_area_xywh = {53,170,640,376},
	s_loiter_img_xywh = {17,8,384,296},
	s_loiter_clear_xywh = {282,320,106,28},
	s_loiter_cap_lt_type_xywh = {404,7,181,35},
	s_loiter_t_lt_type_xywh = {586,14,25,21},
	s_loiter_cap_type_xywh = {404,42,181,35},
	s_loiter_t_type_xywh = {586,42,160,35},
	s_loiter_cap_lt_size_xywh = {404,78,181,35},
	s_loiter_t_lt_size_xywh = {586,85,25,21},
	s_loiter_cap_min_size_xywh = {404,113,181,35},
	s_loiter_t_min_size_xywh = {586,113,160,35},
	s_loiter_cap_max_size_xywh = {404,149,181,35},
	s_loiter_t_max_size_xywh = {586,149,160,35},
	s_loiter_cap_left_time_xywh = {404,184,181,35},
	s_loiter_t_left_time_xywh = {586,184,160,35},
	s_loiter_cap_judge_xywh = {404,220,181,35},
	s_loiter_t_judge_xywh = {586,227,25,21},
	s_loiter_cap_upload_xywh = {404,256,181,35},
	s_loiter_t_upload_xywh = {586,263,25,21},
	s_loiter_cap_draw_xywh = {404,291,181,35},
	s_loiter_t_draw_xywh = {586,298,25,21},
};

w1_page_noopsychearea_loiter.s_1280 = 
{
	s_loiter_area_xywh = {80,240,800,530},
	s_loiter_img_xywh = {12,10,416,416},
	s_loiter_clear_xywh = {270,440,150,40},
	s_loiter_cap_lt_type_xywh = {430,10,340,50},
	s_loiter_t_lt_type_xywh = {780,20,48,30},
	s_loiter_cap_type_xywh = {430,60,340,50},
	s_loiter_t_type_xywh = {780,60,120,50},
	s_loiter_cap_lt_size_xywh = {430,110,340,50},
	s_loiter_t_lt_size_xywh = {780,120,48,30},
	s_loiter_cap_min_size_xywh = {430,160,340,50},
	s_loiter_t_min_size_xywh = {780,160,120,50},
	s_loiter_cap_max_size_xywh = {430,210,340,50},
	s_loiter_t_max_size_xywh = {780,210,120,50},
	s_loiter_cap_left_time_xywh = {430,260,350,50},
	s_loiter_t_left_time_xywh = {780,260,120,50},
	s_loiter_cap_judge_xywh = {430,310,350,50},
	s_loiter_t_judge_xywh = {780,320,48,30},
	s_loiter_cap_upload_xywh = {430,360,350,50},
	s_loiter_t_upload_xywh = {780,370,48,30},
	s_loiter_cap_draw_xywh = {430,410,350,50},
	s_loiter_t_draw_xywh = {780,420,48,30},	
};

w1_page_noopsychearea_loiter.s_1440 = 
{
	s_loiter_area_xywh = {100,220,900,450},
	s_loiter_img_xywh = {12,10,500,356},
	s_loiter_clear_xywh = {300,380,200,40},
	s_loiter_cap_lt_type_xywh = {540,10,340,45},
	s_loiter_t_lt_type_xywh = {860,15,48,30},
	s_loiter_cap_type_xywh = {540,55,340,45},
	s_loiter_t_type_xywh = {860,55,160,45},
	s_loiter_cap_lt_size_xywh = {540,100,340,45},
	s_loiter_t_lt_size_xywh = {860,107,48,30},
	s_loiter_cap_min_size_xywh = {540,145,340,45},
	s_loiter_t_min_size_xywh = {860,145,160,45},
	s_loiter_cap_max_size_xywh = {540,190,340,45},
	s_loiter_t_max_size_xywh = {860,190,160,45},
	s_loiter_cap_left_time_xywh = {540,235,350,45},
	s_loiter_t_left_time_xywh = {860,235,160,45},
	s_loiter_cap_judge_xywh = {540,280,350,45},
	s_loiter_t_judge_xywh = {860,287,48,30},
	s_loiter_cap_upload_xywh = {540,325,350,45},
	s_loiter_t_upload_xywh = {860,332,48,30},
	s_loiter_cap_draw_xywh = {540,370,350,45},
	s_loiter_t_draw_xywh = {860,377,48,30},	
};

w1_page_noopsychearea_loiter.s_1080p = 
{
	s_loiter_area_xywh = {100,240,1200,530},
	s_loiter_img_xywh = {30,10,704,416},
	s_loiter_clear_xywh = {530,450,200,40},
	s_loiter_cap_lt_type_xywh = {740,10,340,50},
	s_loiter_t_lt_type_xywh = {1080,20,48,30},
	s_loiter_cap_type_xywh = {740,60,340,50},
	s_loiter_t_type_xywh = {1080,60,300,50},
	s_loiter_cap_lt_size_xywh = {740,110,340,50},
	s_loiter_t_lt_size_xywh = {1080,120,48,30},
	s_loiter_cap_min_size_xywh = {740,160,340,50},
	s_loiter_t_min_size_xywh = {1080,160,300,50},
	s_loiter_cap_max_size_xywh = {740,210,340,50},
	s_loiter_t_max_size_xywh = {1080,210,300,50},
	s_loiter_cap_left_time_xywh = {740,260,340,50},
	s_loiter_t_left_time_xywh = {1080,260,300,50},
	s_loiter_cap_judge_xywh = {740,310,340,50},
	s_loiter_t_judge_xywh = {1080,320,48,30},
	s_loiter_cap_upload_xywh = {740,360,340,50},
	s_loiter_t_upload_xywh = {1080,370,48,30},
	s_loiter_cap_draw_xywh = {740,410,340,50},
	s_loiter_t_draw_xywh = {1080,420,48,30},	
};
w1_page_noopsychearea_loiter.s_2k = 
{
	s_loiter_area_xywh = {133,320,1900,706},
	s_loiter_img_xywh = {16,13,970,555},
	s_loiter_clear_xywh = {706,600,267,53},
	s_loiter_cap_lt_type_xywh = {986,13,453,67},
	s_loiter_t_lt_type_xywh = {1440,27,64,40},
	s_loiter_cap_type_xywh = {986,80,453,67},
	s_loiter_t_type_xywh = {1440,80,400,67},
	s_loiter_cap_lt_size_xywh = {986,147,453,67},
	s_loiter_t_lt_size_xywh = {1440,160,64,40},
	s_loiter_cap_min_size_xywh = {986,213,453,67},
	s_loiter_t_min_size_xywh = {1440,213,400,67},
	s_loiter_cap_max_size_xywh = {986,280,453,67},
	s_loiter_t_max_size_xywh = {1440,280,400,67},
	s_loiter_cap_left_time_xywh = {986,347,453,67},
	s_loiter_t_left_time_xywh = {1440,347,400,67},
	s_loiter_cap_judge_xywh = {986,413,453,67},
	s_loiter_t_judge_xywh = {1440,427,64,40},
	s_loiter_cap_upload_xywh = {986,480,453,67},
	s_loiter_t_upload_xywh = {1440,493,64,40},
	s_loiter_cap_draw_xywh = {986,547,453,67},
	s_loiter_t_draw_xywh = {1440,560,64,40},
};
w1_page_noopsychearea_loiter.s_4k = 
{
	s_loiter_area_xywh = {200,480,2400,1060},
	s_loiter_img_xywh = {24,20,1412,832},
	s_loiter_clear_xywh = {1060,900,400,80},
	s_loiter_cap_lt_type_xywh = {1480,20,680,100},
	s_loiter_t_lt_type_xywh = {2160,40,96,60},
	s_loiter_cap_type_xywh = {1480,120,680,100},
	s_loiter_t_type_xywh = {2160,120,600,100},
	s_loiter_cap_lt_size_xywh = {1480,220,680,100},
	s_loiter_t_lt_size_xywh = {2160,240,96,60},
	s_loiter_cap_min_size_xywh = {1480,320,680,100},
	s_loiter_t_min_size_xywh = {2160,320,600,100},
	s_loiter_cap_max_size_xywh = {1480,420,680,100},
	s_loiter_t_max_size_xywh = {2160,420,600,100},
	s_loiter_cap_left_time_xywh = {1480,520,680,100},
	s_loiter_t_left_time_xywh = {2160,520,600,100},
	s_loiter_cap_judge_xywh = {1480,620,680,100},
	s_loiter_t_judge_xywh = {2160,640,96,60},
	s_loiter_cap_upload_xywh = {1480,720,680,100},
	s_loiter_t_upload_xywh = {2160,740,96,60},
	s_loiter_cap_draw_xywh = {1480,820,680,100},
	s_loiter_t_draw_xywh = {2160,840,96,60},	
};

w1_page_noopsychearea_loiter.datacheck = function(top, redraw)
	local cwnd = w1_page_noopsychearea_loiter.wnd;
	local minsize = b_wnd_ex.get_value(top,cwnd.t_min_size.id);
	local maxsize = b_wnd_ex.get_value(top,cwnd.t_max_size.id);
	local lefttime = b_wnd_ex.get_value(top,cwnd.t_left_time.id);
	local cap_data = w1_page_noopsychearea_loiter.cap_data;
	local errorstr;
	if cap_data.TargetSizeConstrain_enable == true and b_wnd_ex.get_check(top,cwnd.t_lt_size.id) == false then
			
	else
		if(cap_data.MinTargetSize_enable == true and cap_data.MaxTargetSize_enable == true) then
			if(maxsize < minsize) then
				errorstr = STR('LA_ERR_MIN_BIGGER_MAX')
				return false,errorstr;
			end	
			if maxsize == minsize then
				errorstr = STR('LA_MIN_EQUAL_MAX')
				return false,errorstr;
			end
		end
	end
		
	if cap_data.MaxTargetSize_enable == true and 
		(maxsize > cap_data.MaxTargetSize_max or
		maxsize < cap_data.MaxTargetSize_min) then
		errorstr = STR('LA_ERR_MAX_SIZE')..tostring(cap_data.MaxTargetSize_min)..'-'..tostring(cap_data.MaxTargetSize_max);
		return false, errorstr;
	end
	if cap_data.MinTargetSize_enable == true and 
		(minsize > cap_data.MinTargetSize_max or 
		minsize < cap_data.MinTargetSize_min) then
		errorstr = STR('LA_ERR_MIN_SIZE')..tostring(cap_data.MinTargetSize_min)..'-'..tostring(cap_data.MinTargetSize_max);
		return false,errorstr;
	end
	
	if lefttime > cap_data.MinTime_max or
		lefttime < cap_data.MinTime_min then
		errorstr = STR('LA_ERR_MIN_LEFT')..tostring(cap_data.MinTime_min)..'-'..tostring(cap_data.MinTime_max);
		return false,errorstr;
	end	
	
	return true,nil
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_noopsychearea_loiter.wnd;
	local area = cfgdata.area
	
	local check = b_wnd_ex.get_check(top,cwnd.t_lt_type.id);
	area.target_type_enable = check;
	if check == true then
		area.target_type = b_wnd_ex.get_sel(top,cwnd.t_type.id)
	end
	
	check = b_wnd_ex.get_check(top,cwnd.t_lt_size.id);
	area.target_size_enable = check
	if check == true then
		area.target_min_size = b_wnd_ex.get_value(top,cwnd.t_min_size.id)
		area.target_max_size = b_wnd_ex.get_value(top,cwnd.t_max_size.id)
	end
	area.time	= b_wnd_ex.get_value(top,cwnd.t_left_time.id);
	area.is_analysis_path = b_wnd_ex.get_check(top,cwnd.t_judge.id);
	area.isGetDetail = b_wnd_ex.get_check(top,cwnd.t_upload.id);
	area.isDraw = b_wnd_ex.get_check(top,cwnd.t_draw.id);
	local intarea = b_wnd_ex.get_intarea(top,cwnd.image.id)
	area.region_list = {}
	area.region_num = 0
	for i=1, w1_page_noopsychearea_loiter.cap_data.maxRegionNum do
		if(nil ~= intarea['area'..i]) then
			area.region_num = area.region_num + 1;
			area.region_list['region'..i] = {}
			area.region_list['region'..i].point_num = 0;
			area.region_list['region'..i].points = {}
			for j = 1, w1_page_noopsychearea_loiter.cap_data.edgeNum do
				if intarea['area'..i]['point'..j] ~= nil then
					area.region_list['region'..i].points['point'..j] = {}
					area.region_list['region'..i].points['point'..j].x = intarea['area'..i]['point'..j].x
					area.region_list['region'..i].points['point'..j].y = intarea['area'..i]['point'..j].y
					area.region_list['region'..i].point_num = area.region_list['region'..i].point_num +1;
				end
			end
		end
	end
	cfgdata.change_flag = true;
end

local update_layout_info = function(top, redraw)
	local cwnd = w1_page_noopsychearea_loiter.wnd;	
	--ȸλؼλ
	local pos = nil;
	local s_id = cwnd.cap_lt_type.id; 
	local e_id = cwnd.t_draw.id;
	for i = s_id, e_id do
		pos = SIZE(cwnd[cwnd.sub[i - id]].xywh);
		b_wnd_ex.move_pos(top, i, {pos[1], pos[2]}, false);
	end	

	local capdata = w1_page_noopsychearea_loiter.cap_data
	local area = w1_page_noopsychearea_loiter.cfg_data.area
	local pos = SIZE('s_loiter_cap_lt_type_xywh');	
	local s_y = pos[2];
	pos = SIZE('s_loiter_cap_type_xywh');
	local move_h = pos[2] - s_y;			
		
	if capdata.Region_enable == true then
		b_wnd_ex.set_disable(top,cwnd.clear.id,false,false);
	else
		b_wnd_ex.set_disable(top,cwnd.clear.id,true,false);
	end	
			
	if capdata.TargetTypeConstrain_enable == false then
		b_wnd_ex.set_hide(top, cwnd.cap_lt_type.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_lt_type.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_type.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_type.id, true, false);		
		--
		local s_id = cwnd.cap_lt_size.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h * 2}, false);
		end	
	else
		b_wnd_ex.set_hide(top, cwnd.cap_lt_type.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_lt_type.id, false, false);
		if capdata.TargetType_enable == true and area.target_type_enable == true then
			b_wnd_ex.set_hide(top,cwnd.cap_type.id,false,false);
			b_wnd_ex.set_hide(top,cwnd.t_type.id,false,false);
		else
			b_wnd_ex.set_hide(top,cwnd.cap_type.id,true,false);
			b_wnd_ex.set_hide(top,cwnd.t_type.id,true,false);
			--һ
			local s_id = cwnd.cap_lt_size.id; 
			local e_id = cwnd.t_draw.id;
			for i = s_id, e_id do
				pos = b_wnd.get_wnd_a_rect(top, i);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
			end	
		end
	end
	
	if capdata.TargetSizeConstrain_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_lt_size.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_lt_size.id,false,false);
			
		local check = b_wnd_ex.get_check(top,cwnd.t_lt_size.id);
		if capdata.MinTargetSize_enable == true and check == true then
			b_wnd_ex.set_hide(top,cwnd.cap_min_size.id,false,false);
			b_wnd_ex.set_hide(top,cwnd.t_min_size.id,false,false);		
		else
			b_wnd_ex.set_hide(top,cwnd.cap_min_size.id,true,false);
			b_wnd_ex.set_hide(top,cwnd.t_min_size.id,true,false);	
			--һ
			local s_id = cwnd.cap_max_size.id; 
			local e_id = cwnd.t_draw.id;
			for i = s_id, e_id do
				pos = b_wnd.get_wnd_a_rect(top, i);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
			end	
		end
		
		if capdata.MaxTargetSize_enable == true and check == true then
			b_wnd_ex.set_hide(top,cwnd.cap_max_size.id,false,false);
			b_wnd_ex.set_hide(top,cwnd.t_max_size.id,false,false);		
		else
			b_wnd_ex.set_hide(top,cwnd.cap_max_size.id,true,false);
			b_wnd_ex.set_hide(top,cwnd.t_max_size.id,true,false);		
			--һ
			local s_id = cwnd.cap_left_time.id; 
			local e_id = cwnd.t_draw.id;
			for i = s_id, e_id do
				pos = b_wnd.get_wnd_a_rect(top, i);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
			end	
		end
	else
		b_wnd_ex.set_hide(top,cwnd.cap_lt_size.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_lt_size.id,true,false);
		--һ
		local s_id = cwnd.cap_min_size.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end	
		
		if capdata.MinTargetSize_enable == true and check == true then
			b_wnd_ex.set_hide(top,cwnd.cap_min_size.id,false,false);
			b_wnd_ex.set_hide(top,cwnd.t_min_size.id,false,false);		
		else
			b_wnd_ex.set_hide(top,cwnd.cap_min_size.id,true,false);
			b_wnd_ex.set_hide(top,cwnd.t_min_size.id,true,false);	
			--һ
			local s_id = cwnd.cap_max_size.id; 
			local e_id = cwnd.t_draw.id;
			for i = s_id, e_id do
				pos = b_wnd.get_wnd_a_rect(top, i);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
			end	
		end
		
		if capdata.MaxTargetSize_enable == true then
			b_wnd_ex.set_hide(top,cwnd.cap_max_size.id,false,false);
			b_wnd_ex.set_hide(top,cwnd.t_max_size.id,false,false);		
		else
			b_wnd_ex.set_hide(top,cwnd.cap_max_size.id,true,false);
			b_wnd_ex.set_hide(top,cwnd.t_max_size.id,true,false);		
			--һ
			local s_id = cwnd.cap_left_time.id; 
			local e_id = cwnd.t_draw.id;
			for i = s_id, e_id do
				pos = b_wnd.get_wnd_a_rect(top, i);
				b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
			end	
		end
	end
	
	if capdata.MinTime_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_left_time.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_left_time.id,false,false);		
	else
		b_wnd_ex.set_hide(top,cwnd.cap_left_time.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_left_time.id,true,false);		
		--һ
		local s_id = cwnd.cap_judge.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end	
	end	
	
	if capdata.AnalysisPath_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_judge.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_judge.id,false,false);		
	else
		b_wnd_ex.set_hide(top,cwnd.cap_judge.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_judge.id,true,false);		
		--һ
		local s_id = cwnd.cap_upload.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end	
	end	
	
	if capdata.DetailGet_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_upload.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_upload.id,false,false);	
	else
		b_wnd_ex.set_hide(top,cwnd.cap_upload.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_upload.id,true,false);	
		--һ
		local s_id = cwnd.cap_draw.id; 
		local e_id = cwnd.t_draw.id;
		for i = s_id, e_id do
			pos = b_wnd.get_wnd_a_rect(top, i);
			b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
		end	
	end

	if capdata.OSDDrawLine_enable == true then
		b_wnd_ex.set_hide(top,cwnd.cap_draw.id,false,false);
		b_wnd_ex.set_hide(top,cwnd.t_draw.id,false,false);
	else
		b_wnd_ex.set_hide(top,cwnd.cap_draw.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.t_draw.id,true,false);
	end
	
	if (redraw ~= false) then
		b_dlg.dlg_set_redraw(top);
	end
end	

w1_page_noopsychearea_loiter.setmareaparam = function(top, param, redraw)
	local area = param.area
	local cwnd = w1_page_noopsychearea_loiter.wnd;
	w1_page_noopsychearea_loiter.cfg_data = param;
	local capdata = w1_page_noopsychearea_loiter.cap_data
	local img_cap = {};
	local size;
	img_cap.Region_enable = capdata.Region_enable;
	img_cap.edgeNum = capdata.edgeNum;
	img_cap.maxRegionNum = capdata.maxRegionNum;
	b_wnd_ex.set_cap(top,cwnd.image.id,img_cap,false);	
	
	b_wnd_ex.set_check(top,cwnd.t_lt_type.id,area.target_type_enable,false);
	b_wnd_ex.set_sel(top,cwnd.t_type.id,area.target_type,false);
	b_wnd_ex.set_check(top,cwnd.t_lt_size.id,area.target_size_enable,false);
	b_wnd_ex.set_range(top,cwnd.t_min_size.id,{capdata.MinTargetSize_min, capdata.MinTargetSize_max},false);
	b_wnd_ex.set_range(top,cwnd.t_max_size.id,{capdata.MaxTargetSize_min, capdata.MaxTargetSize_max},false);
	b_wnd_ex.set_range(top,cwnd.t_left_time.id,{capdata.MinTime_min, capdata.MinTime_max},false);
	b_wnd_ex.set_value(top,cwnd.t_min_size.id,area.target_min_size,false);
	b_wnd_ex.set_value(top,cwnd.t_max_size.id,area.target_max_size,false);
	b_wnd_ex.set_value(top,cwnd.t_left_time.id,area.time,false);
	b_wnd_ex.set_check(top,cwnd.t_judge.id,area.is_analysis_path,false);
	b_wnd_ex.set_check(top,cwnd.t_upload.id,area.isGetDetail,false);
	b_wnd_ex.set_check(top,cwnd.t_draw.id,area.isDraw,false);
	b_wnd_ex.clear_intarea(top,cwnd.image.id,false,false);
	local region_num = area.region_num;
	local intarea = {};
	for i = 1, region_num do
		intarea['area'..i] = {};
		intarea['area'..i].points = {};
		intarea['area'..i].point_num = area.region_list['region'..i].point_num 
		for j = 1,  intarea['area'..i].point_num do
			intarea['area'..i].points['point'..j]= {};
			intarea['area'..i].points['point'..j].x = area.region_list['region'..i].points['point'..j].x
			intarea['area'..i].points['point'..j].y = area.region_list['region'..i].points['point'..j].y
		end
	end
	
	if region_num > 0 and intarea['area'..1].point_num ~= nil and intarea['area'..1].point_num ~= 0 then
		b_wnd_ex.set_intarea(top,cwnd.image.id,intarea,false);
	end
	
	update_layout_info(top, false);
	
	if (redraw ~= false) then
		b_dlg.dlg_set_redraw(top);
	end
end
	
w1_page_noopsychearea_loiter.setcapdata = function(top, p_data, redraw)
	local cwnd = w1_page_noopsychearea_loiter.wnd;
	w1_page_noopsychearea_loiter.cap_data = p_data;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg or b_ui.LBUTTONCLK == vmsg) then
		local cwnd = w1_page_noopsychearea_loiter.wnd;
		uitousercfg(top,w1_page_noopsychearea_loiter.cfg_data)
		if (win_id == cwnd.t_lt_type.id or win_id == cwnd.t_lt_size.id ) then
			update_layout_info(top, true);
		end
	end
	return 0
end

local on_clear = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_wnd_ex.clear_intarea(top,w1_page_noopsychearea_loiter.wnd.image.id,false,false);
		uitousercfg(top,w1_page_noopsychearea_loiter.cfg_data)
	end
	return 0;
end

w1_page_noopsychearea_loiter.clear_data = function()
	w1_page_noopsychearea_loiter.cfg_data = nil;	
	w1_page_noopsychearea_loiter.cap_data = nil;
end

w1_page_noopsychearea_loiter.setdispch = function(top, idx)
	local param = {
		chn_id = idx,
		wnd_id = 1,
	}
	local layoutpos = w1_page_noopsychearea_loiter.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param);
	return 0;
end

w1_page_noopsychearea_loiter.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_noopsychearea_loiter.wnd;
	local sid = cwnd.image.id;
	local eid = cwnd.t_draw.id
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end
end

w1_page_noopsychearea_loiter.on_pre_show = function(top)
	local cwnd = w1_page_noopsychearea_loiter.wnd;
	local param = {
		x = SIZE('s_loiter_img_xywh')[1] + SIZE('s_loiter_area_xywh')[1]+ SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_loiter_img_xywh')[2] + SIZE('s_loiter_area_xywh')[2]+ SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_loiter_img_xywh')[3],
		cy = SIZE('s_loiter_img_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_noopsychearea_loiter.layoutpos.x = param.x;
	w1_page_noopsychearea_loiter.layoutpos.cx = param.cx;
	w1_page_noopsychearea_loiter.layoutpos.y = param.y;
	w1_page_noopsychearea_loiter.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_loiter_img_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_loiter_img_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
end

w1_page_noopsychearea_loiter.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_loiter_area_xywh',	
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'image','clear','cap_lt_type','t_lt_type','cap_type','t_type',
			'cap_lt_size','t_lt_size',	'cap_min_size', 't_min_size', 'cap_max_size', 't_max_size',
			'cap_left_time', 't_left_time', 'cap_judge', 't_judge','cap_upload','t_upload','cap_draw','t_draw'},
		
	image 	= {t='intelarea',id=id+1,xywh='s_loiter_img_xywh',text='image weight',trans = false,
				color= {'c_image_bk', 'c_cfg_row_bk', 'c_txt_n'},cmd = on_update_param},
	clear	= {t='tt_button',id=id+2,xywh='s_loiter_clear_xywh',text='LA_CLEAR',cmd = on_clear},			
	cap_lt_type 	= {t='static',	id=id+3, xywh='s_loiter_cap_lt_type_xywh',text='LA_LIMIT_TARGET_TYPE'},
	t_lt_type 	= {t='tt_check',id=id+4, xywh='s_loiter_t_lt_type_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_update_param},
	cap_type 	= {t='static',	id=id+5, xywh='s_loiter_cap_type_xywh',text='LA_TYPE'},
	t_type = {t='combox',	id=id+6, xywh='s_loiter_t_type_xywh' ,
					items = {'LA_PERSON_OR_CAR','LA_PERSON','LA_CAR'},cmd = on_update_param},
	cap_lt_size = {t='static', id=id+7, xywh='s_loiter_cap_lt_size_xywh',text='LA_LIMIT_TARGET_SIZE'},
	t_lt_size 	= {t='tt_check',id=id+8, xywh='s_loiter_t_lt_size_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_update_param},	
	cap_min_size 	= {t='static',	id=id+9, xywh='s_loiter_cap_min_size_xywh',text='LA_MIN_SIZE'},
	t_min_size = {t='edit_num',	id=id+10, xywh='s_loiter_t_min_size_xywh', cmd = on_update_param},				
	cap_max_size 	= {t='static',	id=id+11, xywh='s_loiter_cap_max_size_xywh',text='LA_MAX_SIZE'},
	t_max_size = {t='edit_num',	id=id+12, xywh='s_loiter_t_max_size_xywh',cmd = on_update_param},
	cap_left_time = {t='static', id=id+13, xywh='s_loiter_cap_left_time_xywh',text='LA_SHORT_TIME'},
	t_left_time = {t='edit_num',id=id+14, xywh='s_loiter_t_left_time_xywh',cmd = on_update_param},
	cap_judge = {t='static', id=id+15, xywh='s_loiter_cap_judge_xywh',text='LA_PATH_JUDGE'},
	t_judge 	= {t='tt_check',id=id+16, xywh='s_loiter_t_judge_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_update_param},	
	cap_upload 		=  {t='static',	id=id+17, xywh='s_loiter_cap_upload_xywh',text='LA_UPLOAD_TARGET_INFO'},
	t_upload = {t='tt_check',id=id+18, xywh='s_loiter_t_upload_xywh',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
				cmd = on_update_param},
	cap_draw =  {t='static',	id=id+19, xywh='s_loiter_cap_draw_xywh',text='LA_VIDEO_DRAW'},
	t_draw = {t='tt_check',id=id+20, xywh='s_loiter_t_draw_xywh',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
				cmd = on_update_param},
}

return w1_page_noopsychearea_loiter


