--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_humanthermometer.face_detect_id
local image_id 	= w1_id.cfg_humanthermometer.param_conf_id + 1
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")
local b_dlg 	= require("wnd.core.b_dlg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_page_param_confface_detect = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_param_confface_detect.s_768 =
{
	s_cfg_page_param_confface_xywh = {53,320,746,220},
	s_face_det_cap_face_detect_xywh = {32,0,149,32},
	s_face_det_t_face_detect_xywh = {237,4,25,21},
	s_face_det_cap_trace_info_xywh = {32,35,149,32},
	s_face_det_t_trace_info_xywh = {240,35,117,32},
	s_face_det_cap_detect_area_xywh = {32,71,149,32},
	s_face_det_t_detect_area_xywh = {237,76,25,21},
	s_face_det_cap_con_coe_xywh = {32,106,149,32},
	s_face_det_t_con_coe_xywh = {240,106,117,32},
	s_face_det_cap_area_id_xywh = {32,142,149,32},
	s_face_det_t_area_id_xywh = {240,142,117,32},
	s_face_det_cap_pix_min_xywh = {32,177,149,32},
	s_face_det_t_pix_min_xywh = {240,177,117,32},
	s_face_det_cap_pix_max_xywh = {32,213,149,32},
	s_face_det_t_pix_max_xywh = {240,213,117,32},
	s_face_det_cap_mat_qua_xywh = {32,248,149,32},
	s_face_det_t_mat_qua_xywh = {240,248,117,32},
	s_face_det_cap_snap_mode_xywh = {376,0,149,32},
	s_face_det_t_snap_mode_xywh = {584,0,117,32},
	s_face_det_cap_img_int_xywh = {376,35,154,32},
	s_face_det_t_img_int_xywh = {584,35,117,32},
	s_face_det_cap_yaw_deg_xywh = {376,71,149,32},
	s_face_det_t_yaw_deg_xywh = {584,71,117,32},
	s_face_det_cap_tilt_deg_xywh = {376,106,149,32},
	s_face_det_t_tilt_deg_xywh = {584,106,117,32},
	s_face_det_cap_pitch_deg_xywh = {376,142,149,32},
	s_face_det_t_pitch_deg_xywh = {584,142,117,32},
	s_face_det_cap_ftp_img_mat_xywh = {376,177,149,32},
	s_face_det_t_ftp_img_mat_xywh = {581,182,25,21},
	s_face_det_cap_ftp_whole_img_xywh = {376,213,149,32},
	s_face_det_t_ftp_whole_img_xywh = {581,218,25,21},
	s_face_det_cap_osd_xywh = {376,248,149,32},
	s_face_det_t_osd_xywh = {581,253,25,21},
	s_face_det_cap_alg_lib_ver_xywh = {376,284,149,32},
	s_face_det_t_alg_lib_ver_xywh = {584,284,117,32},
	s_face_det_hline_xywh = {368,0,1,284},
	s_face_det_vdrop_xywh = {706,0,10,277},
	s_face_det_l_cap_line = {32,0,170,32},
	s_face_det_l_t_line = {240,0,117,32},
	s_face_det_r_cap_line = {376,0,170,32},
	s_face_det_r_t_line = {584,0,117,32},
	s_face_det_tt_check_xywh = {2,4,25,21},
	s_face_det_int_xywh = {0,0,35,0},
};

w1_page_param_confface_detect.s_1280 = 
{
	s_cfg_page_param_confface_xywh = {60,440,900,310},
	s_face_det_cap_face_detect_xywh = {40,0,270,45},
	s_face_det_t_face_detect_xywh = {315,7,48,30},
	s_face_det_cap_trace_info_xywh = {40,50,270,45},
	s_face_det_t_trace_info_xywh	= {320,50,160,45},
	s_face_det_cap_detect_area_xywh = {40,100,270,45},
	s_face_det_t_detect_area_xywh = {315,107,48,30},
	s_face_det_cap_con_coe_xywh = {40,150,270,45},
	s_face_det_t_con_coe_xywh = {320,150,160,45},
	s_face_det_cap_area_id_xywh = {40,200,270,45},
	s_face_det_t_area_id_xywh = {320,200,160,45},
	s_face_det_cap_pix_min_xywh = {40,250,270,45},
	s_face_det_t_pix_min_xywh = {320,250,160,45},
	s_face_det_cap_pix_max_xywh = {40,300,270,45},
	s_face_det_t_pix_max_xywh = {320,300,160,45},
	s_face_det_cap_mat_qua_xywh = {40,350,270,45},
	s_face_det_t_mat_qua_xywh = {320,350,160,45},
	s_face_det_cap_snap_mode_xywh = {505,0,270,45},
	s_face_det_t_snap_mode_xywh = {780,0,160,45},
	s_face_det_cap_img_int_xywh = {505,50,270,45},
	s_face_det_t_img_int_xywh = {780,50,160,45},
	s_face_det_cap_yaw_deg_xywh = {505,100,270,45},
	s_face_det_t_yaw_deg_xywh = {780,100,160,45},
	s_face_det_cap_tilt_deg_xywh = {505,150,270,45},
	s_face_det_t_tilt_deg_xywh = {780,150,160,45},
	s_face_det_cap_pitch_deg_xywh = {505,200,270,45},
	s_face_det_t_pitch_deg_xywh = {780,200,160,45},
	s_face_det_cap_ftp_img_mat_xywh = {505,250,270,45},
	s_face_det_t_ftp_img_mat_xywh = {775,257,48,30},
	s_face_det_cap_ftp_whole_img_xywh = {505,300,270,45},
	s_face_det_t_ftp_whole_img_xywh = {775,307,48,30},
	s_face_det_cap_osd_xywh = {505,350,270,45},
	s_face_det_t_osd_xywh = {775,357,48,30},
	s_face_det_cap_alg_lib_ver_xywh = {505,400,270,45},
	s_face_det_t_alg_lib_ver_xywh = {780,400,160,45},
	s_face_det_hline_xywh = {495,0,1,350},
	s_face_det_vdrop_xywh = {940,0,20,350},
	s_face_det_l_cap_line = {40,0,270,45},
	s_face_det_l_t_line = {320,0,160,45},
	s_face_det_r_cap_line = {505,0,270,45},
	s_face_det_r_t_line = {780,0,160,45},
	s_face_det_tt_check_xywh = {5,7,48,30},
	s_face_det_int_xywh = {0,0,50,0}
};

w1_page_param_confface_detect.s_1440 = 
{
	s_cfg_page_param_confface_xywh = {60,332,900,245},
	s_face_det_cap_face_detect_xywh = {40,0,270,45},
	s_face_det_t_face_detect_xywh = {315,7,48,30},
	s_face_det_cap_trace_info_xywh = {40,50,270,45},
	s_face_det_t_trace_info_xywh	= {320,50,160,45},
	s_face_det_cap_detect_area_xywh = {40,100,270,45},
	s_face_det_t_detect_area_xywh = {315,107,48,30},
	s_face_det_cap_con_coe_xywh = {40,150,270,45},
	s_face_det_t_con_coe_xywh = {320,150,160,45},
	s_face_det_cap_area_id_xywh = {40,200,270,45},
	s_face_det_t_area_id_xywh = {320,200,160,45},
	s_face_det_cap_pix_min_xywh = {40,250,270,45},
	s_face_det_t_pix_min_xywh = {320,250,160,45},
	s_face_det_cap_pix_max_xywh = {40,300,270,45},
	s_face_det_t_pix_max_xywh = {320,300,160,45},
	s_face_det_cap_mat_qua_xywh = {40,350,270,45},
	s_face_det_t_mat_qua_xywh = {320,350,160,45},
	s_face_det_cap_snap_mode_xywh = {505,0,270,45},
	s_face_det_t_snap_mode_xywh = {780,0,160,45},
	s_face_det_cap_img_int_xywh = {505,50,270,45},
	s_face_det_t_img_int_xywh = {780,50,160,45},
	s_face_det_cap_yaw_deg_xywh = {505,100,270,45},
	s_face_det_t_yaw_deg_xywh = {780,100,160,45},
	s_face_det_cap_tilt_deg_xywh = {505,150,270,45},
	s_face_det_t_tilt_deg_xywh = {780,150,160,45},
	s_face_det_cap_pitch_deg_xywh = {505,200,270,45},
	s_face_det_t_pitch_deg_xywh = {780,200,160,45},
	s_face_det_cap_ftp_img_mat_xywh = {505,250,270,45},
	s_face_det_t_ftp_img_mat_xywh = {775,257,48,30},
	s_face_det_cap_ftp_whole_img_xywh = {505,300,270,45},
	s_face_det_t_ftp_whole_img_xywh = {775,307,48,30},
	s_face_det_cap_osd_xywh = {505,350,270,45},
	s_face_det_t_osd_xywh = {775,357,48,30},
	s_face_det_cap_alg_lib_ver_xywh = {505,400,270,45},
	s_face_det_t_alg_lib_ver_xywh = {780,400,160,45},
	s_face_det_hline_xywh = {495,0,1,350},
	s_face_det_vdrop_xywh = {950,0,20,350},
	s_face_det_l_cap_line = {40,0,270,45},
	s_face_det_l_t_line = {320,0,160,45},
	s_face_det_r_cap_line = {505,0,270,45},
	s_face_det_r_t_line = {780,0,160,45},
	s_face_det_tt_check_xywh = {5,7,48,30},
	s_face_det_int_xywh = {0,0,50,0}
};

w1_page_param_confface_detect.s_1080p = 
{
	s_cfg_page_param_confface_xywh = {100,450,1400,310},
	s_face_det_cap_face_detect_xywh = {60,0,280,45},
	s_face_det_t_face_detect_xywh = {445,7,48,30},
	s_face_det_cap_trace_info_xywh = {60,50,280,45},
	s_face_det_t_trace_info_xywh	= {450,50,220,45},
	s_face_det_cap_detect_area_xywh = {60,100,280,45},
	s_face_det_t_detect_area_xywh = {445,107,48,30},
	s_face_det_cap_con_coe_xywh = {60,150,280,45},
	s_face_det_t_con_coe_xywh = {450,150,220,45},
	s_face_det_cap_area_id_xywh = {60,200,280,45},
	s_face_det_t_area_id_xywh = {450,200,220,45},
	s_face_det_cap_pix_min_xywh = {60,250,280,45},
	s_face_det_t_pix_min_xywh = {450,250,220,45},
	s_face_det_cap_pix_max_xywh = {60,300,280,45},
	s_face_det_t_pix_max_xywh = {450,300,220,45},
	s_face_det_cap_mat_qua_xywh = {60,350,280,45},
	s_face_det_t_mat_qua_xywh = {450,350,220,45},
	s_face_det_cap_snap_mode_xywh = {705,0,280,45},
	s_face_det_t_snap_mode_xywh = {1095,0,220,45},
	s_face_det_cap_img_int_xywh = {705,50,290,45},
	s_face_det_t_img_int_xywh = {1095,50,220,45},
	s_face_det_cap_yaw_deg_xywh = {705,100,280,45},
	s_face_det_t_yaw_deg_xywh = {1095,100,220,45},
	s_face_det_cap_tilt_deg_xywh = {705,150,280,45},
	s_face_det_t_tilt_deg_xywh = {1095,150,220,45},
	s_face_det_cap_pitch_deg_xywh = {705,200,280,45},
	s_face_det_t_pitch_deg_xywh = {1095,200,220,45},
	s_face_det_cap_ftp_img_mat_xywh = {705,250,280,45},
	s_face_det_t_ftp_img_mat_xywh = {1090,257,48,30},
	s_face_det_cap_ftp_whole_img_xywh = {705,300,280,45},
	s_face_det_t_ftp_whole_img_xywh = {1090,307,48,30},
	s_face_det_cap_osd_xywh = {705,350,280,45},
	s_face_det_t_osd_xywh = {1090,357,48,30},
	s_face_det_cap_alg_lib_ver_xywh = {705,400,280,45},
	s_face_det_t_alg_lib_ver_xywh = {1095,400,220,45},
	s_face_det_hline_xywh = {690,0,2,400},
	s_face_det_vdrop_xywh = {1325,0,20,390},
	s_face_det_l_cap_line = {60,0,320,45},
	s_face_det_l_t_line = {450,0,220,45},
	s_face_det_r_cap_line = {705,0,320,45},
	s_face_det_r_t_line = {1095,0,220,45},
	s_face_det_tt_check_xywh = {5,7,48,30},
	s_face_det_int_xywh = {0,0,50,0}
};

w1_page_param_confface_detect.s_2k = 
{
	s_cfg_page_param_confface_xywh = {133,600,1866,413},
	s_face_det_cap_face_detect_xywh = {80,0,373,60},
	s_face_det_t_face_detect_xywh = {593,9,64,40},
	s_face_det_cap_trace_info_xywh = {80,67,373,60},
	s_face_det_t_trace_info_xywh = {600,67,293,60},
	s_face_det_cap_detect_area_xywh = {80,133,373,60},
	s_face_det_t_detect_area_xywh = {593,142,64,40},
	s_face_det_cap_con_coe_xywh = {80,200,373,60},
	s_face_det_t_con_coe_xywh = {600,200,293,60},
	s_face_det_cap_area_id_xywh = {80,267,373,60},
	s_face_det_t_area_id_xywh = {600,267,293,60},
	s_face_det_cap_pix_min_xywh = {80,333,373,60},
	s_face_det_t_pix_min_xywh = {600,330,293,60},
	s_face_det_cap_pix_max_xywh = {80,400,373,60},
	s_face_det_t_pix_max_xywh = {600,400,293,60},
	s_face_det_cap_mat_qua_xywh = {80,467,373,60},
	s_face_det_t_mat_qua_xywh = {600,467,293,60},
	s_face_det_cap_snap_mode_xywh = {940,0,373,60},
	s_face_det_t_snap_mode_xywh = {1460,0,293,60},
	s_face_det_cap_img_int_xywh = {940,67,387,60},
	s_face_det_t_img_int_xywh = {1460,67,293,60},
	s_face_det_cap_yaw_deg_xywh = {940,133,373,60},
	s_face_det_t_yaw_deg_xywh = {1460,133,293,60},
	s_face_det_cap_tilt_deg_xywh = {940,200,373,60},
	s_face_det_t_tilt_deg_xywh = {1460,200,293,60},
	s_face_det_cap_pitch_deg_xywh = {940,267,373,60},
	s_face_det_t_pitch_deg_xywh = {1460,267,293,60},
	s_face_det_cap_ftp_img_mat_xywh = {940,333,373,60},
	s_face_det_t_ftp_img_mat_xywh = {1453,343,64,40},
	s_face_det_cap_ftp_whole_img_xywh = {940,400,373,60},
	s_face_det_t_ftp_whole_img_xywh = {1453,409,64,40},
	s_face_det_cap_osd_xywh = {940,467,373,60},
	s_face_det_t_osd_xywh = {1453,476,64,40},
	s_face_det_cap_alg_lib_ver_xywh = {940,533,373,60},
	s_face_det_t_alg_lib_ver_xywh = {1460,533,293,60},
	s_face_det_hline_xywh = {920,0,3,533},
	s_face_det_vdrop_xywh = {1767,0,27,520},
	s_face_det_l_cap_line = {80,0,427,60},
	s_face_det_l_t_line = {600,0,293,60},
	s_face_det_r_cap_line = {940,0,427,60},
	s_face_det_r_t_line = {1460,0,293,60},
	s_face_det_tt_check_xywh = {7,9,64,40},
	s_face_det_int_xywh = {0,0,67,0}
};

w1_page_param_confface_detect.s_4k = 
{
	s_cfg_page_param_confface_xywh = {200,900,2800,620},
	s_face_det_cap_face_detect_xywh = {120,0,560,90},
	s_face_det_t_face_detect_xywh = {890,14,96,60},
	s_face_det_cap_trace_info_xywh = {120,100,560,90},
	s_face_det_t_trace_info_xywh	= {900,100,440,90},
	s_face_det_cap_detect_area_xywh = {120,200,560,90},
	s_face_det_t_detect_area_xywh = {890,214,96,60},
	s_face_det_cap_con_coe_xywh = {120,300,560,90},
	s_face_det_t_con_coe_xywh = {900,300,440,90},
	s_face_det_cap_area_id_xywh = {120,400,560,90},
	s_face_det_t_area_id_xywh = {900,400,440,90},
	s_face_det_cap_pix_min_xywh = {120,500,560,90},
	s_face_det_t_pix_min_xywh = {900,500,440,90},
	s_face_det_cap_pix_max_xywh = {120,600,560,90},
	s_face_det_t_pix_max_xywh = {900,600,440,90},
	s_face_det_cap_mat_qua_xywh = {120,700,560,90},
	s_face_det_t_mat_qua_xywh = {900,700,440,90},
	s_face_det_cap_snap_mode_xywh = {1410,0,560,90},
	s_face_det_t_snap_mode_xywh = {2190,0,440,90},
	s_face_det_cap_img_int_xywh = {1410,100,580,90},
	s_face_det_t_img_int_xywh = {2190,100,440,90},
	s_face_det_cap_yaw_deg_xywh = {1410,200,560,90},
	s_face_det_t_yaw_deg_xywh = {2190,200,440,90},
	s_face_det_cap_tilt_deg_xywh = {1410,300,560,90},
	s_face_det_t_tilt_deg_xywh = {2190,300,440,90},
	s_face_det_cap_pitch_deg_xywh = {1410,400,560,90},
	s_face_det_t_pitch_deg_xywh = {2190,400,440,90},
	s_face_det_cap_ftp_img_mat_xywh = {1410,500,560,90},
	s_face_det_t_ftp_img_mat_xywh = {2180,514,96,60},
	s_face_det_cap_ftp_whole_img_xywh = {1410,600,560,90},
	s_face_det_t_ftp_whole_img_xywh = {2180,614,96,60},
	s_face_det_cap_osd_xywh = {1410,700,560,90},
	s_face_det_t_osd_xywh = {2180,714,96,60},
	s_face_det_cap_alg_lib_ver_xywh = {1410,800,560,60},
	s_face_det_t_alg_lib_ver_xywh = {2190,800,440,60},
	s_face_det_hline_xywh = {1380,0,4,800},
	s_face_det_vdrop_xywh = {2650,0,40,780},
	s_face_det_l_cap_line = {120,0,640,90},
	s_face_det_l_t_line = {900,0,440,90},
	s_face_det_r_cap_line = {1410,0,640,90},
	s_face_det_r_t_line = {2190,0,440,90},
	s_face_det_tt_check_xywh = {10,14,96,60},
	s_face_det_int_xywh = {0,0,100,0}
};

local show_line = 8;
local display_off = 0;
local total_show = 0;
local show_list_l = {};
local index_l = 1;
local show_list_r = {};
local index_r = 1;
local tt_check_list_id = {};
local tt_check_count = nil;
w1_page_param_confface_detect.clear_data=function ()
	w1_page_param_confface_detect.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_param_confface_detect.wnd;
	cfgdata.face_enable = b_wnd_ex.get_check(top,cwnd.t_face_detect.id);
	cfgdata.object_mode = b_wnd_ex.get_sel(top,cwnd.t_trace_info.id);
	cfgdata.area_enable = b_wnd_ex.get_check(top,cwnd.t_detect_area.id);
	local sel = b_wnd_ex.get_sel(top,cwnd.t_con_coe.id);
	if sel == 0 then
		cfgdata.reliability = 30
	elseif sel == 1 then
		cfgdata.reliability = 60
	else
		cfgdata.reliability = 90
	end
	cfgdata.areaid = b_wnd_ex.get_sel(top,cwnd.t_area_id.id)
	cfgdata.area.region_list['region'..cfgdata.areaid+1].min_pix = b_wnd_ex.get_value(top,cwnd.t_pix_min.id);
	cfgdata.area.region_list['region'..cfgdata.areaid+1].max_pix = b_wnd_ex.get_value(top,cwnd.t_pix_max.id);
	sel = b_wnd_ex.get_sel(top,cwnd.t_mat_qua.id);
	if sel == 0 then
		cfgdata.pic_quality = 30
	elseif sel == 1 then
		cfgdata.pic_quality = 60
	elseif sel == 2 then
		cfgdata.pic_quality = 80
	else
		cfgdata.pic_quality = 97
	end
	sel = b_wnd_ex.get_sel(top,cwnd.t_snap_mode.id);
	if sel == 0then
		cfgdata.snap_pic_mode = 0;
		cfgdata.upload_inteval = b_wnd_ex.get_value(top,cwnd.t_img_int.id);
	elseif sel == 1 then
		cfgdata.snap_pic_mode = 1;
		cfgdata.snap_count = b_wnd_ex.get_value(top,cwnd.t_img_int.id);
	else
		cfgdata.snap_pic_mode = 4;
		cfgdata.upload_inteval = b_wnd_ex.get_value(top,cwnd.t_img_int.id);
	end
	cfgdata.yawdegree = b_wnd_ex.get_value(top,cwnd.t_yaw_deg.id);
	cfgdata.tiltdegree = b_wnd_ex.get_value(top,cwnd.t_tilt_deg.id);
	cfgdata.petchdegree = b_wnd_ex.get_value(top,cwnd.t_pitch_deg.id);
	cfgdata.ftpupload_enable = b_wnd_ex.get_check(top,cwnd.t_ftp_img_mat.id);
	cfgdata.fuleview_enable = b_wnd_ex.get_check(top,cwnd.t_ftp_whole_img.id);
	cfgdata.picosd_enable = b_wnd_ex.get_check(top,cwnd.t_osd.id);
	return 0
end

local move_ex = function (top)
	local cwnd = w1_page_param_confface_detect.wnd;
	local is_tt_check = function (id)
		for i = 1, tt_check_count do
			if(tt_check_list_id[i] == id) then
				return true
			end
			if i == tt_check_count then
				return false
			end
		end
	end
	--------------------------------------------
	local s_id = cwnd.cap_face_detect.id;
	local e_id = cwnd.t_alg_lib_ver.id;
	for i = s_id, e_id do
		b_wnd_ex.set_hide(top,i,true,false);
	end
	--------------------------------------------
	local size_cap_l = SIZE('s_face_det_l_cap_line');
	local size_t_l = SIZE('s_face_det_l_t_line');
	local size_cap_r = SIZE('s_face_det_r_cap_line');
	local size_t_r = SIZE('s_face_det_r_t_line');
	local size_int = SIZE('s_face_det_int_xywh');
	local size_tt_check = SIZE('s_face_det_tt_check_xywh');
	for i = 1, show_line do
		if show_list_l[2*i+display_off*2-1] ~= nil then
			local pos = {size_cap_l[1],size_cap_l[2]+size_int[3]*(i-1),size_cap_l[3],size_cap_l[4]};
			b_wnd_ex.move_ex(top,show_list_l[2*i+display_off*2-1],pos,false);
			b_wnd_ex.set_hide(top, show_list_l[2*i+display_off*2-1],false,false);
			local flag = is_tt_check(show_list_l[2*i+display_off*2])
			if flag == true then
				local pos = {size_t_l[1]-size_tt_check[1],size_t_l[2]+size_int[3]*(i-1)+size_tt_check[2],size_tt_check[3],size_tt_check[4]};
				b_wnd_ex.move_ex(top,show_list_l[2*i+display_off*2],pos,false);
			else
				local pos = {size_t_l[1],size_t_l[2]+size_int[3]*(i-1),size_t_l[3],size_t_l[4]};
				b_wnd_ex.move_ex(top,show_list_l[2*i+display_off*2],pos,false);
			end
			b_wnd_ex.set_hide(top, show_list_l[2*i+display_off*2],false,false);
		end
		if show_list_r[2*i+display_off*2-1] ~= nil then
			local pos = {size_cap_r[1],size_cap_r[2]+size_int[3]*(i-1),size_cap_r[3],size_cap_r[4]};
			b_wnd_ex.move_ex(top,show_list_r[2*i+display_off*2-1],pos,false);
			b_wnd_ex.set_hide(top, show_list_r[2*i+display_off*2-1],false,false);
			local flag = is_tt_check(show_list_r[2*i+display_off*2])
			if flag == true then
				local pos = {size_t_r[1]-size_tt_check[1],size_t_r[2]+size_int[3]*(i-1)+size_tt_check[2],size_tt_check[3],size_tt_check[4]};
				b_wnd_ex.move_ex(top,show_list_r[2*i+display_off*2],pos,false);
			else
				local pos = {size_t_r[1],size_t_r[2]+size_int[3]*(i-1),size_t_r[3],size_t_r[4]};
				b_wnd_ex.move_ex(top,show_list_r[2*i+display_off*2],pos,false);
			end
			b_wnd_ex.set_hide(top, show_list_r[2*i+display_off*2],false,false);
		end
	end
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_param_confface_detect.cfg_data)
	end
	return 0;
end

local on_snap_change = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_param_confface_detect.wnd;
		local param = w1_page_param_confface_detect.cfg_data;
		local sel = b_wnd_ex.get_sel(top,cwnd.t_snap_mode.id);
		if sel == 0 or sel == 2 then
			b_wnd_ex.set_text(top,cwnd.cap_img_int.id,STR('LA_UPLOAD_IMAGE_INTERVAL'),false);
			b_wnd_ex.set_value(top,cwnd.t_img_int.id,param.upload_inteval,false);
		else
			b_wnd_ex.set_text(top,cwnd.cap_img_int.id,STR('LA_SNAP_COUNT'),false);
			b_wnd_ex.set_value(top,cwnd.t_img_int.id,param.snap_count,false);
		end
		uitousercfg(top,w1_page_param_confface_detect.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_area_change = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cfgdata = w1_page_param_confface_detect.cfg_data
		local cwnd = w1_page_param_confface_detect.wnd;
		local areaid = b_wnd_ex.get_sel(top,cwnd.t_area_id.id)+1
		cfgdata.areaid = areaid-1
		b_wnd_ex.set_value(top,cwnd.t_pix_min.id,cfgdata.area.region_list['region'..areaid].min_pix,false);
		b_wnd_ex.set_value(top,cwnd.t_pix_max.id,cfgdata.area.region_list['region'..areaid].max_pix,false);
		b_wnd_ex.clear_intarea(top,image_id,false,false);
		local intarea = {};
		intarea['area'..1] = {};
		intarea['area'..1].points = {};
		intarea['area'..1].point_num = cfgdata.area.region_list['region'..areaid].point_num 
		for j = 1,  intarea['area'..1].point_num do
			intarea['area'..1].points['point'..j]= {};
			intarea['area'..1].points['point'..j].x = cfgdata.area.region_list['region'..areaid].points['point'..j].x
			intarea['area'..1].points['point'..j].y = cfgdata.area.region_list['region'..areaid].points['point'..j].y
		end
		if intarea['area'..1].point_num ~= nil and intarea['area'..1].point_num ~= 0 then
			b_wnd_ex.set_intarea(top,image_id,intarea,false);
		end
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

w1_page_param_confface_detect.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_param_confface_detect.wnd;
	if bool_hide == true then
		local s_id = cwnd.cap_face_detect.id
		local e_id = cwnd.t_vdrop.id
		for i=s_id, e_id do
			b_wnd_ex.set_hide(top,i,bool_hide,redraw);
		end
	else
		b_wnd_ex.set_hide(top,cwnd.hline.id,bool_hide,redraw);
	end
end

w1_page_param_confface_detect.set_param = function(top, param, redraw)
	w1_page_param_confface_detect.cfg_data = param
	local cwnd = w1_page_param_confface_detect.wnd;
	index_l = 1;
	show_list_l = {}
	show_list_r = {}
	b_wnd_ex.set_check(top,cwnd.t_face_detect.id,param.face_enable,false);
	show_list_l[index_l] = cwnd.cap_face_detect.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_face_detect.id
	index_l = index_l + 1;
	b_wnd_ex.set_sel(top,cwnd.t_trace_info.id,param.object_mode,false);
	show_list_l[index_l] = cwnd.cap_trace_info.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_trace_info.id
	index_l = index_l + 1;
	b_wnd_ex.set_check(top,cwnd.t_detect_area.id,param.area_enable,false);
	show_list_l[index_l] = cwnd.cap_detect_area.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_detect_area.id
	index_l = index_l + 1;
	if param.reliability == 30 then
		b_wnd_ex.set_sel(top,cwnd.t_con_coe.id,0,false);
	elseif param.reliability == 60 then
		b_wnd_ex.set_sel(top,cwnd.t_con_coe.id,1,false);
	else
		b_wnd_ex.set_sel(top,cwnd.t_con_coe.id,2,false);
	end
	show_list_l[index_l] = cwnd.cap_con_coe.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_con_coe.id
	index_l = index_l + 1;
	local items = {}
	for i=1, param.area.area_list_num do
		items[i]=i
	end
	b_wnd_ex.set_items(top,cwnd.t_area_id.id,items,false);
	b_wnd_ex.set_sel(top,cwnd.t_area_id.id,param.areaid,false)
	show_list_l[index_l] = cwnd.cap_area_id.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_area_id.id
	index_l = index_l + 1;
	b_wnd_ex.set_value(top,cwnd.t_pix_min.id,param.area.region_list['region'..param.areaid+1].min_pix,false);
	show_list_l[index_l] = cwnd.cap_pix_min.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_pix_min.id
	index_l = index_l + 1;
	b_wnd_ex.set_value(top,cwnd.t_pix_max.id,param.area.region_list['region'..param.areaid+1].max_pix,false);
	show_list_l[index_l] = cwnd.cap_pix_max.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_pix_max.id
	index_l = index_l + 1;
	if param.pic_quality == 30 then
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,0,false);
	elseif param.pic_quality == 60 then
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,1,false);
	elseif param.pic_quality == 80 then
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,2,false);
	else
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,3,false);
	end	
	show_list_l[index_l] = cwnd.cap_mat_qua.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_mat_qua.id
	
	index_r = 1;
	if param.snap_pic_mode == 0 then
		b_wnd_ex.set_sel(top,cwnd.t_snap_mode.id,0,false);
	elseif param.snap_pic_mode == 1 then
		b_wnd_ex.set_sel(top,cwnd.t_snap_mode.id,1,false);
	else
		b_wnd_ex.set_sel(top,cwnd.t_snap_mode.id,2,false);
	end
	show_list_r[index_r] = cwnd.cap_snap_mode.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_snap_mode.id
	index_r = index_r + 1;
	if param.snap_pic_mode == 0 or param.snap_pic_mode == 4 then
		b_wnd_ex.set_text(top,cwnd.cap_img_int.id,STR('LA_UPLOAD_IMAGE_INTERVAL'),false);
		b_wnd_ex.set_value(top,cwnd.t_img_int.id,param.upload_inteval,false);
	else
		b_wnd_ex.set_text(top,cwnd.cap_img_int.id,STR('LA_SNAP_COUNT'),false);
		b_wnd_ex.set_value(top,cwnd.t_img_int.id,param.snap_count,false);
	end
	show_list_r[index_r] = cwnd.cap_img_int.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_img_int.id
	index_r = index_r + 1;
	b_wnd_ex.set_value(top,cwnd.t_yaw_deg.id,param.yawdegree,false);
	show_list_r[index_r] = cwnd.cap_yaw_deg.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_yaw_deg.id
	index_r = index_r + 1;
	b_wnd_ex.set_value(top,cwnd.t_tilt_deg.id,param.tiltdegree,false);
	show_list_r[index_r] = cwnd.cap_tilt_deg.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_tilt_deg.id
	index_r = index_r + 1;
	b_wnd_ex.set_value(top,cwnd.t_pitch_deg.id,param.petchdegree,false);
	show_list_r[index_r] = cwnd.cap_pitch_deg.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_pitch_deg.id
	index_r = index_r + 1;
	b_wnd_ex.set_check(top,cwnd.t_ftp_img_mat.id,param.ftpupload_enable,false);
	show_list_r[index_r] = cwnd.cap_ftp_img_mat.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_ftp_img_mat.id
	index_r = index_r + 1;
	b_wnd_ex.set_check(top,cwnd.t_ftp_whole_img.id,param.fuleview_enable,false);
	show_list_r[index_r] = cwnd.cap_ftp_whole_img.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_ftp_whole_img.id
	index_r = index_r + 1;
	b_wnd_ex.set_check(top,cwnd.t_osd.id,param.picosd_enable,false);
	show_list_r[index_r] = cwnd.cap_osd.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_osd.id
	index_r = index_r + 1;
	b_wnd_ex.set_text(top,cwnd.t_alg_lib_ver.id,param.algoversion,false)
	show_list_r[index_r] = cwnd.cap_alg_lib_ver.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_alg_lib_ver.id
	
	if index_l > index_r then
		total_show = index_l/2
	else
		total_show = index_r/2
	end
	if total_show > show_line then
		local v_drop = {};
		v_drop.set_cur = display_off;
		v_drop.set_cap = show_line;
		v_drop.set_max = total_show
		b_wnd_ex.set_drop(top,cwnd.t_vdrop.id,v_drop,false);
		b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,false,false);
	else
		b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,true,false);
	end
	move_ex(top);
end

w1_page_param_confface_detect.datacheck = function(top)
	local cwnd = w1_page_param_confface_detect.wnd;
	local cfgdata = w1_page_param_confface_detect.cfg_data
	for i=1, 8 do
		local mix_pix = cfgdata.area.region_list['region'..i].min_pix
		local max_pix = cfgdata.area.region_list['region'..i].max_pix
		if mix_pix < 1 or mix_pix > 2000 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_AREA_ID')..i..' '..STR('LA_PIX_MIN')..')'
		end
		if max_pix < 1 or max_pix > 2000 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_AREA_ID')..i..' '..STR('LA_PIX_MAX')..')'
		end
		if mix_pix > max_pix then
			return false,STR('LA_ERR_MIN_BIGGER_MAX')..'('..STR('LA_AREA_ID')..i..')'
		end
	end
	local sel = b_wnd_ex.get_sel(top,cwnd.t_snap_mode.id);
	local time = b_wnd_ex.get_value(top,cwnd.t_img_int.id);
	if sel == 0 or sel == 2 then
		if time < 1 or time > 10 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_UPLOAD_IMAGE_INTERVAL')..')'
		end
	else
		if time < 1 or time > 10 then
			return false,STR('LA_OUT_RANGE')..'('..STR('LA_SNAP_COUNT')..')'
		end
	end
	
	return true,nil
end

w1_page_param_confface_detect.dwell_updata_f =function(top)
	if total_show > show_line then
		display_off = b_wnd_ex.get_drop(top,w1_page_param_confface_detect.wnd.t_vdrop.id);
		move_ex(top);
		b_dlg.dlg_set_redraw(top);
	end
end

w1_page_param_confface_detect.dwell_mouse_up =function(top)
	if total_show > show_line then
		if display_off > 0 then
			display_off = display_off-1
		end
		local vdrop = {};
		vdrop.set_cur = display_off;
		vdrop.set_cap = show_line;
		vdrop.set_max = total_show;
		b_wnd_ex.set_drop(top,w1_page_param_confface_detect.wnd.t_vdrop.id,vdrop,false);
		move_ex(top)
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_param_confface_detect.dwell_mouse_down =function(top)
	if total_show > show_line then
		if display_off < total_show - show_line then
			display_off = display_off+1
		end
		local vdrop = {};
		vdrop.set_cur = display_off;
		vdrop.set_cap = show_line;
		vdrop.set_max = total_show;
		b_wnd_ex.set_drop(top,w1_page_param_confface_detect.wnd.t_vdrop.id,vdrop,false);
		move_ex(top);
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_param_confface_detect.dwell_drop_drag =function(top)
	if total_show > show_line then
		display_off = b_wnd_ex.get_drop(top,w1_page_param_confface_detect.wnd.t_vdrop.id);
		move_ex(top);
		b_dlg.dlg_set_redraw(top);	
	end
end

w1_page_param_confface_detect.on_pre_show = function(top)
	local dlg_w, dlg_h = global_val.get_size();
	local cwnd = w1_page_param_confface_detect.wnd;
	tt_check_list_id[1] = cwnd.t_face_detect.id;
	tt_check_list_id[2] = cwnd.t_detect_area.id;
	tt_check_list_id[3] = cwnd.t_ftp_img_mat.id;
	tt_check_list_id[4] = cwnd.t_ftp_whole_img.id;
	tt_check_list_id[5] = cwnd.t_osd.id;
	tt_check_count = 5;
	if(dlg_w == 1280 or dlg_h == 1024) then
		show_line = 7;
	elseif(dlg_w == 1440 or dlg_h == 900) then
		show_line = 7;
	else
		show_line = 8;
	end
	local s_id = cwnd.cap_face_detect.id
	local e_id = cwnd.hline.id
	for i = s_id, e_id do
		b_wnd_ex.set_hide(top,i,true,false);
	end
end

w1_page_param_confface_detect.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_param_confface_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'cap_face_detect','t_face_detect','cap_trace_info','t_trace_info','cap_detect_area','t_detect_area','cap_con_coe','t_con_coe',
	'cap_area_id','t_area_id','cap_pix_min','t_pix_min','cap_pix_max','t_pix_max','cap_mat_qua','t_mat_qua','cap_snap_mode','t_snap_mode',
	'cap_img_int','t_img_int','cap_yaw_deg','t_yaw_deg','cap_tilt_deg','t_tilt_deg','cap_pitch_deg','t_pitch_deg','cap_ftp_img_mat','t_ftp_img_mat',
	'cap_ftp_whole_img','t_ftp_whole_img','cap_osd','t_osd','cap_alg_lib_ver','t_alg_lib_ver','hline','t_vdrop'},
	cap_face_detect= {t='static',	id=id+1,	xywh='s_face_det_cap_face_detect_xywh',text='LA_FACE_DETECT', align = b_ui.ALIGN.LEFT},
	t_face_detect = {t='tt_check',id=id+2,	xywh='s_face_det_t_face_detect_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_trace_info= {t='static',	id=id+3,	xywh='s_face_det_cap_trace_info_xywh',text='LA_TRACE_INFO', align = b_ui.ALIGN.LEFT},
	t_trace_info = {t='combox',	id=id+4,	xywh='s_face_det_t_trace_info_xywh' ,items = {'LA_OFF','LA_MODE_1','LA_MODE_2'},cmd = on_update_param},
	cap_detect_area= {t='static',	id=id+5,	xywh='s_face_det_cap_detect_area_xywh',text='LA_DETECT_AREA', align = b_ui.ALIGN.LEFT},
	t_detect_area = {t='tt_check',id=id+6,	xywh='s_face_det_t_detect_area_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_con_coe= {t='static',	id=id+7,	xywh='s_face_det_cap_con_coe_xywh',text='LA_CONFIDENCE_DEGREE', align = b_ui.ALIGN.LEFT},
	t_con_coe = {t='combox',	id=id+8,	xywh='s_face_det_t_con_coe_xywh' ,
					items = {'LA_LOW','LA_MEDIUM','LA_HIGH'},cmd = on_update_param},
	cap_area_id= {t='static',	id=id+9,	xywh='s_face_det_cap_area_id_xywh',text='LA_AREA_ID', align = b_ui.ALIGN.LEFT},
	t_area_id = {t='combox',	id=id+10,	xywh='s_face_det_t_area_id_xywh',items = {},trans = false,cmd = on_area_change},
	cap_pix_min= {t='static',	id=id+11,	xywh='s_face_det_cap_pix_min_xywh',text='LA_PIX_MIN', align = b_ui.ALIGN.LEFT},
	t_pix_min = {t='edit_num',id=id+12,xywh='s_face_det_t_pix_min_xywh',range={1,2000},cmd = on_update_param},
	cap_pix_max= {t='static',	id=id+13,	xywh='s_face_det_cap_pix_max_xywh',text='LA_PIX_MAX', align = b_ui.ALIGN.LEFT},
	t_pix_max = {t='edit_num',id=id+14,xywh='s_face_det_t_pix_max_xywh',range={1,2000},cmd = on_update_param},
	cap_mat_qua= {t='static',	id=id+15,	xywh='s_face_det_cap_mat_qua_xywh',text='LA_MAT_QUA', align = b_ui.ALIGN.LEFT},
	t_mat_qua = {t='combox',	id=id+16,	xywh='s_face_det_t_mat_qua_xywh' ,items = {'LA_LOW','LA_MEDIUM','LA_HIGH','LA_HIGHEST'},cmd = on_update_param},
	cap_snap_mode= {t='static',	id=id+17,	xywh='s_face_det_cap_snap_mode_xywh',text='LA_SNAPSHOT_MODE', align = b_ui.ALIGN.LEFT},
	t_snap_mode = {t='combox',	id=id+18,	xywh='s_face_det_t_snap_mode_xywh',items = {'LA_TIMING','LA_OPTIMAL','LA_TIMER_OPTIMAL'},cmd = on_snap_change},
	cap_img_int= {t='static',	id=id+19,	xywh='s_face_det_cap_img_int_xywh',text='LA_UPLOAD_IMAGE_INTERVAL', align = b_ui.ALIGN.LEFT},
	t_img_int = {t='edit_num',id=id+20,xywh='s_face_det_t_img_int_xywh',range={0,10},cmd = on_update_param},
	cap_yaw_deg= {t='static',	id=id+21,	xywh='s_face_det_cap_yaw_deg_xywh',text='LA_YAW_DEGREE', align = b_ui.ALIGN.LEFT},
	t_yaw_deg = {t='edit_num',id=id+22,xywh='s_face_det_t_yaw_deg_xywh',range={0,90},cmd = on_update_param},
	cap_tilt_deg= {t='static',	id=id+23,	xywh='s_face_det_cap_tilt_deg_xywh',text='LA_TILT_DEGREE', align = b_ui.ALIGN.LEFT},
	t_tilt_deg = {t='edit_num',id=id+24,xywh='s_face_det_t_tilt_deg_xywh',range={0,90},cmd = on_update_param},
	cap_pitch_deg= {t='static',	id=id+25,	xywh='s_face_det_cap_pitch_deg_xywh',text='LA_PITCH_DEGREE', align = b_ui.ALIGN.LEFT},
	t_pitch_deg = {t='edit_num',id=id+26,xywh='s_face_det_t_pitch_deg_xywh',range={0,90},cmd = on_update_param},
	cap_ftp_img_mat= {t='static',	id=id+27,	xywh='s_face_det_cap_ftp_img_mat_xywh',text='LA_FTP_UPLOAD_IMAGE_MATTING', align = b_ui.ALIGN.LEFT},
	t_ftp_img_mat = {t='tt_check',id=id+28,	xywh='s_face_det_t_ftp_img_mat_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_ftp_whole_img = {t='static',	id=id+29,	xywh='s_face_det_cap_ftp_whole_img_xywh',text='LA_FTP_UPLOAD_WHOLE_IMAGE', align = b_ui.ALIGN.LEFT},
	t_ftp_whole_img = {t='tt_check',id=id+30,	xywh='s_face_det_t_ftp_whole_img_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_osd = {t='static',	id=id+31,	xywh='s_face_det_cap_osd_xywh',text='LA_OSD_OVERLAY_SNAPSHOT', align = b_ui.ALIGN.LEFT},
	t_osd = {t='tt_check',id=id+32,	xywh='s_face_det_t_osd_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_alg_lib_ver = {t='static',	id=id+33,	xywh='s_face_det_cap_alg_lib_ver_xywh',text='LA_ALG_LIB_VER', align = b_ui.ALIGN.LEFT},
	t_alg_lib_ver = {t='static',	id=id+34,	xywh='s_face_det_t_alg_lib_ver_xywh',text='', trans=false, align = b_ui.ALIGN.LEFT},
	hline 	= {t='hline',	id=id+35,xywh='s_face_det_hline_xywh'},
	t_vdrop = {t='vdrop', id=id+36,xywh='s_face_det_vdrop_xywh'};
}

return w1_page_param_confface_detect

