-- UIʹõȷȡԻ
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.plate_bwadv_id;
local cjson 	= require("cjson")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_legal 	= require("wnd.w1_util.w1_legal")
local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")
local w1_wnd_util			= require("wnd.w1_cfg.w1_wnd_util")
local b_app_api 			= require("wnd.core.command.b_app_api")
local util 		= require("wnd.core.util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 

local w1_page_plate_bwadv = {
	t = w1_key.DLG_PLATE_BWADV,
	top = nil,
	dlg = nil,
	cfgData = nil;
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_plate_bwadv.s_768 = 
{
	s_bwadv_xywh = {338,284,346,227},
	s_bwadv_cap_type_xywh = {26,56,106,28},
	s_bwadv_t_type_xywh = {176,56,133,28},
	s_bwadv_cap_enable_xywh = {26,99,106,28},
	s_bwadv_t_enable_xywh = {172,103,25,21},
	s_bwadv_ok_xywh = {197,177,64,27},
	s_bwadv_cancel_xywh = {272,177,64,27},
}

w1_page_plate_bwadv.s_1280 = 
{
	s_bwadv_xywh={315,400,650,320},
	s_bwadv_cap_type_xywh= {50,80,200,40},
	s_bwadv_t_type_xywh= {330,80,250,40},
	s_bwadv_cap_enable_xywh= {50,140,200,40},
	s_bwadv_t_enable_xywh= {323,145,48,30},
	s_bwadv_ok_xywh= {370,250,120,38},
	s_bwadv_cancel_xywh= {510,250,120,38},
}
w1_page_plate_bwadv.s_1440 = 
{
	s_bwadv_xywh={395,310,650,320},
	s_bwadv_cap_type_xywh= {50,80,200,40},
	s_bwadv_t_type_xywh= {330,80,250,40},
	s_bwadv_cap_enable_xywh= {50,140,200,40},
	s_bwadv_t_enable_xywh= {323,145,48,30},
	s_bwadv_ok_xywh= {370,250,120,38},
	s_bwadv_cancel_xywh= {510,250,120,38},
}
w1_page_plate_bwadv.s_1080p = 
{
	s_bwadv_xywh ={635,400,650,320},
	s_bwadv_cap_type_xywh= {50,80,200,40},
	s_bwadv_t_type_xywh= {330,80,250,40},
	s_bwadv_cap_enable_xywh= {50,140,200,40},
	s_bwadv_t_enable_xywh= {323,145,48,30},
	s_bwadv_ok_xywh= {370,250,120,38},
	s_bwadv_cancel_xywh= {510,250,120,38},
}

w1_page_plate_bwadv.s_2k = 
{
	s_bwadv_xywh={846,533,866,426},
	s_bwadv_cap_type_xywh= {67,107,267,53},
	s_bwadv_t_type_xywh= {440,107,333,53},
	s_bwadv_cap_enable_xywh= {67,187,267,53},
	s_bwadv_t_enable_xywh= {433,193,53,40},
	s_bwadv_ok_xywh= {493,333,160,51},
	s_bwadv_cancel_xywh= {680,333,160,51},

}

w1_page_plate_bwadv.s_4k = 
{
	s_bwadv_xywh= {1270,800,1300,640},
	s_bwadv_cap_type_xywh= {100,160,400,80},
	s_bwadv_t_type_xywh= {660,160,500,80},
	s_bwadv_cap_enable_xywh= {100,280,400,80},
	s_bwadv_t_enable_xywh= {646,290,96,60},
	s_bwadv_ok_xywh= {740,500,240,76},
	s_bwadv_cancel_xywh= {1020,500,240,76},	
}


local is_change = function(top)
	if (w1_page_plate_bwadv.cfgData.BlackListOpenBarrier ~= w1_page_plate_bwadv.old_cfgData.BlackListOpenBarrier) then
		return true;
	end
	
	if (w1_page_plate_bwadv.cfgData.WhilteListOpenBarrier ~= w1_page_plate_bwadv.old_cfgData.WhilteListOpenBarrier) then
		return true;
	end
	
	if (w1_page_plate_bwadv.cfgData.NoListOpenBarrier ~= w1_page_plate_bwadv.old_cfgData.NoListOpenBarrier) then
		return true;
	end
	
	if (w1_page_plate_bwadv.cfgData.OpenBarrierLevel ~= w1_page_plate_bwadv.old_cfgData.OpenBarrierLevel) then
		return true;
	end
	
	return false;
end

local save_change = function(param)
	b_app_api.set_link_plate_detect_bw_list(w1_page_plate_bwadv.cfgData)
	
	return 0
end

w1_page_plate_bwadv.set_dlgattr = function(data)
	if(data ~= nil) then
		assert(type(data) == 'table');
		w1_page_plate_bwadv.cfgData = data;
	end
end 

local on_enable = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local c_wnd = w1_page_plate_bwadv.dlg;
		local check = b_wnd_ex.get_check(top, c_wnd.t_enable.id);
		local enable = 0;
		if (check == true) then
			enable = 1;
		end
		local sel = b_wnd_ex.get_sel(top, c_wnd.t_type.id);
		if (sel == 0) then
			w1_page_plate_bwadv.cfgData.BlackListOpenBarrier = enable;
		elseif (sel == 1) then
			w1_page_plate_bwadv.cfgData.WhilteListOpenBarrier = enable;
		elseif (sel == 2) then
			w1_page_plate_bwadv.cfgData.NoListOpenBarrier = enable;
		else
			w1_page_plate_bwadv.cfgData.OpenBarrierLevel = enable;
		end
	end
	
	return 0;
end

local on_type_change = function(top, id, vmsg, x, y)
	if vmsg == b_ui_msg.msg_user_update_parent then
		local c_wnd = w1_page_plate_bwadv.dlg;
		local sel = b_wnd_ex.get_sel(top, c_wnd.t_type.id);
		local enable = 0;
		if (sel == 0) then
			enable = w1_page_plate_bwadv.cfgData.BlackListOpenBarrier;
		elseif (sel == 1) then
			enable = w1_page_plate_bwadv.cfgData.WhilteListOpenBarrier;
		elseif (sel == 2) then
			enable = w1_page_plate_bwadv.cfgData.NoListOpenBarrier;
		else
			enable = w1_page_plate_bwadv.cfgData.OpenBarrierLevel;
		end
		local check = false;
		if (enable == 1) then
			check = true;
		end
		
		b_wnd_ex.set_check(top, c_wnd.t_enable.id, check, true);
	end
	
	return 0;
end

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_plate_bwadv.dlg;
		if (true == is_change()) then
			b_app_api.set_link_plate_detect_bw_list(w1_page_plate_bwadv.cfgData)
		end
		
		b_dlg.end_modal(top);
	end
	return 0
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local dlg = {
	attr 	= {xywh='s_bwadv_xywh',},
	sub 	= {'cap_type', 't_type', 'cap_enable', 't_enable','ok', 'cancel'},
	
	cap_type	 = {t='static',	id=id+1,	xywh = 's_bwadv_cap_type_xywh',	
				text='LA_LIST_TYPE', font = 'f_grade6',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_type 	= {t='combox', id=id+2,xywh='s_bwadv_t_type_xywh', 
					items={'LA_RULE_BLACK','LA_RULE_WHITE', 'LA_NOT_ON_LIST', 'LA_ALL'},
					cmd = on_type_change,
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},					
	cap_enable	 = {t='static',	id=id+3,	xywh = 's_bwadv_cap_enable_xywh',
				text='LA_OPEN_GATE', font = 'f_grade6',
				color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
	t_enable 	= {t='tt_check', id=id+4,xywh='s_bwadv_t_enable_xywh',
				t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
				color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
				cmd = on_enable},						
				
	ok		= {t='button',	id=id+5,	xywh = 's_bwadv_ok_xywh',	text='LA_OK',font='f_grade6',
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					cmd=on_ok},
	cancel	= {t='button',	id=id+6,	xywh = 's_bwadv_cancel_xywh',text='LA_CANCEL',font='f_grade6',
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
					cmd=on_cancel}			
}

w1_page_plate_bwadv.on_create = function(top)
	w1_page_plate_bwadv.top = top
	w1_page_plate_bwadv.dlg = dlg;
	b_parser(top, w1_page_plate_bwadv.dlg)
	
	return 0
end

w1_page_plate_bwadv.clear_data = function()
	w1_page_plate_bwadv.cfgData = nil;
	w1_page_plate_bwadv.old_cfgData = nil;
end

w1_page_plate_bwadv.set_channel = function(channel)
	w1_page_plate_bwadv.channel = channel
end	

w1_page_plate_bwadv.on_destroy = function(top)
	w1_page_plate_bwadv.top = nil
	w1_page_plate_bwadv.dlg = nil
	w1_page_plate_bwadv.clear_data();
	return 0
end

w1_page_plate_bwadv.on_pre_show = function(top)
	local items = {};
	table.insert(items, STR('LA_RULE_BLACK'));
	table.insert(items, STR('LA_RULE_WHITE'));
	table.insert(items, STR('LA_NOT_ON_LIST'));
	table.insert(items, STR('LA_ALL'));
	local c_wnd = w1_page_plate_bwadv.dlg;
	b_wnd_ex.set_items(top, c_wnd.t_type.id, items, false);
	
	w1_page_plate_bwadv.cfgData = b_app_api.get_link_plate_detect_bw_list(w1_page_plate_bwadv.channel);	
	w1_page_plate_bwadv.old_cfgData = {};
	util.copy_tab_b(w1_page_plate_bwadv.old_cfgData, w1_page_plate_bwadv.cfgData);
	
	b_wnd_ex.set_sel(top, c_wnd.t_type.id, 0, false);
	local check = false;
	if (w1_page_plate_bwadv.cfgData.BlackListOpenBarrier == 1) then
		check = true
	end	
	b_wnd_ex.set_check(top, c_wnd.t_enable.id, check, false);	
	
	return 0
end

w1_page_plate_bwadv.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'))
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1)
	b_wnd.end_job(top)
	return 0
end

w1_page_plate_bwadv.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.dlg_set_redraw(top);
	elseif(b_ui.RBUTTONCLK == vmsg) then
	
		local ret = is_change(top);
		if ret == true then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_WANT_SAVE'), true, true, false,STR('LA_YES'), STR('LA_BAD'));
			w1_msgbox.set_func(save_change,{top}, nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			w1_msgbox.set_func(nil,nil, nil,nil);
		end
		
		b_dlg.end_modal(top);
	end	
	return 0
end

return w1_page_plate_bwadv




