-- ӡ༭ͨҳ
local global_val	= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.plate_bwedit_id;
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local cjson 	= require("cjson")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local util 			= require("wnd.core.util")

local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")

local w1_page_plate_edit = {
	t = w1_key.DLG_PLATE_EDIT,
	top = nil,
	dlg = nil,
	edit_type,		--0:, 1:༭, 2ɾ
	save_check_illegal,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	data,
	click_idx,
	ok_func,
	okfunc_param,
	time_fmt,
	channel,
}

w1_page_plate_edit.s_768 = 
{
	s_plate_edit_xywh = {282,241,458,284},
	s_plate_edit_titleimg_xywh = {6,8,21,28},
	s_plate_edit_titlestr_xywh = {33,8,253,28},
	s_plate_edit_titleclose_xywh = {426,8,21,28},
	s_plate_edit_cap_plate_xywh = {26,42,186,28},
	s_plate_edit_t_plate_xywh = {245,42,181,28},
	s_plate_edit_cap_libname_xywh = {26,78,186,28},
	s_plate_edit_t_libname_xywh = {245,78,181,28},
	s_plate_edit_cap_type_xywh = {26,113,186,28},
	s_plate_edit_t_type_xywh = {245,113,181,28},
	s_plate_edit_cap_btime_xywh = {26,149,186,28},
	s_plate_edit_t_bdate_xywh = {245,149,90,28},
	s_plate_edit_t_btime_xywh = {336,149,90,28},
	s_plate_edit_cap_etime_xywh = {26,184,186,28},
	s_plate_edit_t_edate_xywh = {245,184,90,28},
	s_plate_edit_t_etime_xywh = {336,184,90,28},
	s_plate_edit_tipinfo_xywh = {26,220,240,14},
	s_plate_edit_hline3_xywh = {26,241,405,1},
	s_plate_edit_ok_xywh = {293,245,64,27},
	s_plate_edit_cancel_xywh = {368,245,64,27},
};

w1_page_plate_edit.s_1280 = 
{
	s_plate_edit_xywh = {210,312,860,400},
	s_plate_edit_titleimg_xywh = {12,12,40,40},
	s_plate_edit_titlestr_xywh = {62,12,476,40},
	s_plate_edit_titleclose_xywh = {800,12,40,40},
	s_plate_edit_cap_plate_xywh = {50,60,350,40},
	s_plate_edit_t_plate_xywh = {460,60,340,40},
	s_plate_edit_cap_libname_xywh = {50,110,350,40},
	s_plate_edit_t_libname_xywh = {460,110,340,40},
	s_plate_edit_cap_type_xywh = {50,160,350,40},
	s_plate_edit_t_type_xywh = {460,160,340,40},
	s_plate_edit_cap_btime_xywh = {50,210,350,40},
	s_plate_edit_t_bdate_xywh = {460,210,170,40},
	s_plate_edit_t_btime_xywh = {630,210,170,40},
	s_plate_edit_cap_etime_xywh = {50,260,350,40},
	s_plate_edit_t_edate_xywh = {460,260,170,40},
	s_plate_edit_t_etime_xywh = {630,260,170,40},
	s_plate_edit_tipinfo_xywh= {50,310,450,20},
	s_plate_edit_hline3_xywh= {50,340,760,1},
	s_plate_edit_ok_xywh= {550,345,120,38},
	s_plate_edit_cancel_xywh= {690,345,120,38},
};

w1_page_plate_edit.s_1440 = 
{
	s_plate_edit_xywh = {290,250,860,400},
	s_plate_edit_titleimg_xywh = {12,12,40,40},
	s_plate_edit_titlestr_xywh = {62,12,476,40},
	s_plate_edit_titleclose_xywh = {800,12,40,40},
	s_plate_edit_cap_plate_xywh = {50,60,350,40},
	s_plate_edit_t_plate_xywh = {460,60,340,40},
	s_plate_edit_cap_libname_xywh = {50,110,350,40},
	s_plate_edit_t_libname_xywh = {460,110,340,40},
	s_plate_edit_cap_type_xywh = {50,160,350,40},
	s_plate_edit_t_type_xywh = {460,160,340,40},
	s_plate_edit_cap_btime_xywh = {50,210,350,40},
	s_plate_edit_t_bdate_xywh = {460,210,170,40},
	s_plate_edit_t_btime_xywh = {630,210,170,40},
	s_plate_edit_cap_etime_xywh = {50,260,350,40},
	s_plate_edit_t_edate_xywh = {460,260,170,40},
	s_plate_edit_t_etime_xywh = {630,260,170,40},
	s_plate_edit_tipinfo_xywh= {50,310,450,20},
	s_plate_edit_hline3_xywh= {50,340,760,1},
	s_plate_edit_ok_xywh= {550,345,120,38},
	s_plate_edit_cancel_xywh= {690,345,120,38},
};

w1_page_plate_edit.s_1080p = 
{
	s_plate_edit_xywh = {530,340,860,400},
	s_plate_edit_titleimg_xywh = {12,12,40,40},
	s_plate_edit_titlestr_xywh = {62,12,476,40},
	s_plate_edit_titleclose_xywh = {800,12,40,40},
	s_plate_edit_cap_plate_xywh = {50,60,350,40},
	s_plate_edit_t_plate_xywh = {460,60,340,40},
	s_plate_edit_cap_libname_xywh = {50,110,350,40},
	s_plate_edit_t_libname_xywh = {460,110,340,40},
	s_plate_edit_cap_type_xywh = {50,160,350,40},
	s_plate_edit_t_type_xywh = {460,160,340,40},
	s_plate_edit_cap_btime_xywh = {50,210,350,40},
	s_plate_edit_t_bdate_xywh = {460,210,170,40},
	s_plate_edit_t_btime_xywh = {630,210,170,40},
	s_plate_edit_cap_etime_xywh = {50,260,350,40},
	s_plate_edit_t_edate_xywh = {460,260,170,40},
	s_plate_edit_t_etime_xywh = {630,260,170,40},
	s_plate_edit_tipinfo_xywh= {50,310,450,20},
	s_plate_edit_hline3_xywh= {50,340,760,1},
	s_plate_edit_ok_xywh= {550,345,120,38},
	s_plate_edit_cancel_xywh= {690,345,120,38},
};

w1_page_plate_edit.s_2k = 
{
	s_plate_edit_xywh = {706,453,1146,533},
	s_plate_edit_titleimg_xywh = {15,15,53,53},
	s_plate_edit_titlestr_xywh = {82,15,634,53},
	s_plate_edit_titleclose_xywh = {1066,15,53,53},
	s_plate_edit_cap_plate_xywh = {66,79,466,53},
	s_plate_edit_t_plate_xywh = {613,79,453,53},
	s_plate_edit_cap_libname_xywh = {66,146,466,53},
	s_plate_edit_t_libname_xywh = {613,146,453,53},
	s_plate_edit_cap_type_xywh = {66,213,466,53},
	s_plate_edit_t_type_xywh = {613,213,453,53},
	s_plate_edit_cap_btime_xywh = {66,279,466,53},
	s_plate_edit_t_bdate_xywh = {613,279,226,53},
	s_plate_edit_t_btime_xywh = {839,279,226,53},
	s_plate_edit_cap_etime_xywh = {66,346,466,53},
	s_plate_edit_t_edate_xywh = {613,346,226,53},
	s_plate_edit_t_etime_xywh = {839,346,226,53},
	s_plate_edit_tipinfo_xywh = {66,413,599,26},
	s_plate_edit_hline3_xywh = {66,453,1013,1},
	s_plate_edit_ok_xywh = {733,459,159,50},
	s_plate_edit_cancel_xywh = {919,459,159,50},
};

w1_page_plate_edit.s_4k = 
{
	s_plate_edit_xywh = {1060,680,1720,800},
	s_plate_edit_titleimg_xywh = {24,24,80,80},
	s_plate_edit_titlestr_xywh = {124,24,952,80},
	s_plate_edit_titleclose_xywh = {1600,24,80,80},
	s_plate_edit_cap_plate_xywh = {100,120,700,80},
	s_plate_edit_t_plate_xywh = {920,120,680,80},
	s_plate_edit_cap_libname_xywh = {100,220,700,80},
	s_plate_edit_t_libname_xywh = {920,220,680,80},
	s_plate_edit_cap_type_xywh = {100,320,700,80},
	s_plate_edit_t_type_xywh = {920,320,680,80},
	s_plate_edit_cap_btime_xywh = {100,420,700,80},
	s_plate_edit_t_bdate_xywh = {920,420,340,80},
	s_plate_edit_t_btime_xywh = {1260,420,340,80},
	s_plate_edit_cap_etime_xywh = {100,520,700,80},
	s_plate_edit_t_edate_xywh = {920,520,340,80},
	s_plate_edit_t_etime_xywh = {1260,520,340,80},
	s_plate_edit_tipinfo_xywh = {100,620,900,40},
	s_plate_edit_hline3_xywh = {100,680,1520,2},
	s_plate_edit_ok_xywh = {1100,690,240,76},
	s_plate_edit_cancel_xywh = {1380,690,240,76},
};

local channel_num;--豸ͨĿ
--local SAVE_TIME;

w1_page_plate_edit.init = function()
	w1_page_plate_edit.ok_func = nil;				--okťص	
	w1_page_plate_edit.okfunc_param = nil;			--okťص
	w1_page_plate_edit.time_fmt = nil;
	w1_page_plate_edit.click_idx = nil;
	w1_page_plate_edit.edit_type = 0;
end

w1_page_plate_edit.set_func  = function(ok_func, okfunc_param, cannel_func, cancelfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')

	w1_page_plate_edit.ok_func = ok_func;				--ⲿtable
	w1_page_plate_edit.okfunc_param = okfunc_param;
end

local is_change = function(top)
	local param = b_wnd.get_wnd_data(top);
	
	return false
end

local save_change = function(param)

end

local on_plate = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		local plate = b_wnd_ex.get_text(top, win_id);	
		plate = string.upper(plate);	
		b_wnd_ex.set_text(top, win_id, plate, true);	
	end
	
	return 0;
end

local convert_ms = function(top, date_id, time_id)
	local date = b_wnd_ex.get_date(top, date_id);
	local time = b_wnd_ex.get_time(top, time_id);
	local hour_off = 0;
	if(time.format == b_ui.TIME.TIME_12PM) then
		if(time.hour ~= 12) then
			hour_off = 12;
		end
	elseif(time.format == b_ui.TIME.TIME_12AM) then
		if(time.hour == 12) then
			hour_off = -12;
		end
	end
	local mstime = os.time({year =date.year, month = date.month, day =date.day, 
				hour =0, min =0, sec = 0})
	mstime = mstime + (time.hour + hour_off) * 3600 + time.minute * 60 + time.second;
	return mstime
end

local on_ok_addedit = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_plate_edit.dlg
		local plate = b_wnd_ex.get_text(top, cwnd.t_plate.id);	
		if(plate == '') then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_LP_NOT_NULL'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end

		local lib = b_wnd_ex.get_text(top, cwnd.t_lib_name.id);	
--[[
		if(lib == '') then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_LPLIB_NOT_NULL'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
--]]
		local s_time = convert_ms(top, cwnd.t_begin_date.id, cwnd.t_begin_time.id)
		local e_time = convert_ms(top, cwnd.t_end_date.id, cwnd.t_end_time.id)
		if (s_time >= e_time) then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_BEGIN_END_TIME1'), false);
			b_dlg.dlg_set_redraw(top);	
			return 0;
		end
	
		local cur_plate_data = {};
		cur_plate_data.plate = plate;
		cur_plate_data.lib = lib;	
		cur_plate_data.type = b_wnd_ex.get_sel(top, cwnd.t_type.id);
		cur_plate_data.stime = s_time;
		cur_plate_data.etime = e_time;
		
		if (w1_page_plate_edit.edit_type == 0) then --
			local param = {};
			param.channel = w1_page_plate_edit.channel;
			param.num = 1;
			param.info = {
				cur_plate_data
			}
			local ret = b_app_api.add_plate_detect_bw_list(param);
			if(ret == 0) then	
				b_dlg.end_modal(top);
				w1_page_plate_edit.okfunc_param[2] = w1_page_plate_edit.edit_type;
				w1_page_plate_edit.ok_func(w1_page_plate_edit.okfunc_param);
			else--ɾʧ
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_ADD_FAIL'), false);
				b_dlg.dlg_set_redraw(top);
			end			
		else --༭
			local idx = w1_page_plate_edit.click_idx;
			local old_plate_data = w1_page_plate_edit.data['member'..idx];
			local param = {};
			param.channel = w1_page_plate_edit.channel;
			param.old_info = old_plate_data;
			param.new_info = cur_plate_data;
			local ret = b_app_api.modify_plate_detect_bw_list(param);
			if(ret == 0) then	
				b_dlg.end_modal(top);
				w1_page_plate_edit.okfunc_param[2] = w1_page_plate_edit.edit_type;
				w1_page_plate_edit.ok_func(w1_page_plate_edit.okfunc_param);
			else--ɾʧ
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_ADD_FAIL'), false);
				b_dlg.dlg_set_redraw(top);
			end				
		end	
	end
	
	return 0;
end		

local on_ok_del = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local idx = w1_page_plate_edit.click_idx;
		local cur_plate_data = w1_page_plate_edit.data['member'..idx];
		if (cur_plate_data ~= nil) then
			local param = {};
			param.channel = w1_page_plate_edit.channel;
			param.num = 1;
			param.info = {
				cur_plate_data
			}
			local ret = b_app_api.del_plate_detect_bw_list(param);
			if(ret == 0) then	--ɾɹֱ˳,ִлص
				b_dlg.end_modal(top);
				w1_page_plate_edit.okfunc_param[2] = w1_page_plate_edit.edit_type;
				w1_page_plate_edit.ok_func(w1_page_plate_edit.okfunc_param);
			else--ɾʧ
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_DELETE_FAIL'), false);
				b_dlg.dlg_set_redraw(top);
			end			
		end
	end

	return 0;
end

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end

	return 0;
end	

local dlg = {
	attr 	= {xywh='s_plate_edit_xywh',},
	
	sub 	= {'titleimg', 'titlestr', 'titleclose', 
				'cap_plate','t_plate', 'cap_lib_name', 't_lib_name',
				'cap_type','t_type', 'cap_begin_time', 't_begin_date', 't_begin_time',
				'cap_end_time', 't_end_date', 't_end_time',
				'hline2','tipinfo',	'ok','cancel'},
	
	titleimg 	= {t='tt_picture',	id=id+1,xywh='s_plate_edit_titleimg_xywh', 
					t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_addcameera'}},
	
	titlestr	= {t='static', 	id=id+2,xywh='s_plate_edit_titlestr_xywh', 
					text='LA_ADD_INFO',	font = 'f_grade5',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
								
	titleclose 	= {t='tt_button',id=id+3,xywh = 's_plate_edit_titleclose_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
					color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_txt_f'},
					color_f= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},cmd=on_close},
	
	cap_plate	= {t='static', 	id=id+4,xywh='s_plate_edit_cap_plate_xywh', 
					text='LA_PLATE', font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	t_plate 		= {t='edit', 	id=id+5,xywh='s_plate_edit_t_plate_xywh', 
					text='',	trans = false, cmd=on_plate,
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},		
	cap_lib_name	= {t='static', 	id=id+6,xywh='s_plate_edit_cap_libname_xywh', 
					text='LA_LIB_NAME', font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	t_lib_name 		= {t='edit', 	id=id+7,xywh='s_plate_edit_t_libname_xywh', 
					text='',	trans = false, 
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},		

	cap_type	= {t='static', 	id=id+8,xywh='s_plate_edit_cap_type_xywh', 
					text='LA_LIST_TYPE',font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
	t_type 	= {t='combox', id=id+9,xywh='s_plate_edit_t_type_xywh', 
					items={'LA_RULE_BLACK','LA_RULE_WHITE'},
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	

	cap_begin_time 		= {t='static',	id=id+10,	xywh='s_plate_edit_cap_btime_xywh',	text='LA_BEGIN_TIME',color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},},
	t_begin_date 		= {t='date_edit',id=id+11,	xywh='s_plate_edit_t_bdate_xywh',	date={0,2020,1,1, true},trans = false, },
	t_begin_time 		= {t='time_edit',id=id+12,	xywh='s_plate_edit_t_btime_xywh',	time = {b_ui.TIME.TIME_24,12,56,04},trans = false,cmd=on_time},	

	cap_end_time 		= {t='static',	id=id+13,	xywh='s_plate_edit_cap_etime_xywh',	text='LA_END_TIME',color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},},
	t_end_date 		= {t='date_edit',id=id+14,	xywh='s_plate_edit_t_edate_xywh',	date={0,2020,1,1, true},trans = false, },
	t_end_time 		= {t='time_edit',id=id+15,	xywh='s_plate_edit_t_etime_xywh',	time = {b_ui.TIME.TIME_24,12,56,04},trans = false,cmd=on_time},	


	tipinfo		= {t='static',id=id+16,	xywh='s_plate_edit_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
					},

	hline3		= {t='hline',	id=id+17,xywh='s_plate_edit_hline3_xywh'},

	ok 			= {t='button',	id=id+18,	xywh='s_plate_edit_ok_xywh', 		text='LA_OK',
					cmd=on_ok_addedit,font='f_grade6',
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	cancel  	= {t='button',	id=id+19,	xywh='s_plate_edit_cancel_xywh',		text='LA_CANCEL',
					cmd=on_close,font='f_grade6',
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
					}
}

local dlg_del = {
	attr 	= {xywh='s_msgbox_xywh',},
	sub 	= {'msg', 'tipinfo','ok', 'cancel'},
	
	msg	 	= {t='static',	id=id+2,	xywh='s_msgbox_msg_xywh',	
			text='LA_CONFIRM_DELETE',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},

	tipinfo	= {t='static',id=id+3,	xywh='s_msgbox_tipinfo_xywh',	text='', 
			font='f_grade7', trans = false,
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
			},
			
	hline	= {t='hline',	id=id+4,	xywh='s_msgbox_hline_xywh'},
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
			
	ok		= {t='button',	id=id+5,	xywh='s_msgbox_ok_xywh',	text='LA_OK',	font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok_del},
	cancel	= {t='button',	id=id+6,	xywh='s_msgbox_cancel_xywh',text='LA_CANCEL',font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
				cmd=on_close},		
}

--ǰһ
local time_nextday = function(year, month, day)
	local backtimems = os.time({year=year,month=month,day=day,hour=8}) + 86400;  
	local backtime = os.date("*t",backtimems);
	return backtime;
end

local get_date_time = function(input_time)
		local time = input_time
		local ui_stime = {};
		ui_stime.date = {};
		ui_stime.date[1] = w1_page_plate_edit.time_fmt
		ui_stime.date[2] = tonumber(os.date("%Y", time))
		ui_stime.date[3] = tonumber(os.date("%m", time))
		ui_stime.date[4] = tonumber(os.date("%d", time))
		
		ui_stime.time = {}
		ui_stime.time[2] = tonumber(os.date("%H", time))
		if(1 == w1_page_plate_edit.time_fmt)then
			ui_stime.time[1] = b_ui.TIME.TIME_24;
		else
			if(ui_stime.time[2] == 12) then
				ui_stime.time[1] = b_ui.TIME.TIME_12PM
				ui_stime.time[2] = ui_stime.time[2]
			elseif(ui_stime.time[2] >= 13 and ui_stime.time[2] <= 23) then
				ui_stime.time[1] = b_ui.TIME.TIME_12PM
				ui_stime.time[2] = ui_stime.time[2] - 12
			elseif (ui_stime.time[2] == 24) then
				ui_stime.time[1] = b_ui.TIME.TIME_12AM
				ui_stime.time[2] = 12
			else
				ui_stime.time[1] = b_ui.TIME.TIME_12AM
				if(ui_stime.time[2] ==0)then
					ui_stime.time[2] = 12
				else
					ui_stime.time[2] = ui_stime.time[2]
				end
			end
		end
		
		ui_stime.time[3] = math.floor((time % 3600) / 60)
		ui_stime.time[4] = math.floor(time % 60)
		
		return ui_stime;
end	

w1_page_plate_edit.set_data = function(data)
	w1_page_plate_edit.data = data;
	return 0;
end

w1_page_plate_edit.set_time_fmt = function(time_fmt)
	w1_page_plate_edit.time_fmt = time_fmt
end

w1_page_plate_edit.set_channel = function(channel)
	w1_page_plate_edit.channel = channel
end

w1_page_plate_edit.clear_data = function()
	w1_page_plate_edit.data = nil;
	w1_page_plate_edit.ok_func = nil;				--okťص	
	w1_page_plate_edit.okfunc_param = nil;			--okťص
	w1_page_plate_edit.time_fmt = nil;
	w1_page_plate_edit.click_idx = nil;
	w1_page_plate_edit.edit_type = 0;

	return 0;
end

w1_page_plate_edit.on_create = function(top)
	w1_page_plate_edit.top = top;
	return 0;
end

w1_page_plate_edit.on_destroy = function(top)
	w1_page_plate_edit.top = nil;
	w1_page_plate_edit.dlg = nil;
	return 0;
end

w1_page_plate_edit.on_pre_show = function(top)
	local setdisable = function(id, disable)
		b_wnd_ex.set_disable(top, id, disable, false);
	end

	local param = b_wnd.get_wnd_data(top);
	local paramdata = nil;
	if(param ~= nil)then
		paramdata = cjson.decode(param);
		assert(paramdata.opera == 1 or paramdata.opera == 2);
		if(paramdata.opera == 1) then
			w1_page_plate_edit.edit_type = 1;--ǵǰǱ༭
		elseif(paramdata.opera == 2) then
			w1_page_plate_edit.edit_type = 2;--ǵǰɾ
		end
		local sel = math.modf((paramdata.sel + 1) / 1)
		w1_page_plate_edit.click_idx = sel;--¼ǰк
	else
		w1_page_plate_edit.edit_type = 0;--ǵǰ
	end
	
	if (w1_page_plate_edit.edit_type == 2) then
		w1_page_plate_edit.dlg = dlg_del;
		b_parser(top, w1_page_plate_edit.dlg);
		return 0;
	end	
	
	w1_page_plate_edit.dlg = dlg;
	if(w1_page_plate_edit.edit_type == 0) then
		--޸ıͼ
		dlg.titlestr.text = 'LA_ADD_INFO';
		dlg.titleimg.t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_addcameera'};
	elseif(w1_page_plate_edit.edit_type == 1) then
		dlg.titlestr.text = 'LA_EDIT_INFO';
		dlg.titleimg.t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_addpic','it_editcameera'}	
	end
	b_parser(top, w1_page_plate_edit.dlg);	
	
	local cwnd = w1_page_plate_edit.dlg;
	if(w1_page_plate_edit.edit_type == 1) then --༭	
		local idx = w1_page_plate_edit.click_idx;
		local cur_plate_data = w1_page_plate_edit.data['member'..idx];	
		b_wnd_ex.set_text(top, cwnd.t_plate.id, cur_plate_data.plate, false);
		b_wnd_ex.set_text(top, cwnd.t_lib_name.id, cur_plate_data.lib, false);
		b_wnd_ex.set_sel(top, cwnd.t_type.id, cur_plate_data.type, false);
		local ui_stime = get_date_time(cur_plate_data.stime)
		local ui_etime = get_date_time(cur_plate_data.etime)
		b_wnd_ex.set_date (top, w1_page_plate_edit.dlg.t_begin_date.id, ui_stime.date, false)
		b_wnd_ex.set_date (top, w1_page_plate_edit.dlg.t_end_date.id, ui_etime.date, false)
		b_wnd_ex.set_time (top, w1_page_plate_edit.dlg.t_begin_time.id, ui_stime.time, false)
		b_wnd_ex.set_time (top, w1_page_plate_edit.dlg.t_end_time.id, ui_etime.time, false)
	else
		local time = os.time()
		local ui_stime = {};
		ui_stime.date = {};
		ui_stime.date[1] = w1_page_plate_edit.time_fmt
		ui_stime.date[2] = tonumber(os.date("%Y", time))
		ui_stime.date[3] = tonumber(os.date("%m", time))
		ui_stime.date[4] = tonumber(os.date("%d", time))
		
		ui_stime.time = {}
		ui_stime.time[2] = tonumber(os.date("%H", time))
		if(1 == w1_page_plate_edit.time_fmt)then
			ui_stime.time[1] = b_ui.TIME.TIME_24;
		else
			if(ui_stime.time[2] == 12) then
				ui_stime.time[1] = b_ui.TIME.TIME_12PM
				ui_stime.time[2] = ui_stime.time[2]
			elseif(ui_stime.time[2] >= 13 and ui_stime.time[2] <= 23) then
				ui_stime.time[1] = b_ui.TIME.TIME_12PM
				ui_stime.time[2] = ui_stime.time[2] - 12
			elseif (ui_stime.time[2] == 24) then
				ui_stime.time[1] = b_ui.TIME.TIME_12AM
				ui_stime.time[2] = 12
			else
				ui_stime.time[1] = b_ui.TIME.TIME_12AM
				if(ui_stime.time[2] ==0)then
					ui_stime.time[2] = 12
				else
					ui_stime.time[2] = ui_stime.time[2]
				end
			end
		end
		
		ui_stime.time[3] = math.floor((time % 3600) / 60)
		ui_stime.time[4] = math.floor(time % 60)
		
		local nexttiem = time_nextday(ui_stime.date[2], ui_stime.date[3], ui_stime.date[4]);
		local ui_etime = {};
		ui_etime.date = {};
		ui_etime.date[1] =  w1_page_plate_edit.time_fmt
		ui_etime.date[2] = nexttiem.year;
		ui_etime.date[3] = nexttiem.month
		ui_etime.date[4] = nexttiem.day
		
		b_wnd_ex.set_date (top, w1_page_plate_edit.dlg.t_begin_date.id, ui_stime.date, false)
		b_wnd_ex.set_date (top, w1_page_plate_edit.dlg.t_end_date.id, ui_etime.date, false)
		b_wnd_ex.set_time (top, w1_page_plate_edit.dlg.t_begin_time.id, ui_stime.time, false)
		b_wnd_ex.set_time (top, w1_page_plate_edit.dlg.t_end_time.id, ui_stime.time, false)
	end
	


	return 0;
end

w1_page_plate_edit.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'));
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1);
	b_wnd.end_job(top);
	return 0;
end

w1_page_plate_edit.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if(b_ui.RBUTTONCLK == vmsg) then
		local ret = false
		w1_page_plate_edit.save_check_illegal = false;		
		if(w1_page_plate_edit.edit_type == 0 or w1_page_plate_edit.edit_type == 1) then
			ret = is_change(top);
		end
		if ret == true then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_WANT_SAVE'), true, true, false,STR('LA_YES'), STR('LA_BAD'));
			w1_msgbox.set_func(save_change,{top}, nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			w1_msgbox.set_func(nil,nil, nil,nil);
		end
		if w1_page_plate_edit.save_check_illegal == true then
			return 0;
		end
		b_dlg.end_modal(top);
	end
	return 0;
end

return w1_page_plate_edit;




