--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_roi.roi_id
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local r_color				= require("wnd.core.r_res.r_color")
local COLOR 				= r_color.get_color
local w1_page_roi = 
{
	old_chid,
	data,
	timestart = false,
	flag, --Ƿroiͨ
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_roi.s_768 =
{
	s_roi_noteinfo_xywh = {70,312,533,35},
	s_roi_noteinfo2_xywh = {70,348,533,35},
	s_roi_noteinfo3_xywh = {70,384,533,35},
	s_cfg_roi_image_xywh = {70,22,352,256},
	s_roi_cap_channel_xywh = {436,35,85,35},
	s_roi_t_channel_xywh = {586,39,131,28},
	s_roi_cap_stream_xywh = {436,78,85,35},
	s_roi_t_stream_xywh = {586,78,131,28},
	s_roi_cap_enable_xywh = {436,163,85,35},
	s_roi_t_enable_xywh = {586,167,25,21},
	s_roi_cap_areaid_xywh = {436,120,85,35},
	s_roi_t_areaid_xywh = {586,120,131,28},
	s_roi_cap_level_xywh = {436,206,85,35},
	s_roi_t_level_xywh = {586,206,131,28},
	s_roi_cap_areaname_xywh = {436,248,85,35},
	s_roi_t_areaname_xywh = {586,248,131,28},
	s_roi_tipinfo_xywh = {70,426,373,35},
};

w1_page_roi.s_1280 = 
{
	s_roi_noteinfo_xywh = {92,440,860,50},
	s_roi_noteinfo2_xywh = {92,490,800,50},
	s_roi_noteinfo3_xywh = {92,540,800,50},
	s_cfg_roi_image_xywh = {92,32,640,360},
	s_roi_cap_channel_xywh = {750,50,110,50},
	s_roi_t_channel_xywh = {880,55,100,40},
	s_roi_cap_stream_xywh = {750,110,110,50},
	s_roi_t_stream_xywh = {880,110,100,40},
	s_roi_cap_enable_xywh = {750,230,110,50},
	s_roi_t_enable_xywh = {880,235,48,30},
	s_roi_cap_areaid_xywh = {750,170,110,50},
	s_roi_t_areaid_xywh = {880,170,100,40},
	s_roi_cap_level_xywh = {750,290,110,50},
	s_roi_t_level_xywh = {880,290,100,40},
	s_roi_cap_areaname_xywh = {750,350,120,50},
	s_roi_t_areaname_xywh = {880,350,100,40},
	s_roi_tipinfo_xywh = {92,750,700,50},
};

w1_page_roi.s_1440 = 
{
	s_roi_noteinfo_xywh = {100,440,1000,50},
	s_roi_noteinfo2_xywh = {100,490,1000,50},
	s_roi_noteinfo3_xywh = {100,540,1000,50},
	s_cfg_roi_image_xywh = {100,32,640,360},
	s_roi_cap_channel_xywh = {750,50,140,50},
	s_roi_t_channel_xywh = {910,55,120,40},
	s_roi_cap_stream_xywh = {750,110,140,50},
	s_roi_t_stream_xywh = {910,110,120,40},
	s_roi_cap_enable_xywh = {750,230,140,50},
	s_roi_t_enable_xywh = {900,235,48,30},
	s_roi_cap_areaid_xywh = {750,170,140,50},
	s_roi_t_areaid_xywh = {910,170,120,40},
	s_roi_cap_level_xywh = {750,290,140,50},
	s_roi_t_level_xywh = {910,290,120,40},
	s_roi_cap_areaname_xywh = {750,350,140,50},
	s_roi_t_areaname_xywh = {910,350,120,40},
	s_roi_tipinfo_xywh = {100,600,700,50},
};

w1_page_roi.s_1080p = 
{
	s_roi_noteinfo_xywh = {98,440,1000,50},
	s_roi_noteinfo2_xywh = {98,490,1000,50},
	s_roi_noteinfo3_xywh = {98,540,1000,50},
	s_cfg_roi_image_xywh = {98,32,640,360},
	s_roi_cap_channel_xywh = {800,50,160,50},
	s_roi_t_channel_xywh = {1080,55,246,40},
	s_roi_cap_stream_xywh = {800,110,160,50},
	s_roi_t_stream_xywh = {1080,110,246,40},
	s_roi_cap_enable_xywh = {800,230,160,50},
	s_roi_t_enable_xywh = {1080,235,48,30},
	s_roi_cap_areaid_xywh = {800,170,160,50},
	s_roi_t_areaid_xywh = {1080,170,246,40},
	s_roi_cap_level_xywh = {800,290,160,50},
	s_roi_t_level_xywh = {1080,290,246,40},
	s_roi_cap_areaname_xywh = {800,350,160,50},
	s_roi_t_areaname_xywh = {1080,350,246,40},
	s_roi_tipinfo_xywh = {98,600,700,50},

};
w1_page_roi.s_2k = 
{
	s_roi_noteinfo_xywh = {133,587,1333,67},
	s_roi_noteinfo2_xywh = {133,657,1333,67},
	s_roi_noteinfo3_xywh = {133,727,1333,67},
	s_cfg_roi_image_xywh = {136,43,856,480},
	s_roi_cap_channel_xywh = {1066,67,213,67},
	s_roi_t_channel_xywh = {1440,73,328,53},
	s_roi_cap_stream_xywh = {1066,147,213,67},
	s_roi_t_stream_xywh = {1440,147,328,53},
	s_roi_cap_enable_xywh = {1066,227,213,67},
	s_roi_t_enable_xywh = {1440,240,48,40},
	s_roi_cap_areaid_xywh = {1066,387,213,67},
	s_roi_t_areaid_xywh = {1440,387,328,53},
	s_roi_cap_level_xywh = {1066,307,213,67},
	s_roi_t_level_xywh = {1440,307,328,53},
	s_roi_cap_areaname_xywh = {1066,467,213,67},
	s_roi_t_areaname_xywh = {1440,467,328,53},
	s_roi_tipinfo_xywh = {133,800,933,67},

};
w1_page_roi.s_4k = 
{
	s_roi_noteinfo_xywh = {200,880,2000,100},
	s_roi_noteinfo2_xywh = {200,980,2000,100},
	s_roi_noteinfo3_xywh = {200,1080,2000,100},
	s_cfg_roi_image_xywh = {200,62,1280,720},
	s_roi_cap_channel_xywh = {1600,100,320,100},
	s_roi_t_channel_xywh = {2160,110,492,80},
	s_roi_cap_stream_xywh = {1600,220,320,100},
	s_roi_t_stream_xywh = {2160,220,492,80},
	s_roi_cap_enable_xywh = {1600,460,320,100},
	s_roi_t_enable_xywh = {2160,480,96,60},
	s_roi_cap_areaid_xywh = {1600,340,320,100},
	s_roi_t_areaid_xywh = {2160,340,492,80},
	s_roi_cap_level_xywh = {1600,580,320,100},
	s_roi_t_level_xywh = {2160,580,492,80},
	s_roi_cap_areaname_xywh = {1600,700,320,100},
	s_roi_t_areaname_xywh = {2160,700,492,80},
	s_roi_tipinfo_xywh = {200,1200,1400,100},
};

local channel_num;--豸ͨĿ
local set_custom_layout = function(top,chid)
	local stream_id = b_wnd_ex.get_sel(top,w1_page_roi.wnd.t_stream.id)
	local param = {
		chn_id = chid,
		wnd_id = 1,
	}
	if stream_id == 0 then
		param.stream = true;			--
	else
		param.stream = false;			--
	end
	local layoutpos = w1_page_roi.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param)
end

w1_page_roi.clear_data = function()
	w1_page_roi.data = nil;
end	

local refresh_chdata = function(top, chid,cfgdata, redraw)
	local chn = "channel"..chid;
	set_custom_layout(top,chid);
	local cwnd =w1_page_roi.wnd
	local limits = cfgdata.roi_limits;
	local roi = cfgdata.roi
	local support = limits[chn]['support'];
	local max_num = limits[chn]['max_num']
	local max_level = limits[chn]['max_level']
	local max_scale = limits[chn]['max_scale']
	local areaidt = {};
	local max_size = STR('LA_ROI_TIP')..max_scale.."%"
	for i=1,max_num do
		table.insert(areaidt,i);
	end
	local arealevel = {};
	for i=1,max_level do
		table.insert(arealevel,i);
	end
	b_wnd_ex.set_items(top,cwnd.t_areaid.id,areaidt,false);
	b_wnd_ex.set_items(top,cwnd.t_level.id,arealevel,false);
	local stream = b_wnd_ex.get_sel(top,cwnd.t_stream.id)+1;
	local areaid = b_wnd_ex.get_sel(top,cwnd.t_areaid.id)+1;
	local check = roi[chn]['stream'..stream]['roi_param'..areaid]['enable']
	local index_id = roi[chn]['stream'..stream]['roi_param'..areaid]['index_id']
	local roi_level = roi[chn]['stream'..stream]['roi_param'..areaid]['roi_level']
	local name = roi[chn]['stream'..stream]['roi_param'..areaid]['name']
	local x = roi[chn]['stream'..stream]['roi_param'..areaid]['x']
	local y = roi[chn]['stream'..stream]['roi_param'..areaid]['y']
	local width = roi[chn]['stream'..stream]['roi_param'..areaid]['width']
	local height = roi[chn]['stream'..stream]['roi_param'..areaid]['height']
	local rect = b_wnd_ex.get_rect(top,cwnd.image.id);
	--תֵ꣬Ϊٷֱ
	x = rect['rect1']+math.floor(x*SIZE('s_cfg_roi_image_xywh')[3]/100)
	y = rect['rect2']+math.floor(y*SIZE('s_cfg_roi_image_xywh')[4]/100)
	width = math.floor(width*SIZE('s_cfg_roi_image_xywh')[3]/100)
	height =math.floor(height*SIZE('s_cfg_roi_image_xywh')[4]/100)
	if check ==0 then
		b_wnd_ex.set_check(top,cwnd.t_enable.id,false,false)
	else
		b_wnd_ex.set_check(top,cwnd.t_enable.id,true,false)
	end
	b_wnd_ex.set_sel(top,cwnd.t_level.id,roi_level-1,false)
	b_wnd_ex.set_sel(top,cwnd.t_areaid.id,index_id-1,false)
	b_wnd_ex.set_text(top,cwnd.t_areaname.id,name,false)
	b_wnd_ex.set_text(top,cwnd.noteinfo.id,max_size,false)
	b_wnd_ex.set_text(top,cwnd.noteinfo3.id,STR('LA_ROI_NOT_SUPPORT'),false)
	b_wnd_ex.set_color(top, cwnd.t_areaname.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_edit_text_n')},false)
	b_wnd_ex.set_color_f(top,cwnd.t_areaname.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_f'),COLOR('c_txt_f')},false)
	if tonumber(x) and tonumber(y) and tonumber(width)and tonumber(height) then
		b_wnd_ex.set_roi_area(top,cwnd.image.id,{x,y,width,height},false)
	end
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end
local sethide =function(top, bool_hide, redraw)
	local cwnd = w1_page_roi.wnd;
	local sid = cwnd.cap_stream.id;
	local eid = cwnd.t_areaname.id;
	
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, false)
	end
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	w1_page_roi.data = cfgdata;
	local limits = cfgdata.roi_limits;
	local cwnd = w1_page_roi.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	local channel = b_wnd_ex.get_text(top, cwnd.t_channel.id);
	for i=1, channel_num do
		if(cfgdata['roi']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_items(top, cwnd.t_channel.id, camreaitems, false);
	local old_chn = 1;
	if(idx ~= 1) then--˵ͨ
		for i=1,#camreaitems do  --ͨ,ȡǰͨӦ
			if(camreaitems[i] == tonumber(channel))then
				old_chn=i;
			end
		end
		b_wnd_ex.set_enableselect(top,cwnd.image.id,true,false);
		b_wnd_ex.set_disable(top, cwnd.t_channel.id, false, false)
		sethide(top, false, false);
		b_wnd_ex.set_sel(top, cwnd.t_channel.id, old_chn-1, false);
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
		refresh_chdata(top, chid, cfgdata,false)
		w1_page_roi.flag = 1
	else--ͨ
		b_wnd_ex.set_enableselect(top,cwnd.image.id,false,false);
		b_wnd_ex.set_disable(top, cwnd.t_channel.id, true, false)
		sethide(top, true, false);
		w1_page_roi.flag = 0
		for i=1, channel_num do
			if(ch_prilist[i] ~= 0) then
				set_custom_layout(top,i);
				break;
			end
		end	
	end
	
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd=w1_page_roi.wnd
	local check = b_wnd_ex.get_check(top,cwnd.t_enable.id)
	local level = b_wnd_ex.get_sel(top,cwnd.t_level.id)+1
	local areaid = b_wnd_ex.get_sel(top,cwnd.t_areaid.id)+1
	local name = b_wnd_ex.get_text(top,cwnd.t_areaname.id)
	local chn_id = b_wnd_ex.get_text(top,cwnd.t_channel.id)
	local chn = "channel"..chn_id
	local stream = b_wnd_ex.get_sel(top,cwnd.t_stream.id)+1
	local area = b_wnd_ex.get_roi_area(top,cwnd.image.id)
	local rect = b_wnd_ex.get_rect(top,cwnd.image.id);
	area[1] = math.floor((area[1] - rect['rect1'])*100)/SIZE('s_cfg_roi_image_xywh')[3]
	area[2] = math.floor((area[2] - rect['rect2'])*100)/SIZE('s_cfg_roi_image_xywh')[4]
	area[3] = math.floor(area[3]*100)/SIZE('s_cfg_roi_image_xywh')[3]
	area[4] = math.floor(area[4]*100)/SIZE('s_cfg_roi_image_xywh')[4]
	if check==false then
		cfgdata['roi'][chn]['stream'..stream]['roi_param'..areaid]['enable'] = 0
	else
		cfgdata['roi'][chn]['stream'..stream]['roi_param'..areaid]['enable'] = 1
	end
	
	cfgdata['roi'][chn]['stream'..stream]['roi_param'..areaid]['index_id']=areaid
	cfgdata['roi'][chn]['stream'..stream]['roi_param'..areaid]['roi_level'] = level
	cfgdata['roi'][chn]['stream'..stream]['roi_param'..areaid]['name'] = name
	cfgdata['roi'][chn]['stream'..stream]['roi_param'..areaid]['x']=area[1]
	cfgdata['roi'][chn]['stream'..stream]['roi_param'..areaid]['y'] = area[2]
	cfgdata['roi'][chn]['stream'..stream]['roi_param'..areaid]['width'] = area[3]
	cfgdata['roi'][chn]['stream'..stream]['roi_param'..areaid]['height']=area[4]
	
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	if w1_page_roi.flag == 0 then
		return true
	end
	local cwnd=w1_page_roi.wnd
	local roi = w1_page_roi.data;
	local legalflag = true
	local nlegalid = {}
	local chn_id = b_wnd_ex.get_text(top,cwnd.t_channel.id)
	local chn = "channel"..chn_id
	local stream = b_wnd_ex.get_sel(top,cwnd.t_stream.id)+1
	local check_data = b_app_cfg.user_cfg
	local max_num = roi['roi_limits'][chn]['max_num']
	local max_scale = roi['roi_limits'][chn]['max_scale']
	local check = 0;
	local areaid = b_wnd_ex.get_sel(top,cwnd.t_areaid.id)+1
	local all_sum = 0
	for i=1,max_num  do
		local snum = 0;
		local name = roi['roi'][chn]['stream'..stream]['roi_param'..i]['name']
		if roi['roi'][chn]['stream'..stream]['roi_param'..i]['enable']==1 then
			local tcx = roi['roi'][chn]['stream'..stream]['roi_param'..i]['width']
			local tcy = roi['roi'][chn]['stream'..stream]['roi_param'..i]['height']
			snum = tcx*tcy;
			if snum==0 or snum==1then
				w1_wnd_util.setparamerr_str(STR('LA_ROI_AREA_TIP').." "..i);
				table.insert(nlegalid, cwnd.image.id);
				return false,nlegalid;
			end
			all_sum = snum+all_sum
		end
		local special = {'>','<','\\','/','&','"',';',',','=','|','+',"'",'%%'};
		for j=1,#special do
			local ret = string.find(name,special[j]);
			if ret~=nil then
				local str = string.gsub(STR('LA_ROI_SET_NAME'), '*' ,i); 
				w1_wnd_util.setparamerr_str(str);
				if i==areaid then
					table.insert(nlegalid, cwnd.t_areaname.id);
				end
				return false,nlegalid;
			end
		end
	end
	if all_sum > max_scale*100 then
		w1_wnd_util.setparamerr_str(STR('LA_ROI_SIZE_TIP')..max_scale.."%");
		table.insert(nlegalid, cwnd.image.id);
		return false,nlegalid;
	end
	
	return true,nil
end

w1_page_roi.timer_start = function()
	w1_page_roi.timestart = true
end

w1_page_roi.timer_stop = function(top)
	w1_page_roi.timestart = false
	w1_wnd_util.tipclear(top, w1_page_roi.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_roi.timerenevt = function(top)
	if(w1_page_roi.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_roi.wnd.tipinfo.id)
	end
	return 0
end

w1_page_roi.init = function(top)
	b_wnd_ex.set_roi_area(top,w1_page_roi.wnd.image.id,{0,0,0,0},false)--ٻ
	w1_wnd_util.cfgtab = {'roi','roi_limits'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	local chidstr = b_wnd_ex.get_text(top, w1_page_roi.wnd.t_channel.id);
	if(chidstr == '') then
		return 0
	end
	local chid =tonumber(chidstr);
	w1_page_roi.old_chid = chid;
	set_custom_layout(top,chid);
	return 0
end

local on_channel= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		w1_wnd_util.cfgtab = {'roi','roi_limits'}
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_init(top)
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_enable = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_update_param = function(top, id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		uitousercfg(top,b_app_cfg.user_cfg);
	elseif (vmsg == b_ui.RBUTTONCLK) then
		return vmsg;
	end
	return 0;
end

local on_areaid = function (top,id,vmsg,x,y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		local cwnd=w1_page_roi.wnd
		local chn_id = b_wnd_ex.get_text(top,cwnd.t_channel.id)
		local chn = "channel"..chn_id
		local roi = w1_page_roi.data.roi
		b_wnd_ex.set_color(top, cwnd.t_areaname.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_edit_text_n')},false)
		b_wnd_ex.set_color_f(top,cwnd.t_areaname.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_f'),COLOR('c_txt_f')},false)
		local stream = b_wnd_ex.get_sel(top,cwnd.t_stream.id)+1;
		local areaid = b_wnd_ex.get_sel(top,cwnd.t_areaid.id)+1;
		local check = roi[chn]['stream'..stream]['roi_param'..areaid]['enable']
		local roi_level = roi[chn]['stream'..stream]['roi_param'..areaid]['roi_level']
		local name = roi[chn]['stream'..stream]['roi_param'..areaid]['name']
		local x = roi[chn]['stream'..stream]['roi_param'..areaid]['x']
		local y = roi[chn]['stream'..stream]['roi_param'..areaid]['y']
		local width = roi[chn]['stream'..stream]['roi_param'..areaid]['width']
		local height = roi[chn]['stream'..stream]['roi_param'..areaid]['height']
		local rect = b_wnd_ex.get_rect(top,cwnd.image.id);
		x = rect['rect1']+math.floor(x*SIZE('s_cfg_roi_image_xywh')[3]/100)
		y = rect['rect2']+math.floor(y*SIZE('s_cfg_roi_image_xywh')[4]/100)
		width = math.floor(width*SIZE('s_cfg_roi_image_xywh')[3]/100)
		height =math.floor(height*SIZE('s_cfg_roi_image_xywh')[4]/100)
		if check ==0 then
			b_wnd_ex.set_check(top,cwnd.t_enable.id,false,false)
		else
			b_wnd_ex.set_check(top,cwnd.t_enable.id,true,false)
		end
		b_wnd_ex.set_sel(top,cwnd.t_level.id,roi_level-1,false)
		b_wnd_ex.set_text(top,cwnd.t_areaname.id,name,false)
		b_wnd_ex.set_roi_area(top,cwnd.image.id,{x,y,width,height},false)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end


local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_roi.apply =function(top)
	local ret = nil; 
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	return ret
end

w1_page_roi.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	
	local cwnd = w1_page_roi.wnd;
	local param = {
		x = SIZE('s_cfg_roi_image_xywh')[1] + SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_cfg_roi_image_xywh')[2] + SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_cfg_roi_image_xywh')[3],
		cy = SIZE('s_cfg_roi_image_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_roi.layoutpos.x = param.x;
	w1_page_roi.layoutpos.cx = param.cx;
	w1_page_roi.layoutpos.y = param.y;
	w1_page_roi.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_cfg_roi_image_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_cfg_roi_image_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
end

w1_page_roi.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'image', 
			'cap_channel', 't_channel','cap_enable', 't_enable',
			'cap_stream', 't_stream','cap_areaid', 't_areaid','cap_level','t_level',
			'cap_areaname','t_areaname','tipinfo', 'default', 'apply','noteinfo','noteinfo2','noteinfo3'},
			
	image = {t='roi',id=id+1,xywh='s_cfg_roi_image_xywh',text='Image widget', 
				cmd = on_update_param	},
	
	cap_channel	= {t='static',	id=id+2,	xywh='s_roi_cap_channel_xywh',		text='LA_CHANNEL'},
	t_channel 	= {t='combox',	id=id+3,	xywh='s_roi_t_channel_xywh',		items={'1','2','3','4','5','6','7','8'},trans = false,channel_cbox = true,cmd = on_channel},	

	cap_stream	= {t='static',	id=id+4,	xywh='s_roi_cap_stream_xywh',		text='LA_STREAM'},
	t_stream 	= {t='combox',	id=id+5,	xywh='s_roi_t_stream_xywh',items={'LA_MAIN_STREAM','LA_SUBCODE_FLOW'},cmd=on_channel},
	
	cap_enable	= {t='static',	id=id+6,	xywh='s_roi_cap_enable_xywh',		text='LA_ENABLE'},
	t_enable	= {t='tt_check',id=id+7,	xywh='s_roi_t_enable_xywh', cmd = on_enable,		
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					},
	cap_areaid	= {t='static',	id=id+8,	xywh='s_roi_cap_areaid_xywh',		text='LA_AREA_ID'},
	t_areaid 	= {t='combox',	id=id+9,	xywh='s_roi_t_areaid_xywh',cmd = on_areaid},
	
	cap_level	= {t='static',	id=id+10,	xywh='s_roi_cap_level_xywh',		text='LA_LEVEL'},
	t_level		= {t='combox',	id=id+11,	xywh='s_roi_t_level_xywh',cmd = on_update_param},
	
	cap_areaname	= {t='static',	id=id+12,xywh='s_roi_cap_areaname_xywh',	text='LA_AREA_NAME'},
	t_areaname	= {t='edit',	id=id+13,	xywh='s_roi_t_areaname_xywh', cmd = on_update_param},

	tipinfo		= {t='static',	id=id+14,	xywh='s_roi_tipinfo_xywh',		text='',		trans = false},	
	noteinfo	= {t='static',	id=id+15,	xywh='s_roi_noteinfo_xywh',		text='',trans = false},	
	noteinfo2	= {t='static',	id=id+16,	xywh='s_roi_noteinfo2_xywh',		text='LA_ROI_TIP2'},
	noteinfo3	= {t='static',	id=id+17,	xywh='s_roi_noteinfo3_xywh',		text='LA_ROI_NOT_SUPPORT'},
	apply 		= {t='button',	id=id+18,	xywh= 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_roi

