-- ӡ༭ͨҳ
local b_ui 		= require("wnd.core.b_ui")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_pattern_pop_id;
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size

local w1_pattern_pop = {
	t = w1_key.DLG_MSG_PATTERN_POP,
	top = nil,
	dlg = nil,
	edit_type,		--0:½һΣ, 1:ע/޸ģΣ
	count,
	pattern_pwd,
	err_tip_time,
	pattern_save_time,			--ͼʱ
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_pattern_pop.s_768 =
{
	s_pattern_pop_check_xywh = {400,227,224,312},
	s_pattern_pop_edit_xywh = {400,213,224,341},
	s_pattern_pop_pattern_xywh = {29,28,165,220},
	s_pattern_pop_tipinfo_xywh = {5,256,213,32},
	s_pattern_pop_ok_xywh = {37,291,64,32},
	s_pattern_pop_cancel_xywh = {112,291,64,32},
};

w1_pattern_pop.s_1280 = 
{
	s_pattern_pop_check_xywh 	= {430,320,420,440},
	s_pattern_pop_edit_xywh		= {430,300,420,480},
	s_pattern_pop_pattern_xywh	= {55,40,310,310},
	s_pattern_pop_tipinfo_xywh	= {10,360,400,45},
	s_pattern_pop_ok_xywh		= {70,410,120,45},
	s_pattern_pop_cancel_xywh	= {210,410,120,45},
};

w1_pattern_pop.s_1440 = 
{
	s_pattern_pop_check_xywh 	= {510,230,420,440},
	s_pattern_pop_edit_xywh		= {510,210,420,480},
	s_pattern_pop_pattern_xywh	= {55,40,310,310},
	s_pattern_pop_tipinfo_xywh	= {10,360,400,45},
	s_pattern_pop_ok_xywh		= {70,410,120,45},
	s_pattern_pop_cancel_xywh	= {210,410,120,45},
};

w1_pattern_pop.s_1080p = 
{
	s_pattern_pop_check_xywh 	= {750,320,420,440},
	s_pattern_pop_edit_xywh		= {750,300,420,480},
	s_pattern_pop_pattern_xywh	= {55,40,310,310},
	s_pattern_pop_tipinfo_xywh	= {10,360,400,45},
	s_pattern_pop_ok_xywh		= {70,410,120,45},
	s_pattern_pop_cancel_xywh	= {210,410,120,45},
};

w1_pattern_pop.s_2k = 
{
	s_pattern_pop_check_xywh 	= {1000,427,560,587},
	s_pattern_pop_edit_xywh		= {1000,300,560,640},
	s_pattern_pop_pattern_xywh	= {73,53,413,413},
	s_pattern_pop_tipinfo_xywh	= {13,480,533,60},
	s_pattern_pop_ok_xywh		= {93,547,160,60},
	s_pattern_pop_cancel_xywh	= {280,547,160,60},
};

w1_pattern_pop.s_4k = 
{
	s_pattern_pop_check_xywh 	= {1500,640,840,880},
	s_pattern_pop_edit_xywh		= {1500,600,840,960},
	s_pattern_pop_pattern_xywh	= {110,80,620,620},
	s_pattern_pop_tipinfo_xywh	= {20,720,800,90},
	s_pattern_pop_ok_xywh		= {140,820,240,90},
	s_pattern_pop_cancel_xywh	= {420,820,240,90},
};

local flag = 0;

w1_pattern_pop.set_pattern_type = function(pattern_type)
	w1_pattern_pop.edit_type = pattern_type
	w1_pattern_pop.pattern_pwd = ''
	w1_pattern_pop.count = 0;
end

w1_pattern_pop.get_pattern_number = function ()
	return w1_pattern_pop.pattern_pwd;
end

w1_pattern_pop.pattern_clear = function ()
	w1_pattern_pop.edit_type = 0
	w1_pattern_pop.pattern_pwd = ''
	w1_pattern_pop.count = 0;
end

local on_pattern = function (top, win_id, vmsg, x, y)
	if vmsg == b_ui.WM_USER_UPDATE_PARAM then
		local number = b_wnd_ex.get_pattern_num(top,w1_pattern_pop.dlg.pattern.id);
		local password = '';
		for i=1, number.count do
			password = password..number.num[i]
		end
		if w1_pattern_pop.edit_type == 1 then
			w1_pattern_pop.pattern_pwd = password;
			return b_ui.RBUTTONCLK;
		elseif w1_pattern_pop.edit_type == 2 then
			if(w1_pattern_pop.pattern_pwd ~= '') then
				if w1_pattern_pop.pattern_pwd == password then
					w1_pattern_pop.count = 2;
					b_wnd_ex.set_disable(top,w1_pattern_pop.dlg.ok.id,false,false);
					b_dlg.dlg_set_redraw(top)
				else
					flag = 1;
					w1_pattern_pop.pattern_pwd = ''
					w1_pattern_pop.count = 0;
					b_wnd_ex.set_pattern_error(top,w1_pattern_pop.dlg.pattern.id,false);
					b_wnd_ex.set_text(top,w1_pattern_pop.dlg.tipinfo.id,STR('LA_PATTERN_SAME'),false);
					b_wnd_ex.set_color(top,w1_pattern_pop.dlg.tipinfo.id,
					{COLOR('c_cfg_row_bk'),COLOR('c_cfg_row_bk'),COLOR('c_hint_text')},false);
					b_dlg.dlg_set_redraw(top)
				end
			else
				w1_pattern_pop.pattern_pwd = password;
				w1_pattern_pop.count = 1;
				w1_pattern_pop.pattern_save_time = os.time();
				b_wnd_ex.set_text(top,w1_pattern_pop.dlg.tipinfo.id,STR('LA_DRAW_AGAIN'),false);
				b_wnd_ex.set_color(top,w1_pattern_pop.dlg.tipinfo.id,
					{COLOR('c_cfg_row_bk'),COLOR('c_cfg_row_bk'),COLOR('c_apply_ok')},false);
				b_dlg.dlg_set_redraw(top)
			end
		end
		
	end
	return 0;
end

local on_ok = function (top, win_id, vmsg, x, y)
	if vmsg == b_ui.LBUTTONCLK then
		return b_ui.RBUTTONCLK;
	end
	return 0;
end	

local on_cancel = function (top, win_id, vmsg, x, y)
	if vmsg == b_ui.LBUTTONCLK then
		w1_pattern_pop.pattern_pwd = '';
		w1_pattern_pop.count = 0;
		return b_ui.RBUTTONCLK;
	end
	return 0;
end	

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		local cur_tinme = os.time()
		if flag ~= 0 then
			if 2 < cur_tinme - w1_pattern_pop.err_tip_time then
				flag = 0;
				b_wnd_ex.pattern_clear(top,w1_pattern_pop.dlg.pattern.id,false);
				b_wnd_ex.set_text(top,w1_pattern_pop.dlg.tipinfo.id,'',false);
				b_dlg.dlg_set_redraw(top)
			end
		else
			w1_pattern_pop.err_tip_time = cur_tinme;
		end 
		if w1_pattern_pop.pattern_save_time ~= 0 then
			if 1 < cur_tinme - w1_pattern_pop.pattern_save_time then
				w1_pattern_pop.pattern_save_time = 0;
				b_wnd_ex.pattern_clear(top,w1_pattern_pop.dlg.pattern.id,false);
				b_wnd_ex.set_text(top,w1_pattern_pop.dlg.tipinfo.id,'',false);
				b_dlg.dlg_set_redraw(top)
			end
		end
		
	end
	return 0;
end

local dlg_check = {
	attr 	= {xywh='s_pattern_pop_check_xywh',cmd=on_dlg,timer={-1, 500}},
	sub 	= {'pattern','tipinfo'},
	
	pattern	= {t='pattern',	id=id+1,	xywh='s_pattern_pop_pattern_xywh',cmd=on_pattern},
			
	tipinfo		= {t='static',id=id+2,	xywh='s_pattern_pop_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,align = b_ui.ALIGN.CENTER,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_hint_text'},
					},	
}

local dlg_edit = {
	attr 	= {xywh='s_pattern_pop_edit_xywh',cmd=on_dlg,timer={-1, 500}},
	sub 	= {'pattern', 'tipinfo', 'ok', 'cancel'},
	
	pattern	= {t='pattern',	id=id+1,	xywh='s_pattern_pop_pattern_xywh',cmd=on_pattern},
			
	tipinfo		= {t='static',id=id+2,	xywh='s_pattern_pop_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,align = b_ui.ALIGN.CENTER,
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_hint_text'},
					},
	
	ok		= {t='button',	id=id+3,	xywh='s_pattern_pop_ok_xywh',	text='LA_OK', font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok},
	cancel	= {t='button',	id=id+4,	xywh='s_pattern_pop_cancel_xywh',text='LA_CANCEL', font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
				cmd=on_cancel},		
}

w1_pattern_pop.on_create = function(top)
	w1_pattern_pop.top = top;
	w1_pattern_pop.edit_type = 2;
	w1_pattern_pop.pattern_pwd = '';
	w1_pattern_pop.count = 0;
	w1_pattern_pop.err_tip_time = 0;
	w1_pattern_pop.pattern_save_time = 0;
	return 0;
end

w1_pattern_pop.on_destroy = function(top)
	w1_pattern_pop.top = nil;
	w1_pattern_pop.dlg = nil;
	return 0;
end

w1_pattern_pop.on_pre_show = function(top)
	w1_pattern_pop.pattern_pwd = '';
	if w1_pattern_pop.edit_type == 1 then
		w1_pattern_pop.dlg = dlg_check;
	else
		w1_pattern_pop.dlg = dlg_edit;
	end
	
	b_parser(top, w1_pattern_pop.dlg);
	if w1_pattern_pop.edit_type == 2 then
		b_wnd_ex.set_disable(top,w1_pattern_pop.dlg.ok.id,true,false);
	end
	return 0
end

w1_pattern_pop.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_pattern_pop.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.RBUTTONCLK == vmsg) then
		if w1_pattern_pop.edit_type == 2 and w1_pattern_pop.count ~= 2 then
			w1_pattern_pop.pattern_pwd = '';		
		end
		b_dlg.end_modal(top);
	elseif (b_ui.LBUTTOUP == vmsg) then
		local ret = b_wnd_ex.pattern_end(top,w1_pattern_pop.dlg.pattern.id)
		if ret ~= nil and ret.is_end == 1 then
			on_pattern(top, w1_pattern_pop.dlg.pattern.id, b_ui.WM_USER_UPDATE_PARAM, x, y);		
		end
	elseif (b_ui.LBUTTONCLK == vmsg) then
		local ret = b_wnd_ex.pattern_end(top,w1_pattern_pop.dlg.pattern.id)
		if ret ~= nil and ret.is_end == 1 then
			on_pattern(top, w1_pattern_pop.dlg.pattern.id, b_ui.WM_USER_UPDATE_PARAM, x, y);		
		end	
	end
	return 0
end
return w1_pattern_pop




