--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/10/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local b_dlg 	= require("wnd.core.b_dlg")
local id 		= w1_id.cfg_auxiliary.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local w1_row_auxiliary = {}

w1_row_auxiliary.s_768 =
{
	s_row_auxiliary_dsp_xywh = {112,27,106,28},
};

w1_row_auxiliary.s_1280 = 
{
	s_row_auxiliary_dsp_xywh = {210,38,200,40},
};

w1_row_auxiliary.s_1440 = 
{
	s_row_auxiliary_dsp_xywh = {210,30,200,40},
};


w1_row_auxiliary.s_1080p = 
{
	s_row_auxiliary_dsp_xywh = {210,38,200,40},
};

w1_row_auxiliary.s_2k = 
{
	s_row_auxiliary_dsp_xywh = {280,51,267,53},
};

w1_row_auxiliary.s_4k = 
{
	s_row_auxiliary_dsp_xywh = {420,76,400,80},
};

local on_auxiliary_cfg = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local nret = w1_wnd_jump.click_row(top, w1_row_auxiliary.wnd, win_id, false)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_auxiliary_display = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local nret = w1_wnd_jump.click_row(top, w1_row_auxiliary.wnd, win_id, false)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_row_auxiliary.on_pre_show= function(top)
	--бҳ
	local cwnd = w1_row_auxiliary.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_w =pos[3]-pos[4] ; --ȥΪԤpos[4]ı߾
	local size1 = b_wnd_ex.get_textsize(top, cwnd.auxiliary_cfg.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.auxiliary_display.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.auxiliary_cfg.id).border * 60 ;--
	local total_w = size1 +size2 + space*2
	local title_1 = SIZE('s_cfg_row_1')
	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.auxiliary_cfg.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.auxiliary_display.id, movepos2, false);
	end
end

w1_row_auxiliary.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'auxiliary_cfg', 'auxiliary_display', 'hline'},

	auxiliary_cfg 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',
				text='LA_AUXILIARY',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_auxiliary_cfg,check = true},
	auxiliary_display 	= {t='checktxt',	id=id+2,xywh='s_row_auxiliary_dsp_xywh',
				text='LA_LAYOUT',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_auxiliary_display},			
	hline 	= {t='hline',	id=id+3,xywh='s_cfg_row_hline'}
}

return w1_row_auxiliary
