--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/12
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local b_dlg 	= require("wnd.core.b_dlg")
local id 		= w1_id.cfg_image.imagerow_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local w1_row_imagerow = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_imagerow.s_768 =
{
	s_row_imagerow_xywh = {0,298,826,57},
	s_row_imagerow_image_xywh = {53,0,90,39},
	s_row_imagerow_scenes_xywh = {146,0,90,39},
	s_row_imagerow_exposure_xywh = {240,0,90,39},
	s_row_imagerow_wb_xywh = {333,0,90,39},
	s_row_imagerow_day_night_xywh = {426,0,90,39},
	s_row_imagerow_noise_reduct_xywh = {520,0,90,39},
	s_row_imagerow_enhance_xywh = {613,0,90,39},
	s_row_imagerow_image_focus_xywh = {706,0,90,39},
	s_row_imagerow_mline1 = {53,39,752,1},
	s_row_imagerow_titile_w = {2,0,90,0},
};

w1_row_imagerow.s_1280 = 
{
	s_row_imagerow_xywh 			= {0,380,1000,75},--980
	s_row_imagerow_image_xywh 		= {60,0,100,55},--
	s_row_imagerow_scenes_xywh 		= {165,0,100,55},
	s_row_imagerow_exposure_xywh	= {270,0,100,55},
	s_row_imagerow_wb_xywh 			= {375,0,100,55},
	s_row_imagerow_day_night_xywh 	= {480,0,100,55},
	s_row_imagerow_noise_reduct_xywh= {585,0,100,55},
	s_row_imagerow_enhance_xywh		= {690,0,100,55},
	s_row_imagerow_image_focus_xywh = {795,0,100,55},
	s_row_imagerow_mline1 			= {60,56,900,1},
	s_row_imagerow_titile_w 		= {5,0,100,0};
};
w1_row_imagerow.s_1440 = 
{
	s_row_imagerow_xywh 			= {0,360,1100,65},--980  
	s_row_imagerow_image_xywh 		= {60,0,110,50},--
	s_row_imagerow_scenes_xywh 		= {175,0,110,50},
	s_row_imagerow_exposure_xywh	= {290,0,110,50},
	s_row_imagerow_wb_xywh 			= {405,0,110,50},
	s_row_imagerow_day_night_xywh 	= {520,0,110,50},
	s_row_imagerow_noise_reduct_xywh= {635,0,110,50},
	s_row_imagerow_enhance_xywh		= {750,0,110,50},
	s_row_imagerow_image_focus_xywh = {865,0,110,50},
	s_row_imagerow_mline1 			= {85,51,1000,1},
	s_row_imagerow_titile_w 		= {5,0,110,0};
};

w1_row_imagerow.s_1080p = 
{
	s_row_imagerow_xywh 			= {0,420,1550,81},
	s_row_imagerow_image_xywh 		= {100,0,170,55},
	s_row_imagerow_scenes_xywh 		= {275,0,170,55},
	s_row_imagerow_exposure_xywh	= {450,0,170,55},
	s_row_imagerow_wb_xywh 			= {625,0,170,55},
	s_row_imagerow_day_night_xywh 	= {800,0,170,55},
	s_row_imagerow_noise_reduct_xywh= {975,0,170,55},
	s_row_imagerow_enhance_xywh		= {1150,0,170,55},
	s_row_imagerow_image_focus_xywh = {1325,0,170,55},
	s_row_imagerow_mline1 			= {100,56,1410,1},--+100
	s_row_imagerow_titile_w 		= {5,0,170,0};
};
w1_row_imagerow.s_2k = 
{
	s_row_imagerow_xywh 			= {0,560,2076,108},
	s_row_imagerow_image_xywh 		= {133,0,220,73},
	s_row_imagerow_scenes_xywh 		= {360,0,220,73},
	s_row_imagerow_exposure_xywh	= {587,0,220,73},
	s_row_imagerow_wb_xywh 			= {814,0,220,73},--+115-30=85
	s_row_imagerow_day_night_xywh 	= {1041,0,220,73},
	s_row_imagerow_noise_reduct_xywh= {1268,0,220,73},
	s_row_imagerow_enhance_xywh		= {1495,0,220,73},
	s_row_imagerow_image_focus_xywh = {1722,0,220,73},
	s_row_imagerow_mline1 			= {133,75,1880,1},
	s_row_imagerow_titile_w 		= {7,0,220,0};
};
w1_row_imagerow.s_4k = 
{
	s_row_imagerow_xywh 			= {0,840,3100,162},
	s_row_imagerow_image_xywh 		= {200,0,330,110},
	s_row_imagerow_scenes_xywh 		= {540,0,330,110},
	s_row_imagerow_exposure_xywh	= {880,0,330,110},
	s_row_imagerow_wb_xywh 			= {1220,0,330,110},--+170
	s_row_imagerow_day_night_xywh 	= {1560,0,330,110},
	s_row_imagerow_noise_reduct_xywh= {1900,0,330,110},
	s_row_imagerow_enhance_xywh		= {2240,0,330,110},
	s_row_imagerow_image_focus_xywh = {2580,0,330,110},
	s_row_imagerow_mline1 			= {200,112,2820,2},
	s_row_imagerow_titile_w 		= {10,0,330,0};
};

w1_row_imagerow.sethide = function (top, param_data, bool_flag, redraw)
	if(bool_flag)then	
	--	b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.imageadjust.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.scenes.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.exposure.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.whitebalance.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.daynight.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.noise_reduct.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.enhance.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_focus.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_pcolor.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_ffc.id,bool_flag, redraw)
	else
	--	b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.imageadjust.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_pcolor.id,true, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_ffc.id,true, redraw)

		local hide_idx = 0;
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.scenes.id,bool_flag, redraw)
		if(-1 == param_data.expose.expose_mode) and (-1 ==param_data.expose.meter_area)then
			b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.exposure.id,true, redraw)
			hide_idx = hide_idx + 1;
		else
			b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.exposure.id,bool_flag, redraw)
		end
		
		if(-1 == param_data.wb.rgb_mode) and (-1 ==param_data.wb.red_gain)then
			b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.whitebalance.id,true, redraw)
			hide_idx = hide_idx + 1;
		else
			b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.whitebalance.id,bool_flag, redraw)
			if(hide_idx == 1)then
				local pos = SIZE('s_row_imagerow_exposure_xywh');
				b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.whitebalance.id, pos, false);	
			end
		end
		
		if(-1 == param_data.daynight.dn_setting) and (-1 ==param_data.daynight.dtn_time_hour)then
			b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.daynight.id,true, redraw)
			hide_idx = hide_idx + 1;
		else
			b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.daynight.id,bool_flag, redraw)
			if(hide_idx == 1)then
				local pos = SIZE('s_row_imagerow_wb_xywh');
				b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.daynight.id, pos, false);	
			elseif(hide_idx == 2)then
				local pos = SIZE('s_row_imagerow_exposure_xywh');
				b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.daynight.id, pos, false);	
			end
		end
		if(-1 == param_data.focus.zoom_enable) and (-1 ==param_data.focus.dn_autofocus)then
			b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_focus.id,true, redraw)
		else
			b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_focus.id,bool_flag, redraw)
		end
		
		if(hide_idx == 1)then
			local pos = SIZE('s_row_imagerow_day_night_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.noise_reduct.id, pos, false);
			pos = SIZE('s_row_imagerow_noise_reduct_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.enhance.id, pos, false);
			pos = SIZE('s_row_imagerow_enhance_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.image_focus.id, pos, false);
		elseif(hide_idx == 2)then
			local pos = SIZE('s_row_imagerow_wb_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.noise_reduct.id, pos, false);
			pos = SIZE('s_row_imagerow_day_night_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.enhance.id, pos, false);
			pos = SIZE('s_row_imagerow_noise_reduct_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.image_focus.id, pos, false);
		elseif(hide_idx == 3)then
			local pos = SIZE('s_row_imagerow_exposure_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.noise_reduct.id, pos, false);
			pos = SIZE('s_row_imagerow_wb_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.enhance.id, pos, false);
			pos = SIZE('s_row_imagerow_day_night_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.image_focus.id, pos, false);
			if (-1 == param_data.pcolor.pseudo_color) and (-1 ==param_data.pcolor.strip_switch) then
				b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_pcolor.id,true, redraw)
			else
				b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_pcolor.id,false, redraw)
			end
			if (-1 == param_data.ffc.ffc_control) and (-1 ==param_data.ffc.ffc_interval_min) then
				b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_ffc.id,true, redraw)
			else
				b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_ffc.id,false, redraw)
			end
			local pos_f = SIZE('s_row_imagerow_day_night_xywh');
			if(-1 == param_data.focus.zoom_enable) and (-1 ==param_data.focus.dn_autofocus)then
				pos = SIZE('s_row_imagerow_day_night_xywh');
				pos_f = SIZE('s_row_imagerow_noise_reduct_xywh');
			else
				pos = SIZE('s_row_imagerow_noise_reduct_xywh');
				pos_f = SIZE('s_row_imagerow_enhance_xywh');	
			end
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.image_pcolor.id, pos, false);
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.image_ffc.id, pos_f, false);
		else
			local pos = SIZE('s_row_imagerow_exposure_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.exposure.id, pos, false);	
			local pos = SIZE('s_row_imagerow_wb_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.whitebalance.id, pos, false);	
			pos = SIZE('s_row_imagerow_day_night_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.daynight.id, pos, false);	
			pos = SIZE('s_row_imagerow_noise_reduct_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.noise_reduct.id, pos, false);
			pos = SIZE('s_row_imagerow_enhance_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.enhance.id, pos, false);
			pos = SIZE('s_row_imagerow_image_focus_xywh');
			b_wnd_ex.move_ex(top, w1_row_imagerow.wnd.image_focus.id, pos, false);
							
		end
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.noise_reduct.id,bool_flag, redraw)
		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.enhance.id,bool_flag, redraw)
--		b_wnd_ex.set_hide(top,w1_row_imagerow.wnd.image_focus.id,bool_flag, redraw)	

	end	
end

w1_row_imagerow.changecheck = function(top, wnd, id,redraw)
	for k,v in pairs( wnd.sub ) do
		if(wnd[v].t == 'checkbutton') then
			b_wnd_ex.set_check(top, wnd[v].id, false, false)
		end
	end
	
	b_wnd_ex.set_check(top, id, true, false);
	local wnd_id = w1_row_imagerow.wnd
	
	if(id == wnd_id.imageadjust.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_image.con_image_id, w1_id.cfg_image.imageadjust_id, false)		
	elseif(id  == wnd_id.scenes.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_image.con_image_id, w1_id.cfg_image.scenes_id, false)	
	elseif(id  == wnd_id.exposure.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_image.con_image_id, w1_id.cfg_image.exposure_id, false)
	elseif(id  == wnd_id.whitebalance.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_image.con_image_id, w1_id.cfg_image.whitebalance_id, false)
	elseif(id  == wnd_id.daynight.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_image.con_image_id, w1_id.cfg_image.daynight_id, false)
	elseif(id  == wnd_id.noise_reduct.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_image.con_image_id, w1_id.cfg_image.noise_reduct_id, false)
	elseif(id  == wnd_id.enhance.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_image.con_image_id, w1_id.cfg_image.enhance_id, false)
	elseif(id  == wnd_id.image_focus.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_image.con_image_id, w1_id.cfg_image.focus_id, false)
	elseif(id  == wnd_id.image_pcolor.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_image.con_image_id, w1_id.cfg_image.imagepcolor_id, false)
	elseif(id  == wnd_id.image_ffc.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_image.con_image_id, w1_id.cfg_image.imageffc_id, false)
	end
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end
end

w1_row_imagerow.get_checkidx = function(top)
	local imageadjust = b_wnd_ex.get_check(top, w1_row_imagerow.wnd.imageadjust.id);
	local scenes = b_wnd_ex.get_check(top, w1_row_imagerow.wnd.scenes.id);
	local exposure = b_wnd_ex.get_check(top, w1_row_imagerow.wnd.exposure.id);
	local wb = b_wnd_ex.get_check(top, w1_row_imagerow.wnd.whitebalance.id);
	local daynight = b_wnd_ex.get_check(top, w1_row_imagerow.wnd.daynight.id);
	local noise_reduct = b_wnd_ex.get_check(top, w1_row_imagerow.wnd.noise_reduct.id);
	local enhance = b_wnd_ex.get_check(top, w1_row_imagerow.wnd.enhance.id);
	local image_focus = b_wnd_ex.get_check(top, w1_row_imagerow.wnd.image_focus.id);
	local image_pcolor = b_wnd_ex.get_check(top, w1_row_imagerow.wnd.image_pcolor.id);
	local image_ffc = b_wnd_ex.get_check(top, w1_row_imagerow.wnd.image_ffc.id);

	
	if(imageadjust) then
		return 0
	elseif(scenes) then
		return 1
	elseif(exposure) then
		return 2
	elseif(wb) then
		return 3
	elseif(daynight) then
		return 4
	elseif(noise_reduct) then
		return 5
	elseif(enhance) then
		return 6
	elseif(image_focus) then
		return 7
	elseif(image_pcolor) then
		return 8
	elseif(image_ffc) then
		return 9
	else 
		return -1
	end
end

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_row_imagerow.changecheck(top, w1_row_imagerow.wnd, win_id,true);
	end
	return 0
end

w1_row_imagerow.move_title_show =function(top)
	local cwnd = w1_row_imagerow.wnd;
	local pos = SIZE('s_row_imagerow_xywh');
	local title_1 = SIZE('s_row_imagerow_image_xywh')
	local title_1 = SIZE('s_row_imagerow_image_xywh')
	local title = SIZE('s_row_imagerow_titile_w')
	local title_w =pos[3]-title_1[1] 
	local size1 = title[3];
	local size2 = size1;
	local size3 = size1;
	local size4 = size1;
	local size5 = size1;
	local size6 = size1;
	local size7 = size1;
	local size8 = size1;
	
	local space = title[1];
	local total_w = size1 + size2 + size3 + size4 + size5 + size6 + size7 + size8 + space*8
	
	if(title_w > total_w)then
		local x = title_1[1]
		local movepos1 = {x,title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.imageadjust.id, movepos1, false);
		
		x = x + size1 + space
		local movepos2 = {x,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.scenes.id, movepos2, false);
		
		x = x + size2 + space
		local movepos3 = {x,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.exposure.id, movepos3, false);
		
		x = x + size3 + space
		local movepos4 = {x,title_1[2],size4,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.whitebalance.id, movepos4, false);
		
		x = x + size4 + space
		local movepos5 = {x,title_1[2],size5,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.daynight.id, movepos5, false);
		
		x = x + size5 + space
		local movepos6 = {x,title_1[2],size6,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.noise_reduct.id, movepos6, false);
		
		x = x + size6 + space
		local movepos7 = {x,title_1[2],size7,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.enhance.id, movepos7, false);
		
		x = x + size7 + space
		local movepos8 = {x,title_1[2],size8,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.image_focus.id, movepos8, false);
	end
end

w1_row_imagerow.on_pre_show= function(top)
	w1_row_imagerow.move_title_show(top)
end

w1_row_imagerow.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_row_imagerow_xywh',

	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'imageadjust','scenes','exposure','whitebalance','daynight','noise_reduct',
			'enhance','image_focus','image_pcolor','image_ffc','hline1'},

	imageadjust	= {t='checkbutton',	id=id+1,xywh = 's_row_imagerow_image_xywh',	text='LA_IMAGE',check = true,	
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},

	scenes 	= {t='checkbutton',	id=id+3,xywh = 's_row_imagerow_scenes_xywh',	text='LA_SCENCE',			
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
				
	exposure 	= {t='checkbutton',	id=id+4,xywh = 's_row_imagerow_exposure_xywh',	text='LA_EXPOSURE',
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},

	whitebalance	= {t='checkbutton',	id=id+5,xywh = 's_row_imagerow_wb_xywh',	text='LA_WHITE_BALANCE',
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},

	daynight 	= {t='checkbutton',	id=id+6,xywh = 's_row_imagerow_day_night_xywh',	text='LA_DAY_NIGHT',			
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
				
	noise_reduct	= {t='checkbutton',	id=id+7,xywh = 's_row_imagerow_noise_reduct_xywh',	text='LA_NOISE_REDUCTION',	
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},

	enhance 	= {t='checkbutton',	id=id+8,xywh = 's_row_imagerow_enhance_xywh',	text='LA_ENHANCE_IMAGE',			
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
				
	image_focus 	= {t='checkbutton',	id=id+9,xywh = 's_row_imagerow_image_focus_xywh',	text='LA_ZOOM_FOCUS',		
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
				
	image_pcolor	= {t='checkbutton',	id=id+10,xywh = 's_row_imagerow_noise_reduct_xywh',	text='LA_PSEUDO_SET',		
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
				
	image_ffc	= {t='checkbutton',	id=id+11,xywh = 's_row_imagerow_enhance_xywh',	text='LA_FFC_CONTRIL',		
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
	hline1 		= {t='hline',id=id+12,	xywh='s_row_imagerow_mline1'},
}

return w1_row_imagerow
