--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_logm.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")

local w1_row_logman = {}

local on_log = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_logman.wnd, win_id, true)
	end
	return 0
end

w1_row_logman.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'log', 'event','hline'},

	log 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',
				text='LA_SYSTEM_LOG',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_log,check = true},
	event 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_2',
				text='LA_EVENT_LOG',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_log},
	hline 	= {t='hline',	id=id+3,xywh='s_cfg_row_hline'}
}

return w1_row_logman
