--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_modify.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_wnd_ex		= require("wnd.core.b_wnd_ex");
local w1_row_modify = {}

local on_modify = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_modify.wnd, win_id, true)
	end
	return 0
end

w1_row_modify.move_title_show= function(top)
	local cwnd = w1_row_modify.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_w =pos[3]-pos[4] 
	local size1 = b_wnd_ex.get_textsize(top, cwnd.modify.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.s_g_pwd.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.s_mail.id).w;
	local size4 = b_wnd_ex.get_textsize(top, cwnd.s_que.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.modify.id).border * 60 ;--
	local total_w = size1 + size2 + size3 + size4 + space * 3
	local title_1 = SIZE('s_cfg_row_1')

	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.modify.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.s_g_pwd.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+space*2,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.s_mail.id, movepos3, false);
		local movepos4 = {title_1[1]+size1+size2+size3+space*3,title_1[2],size4,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.s_que.id, movepos4, false);
	end

end

w1_row_modify.on_pre_show = function(top)
	--adminûðȫͰȫ
	local user_info	= global_val.get_user_info()
	local root_name = global_val.get_root_user_name();
	if(user_info.m_strUsername ~= root_name) then
		b_wnd_ex.set_hide(top,w1_row_modify.wnd.s_g_pwd.id,true,false);
		b_wnd_ex.set_hide(top,w1_row_modify.wnd.s_mail.id,true,false);
		b_wnd_ex.set_hide(top,w1_row_modify.wnd.s_que.id,true,false);
	else
		b_wnd_ex.set_hide(top,w1_row_modify.wnd.s_g_pwd.id,false,false);
		b_wnd_ex.set_hide(top,w1_row_modify.wnd.s_mail.id,false,false);
		b_wnd_ex.set_hide(top,w1_row_modify.wnd.s_que.id,false,false);
	end
	
	local cwnd = w1_row_modify.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_w =pos[3]-pos[4] 
	local size1 = b_wnd_ex.get_textsize(top, cwnd.modify.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.s_g_pwd.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.s_mail.id).w;
	local size4 = b_wnd_ex.get_textsize(top, cwnd.s_que.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.modify.id).border * 60 ;--
	local total_w = size1 +size2+size3+size4 +space*4
	if title_w < total_w then
		space = b_wnd_ex.get_textsize(top, cwnd.modify.id).border * 40 ;
		total_w = size1 +size2+size3+size4 +space*4
	end
	if title_w < total_w then
		space = b_wnd_ex.get_textsize(top, cwnd.modify.id).border * 20 ;
		total_w = size1 +size2+size3+size4 +space*4
	end
	if title_w < total_w then
		space = b_wnd_ex.get_textsize(top, cwnd.modify.id).border * 10 ;
		total_w = size1 +size2+size3+size4 +space*4
	end
	local title_1 = SIZE('s_cfg_row_1')
	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.modify.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.s_g_pwd.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+2*space,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.s_mail.id, movepos3, false);
		local movepos4 = {title_1[1]+size1+size2+size3+3*space,title_1[2],size4,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.s_que.id, movepos4, false);
	else
		space = b_wnd_ex.get_textsize(top, cwnd.modify.id).border * 60 ;--
		if size1 > title_1[3] then
			size1 = title_1[3]
		end
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.modify.id, movepos1, false);
		if size2 > title_1[3] then
			size2 = title_1[3]
		end
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.s_g_pwd.id, movepos2, false);
		if size3 > title_1[3]  then
			size3 = title_1[3] 
		end
		local movepos3 = {title_1[1]+size1+size2+2*space,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.s_mail.id, movepos3, false);
		if size4 > title_1[3]  then
			size4 = title_1[3] 
		end
		local movepos4 = {title_1[1]+size1+size2+size3+3*space,title_1[2],size4,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.s_que.id, movepos4, false);
	end
	
	w1_row_modify.move_title_show(top)
end

w1_row_modify.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'modify','s_g_pwd','s_mail','s_que', 'hline'},
	
	modify 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',
				text='LA_PASSWORD',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_modify,check = true},
	s_g_pwd	= {t='checktxt',	id=id+2,xywh='s_cfg_row_2',
				text='LA_PATTERN',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_modify},			
	s_mail 	= {t='checktxt',	id=id+3,xywh='s_cfg_row_3',
				text='LA_SAFE_EMAIL',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_modify},
	s_que 	= {t='checktxt',	id=id+4,xywh='s_cfg_row_4',
				text='LA_SAFE_QUESTION',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_modify},			
	hline 	= {t='hline',	id=id+5,xywh='s_cfg_row_hline'}
}

return w1_row_modify
