--[[
-- Copyright(c) 2018-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/29
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_record.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")

local w1_row_record = {}

local on_record = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_record.wnd, win_id, true)
	end
	return 0
end

w1_row_record.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'record', 'hline'},

	record 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_x1',
				text='LA_RECORD_POLICY',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_record,check = true},
	hline 	= {t='hline',	id=id+2,xywh='s_cfg_row_hline'}
}

return w1_row_record
