--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_privacy.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_dlg 	= require("wnd.core.b_dlg")
local w1_row_user = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_user.s_768 =
{
};

w1_row_user.s_1280 = 
{
};

w1_row_user.s_1440 = 
{
};


w1_row_user.s_1080p = 
{
};

w1_row_user.s_2k = 
{
};

w1_row_user.s_4k = 
{
};

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local nret = w1_wnd_jump.click_row(top, w1_row_user.wnd, win_id, false)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_row_user.move_title_show= function(top)
	local cwnd = w1_row_user.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_w =pos[3]-pos[4]

	local size1 = b_wnd_ex.get_textsize(top, cwnd.user.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.pri.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.phone_filter.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.user.id).border * 60 ;--
	
	local total_w = size1 + size2 + size3 + space*3
	local title_1 = SIZE('s_cfg_row_1')
	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.user.id, movepos1, false);
		
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.pri.id, movepos2, false);
		
		local movepos3 = {title_1[1]+size1+space+size2+space,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.phone_filter.id, movepos3, false);
	end
end

w1_row_user.on_pre_show = function(top)
	w1_row_user.move_title_show(top)
end

w1_row_user.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'user', 'pri', 'phone_filter', 'hline'},
	user 	= {t='checktxt',id=id+1,xywh='s_cfg_row_1',
					text='LA_PERMISSION',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
					cmd=on_click,check = true},
					
	pri= {t='checktxt',	id=id+2,xywh = 's_cfg_row_2',
					text='LA_PRIVACY',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
					cmd=on_click},
					
	phone_filter= {t='checktxt',	id=id+3,xywh = 's_cfg_row_3',
					text='LA_PHONE_FILTER', font = 'f_grade4',align = b_ui.ALIGN.LEFT,
					cmd=on_click},

	hline 	= {t='hline',	id=id+4,xywh='s_cfg_row_hline'}
	
}

return w1_row_user
