--[[
-- Copyright(c) 2018-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/10
-- author 
-- brief  
--]]
local b_app_cfg	= require("wnd.core.b_app_cfg")
local util 		= require("wnd.core.util")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color


local w1_wnd_util = {}

w1_wnd_util.tipstatus =
{
	success = 0,	--ɹ
	nochange = 1,	--δ޸
	paramerr = 2,	--
	retdefault = 3, --ָĬϳɹ
	paramerr_str = '',
	no_tip = 4,		--ʾṩӦñӦزʱʾ
}


w1_wnd_util.cfgtab = {}					--Ҫȡ豸Ϣֵ
w1_wnd_util.cfgtouifunc = {}			--ˢUI
w1_wnd_util.uitocfgfunc = {}			--UIˢ
w1_wnd_util.uidatacheckfunc = {}		--UIòļ
w1_wnd_util.returndatacheckfunc = {}		--ֵ
w1_wnd_util.errwidgetid = {}			--ؼID
w1_wnd_util.olderrwidgetid = {}			--һοؼID
w1_wnd_util.tipflag = w1_wnd_util.tipstatus.success	--ʾ״̬־λ
		
w1_wnd_util.tipdisptime = 6		--ʾϢʾʱ 120.5
w1_wnd_util.tiptimenum= 0		--ʱ λ:0.5
w1_wnd_util.tipdisp= 0			--ʾϢʾ־λ



--ûǷи,и,򷵻ظĺ
w1_wnd_util.usercfgchange =function()
	local param = b_app_cfg.tabcompare()
	if(	util.is_empty(param) )then
		return false,nil
	else
		return true, param
	end
end

w1_wnd_util.usercfgchange_b =function(table1, table2)
	local param = b_app_cfg.tabcompare_b(table1, table2)
	if(	util.is_empty(param) )then
		return false,nil
	else
		return true, param
	end
end

--Ӧidؼʾ
w1_wnd_util.tipclear = function(top, id, redraw)
	b_wnd_ex.set_text(top, id, '', redraw)

	w1_wnd_util.olderrwidgetid = nil
end

w1_wnd_util.tipdispon = function()			--ʾϢ
	w1_wnd_util.tiptimenum = 0
	w1_wnd_util.tipdisp	= 1
end


w1_wnd_util.page_init = function(top)
	assert(type(w1_wnd_util.cfgtab) == 'table')
	assert(type(w1_wnd_util.cfgtouifunc) == 'function')
	b_app_cfg.init(w1_wnd_util.cfgtab)
	
	w1_wnd_util.cfgtouifunc(top, b_app_cfg.user_cfg)
	w1_wnd_util.paramerr_str = '';
end

w1_wnd_util.page_ondefault = function(top)
	assert(type(w1_wnd_util.cfgtouifunc) == 'function')
	--b_app_cfg.defaluttousercfg()
	w1_wnd_util.cfgtouifunc(top, b_app_cfg.user_cfg)
	w1_wnd_util.tipflag = w1_wnd_util.tipstatus.retdefault	
end

w1_wnd_util.page_onapply = function(top)
	local ret = nil;
	assert(type(w1_wnd_util.uidatacheckfunc) == 'function')
	if(w1_wnd_util.olderrwidgetid ~= nil) then
		for i =1, #w1_wnd_util.olderrwidgetid do
			b_wnd_ex.set_color(top, w1_wnd_util.olderrwidgetid[i],
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top, w1_wnd_util.olderrwidgetid[i],
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_f'),COLOR('c_txt_f')},true)
		end
	end
	w1_wnd_util.clearerrweight(top,false);
	local legalflag, idtab = w1_wnd_util.uidatacheckfunc(top)

	--ûǷȫϷ
	if(legalflag == true) then
		--w1_wnd_util.uitocfgfunc(top, b_app_cfg.user_cfg)
		local changeflag, changeparam = w1_wnd_util.usercfgchange()
		if(changeflag) then
			--Ѹĺ'ṹ'浽ļ
			ret = b_app_cfg.savechangecfg(changeparam)
			if w1_wnd_util.returndatacheckfunc ~= nil and type(w1_wnd_util.returndatacheckfunc) == 'function' and type(ret) == 'table' then
				legalflag, idtab = w1_wnd_util.returndatacheckfunc(top,ret.ret)
			end
			if legalflag ~= true and idtab ~= nil then
				if (w1_wnd_util.errwidgetid == nil) then
					w1_wnd_util.errwidgetid  = idtab;
				else
					util.copy_tab_b(w1_wnd_util.errwidgetid, idtab);	
				end
				if(w1_wnd_util.olderrwidgetid == nil) then
					w1_wnd_util.olderrwidgetid = util.copy_tab(w1_wnd_util.errwidgetid);
				else
					util.copy_tab_b(w1_wnd_util.olderrwidgetid, w1_wnd_util.errwidgetid);
				end
				w1_wnd_util.tipflag = w1_wnd_util.tipstatus.paramerr
			else
				w1_wnd_util.tipflag = w1_wnd_util.tipstatus.success
				b_app_cfg.saveSuccessful();
			end
		else
			w1_wnd_util.tipflag = w1_wnd_util.tipstatus.nochange
			ret = {};
		end	
	else
		w1_wnd_util.tipflag = w1_wnd_util.tipstatus.paramerr
		--ûݲȫǺϷ,¼вϷؼIDֵ
		if(idtab ~= nil) then
			if (w1_wnd_util.errwidgetid == nil) then
				w1_wnd_util.errwidgetid  = idtab;
			else
				util.copy_tab_b(w1_wnd_util.errwidgetid, idtab);	
			end
		end	
		if(w1_wnd_util.olderrwidgetid == nil) then
			w1_wnd_util.olderrwidgetid = util.copy_tab(w1_wnd_util.errwidgetid);
		else
			util.copy_tab_b(w1_wnd_util.olderrwidgetid, w1_wnd_util.errwidgetid);
		end
		
		ret = {param_illegal_falg = true};
	end

	if(w1_wnd_util.tipflag == w1_wnd_util.tipstatus.paramerr)then
		if(type(ret) == "table")then
			ret.param_illegal_falg = true
		end
	end

		
	return ret;
end

--ݺϷԣṩӦñزʾ
w1_wnd_util.check_param =function (top)
	assert(type(w1_wnd_util.uidatacheckfunc) == 'function')
	if(w1_wnd_util.olderrwidgetid ~= nil) then
		for i =1, #w1_wnd_util.olderrwidgetid do
			b_wnd_ex.set_color(top, w1_wnd_util.olderrwidgetid[i],
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top, w1_wnd_util.olderrwidgetid[i],
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_f'),COLOR('c_txt_f')},true)
		end
	end
	local legalflag, idtab = w1_wnd_util.uidatacheckfunc(top)
	if(legalflag == true) then
		w1_wnd_util.tipflag = w1_wnd_util.tipstatus.no_tip
	else
		w1_wnd_util.tipflag = w1_wnd_util.tipstatus.paramerr
		--ûݲȫǺϷ,¼вϷؼIDֵ
		if(idtab ~= nil) then
			if (w1_wnd_util.errwidgetid == nil) then
				w1_wnd_util.errwidgetid  = idtab;
			else
				util.copy_tab_b(w1_wnd_util.errwidgetid, idtab);	
			end
		end
		if(w1_wnd_util.olderrwidgetid == nil) then
			w1_wnd_util.olderrwidgetid = util.copy_tab(w1_wnd_util.errwidgetid);
		else
			util.copy_tab_b(w1_wnd_util.olderrwidgetid, w1_wnd_util.errwidgetid);
		end	
	end	
end
--Ϸж
w1_wnd_util.check_legal_tip = function(top)
	assert(type(w1_wnd_util.uidatacheckfunc) == 'function')
	if(w1_wnd_util.olderrwidgetid ~= nil) then
		for i =1, #w1_wnd_util.olderrwidgetid do
			b_wnd_ex.set_color(top, w1_wnd_util.olderrwidgetid[i],
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top, w1_wnd_util.olderrwidgetid[i],
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_f'),COLOR('c_txt_f')},true)
		end
	end	
	local legalflag, idtab = w1_wnd_util.uidatacheckfunc(top)
	--ûǷȫϷ
	if(legalflag ~= true) then
		w1_wnd_util.tipflag = w1_wnd_util.tipstatus.paramerr
		--ûݲȫǺϷ,¼вϷؼIDֵ
		if(idtab ~= nil) then
			if (w1_wnd_util.errwidgetid == nil) then
				w1_wnd_util.errwidgetid  = idtab;
			else
				util.copy_tab_b(w1_wnd_util.errwidgetid, idtab);	
			end
		end
		if(w1_wnd_util.olderrwidgetid == nil) then
			w1_wnd_util.olderrwidgetid = util.copy_tab(w1_wnd_util.errwidgetid)
		else
			util.copy_tab_b(w1_wnd_util.olderrwidgetid, w1_wnd_util.errwidgetid)
		end	
		return -1;
	end
	return 0
		
end

--ȡвڿؼID
w1_wnd_util.geterrwidgetid = function()
	return w1_wnd_util.errwidgetid
end

--Ӧúȡ״̬־λ
w1_wnd_util.gettipflag = function()
	return w1_wnd_util.tipflag
end

w1_wnd_util.setparamerr_str = function(str)
	assert(type(str) == 'string');
	w1_wnd_util.paramerr_str = str
end

w1_wnd_util.tipinfodisp= function(top, id)
	local settext = function(str)
		b_wnd_ex.set_text(top, id, str, true)
	end
	
	if(w1_wnd_util.tipflag == w1_wnd_util.tipstatus.success) then			--ɹ
		settext(STR('LA_APPLY_OK'))
		b_wnd_ex.set_color(top, id,
			{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_apply_ok')},true)
			return 1;
	elseif(w1_wnd_util.tipflag == w1_wnd_util.tipstatus.nochange) then	--δ޸
		settext(STR('LA_NO_CHANGE'))	
		b_wnd_ex.set_color(top, id,
			{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_apply_ok')},true)
			return 0;
	elseif(w1_wnd_util.tipflag == w1_wnd_util.tipstatus.paramerr) then	--
		if(w1_wnd_util.paramerr_str ~= nil) then
			settext(w1_wnd_util.paramerr_str)
		else
			settext(STR('LA_PARAMETER_ERROR'))
		end
		b_wnd_ex.set_color(top, id,
			{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_hint_err_text')},true)
		return -1;
	elseif(w1_wnd_util.tipflag == w1_wnd_util.tipstatus.retdefault) then	--
		settext(STR('LA_RESTORE_SUCCESS'))
		return -1;
	elseif(w1_wnd_util.tipflag == w1_wnd_util.tipstatus.no_tip)then --Ӧزʾ
		return 0;
	end
	return 0;
end

--Ӧؼ߿ʾ
w1_wnd_util.seterrweight = function(top)
	for i =1, #w1_wnd_util.errwidgetid do
		b_wnd_ex.set_color(top,w1_wnd_util.errwidgetid[i],
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
		b_wnd_ex.set_color_f(top,w1_wnd_util.errwidgetid[i],
		{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},true)
	end
end

--Ӧؼ߿ָ
w1_wnd_util.clearerrweight = function(top,redraw)
	for i =1, #w1_wnd_util.errwidgetid do
		b_wnd_ex.set_color(top,w1_wnd_util.errwidgetid[i],
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_edit_text_n')},redraw)
		b_wnd_ex.set_color_f(top,w1_wnd_util.errwidgetid[i],
		{COLOR('c_edit_bg_f'),COLOR('c_edit_border_f'),COLOR('c_txt_f')},redraw)
	end
	
	util.clear_tab(w1_wnd_util.errwidgetid);
end

w1_wnd_util.tipdispoff = function()			--رʾϢ
	w1_wnd_util.tiptimenum = 0
	w1_wnd_util.tipdisp	= 0
end

w1_wnd_util.timerenevt = function(top, tipinfoid)
	w1_wnd_util.tiptimenum = w1_wnd_util.tiptimenum + 1
	if(w1_wnd_util.tipdisp == 0) then		--ִκζ
	
	elseif(w1_wnd_util.tipdisp == 1) then	--ʾ
		w1_wnd_util.tipdisp = 2				--´νʱִʾ
		local flag = w1_wnd_util.tipinfodisp(top, tipinfoid)
		w1_wnd_util.seterrweight(top)		--Ӧؼ߿ʾ
		return flag;
	elseif(w1_wnd_util.tipdisp == 2 and w1_wnd_util.tiptimenum >= w1_wnd_util.tipdisptime) then	--ʾ
		w1_wnd_util.tipdisp = 0				--´νִκζ
		w1_wnd_util.tipclear(top, tipinfoid, true)
		w1_wnd_util.clearerrweight(top, true)
	end
	return 0;
end
--Ӧidؼʾ
w1_wnd_util.insertwidget = function(widgettype, widgetid)
	
	
end

w1_wnd_util.clear_data = function()
	w1_wnd_util.errwidgetid = nil;
	w1_wnd_util.cfgtab = nil;
end

return w1_wnd_util

