local r_color		= require("wnd.core.r_res.r_color")
local r_img			= require("wnd.core.r_res.r_img")
local r_t_img		= require("wnd.core.r_res.r_t_img")
local r_font		= require("wnd.core.r_res.r_font")
local r_size		= require("wnd.core.r_res.r_size")
local global_val	= require("wnd.global_val")
local b_app_api 	= require("wnd.core.command.b_app_api")
local size_face_n	= nil;
--ɫ
local color_sty1 		= require("wnd.w1_facade.color.w1_color_sty1")		--ɫ
local color_sty2 		= require("wnd.w1_facade.color.w1_color_sty2")		--ɫ

--ƽ̨ɫɫ
local color_sty3536d 		= require("wnd.w1_facade.color.w1_color_sty3536d")		--ɫ

--ͼƬ
local image_1080p_n		= require("wnd.w1_facade.img.w1_image_1080p_n")		--luaӦó򲿷ɫ1
local image_4k_n		= require("wnd.w1_facade.img.w1_image_4k_n")

--ʸͼƬ
local w1_t_img			= require("wnd.w1_facade.img.w1_t_img")		--ʸͼƬ

--
local font_768_n 		= require("wnd.w1_facade.font.w1_font_768_n")		--ֺ
local font_1280_n 		= require("wnd.w1_facade.font.w1_font_1280_n")		--ֺ
local font_1440_n 		= require("wnd.w1_facade.font.w1_font_1440_n")		--ֺ
local font_1080p_n 		= require("wnd.w1_facade.font.w1_font_1080p_n")		--ֺ
local font_4k_n 		= require("wnd.w1_facade.font.w1_font_4k_n")		--ֺ
local font_2k_n 		= require("wnd.w1_facade.font.w1_font_2k_n")		--ֺ

--
local size_768_n 		= require("wnd.w1_facade.size.w1_size_768_n")
local size_1280_n 		= require("wnd.w1_facade.size.w1_size_1280_n")
local size_1440_n 		= require("wnd.w1_facade.size.w1_size_1440_n")
local size_1080p_n 		= require("wnd.w1_facade.size.w1_size_1080p_n")
local size_4k_n 		= require("wnd.w1_facade.size.w1_size_4k_n")
local size_2k_n 		= require("wnd.w1_facade.size.w1_size_2k_n")

local w1_ui_facade = {}

local set_fontsize = function(str)
	if(str == 'f_normal_768') then
		r_font.set_fontsize(font_768_n.widget, font_768_n.capp, font_768_n.luaapp)
	elseif(str == 'f_normal_1280') then
		r_font.set_fontsize(font_1280_n.widget, font_1280_n.capp, font_1280_n.luaapp)	
	elseif(str == 'f_normal_1440') then
		r_font.set_fontsize(font_1440_n.widget, font_1440_n.capp, font_1440_n.luaapp)
	elseif(str == 'f_normal_1080p') then
		r_font.set_fontsize(font_1080p_n.widget, font_1080p_n.capp, font_1080p_n.luaapp)
	elseif(str == 'f_normal_4k') then
		r_font.set_fontsize(font_4k_n.widget, font_4k_n.capp, font_4k_n.luaapp)
	elseif(str == 'f_normal_2k') then
		r_font.set_fontsize(font_2k_n.widget, font_2k_n.capp, font_2k_n.luaapp)
	else
		r_font.set_fontsize(font_1080p_n.widget, font_1080p_n.capp, font_1080p_n.luaapp)	
	end
end

w1_ui_facade.set_image = function(str)
	image_1080p_n.luaapp.i_poe_internet		= "style1_poe/poe_internet"
	image_1080p_n.luaapp.i_poe_gateway		= "style1_poe/poe_gateway"
	image_1080p_n.luaapp.i_poe_device_off	= "style1_poe/poe_device_off"
	image_1080p_n.luaapp.i_poe_device_on	= "style1_poe/poe_device_on"
	image_1080p_n.luaapp.i_poe_wan_on		= "style1_poe/poe_wan_on"
	image_1080p_n.luaapp.i_poe_lan_on		= "style1_poe/poe_lan_on"
	image_1080p_n.luaapp.i_poe_wan_boder	= "style1_poe/poe_wan_boder"
	image_1080p_n.luaapp.i_poe_wan_off		= "style1_poe/poe_wan_off"
	image_1080p_n.luaapp.i_poe_lan_off		= "style1_poe/poe_lan_off"
	if(str == 'i_4k_n') then
		r_img.set_img_style(image_4k_n.widget,image_4k_n.capp,  image_4k_n.luaapp);
	elseif (str == 'i_2k_n') then
		local face_flag = global_val.get_support_face_attr();
		if (face_flag == true) then --֧İͼƬ2KͼƬ ͼƬ1080P
			image_1080p_n.capp.i_stranger_img = "img/2k_stranger_image";
			r_img.set_img_style(image_1080p_n.widget,image_1080p_n.capp, image_1080p_n.luaapp);
		else	
			r_img.set_img_style(image_1080p_n.widget,image_1080p_n.capp, image_1080p_n.luaapp);
		end
	elseif (str == 'i_768_n') then
		image_1080p_n.luaapp.i_poe_internet		= "style1_poe/768_poe_internet"
		image_1080p_n.luaapp.i_poe_gateway		= "style1_poe/768_poe_gateway"
		image_1080p_n.luaapp.i_poe_device_off	= "style1_poe/768_poe_device_off"
		image_1080p_n.luaapp.i_poe_device_on	= "style1_poe/768_poe_device_on"
		image_1080p_n.luaapp.i_poe_wan_on		= "style1_poe/768_poe_wan_on"
		image_1080p_n.luaapp.i_poe_lan_on		= "style1_poe/768_poe_lan_on"
		image_1080p_n.luaapp.i_poe_wan_boder	= "style1_poe/768_poe_wan_boder"
		image_1080p_n.luaapp.i_poe_wan_off		= "style1_poe/768_poe_wan_off"
		image_1080p_n.luaapp.i_poe_lan_off		= "style1_poe/768_poe_lan_off"
		local face_flag = global_val.get_support_face_attr();
		if (face_flag == true) then 
			image_1080p_n.capp.i_stranger_img = "img/768_stranger_image";
		end
		r_img.set_img_style(image_1080p_n.widget,image_1080p_n.capp, image_1080p_n.luaapp);
	else	
		local face_flag = global_val.get_support_face_attr();
		if (face_flag == true) then 
			image_1080p_n.capp.i_stranger_img = "img/stranger_image";
		end	
		r_img.set_img_style(image_1080p_n.widget,image_1080p_n.capp, image_1080p_n.luaapp);
	end
end

w1_ui_facade.set_t_image = function(str)
	r_t_img.set_img_style(w1_t_img.widget, w1_t_img.luaapp);
end

w1_ui_facade.set_color = function(style_num)
	if(style_num == 'light') then
		r_color.set_color_style(color_sty2.widget, color_sty2.capp, color_sty2.luaapp);
	elseif(style_num == 'c_3536d')then
		r_color.set_color_style(color_sty3536d.widget, color_sty3536d.capp, color_sty3536d.luaapp);
	else
		r_color.set_color_style(color_sty1.widget, color_sty1.capp, color_sty1.luaapp);
	end
end

w1_ui_facade.set_size = function(str)
	local face_flag = global_val.get_support_face_attr();
	local attendance_flag = global_val.get_support_attendance_attr();
	if (face_flag == true or attendance_flag == true) then
		if (nil == size_face_n) then
			size_face_n = require("wnd.w1_facade.size.w1_face_recognition_size")
		end
		assert(nil ~= size_face_n and type(size_face_n) == "table");
		
		if(str == 's_768_n') then
			r_size.set_size(size_768_n.widget, size_768_n.capp, size_768_n.luaapp, size_768_n.capp_list_column, size_face_n.s_768);
		elseif(str == 's_1280_n') then
			r_size.set_size(size_1280_n.widget, size_1280_n.capp, size_1280_n.luaapp, size_1280_n.capp_list_column, size_face_n.s_1280);
		elseif(str == 's_1440_n') then
			r_size.set_size(size_1440_n.widget, size_1440_n.capp, size_1440_n.luaapp, size_1440_n.capp_list_column, size_face_n.s_1440);
		elseif(str == 's_2k') then
			r_size.set_size(size_2k_n.widget, size_2k_n.capp, size_2k_n.luaapp, size_2k_n.capp_list_column, size_face_n.s_2k);
		elseif(str == 's_4k') then
			r_size.set_size(size_4k_n.widget, size_4k_n.capp, size_4k_n.luaapp, size_4k_n.capp_list_column, size_face_n.s_4k);
		else
			r_size.set_size(size_1080p_n.widget, size_1080p_n.capp, size_1080p_n.luaapp, size_1080p_n.capp_list_column, size_face_n.s_1080p);
		end
	else
		if(str == 's_768_n') then
			r_size.set_size(size_768_n.widget, size_768_n.capp, size_768_n.luaapp, size_768_n.capp_list_column);
		elseif(str == 's_1280_n') then
			r_size.set_size(size_1280_n.widget, size_1280_n.capp, size_1280_n.luaapp, size_1280_n.capp_list_column);
		elseif(str == 's_1440_n') then
			r_size.set_size(size_1440_n.widget, size_1440_n.capp, size_1440_n.luaapp, size_1440_n.capp_list_column);
		elseif(str == 's_2k') then
			r_size.set_size(size_2k_n.widget, size_2k_n.capp, size_2k_n.luaapp, size_2k_n.capp_list_column);
		elseif(str == 's_4k') then
			r_size.set_size(size_4k_n.widget, size_4k_n.capp, size_4k_n.luaapp, size_4k_n.capp_list_column);
		else
			r_size.set_size(size_1080p_n.widget, size_1080p_n.capp, size_1080p_n.luaapp, size_1080p_n.capp_list_column);
		end
	end		
end

w1_ui_facade.load_fontsize =function(vo, fontsizestr)
	assert(type(fontsizestr) == 'string')
	if(fontsizestr == 'small') then
		if(vo <= 4) then--RJ_VO_SIZE_XGA, RJ_VO_SIZE_720P, RJ_VO_SIZE_SXGA, RJ_VO_SIZE_WXGA, RJ_VO_SIZE_1080P 
			set_fontsize('f_small_1080p');
		elseif(vo == 7) then--RJ_VO_SIZE_4K
			set_fontsize('f_small_4k');
		elseif(vo == 8) then--RJ_VO_SIZE_2K	
			set_fontsize('f_small_2k');
		end
	elseif(fontsizestr == 'big') then
		if(vo <= 4) then--RJ_VO_SIZE_XGA, RJ_VO_SIZE_720P, RJ_VO_SIZE_SXGA, RJ_VO_SIZE_WXGA, RJ_VO_SIZE_1080P 
			set_fontsize('f_big_1080p');
		elseif(vo == 7) then--RJ_VO_SIZE_4K
			set_fontsize('f_big_4k');
		elseif(vo == 8) then--RJ_VO_SIZE_2K	
			set_fontsize('f_big_2k');
		end
	else
		if (vo == 0) then--RJ_VO_SIZE_XGA
			set_fontsize('f_normal_768');
		elseif(vo == 2) then--RJ_VO_SIZE_1280
			set_fontsize('f_normal_1280');
		elseif(vo == 3) then--RJ_VO_SIZE_1440
			set_fontsize('f_normal_1440');	
		elseif(vo == 4) then--RJ_VO_SIZE_1080P 
			set_fontsize('f_normal_1080p');
		elseif(vo == 7) then--RJ_VO_SIZE_4K
			set_fontsize('f_normal_4k');
		elseif(vo == 8) then--RJ_VO_SIZE_2K	
			set_fontsize('f_normal_2k');
		end
	end
end


w1_ui_facade.load_layout = function(vo, style, font)
	local vo_src = b_app_api.get_vo_src(vo);
	
	w1_ui_facade.load_fontsize(vo_src, font);--òֶӦ
	--òֶӦ
	global_val.change_wh(vo_src);
	if(vo_src == 0) then--RJ_VO_SIZE_XGA
		print('w1_ui_facade.set_size: s_768_n');
		w1_ui_facade.set_size('s_768_n');
		w1_ui_facade.set_image('i_768_n');	
	elseif(vo_src == 2) then--RJ_VO_SIZE_1280
		print('w1_ui_facade.set_size: s_1280_n');
		w1_ui_facade.set_size('s_1280_n');
		w1_ui_facade.set_image('i_1080p_n');
	elseif(vo_src == 3) then--RJ_VO_SIZE_1440
		print('w1_ui_facade.set_size: s_1440_n');
		w1_ui_facade.set_size('s_1440_n');
		w1_ui_facade.set_image('i_1080p_n');
	
	elseif(vo_src == 7) then--RJ_VO_SIZE_4K
		print('w1_ui_facade.set_size: s_4k');
		w1_ui_facade.set_size('s_4k');
		w1_ui_facade.set_image('i_4k_n');
	elseif(vo_src == 8) then--RJ_VO_SIZE_2K	
		print('w1_ui_facade.set_size: s_2k');
		w1_ui_facade.set_size('s_2k');
		w1_ui_facade.set_image('i_2k_n');
	else
		print('w1_ui_facade.set_size: s_1080p');
		w1_ui_facade.set_size('s_1080p');
		w1_ui_facade.set_image('i_1080p_n');
	end
end


return w1_ui_facade
