-- ӡ༭ͨҳ
local b_ui 		= require("wnd.core.b_ui")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.edit_dev_id
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local cjson 	= require("cjson")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")

local w1_live_edit_dev = {
	t = w1_key.DLG_EDIT_DEV,
	top = nil,
	dlg = nil,
	alldata,
	curdata,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

local oldprotport = {}

w1_live_edit_dev.s_768 =
{
	s_live_edit_dev_xywh = {357,174,309,440},
	s_live_edit_dev_titleimg_xywh = {6,12,12,17},
	s_live_edit_dev_titlestr_xywh = {26,10,253,28},
	s_live_edit_dev_titleclose_xywh = {288,12,12,17},
	s_live_edit_dev_c_name_xywh = {26,64,106,28},
	s_live_edit_dev_t_name_xywh = {138,64,133,28},
	s_live_edit_dev_c_ip_xywh = {26,106,106,28},
	s_live_edit_dev_t_ip_xywh = {138,106,133,28},
	s_live_edit_dev_c_prot_xywh = {26,149,106,28},
	s_live_edit_dev_t_prot_xywh = {138,149,133,28},
	s_live_edit_dev_c_port_xywh = {26,192,106,28},
	s_live_edit_dev_t_port_xywh = {138,192,133,28},
	s_live_edit_dev_c_user_xywh = {26,234,106,28},
	s_live_edit_dev_t_user_xywh = {138,234,133,28},
	s_live_edit_dev_c_pwd_xywh = {26,277,106,28},
	s_live_edit_dev_t_pwd_xywh = {138,277,133,28},
	s_live_edit_dev_c_remote_ch_xywh = {26,320,106,28},
	s_live_edit_dev_t_remote_ch_xywh = {138,320,133,28},
	s_live_edit_dev_tipinfo_xywh = {26,362,266,12},
	s_live_edit_dev_hline_xywh = {8,384,293,1},
	s_live_edit_dev_ok_xywh = {149,398,64,27},
	s_live_edit_dev_cancel_xywh = {224,398,64,27},
	s_live_edit_dev_draw_xywh = {0,42,0,1},
};

w1_live_edit_dev.s_1280 = 
{
	s_live_edit_dev_xywh= {350,202,580,620},
	s_live_edit_dev_titleimg_xywh= {13,18,24,24}, 
	s_live_edit_dev_titlestr_xywh= {50,15,476,40}, 
	s_live_edit_dev_titleclose_xywh= {541,18,24,24},
	s_live_edit_dev_c_name_xywh= {50,90,200,40},
	s_live_edit_dev_t_name_xywh= {260,90,250,40},
	s_live_edit_dev_c_ip_xywh={50,150,200,40},
	s_live_edit_dev_t_ip_xywh= {260,150,250,40},
	s_live_edit_dev_c_prot_xywh= {50,210,200,40},
	s_live_edit_dev_t_prot_xywh= {260,210,250,40},
	s_live_edit_dev_c_port_xywh= {50,270,200,40},
	s_live_edit_dev_t_port_xywh= {260,270,250,40},
	s_live_edit_dev_c_user_xywh= {50,330,200,40},
	s_live_edit_dev_t_user_xywh= {260,330,250,40},
	s_live_edit_dev_c_pwd_xywh= {50,390,200,40},
	s_live_edit_dev_t_pwd_xywh= {260,390,250,40},
	s_live_edit_dev_c_remote_ch_xywh ={50,450,200,40}, 
	s_live_edit_dev_t_remote_ch_xywh ={260,450,250,40},
	s_live_edit_dev_tipinfo_xywh = {50,510,500,18},
	s_live_edit_dev_hline_xywh = {15,540,550,2},
	s_live_edit_dev_ok_xywh = {280,560,120,38},
	s_live_edit_dev_cancel_xywh = {420,560,120,38},
	s_live_edit_dev_draw_xywh= {0,60,0,1},
}

w1_live_edit_dev.s_1440 = 
{
	s_live_edit_dev_xywh= {670,140,580,620},
	s_live_edit_dev_titleimg_xywh= {13,18,24,24}, 
	s_live_edit_dev_titlestr_xywh= {50,15,476,40}, 
	s_live_edit_dev_titleclose_xywh= {541,18,24,24},
	s_live_edit_dev_c_name_xywh= {50,90,200,40},
	s_live_edit_dev_t_name_xywh= {260,90,250,40},
	s_live_edit_dev_c_ip_xywh={50,150,200,40},
	s_live_edit_dev_t_ip_xywh= {260,150,250,40},
	s_live_edit_dev_c_prot_xywh= {50,210,200,40},
	s_live_edit_dev_t_prot_xywh= {260,210,250,40},
	s_live_edit_dev_c_port_xywh= {50,270,200,40},
	s_live_edit_dev_t_port_xywh= {260,270,250,40},
	s_live_edit_dev_c_user_xywh= {50,330,200,40},
	s_live_edit_dev_t_user_xywh= {260,330,250,40},
	s_live_edit_dev_c_pwd_xywh= {50,390,200,40},
	s_live_edit_dev_t_pwd_xywh= {260,390,250,40},
	s_live_edit_dev_c_remote_ch_xywh ={50,450,200,40}, 
	s_live_edit_dev_t_remote_ch_xywh ={260,450,250,40},
	s_live_edit_dev_tipinfo_xywh = {50,510,500,18},
	s_live_edit_dev_hline_xywh = {15,540,550,2},
	s_live_edit_dev_ok_xywh = {280,560,120,38},
	s_live_edit_dev_cancel_xywh = {420,560,120,38},
	s_live_edit_dev_draw_xywh= {0,60,0,1},
}

w1_live_edit_dev.s_1080p = 
{
	s_live_edit_dev_xywh= {670,245,580,620},
	s_live_edit_dev_titleimg_xywh= {13,18,24,24}, 
	s_live_edit_dev_titlestr_xywh= {50,15,476,40}, 
	s_live_edit_dev_titleclose_xywh= {541,18,24,24},
	s_live_edit_dev_c_name_xywh= {50,90,200,40},
	s_live_edit_dev_t_name_xywh= {260,90,250,40},
	s_live_edit_dev_c_ip_xywh={50,150,200,40},
	s_live_edit_dev_t_ip_xywh= {260,150,250,40},
	s_live_edit_dev_c_prot_xywh= {50,210,200,40},
	s_live_edit_dev_t_prot_xywh= {260,210,250,40},
	s_live_edit_dev_c_port_xywh= {50,270,200,40},
	s_live_edit_dev_t_port_xywh= {260,270,250,40},
	s_live_edit_dev_c_user_xywh= {50,330,200,40},
	s_live_edit_dev_t_user_xywh= {260,330,250,40},
	s_live_edit_dev_c_pwd_xywh= {50,390,200,40},
	s_live_edit_dev_t_pwd_xywh= {260,390,250,40},
	s_live_edit_dev_c_remote_ch_xywh ={50,450,200,40}, 
	s_live_edit_dev_t_remote_ch_xywh ={260,450,250,40},
	s_live_edit_dev_tipinfo_xywh = {50,510,500,18},
	s_live_edit_dev_hline_xywh = {15,540,550,2},
	s_live_edit_dev_ok_xywh = {280,560,120,38},
	s_live_edit_dev_cancel_xywh = {420,560,120,38},
	s_live_edit_dev_draw_xywh= {0,60,0,1},
}

w1_live_edit_dev.s_2k = 
{
	s_live_edit_dev_xywh= {893,327,773,744},
	s_live_edit_dev_titleimg_xywh= {17,24,32,32},
	s_live_edit_dev_titlestr_xywh= {67,20,635,53},
	s_live_edit_dev_titleclose_xywh= {721,24,32,32},
	s_live_edit_dev_c_name_xywh= {67,120,270,53},
	s_live_edit_dev_t_name_xywh= {350,120,330,53},
	s_live_edit_dev_c_ip_xywh= {67,200,270,53},
	s_live_edit_dev_t_ip_xywh= {350,200,330,53},
	s_live_edit_dev_c_prot_xywh= {67,280,270,53},
	s_live_edit_dev_t_prot_xywh= {350,280,330,53},
	s_live_edit_dev_c_port_xywh= {67,360,270,53},
	s_live_edit_dev_t_port_xywh= {350,360,330,53},
	s_live_edit_dev_c_user_xywh= {67,440,270,53},
	s_live_edit_dev_t_user_xywh= {350,440,330,53},
	s_live_edit_dev_c_pwd_xywh= {67,520,270,53},
	s_live_edit_dev_t_pwd_xywh= {350,520,330,53},
	s_live_edit_dev_c_remote_ch_xywh ={67,600,270,53}, 
	s_live_edit_dev_t_remote_ch_xywh ={350,600,330,53},
	s_live_edit_dev_tipinfo_xywh = {67,680,667,24},
	s_live_edit_dev_hline_xywh = {20,720,733,3},
	s_live_edit_dev_ok_xywh = {373,746,160,51},
	s_live_edit_dev_cancel_xywh = {560,746,160,51},
	s_live_edit_dev_draw_xywh= {0,80,0,1},
};
w1_live_edit_dev.s_4k = 
{
	s_live_edit_dev_xywh= {1340,490,1160,1116},
	s_live_edit_dev_titleimg_xywh= {26,36,48,48},
	s_live_edit_dev_titlestr_xywh= {100,30,952,80},
	s_live_edit_dev_titleclose_xywh= {1082,36,48,48},
	s_live_edit_dev_c_name_xywh= {100,180,400,80},
	s_live_edit_dev_t_name_xywh= {520,180,500,80},
	s_live_edit_dev_c_ip_xywh= {100,300,400,80},
	s_live_edit_dev_t_ip_xywh= {520,300,500,80},
	s_live_edit_dev_c_prot_xywh= {100,420,400,80},
	s_live_edit_dev_t_prot_xywh= {520,420,500,80},
	s_live_edit_dev_c_port_xywh= {100,540,400,80},
	s_live_edit_dev_t_port_xywh= {520,540,500,80},
	s_live_edit_dev_c_user_xywh= {100,660,400,80},
	s_live_edit_dev_t_user_xywh= {520,660,500,80},
	s_live_edit_dev_c_pwd_xywh= {100,780,400,80},
	s_live_edit_dev_t_pwd_xywh= {520,780,500,80},
	s_live_edit_dev_c_remote_ch_xywh ={100,900,400,80}, 
	s_live_edit_dev_t_remote_ch_xywh ={520,900,500,80},
	s_live_edit_dev_tipinfo_xywh = {100,1020,1000,36},
	s_live_edit_dev_hline_xywh = {30,1080,1100,4},
	s_live_edit_dev_ok_xywh = {560,1120,240,76},
	s_live_edit_dev_cancel_xywh = {840,1120,240,76},
	s_live_edit_dev_draw_xywh= {0,120,0,2},
};
w1_live_edit_dev.modlist = {}
local rtsp_protocol

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_live_edit_dev.dlg;
		w1_msgbox.set_func(nil, nil, nil, nil);
		
		if(w1_legal.is_empty(top, cwnd.t_name.id)) then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_DEVICE_NAME_EMPTY'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
		
		local legal, num = w1_legal.check_ip(top, cwnd.t_ip.id)
		if(legal == false) then
			if(num == w1_legal.ip.EMPTY or num == w1_legal.ip.PRARMERR or num == w1_legal.ip.LENERR) then
				b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_NETIP_ERR'), false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
		end
		
		local dev_name = b_wnd_ex.get_text(top, cwnd.t_name.id);
		local ch = string.gsub(dev_name, "^%s*(.-)%s*$", "%1")
		if ch == nil or ch == ''then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_USERNAME_EMPTY'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
		
		local cur_ip = w1_live_edit_dev.curdata.addr;
		local modlist = {idx1 = {}};
		modlist.camera_num = 1;
		if(modlist.idx1 == nil) then
			modlist.idx1 =  util.copy_tab(w1_live_edit_dev.curdata);
		else
			util.copy_tab_b(modlist.idx1, w1_live_edit_dev.curdata);
		end		

		modlist.idx1.name = dev_name;
			
		local ip_addr = b_wnd_ex.get_text(top, cwnd.t_ip.id);
		local ip1, ip2, ip3, ip4 = string.match(ip_addr, "(%d+)%.(%d+)%.(%d+)%.(%d+)");	
		local ipstr = tonumber(ip1)..'.'..tonumber(ip2)..'.'..tonumber(ip3)..'.'..tonumber(ip4);
		modlist.idx1.addr = ipstr;
		
		local protocol = b_wnd_ex.get_sel(top, cwnd.t_prot.id) + 1;
		modlist.idx1.protocol = protocol;
		--ssl
		if (protocol == 3 and w1_live_edit_dev.support_ssl == true) then
			modlist['idx1'].protocol = 4;
		elseif(protocol >= 3)then
			if w1_live_edit_dev.support_ssl == true then
				modlist['idx1'].protocol = protocol + 97;
			else
				modlist['idx1'].protocol = protocol + 98;
			end
		end	
		
		local port = b_wnd_ex.get_text(top, cwnd.t_port.id);
		modlist.idx1.port = tonumber(port);
		
		local user = b_wnd_ex.get_text(top, cwnd.t_user.id);
		modlist.idx1.account = user;
		
		local pwd = b_wnd_ex.get_password(top, cwnd.t_pwd.id);
		modlist.idx1.password = pwd;
		
		local remote_channel = b_wnd_ex.get_sel(top,  cwnd.t_remote_ch.id);
		modlist.idx1.remote_cam = remote_channel+1;
		
		modlist.idx1.binded = true;
			
		local ret = b_app_api.onekeyadd_camera(modlist);
		if ret.ret== -2 or ret.ret==-4 then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_CAMERA_MANAGED'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		elseif ret ~= nil and ret.ret < 0 then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_MOD_CHN_FAIL'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		elseif ret.ret == 3105 then
			b_wnd_ex.set_text(top, cwnd.tipinfo.id, STR('LA_IP_CONFLICT'), false);
			b_dlg.dlg_set_redraw(top);
			return 0;
		end		
		
		b_dlg.end_modal(top);
	end
	return 0
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local on_protocolchange = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd =w1_live_edit_dev.dlg;
		local prot = b_wnd_ex.get_sel(top, w1_live_edit_dev.dlg.t_prot.id) + 1;
		b_wnd_ex.set_disable(top, w1_live_edit_dev.dlg.t_port.id ,false,false);
		if(prot == oldprotport.prot) then
			b_wnd_ex.set_value(top, w1_live_edit_dev.dlg.t_port.id , oldprotport.port,false);
		elseif(prot == 1) then
			b_wnd_ex.set_value(top, w1_live_edit_dev.dlg.t_port.id , 80,false);
		elseif(prot == 2) then
			b_wnd_ex.set_value(top, w1_live_edit_dev.dlg.t_port.id , 30001,false);
		elseif(prot == 3) then
			if(w1_live_edit_dev.support_ssl == true) then
				if prot == 3 then --ssl  ˿ں20001	
					b_wnd_ex.set_value(top, w1_live_edit_dev.dlg.t_port.id , 20001,false);
				else
					b_wnd_ex.set_value(top, w1_live_edit_dev.dlg.t_port.id , rtsp_protocol['idx'..prot-3]['stream'..1].port,false);
					b_wnd_ex.set_disable(top, w1_live_edit_dev.dlg.t_port.id ,true,false);
				end
			else
				b_wnd_ex.set_value(top, w1_live_edit_dev.dlg.t_port.id , rtsp_protocol['idx'..prot-2]['stream'..1].port,false);
				b_wnd_ex.set_disable(top, w1_live_edit_dev.dlg.t_port.id ,true,false);
			end
		end
		local prot_id = b_wnd_ex.get_sel(top,  cwnd.t_prot.id);
		local flag = 0
		if w1_live_edit_dev.support_ssl == true then
			if (prot_id>2)then
				flag = 1;
			end
		else
			if (prot_id>1)then
				flag = 1;
			end
		end
		if (0 == prot_id or flag ==1)then
			b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, true, false);
		else
			b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, false, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local dlg = {
	attr 	= {xywh='s_modifycamera_xywh'},
	
	
	sub 	= {'titleimg', 'titlestr', 'titleclose', 
			'c_name', 't_name', 'c_ip', 't_ip', 'c_port', 't_port',
			'c_prot', 't_prot', 'c_user', 't_user', 'c_pwd', 't_pwd',
			'c_remote_ch','t_remote_ch','tipinfo','hline','ok','cancel'},
			
			
	titleimg 	= {t='tt_picture',	id=id+1,xywh='s_live_edit_dev_titleimg_xywh', 
						t_img ={b_ui.ALIGN.CENTER,'c_popdlg_text','f_editpic','it_editcameera'}},
	
	titlestr	= {t='static', 	id=id+2,xywh='s_live_edit_dev_titlestr_xywh', 
					text='LA_MODIFY_CAMERA',font = 'f_grade5',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
					
	titleclose 	= {t='tt_button',id=id+3,xywh = 's_live_edit_dev_titleclose_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn2','it_close','it_close', 'it_close'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_cfgclose_bk'},
					cmd=on_close,
					},
	c_name 		= {t='static', 	id=id+4,xywh='s_live_edit_dev_c_name_xywh', 
					text='LA_CHANNEL_NAME',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_name 		= {t='edit', 	id=id+5,xywh='s_live_edit_dev_t_name_xywh', 
					text='',	trans = false, 	font = 'f_grade6',guide_text='LA_CHANNEL_NAME',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
					
	c_ip 		= {t='static', 	id=id+6,xywh='s_live_edit_dev_c_ip_xywh', 
					text='LA_IP_ADDRESS',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_ip 		= {t='edit_ip', 	id=id+7,xywh='s_live_edit_dev_t_ip_xywh', 
					text='',	trans = false, 	font = 'f_grade6',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
					
	c_prot 		= {t='static', 	id=id+8,xywh='s_live_edit_dev_c_prot_xywh', 
					text='LA_PROTOCOL',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_prot 		= {t='combox', 	id=id+9,xywh='s_live_edit_dev_t_prot_xywh', 
					font = 'f_grade6',items={},trans = false,
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					cmd = on_protocolchange
					},	
			
	c_port 		= {t='static', 	id=id+10,xywh='s_live_edit_dev_c_port_xywh', 
					text='LA_PORT',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_port 		= {t='edit_num', 	id=id+11,xywh='s_live_edit_dev_t_port_xywh', 
					value = 80, trans = false, 	font = 'f_grade6',range={1,65535},
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},		
					
	c_user 		= {t='static', 	id=id+12,xywh='s_live_edit_dev_c_user_xywh', 
					text='LA_USER_NAME',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_user 		= {t='edit', 	id=id+13,xywh='s_live_edit_dev_t_user_xywh', 
					text='',	trans = false, 	font = 'f_grade6',guide_text='LA_USER_NAME',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},	
				
	c_pwd 		= {t='static', 	id=id+14,xywh='s_live_edit_dev_c_pwd_xywh', 
					text='LA_PASSWORD',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_pwd 		= {t='password', 	id=id+15,xywh='s_live_edit_dev_t_pwd_xywh', 
					password='',guide_text='LA_PASSWORD', font = 'f_grade6',
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},
					},					

	c_remote_ch = {t='static', 	id=id+16,xywh='s_live_edit_dev_c_remote_ch_xywh', 
					text='LA_REMOTE_CHANNEL',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
	t_remote_ch = {t='combox', 	id=id+17,xywh='s_live_edit_dev_t_remote_ch_xywh', font = 'f_grade6',
					items={'CH-1','CH-2','CH-3','CH-4','CH-5','CH-6','CH-7','CH-8','CH-9','CH-10','CH-11',
					'CH-12','CH-13','CH-14','CH-15','CH-16'},trans = false,
					},	
					
	tipinfo		= {t='static',id=id+18,	xywh='s_live_edit_dev_tipinfo_xywh',	text='', 
					font='f_grade7', trans = false,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
					},
	hline		= {t='hline',	id=id+19,	xywh='s_live_edit_dev_hline_xywh'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
	
	ok			= {t='tt_button',id=id+20,	xywh='s_live_edit_dev_ok_xywh',	text='LA_OK',font='f_grade6',cmd=on_ok,
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				},
	cancel		= {t='tt_button',id=id+21,	xywh='s_live_edit_dev_cancel_xywh',text='LA_CANCEL',font='f_grade6',cmd=on_cancel,
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
					},
}

w1_live_edit_dev.on_create = function(top)
	w1_live_edit_dev.top = top
	w1_live_edit_dev.dlg = dlg
	b_parser(top, w1_live_edit_dev.dlg)
	w1_live_edit_dev.support_ssl = global_val.get_support_ssl_attr();
	return 0
end

w1_live_edit_dev.on_destroy = function(top)
	w1_live_edit_dev.top = nil
	w1_live_edit_dev.dlg = nil
	w1_live_edit_dev.alldata = nil
	w1_live_edit_dev.curdata = nil
	rtsp_protocol = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0
end

w1_live_edit_dev.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top)	
	if(param ~= nil)then
		local paramdata = cjson.decode(param)
		assert(paramdata.channel ~= nil)
		local select_ch = paramdata.channel;
		w1_live_edit_dev.alldata = b_app_api.get_cfg({'camera_bind'}).camera_bind;
		local alldata = w1_live_edit_dev.alldata;
		local camera_num = alldata.camera_num;
		for i=1,camera_num do
			if(alldata['idx'..i].channel_id == select_ch) then

				w1_live_edit_dev.curdata = alldata['idx'..i];
				alldata['idx'..i].binded = false;
				w1_live_edit_dev.modlist.camera_num = 1;
				break;
			end
		end
		if rtsp_protocol == nil then
			rtsp_protocol = b_app_api.get_rtsp_pro();
		else
			rtsp_protocol = util.copy_tab(b_app_api.get_rtsp_pro());
		end
		local curdata = w1_live_edit_dev.curdata;
		local trade_name = b_app_api.get_trade_name().name;
		if(trade_name == nil or trade_name == '') then
			trade_name = 'Private'
		end
		--Э
		local cwnd = w1_live_edit_dev.dlg;
		if (w1_live_edit_dev.support_ssl == true) then
			local type_list ={'ONVIF',trade_name,trade_name..'_SSL'};
			local count = rtsp_protocol.protocol_num
			for i=1, count do
				table.insert(type_list,rtsp_protocol['idx'..i].name);
			end
			b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
			if(curdata.protocol == 4)then
				b_wnd_ex.set_sel(top,  cwnd.t_prot.id, curdata.protocol - 2, false);
			elseif(curdata.protocol > 100)then
				b_wnd_ex.set_sel(top,  cwnd.t_prot.id, curdata.protocol - 98, false);
				b_wnd_ex.set_disable(top, cwnd.t_port.id, true, false);
			else
				b_wnd_ex.set_sel(top,  cwnd.t_prot.id, curdata.protocol - 1, false);
			end
		else
			local type_list ={'ONVIF',trade_name};
			local count = rtsp_protocol.protocol_num
			for i=1, count do
				table.insert(type_list,rtsp_protocol['idx'..i].name);
			end
			b_wnd_ex.set_items(top,  cwnd.t_prot.id, type_list, false);
			if curdata.protocol > 100 then
				b_wnd_ex.set_sel(top,  cwnd.t_prot.id, curdata.protocol - 99, false);
				b_wnd_ex.set_disable(top, cwnd.t_port.id, true, false);
			else
				b_wnd_ex.set_sel(top,  cwnd.t_prot.id, curdata.protocol - 1, false);
			end
		end	
			
		b_wnd_ex.set_text(top, cwnd.t_name.id, curdata.name, false);
		b_wnd_ex.set_text(top, cwnd.t_ip.id, curdata.addr, false);
		oldprotport.prot = curdata.protocol;
		oldprotport.port = curdata.port;
		b_wnd_ex.set_value(top, cwnd.t_port.id, curdata.port, false);
		b_wnd_ex.set_text(top, cwnd.t_user.id, curdata.account, false);
		b_wnd_ex.set_password(top, cwnd.t_pwd.id, curdata.password, false);
		if(curdata.remote_cam <= 0)then
			b_wnd_ex.set_sel(top,  cwnd.t_remote_ch.id, 0, false);
		else	
			b_wnd_ex.set_sel(top,  cwnd.t_remote_ch.id, curdata.remote_cam - 1, false);
		end
		if curdata.state == 4 then	--豸״̬
			b_wnd_ex.set_color_d(top, cwnd.t_ip.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
			b_wnd_ex.set_disable(top,cwnd.t_ip.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.t_prot.id,true,false);
			b_wnd_ex.set_disable(top,cwnd.t_port.id,true,false);
		end
		
		local prot_id = b_wnd_ex.get_sel(top,  cwnd.t_prot.id);
		local flag = 0
		if w1_live_edit_dev.support_ssl == true then
			if (prot_id>2)then
				flag = 1;
			end
		else
			if (prot_id>1)then
				flag = 1;
			end
		end
		if (0 == prot_id or flag ==1)then
			b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, true, false);
		else
			b_wnd_ex.set_disable(top,  cwnd.t_remote_ch.id, false, false);
		end
	end
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	return 0
end

w1_live_edit_dev.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_live_edit_dev_draw_xywh');
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_live_edit_dev.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local size = SIZE(dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			b_dlg.dlg_set_redraw(top);
		else
			b_dlg.end_modal(top);
		end
	elseif  (b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	end

	return 0
end

return w1_live_edit_dev




