local global_val= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.login.forget_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_login	= require("wnd.w1_live.w1_login")
local w1_login_pattern	= require("wnd.w1_live.w1_login_pattern")
local w1_forget = {
	t = w1_key.DLG_FORGOT,
	send_time = 0;
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_forget.s_768 =
{
	s_forget_page_xywh = {309,152,448,462},
	s_forget_title_xywh = {2,3,442,32},
	s_forget_cap_ver_type_xywh = {5,71,149,32},
	s_forget_t_ver_type_xywh = {160,71,250,32},
	s_forget_cap_email_tip_xywh = {5,113,352,32},
	s_forget_send_xywh = {368,113,42,32},
	s_forget_cap_ver_xywh = {5,156,149,32},
	s_forget_t_ver_xywh = {160,156,250,32},
	s_forget_cap_cap_q1_xywh = {5,113,149,32},
	s_forget_cap_t_q1_xywh = {160,113,250,32},
	s_forget_cap_cap_a1_xywh = {5,156,149,32},
	s_forget_cap_t_a1_xywh = {160,156,250,32},
	s_forget_cap_cap_q2_xywh = {5,199,149,32},
	s_forget_cap_t_q2_xywh = {160,199,250,32},
	s_forget_cap_cap_a2_xywh = {5,241,149,32},
	s_forget_cap_t_a2_xywh = {160,241,250,32},
	s_forget_cap_cap_q3_xywh = {5,284,149,32},
	s_forget_cap_t_q3_xywh = {160,284,250,32},
	s_forget_cap_cap_a3_xywh = {5,327,149,32},
	s_forget_cap_t_a3_xywh = {160,327,250,32},
	s_forget_sn_xywh = {10,156,142,142},
	s_forget_uuid_xywh = {160,192,280,32},
	s_forget_info_xywh = {160,234,280,32},
	s_forget_tipinfo_xywh = {5,369,437,32},
	s_forget_ok_xywh = {112,412,106,32},
	s_forget_cancel_xywh = {229,412,106,32},
	s_forget_draw_xywh = {1,35,1,1},
};

w1_forget.s_1280 = 
{
	s_forget_page_xywh			= {260,215,840,650},
	s_forget_title_xywh			= {5,5,830,45},
	s_forget_cap_ver_type_xywh 	= {10,100,280,45},
	s_forget_t_ver_type_xywh	= {300,100,470,45},
	s_forget_cap_email_tip_xywh	= {10,160,660,45},
	s_forget_send_xywh			= {690,160,80,45},
	s_forget_cap_ver_xywh		= {10,220,280,45},
	s_forget_t_ver_xywh			= {300,220,470,45},
	s_forget_cap_cap_q1_xywh	= {10,160,280,45},
	s_forget_cap_t_q1_xywh		= {300,160,470,45},
	s_forget_cap_cap_a1_xywh	= {10,220,280,45},
	s_forget_cap_t_a1_xywh		= {300,220,470,45},
	s_forget_cap_cap_q2_xywh	= {10,280,280,45},
	s_forget_cap_t_q2_xywh		= {300,280,470,45},
	s_forget_cap_cap_a2_xywh	= {10,340,280,45},
	s_forget_cap_t_a2_xywh		= {300,340,470,45},
	s_forget_cap_cap_q3_xywh	= {10,400,280,45},
	s_forget_cap_t_q3_xywh		= {300,400,470,45},
	s_forget_cap_cap_a3_xywh	= {10,460,280,45},
	s_forget_cap_t_a3_xywh		= {300,460,470,45},
	s_forget_sn_xywh 			= {20,220,200,200},
	s_forget_uuid_xywh 			= {240,270,590,45},
	s_forget_info_xywh			= {240,330,590,45},
	s_forget_tipinfo_xywh		= {10,520,820,45},
	s_forget_ok_xywh			= {210,580,200,45},
	s_forget_cancel_xywh		= {430,580,200,45},
	s_forget_draw_xywh			= {1,50,2,1},
};

w1_forget.s_1440 = 
{
	s_forget_page_xywh			= {340,125,840,650},
	s_forget_title_xywh			= {5,5,830,45},
	s_forget_cap_ver_type_xywh 	= {10,100,280,45},
	s_forget_t_ver_type_xywh	= {300,100,470,45},
	s_forget_cap_email_tip_xywh	= {10,160,660,45},
	s_forget_send_xywh			= {690,160,80,45},
	s_forget_cap_ver_xywh		= {10,220,280,45},
	s_forget_t_ver_xywh			= {300,220,470,45},
	s_forget_cap_cap_q1_xywh	= {10,160,280,45},
	s_forget_cap_t_q1_xywh		= {300,160,470,45},
	s_forget_cap_cap_a1_xywh	= {10,220,280,45},
	s_forget_cap_t_a1_xywh		= {300,220,470,45},
	s_forget_cap_cap_q2_xywh	= {10,280,280,45},
	s_forget_cap_t_q2_xywh		= {300,280,470,45},
	s_forget_cap_cap_a2_xywh	= {10,340,280,45},
	s_forget_cap_t_a2_xywh		= {300,340,470,45},
	s_forget_cap_cap_q3_xywh	= {10,400,280,45},
	s_forget_cap_t_q3_xywh		= {300,400,470,45},
	s_forget_cap_cap_a3_xywh	= {10,460,280,45},
	s_forget_cap_t_a3_xywh		= {300,460,470,45},
	s_forget_sn_xywh 			= {20,220,200,200},
	s_forget_uuid_xywh 			= {240,270,590,45},
	s_forget_info_xywh			= {240,330,590,45},
	s_forget_tipinfo_xywh		= {10,520,820,45},
	s_forget_ok_xywh			= {210,580,200,45},
	s_forget_cancel_xywh		= {430,580,200,45},
	s_forget_draw_xywh			= {1,50,2,1},
};

w1_forget.s_1080p = 
{
	s_forget_page_xywh			= {580,215,840,650},
	s_forget_title_xywh			= {5,5,830,45},
	s_forget_cap_ver_type_xywh 	= {10,100,280,45},
	s_forget_t_ver_type_xywh	= {300,100,470,45},
	s_forget_cap_email_tip_xywh	= {10,160,660,45},
	s_forget_send_xywh			= {690,160,80,45},
	s_forget_cap_ver_xywh		= {10,220,280,45},
	s_forget_t_ver_xywh			= {300,220,470,45},
	s_forget_cap_cap_q1_xywh	= {10,160,280,45},
	s_forget_cap_t_q1_xywh		= {300,160,470,45},
	s_forget_cap_cap_a1_xywh	= {10,220,280,45},
	s_forget_cap_t_a1_xywh		= {300,220,470,45},
	s_forget_cap_cap_q2_xywh	= {10,280,280,45},
	s_forget_cap_t_q2_xywh		= {300,280,470,45},
	s_forget_cap_cap_a2_xywh	= {10,340,280,45},
	s_forget_cap_t_a2_xywh		= {300,340,470,45},
	s_forget_cap_cap_q3_xywh	= {10,400,280,45},
	s_forget_cap_t_q3_xywh		= {300,400,470,45},
	s_forget_cap_cap_a3_xywh	= {10,460,280,45},
	s_forget_cap_t_a3_xywh		= {300,460,470,45},
	s_forget_sn_xywh 			= {20,220,200,200},
	s_forget_uuid_xywh 			= {240,270,590,45},
	s_forget_info_xywh			= {240,330,590,45},
	s_forget_tipinfo_xywh		= {10,520,820,45},
	s_forget_ok_xywh			= {210,580,200,45},
	s_forget_cancel_xywh		= {430,580,200,45},
	s_forget_draw_xywh			= {1,50,2,1},
};
w1_forget.s_2k = 
{
	s_forget_page_xywh			= {773,287,1120,867},
	s_forget_title_xywh			= {7,7,1106,60},
	s_forget_cap_ver_type_xywh 	= {13,133,373,60},
	s_forget_t_ver_type_xywh	= {400,133,627,60},
	s_forget_cap_email_tip_xywh	= {13,213,880,60},
	s_forget_send_xywh			= {920,213,107,60},
	s_forget_cap_ver_xywh		= {13,293,373,60},
	s_forget_t_ver_xywh			= {400,293,627,60},
	s_forget_cap_cap_q1_xywh	= {13,213,373,60},
	s_forget_cap_t_q1_xywh		= {400,213,627,60},
	s_forget_cap_cap_a1_xywh	= {13,293,373,60},
	s_forget_cap_t_a1_xywh		= {400,293,627,60},
	s_forget_cap_cap_q2_xywh	= {13,373,373,60},
	s_forget_cap_t_q2_xywh		= {400,373,627,60},
	s_forget_cap_cap_a2_xywh	= {13,453,373,60},
	s_forget_cap_t_a2_xywh		= {400,453,627,60},
	s_forget_cap_cap_q3_xywh	= {13,533,373,60},
	s_forget_cap_t_q3_xywh		= {400,533,627,60},
	s_forget_cap_cap_a3_xywh	= {13,613,373,60},
	s_forget_cap_t_a3_xywh		= {400,613,627,60},
	s_forget_sn_xywh 			= {27,293,267,267},
	s_forget_uuid_xywh 			= {320,360,786,60},
	s_forget_info_xywh			= {320,440,786,60},	
	s_forget_tipinfo_xywh		= {13,693,1093,60},
	s_forget_ok_xywh			= {280,773,267,60},
	s_forget_cancel_xywh		= {573,773,267,60},
	s_forget_draw_xywh			= {1,67,3,1},
};
w1_forget.s_4k = 
{
	s_forget_page_xywh			= {1160,430,1680,1300},
	s_forget_title_xywh			= {10,10,1660,90},
	s_forget_cap_ver_type_xywh = {20,200,560,90},
	s_forget_t_ver_type_xywh	= {600,200,940,90},
	s_forget_cap_email_tip_xywh	= {20,320,1320,90},
	s_forget_send_xywh			= {1380,320,160,90},
	s_forget_cap_ver_xywh		= {20,440,560,90},
	s_forget_t_ver_xywh			= {600,440,940,90},
	s_forget_cap_cap_q1_xywh	= {20,320,560,90},
	s_forget_cap_t_q1_xywh		= {600,320,940,90},
	s_forget_cap_cap_a1_xywh	= {20,440,560,90},
	s_forget_cap_t_a1_xywh		= {600,440,940,90},
	s_forget_cap_cap_q2_xywh	= {20,560,560,90},
	s_forget_cap_t_q2_xywh		= {600,560,940,90},
	s_forget_cap_cap_a2_xywh	= {20,680,560,90},
	s_forget_cap_t_a2_xywh		= {600,680,940,90},
	s_forget_cap_cap_q3_xywh	= {20,800,560,90},
	s_forget_cap_t_q3_xywh		= {600,800,940,90},
	s_forget_cap_cap_a3_xywh	= {20,920,560,90},
	s_forget_cap_t_a3_xywh		= {600,920,940,90},
	s_forget_sn_xywh 			= {40,440,400,400},
	s_forget_uuid_xywh 			= {480,540,1180,90},
	s_forget_info_xywh			= {480,660,1180,90},
	s_forget_tipinfo_xywh		= {20,1040,1640,90},
	s_forget_ok_xywh			= {420,1160,400,90},
	s_forget_cancel_xywh		= {860,1160,400,90},
	s_forget_draw_xywh			= {2,100,4,2},
};
local err_count = 0;
local set_email_hide = function(top,hide)
	local cwnd = w1_forget.dlg;
	b_wnd_ex.set_hide(top,cwnd.cap_email_tip.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.send.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.cap_ver.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.t_ver.id,hide,false);
end

local set_question_hide = function(top,hide)
	local cwnd = w1_forget.dlg;
	b_wnd_ex.set_hide(top,cwnd.cap_question1.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.t_question1.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.cap_answer1.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.t_answer1.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.cap_question2.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.t_question2.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.cap_answer2.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.t_answer2.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.cap_question3.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.t_question3.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.cap_answer3.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.t_answer3.id,hide,false);

end

local set_qr_hide = function(top,hide)
	local cwnd = w1_forget.dlg;
	b_wnd_ex.set_hide(top,cwnd.sn.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.uuid.id,hide,false);
	b_wnd_ex.set_hide(top,cwnd.info.id,hide,false);
end	

local on_dlg = function(top, win_id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		if err_count > 0 then
			err_count = err_count - 1;
			if err_count == 0 then
				b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,'',false);
				b_dlg.dlg_set_redraw(top);
			end
		else
			err_count = 0;
		end
	end
	return 0;
end

local on_ver_type = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		local str = b_wnd_ex.get_text(top,w1_forget.dlg.t_ver_type.id);
		if str == STR('LA_EMAIL_VER') then
			set_email_hide(top,false)
			set_question_hide(top,true)
			set_qr_hide(top,true)
			b_wnd_ex.set_text(top,w1_forget.dlg.titlestr.id,STR('LA_RECV_PWD_EMAIL'),false);
			b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,'',false);
			b_wnd_ex.set_disable(top,w1_forget.dlg.ok.id,false,false);
		elseif str == STR('LA_QUESTION_VER') then
			set_email_hide(top,true)
			set_question_hide(top,false)
			set_qr_hide(top,true)
			b_wnd_ex.set_text(top,w1_forget.dlg.titlestr.id,STR('LA_RECV_QUESTION'),false);
			b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,'',false);
			b_wnd_ex.set_disable(top,w1_forget.dlg.ok.id,false,false);
		else
			set_email_hide(top,true)
			set_question_hide(top,true)
			set_qr_hide(top,false)
			b_wnd_ex.set_text(top,w1_forget.dlg.titlestr.id,STR('LA_QR_RECOVERY'),false);
			b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,'',false);
			b_wnd_ex.set_disable(top,w1_forget.dlg.ok.id,true,false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_send = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local time = os.time();
		if w1_forget.send_time ~= 0 then
			if time - w1_forget.send_time < 60 then
				local text = string.gsub(STR('LA_SEND_FREQ'),'*','60');
				b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,text,false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
		end

		local username = global_val.get_user_name();
		local email = b_app_api.get_security_mail(username);
		local ret = b_app_api.send_security_code(username,email.security_mail);
		if ret.send == 0 then
			b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,STR('LA_CODE_TIP'),false);
			w1_forget.send_time = time;
		else
			b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,STR('LA_ERR_SEND_FAIL'),false);
			err_count = 10;
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_ok = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local username = global_val.get_user_name();
		local str = b_wnd_ex.get_text(top,w1_forget.dlg.t_ver_type.id);
		if str == STR('LA_EMAIL_VER') then
			local code = b_wnd_ex.get_text(top,w1_forget.dlg.t_ver.id);
			if code == nil or code == '' then
				err_count = 10;
				b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,STR('LA_INPUT_CODE'),false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
			
			local ret = b_app_api.check_verification_code(username,code);
			if ret ~= nil and ret.ret == 0 then
				w1_login.set_check_verification(top,true)
				w1_login_pattern.set_check_verification(top,true)
				b_dlg.end_modal(top);				
			else
				err_count = 10;
				b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,STR('LA_VER_EMAIL_FAIL'),false);
				b_dlg.dlg_set_redraw(top);
			end
		elseif str == STR('LA_QUESTION_VER') then
			local question = b_app_api.get_security_question(username);
			local answer1 = b_wnd_ex.get_text(top,w1_forget.dlg.t_answer1.id);
			if answer1 == nil or answer1 == '' then
				err_count = 10;
				b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,STR('LA_ANS_ONE'),false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
			local answer2 = b_wnd_ex.get_text(top,w1_forget.dlg.t_answer2.id);
			if answer2 == nil or answer2 == '' then
				err_count = 10;
				b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,STR('LA_ANS_TWO'),false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
			local answer3 = b_wnd_ex.get_text(top,w1_forget.dlg.t_answer3.id);
			if answer3 == nil or answer3 == '' then
				err_count = 10;
				b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,STR('LA_ANS_THR'),false);
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
			question.answer1 = answer1
			question.answer2 = answer2
			question.answer3 = answer3
			local ret = b_app_api.check_question(username,question);
			if ret ~= nil and ret.ret == 0 then
				w1_login.set_check_verification(top,true)
				w1_login_pattern.set_check_verification(top,true)
				b_dlg.end_modal(top);
			else
				b_wnd_ex.set_text(top,w1_forget.dlg.tipinfo.id,STR('LA_VER_QUE_FAIL'),false);
				b_dlg.dlg_set_redraw(top);
			end
		end
	end

	return 0;
end
local on_cancel = function(top,win_id,vmsg,x,y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	end
	return 0;
end

local dlg = {
	attr 	= {xywh='s_forget_page_xywh',cmd=on_dlg,timer={-1, 500}},
	
	sub 	= {'titlestr','cap_ver_type','t_ver_type','cap_email_tip','send','cap_ver','t_ver','cap_question1','t_question1','cap_answer1','t_answer1','cap_question2','t_question2',
			'cap_answer2','t_answer2','cap_question3','t_question3','cap_answer3','t_answer3','sn','uuid','info','tipinfo','ok','cancel'},
			
	titlestr	= {t='static', 	id=id+1,xywh='s_forget_title_xywh', 
					text='LA_RECV_PWD_EMAIL',	font = 'f_grade3',align = b_ui.ALIGN.CENTER,},
	cap_ver_type= {t='static',id=id+2,xywh='s_forget_cap_ver_type_xywh',text='LA_VER_TYPE'},
	t_ver_type 	= {t='combox', id=id+3,xywh='s_forget_t_ver_type_xywh',items={},cmd = on_ver_type},
	cap_email_tip	= {t='static',id=id+4,xywh='s_forget_cap_email_tip_xywh',text=''},
	send		= {t='button',	id=id+5,	xywh='s_forget_send_xywh', 		text='LA_SEND',
					cmd=on_send,font='f_grade6',
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	cap_ver 	= {t='static',id=id+6,xywh='s_forget_cap_ver_xywh',text='LA_ENTER_CODE'},
	t_ver	 	= {t='edit',  id=id+7,xywh='s_forget_t_ver_xywh',guide_text='LA_INPUT_CODE'},
	cap_question1= {t='static',id=id+8,xywh='s_forget_cap_cap_q1_xywh',text='LA_FIRST_QUESTION'},
	t_question1	= {t='static',  id=id+9,xywh='s_forget_cap_t_q1_xywh',text='LA_SEC_QUE_1'},
	cap_answer1	= {t='static',id=id+10,xywh='s_forget_cap_cap_a1_xywh',text='LA_ANSWER_ONE'},
	t_answer1	= {t='edit',  id=id+11,xywh='s_forget_cap_t_a1_xywh'},
	cap_question2= {t='static',id=id+12,xywh='s_forget_cap_cap_q2_xywh',text='LA_SECOND_QUESTION'},
	t_question2 = {t='static', id=id+13,xywh='s_forget_cap_t_q2_xywh',text='LA_SEC_QUE_2'},
	cap_answer2	= {t='static',id=id+14,xywh='s_forget_cap_cap_a2_xywh',text='LA_ANSWER_TWO'},
	t_answer2 	= {t='edit',  id=id+15,xywh='s_forget_cap_t_a2_xywh'},
	cap_question3= {t='static',id=id+16,xywh='s_forget_cap_cap_q3_xywh',text='LA_THIRD_QUESTION'},
	t_question3	= {t='static',  id=id+17,xywh='s_forget_cap_t_q3_xywh',text='LA_SEC_QUE_3'},
	cap_answer3	= {t='static',id=id+18,xywh='s_forget_cap_cap_a3_xywh',text='LA_ANSWER_THREE'},
	t_answer3	= {t='edit',  id=id+19,xywh='s_forget_cap_t_a3_xywh'},
	sn			= {t='qr_code',id=id+20,	xywh='s_forget_sn_xywh',text='',trans = false,align = b_ui.ALIGN.CENTER},
	uuid 		={t='static',id=id+21,xywh='s_forget_uuid_xywh',text='',trans = false,align = b_ui.ALIGN.LEFT, font = 'f_grade5' },
	info		= {t='static', id=id+22, xywh='s_forget_info_xywh',text='LA_SCAN_CODE',align = b_ui.ALIGN.LEFT},
	tipinfo		= {t='static', id=id+23, xywh='s_forget_tipinfo_xywh',text='',trans = false,
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_hint_text'}},
	ok 			= {t='button',	id=id+24,	xywh='s_forget_ok_xywh', 		text='LA_OK',
					cmd=on_ok,font='f_grade6',
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	cancel  	= {t='button',	id=id+25,	xywh='s_forget_cancel_xywh',		text='LA_CANCEL',
					cmd=on_cancel,font='f_grade6',
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
					},	
}

w1_forget.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local size = SIZE(dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			
		else
			b_dlg.end_modal(top);
		end
	elseif  (b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	end
	
	return 0
end

w1_forget.on_create = function(top)
	w1_forget.top = top
	w1_forget.dlg = dlg
	b_parser(top, dlg)	
	return 0
end

w1_forget.on_pre_show = function(top)
	local items = {}
	local idx = 0;
	local cwnd = w1_forget.dlg
	local username = global_val.get_user_name();
	local uuid = b_app_api.get_qrc_info();
	assert(uuid ~= nil  and "table" == type(uuid));
	b_wnd_ex.set_text(top, cwnd.uuid.id,uuid.qrc_code,false);
	b_wnd_ex.set_text(top, cwnd.sn.id,uuid.qrc_code,false);
	local email = b_app_api.get_security_mail(username);
	if email ~= nil and email.security_mail ~= nil then
		local text = STR('LA_INFO_VER')..': '..email.security_mail;
		b_wnd_ex.set_text(top,w1_forget.dlg.cap_email_tip.id,text,false);
		items[1] = STR('LA_EMAIL_VER');
		idx = 1;
	end
	local question = b_app_api.get_security_question(username);
	if question ~= nil then
		b_wnd_ex.set_text(top,w1_forget.dlg.t_question1.id,STR('LA_SEC_QUE_'..question.question1),false);
		b_wnd_ex.set_text(top,w1_forget.dlg.t_question2.id,STR('LA_SEC_QUE_'..question.question2),false);
		b_wnd_ex.set_text(top,w1_forget.dlg.t_question3.id,STR('LA_SEC_QUE_'..question.question3),false);
		idx = idx + 1;
		items[idx] = STR('LA_QUESTION_VER');
	end
	idx = idx + 1;
	items[idx] = STR('LA_QR_VER')
	if idx == 3 then
		set_question_hide(top,true);
		set_qr_hide(top,true)
		b_wnd_ex.set_items(top,w1_forget.dlg.t_ver_type.id,items,false);
	elseif idx == 2 then
		b_wnd_ex.set_items(top,w1_forget.dlg.t_ver_type.id,items,false);		
		if email == nil then
			set_email_hide(top,true)
			b_wnd_ex.set_text(top,w1_forget.dlg.titlestr.id,STR('LA_RECV_QUESTION'),false);
		else
			set_question_hide(top,true)
		end
		set_qr_hide(top,true)
	else
		b_wnd_ex.set_items(top,w1_forget.dlg.t_ver_type.id,items,false);
		b_wnd_ex.set_text(top,w1_forget.dlg.titlestr.id,STR('LA_QR_RECOVERY'),false);
		set_email_hide(top,true)
		set_question_hide(top,true)
		set_qr_hide(top,false)
		b_wnd_ex.set_disable(top,w1_forget.dlg.ok.id,true,false);
	end
	b_wnd_ex.set_sel(top,w1_forget.dlg.t_ver_type.id,0,false);
	return 0
end

w1_forget.on_destroy = function(top)
	w1_forget.top = nil
	w1_forget.dlg = nil
	return 0
end

w1_forget.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_forget_draw_xywh');
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	b_wnd.draw_fill(top, x, y+wndsize[2], cx, wndsize[4], COLOR('c_hline_color'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

return w1_forget




