-- UIʹõȷȡԻ
local b_ui 		= require("wnd.core.b_ui")
local b_app_api = require("wnd.core.command.b_app_api")
local b_app_cfg	= require("wnd.core.b_app_cfg")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.msg_packet_id;
local util 		= require("wnd.core.util")


local CANCEL_TIME;
local data = {}
local w1_packet_tip = {
	t = w1_key.DLG_MSG_PACKET,
	top = nil,
	dlg = nil,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_packet_tip.s_1280 = 
{
	s_packettip_xywh={315,400,650,240},
	s_packettip_title_xywh={1,1,648,50},
	s_packettip_title_close_xywh = {598, 5, 40, 40},
	s_packettip_msg_xywh ={50,70,568,50},
	s_packettip_msg_tip_xywh ={50,100,568,50},
	s_packettip_tipinfo_xywh= {15,120,500,18},
	s_packettip_hline_xywh={15,150,620,2},
	s_packettip_ok_xywh={370,170,120,38},
	s_packettip_cancel_xywh={510,170,120,38},	
	s_packettip_okcancel_xywh={510,170,120,38},
};
w1_packet_tip.s_1440 = 
{
	s_packettip_xywh={395,310,650,240},
	s_packettip_title_xywh={1,1,648,50},
	s_packettip_title_close_xywh = {598, 5, 40, 40},
	s_packettip_msg_xywh ={50,70,568,50},
	s_packettip_msg_tip_xywh ={50,100,568,50},
	s_packettip_tipinfo_xywh= {15,120,500,18},
	s_packettip_hline_xywh={15,150,620,2},	
	s_packettip_ok_xywh={370,170,120,38},
	s_packettip_cancel_xywh={510,170,120,38},	
	s_packettip_okcancel_xywh={510,170,120,38},
};
w1_packet_tip.s_1080p = 
{
	s_packettip_xywh={635,400,650,240},
	s_packettip_title_xywh={1,1,648,50},
	s_packettip_title_close_xywh = {598, 5, 40, 40},
	s_packettip_msg_xywh ={50,70,568,50},
	s_packettip_msg_tip_xywh ={50,100,568,50},
	s_packettip_tipinfo_xywh= {15,120,500,18},
	s_packettip_hline_xywh={15,150,620,2},
	s_packettip_ok_xywh={370,170,120,38},
	s_packettip_cancel_xywh={510,170,120,38},	
	s_packettip_okcancel_xywh={510,170,120,38},
};
w1_packet_tip.s_2k = 
{
	s_packettip_xywh={846,533,866,320},
	s_packettip_title_xywh={1,1,864,67},
	s_packettip_title_close_xywh = {794, 7, 53, 53},
	s_packettip_msg_xywh ={67,91,753,67},
	s_packettip_msg_tip_xywh ={67,133,753,67},
	s_packettip_tipinfo_xywh= {20,160,667,24},
	s_packettip_hline_xywh={20,200,827,3},
	s_packettip_ok_xywh={492,227,160,51},
	s_packettip_cancel_xywh={680,227,160,51},
	s_packettip_okcancel_xywh = {680,227,160,51},

};
w1_packet_tip.s_4k = 
{
	s_packettip_xywh={1270,800,1300,480},
	s_packettip_title_xywh={2,2,1296,100},
	s_packettip_title_close_xywh = {1196, 10, 80, 80},
	s_packettip_msg_xywh ={100,140,1136,100},
	s_packettip_msg_tip_xywh ={100,200,1136,100},
	s_packettip_tipinfo_xywh= {30,240,1000,36},
	s_packettip_hline_xywh={30,300,1240,4},
	s_packettip_ok_xywh={740,340,240,76},
	s_packettip_cancel_xywh={1020,340,240,76},
	s_packettip_okcancel_xywh = {1020,340,240,76},
	
};

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0;
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_app_api.destroy_capture(data)
		b_dlg.end_modal(top);
	end
	return 0;
end

w1_packet_tip.set_data = function(param)
	data.path=param[2]
	data.task_id=param[1]
	return 0;
end

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		return 0;
	end
	if b_ui.TIMER == vmsg then
		local status = b_app_api.get_packet_status()
		if status==1 then
			b_app_api.destroy_capture(data)
			b_wnd_ex.set_text(top,w1_packet_tip.dlg.msg.id,STR('LA_NET_PACKET_OVER'),true)
			b_wnd_ex.set_hide(top,w1_packet_tip.dlg.ok.id,false,true)
			b_wnd_ex.set_hide(top,w1_packet_tip.dlg.cancel.id,true,true)
			local pos = SIZE('s_packettip_cancel_xywh')
			b_wnd_ex.move_ex(top,w1_packet_tip.dlg.ok.id,pos,true)
		end
	end
	
	return 0;
end

local dlg = {
	attr 	= {xywh='s_packettip_xywh',cmd=on_dlg,timer={-1, 1000}},
	sub 	= {--[['title',--]] 'msg', --[['hline',--]]'ok', 'cancel'},
	
--[[	title 	= {t='static',	id=id+1,	xywh='s_packettip_title_xywh',	
			text='LA_TIP',align = b_ui.ALIGN.CENTER, font = 'f_grade5',
			color = {'c_popdlg_title_bk', 'c_popdlg_title_bk', 'c_popdlg_text'}},--]]
	
	msg	 	= {t='static',	id=id+2,	xywh='s_packettip_msg_xywh',	
			text='LA_NET_PACKET_EXPORT',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
			
	hline	= {t='hline',	id=id+3,	xywh='s_packettip_hline_xywh'},
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
	
	ok		= {t='button',	id=id+4,	xywh='s_packettip_ok_xywh',	text='LA_OK',font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok},
	cancel	= {t='button',	id=id+5,	xywh='s_packettip_cancel_xywh',text='LA_STOP',font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
				cmd=on_cancel},		
}

w1_packet_tip.on_create = function(top)
	CANCEL_TIME = 30;
		--رhomeڶʱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_pause);
	
	w1_packet_tip.top = top;
	w1_packet_tip.dlg = dlg;
	b_parser(top, w1_packet_tip.dlg);
	b_wnd_ex.set_text(top, w1_packet_tip.dlg.cancel.id, STR('LA_STOP'), false);
	b_wnd_ex.set_hide(top,w1_packet_tip.dlg.ok.id,true,false)

	return 0;
end

w1_packet_tip.on_destroy = function(top)
	w1_packet_tip.top = nil;
	w1_packet_tip.dlg = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk);
	return 0;
end

w1_packet_tip.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top);	
	
	return 0;
end

w1_packet_tip.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'));
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border_h'),1);
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])

	b_wnd.end_job(top);
	return 0;
end

w1_packet_tip.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_CHANGE_RESOLUTION == vmsg ) then
		return vmsg;
	end
	return 0;
end

return w1_packet_tip;

