local global_val= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.ptz_control_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local baud_txt = {"2400", "4800", "9600", "38400", "57600", "115200", "230400", "380400"};
local control_txt = {"RS485", "Coaxial","All"}
local protocol_list = {"PelcoD","PelcoP","Hikvision"};
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local util 		= require("wnd.core.util")
local ptz_toctrl_flag = 0;--սҳ־
local max_num = 0;
local rs485_num = 0;
local cur_chn =1;
local channel_num 	= G.channel_num	--豸ͨĿ
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_ptz_control = {
	t = w1_key.DLG_PTZ_CONTROL,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_ptz_control.s_768 =
{
	s_ptz_control_page_xywh = {325,220,373,327},
	s_ptz_control_title_xywh = {48,3,266,32},
	s_ptz_control_close_xywh = {341,3,26,28},
	s_ptz_control_cap_channel_xywh = {26,49,106,32},
	s_ptz_control_t_channel_xywh = {213,49,106,32},
	s_ptz_control_cap_controltype_xywh = {26,92,106,32},
	s_ptz_control_t_control_type_xywh = {213,92,106,32},
	s_ptz_control_cap_protocol_xywh = {26,135,106,32},
	s_ptz_control_t_protocol_xywh = {213,135,106,32},
	s_ptz_control_cap_address_xywh = {26,177,106,32},
	s_ptz_control_t_address_xywh = {213,177,106,32},
	s_ptz_control_cap_baud_rate_xywh = {26,220,106,32},
	s_ptz_control_t_baud_rate_xywh = {213,220,106,32},
	s_ptz_control_tipinfo_xywh = {26,256,149,32},
	s_ptz_control_default_xywh = {96,284,53,32},
	s_ptz_control_save_xywh = {202,284,53,32},
	s_ptz_control_cancel_xywh = {266,284,53,32},
	s_ptz_control_draw_xywh = {0,36,0,1},
};

w1_ptz_control.s_1280 = 
{
	s_ptz_control_page_xywh= {290,310,700,460},
	s_ptz_control_title_xywh= {90,5,500,45},
	s_ptz_control_close_xywh= {640,5,50,40},
	s_ptz_control_cap_channel_xywh= {50,70,200,45},
	s_ptz_control_t_channel_xywh= {400,70,200,45},
	s_ptz_control_cap_controltype_xywh= {50,130,200,45},
	s_ptz_control_t_control_type_xywh= {400,130,200,45},
	s_ptz_control_cap_protocol_xywh= {50,190,200,45},
	s_ptz_control_t_protocol_xywh= {400,190,200,45},
	s_ptz_control_cap_address_xywh= {50,250,200,45},
	s_ptz_control_t_address_xywh= {400,250,200,45},
	s_ptz_control_cap_baud_rate_xywh= {50,310,200,45},
	s_ptz_control_t_baud_rate_xywh= {400,310,200,45},
	s_ptz_control_tipinfo_xywh = {50,360,280,45},
	s_ptz_control_default_xywh= {180,400,100,45},
	s_ptz_control_save_xywh= {380,400,100,45},
	s_ptz_control_cancel_xywh= {500,400,100,45},
	s_ptz_control_draw_xywh= {0,51,0,1},
}
w1_ptz_control.s_1440 = 
{
	s_ptz_control_page_xywh= {370,220,700,460},
	s_ptz_control_title_xywh= {90,5,500,45},
	s_ptz_control_close_xywh= {640,5,50,40},
	s_ptz_control_cap_channel_xywh= {50,70,200,45},
	s_ptz_control_t_channel_xywh= {400,70,200,45},
	s_ptz_control_cap_controltype_xywh= {50,130,200,45},
	s_ptz_control_t_control_type_xywh= {400,130,200,45},
	s_ptz_control_cap_protocol_xywh= {50,190,200,45},
	s_ptz_control_t_protocol_xywh= {400,190,200,45},
	s_ptz_control_cap_address_xywh= {50,250,200,45},
	s_ptz_control_t_address_xywh= {400,250,200,45},
	s_ptz_control_cap_baud_rate_xywh= {50,310,200,45},
	s_ptz_control_t_baud_rate_xywh= {400,310,200,45},
	s_ptz_control_tipinfo_xywh = {50,360,280,45},
	s_ptz_control_default_xywh= {180,400,100,45},
	s_ptz_control_save_xywh= {380,400,100,45},
	s_ptz_control_cancel_xywh= {500,400,100,45},
	s_ptz_control_draw_xywh= {0,51,0,1},
}

w1_ptz_control.s_1080p = 
{
	s_ptz_control_page_xywh= {610,310,700,460},
	s_ptz_control_title_xywh= {90,5,500,45},
	s_ptz_control_close_xywh= {640,5,50,40},
	s_ptz_control_cap_channel_xywh= {50,70,200,45},
	s_ptz_control_t_channel_xywh= {400,70,200,45},
	s_ptz_control_cap_controltype_xywh= {50,130,200,45},
	s_ptz_control_t_control_type_xywh= {400,130,200,45},
	s_ptz_control_cap_protocol_xywh= {50,190,200,45},
	s_ptz_control_t_protocol_xywh= {400,190,200,45},
	s_ptz_control_cap_address_xywh= {50,250,200,45},
	s_ptz_control_t_address_xywh= {400,250,200,45},
	s_ptz_control_cap_baud_rate_xywh= {50,310,200,45},
	s_ptz_control_t_baud_rate_xywh= {400,310,200,45},
	s_ptz_control_tipinfo_xywh = {50,360,280,45},
	s_ptz_control_default_xywh= {180,400,100,45},
	s_ptz_control_save_xywh= {380,400,100,45},
	s_ptz_control_cancel_xywh= {500,400,100,45},
	s_ptz_control_draw_xywh= {0,51,0,1},
}

w1_ptz_control.s_2k = 
{
	s_ptz_control_page_xywh= {813,413,933,613},
	s_ptz_control_title_xywh= {120,7,667,60},
	s_ptz_control_close_xywh= {853,7,67,53},
	s_ptz_control_cap_channel_xywh= {67,93,267,60},
	s_ptz_control_t_channel_xywh= {533,93,267,60},
	s_ptz_control_cap_controltype_xywh= {67,173,267,60},
	s_ptz_control_t_control_type_xywh= {533,173,267,60},
	s_ptz_control_cap_protocol_xywh= {67,253,267,60},
	s_ptz_control_t_protocol_xywh= {533,253,267,60},
	s_ptz_control_cap_address_xywh= {67,333,267,60},
	s_ptz_control_t_address_xywh= {533,333,267,60},
	s_ptz_control_cap_baud_rate_xywh= {67,413,267,60},
	s_ptz_control_t_baud_rate_xywh= {533,413,267,60},
	s_ptz_control_tipinfo_xywh = {67,480,373,60},
	s_ptz_control_default_xywh= {240,533,133,60},
	s_ptz_control_save_xywh= {506,533,133,60},
	s_ptz_control_cancel_xywh= {666,533,133,60},
	s_ptz_control_draw_xywh= {0,68,0,1},
}

w1_ptz_control.s_4k = 
{
	s_ptz_control_page_xywh= {1220,620,1400,920},
	s_ptz_control_title_xywh= {180,10,1000,90},
	s_ptz_control_close_xywh= {1280,10,100,80},
	s_ptz_control_cap_channel_xywh= {100,140,400,90},
	s_ptz_control_t_channel_xywh= {800,140,400,90},
	s_ptz_control_cap_controltype_xywh= {100,260,400,90},
	s_ptz_control_t_control_type_xywh= {800,260,400,90},
	s_ptz_control_cap_protocol_xywh= {100,380,400,90},
	s_ptz_control_t_protocol_xywh= {800,380,400,90},
	s_ptz_control_cap_address_xywh= {100,500,400,90},
	s_ptz_control_t_address_xywh= {800,500,400,90},
	s_ptz_control_cap_baud_rate_xywh= {100,620,400,90},
	s_ptz_control_t_baud_rate_xywh= {800,620,400,90},
	s_ptz_control_tipinfo_xywh = {100,720,560,90},
	s_ptz_control_default_xywh= {360,800,200,90},
	s_ptz_control_save_xywh= {760,800,200,90},
	s_ptz_control_cancel_xywh= {1000,800,200,90},
	s_ptz_control_draw_xywh= {0,102,0,2},
}
--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w1_ptz_control.dlg
	
	local channel = b_wnd_ex.get_sel(top, w1_ptz_control.dlg.t_channel.id)+1;
	local chn = "channel"..channel
	local flag = cfgdata['ptz'][chn];
	local idx=tonumber(channel);
	if(flag == nil)then
		for i= 1,channel_num do 
			if(flag == nil)then
				 chn = "channel"..tostring(i);
				 flag = cfgdata['ptz'][chn];
				 idx =i
			else
				break;
			end
		end
	end
		
	max_num = cfgdata['ptz']['max_num']
	rs485_num = cfgdata['ptz']['rs485_num']
	if rs485_num == 0 then
		b_wnd_ex.set_items(top, w1_ptz_control.dlg.t_control_type.id, {'Coaxial'}, false)
	else
		b_wnd_ex.set_items(top, w1_ptz_control.dlg.t_control_type.id, {'RS485', 'Coaxial','All'}, false)
	end	
	if((0 ~= max_num)and (flag ~= nil))then
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id,idx-1,false)
		local channel = cfgdata['ptz'][chn]['channel']
		local ctrl = 	cfgdata['ptz'][chn]['ctrl']
		local baud = 	cfgdata['ptz'][chn]['baud']
		local stop =	cfgdata['ptz'][chn]['stop']
		local data = 	cfgdata['ptz'][chn]['data']
		local parity = 	cfgdata['ptz'][chn]['parity']
		local addr = 	tostring(cfgdata['ptz'][chn]['addr'])
		local protocol = cfgdata['ptz'][chn]['protocol']
		local resv = 	cfgdata['ptz'][chn]['resv']
		
		if rs485_num == 0 then
			b_wnd_ex.set_sel(top,c_wnd.t_control_type.id,0,false);
		else
			b_wnd_ex.set_sel(top,c_wnd.t_control_type.id,ctrl-1,false);
		end
		
		b_wnd_ex.set_items(top,c_wnd.t_protocol.id,protocol_list,false)
		if(4 == protocol)then
			b_wnd_ex.set_sel(top,c_wnd.t_protocol.id,0,false)
		elseif(5 == protocol)then
			b_wnd_ex.set_sel(top,c_wnd.t_protocol.id,1,false)
		elseif(8 == protocol)then
			b_wnd_ex.set_sel(top,c_wnd.t_protocol.id,2,false)	
		end
		
		b_wnd_ex.set_items(top,c_wnd.t_baud_rate.id,baud_txt,false)
		local flag = false;
		for i =1,#baud_txt do
			local baud_rate =tonumber(baud_txt[i]);
			if(baud_rate == baud)then
				flag =true;
				local idx =i-1;
				b_wnd_ex.set_sel(top,c_wnd.t_baud_rate.id,idx,false);
			end
		end
		if(flag ~= true)then
			b_wnd_ex.set_sel(top,c_wnd.t_baud_rate.id,1,false);
		end 
		b_wnd_ex.set_text(top, w1_ptz_control.dlg.t_address.id,addr,false);
	else
		print("------ptz_max_num = 0------");
	end
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_ptz_control.dlg;
	local addr = b_wnd_ex.get_text(top, cwnd.t_address.id);
	if(addr ~= "." and "" ~= addr and nil ~= addr)then	
		if(tonumber(addr) > 32767) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_address.id)
		end
	else
		legalflag =false
		table.insert(nlegalid, cwnd.t_address.id)
	end
	if(legalflag) then
		return legalflag, nil
	else
		w1_wnd_util.setparamerr_str("[0 ~ 32767]");
		return legalflag, nlegalid
	end
--	return true, nil
end


--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local channel = b_wnd_ex.get_text(top, w1_ptz_control.dlg.t_channel.id);
	local chn = "channel"..channel
	local control_type =b_wnd_ex.get_sel(top, w1_ptz_control.dlg.t_control_type.id);
	local protocol =b_wnd_ex.get_sel(top, w1_ptz_control.dlg.t_protocol.id);
	local baud =b_wnd_ex.get_text(top, w1_ptz_control.dlg.t_baud_rate.id);
	local addr =b_wnd_ex.get_text(top, w1_ptz_control.dlg.t_address.id);
	if(0 ~= max_num) then
		cfgdata['ptz'][chn]['channel'] = tonumber(channel);
		if rs485_num == 0 then
			cfgdata['ptz'][chn]['ctrl']    = 2;
		else
			cfgdata['ptz'][chn]['ctrl']    = tonumber(control_type)+1;
		end		
		if(0 == protocol)then
			cfgdata['ptz'][chn]['protocol'] = 4;
		elseif(1 ==protocol)then
			cfgdata['ptz'][chn]['protocol'] = 5;
		elseif(2 ==protocol)then
			cfgdata['ptz'][chn]['protocol'] = 8;
		end
		
		cfgdata['ptz'][chn]['baud']    = tonumber(baud);
		cfgdata['ptz'][chn]['addr']  = tonumber(addr);
--		cfgdata['ptz'][chn]['change_flag']  = 1;
		cfgdata['ptz']['max_num'] = max_num;
	end
    --[[cfgdata['ptz'][chn]['stop']
    cfgdata['ptz'][chn]['data']
    cfgdata['ptz'][chn]['parity']--]]
	
	return 0
end

local on_address = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		return 0
	end
	return 0
end
local on_control_type =function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then	
	end
	return 0;
end

local on_channel =function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		w1_wnd_util.cfgtab = {'ptz'}
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_init(top)
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_dlg = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		return 0;
	end
	if b_ui.TIMER == vmsg then
		w1_wnd_util.timerenevt(top, w1_ptz_control.dlg.tipinfo.id);
	end
	return 0;
end

local on_default = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then	
	end
	return 0;
end

local on_save= function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		uitousercfg(top,b_app_cfg.user_cfg);
	
		local ret = w1_wnd_util.page_onapply(top)
		if(ret == 1)then
			b_dlg.end_modal(top)
		else
			w1_wnd_util.tipdispon()		--ʾ
		end
	end
	return 0;
end

local on_cancel =function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_app_cfg.origintousercfg()
		b_dlg.end_modal(top)
	end
	return 0;
end

local on_close=function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_app_cfg.origintousercfg()
		b_dlg.end_modal(top)
	end
	return 0;
end

local dlg = {
	attr={xywh = 's_ptz_control_page_xywh',cmd=on_dlg,timer={-1, 500}},
	sub = {"title","close","cap_channel","t_channel","cap_controltype","t_control_type","cap_protocol","t_protocol","cap_address",
			"tipinfo","t_address","cap_baud_rate","t_baud_rate","default","save","cancel"};
	title ={t='static',id=id+1,xywh='s_ptz_control_title_xywh',text='LA_PTZ',align = b_ui.ALIGN.CENTER},
	
	close = {t='tt_button',id=id+2,xywh='s_ptz_control_close_xywh',t_imgs = {b_ui.ALIGN.LEFT,'f_closebtn2','it_close','it_close', 'it_close'}, cmd=on_close,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_f'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfgclose_bk'}},
	
	
	cap_channel	= {t='static',id=id+3,xywh='s_ptz_control_cap_channel_xywh',text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+4,xywh='s_ptz_control_t_channel_xywh',items={'1','2','3','4'},trans = false,channel_cbox = true,cmd = on_channel},	
	
	cap_controltype		= {t='static',id=id+5,xywh='s_ptz_control_cap_controltype_xywh',text='LA_PTZ_TYPE'},
	t_control_type 		= {t='combox',id=id+6,xywh='s_ptz_control_t_control_type_xywh',--[[items={'RS485', 'Coaxial','All'},--]]trans = false,cmd = on_control_type},	
	
	cap_protocol		= {t='static',id=id+7,xywh='s_ptz_control_cap_protocol_xywh',text='LA_PROTOCOL'},
	t_protocol 		= {t='combox',id=id+8,xywh='s_ptz_control_t_protocol_xywh',items={'PelcoD','PelcoP'},trans = false},	
	
	cap_address	= {t='static',id=id+9,xywh='s_ptz_control_cap_address_xywh',text='LA_ADDRESS'},
	t_address 	= {t='edit',id=id+10,xywh='s_ptz_control_t_address_xywh',edit_num_str =1,text='1',trans = false,cmd = on_address},	--range ={0,2147483646},
		
	cap_baud_rate	= {t='static',id=id+11,xywh='s_ptz_control_cap_baud_rate_xywh',text='LA_BAUD_RATE'},
	t_baud_rate 	= {t='combox',id=id+12,xywh='s_ptz_control_t_baud_rate_xywh',items={'2400','4800','9600','38400','57600','115200','230400','380400'},item_dispnum =5,trans = false},	

	tipinfo		= {t='static', 	id=id+13,	xywh='s_ptz_control_tipinfo_xywh',			text='',trans = false},
	--[[default 	= {t='button',id=id+13,	xywh ='s_ptz_control_default_xywh' ,text='LA_DEFAULT',cmd=on_default},--]]
	save = {t='button',id=id+14,	xywh = 's_ptz_control_save_xywh',text='LA_SAVE',cmd=on_save},
	cancel 	= {t='button',id=id+15,	xywh ='s_ptz_control_cancel_xywh', text='LA_CANCEL',cmd=on_cancel},
}

w1_ptz_control.update_channel = function (top,chn)
	 cur_chn = chn;
end

local get_valid_cam_num = function(channel_num)
	local chn_num = channel_num;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (0 < dec_num and 0 < vi_num) then 
		chn_num = vi_num;
	end
	
	return chn_num;
end


w1_ptz_control.init = function (top)
	channel_num = global_val.get_channelnum();
	channel_num = get_valid_cam_num(channel_num);
	local privilege = G.get_allprivilege()
	local cam_list= {};
	for i= 1,channel_num do
		if(1 == privilege.ptz_control_list[i])then
			table.insert(cam_list,tostring(i))
		end
	end
	b_wnd_ex.set_items(top,w1_ptz_control.dlg.t_channel.id,cam_list,false)	
	local sel = 0;
	for k, v in ipairs(cam_list) do
		if (tonumber(v) == (cur_chn)) then
			sel = k - 1;
		end
	end	
	b_wnd_ex.set_sel(top, w1_ptz_control.dlg.t_channel.id,sel,false)
	
	local cfg_tab = {'ptz'}
	if(w1_wnd_util.cfgtab == nil) then
		w1_wnd_util.cfgtab = cfg_tab
	else
		util.copy_tab_b(w1_wnd_util.cfgtab, cfg_tab)
	end
	
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_ptz_control.on_create = function(top)
	w1_ptz_control.top = top
	w1_ptz_control.dlg = dlg
	b_parser(top, dlg)	
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)
	return 0
end

w1_ptz_control.on_destroy = function(top)
	w1_ptz_control.top = nil
	w1_ptz_control.dlg = nil
	ptz_toctrl_flag =0;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0
end

w1_ptz_control.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_ptz_control_draw_xywh');
	b_wnd.begin_job(top)
	
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	b_wnd.draw_fill(top, x, y+wndsize[2], cx, wndsize[4], COLOR('c_hline_color'))
--	b_wnd.draw_fill(top, x, y+52, cx, cy-52, COLOR('c_cfg_row_bk'))

--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_modch_border'), 1)
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	if(0 == ptz_toctrl_flag)then
		ptz_toctrl_flag = 1;
		w1_ptz_control.init(top)
	end
	return 0
end

w1_ptz_control.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
--	if (b_ui.LBUTTONCLK == vmsg or b_ui.RBUTTONCLK == vmsg) then
	if (b_ui.RBUTTONCLK == vmsg) then
		b_app_cfg.origintousercfg()
		b_dlg.end_modal(top);
	end
	return 0
end

return w1_ptz_control




