local global_val	= require("wnd.global_val")
local channel_count = G.channel_num--豸ͨĿ,ʱȹ̶
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.toolbar.videosignal_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local COLOR 	= r_color.get_color
local b_app_api = require("wnd.core.command.b_app_api");
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local util 		= require("wnd.core.util")

local ex_height = nil;
ex_height =channel_count
local list_num =channel_count+1;
local SIGNAL = {"AHD","TVI","AUTO","CVI"}
local display_off = 0;		--ǰƫ
local dis_col;		--ǰʾͨ
local w1_videosignal = {
	t = w1_key.DLG_VIDEO_SIGNAL,
	top = nil,
	dlg = nil,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}	
	
w1_videosignal.s_1280 = 
{
	s_videosignal_page_xywh1= {240,1024,0,0},
	s_videosignal_page_xywh2= {0,0,800,190},
	s_videosignal_border_xywh= {0,0,6,0},
	s_videosignal_title_xywh= {5,5,750,56},
	s_videosignal_close_xywh= {753,15,24,24},
	s_videosignal_channel_xywh= {13,80,156,41},
	s_videosignal_ahd_xywh= {169,80,155,41},
	s_videosignal_tvi_xywh= {324,80,155,41},
	s_videosignal_auto_xywh= {479,80,155,41},
	s_videosignal_cvi_xywh= {634,80,158,41},
	s_videosignal_line1_xywh= {168,80,2,41};
	s_videosignal_line2_xywh= {323,80,2,41};
	s_videosignal_line3_xywh= {478,80,2,41};
	s_videosignal_line4_xywh= {633,80,2,41};
	s_videosignal_line5_xywh= {11,80,784,1};
	s_videosignal_vdrop_xywh= {773,121,20,695};	
	s_videosignal_inteval_xywh= {0,0,157,41},
	s_videosignal_static_xywh= {70,82,32,32},
	s_videosignal_check_xywh= {83,82,30,32},
	s_videosignal_ok_xywh= {520,140,120,38},
	s_videosignal_cancel_xywh= {660,140,120,38},
	s_videosignal_top_line_xywh= {11,78,784,1},
	s_videosignal_left_line_xywh= {11,78,1,0},
	s_videosignal_right_line_xywh= {795,78,1,0},
	s_videosignal_bottom_line_xywh= {11,78,784,1},
	s_videosignal_draw_xywh= {13,494,26,41},
	s_videosignal_all_xywh ={3,0,160,0},
}

w1_videosignal.s_1440 = 
{
	s_videosignal_page_xywh1= {320,900,0,0},
	s_videosignal_page_xywh2= {0,0,800,185},
	s_videosignal_border_xywh= {0,0,6,0},
	s_videosignal_title_xywh= {5,5,750,50},
	s_videosignal_close_xywh= {753,15,24,24},
	s_videosignal_channel_xywh= {13,80,156,36},
	s_videosignal_ahd_xywh= {169,80,155,36},
	s_videosignal_tvi_xywh= {324,80,155,36},
	s_videosignal_auto_xywh= {479,80,155,36},
	s_videosignal_cvi_xywh= {634,80,158,36},
	s_videosignal_line1_xywh= {169,80,2,36};
	s_videosignal_line2_xywh= {323,80,2,36};
	s_videosignal_line3_xywh= {478,80,2,36};
	s_videosignal_line4_xywh= {633,80,2,36};
	s_videosignal_line5_xywh= {11,80,784,1};
	s_videosignal_vdrop_xywh= {773,116,20,609};	
	s_videosignal_inteval_xywh= {0,0,157,36},
	s_videosignal_static_xywh= {70,85,32,32},
	s_videosignal_check_xywh= {83,85,30,32},
	s_videosignal_ok_xywh= {520,134,120,38},
	s_videosignal_cancel_xywh= {660,134,120,38},
	s_videosignal_top_line_xywh= {11,78,784,1},
	s_videosignal_left_line_xywh= {11,80,1,0},
	s_videosignal_right_line_xywh= {795,80,1,0},
	s_videosignal_bottom_line_xywh= {11,78,784,1},
	s_videosignal_draw_xywh= {13,487,26,36},
	s_videosignal_all_xywh ={3,0,160,0},
}	
	
w1_videosignal.s_1080p = 
{
	s_videosignal_page_xywh1= {560,1080,0,0},
	s_videosignal_page_xywh2= {0,0,800,190},
	s_videosignal_border_xywh= {0,0,6,0},
	s_videosignal_title_xywh= {5,5,750,56},
	s_videosignal_close_xywh= {750,15,24,24},
	s_videosignal_channel_xywh= {13,80,156,41},
	s_videosignal_ahd_xywh= {169,80,155,41},
	s_videosignal_tvi_xywh= {324,80,155,41},
	s_videosignal_auto_xywh= {478,80,155,41},
	s_videosignal_cvi_xywh= {633,80,158,41},
	s_videosignal_line1_xywh= {168,80,2,41},
	s_videosignal_line2_xywh= {323,80,2,41},
	s_videosignal_line3_xywh= {478,80,2,41},
	s_videosignal_line4_xywh= {633,80,2,41},
	s_videosignal_line5_xywh= {11,80,784,1},
	s_videosignal_vdrop_xywh= {772,121,20,695},	
	s_videosignal_inteval_xywh= {0,0,157,41},
	s_videosignal_static_xywh= {70,85,32,32},
	s_videosignal_check_xywh= {83,85,30,32},
	s_videosignal_ok_xywh= {520,140,120,38},
	s_videosignal_cancel_xywh= {660,140,120,38},
	s_videosignal_top_line_xywh= {10,78,784,1},
	s_videosignal_left_line_xywh= {10,80,1,0},
	s_videosignal_right_line_xywh= {794,80,1,0},
	s_videosignal_bottom_line_xywh= {10,78,784,1},
	s_videosignal_draw_xywh= {13,522,26,41},
	s_videosignal_all_xywh ={3,0,160,0},
}

w1_videosignal.s_2k = 
{
	s_videosignal_page_xywh1= {746,1440,0,0},
	s_videosignal_page_xywh2= {0,0,1066,253},
	s_videosignal_border_xywh= {0,0,8,0},
	s_videosignal_title_xywh= {7,7,1000,75},
	s_videosignal_close_xywh= {1000,20,32,32},
	s_videosignal_channel_xywh= {17,107,208,55},
	s_videosignal_ahd_xywh= {225,107,207,55},
	s_videosignal_tvi_xywh= {432,107,207,55},
	s_videosignal_auto_xywh= {637,107,207,55},
	s_videosignal_cvi_xywh= {844,107,211,55},
	s_videosignal_line1_xywh= {224,107,3,55},
	s_videosignal_line2_xywh= {431,107,3,55},
	s_videosignal_line3_xywh= {637,107,3,55},
	s_videosignal_line4_xywh= {844,107,3,55},
	s_videosignal_line5_xywh= {15,107,1045,1},
	s_videosignal_vdrop_xywh= {1029,161,27,926},
	s_videosignal_inteval_xywh= {0,0,209,55},
	s_videosignal_static_xywh= {93,113,43,43},
	s_videosignal_check_xywh= {111,113,40,43},
	s_videosignal_ok_xywh= {693,187,160,51},
	s_videosignal_cancel_xywh= {880,187,160,51},
	s_videosignal_top_line_xywh= {13,104,1045,1},
	s_videosignal_left_line_xywh= {13,107,1,0},
	s_videosignal_right_line_xywh= {1058,107,1,0},
	s_videosignal_bottom_line_xywh= {13,104,1045,1},
	s_videosignal_draw_xywh= {17,696,35,55},
	s_videosignal_all_xywh ={4,0,213,0},
}

w1_videosignal.s_4k = 
{
	s_videosignal_page_xywh1= {1120,2160,0,0},
	s_videosignal_page_xywh2= {0,0,1600,380},
	s_videosignal_border_xywh= {0,0,12,0},
	s_videosignal_title_xywh= {10,10,1500,112},
	s_videosignal_close_xywh= {1500,30,48,48},
	s_videosignal_channel_xywh= {26,160,312,82},
	s_videosignal_ahd_xywh= {338,160,310,82},
	s_videosignal_tvi_xywh= {648,160,310,82},
	s_videosignal_auto_xywh= {956,160,310,82},
	s_videosignal_cvi_xywh= {1266,160,316,82},
	s_videosignal_line1_xywh= {336,160,4,82},
	s_videosignal_line2_xywh= {646,160,4,82},
	s_videosignal_line3_xywh= {956,160,4,82},
	s_videosignal_line4_xywh= {1266,160,4,82},
	s_videosignal_line5_xywh= {22,160,1568,2},
	s_videosignal_vdrop_xywh= {1544,242,40,1390},
	s_videosignal_inteval_xywh= {0,0,314,82},
	s_videosignal_static_xywh= {140,170,64,64},
	s_videosignal_check_xywh= {166,170,60,64},
	s_videosignal_ok_xywh= {1040,280,240,76},
	s_videosignal_cancel_xywh= {1320,280,240,76},
	s_videosignal_top_line_xywh= {20,156,1568,2},
	s_videosignal_left_line_xywh= {20,160,2,0},
	s_videosignal_right_line_xywh= {1588,160,2,0},
	s_videosignal_bottom_line_xywh= {20,156,1568,2},
	s_videosignal_draw_xywh= {26,1044,52,82},
	s_videosignal_all_xywh ={6,0,320,0},

}


local ALL_TYPE=nil;

local on_ok = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_app_api.setvideosignal(ALL_TYPE.max_camera_num,ALL_TYPE.channel,ALL_TYPE.type);
		b_dlg.end_modal(top)
	end
	return 0;
end

local on_cancel = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.end_modal(top)
	end
	return 0;
end

local on_close = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.end_modal(top)
	end
	return 0;
end

local update_all_select = function (top)
	local signal_type =ALL_TYPE.type[1]
	local save_num =0;
	for i=1,channel_count do
		if( signal_type ==ALL_TYPE.type[i])then
			save_num = save_num+1;	
		end	
	end
	local name =nil;
	if(save_num == channel_count)then --Ƿĳһȫѡ
		if(1 == signal_type)then
			name ="signal"..tostring(0)..tostring(1)
			b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, true, false)
		elseif(2 == signal_type)then
			name ="signal"..tostring(0)..tostring(2)
			b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, true, false)
		elseif(0 == signal_type)then
			name ="signal"..tostring(0)..tostring(3)
			b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, true, false)
		elseif(3 == signal_type)then
			name ="signal"..tostring(0)..tostring(4)
			b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, true, false)
		end
	else
		for i=1,4 do
			name ="signal"..tostring(0)..tostring(i)
			b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, false, false)
		end
	end
	b_dlg.dlg_set_redraw(top);
end

local on_set = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local selectall_flag = false;
		for i=1,4 do
			local name ="signal"..tostring(0)..tostring(i)
			if(w1_videosignal.dlg[name].id == win_id)then --Ƿȫѡ
				selectall_flag =true;
				for j=1,channel_count do
					if(i == 3)then
						ALL_TYPE.type[j] = 0;
					elseif(i ==4)then
						ALL_TYPE.type[j] = 3;
					else
						ALL_TYPE.type[j] = i;
					end
					
					if j <= dis_col then
						name ="signal"..tostring(j)..tostring(i)
						b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, true, false) --ȫѡӦtruefalse
						for k=1,4 do  --ȥѡ״̬
							if(i ~= k)then 
								name ="signal"..tostring(j)..tostring(k)
								b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, false, false)
							end
						end
					end
				end
				for k=1,4 do
					if(i ~= k)then 
						name ="signal"..tostring(0)..tostring(k)
						b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, false, false)
					end
				end
				b_dlg.dlg_set_redraw(top);
			end
			
		end
		if(selectall_flag ==false)then--ǵȫѡ
			for i=1,dis_col do
				for j=1, 4 do
					local name ="signal"..tostring(i)..tostring(j)
					if(w1_videosignal.dlg[name].id == win_id)then 
						if(1 ==j)then
							ALL_TYPE.type[i+display_off] = 1
							ALL_TYPE.channel[i+display_off] = i
						elseif(2== j)then
							ALL_TYPE.type[i+display_off] = 2
							ALL_TYPE.channel[i+display_off] = i
						elseif(3 == j)then
							ALL_TYPE.type[i+display_off] = 0
							ALL_TYPE.channel[i+display_off] = i
						elseif(4 == j)then
							ALL_TYPE.type[i+display_off] = 3
							ALL_TYPE.channel[i+display_off] = i
						end
						
						b_wnd_ex.set_check(top, win_id, true, false)
					
						for k=1,4 do
							local name1 ="signal"..tostring(i)..tostring(k)
							if(w1_videosignal.dlg[name1].id ~= win_id)then  --ȥѡ״̬
								b_wnd_ex.set_check(top, w1_videosignal.dlg[name1].id, false, false)
							end
						end						
					end
				end
			end
			update_all_select(top)
		end
		
	end	
	
	return 0;
end

w1_videosignal.init = function ()
	display_off = 0;
	return 0
end

local set_check = function (top)
	local name =nil;
	local a,b,c,d=0,0,0,0;
	local num;
	for k=1, channel_count do
		if(1 == ALL_TYPE.type[k])then
			a=1;
			num = 1;
		elseif(2 == ALL_TYPE.type[k])then
			b=1;
			num = 2;
		elseif(3 == ALL_TYPE.type[k])then
			c=1;
			num = 4;
		else
			d=1;
			num = 3;
		end
		if k > display_off and k <= dis_col+display_off then
			name ="signal"..tostring(k-display_off)..tostring(num)
			b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, true, false)
			name = "ch"..tostring(k-display_off);
			b_wnd_ex.set_text(top, w1_videosignal.dlg[name].id,tostring(k),false);
			for i=1,4 do  --ȥѡ״̬
				if(i ~= num)then 
					name ="signal"..tostring(k-display_off)..tostring(i)
					b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, false, false)
				end
			end		
		end
	end
	local type_num =a+b+c+d;
	if(type_num == 1)then
		local type_id = ALL_TYPE.type[1];
		if(0 == type_id)then
			name ="signal"..tostring(0)..tostring(3)	
			b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, true, false)
		elseif(3 == type_id)then
			name ="signal"..tostring(0)..tostring(4)	
			b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, true, false)
		else
			name ="signal"..tostring(0)..tostring(type_id)	
			b_wnd_ex.set_check(top, w1_videosignal.dlg[name].id, true, false)
		end
	end
end

w1_videosignal.on_create = function(top)
	local dlg = {
		attr = {},
		sub = nil,
	}	
	channel_count = G.channel_num
	if(4 == channel_count)then
		ex_height =0
	else
		ex_height =channel_count
	end
	if channel_count <= 16 then
		list_num =channel_count+1;
		dis_col = channel_count;
	else
		list_num = 17;
		dis_col = 16;
	end
	
--	local wndsize = SIZE('s_videosignal_page_xywh');
	local wndsize = {}
	local wndsize1 = SIZE('s_videosignal_page_xywh1');
	local wndsize2 = SIZE('s_videosignal_page_xywh2');
	local wndsize3 = SIZE('s_videosignal_border_xywh');
	table.insert(wndsize,wndsize1[1])
	table.insert(wndsize,wndsize1[2])
	table.insert(wndsize,wndsize2[3])
	table.insert(wndsize,wndsize2[4])
	local wnd_inteval = SIZE('s_videosignal_inteval_xywh');
   
	local cy = wndsize[4]+list_num*wnd_inteval[4]+12
	local y  = math.floor((wndsize[2] -cy)/2) 
	dlg.attr.xywh ={wndsize[1],y,wndsize[3]+wndsize3[3],cy}
--	dlg.attr.xywh ={wndsize[1],wndsize[2]-ex_height/2*wnd_inteval[4],wndsize[3],wndsize[4]+channel_count*wnd_inteval[4]}
	dlg.sub = {"title","close", "channel", "vline1", "ahd", "vline2","tvi", "vline3", "auto", "vline4","cvi","line1","line2","line3","line4","line5"};
	dlg.title = {t = 'static',id =id+1,xywh='s_videosignal_title_xywh',text='LA_VIDEO_SIGNEL',align = b_ui.ALIGN.CENTER,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_static_text'}
			};
	dlg.close = {t='tt_button',id=id+2,xywh='s_videosignal_close_xywh',t_imgs = {b_ui.ALIGN.LEFT,'f_closebtn2','it_close','it_close', 'it_close'}, cmd=on_close,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfgclose_bk'}};
	
	dlg.channel ={t = 'static',id =id+3,xywh='s_videosignal_channel_xywh',text='LA_CHANNEL',align = b_ui.ALIGN.CENTER,
				color= {'c_list_title', 'c_list_title', 'c_static_text'}};
	dlg.ahd ={t = 'static',id =id+4,xywh='s_videosignal_ahd_xywh',text='AHD',trans = false,align = b_ui.ALIGN.CENTER,
				color= {'c_list_title', 'c_list_title', 'c_static_text'}};
	dlg.tvi ={t = 'static',id =id+5,xywh='s_videosignal_tvi_xywh',text='TVI',trans = false,align = b_ui.ALIGN.CENTER,
				color= {'c_list_title', 'c_list_title', 'c_static_text'}};
	dlg.auto ={t = 'static',id =id+6,xywh='s_videosignal_auto_xywh',text='AUTO',trans = false,align = b_ui.ALIGN.CENTER,
				color= {'c_list_title', 'c_list_title', 'c_static_text'}};
	dlg.cvi ={t = 'static',id =id+7,xywh='s_videosignal_cvi_xywh',text='CVI',trans = false,align = b_ui.ALIGN.CENTER,
				color= {'c_list_title', 'c_list_title', 'c_static_text'}};
				
	dlg.line1 = {t='hline',	id=id+8,xywh='s_videosignal_line1_xywh'};
	dlg.line2 = {t='hline',	id=id+9,xywh='s_videosignal_line2_xywh'};
	dlg.line3 = {t='hline',	id=id+10,xywh='s_videosignal_line3_xywh'};
	dlg.line4 = {t='hline',	id=id+11,xywh='s_videosignal_line4_xywh'};
	dlg.line5 = {t='hline',	id=id+12,xywh='s_videosignal_line5_xywh'};
	if channel_count > 16 then
		table.insert(dlg.sub, 'vdrop')
		dlg['vdrop'] = {t='vdrop', id=id+13,xywh='s_videosignal_vdrop_xywh'};
	end
	local num =list_num *4;
	for i=1,list_num do  --ͨ
		table.insert(dlg.sub, 'ch'..tostring(i-1))
		local name = "ch"..tostring(i-1);
		wndsize = SIZE('s_videosignal_static_xywh');
		local d = i%2
		if(1 == i)then
			local name_w = SIZE('s_videosignal_all_xywh');	--2								--name_w[3]										
			dlg[name] = {t='static',id=id+13+i,xywh={wndsize[1],wndsize[2]+wnd_inteval[4]*i,wndsize[3],wndsize[4]},text=STR('LA_ALL'),trans = false,
				color= {'c_list_brak1', 'c_list_brak1', 'c_txt_n'},align = b_ui.ALIGN.CENTER
				};
		elseif(i%2 ==0)then
			dlg[name] = {t='static',id=id+13+i,xywh={wndsize[1],wndsize[2]+wnd_inteval[4]*i,wndsize[3],wndsize[4]},text=''--[[tostring(i-1)--]],trans = false,
				color= {'c_list_brak2', 'c_list_brak2', 'c_txt_n'}
				};
		else
			dlg[name] = {t='static',id=id+13+i,xywh={wndsize[1],wndsize[2]+wnd_inteval[4]*i,wndsize[3],wndsize[4]},text=''--[[tostring(i-1)--]],trans = false,
				color= {'c_list_brak1', 'c_list_brak1', 'c_txt_n'}
				};
		end
	end
	
	id = id+list_num+14;
	wndsize = SIZE('s_videosignal_check_xywh');
	for k=1,list_num do
		for j=1, 4 do
			if(k%2 ==0)then
				table.insert(dlg.sub, 'signal'..tostring(k-1)..tostring(j))
				local name ="signal"..tostring(k-1)..tostring(j)
				dlg[name] = {t='tt_check',id=id+j+(k-1)*4,xywh={wndsize[1]+wnd_inteval[3]*j,wndsize[2]+wnd_inteval[4]*k,wndsize[3],wndsize[4]},cmd=on_set,
					font = 'f_grade1',
					t_imgs = {b_ui.ALIGN.LEFT,'f_signalimg', 'it_singnal_false','it_singnal_true', 'it_singnal_false'},
					color_c= {'c_list_brak2', 'c_list_brak2', 'c_check_text_c'},color= {'c_list_brak2', 'c_list_brak2', 'c_txt_n'},color_f= {'c_list_brak2', 'c_list_brak2', 'c_txt_n'}};
			else
				table.insert(dlg.sub, 'signal'..tostring(k-1)..tostring(j))
				local name ="signal"..tostring(k-1)..tostring(j)
				dlg[name] = {t='tt_check',id=id+j+(k-1)*4,xywh={wndsize[1]+wnd_inteval[3]*j,wndsize[2]+wnd_inteval[4]*k,wndsize[3],wndsize[4]},cmd=on_set,
					font = 'f_grade1',
					t_imgs = {b_ui.ALIGN.LEFT,'f_signalimg', 'it_singnal_false','it_singnal_true', 'it_singnal_false'},
					color_c= {'c_list_brak1', 'c_list_brak1', 'c_check_text_c'},color= {'c_list_brak1', 'c_list_brak1', 'c_txt_n'},color_f= {'c_list_brak1', 'c_list_brak1', 'c_txt_n'}};
			end		
		end
	end
	id = id+list_num*4+1

	wndsize = SIZE('s_videosignal_ok_xywh');
	local height = wndsize[2]+list_num*wnd_inteval[4]   
	table.insert(dlg.sub, 'ok')
	dlg.ok = {t = 'button',id =id+1,xywh={wndsize[1],height,wndsize[3],wndsize[4]},text='LA_OK',cmd=on_ok,
			color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
			color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},};
	wndsize = SIZE('s_videosignal_cancel_xywh')
	table.insert(dlg.sub, 'cancel')
	dlg.cancel = {t = 'button',id =id+2,xywh={wndsize[1],height,wndsize[3],wndsize[4]},text='LA_CANCEL',cmd=on_cancel,
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},};
	
	id =id+3

	table.insert(dlg.sub, 'topline')
	dlg.topline 	= {t='hline',	id=id+1,xywh={'s_videosignal_top_line_xywh'}}
	wndsize = SIZE('s_videosignal_left_line_xywh');
	table.insert(dlg.sub, 'leftline')
	dlg.leftline 	= {t='hline',	id=id+2,xywh={wndsize[1],wndsize[2],wndsize[3],list_num*wnd_inteval[4]+wnd_inteval[4]}}
	wndsize = SIZE('s_videosignal_right_line_xywh');	
	table.insert(dlg.sub, 'rightline')
	dlg.rightline 	= {t='hline',	id=id+3,xywh={wndsize[1],wndsize[2],wndsize[3],list_num*wnd_inteval[4]+wnd_inteval[4]}}
	wndsize = SIZE('s_videosignal_bottom_line_xywh');
	table.insert(dlg.sub, 'bottomline')
	dlg.bottomline 	= {t='hline',	id=id+4,xywh={wndsize[1],wndsize[2]+list_num*wnd_inteval[4]+wnd_inteval[4],wndsize[3],wndsize[4]}}
			
	w1_videosignal.top = top
	w1_videosignal.dlg = dlg
	b_parser(top, dlg)
	
	if channel_count > 16 then
		local vdrop = {};
		vdrop.set_cur = 0;
		vdrop.set_cap = 16;
		vdrop.set_max = G.channel_num;
		b_wnd_ex.set_drop(top,dlg.vdrop.id,vdrop,false);
	end
	
	--ȡͨӦź	ʾ
	local all_type = b_app_api.getvideosignal();
	if (ALL_TYPE == nil) then
		ALL_TYPE = all_type;
	else
		util.copy_tab_b(ALL_TYPE, all_type);	
	end

	set_check(top)
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)
	return 0
end

w1_videosignal.on_destroy = function(top)
	w1_videosignal.top = nil
	w1_videosignal.dlg = nil
	ALL_TYPE = nil
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0
end

w1_videosignal.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	local pos1 = SIZE('s_videosignal_title_xywh');
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	b_wnd.draw_fill(top, x,y+pos1[2]+pos1[4], cx, 1, COLOR('c_hline_color'))--y+58
	local wndsize = SIZE('s_videosignal_draw_xywh');
	local wnd_inteval = SIZE('s_videosignal_inteval_xywh');
	local wnd_size = SIZE('s_videosignal_page_xywh1');
	local wnd_channel_size = SIZE('s_videosignal_channel_xywh');
	local w_y  = math.floor((wnd_size[2] -cy)/2+wnd_channel_size[2])

	for i=1,list_num do --仯

		local test_h =w_y+wnd_inteval[4]*i;
		if(i%2 ==0)then
			b_wnd.draw_fill(top, x+wndsize[1], test_h, cx-wndsize[3], wndsize[4], COLOR('c_list_brak2'))
		else
			b_wnd.draw_fill(top, x+wndsize[1], test_h, cx-wndsize[3], wndsize[4], COLOR('c_list_brak1'))
		end
		
	end
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_modch_border'), 1)
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)

	return 0
end

w1_videosignal.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
--	if (b_ui.LBUTTONCLK == vmsg or b_ui.RBUTTONCLK == vmsg) then  --Ҽ˳
	if (b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	elseif(b_ui.MOUSEWHEELDOWN == vmsg) then
		if channel_count > 16 then
			if(channel_count == 32)then
				if display_off < 16 then
					display_off = display_off+1
				end
			elseif(channel_count == 64)then
				if display_off < 48 then
					display_off = display_off+1
				end
			elseif(channel_count == 128)then
				if display_off < 112 then
					display_off = display_off+1
				end
			end
			vdrop.set_cur = display_off;
			vdrop.set_cap = 16;
			vdrop.set_max = G.channel_num;
			b_wnd_ex.set_drop(top,dlg.vdrop.id,vdrop,false);
			b_dlg.dlg_set_redraw(top);
		end
	elseif(b_ui.MOUSEWHEELUP == vmsg) then
		if channel_count > 16 then
			if display_off > 0 then
				display_off = display_off-1
			end
			vdrop.set_cur = display_off;
			vdrop.set_cap = 16;
			vdrop.set_max = G.channel_num;
			b_wnd_ex.set_drop(top,dlg.vdrop.id,vdrop,false);
			b_dlg.dlg_set_redraw(top);
		end
	elseif(b_ui.LBUTTONDRAG == vmsg) then
		display_off = b_wnd_ex.get_drop(top,w1_videosignal.dlg.vdrop.id);
		set_check(top)
		b_dlg.dlg_set_redraw(top);
	elseif(b_ui.LBUTTONDOWN == vmsg) then
		if channel_count > 16 then
			display_off = b_wnd_ex.get_drop(top,w1_videosignal.dlg.vdrop.id);
			set_check(top)
			b_dlg.dlg_set_redraw(top);
		end
	end
	return 0
end

return w1_videosignal