--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/7/4
-- author lsl
-- brief  öԻ
--]]
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui		= require("wnd.core.b_ui")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_id 	= require("wnd.w1_util.w1_id")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local id 		= w1_id.wizard_setup.id
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local b_app_cfg	= require("wnd.core.b_app_cfg")
local w1_wnd_jump				= require("wnd.w1_cfg.w1_wnd_jump")
local w1_wizard_network			= require("wnd.w1_live.w1_wizard_network")
local w1_wizard_net_cctv		= require("wnd.w1_live.w1_wizard_net_cctv")
local w1_wizard_network_setup 	= require("wnd.w1_live.w1_wizard_network_setup")
local w1_wizard_sys		= require("wnd.w1_live.w1_wizard_sys")
local w1_wizard_time	= require("wnd.w1_live.w1_wizard_time")
local w1_wizard_tzone	= require("wnd.w1_live.w1_wizard_tzone")
local w1_wizard_dst		= require("wnd.w1_live.w1_wizard_dst")
local w1_wizard_time_setup = require("wnd.w1_live.w1_wizard_time_setup")
local w1_wizard_camera	= require("wnd.w1_live.w1_wizard_camera")
local w1_wizard_disk	= require("wnd.w1_live.w1_wizard_disk")
local w1_wizard_p2p	= require("wnd.w1_live.w1_wizard_p2p")


--local w1_wizard= require("wnd.w1_live.w1_wizard")
local b_app_api 		= require("wnd.core.command.b_app_api")
local w1_msgbox 		= require("wnd.w1_util.w1_msgbox")
local r_str				= require("wnd.core.r_res.r_str")
local STR 				= r_str.get_str
local r_size			= require("wnd.core.r_res.r_size")
local SIZE 				= r_size.get_size
local w1_wnd_page 		= require("wnd.w1_cfg.w1_wnd_page")
local b_ui_msg  		= require("wnd.w1_util.w1_ui_msg") 
local global_val		= require("wnd.global_val")
local page_flag 		= 1;
local util 		= require("wnd.core.util")
local disp_page = {}
local page_id = nil;
local w1_wizard_setup 	= {
	t = w1_key.DLG_WIZARD_SETUP,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_setup.s_768 =
{
	s_wizard_setup_xywh = {285,64,453,645},
	s_wizard_setup_title_xywh = {26,2,373,35},
	s_wizard_setup_title_img_xywh = {5,2,21,35},
	s_wizard_setup_close_xywh = {426,9,17,22},
	s_wizard_setup_hline_xywh = {8,590,437,1},
	s_wizard_setup_prev_xywh = {229,604,64,27},
	s_wizard_setup_next_xywh = {304,604,64,27},
	s_wizard_setup_cancel_xywh = {378,604,64,27},
	s_wizard_setup_title_all_xywh = {0,0,453,35},
};

w1_wizard_setup.s_1280 = 
{
	s_wizard_setup_xywh = {215,62,850,908},
	s_wizard_setup_title_xywh={50,3,700,50},
	s_wizard_setup_title_img_xywh= {10,3,40,50},
	s_wizard_setup_close_xywh={800,13,32,32},
	s_wizard_setup_hline_xywh={15,830,820,1},
	s_wizard_setup_prev_xywh={430,850,120,38},
	s_wizard_setup_next_xywh={570,850,120,38},
	s_wizard_setup_cancel_xywh={710,850,120,38},
	s_wizard_setup_title_all_xywh={0,0,850,50},

}

w1_wizard_setup.s_1440 = 
{
	s_wizard_setup_xywh = {295,25,850,868},
	s_wizard_setup_title_xywh={50,3,700,50},
	s_wizard_setup_title_img_xywh= {10,3,40,50},	
	s_wizard_setup_close_xywh={800,13,32,32},
	s_wizard_setup_hline_xywh={15,790,820,1},
	s_wizard_setup_prev_xywh={430,810,120,38},
	s_wizard_setup_next_xywh={570,810,120,38},
	s_wizard_setup_cancel_xywh={710,810,120,38},
	s_wizard_setup_title_all_xywh={0,0,850,50},

}

w1_wizard_setup.s_1080p = 
{
	s_wizard_setup_xywh = {535,90,850,908},
	s_wizard_setup_title_xywh={50,3,700,50},
	s_wizard_setup_title_img_xywh= {10,3,40,50},	
	s_wizard_setup_close_xywh={800,13,32,32},
	s_wizard_setup_hline_xywh={15,830,820,1},
	s_wizard_setup_prev_xywh={430,850,120,38},
	s_wizard_setup_next_xywh={570,850,120,38},
	s_wizard_setup_cancel_xywh={710,850,120,38},
	s_wizard_setup_title_all_xywh={0,0,850,50},

}

w1_wizard_setup.s_2k = 
{
	s_wizard_setup_xywh = {713,120,1133,1210},
	s_wizard_setup_title_xywh={67,4,933,67},
	s_wizard_setup_title_img_xywh= {13,4,53,67},	
	s_wizard_setup_close_xywh={1066,17,43,43},
	s_wizard_setup_hline_xywh={20,1106,1093,1},
	s_wizard_setup_prev_xywh={573,1133,160,51},
	s_wizard_setup_next_xywh={760,1133,160,51},
	s_wizard_setup_cancel_xywh={946,1133,160,51},
	s_wizard_setup_title_all_xywh={0,0,1133,67},
}
w1_wizard_setup.s_4k = 
{
	s_wizard_setup_xywh = {1070,180,1700,1816},
	s_wizard_setup_title_xywh={100,6,1400,100},
	s_wizard_setup_title_img_xywh= {20,6,80,100},
	s_wizard_setup_close_xywh ={1600,26,64,64},
	s_wizard_setup_hline_xywh={30,1660,1640,2},
	s_wizard_setup_prev_xywh ={860,1700,240,76},
	s_wizard_setup_next_xywh ={1140,1700,240,76},
	s_wizard_setup_cancel_xywh={1420,1700,240,76},
	s_wizard_setup_title_all_xywh={0,0,1700,100},
}


local wizard_data = nil;
local exit_flag =false;
--local SAVE_TIME;
local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		local tc = b_wnd.tick_count(top);
		
		w1_wizard_network.timerenevt(top);
		w1_wizard_net_cctv.timerenevt(top);
		w1_wizard_time.timerenevt(top);
		w1_wizard_dst.timerenevt(top);
		w1_wizard_camera.timerenevt(top);
--[[		if SAVE_TIME > 0 then
			SAVE_TIME = SAVE_TIME - 1;
		else
			--߿
			b_dlg.dlg_set_redraw(top);
		end	--]]	
	end
	return 0
end

local change_time_timer =function (top,flag)
	local check_id = w1_wizard_time_setup.get_checkidx(top);
	if flag then
		if(0 == check_id)then
			w1_wizard_time.timer_start();
		elseif(1 == check_id)then
			w1_wizard_tzone.timer_start();
		elseif(2 == check_id)then
			w1_wizard_dst.timer_start();
		end
	else
		if(0 == check_id)then
			w1_wizard_time.timer_stop(top);
		elseif(1 == check_id)then
			w1_wizard_tzone.timer_stop(top);
		elseif(2 == check_id)then
			w1_wizard_dst.timer_stop(top);
		end
	end
end

local leave_network_timer =function (top)
	local check_id = w1_wizard_network_setup.get_checkidx(top);
	if(0 ==check_id)then
		local legal = w1_wizard_network.next(top)
		if(legal ~= 0)then
			return -1;
		end
	else
		local legal = w1_wizard_net_cctv.next(top)
		if(legal ~= 0)then
			return -1;
		end
	end
	local net_ip = {}
	local net_upnp ={}
	local ipv4 = w1_wizard_network.get_data(top)
	if(ipv4 ~= nil)then
		net_ip.network_ipv4 =ipv4.network_ipv4;
		net_upnp.upnp =ipv4.upnp;
	end
	local net_cctv ={}
	if (2==global_val.get_nic_num())then
		local cctv =w1_wizard_net_cctv.get_data(top)
		if(cctv ~= nil)then
			net_cctv.network_cctv =cctv.network_cctv;
		end	
	end
	local ret = nil;
	if(0 ==check_id)then
		if(net_ip.network_ipv4 ~= nil)then
			ret = b_app_api.save_cfg(net_ip)
			if (type(ret) == 'table') then
				local legalflag, idtab = w1_wizard_network.returndatacheck(top,ret.ret)
				if(legalflag ~= true and idtab ~= nil)then
					if (w1_wnd_util.errwidgetid == nil) then
						w1_wnd_util.errwidgetid  = idtab;
					else
						util.copy_tab_b(w1_wnd_util.errwidgetid, idtab);	
					end
					if(w1_wnd_util.olderrwidgetid == nil) then
						w1_wnd_util.olderrwidgetid = util.copy_tab(w1_wnd_util.errwidgetid);
					else
						util.copy_tab_b(w1_wnd_util.olderrwidgetid, w1_wnd_util.errwidgetid);
					end
					w1_wnd_util.tipflag = w1_wnd_util.tipstatus.paramerr
					
					w1_wnd_util.tipdispon()		--ʾ
					return -1;
				end
			end
		end
		if(net_upnp.upnp ~= nil)then
			b_app_api.save_cfg(net_upnp)
		end
		if(net_cctv.network_cctv ~=nil)then
			b_app_api.save_cfg(net_cctv)
		end
		w1_wizard_network.timer_stop(top);
	else
		if(net_cctv.network_cctv ~=nil)then
			ret = b_app_api.save_cfg(net_cctv)
			if (type(ret) == 'table') then
				local legalflag, idtab = w1_wizard_net_cctv.returndatacheck(top,ret.ret)
				if(legalflag ~= true and idtab ~= nil)then
					if (w1_wnd_util.errwidgetid == nil) then
						w1_wnd_util.errwidgetid  = idtab;
					else
						util.copy_tab_b(w1_wnd_util.errwidgetid, idtab);	
					end
					if(w1_wnd_util.olderrwidgetid == nil) then
						w1_wnd_util.olderrwidgetid = util.copy_tab(w1_wnd_util.errwidgetid);
					else
						util.copy_tab_b(w1_wnd_util.olderrwidgetid, w1_wnd_util.errwidgetid);
					end
					w1_wnd_util.tipflag = w1_wnd_util.tipstatus.paramerr
					
					w1_wnd_util.tipdispon()		--ʾ
					return -1;
				end
			end
		end
		if(net_ip.network_ipv4 ~= nil)then
			 b_app_api.save_cfg(net_ip)
		end
		if(net_upnp.upnp ~= nil)then
			b_app_api.save_cfg(net_upnp)
		end
		w1_wizard_net_cctv.timer_stop (top);
	end
	w1_wizard_network.timer_stop(top);
end

local leave_time_save = function (top)
	local check_id = w1_wizard_time_setup.get_checkidx(top);
	if(0 == check_id)then
		local legal = w1_wizard_time.check_time(top)
		if(legal ~= 0)then
			return -1;
		end
		w1_wizard_time.timer_stop(top);
	elseif(1 == check_id)then
		w1_wizard_tzone.timer_stop(top);
	elseif(2 == check_id)then
		local legal = w1_wizard_dst.dst_to_other(top)
		if(legal ~= 0)then
			return -1;
		end
		w1_wizard_dst.timer_stop(top);
	end
	local check_id = w1_wizard_time_setup.get_checkidx(top);
	local time_data = {}--w1_wizard_time_setup.get_data(top)
	local time = w1_wizard_time.get_data(top)
	local tzone =w1_wizard_tzone.get_data(top)
	local dst =w1_wizard_dst.get_data(top)
	if(time ~= nil)then
		time_data.time =time;
	end
	if(dst ~= nil)then
		time_data.dst =dst;
	end
	if(tzone ~= nil)then
		time_data.timezone =tzone;
	end
	if(time_data.time ~=nil or time_data.dst ~= nil or time_data.timezone ~= nil)then
		b_app_api.save_cfg(time_data)
	end

end

local leave_p2p_save = function (top)
	local data = {};
	data.p2p = w1_wizard_p2p.get_data(top);
	b_app_api.save_cfg(data)
	return 0;
end
local okfunc_exit =function (param)
	exit_flag =true;
	return 0;
end

local cfg_exit = function(top)
	local user_info = global_val.get_current_user_info();
	if (true ~= user_info.m_bisValid) then	--
		return b_ui_msg.msg_on_skip_reminder_pwd;	
	else
		b_app_cfg.origintousercfg()
		return b_ui_msg.msg_on_login_successful;
	end
	
	return 0;
end

local on_close = function(top, id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
--		SAVE_TIME = 120;
		b_dlg.dlg_set_redraw(top);
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_EXIT_WIZARD'), true, true,false);
		w1_msgbox.set_func(okfunc_exit,{top}, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		if(exit_flag ==true)then
			return cfg_exit(top);
		end 	
	end
	return 0;
end

local on_cancel= function(top, id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
--		SAVE_TIME = 120;
		b_dlg.dlg_set_redraw(top);		
		if(page_id == disp_page[#disp_page])then
			if page_id == w1_id.wizard_sys.id then
				--
				local sys_data,param = w1_wizard_sys.get_data(top);
				if(sys_data.tip_flag)then
					wizard_data.privacy.guide = 0
				else
					
				end
				b_app_api.save_cfg(wizard_data)
		
				--òֶӦ
				if(1 == sys_data.uivo)then
					local w1_ui_facade	= require("wnd.w1_facade.w1_ui_facade");
					w1_ui_facade.load_layout(param.cur_resolution, 'w1', 'f_normat');
					b_app_api.channge_resolution(param);
					return b_ui.WM_USER_CHANGE_RESOLUTION;
				else
					return cfg_exit(top);
				end
			end
			return cfg_exit(top);
		else
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_EXIT_WIZARD'), true, true,false);
			w1_msgbox.set_func(okfunc_exit,{top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			if(exit_flag ==true)then
				return cfg_exit(top);
			end 
		end
	end
	return 0;
end

local on_next = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.dlg_set_redraw(top);
		local network_id = w1_id.wizard_network_setup.id
		local time_id	 = w1_id.wizard_time_setup.id
		local camera_id = w1_id.wizard_camera.id
		local disk_id = w1_id.wizard_disk.id
		local p2p_id = w1_id.wizard_p2p.id
		local sys_id = w1_id.wizard_sys.id
		--Ϊǰһҳ
		if page_id==network_id then--
			if (-1 == leave_network_timer(top)) then
				return 0;
			end
		elseif page_id==time_id then--
			if (-1 == leave_time_save(top)) then
				return 0;
			end
		elseif (page_id==camera_id) then
			w1_wizard_camera.timer_stop(top);
		elseif (page_id==p2p_id) then
			leave_p2p_save(top)
		end
		
		for i=1,#disp_page do
			if disp_page[i]== page_id then
				page_id = disp_page[i+1]
				break;
			end
		end
		--ˢµǰҳid
		if(page_id ==  time_id)then
			change_time_timer(top,true)
			w1_wizard_time_setup.init(top);
		elseif(page_id ==  camera_id)then		
			w1_wizard_camera.timer_start();	
			w1_wizard_camera.init(top);
		elseif(page_id ==  disk_id)then
			w1_wizard_disk.on_pre_show(top);	
		elseif(page_id==p2p_id)then
			w1_wizard_p2p.init(top)
		elseif(page_id==sys_id)then
			w1_wizard_sys.init(top)
		elseif(page_id ==network_id)then
			w1_wizard_network_setup.init(top, page_id)
		end
		b_wnd_ex.set_show_page(top, w1_id.wizard_setup.conItem_id, page_id, true);	
		--Ϊһҳ
		if page_id==disp_page[#disp_page] then
			local changeflag, changeparam = w1_wnd_util.usercfgchange()
			if(changeflag) then
				--Ѹĺ'ṹ'浽ļ
				ret = b_app_cfg.savechangecfg(changeparam)
				b_app_cfg.saveSuccessful();
			end
			b_wnd_ex.set_disable (top, w1_wizard_setup.dlg.next.id, true, false);
			--local pos =  SIZE('s_wizard_setup_next_xywh')
			--b_wnd_ex.move_ex(top,w1_wizard_setup.dlg.prev.id,pos,false)
			b_wnd_ex.set_text(top,w1_wizard_setup.dlg.cancel.id,STR('LA_FINISH'), false);	
		else
			b_wnd_ex.set_disable (top, w1_wizard_setup.dlg.next.id, false, false);
		end
		b_wnd_ex.set_hide (top, w1_wizard_setup.dlg.prev.id, false, false);
	end
	b_dlg.dlg_set_redraw(top)
	return 0;
end

local on_prev = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ӵǰҳһҳ棬ֻرնʱ
		if (page_id==w1_id.wizard_time_setup.id) then
			change_time_timer(top,false)
		elseif(page_id==w1_id.wizard_camera.id) then 
			w1_wizard_camera.timer_stop();	
		elseif(page_id==w1_id.wizard_network_setup.id) then
			change_time_timer(top)
		end
		
		for i=1,#disp_page do
			if disp_page[i]== page_id and i>1 then
				page_id = disp_page[i-1]
				break;
			end
		end
		
		if(page_id == w1_id.wizard_sys.id)then
			w1_wizard_sys.init(top)
		elseif(page_id == w1_id.wizard_network_setup.id)then
			w1_wizard_network_setup.init(top, page_id)
		elseif(page_id == w1_id.wizard_time_setup.id)then
			w1_wizard_time_setup.init(top);
			change_time_timer(top,true)
		elseif(page_id == w1_id.wizard_camera.id)then
			page_id =w1_id.wizard_camera.id;
			w1_wizard_camera.init(top);
			w1_wizard_camera.timer_start();
		elseif(page_id == w1_id.wizard_disk.id)then
			w1_wizard_disk.on_pre_show(top);	
		elseif(page_id == w1_id.wizard_p2p.id)then
			w1_wizard_p2p.init(top)
		end
		b_wnd_ex.set_show_page(top, w1_id.wizard_setup.conItem_id, page_id, true);
		b_wnd_ex.set_text(top,w1_wizard_setup.dlg.cancel.id,STR('LA_CANCEL'), false);
		b_wnd_ex.set_disable (top, w1_wizard_setup.dlg.next.id, false, false);
		if disp_page[1]~=nil and page_id==disp_page[1] then
			b_wnd_ex.set_hide (top, w1_wizard_setup.dlg.prev.id, true, false);
		else
			--local pos =  SIZE('s_wizard_setup_prev_xywh')
			--b_wnd_ex.move_ex(top,w1_wizard_setup.dlg.prev.id,pos,false)
			b_wnd_ex.set_hide (top, w1_wizard_setup.dlg.prev.id, false, false);
		end
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local dlg = {
	attr = {xywh='s_wizard_setup_xywh',cmd=on_dlg,timer={-1, 500}},
	sub = {	'containerColumn', 'containerRow', 'containerItem','title_img','title','close','prev','next','cancel','w1_wizard_setup_title_wnd','line',
			'w1_wizard_wnd','w1_network_wnd','w1_wizard_network_setup_wnd','w1_wizard_title_wnd','w1_wizard_time_setup_wnd','w1_wizard_sys_wnd','w1_wizard_camera_wnd',
			'w1_wizard_disk_wnd','w1_wizard_p2p_wnd'
		},
--	containerColumn		= {t='container',id=w1_id.w1_wizard_setup.conCol_id,	xywh='s_cfg_con_xywh'},
	containerRow		= {t='container',id=w1_id.wizard_setup.conRow_id,	xywh='s_cfg_con_xywh'},
	containerItem 		= {t='container',id=w1_id.wizard_setup.conItem_id,	xywh='s_cfg_con_xywh'},
--	w1_wizard_wnd	=	w1_wizard.wnd,
--	w1_network_wnd 	= w1_wizard_network.wnd,
	w1_wizard_network_setup_wnd = w1_wizard_network_setup.wnd,
	w1_wizard_time_setup_wnd = w1_wizard_time_setup.wnd,
	w1_wizard_sys_wnd = w1_wizard_sys.wnd,
	w1_wizard_camera_wnd = w1_wizard_camera.wnd,
	w1_wizard_disk_wnd = w1_wizard_disk.wnd,
	w1_wizard_p2p_wnd = w1_wizard_p2p.wnd,

	title_img= {t ='tt_button',id=id+13,xywh='s_wizard_setup_title_img_xywh',
				t_imgs = {b_ui.ALIGN.LEFT,'f_image','it_wizard_title_img','it_wizard_title_img','it_wizard_title_img'},
				color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
				color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},},	
	
	title 		= {t='static',id=id+7,xywh='s_wizard_setup_title_xywh',text='LA_START_WIZARD',align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}
					},

					
	close = {t='tt_button',id=id+8,xywh='s_wizard_setup_close_xywh',
			t_imgs = {b_ui.ALIGN.LEFT,'f_closebtn2','it_close','it_close', 'it_close'},
			cmd=on_close,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_f'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfgclose_bk'}},
	
--	tip_check	=	{t='check', id=id+7,xywh={30,770,40,40}, check = false,},
--	tip			=	{t='static', id=id+8,xywh={80,770,700,40},text='LA_WIZARD_TIP', check = true,},
	line		=	{t='hline',	id=id+9,xywh='s_wizard_setup_hline_xywh'},
	prev		= 	{t='button',id=id+10,	xywh='s_wizard_setup_prev_xywh', 	text='LA_PREV',cmd=on_prev,
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	next		= 	{t='button',id=id+11,	xywh='s_wizard_setup_next_xywh', 	text='LA_NEXT',cmd=on_next,
					color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
					},
	cancel 		= 	{t='button',id=id+12,	xywh='s_wizard_setup_cancel_xywh', 	text='LA_CANCEL',cmd=on_cancel,
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
					},
}

w1_wizard_setup.on_create = function(top)
	w1_wizard_setup.top = top;
	w1_wizard_setup.dlg = dlg;
--	SAVE_TIME = 120;
	--UIڳʼ
	b_parser(top, w1_wizard_setup.dlg);	
	local add_page = function(child_id, w_id)
		b_wnd_ex.set_add_page(top, child_id, w_id);
	end
	
	local show_page = function(child_id, w_id)
		b_wnd_ex.set_show_page(top, child_id, w_id, false);
	end
	
	local cwnd = w1_wizard_setup.dlg;
--	add_page(cwnd.containerRow.id, cwnd.w1_wizard_wnd.id);
--	add_page(cwnd.containerItem.id, cwnd.w1_wizard_wnd.id);
--	add_page(cwnd.containerItem.id, cwnd.w1_network_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_wizard_network_setup_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_wizard_time_setup_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_wizard_sys_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_wizard_camera_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_wizard_disk_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_wizard_p2p_wnd.id);
	show_page(cwnd.containerItem.id, cwnd.w1_wizard_network_setup_wnd.id);

--	show_page(cwnd.containerRow.id, cwnd.w1_wizard_wnd.id);
--w1_id.wizard_time.wizard_time_id;
--	show_page(cwnd.containerItem.id, cwnd.w1_network_wnd.id);
	


	--homeڶʱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	
	return 0
end

w1_wizard_setup.on_pre_show = function(top)
	exit_flag =false;
	page_flag =1;
	local privacy ={}
	table.insert(privacy,"privacy")
	
	local cfg_data = b_app_api.get_cfg(privacy)	
	if(wizard_data == nil) then
		wizard_data = cfg_data
	else
		util.copy_tab_b(wizard_data, wizard_data);	
	end	
		
	b_wnd_ex.set_hide (top, w1_wizard_setup.dlg.prev.id, true, false);
--	w1_wizard_network.init(top);
	local p2p_flag = global_val.get_p2p_support();
	local pb_flag = global_val.get_playback_support();
	local network_id = w1_id.wizard_network_setup.id
	local time_id	 = w1_id.wizard_time_setup.id
	local camera_id = w1_id.wizard_camera.id
	local disk_id = w1_id.wizard_disk.id
	local p2p_id = w1_id.wizard_p2p.id
	local sys_id = w1_id.wizard_sys.id
	
	if (p2p_flag == true) then
		if (pb_flag == true) then
			disp_page={network_id,time_id,camera_id,disk_id,p2p_id,sys_id}
		else
			disp_page={network_id,time_id,camera_id,p2p_id,sys_id}
		end	
	else
		if (pb_flag == true) then
			disp_page={network_id,time_id,camera_id,disk_id,sys_id}
		else
			disp_page={network_id,time_id,camera_id,sys_id}
		end	
	end
		
	--disp_pageҳidչʾ˳
	--disp_page={disk_id,camera_id,network_id,time_id,sys_id}

	page_id = disp_page[1]
	w1_wizard_network_setup.on_pre_show(top);
	w1_wizard_time_setup.on_pre_show(top);
	w1_wizard_camera.on_pre_show(top);
	w1_wizard_disk.on_pre_show(top);
	if (page_id==network_id )then
		w1_wizard_network_setup.init(top)
	elseif(page_id==time_id) then
		w1_wizard_time_setup.init(top)
		change_time_timer(top,true)
	elseif(page_id==camera_id)then
		w1_wizard_camera.init(top)
		w1_wizard_camera.timer_start()
	end
		
	
--	w1_wizard_network_setup.init(top);
	return 0
end

w1_wizard_setup.on_destroy = function(top)
	w1_wizard_setup.top = nil;
	w1_wizard_setup.dlg = nil;
	wizard_data = nil;
	w1_wizard_dst.clear();
	w1_wizard_net_cctv.clear();
	w1_wizard_network.clear();
	w1_wizard_time.clear();
	w1_wizard_disk.clear();
	w1_wizard_sys.clear();
	w1_wizard_camera.clear();
	
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)	

	return 0;
end

w1_wizard_setup.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'));
	local param =SIZE('s_wizard_setup_title_all_xywh')
	b_wnd.draw_fill(top, x, y, param[3], param[4], COLOR('c_cfg_row_bk'));
--	b_wnd.draw_rect(top, x-1, y-1, cx+2, cy+2, COLOR('c_modch_border'),1)
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	
--[[	if SAVE_TIME > 0 then
		b_wnd.draw_rect(top, x-1, y-1, cx+2, cy+2, COLOR('c_popdlg_border_h'),1)
	else
		b_wnd.draw_rect(top, x-1, y-1, cx+2, cy+2, COLOR('c_popdlg_bk'),1)
	end--]]
	b_wnd.end_job(top);
	return 0;
end

w1_wizard_setup.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if( b_ui.WM_USER_UPDATE_LANGUAGE == vmsg)then
		return vmsg;
	elseif( b_ui.RBUTTONCLK == vmsg)then
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_EXIT_WIZARD'), true, true,false);
		w1_msgbox.set_func(okfunc_exit,{top}, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		if(exit_flag ==true)then
			local user_info = global_val.get_current_user_info();
			if (true ~= user_info.m_bisValid) then	--
				b_app_cfg.origintousercfg()
				b_dlg.end_modal(top);
				return b_ui_msg.msg_on_skip_reminder_pwd;	
			else
				b_app_cfg.origintousercfg()
				b_dlg.end_modal(top);
				return b_ui_msg.msg_on_login_successful;
			end
		end
		b_dlg.dlg_set_redraw(top);
	elseif(b_ui.WM_USER_CHANGE_RESOLUTION ==vmsg)then
		return b_ui.WM_USER_CHANGE_RESOLUTION;
	elseif(1 ==vmsg)then
		local cwnd = w1_wizard_setup.dlg;
		b_wnd_ex.set_hide(top, w1_id.wizard.id, true, false)
		b_dlg.clear_foucs_wnd(top);
		b_wnd_ex.set_show_page(top, cwnd.containerItem.id, cwnd.w1_network_wnd.id, false);
		b_wnd_ex.set_hide (top, w1_wizard_setup.dlg.next.id, false, false);
		b_wnd_ex.set_hide (top, w1_wizard_setup.dlg.cancel.id, false, false);
		b_dlg.dlg_set_redraw(top);
	elseif (b_ui_msg.msg_on_skip_reminder_pwd == vmsg) then
		b_app_cfg.origintousercfg()
		b_dlg.end_modal(top);
		return vmsg;
	elseif (b_ui_msg.msg_on_login_successful == vmsg) then
		b_dlg.end_modal(top);
		return vmsg;			
	end
	
	return 0
end

return w1_wizard_setup
