-- UIʹõȷȡԻ
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.copy_id;
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local util 		= require("wnd.core.util")

local channel_num;
local w1_copy = {
	t = w1_key.DLG_COPY,
	top = nil,
	dlg = nil,
	
	enable_ch,			--ʹܸƵͨ
	select_ch,			--ѡеͨ
	ok_func = nil,			--okťص
	okfunc_param = nil;		--okťص
	state = 0;
	start_x = 0;
	start_y = 0;
	end_x = 0;
	end_y = 0;
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_copy.s_768 =
{
	s_copy1_xywh = {800,604,128,92},
	s_copy2_xywh = {800,568,128,128},
	s_copy3_xywh = {750,568,232,128},
	s_copy4_xywh = {750,497,232,199},
	s_copy5_xywh = {518,497,457,199},
	s_copy6_xywh = {518,341,457,355},
	s_copy_ch4_check_xywh = {8,56,18,28},
	s_copy_ch4_selectall_xywh = {26,56,53,28},
	s_copy_ch8_check_xywh = {8,92,18,28},
	s_copy_ch8_selectall_xywh = {26,92,53,28},
	s_copy_ch16_check_xywh = {8,92,18,28},
	s_copy_ch16_selectall_xywh = {26,92,53,28},
	s_copy_ch32_check_xywh = {8,163,18,28},
	s_copy_ch32_selectall_xywh = {26,163,53,28},
	s_copy_ch64_check_xywh = {8,163,18,28},
	s_copy_ch64_selectall_xywh = {26,163,53,28},
	s_copy_ch128_check_xywh = {8,320,18,28},
	s_copy_ch128_selectall_xywh = {26,320,53,28},
	s_copy_ch4_ok_xywh = {80,56,42,28},
	s_copy_ch8_ok_xywh = {80,92,42,28},
	s_copy_ch16_ok_xywh = {185,92,42,28},
	s_copy_ch32_ok_xywh = {185,163,42,28},
	s_copy_ch64_ok_xywh = {410,163,42,28},
	s_copy_ch128_ok_xywh = {410,320,42,28},
	s_copy_chmul_xywh = {28,0,0,0},
	s_copy_ch_xywh = {5,7,26,24},
	s_copy_ch4_8_xywh = {10,7,26,24},
	s_copy_frame_xywh = {0,0,5,7},
};

w1_copy.s_1280 = 
{
	s_copy1_xywh = {838,810,255,130},
	s_copy2_xywh = {838,760,255,180},
	s_copy3_xywh = {744,760,448,180},
	s_copy4_xywh = {744,660,448,280},
	s_copy5_xywh = {312,660,880,280},
	s_copy6_xywh = {312,420,880,500},
	s_copy_ch4_check_xywh = {15,80,35,40},
	s_copy_ch4_selectall_xywh = {50,80,100,40},
	s_copy_ch8_check_xywh = {15,130,35,40},
	s_copy_ch8_selectall_xywh = {50,130,100,40},
	s_copy_ch16_check_xywh = {15,130,35,40},
	s_copy_ch16_selectall_xywh = {50,130,100,40},
	s_copy_ch32_check_xywh = {15,230,35,40},
	s_copy_ch32_selectall_xywh = {50,230,100,40},
	s_copy_ch64_check_xywh = {15,230,35,40},
	s_copy_ch64_selectall_xywh = {50,230,100,40},
	s_copy_ch128_check_xywh = {15,450,35,40},
	s_copy_ch128_selectall_xywh = {50,450,100,40},
	s_copy_ch4_ok_xywh = {155,80,80,40},
	s_copy_ch8_ok_xywh = {155,130,80,40},
	s_copy_ch16_ok_xywh	= {353,130,80,40},
	s_copy_ch32_ok_xywh = {353,230,80,40},
	s_copy_ch64_ok_xywh = {785,230,80,40},
	s_copy_ch128_ok_xywh= {785,450,80,40},
	s_copy_chmul_xywh = {54,0,0,0},
	s_copy_ch_xywh = {10,10,50,50},
	s_copy_ch4_8_xywh = {20,10,50,50},
	s_copy_frame_xywh = {0,0,10,10},
};
w1_copy.s_1440 = 
{
	s_copy1_xywh = {1020,690,255,130},
	s_copy2_xywh = {1020,640,255,180},
	s_copy3_xywh = {914,640,448,180},
	s_copy4_xywh = {914,540,448,280},
	s_copy5_xywh = {482,540,880,280},
	s_copy6_xywh = {482,320,880,500},
	s_copy_ch4_check_xywh = {15,80,35,40},
	s_copy_ch4_selectall_xywh = {50,80,100,40},
	s_copy_ch8_check_xywh = {15,130,35,40},
	s_copy_ch8_selectall_xywh = {50,130,100,40},
	s_copy_ch16_check_xywh = {15,130,35,40},
	s_copy_ch16_selectall_xywh = {50,130,100,40},
	s_copy_ch32_check_xywh = {15,230,35,40},
	s_copy_ch32_selectall_xywh = {50,230,100,40},
	s_copy_ch64_check_xywh = {15,230,35,40},
	s_copy_ch64_selectall_xywh = {50,230,100,40},
	s_copy_ch128_check_xywh = {15,450,35,40},
	s_copy_ch128_selectall_xywh = {50,450,100,40},
	s_copy_ch4_ok_xywh = {155,80,80,40},
	s_copy_ch8_ok_xywh = {155,130,80,40},
	s_copy_ch16_ok_xywh	= {353,130,80,40},
	s_copy_ch32_ok_xywh = {353,230,80,40},
	s_copy_ch64_ok_xywh = {785,230,80,40},
	s_copy_ch128_ok_xywh= {785,450,80,40},
	s_copy_chmul_xywh = {54,0,0,0},
	s_copy_ch_xywh = {10,10,50,50},
	s_copy_ch4_8_xywh = {20,10,50,50},
	s_copy_frame_xywh = {0,0,10,10},
};
w1_copy.s_1080p = 
{
	s_copy1_xywh = {1488,850,255,130},
	s_copy2_xywh = {1488,800,255,180},
	s_copy3_xywh = {1390,800,448,180},
	s_copy4_xywh = {1390,700,448,280},
	s_copy5_xywh = {958,700,880,280},
	s_copy6_xywh = {958,480,880,500},	
	s_copy_ch4_check_xywh = {15,80,35,40},
	s_copy_ch4_selectall_xywh = {50,80,100,40},
	s_copy_ch8_check_xywh = {15,130,35,40},
	s_copy_ch8_selectall_xywh = {50,130,100,40},
	s_copy_ch16_check_xywh = {15,130,35,40},
	s_copy_ch16_selectall_xywh = {50,130,100,40},
	s_copy_ch32_check_xywh = {15,230,35,40},
	s_copy_ch32_selectall_xywh = {50,230,100,40},
	s_copy_ch64_check_xywh = {15,230,35,40},
	s_copy_ch64_selectall_xywh = {50,230,100,40},
	s_copy_ch128_check_xywh = {15,450,35,40},
	s_copy_ch128_selectall_xywh = {50,450,100,40},
	s_copy_ch4_ok_xywh = {155,80,80,40},
	s_copy_ch8_ok_xywh = {155,130,80,40},
	s_copy_ch16_ok_xywh	= {353,130,80,40},
	s_copy_ch32_ok_xywh = {353,230,80,40},
	s_copy_ch64_ok_xywh = {785,230,80,40},
	s_copy_ch128_ok_xywh= {785,450,80,40},
	s_copy_chmul_xywh = {54,0,0,0},
	s_copy_ch_xywh = {10,10,50,50},
	s_copy_ch4_8_xywh = {20,10,50,50},
	s_copy_frame_xywh = {0,0,10,10},
};
w1_copy.s_2k = 
{
	s_copy1_xywh = {1984,1133,340,173},
	s_copy2_xywh = {1984,1066,340,240},
	s_copy3_xywh = {1853,1066,597,240},
	s_copy4_xywh = {1853,933,597,373},
	s_copy5_xywh = {1277,933,1173,373},
	s_copy6_xywh = {1277,640,1173,667},
	s_copy_ch4_check_xywh = {20,107,47,53},
	s_copy_ch4_selectall_xywh = {67,107,133,53},
	s_copy_ch8_check_xywh = {20,173,47,53},
	s_copy_ch8_selectall_xywh = {67,173,133,53},
	s_copy_ch16_check_xywh = {20,173,47,53},
	s_copy_ch16_selectall_xywh = {67,173,133,53},
	s_copy_ch32_check_xywh = {20,307,47,53},
	s_copy_ch32_selectall_xywh = {67,307,133,53},
	s_copy_ch64_check_xywh = {20,307,47,53},
	s_copy_ch64_selectall_xywh = {67,307,133,53},
	s_copy_ch128_check_xywh = {20,600,47,53},
	s_copy_ch128_selectall_xywh = {67,600,133,53},
	s_copy_ch4_ok_xywh={206,107,107,53},
	s_copy_ch8_ok_xywh={206,173,107,53},
	s_copy_ch16_ok_xywh={471,173,107,53},
	s_copy_ch32_ok_xywh={471,307,107,53},
	s_copy_ch64_ok_xywh={1046,307,107,53},
	s_copy_ch128_ok_xywh={1046,600,107,53},
	s_copy_chmul_xywh = {72,0,0,0},
	s_copy_ch_xywh = {13,13,67,67},
	s_copy_ch4_8_xywh ={26,13,67,67},
	s_copy_frame_xywh = {0,0,10,10},

};
w1_copy.s_4k = 
{
	s_copy1_xywh = {2976,1700,510,260},
	s_copy2_xywh = {2976,1600,510,360},
	s_copy3_xywh = {2780,1600,896,360},
	s_copy4_xywh = {2780,1400,896,560},
	s_copy5_xywh = {1916,1400,1760,560},
	s_copy6_xywh = {1916,960,1760,1000},
	s_copy_ch4_check_xywh = {30,160,70,80},
	s_copy_ch4_selectall_xywh = {100,160,200,80},
	s_copy_ch8_check_xywh = {30,260,70,80},
	s_copy_ch8_selectall_xywh = {100,260,200,80},
	s_copy_ch16_check_xywh = {30,260,70,80},
	s_copy_ch16_selectall_xywh = {100,260,200,80},
	s_copy_ch32_check_xywh = {30,460,70,80},
	s_copy_ch32_selectall_xywh = {100,460,200,80},
	s_copy_ch64_check_xywh = {30,460,70,80},
	s_copy_ch64_selectall_xywh = {100,460,200,80},
	s_copy_ch128_check_xywh = {30,900,70,80},
	s_copy_ch128_selectall_xywh = {100,900,200,80},
	s_copy_ch4_ok_xywh={310,160,160,80},
	s_copy_ch8_ok_xywh={310,260,160,80},
	s_copy_ch16_ok_xywh={706,260,160,80},
	s_copy_ch32_ok_xywh={706,460,160,80},
	s_copy_ch64_ok_xywh={1570,460,160,80},
	s_copy_ch128_ok_xywh={1570,900,160,80},
	s_copy_chmul_xywh = {108,0,0,0},
	s_copy_ch_xywh = {20,20,100,100},
	s_copy_ch4_8_xywh ={40,20,100,100},
	s_copy_frame_xywh = {0,0,10,10},
};

w1_copy.set_dlgattr = function(enable_ch)
	assert(enable_ch ~= nil and type(enable_ch) == 'table')
	if(w1_copy.enable_ch == nil) then
		w1_copy.enable_ch = util.copy_tab(enable_ch);
	else
		util.copy_tab_b(w1_copy.enable_ch, enable_ch);
	end
end

w1_copy.set_func  = function(ok_func, okfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')
	w1_copy.ok_func = ok_func;
	w1_copy.okfunc_param = okfunc_param;
end

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(w1_copy.ok_func ~= nil) then
			local idx=1;
			local check;
			for i=1, channel_num do
				check = b_wnd_ex.get_check(top, w1_copy.dlg['ch'..i].id)
				if(check) then
					w1_copy.select_ch[idx] = i;
					idx = idx + 1;
				end
			end
			if(w1_copy.okfunc_param[2] == nil) then
				w1_copy.okfunc_param[2] = util.copy_tab(w1_copy.select_ch)
			else
				util.copy_tab_b(w1_copy.okfunc_param[2], w1_copy.select_ch)
			end
			w1_copy.ok_func(w1_copy.okfunc_param);
		end
		b_dlg.end_modal(top);
	end
	return 0
end

local on_select_all = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local ch_list ={};
		
		local un_select = 0;
		local check;
		for i = 1, #w1_copy.enable_ch do
			local idx = w1_copy.enable_ch[i];
			check = b_wnd_ex.get_check(top, w1_copy.dlg['ch'..idx].id)
			if(false == check) then
				un_select = 1;
				break;
			end
		end
		if(0 == un_select)then
			for i = 1, #w1_copy.enable_ch do
				local idx = w1_copy.enable_ch[i];
				b_wnd_ex.set_check(top, w1_copy.dlg['ch'..idx].id, false, false)
			end
			b_wnd_ex.set_check(top, w1_copy.dlg.check.id, false, false)
		else
			for i = 1, #w1_copy.enable_ch do
				local idx = w1_copy.enable_ch[i];
				b_wnd_ex.set_check(top, w1_copy.dlg['ch'..idx].id, true, false)
			end
			b_wnd_ex.set_check(top, w1_copy.dlg.check.id, true, false)
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local check_in = function (x, y, cx, cy)
	local s_x = 0;
	local s_y = 0;
	local s_cx = 0;
	local s_cy = 0;
	if w1_copy.start_x < w1_copy.end_x then
		s_x = w1_copy.start_x ;
		s_cx = w1_copy.end_x - w1_copy.start_x;
	else
		s_x = w1_copy.end_x ;
		s_cx = w1_copy.start_x - w1_copy.end_x;
	end
	if w1_copy.start_y < w1_copy.end_y then
		s_y = w1_copy.start_y;
		s_cy = w1_copy.end_y - w1_copy.start_y
	else
		s_y = w1_copy.end_y;
		s_cy = w1_copy.start_y - w1_copy.end_y
	end
	if (s_x + s_cx < x) or (s_x > x + cx)
	or (s_y + s_cy < y) or (s_y > y + cy) then
		return false;
	end
	return true;
end

local end_drag = function (top)
	local un_select = 0;
	local check;
	local select_ch = {};
	local select_count = 1;
	for i = 1, #w1_copy.enable_ch do
		local idx = w1_copy.enable_ch[i];
		local rect = b_wnd_ex.get_rect(top, w1_copy.dlg['ch'..idx].id);
		local is_in = check_in(rect['rect'..1], rect['rect'..2], rect['rect'..3], rect['rect'..4]);
		if is_in == true then
			select_ch[select_count] = idx;
			select_count = select_count + 1;
			check = b_wnd_ex.get_check(top, w1_copy.dlg['ch'..idx].id)
			if(false == check) then
				un_select = 1;
			end
		end				
	end
	
	if un_select == 0 then
		for i = 1, #select_ch do
			local idx = select_ch[i];
			b_wnd_ex.set_check(top, w1_copy.dlg['ch'..idx].id, false, false)
		end
	else
		for i = 1, #select_ch do
			local idx = select_ch[i];
			b_wnd_ex.set_check(top, w1_copy.dlg['ch'..idx].id, true, false)
		end
	end
	w1_copy.state = 0;
	w1_copy.start_x = 0;
	w1_copy.start_y = 0;
	w1_copy.end_x = 0;
	w1_copy.end_y = 0;
	b_dlg.dlg_set_redraw(top);
end

w1_copy.init = function()
	w1_copy.enable_ch = {};
	w1_copy.select_ch = {};
	w1_copy.ok_func = nil;
end

w1_copy.on_create = function(top)
	channel_num = global_val.get_channelnum();
	w1_copy.top = top;
	local dlg = {
		attr 	= {xywh},
		sub 	= {'ch1', 'ch2', 'ch3', 'ch4','ch5', 'ch6','ch7', 'ch8','ch9', 'ch10', 'ch11', 'ch12','ch13', 'ch14','ch15', 'ch16',
					'ch17', 'ch18', 'ch19', 'ch20','ch21', 'ch22','ch23', 'ch24', 'ch25', 'ch26', 'ch27', 'ch28','ch29', 'ch30','ch31', 'ch32',
					'ch33', 'ch34', 'ch35', 'ch36','ch37', 'ch38','ch39', 'ch40', 'ch41', 'ch42', 'ch43', 'ch44','ch45', 'ch46','ch47', 'ch48',
					'ch49', 'ch50', 'ch51', 'ch52','ch53', 'ch54','ch55', 'ch56', 'ch57', 'ch58', 'ch59', 'ch60','ch61', 'ch62','ch63', 'ch64',
					'ch65', 'ch66', 'ch67', 'ch68','ch69', 'ch70','ch71', 'ch72', 'ch73', 'ch74', 'ch75', 'ch76','ch77', 'ch78','ch79', 'ch80',
					'ch81', 'ch82', 'ch83', 'ch84','ch85', 'ch86','ch87', 'ch88', 'ch89', 'ch90', 'ch91', 'ch92','ch93', 'ch94','ch95', 'ch96',
					'ch97', 'ch98', 'ch99', 'ch100','ch101', 'ch102','ch103', 'ch104', 'ch105', 'ch106', 'ch107', 'ch108','ch109', 'ch110','ch111', 'ch112',
					'ch113', 'ch114', 'ch115', 'ch116','ch117', 'ch118','ch119', 'ch120', 'ch121', 'ch122', 'ch123', 'ch124','ch125', 'ch126','ch127', 'ch128',
					'frame','check','select_all','ok'},	
	}
	local chmul = SIZE('s_copy_chmul_xywh');
	local chpos = SIZE('s_copy_ch_xywh');
	if(channel_num == 4) then
		local chpos4_8 = SIZE('s_copy_ch4_8_xywh');
		dlg.attr.xywh = 's_copy1_xywh'
		for i=1,channel_num do
			dlg['ch'..i] = { t='checkbtntext',id=id+i,	xywh = {chpos4_8[1] + chmul[1]*(i-1),chpos4_8[2],chpos4_8[3],chpos4_8[4]}, text=tostring(i),trans = false,
					color = {'c_copy_ckbtn_bg', 'c_copy_ckbtn_bg', 'c_txt_n'},
					color_f = {'c_copy_ckbtn_bg_f', 'c_copy_ckbtn_bg_f', 'c_txt_n'},check = false,
					cmd = on_channel};
		end
		dlg.check 	= {t='check', 	id=id+20,xywh='s_copy_ch4_check_xywh',
				cmd = on_select_all};
		dlg.select_all = {t='button',id=id+21,	xywh = 's_copy_ch4_selectall_xywh',	text='LA_ALL',	align = b_ui.ALIGN.LEFT,
			color= {'c_copy_bk', 'c_copy_bk', 'c_txt_n'},color_f= {'c_copy_bk', 'c_copy_bk', 'c_txt_f'},cmd=on_select_all};
		dlg.ok = {t='button',		id=id+22,	xywh = 's_copy_ch4_ok_xywh',	
					text='LA_OK',		cmd=on_ok};
	elseif(channel_num == 6 or channel_num == 8) then
		local chpos4_8 = SIZE('s_copy_ch4_8_xywh');
		dlg.attr.xywh = 's_copy2_xywh'
		local sx,sy, mod;
		for i=1,channel_num do
			mod = math.modf( (i-1) / 4);
			sx = chpos4_8[1] + chmul[1]* ( (i-1) % 4);
			sy = chpos4_8[2] + chmul[1] * mod;
			dlg['ch'..i] = { t='checkbtntext',id=id+i,	xywh = {sx, sy, chpos4_8[3], chpos4_8[4]}, text=tostring(i),trans = false,
					color = {'c_copy_ckbtn_bg', 'c_copy_ckbtn_bg', 'c_txt_n'},
					color_f = {'c_copy_ckbtn_bg_f', 'c_copy_ckbtn_bg_f', 'c_txt_n'},check = false,
					cmd = on_channel};
			dlg.check 	= {t='check', 	id=id+20,xywh='s_copy_ch8_check_xywh',
				cmd = on_select_all};
			dlg.select_all = {t='button',id=id+21,	xywh = 's_copy_ch8_selectall_xywh',	text='LA_ALL',	align = b_ui.ALIGN.LEFT,	
				color= {'c_copy_bk', 'c_copy_bk', 'c_txt_n'},color_f= {'c_copy_bk', 'c_copy_bk', 'c_txt_f'},cmd=on_select_all};
			dlg.ok = {t='button',	id=id+22,	xywh = 's_copy_ch8_ok_xywh',	
					text='LA_OK',		cmd=on_ok};
		end
	elseif(channel_num == 10 or channel_num == 12 or channel_num == 16) then
		dlg.attr.xywh = 's_copy3_xywh'
		local sx,sy, mod;
		for i=1,channel_num do
			mod = math.modf( (i-1) / 8);
			sx = chpos[1] + chmul[1]* ( (i-1) % 8);
			sy = chpos[2] + chmul[1] * mod;
			dlg['ch'..i] = { t='checkbtntext',id=id+i,	xywh = {sx, sy, chpos[3], chpos[4]}, text=tostring(i),trans = false,
					color = {'c_copy_ckbtn_bg', 'c_copy_ckbtn_bg', 'c_txt_n'},
					color_f = {'c_copy_ckbtn_bg_f', 'c_copy_ckbtn_bg_f', 'c_txt_n'},check = false,
					cmd = on_channel};
			dlg.check 	= {t='check', 	id=id+20,xywh='s_copy_ch16_check_xywh',
				cmd = on_select_all};
			dlg.select_all = {t='button',id=id+21,	xywh = 's_copy_ch16_selectall_xywh',text='LA_ALL',	align = b_ui.ALIGN.LEFT,
				color= {'c_copy_bk', 'c_copy_bk', 'c_txt_n'},color_f= {'c_copy_bk', 'c_copy_bk', 'c_txt_f'},cmd=on_select_all};
			dlg.ok = {t='button',	id=id+22,	xywh = 's_copy_ch16_ok_xywh',	
					text='LA_OK',		cmd=on_ok};
		end
	elseif(channel_num == 20 or channel_num == 24 or channel_num == 32) then
		dlg.attr.xywh = 's_copy4_xywh'
		local sx,sy, mod;
		for i=1,channel_num do
			mod = math.modf( (i-1) / 8);
			sx = chpos[1] + chmul[1]* ( (i-1) % 8);
			sy = chpos[2] + chmul[1] * mod;
			dlg['ch'..i] = { t='checkbtntext',id=id+i,	xywh = {sx, sy, chpos[3], chpos[4]}, text=tostring(i),trans = false,
					color = {'c_copy_ckbtn_bg', 'c_copy_ckbtn_bg', 'c_txt_n'},
					color_f = {'c_copy_ckbtn_bg_f', 'c_copy_ckbtn_bg_f', 'c_txt_n'},check = false,
					cmd = on_channel};
			dlg.check 	= {t='check', 	id=id+40,xywh='s_copy_ch32_check_xywh',
				cmd = on_select_all};
			dlg.select_all = {t='button',		id=id+41,	xywh = 's_copy_ch32_selectall_xywh',text='LA_ALL',align = b_ui.ALIGN.LEFT,
				color= {'c_copy_bk', 'c_copy_bk', 'c_txt_n'},color_f= {'c_copy_bk', 'c_copy_bk', 'c_txt_f'},cmd=on_select_all};
			dlg.ok = {t='button',	id=id+42,	xywh = 's_copy_ch32_ok_xywh',	
					text='LA_OK',		cmd=on_ok};
		end		
	elseif(channel_num == 64) then
		dlg.attr.xywh = 's_copy5_xywh'
		local sx,sy, mod;
		for i=1,channel_num do
			mod = math.modf( (i-1) / 16);
			sx = chpos[1] + chmul[1]* ( (i-1) % 16);
			sy = chpos[2] + chmul[1] * mod;
			dlg['ch'..i] = { t='checkbtntext',id=id+i,	xywh = {sx, sy, chpos[3], chpos[4]}, text=tostring(i),trans = false,
					color = {'c_copy_ckbtn_bg', 'c_copy_ckbtn_bg', 'c_txt_n'},
					color_f = {'c_copy_ckbtn_bg_f', 'c_copy_ckbtn_bg_f', 'c_txt_n'},check = false,
					cmd = on_channel};
			dlg.check 	= {t='check', 	id=id+70,xywh='s_copy_ch64_check_xywh',
				cmd = on_select_all};
			dlg.select_all = {t='button',id=id+71,	xywh = 's_copy_ch64_selectall_xywh',text='LA_ALL',	align = b_ui.ALIGN.LEFT,
				color= {'c_copy_bk', 'c_copy_bk', 'c_txt_n'},color_f= {'c_copy_bk', 'c_copy_bk', 'c_txt_f'},cmd=on_select_all};
			dlg.ok = {t='button',	id=id+72,	xywh = 's_copy_ch64_ok_xywh',	
					text='LA_OK',		cmd=on_ok};
		end		
	elseif(channel_num == 128) then
		dlg.attr.xywh = 's_copy6_xywh'
		local sx,sy, mod;
		for i=1,channel_num do
			mod = math.modf( (i-1) / 16);
			sx = chpos[1] + chmul[1]* ( (i-1) % 16);
			sy = chpos[2] + chmul[1] * mod;
			dlg['ch'..i] = { t='checkbtntext',id=id+i,	xywh = {sx, sy, chpos[3], chpos[4]}, text=tostring(i),trans = false,
					color = {'c_copy_ckbtn_bg', 'c_copy_ckbtn_bg', 'c_txt_n'},
					color_f = {'c_copy_ckbtn_bg_f', 'c_copy_ckbtn_bg_f', 'c_txt_n'},check = false,
					cmd = on_channel};
			dlg.check 	= {t='check', 	id=id+130,xywh='s_copy_ch128_check_xywh',
				cmd = on_select_all};
			dlg.select_all = {t='button',id=id+131,	xywh = 's_copy_ch128_selectall_xywh',text='LA_ALL',align = b_ui.ALIGN.LEFT,
				color= {'c_copy_bk', 'c_copy_bk', 'c_txt_n'},color_f= {'c_copy_bk', 'c_copy_bk', 'c_txt_f'},cmd=on_select_all};
			dlg.ok = {t='button',	id=id+132,	xywh = 's_copy_ch128_ok_xywh',	
					text='LA_OK',		cmd=on_ok};
		end		
	end
	dlg.frame = {t='frame', id=id+132, xywh = 's_copy_frame_xywh'};
	w1_copy.dlg = dlg
	b_parser(top, w1_copy.dlg)
	return 0
end

w1_copy.on_destroy = function(top)
	w1_copy.top = nil;
	w1_copy.dlg = nil;
	w1_copy.enable_ch = nil;
	w1_copy.select_ch = nil;
	w1_copy.okfunc_param = nil;
	w1_copy.state = 0;
	w1_copy.start_x = 0;
	w1_copy.start_y = 0;
	w1_copy.end_x = 0;
	w1_copy.end_y = 0;
	return 0
end

w1_copy.on_pre_show = function(top)
	for i = 1, channel_num do
		b_wnd_ex.set_disable(top, w1_copy.dlg['ch'..i].id, true, false);	
	end
	for i = 1, #w1_copy.enable_ch do
		local idx = w1_copy.enable_ch[i];
		b_wnd_ex.set_disable(top, w1_copy.dlg['ch'..idx].id, false, false);	
	end
	b_wnd_ex.set_hide(top, w1_copy.dlg['frame'].id, true, false);
	return 0
end

w1_copy.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_copy_bk'))
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1)
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_copy.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui.RBUTTONCLK == vmsg) then
		local size = SIZE(w1_copy.dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			if w1_copy.state == 1 then
				b_wnd_ex.set_hide(top, w1_copy.dlg.frame.id, true, false);
				end_drag(top);
			end
		else
			b_dlg.end_modal(top);
		end
	elseif (b_ui.LBUTTONDOWN == vmsg) then
		local size = SIZE(w1_copy.dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			w1_copy.start_x = x;
			w1_copy.start_y = y;
			w1_copy.end_x = x;
			w1_copy.end_y = y;
			b_dlg.dlg_set_redraw(top);
		else
			b_dlg.end_modal(top);
		end		
	elseif (b_ui.LBUTTONDRAG == vmsg) then
		local size = SIZE(w1_copy.dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			w1_copy.state = 1;
			w1_copy.end_x = x;
			w1_copy.end_y = y;
			b_wnd_ex.set_hide(top, w1_copy.dlg.frame.id, false, false);
			local s_x = 0;
			local s_y = 0;
			local s_cx = 0;
			local s_cy = 0;
			if w1_copy.start_x < w1_copy.end_x then
				s_x = w1_copy.start_x ;
				s_cx = w1_copy.end_x - w1_copy.start_x;
			else
				s_x = w1_copy.end_x ;
				s_cx = w1_copy.start_x - w1_copy.end_x;
			end
			if w1_copy.start_y < w1_copy.end_y then
				s_y = w1_copy.start_y;
				s_cy = w1_copy.end_y - w1_copy.start_y
			else
				s_y = w1_copy.end_y;
				s_cy = w1_copy.start_y - w1_copy.end_y
			end
			s_x = s_x - size[1]
			s_y = s_y - size[2]
			
			b_wnd_ex.move_ex(top, w1_copy.dlg.frame.id, {s_x, s_y, s_cx, s_cy}, false);
			b_dlg.dlg_set_redraw(top);	
		else
			b_wnd_ex.set_hide(top, w1_copy.dlg.frame.id, true, false);
			end_drag(top);
		end
	elseif (b_ui.LBUTTOUP == vmsg) then
		local size = SIZE(w1_copy.dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4])) then
			if w1_copy.state == 1 then
				b_wnd_ex.set_hide(top, w1_copy.dlg.frame.id, true, false);
				end_drag(top);
			end
		else
			b_dlg.end_modal(top);
		end
	end
	return 0
end

return w1_copy




