--[[
-- Copyright(c) 2018-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/10
-- author 
-- brief  
--]]
local b_app_cfg	= require("wnd.core.b_app_cfg")
local util 		= require("wnd.core.util")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w2_utilwnd = {}



w2_utilwnd.tipstatus =
{
	success = 0,	--ɹ
	nochange = 1,	--δ޸
	paramerr = 2,	--
	retdefault = 3, --ָĬϳɹ
}


w2_utilwnd.cfgtab = {}				--Ҫȡ豸Ϣֵ
w2_utilwnd.cfgtouifunc = {}			--ˢUI
w2_utilwnd.uitocfgfunc = {}			--UIˢ
w2_utilwnd.uidatacheckfunc = {}		--UIòļ
w2_utilwnd.errwidgetid = {}			--ؼID
w2_utilwnd.tipflag = w2_utilwnd.tipstatus.success	--ʾ״̬־λ
		
w2_utilwnd.tipdisptime = 12		--ʾϢʾʱ 120.5
w2_utilwnd.tiptimenum= 0		--ʱ λ:0.5
w2_utilwnd.tipdisp= 0			--ʾϢʾ־λ



--ûǷи,и,򷵻ظĺ
w2_utilwnd.usercfgchange =function()
	local param = b_app_cfg.tabcompare()
	if(	util.is_empty(param) )then
		return false,nil
	else
		return true, param
	end
end

--
w2_utilwnd.cfgdataclear =function()
	b_app_cfg.origin_cfg = nil
	b_app_cfg.default_cfg = nil
	b_app_cfg.user_cfg = nil
	b_app_cfg.origin_cfg = {}
	b_app_cfg.default_cfg = {}
	b_app_cfg.user_cfg = {}
end


w2_utilwnd.page_init = function(top)
	assert(type(w2_utilwnd.cfgtab) == 'table')
	assert(type(w2_utilwnd.cfgtouifunc) == 'function')
	w2_utilwnd.cfgdataclear();
	b_app_cfg.init(w2_utilwnd.cfgtab)
	w2_utilwnd.cfgtouifunc(top, b_app_cfg.user_cfg)
end

w2_utilwnd.page_ondefault = function(top)
	assert(type(w2_utilwnd.cfgtouifunc) == 'function')
	--b_app_cfg.defaluttousercfg()
	w2_utilwnd.cfgtouifunc(top, b_app_cfg.user_cfg)
	w2_utilwnd.tipflag = w2_utilwnd.tipstatus.retdefault	
end

w2_utilwnd.page_onapply = function(top)
	assert(type(w2_utilwnd.uidatacheckfunc) == 'function')
	assert(type(w2_utilwnd.uitocfgfunc) == 'function')
	
	local legalflag, idtab = w2_utilwnd.uidatacheckfunc(top)

	--ûǷȫϷ
	if(legalflag == true) then
		w2_utilwnd.uitocfgfunc(top, b_app_cfg.user_cfg)
		local changeflag, changeparam = w2_utilwnd.usercfgchange()
		if(changeflag) then
			--Ѹĺ'ṹ'浽ļ
			b_app_cfg.savechangecfg(changeparam)
			w2_utilwnd.tipflag = w2_utilwnd.tipstatus.success
		else
			w2_utilwnd.tipflag = w2_utilwnd.tipstatus.nochange
		end	
	else
		w2_utilwnd.tipflag = w2_utilwnd.tipstatus.paramerr
		--ûݲȫǺϷ,¼вϷؼIDֵ
		w2_utilwnd.errwidgetid  = idtab
	end
end

--ȡвڿؼID
w2_utilwnd.geterrwidgetid = function()
	return w2_utilwnd.errwidgetid
end

--Ӧúȡ״̬־λ
w2_utilwnd.gettipflag = function()
	return w2_utilwnd.tipflag
end

w2_utilwnd.tipinfodisp= function(top, id)
	if(w2_utilwnd.tipflag == w2_utilwnd.tipstatus.success) then			--ɹ
		b_wnd_ex.set_text(top, id, STR('LA_APPLY_OK'),true)
	elseif(w2_utilwnd.tipflag == w2_utilwnd.tipstatus.nochange) then	--δ޸
		b_wnd_ex.set_text(top, id, STR('LA_NO_CHANGE'),true)
	elseif(w2_utilwnd.tipflag == w2_utilwnd.tipstatus.paramerr) then	--
		b_wnd_ex.set_text(top, id, STR('param_err'),true)
	elseif(w2_utilwnd.tipflag == w2_utilwnd.tipstatus.retdefault) then	--
		b_wnd_ex.set_text(top, id, STR('LA_RESTORE_SUCCESS'),true)
	end
end

--Ӧidؼʾ
w2_utilwnd.tipclear = function(top, id)
	b_wnd_ex.set_text(top, id, '',true)
end

w2_utilwnd.tipdispon = function()			--ʾϢ
	w2_utilwnd.tiptimenum = 0
	w2_utilwnd.tipdisp	= 1
end

w2_utilwnd.timerenevt = function(top, tipinfoid)
	w2_utilwnd.tiptimenum = w2_utilwnd.tiptimenum + 1
	if(w2_utilwnd.tipdisp == 0) then		--ִκζ
	
	elseif(w2_utilwnd.tipdisp == 1) then	--ʾ
		w2_utilwnd.tipdisp = 2				--´νʱִʾ
		w2_utilwnd.tipinfodisp(top, tipinfoid)
	elseif(w2_utilwnd.tipdisp == 2 and w2_utilwnd.tiptimenum >= w2_utilwnd.tipdisptime) then	--ʾ
		w2_utilwnd.tipdisp = 0				--´νִκζ
		w2_utilwnd.tipclear(top, tipinfoid)
	end
end


--Ӧidؼʾ
w2_utilwnd.insertwidget = function(widgettype, widgetid)
	
	
	--b_wnd_ex.set_text(top, id, '',true)
end



return w2_utilwnd

